c besbfcn rcprogrammed in C (ZCM 4/13/2000)
 
c  (Wonder if there's still any typos in these functions...)
 
      real function bi0(xp)
      x = abs(xp)
      t = x/3.75
      if(t < 1.) then
        t = t*t
        val = 1. + t*(3.5156229 + t*(3.0899424 + t*(1.2067492 +
          t*(.2659732 + t*(.0360768 + t*.0045813)))))
      else
        t = 1./t
        val = .39894228 + t*(.01328592 + t*(.00225319 + t*(-.00157565 +
          t*(.00916281 + t*(-.02057706 + t*(.02635537 + t*(-.01647633 +
          t*.00392377)))))))
        val = exp(x)*val/sqrt(x)
      endif
      return (val)
      end
 
      real function bi1(xp)
      x = abs(xp)
      t = x/3.75
      if(t < 1.) then
        t = t*t
        val = .5 + t*(.87890594 + t*(.51498869 + t*(.15084934 +
          t*(.02658733 + t*(.00301532 + t*.00032411)))))
        val = xp*val
      else
        t = 1./t
        val = .39894228 + t*(-.03988024 + t*(-.00362018 + t*(.00163801 +
          t*(-.01031555 + t*(.02282967 + t*(-.02895312 + t*(.01787654 -
          t*.00420059)))))))
        val = exp(x)*val/sqrt(x)
        if(xp < 0) val = -val
      endif
      return (val)
      end
 
      real function bk0(xp)
      real bi0
      x = xp
      t = x/2.
      if(t < 1.) then
        val = -alog(t)*bi0(x)
        t = t*t
        val = val - .57721566 + t*(.42278420 + t*(.23069756 +
          t*(.03488590 + t*(.00262698 + t*(.00010750 + t*.740e-5)))))
      else
        t = 1./t
        val = 1.25331414 + t*(-.07832358 + t*(.02189568 + t*(-.01062446 +
          t*(.00587872 + t*(-.00251540 +t*.00053208)))))
        val = exp(-x)*val/sqrt(x)
      endif
      return (val)
      end
 
      real function bk1(xp)
      real bi1
      x = xp
      t = x/2.
      if(t < 1.) then
        val = alog(t)*bi1(x)
        t = t*t
        val = val + (1. + t*(.15443144 + t*(-.67278579 + t*(-.18156897 +
          t*(-.01919402 + t*(-.00110404 - t*.4686e-4))))))/x
      else
        t = 1./t
        val = 1.25331414 + t*(.23498619 + t*(-.03655620 + t*(.01504268 +
          t*(-.00780353 + t*(.00325614 - t*.00068245)))))
        val = exp(-x)*val/sqrt(x)
      endif
      return (val)
      end


      real function bj0(xp)
 
c  Compute Bessel function J0(x) for real x
c  using the polynomial approximations given in
c  Abramowitz & Stegun, sections 9.4.1, 9.4.3
c
      real cf(7),cj(7),ct(7),f,theta,z,val

      x = abs(xp)

      cf(1) =   .79788456
      cf(2) = - .00000077
      cf(3) = - .00552740
      cf(4) = - .00009512
      cf(5) =   .00137237
      cf(6) = - .00072805
      cf(7) =   .00014476

      cj(1) =  1.
      cj(2) = -2.2499997
      cj(3) =  1.2656208
      cj(4) = - .3163866
      cj(5) =   .0444479
      cj(6) = - .0039444
      cj(7) =   .0002100

      ct(1) = - .78539816
      ct(2) = - .04166397
      ct(3) = - .00003954
      ct(4) =   .00262573
      ct(5) = - .00054125
      ct(6) = - .00029333
      ct(7) =   .00013558
 
      if(x < 3.) then
        z = (x/3.)**2
        val = cj(1) + z*(cj(2) + z*(cj(3) + z*(cj(4) + z*(cj(5) + z*(cj(6) + 
            z*cj(7))))))
      else
        z = 3./x
        theta = x + ct(1) + z*(ct(2) + z*(ct(3) + z*(ct(4) + z*(ct(5) + z*(ct(6) + 
          z*ct(7))))))
        f = cf(1) + z*(cf(2) + z*(cf(3) + z*(cf(4) + z*(cf(5) + z*(cf(6) + 
          z*cf(7))))))
        val = f*cos(theta)/sqrt(x)
      endif
      return (val)
      end
 
      real function by0(x)
 
c  Compute Bessel function Y0(x) for real x > 0
c  using the polynomial approximations given in
c  Abramowitz & Stegun, sections 9.4.2, 9.4.3
c
      real cf(7),cj(7),ct(7),cy(7),f,pi,theta,z,j0

      cf(1) =   .79788456
      cf(2) = - .00000077
      cf(3) = - .00552740
      cf(4) = - .00009512
      cf(5) =   .00137237
      cf(6) = - .00072805
      cf(7) =   .00014476

      cj(1) =  1.
      cj(2) = -2.2499997
      cj(3) =  1.2656208
      cj(4) = - .3163866
      cj(5) =   .0444479
      cj(6) = - .0039444
      cj(7) =   .0002100

      ct(1) = - .78539816
      ct(2) = - .04166397
      ct(3) = - .00003954
      ct(4) =   .00262573
      ct(5) = - .00054125
      ct(6) = - .00029333
      ct(7) =   .00013558

      cy(1) =   .36746691
      cy(2) =   .60559366
      cy(3) = - .74350384
      cy(4) =   .25300117
      cy(5) = - .04261214
      cy(6) =   .00427916
      cy(7) = - .00024846

      pi = 3.141592654

      if(x < 3.) then
        z = (x/3.)**2
        j0 = cj(1) + z*(cj(2) + z*(cj(3) + z*(cj(4) + z*(cj(5) + z*(cj(6) + 
          z*cy(7))))))    # j0 is really J0
        val = cy(1) + z*(cy(2) + z*(cy(3) + z*(cy(4) + z*(cy(5) + z*(cy(6) + 
           z*cy(7))))))
        val = (2./pi)*alog(.5*x)*j0 + val
      else
        z = 3./x
        theta = x + ct(1) + z*(ct(2) + z*(ct(3) + z*(ct(4) + z*(ct(5) + z*(ct(6) + 
          z*ct(7))))))
        f = cf(1) + z*(cf(2) + z*(cf(3) + z*(cf(4) + z*(cf(5) + z*(cf(6) + 
          z*cf(7))))))
        val = f*sin(theta)/sqrt(x)
      endif
      return (val)
      end
 
 
      real function bj1(xp)
 
c  Compute Bessel function J1(x) for real x
c  using the polynomial approximations given in
c  Abramowitz & Stegun, sections 9.4.4, 9.4.6
c
      real x,cf(7),cj(7),ct(7),f,pi,z,theta

      x = abs(xp)

      cf(1) =   .79788456
      cf(2) =   .00000156
      cf(3) =   .01659667
      cf(4) =   .00017105
      cf(5) = - .00249511
      cf(6) =   .00113653
      cf(7) = - .00020033

      cj(1) =   .5
      cj(2) = - .56249985
      cj(3) =   .21093573
      cj(4) = - .03954289
      cj(5) =   .00443319
      cj(6) = - .00031761
      cj(7) =   .00001109

      ct(1) = -2.35619449
      ct(2) =   .12499612
      ct(3) =   .0000565
      ct(4) = - .00637879
      ct(5) =   .00074348
      ct(6) =   .00079824
      ct(7) = - .00029166

      pi = 3.141592654
 
      if(x < 3.) then
        z = (x/3.)**2
        val = (cj(1) + z*(cj(2) + z*(cj(3) + z*(cj(4) + z*(cj(5) + z*(cj(6) + 
            z*cj(7)))))))*xp
      else
        z = 3./x
        theta = x + ct(1) + z*(ct(2) + z*(ct(3) + z*(ct(4) + z*(ct(5) + z*(ct(6) + 
          z*ct(7))))))
        f = cf(1) + z*(cf(2) + z*(cf(3) + z*(cf(4) + z*(cf(5) + z*(cf(6) + 
          z*cf(7))))))
        val = f*cos(theta)/sqrt(x)
	if(xp < 0.) val = - val
      endif
      return (val)
      end
 
      real function by1(x)
 
c  Compute Bessel function Y1(x) for real x > 0
c  using the polynomial approximations given in
c  Abramowitz & Stegun, sections 9.4.5, 9.4.6
c
      real cf(7),cj(7),ct(7),cy(7),z,f,pi,theta,j1

      cf(1) =   .79788456
      cf(2) =   .00000156
      cf(3) =   .01659667
      cf(4) =   .00017105
      cf(5) = - .00249511
      cf(6) =   .00113653
      cf(7) = - .00020033

      cj(1) =   .5
      cj(2) = - .56249985
      cj(3) =   .21093573
      cj(4) = - .03954289
      cj(5) =   .00443319
      cj(6) = - .00031761
      cj(7) =   .00001109

      ct(1) = -2.35619449
      ct(2) =   .12499612
      ct(3) =   .0000565
      ct(4) = - .00637879
      ct(5) =   .00074348
      ct(6) =   .00079824
      ct(7) = - .00029166

      cy(1) = - .6366198
      cy(2) =   .2212091
      cy(3) =  2.1682709
      cy(4) = -1.3164827
      cy(5) =   .3123951
      cy(6) = - .0400976
      cy(7) =   .0027873

      pi = 3.141592654
 
      if(x < 3.) then
        z = (x/3.)**2
        j1 = (cj(1) + z*(cj(2) + z*(cj(3) + z*(cj(4) + z*(cj(5) + z*(cj(6) + 
            z*cj(7)))))))*x   # j1 is really J1
        val = cy(1) + z*(cy(2) + z*(cy(3) + z*(cy(4) + z*(cy(5) + z*(cy(6) + 
           z*cy(7))))))
        val = (2./pi)*alog(.5*x)*j1 + val/x
      else
        z = 3./x
        theta = x + ct(1) + z*(ct(2) + z*(ct(3) + z*(ct(4) + z*(ct(5) + z*(ct(6) + 
          z*ct(7))))))
        f = cf(1) + z*(cf(2) + z*(cf(3) + z*(cf(4) + z*(cf(5) + z*(cf(6) + 
          z*cf(7))))))
        val = f*sin(theta)/sqrt(x)
      endif
      return (val)
      end
