
/* FF_ID - attempt a uniform naming of FORTRAN functions which 
 *       - gets around loader naming conventions
 *       -
 *       - FF_ID(foo, FOO)(x, y, z)
 */

#ifndef HDR_BASCONF
#define HDR_BASCONF

#ifndef __GNUC__

# ifdef __HOS_AIX__
#  define FF_ID(x, X)  x
# endif

# ifdef __hpux
#  define FF_ID(x, X)  x
# endif

# ifdef cray
#  define FF_ID(x, X)  X
# endif

#endif

#ifndef FF_ID
# define FF_ID(x, X)  x ## _
#endif

/* FCB_ID - attempt a uniform naming of FORTRAN common blocks which 
 *        - gets around compiler/loader naming conventions
 *        -
 *        -    FCB_ID(type, foo, FOO)(x, y, z)
 */

#ifdef INTEL_FC   /* Intel fortran compiler */

# define FCB_ID(x, X) ifl_ ## x ## _

#else    

# define FCB_ID(x, X) FF_ID(x, X)

#endif

#include "basis-c-defs.h"

#endif /* HDR_BASCONF */
