/* FILE: csc.h */

#if !defined(__csc__)
#define __csc__


#if !defined(__Basis__) && defined(__cplusplus)
#include "Basis.h"
#endif
#if !defined(__Vector__) && defined(__cplusplus)
#include "Vector.h"
#endif
#if !defined(__Array3__) && defined(__cplusplus)
#include "Array3.h"
#endif
#if !defined(__Array4__) && defined(__cplusplus)
#include "Array4.h"
#endif
#if !defined(__Character__) && defined(__cplusplus)
#include "Character.h"
#endif
#if !defined(__CCLComplex__) && defined(__cplusplus)
#include "CCLComplex.h"
#endif

#if !defined(__cplusplus)
#include "SysConfig.h"
#endif

/* Definitions / Parameters */

#define Pi 3.14159265358979323
#define Ntemps 2
#define Nparts 10
#define Nconfig 12


/*** CRAY -- defined common/function names ***/
#if defined(CRAY)



/* Group Utility */
#define csc_create_backup_fcns CREATE_BACKUP_FCNS          /* subroutine (CRAY) */
#define csc_csc_attrlist CSC_ATTRLIST          /* subroutine (CRAY) */
#define csc_erset ERSET          /* subroutine (CRAY) */

/* Group Codeinfo */
#define CSC10000_Codeinfo CSC10000          /* common (CRAY) */
#define CSC10001_Codeinfo CSC10001          /* common (CRAY) */
#define CSC10_Codeinfo CSC10          /* common (CRAY) */
#define CSC10002_Codeinfo CSC10002          /* common (CRAY) */
#define CSC10003_Codeinfo CSC10003          /* common (CRAY) */
#define CSC13_Codeinfo CSC13          /* common (CRAY) */

/* Group Torflux_Dimensions */
#define CSC20_Torflux_Dimensions CSC20          /* common (CRAY) */

/* Group Torflux */
#define CSC33_Torflux CSC33          /* common (CRAY) */
#define CSC36_Torflux CSC36          /* common (CRAY) */

#endif  /*** CRAY ***/


/*** sun -- defined common/function names ***/
#if defined(sun) || defined(__alpha) || defined(linux)



/* Group Utility */
#define csc_create_backup_fcns create_backup_fcns_          /* subroutine (sun) */
#define csc_csc_attrlist csc_attrlist_          /* subroutine (sun) */
#define csc_erset erset_          /* subroutine (sun) */

/* Group Codeinfo */
#define CSC10000_Codeinfo csc10000_             /* common (sun) */
#define CSC10001_Codeinfo csc10001_             /* common (sun) */
#define CSC10_Codeinfo csc10_             /* common (sun) */
#define CSC10002_Codeinfo csc10002_             /* common (sun) */
#define CSC10003_Codeinfo csc10003_             /* common (sun) */
#define CSC13_Codeinfo csc13_             /* common (sun) */

/* Group Torflux_Dimensions */
#define CSC20_Torflux_Dimensions csc20_             /* common (sun) */

/* Group Torflux */
#define CSC33_Torflux csc33_             /* common (sun) */
#define CSC36_Torflux csc36_             /* common (sun) */

#endif  /*** sun ***/


/*** hp9000s800 -- defined common/function names ***/
#if defined(hp9000s800)



/* Group Utility */
#define csc_create_backup_fcns create_backup_fcns          /* subroutine (hp9000s800) */
#define csc_csc_attrlist csc_attrlist          /* subroutine (hp9000s800) */
#define csc_erset erset          /* subroutine (hp9000s800) */

/* Group Codeinfo */
#define CSC10000_Codeinfo csc10000    /* common (hp9000s800) */
#define CSC10001_Codeinfo csc10001    /* common (hp9000s800) */
#define CSC10_Codeinfo csc10    /* common (hp9000s800) */
#define CSC10002_Codeinfo csc10002    /* common (hp9000s800) */
#define CSC10003_Codeinfo csc10003    /* common (hp9000s800) */
#define CSC13_Codeinfo csc13    /* common (hp9000s800) */

/* Group Torflux_Dimensions */
#define CSC20_Torflux_Dimensions csc20    /* common (hp9000s800) */

/* Group Torflux */
#define CSC33_Torflux csc33    /* common (hp9000s800) */
#define CSC36_Torflux csc36    /* common (hp9000s800) */

#endif  /*** hp9000s800 ***/


/*** _IBMR2 -- defined common/function names ***/
#if defined(_IBMR2)



/* Group Utility */
#define csc_create_backup_fcns create_backup_fcns          /* subroutine (_IBMR2) */
#define csc_csc_attrlist csc_attrlist          /* subroutine (_IBMR2) */
#define csc_erset erset          /* subroutine (_IBMR2) */

/* Group Codeinfo */
#define CSC10000_Codeinfo csc10000    /* common (_IBMR2) */
#define CSC10001_Codeinfo csc10001    /* common (_IBMR2) */
#define CSC10_Codeinfo csc10    /* common (_IBMR2) */
#define CSC10002_Codeinfo csc10002    /* common (_IBMR2) */
#define CSC10003_Codeinfo csc10003    /* common (_IBMR2) */
#define CSC13_Codeinfo csc13    /* common (_IBMR2) */

/* Group Torflux_Dimensions */
#define CSC20_Torflux_Dimensions csc20    /* common (_IBMR2) */

/* Group Torflux */
#define CSC33_Torflux csc33    /* common (_IBMR2) */
#define CSC36_Torflux csc36    /* common (_IBMR2) */

#endif  /*** _IBMR2 ***/


#if defined(__cplusplus)

// csc package class definition

class csc {
public:

// Group Utility

  static void create_backup_fcns ( void );
  static void csc_attrlist ( Integer &, Character &, Character & );
  static void erset ( Integer &, Integer &, Integer & );

// Group Codeinfo

  static Vector<Char> codename;
  static Vector<Char> logname;
  static Integer  &logunit;
  static Vector<Char> author;
  static Integer  &nprob;
  static Vector<Char> shotName;
  static Double  &shotTime;

// Group Torflux_Dimensions

  static Integer  &mtor;
  static Integer  &nsp2tor;
  static Integer  &fluxCord;

// Group Torflux

  static Double  &oneTorf;
  static Vector<Double> chargeNum;
  static Double  &ibsTot;
  static Array3<Double> neoTrCoef;
  static Matrix<Double> neoPinchCoef;
  static Vector<Integer> itor;

#if defined(UseCTLPackage)
  static Integer gen(Vector<Integer> &optlist, Integer &nopt);
  static Integer exe(Vector<Integer> &optlist, Integer &nopt);
  static Integer fin(Vector<Integer> &optlist, Integer &nopt);
#endif

  static void sync();
};

#endif /* __cplusplus */

/* Run-controller package stuff: */

#if defined(UseCTLPackage)
#if defined(CRAY)
#define csc_cscgen CSCGEN
#define csc_cscexe CSCEXE
#define csc_cscfin CSCFIN
#endif
#if defined(sun) || defined(__alpha) || defined(linux)
#define csc_cscgen cscgen_
#define csc_cscexe cscexe_
#define csc_cscfin cscfin_
#endif
#if defined(hp9000s800)
#define csc_cscgen cscgen
#define csc_cscexe cscexe
#define csc_cscfin cscfin
#endif
#if defined(_IBMR2)
#define csc_cscgen cscgen
#define csc_cscexe cscexe
#define csc_cscfin cscfin
#endif


#endif


#endif  /* __csc__ */

