csc
# This file contains a subset of the items in the Corsica variable
# descriptor file csc.v. Hopefully this can be used to forestall
# errors in the C++ interface introduced by changes in mac.
{
 Ntemps = 2           # Maximum level of temperatures
 Nparts = 10          # Maximum index of particles
 Nconfig = Nparts + 2 # size of configuration array

%ifelse(SYSTEM,SUN4,   [define(ARCH,"SUN4")])
%ifelse(SYSTEM,UNICOS, [define(ARCH,"CRAY")])
%ifelse(SYSTEM,HP700,  [define(ARCH,"HP700")])
%ifelse(SYSTEM,SOL,    [define(ARCH,"SOL")])
%ifelse(SYSTEM,RS6000, [define(ARCH,"IBM")])
%ifelse(SYSTEM,IRIX64, [define(ARCH,"SGI")])
%ifelse(SYSTEM,IRIXn32,[define(ARCH,"SGI")])
%ifelse(SYSTEM,AXP,    [define(ARCH,"ALPHA")])
%ifelse(SYSTEM,LINUX,    [define(ARCH,"LINUX")])

}
******* Utility:

# Functions not tied to any particular physics package.

create_backup_fcns subroutine
 # creates init_eq_backup, save_eq_backup, and restore_eq_backup.

csc_attrlist(jout:integer,attr:string,servestr:string) subroutine
 # list via attribute - see attrlist command

erset(iersvr,ipact,isact) subroutine
 # change imsl's default error handling; args are input...

****** Codeinfo:
# Code and Job identification
# Watch out for: separate common block (struct) for each character
# variable; FORTRAN names should not be changed in case; struct
# names should not be missing; All non-string variables of the same
# type in the same group should be in the same struct;no two
# structs should have the same name.

codename character * 8
 # code identifier

logname character*64
 # name of log file

logunit integer / -1 /

$ logwrite macro
$ To use, replace "write(UNIT,NN) list" with "logwrite(UNIT,NN,[list])"
%ifdef([logwrite],[],[
%  define([logwrite],[
%    write($$91,$$92) $$93
%    if (logunit >= 0) then
%      write (logunit,$$92) $$93
%    endif
%  ])
%])

author character*64 /'Bulmer, LoDestro, Pearlstein (LLNL) November 20 1992'/

nprob integer / 0 /
 # problem number (case number) counter

shotName character*8 /' '/
 +input
 # identifying name for an experimental shot

shotTime real [sec] /0./
 +input
 # experimental shot-time for the data from shot shotName

****** Torflux_Dimensions:
# Dimensions of the rhobar grid and the R-Z mesh

mtor integer
 # dimension of rhobar grid

nsp2tor integer
 # two times the number of species used

fluxCord integer /0/
 # if zero toroidal flux coordinate system
 # if zero poloidal flux coordinate system

****** Torflux:
# Variables used in coupling equilibrium and transport

%ifelse(Module,cscwake|cscdata|csciyiyi,[],[
%  Use(Torflux_Dimensions)
%])

oneTorf real /1.0/
 # "1" multiplying torf in flux equation...
 # Used to apply feedback to control psi

chargeNum(Nparts) real
/ -1.0, 1.0, 1.0, 1.0, 1.0, 2.0, 4.0, 6.0, 8.0, 26.0 /
 # Charge numbers for particle species

ibsTot real [MA]
 # bootstrap current

neoTrCoef(mtor,nsp2tor,nsp2tor) _real
 # neoclassical radial transport coefficients from bootstrap routine

neoPinchCoef(mtor,nsp2tor) _real [rhobar/s/V]
 # neoclassical pinch coefficients from bootstrap routine

itor(mtor) _integer
