/* FILE: cscBase.cc */

#if !defined(__csc__)
#include "csc.h"
#endif

#if defined(UseCTLPackage)
  extern "C" Integer csc_cscgen(Integer &, Integer &);
  extern "C" Integer csc_cscexe(Integer &, Integer &);
  extern "C" Integer csc_cscfin(Integer &, Integer &);
#endif



// Group Utility


// create_backup_fcns is a fortran subroutine
extern "C" void csc_create_backup_fcns( void );
void csc::create_backup_fcns()
  {
      ::csc_create_backup_fcns();
  }

// csc_attrlist is a fortran subroutine
extern "C" void csc_csc_attrlist( Integer &, Character &, Character & );
void csc::csc_attrlist( Integer &jout, Character &attr, Character &servestr )
  {
      ::csc_csc_attrlist( jout, attr, servestr );
  }

// erset is a fortran subroutine
extern "C" void csc_erset( Integer &, Integer &, Integer & );
void csc::erset( Integer &iersvr, Integer &ipact, Integer &isact )
  {
      ::csc_erset( iersvr, ipact, isact );
  }



// Group Codeinfo


extern "C" struct {
  Char codename[8];
} CSC10000_Codeinfo;

extern "C" struct {
  Char logname[64];
} CSC10001_Codeinfo;

extern "C" struct {
  Char author[64];
} CSC10002_Codeinfo;

extern "C" struct {
  Char shotName[8];
} CSC10003_Codeinfo;

extern "C" struct {
  Integer logunit;
  Integer nprob;
} CSC10_Codeinfo;

extern "C" struct {
  Double shotTime;
} CSC13_Codeinfo;

Vector<Char> csc::codename(1,8, CSC10000_Codeinfo.codename);
Vector<Char> csc::logname(1,64, CSC10001_Codeinfo.logname);
Integer  &csc::logunit = CSC10_Codeinfo.logunit;
Vector<Char> csc::author(1,64, CSC10002_Codeinfo.author);
Integer  &csc::nprob = CSC10_Codeinfo.nprob;
Vector<Char> csc::shotName(1,8, CSC10003_Codeinfo.shotName);
Double  &csc::shotTime = CSC13_Codeinfo.shotTime;


// Group Torflux_Dimensions


extern "C" struct {
  Integer mtor;
  Integer nsp2tor;
  Integer fluxCord;
} CSC20_Torflux_Dimensions;

Integer  &csc::mtor = CSC20_Torflux_Dimensions.mtor;
Integer  &csc::nsp2tor = CSC20_Torflux_Dimensions.nsp2tor;
Integer  &csc::fluxCord = CSC20_Torflux_Dimensions.fluxCord;


// Group Torflux


extern "C" struct {
  Double oneTorf;
  Double chargeNum[Nparts];
  Double ibsTot;
} CSC33_Torflux;

extern "C" struct {
  Double *neoTrCoef;
  Double *neoPinchCoef;
  Integer *itor;
} CSC36_Torflux;

Double  &csc::oneTorf = CSC33_Torflux.oneTorf;
Vector<Double> csc::chargeNum(1,Nparts, CSC33_Torflux.chargeNum);
Double  &csc::ibsTot = CSC33_Torflux.ibsTot;
Array3<Double> csc::neoTrCoef(false);
Matrix<Double> csc::neoPinchCoef(false);
Vector<Integer> csc::itor(false);

// Sync function initializations

void csc::sync()
{
  neoTrCoef.init(1,mtor,1,nsp2tor,1,nsp2tor, CSC36_Torflux.neoTrCoef);
  neoPinchCoef.init(1,mtor,1,nsp2tor, CSC36_Torflux.neoPinchCoef);
  itor.init(1,mtor, CSC36_Torflux.itor);
}

// Run-controller package stuff:

#if defined(UseCTLPackage)

extern "C" {
  Integer csc_cscgen(Integer &optlist, Integer &nopt)
    {
      Vector<Integer> optlist1(32, &optlist);
      return csc::gen(optlist1, nopt);
    }
  Integer csc_cscexe(Integer &optlist, Integer &nopt)
    {
      Vector<Integer> optlist1(32, &optlist);
      return csc::exe(optlist1, nopt);
    }
  Integer csc_cscfin(Integer &optlist, Integer &nopt)
    {
      Vector<Integer> optlist1(32, &optlist);
      return csc::fin(optlist1, nopt);
    }
};

#endif  /* ifdef(UseCTLPackage) */
