# Copyright 1988 Regents of the University of California
      function ctlrun(command,runpkg,runplot,runexe,maxits)
   # run package whose name is runpkg ; if runpkg is blank, run current package
   # command: "run", "generate", "step", "finish"
   # runplot:
   #   controls whether or not the pkggenp, pkgexep, pkgfinp stages are called
   # runexe:
   #   controls whether or not the pkggen, pkgexe, pkgfin stages are called
   # maxits: maximum number of iterations to run before returning
   #         if < 0, use default limit for this package
      integer ctlrun, runplot, runexe, maxits
      character*(*) command, runpkg
# returns OK, ERR, or DONE after running package runpkg
# command is generate, step, finish, or run
# maxits is a maximum iteration maxits or <0 = package default
      integer i,status,statusp,istop,n
      character*3 pknam
      integer glbgetcp, glbpknum, izverbos, glbmax
      external glbgetcp, glbpknum, izverbos, glbmax
      integer glbgen,glbgenp,glbexe,glbexep,glbfin,glbfinp
      external glbgen,glbgenp,glbexe,glbexep,glbfin,glbfinp
#   Changed write(STDOUT,... to call remark. (FNF 7/15/97)
      character*80 message
#
      status = OK
      if(runpkg == " ") then
	n = glbgetcp()
	call glbpknam(n,pknam)
      else
	n = glbpknum(runpkg)
	pknam = runpkg
	if(n == 0 ) return(ERR)
      endif
      if(runplot == 0 & runexe == 0) then
	call remark("ctlrun: don't plot or run??? ")
	return(ERR)
      endif
# generate
      if(command == "generate" | command == "run") then
         if(runexe > 0) then
             if(glbgen(n,ctlopt,nctlopt) == ERR) return(ERR)
         endif
         if(runplot > 0) then
             if(glbgenp(n,ctlopt,nctlopt) == ERR) return(ERR)
         endif
      endif
# execute
      if(command == "step" | command == "run") then
         if(runexe == 0) then
                if(glbexep(n,ctlopt,nctlopt) == ERR) return(ERR)
         else          
		if( maxits < 0) then 
		   istop = glbmax(n)
		else
		   istop = maxits
		endif
                do i=1, istop
                  call ruthere
                  status = glbexe(n,ctlopt,nctlopt)
                  if(status == ERR) then
                        call remark("Package error in "//pknam)
                        return(ERR)
                  else
                        if(runplot > 0) then
                              statusp = glbexep(n,ctlopt,nctlopt)
                              if(statusp == ERR) then
                                 call remark("Error in step-plot package.")
                                 return(ERR)
                              endif
                        endif
                  endif
                  if(status == DONE ) then
                      if (izverbos() <> 0) then
                        call remark("DONE status received from "//pknam)
                      endif
                      go to 95
                  endif
                enddo i
                if (izverbos() <> 0 & istop > 1) then
                  write(message,90) pknam, istop
                  call remark(message)
	        endif
90      format("Package ",a," completed maximum number of allowed steps: ",i6)
        endif
95      continue
      endif
# finish
      if(command == "finish" | command == "run") then
        if(runexe > 0) then
                if(glbfin(n,ctlopt,nctlopt) == ERR) return(ERR)
        endif
        if(runplot > 0) then
                if(glbfinp(n,ctlopt,nctlopt) == ERR) return(ERR)
        endif
      endif
      return(status)
      end
      subroutine ctlinit
      call mcchrdef(
         "generate",
         'ctl.ctlstat=ctlrun("generate",ctl.ctlpkg,ctl.ctlplot,ctl.ctlexe,0)',
         FALSE)
      call mcchrdef(
	  "step",
	  'ctl.ctlstat='//\
	  'ctlrun("step",ctl.ctlpkg,ctl.ctlplot,ctl.ctlexe,ifelse($1,)(-1,$1))',
	  TRUE)
      call mcchrdef(
	  "finish",
          'ctl.ctlstat=ctlrun("finish",ctl.ctlpkg,ctl.ctlplot,ctl.ctlexe,0)',
	  FALSE)
      call mcchrdef(
	  "run",
          'ctl.ctlstat='//\
	  'ctlrun("run",ctl.ctlpkg,ctl.ctlplot,ctl.ctlexe,ifelse($1,)(-1,$1))',
	  TRUE)
      return
      end
