.\" groff -Tascii -mgm -t %s
.\" groff -mgm -t %s
.de TP
.sp 3
..
.PH ""
.PF "''- % -'"
.S 12
.if t .2C
.H 1 "Requirements for Basis layout, naming, archiving, and notice"
.P
We maintain several binary distributions of Basis for use by customers
in A-Program at LLNL.
Other customers require access to source code distributions.
They can modify Basis layout and naming to fit their local needs.
.P
.H 2 "Layout"
.P
Refer to the diagram titled "Basis /usr/gapps layout",
as shown in the document doc/notes/b12layout.pic.
.P
.H 2 "Naming and versioning"
.P
We make four well-known versions of Basis available at any given time.
In directory /usr/local/apps, the following links should exist:
.AL a
.LI
basisold:
This link points to the public release of Basis immediately prior
to the one named by basis.
.LI
basis:
This link points to the current public release of Basis.
Public releases have occurred at the rate of about two per year
in the past.
Public releases are not patched,
save to repair crucial problems,
after release.
Source code distributions (tar files) of Basis are made to match
the public releases.
.LI
basisnew:
This link points to a version of Basis at least as new as basis
itself.
All new functionality needed by A-Program client codes that is not in
the current public release is normally made available in basisnew.
Thus it is updated as needed,
whenever such new functionality appears.
.LI
basisexp:
This link points to a version of Basis that is usually updated daily.
It is the latest version of Basis known to have passed the
automatic regression test series.
Lasnex automatic daily tests should link against basisexp.
.LE
.P
.H 2 "Archiving"
.AL a
.LI
Binary distributions of Basis public releases are retained on disk at least
as long as customers and machines remain to run them.
At least one older binary distribution is always available
through the well-known name basisold.
Others may be available as numbered releases under /usr/gapps/basis.
The last binary release before a major new release (change in
the major number) is archived on the tape storage unit at LC.
.LI
Source code for basis is archived periodically by storing a snapshot
of the code repository as a dated file on the LC tape storage unit.
Other archiving and backup processes may also be in operation,
outside the purview of the Basis development group.
.LE
.P
.H 2 "Notice"
.P
.AL a
.LI
Public releases of Basis require approximately two weeks notice.
Sample notices are available at doc/HOWTO/notice.*.
Mid-week releases are usually best.
See basis/doc/HOWTO/RELEASE-HOWTO for additional details
regarding notice.
.LI
Updates of basisnew can proceed with minimal notice to the local community
of basis programmers.
Friday updates should be avoided.
.LE
.P
.H 1 "Stages of the public release process"
.P
.H 2 "Before the release"
.P
In the tables following,
"Linkname" is the well-known name for a given version
as discussed above.
This is implemented as a symbolic link in /usr/local/apps.
"Directory" is a subdirectory of /usr/gapps/basis.
To be precise, a given well-known name (link) will point to 
a dev/<arch> subdirectory of Directory.
The typical contents of a given directory are named
as a specific version number of the Basis source code.
The literal version numbers given are appropriate for the time
of writing,
but may be expected to increase as time goes by.
.DS
.TS
lll.
Linkname	Directory	Contents
\_	\_	\_
basisold	11.12	11.12.0
basis	12.0	12.0.0
basisnew	new	12.0.m, m\(<=n
basisexp	exp	12.0.n, n\(>=0
.TE
.DE
.DS
.P
.H 2 "Release stage 1: Announce"
Actions:
  - Increment minor version number for exp;
  - Announce the pending release.
.DE
.DS
.TS
lll.
Linkname	Directory	Contents
\_	\_	\_
basisold	11.12	11.12.0
basis	12.0	12.0.0
basisnew	new	12.0.m_max
basisexp	exp	12.1.0
.TE
.DE
.DS
.P
.H 2 "Release stage 2: Two week trial period"
Actions:
  - Patch number for exp may increase.
.DE
.DS
.TS
lll.
Linkname	Directory	Contents
\_	\_	\_
basisold	11.12	11.12.0
basis	12.0	12.0.0
basisnew	new	12.0.m_max
basisexp	exp	12.1.p, p\(>=0
.TE
.DE
.P
.H 2 "Release stage 3: Completion"
.P
The following set of actions outlines the steps needed to
complete a Basis binary and source code release on our
unclassified networks.
A subset of these actions is necessary to complete release
on the classified networks tended by the Basis development group.
.DS
Actions:
  - Reminder notice at T-minus one day.
  - Update basisnew:
      do-net .../hosts.install -a -vers new
  - Update basisexp:
      do-net .../hosts.install
  - Build the public version:
      do-net .../hosts.install -a -vers 12.1
  - Relink basisold to old public version
  - Relink basis to new public version
  - Tag repository
  - Create source distribution tar file
  - Update ftp site
  - Update web pages
  - Send completion notice.
.DE
.DS
.TS
lll.
Linkname	Directory	Contents
\_	\_	\_
(none)	11.12	11.12.0
basisold	12.0	12.0.0
basis	12.1	12.1.p, p\(>=0
basisnew	new	12.1.p, p\(>=0
basisexp	exp	12.1.p, p\(>=0
.TE
.DE
.P
.H 1 "The update process for basisnew"
.P
Basisnew is updated at the same time the public version is updated,
to preserve the requirement that it always be at least as recent
as the public code.
Basisnew may also be updated separately from the public code.
.P
Update actions for basisnew alone are the same as the first
two steps from stage 3 as shown earlier,
plus the final completion notice.
