/*--------------------------------------------------------------------------*/

/**
 * leos_setup_linear ::: Compute piecewise linear interpolation coefficients.
 *
 *   x     (i) : An array of independent variable values.
 *               x must be strictly increasing. (Error return if not.)
 *   y     (i) : The associated array of dependent variable values.
 *   n     (i) : An integer specifying the number of data points.
 *               Restriction: n > 1. (Error return if not.)
 *   coeff (o) : The array of interpolation coefficients, length 2*n.
 *               The even-numbered entries contain a copy of y; the odd
 *               entries contain the data slopes on each interval. 
 *
 * The resulting interpolating function is compatible with the bilinear
 * function determined by leos_setup_bilinear.
 *
 * Return value:  The return value, retval, should be zero.
 *    A negative value is an error:
 *        retval = -1 : n < 2.
 *        retval = -3 : x-array is not strictly increasing.
 *    In none of these cases has a valid coeff array been computed.
 *
 **
 */ 

Integer leos_setup_linear( Real8 *x, Real8 *y, Integer n, Real8 *coeff )
{
    Declarations
    Executable code
}

/*--------------------------------------------------------------------------*/
