c  NCAR Graphics Guide to New Utilities, Appendix B
c  recommends replacing agpwrt to use the plotchar routines instead of the
c  old pwrit* or wtstr routines, and provides this coding.
c  Added coding for isiz=1:4 so it would perform as per AutoGraph manual.
c  A. B. Langdon, 1991; hacked by Paul Dubois 1993 to get sizes right

c  Default agpwrt does only:  CALL PWRIT (XPOS,YPOS,CHRS,NCHS,ISIZ,IORI,ICEN)
c  That in turn only calls wtstr, who eventually calls gtx to write the string.
c  Plotchar routine plchlq also uses gtx to write the string.

      subroutine agpwrt (xpos,ypos,chrs,nchs,isizp,iori,icen)
      real xpos, ypos
      character*(*) chrs
      integer nchs, isizp, iori, icen, iqual

      save agpwrtdb, agpwrtqu, agpwrtcd
      integer agpwrtdb, agpwrtqu, agpwrtcd
      data  agpwrtdb/0/, agpwrtqu/1/, agpwrtcd/0/
c  agpwrtdb nonzero prints all calls to agpwrt.
c  agpwrtqu	the plotchar QU parameter
c	<0   	call pwrit same as in default agpwrt.  
c	0	High-quality characters. Plotchar default.
c	1	Medium-quality (Our default)
c	2	Low-quality via GKS primitives.
c  agpwrtcd	the plotchar CD parameter. Only matters for QU = 0.
c	0	Complex alphanumerics (serifs etc).  Default.
c	1	Duplex alphanumerical characters.
c  NCAR warns that changing CD results in the overhead of reading a file.
c  They don't explicitly say this happens if you set CD to the existing value.
c  In fact the plchhq coding checks and seems to skip the read if the value
c  hasn't changed.  Nonetheless we also test.  Is that wise? -someone else
c  may have changed CD.

      integer isiz, cdsave
      real csfl
      save cdsave
      data cdsave/0/


c See what Autograph or other caller is doing...
      if(agpwrtdb .ne. 0) then
        write(*,'(2f5.2,3i4,1x,a)') xpos, ypos, isizp, iori, icen,
     .    chrs(1:min(60,nchs))
      endif

      if(agpwrtqu .lt. 0) then
c      Same as default agpwrt
	call pwrit(xpos,ypos,chrs,nchs,isizp,iori,icen)
	return
      endif

c  Sizes 1:4 map to 8,12,16,20, per AutoGraph manual and older pwrit routine.
	if (isizp.eq.1) then
	  isiz = 8
	elseif (isizp.eq.2) then
	  isiz = 12
	elseif (isizp.eq.3) then
	  isiz = 16
	elseif (isizp.eq.4) then
	  isiz = 20
	else
	  isiz = isizp
	endif


c  We could call pcseti('QU',agpwrtqu), call plchql(....  but then we'd affect
c  anyone else who calls plchhq.
      if(agpwrtqu.eq.0) then
c  If agpwrtcd has changed since we last set CD, give it new value.
        if(agpwrtcd.ne.cdsave) then
	   cdsave = abs(agpwrtcd)
	   agpwrtcd = cdsave
           call pcseti('CD',cdsave)
        endif
	call pcgetr ('CS - CONSTANT SPACING FLAG',csfl)
	if (icen.ne.0) then
	  call pcsetr ('CS - CONSTANT SPACING FLAG',1.25)
	else
	  call pcsetr ('CS - CONSTANT SPACING FLAG',0.)
	endif
	call plchhq (xpos,ypos,chrs(1:nchs),
     +               0.8*real(isiz),real(iori),real(icen))
        call pcsetr ('CS - CONSTANT SPACING FLAG',csfl)
      elseif(agpwrtqu.eq.1) then
	call plchmq (xpos,ypos,chrs(1:nchs),
     +               real(isiz),real(iori),real(icen))
      else
	call plchlq (xpos,ypos,chrs(1:nchs),
     +               real(isiz),real(iori),real(icen))
      endif
      return

      entry ezcstxqu(iqual)
      agpwrtqu = iqual
      return
      entry ezcitxqu(iqual)
      iqual = agpwrtqu
      return
      end
