ezd
#Graphical devices package
usertype real4 
{
%define real4 real(Size4)
%define _real4 real4
CGMUNIT=50
CGMLOGUNIT=51
PSLOGUNIT=52
PSUNIT=53
NWINDOWS=30	#maximum number of windows
NCOLORSH=17	#number of colors setup for this GKS (YHC)
NCOLORSL=-7	#add "power" "relpow" YHC 4/5/95
CGMWKID=1
PSWKID=1900
GASAP=0
GALLOW=1
GSNEVR=2
GIFIXUP=4
GREALI=1
GCLIP=1
}
********** Devices local:
%Use(Device_Control)
%Use(Device_Internal)
%Use(Problem_name)

********** Problem_name /baspn/ hidden:
$Note, shared with parser package if Basis present
$Same as Basis variable "probname"
fnroot character*(32)

********** Device_Control dump:
#variables to control the graphics devices
ezccgmc integer 
   #Number of frames to put in a single CGM file.
cgmfile Filename -dump
   # Name of the current CGM file.
cgmfsfx integer
   # CGM file suffix.
iezccgmf Filename -dump
   # Log file name for CGM device.
ezcpsc integer
   #Number of frames to put in a single PS file.
psfile Filename -dump
   # Name of the current PS file.
psfsfx integer
   # PS file suffix.
iezcpsf Filename -dump
   # Log file name for PS file.

$for window workstations
ezcdisp character*32  -dump
   #X11 display specification.
ezcwinht real4 -dump
   #X11 window height in inches. (default = 7.)
ezcwinwd real4 -dump
   #X11 window width in inches. (default = 7.)
ezcwinlb character*16 -dump
   #X11 window label specification.

$for parameter index specifications
ezcpidx integer /0/
   # Parameter index, for use with ezcset and ezcget routines.

********** Device_Internal hidden:
iezcdev integer 
   # Number of active devices.
codeplot integer 
   # Are plots active?
ezcsend logical /FALSE/
   # Is this frame the result of a "device send" command?

$for CGM workstation
iezccgma integer
   # CGM workstation status flag: -1 uninitialized, 0 off, 1 on.
iezccgmn integer
   # Number of frames in current CGM file.
cgmclrmap character*16
   # CGM colormap name, default "color".

$for Xwindow workstation
winclrmap character*16
   # Xwindow colormap name, default "color".
iwinop integer
   #Open window count.
iwsidset integer
   #Workstation id, initialized to 1000.
idwind Address
   #Connection id from GXWIN (must be 64 bits).
winame(NWINDOWS) character*16
   #List of window names.
winstate(NWINDOWS) logical
   #List of window activations.
iwsid(NWINDOWS) integer
   #Workstation id assigned to the window list.
iwscn(NWINDOWS) Address
   #Workstation connection id (each must be 64 bits).
windisp(NWINDOWS) character*32
   #Associated DISPLAY of the window.
winncoli(NWINDOWS) integer
   #Number of colors available on window.
wincola(NWINDOWS) integer
   #Is this a color window?

$for PostScript workstation
iezcpsa integer
   # Postscript workstation activation status.
iezcpsn integer
   # Number of frames in current PS file.
psclrmap character*16
   # PS colormap name, default to "mono".

$for minimum character size
ezcminch integer
   # Minimum character size.  (Set via ezcminsz.)

*********** Colors:
color(NCOLORSL:NCOLORSH) character*16
   #Names of colors.
debcolr integer
   # Print debug output in color routines if non-zero.
indbase integer
   # First color available to user (also number of named colors).
   # DO NOT ASSIGN TO THIS VARIABLE.
numcol integer
   # Number of user alterable colors.
bakcol integer
   # Background color: 0 means black, else white.
   # Caution: The recommended way to set this is via ezcsetbb or ezcsetbw.
indmax integer
   # Maxium color index that has been set for the colormap.

ezcred(249) integer /249*0/
   # Red in user defined RGB for colormap.
ezcgreen(249) integer /249*0/
   # Green in user defined RGB for colormap.
ezcblue(249) integer /249*0/
   # Blue in user defined RGB for colormap.

ezccoltb(indlo:integer,indhi:integer,red:real4,green:real4,blue:real4) integer function
   # Set color representation for indices indlo thru indhi from arrays
   # red, green, and blue.
ctablist() integer function
   # Print the color table of the X11 window to the terminal.
ezcgetcol(indx:integer) integer function
   # Print the RGB components of the color whose index is indx.
loadct(ctab:integer) integer function
   # Load numbered color table.
reqcolr(nreq:integer) subroutine
   # Request number of entries in color table.
backcolr(bakndx:integer) subroutine
   # Request background color (0 for black, 1 for white).
ezcsetbw subroutine
   # Set background color to white.
ezcsetbb subroutine
   # Set background color to black.

****** Ptext /ptextc/:
nptext integer /45/
   #Number of lines per page for ptext.
textline integer /0/
   #Number of lines on current ptext page.
%save /ptextc/

********** Routines:
#Routines in ezc package
ezcquad(iquad) subroutine
   #Set quadrant: 1, 2, 3, 4, 12, 34, 13, 24, or 1234.
ezcdquad(v1:real4,v2:real4,v3:real4,v4:real4) subroutine
   #Set portion of 0-1 space to be used for the quadrants by ezcquad.
ezciquad(v1:real4,v2:real4,v3:real4,v4:real4,iquad:integer) subroutine
   #Inquiry for quadrant parameters.  (All arguments are outputs;
   #do not forget the &s if used from Basis.)
ezcsquad(v1:real4,v2:real4,v3:real4,v4:real4) subroutine
   #Set quadrant parameters.  (Does not have to be a quadrant per se.)
ezcshowg subroutine
   #sf: display current frame.
ezcnf subroutine
   #nf: begin new frame.
ezcdodev(device:string;flag:string,aux:string) subroutine
   # Process command:  device flag aux
   #   device = "cgm", "ps", "tex", or "win";
   #   flag ="on", "off", "send" or "close".
ezcifname(s1:string,s2:string) subroutine
   # Inquiry for file name.
ezccklen(fname1:string,fname2:string,nadd:integer) logical function
   # Check whether fname2 has ezactly nadd more characters than fname1.
   # Return value is TRUE if this condition is satisfied, else FALSE.
   # Intended to check for truncation during filename construction.
ezciunit(iunit:integer,unitype:string) subroutine
   # Inquiry for the unit number of the input unitype; e.g. cgm,ps,etc.
   # (Basis users: don't forget & on first argument.)
ezcwrtlog(message:string) subroutine
   # Write message (character*120) to the log file.
ezcgeti(pname:string,pvalue:integer) subroutine
   # Get the current value "pvalue" of integer parameter "pname".
   # (Don't forget to use &pvalue if called from Basis.)
   # If "pname" is an array name, ezcpidx is the index of the array
   # element, which should be set with ezcseti.
ezcgetr(pname:string,pvalue:real4) subroutine
   # Get the current value "pvalue" of real parameter "pname".
   # (Don't forget to use &pvalue if called from Basis.)
   # If "pname" is an array name, ezcpidx is the index of the array
   # element, which should be set with ezcseti.
ezcgetc(pname:string,pvalue:integer) subroutine
   # Get the current value "pvalue" of string parameter "pname".
   # WARNING: this routine will NOT work in Basis.
   # If "pname" is an array name, ezcpidx is the index of the array
   # element, which should be set with ezcseti.
ezcseti(pname:string,pvalue:integer) subroutine
   # Set the integer parameter "pname" to value "pvalue".
   # If "pname" is an array name, ezcpidx is the index of the array
   # element, which should be set with ezcseti.
ezcsetr(pname:string,pvalue:real4) subroutine
   # Set the real parameter "pname" to value "pvalue".
   # If "pname" is an array name, ezcpidx is the index of the array
   # element, which should be set with ezcseti.
ezcsetc(pname:string,pvalue:string) subroutine
   # Set the string parameter "pname" to value "pvalue".
   # If "pname" is an array name, ezcpidx is the index of the array
   # element, which should be set with ezcseti.
ezdckwin(wson:integer,wsid:integer,wsname:string,wsdisp:string) subroutine
   # Return the number of currently active windows in wson.
   # If the return value of wson is > 0, then:
   #   wsid   is the workstation ID of the most recently opened one,
   #   wsname is the associated window name (character*16), and
   #   wsdisp is the display on which the window is open (character*32).
ezdflwin(wsid:integer,stat:integer) subroutine
   # Flush any outstanding events on window with workstation ID wsid.
   # A return value of stat > 0 implies trouble flushing.
ezdpbsv subroutine
   # Probe the current active window until ezdprob returns qflag<>0.
ezdprobe(px:real4,py:real4,upx:real4,upy:real4,qflag:integer) subroutine
   # Probe the current active window for values.
   # qflag returns nonzero if probe is outside plot frame.
ezcctoi(colorname:string)  integer function
   # Determine the corresponding color index for a given colorname

****** Ezcxnc /ezcxnc/ hidden :
notified integer /NO/
%save /ezcxnc/
