      subroutine ezccell(icell,kmax,lmax,xmin,xmax,ymin,ymax)
c------------------------------------------------------------------------
c*s
c       NAME OF ROUTINE...ezccell  
c
c       AUTHOR OF ROUTINE...Steve Langer...Oct. 30, 1992
c
c       PURPOSE...
c           Draws a cell array with corners at (xmin,ymin) and (xmax,ymax).
c           The color index for each cell is in the array colors.
c           There are kmax by lmax cells.
c
c       GLOSSARY OF IMPORTANT VARIABLES...
c           xmin,xmax,ymin,ymax  =: coordinates of corners.
c           kmax,lmax            =: size of color index array.
c           icell                =: 2D array of color indices.
c
c
Use(Colors)
c
define GCLIP 1
c
      integer kmax,lmax
      integer icell(kmax,lmax)
      real(Size4) xmin, xmax, ymin, ymax
c	the following are used in controlling clipping
	integer errind, iclip, ii, jj
	real(Size4) clrect(4)
c
c---Check for legal portion of color array.
        if(kmax .le. 0 .or. lmax .le. 0) then
           return
        endif
c	save old clipping state and turn on clipping
	call gqclip(errind, iclip, clrect)
	if(iclip .ne. GCLIP) call gsclip(GCLIP)
c---Adjust the color indices to reflect the base color
	do jj=1,lmax
	   do ii=1,kmax
	      icell(ii,jj)= min(numcol,max(1,icell(ii,jj)))
     1	             +indbase-1
           enddo
        enddo
c---Plot the cell array.
	call gca(xmin,ymin,xmax,ymax,kmax,lmax,1,1,kmax,lmax,icell)
c---Restore the color indices
	do jj=1,lmax
	   do ii=1,kmax
	      icell(ii,jj)= icell(ii,jj)-(indbase-1)
           enddo
        enddo
c	restore clipping
	if(iclip .ne. GCLIP) call gsclip(iclip)
      return
      end
