        subroutine ezccgm(iflag,istring)
        character*(*) iflag,istring
#     Routine to process command "cgm iflag istring".
#
# Change record:
# (yymmdd means 19yy/mm/dd)
#  970304  (FNF)
#     1. Changed "write(STDOUT,..." statements to "call remark".
#     2. Deleted archaic Cray code for sending cgm file to microfiche.
#     3. Additional minor housekeeping.
#  970305  (FNF)
#     Modified to make sure that cgm and cgmlog file get same suffix.
#  970311  (FNF)
#     Changed character*(80) declaration for fnameroot to Filename.
#  970312  (FNF)
#     Created local character*80 variable cgmncar for NCAR's GESC call.
#  970516  Made "open" a synonym for "on".  (FNF)
#  970812  Changed "call remark" statements to "call ezcremrk".  (FNF)
#  971229  Cosmetic changes to make ezccgm and ezcps more similar. (FNF)
#  980626  Eliminated extra blank frame from "cgm send" files. (FNF)
# (yymmdd means 20yy/mm/dd)
#  000517  Removed code for ATC GKS, which is no longer supported. (FNF)
#  000517  Removed code related to (unsupported) tek output. (FNF)
# -------------------------------------------------------------------------
Use(Devices)
Use(Colors)
        Filename  fnameroot
        character*(16) filetype
        character*(16) oldcmap    #Temp store of old colormap name
        integer iws, iwstype      #Integers for workstation id and type
        integer i, j, k
        integer verbfl
        logical winrvs(NWINDOWS), psrvs
        integer suffile, sufflog  #Temporary file suffix values
        logical fnsucc            #Flag for successful file name assignment
        character*(120) msg       #Error message

        integer rtgetverb
        external rtgetverb

        integer ezcgetcl
        external ezcgetcl

        character*(80) cdum, cgmncar
        integer idum

        verbfl = rtgetverb()

	iws = CGMWKID 
        iwstype = 1
        call ezcp(1)
        if (iflag == "on" | iflag == "open") then
	  # Open the CGM device.
               if (iezccgma < 0) then
	       # Set the name of the CGM file.
		  if (fnroot == " ") fnroot = "Problem"
		  fnameroot = fnroot(1:ezcgetcl(fnroot))

		  #Append suffix, making sure cgm and cgmlog get same one.
                  # This takes care of case user has moved either old cgm
                  # files or old cgmlog files (but not both).
                  # Note that this is not foolproof if there are gaps in the
                  # suffixes on existing files.  (FNF 3/05/97)
                  filetype = "cgm"
                  suffile = cgmfsfx
	          call ezcapsfx(fnameroot,filetype,suffile,cgmfile,fnsucc)
		  if (~fnsucc) goto 210
		  filetype = "cgmlog"
                  sufflog = cgmfsfx
	          call ezcapsfx(fnameroot,filetype,sufflog,iezccgmf,fnsucc)
		  if (~fnsucc) goto 200
                  cgmfsfx = max(suffile, sufflog)
                  if (suffile < cgmfsfx) then
                     filetype = "cgm"
                     cgmfsfx = cgmfsfx-1  # Adjust to suffix actually used
	             call ezcapsfx(fnameroot,filetype,cgmfsfx,cgmfile,fnsucc)
		     if (~fnsucc) goto 210
                  else if (sufflog < cgmfsfx) then
		     filetype = "cgmlog"
                     cgmfsfx = cgmfsfx-1  # Adjust to suffix actually used
	             call ezcapsfx(fnameroot,filetype,cgmfsfx,iezccgmf,fnsucc)
		     if (~fnsucc) goto 200
                  endif

               # Now actually create/open the CGM file.
                  cgmncar = cgmfile  # Must be 80 chars (FNF 3/12/97)
                  cdum = " "
                  call gesc(-1391,1,cgmncar,1,idum,cdum)
                  call setusv('MU',CGMUNIT)
                  call gopwk(iws,CGMUNIT,iwstype)
	       # Notify user of the CGM file name.
                  if (verbfl .eq. 1) then
                     write(msg,105) cgmfile(1:ezcgetcl(cgmfile))
105                  format('Beginning CGM File ',a)
                     call ezcremrk(msg)
                  endif

               # Create/open the CGM log file and notify user.
                  open(unit=CGMLOGUNIT,file=iezccgmf(1:ezcgetcl(iezccgmf)),\
			status='new',err=200)
                  if (verbfl .eq. 1) then
                     write(msg,100) iezccgmf(1:ezcgetcl(iezccgmf))
 100                 format('Beginning CGM Log ',a)
                     call ezcremrk(msg)
                  endif

               # Finish CGM device initialization.
                  call gacwk(iws)
                  iezccgma = 1
                  iezcdev = iezcdev + 1
                  # Initialize color indices (for color CGM).
                  if (istring == "mono") then
		     cgmclrmap = "mono" 
		     call ezcmono(iws,iwstype)
                  else 
		     call ezccidx(iws,iwstype,cgmclrmap)
                  endif
               endif

	       # Check for previously opened CGM file.
               if (iezccgma == 0) then
                  call gacwk(iws)
                  iezcdev = iezcdev + 1
                  iezccgma = 1
               endif

        elseif (iflag == "off") then
               if (iezccgma > 0) then
                  call gdawk(iws)
                  iezcdev = iezcdev - 1
                  iezccgma = 0
               endif

        elseif (iflag == "close") then
               if (iezccgma >= 0) then
                  if (iezccgma>0) then
                    call gdawk(iws)
                    iezcdev = iezcdev - 1
                  endif
                  call gclwk(iws)

                # Removed archaic Cray code to "give" cgm file to lpr for
                # printing on microfiche, depending on variable ezcgk.

                  iezccgma = -1
                  if (verbfl .eq. 1) then
                     write(msg,110) cgmfile(1:ezcgetcl(cgmfile)),iezccgmn
 110                 format('Closed CGM File ',a,', ',i5,' frames.')
                     call ezcremrk(msg)
                  endif
                  iezccgmn = 0
                  close(CGMLOGUNIT)
                  if (verbfl .eq. 1) then
                     write(msg,500) iezccgmf(1:ezcgetcl(iezccgmf))
 500                 format('Closed CGM Log File ',a)
                     call ezcremrk(msg)
                  endif
               endif

        elseif (iflag == "send") then
		# Deactive PS if it is on.
		psrvs = FALSE
		if (iezcpsa > 0) then
		   call ezcps("off"," ")
		   psrvs = TRUE
		endif

		# Deactivate windows, if any.
		if (iwinop > 0) then
		   #initialize the window reverse state array 
		   do k=1,NWINDOWS
	              winrvs(k) = FALSE
		   enddo	
		   do i=1,iwinop
		      if (winstate(i)) then
			 winrvs(i) = TRUE
		         call ezcwin("off",winame(i))
		      endif
		   enddo
		endif

		# Open CGM and write frame to it.
		if (iezccgma <= 0) then
		      call ezccgmr("on",istring)
		endif
                ezcsend = TRUE
		call ezcshowg
                ezcsend = FALSE
                # Turn it off.
		call ezccgmr("off"," ")

		# Restore the orginal states before "send".
		if (psrvs) call ezcps("on"," ")
		if (iwinop >0) then
		   do j=1,iwinop
		      if (winrvs(j)) call ezcwin("on",winame(j))
		   enddo
		endif

        elseif (iflag == "colormap") then
           oldcmap = cgmclrmap
           cgmclrmap = istring
           if (debcolr <> 0) then
              msg = "CGM colormap has been set to "//cgmclrmap(1:ezcgetcl(cgmclrmap))
              call ezcremrk(msg)
           endif
           if (iezccgma < 0) then
	      call ezccgmr("on"," ")
           else
              if (oldcmap <> cgmclrmap) then
                 if (iezccgma == 0) then
	            call ezccgmr("on"," ")
	            call ezccidx(iws,iwstype,cgmclrmap)
                    call ezccgmr("off"," ")
                 else
	            call ezccidx(iws,iwstype,cgmclrmap)
                 endif
              endif
           endif

        else
	   msg = "ezccgm: ignoring unknown command- "//iflag(1:ezcgetcl(iflag))	
	   call ezcerror(msg,0)
        endif
        return

#      Error exits
200     msg = "Could not create CGM log file."
	call ezcerror(msg,1)
	return
210     msg = "Could not create CGM graphics file."
	call ezcerror(msg,1)
	return

        end

        subroutine ezccgmr(iflag,istring)
c recursion intermediary
        character*(*) iflag,istring
        call ezccgm(iflag,istring)
        return
        end
