	subroutine ezccidx(iws,iwstype,colormap)
	# initialize color indices

# (FNF  7/30/1997) Changed "write(STDOUT,..." statements to "call remark".
# (FNF  8/12/1997) Changed "call remark" statements to "call ezcremrk".
# (FNF 12/29/1997) Minor changes for NCAR GKS.
# (FNF  5/17/2000) Removed code for ATC GKS, which is no longer supported.

        character*16 colormap
	integer iws,iwstype	#workstation id and workstation type
	integer cola # color availability indicator (GMONOC=0,GCOLOR=1)
	integer lmtidx	#color index limit
	integer bkctmp  #temp background color flag for PS or CGM usage

        character*80 msg
Use(Colors)

	# set ASPECT SOURCE FLAGS to individual
	integer iasf(13)
	integer i
	do i = 1,13
	   iasf(i) = 1
	enddo
	call gsasf(iasf)

	if(debcolr <> 0) then
	   write(msg,'(a,i8)') 'in ezccidx: bakcol= ',bakcol
           call ezcremrk(msg)
	   write(msg,'(a,i8,a,i8)') '   iws= ',iws,', iwstype= ',iwstype
           call ezcremrk(msg)
	endif

	# reinitialize indmax
        indmax = 1

	bkctmp = bakcol

#	handle PostScript and CGM workstations background color
	if (iwstype == 20 | iwstype == 23 | iwstype == 1) bkctmp = 1

	# NOTE: will set at least two colors for all devices.

        if (bkctmp == 0) then
           # bgcolor is black
           call gscr(iws, 0, 0._Size4, 0._Size4, 0._Size4)
           # fgcolor is white
           call gscr(iws, 1, 1.0_Size4, 1.0_Size4, 1.0_Size4)
        else
           # bgcolor is white
           call gscr(iws, 0, 1.0_Size4, 1.0_Size4, 1.0_Size4)
           # fgcolor is black
           call gscr(iws, 1, 0._Size4, 0._Size4, 0._Size4)
        endif

	# check for color property
        call ezcgetcp(iws,iwstype,lmtidx,cola)
	if(debcolr <> 0) then
	   write(msg,'(a,i8)') 'in ezccidx: bkctmp= ',bkctmp
           call ezcremrk(msg)
	   write(msg,'(a,i8,a,i8)') '   lmtidx= ',lmtidx,', cola= ',cola
           call ezcremrk(msg)
	endif
	if (cola == 0 & iwstype <> 20) return

	#set "named color"
	if (indmax > lmtidx-1) return
	indmax = indmax + 1
	# red
	call gscr(iws,2,1.0_Size4,0.0_Size4,0.0_Size4)

	if (indmax > lmtidx-1) return
	indmax = indmax + 1
	# green
	call gscr(iws,3,0.0_Size4,1.0_Size4,0.0_Size4)

	if (indmax > lmtidx-1) return
	indmax = indmax + 1
	# blue
	call gscr(iws,4,0.0_Size4,0.0_Size4,1.0_Size4)

	if (indmax > lmtidx-1) return
	indmax = indmax + 1
	# cyan
	call gscr(iws,5,0.0_Size4,1.0_Size4,1.0_Size4)

	if (indmax > lmtidx-1) return
	indmax = indmax + 1
	# magenta
	call gscr(iws,6,1.0_Size4,0.0_Size4,1.0_Size4)

	if (indmax > lmtidx-1) return
	indmax = indmax + 1
	# yellow
	call gscr(iws,7,1.0_Size4,1.0_Size4,0.0_Size4)

	if (indmax > lmtidx-1) return
	indmax = indmax + 1
	# coral
	call gscr(iws,8,1.0_Size4,0.5_Size4,0.0_Size4)

	if (indmax > lmtidx-1) return
	indmax = indmax + 1
	# yellowgreen
	call gscr(iws,9,0.6_Size4,0.83_Size4,0.0_Size4)

	if (indmax > lmtidx-1) return
	indmax = indmax + 1
	# springgreen
	call gscr(iws,10,0.0_Size4,1.0_Size4,0.6_Size4)

	if (indmax > lmtidx-1) return
	indmax = indmax + 1
	# slateblue
	call gscr(iws,11,0.0_Size4,0.5_Size4,1.0_Size4)

	if (indmax > lmtidx-1) return
	indmax = indmax + 1
	# skyblue
	call gscr(iws,12,0.55_Size4,0.0_Size4,0.83_Size4)

	if (indmax > lmtidx-1) return
	indmax = indmax + 1
	# orangered
	call gscr(iws,13,1.0_Size4,0.0_Size4,0.55_Size4)

	if (indmax > lmtidx-1) return
	indmax = indmax + 1
	# gray33
	call gscr(iws,14,0.33_Size4,0.33_Size4,0.33_Size4)

	if (indmax > lmtidx-1) return
	indmax = indmax + 1
	# lavender
	call gscr(iws,15,0.8_Size4,0.8_Size4,1.0_Size4)

	if (indmax > lmtidx-1) return
	indmax = indmax + 1
	# orchid
	call gscr(iws,16,0.85_Size4,0.45_Size4,0.8_Size4)

	if (indmax > lmtidx-1) return
	indmax = indmax + 1
	# gray70
	call gscr(iws,17,0.7_Size4,0.7_Size4,0.7_Size4)

	# done with named colors
        # assign specialized colors
        if (colormap == "greyscale" | colormap == "idl1") then
           if(loadcmap(iws,lmtidx,1) <> 0) then
	      call ezcremrk("failed to load colormap")
           endif
        elseif (colormap == "bluescale" | colormap == "idl2") then
           if(loadcmap(iws,lmtidx,2) <> 0) then
	      call ezcremrk("failed to load colormap")
           endif
        elseif (colormap == "idl3") then
           if(loadcmap(iws,lmtidx,3) <> 0) then
	      call ezcremrk("failed to load colormap")
           endif
        elseif (colormap == "brownscale" | colormap == "idl4") then
           if(loadcmap(iws,lmtidx,4) <> 0) then
	      call ezcremrk("failed to load colormap")
           endif
        elseif (colormap == "idl5") then
           if(loadcmap(iws,lmtidx,5) <> 0) then
	      call ezcremrk("failed to load colormap")
           endif
        elseif (colormap == "idl6") then
           if(loadcmap(iws,lmtidx,6) <> 0) then
	      call ezcremrk("failed to load colormap")
           endif
        elseif (colormap == "rainbow" | colormap == "idl7") then
           if(loadcmap(iws,lmtidx,7) <> 0) then
	      call ezcremrk("failed to load colormap")
           endif
        elseif (colormap == "pinkscale" | colormap == "idl8") then
           if(loadcmap(iws,lmtidx,8) <> 0) then
	      call ezcremrk("failed to load colormap")
           endif
        elseif (colormap == "greenscale" | colormap == "idl9") then
           if(loadcmap(iws,lmtidx,9) <> 0) then
	      call ezcremrk("failed to load colormap")
           endif
        elseif (colormap == "idl10") then
           if(loadcmap(iws,lmtidx,10) <> 0) then
	      call ezcremrk("failed to load colormap")
           endif
        elseif (colormap == "idl11") then
           if(loadcmap(iws,lmtidx,11) <> 0) then
	      call ezcremrk("failed to load colormap")
           endif
        elseif (colormap == "idl12") then
           if(loadcmap(iws,lmtidx,12) <> 0) then
	      call ezcremrk("failed to load colormap")
           endif
        elseif (colormap == "idl13") then
           if(loadcmap(iws,lmtidx,13) <> 0) then
	      call ezcremrk("failed to load colormap")
           endif
        elseif (colormap == "idl14") then
           if(loadcmap(iws,lmtidx,14) <> 0) then
	      call ezcremrk("failed to load colormap")
           endif
        elseif (colormap == "idl15") then
           if(loadcmap(iws,lmtidx,15) <> 0) then
	      call ezcremrk("failed to load colormap")
           endif
        elseif (colormap == "idl16") then
           if(loadcmap(iws,lmtidx,16) <> 0) then
	      call ezcremrk("failed to load colormap")
           endif
        elseif (colormap == "mycolormap") then
           if(loadcmap(iws,lmtidx,17) <> 0) then
	      call ezcremrk("failed to load colormap")
           endif
        else
	   call ezcdfc(iws,lmtidx,numcol)
        endif

	return
	end
