      subroutine ezdckwin (wson, wsid, wsname, wsdisp)
#
#   Scan the EZD open window list and return the number of currently
#   active windows.
#
#   If the return value of wson is > 0, then:
#     wsid   is the workstation ID of the most recently opened one,
#     wsname is the associated window name (character*16), and
#     wsdisp is the display on which the window is open (character*32).
#   These arguments are not set if the return value of wson is zero.
#
# Change record:
#  Written 17 March 1999 by Fred N. Fritsch.
# ----------------------------------------------------------------------
Use(Devices)

#  Declare arguments.
      integer wson          # Number of active windows
      integer wsid          # ID of active window
      character*(*) wsname  # Name of active window
      character*(*) wsdisp  # Display of active window

#  Declare externals.
      integer ezcgetcl
      external ezcgetcl

#  Declare local variables.
      integer idx

      wson = 0     #Initialize active window counter

      if (iwinop < 1) return
      do idx = 1, iwinop
         if (winstate(idx)) then
            wson = wson + 1
            wsid = iwsid(idx)
            wsname = winame(idx)
            wsdisp = windisp(idx)
         endif
      enddo

      return
      end
      
