	integer function ezccmap(iws,ncoli,indlo,indhi,red,green,blue)
c----------------------------------------------------------------------------
c*s
c	NAME OF ROUTINE... ezccmap
c
c	AUTHOR OF ROUTINE...Yu-Hsing Chiu ...Nov.24,1993
c
c	PURPOSE...
c		Sets the RGB color corresponding to indexes "indlo" through
c		"indhi" for an individual workstation(in the sense of GKS)
c	        (Modified from Steve Langer's ezdcoltb.m)
c	
c	RETURNS...
c		zero for success, non-zero for bad arguments
c
c	GLOSSARY OF IMPORTANT VARIABLES...
c		indlo := Logical indices for low color ranges
c		indhi := Logical indices for high color ranges 
c		red =: Array of red color range
c		green =: Array of green color range
c		blue =: Array of blue color range	
c
c	OUTLINE...
c	  - Red, green, and blue are fractions of full intensity (0 through 1).
c
c     NOTE: This routine modifies color table entries with
c     logical indices indlo thru indhi. It thus adds an
c     offset based on indbase to the index before calling
c     the GKS set colour representation routine. The input
c     arrays red, green, and blue are indhi-indlo+1 elements
c     long, and are declared as having a range indlo:indhi to
c     avoid the need for yet another offset.
c
      integer iws, indlo, indhi
		# iws: workstation id
      real(Size4) red(indlo:indhi), green(indlo:indhi), blue(indlo:indhi)

      integer ncoli
                # ncoli: number of colors available
#
Use(Colors)
Use(Devices)
c
      integer ilow, ihi, ii, jj
# (FNF 7/30/97) Changed "write(STDOUT,..." statements to "call remark".
# (FNF 8/12/97) Changed "call remark" statements to "call ezcremrk".
      character*80 msg

        if (debcolr <> 0) then
	   write(msg,'(a,i8,a,i8)') 'in ezccmap: ncoli = ',ncoli,', iws = ',iws
           call ezcremrk(msg)
        endif
c
c	This function sets color index "indx" to a color with
c	fractional components red, green, blue.
c
c	be sure the requested indices are in range
c	NOTE: the input indices are indices into a
c	Fortran array, so they start at 1
	if(indlo .gt. indhi) then
	    ezccmap= -10
	    return
	endif
	ilow= indlo
	if(ilow .lt. 1) then
	    ezccmap= -1
	    return
	endif
	if(ilow .gt. numcol) then
	    ezccmap= -2
	    return
	endif
	ihi= indhi
	if(ihi .lt. ilow) then
	    ezccmap= -3
	    return
	endif
	if(ihi .gt. numcol) then
	    ezccmap= -4
	    return
	endif
	ezccmap= 0
c
c	the indices are legal, so go ahead and use them
c
c       loop over all colors
        do ii=ilow,ihi
c       adjust so that a 1 becomes the base index
c       in the available part of the GKS color table
           jj= ii-1+indbase
           if (jj <= ncoli) then
              call GSCR(iws, jj, red(ii), green(ii), blue(ii))
	      indmax = jj
              if (debcolr <> 0) then
                 write(msg,'(a,i8)') 'in ezccmap: set indx = ',jj
                 call ezcremrk(msg)
              endif
           endif
        enddo
	return
	end
