
c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

      subroutine ezcdvck
Use(Devices)
       logical ezcnopl
       external ezcnopl
       if (ezcnopl()) return  #Implement no-plot option (FNF 11/08/96)

# check that at least one device is on, if not turn on cgm
      if(iezcdev == 0) then
         call ezccgm("on"," ")
      endif
      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

      subroutine ezcdodev(devtype,arg1,arg2)
# main device routine
#     Processes command:  devtype arg1 arg2
# devtype is the device type. Valid values are:
#         [cgm,ps,win]
# arg1 is the device action command.  Valid values are:
#         [on,off,close,send,colormap]
#         Defaults to "on" of omitted.
# arg2 contains device attributes. 
#         win has a string for window name
#	  cgm, ps has color or mono
#	  colormap has idl1,idl2,..,idl16,mycolormap
#
# (yymmdd means 19yy/mm/dd)
#  980114  Since each of ezccgm, ezcps, ezcwin, ezctek begins with a
#          call ezcp(1), the one here is redundant.  Removed it. (FNF)
#   NOTE: This assumes that each device routine starts with call ezcp(1).
# (yymmdd means 20yy/mm/dd)
#  000517  Removed code related to (unsupported) tek output. (FNF)
#  001212  Added back tek option as a (near) synonym for cgm. (FNF)
# ----------------------------------------------------------------------
       character*(*) devtype, arg1, arg2
       character*(8) command
       character*(120) msg
       integer errsvl
       integer ezcgetcl
       external ezcgetcl
       logical ezcnopl
       external ezcnopl

       if (ezcnopl()) return  #Implement no-plot option (FNF 11/08/96)

       command = "on"
       if(arg1 <> " ") command = arg1

       if(devtype == "cgm") then
          call ezccgm(command,arg2)
       elseif(devtype == "ps") then
	  call ezcps(command,arg2)
       elseif(devtype == "tek") then
          call ezcremrk('tek graphics device not available'// \
                        '--see basis12.0 news')
          call ezcremrk('Will use cgm.')
          call ezccgm(command,arg2)
       elseif(devtype == "tv" | devtype == "win") then  
          call ezcwin(command,arg2)
       else
	 msg = devtype(1:ezcgetcl(devtype))//" graphics device not available"
	 errsvl = 0
	 call ezcerror(msg,errsvl)
       endif
       return
       end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

       subroutine pltend
       call ezcp(0)
       call eznfree
       return
       end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

       subroutine pltdie
#emergency shutdown
       call ezcp(-1)
       return
       end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

       subroutine pltstart
# Begin gks and make sure at least one device is on
       call ezcp(1)
       call ezcdvck
       return
       end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c EZDFIN - fin the graphics
c        -   IES  0 for normal, -1 error exit

      integer function ezdfin(ies, idum)
      integer ies, idum

      call ezcp(ies)
      call eznfree

      return(OK)
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

        subroutine ezcp(iflagin)
Use(Devices)
        integer iflag, ibufsz, ezcgetcl, i, ilimit, ezcxn, iquit, iflagin
        external ezcgetcl, ezcxn
# (FNF 7/30/97) Changed "write(STDOUT,..." statements to "call remark".
# (FNF 8/12/97) Changed "call remark" statements to "call ezcremrk".
# (FNF 5/17/2000) Removed code related to (unsupported) tek output.
        character*80 msg

        iflag = iflagin
        iquit = 0
        if(iflag == -1) then
#emergency shutdown
           iflag=0
           iquit=1
        endif
        if(iflag == 1) then
c start up graphics file if we haven't already
           if (codeplot == NO) then
               codeplot = YES
               call ezcada 
               ibufsz = 4096
	       call gopks(STDERR,ibufsz) # ibufsz GKS-version dependent
           endif   
        elseif(codeplot == YES) then
	   if (iezcdev == 0) then
              codeplot = NO
	      return
           else
              if(iquit==0) then
                 call ezcnf  #get last frame done
              else
# can't call nf for emergency shutdown, might get an error
                 call frame
              endif
              if(iezccgma >=0) call ezccgm("close"," ")
	      if(iezcpsa >=0) call ezcps("close"," ")
	      if(iwinop >0) then
		 ilimit = iwinop
                 do i = 1,ilimit 
                    call ezcwin("close",winame(1))
                 enddo
	      endif		
              call gclks
              if (iezccgma >= 0) then		
                 write(msg,100) iezccgmf(1:ezcgetcl(iezccgmf))
                 call ezcremrk(msg)
                 close(CGMLOGUNIT)
	      endif
100           format('Closing CGM Log File ',a)

	      if (iezcpsa >= 0) then
                 write(msg,105) iezcpsf(1:ezcgetcl(iezcpsf))
                 call ezcremrk(msg)
                 close(PSLOGUNIT)
	      endif
105           format('Closing PS Log File ',a)

              codeplot = NO
	   endif
	endif
        return
        end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

