c==============================================================================
c
c   ezcdfc
c
c   purpose: create and initialize a default colormap 
c
c   created: Yu-Hsing Chiu 11/24/93
c
c   revision history:
# (FNF 7/23/97) Modified print statements,
# (FNF 8/12/97) Changed "call remark" statements to "call ezcremrk".
c
c==============================================================================

c234567
      subroutine ezcdfc(iws,ncoli,idepth)
c
Use(Colors)
      integer idepth,iws,ncoli # iws: workstation id, ncoli: available colors
c
ifelse(SYSTEM,UNICOS,[
      real(Size4)    ONE, ZERO
      parameter (ZERO=1.e-06)
      parameter (ONE=1. - ZERO)
])
c
      real(Size4)  red(256), green(256), blue(256)
      integer      i, idepth2, istat, ezccmap
      character*80 msg

c create the colormap
      idepth2 = idepth/2
      do i=1, idepth2
         red(i) = i * 1.0 / idepth
         blue(i) = 1.0 - red(i)
         green(i) = i * 1.0 / idepth2
      enddo
      do i=idepth2+1, idepth
         red(i) = i * 1.0 / idepth
         blue(i) = 1.0 - red(i)
         green(i) = 1.0 - (i-idepth2) * 1.0 / (idepth-idepth2)
      enddo

ifelse(SYSTEM,UNICOS,[
      if (debcolr <> 0) 
         call ezcremrk("In EZCSCMAP before calling set color table:")
      do i=1,idepth
         if (red(i) > ONE) then
            red(i) = ONE
         else if (red(i) < ZERO) then
            red(i) = ZERO
         endif

         if (green(i) > ONE) then
            green(i) = ONE
         else if (red(i) < ZERO) then
            green(i) = ZERO
         endif

         if (blue(i) > ONE) then
            blue(i) = ONE
         else if (red(i) < ZERO) then
            blue(i) = ZERO
         endif
         if (debcolr <> 0) then
            write(msg,7000) i, red(i), green(i), blue(i)
 7000       format(" rgb(",i3,") = ",f10.8, " / ",f10.8, " / ",f10.8)
            call ezcremrk(msg)
         endif
      enddo
])


c download the RGB value to the default color map by invoking ezccmap
c   ezccmap(iws, ncoli, ilo, ihi, red, green, blue)
      istat=ezccmap(iws, ncoli, 1, idepth, red, green, blue)

c print error message if warranted
      if (istat .ne. 0) then
         write(msg,'(a,i8)') 'Colormap not loaded.  Status is ', istat
         call ezcerror(msg,0)
      endif

      return
      end
