      subroutine ezdflwin (wsid, stat)
#
#   Flush any outstanding events on window with workstation ID wsid.
#
#   If the return value of stat is > 0, then gfwin had trouble.
#
#   This is essentially a device-independent interface to gfwin that is
#   effectively a no-op for ATC GKS.
#
# Change record:
#  Written 26 March 1999 by Fred N. Fritsch.
# (yymmdd means 19yy/mm/dd)
#  991103  Changed idwind from real(size8) to integer(2). (FNF)
#  991108  Changed name idwind to idwin to avoid possible conflict, for
#          idwind is now in common, via ezd.v. (FNF)
# (yymmdd means 20yy/mm/dd)
#  000210  Changed type of idwin to Address, to match idwind. (FNF)
#  000517  Removed code for ATC GKS, which is no longer supported. (FNF)
# ----------------------------------------------------------------------

#  Declare arguments.
      integer wsid          # ID of window to be flushed
      integer stat          # Status returned by gfwin

#  Declare externals.
      integer ezdluwin
      external ezdluwin

#  Declare local variables.
      Address idwin    # Corresponding connection ID
      character*80 errmsg

#     Look up gxwin connection ID corresponding to wsid.
      if ( ezdluwin(wsid, idwin) > 0) then
         write (errmsg,'(A,I5,A)') \ 
            'Trouble finding connection ID.  Bad wsid =', wsid, '??'
         call ezcremrk(errmsg)
         stat = 30
         return
      endif
         
      call gfwin (idwin, stat)

      return
      end
      
      integer function ezdluwin (wsid, idwin)
#
#     Look up gxwin connection ID corresponding to wsid.
#
#     A positive return value indicates trouble.
#
# Change record:
#  Written 26 March 1999 by Fred N. Fritsch.
# (yymmdd means 19yy/mm/dd)
#  991103  Changed idwind and iwscn from real(size8) to integer(2). (FNF)
#  991108  Changed name idwind to idwin to avoid possible conflict, for
#          idwind is now in common, via ezd.v. (FNF)
# (yymmdd means 20yy/mm/dd)
#  000210  Changed type of idwin to Address, to match idwind. (FNF)
# ----------------------------------------------------------------------
Use(Devices)

#  Declare arguments.
      integer wsid          # ID of window of interest
      Address idwin      # Corresponding connection ID

#  Declare local variables.
      integer idx, retval

      retval = 1     #Initialize return value

      if (iwinop < 1) return(retval)
      do idx = 1, iwinop
         if (wsid == iwsid(idx)) then
            idwin = iwscn(idx)
            retval = 0
            break
         endif
      enddo

      return(retval)
      end
