	subroutine ezcsfname(fnamei,ftype,fnameo)
	character*(*)  fnamei, ftype, fnameo
#Filename assignment for a given filetype
#
#  fnamei is the input filename so far;
#  ftype  is the input filetype.  Currently handled ftype values:
#       "cgm"    (alias "CGM", "cgmfile", "CGMFILE" allowed);
#       "ps"     (alias "PS", "psfile", "PSFILE" allowed);
#       "cgmlog" (alias "CGMLOG", "cgmlogfile", "CGMLOGFILE" allowed);
#       "pslog"  (alias "PSLOG", "pslogfile", "PSLOGFILE" allowed).
#  fnameo is the output filename with extension added.
#
#  If filename truncation is detected, a nonfatal "call ezcerror" message
#  is issued and fnameo is set to all blanks.  The calling program is
#  expected to check for this and take appropriate action.
#
# Change record:
# (yymmdd means 19yy/mm/dd)
#  970310  (FNF)
#       Modified to check that output filename has expected number of
#       characters.  (Failure indicates name truncation.)
#  970312  (FNF)
#       Changed fnamei,fnameo from character*(80) to character*(*).
# (yymmdd means 20yy/mm/dd)
#  000517  Removed code for ATC GKS, which is no longer supported. (FNF)
# -------------------------------------------------------------------------
	character*(120) msg
	integer errsvl
	integer ezcgetcl
	logical ezccklen
	external ezccklen, ezcerror, ezcgetcl
Use(Devices)

	if (ftype == "cgm" .OR. ftype == "CGM" \
	    .OR. ftype == "cgmfile" .OR. ftype == "CGMFILE") then
	      fnameo = fnamei(1:ezcgetcl(fnamei))//".ncgm"
	      if (~ezccklen(fnamei,fnameo,5)) goto 200
	elseif (ftype == "ps" .OR. ftype == "PS" \
	    .OR. ftype == "psfile" .OR. ftype == "PSFILE") then
	   fnameo = fnamei(1:ezcgetcl(fnamei))//".ps"
           if (~ezccklen(fnamei,fnameo,3)) goto 200
	elseif (ftype == "cgmlog" .OR. ftype == "CGMLOG" \
	    .OR. ftype == "cgmlogfile" .OR. ftype == "CGMLOGFILE") then
	   fnameo = fnamei(1:ezcgetcl(fnamei))//".cgmlog"
           if (~ezccklen(fnamei,fnameo,7)) goto 200
	elseif (ftype == "pslog" .OR. ftype == "PSLOG" \
	    .OR. ftype == "pslogfile" .OR. ftype == "PSLOGFILE") then
	   fnameo = fnamei(1:ezcgetcl(fnamei))//".pslog"
           if (~ezccklen(fnamei,fnameo,6)) goto 200
	else
	   msg = "ezcsfname: Unknown filetype "//ftype(1:ezcgetcl(ftype))//\
                "; no filename was set."
	   errsvl = 0
	   call ezcerror(msg,errsvl)
	endif

	return

#   Error return
 200	continue
	msg = "ezcsfname: Could not generate proper extension for "\
             //ftype(1:ezcgetcl(ftype))//" file."
	errsvl = 0
	call ezcerror(msg,errsvl)
	fnameo = " "
	return
	end
