/* This is a template for gfwind.c.
Copy Gfwind.t to gfwind.c, then replace pattern Gfwind.
 Fortran externals are name, name_, or NAME (platform dependent);
 C  externals are name
 Same as gfwindc.c. Cp Gfwind.t to gfwindc.c, replace Gfwind.
 */
#include <stdio.h>
#include <stdlib.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xatom.h>

int
    Gfwind(Window * wind_id, int *stat)
/*=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
  Routine:  Gfwind
  Author:  Jeff Rowe,
           Lawrence Livermore National Lab,
           Livermore Computing Center,
           Information Management & Graphics Group
           Tel: (510) 422-4042, email: jrowe@llnl.gov
  Modifications:
    Created: Jun 98

  Description: Flush an X11 Window. Fortran callable.
	   All request and events are discarded.

  Parameters:
	Window *wind_id   > X Window ID. 
	int *stat   > same as Gfwind.
	Gfwind   > 0 if no error, 1 if X display not initialized.
			    2 if window not initiailized.
			    3 if can't flush window.

  Procedure: Setup for XSync. 

=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=*/
{
    Display *llnlgetwdpy();
    char *llnlgetdpyn();
    Display *display_ptr = NULL;
    Window llnlgetxwin();
    Window Xwindow = 0;
    char *display_name = NULL;
    int debug = 0;

    *stat = 0;

    Xwindow = *wind_id;

    if (debug)
        printf("Gfwind: stat %d winid %d\n", *stat, *wind_id);
    display_name = llnlgetdpyn(Xwindow);

    if (display_name == NULL) {
        printf
            ("Error: Couldn't open display.\n Gfwind at IP: %s \n  A LLNL private NCAR routine. Contact J.Rowe, LC/IMG, x 2-4042\n",
             XDisplayName(display_name));

        *stat = 1;
        return 1;
    }

    display_ptr = llnlgetwdpy(Xwindow);
    if (display_ptr == NULL) {
        printf
            ("Error: Couldn't open display.\n Gfwind at IP: %s display_ptr %x \n  A LLNL private NCAR routine. Contact J.Rowe, LC/IMG, x 2-4042\n",
             XDisplayName(display_name), display_ptr);

        *stat = 1;
        return 1;
    }

    if (wind_id == NULL) {
        *stat = 2;
        return 2;
    }

    if (debug)
        printf("Gfwind: XSync Window: display_ptr %d winid %d\n",
               display_ptr, *wind_id);
/* Wait until all events have been received and processed by X Server. Discards
all events on input queue.
*/
    XSync(display_ptr, True);
    *stat = 0;
    return 0;
}
