      subroutine cpmpxy (imap,xinp,yinp,xotp,yotp)
c
c by default, conpack draws contour lines using x coordinates in the
c range from xat1 to xatm and y coordinates in the range from yat1 to
c yatn.  setting the flag 'map' non-zero causes those coordinates to be
c transformed by calling the subroutine cpmpxy.  by default, 'map' = 1
c selects the ezmap transformations and 'map' = 2 selects the polar
c coordinate transformations.  the user of conpack may replace this
c subroutine as desired to transform the final coordinates and thus to
c transform the objects drawn.
c
Use(Cpmpxy)      
Use(Default_attributes)
      integer imap, i23000
      integer m,n,m1,n1
      real(Size4) xinp,yinp,xotp,yotp
      real(Size4) xd,yd,x1,x2,x3,x4,y1,y2,y3,y4
      select(imap)
      case 1:
        call maptrn (yinp,xinp,xotp,yotp)
      case 2:
        xotp=xinp*cos(.017453292519943*yinp)
        yotp=xinp*sin(.017453292519943*yinp)
      case 3:
c we choose the m,n coordinates to be the lower left corner of the box
c note that for things like vectors, we're out of the box.
c matrix-matrix-matrix
         m = xinp
         n = yinp
         m = max(min(m,nx1-1),1)
         n = max(min(n,nx2-1),1)
         m1 = m+1
         n1 = n+1
         xd = (xinp-m)
         yd = (yinp-n)
         x1=x(m+(n-1)*nx1)
         x2=x(m1+(n-1)*nx1)
         x3=x(m+(n1-1)*nx1)
         x4=x(m1+(n1-1)*nx1)
         y1=y(m+(n-1)*nx1)
         y2=y(m1+(n-1)*nx1)
         y3=y(m+(n1-1)*nx1)
         y4=y(m1+(n1-1)*nx1)
         xotp = x1+(x2-x1)*xd + (x3-x1)*yd + ((x4-x3)-(x2-x1))*xd*yd
         yotp = y1+(y2-y1)*xd + (y3-y1)*yd + ((y4-y3)-(y2-y1))*xd*yd
       case 4:
c matrix-vector-vector
         m = xinp
         n = yinp
         m = max(min(m,nx1-1),1)
         n = max(min(n,ny1-1),1)
         m1 = m+1
         n1 = n+1
         xd = xinp-m
         yd = yinp-n
         x1=x(m)
         x2=x(m1)
         y1=y(n)
         y2=y(n1)
         xotp = x1+(x2-x1)*xd
         yotp = y1+(y2-y1)*yd
      case 5: #ireg
         m = xinp
         n = yinp
         m = max(min(m,nx1-1),1)
         n = max(min(n,nx2-1),1)
         m1 = m+1
         n1 = n+1
# The following uses the NCAR 'ORV' parameter set to NCARSPV
# This tells NCAR the mapping is not defined in this zone.
         xd = (xinp-m)
         yd = (yinp-n)
         x1=x(m+(n-1)*nx1)
         x2=x(m1+(n-1)*nx1)
         x3=x(m+(n1-1)*nx1)
         x4=x(m1+(n1-1)*nx1)
         y1=y(m+(n-1)*nx1)
         y2=y(m1+(n-1)*nx1)
         y3=y(m+(n1-1)*nx1)
         y4=y(m1+(n1-1)*nx1)
         if(x1==NCARSPV|x2==NCARSPV|x3==NCARSPV|x4==NCARSPV) then  
            xotp = NCARSPV
            yotp = NCARSPV
            return
         endif
         xotp = x1+(x2-x1)*xd + (x3-x1)*yd + ((x4-x3)-(x2-x1))*xd*yd
         yotp = y1+(y2-y1)*xd + (y3-y1)*yd + ((y4-y3)-(y2-y1))*xd*yd
      default:
        xotp=xinp
        yotp=yinp
      endselect
      return
      end

      function fx(x,y)
      real(Size4) x,y,xotp,yotp, fx, fy, ezcmap
      logical ezccall, isezc
      save ezccall
      data ezccall/.false./
      if(ezccall) then
         call cpmpxy (5,x,y,xotp,yotp)
         fx = xotp
      else
         fx = x
      endif
      return

      entry fy(x,y)
      if(ezccall) then
         call cpmpxy (5,x,y,xotp,yotp)
         fy = yotp
      else
         fy = y
      endif
      return

      entry ezcmap(isezc)
      ezccall = isezc
      ezcmap = 0._Size4
      return
      end
