      subroutine ezcaddc(y,m,nyc,ilow,istridey,x,nxin,nxcin)
      integer m,nyc,nx,nxc,istridey, nxin, nxcin
      integer ilow, numdata, j1, j2, i
      real(Size8) y(m*nyc), x(nxin*nxcin)
Use(Ezcurve)
Use(Collections)
Use(Default_attributes)
Use(Extrema)
      Dynamic(xs,real(Size4),1)
      Dynamic(xsa,real(Size4),1)
      Dynamic(ys,real(Size4),1)
      logical xexlarge,xexsmall,yexlarge,yexsmall
      integer utsizeof
      external utsizeof
      real(Size8) yave
      real(Size8) anum
      real(Size4) store,floor
      real(Size4) arg1,arg2
      logical arequal
      logical ezcnopl
      external ezcnopl
      real(Size4) r1mach
      external r1mach
      character*80 errmsg
# (FNF 7/29/97) Changed "write(STDOUT,...) statements to "call remark".
# (FNF 8/13/97) Changed "call remark" statements to "call ezcremrk".
# (FNF 5/29/98) Corrected tests for exlarge and exsmall variables.
#               Also corrected bug in y-averaging code.
# (FNF 6/30/98) Replaced tests for equality of floating point numbers by
#               comparison of their relative difference with r1mach(4).
    
      store(anum)=real(sign(min(ceiling,abs(anum)),anum),Size4)
      floor(anum)=real(sign(max(realsmall,abs(anum)),anum),Size4)
#       The following assumes arg2>0.
      arequal(arg1,arg2) = abs(arg1-arg2)/max(abs(arg1),arg2) .lt. r1mach(4)
    
      if (ezcnopl()) return  #Implement no-plot option (FNF 11/11/96)
      xexlarge = .false.
      yexlarge = .false.
      xexsmall = .false.
      yexsmall = .false.
      call ezcxpnd
      if (marka <> " ") then
         namec(nc) = Mark
      elseif (arrowa = YES) then
         namec(nc) = Arrow
      else
         namec(nc) = Curve
      endif
      labeli(nc) = labela
# save the data      
      if(nxcin = 0) then
#x not supplied
         if (ixprev == 0) then
	    nx = m
	    nxc = 1
            numdata = utsizeof(nx*nxc,type4)
            call osallotn(Point(xs),numdata,"EZCADDC:xs ")
	    do i = 1, m
  	      xs(i) = ilow +(i-1)*istridey
	    enddo
            call ezcsdata(Point(xs),nx,nxc,xi(nc),TRUE)
            ixprev = xi(nc) ; ixpreva = 0
         else
            nx = n1(ixprev)
            nxc = n2(ixprev)
            xi(nc) = ixprev
            Point(xs) = data(ixprev)
         endif
      else
#x supplied
         nx = nxin
         nxc = nxcin
         numdata = utsizeof(nx*nxc,type4)
         call osallotn(Point(xs),numdata,"EZCADDC:xs- ")
         do j1 = 1, nx*nxc
            xs(j1) = store(x(j1))
            if ( arequal(abs(xs(j1)), real(ceiling,Size4)) ) then
               xexlarge = .true.
            else if (x(j1) <> 0.) then
               xs(j1) = floor(x(j1))
               if ( arequal(abs(xs(j1)), real(realsmall,Size4)) ) \
                  xexsmall = .true.
            endif
         enddo
         call ezcsdata(Point(xs),nx,nxc,xi(nc),TRUE)
         ixprev = xi(nc) ; ixpreva = 0
      endif

      if(nxc > 1 & nxc <> nyc) then
         call ezcremrk("plot: mismatched numbers of curves.")
         go to 900
      endif
      if(abs(nx-m)>1) then
         call ezcremrk('plot: curves have mismatched lengths,ignored.')
         go to 900
      endif
      if(nx >=m) then
#The y data is used as presented
         numdata = utsizeof(m*nyc,type4)
         call osallotn(Point(ys),numdata,"EZCADDC:ys ")
         do j1 = 1, m*nyc
            ys(j1) = store(y(j1))
            if ( arequal(abs(ys(j1)), real(ceiling,Size4)) ) then
               yexlarge =.true.
            else if (y(j1) <> 0.) then
               ys(j1) = floor(y(j1))
               if ( arequal(abs(ys(j1)), real(realsmall,Size4)) ) \
                  yexsmall = .true.
            endif
         enddo
         call ezcsdata(Point(ys),m,nyc,yi(nc),TRUE)
      endif
      if( nx == m+1) then
#Need to use the averaged form of x
         if(ezcnocx) then
            call ezcremrk('plot: length(x) = length(y) + 1, averaging disabled.')
            call ezcremrk('command ignored.')
            go to 900
         endif
         if(ixpreva > 0) then
            xi(nc) = ixpreva
         else
            numdata = utsizeof(m*nxc,type4)
            call osallotn(Point(xsa),numdata,"EZCADDC:xsa ")
            do j2 = 1, nxc
            do j1 = 1, m
#             Note that we are averaging previously stored Size4 numbers,
#             so do not need to use store/floor to guard against floating
#             point exceptions, due to safety factors in ceiling/realsmall.
               xsa(j1+(j2-1)*m) = \
                     (xs(j1+(j2-1)*nx)+xs(j1+(j2-1)*nx+1))*0.5_Size4
            enddo
            enddo
            call ezcsdata(Point(xsa),m,nxc,xi(nc),TRUE)
            ixpreva = xi(nc)
         endif
      endif
      if( m == nx+1) then
#Need to use the averaged form of y -- the original y is not saved.
         if(ezcnocy) then
            call ezcremrk('plot: length(y) = length(x) + 1, averaging disabled.')
            call ezcremrk('command ignored.')
            go to 900
         endif
         numdata = utsizeof((m-1)*nyc,type4)
         call osallotn(Point(ys),numdata,"EZCADDC:ys ")
         do j2 = 1, nyc
            do j1 = 1, m-1
               yave = (y(j1+(j2-1)*m)+y(j1+(j2-1)*m+1))*0.5_Size8
               ys(j1+(j2-1)*(m-1)) = store(yave)
               if ( arequal(abs(ys(j1+(j2-1)*(m-1))), \
                            real(ceiling,Size4)) ) then
                  yexlarge = .true.
               else if (yave <> 0.) then
                  ys(j1+(j2-1)*(m-1)) = floor(yave)
                  if ( arequal(abs(ys(j1+(j2-1)*(m-1))), \
                               real(realsmall,Size4)) ) yexsmall = .true.
               endif
            enddo
         enddo
         call ezcsdata(Point(ys),m-1,nyc,yi(nc),TRUE)
      endif

      if (ezcdebug) then
         if (xexlarge) then
            write(errmsg,'(a,1p,e11.3)') 'WARNING!! x data exceeds plot limit ',ceiling
            call ezcremrk(errmsg)
         endif
         if (xexsmall) then
            write(errmsg,'(a,1p,e11.3)') 'WARNING!! x data is below plot limit ',realsmall
            call ezcremrk(errmsg)
         endif
         if (yexlarge) then
            write(errmsg,'(a,1p,e11.3)') 'WARNING!! y data exceeds plot limit ',ceiling
            call ezcremrk(errmsg)
         endif
         if (yexsmall) then
            write(errmsg,'(a,1p,e11.3)') 'WARNING!! y data is below plot limit ',realsmall
            call ezcremrk(errmsg)
         endif
      endif

      pending = TRUE
      if (ezcshow) call ezcshowf
      return
900   continue
      call ezcremrk(legenda)
      nc = nc - 1
      return
      end
