      subroutine ezcaddfm(x,y,z,ireg,kmax,lmax,cidxflag)
#fillmesh plot
#z is the array of physics quantities 
      integer kmax,lmax,ireg(kmax,lmax),cidxflag
      real(Size8) y(kmax,lmax), x(kmax,lmax), z(kmax,lmax)
      real(Size8) rco, zz(5)
      character*80 errmsg
# (FNF 7/29/97) Changed "write(STDOUT,...) statements to "call remark".
# (FNF 8/13/97) Changed "call remark" statements to "call ezcremrk".
#               Also eliminated unused variables zexlarge and zexsmall.
# (FNF 3/26/98) Changed ezclr8* calls to new ezclrm* routines, to get
#               rid of color mapping glitch. (Darwin Ho)
# (FNF 5/22/98) Changed second smin to samin in ezcchgfe calls.
# (FNF 5/29/98) Corrected tests for exlarge and exsmall variables.
# (FNF 6/30/98) Replaced tests for equality of floating point numbers by
#               comparison of their relative difference with r1mach(4).
# (FNF 1/08/99) Implemented "zlim" option for user-supplied z-limits.
# (FNF 5/12/2000) Added zlim argument to ezclrm-calls.
# (FNF 6/29/2001) Added new cscale options rlin, rlog, rnormal.

      integer utsizeof
      external utsizeof
      integer ibasis
      external ibasis
Use(Ezcurve)
Use(Collections)
Use(Default_attributes)
Use(Extrema)
Use(EzcurveDefaults)
      integer j,k,l,n,nhit
      integer nks, nls
      Dynamic(xs,real(Size4),1)
      Dynamic(ys,real(Size4),1)
      Dynamic(zexts,real(Size4),5)	#zmin,zmax,zbar,zsigma and zmap for z
      Dynamic(zci,integer,1)
      Dynamic(zs,integer,1)	#stored color indices array
      Dynamic(iregs,integer,1)
      Dynamic(kpregs,logical,1)
      Dynamic(kllmts,integer,8)

      real(Size4) xsmin,xsmax,ysmin,ysmax
      real(Size4) xsamin,xsamax,ysamin,ysamax
      logical xexlarge,xexsmall,yexlarge,yexsmall

      integer klo,khi,kinc,khilmt,llo,lhi,linc,lhilmt
      integer nclrs	#number of allocated colors in ezd
      integer itemp	#temp index
      logical ezcsel
      external ezcsel
      real(Size8) anum, zlim(2)
      real(Size4) store,floor
      real(Size4) arg1,arg2
      logical arequal
      logical ezcnopl
      external ezcnopl
      real(Size4) r1mach
      external r1mach

      store(anum)=real(sign(min(ceiling,abs(anum)),anum),Size4)
      floor(anum)=real(sign(max(realsmall,abs(anum)),anum),Size4)
#       The following assumes arg2>0.
      arequal(arg1,arg2) = abs(arg1-arg2)/max(abs(arg1),arg2) .lt. r1mach(4)

      if (ezcnopl()) return  #Implement no-plot option (FNF 11/11/96)
      xexlarge = .false.
      xexsmall = .false.
      yexlarge = .false.
      yexsmall = .false.

#Pick up user-supplied limits.
      if (nzlima > 0) then
         zlim(1) = zlimin(1)
         zlim(2) = zlimin(2)
      else
         zlim(1) = 0
         zlim(2) = 0
      endif

      call ezckl(kmax,lmax,ireg,klo,khi,kinc,
                                 llo,lhi,linc,nks,nls)
      n = nks*nls
      if(n == 0) then
         call ezcremrk('plotfm:  specification excludes all points, ignored.')
         return
      endif
      call ezcxpnd
      namec(nc)=FillMesh

      #convert to color indices from physics quantities
      nclrs = ibasis("ezd.numcol")
      call osallotn(Point(zci),kmax*lmax,"EZNADDFM:zci ")
      if (cidxflag == 1) then
         zz(5) = 3
         do k = 1,kmax
            do l = 1,lmax
               itemp = int(z(k,l))
               if (itemp > 0 & itemp <= nclrs) then
                  zci(k+(l-1)*kmax) = int(z(k,l))
               else
		  call ezcremrk("bad index array, negative or exceed limit")
                  call osfreen(Point(zci),"ezn.zci")
                  return
	       endif
            enddo
         enddo
      else
         zz(5) = 1  !Set for normal color order.
         rco = 0
         if (cscalea == "rlog" | cscalea == "rnormal" | \
             cscalea == "rlin")  then  !Reverse color order.
              rco = 4
              zz(5) = -1
#           Note that the correct output value of zz(5)
#             zz(5) = 0 : linear mapping
#             zz(5) = 1 : logarithmic mapping
#             zz(5) = 2 : normal mapping
#           will be set by the ezclrm-routine called below.
         endif
         if (cscalea == "log" | cscalea == "rlog") then
            call ezclrmln(nclrs,z,ireg,kmax,lmax,zci,zz,zlim)
            if (zz(1) <= 0 | zz(2) <= 0) then
#               Bad data message already printed by ezclrmln.
               call osfreen(Point(zci),"ezn.zci")
               return
            endif
         elseif (cscalea == "normal" | cscalea == "rnormal") then
            call ezclrmnml(nclrs,z,ireg,kmax,lmax,zci,zz,zlim)
         else
            call ezclrm(nclrs,z,ireg,kmax,lmax,zci,zz,zlim)
         endif
#         Add rco so that zz(5) is in range 0-2 for normal color order,
#         and in range 4-6 for reverse color order.  (Note that zz(5)=3
#         has the special meaning that user has supplied color indices.)
#         This is used in ezcdispl to get correct annotation. (FNF)
         zz(5) = zz(5) + rco
      endif

      lhilmt=lhi
      khilmt=khi
      if (lhi<lmax) lhilmt=lhilmt+1
      if (khi<kmax) khilmt=khilmt+1

      nks = khilmt - klo + 1
      nls = lhilmt - llo + 1
      n = nks * nls 	#need to store all r, z, and ireg
      call osallotn(Point(ys),n,"EZNADDFM:ys ")
      call osallotn(Point(xs),n,"EZNADDFM:xs ")
      call osallotn(Point(zs),n,"EZNADDFM:zs ")
      call osallotn(Point(iregs),n,"EZNADDFM:iregs ")
      call osallotn(Point(kpregs),n,"EZNADDFM:kpregs ")
      call osallotn(Point(kllmts),8,"EZNADDFM:kllmts ")
      call osallotn(Point(zexts),5,"EZNADDFM:zexts ")
      zexts(1) = store(zz(1))
      zexts(2) = store(zz(2))
      zexts(3) = store(zz(3))
      zexts(4) = store(zz(4))
      zexts(5) = store(zz(5))
      j = 0
      nhit = 0
      ysmin = real(ceiling,Size4)
      ysmax = real(-ceiling,Size4)
      xsmin = real(ceiling,Size4)
      xsmax = real(-ceiling,Size4)
      ysamin = real(ceiling,Size4)
      ysamax = real(-ceiling,Size4)
      xsamin = real(ceiling,Size4)
      xsamax = real(-ceiling,Size4)
      do l=llo,lhilmt
         do k=klo,khilmt
            j = j + 1
            ys(j) = store(y(k,l))
            if ( arequal(abs(ys(j)), real(ceiling,Size4)) ) then
                yexlarge = .true.
            else if (y(k,l) <> 0.) then
               ys(j) = floor(y(k,l))
               if ( arequal(abs(ys(j)), real(realsmall,Size4)) ) \
                  yexsmall = .true.
            endif
            xs(j) = store(x(k,l))
            if ( arequal(abs(xs(j)), real(ceiling,Size4)) ) then
               xexlarge = .true.
            else if (x(k,l) <> 0.) then
               xs(j) = floor(x(k,l))
               if ( arequal(abs(xs(j)), real(realsmall,Size4)) ) \
                  xexsmall = .true.
            endif

            zs(j) = zci(k+(l-1)*kmax) + ibasis("ezd.indbase") - 1
	    iregs(j) = ireg(k,l)
	    kpregs(j) = .not.(excludea(ireg(k,l)))
            if(ezcsel(k,l,kmax,lmax,ireg)) then
               xsmin = min(xsmin,xs(j))
               xsmax = max(xsmax,xs(j))
               xsamin = min(xsamin,abs(xs(j)))
               xsamax = max(xsamax,abs(xs(j)))
               ysmin = min(ysmin,ys(j))
               ysmax = max(ysmax,ys(j))
               ysamin = min(ysamin,abs(ys(j)))
               ysamax = max(ysamax,abs(ys(j)))
               nhit = nhit + 1
            endif
         enddo
      enddo
      if(nhit == 0) then
         call ezcremrk('plotfm:  specification excludes all points, ignored.')
         call osfreen(Point(zexts),"ezn.zexts")
         call osfreen(Point(ys),"ezn.ys")
         call osfreen(Point(xs),"ezn.xs")
         call osfreen(Point(zs),"ezn.zs")
         call osfreen(Point(zci),"ezn.zci")
         call osfreen(Point(iregs),"ezn.iregs")
         call osfreen(Point(kpregs),"ezn.kpregs")
         call osfreen(Point(kllmts),"ezn.kllmts")
         nc = nc - 1
         return
      endif

      if (ezcdebug) then
         if (xexlarge) then
            write(errmsg,'(a,1p,e11.3)') 'WARNING!! x data exceeds plot limit ',ceiling
            call ezcremrk(errmsg)
         endif
         if (xexsmall) then
            write(errmsg,'(a,1p,e11.3)') 'WARNING!! x data is below plot limit ',realsmall
            call ezcremrk(errmsg)
         endif
         if (yexlarge) then
            write(errmsg,'(a,1p,e11.3)') 'WARNING!! y data exceeds plot limit ',ceiling
            call ezcremrk(errmsg)
         endif
         if (yexsmall) then
            write(errmsg,'(a,1p,e11.3)') 'WARNING!! y data is below plot limit ',realsmall
            call ezcremrk(errmsg)
         endif
      endif


      kllmts(1)= klo
      kllmts(2)= khi
      kllmts(3)= kinc
      kllmts(4)= llo
      kllmts(5)= lhi
      kllmts(6)= linc
      kllmts(7)= kmax
      kllmts(8)= lmax

      call ezcsdata(Point(ys),nks,nls,yi(nc),FALSE)
      call ezcchgfe(yi(nc),ysmin,ysmax,ysamin,ysamax)
      call ezcsdata(Point(xs),nks,nls,xi(nc),FALSE)
      call ezcchgfe(xi(nc),xsmin,xsmax,xsamin,xsamax)
      call ezcsdata(Point(zs),nks,nls,zi(nc),FALSE)
      call ezcsdata(Point(iregs),nks,nls,iregi(nc),FALSE)
      call ezcsdata(Point(kpregs),nks,nls,kpregi(nc),FALSE)
      call ezcsdata(Point(kllmts),1,8,kllmti(nc),FALSE)
      call ezcsdata(Point(zexts),1,5,zexti(nc),FALSE)

      #call ezcsmda	#store mesh plot attributes

      pending = TRUE
      if (ezcshow) call ezcshowf
      call osfreen(Point(zci),"ezn.zci")
      return
      end
