      subroutine ezcaddm(x,y,ireg,kmax,lmax)
#mesh plot
      integer kmax,lmax,ireg(kmax,lmax)
      real(Size8) y(kmax,lmax), x(kmax,lmax)
      integer utsizeof
      external utsizeof
Use(Ezcurve)
Use(Collections)
Use(Default_attributes)
Use(Extrema)
Use(EzcurveDefaults)
      integer j,k,l,n,nhit
      integer nks, nls
      Dynamic(xs,real(Size4),1)
      Dynamic(ys,real(Size4),1)
      Dynamic(iregs,integer,1)
      Dynamic(kpregs,logical,1)
      Dynamic(kllmts,integer,8)
      Dynamic(bndflags,integer,1)
      logical xexlarge,xexsmall,yexlarge,yexsmall
      real(Size4) xsmin,xsmax,ysmin,ysmax
      real(Size4) xsamin,xsamax,ysamin,ysamax
      integer klo,khi,kinc,khilmt,llo,lhi,linc,lhilmt
      logical ezcsel
      external ezcsel
      real(Size8) anum
      real(Size4) store,floor
      real(Size4) arg1,arg2
      logical arequal
      logical ezcnopl
      external ezcnopl
      real(Size4) r1mach
      external r1mach
      character*80 errmsg
# (FNF 7/29/97) Changed "write(STDOUT,...) statements to "call remark".
# (FNF 8/13/97) Changed "call remark" statements to "call ezcremrk".
# (FNF 5/22/98) Changed second smin to samin in ezcchgfe calls.
# (FNF 5/29/98) Corrected tests for exlarge and exsmall variables.
# (FNF 6/30/98) Replaced tests for equality of floating point numbers by
#               comparison of their relative difference with r1mach(4).

      store(anum)=real(sign(min(ceiling,abs(anum)),anum),Size4)
      floor(anum)=real(sign(max(realsmall,abs(anum)),anum),Size4)
#       The following assumes arg2>0.
      arequal(arg1,arg2) = abs(arg1-arg2)/max(abs(arg1),arg2) .lt. r1mach(4)

      if (ezcnopl()) return  #Implement no-plot option (FNF 11/11/96)
      xexlarge = .false.
      xexsmall = .false.
      yexlarge = .false.
      yexsmall = .false.

      call ezckl(kmax,lmax,ireg,klo,khi,kinc,
                                 llo,lhi,linc,nks,nls)
      n = nks*nls
      if(n == 0) then
         call ezcremrk('plotm:  specification excludes all points, ignored.')
         return
      endif
      call ezcxpnd
      namec(nc)=Mesh
      call smovftoa (kstylec, SSIZE*(nc-1), kstylea, 0, SSIZE)
      call smovftoa (lstylec, SSIZE*(nc-1), lstylea, 0, SSIZE)
      call smovftoa (markc, SSIZE*(nc-1), marka, 0, SSIZE)
      marksc(nc)= marksa

      lhilmt=lhi
      khilmt=khi
      if (lhi<lmax) lhilmt=lhilmt+1
      if (khi<kmax) khilmt=khilmt+1

      nks = khilmt - klo + 1
      nls = lhilmt - llo + 1
      n = nks * nls 	#need to store all r, z, and ireg
      call osallotn(Point(ys),n,"EZCADDM:ys ")
      call osallotn(Point(xs),n,"EZCADDM:xs ")
      call osallotn(Point(iregs),n,"EZCADDM:iregs ")
      call osallotn(Point(kpregs),n,"EZCADDM:kpregs ")
      call osallotn(Point(kllmts),8,"EZCADDM:kllmts ")
      call osallotn(Point(bndflags),1,"EZCADDM:bndflags ")
      j = 0
      nhit = 0
      ysmin = real(ceiling,Size4)
      ysmax = real(-ceiling,Size4)
      xsmin = real(ceiling,Size4)
      xsmax = real(-ceiling,Size4)
      ysamin = real(ceiling,Size4)
      ysamax = real(-ceiling,Size4)
      xsamin = real(ceiling,Size4)
      xsamax = real(-ceiling,Size4)
      do l=llo,lhilmt
         do k=klo,khilmt
            j = j + 1
            ys(j) = store(y(k,l))
            if ( arequal(abs(ys(j)), real(ceiling,Size4)) ) then
               yexlarge = .true.
            else if (y(k,l) <> 0.) then
               ys(j) = floor(y(k,l))
               if ( arequal(abs(ys(j)), real(realsmall,Size4)) ) \
                  yexsmall = .true.
            endif
            xs(j) = store(x(k,l))
            if ( arequal(abs(xs(j)), real(ceiling,Size4)) ) then
               xexlarge = .true.
            else if (x(k,l) <> 0.) then
               xs(j) = floor(x(k,l))
               if ( arequal(abs(xs(j)), real(realsmall,Size4)) ) \
                  xexsmall = .true.
            endif

	    iregs(j) = ireg(k,l)
	    kpregs(j) = .not.(excludea(ireg(k,l)))
            if(ezcsel(k,l,kmax,lmax,ireg)) then
               xsmin = min(xsmin,xs(j))
               xsmax = max(xsmax,xs(j))
               xsamin = min(xsamin,abs(xs(j)))
               xsamax = max(xsamax,abs(xs(j)))
               ysmin = min(ysmin,ys(j))
               ysmax = max(ysmax,ys(j))
               ysamin = min(ysamin,abs(ys(j)))
               ysamax = max(ysamax,abs(ys(j)))
               nhit = nhit + 1
            endif
         enddo
      enddo
      if(nhit == 0) then
         call ezcremrk('plotm:  specification excludes all points, ignored.')
         call osfreen(Point(ys),"ezn.ys")
         call osfreen(Point(xs),"ezn.xs")
         call osfreen(Point(iregs),"ezn.iregs")
         call osfreen(Point(kpregs),"ezn.kpregs")
         call osfreen(Point(kllmts),"ezn.kllmts")
         call osfreen(Point(bndflags),"ezn.bndflags")
         nc = nc - 1
         return
      endif

      if (ezcdebug) then
         if (xexlarge) then
            write(errmsg,'(a,1p,e11.3)') 'WARNING!! x data exceeds plot limit ',ceiling
            call ezcremrk(errmsg)
         endif
         if (xexsmall) then
            write(errmsg,'(a,1p,e11.3)') 'WARNING!! x data is below plot limit ',realsmall
            call ezcremrk(errmsg)
         endif
         if (yexlarge) then
            write(errmsg,'(a,1p,e11.3)') 'WARNING!! y data exceeds plot limit ',ceiling
            call ezcremrk(errmsg)
         endif
         if (yexsmall) then
            write(errmsg,'(a,1p,e11.3)') 'WARNING!! y data is below plot limit ',realsmall
            call ezcremrk(errmsg)
         endif
      endif

      bndflags(1) = bnda
      kllmts(1)= klo
      kllmts(2)= khi
      kllmts(3)= kinc
      kllmts(4)= llo
      kllmts(5)= lhi
      kllmts(6)= linc
      kllmts(7)= kmax
      kllmts(8)= lmax

      call ezcsdata(Point(ys),nks,nls,yi(nc),FALSE)
      call ezcchgfe(yi(nc),ysmin,ysmax,ysamin,ysamax)
      call ezcsdata(Point(xs),nks,nls,xi(nc),FALSE)
      call ezcchgfe(xi(nc),xsmin,xsmax,xsamin,xsamax)
      call ezcsdata(Point(iregs),nks,nls,iregi(nc),FALSE)
      call ezcsdata(Point(kpregs),nks,nls,kpregi(nc),FALSE)
      call ezcsdata(Point(kllmts),1,8,kllmti(nc),FALSE)
      call ezcsdata(Point(bndflags),1,1,bndflagi(nc),FALSE)

      call ezcsmda	#store mesh plot attributes

      pending = TRUE
      if (ezcshow) call ezcshowf
      return
      end
