      subroutine ezcaddmc(x,y,z,ireg,kmax,lmax)
#contour map for a point-centered quantity
      integer kmax,lmax,ireg(kmax,lmax)
      real(Size8) y(kmax,lmax), x(kmax,lmax), z(kmax,lmax)
      integer utsizeof
      external utsizeof
Use(Ezcurve)
Use(Collections)
Use(Default_attributes)
Use(Extrema)
Use(EzcurveDefaults)
      integer j,k,l,n, nhit
      integer plkmin, plkmax, plkinc, pllmin, pllmax, pllinc
      integer nks, nls
      Dynamic(xs,real(Size4),1)
      Dynamic(ys,real(Size4),1)
      Dynamic(zs,real(Size4),1)
      real(Size4) xsmin,xsmax,ysmin,ysmax,zsmin,zsmax
      real(Size4) xsamin,xsamax,ysamin,ysamax,zsamin,zsamax
      logical xexlarge,xexsmall,yexlarge,yexsmall,zexlarge,zexsmall
      logical ezcsel
      external ezcsel
      real(Size8) anum
      real(Size4) store,floor
      real(Size4) arg1,arg2
      logical arequal
      logical ezcnopl
      external ezcnopl
      real(Size4) r1mach
      external r1mach
      character*80 errmsg
# (FNF 7/29/97) Changed "write(STDOUT,...) statements to "call remark".
# (FNF 8/13/97) Changed "call remark" statements to "call ezcremrk".
# (FNF 5/22/98) Changed second smin to samin in ezcchgfe calls.
# (FNF 5/22/98) Corrected test for extremely large or small values
#               and moved it before min/max computations.
# (FNF 5/29/98) Corrected tests for exlarge and exsmall variables.
# (FNF 6/30/98) Replaced tests for equality of floating point numbers by
#               comparison of their relative difference with r1mach(4).

      store(anum)=real(sign(min(ceiling,abs(anum)),anum),Size4)
      floor(anum)=real(sign(max(realsmall,abs(anum)),anum),Size4)
#       The following assumes arg2>0.
      arequal(arg1,arg2) = abs(arg1-arg2)/max(abs(arg1),arg2) .lt. r1mach(4)

      if (ezcnopl()) return  #Implement no-plot option (FNF 11/11/96)
      xexlarge = .false.
      xexsmall = .false.
      yexlarge = .false.
      yexsmall = .false.
      zexlarge = .false.
      zexsmall = .false.
      call ezckl(kmax,lmax,ireg,plkmin,plkmax,plkinc,
                                 pllmin,pllmax,pllinc,nks,nls)
      n = nks*nls
      if(n == 0) then
         call ezcremrk('plotc: no points selected, ignored.')
         return
      endif
      call ezcxpnd
      namec(nc)=MeshContour
      labeli(nc) = levela
      if(nlevela ==0) nlevela = 8      
      vxi(nc) = nlevela

      call osallotn(Point(ys),n,"EZCADDMC:ys ")
      call osallotn(Point(xs),n,"EZCADDMC:xs ")
      call osallotn(Point(zs),n,"EZCADDMC:zs ")
      j = 0
      nhit = 0
      ysmin = real(ceiling,Size4)
      ysmax = real(-ceiling,Size4)
      xsmin = real(ceiling,Size4)
      xsmax = real(-ceiling,Size4)
      zsmin = real(ceiling,Size4)
      zsmax = real(-ceiling,Size4)
      ysamin = real(ceiling,Size4)
      ysamax = real(-ceiling,Size4)
      xsamin = real(ceiling,Size4)
      xsamax = real(-ceiling,Size4)
      zsamin = real(ceiling,Size4)
      zsamax = real(-ceiling,Size4)
      do l=pllmin,pllmax,pllinc
         do k=plkmin,plkmax,plkinc
            j = j + 1
            ys(j) = store(y(k,l))
            if ( arequal(abs(ys(j)), real(ceiling,Size4)) ) then
               yexlarge = .true.
            else if (y(k,l) <> 0.) then
               ys(j) = floor(y(k,l))
               if ( arequal(abs(ys(j)), real(realsmall,Size4)) ) \
                  yexsmall = .true.
            endif
            xs(j) = store(x(k,l))
            if ( arequal(abs(xs(j)), real(ceiling,Size4)) ) then
               xexlarge = .true.
            else if (x(k,l) <> 0.) then
               xs(j) = floor(x(k,l))
               if ( arequal(abs(xs(j)), real(realsmall,Size4)) ) \
                  xexsmall = .true.
            endif
            if(ezcsel(k,l,kmax,lmax,ireg)) then
               zs(j) = store(z(k,l))
#               Check for extremely large value.
               if ( arequal(abs(zs(j)), real(ceiling,Size4)) ) then
                  zexlarge = .true.
                  zs(j) = NCARSPV
                  next
               else if (z(k,l) <> 0.) then
                  zs(j) = floor(z(k,l))
#                  Check for extremely small value.
                  if ( arequal(abs(zs(j)), real(realsmall,Size4)) ) then
                     zexsmall = .true.
                     zs(j) = NCARSPV
                     next
                  endif
               endif
               zsmin = min(zsmin,zs(j))
               zsmax = max(zsmax,zs(j))
               zsamin = min(zsamin,abs(zs(j)))
               zsamax = max(zsamax,abs(zs(j)))
               xsmin = min(xsmin,xs(j))
               xsmax = max(xsmax,xs(j))
               xsamin = min(xsamin,abs(xs(j)))
               xsamax = max(xsamax,abs(xs(j)))
               ysmin = min(ysmin,ys(j))
               ysmax = max(ysmax,ys(j))
               ysamin = min(ysamin,abs(ys(j)))
               ysamax = max(ysamax,abs(ys(j)))
               nhit = nhit + 1
            else
	       zs(j) = NCARSPV
            endif
         enddo
      enddo

      if (ezcdebug) then
         if (xexlarge) then
            write(errmsg,'(a,1p,e11.3)') 'WARNING!! x data exceeds plot limit ',ceiling
            call ezcremrk(errmsg)
         endif
         if (xexsmall) then
            write(errmsg,'(a,1p,e11.3)') 'WARNING!! x data is below plot limit ',realsmall
            call ezcremrk(errmsg)
         endif
         if (yexlarge) then
            write(errmsg,'(a,1p,e11.3)') 'WARNING!! y data exceeds plot limit ',ceiling
            call ezcremrk(errmsg)
         endif
         if (yexsmall) then
            write(errmsg,'(a,1p,e11.3)') 'WARNING!! y data is below plot limit ',realsmall
            call ezcremrk(errmsg)
         endif
         if (zexlarge) then
            write(errmsg,'(a,1p,e11.3)') 'WARNING!! z data exceeds plot limit ',ceiling
            call ezcremrk(errmsg)
         endif
         if (zexsmall) then
            write(errmsg,'(a,1p,e11.3)') 'WARNING!! z data is below plot limit ',realsmall
            call ezcremrk(errmsg)
         endif
      endif

      if(nhit == 0) then
         call ezcremrk('plotc: no points selected, ignored.')
         call osfreen(Point(ys),"ezn.ys")
         call osfreen(Point(xs),"ezn.xs")
         call osfreen(Point(zs),"ezn.zs")
         nc = nc - 1
         return
      endif
      call ezcsdata(Point(ys),nks,nls,yi(nc),FALSE)
      call ezcchgfe(yi(nc),ysmin,ysmax,ysamin,ysamax)
      call ezcsdata(Point(xs),nks,nls,xi(nc),FALSE)
      call ezcchgfe(xi(nc),xsmin,xsmax,xsamin,xsamax)
      call ezcsdata(Point(zs),nks,nls,zi(nc),FALSE)
      call ezcchgfe(zi(nc),zsmin,zsmax,zsamin,zsamax)

      call ezcsmda	#store mesh plot attributes

      pending = TRUE
      if (ezcshow) call ezcshowf
      return
      end
