      subroutine ezcaddr(laser,nlaser,raypr,raypz,rayppow,jrp,kpt,ndx,mxp,idmpr,rpltf,rayl,rayu,nsray)
#laser ray plot
      real(Size4) raypr(1),raypz(1),rayppow(1)
      integer nlaser,laser(1),nsray
      integer jrp(1),kpt(1),ndx(1),mxp(1),idmpr(1),rpltf(1),rayl(1),rayu(1)
      integer utsizeof
      external utsizeof
Use(Ezcurve)
Use(Collections)
Use(Default_attributes)
Use(Extrema)
Use(EzcurveDefaults)
      integer i,j,k,kk,ii
      integer tnrays, nthray, tnraypts, nthpt
      integer dispmark(15)
      integer imkstr
      external imkstr
      save dispmark
      Dynamic(lasindx,integer,1)	# array of laser indices
      Dynamic(raydspix,integer,1)	# array of laser dispmark indices
      Dynamic(lasers,integer,1)		# array of lasers 
      Dynamic(nrays,integer,1)		# array of ray count 
      Dynamic(raylabs,integer,1)	# array of ray labels
      Dynamic(dispmarks,integer,1)	# array of dispmark indices
      Dynamic(nraypts,integer,1)	# array of point count(rays linearized)
      Dynamic(xs,real(Size4),1)		# z coordinates of points
      Dynamic(ys,real(Size4),1)		# r coordinates of points
      Dynamic(pws,real(Size4),1)	# power values at the points YHC 4/3/95
      data dispmark /49,50,51,52,53,54,55,56,57,111,98,97,110,101,108/

#  Changed "write(STDERR,..." to "call ezcerror".  (FNF 7/23/97)
      character*80 msg

      logical ezcnopl
      external ezcnopl
      if (ezcnopl()) return  #Implement no-plot option (FNF 11/11/96)

      call ezcxpnd
      namec(nc)=Ray

      call osallotn(Point(lasindx),nlaser,"EZCADDR:lasindx ")	#laser indices for laser numbers
      call osallotn(Point(raydspix),nlaser,"EZCADDR:raydspix ")	#dispmark indices
      call osallotn(Point(lasers),nlaser,"EZCADDR:lasers ")	#space to store laser list
      call osallotn(Point(nrays),nlaser,"EZCADDR:nrays ")	#space to store no of rays in each laser

      do i = 1,nlaser
         lasers(i) = laser(i)
      enddo

      tnrays = 0	#total number of rays to plot
      tnraypts = 0	#total number of plot points
      
      do i = 1,nlaser
         # check if bad laser number
         if ((laser(i) <= 0) | (laser(i) > nsray)) then
            call osfreen(Point(lasindx),"ezn.lasindx")
            call osfreen(Point(raydspix),"ezn.raydspix")
            call osfreen(Point(lasers),"ezn.lasers")
            call osfreen(Point(nrays),"ezn.nrays")
            nc = nc -1
            write(msg,951) laser(i)
            call ezcerror(msg,0)
951   format('ezcaddr: invalid laser number ',i7)
            return
         endif
         # check if laser is to be plotted
         if (jrp(laser(i)) == 0) then
            call osfreen(Point(lasindx),"ezn.lasindx")
            call osfreen(Point(raydspix),"ezn.raydspix")
            call osfreen(Point(lasers),"ezn.lasers")
            call osfreen(Point(nrays),"ezn.nrays")
            nc = nc -1
            write (msg,961) laser(i)
            call ezcerror(msg,0)
961   format ('ezcray: ray plot flag (JRP) is off for laser number ',i7)
            return
         endif

         # set laser index
         lasindx(i) = 0
         do j = 1,laser(i)
            lasindx(i) = lasindx(i) + jrp(j)
         enddo

         raydspix(i) = ndx(lasindx(i)) - 1	# used for dispmarks

	 # number of rays for this laser
         nrays(i) = rayu(lasindx(i))-rayl(lasindx(i))+1 	
         tnrays = tnrays + nrays(i)		# the total number of rays

      enddo

      call osallotn(Point(nraypts),tnrays,"EZCADDR:nraypts ")	# allocate space for nraypts
      call osallotn(Point(raylabs),tnrays,"EZCADDR:raylabs ")	# allocate space for raylabs
      call osallotn(Point(dispmarks),tnrays,"EZCADDR:dispmarks ")	# allocate space for dispidxs
      nthray = 0	# cursor to walk through all rays
      do i = 1,nlaser
         do j = 1,nrays(i)
            kk = rayl(lasindx(i)) + j - 1
            nthray = nthray + 1
            nraypts(nthray) = mxp(kk)	# store no of pts in each ray
            if (mxp(kk) > 0) then
            # calculate number of total ploting points
               tnraypts= tnraypts+ mxp(kk)	# the total plot points
            # store ray labels and dispmarks
               raylabs(nthray) = kk
             #-Change requested 4/02/99 by JAH to reflect idmpr changes.
             # (Now all rays have an idmpr entry.)   (FNF 11/02/99)
               ii = idmpr(kk)
               if (ii > 0 & ii < 16) then
                  dispmarks(nthray) = dispmark(ii)
               else
                  dispmarks(nthray) = 0
               endif
            endif
         enddo
      enddo

      call osallotn(Point(ys),tnraypts,"EZCADDR:ys ")	#space to store y values
      call osallotn(Point(xs),tnraypts,"EZCADDR:xs ")	#space to store x values
      # allocate memory to store power reading at the points YHC 4/3/95
      call osallotn(Point(pws),tnraypts,"EZCADDR:pws ")  #space to store power values
      
      nthpt = 0	# cursor to walk through all data points
      do i = 1,nlaser  	 
         # process all laser rays
         do j = rayl(lasindx(i)),rayu(lasindx(i))
            if (mxp(j) > 0) then
               # store the ray info
               do k = 1,mxp(j)
                  nthpt = nthpt + 1
                  ys(nthpt) = raypr(kpt(j)+k)
                  xs(nthpt) = raypz(kpt(j)+k)
                  pws(nthpt) = rayppow(kpt(j)+k)	#store power values
               enddo
            endif
         enddo
      enddo


      # store the data for ezcdispl
      call ezcsdata(Point(lasers),nlaser,1,lasi(nc),FALSE)
      call ezcsdata(Point(nrays),nlaser,1,nrayi(nc),FALSE)
      call ezcsdata(Point(raylabs),tnrays,1,raylabi(nc),FALSE)
      call ezcsdata(Point(dispmarks),tnrays,1,dispmarki(nc),FALSE)
      call ezcsdata(Point(nraypts),tnrays,1,nraypti(nc),FALSE)
      call ezcsdata(Point(ys),tnraypts,1,yi(nc),FALSE)
      call ezcsdata(Point(xs),tnraypts,1,xi(nc),FALSE)
      call ezcsdata(Point(pws),tnraypts,1,pwi(nc),FALSE)	

      pending = TRUE
      if (ezcshow) call ezcshowf
      return
      end
