      subroutine ezcaddv(x,y,xv,yv,ireg,kmax,lmax)
      integer kmax, lmax
      real(Size8) y(kmax,lmax), x(kmax,lmax), yv(kmax,lmax), xv(kmax,lmax)
      integer ireg(kmax,lmax)
Use(Ezcurve)
Use(Collections)
Use(Default_attributes)
Use(Extrema)
Use(EzcurveDefaults)
      integer j,k,l,n, nhit
      integer plkmin, plkmax, plkinc, pllmin, pllmax, pllinc
      integer nks, nls
      Dynamic(xs,real(Size4),1)
      Dynamic(ys,real(Size4),1)
      Dynamic(xvs,real(Size4),1)
      Dynamic(yvs,real(Size4),1)
      real(Size4) xsmin,xsmax,ysmin,ysmax
      real(Size4) xsamin,xsamax,ysamin,ysamax
      logical xexlarge,xexsmall,yexlarge,yexsmall,xvexlarge,xvexsmall,
     +        yvexlarge,yvexsmall
      logical ezcsel
      external ezcsel
      real(Size8) anum
      real(Size4) store,floor
      real(Size4) arg1,arg2
      logical arequal
      logical ezcnopl
      external ezcnopl
      real(Size4) r1mach
      external r1mach
      character*80 errmsg
# (FNF 7/29/97) Changed "write(STDOUT,...) statements to "call remark".
# (FNF 8/13/97) Changed "call remark" statements to "call ezcremrk".
# (FNF 5/22/98) Changed second smin to samin in ezcchgfe calls.
# (FNF 5/29/98) Corrected tests for exlarge and exsmall variables.
# (FNF 6/30/98) Replaced tests for equality of floating point numbers by
#               comparison of their relative difference with r1mach(4).

      store(anum)=real(sign(min(ceiling,abs(anum)),anum),Size4)
      floor(anum)=real(sign(max(realsmall,abs(anum)),anum),Size4)
#       The following assumes arg2>0.
      arequal(arg1,arg2) = abs(arg1-arg2)/max(abs(arg1),arg2) .lt. r1mach(4)

      if (ezcnopl()) return  #Implement no-plot option (FNF 11/11/96)
      xexlarge = .false.
      yexlarge = .false.
      xexsmall = .false.
      yexsmall = .false.
      xvexlarge = .false.
      yvexlarge = .false.
      xvexsmall = .false.
      yvexsmall = .false.

      call ezckl(kmax,lmax,ireg,plkmin,plkmax,plkinc,
                                 pllmin,pllmax,pllinc,nks,nls)
      n = nks*nls
      if(n == 0) then
         call ezcremrk('plotv: no points selected, ignored.')
         return
      endif
      call ezcxpnd
      namec(nc)=Vector
      marksc(nc) = vscalea
      call osallotn(Point(ys),n,"EZCADDV:ys ")
      call osallotn(Point(xs),n,"EZCADDV:xs ")
      call osallotn(Point(yvs),n,"EZCADDV:yvs ")
      call osallotn(Point(xvs),n,"EZCADDV:xvs ")
      j = 0
      nhit = 0
      ysmin = real(ceiling,Size4)
      ysmax = real(-ceiling,Size4)
      xsmin = real(ceiling,Size4)
      xsmax = real(-ceiling,Size4)
      ysamin = real(ceiling,Size4)
      ysamax = real(-ceiling,Size4)
      xsamin = real(ceiling,Size4)
      xsamax = real(-ceiling,Size4)
      do l=pllmin,pllmax,pllinc
         do k=plkmin,plkmax,plkinc
            j = j + 1
            ys(j) = store(y(k,l))
            if ( arequal(abs(ys(j)), real(ceiling,Size4)) ) then
               yexlarge = .true.
            else if (y(k,l) <> 0.) then
               ys(j) = floor(y(k,l))
               if ( arequal(abs(ys(j)), real(realsmall,Size4)) ) \
                  yexsmall = .true.
            endif
            xs(j) = store(x(k,l))
            if ( arequal(abs(xs(j)), real(ceiling,Size4)) ) then
               xexlarge = .true.
            else if (x(k,l) <> 0.) then
               xs(j) = floor(x(k,l))
               if ( arequal(abs(xs(j)), real(realsmall,Size4)) ) \
                  xexsmall = .true.
            endif
            if(ezcsel(k,l,kmax,lmax,ireg)) then
               yvs(j) = store(yv(k,l))
               if ( arequal(abs(yvs(j)), real(ceiling,Size4)) ) then
                  yvexlarge =.true.
               else if (yv(k,l) <> 0.) then
                  yvs(j) = floor(yv(k,l))
                  if ( arequal(abs(yvs(j)), real(realsmall,Size4)) ) \
                     yvexsmall =.true.
               endif
               xvs(j) = store(xv(k,l))
               if ( arequal(abs(xvs(j)), real(ceiling,Size4)) ) then
                  xvexlarge =.true.
               else if (xv(k,l) <> 0.) then
                  xvs(j) = floor(xv(k,l))
                  if ( arequal(abs(xvs(j)), real(realsmall,Size4)) ) \
                     xvexsmall =.true.
               endif
               xsmin = min(xsmin,xs(j))
               xsmax = max(xsmax,xs(j))
               ysmin = min(ysmin,ys(j))
               ysmax = max(ysmax,ys(j))
               xsamin = min(xsamin,abs(xs(j)))
               xsamax = max(xsamax,abs(xs(j)))
               ysamin = min(ysamin,abs(ys(j)))
               ysamax = max(ysamax,abs(ys(j)))
               nhit = nhit + 1
            else
               yvs(j) = NCARSPV
               xvs(j) = NCARSPV
            endif
         enddo
      enddo

      if (ezcdebug) then
         if (xexlarge) then
            write(errmsg,'(a,1p,e11.3)') 'WARNING!! x data exceeds plot limit ',ceiling
            call ezcremrk(errmsg)
         endif
         if (xexsmall) then
            write(errmsg,'(a,1p,e11.3)') 'WARNING!! x data is below plot limit ',realsmall
            call ezcremrk(errmsg)
         endif
         if (yexlarge) then
            write(errmsg,'(a,1p,e11.3)') 'WARNING!! y data exceeds plot limit ',ceiling
            call ezcremrk(errmsg)
         endif
         if (yexsmall) then
            write(errmsg,'(a,1p,e11.3)') 'WARNING!! y data is below plot limit ',realsmall
            call ezcremrk(errmsg)
         endif
         if (xvexlarge) then
            write(errmsg,'(a,1p,e11.3)') 'WARNING!! xv data exceeds plot limit ',ceiling
            call ezcremrk(errmsg)
         endif
         if (xvexsmall) then
            write(errmsg,'(a,1p,e11.3)') 'WARNING!! xv data is below plot limit ',realsmall
            call ezcremrk(errmsg)
         endif
         if (yvexlarge) then
            write(errmsg,'(a,1p,e11.3)') 'WARNING!! yv data exceeds plot limit ',ceiling
            call ezcremrk(errmsg)
         endif
         if (yvexsmall) then
            write(errmsg,'(a,1p,e11.3)') 'WARNING!! yv data is below plot limit ',realsmall
            call ezcremrk(errmsg)
         endif
      endif

      if(nhit == 0) then
         call ezcremrk('plotv: no points selected, ignored.')
         call osfreen(Point(ys),"ezn.ys")
         call osfreen(Point(xs),"ezn.xs")
         call osfreen(Point(yvs),"ezn.yvs")
         call osfreen(Point(xvs),"ezn.xvs")
         nc = nc - 1
         return
      endif
      call ezcsdata(Point(ys),nks,nls,yi(nc),FALSE)
      call ezcchgfe(yi(nc),ysmin,ysmax,ysamin,ysamax)
      call ezcsdata(Point(xs),nks,nls,xi(nc),FALSE)
      call ezcchgfe(xi(nc),xsmin,xsmax,xsamin,xsamax)
      call ezcsdata(Point(yvs),nks,nls,vyi(nc),FALSE)
      call ezcsdata(Point(xvs),nks,nls,vxi(nc),FALSE)

      call ezcsmda	#store mesh plot attributes

      pending = TRUE
      if (ezcshow) call ezcshowf
      return
      end
