      subroutine ezcaddz(z,nz1,nz2,x,nx1,nx2,y,ny1,ny2)
      integer i,nx1,nx2,ny1,ny2,nz1,nz2
#contour map of random data or matrix vs. vector vector or matrix matrix matrix
      real(Size8) z(1),y(1),x(1)
      Use(Ezcurve)
      Use(Collections)
      Use(Default_attributes)
      Use(Extrema)
      Use(Random_Contour_Plots)
      Dynamic(xs,real(Size4),1)
      Dynamic(ys,real(Size4),1)
      Dynamic(zs,real(Size4),1)
      Dynamic(rsq,real(Size4))
      logical xexlarge,xexsmall,yexlarge,yexsmall,zexlarge,zexsmall

      integer utsizeof
      external utsizeof
      real(Size8) anum
      real(Size4) store,floor
      real(Size4) arg1,arg2
      logical arequal
      logical ezcnopl
      external ezcnopl
      real(Size4) r1mach
      external r1mach
      character*80 errmsg
# (FNF 7/29/97) Changed "write(STDOUT,...) statements to "call remark".
# (FNF 8/13/97) Changed "call remark" statements to "call ezcremrk".
# (FNF 5/29/98) Corrected tests for exlarge and exsmall variables.
# (FNF 6/30/98) Replaced tests for equality of floating point numbers by
#               comparison of their relative difference with r1mach(4).

      store(anum)=real(sign(min(ceiling,abs(anum)),anum),Size4)
      floor(anum)=real(sign(max(realsmall,abs(anum)),anum),Size4)
#       The following assumes arg2>0.
      arequal(arg1,arg2) = abs(arg1-arg2)/max(abs(arg1),arg2) .lt. r1mach(4)

      if (ezcnopl()) return  #Implement no-plot option (FNF 11/11/96)
      xexlarge = .false.
      yexlarge = .false.
      zexlarge = .false.
      xexsmall = .false.
      yexsmall = .false.
      zexsmall = .false.

# save the data     

      call ezcxpnd
      namec(nc)=OtherContour
      labeli(nc) = levela
      if(nlevela == 0) nlevela = 8      
      vxi(nc) = nlevela

      call osallotn(Point(rsq),1,"EZCADDZ:rsq ")
      rsq = rsqa
      call ezcsdata(Point(rsq),1,1,vyi(nc),FALSE)

      call osallotn(Point(zs),nz1*nz2,"EZCADDZ:zs ")
      do i=1, nz1*nz2
         zs(i) = store(z(i))
         if ( arequal(abs(zs(i)), real(ceiling,Size4)) ) then
            zexlarge = .true.
         else if (z(i) <> 0.) then
            zs(i) = floor(z(i))
            if ( arequal(abs(zs(i)), real(realsmall,Size4)) ) zexsmall = .true.
         endif
      enddo
      call ezcsdata(Point(zs),nz1,nz2,zi(nc),TRUE)

      call osallotn(Point(xs),nx1*nx2,"EZCADDZ:xs ")
      do i=1, nx1*nx2
         xs(i) = store(x(i))
         if ( arequal(abs(xs(i)), real(ceiling,Size4)) ) then
            xexlarge = .true.
         else if (x(i) <> 0.) then
            xs(i) = floor(x(i))
            if ( arequal(abs(xs(i)), real(realsmall,Size4)) ) xexsmall = .true.
         endif
      enddo
      call ezcsdata(Point(xs),nx1,nx2,xi(nc),TRUE)

      call osallotn(Point(ys),ny1*ny2,"EZCADDZ:ys ")
      do i=1, ny1*ny2
         ys(i) = store(y(i))
         if ( arequal(abs(ys(i)), real(ceiling,Size4)) ) then
            yexlarge = .true.
         else if (y(i) <> 0.) then
            ys(i) = floor(y(i))
            if ( arequal(abs(ys(i)), real(realsmall,Size4)) ) yexsmall = .true.
         endif
      enddo
      call ezcsdata(Point(ys),ny1,ny2,yi(nc),TRUE)

      if (ezcdebug) then
         if (zexlarge) then
            write(errmsg,'(a,1p,e11.3)') 'WARNING!! z data exceeds plot limit ',ceiling
            call ezcremrk(errmsg)
         endif
         if (zexsmall) then
            write(errmsg,'(a,1p,e11.3)') 'WARNING!! z data is below plot limit ',realsmall
            call ezcremrk(errmsg)
         endif
         if (xexlarge) then
            write(errmsg,'(a,1p,e11.3)') 'WARNING!! x data exceeds plot limit ',ceiling
            call ezcremrk(errmsg)
         endif
         if (xexsmall) then
            write(errmsg,'(a,1p,e11.3)') 'WARNING!! x data is below plot limit ',realsmall
            call ezcremrk(errmsg)
         endif
         if (yexlarge) then
            write(errmsg,'(a,1p,e11.3)') 'WARNING!! y data exceeds plot limit ',ceiling
            call ezcremrk(errmsg)
         endif
         if (yexsmall) then
            write(errmsg,'(a,1p,e11.3)') 'WARNING!! y data is below plot limit ',realsmall
            call ezcremrk(errmsg)
         endif
      endif

      pending = TRUE
      if (ezcshow) call ezcshowf
      return
      end
