	subroutine ezcarrow(x,y,npts)
	# draw arrows along a ray path

Use(Ezcurve)
Use(Curve_Internal)
Use(Probe)
	real(Size4) x(1),y(1),ptx(3),pty(3)
	real(Size4) dist
        real(Size4) px,py,px0,py0	# plotter position x,y
        integer crevert
        real(Size4) CUFX, CUFY	# convert form User to Fraction coord
        real(Size4) CFUX, CFUY	# convert form Fraction to User coord
        Dynamic(arx,real(Size4),1)
        Dynamic(ary,real(Size4),1)
        Dynamic(theta,real(Size4),1)

	integer npts	#size of the array x (same for y)
        integer i,j
        integer kount
        real(Size4) seglen,arlen

        #initialize crevert
        crevert = 0
	#set samllest distance apart for arrows
        seglen = (sqrt(2._Size4)/20._Size4)*ezcarsp #spacing factor
        #set the arrow size
        arlen = (1.5_Size4/100._Size4)*ezcarsz	#arrow size factor
        #set the arrow color
        if ( ccolor == -1) then
           ccolor = mcolor
           crevert = 1
        endif
            

        call osallotn(Point(arx),npts,"EZCARROW:arx ")
        call osallotn(Point(ary),npts,"EZCARROW:ary ")
        call osallotn(Point(theta),npts,"EZCARROW:theta ")

        #invoke "getset" subroutine to remember the proper mapping
        call getset(ezcfl,ezcfr,ezcfb,ezcft,ezcul,ezcur,ezcub,ezcut,ezcll)

	# extracting subset of the input points for anchoring arrows
        kount = 0
	do i = 1,npts
           if ( x(i) >= ezcul & x(i) <= ezcur &
                y(i) >= ezcub & y(i) <= ezcut) then
	      px = CUFX(x(i))
              py = CUFY(y(i)) 
              if ( kount <> 0) then
                 # measure the length from the previous extracted point
                 dist = sqrt((px-px0)**2+(py-py0)**2)
	         if (dist > seglen) then 	#SEGLEN is a minimum spacing
                    kount = kount + 1
                    arx(kount) = px
                    ary(kount) = py 
                    theta(kount) = atan2(py0-py,px0-px)	
		    #theta derived from negative vector for arrow head drawing
                    px0 = px
                    py0 = py
                 endif
              else
                 kount = 1
                 arx(1) = px
                 ary(1) = py
                 px0 = px
                 py0 = py
	      endif
           endif
	enddo

	do j = 2,kount
           ptx(2) = arx(j)
           pty(2) = ary(j)
           ptx(1) = ptx(2)+arlen*cos(theta(j)-Pi/6)
           pty(1) = pty(2)+arlen*sin(theta(j)-Pi/6)
           ptx(3) = ptx(2)+arlen*cos(theta(j)+Pi/6)
           pty(3) = pty(2)+arlen*sin(theta(j)+Pi/6)

	   ptx(1) = CFUX(ptx(1))
	   pty(1) = CFUY(pty(1))
	   ptx(2) = CFUX(ptx(2))
	   pty(2) = CFUY(pty(2))
	   ptx(3) = CFUX(ptx(3))
	   pty(3) = CFUY(pty(3))

           call agcurv(ptx(1),1,pty(1),1,3,1)
          
        enddo

	# revert the color index if necessary
        if (crevert == 1) ccolor = -1

        call osfreen(Point(arx),"ezn.arx")
        call osfreen(Point(ary),"ezn.ary")
        call osfreen(Point(theta),"ezn.theta")

	return
	end
