c==============================================================================
c
c  ezclr4
c
c  purpose: convert an array of reals into an array of indices into a colormap
c     using a linear mapping.
c
c  created: bert still, 930406
c
c  revision history:
c     - renamed from r2clr (eznr2c), [chs] 931031
c     - add checking zmax .eq. zmin case  YHC 950407
c     - Corrected formula for ndx.  FNF 961226
c
c==============================================================================


      subroutine ezclr4(ncol, n, z, ndx)
c
      integer        ncol, n, ndx(n), ncm1
      real(Size4)    z(n)
c
      integer        i
      real(Size4)    zmin, zmax

c   Define function to map f (in [0.,1.]) to color index (in [0,nind]),
c   mapping any negative f's to 0, f > 1 to nind.  (FNF)
      integer      nind, colmap
      real(Size4)  f
      colmap(f,nind) = max(0, min( int(f*nind), nind) )

c find range of data
      zmin = z(1)
      zmax = z(1)
      do i=2, n
         if (z(i) > zmax) zmax = z(i)
         if (z(i) < zmin) zmin = z(i)
      enddo

c convert data to color indices
      if ( zmax == zmin) then
         do i=1,n
            ndx(i) = 1
         enddo
      else
         ncm1 = ncol - 1
         do i=1, n
            ndx(i) = colmap( (z(i) - zmin)/(zmax - zmin), ncm1) + 1
         enddo
      endif
c
      return
      end
 
         
