c==============================================================================
c
c  ezclrlim
c
c  Purpose: compute the limits of array z, ignoring values where ireg=0.
c           Returns zmin=zmax=0 if ireg=0 everywhere.
c
c           Called by ezclrm, ezclrmln, ezclrmnml.
c
c  Created: Fred N. Fritsch, 980325
c
c  Revision History:
c
c==============================================================================


      subroutine ezclrlim(z, ireg, kmax, lmax, zmin, zmax)
c
      integer        ireg(kmax,lmax), kmax, lmax
      real(Size8)    z(kmax,lmax), zmin, zmax
c
      integer        k, l
      logical        init
c
      zmin = 0.      #Initialize in case all of ireg=0.
      zmax = 0.      #Ditto.
      init = .false. #Have we found first eligable z-value?
c
      do l = 1, lmax
         do k = 1, kmax
            if (ireg(k,l) > 0) then
               if (init) then
                  if (z(k,l) > zmax) zmax = z(k,l)
                  if (z(k,l) < zmin) zmin = z(k,l)
               else
                  zmin = z(k,l)
                  zmax = z(k,l)
                  init = .true.
               endif
            endif
         enddo
      enddo
c
      return
      end
