      integer function ezcconpl(iplot,z,nz1,nz2,maptype,cfill,rcfill,filml)
      real(Size4) z(nz1,nz2)
      integer iplot,nz1,nz2,maptype
      logical cfill,rcfill,filml
C
C  This routine does the actual contour plotting for ezcdispl.
C
C  Change record:
C  (yymmdd)
C   960820  Created from code extracted from ezndispl.m by F.N.Fritsch.
C           (Lines were left at their original indentation.)
C   961009  Added calls to NCAR error recovery routines. (FNF)
C           (These statements are generally in ALL CAPS.)
C   961031  Moved said calls to only bracket the filled contour section
C           of the code.
C   961114  Added two calls before the cprect call to correct color leak
C           problem. (FNF)
C   970813  Changed CALL REMARK statements to CALL EZCREMRK. (FNF)
C
Use(Ezcurve)
Use(Collections)

# Declare temporary variables
      Dynamic(map,integer,1)
      Dynamic(xwrk,real(Size4),1)
      Dynamic(ywrk,real(Size4),1)
      Dynamic(iarea,integer,1)
      Dynamic(igrp,integer,1)
      Dynamic(iwrk,integer,1)
      Dynamic(rwrk,real(Size4),1)
# Externals for color=fill implementation (cfill or rcfill)
      external ezccfil        # color fill
      external ezccfil2       # reverse color fill

#       Declare NCAR error recovery routines. (FNF -- 10/09/96)
      INTEGER NERRO
      EXTERNAL ENTSR,ERROF,NERRO,RETSR
#       Declare local variables for NCAR error recovery. 
      INTEGER IERRF,IRECSAV

# Initialize
      ezcconpl = 0

# Code extracted from ezndispl.m by F.N.Fritsch -- 8/20/96.
               call osallotn(Point(iwrk),ezciwrk,"EZCCONPL:iwrk ")
               call osallotn(Point(rwrk),ezcrwrk,"EZCCONPL:rwrk ")
               call cpseti('MAP',maptype)
               # initial area when cfill is true
               if (cfill) then
                  call osallotn(Point(map),ezcamap,"EZCCONPL:map ")
                  call osallotn(Point(xwrk),ezcrwrk,"EZCCONPL:xwrk ")
                  call osallotn(Point(ywrk),ezcrwrk,"EZCCONPL:ywrk ")
                  call osallotn(Point(iarea),ezciwrk,"EZCCONPL:iarea ")
                  call osallotn(Point(igrp),ezciwrk,"EZCCONPL:igrp ")
                  call arinam(map,ezcamap)
               endif

# Calls suggested by NCAR's Dave Kennison to solve color leak:
               CALL CPSETI ('PAI',-1)
               CALL CPSETI ('AIA',-1)
C                  These set the area identifier associated with the
C                  outside of the grid to -1. (FNF -- 11/14/96)
               call cprect(z,nz1,nz1,nz2,rwrk,ezcrwrk,iwrk,ezciwrk)

               # color fill to the contour areas
#   Set NCAR errors to be recoverable. (FNF -- 10/31/96)
      CALL ENTSR (IRECSAV, 1)

               if (cfill) then
	 	   call cpclam(z,rwrk,iwrk,map)
		   if (rcfill) then
	              call arscam(map,xwrk,ywrk,ezcrwrk,iarea,igrp,5,ezccfil2)
                   else
	              call arscam(map,xwrk,ywrk,ezcrwrk,iarea,igrp,5,ezccfil)
		   endif
               endif

#   Check whether an NCAR error has occurred. (FNF -- 10/31/96)
      IF (NERRO(IERRF).NE.0) THEN
         ezcconpl = 1
         CALL EZCREMRK ("**** A 'recoverable' NCAR error has occurred in EZCCONPL.")
         CALL EZCREMRK ("****    Too many filled contour levels?")
C          Clear the error flag.
         CALL ERROF
         GO TO 30
      ENDIF
               call ezcclu(iplot,z,rwrk,iwrk)
	       if (~filml) then
                  call cpcldr(z,rwrk,iwrk)
	       endif
                  call gsclip(0)
                  call cplbdr(z,rwrk,iwrk)
                  call gsclip(1)
   30 CONTINUE
               call osfreen(Point(rwrk),"ezn.rwrk")
               call osfreen(Point(iwrk),"ezn.iwrk")
               if (cfill) then
                  call osfreen(Point(xwrk),"ezn.xwrk")
                  call osfreen(Point(ywrk),"ezn.ywrk")
                  call osfreen(Point(iarea),"ezn.iarea")
                  call osfreen(Point(igrp),"ezn.igrp")
                  call osfreen(Point(map),"ezn.map")
               endif
# End code from ezndispl.m ---------------------------

# Before returning, reset original NCAR recovery mode. (FNF -- 10/09/96)
      CALL RETSR (IRECSAV)

      return
      end
