      subroutine ezcdefm(ireg,kmax,lmax,kpoint,lpoint,kseg,lseg)
#*s
#     NAME OF ROUTINE...ezcdefm
#
#     AUTHOR OF ROUTINE...Janet Takemoto  04/14/88
#
#     PURPOSE...
#
#        To create the mesh connectivity arrays needed for the PLOT MESH
#        command.  This is the default version.
#
#     GLOSSARY OF IMPORTANT VARIABLES...
#
#        kmax                 = the maximum k value for the r and z arrays.
#        lmax                 = the maximum l value for the r and z arrays.
#        lklines              = determines which lines to plot
#                               valid values are "kl", "k", "l"
#        krangea               = user supplied range for the k-lines
#                               krange(1) is the minimum value for k.
#                               krange(2) is the maximum value for k.
#                               krange(3) is the increment value for k.
#        lrangea              = user supplied range for the l-lines
#                               lrange(1) is the minimum value for l.
#                               lrange(2) is the maximum value for l.
#                               lrange(3) is the increment value for l.
#        mconn                  is the result; should then be released.
#
#     COMMENTS...
#
#        Here, the mesh is assumed to be quadrilateral.
#
#/c
Use(Ezcurve)
Use(Collections)
Use(Default_attributes)
      integer kmax,lmax,kpoint,lpoint, maxcrvk, maxcrvl
      integer ireg(kmax,lmax), kseg, lseg
      integer k, l, plkmin, plkmax, plkinc, pllmin, pllmax, pllinc
      integer nks, nls, maxpoint
      logical lanchor, kanchor
      integer utsizeof
      external utsizeof

      if(krangea(1) == DEFAULT) then
         plkmin = 1
      else
         plkmin = max(1,krangea(1))
      endif
      if(lrangea(1) == DEFAULT) then
         pllmin = 1
      else
         pllmin = max(1,lrangea(1))
      endif
      if(krangea(2) == DEFAULT) then
         plkmax = kmax
      else
         plkmax = min(kmax,krangea(2))
      endif
      if(lrangea(2) == DEFAULT) then
         pllmax = lmax
      else
         pllmax = min(lmax,lrangea(2))
      endif
      plkmax=max(plkmin,plkmax)
      pllmax=max(pllmin,pllmax)
      plkinc = max(1,krangea(3))
      pllinc = max(1,lrangea(3))
      nks = 1+((plkmax-plkmin)/plkinc)
      nls = 1+((pllmax-pllmin)/pllinc)
      maxpoint = nks*(pllmax-pllmin+1)+nls*(plkmax-plkmin+1)
      call osallot(Point(mconn),maxpoint)
      maxcrvk = nks*((pllmax-pllmin+1)/2)+1
      call osallot(Point(klen),maxcrvk)
      maxcrvl = nls*((plkmax-plkmin+1)/2)+1
      call osallot(Point(llen),maxcrvl)

      kpoint = 0      
      kseg = 0
#     -- Do for horizontal lines.
      if (kstylea <> "none") then
         do k=plkmin,plkmax,plkinc
            lanchor = FALSE
            do l=pllmin+1,pllmax
               if(excludea(ireg(k,l))) then
                  if(k<kmax) then
                     if(excludea(ireg(k+1,l))) then
                        lanchor = FALSE
                        next
                     endif
                  else
                     lanchor = FALSE
                     next
                  endif
               endif
               if(lanchor) then
                  kpoint = kpoint + 1
                  mconn(kpoint)=(l-1)*kmax+k
                  klen(kseg) = klen(kseg) + 1
               else
                  kpoint = kpoint + 2
                  kseg = kseg+1
                  klen(kseg)=2
                  mconn(kpoint)=(l-1)*kmax+k
                  mconn(kpoint-1)=(l-2)*kmax+k
                  lanchor = TRUE
               endif
            enddo
         enddo
      endif
#     -- Do for vertical lines.
      lpoint = kpoint
      lseg = 0
      if (lstylea <> "none") then
         do l=pllmin,pllmax,pllinc
            kanchor = FALSE
            do k=plkmin+1,plkmax
               if(excludea(ireg(k,l))) then
                  if(l<lmax) then
                     if(excludea(ireg(k,l+1))) then
                        kanchor = FALSE
                        next
                     endif
                  else
                     kanchor = FALSE
                     next
                  endif
               endif
               if(kanchor) then
                  lpoint = lpoint + 1
                  mconn(lpoint)=(l-1)*kmax+k
                  llen(lseg)=llen(lseg) + 1
               else
                  lpoint = lpoint + 2
                  lseg = lseg + 1
                  llen(lseg) = 2
                  mconn(lpoint)=(l-1)*kmax+k
                  mconn(lpoint-1)=(l-1)*kmax+k-1
                  kanchor = TRUE
               endif
            enddo
         enddo
      endif
      lpoint = lpoint - kpoint
      return
      end
