      subroutine ezcdispl
Use(Ezcurve)      
Use(Collections)
Use(Probe)
Use(Extrema)
Use(Default_attributes)
Use(EzcurveDefaults)
Use(Random_Contour_Plots)
Use(Cpmpxy)
Use(Contours)
Use(Curve_Internal)

# Change record:
# (FNF 10/09/1996) Moved NCAR error recovery calls to ezcconpl.
# (FNF  5/22/1997) Improvements/corrections to fillmesh plots.
# (FNF  8/13/1997) Changed "call remark" statements to "call ezcremrk".
# (FNF 10/06/1997) Corrected errors in "random" contour plot section.
# (FNF 12/09/1998) Added an sflush call before the main display loop
#                  to make sure full grid gets displayed before other
#                  plotting.
# (FNF 11/02/1999) Implemented rayplot changes requested 4/02/99 by JAH.
# (FNF 11/09/1999) Corrected formula for log-spaced contour levels.
# (FNF 11/18/1999) Corrected bug in setting plotv thickness.
# (ZCM  ?/??/2000) Made changes needed for Basis 12.0.
#   The following four sets of changes were retrofitted from the 11.12
#   version of ezndispl.m on 5/12/2000.
# (FNF  3/06/2000) Implemented additional rayplot changes per JAH.
# (FNF  4/03/2000) Added code to implement new polyfill (plotp) command,
#                  with multiple polygons.
# (FNF  4/13/2000) Added code to implement new polyfunc (plotpf) command.
# (FNF  5/01/2000) Avoid overlap of contour and fillmesh annotations.
# (FNF  5/15/2000) Made changes to get rid of dynamic string indexing.
# (FNF  4/19/2001) Added option to control order of contour level keys.
# (FNF  6/29/2001) Added code to handle reverse fill color order.

      # variables for color implementations
      integer ezcctoi
      external ezcctoi
      logical cfill,rcfill,filml
      integer ezcrnbw
      external ezcrnbw

      # variables for curve/log plot
      Dynamic(xcopy,real(Size4),1)
      Dynamic(xcopys,real(Size4),1)	#store algebraic signs
      Dynamic(ycopy,real(Size4),1)
      Dynamic(ycopys,real(Size4),1)	#store algebraic signs
      integer kpbegx,kpendx,kpbegy,kpendy,kount,kpsup
      character*16 labelcrv
      logical copyx, copyy
      real(Size4) xfloored,yfloored, anum, dummy

      # variables for contour plot
      logical conerr, conplot
      real(Size4) clbpx(4), clbpy(4) #polygon box to contain contour label
      integer cfidx  # color index of polygon fill 
      Dynamic(ymplot,real(Size4),1)
      Dynamic(levs,real(Size4),1)
      integer  ezcconpl, maptype
      external ezcconpl

      # variables for mesh plot
      logical ezcsgkp	#plot line segment for the mesh 
      external ezcsgkp
      integer kpts,lpts,ibeg,ilen
      integer klo,khi,kinc,khilmt,llo,lhi,linc,lhilmt,ezckmax,ezclmax
      Dynamic(pxmesh,real(Size4),1)
      Dynamic(pymesh,real(Size4),1)

      # variables for fillmesh plot
      logical fmplot
      integer fmci,kl,kr,lb,lt,indbase,indmax,numcol
      real(Size4) polyx(4),polyy(4)
      real(Size4) zmin,zmax,zbar,zsigma,zrange,eps
      integer zmap,rco
      integer ibasis
      external ibasis
 
      # variables for ray plot
      logical raypw
      integer laserct,rayct,ptct,bptidx,rayptct,pltrayct
      character*(8) raylabel
      real(Size4) pwmin,pwmax,rpwsum,rpwbar
      Dynamic(rpwmax,real(Size4),1)
      Dynamic(rpwidx,integer,1)

      #variables for polyfill or polyfun plot
      logical pfplot
      integer npoly, npts, pcolor
 
      #variables for color annotation setup
      logical clrann
      integer jclrln, nclrln
      real(Size4) clradj

      #variables for general plot usage
      integer nlines, kxfncar, mlines, mlines1, mlines2
      parameter(nlines=64)
      character*(LSIZE) msg(nlines)
      character*(LSIZE) logmsg
      integer iplot, i, j, k, kk, l, nj, njdone, nelt, nword, 
        ixstr, iystr, lpreleg, n, jleg, q1,
        lastc, ileg, lastcc, textonly, jminsz,
        nz1,nz2, imark, plttyp, nlabels, idum, agsave
      integer imkstr
      external imkstr
      real(Size4) dx, dy, axmin, axmax, aymin, aymax, rsq, 
        zlo, zhi, zratio, xspec(3), yspec(3), grid(5), pquad(4), 
        quad(4),view(4),hw,
        titlert,titlelf,titletp,titlebt,suptitle,xdivider,conkey
      integer utgetcl, utsizeof, ezcmqd, ezcmarki
      external utgetcl, utsizeof, ezcmqd, ezcmarki
      real(Size4) tmpx,tmpy
      real(Size4) cfux, cfuy
      external cfux, cfuy #NCAR
      Dynamic(icell,integer,1)
      Dynamic(vy,real(Size4),1)
      Dynamic(vx,real(Size4),1)
      Address labelu, sdata
      character*(LSIZE) msdata
      Dynamic(tdata,real(Size4),6)   

      character*CSIZE mlcolorc, mkcolorc, mcolorc, mpreleg

      character*SSIZE mlstylec, mkstylec

      character*SSIZE mstylec, mmarkc

      character*(LSIZE) mlegendc

      integer streq1f
      external streq1f

      external ezcmap
      real(Size4) ezcmap

      xfloored(anum) = max(xfloor,abs(anum))
      yfloored(anum) = max(yfloor,abs(anum))

#      write (*,*) "Debug: Entered ezcdispl."
      eps = 1.e-14
      conerr = .false.
      conplot = .false.
      fmplot = .false.
      pfplot = .false.
      raypw = .false.
      cfill = .false.
      rcfill = .false.
      filml = .false.

      if(yucked) then
#       Changed "write(STDERR,..." to "call ezcerror".  (FNF 7/23/97)
         call ezcerror(
        "Clearing EZN display list of data that caused error.",0)
         call ezcclear
         call ezcsetxn
         call ezcfradv("ezcshowf")
         return
      endif

      call ezciquad(pquad(1),pquad(2),pquad(3),pquad(4),q1)
      if (~pending) go to 9000
      pending = FALSE
      yucked = TRUE
      call ezciminsz(jminsz)
      call pcgetr("HW",hw)
# set up the frame
# viewport
# come in a little bit for our stuff
      quad(1)=pquad(1)+.01_Size4
      quad(3)=pquad(3)+.01_Size4
      quad(2)=pquad(2)-.01_Size4
      quad(4)=pquad(4)-.01_Size4
      if(nc == 0 ) go to 9000
      call ezcscale
      ezctctn = 0 #initialize contour list

      ezclegfr=min(0.75_Size4,ezclegfr)
      ezclegfr=max(0.0_Size4,ezclegfr)
      ezccntfr=min(0.25_Size4,ezccntfr)
      ezccntfr=max(0.0_Size4,ezccntfr)
      textonly=YES
      do i=1,nc
         if(namec(i)<>Text) then
            textonly=NO
         endif
      enddo
# fixed sizes
      titlert = ezctitfr*(quad(2)-quad(1))
      titlelf = ezctitfr*(quad(2)-quad(1))
      titletp = ezctitfr*(quad(4)-quad(3))
      titlebt = ezctitfr*(quad(4)-quad(3))
      suptitle = ezctitfr*0.6_Size4*(quad(4)-quad(3))
      conkey = ezccntfr*(quad(2)-quad(1))
      xdivider = (1-textonly)*ezclegfr*(quad(4)-quad(3))
# check for contour plot
      do i=1,nc
         if(namec(i)==MeshContour|namec(i)==OtherContour) then
            conplot = .true.
            break
         endif
      enddo

# check for fillmesh plot
      do i=1,nc
         if(namec(i)==FillMesh) then
            fmplot = .true.
            break
         endif
      enddo

# check for polyfunc plot
      do i=1,nc
         if(namec(i)==PolyFunc) then
            pfplot = .true.
            break
         endif
      enddo

# check for ray power plot		#add for ray power plot YHC 4/5/95
      do i=1,nc
         if(namec(i)==Ray & (streq1f(colorc,CSIZE*(i-1),CSIZE,"power",0,5)==1 |\
                             streq1f(colorc,CSIZE*(i-1),CSIZE,"relpow",0,6)==1)) then
            raypw = .true.
            break
         endif
      enddo

# variable sizes
# merge spaces where possible
      if (~ezcfixed) then
         if(titler==" ") titlert = 0._Size4
         if(titlel==" ") titlelf = 0._Size4
         if(ezctitle==" ") suptitle = 0._Size4
         if(titlet == " ") titletp = 0._Size4
         if(titleb == " ") titlebt = 0._Size4 
	 if (~conplot & ~fmplot & ~raypw) conkey = 0._Size4
         xdivider = leginfoa*xdivider
      endif
# compute proper margin spaces
      view(1)=quad(1)+titlelf
      view(2)=quad(2)-titlert-conkey
      if (ezcsuper) then
         view(3)=quad(3)+xdivider+titlebt
         view(4)=quad(4)-suptitle-titletp
      else
         view(3)=quad(3)+xdivider+titlebt+suptitle
         view(4)=quad(4)-titletp
      endif

      call agsetp('GRAPH.',view,4)
# grid
# attempt to use the type size to make things fit
      grid(1)=jminsz*10/(1024*(view(2)-view(1)))
      grid(1)=max(.1_Size4,min(grid(1),.25_Size4))
      grid(2)=.98_Size4
      grid(3)=jminsz*10/(1024*(view(2)-view(1)))
      grid(3)=max(.1_Size4,min(grid(3),.25_Size4))
      grid(4)=.98_Size4   
      grid(5)=0._Size4
      xspec(1)=xminu
      xspec(2)=xmaxu
      xspec(3)=0._Size4
      yspec(1)=yminu
      yspec(2)=ymaxu
      yspec(3)=0._Size4
      if(scalea="linlog") then
	 yspec(3)=1._Size4
      elseif(scalea="loglin") then
         xspec(3)=1._Size4
      elseif(scalea="loglog") then
         xspec(3)=1._Size4
	 yspec(3)=1._Size4
      elseif(scalea="equal") then
         grid(5)=10._Size4  #value for GRID/SHAPE.
      endif
      call agsetp('X.',xspec,3)
      call agsetp('Y.',yspec,3)
      call agsetp('GRID.',grid,5)
      if(textonly=NO) then
         call agseti('BAC.',1)
         call agseti('LABEL/CONTROL.',0)
         if(gridxa = "on") then
            call agsetf('AXIS/BOTTOM/TICKS/MAJOR/LENGTH/INWARD.',1.0_Size4)
            call agsetf('AXIS/TOP/CONTROL.',-1.0_Size4)
         else
            call agsetf('AXIS/BOTTOM/TICKS/MAJOR/LENGTH/INWARD.',0.015_Size4)
            call agsetf('AXIS/TOP/CONTROL.',4.0_Size4)
         endif
         if(gridya = "on") then
            call agsetf('AXIS/LEFT/TICKS/MAJOR/LENGTH/INWARD.',1.0_Size4)
            call agsetf('AXIS/RIGHT/CONTROL.',-1.0_Size4)
         else
            call agsetf('AXIS/LEFT/TICKS/MAJOR/LENGTH/INWARD.',0.015_Size4)
            call agsetf('AXIS/RIGHT/CONTROL.',4.0_Size4)
         endif
      else
         call agseti('BAC.',4)
      endif
#none of args to agstup effective; all set above
      call agstup(0._Size4,0,0,0,0,0._Size4,0,0,0,0) 
      call agback
      call sflush	#Flush buffer for complete grid output.
# Do the log       
      call ezcfrlog	#set up frame count and filename
      if(suptitle >0._Size4) then
  	  logmsg = "   "//ezctitle(1:utgetcl(ezctitle))
	  call ezcwrtlog(logmsg)
      endif
      if(titletp >0._Size4) then
	  logmsg = "   "//titlet(1:utgetcl(titlet))
	  call ezcwrtlog(logmsg)
      endif

#############################################################
## main loop over entries in collection
#############################################################
      njdone = 0
      mcolor = 1	# initialize the rainbow color base index
      do iplot = 1, nc
        call smovatof (mmarkc, 0, markc, SSIZE*(iplot-1), SSIZE)
        call smovatof (mcolorc, 0, colorc, CSIZE*(iplot-1), CSIZE)
        call smovatof (mlegendc, 0, legendc, LSIZE*(iplot-1), LSIZE)
        logmsg = "   "//mlegendc(1:utgetcl(mlegendc))
        call ezcwrtlog(logmsg)
        plttyp = namec(iplot)
        call sblkset (preleg, (iplot-1)*CSIZE, CSIZE)
        mpreleg = " "

# Do the appropriate plotting, depending on plttyp:
        if (plttyp <= Curve) then
## CURVES
           Point(x) = data(xi(iplot))
           Point(y) = data(yi(iplot))
           copyx = FALSE
           copyy = FALSE
           cthick = thickc(iplot)
	   ccolor = ezcctoi(mcolorc)	#set color
           if(xlog) then #xlog, ylog were set by ezcscale
              if(dminc(xi(iplot)) < xfloor) then
# we need to copy this data since we can't plot it as is
                nelt = n1(xi(iplot)) * n2(xi(iplot))
                nword = utsizeof(nelt, type4)
		call osallotn(Point(xcopy), nword,"EZCDISPL:xcopy ")
		call osallotn(Point(xcopys), nword,"EZCDISPL:xcopys ")
                do i = 1, nelt
                   xcopy(i) = xfloored(x(i))
                   if (x(i) < xcopy(i)) then
		      xcopys(i) = -1._Size4
                   else
		      xcopys(i) = 1._Size4
                   endif
                enddo
                Point(x) = Point(xcopy)
                copyx=TRUE
              endif
           endif
           if(ylog) then
              if(dminc(yi(iplot)) < yfloor) then
# we need to copy this data since we can't plot it as is
                nelt = n1(yi(iplot)) * n2(yi(iplot))
                nword = utsizeof(nelt, type4)
		call osallotn(Point(ycopy), nword,"EZCDISPL:ycopy ")
		call osallotn(Point(ycopys), nword,"EZCDISPL:ycopys ")
                do i = 1, nelt
                   ycopy(i) = yfloored(y(i))
                   if (y(i) < ycopy(i)) then
                      ycopys(i) = -1._Size4
                   else
                      ycopys(i) = 1._Size4
                   endif
                enddo
                Point(y) = Point(ycopy)
                copyy=TRUE
              endif
           endif
	   if( n2(xi(iplot)) == 1) then
              ixstr = 0
           else
              ixstr = n1(xi(iplot))
           endif
	   if( n2(yi(iplot)) == 1) then
              iystr = 0
           else
              iystr = n1(yi(iplot))
           endif
           nj = max(n2(xi(iplot)),n2(yi(iplot)))

           if (plttyp<>Mark) then
##curves / arrows
              if( labeli(iplot) == 0) then
                 nlabels = 0
              else
                 nlabels = n1(labeli(iplot)) 
                 labelu = data(labeli(iplot))
              endif
              do j = 1, nj
                 if(labelsa == YES) then
                    if(nlabels ==0) then
                       idum = imkstr(njdone+j,labelcrv)
                    elseif(j <= nlabels) then
                       call smovatof (labelcrv, 0, labelu, (j-1)*CSIZE, CSIZE)
                    else
                       call smovatof (labelcrv, 0, labelu, (nlabels-1)*CSIZE, CSIZE)
                    endif
                 else
		     labelcrv = " "
                 endif
                 if(leginfoa == YES) then
                    if(j == 1) then
                       call smovftoa (preleg, (iplot-1)*CSIZE, labelcrv, 0, CSIZE)
                       mpreleg = labelcrv
                    endif
                    if(j == nj) then
                       if(mpreleg<>labelcrv) then
                          lpreleg = utgetcl(mpreleg)
                          call utcat(mpreleg,lpreleg,
                             mpreleg,lpreleg,
                             "-",1,labelcrv,utgetcl(labelcrv))
                          call smovftoa (preleg, (iplot-1)*CSIZE, mpreleg, 0, CSIZE)
                       endif
                    endif
                 endif
                 call smovatof (mstylec, 0, stylec, SSIZE*(iplot-1), SSIZE)
                 call ezcstyle(mstylec)
                 if(labelcrv <> " ") then
                    call ezcdshl(labelcrv,mod((njdone+j-1)*ezclbshft,4)) 
			#add label shifting to avoid labels piled up
                 endif
                 if (plttyp.eq.Arrow) then
                    call ezcdsha
                 endif
                 call ezcdshs
                 if (copyy & dflogstyle) then	#special treat for log plot
                    # break up the curve into segments based on algebraic signs
                    kpbegx = (j-1)*ixstr+1	#initialize the beginning index
                    kpbegy = (j-1)*iystr+1	#initialize the beginning index
                    kpendx = (j-1)*ixstr+1	#initialize the ending index
                    kpendy = (j-1)*iystr+1	#initialize the ending index
                    if (iystr > 0) then	#set the upper limit of index
                       kpsup = j*iystr
                    else
                       kpsup = n1(yi(iplot))
                    endif
                    while (kpbegy <= kpsup)	
                      kount = 0		#initialize the count of points
                      while (kpendy <= kpsup & ycopys(kpbegy) == ycopys(kpendy))
                         kpendy = kpendy + 1
                         kount = kount + 1
                      endwhile 
                      # set proper line style depends on algebraic sign
                      if (ycopys(kpbegy) < 0.) then
		         call ezcstyle("dotted")
                      else
		         call ezcstyle("solid")
                      endif
                      call ezcdshs
                      # draw the curve
                      if (kpendy < kpsup) then
                         call agcurv(x(kpbegx),1,y(kpbegy),1,kount+1,1)
                      else
                         call agcurv(x(kpbegx),1,y(kpbegy),1,kount,1)
                      endif
                      # move to next segment
                      kpbegy = kpendy
                      kpbegx = kpbegx + kount
                    endwhile
                 else
                     call agcurv(x(1+(j-1)*ixstr),1,y(1+(j-1)*iystr),1,
                        n1(yi(iplot)),1)
                 endif
              enddo
              # release the temp allocated memories for data copies
              if(copyx) call osfreen(Point(xcopy),"ezn.xcopy")
              if(copyx) call osfreen(Point(xcopys),"ezn.xcopys")
              if(copyy) call osfreen(Point(ycopy),"ezn.ycopy")
              if(copyy) call osfreen(Point(ycopys),"ezn.ycopys")
           else 
## Markers
# convert marker name to GKS marker number
              imark = ezcmarki(mmarkc)
              call setusv('MS',int(1000._Size4*marksc(iplot)))
	      #set marker color 
	      call gspmci(ezcrnbw(ccolor))
              do j = 1, nj
                 call points(x(1+(j-1)*ixstr),y(1+(j-1)*iystr),n1(yi(iplot)),
                   -imark,0)
              enddo
              call setusv('MS',int(1000._Size4*defmarks))
	      #restore the marker color
	      call gspmci(ezcctoi(defcolor))
           endif
        njdone = njdone+nj

        elseif (plttyp = Mesh) then
## MESH
           Point(y) = data(yi(iplot))
           Point(x) = data(xi(iplot))
           Point(reg) = data(iregi(iplot))
           Point(kpreg) = data(kpregi(iplot))
           Point(kllmt) = data(kllmti(iplot))
           Point(bndflag) = data(bndflagi(iplot))
           cthick = thickc(iplot)
	   ccolor = ezcctoi(mcolorc)
           klo = kllmt(1)
           khi = kllmt(2)
           kinc = kllmt(3)
           llo = kllmt(4)
           lhi = kllmt(5)
           linc = kllmt(6)
           ezckmax = kllmt(7)
	   ezclmax = kllmt(8)
	
	   khilmt = khi
	   lhilmt = lhi
	   if(khi<ezckmax) khilmt=khilmt+1
	   if(lhi<ezclmax) lhilmt=lhilmt+1
	   lpts=lhilmt-llo+1
	   kpts=khilmt-klo+1

	   # special case: a single point, the point passed screening already
	   if (klo==khi & llo==lhi) then
              imark = ezcmarki(mmarkc)
              call setusv('MS',int(1000._Size4*marksc(iplot)))
              #set marker color
              call gspmci(ccolor)
              call points(x(1),y(1),1,-imark,0)
              #restore the marker color, size
              call setusv('MS',int(1000._Size4*defmarks))
              call gspmci(ezcctoi(defcolor))
	   endif

	   #plot the k lines (color,style,etc can be specified here)
           call smovatof(mkstylec, 0, kstylec, SSIZE *(iplot-1), SSIZE)
	   if(mkstylec<>"none") then
              call smovatof (mkcolorc, 0, kcolorc, (iplot - 1) * CSIZE, CSIZE)
	      if ( mkcolorc <> defcolor ) then
	         ccolor = ezcctoi(mkcolorc)
              endif
              call ezcstyle(mkstylec)
              call ezcdshs
	      do k = klo,khi,kinc
	        ibeg = 0	#begin index
	        ilen = 0	#number of segements to plot
	        do l = llo,lhi
	      	  if(ezcsgkp(k,l,kpts,lpts,kllmt,bndflag,reg,kpreg,"kseg")) then
	            if (ibeg==0) then
		        ibeg=l
			ilen=1
		    else
			ilen=ilen+1
	            endif
	          else
	            if (ilen<>0) then
		       j=(ibeg-llo)*kpts+(k-klo+1)
	               # check for marker
		       if (mmarkc<>" ") then
	                  imark = ezcmarki(mmarkc)
		  	  call setusv('MS',int(1000._Size4*marksc(iplot)))                                #set marker color
                          call gspmci(ccolor)
			  call osallotn(Point(pxmesh),ilen+1,"EZCDISPL:pxmesh ")
			  call osallotn(Point(pymesh),ilen+1,"EZCDISPL:pymesh ")
                          do i = 1, ilen+1
		             pxmesh(i)=x(j+(i-1)*kpts)
		             pymesh(i)=y(j+(i-1)*kpts)
                          enddo
                          call points(pxmesh,pymesh,ilen+1,-imark,0)
                          call setusv('MS',int(1000._Size4*defmarks))
                          #restore the marker color
                          call gspmci(ezcctoi(defcolor))
			  #free the memory
		          call osfreen(Point(pxmesh),"ezn.pxmesh")
		          call osfreen(Point(pymesh),"ezn.pymesh")
		       else
                          call agcurv(x(j),kpts,y(j),kpts,ilen+1,1)
		       endif
		       ibeg=0
		       ilen=0
		    endif
	          endif
	        enddo
              enddo
	   endif
           #plot the l lines (color,style,etc can be specified here)
           call smovatof (mlstylec, 0, lstylec, (iplot - 1) * SSIZE, SSIZE)
           if(mlstylec<>"none") then
              call ezcstyle(mlstylec)
              ccolor = ezcctoi(mcolorc)
              call smovatof (mlcolorc, 0, lcolorc, (iplot - 1) * CSIZE, CSIZE)
	      if ( mlcolorc <> defcolor ) then
	         ccolor = ezcctoi(mlcolorc)
              endif
              call ezcdshs
              do l = llo,lhi,linc
                ibeg = 0  #begin index
                ilen = 0  #number of segements to plot
                do k = klo,khi
                  if(ezcsgkp(k,l,kpts,lpts,kllmt,bndflag,reg,kpreg,"lseg")) then
                    if (ibeg==0) then
                        ibeg=k
                        ilen=1
                    else
                        ilen=ilen+1
                    endif
                  else
                    if (ilen<>0) then
		       j=(ibeg-klo+1)+(l-llo)*kpts
		       # check for marker
                       if (mmarkc<>" ") then
                          imark = ezcmarki(mmarkc)
                          call setusv('MS',int(1000._Size4*marksc(iplot)))
                          #set marker color
                          call gspmci(ccolor)
                          call points(x(j),y(j),ilen+1,-imark,0)
                          call setusv('MS',int(1000._Size4*defmarks))
                          #restore the marker color
                          call gspmci(ezcctoi(defcolor))
                       else
                          call agcurv(x(j),1,y(j),1,ilen+1,1) 
                       endif
                       ibeg=0
                       ilen=0
                    endif
                  endif
                enddo
              enddo
	   endif

        elseif (plttyp = Ray) then
## RAYS
           cthick = thickc(iplot)
	   numcol = ibasis("ezd.numcol")	#number of color indices
           indbase = ibasis("ezd.indbase")	#base color index

	   Point(laslist) = data(lasi(iplot))
           Point(nray) = data(nrayi(iplot))
           Point(raylab) = data(raylabi(iplot))
           Point(dispmark) = data(dispmarki(iplot))
           Point(nraypt) = data(nraypti(iplot))
           Point(y) = data(yi(iplot))
           Point(x) = data(xi(iplot))
           Point(pw) = data(pwi(iplot))
           laserct = n1(lasi(iplot))
           rayct = n1(raylabi(iplot))
           rayptct = n1(pwi(iplot))		#total ray points count

           if (raypw) then	#ray color to show power
	      call osallotn(Point(rpwidx), rayptct,"EZCDISPL:rpwidx ")
	      call osallotn(Point(rpwmax), rayct,"EZCDISPL:rpwmax ")
              pltrayct = 0	#plot ray count; sum(mxp)
              rpwsum = 0.	#sum of max power 
              bptidx = 1
              do i = 1, rayct
                 ptct = nraypt(i)  # number of points in the ray; mxp(ilas)
                 if ( ptct > 0) then       # skip the ray with no points
                    pltrayct = pltrayct + 1  # number of rays plotted; sum(rypltf(ilas))
                   # Per JAH (4/2/99): Since ray power never increases as it 
                   # propagates, min and max power calculation is trivial.
                   # Correct indexing error per JAH. (FNF 2/28/2000)
                    pwmax = pw(bptidx)
                    pwmin = pw(bptidx+ptct-1)
                    rpwmax(i) = pwmax	#store the max power of the ray
                    rpwsum = rpwsum + rpwmax(i)	#total max power
                    if (mcolorc=="relpow") then
          	       #normalize pw over each ray
                       if (pwmin == pwmax) then
			  do k = 1,ptct
                             pw(bptidx+k-1) = 1.
                          enddo
		       else
                          do k = 1,ptct
			     pw(bptidx+k-1)=(pw(bptidx+k-1)-pwmin)/(pwmax-pwmin)
                          enddo
                       endif
                    endif
                    # reset bptidx for the next ray
                    bptidx = bptidx + ptct 
                 endif
              enddo  # End loop over rays.

             #--Changes requested by JAH 4/2/99:  (FNF 11/02/99)
             #--Corrected by JAH 3/3/2000:  (FNF 3/06/2000)
              #  Find pwmax and pwmin over ALL rays plotted.
              #  If color=relpow, they have been normalized so max=1,
              #  min=0; otherwise, must search array, again ...
              if (streq1f (colorc, (iplot -1) * CSIZE, CSIZE, "relpow",
                 0, 6) == 1) then
                 pwmax=1.
                 pwmin=0.
              else
                 #  starting values for search will be the values found
                 #  for tha last ray, processed above.
                 kk=0
                 do i=1,rayct
                   if(nraypt(i) > 0) then # skip the rays with no points plotted
                                          # this was the bug found 3/3/2000
                     kk = kk + 1
                     if(pwmax < pw(kk)) pwmax = pw(kk)
                     kk = kk + nraypt(i) - 1
                     if(pwmin > pw(kk)) pwmin = pw(kk)
                   endif
                 enddo
              endif
             #--End of JAH changes.

              ccolor = ezcctoi("fgcolor")
              rpwbar = rpwsum/pltrayct	#average max power

	      #convert to color idx linearly
              call ezclr4(numcol,rayptct,pw,rpwidx)
           else
	      ccolor = ezcctoi(mcolorc)
           endif

           bptidx = 1
           do i = 1, rayct
              # number of points in the ray
              ptct = nraypt(i)
              if ( ptct > 0) then	# skip the ray with no points
                 # set raylabel
                 if (ezcraylab == "on") then
                    idum = imkstr(raylab(i),raylabel)
                    call ezcdshl(raylabel(1:idum),mod((i-1)*ezclbshft,4))
                    call ezcdshs
                 endif
	         # mark the beginning point with marker
                 # Turned off per JAH to avoid ATC-GKS bug, 11/07/96 (FNF)
                 #call points(x(bptidx),y(bptidx),1,-4,0)
                 # plot the ray
                 if (raypw) then	#color the ray with power values
		    if (ezcthickray == "on") then	#thick ray option
                       cthick = int(rpwmax(i)/rpwbar + 1.5)
                    endif
                    do j = 1,ptct-1
                       ccolor = rpwidx(bptidx+j)+indbase-1
                       call agcurv(x(bptidx+j-1),1,y(bptidx+j-1),1,2,1)
                    enddo
                 else      
                    call agcurv(x(bptidx),1,y(bptidx),1,ptct,1)
                 endif
	         # add arrows to indicate the ray direction
                 if (raypw) ccolor = ezcctoi("fgcolor")  #for raypower arrows
                 call ezcarrow(x(bptidx),y(bptidx),ptct)
                 # reset bptidx for the next ray
                 bptidx = bptidx + ptct 
                 # plot dispmark if assigned (at the end of the ray)
                 if (dispmark(i) <> 0) then
                    call points(x(bptidx-1),y(bptidx-1),1,dispmark(i),0)
	         endif
              endif
           enddo
           if(raypw) call osfreen(Point(rpwidx),"ezn.rpwidx")
           if(raypw) call osfreen(Point(rpwmax),"ezn.rpwmax")

        elseif (plttyp == PolyFill) then
## POLYFILL
           Point(x) = data(xi(iplot))
           Point(y) = data(yi(iplot))
           npoly = n1(xi(iplot))
           npts = n2(xi(iplot))

#         Set up polygon fill style.
           call smovatof (mstylec, 0, stylec, 8*(iplot-1), 8)
           if (mstylec == "solid") then
              call gsfais(1)
           else
              call gsfais(0)
           endif

#         Determine the proper color index.
           call smovatof (mcolorc, 0, colorc, 16*(iplot-1), 16)
           pcolor = ezcctoi(mcolorc)
           if (pcolor < 0)  pcolor = ezcctoi("fgcolor")
           call gsfaci(pcolor)

#         Plot the polygons.
           do i = 1, npoly
              call gfa(npts, x((i-1)*npts+1), y((i-1)*npts+1) )
           enddo
	      
        elseif (plttyp == PolyFunc) then
## POLYFUNC
           Point(x) = data(xi(iplot))
           Point(y) = data(yi(iplot))
           npoly = n1(xi(iplot))
           npts = n2(xi(iplot))

           Point(ci) = data(zi(iplot))
           Point(zext) = data(zexti(iplot))
           zmin = zext(1)
           zmax = zext(2)
           zbar = zext(3)
           zsigma = zext(4)
           zmap = zext(5) + .5  ! Make sure we get correct integer.
#           Recover reverse color order used in ezcaddfm or ezcaddpf.
           rco = 0
           if (zmap > 3) then
              rco = 4
              zmap = zmap - 4
           endif

#         Set up polygon fill solid.
           call gsfais(1)

#         Plot the polygons, filled with colors from ci.
#           write (*,*) "Debug: PolyFunc has npoly =", npoly
           do i = 1, npoly
#              write (*,*) "Debug:  i, ci(i) =", i, ci(i)
#              Set the color.
              call gsfaci(ci(i))

              call gfa(npts, x((i-1)*npts+1), y((i-1)*npts+1) )
           enddo

        elseif (plttyp = CellArray) then
## CELLARRAY
           Point(icell) = data(zi(iplot))
           k = n1(zi(iplot))
           l = n2(zi(iplot))
           Point(x) = data(xi(iplot))
           Point(y) = data(yi(iplot))
           call ezccell(icell,k,l,x(1),x(2),y(1),y(2))
	      
        elseif (plttyp = FillMesh) then
## FILLMESH
	   # retained (x,y) are passed after screen out unwanted regions
           Point(y) = data(yi(iplot))
           Point(x) = data(xi(iplot))
           Point(zext) = data(zexti(iplot))
	   Point(ci) = data(zi(iplot))
           Point(reg) = data(iregi(iplot))
           Point(kpreg) = data(kpregi(iplot))
           Point(kllmt) = data(kllmti(iplot))
           klo = kllmt(1)
           khi = kllmt(2)
           kinc = kllmt(3)
           llo = kllmt(4)
           lhi = kllmt(5)
           linc = kllmt(6)
           ezckmax = kllmt(7)
           ezclmax = kllmt(8)
           zmin = zext(1)
           zmax = zext(2)
           zbar = zext(3)
	   zsigma = zext(4)
	   zmap = zext(5)
           zmap = zext(5) + .5  ! Make sure we get correct integer.
#           Recover reverse color order used in ezcaddfm or ezcaddpf.
           rco = 0
           if (zmap > 3) then
              rco = 4
              zmap = zmap - 4
           endif

           khilmt = khi
           lhilmt = lhi
           if(khi<ezckmax) khilmt=khilmt+1
           if(lhi<ezclmax) lhilmt=lhilmt+1
           lpts=lhilmt-llo+1
           kpts=khilmt-klo+1
           call gsfais(1)	# set up polygon fill solid

           # k and l lines have to form zones
           if (klo < khi & llo < lhi) then
              do k = klo,khi-1,kinc
              do l = llo,lhi-1,linc
		kl = k		#set left k line
		kr = k+1	#set right k line
		lb = l		#set bottom l line
		lt = l+1	#set top l line
                if(ezcsgkp(kl,lb,kpts,lpts,kllmt,0,reg,kpreg,"kseg") &
                   ezcsgkp(kr,lb,kpts,lpts,kllmt,0,reg,kpreg,"kseg") &
                   ezcsgkp(kl,lb,kpts,lpts,kllmt,0,reg,kpreg,"lseg") &
                   ezcsgkp(kl,lt,kpts,lpts,kllmt,0,reg,kpreg,"lseg")) then
	 	   # determine the proper color index
	           fmci = ci((kr-klo+1)+(lt-llo)*kpts)
		   call gsfaci(fmci)
		   # determine the vertices of the zone
                   polyx(1) = x((kl-klo+1)+(lb-llo)*kpts)
                   polyx(2) = x((kr-klo+1)+(lb-llo)*kpts)
                   polyx(3) = x((kr-klo+1)+(lt-llo)*kpts)
                   polyx(4) = x((kl-klo+1)+(lt-llo)*kpts)
                   polyy(1) = y((kl-klo+1)+(lb-llo)*kpts)
                   polyy(2) = y((kr-klo+1)+(lb-llo)*kpts)
                   polyy(3) = y((kr-klo+1)+(lt-llo)*kpts)
                   polyy(4) = y((kl-klo+1)+(lt-llo)*kpts)

		   call gfa(4,polyx,polyy)
		endif
	      enddo
	      enddo
		   
	   endif

	elseif (plttyp = OtherContour|plttyp = MeshContour) then
## CONTOURS
            Point(z) = data(zi(iplot))
            Point(x) = data(xi(iplot))
            Point(y) = data(yi(iplot))
            zlo = dminc(zi(iplot))
            zhi = dmaxc(zi(iplot))
            ezcctn = vxi(iplot)

# Set contour color
	    ccolor = ezcctoi(mcolorc)
	    # check for fill contour area
	    if ( ccolor <= -2) cfill = .true.	
	    if ( ccolor == -3) rcfill = .true.
	    if ( ccolor == -4) filml = .true.
	    if ( ccolor == -5) then
		rcfill = .true.
		filml = .true.
	    endif

# Select the contour levels
# NOTE::::::::::::::::::::
# Contour levels not really set here; have to wait until cprect/cppkcl called
# See ezcclu 
            if(labeli(iplot)>0) then
               call cpseti('CLS - contour level selection',0)
               call cpseti('NCL - number of contour levels',ezcctn)
               Point(levs) = data(labeli(iplot))
               do i=1, ezcctn
                  call cpseti('PAI - parameter array index',i)
                  call cpsetr('CLV - contour level',levs(i))
               enddo
            elseif(ezcctn < 0 & zlo < zhi & zlo > 0) then
#log levels requested
               ezcctn = - ezcctn
               call cpseti('CLS - contour level selection', 0)
               call cpseti('NCL - number of contour levels',ezcctn)
               zratio = log(zhi) - log(zlo)
               do i=1, ezcctn
                  call cpseti('PAI - parameter array index',i)
                  call cpsetr('CLV - contour level',
                    zlo * exp((real(i,Size4)/(ezcctn+1._Size4))* zratio))
               enddo
            else
               if (ezcctn < 0) then   # Must be constant or negative data.
                  ezcctn = -ezcctn
                  write(logmsg,'(a)') "Warning: log-spaced contour levels disallowed."
                  call ezcwrtlog(logmsg)
                  call ezcremrk(logmsg)
               endif
               call cpseti('CLS - contour level selection',ezcctn)
            endif
# Contour levels not set yet really; have to wait until cprect/cppkcl called
# See ezcclu 
            nx1 = n1(xi(iplot))
            nx2 = n2(xi(iplot))
            ny1 = n1(yi(iplot))
            ny2 = n2(yi(iplot))
            nz1 = n1(zi(iplot))
            nz2 = n2(zi(iplot))
            if(nz2>1 & nz1 = nx1 & nz2 = nx2 & nz1 = ny1 & nz2 = ny2 ) then
#             (nz2 = 1 case treated as random--F.N.Fritsch 6/4/96)
#rectangular
# z, x, and y are matrices of the same shape
               if (plttyp=MeshContour) then
                  maptype = 5
               else
                  maptype = 3
               endif

               if (ezcconpl(iplot,z,nz1,nz2,maptype,cfill,rcfill,filml) .ne.0) then
                  conerr = .true.
                  break
               endif

               if(mmarkc <> " ") then
                  imark = ezcmarki(mmarkc)
                  call setusv('MS',int(1000._Size4*marksc(iplot)))
                  call points(x,y,nz1*nz2,-imark,0)
                  call setusv('MS',int(1000._Size4*defmarks))
               endif
            elseif(nz2> 1 & nz1 = nx1 & nz2 = ny1 & nx2 = 1 & ny2 = 1) then
#matrix-vector-vector
# z is a matrix, x and y are vectors
               maptype = 4

               if (ezcconpl(iplot,z,nz1,nz2,maptype,cfill,rcfill,filml) .ne.0) then
                  conerr = .true.
                  break
               endif

               if(mmarkc <> " ") then
                  imark = ezcmarki(mmarkc)
                  call osallotn(Point(ymplot),nz1,"EZCDISPL:ymplot ")
                  call setusv('MS',int(1000._Size4*marksc(iplot)))
                  do i = 1, nz2  #for each y point, plot x vs.
                     do k = 1, nz1 #constant y vector of size length(x)
                        ymplot(k) = y(i)
                     enddo
                     call points(x,ymplot,nz1,-imark,0)
                  enddo
                  call osfreen(Point(ymplot),"ezn.ymplot")
                  call setusv('MS',int(1000._Size4*defmarks))
               endif
            elseif(nz1*nz2 = nx1*nx2 & nz1*nz2 = ny1*ny2) then
#random
# use multiquadric fit to fill a grid
# this grid should fit the data, not the frame -- pfd, 10/3/91
               if(vyi(iplot) = 0) then
                  call ezcremrk("Contour plot: internal error.")
                  break
               endif
               Point(tdata) = data(vyi(iplot))
               rsq = tdata(1)
               nzcplot = nz1*nz2
               call gallot("ezc.Random_Contour_Plots",0)
               aymin = dminc(yi(iplot))
               aymax = dmaxc(yi(iplot))
               axmin = dminc(xi(iplot))
               axmax = dmaxc(xi(iplot))
               dx = (axmax-axmin)/nxcplot
               dy = (aymax-aymin)/nycplot
               do i=1, nxcplot
                  xcplot(i) = axmin + (i-1)*dx
               enddo

               do i=1, nycplot
                  ycplot(i) = aymin + (i-1)*dy
               enddo
# Pick the rsqmqd parameter if the user didn't
               if(rsq <= 0._Size4) then
                  rsqmqd=4._Size4*(axmax-axmin)*(aymax-aymin)/nzcplot
               else
                  rsqmqd=rsq
               endif

               if(ezcmqd(nzcplot,x,y,z,rsqmqd,acplot) = ERR) then
                  call ezcremrk("plotz: error in mqdfit--duplicate x,y values?")
                  break
               endif

               call ezcmqdv(nzcplot,x,y,rsqmqd,acplot,
                  nxcplot,xcplot,nycplot,ycplot,zcplot)

               maptype = 4	#use matrix-vector-vector for mq(YHC)
#this connects through cpmpxy
               Point(x) = loc(xcplot)
               Point(y) = loc(ycplot)
               nx1 = nxcplot
               ny1 = nycplot

               if (ezcconpl(iplot,zcplot,nxcplot,nycplot,maptype,cfill,rcfill,filml) .ne.0) then
                  conerr = .true.
                  break
               endif

               if(mmarkc <> " ") then
#                Reset pointers to original data.
                  Point(x) = data(xi(iplot))
                  Point(y) = data(yi(iplot))
                  imark = ezcmarki(mmarkc)
                  call setusv('MS',int(1000._Size4*marksc(iplot)))
                  call points(x,y,nzcplot,-imark,0)
                  call setusv('MS',int(1000._Size4*defmarks))
               endif
               if(freemqd) call gfree("ezc.Random_Contour_Plots")
            else
               call ezcremrk("Contour plot data does not have an acceptable shape.")
               break
            endif

        elseif (plttyp == Vector) then
## VECTORS
           Point(x) = data(xi(iplot))
           Point(y) = data(yi(iplot))
           Point(vx) = data(vxi(iplot))
           Point(vy) = data(vyi(iplot))
           k = n1(yi(iplot))
           l = n2(yi(iplot))
           nx1 = k
           nx2 = l
           ny1 = k
           ny2 = l
           cthick = defthick  # Use default thickness for agchcu.
	   ccolor = ezcctoi(mcolorc)
           call agchcu(0,0)
           call getusv('XF',kxfncar)
# divert fx, fy to using ireg mapping
           dummy = ezcmap(TRUE)
# Set vector thickness via the vv parameter instead of agchcu:
           cthick = max(thickc(iplot), 1._Size4)
           call vvsetr('LWD', cthick)
           call velvct(vx,k,vy,k,k,l,0._Size4,0._Size4,
                     1,int(marksc(iplot)*2**kxfncar),1,NCARSPV)
           dummy = ezcmap(FALSE)
           call agchcu(1,0)

        elseif (plttyp == Text) then
## TEXT
           Point(x) = data(xi(iplot))
           Point(y) = data(yi(iplot))
           Point(tdata) = data(vxi(iplot))
           sdata = data(zi(iplot))
           n = tdata(1)
           call smovatof (msdata, 0, sdata, 0, n)
           k = tdata(2)
	   ccolor = ezcctoi(mcolorc)
	   call gsplci(ccolor)
           if(k>4) then
              k = k*(pquad(2)-pquad(1))*(pquad(4)-pquad(3))
              k = max(k,jminsz)
           endif
           call agpwrt(x,y,msdata(1:n),n,k,int(tdata(3)),int(tdata(4)))
	   ccolor = ezcctoi(defcolor)
	   if (ccolor <> -1) then
	      call gsplci(ccolor)
           else
	      call gsplci(1)
	   endif

        elseif (plttyp == Ftext) then
## Fr TEXT
           Point(x) = data(xi(iplot))
           Point(y) = data(yi(iplot))
           Point(tdata) = data(vxi(iplot))
           sdata = data(zi(iplot))
           n = tdata(1)
           call smovatof (msdata, 0, sdata, 0, n)
           k = tdata(2)
	   ccolor = ezcctoi(mcolorc)
	   call gsplci(ccolor)
           if(k>4) then
              k = k*(pquad(2)-pquad(1))*(pquad(4)-pquad(3))
              k = max(k,jminsz)
           endif
	   tmpx = cfux(x(1))
	   tmpy = cfuy(y(1))
	   call gsclip(0)
           call agpwrt(tmpx,tmpy,msdata(1:n),n,k,int(tdata(3)),int(tdata(4)))
	   call gsclip(1)
	   ccolor = ezcctoi(defcolor)
	   if (ccolor <> -1) then
	      call gsplci(ccolor)
           else
	      call gsplci(1)
	   endif
        endif  # end processing plttyp cases
       # reset the color fill flags for next list item
       # (Repositioned so filled color not "sticky".  FNF 1/07/97)
        cfill = .false.
        rcfill = .false.
        filml = .false.
      enddo iplot
      
#######################################################
## remember the set variables from fraction to user
#######################################################
	call getset(ezcfl,ezcfr,ezcfb,ezcft,ezcul,ezcur,ezcub,ezcut,ezcll)

#######################################################
## Titles
#######################################################
# left
        if(titlelf>0._Size4) then
          call set(
             quad(1),view(1),view(3),view(4),
             0._Size4,1._Size4,0._Size4,1._Size4,
             1)
          call ezcwtext(0.5_Size4,0.55_Size4,
             titlel(1:utgetcl(titlel)),.9_Size4, 1.0_Size4,
             90._Size4,0._Size4)
        endif
# right
        if(titlert>0._Size4) then
          call set(
            view(2),view(2)+titlert,view(3),view(4),
            0._Size4,1._Size4,0._Size4,1._Size4,
            1)
          call ezcwtext(0.5_Size4,0.55_Size4,
             titler(1:utgetcl(titler)),.9_Size4, 1.0_Size4,
             90._Size4,0._Size4)
        endif
# bottom
        if(titlebt>0._Size4) then
          call set(
             view(1),view(2),view(3)-titlebt,view(3),
             0._Size4,1._Size4,0._Size4,1._Size4,
             1)
          call ezcwtext(0.54_Size4,0.5_Size4,
             titleb(1:utgetcl(titleb)),1.0_Size4, .88_Size4,
             0._Size4,0._Size4)
        endif
# top
        if(titletp>0._Size4) then
          call set(
            view(1),view(2),view(4),view(4)+titletp,
                  0._Size4,1._Size4,0._Size4,1._Size4,
                  1)
          call ezcwtext(0.54_Size4,0.5_Size4,
             titlet(1:utgetcl(titlet)),1.0_Size4, .88_Size4,
             0._Size4,0._Size4)
        endif
# Write contour plot error message
        if(conerr) then
          call set(
            view(1),view(2),view(3),view(4),
                  0._Size4,1._Size4,0._Size4,1._Size4,
                  1)
          call ezcwtext(0.55_Size4,0.55_Size4,
             'Error in NCAR contour plot routine',
             1.0_Size4, .88_Size4,
             45._Size4,0._Size4)
        endif
# ezctitle
        if(suptitle>0._Size4) then
          if (ezcsuper) then
             call set(
                  view(1),view(2),quad(4)-suptitle,quad(4),
                  0._Size4,1._Size4,0._Size4,1._Size4,
                  1)
             call ezcwtext(0.54_Size4,0.5_Size4,
                ezctitle(1:utgetcl(ezctitle)),1.0_Size4, .88_Size4,
                0._Size4,0._Size4)
          else
             call set(
                  view(1),view(2),quad(3),quad(3)+suptitle,
                  0._Size4,1._Size4,0._Size4,1._Size4,
                  1)
             call ezcwtext(0.54_Size4,0.5_Size4,
                ezctitle(1:utgetcl(ezctitle)),1.0_Size4, .88_Size4,
                0._Size4,0._Size4)
          endif
        endif
# prevent high quality being used for the legend which almost certainly has
# characters plchhq will misinterpret
      call ezcitxqu(agsave)
      if(agsave==0) then
         call ezcstxqu(1)
      endif

#########################################################
## Initialize to avoid contour/color annotation conflict
#########################################################
      clrann = .false.        #initialize to no color annotation
      if (fmplot | pfplot) then          #fillmesh or polyfunc plot invoked
         if (zmap <> 3) then  #input is a array of physics quantities
            #write to the graphic display
            if (conkey > 0 & ezcfmkey == "on") clrann = .true. 
         endif
      endif
      if (raypw) then         #ray power plot invoked
         if (conkey > 0 & ezcpwkey == "on") clrann = .true.
      endif
      if (clrann) then
         numcol = ibasis("ezd.numcol")
         #list 16 colors evenly selected from the color spectrum
         jclrln = min(numcol,16)
         nclrln = 40  #set 40 lines of annotation as the size
         clradj = (jclrln+2)*(1._Size4/nclrln)
      else
         clradj = 0._Size4
      endif
#      write (*,*) 'Debug: clradj =', clradj
#########################################################
## Do the contour levels annotation 
#########################################################
      if (conplot) then
         #write to the log
         j = min(52,ezctctn)
            do i=1,j,5
               write(logmsg,80) (ezctcl(k),ezctctlev(k),k=i,min(i+4,j))
               call ezcwrtlog(logmsg)
            enddo
         if (j < ezctctn) then
            do i=j+1,ezctctn,5
               write(logmsg,80) (" ",ezctctlev(k),k=i,min(i+4,ezctctn))
               call ezcwrtlog(logmsg)
            enddo
         endif
         if(conerr) then  #write error message
            write(logmsg,'(a)') "**** A 'recoverable' NCAR error has occurred in EZCCONPL."
            call ezcwrtlog(logmsg)
            write(logmsg,'(a)') "     Too many filled contour levels?"
            call ezcwrtlog(logmsg)
         endif

         #write to the graphic display
         if(conkey > 0 & ezcconkey == "on") then
            call set(
                  quad(2)-conkey,quad(2),quad(3),quad(4),
                  0._Size4,1._Size4,0._Size4,1._Size4,
                  1)
# this makes sure it isn't too big for the type size
            mlines2 = (quad(4)-quad(3))*1024/(hw*jminsz)
            mlines = min(ezctctn,52,mlines2)
            if (mlines > 0) then
# make sure the lines don't spread out too much
               mlines1 = (quad(4)-quad(3))*nlines*0.75_Size4
               j = max(mlines1,mlines)
	       # set polygon vertices for label box
	       clbpx(1) = 0.0_Size4
	       clbpx(2) = 1.0_Size4
	       clbpx(3) = clbpx(2)
	       clbpx(4) = clbpx(1)
               call gsfais(1)	# set up polygon fill solid
               if (ezccksfill <> "solid") call gsfais(0)
               do k = 1, mlines
#                k is the index of the annotation box.
#                i is the index of the color and label in the box.
                  if (ezcconord == "incr" | ezcconord == "inc") then
                     i = k
                  else
                     i = mlines+1 - k
                  endif
	          clbpy(1) = 1._Size4-clradj-(k*(1._Size4/j))
	          clbpy(2) = clbpy(1)
	          clbpy(3) = clbpy(1)+(1._Size4/j)
	          clbpy(4) = clbpy(3)
	          #determine the color index
	          cfidx = ezctctci(i)
	          if (cfidx < 0) then	#conflict color assignement
	             call gsfais(0)	#use hollow fill to distingush it
	             cfidx = 1
	             call gsfaci(cfidx) 	
	             call gfa(4,clbpx,clbpy)
	             if (ezccksfill == "solid") call gsfais(1)	
						#set back to solid fill
                  else
	             if (cfidx > 1) then	#avoid use fgcolor for fill
	                call gsfaci(cfidx) 	#color index
	                call gfa(4,clbpx,clbpy)
                     endif
	          endif

	          #write the contour label
	          if (ezclabel == "off" | ezclabel == "on") then
                     write(msg(1),90) ezctctlev(i)
	          else
                     write(msg(1),80) ezctcl(i),ezctctlev(i)
	          endif
                  call ezcwtext(
                      0.0_Size4,
                      1._Size4-clradj-(k-0.5_Size4)*(1._Size4/j),
                      msg(1)(1:13),
                      1._Size4/j,
                      1.0_Size4,
                      0._Size4,
                     -1._Size4)
               enddo
	    endif
	 endif
90    format("  ",1Pe11.3)
80    format(5(a," ",1Pe11.3,"  "))

      endif

#########################################################
## Do the fillmesh or ray power annotation
#########################################################
#   (Code to initialize clrann moved before contour level
#    annotation 5/01/2000 -- FNF)
      #control of color annotation
      if (clrann) then
         call set(
              quad(2)-conkey,quad(2),quad(3),quad(4),
              0._Size4,1._Size4,0._Size4,1._Size4,
              1)
         #find base index and max index of color map
         indbase = ibasis("ezd.indbase")
         indmax = ibasis("ezd.indmax")
#       Initialization of jclrln, nclrln (formerly j, nn) moved before
#       contour annotation with clrann initialization -- (FNF 5/01/2000)
#         write (*,*) 'Debug: jclrln, nclrln =', jclrln, nclrln
         # set polygon vertices for label box
         clbpx(1) = 0.0_Size4
         clbpx(2) = 1.0_Size4
         clbpx(3) = clbpx(2)
         clbpx(4) = clbpx(1)
         call gsfais(1)   # set up polygon fill solid
#        Add switch for solid/hollow like for contour levels (FNF 5/22/97)
         if ( (fmplot & ezcfmfill<>"solid") |
              (pfplot & ezcfmfill<>"solid") |
              (raypw  & ezcpwfill<>"solid") ) call gsfais(0)
         do i=1, jclrln+1
            clbpy(1) = 1._Size4-(i*(1._Size4/nclrln))
            clbpy(2) = clbpy(1)
            clbpy(3) = clbpy(1)+(1._Size4/nclrln)
            clbpy(4) = clbpy(3)
            if (~raypw & rco>0) then  !Reverse color order
               k = jclrln+2 - i
            else  !Normal color order
               k = i
            endif
            #determine the color index
            cfidx = (k-1)*((indmax-indbase)/jclrln)+indbase
            call gsfaci(cfidx)      #color index
            call gfa(4,clbpx,clbpy)
         enddo
         call gsfais(0)

         call gsplci(1)
         if (fmplot | pfplot) then
            if (zmap==1) zrange = (log(zmax)-log(zmin))/jclrln
         endif
         do i=1, jclrln+1 
            if (raypw) then
               write(msg(1),90) pwmin+(i-1)*((pwmax-pwmin)/jclrln)
            else
               #write the fillmesh label
               if (zmap == 0) then
                  write(msg(1),90) zmin+(i-1)*((zmax-zmin)/jclrln)
               elseif (zmap == 1) then
#                 Changed to match corrected ezclr8ln (FNF 5/21/97)
	     	  write(msg(1),90) zmin * exp((i-1)*zrange)
               else
	          write(msg(1),90) zbar+ (((i-1)*numcol/jclrln)-numcol/2)*
						zsigma*4/numcol
               endif
            endif
            call ezcwtext(
                        0._Size4,
                        1._Size4-(i-0.5_Size4)*(1._Size4/nclrln),
                        msg(1)(1:13),
                        1._Size4/nclrln,
                        1._Size4,
                        0._Size4,
                       -1._Size4)
         enddo
      endif

#########################################################
## Do the legend
#########################################################
      if (xdivider > 0._Size4 & leginfoa <>0) then
# Decide how many lines max for the legend
         mlines1=nlines*xdivider
# Second estimate
         mlines2 = xdivider*1024/(hw*jminsz)
# Take the smaller
         mlines = min(mlines1, mlines2)
         if(ezcsuper) then
            call set(quad(1),
		  quad(2)-conkey,
		  quad(3),
		  quad(3)+xdivider,
                  0._Size4,1._Size4,0._Size4,1._Size4,
                  1)
         else
            call set(quad(1),
                  quad(2)-conkey,
                  quad(3)+suptitle,
                  quad(3)+suptitle+xdivider,
                  0._Size4,1._Size4,0._Size4,1._Size4,
                  1)
	 endif
         lastc = -2
         ileg = 0
         do iplot = 1 , nc
            call smovatof (mlegendc, 0, legendc, LSIZE*(iplot-1), LSIZE)
            call smovatof (mpreleg, 0, preleg, CSIZE*(iplot-1), CSIZE)
            if (mlegendc<>" ") then
               jleg=mod(ileg,mlines)+1
               ileg = ileg + 1
               if(jleg==1) then
                  lastcc= lastc+3
                  if(lastcc > LSIZE-10) break
               endif
               if(mpreleg <> " ") then
                  msg(jleg)(lastcc:LSIZE) =
                 mpreleg(1:utgetcl(mpreleg))//": "//mlegendc
               else
                  msg(jleg)(lastcc:LSIZE) = mlegendc
               endif
               lastc = max(utgetcl(msg(jleg)),lastc)
            endif
         enddo iplot
         ileg = min(mlines,ileg)
# plot all lines with the same length for uniformity
# prevent overly large or spread-out legends
         mlines1 = nlines*xdivider*0.75_Size4
         j = max(ileg,mlines1)
         do i=1, ileg
              call ezcwtext(
                  0.0_Size4,
                  1._Size4-(i-0.5_Size4)*(1._Size4/j),
                  msg(i)(1:lastc),
                  1._Size4/j,
                  1.0_Size4,
                  0._Size4,
                 -1._Size4)
         enddo
      endif  #if xdivider > 0.
      call ezcstxqu(agsave)
      call sflush	#Flush the GKS pen-move buffer.
      call ezcsetxn
#set the transformation to the quadrant
#in case following text or Fortran to be added
9000  continue

      call set(
               pquad(1),pquad(2),pquad(3),pquad(4),
               0._Size4,1._Size4,0._Size4,1._Size4,
               1)
      yucked = FALSE
      return
      end

      integer function ezcmarki(marktype)
Use(Ezcurve)
      character*(*) marktype
      integer j
      do j = 1, NMARKERS
         if(marktype=markers(j)) return(j)
      enddo
      return(1)
      end

      subroutine agchcu(iflg,kdsh)
      integer iflg, kdsh
      real(Size4) dthick
Use(Curve_Internal)
Use(EzcurveDefaults)

      integer cidx

      integer ezcctoi
      external ezcctoi

      integer ezcrnbw
      external ezcrnbw

      if(iflg == 0) then
        if(cthick<=1._Size4) cthick = 1._Size4
        call setusv('LW',int(1000._Size4*cthick))
        # set color index for the polyline
        cidx = ezcrnbw(ccolor)
	call gsplci(cidx)
	call gspmci(cidx)
      else
        dthick = defthick
        if(dthick<=1._Size4) dthick = 1._Size4
        call setusv('LW',int(1000._Size4*dthick))
        # restore the color index to the default value
        cidx = ezcctoi(defcolor)
        if (cidx <> -1) then
	   call gsplci(cidx)
	   call gspmci(cidx)
	   call gstxci(cidx)
        else
           call gsplci(1)
           call gspmci(1)
           call gstxci(1)
	endif
      endif
      return
      end
