c==============================================================================
c
c  ezcfmcnml
c
c  Purpose: Convert an array of real8's into an array of indices into a
c     colormap using a normal mapping with user supplied zmin and zmax.
c
c  Arguments:
c     ncol  Number of colors in colormap.
c     n     Number of elements in array z.  (CAUTION: Assumes n>1.)
c     z     The array to be mapped.
c     ndx   The output array of color indices, in range [1,ncol].
c     zlim  Input array containing limits: zlim(1)=zmin, zlim(2)=zmax.
c
c  Routines called: ezcmp8nml.
c
c  Created: Yu-Hsing Chiu, 940819
c
c  Revision History:
c     - Minor change to parallel ezclr8nml.  (FNF 961230)
c     - Changed "call remark" statement to "call ezcremrk".  (FNF 970813)
c     - Added code to handle special case all data equal.
c       Also made some cosmetic changes.  (FNF 000420)
c     - Modified to call new ezcmp8nml to do color mapping, which elimi-
c       nates duplicate coding.  (FNF 000426)
c
c==============================================================================

      subroutine ezcfmcnml (ncol, n, z, ndx, zlim)

c Declare arguments.
      integer        ncol, n, ndx(n)
      real(Size8)    z(n), zlim(2)

c Declare local variables.
      real(Size8)    zz(5)  #For auxiliary output from ezcmp8nml

c Do the color mapping.
      call ezcmp8nml (ncol, n, z, ndx, zz, zlim)

      return
      end
 
         
