#     Minimum and maximum array computations for EZN.
#
#########################################################################
#
# Function eznmax returns the maximum value in a 1-D array and its index.
# Function eznmin returns the minimum value in a 1-D array and its index.
# Subroutine eznminmx computes both the minimum and maximum values in a
#    1-D array and returns their indices.
#
# Change record:
#  4/26/2000  Added eznminmx. (F.N.Fritsch)
#
#########################################################################

### eznmax
      real(Size8) function eznmax(v,low,high,stride,jx)
      integer low,high,stride,jx
      real(Size8) v(high)
      integer i
      real(Size8) result

      jx = low
      result = v(low)
      do  100 i=low+stride,high,stride
         if(v(i).gt.result) then
	    result = v(i)
	    jx = i
	 endif
100   continue
      eznmax = result
      return
      end

### eznmin
      real(Size8) function eznmin(v,low,high,stride,jx)
      integer low,high,stride,jx
      real(Size8) v(high)
      integer i
      real(Size8) result

      jx = low
      result = v(low)
      do  100 i=low+stride,high,stride
         if(v(i).lt.result) then
	    result = v(i)
	    jx = i
	 endif
100   continue
      eznmin = result
      return
      end

### eznminmx
      subroutine eznminmx(v,low,high,stride,vmin,vmax,jmin,jmax)
      integer low,high,stride,jmin,jmax
      real(Size8) v(high), vmin, vmax
      integer i

      jmin = low
      jmax = low
      vmin = v(low)
      vmax = v(low)
      do  100 i=low+stride,high,stride
         if(v(i).lt.vmin) then
	    vmin = v(i)
	    jmin = i
         else if(v(i).gt.vmax) then
	    vmax = v(i)
	    jmax = i
	 endif
100   continue

      return
      end
