      subroutine ezcfz(rpin,zpin,n,kout,lout,rt,zt,ireg,kmax,lmax)
# what zone holds rp(j), zp(j), j = 1, n ? 
# returned in kout(j),lout(j), j= 1, n; ( 0 0 if not in mesh)

      integer n, ipoint
      integer kmax,lmax, kout(n), lout(n)
      integer ireg(kmax,lmax)
      real(Size8) rt(kmax,lmax),zt(kmax,lmax),rp,zp, rpin(n), zpin(n)
      real(Size8) bigreal, smalreal
      parameter(bigreal=1.e200, smalreal = 1.e-200)
      integer kalm, kalmw, utsizstr, k,l,jz
      real(Size8) xa,ya,del,zsup
      Dynamic(angk,real(Size8),[kmax,lmax])
      Dynamic(angl,real(Size8),[kmax,lmax])
      Dynamic(zang,real(Size8),[kmax,lmax])
      real(Size8) eznmax, eznmin
      external utsizstr, eznmax, eznmin

      kalm = kmax*lmax
      kalmw = utsizstr(kalm,Quote(real(Size8)))
      call osallotn(Point(angk),kalmw,"EZCFZ:angk ")
      call osallotn(Point(angl),kalmw,"EZCFZ:angl ")
      call osallotn(Point(zang),kalmw,"EZCFZ:zang ")
      do ipoint = 1, n
         rp = rpin(ipoint)
         zp = zpin(ipoint)

         do k=2,kmax
            do l=1,lmax
               ya=(rt(k-1,l)-rp)*(zt(k,l)-zp)-
                  (rt(k,l)-rp)*(zt(k-1,l)-zp)
               xa=(rt(k-1,l)-rp)*(rt(k,l)-rp)+
                  (zt(k-1,l)-zp)*(zt(k,l)-zp)
               if(xa < 0.0_Size8) then
                  del = sign(Pi,ya)
               else
                  del = 0.0_Size8
               endif
               if(xa == 0.0_Size8) then
                  angk(k,l) = sign(Pi/2.0_Size8,ya)
               else
                  angk(k,l) = atan(ya/xa)+del
               endif
            enddo
         enddo
         do k=1,kmax
            do l=2,lmax
               ya=(rt(k,l-1)-rp)*(zt(k,l)-zp)-
                  (rt(k,l)-rp)*(zt(k,l-1)-zp)
               xa=(rt(k,l-1)-rp)*(rt(k,l)-rp)+
                  (zt(k,l-1)-zp)*(zt(k,l)-zp)
               if(xa < 0.0_Size8) then
                  del = sign(Pi,ya)
               else
                  del = 0.0_Size8
               endif
               if(xa == 0.0_Size8) then
                  angl(k,l) = sign(Pi/2.0_Size8,ya)
               else
                  angl(k,l) = atan(ya/xa)+del
               endif
            enddo
         enddo
         do k = 1, kmax
            zang(k,1) = -bigreal
         enddo
         do l = 1, lmax
            zang(1,l) = -bigreal
         enddo
         do  k=2,kmax
            do l=2,lmax
               if(ireg(k,l) <> 0) then
                  zang(k,l)=(-angk(k,l-1)-angl(k,l)+angk(k,l)+angl(k-1,l))
               else
                  zang(k,l) = -bigreal
               endif
            enddo
         enddo
         zsup=eznmax(zang,1,kalm,1,jz)
         if(abs(zsup-2.0*Pi).lt.1.e-6)then
            l=1+(jz-1)/kmax
            k=jz-(l-1)*kmax
            kout(ipoint) = k
            lout(ipoint) = l
         elseif(abs(zsup).gt.1.e-6)then
c....       mesh point
            do k = 1, kmax
               do l = 1, lmax
                  zang(k,l)=(rt(k,l)-rp)**2+(zt(k,l)-zp)**2
               enddo
            enddo
            zsup=eznmin(zang,1,kalm,1,jz)
            l=1+(jz-1)/kmax
            k=jz-(l-1)*kmax
            kout(ipoint) = max(k,2)
            lout(ipoint) = max(l,2)
	 else
	    kout(ipoint) = 0
	    lout(ipoint) = 0
         endif
      enddo ipoint
      call osfreen(Point(angk),"ezn.angk")
      call osfreen(Point(angl),"ezn.angl")
      call osfreen(Point(zang),"ezn.zang")
      return
      end


