
      function ezcmqd(n, x, y, z, rsq, alpha)
      integer i, info, j, n, ezcmqd
      real(Size4) x(n),y(n),z(n),alpha(n),rsq
# (FNF 7/31/97) Turned on error message controlled by ezcdebug.
# (FNF 8/13/97) Changed "call remark" statement to "call ezcremrk".
# (FNF 6/07/2001) Removed special code for BASIS_MAJOR_VERSION=9.
Use(Ezcurve)
      character*80 errmsg

      Dynamic(aa,real(Size4),[n,n])
      Dynamic(ipvt,integer,n)
# allocate space for matrix and workspaces
      call osallotn(Point(aa), n*n,"EZCNMQD:aa ")
      call osallotn(Point(ipvt), n,"EZCNMQD:iput ")
#
# ... Calculate coefficients of Hardy's multiquadric fit.
#     The scattered data is represented by the Cartesian coordinates
#     x(i) and y(i) at which the data values are z(i), i=1,2,...,n.
#     rsq is an input parameter, based on x and y, and
#     alpha is the coefficient array.
#
# ... Set up the real, symmetric matrix that is used in solving for alpha.
        do j=2,n
                do i=1,j-1
                        aa(i,j)=sqrt((x(i)-x(j))**2+(y(i)-y(j))**2+rsq)
                        aa(j,i)=aa(i,j)
                enddo i
        enddo j
#
        do i=1,n
                aa(i,i)=sqrt(rsq)
                alpha(i) = z(i)
        enddo
#
# ... Solve the system of simultaneous linear equations for alpha.
	call sgesv(n,1,aa,n,ipvt,alpha,n,info)

        call osfreen(Point(aa),"ezn.aa")
        call osfreen(Point(ipvt),"ezn.iput")
#
# ... Report a failure if it occurred.
        if (info <> 0) then
           if (ezcdebug) then
                write (errmsg,100) "ezcmqd: sgefa returned info=",info
                call ezcremrk(errmsg)
  100           format(a,i3)
           endif
                return(ERR)
        endif
#
      return(OK)
      end
 
        subroutine ezcmqdv(n, x, y, rsq, alpha, mx, xp, my, yp, f)
        integer i, j, k, n, mx, my
        real(Size4) x(n), y(n), rsq, alpha(n)
        real(Size4) xp(mx), yp(my), f(mx,my)
        real(Size4) sum
# ... Evaluate a multiquadric interpolating function defined
#     by n data points [x(i),y(i)], rsq, and n coefficients alpha(i)
#     at mx*my points [xp(j),yp(j)], and return the values in f(i,j).
#
        do i = 1, mx
                do j = 1, my
                        sum = 0._Size4
                        do k = 1,n
                                sum = sum+alpha(k)*
                                sqrt((x(k)-xp(i))**2+(y(k)-yp(j))**2+rsq)
                        enddo k
                        f(i,j) = sum
                enddo j
        enddo i
#
        return
        end

