c==============================================================================
c
c   ezcscm
c
c   purpose: create and initialize a colormap to all active
c       workstations.
c
c   created: bert still 930405
c
c   revision history:
c      o name changed from setcmap, 931101 [chs]
c      o Modified print statements, 970723 [FNF]
c      o Changed "call remark" statements to "call ezcremrk", 970813 [FNF]
c
c==============================================================================

c234567
      subroutine ezcscm(idepth)
c
      integer idepth
c
ifelse(SYSTEM,UNICOS,[
      real(Size4)    ONE, ZERO
      parameter (ZERO=1.e-06)
      parameter (ONE=1. - ZERO)
])
c
      real(Size4)  red(256), green(256), blue(256)
      integer      i, idepth2, istat, ezccoltb
      character*80 msg

c create the colormap
      idepth2 = idepth/2
      do i=1, idepth2
         red(i) = i * 1.0 / idepth
         blue(i) = 1.0 - red(i)
         green(i) = i * 1.0 / idepth2
      enddo
      do i=idepth2+1, idepth
         red(i) = i * 1.0 / idepth
         blue(i) = 1.0 - red(i)
         green(i) = 1.0 - (i-idepth2) * 1.0 / (idepth-idepth2)
      enddo

ifelse(SYSTEM,UNICOS,[
      if (ibasis("ezd.debcolr") <> 0) 
         call ezcremrk("In EZCSCMAP before calling set color table:")
      do i=1,idepth
         if (red(i) > ONE) then
            red(i) = ONE
         else if (red(i) < ZERO) then
            red(i) = ZERO
         endif

         if (green(i) > ONE) then
            green(i) = ONE
         else if (red(i) < ZERO) then
            green(i) = ZERO
         endif

         if (blue(i) > ONE) then
            blue(i) = ONE
         else if (red(i) < ZERO) then
            blue(i) = ZERO
         endif
         if (ibasis("ezd.debcolr") <> 0) then
            write(msg,7000) i, red(i), green(i), blue(i)
 7000       format(" rgb(",i3,") = ",f10.8, " / ",f10.8, " f/",f10.8)
            call ezcremrk(msg)
         endif
      enddo
])

c  check to see that a graphics device exists and fire up a new frame
      call pltstart

c download the colormap to all workstations using
c   EZCCOLTB(ilo, ihi, red, green, blue)
      istat=ezccoltb(1, idepth, red, green, blue)

c print error message if warranted
      if (istat .ne. 0) then
         write(msg,'(a,i8)') 'Colormap not loaded.  Status is ', istat
         call ezcerror(msg,0)
      endif

      return
      end
