      subroutine ezcseta(nargs,nargs1,lflag)
# (ZCM 8/16/1999) Remove ss and sp as arguments
Use(Collections)
Use(Default_attributes)
Use(Keywords)
Use(Ezcurve)
Use(EzcurveDefaults)
      # ----------------------------------------------------------------------
      #  Function Name:    ezcseta
      #  Author:	     Janet Takemoto (06 November 1989)
      #  Description:	     Sets an attribute for the frame.
      # ----------------------------------------------------------------------
      # Change record:
      #19yymmdd:
      #  961017  Made "filled" a synonym for "fill". (FNF)
      #  970327  Deleted reduntant copy of "thick" and "vsc" tests. (FNF)
      #  970428  Commented out code associated with unused attributes
      #          "zcenter" and "zfactor". (FNF)
      #  970813  Changed "call remark" statements to "call ezcremrk". (FNF)
      #  990108  Added attribute "zlim" to handle user-supplied limits for
      #          plotf.
      #20yymmdd:
      #  010628  Added new cscale values "rlin", "rlog", "rnormal". (FNF)
      #  010720  Completed implementing above. (FNF)
      #  010724  Corrected long-standing error in cscale coding. (FNF)

      integer iarg, nargs, nargs1, lflag,
         sy(SS_WIDTH),sl(SS_WIDTH), i, nregion, nlabela
      character*72 valuein
      character*72 tmpcolora
      logical doframe
      Address  paraddr
      external paraddr
      integer  parname, parcoerc, parlen, utsizeof
      external parname, parcoerc, parlen, utsizeof
      integer rrange(3)
      integer ibasis
      external ibasis
      Dynamic(y,real(Size4),1)
      Dynamic(dy,real(Size8),2)
      Dynamic(iy,integer,1)
      Address lbl, labeld
      Dynamic(levlist,real(Size4),1)
#
      doframe=FALSE
      if(lflag = LOCAL) call ezcsda
      do iarg = nargs1+1,nargs-1,2
         key = symbols(iarg)
         valuein = symbols(iarg+1)
         if (key  = "grid") then
            if (valuein="xy") then
               gridxa = "on";               gridya = "on"
            elseif (valuein="x") then
               gridxa = "on";               gridya = "off"
            elseif (valuein="y") then
               gridxa = "off";               gridya = "on"
            elseif (valuein="no" | valuein="tickonly") then
               gridxa = "off";               gridya = "off"
            endif
            doframe=TRUE
         elseif (key = "scale") then
            if(valuein == "linlin" |
               valuein == "linlog" |
               valuein == "loglin" |
               valuein == "loglog" |
               valuein == "equal" ) then
               scalea = valuein
            else
               call ezcargs(iarg+1,scalea)
               if(scalea <> "linlin" &
                  scalea <> "linlog" &
                  scalea <> "loglin" &
                  scalea <> "loglog" &
                  scalea <> "equal" ) then
                  call ezcremrk(scalea)
                  call ezcremrk("is not a valid value for scale.")
                  scalea = "linlin"
               endif
            endif
            doframe=TRUE
         elseif( key = "cscale") then
            if(valuein == "lin" |
               valuein == "rlin" |
               valuein == "log" |
               valuein == "rlog" |
               valuein == "normal" |
               valuein == "rnormal") then
               cscalea = valuein
            else
	       call ezcargs(iarg+1,cscalea)
               if(cscalea <> "lin" &
                  cscalea <> "rlin" &
                  cscalea <> "log" &
                  cscalea <> "rlog" &
                  cscalea <> "normal" &
                  cscalea <> "rnormal" ) then
                  call ezcremrk(cscalea)
	          call ezcremrk("is not a valid value for cscale; using lin.")
                  cscalea = "lin"
               endif
            endif
         elseif( key = "color") then
            if (valuein == "relpow" 		|
                valuein == "power" 		|
                valuein == "rfillnl" 		|
                valuein == "fillnl"  		|
                valuein == "rfill"  		|
                valuein == "fill"  		|   #Old name for "filled"
                valuein == "filled"  		|
                valuein == "rainbow"  		|
                valuein == "bgcolor"  		|
                valuein == "fgcolor"  		|
                valuein == "red"  		|
                valuein == "green"  		|
                valuein == "blue"  		|
                valuein == "cyan"  		|
                valuein == "magenta"  		|
                valuein == "yellow"  		|
                valuein == "coral"  		|
                valuein == "yellowgreen"  	|
                valuein == "springgreen"  	|
                valuein == "slateblue"  	|
                valuein == "skyblue"  		|
                valuein == "orangered" 		| 
                valuein == "gray33"  		|
                valuein == "lavender"  		|
                valuein == "orchid"  		|
                valuein == "gray70") then  
                colora = valuein
            else
                call ezcargs(iarg+1,colora)
                if (colora <> "relpow"             &
                    colora <> "power"              &
                    colora <> "rfillnl"            &
                    colora <> "fillnl"             &
                    colora <> "rfill"              &
                    colora <> "fill"               &   #Old name for "filled"
                    colora <> "filled"             &
                    colora <> "rainbow"            &
                    colora <> "bgcolor"            &
                    colora <> "fgcolor"            &
                    colora <> "red"                &
                    colora <> "green"              &
                    colora <> "blue"               &
                    colora <> "cyan"               &
                    colora <> "magenta"            &
                    colora <> "yellow"             &
                    colora <> "coral"              &
                    colora <> "yellowgreen"        &
                    colora <> "springgreen"        &
                    colora <> "slateblue"          &
                    colora <> "skyblue"            &
                    colora <> "orangered"          &
                    colora <> "gray33"             &
                    colora <> "lavender"           &
                    colora <> "orchid"             &
                    colora <> "gray70") then
                    call ezcremrk(colora)
                    call ezcremrk("is not a valid color name")
                    colora = "fgcolor"
                endif
            endif
            #Make "fill" a synonym for "filled" -- FNF 10/17/96
            if (colora == "fill") colora = "filled"

         elseif( key == "kcolor" | key == "lcolor") then
            if (valuein == "rainbow"  		|
                valuein == "bgcolor"  		|
                valuein == "fgcolor"  		|
                valuein == "red"  		|
                valuein == "green"  		|
                valuein == "blue"  		|
                valuein == "cyan"  		|
                valuein == "magenta"  		|
                valuein == "yellow"  		|
                valuein == "coral"  		|
                valuein == "yellowgreen"  	|
                valuein == "springgreen"  	|
                valuein == "slateblue"  	|
                valuein == "skyblue"  		|
                valuein == "orangered" 		| 
                valuein == "gray33"  		|
                valuein == "lavender"  		|
                valuein == "orchid"  		|
                valuein == "gray70") then  
                if ( key == "kcolor" ) then
                   kcolora = valuein
                else
                   lcolora = valuein
                endif
            else
                call ezcargs(iarg+1,tmpcolora)
                if ( key == "kcolor" ) then
                   kcolora = tmpcolora
                else
                   lcolora = tmpcolora
	        endif
                if (tmpcolora <> "rainbow"            &
                    tmpcolora <> "bgcolor"            &
                    tmpcolora <> "fgcolor"            &
                    tmpcolora <> "red"                &
                    tmpcolora <> "green"              &
                    tmpcolora <> "blue"               &
                    tmpcolora <> "cyan"               &
                    tmpcolora <> "magenta"            &
                    tmpcolora <> "yellow"             &
                    tmpcolora <> "coral"              &
                    tmpcolora <> "yellowgreen"        &
                    tmpcolora <> "springgreen"        &
                    tmpcolora <> "slateblue"          &
                    tmpcolora <> "skyblue"            &
                    tmpcolora <> "orangered"          &
                    tmpcolora <> "gray33"             &
                    tmpcolora <> "lavender"           &
                    tmpcolora <> "orchid"             &
                    tmpcolora <> "gray70") then
                    call ezcremrk(tmpcolora)
                    call ezcremrk("is not a valid color name")
                    if ( key == "kcolor" ) then
                       kcolora = "fgcolor"
                    else
                       lcolora = "fgcolor"
                    endif
                endif

            endif
         elseif (key="thick") then
            call ezcargr(iarg+1,thicka)
         elseif (key="vsc") then
            call ezcargr(iarg+1,vscalea)
         elseif (key="krange") then
            call ezcargx(iarg+1,krangea)
         elseif (key="lrange") then
            call ezcargx(iarg+1,lrangea)
         elseif (key="bnd") then
            call ezcargi(iarg+1,bnda)
         elseif (key="region") then
            if(valuein = "all") then
               do i=1,MAXREG
                  excludea(i)=FALSE
               enddo
            else
               call fcnarga(iarg+1,sy)
               if(sy(SS_TC)=typex) then
                  call ezcargx(iarg+1,rrange)
                  if(rrange(1)==DEFAULT) rrange(1) = 1
                  if(rrange(2)==DEFAULT) rrange(1) = MAXREG
                  if(rrange(3)==DEFAULT) rrange(1) = 1
                  rrange(1)=max(1,rrange(1))
                  rrange(2)=min(MAXREG,rrange(2))
                  rrange(3)=max(1,rrange(3))
                  do i = 1, MAXREG
                     excludea(i) = TRUE
                  enddo
                  do i = rrange(1), rrange(2), rrange(3)
                     excludea(i) = FALSE
                  enddo
               elseif(parcoerc(sy,typeint) == ERR) then
                  call ezcremrk('region list unacceptable, ignored')
               else
                  nregion = parlen(sy)
                  if(nregion == 0) then
                     call ezcremrk('region list unacceptable, ignored.')
                  else
                     Point(iy) = paraddr(sy)
                     do i = 1, MAXREG
                        excludea(i) = TRUE
                     enddo
                     do i = 1, nregion
                        if(iy(i) < 1 | iy(i) > MAXREG) next
                        excludea(iy(i)) = FALSE
                     enddo
                  endif
               endif
               call parkill(sy) # ZCM 11/14/95
            endif
         elseif (key="lev") then
            if(valuein == "log") then
               nlevela = -abs(deflev)
               levela = 0
            elseif(valuein == "linear") then
               nlevela = abs(deflev)
               levela = 0
            else
               call fcnarga(iarg+1,sy)
               if( parlen(sy) == 1 & sy(SS_TC) = typeint) then
                  Point(iy) = paraddr(sy)
                  nlevela =  iy(1)
                  levela = 0
               else
                  if(parcoerc(sy,type4) == ERR) then
                     call ezcremrk('Contour levels unacceptable, ignored.')
                     nlevela = deflev
                     levela = 0
                  else
                     nlevela = parlen(sy)
                     if(nlevela > 0) then
                        call osallotn(Point(levlist),utsizeof(nlevela,type4),
				      "EZCSETA:levlist ")
                        Point(y) = paraddr(sy)
                        do i=1, nlevela
                           levlist(i) = y(i)
                        enddo
                        call ezcsdata(Point(levlist),nlevela,1,levela,FALSE)
                     else
                        call ezcremrk("Empty contour level list given, ignored.")
                        levela = 0
                        nlevela=deflev
                     endif
                  endif
               endif
               call parkill(sy) # ZCM 11/14/95
            endif
         elseif (key="kstyle") then
            kstylea = valuein
         elseif (key="lstyle") then
            lstylea = valuein
         elseif (key="style") then
            stylea = valuein
         elseif (key="labels") then
            if(valuein="yes") then
               labelsa = YES
               doframe=TRUE
            elseif(valuein="no") then
               labelsa = NO
               doframe=TRUE
            else
               call fcnarga(iarg+1,sl)
               call pardim(sl)
               nlabela = parlen(sl)
               if(nlabela == 0) then
                  call ezcremrk('Labels unacceptable, ignored.')
                  go to 900
               endif
               if(parcoerc(sl,-CSIZE) == ERR) then
                  call ezcremrk('Labels unacceptable, ignored.')
                  go to 900
               else
                  call osallotn(labeld,utsizeof(nlabela,-CSIZE),"EZCSETA:labeld ")
                  lbl = paraddr(sl)
                  call smovatoa (labeld, 0, lbl, 0, nlabela*CSIZE)
                  call ezcsdata(labeld,nlabela,1,labela,FALSE)
               endif
               call parkill(sl) # ZCM 11/14/95
            endif
         elseif (key="font") then
            if(index(valuein,"bold_") == 1) then
               fonta = valuein(6:)
            else
               fonta = valuein
            endif
         elseif (key="arrow") then
            if(valuein = "yes") then
               arrowa = YES
            else
               arrowa = NO
            endif
         elseif (key="mark") then
            if(valuein == " ") then
               marka = " "
            else
               do i=1, NMARKERS
                  if(valuein == markers(i)) then
                     marka = valuein
                     break
                  endif
               enddo
               if(i > NMARKERS) marka="cross"
            endif
         elseif (key="marksize") then
            call ezcargr(iarg+1,marksa)
         elseif (key="rsquared") then
            call ezcargr(iarg+1,rsqa)
         elseif (key="legend") then
            if(valuein == "yes") then
               leginfoa = YES
               doframe=TRUE
            elseif(valuein == "no") then
               leginfoa = NO
               doframe=TRUE
            else
               call ezcargs(iarg+1,legenda)
            endif
         elseif (key="point") then
            call ezcargi(iarg+1,centera)
         elseif (key="zlim") then
            call fcnarga(iarg+1,sy)
            if( parcoerc(sy,type8) == ERR ) then
               call ezcremrk('z-limits unacceptable, ignored.')
               nzlima = 0
            else if( parlen(sy) <> 2 ) then
               call ezcremrk('Illegal number of z-limits, ignored.')
               nzlima = 0
            else
               nzlima = 2
               Point(dy) = paraddr(sy)
#               Make sure zmin<zmax.
               if ( dy(1) > dy(2) ) then
                  zlimin(1) = dy(2)
                  zlimin(2) = dy(1)
               else
                  zlimin(1) = dy(1)
                  zlimin(2) = dy(2)
               endif
            endif
            call parkill(sy)
         else
            call ezcremrk ("attr: <"//key//"> is an invalid keyword, ignored")
         endif
  900    continue
         call parkilla (iarg)
         call parkilla (iarg + 1)
      enddo
      if(iarg <=nargs) then
         call ezcremrk("dangling keyword ignored.")
      endif
      if(doframe) then
         pending=TRUE
         call ezcshowf
      endif
      return
      end
