	subroutine ezczoom

# (FNF  8/13/97) Changed "call remark" statements to "call ezcremrk".
# (FNF 12/18/97) Added test for lastprobe too large.
# (FNF 03/17/1999) Modified to inform user of multiple open windows.
# (FNF 03/26/1999) Modified to flush any events on window before probing.
# (FNF 03/31/1999) Corrected logic error in limit tests.
Use(Ezcurve)
Use(Probe)

	real(Size4) zxmin,zxmax,zymin,zymax,zxtmp,zytmp
	real(Size4) px,py,upx,upy
	integer qflag, stat
	character*80 framecall

        integer ezcgetcl
        external ezcgetcl

        integer wson         # Number of active windows
        integer wsid         # ID of active window
        character*16 wsname  # Name of active window
        character*32 wsdisp  # Display of active window
        character*80 errmsg

        call ezdckwin (wson, wsid, wsname, wsdisp)
        if (wson < 1) then
           call ezcerror('No currently active windows.',0)
           return
        endif
#        Flush any old events on this window.
        call ezdflwin (wsid, stat)
        if (stat > 0) then
           write (errmsg,'(A,I2,A,I5,A)') 'ezdflwin returned stat=',
              stat, '.  wsid =', wsid, ' bad??'
           call ezcremrk(errmsg)
           return
        endif

        if (wson > 1) then
           write (errmsg,'(A,I3,A)') 'Warning:', wson,
              ' windows are currently active.'
           call ezcremrk(errmsg)
           write (errmsg,'(4A)') 'Will accept clicks only on window ',
              wsname(1:ezcgetcl(wsname)), ' on display ',
              wsdisp(1:ezcgetcl(wsdisp))
           call ezcremrk(errmsg)
        endif

	qflag = 0

        call ezcremrk("Click on 2 opposing corners of zoom region")

	call ezdprobe(px,py,upx,upy,qflag)
	if (qflag == 0) then
	   zxmin = upx
	   zymin = upy
	else
	   return
	endif

	call ezdprobe(px,py,upx,upy,qflag)
	if (qflag == 0) then
	   zxmax = upx
	   zymax = upy
	else
	   return
	endif

	if (zxmax == zxmin) then
	   call ezcremrk("X limits for zooming collided")
	   return
	elseif (zymax == zymin) then
           call ezcremrk("Y limits for zooming collided")
	   return
        else
#         Make sure that limits are properly ordered.
           if (zxmax < zxmin) then
              zxtmp = zxmax
              zxmax = zxmin
              zxmin = zxtmp
           endif
           if (zymax < zymin) then
              zytmp = zymax
              zymax = zymin
              zymin = zytmp
           endif
        endif

# call frame command with zxmin,zxmax,zymin,zymax
# need to use call parsestr command
	write(framecall,110) zxmin,zxmax,zymin,zymax
110	format('frame ',4(e12.5,' '))
	call parsestr(framecall)

        call set(ezcfl,ezcfr,ezcfb,ezcft,zxmin,zxmax,zymin,zymax,ezcll)

# increment probe command counter
        lastprobe=lastprobe+1
        if (ezcdebug) then
           call ezcremrk('ezczoom: framecall = '//framecall)
           write (framecall,'(A,I3)') 'ezczoom: lastprobe = ',lastprobe
           call ezcremrk(framecall)
        endif

        if (lastprobe > ezcprsave) then
           write (framecall,120) ezcprsave
  120      format('Value of lastprobe exceeds ',i2,'.  Cannot unzoom.')
           call ezcremrk(framecall)
           lastprobe = ezcprsave
        else
#         Save returned values for possible undo commands.
           savezcfl(lastprobe)=ezcfl
           savezcfr(lastprobe)=ezcfr
           savezcfb(lastprobe)=ezcfb
           savezcft(lastprobe)=ezcft
           savezcul(lastprobe)=ezcul
           savezcur(lastprobe)=ezcur
           savezcub(lastprobe)=ezcub
           savezcut(lastprobe)=ezcut
           savezcll(lastprobe)=ezcll
        endif

	call getset(ezcfl,ezcfr,ezcfb,ezcft,ezcul,ezcur,ezcub,ezcut,ezcll)

	return
	end
