c=======================================================================
c
c  isoload: load the data, possibly thinned, into the plot arrays
c
c  Notes:
c   o array t(inx,iny,inz) is the original data
c   o array tnew(nx,ny,nz) is the copy
c
c  Created:   Bert Still [chs], 950503
c  Revision history:
c     Modified srfload() to work for isosurfaces, 950503 [chs]
c     Corrected thinning algorithm, 970428 (FNF)
c
c=======================================================================
      subroutine isoload(t, inx, iny, inz, tnew, nx, ny, nz)

Use(Isosurface_Plot)
Use(Iso_Internal_Parms)

      INTEGER        inx, iny, inz, nx, ny, nz
      real(Size4)    t(inx,iny,inz)
      real(Size4)    tnew(nx,ny,nz)
      INTEGER        i, j, k, itmp, jtmp, ktmp

C     Define function to map thinned indices to original ones.
C       fract is the fraction of thinned interval range.
      integer  mapit, norig
      real fract
      mapit(fract,norig) = max(0, min(int(fract*norig), norig) )
C       Note that the -1,+1 in usage are so end values map OK.

c  load the data
      do k=1, nz
         ktmp = mapit( (k-1+1.e-6)/(nz-1), inz-1) + 1
         do j=1, ny
            jtmp = mapit( (j-1+1.e-6)/(ny-1), iny-1) + 1
            do i=1, nx
               itmp = mapit( (i-1+1.e-6)/(nx-1), inx-1) + 1
               tnew(i,j,k) = t(itmp,jtmp,ktmp)
            enddo
         enddo
      enddo

      return
      end

