

srf
# package for surface plotting


usertype real4
usertype real8
{
%define real4 real(Size4)
%define _real4 real4
%define real8 real(Size8)
%define _real8 real8

}


**** Srf3D :
srfplot(x:real4, y:real4, z:real4, nx:integer, ny:integer,
            view:real4) subroutine
       # 3-D surface plotting routine, an easy-use version
       #    (assumes z_ij=fcn(i,j))

**** Internal_Srf /INSRF/ hidden:
srfl2u(starr:string) subroutine
       # converts lowercase to uppercase
srfload(x:real4, y:real4, z:real4, inx:integer, iny:integer, xnew:real4, 
            ynew:real4, znew:real4, nx:integer, ny:integer) subroutine
       # load data, possibly thinned, into plot arys
srfscal(x:real4, y:real4, z:real4, nx:integer, ny:integer, low:real4,
            high:real4) integer function
       # scale the data and return the extrema
srfvpt(view:real4, ixflip:integer, iyflip:integer, ixswap:integer,
            iyswap:integer) subroutine
       # get label posns according to viewpoint

***Srf_Internal_Parms /EZCSRF/ :
srfscr(1)  _real4           # scratch array for SRFACE
srfmaxsz   integer /80/     # maximum size for titles
srfspmin   real4 /1.0e-6/    # minimum spread allowed in data values
srfxplot(1) _real4          # scrub array: x values to be plotted
srfyplot(1) _real4          # scrub array: y values to be plotted
srfzplot(1) _real4          # scrub array: z values to be plotted

***Surface_Plot:
srfxlo     real4 /1.0/      # maximum and minimum X values for scaling
srfxhi     real4 /0.0/
srfylo     real4 /1.0/      # maximum and minimum Y values for scaling
srfyhi     real4 /0.0/
srfzlo     real4 /1.0/      # maximum and minimum Z values for scaling
srfzhi     real4 /0.0/
srftitle   character*80     # major title for surface plots
srfxtle    character*80     # X-Axis title for surface plots
srfytle    character*80     # Y-Axis title for surface plots
srfztle    character*80     # Z-Axis title for surface plots
srftopln   integer /1/      # (boolean) put legend on the topline
srfxn      integer /1/      # (boolean) call ezcsetxn within showsrf
srflabel   integer /1/      # (boolean) label the axes with the titles
srfautoscal integer /1/     # (boolean) perform automatic scaling
srfnpx     integer /100/    # number of points to display in X-direction
srfnpy     integer /100/    # number of points to display in Y-direction
srfiskrt   integer /0/      # (boolean) plot skirt? (Default: no)
srfhskrt   real4 /0.1/      # skirt height, if srfskrt=1.

***NCAR_Surface_Int / SRFIP1/ hidden:
# put common block stuff here.
#     the strange names were taken from the NCARG 3.2 source code
#     and an "_N" appended to avoid naming conflicts...
IFR_N      integer          # call frame? -1=before, 0=no, +1=after
ISTP_N     integer          # stereo? -1=alternating, 0=blank, +1=same frame
IROTS_N    integer          # rotate? 0=+Z in vert, +1=+Z in horiz
IDRX_N     integer          # +1=Draw lines of const X, 0=Don't
IDRY_N     integer          # +1=Draw lines of const Y, 0=Don't
IDRZ_N     integer          # +1=Draw contours in Z, 0=Don't
IUPPR_N    integer          # +1=Upper side of srf only, -1=Lower, 0=Both
ISKRT_N    integer          # +1=Draw skirt around srf, 0=Don't
NCLA_N     integer          # Nbr levels of const Z drawn (dflt=6, max=40)
THETA_N    real4            # Angle in rads b/w eyes for stereo (dflt=0.02)
HSKRT_N    real4            # Height of skirt if ISKIRT=1
CHI_N      real4            # Highest level of const Z
CLO_N      real4            # Lowest level of const Z
CINC_N     real4            # Increment b/w levels
ISPVL_N    integer          # Special value marking missing data if IOFFP=1


# end of the file
