c=======================================================================
c
c  srfload: load the data, possibly thinned, into the plot arrays
c
c  Notes:
c   o arrays x(inx), y(iny), and z(inx,iny) are the original data
c   o arrays xnew(nx), ynew(ny), and znew(nx,ny) are the copies
c
c  Created:   Bert Still [chs], 930519
c  Revision history:
c     Extracted from showsrf() to simplify that routine, 930519 [chs]
c     Corrected thinning algorithm, 970428 (FNF)
c
c=======================================================================
      subroutine srfload(x, y, z, inx, iny, xnew, ynew, znew, nx, ny)

Use(Surface_Plot)
Use(Srf_Internal_Parms)

      INTEGER        inx, iny, nx, ny, i, j
      real(Size4)    x(inx), y(iny), z(inx,iny)
      real(Size4)    xnew(nx), ynew(ny), znew(nx,ny)
      INTEGER        itmp, jtmp

C     Define function to map thinned indices to original ones.
C       fract is the fraction of thinned interval range.
      integer  mapit, norig
      real fract
      mapit(fract,norig) = max(0, min(int(fract*norig), norig) )
C       Note that the -1,+1 in usage are so end values map OK.

c  load the data
      do i=1, nx
         itmp = mapit( (i-1+1.e-6)/(nx-1), inx-1) + 1
         xnew(i) = x(itmp)
         do j=1, ny
            jtmp = mapit( (j-1+1.e-6)/(ny-1), iny-1) + 1
            ynew(j) = y(jtmp)
            znew(i,j) = z(itmp,jtmp)
         enddo
      enddo

      return
      end
