c   subroutine / function  dffti
c
c
*deck dffti
      subroutine dffti(n,wsave)
c***begin prologue  dffti
c***date written   790601   (yymmdd)
c***revision date  861211   (yymmdd)
c***category no.  j1a1
c***keywords  library=slatec,type=double precision(dffti-s cffti-c),
c             fourier transform
c***author  swarztrauber, p. n., (ncar)
c***purpose  initialize for dfftf and dfftb.
c***description
c
c  subroutine dffti initializes the array wsave which is used in
c  both dfftf and dfftb.  the prime factorization of n together with
c  a tabulation of the trigonometric functions are computed and
c  stored in wsave.
c
c  input parameter
c
c  n       the length of the sequence to be transformed.
c
c  output parameter
c
c  wsave   a work array which must be dimensioned at least 2*n+15.
c          the same work array can be used for both dfftf and dfftb
c          as long as n remains unchanged.  different wsave arrays
c          are required for different values of n.  the contents of
c          wsave must not be changed between calls of dfftf or dfftb.
c***references  (none)
c***routines called  rffti1
c***end prologue  dffti
      implicit double precision(a-h,o-z)
      double precision wsave(*)
c***first executable statement  dffti
      if (n .eq. 1) return
      call dffti1 (n,wsave(n+1),wsave(2*n+1))
      return
      end
*deck rffti1
      subroutine dffti1(n,wa,ifac)
c***begin prologue  rffti1
c***refer to  dffti
c***routines called  (none)
c***end prologue  rffti1
      implicit double precision(a-h,o-z)
      double precision wa(*)
      integer   ifac(*)    ,ntryh(4)
      save ntryh
      data ntryh(1),ntryh(2),ntryh(3),ntryh(4)/4,2,3,5/
c***first executable statement  rffti1
      nl = n
      nf = 0
      j = 0
  101 j = j+1
      if (j-4) 102,102,103
  102 ntry = ntryh(j)
      go to 104
  103 ntry = ntry+2
  104 nq = nl/ntry
      nr = nl-ntry*nq
      if (nr) 101,105,101
  105 nf = nf+1
      ifac(nf+2) = ntry
      nl = nq
      if (ntry .ne. 2) go to 107
      if (nf .eq. 1) go to 107
      do 106 i=2,nf
         ib = nf-i+2
         ifac(ib+2) = ifac(ib+1)
  106 continue
      ifac(3) = 2
  107 if (nl .ne. 1) go to 104
      ifac(1) = n
      ifac(2) = nf
      tpi = 6.28318530717959
      argh = tpi/float(n)
      is = 0
      nfm1 = nf-1
      l1 = 1
      if (nfm1 .eq. 0) return
      do 110 k1=1,nfm1
         ip = ifac(k1+2)
         ld = 0
         l2 = l1*ip
         ido = n/l2
         ipm = ip-1
         do 109 j=1,ipm
            ld = ld+l1
            i = is
            argld = float(ld)*argh
            fi = 0.
            do 108 ii=3,ido,2
               i = i+2
               fi = fi+1.
               arg = fi*argld
               wa(i-1) = cos(arg)
               wa(i) = sin(arg)
  108       continue
            is = is+ido
  109    continue
         l1 = l2
  110 continue
      return
      end
