#ifndef FFT_H
#define FFT_H

#include "Fcc.h"
#include <string.h>

/* macros */
#define SS_N 1
#define SS_TC 2
#define SS_M1 13
#define ERR -1
#define OK 0
#define SS_N1 6
#define SS_WIDTH 26
#define INTEGER 1
#define REAL 2
#define DOUBLE 3
#define COMPLEX 4
#define DOUBLE_C 5

/* Externals */
extern void Fcnargb (Integer, Integer *);
extern Integer Parlen (Integer *);
extern Address Paraddr (Integer *);
extern void Parrel (Integer * s);
extern void Parget (Integer * s);

/* FORTRAN prototypes */
#if defined(CRAY2) || defined(XMP) || defined(YMP) || defined(C90) || defined(J90)
#   undef WORKSTATION
#   define BasError BasErrCray
#   define Rffti RFFTI
#   define Dffti DFFTI
#   define Cffti CFFTI
#   define Rfftf RFFTF
#   define Dfftf DFFTF
#   define Cfftf CFFTF
#   define Rfftb RFFTB
#   define Dfftb DFFTB
#   define Cfftb CFFTB
#   define Parint PARINT
#   define Parcoerc PARCOERC
#elif defined(SUN4) || defined(SOL) || defined(SGI) || defined(CS2) || defined(AXP) || defined(LINUX) || defined(IRIX64)
#   define WORKSTATION
#   define BasError baserror_
#   define Rffti rffti_
#   define Dffti dffti_
#   define Cffti cffti_
#   define Rfftf rfftf_
#   define Dfftf dfftf_
#   define Cfftf cfftf_
#   define Rfftb rfftb_
#   define Dfftb dfftb_
#   define Cfftb cfftb_
#   define Parint parint_
#   define Parcoerc parcoerc_
#else
#   define WORKSTATION
#   define BasError baserror
#   define Rffti rffti
#   define Dffti dffti
#   define Cffti cffti
#   define Rfftf rfftf
#   define Dfftf dfftf
#   define Cfftf cfftf
#   define Rfftb rfftb
#   define Dfftb dfftb
#   define Cfftb cfftb
#   define Parint parint
#   define Parcoerc parcoerc
#endif

extern void BasError PROTO((const char *, const Integer));
extern void Rffti PROTO((const Integer *, float *));
extern void Dffti PROTO((const Integer *, real8 *));
extern void Cffti PROTO((const Integer *, float *));
extern void Rfftf PROTO((const Integer *, float *, float *));
extern void Dfftf PROTO((const Integer *, real8 *, real8 *));
extern void Cfftf PROTO((const Integer *, float *, float *));
extern void Rfftb PROTO((const Integer *, float *, float *));
extern void Dfftb PROTO((const Integer *, real8 *, real8 *));
extern void Cfftb PROTO((const Integer *, float *, float *));
extern Integer Parint PROTO((Integer *, Integer *));
extern Integer Parcoerc PROTO ((Integer *, Integer *));
#endif
