/*
 * fit.h
 */

#ifndef FIT_H
#define FIT_H

#include "fit_.h"
#include <string.h>

/* Macros */
#define SS_WIDTH 26
#define SS_N 1
#define SS_TC 2
#define SS_PTR 3
#define SS_N1 6
#define SS_M1 13
#define SS_I1 20
#define INTEGER 1
#define REAL 2
#define DOUBLE 3
#define RANGE 7
#define OK 0
#define ERR -1
#undef max
#define max(x,y) ( (x) < (y) ? (y) : (x))
#if ! defined (NOTSET)
#  if defined (SGI)
#       define NOTSET 0
#  else
#       define NOTSET -8192
#  endif
#endif
#define DEFAULT -999999

/* externs */
extern void Fcnargb (Integer, Integer *);
extern Integer Parlen (Integer *);
extern Address Paraddr (Integer *);
extern void Parget (Integer *);
extern void Parkill (Integer *);
extern Integer Ivecmin (Integer * iarray, Integer ifirst, Integer ilast);
extern Integer Ivecmax (Integer * iarray, Integer ifirst, Integer ilast);
extern Integer Partempc (Address fwa);

/* FORTRAN prototypes */
#if defined(CRAY2) || defined(XMP) || defined(YMP) || defined(C90) || defined(J90)
#   undef WORKSTATION
#   define BasError BasErrCray
#else
#   define WORKSTATION
#   define BasError FF_ID(baserror, BASERROR)
#endif

#define Parcoerc FF_ID(parcoerc, PARCOERC)
#define Gallot   FF_ID(gallot,   GALLOT)
#define Gfree    FF_ID(gfree,    GFREE)
#define Sgels    FF_ID(sgels,    SGELS)
#define Dgels    FF_ID(dgels,    DGELS)
#define Parcopy  FF_ID(parcopy,  PARCOPY)

extern void BasError(const char *, const Integer);
extern Integer Parcoerc(Integer *, Integer *);
extern Integer Gallot(char *, Integer *, Integer);
extern Integer Gfree(char *, Integer);
extern void Sgels(char *, Integer *, Integer *, Integer *, real8 *,
   Integer *, real8 *, Integer *, real8 *, Integer *, Integer *, Integer);
extern void Dgels(char *, Integer *, Integer *, Integer *, real8 *,
   Integer *, real8 *, Integer *, real8 *, Integer *, Integer *, Integer);
extern void Parcopy(Integer *, Integer *);

#endif
