/*
 * hst.h
 */

#include "Fcc.h"
#include "hst_.h"
#include <string.h>
#include <stdio.h>
#include <stdarg.h>

/*--------------------------------------------------------------------------*/

/*                           DEFINED CONSTANTS                              */

/*--------------------------------------------------------------------------*/

#define DEFAULT -999999
#if defined(GENERIC) || defined(HPUX) || defined(HP700)
#   define STDERR 7
#elif defined (NLTSS)
#   define STDERR 6
#else
#   define STDERR 0
#endif
#if ! defined (NOTSET)
#  if defined (SGI)
#       define NOTSET 0
#  else
#       define NOTSET -8192
#  endif
#endif
#define OK 0
#define ERR -1

/*--------------------------------------------------------------------------*/

/*                          FUNCTION DECLARATIONS                           */

/*--------------------------------------------------------------------------*/

extern Integer Utgetcl (char * name);
extern Integer Crtaddim (char * name);
extern Integer StrGetCl (Address str, Integer offset, Integer length);
extern void Baslt10 (void);
extern Integer Gmemtr (void);

/* FORTRAN prototypes */
#if defined(CRAY2) || defined(XMP) || defined(YMP) || defined(C90) || defined(J90)
#   define Hstgti HSTGTI
#   define Hstgtv HSTGTV
#   define Hstdcond HSTDCOND
#   define Hsttnum HSTTNUM
#   define Baswline BASWLINE
#   define Gchange GCHANGE
#   define Hstmcn HSTMCN
#   define Parsestr PARSESTR
#   define Hstfind HSTFIND
#   define Hsterr HSTERR
#   define Remark REMARK
#elif defined(SUN4) || defined(SOL) || defined(SGI) || defined(CS2) || defined(AXP) || defined(LINUX) || defined(IRIX64)
#   define Hstgti hstgti_
#   define Hstgtv hstgtv_
#   define Hstdcond hstdcond_
#   define Baswline baswline_
#   define Hsttnum hsttnum_
#   define Gchange gchange_
#   define Hstmcn hstmcn_
#   define Parsestr parsestr_
#   define Hstfind hstfind_
#   define Hsterr hsterr_
#   define Remark remark_
#else
#   define Hstgti hstgti
#   define Hstgtv hstgtv
#   define Hstdcond hstdcond
#   define Baswline baswline
#   define Hsttnum hsttnum
#   define Gchange gchange
#   define Hstmcn hstmcn
#   define Parsestr parsestr
#   define Hstfind hstfind
#   define Hsterr hsterr
#   define Remark remark
#endif

extern Integer Hstgti (Integer *icond, Integer *ivin, Integer *iv);
extern Integer Hstgtv (Integer *icond, real8 *ivin, real8 *iv);
extern void Hstdcond (Integer *icond);
extern Integer Hsttnum (char *tag, Integer ltag);
extern void Baswline (Integer *unit, char *msg, Integer lmsg);
extern void Gchange (char *gname, Integer *sig, Integer lgname);
extern void Hstmcn (Integer *itag, Integer *icond);
extern void Parsestr (char *str, Integer lstr);
extern void Hstfind (char *name, Address *fwa, Integer *itype,
   Integer *ndim, Integer *ilow, Integer *ihi, Integer *icol,
   Integer lname);
extern void Hsterr (char *caller, char *msg, char *tag, Integer lcaller,
   Integer lmsg, Integer ltag);
extern void Remark (const char *str, const Integer lstr);
