hst
{
MAXTAGS = 20
MAXOPTS = 20
MAXITEMS = 100
MAXITEMSIZE=72
MAXOPTSSIZE=176
MAXCOND = 20
BLANK     = " "
CYCLESPEC = 1   #values for tagmode
CYCLELIST = 2
VALUESPEC = -1
VALUELIST = -2

NEGINF = -1  
POSINF = 1000000
RPOSINF = 1.e10
RNEGINF = -RPOSINF
NMSG = 176          ## value must be divisible by 8

%define([HistoryGroups],[
%Use(Tag_Data)
%Use(Nondumpable_Tag_Data)
%Use(Condition_Data)
%Use(Items_Data)
%Use(Controls_History)
%Use(Internal_History)
%])
}
**** Tag_Data dump language "C": # data about history tags, indexed by tag number.
numtags integer /0/ #Number of history tags.
mumtags integer /0/  #Storage for tags.
tagname(mumtags) _Varname limited(numtags) 
   #Name of a history tag.
tagcond(mumtags) _integer limited(numtags)
   # Index to conditions for the tag.
   # 0 if tag inactive.
tagfile(mumtags) _Filename limited(numtags) 
   # Name of file containing histories: blank means memory.
tagclc(mumtags) _integer limited(numtags) 
   #Cycle at which tag was last collected.
tagrec(mumtags) _integer limited(numtags)
   #Number of generations of this tag that have been collected.
taglogic(mumtags) _character*80 limited(numtags)
   # Logical condition on the tag.
tagact(mumtags) _character*500 limited(numtags)
   # Expression to execute before collecting, if any.
tagccn(mumtags) _Varname limited(numtags)
   # Name of the cycle counter for this tag.
tagivn(mumtags) _Varname limited(numtags)
   # Name of the independent variable for this tag, if any.
taglog logical 
   # Result of last evaluation of a taglogic component.

***** Nondumpable_Tag_Data language "C":
# things that need to be reset after a restart
hstvptr(mumtags) _Address limited(numtags) 
   # Pointer to independent variable, set by hsttag.
hstcptr(mumtags) _Address limited(numtags) 
   # Pointer to cycle-counter, set by hsttag.
tagdoub(mumtags) _logical limited(numtags) 
   # True if independent variable is double precision.
tagrecrn(mumtags) _integer limited(numtags)
   #Number of times collected since the beginning of this run.
tagcall(mumtags) _Varname limited(numtags)
   # Name of collection routine; blank if this is non-existant or outdated.

********* Condition_Data dump language "C":
# data about when to collect things
mumcond   integer /0/  #storage for number of conditions
hstvalue(mumcond) _real 
   # Value at which to collect next generation (if in value mode).
hstcyc(mumcond) _integer 
   # Cycle at which to collect next generation (if in cycle mode).
hstcond(mumcond) _Varname 
   # Name of the variable in which condition data is stored.
hstnext(mumcond) _integer /-1/
   # Index of next condition for this tag.
hstmode(mumcond) _integer
   # Mode of this condition.

**** Items_Data  dump language "C": # items indexed by item number.
hstbad integer /0/
   # Number of bad items requested; must be 0 to call hstory.
numitems integer /0/
   #Number of items.
mumitems integer /0/
   #Storage for items.
hstitms(mumitems) limited(numitems) _character*(MAXITEMSIZE)
   # Text of items.
hstname(mumitems) limited(numitems) _Varname 
   #Name of history array.
hstown(mumitems) limited(numitems) _integer 
   #Tag number of owning tag.
hstvol(mumitems) limited(numitems) _integer
   #True if this is a "volatile" item.
hststatc(mumitems) limited(numitems) _integer
   # =1 if static (file header) item, else
   # =0 regular item (or file rec item).

**** Controls_History  dump language "C": #controls user can set
hstcycle Varname /"ncycle"/ # Name of cycle-counter for new tag.
hsttime Varname /"time"/ # Name of independent variable for new tag.
hstfile Filename /" "/ # Base name of file in which to store tag.
  #If blank use second arg of newtag command as filename;
  #otherwise, append second arg to this name.
hstdebug integer /0/ #Debug flag.

**** Internal_History hidden:  
hstisvol integer /0/
   # flag used for volatile items
   $type codes, initialized in hstinit
imareal8 integer
imarng
imadble
imanint

**** Modules_History: #routines in the history package
hstall subroutine
   # Check and collect history for all tags.
hstalll subroutine
   # Collect history for all tags ignoring collection times
   # (but not logical condition).
   # Usually used for "last" sample.
hstallc subroutine
   # Check all items by attempting to evaluate them.
hstallp(;unit:integer) subroutine
   # Print the status of all active tags to unit (default stderr).
hstallpi(;unit:integer) subroutine
   # Print the status of all (active or inactive) tags to unit
   # (default stderr).
hstory(tag:string) subroutine
   # Check and collect specific tag.
hstoryl(tag:string) subroutine
   # Collect history for tag ignoring collection times 
   # (but not logical condition).
   # Usually used for "last" sample.
hstoryc(tag:string) subroutine
   # Check all items belonging to tag by attempting to evaluate them.
hstitem(tag:string,text:string,static:integer) subroutine
   # Create a new item in tag.
hstcheck(tagnum:integer) logical function
   # Is it time to collect tag whose index is tagnum?
hsttnum(tag:string) integer function
   # Return the index of tag or 0 if not found.
hsttnumc(caller:string,tag:string) integer function
   # Return the index of tag or die if not found;
   # caller used in error msg.
hstscyc(s:string) subroutine
   # Set name of cycle counter.
hststime(s:string) subroutine
   # Set name of independent variable (time).
hstslog(tag:string,condition:string) subroutine
   # Set the logical condition for tag to condition.
hstsact(tag:string;f:string) subroutine
   # Set the name of the function to execute before collecting this tag.
hstslstn(tag:string,cyclelst:integer,nlist) subroutine
   # Set the condition for tag to a list of nlst cycles, cyclelst.
hstslstv(tag:string,timelist:real,ntime) subroutine
   # Set the condition for tag to a list of ntime real values, timelist.
hstsssin(tag:string,istart,istop,inc) subroutine
   # Set the condition for tag to a start-stop-increment on cycles.
hstsssiv(tag:string,vstart:real,vstop:real,vinc:real) subroutine
   # Set the condition for tag to a start-stop-increment on values.
hstgti(itag,ivin,iv) integer function
   # Set iv=the least integer in the itag list greater than ivin and
   # return OK; return ERR if no such integer in list.
hstgtv(itag,vin:real,vout:real) integer function
   # Set v = the least value in the itag list greater than vin
   # return OK; return ERR if no such integer in list.
hstprint(tag:string;unit:integer) subroutine
   # Print a report about the status of the tag to unit (default stderr).
hstshowi(tag:string,item:string;unit:integer) subroutine
   # Print the name of the history variable corresponding to a given item.
hstvers(unit:integer) subroutine
   # Print the history package version number on unit.
hstrest subroutine
   # Call this after a history package restore.
$ user interface and internal:
hsterr(caller:string,message:string,tag:string) subroutine
   # Issue error message.
hstsitem(ivolatile,tag,various) builtin [3-100]
   # Used by the items and itemsv macros.
hstssn(tag,item,newname,item2,newname2,...) builtin [3-100]
  # Used by itemname macro.
hstset(change,tag,various) builtin [3-100]
   # Used by the collect macro.
hstsetf(fileid:integer,itag:integer) subroutine
   # Used by the history to file function written by hstflfcn.
hstgens(tag:string) integer function
   #Returns the number of generations a tag has been collected.
hstcrtag(tag:string; filename:string) subroutine 
   # Create a new tag, store in file if file name given.
   # See hstfile.
hstinit subroutine
   # Reinitialize history package.
   # Previously collected history data not removed but may be overwritten.
   # You can call gfree("hst.Histories") to remove most data.

***** Histories dump:         $ This Group MUST always be the last group
# history arrays created by the history package
hstver character*8 /"7.1"/
   #Version number of history package.



