/*
 * hstcol.c
 */

#include "hst.h"

/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/

/* HSTCOL - update pending values */

void Hstcol(Integer itag)
{
    Integer item, icond, idum, mode, jcond, *ncycle;
    Integer nc, it, lcat;
    float *v;
    real8 *vd, xd;
    char *ps;
    char stmp[3 * VARNAMESIZE];

    nc = VARNAMESIZE;
    it = itag - 1;

    ncycle = (Integer *) hstcptr[it];

/* taglog got set when we called tagcall(itag) */
    if (taglog) {
        tagclc[it] = *ncycle;
        if (tagfile[it * FILENAMESIZE] == ' ') {
            if (tagrec[it] == 0) {
                ps = tagcall + it * nc;
                memset(ps, (int) ' ', nc);
                for (item = 0; item < numitems; item++) {
                    if (hstown[item] != itag)
                        continue;
                    strcpy(stmp, "hst.");
                    lcat = StrGetCl((Address) hstname, item * nc, nc);
                    strncat(stmp, hstname + item * nc, lcat);
                    idum = Crtaddim(stmp);
                }
            }
        }

/* if new basis session, start new time-history file */
        else {
            if (tagrecrn[it] == 0) {
                ps = tagcall + it * nc;
                memset(ps, (int) ' ', nc);
            }
        }
        tagrec[it]++;
        tagrecrn[it]++;
    }

    icond = tagcond[it];
    while (icond != 0) {
        mode = hstmode[icond - 1];
        jcond = hstnext[icond - 1];
        if (mode == CYCLELIST || mode == CYCLESPEC) {
            if (Hstgti(&icond, ncycle, &hstcyc[icond - 1]) == ERR)
                Hstdcond(&icond);
        } else if (tagdoub[it]) {
            vd = (real8 *) hstvptr[it];
            if (Hstgtv(&icond, vd, &hstvalue[icond - 1]) == ERR)
                Hstdcond(&icond);
        } else {
            v = (float *) hstvptr[it];
            xd = (real8) *v;
            if (Hstgtv(&icond, &xd, &hstvalue[icond - 1]) == ERR)
                Hstdcond(&icond);
        }
        icond = jcond;
    }

    return;
}

/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
