
c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c HSTGTV - set v equal to the least element in an integer list or range
c        - greater than vin
c        - if there is one, return OK; else return ERR
c        - return error if v exceeds the maximum of the range

	integer function hstgtv(icond, vin, v)
	implicit none
	integer icond
        real(Size8) vin, v

HistoryGroups

	Address vstruct
	integer nc, mode, ipicket, i, ilim
        Address iloc
        real(Size8) d1, d2, d3, dd, dr
	integer itype, ndim, ilow(7), ihi(7), icol(7)
        Varname thishst

	integer ivalueo, utstrcod
        external ivalueo, utstrcod
        real(Size8) r8valueo
        external r8valueo

	nc   = VARNAMESIZE
	ilim = 100000000

c ... conditions of this type are real(Size8)
	mode = ivalueo(hstmode, icond)
        call smovatof(thishst, 0, hstcond, (icond-1)*nc, nc)
	if (mode == VALUESPEC) then
	   call hstfind(thishst, iloc, itype, ndim, ilow, ihi, icol)
	   vstruct = iloc
	   d1 = r8valueo(vstruct, 1)
	   d2 = r8valueo(vstruct, 2)
	   d3 = r8valueo(vstruct, 3)
	   if (vin < d1) then
	      v = d1
	      return(OK)
	   endif

	   dd = vin - d1
	   dr = 1.00000000001_Size8 * (dd/d3)

c ... if the range can be handled with an integer step do so
	   if ((-ilim .lt. dr) .and. (dr .lt. ilim)) then
	      ipicket = dr
	      v       = d1 + (ipicket+1)*d3

c ... otherwise keep it all in floating point
	   else
	      v = d1 + dr*d3
	   endif

c ... force v to be greater than or equal to vin
	   v = max(v, vin)

c ... check for v exceeding the range
	   if (v > d2) then
	      v = RPOSINF
	      return(ERR)
	   endif

	   return(OK)

	elseif (mode = VALUELIST) then
	   call hstfind(thishst, iloc, itype, ndim, ilow, ihi, icol)
	   vstruct = iloc
	   if (vin < r8valueo(vstruct, 1)) then
	      v = r8valueo(vstruct, 1)
	      return(OK)
	   elseif (vin >= r8valueo(vstruct, icol(1))) then
	      v = RPOSINF
	      return(ERR)
	   endif

	   do i = 1, icol(1)
	      if (r8valueo(vstruct, i) > vin) then
		 v = r8valueo(vstruct, i)
		 return(OK)
	      endif
	   enddo
	   return(ERR)

	else
	   call remark("hstgtv: wrong mode in history package tag.")
	   call kaboom(0)
	endif

	return
	end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------
