/*
 * HSTMAKF.C - do the hstmkfcn functionality in C where it belongs
 *
 */

#include "hst.h"
#include "hst_.h"

#define INDENT_IN(_n)                                                              \
    {int _m;                                                                       \
     _m = strlen(indent);                                                          \
     memset(indent + _m, ' ', _n);                                                 \
     indent[_m+_n] = '\0';}

#define INDENT_OUT(_n)    indent[strlen(indent)-(_n)] = '\0'

#if defined(CRAY2) || defined(XMP) || defined(YMP) || defined(C90) || defined(J90)
# define Basnxtsq BASNXTSQ
#elif defined(SUN4) || defined(SOL) || defined(SGI) || defined(CS2) || defined(AXP) || defined(LINUX) || defined(IRIX64)
# define Basnxtsq basnxtsq_
#else
# define Basnxtsq basnxtsq
#endif

extern integer
    Ivalueo(Address t, Integer o), Rtgetverb(void);

extern void
    Kaboom(Integer idum),
    Basnxtsq(char *s, char *t, Integer i, Integer j),
    Osallotn(Address *ptr, Integer n, char *name),
    Oschangn(Address *ptr, Integer newlen, Integer oldlen, char *name),
    SBlkSet(char *target, integer offset, integer length),
    SmovFtoA(char *target, integer toffset,
             char *source, integer soffset, integer length);

static integer
    icount = 0, mmsgs = 0;

static char
    indent[NMSG] = "",
    *msgs = NULL;

/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/

static void PREP(char *d, char *s, Integer offs, Integer nc)
{
    Integer i;
    char *ps;

    ps = s + offs;
    strncpy(d, ps, nc);

    for (i = nc - 1; i >= 0; i--) {
        if (d[i] != ' ') {
            d[i + 1] = '\0';
            return;
        }
    }

    d[0] = '\0';

    return;
}

/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/

/* REMRK - sensible remark call */

static void remrk(char *s)
{

    Remark(s, strlen(s));

    return;
}

/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/

/* HSTAMSG - cat MS onto the current function definition text
 *         - keep a count of the number of parts in ICOUNT
 */

void Hstamsg(char *fmt, ...)
{
    Integer nc, newm, lmove;
    char bf[512];
    va_list al;

    va_start(al, fmt);
    vsprintf(bf, fmt, al);
    va_end(al);

    if (icount == mmsgs) {
        newm = mmsgs + 50;
        nc = newm * NMSG;
        if (msgs == NULL)
            Osallotn((Address *) &msgs, nc, "PERM|HSTAMSG:msgs");

        else
            Oschangn((Address *) &msgs, nc, nc, "HSTAMSG:msgs");

        mmsgs = newm;
    }

    lmove = strlen(bf);

    if (lmove > NMSG) {
        remrk("hstamsg: item too long");
        remrk(bf);
        Kaboom(0);
    }

    icount++;

    strcat(msgs, indent);
    strcat(msgs, bf);
    strcat(msgs, "\n");

    return;
}

/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/

void Hstflrec(Integer itag)
{
    Integer item, nc, nm;
    char pn[VARNAMESIZE], pi[MAXITEMSIZE];

    nc = VARNAMESIZE;
    nm = MAXITEMSIZE;

    Hstamsg("call pfbbegr(i___);");

    for (item = 1; item <= numitems; item++) {
        if ((Ivalueo(hstown, item) != itag) ||
            (Ivalueo(hststatc, item) == 1))
            continue;

        PREP(pn, hstname, (item - 1) * nc, nc);
        PREP(pi, hstitms, (item - 1) * nm, nm);

        Hstamsg("call pfbsavee(%s, \"%s\", i___);", pi, pn);
    }

    Hstamsg("call pfbendr(i___);");

    return;
}

/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/

/* HSTFLST - writes code to write the static items to the file */

void Hstflst(Integer itag)
{
    Integer item, nc, nm;
    char pn[VARNAMESIZE], pi[MAXITEMSIZE];

    nc = VARNAMESIZE;
    nm = MAXITEMSIZE;

    Hstamsg("if (do_static___) then");
    INDENT_IN(3);

    for (item = 1; item <= numitems; item++) {
        if ((Ivalueo(hstown, item) != itag) ||
            (Ivalueo(hststatc, item) == 0))
            continue;

        PREP(pn, hstname, (item - 1) * nc, nc);
        PREP(pi, hstitms, (item - 1) * nm, nm);

        Hstamsg("call pfbsavee(%s, \"%s\", i___);", pi, pn);
    }

    INDENT_OUT(3);
    Hstamsg("endif");

    return;
}

/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/

void Hstflfcn(Integer itag)
{
    integer it, nc, nf;
    char ctag[16];
    char pl[FILENAMESIZE], pt[VARNAMESIZE], pi[VARNAMESIZE];

    nc = VARNAMESIZE;
    nf = FILENAMESIZE;

    it = itag - 1;
    sprintf(ctag, "%ld", (long) itag);

/* first sample in this run */
    if (Ivalueo(tagrecrn, itag) == 0)

/* don't overwrite the file we made last time! */
    {
        if (Ivalueo(tagrec, itag) > 0) {
            PREP(pl, tagfile, it * nf, nf);
            Basnxtsq(pl, pl, FILENAMESIZE, FILENAMESIZE);
            SmovFtoA(tagfile, it * nf, pl, 0, strlen(pl));
        }

        PREP(pt, tagccn, it * nc, nc);
        PREP(pi, tagivn, it * nc, nc);

        Hstamsg("logical do_static___ = true;");
        Hstamsg("pfb.pfbcycle = \"%s\";", pt);
        Hstamsg("pfb.pfbtime  = \"%s\";", pi);
        Hstamsg("integer i___ =  pfbopen(tagfile(%s), \"w\");", ctag);
        if (Rtgetverb())
            Hstamsg("<< \"Starting \" << trim(tagfile(%s));", ctag);
    }

/* subsequent sample collector */
    else {
        Hstamsg("integer i___ =  pfbopen(tagfile(%s), \"a\");", ctag);
        Hstamsg("integer j___ = i___; i___ = pfbfam(i___);");
        Hstamsg("logical do_static___ = (j___ .ne. i___);");
    }

    Hstamsg("call hstsetf(i___, %s);", ctag);

/* write code to output statics */
    Hstflst(itag);

/* write code to output record */
    Hstflrec(itag);

    Hstamsg("call pfbclose(i___);");

    return;
}

/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/

/* HSTMKFCN - construct a user function for collecting the tag */

void Hstmkfcn(Integer itag, Integer flag)
{
    Integer nc, nf, nm, item, itg;
    Integer isatest;
    char pf[VARNAMESIZE], pt[80], pg[500], pl[FILENAMESIZE];
    char pn[VARNAMESIZE], pi[MAXITEMSIZE], f[VARNAMESIZE];

    nc = VARNAMESIZE;
    nm = MAXITEMSIZE;
    nf = FILENAMESIZE;
    itg = itag - 1;

    indent[0] = '\0';
    icount = 0;
    if (msgs != NULL)
        msgs[0] = '\0';

    PREP(pf, tagname, itg * nc, nc);
    PREP(pt, taglogic, itg * 80, 80);
    PREP(pg, tagact, itg * 500, NMSG);
    PREP(pl, tagfile, itg * nf, nf);

    sprintf(f, "%%%s", pf);

    Hstamsg("forget %s;", f);

    Hstamsg("function %s", f);
    INDENT_IN(4);

    isatest = (strcmp(pt, "true") != 0);

    Hstamsg("hst.taglog = %s;", pt);

    if (isatest) {
        Hstamsg("if (hst.taglog) then");
        INDENT_IN(3);
    }

    if (pg[0] != '\0')
        Hstamsg("%s;", pg);

/* make function that writes to a file */
    if (pl[0] != '\0')
        Hstflfcn(itag);

    else {
        for (item = 1; item <= numitems; item++) {
            if (Ivalueo(hstown, item) != itag)
                continue;

            PREP(pn, hstname, (item - 1) * nc, nc);
            PREP(pi, hstitms, (item - 1) * nm, nm);

/* first sample collector */
            if (Ivalueo(tagrec, itag) == 0) {
                Hstamsg("hst chameleon %s = squeeze(%s);", pn, pi);
                Hstamsg("rtcattr(\"hst.%s\", \"history\");", pn);
            }

/* subsequent sample collector */
            else if (Ivalueo(hstvol, item) > 0)
                Hstamsg("hst.%s = [hst.%s, squeeze(%s)];", pn, pn, pi);

            else
                Hstamsg("hst.%s := %s;", pn, pi);
        }
    }

    if (isatest) {
        INDENT_OUT(3);
        Hstamsg("endif");
    }

    INDENT_OUT(4);
    Hstamsg("endf");

    if (hstdebug > 0) {
        FILE *out;
        char actn[512];

        out = fopen(f, "w");
        fprintf(out, "%s\n", msgs);
        fclose(out);

        sprintf(actn, "Wrote function to collect history: %s", f);
        remrk(actn);
    }

    Parsestr(msgs, strlen(msgs));
    SmovFtoA(tagcall, itg * nc, f, 0, strlen(f));

    if (flag) {
        icount = 0;
        msgs[0] = '\0';

        for (item = 1; item <= numitems; item++) {
            if (Ivalueo(hstown, item) != itag)
                continue;

            PREP(pi, hstitms, (item - 1) * nm, nm);

            Hstamsg("hst chameleon hstjunk = %s", pi);
        }

        Hstamsg("forget hst.hstjunk");

        Parsestr(msgs, strlen(msgs));
    }


    return;
}

/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
