/*
 * hstslist.c
 */

#include "hst.h"

static Integer zero = 0;
static real8 rneginf = RNEGINF;

/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/

/* HSTSLIST - create a list structure, put name of it in hstcond, mode in hstmode,
 * and length of the list in taglen
 */

void Hstslist(Integer itag, Integer mode, Address list, Integer nlist)
{
    Integer icond, jcond, *ilist, istatus;
    real8 t, *vlist, *vstruct;
    char thishst[VARNAMESIZE + 1], msg1[NMSG + 1];
    static char
        msg2[] = "Cannot set value condition: tag has no dependent variable.";
    static char
      msg3[] = "Too many timepoints specified (> 99999)";
    Integer i, j, it, nc, itype, ndim, ilow[7], ihi[7], icol[7];
    static char G1[] = "hst.Condition_Data";

    nc = VARNAMESIZE;

    icond = tagcond[itag - 1];
    if (icond == 0) {
        for (j = 0; j < mumcond; j++) {
            if (hstnext[j] == -1) {
                break;
            }
        }
        icond = j + 1;
        if (icond > mumcond) {
            mumcond += MAXCOND;
            Gchange(G1, &zero, strlen(G1));
        }
        tagcond[itag - 1] = icond;
    } else {
        while (hstnext[icond - 1] != 0) {
            icond = hstnext[icond - 1];
        }
        jcond = icond;
        for (j = 0; j < mumcond; j++) {
            if (hstnext[j] == -1) {
                break;
            }
        }
        icond = j + 1;
        if (icond > mumcond) {
            mumcond += MAXCOND;
            Gchange(G1, &zero, strlen(G1));
        }
        hstnext[jcond - 1] = icond;
    }

    hstnext[icond - 1] = 0;
    Hstmcn(&itag, &icond);      /* invent a name for the condition */
    strncpy(thishst, (char *) hstcond + (icond - 1) * nc, nc);
    thishst[nc] = '\0';
    thishst[Utgetcl(thishst)] = '\0';

    if ((mode == CYCLELIST || mode == VALUELIST) && nlist >= 99999) {

/* this list gets too long to sort in real time! currently >100 minutes */

        Hsterr("hstslist", msg3, (char *) tagname + (itag - 1) * nc, 8,
               strlen(msg3), nc);
        return;
    }

    if (mode == CYCLELIST || mode == CYCLESPEC) {
        sprintf(msg1, "hst integer %s(%ld)", thishst + 4, (long) nlist);
        j = strlen(msg1);
        Parsestr(msg1, j);
        Hstfind(thishst, (Address *) &ilist, &itype, &ndim, ilow,
                ihi, icol, nc);
        for (i = 0; i < nlist; i++) {
            ilist[i] = ((Integer *) list)[i];
        }

        if (mode == CYCLELIST) {
            for (i = 0; i < nlist - 1; i++) {
                for (j = i + 1; j < nlist; j++) {
                    if (ilist[j] < ilist[i]) {
                        it = ((Integer *) list)[i];
                        ilist[i] = ilist[j];
                        ilist[j] = it;
                    }
                }
            }
        }

        hstmode[icond - 1] = mode;
        istatus =
            Hstgti(&icond, &(tagclc[itag - 1]), &(hstcyc[icond - 1]));
        if (istatus == ERR) {
            Hstdcond(&icond);
        }
    } else {
        if (hstvptr[itag - 1] == (Address) NOTSET) {
            Hstdcond(&icond);
            Hsterr("hstslist", msg2, (char *) tagname + (itag - 1) * nc, 8,
                   strlen(msg2), nc);
            return;
        }

        sprintf(msg1, "hst real8 %s(%ld)", thishst + 4, (long) nlist);
        i = strlen(msg1);
        Parsestr(msg1, i);
        Hstfind(thishst, (Address *) (&vstruct), &itype, &ndim, ilow,
                ihi, icol, nc);

        vlist = (real8 *) list;
        for (i = 0; i < nlist; i++) {
            vstruct[i] = vlist[i];
        }

        if (mode == VALUELIST) {
            for (i = 0; i < nlist - 1; i++) {
                for (j = i + 1; j < nlist; j++) {
                    if (vstruct[j] < vstruct[i]) {
                        t = vstruct[i];
                        vstruct[i] = vstruct[j];
                        vstruct[j] = t;
                    }
                }
            }
        }

        hstmode[icond - 1] = mode;

        istatus = Hstgtv(&icond, &rneginf, &(hstvalue[icond - 1]));
        if (istatus == ERR) {
            Hstdcond(&icond);
        }
    }

    return;
}

/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
