! defines - includes to use
! for loops -> do while
! select
! while
! logical <> == <= >= < > & | ~= ~
! order of use statments
! explicit continues
!  break->cycle    - add for increment clause first
! case () \n or ;
! return(0)
! next->cycle


! case sensentive macro names


! stlength

! to f90
! select cases are limited to integers in mppl.
! Now allow ALPHA; however, it now loses the ability to do error checking
! on select -- redundant cases, ...
!
! save the for iterator in a macro mppl_foriter
!



! Mppl was written by Paul F. Dubois, Lee Busby, Peter Willmann, and
! Janet Takemoto at Lawrence Livermore National Laboratory.
! All files in the Basis system are Copyright 1994-2000, by the Regents of
! the University of California.  All rights reserved.
! See "Copyright" for complete legal notice.

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

module params
  integer, parameter ::	VARNAMESIZE = 129
  integer, parameter ::	MPPL_MAXINLEV = 5
  integer, parameter ::	MPPL_MAXCARD = 200
  integer, parameter ::	FILENAMESIZE = 256

  character*(*), parameter :: TTY = '-'
  integer, parameter :: NO = 0
  integer, parameter :: YES = 1
  integer, parameter :: FATALERROR = 1
! sizes
  integer, parameter :: ARGSIZE = 500
  integer, parameter :: CALLSIZE = 200
  integer, parameter :: BUFSIZE = 50000
  integer, parameter :: EVALSIZE = 50000
  integer, parameter :: MAXDEPTH = 10
  integer, parameter :: MAXSELECT = 500
  integer, parameter :: MAXSTATE = 125
  integer, parameter :: MAXTOK = 20000
! lexical
  integer, parameter :: LEXMIN = 0
  integer, parameter :: NULL = 0
  integer, parameter :: COMMENT = 1
  integer, parameter :: LETTER = 2
  integer, parameter :: DIGIT  = 3
  integer, parameter :: ALPHA  = 4
  integer, parameter :: WHITE  = 5
  integer, parameter :: COL1C = 6
  integer, parameter :: BELL = 7
  integer, parameter :: TAB = 9
  integer, parameter :: NEWLINE = 13
  integer, parameter :: EOF = 28
  integer, parameter :: BLANK = 32
  integer, parameter :: BANG = 33
  integer, parameter :: QUOTE = 34
  integer, parameter :: POUND = 35
  integer, parameter :: DOLLAR = 36
  integer, parameter :: PERCENT = 37
  integer, parameter :: AMPERSAND = 38
  integer, parameter :: TICK = 39
  integer, parameter :: LPAREN = 40
  integer, parameter :: RPAREN = 41
  integer, parameter :: ASTERISK = 42
  integer, parameter :: PLUS = 43
  integer, parameter :: COMMA = 44
  integer, parameter :: MINUS = 45
  integer, parameter :: PERIOD = 46
  integer, parameter :: SLASH = 47
  integer, parameter :: ZERO = 48
  integer, parameter :: NINE = 57
  integer, parameter :: COLON = 58
  integer, parameter :: SEMICOLON = 59
  integer, parameter :: LANGLE = 60
  integer, parameter :: EQUALS = 61
  integer, parameter :: RANGLE = 62
  integer, parameter :: QUESTION = 63
  integer, parameter :: ATSIGN = 64
  integer, parameter :: LBRACK = 91
  integer, parameter :: BSLASH = 92
  integer, parameter :: RBRACK = 93
  integer, parameter :: CARET = 94
  integer, parameter :: UNDERSCORE = 95
  integer, parameter :: GRAVE = 96
  integer, parameter :: LBRACE = 123
  integer, parameter :: VBAR = 124
  integer, parameter :: RBRACE = 125
  integer, parameter :: TILDE = 126
  integer, parameter :: ESCAPE = 127  ! can't collide with normal text or flags below
  integer, parameter :: LEXMAX = 127

! builtin flags
  integer, parameter :: DEFTYPE = 65
  integer, parameter :: IFELSETYPE  = 66
  integer, parameter :: IFDEFTYPE   = 67
  integer, parameter :: ERRPRINTTYPE = 68
  integer, parameter :: INFOPRINTTYPE = 110
  integer, parameter :: DUMPDEFTYPE = 69
  integer, parameter :: EVALUATETYPE = 70
  integer, parameter :: IMMEDIATETYPE = 71
  integer, parameter :: UNDEFINETYPE = 72
  integer, parameter :: SMODTYPE = 73

  integer, parameter :: DECIDELOW   = 74
  integer, parameter :: SENDDO      = 74
  integer, parameter :: SBREAK      = 75
  integer, parameter :: SNEXT       = 76
  integer, parameter :: SDO         = 77
  integer, parameter :: SWHILE      = 78
  integer, parameter :: SENDWHILE   = 79
  integer, parameter :: SUNTIL      = 80
  integer, parameter :: SIF         = 81
  integer, parameter :: SELSE       = 82
  integer, parameter :: SENDIF      = 83
  integer, parameter :: SELSEIF     = 84
  integer, parameter :: STHEN       = 85
  integer, parameter :: SSELECT     = 86
  integer, parameter :: SCASE       = 87
  integer, parameter :: SDEFAULT    = 88
  integer, parameter :: SESELECT    = 89
  integer, parameter :: SFOR        = 90
  integer, parameter :: SEFOR       = 91
  integer, parameter :: SINCLUDE    = 92
  integer, parameter :: SBLOCK      = 93
  integer, parameter :: MPROGRAM    = 94
  integer, parameter :: MSUBROUTINE = 95
  integer, parameter :: MFUNCTION   = 96
  integer, parameter :: MRETURN     = 97
  integer, parameter :: MEND        = 98
  integer, parameter :: MINTERFACE  = 99
  integer, parameter :: DECIDEHI    = 99
!values for do statement types
  integer, parameter :: OLD = 1
  integer, parameter :: REGULAR = 2
  integer, parameter :: BLOCK = 3
  integer, parameter :: WHILE = 4
! select parameters
  integer, parameter :: CUTOFF = 3
  integer, parameter :: DENSITY = 3
! value for domath
  integer, parameter :: TOKOPER = 100
  integer, parameter :: TOKEOF = 101
  integer, parameter :: TOKNUM = 102
  integer, parameter :: ERR = 1
  integer, parameter :: OK = 0
  integer, parameter :: INLINE = 512
end module

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

module irset_mod
  logical ireset,rreset
  common /irset/ ireset,rreset
end module irset_mod

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

module stdunits_mod
  integer stdin,stdout,stderr
  common /stdunits/ stdin,stdout,stderr
end module stdunits_mod

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

module fname_mod
  use params
  character(FILENAMESIZE) std,basis,sys,system
  common /fname/ std,basis,sys,system
end module fname_mod

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

module idircom_mod
  use params
  character(FILENAMESIZE) incldirs(200)
  integer inclnum
  character dirsep
  common /idircom/ incldirs, inclnum
  common /idircoc/ dirsep
end module idircom_mod

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

module icom_mod
  integer icompile
  common /icom/icompile
end module icom_mod

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

module pathvars_mod
  use params
  character(FILENAMESIZE) argv0
  character(FILENAMESIZE) realname
  character(FILENAMESIZE) realpath
  integer len1,len2,len3
  common /pathvars/argv0,realname,realpath,len1,len2,len3
end module pathvars_mod

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

module ctlvars_mod
  use params
  integer lexwarn,realsize,intsize,wordsize
  integer inlev,finerr,nodblquo,yyline(MPPL_MAXINLEV)
  common /ctlvars/ lexwarn,realsize,intsize,wordsize
  common /ctlvars/ inlev,finerr,nodblquo,yyline
end module ctlvars_mod

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

module cargs_mod
  use params
  integer ap,argstk(ARGSIZE),callst(CALLSIZE),nlb,plev(CALLSIZE)
  common /cargs/ ap,argstk,callst,nlb,plev
end module cargs_mod

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

module cfile_mod
  use params
  integer iusin(MPPL_MAXINLEV),lnbt
  integer lcbuf
  common /cfile/iusin,lcbuf,lnbt

  character(FILENAMESIZE) filnam(MPPL_MAXINLEV)
  common /cfilec/filnam
  logical firstfil, verbose
  common /cfiled/firstfil, verbose

  character(MPPL_MAXCARD) cbuf
  character(MPPL_MAXCARD) cbsav(MPPL_MAXINLEV)
  integer lcsav(MPPL_MAXINLEV)
  common /cbsav1/ lcsav
  common /cbsav2/ cbsav
  common /cinbuf/cbuf

  integer outbuf(BUFSIZE),lastpc,col72,icontinue
  logical bckeep
  common /cputc/outbuf,lastpc,col72,icontinue,bckeep
  
  integer bp,pblinl(MPPL_MAXINLEV)
  common /cdef/bp,pblinl

  integer pbbuf(BUFSIZE),pblins(BUFSIZE,MPPL_MAXINLEV)
  common /cdefc/pbbuf,pblins
end module cfile_mod

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

module clabs_mod
  integer labnxt,laborg
  common /labg/labnxt,laborg
end module clabs_mod

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

module cmacro_mod
  use params
  integer cp                      !current call stack pointer
  integer ep                      !next free position in evalst
  integer mline(CALLSIZE),mlev(CALLSIZE)
                                        !line,file at which macro began
  common /cmacro/ cp,ep,mline,mlev

  integer evalst(EVALSIZE)        !evaluation stack
  common /cmacrc/ evalst
end module cmacro_mod

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

module cstat_mod
  use params
  integer level,iflevel,ifacelev
  integer dotype(0:MAXDEPTH),labn(0:MAXDEPTH)
  integer labb(0:MAXDEPTH),used(0:MAXDEPTH)
  integer token(MAXTOK),ltoken,code(1)
  integer modtype(0:MAXDEPTH),modfun
  character(130) foriter(0:MAXDEPTH)
  common /stat1/level,iflevel,ifacelev
  common /stat1/dotype,labn,labb,used,token,ltoken,code,modtype,modfun
  character*32 modname(0:MAXDEPTH)
  common /stat2/ modname, foriter
  integer decide(DECIDELOW:DECIDEHI)
  common /decid/decide
  integer seltop   ! current select entry; init = 0
  integer sellast  ! next available position; init = 1
  integer selstak  ! select information
  integer sellev   ! select depth
  integer sellab   ! label that started this select
  common /csel/ sellev,seltop, sellast, &
       selstak(MAXSELECT),sellab(MAXDEPTH)
end module cstat_mod

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

module ctype_mod
  use params
  integer type(LEXMIN:LEXMAX)
  integer alphan(LEXMIN:LEXMAX)
  integer contu(LEXMIN:LEXMAX)
  integer tokgo(LEXMIN:LEXMAX)
  logical col1(LEXMIN:LEXMAX)
  logical col6
  common /ctype/type,alphan,contu,tokgo,col1,col6
end module ctype_mod

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

module cone_mod
  use params
  character(8) act1       ! array of actions(shift,reduce,etc)
  integer act2            ! array  of states corresponding to act1
  integer move            ! array of next states after reduction
  integer stray,stop      ! stack of states,stack top
  integer numray,numtop   ! stack of tokens, stack top
  common /ceo/ act1(26)
  common /ceo1/ act2(26,8), move(26,4)
  common /ceo2/ stray(MAXSTATE), stop, numray(MAXSTATE), numtop
end module cone_mod

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

subroutine mppldata
  use cargs_mod
  use cfile_mod
  use cone_mod
  use clabs_mod
  use cmacro_mod
  use cstat_mod
  use ctype_mod
  use icom_mod
        integer i
        verbose = .false.
        laborg = 23000
!XXX- decide width
        col72 = 130   ! leave space for continuation ' &'
        col72 = 72
        col72 = 78
        firstfil  = .true.
!
! act1,act2 indexed by current state and input
! columns 1-8 correspond to: ( ) * + int - eof /
!
        act1(1) = 'eeeeeeee'
        act1(2) = 'seeessee'
        act1(3) = 'seeessee'
        act1(4) = 'seeeseee'
        act1(5) = 'errrerrr'
        act1(6) = 'eeesesee'
        act1(7) = 'eeeeeeae'
        act1(8) = 'errrerrr'
        act1(9) = 'ersrerrs'
        act1(10) = 'eseeeeee'
        act1(11) = 'eeesesee'
        act1(12) = 'ersrerrs'
        act1(13) = 'seeeseee'
        act1(14) = 'seeeseee'
        act1(15) = 'eeeeeeae'
        act1(16) = 'seeeseee'
        act1(17) = 'seeeseee'
        act1(18) = 'errrerrr'
        act1(19) = 'seeeseee'
        act1(20) = 'seeeseee'
        act1(21) = 'ersrerrs'
        act1(22) = 'ersrerrs'
        act1(23) = 'errrerrr'
        act1(24) = 'errrerrr'
        act1(25) = 'ersrerrs'
        act1(26) = 'ersrerrs'

        act2( 1,:) = (/1,  1,  1,  1,  1,  1,  1,  1/)
        act2( 2,:) = (/3,  1,  1,  1,  5,  4,  1,  1/)
        act2( 3,:) = (/3,  1,  1,  1,  5,  4,  1,  1/)
        act2( 4,:) = (/3,  1,  1,  1,  5,  1,  1,  1/)
        act2( 5,:) = (/1, 14, 14, 14,  1, 14, 14, 14/)
        act2( 6,:) = (/1,  1,  1, 13,  1, 14,  1,  1/)
        act2( 7,:) = (/1,  1,  1,  1,  1,  1,  1,  1/)
        act2( 8,:) = (/1, 11, 11, 11,  1, 11, 11, 11/)
        act2( 9,:) = (/1,  2, 16,  8,  1,  8,  2, 17/)
        act2(10,:) = (/1, 18,  1,  1,  1,  1,  1,  1/)
        act2(11,:) = (/1,  1,  1, 19,  1, 20,  1,  1/)
        act2(12,:) = (/1,  3, 16,  8,  1,  8,  3, 17/)
        act2(13,:) = (/3,  1,  1,  1,  5,  1,  1,  1/)
        act2(14,:) = (/3,  1,  1,  1,  5,  1,  1,  1/)
        act2(15,:) = (/1,  1,  1,  1,  1,  1,  1,  1/)
        act2(16,:) = (/3,  1,  1,  1,  5,  1,  1,  1/)
        act2(17,:) = (/3,  1,  1,  1,  5,  1,  1,  1/)
        act2(18,:) = (/1, 15, 15, 15,  1, 15, 15, 15/)
        act2(19,:) = (/3,  1,  1,  1,  5,  1,  1,  1/)
        act2(20,:) = (/3,  1,  1,  1,  5,  1,  1,  1/)
        act2(21,:) = (/1,  4, 16,  9,  1,  9,  4, 17/)
        act2(22,:) = (/1,  6, 16, 10,  1, 10,  6, 17/)
        act2(23,:) = (/1, 12, 12, 12,  1, 12, 12, 12/)
        act2(24,:) = (/1, 13, 13, 13,  1, 13, 13, 13/)
        act2(25,:) = (/1,  5, 16,  9,  1,  9,  5, 17/)
        act2(26,:) = (/1,  7, 16, 10,  1, 10,  7, 17/)
!
! move indexed by stray(stop) and current non-terminal
! from grammar
! columns 1-4 correspond to: E  E'  T  F
!
        move(1,:) = (/1,1,1,1/)
        move(2,:) = (/7,6,9,8/)
        move(3,:) = (/10,6,9,8/)
        move(4,:) = (/1,11,12,8/)
        move(5,:) = (/1,1,1,1/)
        move(6,:) = (/1,1,1,1/)
        move(7,:) = (/1,1,1,1/)
        move(8,:) = (/1,1,1,1/)
        move(9,:) = (/1,1,1,1/)
        move(10,:) = (/1,1,1,1/)
        move(11,:) = (/1,1,1,1/)
        move(12,:) = (/1,1,1,1/)
        move(13,:) = (/1,1,21,8/)
        move(14,:) = (/1,1,22,8/)
        move(15,:) = (/1,1,1,1/)
        move(16,:) = (/1,1,1,23/)
        move(17,:) = (/1,1,1,24/)
        move(18,:) = (/1,1,1,1/)
        move(19,:) = (/1,1,25,8/)
        move(20,:) = (/1,1,26,8/)
        move(21,:) = (/1,1,1,1/)
        move(22,:) = (/1,1,1,1/)
        move(23,:) = (/1,1,1,1/)
        move(24,:) = (/1,1,1,1/)
        move(25,:) = (/1,1,1,1/)
        move(26,:) = (/1,1,1,1/)

        end

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

        subroutine aampp

  use params
  use irset_mod
  use fname_mod
  use cfile_mod
  use ctlvars_mod
  use stdunits_mod
  use pathvars_mod

        external getarg, iargc
        integer i, iargc, jcd
        character*128 argv(200)
        integer arg1, argc, firstfile
        character(FILENAMESIZE) basisv
        logical obckeep, bv
        integer idone

        call mppldata
        call init0(stdin,stdout,stderr,intsize,realsize,wordsize,system)
        call init
        call tabini
        idone  = 0 
        finerr = 0
	nodblquo = 0
	lexwarn = NO
	ireset = .false.
	rreset = .false.

! There is a chicken and egg problem in setting intsize, realsize, and
! wordsize.  They need to be set before reading any input which contains
! literal integers or floating point constants, but you need to read
! "mppl.sys" in order to (properly) set wordsize.  Then that value of
! wordsize is used to set the default values for intsize and realsize for
! a given SYSTEM (which may have been set with a "-t" option).  However,
! the user may have set values for intsize and realsize by the command line
! options "-i" or "-r", so we need to check for that before (re)setting the
! wordsize-based defaults.  The upshot is that we compile in provisional
! values for intsize, realsize, and wordsize, check the command line for any
! changes to intsize or realsize, and use those while reading "mppl.sys".
! Finally, we use the wordsize read in to reset intsize or realsize,
! if they weren't set on the command line.  Given this order of events,
! it would be foolhardy to put any floating point literals in "mppl.sys".
!
!	1) Set provisional values in init0 for intsize, realsize, wordsize.
!	2) Check command line - may reset SYSTEM.
!	3) Read mppl.sys - sets WORDSIZE as function of SYSTEM.
!	4) Reread command line to over-ride default MACHINE or COMPILER.
!	5) Set intsize, realsize per wordsize unless given on command line.
!	6) Read mppl.std.
!	7) Read mppl.BASIS.
!	8) Process remaining input files.
!
! Intsize, realsize, wordsize changes after step 5 will produce
! undefined behavior.

        arg1   = 1
        argc   = iargc()
        call getarg(arg1-1,argv0)
        do i = arg1, argc
	    call getarg(i,argv(i))
	enddo

	i=arg1
        do while (argv(i)(1:1) .eq. '-' .and. argv(i) .ne. '-')
	    call setopt(argv(i)(2:))
            i=i+1
	enddo

        realname = " "
        realpath = " "
        len1 = len_trim(argv0)
        len2 = len(realname)
        len3 = len(realpath)
        call nameme0()
        jcd = len_trim(realpath)
        sys=realpath(1:jcd)//"/mppl.sys"
        std=realpath(1:jcd)//"/mppl.std"
        basis=realpath(1:jcd)//"/mppl.conv"
        basisv='mppl.conv'

! These must be called after casesen is set ( -u )
	call bltin
	call shared_constants
	call cnstal('SYSTEM',system(1:len_trim(system)))
! Turn off blank and comment line output while processing startup files.
	bckeep = .false.
        call dofile(sys)
	bckeep = .true.
! Reprocess the option list to over-ride defaults just read in.
	i=arg1
	do while (argv(i)(1:1) .eq. '-' .and. argv(i) .ne. '-')
	    call setopt(argv(i)(2:))
            i=i+1
	enddo
	firstfile = i

! Set intsize and realsize to final values.
	if(.not. ireset) intsize = 4
	call getwdsz(wordsize)
	if(.not. rreset)then
	    if(wordsize .lt. 64)then
		realsize = 4
	    else
		realsize = 8
	    endif
	endif
	call setsize('IntSize',intsize)
	call setsize('RealSize',realsize)

! Turn off comments again, process remaining configuration files.
	obckeep = bckeep
	bckeep = .false.
        call dofile(std)
        if(basis .ne. " ") then
            call dofile(basis)
            inquire(file=basisv, exist=bv)
            if (bv) call dofile(basisv)
        endif
	bckeep = obckeep

! Process remaining arguments as input files.
        do i = firstfile, argc
	    call dofile(argv(i))
        enddo
        if (firstfile .gt. argc) call dofile(TTY)
        call finish(finerr)
        end subroutine aampp

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

      subroutine wrline(unit,msg,n)
      integer n,unit
      character*(*) msg
      write(unit,100) msg(1:n)
100   format(a)
      return
    end subroutine wrline

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

      subroutine rem(msg,n)
  use stdunits_mod
      character*(*) msg
      integer n
      write(stderr,100) msg(1:n)
100   format(1x,a)
      return
    end subroutine rem

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

        function zpakchrz(sout,lsout, ain,n)
	integer zpakchrz
        character*(*) sout
        integer ain(*), n, i, lsout
	zpakchrz = min(lsout, n)
        do i = 1, zpakchrz
           sout(i:i) = char(ain(i))
        enddo
        return
      end function zpakchrz

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

        subroutine bltin
! install names and defns of define, ifelse, etc... in table
   use params
        character*2 c

        call cnstal('Prolog','#Prolog')
        c=char(ESCAPE)

        c(2:) = char(DEFTYPE)
        call cnstal('define',c)

        c(2:) = char(SMODTYPE)
        call cnstal('Module',c)

        c(2:) = char(IFDEFTYPE)
        call cnstal('ifdef',c)

        c(2:) = char(IFELSETYPE)
        call cnstal('ifelse',c)

        c(2:) =char(ERRPRINTTYPE)
        call cnstal('Errprint',c)

        c(2:) =char(INFOPRINTTYPE)
        call cnstal('Infoprint',c)

        c(2:)=char(DUMPDEFTYPE)
        call cnstal('Dumpdef',c)

        c(2:)=char(EVALUATETYPE)
        call cnstal('Evaluate',c)

        c(2:)=char(IMMEDIATETYPE)
        call cnstal('Immediate',c)

        c(2:)=char(SINCLUDE)
        call cnstal('include',c)

        c(2:)=char(SDO)
        call cnstal('do',c)

        c(2:)=char(SENDDO)
        call cnstal('enddo',c)

        c(2:)=char(SNEXT)
        call cnstal('next',c//' $1')

        c(2:)=char(SBREAK)
        call cnstal('break',c//' $1')

        c(2:)=char(MPROGRAM)
        call cnstal('program',c)

        c(2:)=char(MSUBROUTINE)
        call cnstal('subroutine',c)

        c(2:)=char(MFUNCTION)
        call cnstal('function',c)

        c(2:)=char(MEND)
        call cnstal('end',c)

        c(2:)=char(MRETURN)
        call cnstal('return',c//'ifelse($1,,,([$1]))')

        c(2:)=char(SWHILE)
!XXX        call cnstal('while',c//'ifelse($1,,,[Immediate([c while($1)])])([$1])')
        call cnstal('while',c//'([$1])')

        c(2:)=char(SENDWHILE)
        call cnstal('endwhile',c)

        c(2:)=char(SUNTIL)
!XXX        call cnstal('until',c//'ifelse($1,,,[Immediate([c until($1)])])([$1])')
        call cnstal('until',c//'([$1])')

        c(2:)=char(SIF)
        call cnstal('if',c//'([$1])')

        c(2:)=char(SELSE)
        call cnstal('else',c)

        c(2:)=char(SELSEIF)
        call cnstal('elseif',c//'([$1])')

        c(2:)=char(SENDIF)
        call cnstal('endif',c)

        c(2:)=char(STHEN)
        call cnstal('then',c)

        c(2:)=char(SSELECT)
!XXX        call cnstal('select',c//'ifelse($1,,, = $1)')
        call cnstal('select',c//'[select case] ($1)')

        c(2:)=char(SCASE)
        call cnstal('case',c//'$1')

        c(2:)=char(SDEFAULT)
        call cnstal('default',c//'$1')

        c(2:)=char(SESELECT)
        call cnstal('endselect',c//'[end select]')

        c(2:)=char(SFOR)
        call cnstal('for',c// &
!             'define([mppl_foriter],[$3]);Dumpdef([mppl_foriter])' // &
             'define([mppl_foriter],[$3])' // &
             'ifelse([$2nn],,,'//'[$1];do while ([$2]))')
!XXX'ifelse([$2],,,'// &
!XXX'[Immediate([c -- for([$*])])[$1];go to @1;do;[$3];@1 if(.not.([$2])) break])')

        c(2:)=char(SEFOR)
        call cnstal('endfor',c)

        c(2:)=char(UNDEFINETYPE)
        call cnstal('Undefine',c)

        c(2:)=char(SBLOCK)
        call cnstal('block',c)

        c(2:)=char(MINTERFACE)
        call cnstal('interface',c)

        return
        end subroutine bltin

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

        subroutine shared_constants
! Install definitions for some basis and mppl constants.  It is convenient
! to do this here, because these constants receive their fundamental
! definition in scon.h.  They are also known and required by various
! C source routines.
  use params

        character *32 s
        integer, external :: scon, fnb

!        write(s,'(i8)') scon(1)
!        call cnstal('VARNAMESIZE',s(fnb(s):))

        write(s,'(i8)') scon(2)
        call cnstal('MPPL_MAXINLEV',s(fnb(s):))

        write(s,'(i8)') scon(3)
        call cnstal('MPPL_MAXCARD',s(fnb(s):))

!        write(s,'(i8)') scon(4)
!        call cnstal('FILENAMESIZE',s(fnb(s):))

        return
      end subroutine shared_constants

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

! Return the index of the first non-blank character in s.

        function fnb(s)
        integer fnb
        character *(*) s

        fnb = 1
        do while( (s(fnb:fnb) .eq. ' ') .and. (fnb .lt. len(s)) )
          fnb = fnb+1
        enddo
        return
      end function fnb

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

!install a definition, character string
!maximum lengths for name and defn 32 and 256 THIS ROUTINE ONLY

        subroutine cnstal(cname,cdef)
        integer name(32),def(256),i
        character*(*) cname,cdef
        integer lname,ldef

        lname = len(cname)
        ldef  = len_trim(cdef)
        if(lname .gt. 32 .or. ldef .gt. 256) &
                call oops('cnstal: name or defn too long')
        do i=1,lname
                name(i) = ichar(cname(i:i))
        enddo
        do i=1,ldef
                def(i) = ichar(cdef(i:i))
        enddo
        call instal(name,lname,def,ldef)
        return
      end subroutine cnstal

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

! push back character string str

        subroutine cpbstr(str)
        character*(*) str
        integer i,n
!
        n = len(str)
        do i=n,1,-1
                call putbak(ichar(str(i:i)))
        enddo
        return
      end subroutine cpbstr

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

        subroutine doblock
  use cfile_mod
  use cstat_mod
        integer t
        integer, external :: gnbtok
!
        call outtab
        call putqs('block ')
        t = gnbtok(token,ltoken)
        call putchr(token,ltoken)
! look for the word data or DATA
        if (ltoken .ne. 4) then
!not a block data statement after all
                call eatup
                return
        else
           if((token(1).ne.100 .and. token(1) .ne. 68) .or. &
              (token(2).ne. 97 .and. token(2) .ne. 65) .or. &
              (token(3).ne.116 .and. token(3) .ne. 84) .or. &
              (token(4).ne. 97 .and. token(4) .ne. 65) ) then
                   call eatup
                   return
           endif
        endif
! next should be the module name
        call putqs(' ')
        t = gnbtok(token,ltoken)
        call putchr(token,ltoken)
        if (ltoken .gt.  32) &
                call warn('block module name too long')
        ltoken = min(ltoken,32)
        modtype(ifacelev) = SBLOCK
        call setmod(token,ltoken)
        call eatup
        return
        end subroutine doblock
!
!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

        function docond()
! evaluate and put out conditional
!translate >, >=, <,<=,~, ~=, <>, = or ==, ~ , ~=, &, |
! argument is a dummy, not used
! returns 0 if o.k., 1 otherwise
  use cstat_mod
        integer docond
        integer t,nlev
        integer, external :: gtok,gnbtok

        t = gnbtok(token,ltoken)
        if( t .ne. LPAREN) then
                call warn('Missing condition.')
                docond = 1
                return
        endif
        call putqs('(')
        nlev = 1
        do while(nlev .gt. 0)
                t = gtok(token,ltoken)
                if(t .eq. LPAREN) then
                        nlev = nlev + 1
                        code(1) = LPAREN
                        call putchr(code,1)
                elseif(t .eq. RPAREN) then
                        nlev = nlev - 1
                        code(1) = RPAREN
                        call putchr(code,1)
                elseif( t .eq. AMPERSAND ) then
                        call putqs('.and.')
                elseif( t .eq. VBAR) then
                        call putqs('.or.')
                elseif( t .eq. EQUALS) then
                        call putqs('.eq.')
                        t = gtok(token,ltoken)
! ok to have = or ==
                        if ( t .ne. EQUALS) then
                                call pbstr(token,ltoken)
                        endif
                elseif( t .eq. TILDE) then
                        t = gtok(token,ltoken)
                        if( t .ne. EQUALS) then
                                call pbstr(token,ltoken)
                                call putqs('.not.')
                        else
                                call putqs('.ne.')
                        endif
                elseif( t .eq. LANGLE) then
                        t = gtok(token,ltoken)
                        if( t .eq. EQUALS) then
                                call putqs('.le.')
                        elseif(t .eq. RANGLE) then
                                call putqs('.ne.')
                        else
                                call pbstr(token,ltoken)
                                call putqs('.lt.')
                        endif
                elseif( t .eq. RANGLE) then
                        t = gtok(token,ltoken)
                        if( t .eq. EQUALS) then
                                call putqs('.ge.')
                        elseif(t .eq. LANGLE) then
                                call putqs('.ne.')
                        else
                                call pbstr(token,ltoken)
                                call putqs('.gt.')
                        endif
                elseif( t .eq. NEWLINE) then
                        call warn('Missing right parenthesis in condition.')
                        docond = 1
                        return
                else
                        call putchr(token,ltoken)
                endif
        enddo ! nlev .gt. 0
	code(1) = BLANK
        call putchr(code,1)
        docond = 0
        return
        end function docond

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

        subroutine dodef(argstk,i,j)
!dodef -- install definition in table
  use cmacro_mod
  use cstat_mod
  use ctype_mod
        integer a1,a2,a3,argstk(1),i,j,jloc,k,ilo,ihi,lname
        integer t
        integer, external :: gettok

        if(j .gt. i + 3) call oops(' Wrong number of arguments in define.')
        jloc = j
50      continue
! if called as a macro:
        a1 = argstk(i+2)
        a2 = argstk(i+3)
        if( a2-a1 .eq. 0 ) go to 100
        if( jloc .eq. i+3) then
                a3 = argstk(i+4)
        else
                a3 = a2
        endif
        do ilo = a1, a2-1 
           if(type(evalst(ilo)).ne.WHITE) exit
        enddo
        do ihi = a2-1, a1, -1
           if(type(evalst(ihi)).ne.WHITE) exit
        enddo
        lname = ihi -ilo + 1
        if(lname .le.0) call oops(' Empty name in define macro.')
        do k = ilo, ihi
           if(alphan(evalst(k)).ne.YES) &
                call oops(' Name not alphanumeric in define macro.')
        enddo 
        call instal(evalst(ilo),lname,evalst(a2),a3-a2)
        return
100     continue !arguments not supplied, go get them
! note that this routine is called from eval called from gtok,
! so we can only use gettok , not gnbtok or gtok
        t = gettok(token,ltoken)
        if(t .eq. WHITE) t = gettok(token,ltoken)
        if(t .ne. ALPHA) call oops('define not followed by name')
        do k=1,ltoken
                evalst(argstk(i+2)-1+k)=token(k)
        enddo
        argstk(i+3) = argstk(i+2) + ltoken
        argstk(i+4) = argstk(i+3)
        jloc = i + 3
! eatup rest of line as definition
        t = gettok(token,ltoken)
        if(t.eq.WHITE) t=gettok(token,ltoken)
        do while(t .ne. NEWLINE)
                do k=1,ltoken
                        evalst(argstk(i+4) - 1 + k) = token(k)
                enddo
                argstk(i+4) = argstk(i+4) + ltoken
                t = gettok(token,ltoken)
        enddo
        go to 50
        end subroutine dodef

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

        subroutine doend
  use params
  use cfile_mod
  use cstat_mod
        integer, external :: gnbtok
        integer t, ierr
        integer i23000

! handles end, end do, end while, end if
! sure, we've seen an end, but did they really mean it ?
        t = gnbtok(token,ltoken)
        if (t .eq. ALPHA) then
           call sendalpha
        elseif(t .ne. ESCAPE) then
           call sendmod
        else
           select case (token(2))
           case (SDO)
              call sedo
           case (SWHILE)
              call sewhile
           case (SIF)
              call do_sendif
           case (SEFOR)
              call do_sefor
           case (SSELECT)
              call do_seselect
           case (SBLOCK)
              call sendmod
           case (MSUBROUTINE)
              call sendmod
           case (MFUNCTION)
              call sendmod
           case (MPROGRAM)
              call sendmod
           case (MINTERFACE)
              call sendiface
           case default
              call warn('end followed by improper keyword')
           endselect
        endif

        return
      end subroutine doend

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

! This handles the case where select has been undefined.
! It will now be an ALPHA instead of SSELECT.
! also recognize 'end type'
        subroutine sendalpha

  use cstat_mod
        character*32 endmod, endname
        integer lenmod, lenname
        integer i

      endmod = ' '
      do i=1,ltoken
         endmod(i:i) = char(token(i))
      enddo
      lenmod = ltoken

      call outtab

      if (endmod .eq. 'module') then
! the trailing space is necessary if a name is given:  'end module foo'
         call putqs('end module ')
      else if (endmod .eq. 'select') then
         call putqs('end select')
      else if (endmod .eq. 'type') then
         call putqs('end type')
      else if (endmod .eq. 'where') then
         call putqs('end where')
      else
         call warn('end followed by improper keyword')
      endif

    end subroutine sendalpha

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

        subroutine sendmod
! end a module (subroutine or function)

  use cstat_mod

        integer, external :: gnbtok
        integer t, ierr
        character*32 endname
        integer i

        endname = ' '

        ierr = 0
        if(level .ne. 0) then
           call inform('do-block level not 0 at end.')
           ierr = 1
        elseif(iflevel .ne. 0) then
           call inform('if-block level not 0 at end.')
           ierr = 1
        elseif(sellev .ne. 0) then
           call inform('select statement level not 0 at end.')
           ierr = 1
        endif
        level = 0 ; iflevel = 0 ; sellev = 0

        call outtab
        call putqs('end')

        if (token(1) .eq. ESCAPE) then

           if (modtype(ifacelev) .ne. token(2)) then
              ierr = 1
              if (token(2) .eq. MFUNCTION) then
                 call warn('Should be "end function"')
                 call putqs(' function')
              else if (token(2) .ne. MSUBROUTINE) then
                 call warn('Should be "end subroutine"')
                 call putqs(' subroutine')
              else if (token(2) .ne. MPROGRAM) then
                 call warn('Should be "end program"')
                 call putqs(' program')
              else if (token(2) .ne. SBLOCK) then
                 call warn('Should be "end block data"')
                 call putqs(' block data')
              endif
           endif

           if (token(2) .eq. SBLOCK) then
              t = gnbtok(token,ltoken) ! assume 'data'
           endif

           ! look for optional name
           t = gnbtok(token,ltoken)
           if (t .eq. ALPHA) then
              endname = ' '
              do i=1,ltoken
                 endname(i:i) = char(token(i))
              enddo
              if (endname .ne. modname(ifacelev)) then
                 call warn('Module name does not match')
                 ierr = 1
              else
                call putqs(' ')
                call putqs(endname(1:ltoken))
              endif
              t = gnbtok(token,ltoken)
           endif

        else
           select case (modtype(ifacelev))
           case (MFUNCTION)
              call putqs(' function ')
           case (MSUBROUTINE)
              call putqs(' subroutine ')
           case (MPROGRAM)
              call putqs(' program ')
           case (SBLOCK)
              call putqs(' block data ')
           end select
           call putqs(modname(ifacelev)(1:len_trim(modname(ifacelev))))
        endif

        call outlin

        if (ifacelev .eq. 0) then
           call setmod(QUESTION,1)
           modfun = YES
           modtype(ifacelev) = 0
! reset the label generator
           call reset
        endif
        if(token(1) .ne. NEWLINE .and. ierr .eq. 0 ) call spit
        return
        end subroutine sendmod

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

        subroutine doerrp(argstk,i,j)
  use cmacro_mod
  use ctype_mod
        integer a1,a2,argstk(1),i,j,kk, iarg
        character*80 msg
        do iarg = i + 2, j
                a1 = argstk(iarg)
                a2 = argstk(iarg+1)
                write(msg,'(80a)') (char(evalst(a1-1+kk)), kk=1, a2-a1)
                call warn(msg(1:a2-a1))
        enddo
        return
      end subroutine doerrp

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

        subroutine doinfop(argstk,i,j)
  use cmacro_mod
  use ctype_mod
        integer a1,a2,argstk(1),i,j,kk, iarg
        character*80 msg
        do iarg = i + 2, j
                a1 = argstk(iarg)
                a2 = argstk(iarg+1)
                write(msg,'(80a)') (char(evalst(a1-1+kk)), kk=1, a2-a1)
                call rem(msg,a2-a1)
        enddo
        return
      end subroutine doinfop

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

        subroutine dofile(fil)
  use idircom_mod
  use cmacro_mod
  use cargs_mod
  use cstat_mod
  use cfile_mod
  use stdunits_mod
        character*(*) fil
        integer, external :: gnbtok,toktoi,zpakchrz
	character*(MPPL_MAXCARD) msg
        integer t,blanks(5),i,k
        integer idoflg, kesc
        integer dummy(1)
        integer, external :: initio

        do i=1,5
                blanks(i) = BLANK
        enddo
!
        if (initio(fil) .eq. ERR) return
! reset the label counter
        call reset
! initialize the argument stack
        cp = 0
        ap = 1
        ep = 1
! count of square brackets
        nlb = 0
! do/while/if levels
        level = 0
        iflevel = 0
        dotype(0) = 0
        labn(0) = 0
        labb(0) = 0
        used(0) = NO
! select stuff
        seltop = 0
        sellev = 0
        sellast = 1
! module name
        ifacelev = 0
        modtype(ifacelev) = 0
        call setmod(QUESTION,1)
        icontinue = 0
! idoflg = YES after seeing the label which terminates a regular do
        idoflg = NO
! process this file
! gtok returns the next token after expanding macros
! each for loop does one statement
        t=gnbtok(token,ltoken)
        do while (t .ne. EOF)
! if the previous statement was the end of a standard do statement...
                if(idoflg .eq. YES) then
                        call sedo
                        idoflg = NO
                endif

                if( t .eq. DIGIT) then
                        call putchr(blanks,5-ltoken)
                        call putchr(token,ltoken)
                        if(dotype(level) .eq. OLD) then
                                if(labn(level) .eq. toktoi(token,ltoken)) then
                                        idoflg = YES
                                endif
                        endif
                        call outtab
                        t = gnbtok(token,ltoken)
                endif
1000            continue
                if( t .eq. ESCAPE) then
                   select case (token(2))
                   case(SBLOCK)
                      call doblock
                   case(SDO)
                      call do_sdo
                   case(SENDDO)
                      call sedo
                   case(SNEXT)
                      call do_snext(dummy, 0)
                   case(SBREAK)
                      call sbrks(dummy, 0)
                   case(SUNTIL)
                      call do_suntil
                   case(SWHILE)
                      call do_swhile
                   case(SENDWHILE)
                      call sewhile
                   case(SIF)
                      call do_sif
                   case(SELSEIF)
                      call selif
                   case(SELSE)
                      call do_selse
                   case(SENDIF)
                      call do_sendif
                   case(MSUBROUTINE, MPROGRAM, MFUNCTION)
! domod might need to be called by eatup to handle 'type function blahblah..'
! so domod does not do the eatup since it might get called by eatup
                      call outtab
                      kesc = token(2)
                      call domod(kesc)
                      call eatup
                      call prolog
                   case(MEND)
                      call doend
                   case(MRETURN)
                      call doret(.false., dummy, 0)
                   case(SINCLUDE)
                      call doinc
! for -- discard marker character (used just to detect 'end for')
! rest of for accomplished with what was pushed back from arguments
                   case(SFOR)
                      t = gnbtok(token,ltoken)
                      go to 1000
                   case(SEFOR)
                      call do_sefor
                   case(SSELECT)
                      call do_sselect
                   case(SCASE, SDEFAULT)
                      kesc = token(2)
                      call do_scase(kesc)
                   case(SESELECT)
                      call do_seselect
                   case(MINTERFACE)
                      call doiface
! then (N. B. this only occurs if 'then' is illegally placed)
                   case(STHEN)
                      call warn("'then' is illegally placed in code")
                   case default
                      call warn("Unrecognized builtin")
                   end select
                elseif(t .eq. COL1C) then
			if(bckeep) then
!XXX				token(1) = 99
				token(1) = BANG
				k = zpakchrz(msg, len(msg), token, ltoken - 1)
				call wrline(stdout, msg, k)
			endif
                elseif( t.eq. NEWLINE) then
                    	if(bckeep) then
				call outlin
			endif
                elseif( t.eq. COMMENT) then
                    	if(bckeep) then
                           call putchr(token,ltoken)
!XXX- ?                         call eatup
!XXX- ?                         call outlin
			endif
                else
                        call outtab    !get past label field
                        call putchr(token,ltoken)
                        call eatup
                endif

              
              t=gnbtok(token,ltoken)
        enddo
        if(level .ne. 0) &
                call warn('do-block level not 0 at end of file.')
        if(iflevel .ne. 0) &
                call warn('if-block level not 0 at end of file.')
        if(sellev .ne. 0) &
                call warn('select statement level not 0 at end of file.')
        if( modname(0) .ne. '?') &
                call warn('Probably a missing end statement.')

! note, the file got closed by getlin
        return
        end subroutine dofile

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

      subroutine doif(argstk,i,j)
  use cmacro_mod
  use ctype_mod
      integer argstk(*),i,j
      integer, save ::  a1,a2,a3,a4,a5,i0,e1,e2,k,p,q
      logical, save :: match

      i0 = i + 2
      if(i0 + 2 .le. j) then
         a1 = argstk(i0+0)
         a2 = argstk(i0+1)
         a3 = argstk(i0+2)
         a4 = argstk(i0+3)
         e1 = a2 - 1
         e2 = a3 - 1
         do while((a1 .lt. a2) .and. (type(evalst(a1)) .eq. WHITE))
            a1 = a1 + 1
         enddo
         do while((e1 .ge. a1) .and. (type(evalst(e1)) .eq. WHITE))
            e1 = e1 - 1
         enddo

         do while((a2 .lt. a3) .and. (type(evalst(a2)) .eq. WHITE))
            a2 = a2 + 1
         enddo
         do while((e2 .ge. a2) .and. (type(evalst(e2)) .eq. WHITE))
            e2 = e2 - 1
         enddo
! At this point, a1 is the index of the first non-blank character of the
! first arg, e1 is the index of the last non-blank character of the first
! argument.  (Hence, if the argument is one character long, a1=e1.)  If
! the argument is null, (0 or more blank characters) then e1 = a1-1.
! Thus the length of the argument is always e1-a1+1, where null arguments
! have length = 0 by definition.  Similar statements apply for a2, e2.

! Argument 2 may be composed of several subexpressions, some of which
! may be null: "abc|xyz|" has 3 subexpressions, the last of which is null.
! Leading and trailing blanks are not significant, but embedded space is.
! p and q are used to point at the beginning and end of each subexpression
! in succession.  If a subexpression is null, then q = p-1.

         match = .false.
         do
            p = a2
            q = min(p,e2)
            do while((q.lt.e2) .and. (type(evalst(q)) .ne. VBAR))
               q = q + 1
            enddo
            if((q.ge.p) .and. (type(evalst(q)) .eq. VBAR))then
               a2 = q + 1 ! Move a2 to the beginning of the next subexpression
               q = q - 1
               do while((q.ge.p) .and. (type(evalst(q)) .eq. WHITE))
                  q = q - 1
               enddo
               do while((a2.le.e2) .and. (type(evalst(a2)) .eq. WHITE))
                  a2 = a2 + 1
               enddo
            endif
            if(e1-a1 .eq. q-p) then
               match = .true.
               do k = 0,e1-a1
                  if(evalst(a1+k) .ne. evalst(p+k)) match = .false.
               enddo
               if(match) exit
            endif
	    if(q .eq. e2) exit
         enddo

         if(match)then ! Push back arg3
            call pbstr(evalst(a3),a4-a3)
         else ! Push back arg4, if it's there
            if( i0 + 3 .le.j) then
               a5 = argstk(i0+4)
               call pbstr(evalst(a4),a5-a4)
            endif
         endif
      endif
      return
      end subroutine doif

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

        subroutine doifdf(argstk,i,j)
  use ctype_mod
  use cmacro_mod
        integer, external :: lookup
        integer a1,a2,a3,a4,e1,argstk(1),i,j, i0

        i0=i+2
        if( i0 + 1 .gt.j) return
        a1= argstk(i0)
        a2= argstk(i0+1)
        a3= argstk(i0+2)
        do while ((a1 .lt. a2) .and. (type(evalst(a1)) .eq. WHITE))
                        a1 = a1 + 1
        enddo
        e1 = a2-1
        do while ((e1 .gt. a1) .and. (type(evalst(e1)) .eq. WHITE))
                e1 = e1 - 1
        enddo
        e1 = e1 + 1
        if(lookup(e1-a1,evalst(a1)) .ge. 0) then 
!arg1 IS defined
                call pbstr(evalst(a2),a3-a2)
        else
                if(i0+2 .le.j) then          !it isn't
                        a4 = argstk(i0+3)
                        call pbstr(evalst(a3),a4-a3)
                endif
        endif
        return
      end subroutine doifdf

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

! if argument exists, blast it out immediately to output file

        subroutine doimed(argstk,i,j)
  use cmacro_mod
  use ctype_mod
  use cfile_mod
  use stdunits_mod
        integer a1,a2,argstk(1),i,j,larg,iarg
        character*(MPPL_MAXCARD) msg
	integer idummy
	integer, external :: zpakchrz
        do iarg = i + 2, j
	    a1 = argstk(iarg)
	    a2 = argstk(iarg+1)
	    larg = min(a2-a1,73)
	    if(larg .eq. 0) return
	    idummy = zpakchrz(msg, len(msg), evalst(a1),larg)
	    call wrline(stdout,msg,larg)
        enddo
        return
      end subroutine doimed

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

! include file named in next token

        subroutine doinc
  use params
  use idircom_mod
  use cfile_mod
  use cstat_mod
  use ctlvars_mod
  use stdunits_mod

        integer, external :: gnbtok
        character(FILENAMESIZE) fil, tmpfil
        character(2*FILENAMESIZE) ifil ! Twice as long as a Filename.
	character(2*FILENAMESIZE) inccom
        integer t, i, j, ierr, iind, n
!
        fil = ' '
        n = len(fil)
        j = 0
        t=gnbtok(token,ltoken)
! check for quoted string
        if (t .eq. QUOTE) then
           call outtab
           call putqs('include ')
           call putchr(token,ltoken)
           call outlin
           return
        endif

! save all tokens up to the newline
        do while (t .ne. NEWLINE)
           if(j + ltoken  .gt. n) call oops('Filename too long in include')
           do i=1,ltoken
              fil(j+i:j+i) = char(token(i))
           enddo
           j = j + ltoken
           t=gnbtok(token,ltoken)
        enddo

! save current contents of pbbuf
        if(pbbuf(1) .eq. COMMENT) then
                cbsav(inlev) = cbuf(1:lcbuf)
                lcsav(inlev) = lcbuf
        endif
        pblinl(inlev) = bp
        do i=1,bp
                pblins(i,inlev) = pbbuf(i)
        enddo
! arrange for input to come from the new file
        bp = 0
        if(inlev .eq. MPPL_MAXINLEV) call oops('Includes nested too deeply')
        inlev = inlev + 1
        filnam(inlev) = fil
        yyline(inlev) = 0
        tmpfil = fil
	call filopn(iusin(inlev),ierr,len_trim(tmpfil),tmpfil)
	if(ierr .ne. 0) then
	  j = 1
	  do while (j .le. inclnum)
	    ifil = incldirs(j)
	    iind = index(ifil," ") - 1
	    if (ifil(iind:iind) .ne. dirsep) then
	      iind = iind + 1
	      ifil(iind:iind) = dirsep
	    endif
	    ifil = ifil(:iind) // filnam(inlev)
	    tmpfil = ifil
	    call filopn(iusin(inlev),ierr,len_trim(tmpfil),tmpfil)
	    if (ierr .eq. 0) then
	      inccom = 'c%%%%%-included-file:' // ifil
	      call wrline( stdout, inccom, index(inccom,' ')  )
	      return
	    endif
            j = j + 1
	  enddo
	  inlev = inlev - 1
	  call oops('Could not open include file '//fil)
	endif
        inccom = 'c%%%%%-included-file:' // fil
        call wrline( stdout, inccom, index(inccom,' ')  )
        return
        end subroutine doinc

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

! handles program,subroutine,function

        subroutine domod(td)
  use cstat_mod
        integer td
        integer, external :: gnbtok
        integer t

        if (ifacelev .eq. 0) then
           if(modname(0) .ne. '?') then
              call warn('Nested subroutine, function or program.')
              return
           endif
           if(td .eq. MFUNCTION) then
              modfun = YES
           else
              modfun = NO
           endif
        endif

        t = gnbtok(token,ltoken)
        if(t .ne. ALPHA) then
                call warn('subroutine,function, or program statement error.')
                return
        endif
        if(ltoken .gt. 32) then
                call warn('Module name too long.')
                return
        endif
        call setmod(token,ltoken)
        modtype(ifacelev) = td

        if(td .eq. MPROGRAM) then
           call putqs('program ')
        elseif(td .eq. MSUBROUTINE) then
           call putqs('subroutine ')
        else
           call putqs('function ')
        endif
        call putchr(token,ltoken)
        return
      end subroutine domod

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------
        subroutine doiface
  use cstat_mod
        call outtab
        call putqs('interface ')
        ifacelev = ifacelev + 1
        
        return
      end subroutine doiface

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

        subroutine sendiface
  use cstat_mod
        ifacelev = ifacelev - 1
        call outtab
        call putqs('end interface')
        return
      end subroutine sendiface
!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

! look for value to be returned

        subroutine doret(in_if, stoken, sltoken)
  use cstat_mod
        logical in_if
        integer stoken(*), sltoken
        integer t
        integer, external :: gnbtok,gtok
        integer nlev

        t = gnbtok(token,ltoken)
        if( t .eq. LPAREN) then  !return for function value
                if(modfun .eq. NO) then
                        call warn('Attempt to return value from subroutine.')
                        return
                endif
                if (in_if) then
                   call putqs('then')
                   call outlin
                   iflevel = iflevel + 1
                endif
                call outtab
                call putqs(modname(0)(1:len_trim(modname(0))))
                call putqs(' = ')
                nlev = 1
                do
                        t = gtok(token,ltoken)
                        if(t .eq. LPAREN) then
                                nlev = nlev + 1
                        elseif(t .eq. RPAREN) then
                                nlev = nlev - 1
                                if (nlev .eq. 0) exit
                        elseif( t .eq. NEWLINE) then
                                call warn('Missing right parenthesis.')
                                return
                        endif
                        call putchr(token,ltoken)
                enddo
                call eatup
                call outtab
                call putqs('return')
                if (sltoken .gt. 0) call endcomment(stoken, sltoken)
                call outlin
                if (in_if) then
                   iflevel = iflevel - 1
                   call outtab
                   call putqs('endif')
                   call outlin
                endif
        else   !regular return statement
                call outtab
                call putqs('return')
                if(t .ne. NEWLINE) then
                        call putchr(token,ltoken)
                        ! XXX- what about comment?
                        call eatup
                else
                   if (sltoken .gt. 0) call endcomment(stoken, sltoken)
                        call outlin
                endif
        endif
        return
        end subroutine doret

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

        subroutine eatup
  use cstat_mod
  use ctype_mod
        integer, external :: gtok
        integer t, needlog, kesc

        needlog = 0
        t = gtok(token,ltoken)
        do while (t .ne. NEWLINE)
                if (t .eq. COMMENT) then
                        call endcomment(token, ltoken)
                else if( t.ne. ESCAPE) then
                        call putchr(token,ltoken)
                else
                     kesc = token(2)
                     if (kesc .eq. MFUNCTION .or. kesc .eq. MSUBROUTINE) then
!function can follow a type
                        call domod(kesc)      
                        needlog = 1
                     elseif( kesc .eq. MEND ) then
!for end=label in open statements
                        call putqs('end')   
                     else
                        call warn('Misused keyword (?)')
                     endif
                endif
                t = gtok(token,ltoken)
        enddo
        call outlin
        if( needlog .ne. 0) call prolog
        return
      end subroutine eatup

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

! expand args i through j; evaluate builtin or push back defn

        subroutine eval(argstk,i,j)
  use cmacro_mod
        integer argstk(ARGSIZE),i,j,k,m,n,t,td, ano, ml
        integer lbl(5),lenlbl,nl,nat,natl
        integer i23000
	integer k2
        integer, external :: labgen
!
        t = argstk(i)
        if(argstk(i+1) .eq. t ) then
                td = NULL
        else
                td = evalst(t)
        endif
!
        if( td .eq. ESCAPE) then
                select case (evalst(t+1))
                case (DEFTYPE)
                   call dodef(argstk,i,j)
                case (IFDEFTYPE)
                   call doifdf(argstk,i,j)
                case (IFELSETYPE)
                   call doif(argstk,i,j)
                case (ERRPRINTTYPE)
                   call doerrp(argstk,i,j)
                case (INFOPRINTTYPE)
                   call doinfop(argstk,i,j)
                case (DUMPDEFTYPE)
                   call dodmp(argstk,i,j)
                case (EVALUATETYPE)
                   call domath(argstk,i,j)
                case (IMMEDIATETYPE)
                   call doimed(argstk,i,j)
                case (UNDEFINETYPE)
                   call doundf(argstk,i,j)
                case (SMODTYPE)
                   call domodn(argstk,i,j)
                case default
                   go to 10
                endselect
                return
        endif
10      continue
! do replacement on text
! first scan for how many @n's needed
        nat = 0
        do k=t,argstk(i+1)-2
                if(evalst(k) .eq. ATSIGN) then
                        n = evalst(k+1) - ZERO
                        if(n .lt. 1 .or. n .gt. 9) then
                                call oops('Bad at sign argument in macro definition.')
                        endif
                        nat = max(nat,n)
                endif
        enddo
        if(nat .gt. 0) natl = labgen(nat)
! now scan text backwards looking for $n, @n
        k = argstk(i+1) - 1
outer:  do while (k.gt.t)
		if(evalst(k-1) .ne. ATSIGN .and. evalst(k-1) .ne. DOLLAR) then
			call putbak(evalst(k))
                        k = k - 1
			cycle
                endif
		! now decide if in COL1C area; if so, no expansion
		do k2 = k-1, t, -1
			if (evalst(k2) .eq. COL1C) then
				call putbak(evalst(k))
                                k = k - 1
				cycle outer
                	endif
			if (evalst(k2) .eq. NEWLINE) then
				exit
                	endif
		enddo

                if(evalst(k-1) .eq. ATSIGN) then
                        n = evalst(k) - ZERO
                        nl = natl + n - 1
                        call itotok(nl,lbl,lenlbl)
                        call pbstr(lbl,lenlbl)
                        k = k - 1
                else ! $n or $* or $- or $$ or $(other)
                        if(evalst(k) .eq. ASTERISK) then
                                ano=j-i-1
                                do while (ano.gt.0)
                                        n = i + ano + 1
                                        m = argstk(n)
                                        ml = argstk(n+1)-argstk(n)
                                        call pbstr(evalst(m),ml)
                                        if(ano.gt.1) call pbstr(COMMA,1)
                                        ano=ano-1
                                enddo
                        elseif(evalst(k) .eq. MINUS) then
                                ano=j-i-1
                                do while (ano.gt.1)
                                        n = i + ano + 1
                                        m = argstk(n)
                                        ml = argstk(n+1)-argstk(n)
                                        call pbstr(evalst(m),ml)
                                        if(ano.gt.2) call pbstr(COMMA,1)
                                        ano=ano-1
                                enddo
                        elseif(evalst(k) .eq. DOLLAR) then
				continue
                        else !look for digit
                                ano = evalst(k) - ZERO
                                if(ano .ge.0 .and. ano .le.9) then
                                        if ( ano .lt. j-i) then
                                                n = i + ano + 1
                                                m = argstk(n)
                                                ml = argstk(n+1)-argstk(n)
                                                call pbstr(evalst(m),ml)
                                        endif
                                else  ! other, leave it alone 
					call putbak(evalst(k))
                                endif
                        endif
                        k = k - 1 !skip over $
                endif
                k = k-1
        enddo outer
        if (k .eq. t) call putbak(evalst(k)) !do last character
             
        return
        end subroutine eval

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

! find integer after break,next statements if any

        subroutine getlev(nlev,argstk,i,j)
  use cstat_mod
  use cmacro_mod
        integer nlev,toktoi
        integer i,j,argstk(1)
        integer a1,a2

        if( j .gt. i + 2) &
                call warn('Too many arguments to break or next')
        a1 = argstk(i+2)
        a2 = argstk(i+3)
        if(a2 .gt. a1) then  !there is an argument
                nlev = toktoi(evalst(a1),a2-a1) - 1
        else
                nlev = 0
        endif
        return
      end subroutine getlev

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

!read the next line
!send comments out immediately

        subroutine getlin
  use cfile_mod
  use ctype_mod
  use icom_mod
  use ctlvars_mod
        integer i,c1,nextline

10      continue
        lcbuf = nextline(0)
        yyline(inlev) = yyline(inlev) + 1
        if( lcbuf .lt. 0) go to 2000 !!!!!END OF FILE
        if( lcbuf .eq. 0) go to 200
        c1 = ichar(cbuf(1:1))
        if( c1 .eq. PERIOD) go to 2000  !alternate method for end-of-file

! is this a comment?
        if(col1(c1) ) then
                pbbuf(1) = COMMENT
                bp = 1
                cbuf(1:1) = 'X'  ! BANG
                return
        endif
        if(type(c1) .eq. COMMENT) then
                pbbuf(1) = COMMENT
                bp = 1
                cbuf(1:1) = 'X'   ! BANG
                return
        endif
200     continue
        bp = lcbuf + 1
        pbbuf(1) = NEWLINE
! line goes backward into pbbuf
        do i=1,lcbuf
                pbbuf(bp + 1 - i) = ichar(cbuf(i:i))
        enddo
! is this a continued line ?
        if(bp .lt. 7 .or. .not. col6 ) return
        if(cbuf(1:5) .eq. '     ' .and. type(pbbuf(bp-5)) .ne.WHITE) then
! delete the unwanted part
                bp = bp - 5
                pbbuf(bp) = NULL
        endif
        return
! end-of-file
2000    continue
	call filcls(iusin(inlev))
        inlev = inlev - 1
        if(inlev .gt. 0) then !back to previous file
                call popyin(iusin(inlev),len_trim(filnam(inlev)),filnam(inlev))
                bp = pblinl(inlev)
                do i=1,bp
                        pbbuf(i) = pblins(i,inlev)
                enddo
                if(pbbuf(1) .eq. COMMENT) then
                        cbuf = cbsav(inlev)
                        lcbuf = lcsav(inlev)
                endif
        else
                bp = 1
                pbbuf(bp) = EOF
        endif
        return
        end subroutine getlin

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

! return next token, length of which is toksiz
! on NEWLINE, check for following NULL which means line is continued
!             check if last non-white token indicates continuation

        function gettok(token,toksiz)
  use ctype_mod
  use cfile_mod
  use cmacro_mod
  use stdunits_mod
        integer gettok
        integer toksiz
        integer token(2)
        integer i,j,n
        character*(MPPL_MAXCARD) msg
        integer, external :: toktoi, zpakchrz
        character qte

! look at next character first
! gettok is the only routine allowed to take anything OUT of pbbuf
300     continue
        if(bp .eq. 0) call getlin
        token(1) = pbbuf(bp)
        gettok = type(token(1))
        if(gettok .eq. EOF) return
        bp = bp - 1
        toksiz = 1
! pbbuf has only a NEWLINE, EOF, or COMMENT in position 1
! in the case of COMMENT, the text is still in cbuf
! a newline might not count if the following character is NULL
! ALPHAS, DIGITS can not be broken over continued lines
        go to (1,2,3,4,5,6,7,8,9,10),tokgo(gettok)
! NEWLINE
2       if(bp .gt.0 ) return
! check ahead for possible continuation
        call getlin
        if(pbbuf(bp) .eq. NULL) then
                bp = bp - 1
                go to 300
        endif
        if(lnbt .eq. YES .and. pbbuf(bp) .ne. EOF) go to 300
        lnbt = NO
        return
! LETTER
3       do i=bp,1,-1
                if( alphan(pbbuf(i)) .eq. NO) exit
        enddo
        do j=bp,i+1,-1
                token(2+bp-j) = pbbuf(j)
        enddo
        toksiz = 1 + bp - i
        bp = i
        gettok = ALPHA
        lnbt = NO
        return
! QUOTE
4       i = bp
500     continue
        if(i .eq. 1) then   !at end of line, check for continuation
                do j=bp,2,-1
                        token(toksiz+bp+1-j) = pbbuf(j)
                enddo
                toksiz = toksiz + bp - 1
                call getlin
                if(pbbuf(bp) .eq. NULL) then
                        bp = bp -1
                        i  = bp
                        go to 500
                endif
                qte=char(token(1))
                call inform('Missing quote ('//qte//')')
                lnbt = NO
                call putbak(NEWLINE)
                return
        endif
        if( pbbuf(i) .eq. token(1) ) then
! probably the end but watch out for doubled quote
                if(pbbuf(i-1) .ne. token(1)) go to 501
                i = i - 1
        endif
        i = i - 1
        go to 500
501     continue
        do j=bp,i,-1
                token(toksiz+bp+1-j) = pbbuf(j)
        enddo
        toksiz = toksiz + 1 + bp - i
        bp = i - 1
        lnbt = NO
        return
! WHITE
5       do i=bp,1,-1
                if( type(pbbuf(i)) .ne. WHITE ) exit
        enddo
        token(1) = BLANK
        bp = i
!avoid setting lnbt on white
        return
! DIGIT
6       do i=bp,1,-1
                if( type(pbbuf(i)) .ne. DIGIT ) exit
        enddo
        do j=bp,i+1,-1
                token(2+bp-j) = pbbuf(j)
        enddo
        toksiz = 1 + bp-i
        bp = i
! peek ahead for Hollerith
        if(pbbuf(bp) .eq. 72 .or. pbbuf(bp) .eq. 104) then
                if(toksiz .gt. 2) call oops('Hollerith count too large.')
                n = toktoi(token,toksiz)
                if( n .ge. bp - 1) call oops('Hollerith constant error.')
                toksiz = toksiz + 1
                token(toksiz) = pbbuf(bp)
                do i = 1, n
                        token(toksiz+i) = pbbuf(bp - i)
                enddo
                toksiz = toksiz+n
                gettok = QUOTE
                bp = bp - (n+1)
        endif
        lnbt = NO
        return
! COMMENT
7       continue
        if(bp .eq. 0) then   !whole line a comment
                token(1) = COL1C
                gettok = COL1C
                toksiz = lcbuf + 1
                do i = 2, lcbuf
                        token(i) = ichar(cbuf(i:i))
                enddo
                token(toksiz) = NEWLINE
                lnbt = NO
                if(toksiz .gt. col72 + 1) then
                        if(cbuf(2:5) .eq. "$omp" .or. cbuf(2:5) .eq. "$OMP") then
                                call inform("c$omp line too long.")
                                call inform(cbuf(1:lcbuf))
                        endif
                endif
                return
        endif
        token(1) = BANG
        do j=bp,2,-1
                if(pbbuf(j) .eq. NEWLINE) exit
        enddo
        if( bckeep.and.(cp.eq.0)) then
                toksiz = bp - j + 1
                do i = bp, j+1, -1
                        token(2 + bp - i) = pbbuf(i)
                enddo
!XXX                call putchr(token, toksiz)
!XXX                toksiz = zpakchrz(msg, len(msg), token, toksiz)
!XXX                call wrline(stdout,msg,toksiz)
        endif
        bp = j
        return
!XXX        go to 300
! BACKSLASH
8       lnbt = YES
        go to 300
! ESCAPE (code)
9       token(2) = pbbuf(bp)
        toksiz = 2
        bp = bp -1
        lnbt = NO
        return 
! COL1C
10      do j = bp, 1, -1
		token(2 + bp - j) = pbbuf(j)
		if(pbbuf(j) .eq. NEWLINE) go to 11
	enddo
	call oops('Comment line token damaged. Internal error.')
11	continue
	toksiz = 2 + bp - j
	bp = j - 1
	lnbt = NO
	return
! remark: otherwise is a single letter token, returns as itself
1       lnbt = contu(gettok)
        return
        end function gettok

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

        function gnbtok(token,ltoken)
          use params
        integer gnbtok,token(*),ltoken
        integer, external :: gtok

        gnbtok = gtok(token,ltoken)
        do while(gnbtok .eq. WHITE)
                gnbtok = gtok(token,ltoken)
        enddo
        return
      end function gnbtok

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

        function gtok(token,ltoken)
  use cfile_mod
  use cmacro_mod
  use cargs_mod
  use ctype_mod
  use ctlvars_mod
        integer gtok
        integer token(1),ltoken
        integer addr
        integer, external :: lookup,gettok,peek,putdef
        integer t
! return with next token after resolving macro definitions
        t=gettok(token,ltoken)
        do while (t .ne. EOF)
! if token is alphanumeric, see if it is a macro and expand it if
! we are not inside square brackets
                if(t .eq. ALPHA ) then
                        if(nlb .gt. 0) go to 100  !no lookup if inside brackets
                        addr = lookup(ltoken,token)
                        if(addr .eq. -1) go to 100
! token is a macro ; set up stack frame
                        cp = cp + 1
                        if(cp .gt. CALLSIZE) then
                                cp = CALLSIZE
                                call oops('Macro error, call stack overflow.')
                        endif
                        mline(cp) = yyline(inlev)
                        mlev(cp) = inlev
                        callst(cp) = ap
!start stack frame
                        call push(ep,argstk,ap)
!stack definition
                        if(putdef(addr,evalst,ep,EVALSIZE).ne.0) then
                           call oops('Evaluation stack overflow.')
                        endif
                        call push(ep,argstk,ap)
!stack name
                        call putarg(token,ltoken)
                        call push(ep,argstk,ap)
!add parenthesis if they are not already on the way
! peek returns YES if next non-blank character matches its argument
                        t = peek(LPAREN)
                        if(t .eq. NO) then  !push back parens
                                call putbak(RPAREN)
                                call putbak(LPAREN)
                        else
                                do while (t .ne. LPAREN)
                                        t=gettok(token,ltoken)
                                enddo
                                call putbak(LPAREN)
                        endif
                        plev(cp) = 0
! start collecting arguments
                        t=gettok(token,ltoken)
                        cycle
                elseif(t.eq.LBRACK) then
                        nlb = nlb + 1
!strip one level of []
                        if(nlb .eq. 1) then
                           t=gettok(token,ltoken)
                           cycle
                        endif
                elseif(t.eq.RBRACK) then
                        nlb = nlb - 1
                        if(nlb .lt. 0) then
                                call inform('Extraneous right square bracket.')
                                nlb = 0
                        endif
                        if(nlb .eq. 0) then
                           t=gettok(token,ltoken)
                           cycle
                        endif
                endif
100     continue
                if(cp .eq. 0) then  ! not in a macro, this is the token we want
                        gtok = t
                        return
                     endif
! if inside square brackets just copy token
                if(nlb .gt. 0) then
                        call putarg(token,ltoken)
! argument collection, look for commas, but not inside parens
                elseif(t.eq.LPAREN) then
                        if(plev(cp) .gt. 0) call putarg(token,ltoken)
                        plev(cp) = plev(cp) + 1
                elseif(t.eq.RPAREN) then
                        plev(cp) = plev(cp) - 1
                        if(plev(cp) .gt. 0 ) then
                                call putarg(token,ltoken)
                        else    !end of argument list found !
! evaluate the macro and its arguments
                                argstk(ap) = ep
                                call eval(argstk,callst(cp),ap-1)
!pop evaluation stack
                                ap = callst(cp)
                                ep = argstk(ap)
                                cp = cp - 1
                        endif
                elseif(t .eq. COMMA .and. plev(cp) .eq. 1) then    !new arg
                        call push(ep,argstk,ap)
                else
                        call putarg(token,ltoken)   !just stack it
                endif
                t=gettok(token,ltoken)
        enddo  ! end of gettok call loop
! arrive here if end-of-file, check for screwed up [] or parens
        if(cp .ne. 0 ) &
                call oops( &
                'Unexpected end of file in macro arguments--missing ) or ] ?')
        if(nlb .gt. 0) &
             call oops('Missing right square bracket, at end-of-file.')
        gtok = EOF
        return
        end function gtok

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

        subroutine init
  use idircom_mod
  use ctype_mod
  use cstat_mod
  use cfile_mod
        integer i
! default include directory separator (a slash)
        dirsep = '/'
        inclnum = 0
! type table and switch tables
        call setsen
        do i=LEXMIN,LEXMAX
                type(i) = i
                alphan(i) = NO
                contu(i) = NO
                tokgo(i) = 1
                col1(i)  = .false.
        enddo
        do i=DECIDELOW,DECIDEHI
                decide(i) = 1
        enddo
        do i=48,57
                type(i) = DIGIT
                alphan(i) = YES
        enddo
        do i=65,90
                type(i) = LETTER
                alphan(i) = YES
        enddo
        do i=97,122
                type(i) = LETTER
                alphan(i) = YES
        enddo
        type(BLANK) = WHITE
        type(TAB) = WHITE
        type(UNDERSCORE) = LETTER
        type(SEMICOLON) = NEWLINE
        type(TICK) = QUOTE
        type(BANG) = COMMENT
        type(POUND) = COMMENT
        type(BANG) = COMMENT
        type(ESCAPE) = ESCAPE
        tokgo(NEWLINE)=2
        tokgo(LETTER)=3
        tokgo(QUOTE)=4
        tokgo(WHITE)=5
        tokgo(DIGIT)=6
        tokgo(COMMENT)=7
        tokgo(BSLASH)=8
        tokgo(ESCAPE)=9
	tokgo(COL1C)=10
        decide(SBLOCK)=1
        decide(SDO)=2
        decide(SENDDO)=3
        decide(SNEXT)=4
        decide(SBREAK)=5
        decide(SUNTIL)=6
        decide(SWHILE)=7
        decide(SENDWHILE)=8
        decide(SIF) = 9
        decide(SELSEIF) = 10
        decide(SELSE) = 11
        decide(SENDIF) = 12
        decide(MSUBROUTINE)=13
        decide(MPROGRAM)=13
        decide(MFUNCTION)=13
        decide(MEND)=14
        decide(MRETURN)=15
        decide(SINCLUDE)=16
        decide(SFOR)=17
        decide(SEFOR)=18
        decide(SSELECT)=19
        decide(SCASE)=20
        decide(SDEFAULT)=20
        decide(SESELECT)=21
        decide(MINTERFACE)=22
        decide(STHEN)=23
        alphan(UNDERSCORE) = YES
! characters which cause a line to be continued
        contu(PLUS) = YES
        contu(MINUS) = YES
        contu(ASTERISK) = YES
! can't do it on SLASH because of data statement
        contu(LPAREN) = YES
        contu(BSLASH) = YES
        contu(EQUALS) = YES
        contu(COMMA) = YES
        contu(VBAR) = YES
        contu(AMPERSAND) = YES
        contu(TILDE) = YES
        contu(LANGLE) = YES
        contu(RANGLE) = YES
! characters which are a comment in column 1
        col1(99) = .true.  !  c
        col1(67) = .true.  !  C
        col1(ASTERISK) = .true.
! column 6 continuation conventions
        col6 = .true.
        return
        end subroutine init

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

        integer function initio(fil)
  use params
  use cfile_mod
  use ctlvars_mod
  use stdunits_mod
        character*(*) fil
        integer il, ierr
! initialize input and output buffers
        character(FILENAMESIZE) tmpfil
        inlev = 1
        filnam(inlev) = fil
        call setmod(QUESTION,1)
        yyline(inlev) = 0
        lastpc = 0      !output line empty
        bp = 0          !push back buffer empty
10      continue

        il = len(filnam(inlev))
        do while (il .gt. 0)
            if(' ' .ne. filnam(inlev)(il:il)) go to 20
            il=il-1
        enddo
20      continue
        if( verbose) then
          write(stderr,101) filnam(inlev)(1:il)
101       format('   Preprocessing ',a)
        endif

        tmpfil = filnam(inlev)
        call filopn(iusin(inlev),ierr,len_trim(tmpfil),tmpfil)
	if(ierr .ne. 0 ) go to 200
        initio = OK
        return
200     continue
        write(stderr,100) filnam(inlev)(1:il)
100     format('  Could not open input file ',a)
        call warn('  ******** Will proceed if others can be opened **********')
        initio = ERR
	return
        end function initio

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

! return the current value of modnam

        subroutine domodn(argstk,i,j)
  use cstat_mod
        integer argstk(1), i, j

        call cpbstr(modname(0)(1:len_trim(modname(0))))
        return
      end subroutine domodn

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

        subroutine itotok(n,token,ltoken)
! convert n into a string in token, length to ltoken
          use params
        integer n,token(1),ltoken
        character*16 target
        integer i,j
        if(n .eq. 0) then
                ltoken = 1
                token(1) = ZERO
                return
        endif
        write(target,100) n
100     format(i16)
        do i=1,16
                if( target(i:i) .ne. ' ') exit
        enddo
        i = i - 1
        ltoken = 16 - i
        do j = 1, ltoken
                token(j) = ichar(target(i+j:i+j))
        enddo
        return
        end

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

        function labgen(n)
  use clabs_mod
        integer labgen,n
        labgen = labnxt
        labnxt = labnxt + n
        return
      end function labgen

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

        subroutine reset
  use clabs_mod
        labnxt = laborg
        return
      end subroutine reset

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

        subroutine setmod(name,lname)
  use cstat_mod
        integer name(1),lname,i,j
        modname(ifacelev) = ' '
        do i=1,lname
           modname(ifacelev)(i:i) = char(name(i))
        enddo
        return
      end subroutine setmod

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

        subroutine setorg(n)
  use clabs_mod
        integer n
        laborg = n
        return
      end subroutine setorg

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

        subroutine oops(msg)
          use params
        character*(*) msg
        call warn(msg)
        call finish(FATALERROR)
      end subroutine oops

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

        subroutine warn(msg)
  use cfile_mod
        character*(*) msg
        call inform(msg)
! attempt to recover to next line
        call outlin
        bp = 1
        return
      end subroutine warn

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

        subroutine inform(msg)
  use cmacro_mod
  use cfile_mod
  use cstat_mod
  use cargs_mod
  use ctlvars_mod
  use stdunits_mod
        character*(*) msg
        integer igoof,ilev,jlev,a1,a2,j,il, ip, jl,k
        character*56 mname

        finerr = finerr+1
        write(stderr,90) modname(0),msg
        ilev = inlev
        if(pbbuf(bp) .eq. EOF) ilev = ilev + 1
        jlev = ilev
        do while(ilev .gt. 0)
	    igoof = yyline(ilev)
	    il = 1
	    do while (filnam(ilev)(il:il) .ne. ' ')
		if(il .eq. len(filnam(ilev))) exit
                il=il+1
	    enddo
	    if(ilev .eq. jlev) then
		write(stderr,100) igoof,filnam(ilev)(1:il)
		do ip = 1,cp
		    a1 = argstk(callst(ip)+1)
		    a2 = argstk(callst(ip)+2) - 1
		    jl = min(a2-a1+1,56)
		    do j=1,jl
			mname(j:j)=char(evalst(a1-1+j))
		    enddo
		    if(mname.eq.'Errprint') exit
		    if(mname.eq.'Infoprint') exit
		    k=len_trim(filnam(mlev(ip)))
		    if(ip .eq. 1) then
			write(stderr,103) &
                             mname(1:jl),mline(ip),filnam(mlev(ip))(1:k)
		    else
			write(stderr,104) &
                             mname(1:jl),mline(ip),filnam(mlev(ip))(1:k)
		    endif
		enddo
	    else
		write(stderr,101) igoof-1,filnam(ilev)(1:il)
	    endif
	    ilev = ilev - 1
        enddo ! ilev .gt. 0
        call outlin
        return
 90     format(' mppl error : module = ',a/1x,a)
100     format(' Near line no. ',i5,' in file ',a)
101     format(' (Included from line no. ',i5,' in file ',a,')')
103     format(' ERROR OCCURRED DURING MACRO/KEYWORD PROCESSING:',/, &
               ' Error in  ',a,' which began on line ',i5,' of file ',a)
104     format(' which called  ',a,' on line ',i5,' of file ',a)
        end

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

! put out the statement 'n continue'

        subroutine outcnt(n)
  use cfile_mod
        integer n

        if( lastpc .gt. 0) then
                call inform('Label not permitted on this kind of statement.')
        endif
        call puti5(n)
        call outtab
        call putqs('continue')
        call outlin
        return
      end subroutine outcnt

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

! put the statment 'go to n' into the output buffer, call outlin

        subroutine outgo(n)
        integer n

        call putqs('go to ')
        call puti5(n)
        call outlin
        return
      end subroutine outgo

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

        subroutine outifl
! if a label is already present, output a continue on it
! otherwise do nothing
! used to handle labels on statements that generate their own label
! like while, block do
  use cfile_mod
        if(lastpc .eq. 0) return
        call outtab
        call putqs('continue')
        call outlin
        return
      end subroutine outifl

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

! outputs one line

        subroutine outlin
  use cfile_mod
  use stdunits_mod
        character*(MPPL_MAXCARD) msg
	integer n
	integer, external :: zpakchrz

       	n = zpakchrz(msg, len(msg), outbuf,lastpc)
       	call wrline(stdout,msg,n)
        lastpc = 0
        icontinue = 0
        return
      end subroutine outlin

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

! get past statement field
! if already there, do nothing

        subroutine outtab
  use cfile_mod
  use cstat_mod
        integer newpc, i
        if(lastpc .gt. 5) return
!XXX-
        newpc=8+(iflevel + level + sellev + ifacelev + icontinue)*3
!        newpc=6+(iflevel + level + sellev + ifacelev + icoitinue)*3
        do i=lastpc+1,newpc
                outbuf(i) = BLANK
        enddo
        lastpc = newpc
        return
      end subroutine outtab

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

        subroutine pbstr(in,n)
! push back in
  use cfile_mod
        integer in(1)
        integer n
        integer i,bpnew
        bpnew = bp + n
        if(bpnew .gt. BUFSIZE) &
                call oops('Macro processor error in pbstr:'// &
                ' too many characters pushed back')
        do i = 1, n
                pbbuf(bp + i) = in(n + 1 - i)
        enddo
        bp = bpnew
        return
      end subroutine pbstr

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

! return YES if next non-blank is c, NO otherwise
! only checks in this line

        function peek(c)
  use ctype_mod
  use cfile_mod
        integer c,peek
        integer i
        do i=bp,2,-1
                if(type(pbbuf(i)) .ne. WHITE) exit
        enddo
        if(pbbuf(i) .eq. c) then
           peek = YES
        else
           peek = NO
        endif
        return
      end function peek

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

! insert a statement Prolog after each module card

        subroutine prolog
  use cstat_mod
        if (ifacelev .eq. 0) then
           call putbak(NEWLINE)
           call cpbstr('      Prolog')
        endif
        return
      end subroutine prolog

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

        subroutine push(ep,argstk,ap)
  use params
        integer ep,argstk(ARGSIZE),ap

        if(ap .ge. ARGSIZE) &
                call oops('Macro processor error: argument stack overflow.')
        argstk(ap) = ep
        ap = ap + 1
      end subroutine push

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

        subroutine putarg(cout,n)
  use cmacro_mod
        integer i,n
        integer cout(1)
        if(ep + n .gt. EVALSIZE) &
                call oops('Macro processor error: evaluation stack overflow.')
        do i=1,n
                evalst(ep - 1 + i ) = cout(i)
        enddo
        ep = ep + n
        return
      end subroutine putarg

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

        subroutine putbak(c)
  use cfile_mod
        integer c
        bp = bp + 1
        if(bp .gt. BUFSIZE) &
                call oops('Macro processor error: '// &
                'too many characters pushed back.')
        pbbuf(bp) = c
        return
      end subroutine putbak

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

        subroutine putchr(cout,n)
  use cfile_mod
  use stdunits_mod
        integer i,n, nc, idone, lastpc_keep
        integer cout(1)
	integer zpakchrz, k
        character*(MPPL_MAXCARD) msg
        if( lastpc + n .le. col72 ) then
                do i=1,n
                        outbuf(lastpc + i) = cout(i)
                enddo
                lastpc = lastpc + n
                return
        endif
! doesn't fit
! blast out existing line, set up for continuation
        outbuf(lastpc + 1) = BLANK
        outbuf(lastpc + 2) = AMPERSAND
        icontinue = 1
        lastpc = lastpc + 2
        k = zpakchrz(msg, lastpc, outbuf, lastpc)
        call wrline(stdout, msg, k)
!XXX        lastpc = 6
!XXX        do i=1,5
!XXX                outbuf(i) = BLANK
!XXX        enddo
!XXX        outbuf(6) = AMPERSAND
        lastpc = 1
        call outtab
        lastpc_keep = lastpc ! remember indention level

        if (cout(1) .ne. QUOTE .and. cout(1) .ne. TICK) then
           ! print out token, even if very long
           do i=1,n
              outbuf(lastpc + i) = cout(i)
           enddo
           lastpc = lastpc + n
        else
! split long quoted strings
! watch out for extremely long tokens
           nc = 0
           do
              if( lastpc + n - nc .le. col72) then
                 do i=1,n-nc
                    outbuf(lastpc + i) = cout(nc + i)
                 enddo
                 lastpc = lastpc + n - nc
                 return
              endif
              idone = col72 - lastpc - 1
              do i=1,idone
                 outbuf(lastpc + i) = cout(nc + i)
              enddo
              outbuf(col72) = AMPERSAND
              k = zpakchrz(msg,col72, outbuf,col72)
              call wrline(stdout,msg,k)
              lastpc = lastpc_keep + 1
              nc = nc + idone
              outbuf(lastpc) = AMPERSAND
           enddo
        endif
      end subroutine putchr
        
!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

        subroutine puti5(n)
! adds the character representation of n to the current output line
! used only for label fields...right adjust in 5 characters
  use params
        integer n, m, i
        integer lb(5)
        m = n
        lb(5) = mod(m,10) + ZERO
        m = m/10
        do i=4,1,-1
                if( m .eq. 0) then
                        lb(i) = BLANK
                else
                        lb(i) = mod(m,10 ) + ZERO
                        m = m/10
                endif
        enddo
        call putchr(lb,5)
        return
      end subroutine puti5

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

        subroutine putlab(token,ltoken)
  use cfile_mod
        integer token(1),ltoken, i
        do i=1,ltoken
                outbuf(i) = token(i)
        enddo
        do i=ltoken+1,6
                outbuf(i) = BLANK
        enddo
        lastpc = 6
        return
      end subroutine putlab

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

        subroutine putqs(str)
  use cfile_mod
        character*(*) str
        integer i,n
        integer qs(80)
        n = len(str)
        do i=1,n
                qs(i) = ichar(str(i:i))
        enddo
        call putchr(qs,n)
        return
      end subroutine putqs

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

! look for digit after the next

        subroutine sbrks(stoken,sltoken)
  use cstat_mod
        integer stoken(*), sltoken
        integer t
        integer, external :: gnbtok,toktoi
        integer nlev

        t = gnbtok(token,ltoken)
        if( t .eq. DIGIT) then
! XXX- warn about this
                nlev = toktoi(token,ltoken) - 1
                t = gnbtok(token,ltoken)
        else
                nlev = 0
        endif
        call outtab
        call putqs('exit')
        if (t .eq. COMMENT) then
              call endcomment(token, ltoken)
              t = gnbtok(token,ltoken)
        endif
! shouldn't be anything else here
        if( t .ne. NEWLINE) then
                call warn('Illegal syntax in -break- statement.')
                return
        elseif(level-nlev .le. 0) then
                call warn('Illegal -break- statement, level wrong')
                return
        endif
        if (sltoken .gt. 0) call endcomment(stoken, sltoken)
        call outlin
!XXX        call outgo(labb(level-nlev))
!XXX        used(level-nlev) = YES
        return
      end subroutine sbrks

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

        subroutine do_sdo
  use cstat_mod
        integer, external :: labgen,gnbtok,toktoi
        integer t, n

! expand a do statement -- statement might have a label
! peek ahead
        t = gnbtok(token,ltoken)
        if(t .eq. DIGIT) then  !Old style, user supplied label for the end
                call outtab   ! get past statement field
                call putqs('do ') !put out 'do '
                level = level + 1
                dotype(level) = OLD
                labb(level) = labgen(1)
                labn(level) = toktoi(token,ltoken)
                call putchr(token,ltoken)
                call eatup
                used(level) = NO
        elseif(t .eq. NEWLINE .or. t .eq. COMMENT) then
                call outtab
                call putqs('do') !put out 'do '
                if (t .eq. COMMENT) then
                   call endcomment(token, ltoken)
                   t = gnbtok(token,ltoken)
                endif
                call outlin
!XXX                call outifl
                n = labgen(1)
!XXX                call outcnt(n)  !target for repeat, until
                level = level + 1
                dotype(level) = BLOCK
                labn(level) = n
                labb(level) = labgen(1)
                used(level) = NO
        else  ! new style do var=... or do for var=...
                if (t .eq. ESCAPE) then
                        if(token(2) .eq. SFOR) then
                           t=gnbtok(token,ltoken)
                        elseif(token(2) .eq. SWHILE) then
                           call do_swhile
                           return
                        else
                           call warn(' Syntax error in do statement.')
                           return
                        endif
                endif
                call outtab
                call putqs('do ') !put out 'do '
                level = level + 1
                dotype(level) = REGULAR
                labn(level) = labgen(1)
                labb(level) = labgen(1)
                used(level) = NO
!XXX                call puti5(labn(level))
!XXX                code(1) = BLANK
!XXX                call putchr(code,1)
                call putchr(token,ltoken)
                call eatup
        endif
        return
        end

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

! process enddo or labeled target of traditional do

        subroutine sedo
  use cstat_mod
        integer, external :: gnbtok
        integer it,nlev,lab,i

        if(level .eq. 0) then
                call warn('Unmatched end of do block.')
                return
        endif
        it = dotype(level)
        if(it .eq. REGULAR) then
!XXX                call outifl
                level = level - 1
!XXX                call outcnt(labn(level+1))
!XXX                if(used(level+1) .eq. YES) call outcnt(labb(level+1))
                call outtab   ! get past statement field
                call putqs('enddo')
                call spit
                call outlin
        elseif(it .eq. OLD) then
! dofile has just processed the labeled statement on a traditional do
! put out the continue statements for breaks
! have to watch out for the case of multiple old-style dos with the
! SAME target  i.e. do 200 i= 1,100 ; do 200 j=1,100 ; .... 200 continue
                nlev = level   !save level for later use
                lab = labn(level)
                level = level - 1
! get the new level of indentation
                do while(labn(level) .eq. lab)  !this is sure to stop (labn(0)=0)
                        level = level - 1
                enddo
                do i=nlev,level+1,-1
                        if(used(i) .eq. YES) call outcnt(labb(i))
                enddo
        elseif(it .eq. BLOCK) then
!XXX                call outifl
!XXX                call putqs('c -- repeat')
!XXX                call outlin
                level = level - 1
                call outtab
                call putqs('enddo')
                call spit
                call outlin
!XXX                call outgo(labn(level+1))
!XXX                call spit
!XXX                if(used(level+1) .eq. YES) call outcnt(labb(level+1))
        elseif(it .eq. WHILE) then
                call sewhile
        endif
        return
      end subroutine sedo

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

        subroutine do_sefor
        use cstat_mod
        integer nforiter

        if (foriter(level) .ne. " ") then
           call outtab
           nforiter = len_trim(foriter(level))
           call putqs(foriter(level)(:nforiter))
           call outlin
        endif
        call sedo
!XXX        call putqs('c endfor')
!XXX        call outlin
        return
      end subroutine do_sefor

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

! process elseif statement
! call docond to output condition & translate logical operators
! elseif (condition) must be followed by then; we supply even if missing

        subroutine selif
  use cstat_mod
        integer t
        integer, external :: gnbtok,docond
!
        if(iflevel .eq. 0) then
                call warn('Elseif not inside if block.')
                return
        endif
        iflevel = iflevel - 1
        call outtab
        call putqs('elseif ')
        if(docond() .ne. 0) return
        call putqs('then')
        iflevel = iflevel + 1
        t = gnbtok(token,ltoken)
        if (t .eq. COMMENT) then
           call endcomment(token, ltoken)
           t = gnbtok(token,ltoken)
        endif
	if(t.eq.NEWLINE) then
	        do while(t.eq.NEWLINE)
			t = gnbtok(token,ltoken)
		enddo
		call pbstr(token,ltoken)
                call outlin
		return
	endif
        if( t .eq. ESCAPE) then
                if(token(2).eq.STHEN) then
                   call spit
                   call outlin
                   return
                endif
        endif
        call warn('Syntax error in elseif statement.')
        call spit
        call outlin
        return
      end subroutine selif

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

        subroutine do_selse
  use cstat_mod
        integer, external :: gnbtok
        integer t
!
        if(iflevel .eq. 0) then
                call warn('Unmatched else.')
                return
        endif
        t = gnbtok(token,ltoken)
! check for 'else if' which is treated as elseif
        if(t .eq. ESCAPE) then
                if(token(2) .eq. SIF) then
                        call selif
                        return
                endif
        endif
        iflevel = iflevel - 1
        call outtab
        call putqs('else')
        if (t .eq. NEWLINE) then
           call outlin
        else if (t .eq. COMMENT) then
           call endcomment(token, ltoken)
        else
           call outlin
           call warn('Syntax error in else statement')
        endif
        iflevel = iflevel + 1
        return
      end subroutine do_selse

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

        subroutine do_sendif
  use cstat_mod
        if(iflevel .eq. 0) then
                call warn('Unmatched endif.')
                return
        endif
        iflevel = iflevel - 1
        call outtab
        call putqs('endif')
        call spit
        call outlin
        return
      end subroutine do_sendif

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

        subroutine setopt(optstr)
! processes all the options
  use irset_mod
  use idircom_mod
  use cfile_mod
  use ctype_mod
  use icom_mod
  use ctlvars_mod
  use fname_mod
  use stdunits_mod
        character*(*) optstr
        integer c1,i, i23000, n, i23005, ind1
	integer ierr
	integer, external :: evalone
! is passed the option string with the leading - removed
        c1 = ichar(optstr(1:1))
        select case (c1)
          case (ZERO-NINE)
                n = c1 - ZERO
                do i=2,len(optstr)
                        c1 = ichar(optstr(i:i))
                        select case (c1)
                        case (ZERO-NINE)
                           n = n*10+c1-ZERO
                        case (BLANK)
                           exit
                        case default
                           go to 900
                        endselect
                enddo
                call setorg(n)
	  case (119)	! w
		lexwarn = YES
          case (98)    !b
                bckeep = .false.
          case (99)    !c
                do i=LEXMIN,LEXMAX
                        col1(i) = .false.
                enddo
                do i=2,len(optstr)
                        c1 = ichar(optstr(i:i))
! XXX -
                        if (c1 .eq. BLANK) exit
                        col1(c1) = .true.
                enddo
          case (67)    !C
                call cnstal('COMPILER',optstr(2:))
	  case (100)	! d
		nodblquo = YES
          case (68)    ! D
                ind1 = index(optstr, '=')
                if (ind1 .eq. 0) then
                   ind1 = index(optstr,' ')
                   call cnstal(optstr(2:ind1-1),' ')
                elseif (len(optstr) .eq. ind1) then
                   call cnstal(optstr(2:ind1-1), ' ')
                else
                   call cnstal(optstr(2:ind1-1), optstr(ind1+1:))
                endif
          case (102) !f
! free form input: no col1 convention, no col6 convention
                do i=LEXMIN,LEXMAX
                        col1(i) = .false.
                enddo
                col6 = .false.
	  case (73) !I
	        inclnum = inclnum + 1
	        incldirs(inclnum) = optstr(2:)
          case (108) !l
                col72 = 80
          case (109) !m
		basis=" "
          case (77) !M
		call cnstal('MACHINE',optstr(2:))
          case (116)  !t
		system=optstr(2:)
	  case (105) !i
		intsize = evalone(optstr(2:),ierr)
		select case(intsize)
		    case (2,4,8)
                       ireset = .true.
		    case default
                       goto 900
		endselect
          case (114) !r
		realsize = evalone(optstr(2:),ierr)
		select case (realsize)
		    case (4,8,16)
                       rreset = .true.
		    case default
                       goto 900
		endselect
          case (117) !u
		call notsen
          case (118)  !v
                verbose=.not.verbose
          case default
             go to 900
        endselect
        return
! bad options
900     continue
        write(stderr,100) optstr
100     format(' Error in option....'/a)
        call finish(FATALERROR)
        return
        end

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

! do endwhile statement
! put out go to L,endif

        subroutine sewhile
  use cstat_mod
        level = level - 1
!XXX        call outifl
!XXX        call outtab
!XXX        call outgo(labn(level))
        call outtab
        call putqs('enddo')
        call spit
        call outlin
!XXX        call putqs('c endwhile')
!XXX        call outlin
!XXX        if(used(level+1) .eq. YES) call outcnt(labb(level+1))
        return
      end subroutine sewhile

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

! process if statement
! call docond to output condition & translate logical operators
! if (condition) may be followed by
! a. then -- put out as is
! b. some other statement
!     We check on the next line if nothing follow the cond.
! Note that return(value) has to be handled correctly.

        subroutine do_sif
  use cstat_mod
        integer t
        integer stoken(MAXTOK), sltoken
        integer, external :: gnbtok,docond
!
        call outtab
        call putqs('if ')
        if(docond() .ne. 0) return
        t = gnbtok(token,ltoken)
        sltoken = 0
        do while(t .eq. NEWLINE .or. t .eq. COMMENT)
                if (t .eq. COMMENT) then
                   stoken = token
                   sltoken = ltoken
                endif
                t = gnbtok(token,ltoken)
        enddo
        if(t .ne. ESCAPE) then
                if (sltoken .gt. 0) call embededcomment(stoken, sltoken)
                call putchr(token,ltoken)
                call eatup
                return
        else
                t = token(2)
        endif
        if(t .eq. STHEN) then
                call putqs('then')
                iflevel = iflevel + 1
                if (sltoken .gt. 0) call endcomment(stoken, sltoken)
                call spit
                call outlin
        elseif(t .eq. MRETURN) then
                if (modfun .eq. YES) then
                   call doret(.true., stoken, sltoken)
                else
                   call doret(.false., stoken, sltoken)
                endif
        elseif(t .eq. SBREAK) then
                call sbrks(stoken, sltoken)
        elseif(t .eq. SNEXT) then
                call do_snext(stoken, sltoken)
        else !?? something wrong
                if (sltoken .gt. 0) call embededcomment(stoken, sltoken)
                call putchr(token,ltoken)
                call eatup
                return
        endif
        return
        end

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

! look for digit after the next

        subroutine do_snext(stoken, sltoken)
  use cstat_mod
        integer stoken(*), sltoken
        integer t
        integer, external :: gnbtok,toktoi
        integer nlev

        t = gnbtok(token,ltoken)
        if( t .eq. DIGIT) then
! XXX-warn about this
                nlev = toktoi(token,ltoken) - 1
                t = gnbtok(token,ltoken)
        else
                nlev = 0
        endif
        call outtab
        call putqs('cycle')
        if (t .eq. COMMENT) then
              call endcomment(token, ltoken)
              t = gnbtok(token,ltoken)
        endif
! shouldn't be anything else here
        if( t .ne. NEWLINE) then
                call warn('Illegal syntax in -next- statement.')
                return
        elseif(level-nlev .le. 0) then
                call warn('Illegal -next- statement, level wrong')
                return
        endif
        if (sltoken .gt. 0) call endcomment(stoken, sltoken)
        call outlin
!XXX        call outgo(labn(level-nlev))
        return
      end subroutine do_snext

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

! delete to end of line, inclusive

        subroutine spit
  use cstat_mod

        integer t
        integer, external :: gtok

        do
           t = gtok(token,ltoken)
           if (t .eq. COMMENT) then
              call endcomment(token, ltoken)
!XXX-           elseif (t .eq. WHITE) then
!              call putchr(token, ltoken)
           endif
           if (t .eq. NEWLINE) exit
        enddo

        return
      end subroutine spit

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

! end block do with until( condition)
! translates to: if(.not.(condition)) go to L ; enddo

        subroutine do_suntil
  use cstat_mod

        integer, external :: docond

        if(level .eq. 0 ) then
                call warn('Extraneous until statement.')
                return
        elseif(dotype(level) .ne. BLOCK) then
                call warn('Until statement in wrong kind of do loop.')
                return
        endif
!XXX        call outifl
        call outtab
!XXX        call putqs('if ( .not. ')
        call putqs('if ')
        if(docond() .ne. 0) return
!XXX	code(1) = RPAREN
!XXX        call putchr(code,1)
!XXX        call outgo(labn(level+1))
        call putqs(' exit')
        call spit
        call outlin
        level = level - 1
!XXX        if(used(level+1) .eq. YES) call outcnt(labb(level+1))
        call outtab
        call putqs('enddo')
        call outlin
        return
        end

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

! translate while(cond) to
!       continue   (in case this statement was labeled)
! L     if(cond) then
!

        subroutine do_swhile
  use params
  use cstat_mod
        integer n
        integer, external :: docond, labgen, getdef
!
!XXX        call outifl
        n = labgen(2)
!XXX        call puti5(n)
        call outtab
        call putqs('do while ')
        if(docond() .ne. 0) return
!XXX        call putqs(' then')
        call spit
        call outlin
        level = level + 1
        labn(level) = n
        labb(level) = n + 1
        used(level) = NO
        dotype(level) = WHILE
        foriter(level) = " "
        if (getdef('mppl_foriter', foriter(level)) .ge. 0) then
           ! do not reuse macro with next loop
           call undef('mppl_foriter')
        endif
        return
      end subroutine do_swhile

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

! convert a token to an integer

        integer function toktoi(token,toksiz)
        use params
        integer token(1),toksiz,i,j,k,isgn
        toktoi = 0
        isgn = 1
        do j=1,toksiz
                if(token(j) .ne. BLANK) exit
        enddo
        if(token(j) .eq. MINUS) then
                isgn = -1
                k=j + 1
                do j=k,toksiz
                        if(token(j) .ne. BLANK) exit
                enddo
        endif
        do i=j,toksiz
                toktoi = toktoi*10 + token(i) - ZERO
        enddo
        toktoi = toktoi*isgn
        return
        end

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

! sselect - generate code for beginning of select statement

        subroutine do_sselect
  use cstat_mod
        integer lab, t
        integer labgen, gnbtok

!XXX        lab = labgen(2)
        if (sellast + 3 .gt. MAXSELECT) &
                call oops('select table overflow.')
!XXX        call outifl
!XXX        call putqs('c select')
!XXX        call outlin
        call outtab    ! Innn=(e)
!XXX        call selvar(lab)
        t = gnbtok(token,ltoken)
        if(t .eq. NEWLINE) then
                call warn('select statement syntax error.')
                return
        endif
!XXX        if(t .ne. EQUALS) then
!XXX           code(1) = EQUALS
!XXX           call putchr(code,1)
!XXX        endif
        call putchr(token,ltoken)
        call eatup
        sellev = sellev + 1
        if(sellev .gt. MAXDEPTH) &
                call oops('select statements nested too deeply.')
!XXX        sellab(sellev) = 999 !lab
!XXX the triplets in selstak represent lower, upper bounds + label
!XXX in the FIRST one however, at seltop,
!XXX selstak(seltop) = previous seltop
!XXX selstak(seltop+1) = number of cases in this select so far
!XXX selstak(seltop+2) = label for default case, 0 if no default stat yet.
!XXX        selstak(sellast) = seltop
!XXX        selstak(sellast+1) = 0
!XXX        selstak(sellast+2) = 0
!XXX        seltop = sellast
!XXX        sellast = sellast + 3
!XXX        call outtab
!XXX        call outgo(lab)  ! goto L
        return
        end

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

! case or default statement
! td is SCASE or SDEFAULT

        subroutine do_scase(td)
  use cstat_mod
        integer td
        integer t, l, lb, ub, i, j, lab, junk
        integer caslab, labgen, gnbtok
        integer, external :: peek

        if (sellev .le. 0) then
                call warn('illegal case or default.')
                return
        endif
!XXX        call outifl
        lab = sellab(sellev)
!XXX        if(selstak(seltop+1) .gt. 0) then
!XXX in case the previous statement was a break or other goto, label this one
!XXX                i = labgen(1)
!XXX                call puti5(i)
!XXX                call outtab
!XXX                call outgo(lab+1)  ! terminate previous case
!XXX        endif
        l = labgen(1)
        if (td .eq. SCASE) then   ! case n[,n]... : ...
                sellev = sellev - 1
                call outtab
                sellev = sellev + 1
                call putqs('case (')
                do while (caslab(lb, t) .ne. NEWLINE )
!XXX                        ub = lb
                        if (t .eq. MINUS) then
                           call putqs(':')
                           junk = caslab(ub, t)
                        endif
!XXX                        if (lb .gt. ub) then
!XXX                                call warn('illegal range in case label.')
!XXX                                return
!XXX                        endif
!XXX                        if (sellast + 3 .gt. MAXSELECT) &
!XXX                                call oops('select table overflow.')
!XXX                        i = seltop + 3
!XXX                        do while (i .lt. sellast)
!XXX                                if (lb .le. selstak(i)) then
!XXX                                        exit
!XXX                                else if (lb .le. selstak(i+1)) then
!XXX                                        call warn('duplicate case label.')
!XXX                                        return
!XXX                                endif
!XXX                                i = i + 3
!XXX                        enddo
!XXX                        if (i .lt. sellast .and. ub .ge. selstak(i)) then
!XXX                                call warn('duplicate case label.')
!XXX                                return
!XXX                        endif
!XXX insert new entry
!XXX                        j = sellast
!XXX                        do while (j .gt. i)
!XXX                                selstak(j+2) = selstak(j-1)
!XXX                                j = j - 1
!XXX                        enddo
!XXX                        selstak(i) = lb
!XXX                        selstak(i+1) = ub
!XXX                        selstak(i+2) = l
!XXX                        selstak(seltop+1) = selstak(seltop+1) + 1
!XXX                        sellast = sellast + 3
!XXX                        call outnum(lb)
!XXX                        if(ub .gt. lb) then
!XXX                                call outnum(ub)
!XXX                        endif
                        if (t .eq. COLON) then
                                exit
                        else if (t .ne. COMMA) then
                                call warn('illegal case syntax.')
                                return
                        endif
                        call putqs(',')
                enddo
                call putqs(')')
        else      ! default : ...
                sellev = sellev - 1
                call outtab
                sellev = sellev + 1
                call putqs('case default')
                t = gnbtok(token, ltoken)
!XXX                if (selstak(seltop+2) .ne. 0) then
!XXX                        call warn('multiple defaults in select statement.')
!XXX                        return
!XXX                endif
!XXX                selstak(seltop+2) = l
        endif
        call outlin
        if (t .ne. COLON) then
           call inform('missing colon in case or default label.')
        else if (peek(NEWLINE) .eq. YES) then
           t = gnbtok(token, ltoken)
        endif
!XXX        sellev = sellev - 1
!XXX        call outcnt(l)
!XXX        sellev = sellev + 1
        return
        end

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

! caslab - get one case label

        function caslab(n, t)
  use cstat_mod
        integer caslab
        integer n, t
        integer s
        integer gnbtok, toktoi

        t = gnbtok(token, ltoken)
        if (t .eq. NEWLINE) then
           caslab = t
           return
        endif
        if (t .eq. MINUS) then
                s = -1
        else
                s = +1
        endif
        if (t .eq. MINUS .or. t .eq. PLUS) t = gnbtok(token, ltoken)
        if (t .ne. DIGIT .and. t .ne. ALPHA) then
                call inform('invalid case label.')
                t = COLON
                n = 9999
                caslab = 0
                return
        endif
        call putchr(token,ltoken)
        n = 9999
!XXX        n = s*toktoi(token,ltoken)
! get next token (should be comma or colon)
        t = gnbtok(token, ltoken)
        caslab= 0
        return
      end function caslab

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

! seselect - finish off select statement; generate dispatch code

        subroutine do_seselect
  use cstat_mod
        integer lab
        integer lb, ub, n, i, j
        integer, external :: labgen

        if(sellev .le.0) then
                call warn('Unmatched endselect.')
                return
        endif
!XXX        lab = sellab(sellev)
!XXX        lb = selstak(seltop+3)
!XXX        ub = selstak(sellast-2)
!XXX        n = selstak(seltop+1)
        sellev = sellev - 1
!XXX        call outtab
!XXX        call outifl
!XXX        call putqs('end select')
!XXX        call outlin
!XXX        if( n .gt. 0 ) then
!XXX!XXX in case the previous statement was a break or other goto, label this one
!XXX                i = labgen(1)
!XXX                call puti5(i)
!XXX                call outtab
!XXX                call outgo(lab+1)  !XXX terminate last case
!XXX        endif
!XXX        if (selstak(seltop+2) .eq. 0) &
!XXX                selstak(seltop+2) = lab + 1    !XXX default default label
!XXX        call outcnt(lab)    !XXX L   continue
!XXX        if (n .ge. CUTOFF .and. ub - lb + 1 .lt. DENSITY * n ) then
!XXX!XXX output branch table
!XXX                if (lb .ne. 1) then    !XXX L  Innn=Innn-lb+1
!XXX                        call outtab
!XXX                        call selvar(lab)
!XXX                        code(1) = EQUALS
!XXX                        call putchr(code,1)
!XXX                        call selvar(lab)
!XXX                        if (lb .lt. 1) then
!XXX                           code(1) = PLUS
!XXX                           call putchr(code,1)
!XXX                        endif
!XXX                        call outnum(-lb + 1)
!XXX                        call outlin
!XXX                endif
!XXX                call outtab    !XXX  if(Innn.lt.1.or.Innn.gt.ub-lb+1)goto default
!XXX                call putqs('if(')
!XXX                call selvar(lab)
!XXX                call putqs('.lt. 1 .or. ')
!XXX                call selvar(lab)
!XXX                call putqs('.gt.')
!XXX                call outnum(ub - lb + 1)
!XXX                call putqs(') go to ')
!XXX                call puti5(selstak(seltop+2))
!XXX                call outlin
!XXX!XXX go to (....), Innnn
!XXX                call outtab
!XXX                call putqs('go to (')
!XXX                j = lb
!XXX                i = seltop + 3
!XXX                do while (i .lt. sellast)
!XXX                        do while (j .lt. selstak(i))  !XXX fill in vacancies
!XXX                                call outnum(selstak(seltop+2))
!XXX                                code(1) = COMMA
!XXX                                call putchr(code,1)
!XXX                                j = j + 1
!XXX                        enddo
!XXX                        j = selstak(i+1) - selstak(i)
!XXX                        do while (j .ge. 0)
!XXX                                call outnum(selstak(i+2))  !XXX fill in range
!XXX                                if ((i .lt. sellast - 3) .or. (j .gt. 0)) then
!XXX                                   code(1) = COMMA
!XXX                                   call putchr(code,1)
!XXX                                endif
!XXX                                j = j - 1
!XXX                        enddo
!XXX                        j = selstak(i+1) + 1
!XXX                        i = i + 3
!XXX                enddo
!XXX                call putqs('), ')
!XXX                call selvar(lab)
!XXX                call outlin
!XXX        else if (n .gt. 0) then    !XXX output linear search form
!XXX                i = seltop + 3
!XXX                do while (i .lt. sellast)
!XXX                        call outtab    !XXX if(Innn
!XXX                        call putqs('if( ')
!XXX                        call selvar(lab)
!XXX                        if (selstak(i) .eq. selstak(i+1)) then
!XXX                                call putqs(' .eq. ')  !XXX   .eq....
!XXX                                call outnum(selstak(i))
!XXX                        else
!XXX                                call putqs(' .ge. ')  !XXX   .ge.lb.and.Innn.le.ub
!XXX                                call outnum(selstak(i))
!XXX                                call putqs(' .and. ')
!XXX                                call selvar(lab)
!XXX                                call putqs(' .le. ')
!XXX                                call outnum(selstak(i+1))
!XXX                        endif
!XXX                        call putqs(') ')   !XXX ) go to ....
!XXX                        call outgo(selstak(i+2))
!XXX                        i = i + 3
!XXX                enddo
!XXX                if (lab + 1 .ne. selstak(seltop+2)) then
!XXX                        call outtab
!XXX                        call outgo(selstak(seltop+2))
!XXX                endif
!XXX        endif
!XXX        call outcnt(lab+1)      !XXX L+1  continue
!XXX        call putqs('c endselect')
!XXX        call outlin
!XXX        sellast = seltop  !XXX pop select stack
!XXX        seltop = selstak(seltop)
!XXX        call spit
        return
        end subroutine do_seselect

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

        subroutine selvar(lab)
        integer lab
        call putqs('i')
        call outnum(lab)
        return
      end subroutine selvar

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

        subroutine outnum(n)
        integer n,i
        character*16 msg
        common /onc/ msg
        write(msg,100) n
100     format(i16)
        i = 1
        do while (i.lt.16 .and. msg(i:i) .eq. ' ')
           i=i+1
        enddo
        call putqs(msg(i:16))
        return
      end subroutine outnum

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

        subroutine domath(argstk,i,j)
! this subroutine evaluates an expression
  use cmacro_mod
  use ctype_mod
        integer, external :: evalone
        integer argstk(1),i,j
        integer ival, ierr
        integer jrem,jq,a1,a2
        integer i0,pos,k
        character*(MAXSTATE)  str

        ierr = OK
        ival = 0
        pos = 1
! if there are too many arguments
        if (i+2 .ne.j) then
                call warn('Too many arguments to Evaluate macro')
                ierr=ERR
        else
                i0 = ZERO
                a1=argstk(i+2)
                a2=argstk(i+3)
                if(a2-a1 .gt. MAXSTATE) then
                        call warn('Too long an argument to Evaluate macro')
                        ierr = ERR
                        return
                endif
! if the string is not null, create the character string
                if (a1.ne.a2) then
                        k=a1
                        do while (k.lt.a2)
                                str(pos:pos) = char(evalst(k))
                                pos=pos+1
                                k=k+1
                        enddo
                        str(pos: )=' '
! evaluate the string
                        ival=evalone(str,ierr)
                endif
        endif
        if(ierr .eq. ERR) then      ! an error occurred
                call pbstr(evalst(a1),a2-a1)
        else                   ! put the anwswer back
                jrem=abs(ival)
                if(jrem.eq.0) then
                        call putbak(i0)
                        return
                endif
                do while(jrem.gt.0)
                        jq=jrem/10
                        call putbak(i0+jrem-jq*10)
                        jrem=jq
                enddo
                if(ival.lt.0) then
                        call putbak(MINUS)
                endif
        endif
        return
        end

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

!
!   This fuction returns the value of a vlaid infix integer
!   expression. If it cannot be evaluated, it returns 0
!   and ierr = ERR
!
!   extended by
!   Cathleen Benedetti
!   10-13-86

function evalone(str, ierr)
  use cone_mod
  integer evalone        ! function name
  character*(*) str      ! input string
  integer ierr, i23005, i23014
  integer i,j            ! delimits current token in str
  integer lstr           ! length of str
  integer tok            ! type of current token
  integer term           ! value of integer token
  integer total          ! value of expression
  integer index          ! index to act1,act2
  integer state,nstate   ! current state,next state
  integer t              ! temporary variable
  character(1) action    ! current action
  character(1) nxtin     ! next input

  integer, external ::  evaltokn

!
!   ***********initialize**************
!
  total = 0
  ierr = OK
  action = 'e'
  stop = 0
  numtop = 0
  state = 2
  call evpush(state,stray,stop,ierr)
  lstr = len_trim(str)
!
i=1
do while (ierr .eq. OK .and. action .ne. 'a')
  tok = evaltokn(str,i,j,ierr,lstr)
  if(ierr .eq. OK) then
    call getin(tok,i,j,str,term,nxtin,index)
    action = 'e'
    do while(ierr .eq. OK .and. action .ne. 'a' .and. action .ne. 's')
    state=stray(stop)
    action=act1(state)(index:index)
    nstate=act2(state,index)
  select case (ichar(action))
    case (101)
       ierr = ERR   !  error
    case (97)
       call evpop(total, numray, numtop, ierr) ! accept
    case (115)
       if (nxtin .eq. '!') then                 ! shift
              call evpush (term, numray, numtop, ierr)
              else
                t = ichar(nxtin)
                call evpush(t,numray,numtop,ierr)
            endif
              call evpush (nstate, stray, stop, ierr)
    case (114) ! reduce
           call operate (ierr, nstate, stray, stop, numray, numtop)
              select case (nstate)
                case (2:7)
                   state = move(stray(stop),1)
                case (8:10)
                   state = move(stray(stop),2)
                case (11:13)
                   state = move(stray(stop),3)
                case (14,15)
                   state = move(stray(stop),4)
                case default
                   call oops('evalsub1:bad input state')
              endselect
              call evpush (state,stray, stop, ierr)
    case default
       call oops ('evalsub1: bad input action')
   endselect
  enddo
 endif
 i = j+1
enddo
evalone = total
return
end

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

function evaltokn(str, i, j, ierr,lstr)
!
!  this function determines whether the current token
!  invalid, eof, an operator, an integer, or a variable
!
!  str      input string
!  i,j      position of token in strinteger evaltok
!  c1       integer value of current character
!
!
  use params

  integer evaltokn
  character*(*) str
  integer i,j,lstr, c1, ierr

  ierr = OK
  do while ((str(i:i) .eq. ' ') .and. (i.le.lstr))
        i=i+1
  enddo
  if (i.gt.lstr) then
     evaltokn = TOKEOF     ! it's the end of the string
     return
  endif
  c1 = ichar(str(i:i))
! XXX - 
  select case (c1)
  case (40,41,42,43,45,47)      !  (, ), *, +, -, /
     j=i
     evaltokn = TOKOPER        ! it's an operator
  case (48:57)                   ! integer
     j = i + 1
     do while (j .le. lstr)
        c1 = ichar(str(j:j))
        if (c1 .lt. 48 .or. c1 .gt. 57) exit
        j = j + 1
     enddo
     j = j -1
     evaltokn = TOKNUM         ! it's an integer
  case default
     ierr = ERR
     evaltokn = TOKEOF            ! it's a bad character
  endselect
  return
end

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

subroutine getin(tok,i,j,str,term,nxtin,index)

  use params

  integer tok         ! type of token
  integer i,j         ! delimiters
  integer term        ! value of integer token
  integer index       ! index to arrays
  integer t           ! temporary variable
  character*(*) str   ! input string
  character*(1) nxtin ! next input
  integer i23000

  select case (tok)
       case (TOKEOF)
                index=7
                nxtin = '$'
        case (TOKOPER)
                index=ichar(str(i:i))-39
                nxtin=str(i:i)
        case (TOKNUM)
                index=5
                nxtin = '!'
                t=i
                term=0
                do while(t.le.j)
                        term=term*10+(ichar(str(t:t))-48)
                        t=t+1
                enddo
        case default
           call oops('getin:impossible token from evaltok')
    endselect
    return
end subroutine getin

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

!
! perform a reduction
!
! p corresponds to the production being used

subroutine operate(ierr, p, stray, stop, numray, numtop)
use params
integer stray(1), numray(1), stop, numtop, ierr, k, i23004, i23014
integer first, second, temp, p, optr, value

if(p.lt.2 .or. p.gt.15) then
    ierr = ERR
 elseif (p.eq.2 .or. p.eq.8 .or. p.eq.11 .or. p.eq.14) then
         call evpop(temp, stray, stop, ierr)
 elseif (p.eq.15) then
         do k=1,3
            call evpop(temp, stray, stop, ierr)
         enddo
         call evpop(temp, numray, numtop, ierr)
         call evpop(value, numray, numtop,ierr)
         call evpop(temp, numray, numtop, ierr)
         call evpush (value,numray,numtop,ierr)
else
         do k=1,2
           call evpop(temp, stray, stop, ierr)
         enddo
         call evpop(second, numray, numtop, ierr)
         call evpop(optr, numray, numtop, ierr)
         if (p.eq.3) then
                value = -second
         else
              call evpop(temp, stray, stop, ierr)
              call evpop(first, numray, numtop, ierr)
              if (p .ne. 5 .and. p .ne. 7) then
                 select case (optr)
                   case (42)
                      value = first * second
                   case (43)
                      value = first + second
                   case (45)
                      value = first - second
                   case (47)
                      if (second .ne.0) then
                         value = first/second
                      else
                         call oops('evaluate macro--divide by zero')
                      endif
                 endselect
               else
                 call evpop(temp, numray, numtop, ierr)
                 call evpop (temp, stray, stop, ierr)
                 select case (optr)
                   case (45)
                      value = -first - second
                   case (43)
                      value =  -first + second
                 endselect
              endif
          endif
         call evpush (value, numray,numtop, ierr)
endif
return
end

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

! pop an integer off an integer stack

subroutine evpop(item, stack, top, ierr)
use params
integer item, stack, top, ierr
dimension stack(*)

item = 0
if (top.gt.0) then
  item = stack(top)
  top = top - 1
else
        ierr = ERR
endif
return
end subroutine evpop
!
!
!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

! push an integer onto an integer stack

subroutine evpush(item, stack, top, ierr)
use params
integer item, stack, top, ierr
dimension stack(*)

if (top .lt. MAXSTATE ) then
   top = top + 1
   stack(top) = item
else
        ierr = ERR
endif
return
end subroutine evpush

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

! take definition out of table

        subroutine doundf(argstk,i,j)
  use cmacro_mod
  use ctype_mod
        integer a1,a2,argstk(1),i,j, ilo, ihi, lname, k

        if(j .ne. i+2) &
                call oops('wrong number of arguments in undefine')
        a1=argstk(i+2)
        a2=argstk(i+3)
        do ilo = a1, a2-1 
           if(type(evalst(ilo)).ne.WHITE) exit
        enddo
        do ihi = a2-1, a1, -1
           if(type(evalst(ihi)).ne.WHITE) exit
        enddo
        lname = ihi -ilo + 1
        if(lname .le.0) &
           call oops(' Empty name in Undefine macro.')
        do k = ilo, ihi
           if(alphan(evalst(k)).ne.YES) &
              call oops(' Name not alphanumeric in Undefine macro.')
        enddo 
        call unstal(evalst(ilo),lname)
        return
      end subroutine doundf

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

        subroutine dodmp(argstk,i,j)
  use cmacro_mod
  use ctype_mod
        integer i,j,argstk(1)
        integer k,a1,a2
        integer, external :: dumpdf
        external dumpa
        character*80 out
        do k = i + 2 ,j
                a1 = argstk(k)
                a2 = argstk(k+1)
                if(a2.eq.a1) then
                        call dumpa
                else
                        do while(type(evalst(a1)) .eq. WHITE .and. a1 .lt.a2)
                                a1 = a1 + 1
                        enddo
                        do while(type(evalst(a2-1)) .eq. WHITE .and. a1 .lt.a2)
                                a2 = a2 - 1
                        enddo
                        if( a2-a1 .le.0) call warn('Dumpdef: empty name')
                        if( dumpdf(a2-a1,evalst(a1)) .ne. 0) then
                           do i=1, a2-a1
                              out(i:i) = char(evalst(a1-1+i))
                           enddo
                           call warn('Dumpdef: name not defined')
                           call rem(out,a2-a1)
                        endif
                endif
        enddo
        return
        end

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

! Set either RealSize or IntSize definition.  Called whenever "realsize"
! or "intsize" is changed, to change the corresponding macros.

	subroutine setsize(name,val)
	character *(*)name
	integer val
	character *1 s1
	character *2 s2
	select case (val)
	    case (2,4,8)
	        write(s1,'(i1)') val
		call cnstal(name,s1)
	    case (16)
	        write(s2,'(i2)') val
		call cnstal(name,s2)
	    case default 
		call oops("Attempted to write bad size in setsize")
	endselect
      end subroutine setsize

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

! Query the hash table and find the current definition of WORDSIZE
! Fatal error if WORDSIZE is not defined

	subroutine getwdsz(ws)
	integer ws
	integer, external :: getdef
	character *8 wsstr

	if(getdef('WORDSIZE',wsstr) .gt. 0)then
	    read(wsstr,'(i2)') ws
	    return
	endif
	call oops("WORDSIZE is not defined!")
      end subroutine getwdsz

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

! Read a definition from the hash table, leaving the string value in "val".
! Val must be long enough to store the definition value.  Return value is
! length of "val", or -1 if "def" was not in the table.

	integer function getdef(def,val)
	character *(*) def, val
        integer defp
        integer i
        integer, external :: lookup, readdef
	integer idef(32),lidef

	! Measure the length of "def" and convert it to integer form
	lidef = len_trim(def)
        do i=1,lidef
           idef(i) = ichar(def(i:i))
	enddo

	defp = lookup(lidef,idef)
	if(defp .eq. -1) then
           getdef = -1
        else
           getdef = readdef(defp,val)
        endif
	return
        end function getdef

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

! Remove a definition from the hash table.
        
	subroutine undef(def)
	character *(*) def
        integer i
	integer idef(32),lidef

	! Measure the length of "def" and convert it to integer form
	lidef = len_trim(def)
        do i=1,lidef
           idef(i) = ichar(def(i:i))
	enddo

        call unstal(idef, lidef)

	return
        end subroutine undef

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

! Write a comment at the end of a line
! Do not break the line
        subroutine endcomment(stoken,sltoken)

          use cfile_mod

          integer stoken(*), sltoken
          integer i

          call putqs("  ")
          do i=1,sltoken
             outbuf(lastpc + i) = stoken(i)
          enddo
          lastpc = lastpc + sltoken

        end subroutine endcomment

!--------------------------------------------------------------------------
!--------------------------------------------------------------------------

! Deal with comments embedded in a line:
!   if (foo) # comment
!      foo = 1
!

        subroutine embededcomment(stoken, sltoken)

          integer stoken(*), sltoken

          call endcomment(stoken, sltoken)
          call outlin
          call outtab
          call putqs('    ')

        end subroutine embededcomment
