pfb
## pfb interface to pdblib
{
# pre-wired package numbers
HISTORY=1  
RECORD=2    
MACRO=3
FUNCT=4
HIDEME=5
OPEN=6
# sizes
NTYPEC=16 #size of a pdb type string
NPN=7 #size of package name space
NPDBN=(VARNAMESIZE + NPN)  #size of name in pdb file allows for @ and package name
NHASH=2999 #hash size for pfbhash
NENCODE=4096
DIRNAMESIZE=255 #max chars in an internal PDBfile directory name
}
**** PfbControls dump:
# Basis interface to PDB routines
pfbdebug  integer /0/
  # Debug flag, set to 1, 2, or 3 for diagnostics of increasing
  # complexity.
pfbls     integer /YES/
  # Set YES for short ls output.
pfblsopt character*(256) 
  # What to execute on "ls" command when nothing open.
pfblsa    integer /NO/
  # Implement: ls -a
pfbask    integer /NO/
  # Ask user before overwrite of file?
pfbmax    integer 
  # If file has this many bytes in it, pfbfam will family it.
pfbcycle  character*(NPDBN) /" "/
  # Name of variable on which to catalog cycles when creating records.
pfbtime character*(NPDBN) /" "/
  # Name of variable on which to catalog time when creating records.
pfbofam  integer /YES/
  # Open families if possible.
pfbhide  integer /YES/
  # Don't show dmi2pdb superstructure in dap-style old history files.
pfbdcyc Varname /" "/
  # Inform PFB of name of cycle variable in non-standard file.
pfbdtime Varname /" "/
  # Inform PFB of name of time variable in non-standard file.
pfbact integer /YES/
  # On open for read, parse contents of variables named *@open?

***** Routines:
# Routines to access the inner workings
pfbfileid (;access:string) integer function
   # Returns the fileid of the current file open for access;
   # access = "r" (default) or "w".
pfbopen(name:string;access:string) integer function
   # Returns fileid.
pfbopend(fileid:integer) subroutine
   # Parse contents of each variable named *@open in file.
pfbclose(;fileid:integer) subroutine
   # Close the file; defaults to write file, if any, else read file.
pfbfile(fileid:integer) builtin [1]
   # Print the current working directory of the file;
pfbpwdf(fileid:integer) builtin [0-1]
   # Return the name of the file given fileid.
pfbglue(fileid1:integer,fileid2:integer) subroutine
   # Glue second family on to first, close the second.
   # Assumes you know what you are doing.
pfbsave(name:string;fileid:integer) subroutine
   # Save item to file; can invoke with write macro.
   # fileid defaults to file id of current write file.
pfbrest(;fileid:integer,name:string) subroutine
   # Restore from the file; restore just name if not blank.
pfbrs(name:string;fileid:integer) subroutine
   # Restore from a file; fileid defaults to current read file.
pfbasave(aexp:string;fileid:integer) subroutine
   # Save things satisfying attribute expression aexp.
   # fileid defaults to file id of current write file.
pfbalist(v:string, a:string) subroutine
   # Create a list of variables satisfying a as variable v.
   # First element of the list is a.
pfbaset(v:string) subroutine
   #  Given v made by pfbalist, restore attribute to variables.
pfblist(stringlist) builtin [0-100]
   # ls [help|files|names|records]
pfblsrec(;fileid:integer;unit:integer) subroutine
   # ls records implementation.
pfbsavee(expr, name:string, fileid:integer) builtin [2-3]
   # Save expr as name.
pfbsavel(namelist) builtin [0-100]
   # write name1, name2, ...
pfbsavfl(namelist) builtin [0-100]
   # writef name1, name2, ...
pfbrestl(namelist) builtin [0-100]
   # restore name1, name2, ...
file_access builtin [0-7]
   # Internal mechanism used by PFB package to access data in PDB
   # files.
pfbopenl(namelist) builtin [0-100]
   # Implements the open command.
pfbopeng(namelist) builtin [0-100]
   # Implements the openg command.
pfbclosel(fileidlist) builtin [0-100]
   # Implements the close command.
pfbcreatel(namelist) builtin [0-100]
   # Implements the create command.
pfbappendl(namelist) builtin [0-100]
   # Implements the append command.
pfbjt(t:real;fileid:integer) integer function
   # Return record number closest to given time.
pfbjc(n:integer;fileid:integer) integer function
   # Return record number closest to given cycle number.
pfbcount(;fileid:integer) integer function
   # Number of names in current read file.
pfblong(i:integer;fileid:integer) character*(NPDBN) function
   # Return the long name of the i'th entry.
pfbpack(i:integer;fileid:integer) character*(NPN) function
   # Return the package name of the i'th entry.
pfbname(i:integer;fileid:integer) character*(NPDBN) function
   # Return the short name of the i'th entry.
pfbbegr(;fileid:integer) subroutine
   # Enter record mode.
pfbendr(;fileid:integer) subroutine
   # Leave record mode.
pfbgetid (fid: integer) integer function
   # Return the pdb file id of the file whose pfb id is fid, -1 if fid is bad.
pfbgrec(;fileid:integer) integer function
   # Return current record number in file being written.
pfbsrec(;irec:integer) subroutine
   # Set record number for reading.
pfbcrec integer function
   # Return current record number for reading.
pfbwras(fileid:integer,irec,name:string,typecode:integer,fwa:integer,
       ndim,ilow,ihi,icol)  subroutine
   # Nitty-gritty output routine. (Do not try this at home!)
pfbfam(;fileid:integer) integer function
   # Return fileid or fileid of new family member of file, if full.
pfbrerrs() integer function
   # Return number of errors in last call to pfbrest.
pfbgoto(when) builtin [1]
   # Set record number to last record before or equal to given time or
   # cycle.
$ -------------------------------------------------------------
$ 
***** Pfb local:
%Use(PfbControls)
%Use(PfbFiledata)
%Use(PfbInternal)
%Use(Current_file_info)
%Use(CharCollect)

**** Current_file_info hidden:
pfbrfid integer /0/
  # id of current file for read
pfbwfid integer /0/
  # id of current file for write
pfbnamen integer /0/
  # number of slots in list of names
pfbnamer integer /0/
  # current number of names
pfbnames(pfbnamen) _character*(NPDBN)
# full names of variables in current package open for read
pfbshort(pfbnamen) _character*(NPDBN)
# short names of variables in current package open for read
pfbpacks(pfbnamen) _integer
# package names of variables in current package open for read
pfbhasht(NHASH) _integer
# hash table for names of variables in current package open for read
pfbnext(pfbnamen) _integer
 # hash table ptrs for names of variables in current package open for read
**** PfbFiledata hidden:
# data about the files that are open
$ if you add something here, see pfblu to allocate its space
$ these fields used for all files
pfbmfiles integer /0/
pfbsfiles integer /0/ #storage size
pfbnamf(pfbsfiles) _Filename #name of the file
pfbacc(pfbsfiles) _character #access flag/ blank if no longer in use
pfbfids(pfbsfiles) _integer  #PDB file id
$ these fields used only for read access
pfbnamn(pfbsfiles) _integer  #size of  name table
pfbnamr(pfbsfiles) _integer  #number of names
pfbnamp(pfbsfiles) _Address  #pointer to full names
pfbpacp(pfbsfiles) _Address  #pointer to package names
pfbshtp(pfbsfiles) _Address  #pointer to short names
pfbhshp(pfbsfiles) _Address  #pointer to hash table
pfbnxtp(pfbsfiles) _Address  #pointer to hash-link indices
pfbfams(pfbsfiles) _integer  #number of files in family
pfbfamc(pfbsfiles) _integer  #number of records in family
pfbfamo(pfbsfiles) _integer  #number of the extra family member currently open
pfbfamp(pfbsfiles) _integer  #pfileid of the extra family member currently open
pfbfamf(pfbsfiles) _Address  #pointer to names of files in this family
pfbfamh(pfbsfiles) _Address  #pointer to highest record in this file
pfbfamt(pfbsfiles) _Address  #pointer to times
pfbfami(pfbsfiles) _Address  #pointer to file index
pfbfamj(pfbsfiles) _Address  #pointer to first record name offset
pfbfamn(pfbsfiles) _Address  #pointer to cycles
$ these fields used only for write access
pfbrecd(pfbsfiles) _integer  #number of records written to this file this run
pfbrecn(pfbsfiles) _integer  #current record number
pfbwrds(pfbsfiles) _integer  #number of words written so far
****** PfbInternal hidden:
tcx     integer  #type code for function
typerng integer  #type code for range
typeint integer  #type code for integer
typelog integer  #type code for logical
typer4  integer  #type code for real(Size4)
typer8  integer  #type code for real(Size8)
typer16  integer  #type code for real(Size16)
typec4  integer  #type code for complex(Size4)
typec8  integer  #type code for complex(Size8)
typef   integer  #type code for function
typest  integer  #type code for struct
typeind integer  #type code for indirect
typename integer  #type code for name
atsign  character /"@"/
persign character /"%"/
record    integer /1/
  # number of record to read if not specified on history variable
pfbrerr   integer /0/
  # number of errors during previous call to pfbrest 
pfbpackm  integer /0/
  # size of pfbpackt
pfbpackn  integer /0/
  # contents of pfbpackt
pfbpackt(pfbpackm)  _character*(NPN)
  # package names
pfbpackc  integer /1/  
  # cursor for pack object

*** CharCollect hidden:
# used to collect macros prior to blasting
lcdef integer /0/
jcdef integer
cdef(lcdef) _character

*** Directories:
# functions to manipulate PDB file directories

pfbpwd (;fileid:integer) character*(DIRNAMESIZE) function
   # Return the current directory name.
   # fileid defaults to current file open for read.

pfbcd (dirname:string; fileid:integer) subroutine
   # Change directory to dirname on the file connected to fileid.
   # Default fileid is current file open for read.

pfbmkdir (dirname:string; fileid:integer) subroutine
   # Make directory dirname on the file connected to fileid.
   # fileid defaults to current file open for write.
