      subroutine pfbmnt (fileid)
# pfb Make Name Table
# create the table of names in the file for pfbfind to use
# Called by pfbopenf and by pfbcd
# when directory is changed on a file open for read.
      integer fileid
Use(Pfb)
      character*(DIRNAMESIZE) dirname, name
      character*(NPN) packname
      character*(NPDBN) shrtname, fullname
      integer pfileid
      integer iname, at, ie, i, jmatch, ndir, i1
      integer utgetcl
      external utgetcl
      character*(DIRNAMESIZE) pfbpwd
      external pfbpwd

      pfileid = pfbfids (fileid)

# dump the file symbol table into an array of names
      call pfxvart (pfileid, ie)

      call pfbnamti (fileid, ie)

# get the current directory name
      dirname = pfbpwd (fileid)
      ndir = utgetcl(dirname)

# select the names for the finder table
      do i=1, pfbnamn(fileid)

# we want to use only the names that match dirname
# but if dirname is "/" then the slash isn't on the names we want.
          call pfxgvar (i, iname, name)

          if (ndir > 1) then
              jmatch = index (name(1:iname), dirname(1:ndir))
              if (jmatch <> 1) next #not in current dir
              i1 = ndir + 2 # index of the start of the name, skipping the /
          else
              if (name(1:1) == "/") then
                  i1 = 2
              else
                  i1 = 1
              endif
          endif

          if (i1 > iname) next # it was the name of the current directory
# Exclude anything that still has an internal /
          jmatch = index (name (i1:iname), "/") 
          if ((jmatch > 0) & (jmatch < (iname - i1 + 1))) next
# This name is a keeper -- do the @sign stuff  
          fullname = name (i1:iname)
          iname = iname - i1 + 1
          at = index (fullname (1:iname), atsign)
          if (at <= 1) then
              packname = " "
              shrtname = fullname (1:iname)
          else
              packname = fullname ((at + 1):iname)
              shrtname = fullname (1: (at - 1))
          endif
          if(packname == "history") then
              pfbfams (fileid) = 1
          endif
          call pfbnamta (fileid, packname, shrtname, fullname)
      enddo

# release the internal name array (PDBLib internal)
      call pfxdvar

      return
      end
