
c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

       subroutine pfbrs(rname,fileid)
# restore from file
       character*(*) rname
       integer fileid
       call pfbrest(fileid,rname)
       return
       end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

       subroutine pfbrest(fileidi,rname)
# restore from file 
# revision (ZCM 9/9/94) use routine ismac to see if it's a macro
Use(Pfb)
       character*(*) rname
       integer fileid, fileidi
       integer jvar, ndb, tc, i, jdef
       integer rtfinder, utgetcl, ismac
       logical rgiven
       character*(NPN) pname
       external rtfinder, utgetcl, ismac
       character*(NPDBN) nameinf, name
       Dynamic(pack,integer,1)
       Address full
       Address short
# set error count to zero
       pfbrerr = 0
# resolve defaulted arguments
       fileid = fileidi
       if(fileid==DEFAULT) fileid=pfbrfid
       call pfbchkf(fileid,"r","pfbrest")
       rgiven = (rname .ne. " ")
       full=pfbnamp(fileid)
       short=pfbshtp(fileid)
       Point(pack)=pfbpacp(fileid)
# loop over items in file, restoring them
# policies:
# restore in order written (so macros probably should precede functions)
# do not restore a macro or a function the code already has
# do not restore a history variable (unlimited last dimension)
       do i=1, pfbnamr(fileid)
         call smovatof (pname,0,pfbpackt,(pack(i)-1)*NPN,NPN)
         call smovatof(name, 0, short, (i-1)*NPDBN, NPDBN)
         call smovatof(nameinf, 0, full, (i-1)*NPDBN, NPDBN)
         if(rgiven) then
           if(name <> rname & name <> nameinf) next
         endif
         if(pname == "value") next
         if(pname == "open") next
         if(pname == "history") next
         if(pname == "hidden") next
         if(pname == "record") next
         if(pname == "macro") then
            jdef = ismac(name(1:utgetcl(name)))
            if( jdef == 0) then
# restore macro only if not defined
               call pfbrestm(fileid, nameinf)
            endif
         elseif(pname == "funct" ) then
# restore function only if not defined
            if(rtfinder("global."//name(1:utgetcl(name)), jvar, ndb, 
               tc, " ")==ERR) then
               call pfbrestf(fileid, nameinf)
            endif
         else
            call pfbrestv(fileid, nameinf, pname, name)
         endif
       enddo
       return
       end
       
c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

       integer function pfbrerrs()
Use(Pfb)
       return(pfbrerr)
       end
 
c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

       subroutine pfbrestv(fileid, nameinf, ipname, name)
Use(Pfb)
       integer fileid
       character*(*) name, nameinf, ipname
       integer i, jvar, ndb, tc, ndim, iptype, n, itype,
           ilow(7), ihi(7), icol(7), isave, svar(SS_WIDTH), pad, sx(SS_WIDTH)
       integer utgetcl, rtlookup, rtinname, glbpknux, pfbpad, parasgn2
       logical rtisdyn , doassign, rtischam, isnew
       external utgetcl, rtlookup, rtisdyn, rtinname, glbpknux, pfbpad,
          parasgn2, rtischam, strgfind
       integer strgfind
       character*(NPDBN) errname, errname2
       character*(NTYPEC) pdbtype
       character*(NPN) pname
       character*(72) dimsto, fname
       integer ndims, dims(2,8), off1
       integer ns, ni(7), mi(7), ii(7), kslot
       Dynamic(data,integer,1)
       Dynamic(ldata,logical,1)
# decide on the package to target
       pname = ipname
       if(pname == " ") pname = "global"  
       ndb = glbpknux(pname)
       if(ndb == 0) then
          pname = "global"
          ndb = glbpknux(pname)
       endif
       errname = nameinf
       errname2 = pname(1:utgetcl(pname)) // "." // name
# get the properties of the item in the file
       call pfxivar(pfbfids(fileid), nameinf, pdbtype, ndims, dims)
       call pfxgbtyp(pfbfids(fileid), pdbtype, dims, iptype, off1)
       if(iptype=typest) then
          if(pfbdebug > 1) then
             call remark("Note, not restoring structure: "//errname)
          endif
          go to 900
       elseif(iptype = typeind) then
          itype = -24
       else
          itype = iptype
       endif
# find the corresponding program variable
# use rtlookup, not parfind, to avoid indirection.
# disable pfbfind
       isave = pfbrfid
       pfbrfid = -1
       kslot = strgfind(name) # ZCM 8/15/95 avoid extra lookups
       jvar = rtlookup(name, ndb, tc, kslot)
       pfbrfid = isave
#
       doassign = FALSE
       if(jvar == 0) then
# doesn't exist, make one like the one in the file
          isnew = TRUE
          if(pfbdebug >0) then
             call remark(
             "Creating "//errname2(1:utgetcl(errname2))//" from "//errname)
          endif
# set up the stack element needed by rtinname
# changes in the way this is done to reflect new stack element for name
# (Zane C. Motteler 4/6/95)
          svar(SS_TC) = typename
          svar(SS_PTR) = kslot # used to be location
          svar(SS_N) = 0
          svar(SS_NAML) = utgetcl(name)
          svar(SS_NS) = 0
# create the variable in the database
          jvar = rtinname(ndb, itype, svar)
          if(jvar <= 0) then
             call remark("pfbrestv: variable create failed on "//errname)
             call kaboom(0)
          endif
       elseif(jvar > 0) then
# variable already exists
          isnew = FALSE
          if(iptype = typeind) then # don't replace existing indirects
             if(pfbdebug > 1) then
                call remark(
                "Not restoring existing indirect: "//errname)
             endif
             go to 900
          endif
          if(pfbdebug >0) then
             call remark(
             "Restoring "//errname2(1:utgetcl(errname2))//" from "//errname)
          endif
          if(tc <> iptype) then
# type mismatch, so try assignment
             doassign = TRUE
          endif
       else #variable exists, but is foreign! Eeeek!
          call remark("pfbrestv: cannot restore foreign variable "//errname)
          pfbrerr = pfbrerr + 1
          go to 900
       endif
       if(rtisdyn(jvar, ndb)) then
# dynamic variable
# chameleon also changes type to match file
          ndim = ndims - off1
          do i=1, ndims - off1
             icol(i)=dims(2,off1+i)-dims(1,off1+i)+1
             ilow(i)=dims(1,off1+i)
             ihi(i) = ilow(i) - 1 + icol(i)  
          enddo
          if(rtischam(jvar,ndb)) then
             if(pfbdebug > 2) then
                 call remark(
"Endowing chameleon "//errname2(1:utgetcl(errname2))//" with type of "//errname)
             endif
  	     call rtstc ( jvar, ndb, itype)
             doassign=FALSE  
             isnew = TRUE
          endif
          pad = pfbpad(jvar, ndb) # user replaceable pad routine
          call rtstgget(jvar,ndb,ndim,icol,ilow,pad)
# For new variables set their shape also so that "change" won't bother them
# and so they will document themselves better.
          if(isnew) then
             fname = pname(1:utgetcl(pname)) // "." // name
             call pfbshape(ndim, ilow, ihi, dimsto)
             call setshape(fname,dimsto)
	  endif
          call rtxdb(jvar, ndb, Point(data), ndim, ilow, ihi, icol, 2)
       else
# static variable
          call rtxdb(jvar, ndb, Point(data), ndim, ilow, ihi, icol, 2)
          if(ndim <> ndims - off1) then
             doassign = TRUE
          else
             do i = 1, ndim 
                if(icol(i) <> dims(2,i+off1)-dims(1,i+off1)+1) then
                   doassign = TRUE
                   break
                endif
             enddo
          endif
       endif 
#transfer the data from the file to the program
       if(doassign) then
# types or sizes weren't a perfect match, or chameleon, use assignment 
          if(pfbdebug > 2) then
             call remark(
                "Assigning to "//errname2(1:utgetcl(errname2))\
                 //" from "//errname)
          endif
          call pfbse(fileid,nameinf,0,0,0,0,sx)
          ns = 0
          if(
            parasgn2(tc,Point(data),ndim,ilow,ihi,icol,ns,ni,mi,ii,sx)==ERR) 
          then
             pfbrerr = pfbrerr + 1
             call remark(
                "pfbrestv: Could not restore "//errname2(1:utgetcl(errname2))\
                 //" from "//errname)
             go to 900
          endif
       else
          if(pfbdebug > 2) then
             call remark(
                "Restoring directly to "//errname2(1:utgetcl(errname2))\
                 //" from "//errname)
          endif
          if (tc < 0) then # string
             call pfxreada(pfbfids(fileid), nameinf, Point(data))
          else
             call pfxread(pfbfids(fileid), nameinf, data)
          endif
       endif
       if(iptype = typeind ) then
          call rtstc(jvar,ndb,typeind) 
       elseif(iptype = typelog) then
# transform non-zero to true
          Point(ldata)=Point(data)
          n = 1
          do i = 1, ndim
             n = n*icol(i)
          enddo
          do i = 1, n
             if(data(i) <> 0) then
                ldata(i) = TRUE
             else
                ldata(i) = FALSE
             endif
          enddo
       endif
900    continue
       return
       end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

       subroutine pfbrestm(fileid, name)
# restore macro
Use(Pfb)
       character*(*) name
       integer fileid
       integer sx(SS_WIDTH), n
       Address text
       Varname errname
       Address paraddr
       external paraddr
       if(pfbdebug >0) then
         errname = name
         call remark("Restoring macro "//errname)
       endif
       call pfbse(fileid,name,0,0,0,0,sx)
       n = -sx(SS_TC)
       text = paraddr(sx)
       call parselng_(text,1,n)
       call parkill(sx)
       return
       end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

       subroutine pfbrestf(fileid, name)
# restore user function
       character*(*) name
       integer fileid
       integer sx(SS_WIDTH), n
       Address text
       Varname errname
       Address paraddr
       external paraddr
Use(Pfb)
       if(pfbdebug >0) then
          errname = name
          call remark("Restoring function "//errname)
       endif
       call pfbse(fileid,name,0,0,0,0,sx)
       n = -sx(SS_TC)
       text = paraddr(sx)
       call parselng_(text,1,n)
       call parkill(sx)
       return
       end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

       subroutine pfbshape(ndim,ilow,ihi,dimsto)
       character*(*) dimsto
       integer ndim, ilow(7), ihi(7)
       integer i, lcomma, ldimsto, imkstr, n1, n2
       character*(16) shi, slow
# set dimsto to describe given dimensions
        if(ndim = 0) then
           dimsto="scalar"
           return
        endif
        dimsto="("
	ldimsto = 1
	lcomma = 0   #trick to prevent leading comma in string
	do i = 1, ndim
		n2 = imkstr(ihi(i), shi)
		if(ilow(i) == 1) then
			call utcat(dimsto, ldimsto, dimsto, ldimsto,
			      ", ", lcomma, shi, n2)
		else
			n1 = imkstr(ilow(i), slow)
			call utcat(dimsto, ldimsto, dimsto, ldimsto,
					", ", lcomma, slow, n1)
			call utcat(dimsto,ldimsto,dimsto,ldimsto,":",1,shi,n2)
		endif
		lcomma = 1 #put in a comma after the first one
	enddo
	call utcat(dimsto,ldimsto,dimsto,ldimsto,")",1," ",0)
        return
        end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

