
c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

       subroutine pfbsave(name,fileidi)
# write name out to pdb file
# As opposed to pfbsavf, this always tries to write any named quantities
# as if they represented values, not macros or function bodies
# Names which turn out to be functions or macros are reprocessed via writeas
Use(Pfb)
       integer fileid, fileidi
       character*(*) name
       character*500 msg
       integer rtfinder, jvar, ndb, tc, n
       integer iooutus, utgetcl, ismac, rtglimst
       external rtfinder, iooutus, utgetcl, ismac, rtglimst
       external pfbsattr

# resolve defaulted argument
       fileid = fileidi
       if(fileid==DEFAULT) fileid=pfbwfid
       call pfbchkf(fileid,"w","pfbsave")
# handle metanames
# Group names?
       if(name == "all")then
         call rtserv(" ", pfbsattr, fileid, "m serve:info", " ")
         call rtserv(" ", pfbsattr, fileid, "f db:global serve:info", " ")
         call rtserv(" ", pfbsattr, fileid, "v db:global serve:info", " ")
       elseif(name == "macros")then
         call rtserv(" ", pfbsattr, fileid, "m serve:info", " ")
       elseif(name == "functions")then
         call rtserv(" ", pfbsattr, fileid, "f db:global serve:info", " ")
       elseif(name == "variables")then
         call rtserv(" ", pfbsattr, fileid, "v db:global serve:info", " ")
       else
          jvar = ismac(name(1:utgetcl(name)))
          if(jvar > 0) then
             n = utgetcl(name)
             write(msg,100) name(1:n),name(1:n), fileid
             if(pfbdebug>1) then
                call remark("Name in save is a macro, will do")
                call remark(msg)
             endif
             call parsestr(msg)
          else
             if(rtfinder(name, jvar, ndb, tc, " ")==ERR) then
                n = utgetcl(name)
                write(msg,100) name(1:n),name(1:n), fileid
                if(pfbdebug>1) then
                   call remark("Name in save is an expression, will do")
                   call remark(msg)
                endif
                call parsestr(msg)
             elseif(tc == typef) then
                n = utgetcl(name)
                write(msg,100) name(1:n),name(1:n), fileid
                if(pfbdebug>1) then
                   call remark("Name in save is a function, will do")
                   call remark(msg)
                endif
                call parsestr(msg)
             else
                if(rtglimst(jvar, ndb) <> 0) then
                   call pfbsavel (name, jvar, ndb, tc, fileid)
                else
                   call pfbsavev (name, jvar, ndb, tc, fileid)
                endif
             endif
          endif
       endif
       return
 100      format("writeas ",a," ",a," ",i8)
       end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

      subroutine pfbsavf(name,fileidi)
# write name out to pdb file; named functions or macros saved not their values
Use(Pfb)
       integer fileid, fileidi
       character*(*) name
       integer rtfinder, jvar, ndb, tc, n
       character*500 msg
       integer iooutus, utgetcl, ismac, rtglimst
       external rtfinder, iooutus, utgetcl, ismac, rtglimst
       external pfbsattr

# resolve defaulted argument
       fileid = fileidi
       if(fileid==DEFAULT) fileid=pfbwfid
       call pfbchkf(fileid,"w","pfbsave")
# handle metanames
# Group names?
       if(name == "all")then
         call rtserv(" ", pfbsattr, fileid, "m serve:info", " ")
         call rtserv(" ", pfbsattr, fileid, "f db:global serve:info", " ")
         call rtserv(" ", pfbsattr, fileid, "v db:global serve:info", " ")
       elseif(name == "macros")then
         call rtserv(" ", pfbsattr, fileid, "m serve:info", " ")
       elseif(name == "functions")then
         call rtserv(" ", pfbsattr, fileid, "f db:global serve:info", " ")
       elseif(name == "variables")then
         call rtserv(" ", pfbsattr, fileid, "v db:global serve:info", " ")
       else
          jvar = ismac(name(1:utgetcl(name)))
          if(jvar > 0) then
             call pfbsavem(name, jvar, fileid)
          else
             if(rtfinder(name, jvar, ndb, tc, " ")==ERR) then
                n = utgetcl(name)
                write(msg,100) name(1:n),name(1:n), fileid
                if(pfbdebug>1) then
                   call remark("Name in save is an expression, will do")
                   call remark(msg)
                endif
                call parsestr(msg)
             elseif(tc == typef) then
                call pfbsavef(name, jvar, ndb, fileid)
             else
                if(rtglimst(jvar, ndb) <> 0) then
# Variable is limited, save it the hard way
                   call pfbsavel (name, jvar, ndb, tc, fileid)
                else
                   call pfbsavev (name, jvar, ndb, tc,fileid)
                endif
             endif
          endif
       endif
       return
 100      format("writeas ",a," ",a," ",i8)
       end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

       subroutine pfbsavev(name, jvar, ndb, tc,fileid)       
Use(Pfb)
# This only works for unlimited variables in a database
# Logic in the routines that calls this must assure it is not limited,
# foreign, etc.
       integer fileid
       character*(*) name
       Address fwa
       integer jvar, ndb, tc, ndim,
           ilow(7), ihi(7), icol(7), i
       character*(NPN) packname
       character*(NPDBN) longname
       integer utgetcl
       external utgetcl
#
       call rtxdb(jvar, ndb, fwa, ndim, ilow, ihi, icol, 2)
       if(pfbrecn(fileid) > 0) then
          packname = "history"
       else
          call glbpknam(ndb, packname)
       endif
       i = index(name,".")
       if(i > 0) then
          longname = name(i+1:utgetcl(name))//atsign//packname
       else
          longname = name(1:utgetcl(name))//atsign//packname
       endif
       call pfbwras(fileid,longname,tc,fwa,ndim,ilow,ihi,icol)
       return
       end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

       subroutine pfbsavel (name, jvar, ndb, tc, fileid)       
Use(Pfb)
# This only works for limited variables in a database
# Logic in the routines that calls this must assure it is not limited,
# foreign, etc.
#
# Philosophy
#   With limited variables one is between a rock and a hard place. 
#   If the limits are on any but the last dimension the data isn't contiguous.
#   In order to use PDB we need a contiguous block or we have to make a 
#   a temporary. If we make a temporary there are problems about what "restore"
#   could mean. Here is what I decided: to make this work right with the 
#   history package. At least that makes it make sense for somebody. So what I 
#   do is store the unlimited array, except I use the limit on the last 
#   dimension ONLY, and only the UPPER limit at that. This ensures the data is
#   contiguous and of minimal size to be contiguous.
#   -- Paul Dubois
       integer fileid
       character*(*) name
       Address fwa
       integer jvar, ndb, tc, ndim,
           ilow(7), ihi(7), icol(7), i,
           uilow(7), uihi(7), uicol(7)
       character*(NPN) packname
       character*(NPDBN) longname
       integer utgetcl
       external utgetcl
#
       call rtxdb(jvar, ndb, fwa, ndim, ilow, ihi, icol, 1)
       call rtxdb(jvar, ndb, fwa, ndim, uilow, uihi, uicol, 2)
       if(pfbrecn(fileid) > 0) then
          packname = "history"
       else
          call glbpknam(ndb, packname)
       endif
       i = index(name,".")
       if(i > 0) then
          longname = name(i+1:utgetcl(name))//atsign//packname
       else
          longname = name(1:utgetcl(name))//atsign//packname
       endif
       uihi (ndim) = ihi (ndim)
       call pfbwras(fileid,longname,tc,fwa,ndim,uilow,uihi,uicol)
       return
       end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

       subroutine pfbsavee(sy, name, fileid)
Use(Pfb)
       integer sy(SS_WIDTH), fileid
       character*(*) name
       integer ilow(7), ihi(7), icol(7)
       integer ndim, tc, i, k
       Address  paraddr,fwa
       external paraddr
       integer  utgetcl
       external utgetcl
       character*(NPDBN) longname

       call pfbchkf(fileid,"w","pfbsavee")
       tc = sy(SS_TC) 
       if(tc == typef) then
          call remark("write or writeas failed.")
          call remark(name)
          call remark("requires 1 or more arguments")
          call kaboom(0)
       endif
       ndim = sy(SS_N)
       fwa = paraddr(sy)
       do i = 1, ndim
          ilow(i) = sy(SS_M1-1+i)
          ihi(i) = sy(SS_N1-1+i) + sy(SS_M1-1+i) - 1
          icol(i) = sy(SS_N1-1+i)
       enddo
       if(pfbrecn(fileid) == 0) then
          k = index(name,atsign)
          if(k > 1) then
             if(utgetcl(name)= k) then
                longname = name(1:k-1)
             else
                longname = name
             endif
          else
             longname = name(1:utgetcl(name))//atsign//"value"
          endif
       else
          longname = name(1:utgetcl(name))//atsign//"history"
       endif
       call pfbwras(fileid,longname,tc,fwa,ndim,ilow,ihi,icol)
       return
       end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

       subroutine pfbwras(fileid,name,tcin,fwain,ndim,ilow,ihi,icol)       
# This routine does all the saving
Use(Pfb)
       integer fileid
       character*(*) name
       Address fwa,fwain
       integer tc, ndim, tcin,
           ilow(7), ihi(7), icol(7), ind(3,8),
           i, itotal, off1
       character*80 msg
       character*(NTYPEC) pdbtype
       Dynamic(data,integer)
       integer iooutus, utgetcl, utsizeof
       external iooutus, utgetcl, utsizeof
       Dynamic(r8,real(Size8),1)
       Dynamic(r16,real(Size16),1)
#
       if(pfbdebug > 1) then
         msg = "Writing "// name
         call remark(msg)
       endif
       fwa = fwain
       if(fwa == NOTSET) then
          if(pfbdebug > 2) then
            msg="Not written since address not set: " // name
            call remark(msg)
          endif
          return
       endif
       tc = tcin
       if(tc == 0) then
          if(pfbdebug > 2) then
            msg="Not written since of type NULL: " // name
            call remark(msg)
          endif
          return
       endif
       itotal = 1
       do i=1, ndim
          itotal = itotal*(ihi(i)-ilow(i)+1)
       enddo
       if(itotal=0) then
          if(pfbdebug > 2) then
            msg = "Not written since of zero length: " // name
            call remark(msg)
          endif
          return
       endif
       if(tc = typer16 & tc <> typer8) then
# can't write Cray doubles per se, need to make a copy
          call osallotn(Point(r8),utsizeof(itotal,typer8),"PFBWRAS:pfb.r8 ")
          Point(r16) = fwain
          do i=1,itotal
              r8(i) = r16(i)  
          enddo
          fwa =  Point(r8)
          tc = typer8
       endif
       call pfxgftyp(tc, pdbtype, off1, ind)
       if(ndim + off1 > 7) then
          call remark(name)
          call sorry("pfbwras: Write of data with too many dimensions.")
       endif
       do i = 1, ndim
          ind(1,i+off1)=ilow(i)
          ind(2,i+off1)=ihi(i)
          ind(3,i+off1)=1
       enddo
       Point(data)=fwa
       if(pfbrecn(fileid) == 0) then
         call pfxwrtd(pfbfids(fileid),name,pdbtype,data,ndim+off1,ind)
         if(pfbdebug > 2) then
            msg = "Wrote: " // name
            call remark(name)
         endif
       else
         call pfxwrth(pfbfids(fileid),name,pdbtype,data,ndim+off1,ind,
                      pfbrecd(fileid))
         if(pfbdebug > 2) then
            write(msg,80) pfbrecd(fileid),name
 80         format('Wrote file record ',i6.6,' of ',a)
            call remark(msg)
         endif
       endif
       if(tc == typeind) then
          pfbwrds(fileid) = pfbwrds(fileid) + utsizeof(itotal, -24)
       else
          pfbwrds(fileid) = pfbwrds(fileid) + utsizeof(itotal, tc)
       endif
# if we made a copy, let go of it
       if(fwa <> fwain) call osfreen(fwa,"pfb.fwa")
       return
       end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

       subroutine pfbsavem(name, jvar, fileid)
# save macro; jvar is the string table slot of the body
# Revisions (ZCM 9/9/94) using Dubois string/hash table reps of macros
Use(Pfb)
       character*(*) name
       character*(NPDBN) longname
       integer jvar, fileid, indx
       integer defsize, ind(3), lname
       Address cdef1
       integer utgetcl, utsizeof, iooutus, strgfind,
               strglen
       logical hasp, mcparck
       external utgetcl, utsizeof, iooutus, mcparck, strgfind,
               strglen, strggetna

       lname = utgetcl(name)
       hasp = mcparck(strgfind(name))  #does macro take parameters?
       defsize = strglen(jvar)
       call osallotn(cdef1,utsizeof(defsize,-1),"PFBSAVEM:pfb.cdef1 ")
       indx = 0
       call strggetna(jvar, cdef1, defsize,indx,indx,0)
# construct in cdef a parseable definition for this macro
       jcdef = 0
       call pfbicdef("mdef ",5)
       call pfbicdef(name,lname)
       if(hasp) then
          call pfbicdef("()",2)
       endif
       call pfbicdef("=",1)
       call pfbicdefa(cdef1, defsize)
       call osfreen(cdef1,"pfb.cdef1")
       call pfbicdef(" mend",5)
       ind(1)=1
       ind(2)=jcdef
       ind(3)=1
       longname = name(1:lname)//atsign//"macro"
       call pfxwrtd(pfbfids(fileid),longname,"char*",cdef,1,ind)
       return
       end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

       subroutine pfbicdefa(s,ns)
#append ns characters from s onto cdef
#Same as pfbicdef except s is of type Address (ZCM 4/13/1999)
Use(Pfb)
       integer ns
       Address s
       integer old, utsizeof
       external utsizeof

       while(jcdef+ns > lcdef)
          old = lcdef
          lcdef = lcdef*2
          call oschangn(cdef,utsizeof(lcdef,-1),utsizeof(old, -1),
           "pfb.cdef")
       endwhile
       call smovatoa (cdef, jcdef, s, 0, ns)
       jcdef = jcdef + ns
       return
       end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

       subroutine pfbicdef(s,ns)
#append ns characters from s onto cdef
Use(Pfb)
       integer ns, i
       character s(ns)
       integer old, utsizeof
       external utsizeof

       while(jcdef+ns > lcdef)
          old = lcdef
          lcdef = lcdef*2
          call oschangn(cdef,utsizeof(lcdef,-1),utsizeof(old, -1),
           "pfb.cdef")
       endwhile
       do i = 1, ns
          call strputch (cdef, jcdef + i - 1, s(i))
       enddo
       jcdef = jcdef + ns
       return
       end


c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

       subroutine pfbsavef(name, jvar, ndb, fileid)
       character*(*) name
       integer jvar, ndb, fileid
Use(Pfb)
       character*(NPDBN) longname
       Address ftext
       integer ind(3), utgetcl, size
       Address rtgftext
       external utgetcl
# check for this being a user function...
       call glbpknam(ndb,longname)
       if(longname <> "global") then
          call remark("Cannot save non-user function.")
          call remark(name)
          call remark("from package "//longname)
          return
       endif
       longname = name(1:utgetcl(name))//atsign//"funct"
       ftext = rtgftext(jvar, ndb, size)
       ind(1)=1
       ind(2)=size
       ind(3)=1
       call pfxwrtd(pfbfids(fileid),longname,"char*",ftext,1,ind)
       return
       end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

        integer function pfbgrec(fileidi)
# return number of records begun on this file
# fileid defaults to current file for write
Use(Pfb)
        integer fileidi, fileid
        fileid = fileidi
        if(fileid == DEFAULT) fileid = pfbwfid
        call pfbchkf(fileid,"w","pfbgrec")
        return(pfbrecd(fileid))
        end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

        subroutine pfbsrec(irec)
# set record number for read, or report it
        integer irec, iooutus
        external iooutus
        character*40 msg
Use(Pfb)
        if(irec == DEFAULT|pfbdebug > 0) then
#          Changed "write(iooutus(),..." to "call remark". (FNF 7/18/97)
           write(msg, 100) record
           call remark(msg)
           return
 100       format("Current record number is ",i6)
        endif
        record = max(irec,0)
        return
        end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

        integer function pfbcrec()
# return current record number for reading
Use(Pfb)
        return(record)
        end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

       subroutine pfbbegr(fileidi)
Use(Pfb)
# start writing next record of variables
# bump record number
# fileid defaults to current file for write
       integer fileid, fileidi
       character*80 msg
       fileid = fileidi
       if(fileid == DEFAULT) fileid = pfbwfid
       call pfbchkf(fileid,"w","pfbbegr")
       if(pfbrecn(fileid) > 0) then
          call pfbendr(fileid)
       endif
       if(pfbrecd(fileid) == 0) then
          if(pfbcycle <> " ") then
             write(msg,100) atsign, fileid
 100   format('writeas trim(pfb.pfbcycle)//"',a,'"//"history" cycle_variable ',i5)
             call parsestr(msg)
          endif
          if(pfbtime <> " ") then
             write(msg,101) atsign,fileid
 101   format('writeas trim(pfb.pfbtime)//"',a,'"//"history" time_variable ',i5)
             call parsestr(msg)
          endif
       endif
       pfbrecd(fileid) = pfbrecd(fileid) + 1
       pfbrecn(fileid) = pfbrecd(fileid) 
       call pfxbegr(pfbfids(fileid), pfbrecd(fileid))
       return
       end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

       subroutine pfbendr(fileidi)
Use(Pfb)
# finish writing record of variables
# turn record mode off
# fileid defaults to current file for write
       integer fileid, fileidi
       fileid = fileidi
       if(fileid == DEFAULT) fileid = pfbwfid
       call pfbchkf(fileid,"w","pfbendr")
       pfbrecn(fileid) = 0
       call pfxendr(pfbfids(fileid),pfbrecd(fileid))
       return
       end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

       integer function pfbfam(fileidi)
Use(Pfb)
       integer fileidi, fileid, pfbdofam
       external pfbdofam
# family a file being written if this one contains more than pfbmax words
# written during this run.
       fileid = fileidi
       if(fileid == DEFAULT) fileid = pfbwfid
       if(fileid < 1 | fileid > pfbmfiles) then
          call remark("pfbfam: illegal fileid")
          call kaboom(0)
       endif
       if(pfbwrds(fileid) > pfbmax) then
          return(pfbdofam(fileid))
       else
          return(fileid)
       endif
       end
 
c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

# family a file because it is full

      integer function pfbdofam(fileidi)

Use(Pfb)

      integer fileid, fileidi
      Filename f,pfbnamff
      integer lf

      integer utgetcl, pfbopent, rtgetverb
      external utgetcl, pfbopent, rtgetverb

      lf = len(f)
      call pfbclose(fileidi)
      call smovatof(pfbnamff,0,pfbnamf,(fileidi-1)*lf, lf)
      call basnxtsq(pfbnamff, f)

      fileid = pfbopent(f,"w")
      if (fileid == 0) then
         call remark("pfbdofam: cannot create next sequenced file:")
         call remark(f)
         call kaboom(0)
      endif
      
      if (rtgetverb() .eq. YES) then
         call remark("Familying to "//f)
      endif
      
      return(fileid)
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

