c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

      subroutine pfbse(fileid, name, ns, low, hi, str, sx)
Use(Pfb)
      integer fileid, sx(SS_WIDTH)
      integer ns, low(7), hi(7), str(7)
      character*(*) name
      call pfxse(pfbfids(fileid), name, ns, low, hi, str, sx)
      return
      end       

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

      subroutine pfxse(pfileid, name, ns, low, hi, str, sx)
# produce stack element sx containing item requested
# not right for negative strides yet
# Bug fix (ZCM 3/20/97) To handle slices of arrays of character
# strings correctly (see notes below)
Use(Pfb)
      integer pfileid, sx(SS_WIDTH)
      integer ns, low(7), hi(7), str(7), ind(3,7), il, ih
      character*(*) name
      integer iptype, icode, fileidx, jvarx
      character*(NPDBN) pdbtype
      integer ndims, dims(2,8), itype, off1, i, nse
      Address  paraddr
      external paraddr
      integer  utgetcl, parcoerc, iooutus, pfbfind, tc
      external utgetcl, parcoerc, iooutus, pfbfind
      logical partread
      Dynamic(data,integer)
      Address names
      character*(NPDBN) namesj
      Varname indir
      character*80 msg
#
      call pfxivar(pfileid, name, pdbtype, ndims, dims)
      if(pfbdebug > 2) then
#        Changed "write(iooutus(),..." to "call remark". (FNF 7/18/97)
         write(msg, 103) name(1:utgetcl(name))
         call remark(msg)
103      format("Reading ",a)
      endif
      call pfxgbtyp(pfileid, pdbtype, dims, iptype, off1)
# fetch logicals as integers, later coerce 
      if(iptype=typelog) then
         itype=typeint
      elseif(iptype=typeind) then
         itype = -24
      elseif(iptype=typest) then
        call sorry("Cannot read structs from PDB files.")
      else
        itype = iptype
      endif
# we will create a stack object which has same number of dimensions
# as object on disk, minus correction for character stuff
      sx(SS_TC)=itype
      if(itype<0)sx(SS_NAML)=1 # force strings to literal table
      sx(SS_N)=ndims - off1
# use the subscripts supplied to adjust dims
# complicated policy for defaults
      nse = ns  #need a copy since we may change it below
      partread = FALSE
      if(nse > ndims-off1) then
# one subscript on a scalar, ok if it is a 1
        if(ns> 1 | low(1) <> 1 | hi(1) <> 1) then
            call remark("pfbse: too many subscripts on")
            call remark(name)
            call kaboom(0)
         endif
         nse = 0
      endif 
      if (off1 == 1 & itype < 0) then
      # Array of character strings: the first dimension controls
      # the length of strings returned, and should be set to 1:strlen:1
      # (ZCM 3/20/97)
        ind (1, 1) = 1
        ind (2, 1) = -itype
        ind (3, 1) = 1
      endif
      do i=1, nse
        if(str(i)<0) then
              call sorry("pbse: negative stride on file variables")
        endif
        if(low(i)==DEFAULT) then
           il = dims(1,off1+i)
        else
           il = low(i)
        endif           
        if(il<dims(1,off1+i)) then
           call remark("pfbse: error, subscript too low on")
           call remark(name)
           call kaboom(0)
        endif
        if(hi(i)==DEFAULT) then
           ih = il + str(i)*((dims(2,off1+i)-il)/str(i))
        else
           ih = il + str(i)*((hi(i)-il)/str(i))
        endif
        if(ih>dims(2,off1+i)) then
              call remark("pfbse: error, subscript too high on")
              call remark(name)
              call kaboom(0)
        endif
        if(il <> dims(1,off1+i) | ih <> dims(2,off1+i) | str(i) <> 1) then
           partread = TRUE
        endif
        if(il > ih) then
              call remark("pfbse: low subscript > high subscript on")
              call remark(name)
              call kaboom(0)
        endif
        ind(1,off1+i)=il
        ind(2,off1+i)=ih
        ind(3,off1+i)=str(i)
        sx(SS_N1-1+i)=(ih-il)/str(i)+1
        sx(SS_M1-1+i)=il
        sx(SS_I1-1+i)=str(i)
      enddo
# default subscripts not supplied to whole thing
      do i=nse+1, ndims - off1
         sx(SS_N1-1+i)=dims(2,off1+i)-dims(1,off1+i)+1
         sx(SS_M1-1+i)=dims(1,off1+i)
         sx(SS_I1-1+i)=1
         ind(1,off1+i)=dims(1,off1+i)
         ind(2,off1+i)=dims(2,off1+i)
         ind(3,off1+i)=1
      enddo
      call parget(sx)
      Point(data)=paraddr(sx)
      if (sx(SS_TC) < 0) then # string
         call sblkset (Point(data), 0, -sx(SS_TC))
         if(partread) then
            call pfxptrda(pfileid, name, Point(data), ind)
         else
            call pfxreada(pfileid, name, Point(data))
         endif
      else
         if(partread) then
            call pfxptrd(pfileid, name, data, ind)
         else
            call pfxread(pfileid, name, data)
         endif
      endif
# transform non-zero to true
      if(iptype==typelog) then
         if(parcoerc(sx,typelog)==ERR) call kaboom(0)
      endif
      if(iptype=typeind) then
         call parname(sx, indir)
         icode = pfbfind(indir,tc)
         if(icode <> 0) then
            call parkill(sx)
            fileidx = mod(icode, NENCODE)
            jvarx = icode/NENCODE
            names = pfbnamp(fileidx)
            call smovatof (namesj, 0, names, (jvarx-1)*NPDBN, NPDBN)
            call pfbse(fileidx, namesj, ns, low, hi, str, sx)
         endif
      endif
      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

