      subroutine pfbsh(fileid, name, irec, ns, low, hi, str, sx)
# produce stack element sx containing history item requested
# this differs from pfbse in calling pfbhvar to get the last dimension
# right and in the logic to get and put the pieces together at the end.
# (FNF 7/18/97) Changed "write(iooutus(),..." and "write(6,..." to
#               "call remark".
Use(Pfb)
      integer fileid, pfileid, sx(SS_WIDTH)
      integer ns, low(7), hi(7), str(7), ind(3,7), il, ih, 
         irec, nelt, j1, j2
      character*(*) name
      integer iptype, ioff
      character*(NPDBN) pdbtype
      integer ndims, dims(2,8), itype, off1, i, nse, jfile, ir1, ir2, ir3
      character*500 msg  #Big enough for second usage??
      Address  paraddr
      external paraddr
      integer  utgetcl, parcoerc, iooutus, pfbswfam,
          parlen, utsizeof
      external utgetcl, parcoerc, iooutus, pfbswfam,
          parlen, utsizeof
      Dynamic(data,integer,1)
      Dynamic(indices,integer,1)
      Dynamic(highrec,integer,0:1)
#
      pfileid = pfbfids(fileid)
      call pfbhvar(fileid, name, pdbtype, ndims, dims)
      if(pfbdebug > 2) then
         write(msg, 103) name(1:utgetcl(name))
         call remark(msg)
103      format("Reading history ",a)
      endif
      call pfxgbtyp(pfileid, pdbtype, dims, iptype, off1)
# fetch logicals as integers, later coerce 
      if(iptype=typelog) then
         itype=typeint
      elseif(iptype=typeind) then
         call remark("type indirect on a history variable, error")
         call kaboom(0)
      elseif(iptype=typest) then
        call sorry("Read structs from files.")
      elseif(iptype < 0) then
        call sorry("History variables of character types")
      else
        itype = iptype
      endif
# we will create a stack object which has same number of dimensions
# as object on disk, minus correction for character stuff
      sx(SS_TC)=itype
      if(itype<0)sx(SS_NAML)=1 # force strings to literal table
      sx(SS_N)=ndims - off1
# use the subscripts supplied to adjust dims
# complicated policy for defaults
      nse = ns  #need a copy since we may change it below
      if(nse > ndims-off1) then
# one subscript on a scalar, ok if it is a 1
        if(ns> 1 | low(1) <> 1 | hi(1) <> 1) then
            call remark("pfbsh: too many subscripts on")
            call remark(name)
            call kaboom(0)
         endif
         nse = 0
      endif 
      do i=1, nse
        if(str(i)<0) then
              call sorry("pbse: negative stride on file variables")
        endif
        if(low(i)==DEFAULT) then
           il = dims(1,off1+i)
        else
           il = low(i)
        endif           
        if(il<dims(1,off1+i)) then
           call remark("pfbsh: error, subscript too low on")
           call remark(name)
           call kaboom(0)
        endif
        if(hi(i)==DEFAULT) then
           ih = il + str(i)*((dims(2,off1+i)-il)/str(i))
        else
           ih = il + str(i)*((hi(i)-il)/str(i))
        endif
        if(ih>dims(2,off1+i)) then
              call remark("pfbsh: error, subscript too high on")
              call remark(name)
              call kaboom(0)
        endif
        if(il > ih) then
              call remark("pfbsh: low subscript > high subscript on")
              call remark(name)
              call kaboom(0)
        endif
        ind(1,off1+i)=il
        ind(2,off1+i)=ih
        ind(3,off1+i)=str(i)
        sx(SS_N1-1+i)=(ih-il)/str(i)+1
        sx(SS_M1-1+i)=il
        sx(SS_I1-1+i)=str(i)
      enddo
# default subscripts not supplied to whole thing
      do i=nse+1, ndims - off1
         sx(SS_N1-1+i)=dims(2,off1+i)-dims(1,off1+i)+1
         sx(SS_M1-1+i)=dims(1,off1+i)
         sx(SS_I1-1+i)=1
         ind(1,off1+i)=dims(1,off1+i)
         ind(2,off1+i)=dims(2,off1+i)
         ind(3,off1+i)=1
      enddo
      if(irec > 0) then
# default last subscript to irec and lower dimension of the return value
         if(nse < ndims - off1) then
            if(irec < dims(1,ndims) ) then
               call remark("pfbsh: record number too low for")
               call remark(name)
               call kaboom(0)
            elseif(irec > dims(2,ndims) ) then
               call remark("pfbsh: record number too high for")
               call remark(name)
               call kaboom(0)
            endif
            ind(1,ndIms) = irec
            ind(2,ndims) = irec
            sx(SS_N) = sx(SS_N) - 1
         endif
      endif
# set up to get data
      ir1 = ind(1,ndims)
      ir2 = ind(2,ndims)
      ir3 = ind(3,ndims)
      call parget(sx)
      nelt = utsizeof(parlen(sx)/sx(SS_N1 - 1 + ndims),itype)
      Point(data)=paraddr(sx)
      Point(indices) = pfbfami(fileid)
      Point(highrec) = pfbfamh(fileid)
# get data
      j1 = ir1
      ioff = 1
      while(j1 <= ir2)
         jfile = indices(j1)
         pfileid = pfbswfam(fileid,jfile)
# find the last elt we can fetch in *this* file
         j2 = j1 + ((min(highrec(jfile),ir2)-j1)/ir3)*ir3
         ind(2,ndims) = j2 - highrec(jfile-1)
         ind(1,ndims) = j1 - highrec(jfile-1)
         if(pfbdebug > 3) then
            write(msg,'(5i10)') jfile, pfileid, ind(1,ndims), ind(2,ndims), ioff
            call remark(msg)
         endif
         call pfxptrd(pfileid, name, data(ioff), ind)
         ioff = ioff + nelt * (1+(j2-j1)/ir3)
         j1 = j2 + ir3
      endwhile
# transform non-zero to true
      if(iptype==typelog) then
         if(parcoerc(sx,typelog)==ERR) call kaboom(0)
      endif
      return
      end


