
c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

        integer function pfxcall(ivalue)
# This file contains all the actual dialog with the database library
# Fileids in here are DIFFERENT than in the rest of the library.
# In here, they are whatever you want them to be: 
# you return one from pfxopen, and when the library wants to act on that
# file the incoming fileid will be what you returned.
#
# This function checks return values from library calls, gets error message
# if any, reports it, and kabooms.  It is here strictly as an encapsulation
# and doesn't have to be used unless it is helpful.
# It is internal to this file.
        integer ivalue
        character*255 errmsg
        integer nmsg
#
        if(ivalue <> 0) return(ivalue)
#
      	call pfgerr(nmsg,errmsg)
        call remark("Error calling pdb routine:")
        if(nmsg > 1) then
	   call remark(errmsg(1:nmsg))
        else
           call remark("No error message available from PDB.")
        endif
        call kaboom(0)
        return
        end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

        subroutine pfxpwd (fileid, dirname)
        integer fileid
        character*(*) dirname

        integer pfpwd, pfxcall
        external pfpwd, pfxcall

        integer idum, nchr, mchr
        nchr = len(dirname)
        mchr = nchr 
        idum = pfxcall (pfpwd (fileid, mchr, dirname))
# PDB lib naughtily null terminates even in the Fortran interface
        if (mchr < nchr) dirname (mchr + 1:) = " "
        return
        end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

        subroutine pfxcd (fileid, dirname)
        integer fileid
        character*(*) dirname

        integer pfcd, pfxcall, utgetcl
        external pfcd, pfxcall, utgetcl

        integer idum, nchr
        nchr = utgetcl (dirname)
        idum = pfxcall (pfcd (fileid, nchr, dirname(1:nchr)))
        return
        end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

        subroutine pfxmkdir (fileid, dirname)
        integer fileid
        character*(*) dirname

        integer pfmkdr, pfxcall, utgetcl
        external pfmkdr, pfxcall, utgetcl

        integer idum, nchr
        nchr = utgetcl (dirname)
        idum = pfxcall (pfmkdr (fileid, nchr, dirname(1:nchr)))
        return
        end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

	subroutine pfxclose(fileid)
# close the file 
        integer fileid, idum
        integer  pfclos, pfxcall
        external pfclos, pfxcall

	idum = pfxcall(pfclos(fileid))
	return
	end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

      subroutine pfxivar(fileid,namein,type,ndims,dims)
# given the name, return the type, 
# number of dimensions, and low-high indices
      integer fileid,ndims,dims(2,8)
      character*(*) namein, type
      character*(255) ptype
      integer ntype, nchr, idum, nelt
      integer pfxcall, pfivar, utgetcl
      external pfxcall, pfivar, utgetcl
#
      nchr =  utgetcl(namein)
      idum=pfxcall(pfivar(fileid, nchr, namein(1:nchr), 
           ntype, ptype, nelt, ndims, dims))
      type=ptype(1:ntype)
      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

	integer function pfxopen(fname, access)
# try to open fname with access; return -1 if not successful
#
#     parameters:
#          fname     := name of the output file to create or open
#          access    := "r", "w", or "a"
	character*(*) fname
        character access
        integer namelen
        integer utgetcl, pfopen, pfxcall, fileid
        external utgetcl, pfopen, pfxcall
#
        namelen = utgetcl(fname)
        fileid = pfopen(namelen, fname(1:namelen), access)
        if(fileid == 0) then #couldn't open it
           return(-1)
        endif
        return(fileid)
	end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

      subroutine pfxptrd(fileid,namein,space,ind)
# into space, read the part of name described by the low-high-stride 
# triples in ind
      integer fileid, space(1), idum, ind(3,8)
      character*(*) namein
      integer pfxcall, pfptrd, n, utgetcl
      external pfxcall, pfptrd, utgetcl
      n = utgetcl(namein)
      idum = pfxcall(
             pfptrd(fileid,n,namein(1:n),space,ind))
      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

      subroutine pfxptrda(fileid,namein,space,ind)
# into space, read the part of name described by the low-high-stride
# triples in ind
      integer fileid, idum, ind(3,8)
      Address space
      character*(*) namein
      integer pfxcall, mypfptrd, n, utgetcl
      external pfxcall, mypfptrd, utgetcl
      n = utgetcl(namein)
      idum = pfxcall(
             mypfptrd(fileid,n,namein(1:n),space,ind))
      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

      subroutine pfxread(fileid,namein,space)
# into space, read ALL of name
      integer fileid, space(1), idum
      character*(*) namein
      integer pfxcall, pfread, utgetcl, n
      external pfxcall, pfread, utgetcl
      n = utgetcl(namein)
      idum = pfxcall(pfread(fileid,n,namein(1:n),space))
      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

      subroutine pfxreada(fileid,namein,space)
# into space, read ALL of name
      integer fileid, idum
      Address space
      character*(*) namein
      integer pfxcall, mypfread, utgetcl, n
      external pfxcall, mypfread, utgetcl
      n = utgetcl(namein)
      idum = pfxcall(mypfread(fileid,n,namein(1:n),space))
      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

      subroutine pfxwrtd(fileid, namein, type, data, ndim, ind)
# write data under name and with file type type
      integer idum, pfwrtd, mypfwrtd, pfxcall, fileid, utgetcl, data(1), ndim
      integer ind(3,ndim)
      character*(*) namein, type
      character*(NPDBN) name
      integer pfxlegal, n
      external pfwrtd, pfxcall, utgetcl, pfxlegal
      n = pfxlegal(namein, name)
      if (type == "char*")then
         idum = pfxcall( 
           mypfwrtd(fileid, n ,name(1:n),4, "char", data,
              ndim, ind) )
      else
         idum = pfxcall( 
           pfwrtd(fileid, n ,name(1:n),utgetcl(type), type, data,
              ndim, ind) )
      endif
      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

      subroutine pfxappd(fileid, namein, type, data, ndim, ind)
# append data under name 
# note that PDB lib doesn't use type but I thought maybe another lib might
      integer idum, pfappd, pfxcall, fileid, pfxlegal, data(1), ndim
      integer ind(3,ndim), n
      character*(*) namein, type
      external pfappd, pfxcall, pfxlegal
      character*(NPDBN) name
      n = pfxlegal(namein, name)
      idum = pfxcall( pfappd(fileid, n, name(1:n), data, ndim, ind) )
      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

      subroutine pfxvart(fileid,count)
# create a table of the names of the items in the file, preferably disk order
# set count to the number of names in the table
      integer fileid, pfvart, count, idum
      external pfvart
# the 2 means a disk-order table requested
      idum = pfvart(fileid,2,count)
      if(idum ==0) count=0
      return
      end
 
c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

      subroutine pfxgvar(iseq, iname, name)
# get the iseq'th name into name, return number of characters in iname
      integer iseq, pfgvar, iname, pfxcall, idum
      external pfgvar, pfxcall
      character*(*) name
      idum = pfxcall(pfgvar(iseq,iname,name))
      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

      subroutine pfxdvar
# release the table created by pfxvart
      integer idum
      integer pfdvar, pfxcall
      external pfdvar, pfxcall
      idum = pfxcall(pfdvar())
      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

      subroutine pfxbegr(fileid, irec)
# begin a record
      integer fileid, irec
      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

      subroutine pfxendr(fileid, irec)
# end the record
      integer fileid, irec
      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

      subroutine pfxgbtyp(fileid, pdbtype, dims, type, off1)
# find Basis type code corresponding to type used in the file
# Set off1 to 0 or 1 depending on whether file type has a fake first dim
Use(Pfb)
      character*(*) pdbtype
      integer type
      integer off1, dims(2,8), fileid, pfxcall, pfityp
      external pfityp, pfxcall
      off1 = 0
      if(pdbtype="float") then
         type=typer4
      elseif(pdbtype="integer") then
         type=typeint
      elseif(pdbtype="double") then
         type=typer8
      elseif(pdbtype=="long") then
# we don't write these but there are some in older files...
         type=typeint
      elseif(pdbtype="fcomplex") then
         type=typec4
      elseif(pdbtype="complex") then
         type=typec8
      elseif(pdbtype=="char") then
         type = -dims(2,1)
         off1 = 1
      elseif(pdbtype=="logical") then
         type= typelog
      elseif(pdbtype=="range") then
         type= typerng
      elseif(pdbtype=="indirect") then
         type= typeind
      elseif(pdbtype=="macro") then
# we don't write these but there are some in older files...
         type = - dims(2,1)
         off1 = 1
      else
         type = typest
      endif
      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

       subroutine pfxgftyp(tc, pdbtype, off1, ind)
# given a Basis type code, return the pdbtype to write
# set off1 and ind(,1) if needed to absorb a fake first dimension
# On the Cray we label reals as "double" so they don't lose info
# when read on to workstation.
# (5/15/95 ZCM) Use mppl macro INTSTR to give right size for 64 bit machines
Use(Pfb)
       integer tc, off1, ind(3,8)
       character*(*) pdbtype
       off1 = 0
       if(tc=typeint) then
         pdbtype= "integer"
       elseif(tc=typer8) then  #order counts here, see above
         pdbtype="double"
       elseif(tc=typer4) then
         pdbtype="float"
       elseif(tc=typelog) then
         pdbtype="logical"
       elseif(tc=typerng) then
         pdbtype="range"
       elseif(tc=typec8) then  #order counts
         pdbtype="complex"
       elseif(tc=typec4) then
         pdbtype="fcomplex"
       elseif(tc=typeind) then
         pdbtype="indirect"
       elseif(tc < 0) then
         pdbtype = "char"
         off1 = 1
         ind(1,1)=1
         ind(2,1)=(-tc)
         ind(3,1)=1
       else
          call sorry("type not supported for save")
       endif
       return
       end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

       subroutine pfxwdef(pfileid)
# to the recently created file whose id is pfileid, add whatever
# definitions you need for these types:       
# indirect, range, complex, logical, fcomplex
       integer pfileid
        character*32 desc(3)
        integer nc(2,3), idum
        integer utgetcl, pfxcall, pfdeft
        external utgetcl, pfxcall, pfdeft
# define indirect
           desc(1)="char reference(24)"
           nc(1,1)=0
           nc(2,1)=utgetcl(desc(1))
           idum=pfxcall( pfdeft(pfileid,8,"indirect",1,nc,desc))
# define range
           desc(1)="integer start"
           nc(1,1)=0
           nc(2,1)=utgetcl(desc(1))
           desc(2)="integer stop"
           nc(1,2)=len(desc(1))
           nc(2,2)=utgetcl(desc(2))
           desc(3)="integer stride"
           nc(1,3)=2*len(desc(1))
           nc(2,3)=utgetcl(desc(3))
           idum=pfxcall( pfdeft(pfileid,5,"range",3,nc,desc))
# define complex
           desc(1)="double r"
           nc(1,1)=0
           nc(2,1)=utgetcl(desc(1))
           desc(2)="double i"
           nc(1,2)=len(desc(1))
           nc(2,2)=utgetcl(desc(2))
           idum=pfxcall( pfdeft(pfileid,7,"complex",2,nc,desc))
# define fcomplex
           desc(1)="float r"
           nc(1,1)=0
           nc(2,1)=utgetcl(desc(1))
           desc(2)="float i"
           nc(1,2)=len(desc(1))
           nc(2,2)=utgetcl(desc(2))
           idum=pfxcall( pfdeft(pfileid,8,"fcomplex",2,nc,desc))
# define logical
           desc(1)="integer value"
           nc(1,1)=0
           nc(2,1)=utgetcl(desc(1))
           idum=pfxcall( pfdeft(pfileid,7,"logical",1,nc,desc))
       return
       end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

       subroutine pfxsbfs(value)
# set buffer size, if that makes sense
Use(Pfb)
       integer value, pfsbfs, idum, iooutus
       external pfsbfs, iooutus
       character*32 msg
       idum = pfsbfs(value)
       if(pfbdebug > 0) then
          write(msg,100) idum
          call baspline(iooutus(), msg)
       endif
100    format('Buffer size set to ',i10)
       return
       end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

       subroutine pfxgbfs(value)
# get buffer size, if that makes sense
       integer value, pfgbfs
       external pfgbfs
       value = pfgbfs()
       end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

       subroutine pfxstrgt(value)
# set target architecture type, if that makes sense
       integer value
       if(value == 1) then
          call pftrgt(1,1) #SPARC
          call remark("pfb: output file type SPARC")
       else
          call pftrgt(7,7) #UNICOS CRAY
          call remark("pfb: output file type UNICOS")
       endif
       return
       end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

       subroutine pfxwrth(fileid,name,pdbtype,data,ndim,ind,nrec)
# write a history variable
# the name to write gets made legal in pfxwrtd, pfxappd
# I think for most libraries this routine would be self contained and
# if so should legalize name here
       integer fileid, data(1), ndim, nrec
       integer ind(3,8)       
       character*(*) name, pdbtype
       if(ndim +1 > 8) then
            call remark(name)
            call sorry('pfxwrth: too many dimensions for history variable.')
       endif
       ind(1,ndim+1)=nrec
       ind(2,ndim+1)=nrec
       ind(3,ndim+1)=1
       if(nrec == 1) then
          call pfxwrtd(fileid,name,pdbtype,data,ndim+1,ind)
       else
          call pfxappd(fileid,name,pdbtype,data,ndim+1,ind)
       endif
       return
       end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

define([Pfxcom],[
      character ltable(0:255)
      common /pfx/ ltable
      save /pfx/
])

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

       integer function pfxlegal(namein, name)
# change name to be legal for the file to be written
# return number of characters in name
# this version changes everything except @, numbers, letters, $ to underscore
# force leading character to be a lower case letter if necessary
# ltable set in pfxinit
Pfxcom
       character*(*) namein, name
       character*(NPDBN) temp
       integer i, utgetcl, n, j, k, ns
       external utgetcl
#
       temp = namein  #namein might equal name, so watch out
       ns = len(name)
       n = utgetcl(temp)
       k = 0
       if((temp(1:1) < 'a' | temp(1:1) > 'z') & temp(1:1) ~= '$') then
          # (note names starting with $ are OK--usually chameleons [ZCM 5/95])
          k = 1
          name(1:1)="v"
       endif
       do i=1, n
         j = ichar(temp(i:i))
         if(k < ns) then
            k = k + 1
            name(k:k) = ltable(j)
         endif
       enddo
       if(ns > k) then
         name(k+1:ns)=" "
       endif
       return(k)
       end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

       subroutine pfxinit
# called once by pfb to initialize
Pfxcom
       integer i
       do i = 0, 35
          ltable(i) = '_'
       enddo
       ltable(36) = '$'
       do i = 37, 47
          ltable(i) = '_'
       enddo
       do i = 48, 57
          ltable(i) = char(i)
       enddo
       do i = 58, 63
          ltable(i) = '_'
       enddo
       do i = 64, 90
          ltable(i) = char(i)
       enddo
       do i = 91, 96
          ltable(i) = '_'
       enddo
       do i = 97, 122
          ltable(i) = char(i)
       enddo
       do i = 123, 255
          ltable(i) = '_'
       enddo
       return
       end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

