c
c EPATTR - attribute handlers
c

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c EZCADA - assign the default values for the attributes.
c        - if variable autoreset=TRUE, these attributes
c        - will be reset upon a frame advance.

      subroutine ezcada

Use(Ezcurve)
Use(EzcurveDefaults)
Use(Default_attributes)

      integer i

      gridxa   = defgridx
      gridya   = defgridy
      vscalea  = defvsc
      marksa   = defmarks
      thicka   = defthick
      fonta    = deffont
      marka    = defmark
      stylea   = defstyle
      labelsa  = deflabel
      leginfoa = deflegnd
      scalea   = defscale
      cscalea  = defcscale
      arrowa   = defarrow
      rsqa     = defrsq
      colora   = defcolor
      kcolora  = defcolor
      lcolora  = defcolor
      centera  = defpoint
      kstylea  = defksty
      lstylea  = deflsty
      bnda     = defbnd
      levela   = 0

      if (deflev .eq. 0) deflev = 8 #defense against restart, stupidity

      nlevela = deflev
      titlet  = deftop
      titleb  = defbot
      titlel  = defleft
      titler  = defright

      krangea(1) = DEFAULT
      krangea(2) = DEFAULT
      krangea(3) = 1
      lrangea(1) = DEFAULT
      lrangea(2) = DEFAULT
      lrangea(3) = 1

      do i=1, MAXREG
         excludea(i) = FALSE
      enddo

      legenda   = " "
      labela    = 0
      zlimin(1) = 0.0
      zlimin(2) = 0.0
      nzlima    = 0

      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c EZCSETA - sets an attribute for the frame

      subroutine ezcseta(nargs, nargs1, lflag)

Use(Collections)
Use(Default_attributes)
Use(Keywords)
Use(Ezcurve)
Use(EzcurveDefaults)

      integer iarg, nargs, nargs1, lflag, 
         sy(SS_WIDTH), sl(SS_WIDTH), i, nregion, nlabela
      character*72 valuein
      character*72 tmpcolora
      logical doframe
      Address  paraddr
      external paraddr
      integer  parname, parcoerc, parlen, utsizeof
      external parname, parcoerc, parlen, utsizeof
      integer rrange(3)
      integer ibasis
      external ibasis
      Dynamic(y, real(Size8), 1)
      Dynamic(dy, real(Size8), 2)
      Dynamic(iy, integer, 1)
      Dynamic(levlist, real(Size8), 1)
      Address lbl, labeld

      doframe = FALSE

      if (lflag = LOCAL) call ezcsda

      do iarg = nargs1+1, nargs-1, 2
         key = symbols(iarg)
         valuein = symbols(iarg+1)
         if (key .eq. "grid") then
            if (valuein .eq. "xy") then
               gridxa = "on";                gridya = "on"
            elseif (valuein .eq. "x") then
               gridxa = "on";                gridya = "off"
            elseif (valuein .eq. "y") then
               gridxa = "off";               gridya = "on"
            elseif (valuein .eq. "no" | valuein .eq. "tickonly") then
               gridxa = "off";               gridya = "off"
            endif
            doframe = TRUE

         elseif (key .eq. "scale") then
            if (valuein .eq. "linlin" |
                valuein .eq. "linlog" |
                valuein .eq. "loglin" |
                valuein .eq. "loglog" |
                valuein .eq. "equal" ) then
               scalea = valuein
            else
               call ezcargs(iarg+1, scalea)
               if (scalea .ne. "linlin" &
                   scalea .ne. "linlog" &
                   scalea .ne. "loglin" &
                   scalea .ne. "loglog" &
                   scalea .ne. "equal" ) then
                  call ezcremrk(scalea)
                  call ezcremrk("is not a valid value for scale.")
                  scalea = "linlin"
               endif
            endif
            doframe = TRUE

         elseif (key .eq. "cscale") then
            if (valuein .eq. "lin" |
                valuein .eq. "rlin" |
                valuein .eq. "log" |
                valuein .eq. "rlog" |
                valuein .eq. "normal" |
                valuein .eq. "rnormal") then
               cscalea = valuein
            else
	       call ezcargs(iarg+1, cscalea)
               if (cscalea .ne. "lin" &
                   cscalea .ne. "rlin" &
                   cscalea .ne. "log" &
                   cscalea .ne. "rlog" &
                   cscalea .ne. "normal" &
                   cscalea .ne. "rnormal" ) then
                  call ezcremrk(cscalea)
	          call ezcremrk("is not a valid value for cscale; using lin.")
                  cscalea = "lin"
               endif
            endif

         elseif (key .eq. "color") then
            if (valuein .eq. "relpow" 		|
                valuein .eq. "power" 		|
                valuein .eq. "rfillnl" 		|
                valuein .eq. "fillnl"  		|
                valuein .eq. "rfill"  		|
                valuein .eq. "fill"  		|   #Old name for "filled"
                valuein .eq. "filled"  		|
                valuein .eq. "rainbow" 		|
                valuein .eq. "bgcolor" 		|
                valuein .eq. "fgcolor" 		|
                valuein .eq. "red"  		|
                valuein .eq. "green"  		|
                valuein .eq. "blue"  		|
                valuein .eq. "cyan"  		|
                valuein .eq. "magenta"  	|
                valuein .eq. "yellow"  		|
                valuein .eq. "coral"  		|
                valuein .eq. "yellowgreen"  	|
                valuein .eq. "springgreen"  	|
                valuein .eq. "slateblue"  	|
                valuein .eq. "skyblue"  	|
                valuein .eq. "orangered"	| 
                valuein .eq. "gray33"  		|
                valuein .eq. "lavender" 	|
                valuein .eq. "orchid"  		|
                valuein .eq. "gray70") then  
                colora = valuein
            else
                call ezcargs(iarg+1, colora)
                if (colora .ne. "relpow"             &
                    colora .ne. "power"              &
                    colora .ne. "rfillnl"            &
                    colora .ne. "fillnl"             &
                    colora .ne. "rfill"              &
                    colora .ne. "fill"               &   #Old name for "filled"
                    colora .ne. "filled"             &
                    colora .ne. "rainbow"            &
                    colora .ne. "bgcolor"            &
                    colora .ne. "fgcolor"            &
                    colora .ne. "red"                &
                    colora .ne. "green"              &
                    colora .ne. "blue"               &
                    colora .ne. "cyan"               &
                    colora .ne. "magenta"            &
                    colora .ne. "yellow"             &
                    colora .ne. "coral"              &
                    colora .ne. "yellowgreen"        &
                    colora .ne. "springgreen"        &
                    colora .ne. "slateblue"          &
                    colora .ne. "skyblue"            &
                    colora .ne. "orangered"          &
                    colora .ne. "gray33"             &
                    colora .ne. "lavender"           &
                    colora .ne. "orchid"             &
                    colora .ne. "gray70") then
                    call ezcremrk(colora)
                    call ezcremrk("is not a valid color name")
                    colora = "fgcolor"
                endif
            endif

c ... make "fill" a synonym for "filled" -- FNF 10/17/96
            if (colora .eq. "fill") colora = "filled"

         elseif (key .eq. "kcolor" | key .eq. "lcolor") then
            if (valuein .eq. "rainbow" 		|
                valuein .eq. "bgcolor" 		|
                valuein .eq. "fgcolor" 		|
                valuein .eq. "red"  		|
                valuein .eq. "green"  		|
                valuein .eq. "blue"  		|
                valuein .eq. "cyan"  		|
                valuein .eq. "magenta"  	|
                valuein .eq. "yellow"  		|
                valuein .eq. "coral"  		|
                valuein .eq. "yellowgreen"  	|
                valuein .eq. "springgreen"  	|
                valuein .eq. "slateblue"  	|
                valuein .eq. "skyblue"  	|
                valuein .eq. "orangered"	| 
                valuein .eq. "gray33"  		|
                valuein .eq. "lavender" 	|
                valuein .eq. "orchid"  		|
                valuein .eq. "gray70") then  
                if (key .eq. "kcolor" ) then
                   kcolora = valuein
                else
                   lcolora = valuein
                endif
            else
                call ezcargs(iarg+1, tmpcolora)
                if (key .eq. "kcolor" ) then
                   kcolora = tmpcolora
                else
                   lcolora = tmpcolora
	        endif
                if (tmpcolora .ne. "rainbow"            &
                    tmpcolora .ne. "bgcolor"            &
                    tmpcolora .ne. "fgcolor"            &
                    tmpcolora .ne. "red"                &
                    tmpcolora .ne. "green"              &
                    tmpcolora .ne. "blue"               &
                    tmpcolora .ne. "cyan"               &
                    tmpcolora .ne. "magenta"            &
                    tmpcolora .ne. "yellow"             &
                    tmpcolora .ne. "coral"              &
                    tmpcolora .ne. "yellowgreen"        &
                    tmpcolora .ne. "springgreen"        &
                    tmpcolora .ne. "slateblue"          &
                    tmpcolora .ne. "skyblue"            &
                    tmpcolora .ne. "orangered"          &
                    tmpcolora .ne. "gray33"             &
                    tmpcolora .ne. "lavender"           &
                    tmpcolora .ne. "orchid"             &
                    tmpcolora .ne. "gray70") then
                    call ezcremrk(tmpcolora)
                    call ezcremrk("is not a valid color name")
                    if ( key .eq. "kcolor" ) then
                       kcolora = "fgcolor"
                    else
                       lcolora = "fgcolor"
                    endif
                endif

            endif

         elseif (key .eq. "thick") then
            call ezcargr(iarg+1, thicka)

         elseif (key .eq. "vsc") then
            call ezcargr(iarg+1, vscalea)

         elseif (key .eq. "krange") then
            call ezcargx(iarg+1, krangea)

         elseif (key .eq. "lrange") then
            call ezcargx(iarg+1, lrangea)

         elseif (key .eq. "bnd") then
            call ezcargi(iarg+1, bnda)

         elseif (key .eq. "region") then
            if (valuein .eq. "all") then
               do i = 1, MAXREG
                  excludea(i)=FALSE
               enddo
            else
               call fcnarga(iarg+1, sy)
               if (sy(SS_TC) .eq. typex) then
                  call ezcargx(iarg+1, rrange)
                  if (rrange(1).eq.DEFAULT) rrange(1) = 1
                  if (rrange(2).eq.DEFAULT) rrange(1) = MAXREG
                  if (rrange(3).eq.DEFAULT) rrange(1) = 1
                  rrange(1)=max(1, rrange(1))
                  rrange(2)=min(MAXREG, rrange(2))
                  rrange(3)=max(1, rrange(3))
                  do i = 1, MAXREG
                     excludea(i) = TRUE
                  enddo
                  do i = rrange(1), rrange(2), rrange(3)
                     excludea(i) = FALSE
                  enddo
               elseif (parcoerc(sy, typeint) .eq. ERR) then
                  call ezcremrk('region list unacceptable, ignored')
               else
                  nregion = parlen(sy)
                  if (nregion .eq. 0) then
                     call ezcremrk('region list unacceptable, ignored.')
                  else
                     Point(iy) = paraddr(sy)
                     do i = 1, MAXREG
                        excludea(i) = TRUE
                     enddo
                     do i = 1, nregion
                        if (iy(i) < 1 | iy(i) > MAXREG) next
                        excludea(iy(i)) = FALSE
                     enddo
                  endif
               endif
               call parkill(sy) # ZCM 11/14/95
            endif

         elseif (key .eq. "lev") then
            if (valuein .eq. "log") then
               nlevela = -abs(deflev)
               levela = 0
            elseif (valuein .eq. "linear") then
               nlevela = abs(deflev)
               levela = 0
            else
               call fcnarga(iarg+1, sy)
               if ( parlen(sy) .eq. 1 & sy(SS_TC) = typeint) then
                  Point(iy) = paraddr(sy)
                  nlevela =  iy(1)
                  levela = 0
               else
                  if (parcoerc(sy, type4) .eq. ERR) then
                     call ezcremrk('Contour levels unacceptable, ignored.')
                     nlevela = deflev
                     levela = 0
                  else
                     nlevela = parlen(sy)
                     if (nlevela > 0) then
                        call memtemp(Point(levlist), Quote(real8), nlevela,
     &                               Quote(EZCSETA:levlist ))
                        Point(y) = paraddr(sy)
                        do i = 1, nlevela
                           levlist(i) = y(i)
                        enddo
                        call ezcsdata(Point(levlist), nlevela, 1, levela, FALSE)
                     else
                        call ezcremrk("Empty contour level list given, ignored.")
                        levela  = 0
                        nlevela = deflev
                     endif
                  endif
               endif
               call parkill(sy) # ZCM 11/14/95
            endif

         elseif (key .eq. "kstyle") then
            kstylea = valuein

         elseif (key .eq. "lstyle") then
            lstylea = valuein

         elseif (key .eq. "style") then
            stylea = valuein

         elseif (key .eq. "labels") then
            if (valuein .eq. "yes") then
               labelsa = YES
               doframe=TRUE
            elseif (valuein .eq. "no") then
               labelsa = NO
               doframe=TRUE
            else
               call fcnarga(iarg+1, sl)
               call pardim(sl)
               nlabela = parlen(sl)
               if (nlabela .eq. 0) then
                  call ezcremrk('Labels unacceptable, ignored.')
                  go to 900
               endif
               if (parcoerc(sl, -16) .eq. ERR) then
                  call ezcremrk('Labels unacceptable, ignored.')
                  go to 900
               else
                  call memtemp(labeld, Quote(character*16), nlabela,
     &                               Quote(EZCSETA:labeld ))
                  lbl = paraddr(sl)
                  do i = 1, nlabela
                     call smovatoa (labeld, (i - 1) * 16, lbl, (i - 1) * 16, 16)
                  enddo
                  call ezcsdata(labeld, nlabela, 1, labela, FALSE)
               endif
               call parkill(sl) # ZCM 11/14/95
            endif

         elseif (key .eq. "font") then
            if (index(valuein, "bold_") .eq. 1) then
               fonta = valuein(6:)
            else
               fonta = valuein
            endif

         elseif (key .eq. "arrow") then
            if (valuein = "yes") then
               arrowa = YES
            else
               arrowa = NO
            endif

         elseif (key .eq. "mark") then
            if (valuein .eq. " ") then
               marka = " "
            else
               do i=1, NMARKERS
                  if (valuein .eq. markers(i)) then
                     marka = valuein
                     break
                  endif
               enddo
               if (i > NMARKERS) marka="cross"
            endif

         elseif (key .eq. "marksize") then
            call ezcargr(iarg+1, marksa)

         elseif (key .eq. "rsquared") then
            call ezcargr(iarg+1, rsqa)

         elseif (key .eq. "legend") then
            if (valuein .eq. "yes") then
               leginfoa = YES
               doframe=TRUE
            elseif (valuein .eq. "no") then
               leginfoa = NO
               doframe=TRUE
            else
               call ezcargs(iarg+1, legenda)
            endif

#         elseif (key .eq. "zfactor") then
#            call ezcargr(iarg+1, zfactora)

#         elseif (key .eq. "zcenter") then
#            call ezcargr(iarg+1, zcentera)

         elseif (key .eq. "point") then
            call ezcargi(iarg+1, centera)

         elseif (key .eq. "zlim") then
            call fcnarga(iarg+1, sy)
            if ( parcoerc(sy, type8) .eq. ERR ) then
               call ezcremrk('z-limits unacceptable, ignored.')
               nzlima = 0
            else if ( parlen(sy) .ne. 2 ) then
               call ezcremrk('Illegal number of z-limits, ignored.')
               nzlima = 0
            else
               nzlima = 2
               Point(dy) = paraddr(sy)

c ... make sure zmin < zmax
               if ( dy(1) > dy(2) ) then
                  zlimin(1) = dy(2)
                  zlimin(2) = dy(1)
               else
                  zlimin(1) = dy(1)
                  zlimin(2) = dy(2)
               endif
            endif
            call parkill(sy)
         else
            call ezcremrk ("attr: <"//key//"> is an invalid keyword, ignored")
         endif

  900    continue
         call parkilla(iarg)
         call parkilla(iarg+1)
      enddo

      if (iarg <=nargs) then
         call ezcremrk("dangling keyword ignored.")
      endif

      if (doframe) then
         pending = TRUE
         call ezcshowf
      endif

      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c EZDHOOK - user-replaceable routine called on various events

      subroutine ezchook(msg1, msg2)

      character*(*) msg1, msg2

c      call ezcremrk(msg1//":"//msg2)

      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

