c
c EPDISP.M - display list handlers
c

c--------------------------------------------------------------------------

c                   DISPLAY LIST ADD ROUTINES

c--------------------------------------------------------------------------

c EZCADDC - add curve to display list

      subroutine ezcaddc(y, m, nyc, ilow, istridey, x, nxin, nxcin)
      integer m, nyc, nx, nxc, istridey, nxin, nxcin
      integer ilow, numdata, j1, j2, i
      real(Size8) y(m*nyc), x(nxin*nxcin)

Use(Ezcurve)
Use(Collections)
Use(Default_attributes)
Use(Extrema)

      Dynamic(xs, real(Size8), 1)
      Dynamic(xsa, real(Size8), 1)
      Dynamic(ys, real(Size8), 1)
      logical xexlarge, xexsmall, yexlarge, yexsmall
      integer utsizeof
      external utsizeof
      real(Size8) yave
      real(Size8) anum
      real(Size8) floor
      real(Size8) arg1, arg2
      logical arequal
      logical ezcnopl
      external ezcnopl
      real(Size8) d1mach
      external d1mach
      character*80 errmsg
    
      floor(anum)=real(sign(max(realsmall, abs(anum)), anum), Size8)

c ... the following assumes arg2>0.
      arequal(arg1, arg2) = abs(arg1-arg2)/max(abs(arg1), arg2) .lt. d1mach(4)
    
      if (ezcnopl()) return  # Implement no-plot option (FNF 11/11/96)
      xexlarge = .false.
      yexlarge = .false.
      xexsmall = .false.
      yexsmall = .false.

      call ezcxpnd
      if (marka .ne. " ") then
         namec(nc) = Mark
      elseif (arrowa = YES) then
         namec(nc) = Arrow
      else
         namec(nc) = Curve
      endif

      labeli(nc) = labela

c ... save the data      
      if (nxcin = 0) then

c ... x not supplied
         if (ixprev .eq. 0) then
            nx  = m
            nxc = 1

            numdata = nx*nxc
            call memtemp(Point(xs), Quote(real8), numdata, Quote(EZCADDC:xs ))

            do i = 1, m
              xs(i) = ilow +(i-1)*istridey
            enddo
            call ezcsdata(Point(xs), nx, nxc, xi(nc), TRUE)
            ixprev = xi(nc) ; ixpreva = 0
         else
            nx = n1(ixprev)
            nxc = n2(ixprev)
            xi(nc) = ixprev
            Point(xs) = data(ixprev)
         endif

c ... x supplied
      else
         nx  = nxin
         nxc = nxcin

         numdata = nx*nxc
         call memtemp(Point(xs), Quote(real8), numdata, Quote(EZCADDC:xs ))

         do j1 = 1, nx*nxc
            xs(j1) = x(j1)
            if (arequal(abs(xs(j1)), real(ceiling, Size8))) then
               xexlarge = .true.
            else if (x(j1) .ne. 0.) then
               xs(j1) = floor(x(j1))
               if (arequal(abs(xs(j1)), real(realsmall, Size8))) \
                  xexsmall = .true.
            endif
         enddo
         call ezcsdata(Point(xs), nx, nxc, xi(nc), TRUE)
         ixprev = xi(nc) ; ixpreva = 0
      endif

      if (nxc > 1 & nxc .ne. nyc) then
         call ezcremrk("plot: mismatched numbers of curves.")
         go to 900
      endif
      if (abs(nx-m)>1) then
         call ezcremrk('plot: curves have mismatched lengths, ignored.')
         go to 900
      endif

c ... the y data is used as presented
      if (nx >= m) then

         numdata = m*nyc
         call memtemp(Point(ys), Quote(real8), numdata, Quote(EZCADDC:ys ))

         do j1 = 1, m*nyc
            ys(j1) = y(j1)
            if (arequal(abs(ys(j1)), real(ceiling, Size8))) then
               yexlarge =.true.
            else if (y(j1) .ne. 0.) then
               ys(j1) = floor(y(j1))
               if (arequal(abs(ys(j1)), real(realsmall, Size8))) \
                  yexsmall = .true.
            endif
         enddo
         call ezcsdata(Point(ys), m, nyc, yi(nc), TRUE)
      endif

c ... need to use the averaged form of x
      if (nx .eq. m+1) then
         if (ezcnocx) then
            call ezcremrk('plot: length(x) = length(y) + 1, averaging disabled.')
            call ezcremrk('command ignored.')
            go to 900
         endif

         if (ixpreva > 0) then
            xi(nc) = ixpreva
         else
            numdata = m*nxc
            call memtemp(Point(xsa), Quote(real8), numdata, Quote(EZCADDC:xsa ))

            do j2 = 1, nxc
               do j1 = 1, m
                  xsa(j1+(j2-1)*m) = (xs(j1+(j2-1)*nx) +
     &                                xs(j1+(j2-1)*nx+1))*0.5_Size8
               enddo
            enddo
            call ezcsdata(Point(xsa), m, nxc, xi(nc), TRUE)
            ixpreva = xi(nc)
         endif
      endif

c ... need to use the averaged form of y -- the original y is not saved
      if (m .eq. nx+1) then
         if (ezcnocy) then
            call ezcremrk('plot: length(y) = length(x) + 1, averaging disabled.')
            call ezcremrk('command ignored.')
            go to 900
         endif

         numdata = (m-1)*nyc
         call memtemp(Point(ys), Quote(real8), numdata, Quote(EZCADDC:ys ))

         do j2 = 1, nyc
            do j1 = 1, m-1
               yave = (y(j1+(j2-1)*m)+y(j1+(j2-1)*m+1))*0.5_Size8
               ys(j1+(j2-1)*(m-1)) = yave
               if (arequal(abs(ys(j1+(j2-1)*(m-1))), \
                            real(ceiling, Size8))) then
                  yexlarge = .true.
               else if (yave .ne. 0.) then
                  ys(j1+(j2-1)*(m-1)) = floor(yave)
                  if (arequal(abs(ys(j1+(j2-1)*(m-1))), \
                               real(realsmall, Size8))) yexsmall = .true.
               endif
            enddo
         enddo
         call ezcsdata(Point(ys), m-1, nyc, yi(nc), TRUE)
      endif

      if (ezcdebug) then
         if (xexlarge) then
            write(errmsg, '(a, 1p, e11.3)') 'WARNING!! x data exceeds plot limit ', ceiling
            call ezcremrk(errmsg)
         endif
         if (xexsmall) then
            write(errmsg, '(a, 1p, e11.3)') 'WARNING!! x data is below plot limit ', realsmall
            call ezcremrk(errmsg)
         endif
         if (yexlarge) then
            write(errmsg, '(a, 1p, e11.3)') 'WARNING!! y data exceeds plot limit ', ceiling
            call ezcremrk(errmsg)
         endif
         if (yexsmall) then
            write(errmsg, '(a, 1p, e11.3)') 'WARNING!! y data is below plot limit ', realsmall
            call ezcremrk(errmsg)
         endif
      endif

      pending = TRUE
      if (ezcshow) call ezcshowf
      return

900   continue
      call ezcremrk(legenda)
      nc = nc - 1

      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c EZCADDFM - add fill poly to display list
c          - is the array of physics quantities 

      subroutine ezcaddfm(x, y, z, ireg, kmax, lmax, cidxflag)
      implicit none
      integer kmax, lmax
      real(Size8) x(kmax, lmax), y(kmax, lmax), z(kmax, lmax)
      integer ireg(kmax, lmax), cidxflag

Use(Ezcurve)
Use(Collections)
Use(Default_attributes)
Use(Extrema)
Use(EzcurveDefaults)

      call ezcadd21(x, y, z, ireg, kmax, lmax, FillMesh, 1, 0)

      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c EZCADDFT - add ftext to display list

      subroutine ezcaddft(s, x, y, nsize, angle, align)
      real(Size8) x, y, angle, align
      character*(*) s
      integer nsize, n, m

      Address ssave
      Dynamic(tdata, real(Size8), 4)
      Dynamic(xsave, real(Size8))
      Dynamic(ysave, real(Size8))

Use(Ezcurve)
Use(Collections)
Use(Default_attributes)

      integer utsizeof
      external utsizeof

      logical ezcnopl
      external ezcnopl
      if (ezcnopl()) return  # Implement no-plot option (FNF 11/11/96)

      n = len(s)
      m = utsizeof(1, -n)

      call memtemp(Point(xsave), Quote(real8), 1, Quote(EZCADDFT:xsave ))
      call memtemp(Point(ysave), Quote(real8), 1, Quote(EZCADDFT:ysave ))
      call memtemp(ssave, Quote(character*(LSIZE)), m,
     &             Quote(EZCADDFT:ssave ))
      call memtemp(Point(tdata), Quote(real8), 4,
     &             Quote(EZCADDFT:tdata ))

      call smovftoa (ssave, 0, s, 0, n)

      xsave = x
      ysave = y

      tdata(1) = n
      tdata(2) = nsize
      tdata(3) = angle
      tdata(4) = align

      call ezcxpnd
      namec(nc) = Ftext

      call ezcsdata(Point(xsave), 1, 1, xi(nc), FALSE)
      call ezcsdata(Point(ysave), 1, 1, yi(nc), FALSE)
      call ezcsdata(Point(tdata), 4, 1, vxi(nc), FALSE)
      call ezcsdata(ssave, m, 1, zi(nc), FALSE)

      pending = TRUE
      if (ezcshow) call ezcshowf

      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c EZCADDI - add image to display list

      subroutine ezcaddi(icell, m, n, x1, x2, y1, y2)
      integer m, n, icell(1), i
      real(Size8) x1, x2, y1, y2

Use(Ezcurve)
Use(Collections)
Use(Default_attributes)
Use(Extrema)

      integer ni
      logical xexlarge, xexsmall, yexlarge, yexsmall
      real(Size8) anum
      real(Size8) floor
      real(Size8) arg1, arg2
      character*80 errmsg

      Dynamic(xs, real(Size8), 2)
      Dynamic(ys, real(Size8), 2)
      Dynamic(icells, integer, 1)

      integer utsizeof
      external utsizeof
      logical ezcnopl
      external ezcnopl
      logical arequal
      real(Size8) d1mach
      external d1mach

      floor(anum)=real(sign(max(realsmall, abs(anum)), anum), Size8)

c ... the following assumes arg2>0
      arequal(arg1, arg2) = abs(arg1-arg2)/max(abs(arg1), arg2) .lt. d1mach(4)

      if (ezcnopl()) then
         return
      endif

      xexlarge = .false.
      yexlarge = .false.
      xexsmall = .false.
      yexsmall = .false.

      ni = n*m

      if (ni .eq. 0) then
         call ezcremrk("ezcaddi: cell array empty")
         call ezcremrk(legenda)
         nc = nc - 1
         return
      endif

      call ezcxpnd
      namec(nc) = CellArray

      call memtemp(Point(icells), Quote(integer), ni,
     &             Quote(EZCADDI:icells ))
      call memtemp(Point(xs), Quote(real8), 2, Quote(EZCADDI:xs ))
      call memtemp(Point(ys), Quote(real8), 2, Quote(EZCADDI:ys ))

      do i = 1, ni
         icells(i) = icell(i)
      enddo

      xs(1) = x1
      if (arequal(abs(xs(1)), real(ceiling, Size8))) then
         xexlarge = .true.
      else if (x1 .ne. 0.0) then
         xs(1) = floor(x1)
         if (arequal(abs(xs(1)), real(realsmall, Size8))) xexsmall = .true.
      endif

      xs(2) = x2
      if (arequal(abs(xs(2)), real(ceiling, Size8))) then
         xexlarge = .true.
      else if (x2 .ne. 0.0) then
         xs(2) = floor(x2)
         if (arequal(abs(xs(2)), real(realsmall, Size8))) xexsmall = .true.
      endif

      ys(1) = y1
      if (arequal(abs(ys(1)), real(ceiling, Size8)))  then
         yexlarge = .true.
      else if (y1 .ne. 0.0) then
         ys(1) = floor(y1)
         if (arequal(abs(ys(1)), real(realsmall, Size8))) yexsmall = .true.
      endif

      ys(2) = y2 
      if (arequal(abs(ys(2)), real(ceiling, Size8)))  then
         yexlarge = .true.
      else if (y2 .ne. 0.0) then
         ys(2) = floor(y2)
         if (arequal(abs(ys(2)), real(realsmall, Size8))) yexsmall = .true.
      endif

      if (ezcdebug) then
         if (xexlarge) then
            write(errmsg, '(a, 1p, e11.3)') 'WARNING!! x data exceeds plot limit ', ceiling
            call ezcremrk(errmsg)
         endif
         if (xexsmall) then
            write(errmsg, '(a, 1p, e11.3)') 'WARNING!! x data is below plot limit ', realsmall
            call ezcremrk(errmsg)
         endif
         if (yexlarge) then
            write(errmsg, '(a, 1p, e11.3)') 'WARNING!! y data exceeds plot limit ', ceiling
            call ezcremrk(errmsg)
         endif
         if (yexsmall) then
            write(errmsg, '(a, 1p, e11.3)') 'WARNING!! y data is below plot limit ', realsmall
            call ezcremrk(errmsg)
         endif
      endif

      call ezcsdata(Point(icells), m, n, zi(nc), FALSE)
      call ezcsdata(Point(xs),     2, 1, xi(nc), TRUE)
      call ezcsdata(Point(ys),     2, 1, yi(nc), TRUE)

      pending = TRUE

      if (ezcshow) call ezcshowf

      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c EZCADDM - add mesh plot to display list

      subroutine ezcaddm(x, y, ireg, kmax, lmax)
      implicit none
      integer kmax, lmax
      real(Size8) x(kmax, lmax), y(kmax, lmax)
      integer ireg(kmax, lmax)

Use(Ezcurve)
Use(Collections)
Use(Default_attributes)
Use(Extrema)
Use(EzcurveDefaults)

      call ezcadd21(x, y, x, ireg, kmax, lmax, Mesh, 1, 0)

      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c EZCADDMC - add contour map for a point-centered quantity to display list

      subroutine ezcaddmc(x, y, z, ireg, kmax, lmax)
      implicit none
      integer kmax, lmax
      real(Size8) x(kmax, lmax), y(kmax, lmax), z(kmax, lmax)
      integer ireg(kmax, lmax)

Use(Ezcurve)
Use(Collections)
Use(Default_attributes)
Use(Extrema)
Use(EzcurveDefaults)

      call ezcadd21(x, y, z, ireg, kmax, lmax, MeshContour, 1, 0)

      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c EZADDP - add a polyplot object to the display list
c
c     Real arrays x and y contain the x- and y-coordinates of the
c     polygon(s) to be plotted.  They are both assumed dimensioned 
c     (nx1, nx2).  If either of these numbers is 1, a single polygon
c     is to be be plotted; otherwise, npoly=nx2 polygons are to be
c     plotted.  In the latter case npts=nx1 > 2 is the number of sides
c     of the polygons.

      subroutine ezcaddp(x, y, nx1, nx2)
      implicit none

c ... declare arguments
      integer nx1, nx2, cidxflag
      real(Size8) y(nx1, nx2), x(nx1, nx2), z(1)

Use(Ezcurve)
Use(Collections)
Use(Default_attributes)
Use(Extrema)
Use(EzcurveDefaults)

c ... declare local variables
      integer npoly, npts

c ... distinguish between one and multiple polygons.
      if (nx1 .eq. 1) then   # Treat (1, nx2) array as (nx2, 1).
         npts  = nx2
         npoly = 1
      else
         npts  = nx1
         npoly = nx2
      endif

      call ezcaddac21(x, y, z, npts, npoly, PolyFill)

      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c EZCADDPF - add a polyfunc object to the display list
c
c     Real arrays x and y contain the x- and y-coordinates of the
c     polygon(s) to be treated.  They are both assumed dimensioned 
c     (nx1, nx2).  If either of these numbers is 1, there is a single
c     polygon (npoly=1); otherwise, there are npoly=nx2 polygons.  In
c     the latter case npts=nx1 > 2 is the number of sides of the polygons.
c
c     In either case, there are npoly elements in the z-array.
c
c     The flag cidxflag is nonzero if z contains color indices.

      subroutine ezcaddpf(x, y, z, nx1, nx2, cidxflag)
      implicit none

c ... declare arguments
      integer nx1, nx2, cidxflag
      real(Size8) y(nx1, nx2), x(nx1, nx2), z(*)

Use(Ezcurve)
Use(Collections)
Use(Default_attributes)
Use(Extrema)
Use(EzcurveDefaults)

c ... declare local variables
      integer npoly, npts

c ... distinguish between one and multiple polygons.
      if (nx1 .eq. 1) then   # Treat (1, nx2) array as (nx2, 1).
         npts  = nx2
         npoly = 1
      else
         npts  = nx1
         npoly = nx2
      endif

      call ezcaddac21(x, y, z, npts, npoly, PolyFunc)

      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c EZCADDR - add laser ray plot to display list

      subroutine ezcaddr(laser, nlaser, raypr, raypz, rayppow, jrp, kpt, ndx, mxp, idmpr, rpltf, rayl, rayu, nsray)
      real(Size8) raypr(1), raypz(1), rayppow(1)
      integer nlaser, laser(1), nsray
      integer jrp(1), kpt(1), ndx(1), mxp(1), idmpr(1), rpltf(1), rayl(1), rayu(1)
      integer utsizeof
      external utsizeof

Use(Ezcurve)
Use(Collections)
Use(Default_attributes)
Use(Extrema)
Use(EzcurveDefaults)

      integer i, j, k, kk, ii
      integer tnrays, nthray, tnraypts, nthpt
      integer dispmark(15)
      integer imkstr
      external imkstr
      save dispmark
      Dynamic(lasindx, integer, 1)        # array of laser indices
      Dynamic(raydspix, integer, 1)       # array of laser dispmark indices
      Dynamic(lasers, integer, 1)         # array of lasers 
      Dynamic(nrays, integer, 1)          # array of ray count 
      Dynamic(raylabs, integer, 1)        # array of ray labels
      Dynamic(dispmarks, integer, 1)      # array of dispmark indices
      Dynamic(nraypts, integer, 1)        # array of point count(rays linearized)
      Dynamic(xs, real(Size8), 1)         # z coordinates of points
      Dynamic(ys, real(Size8), 1)         # r coordinates of points
      Dynamic(pws, real(Size8), 1)        # power values at the points YHC 4/3/95
      data dispmark /49, 50, 51, 52, 53, 54, 55, 56, 57, 111, 98, 97, 110, 101, 108/

      character*80 msg

      logical ezcnopl
      external ezcnopl

      if (ezcnopl()) return  # Implement no-plot option (FNF 11/11/96)

      call ezcxpnd
      namec(nc) = Ray

      call memtemp(Point(lasindx), Quote(integer), nlaser,
     &             Quote(EZCADDR:lasindx ))
      call memtemp(Point(raydspix), Quote(integer), nlaser,
     &             Quote(EZCADDR:raydspix ))
      call memtemp(Point(lasers), Quote(integer), nlaser,
     &             Quote(EZCADDR:lasers ))
      call memtemp(Point(nrays), Quote(integer), nlaser,
     &             Quote(EZCADDR:nrays ))

      do i = 1, nlaser
         lasers(i) = laser(i)
      enddo

      tnrays = 0        # total number of rays to plot
      tnraypts = 0      # total number of plot points
      
      do i = 1, nlaser
c ... check if bad laser number
         if ((laser(i)  .le.  0) | (laser(i) > nsray)) then
            call memfree(Point(lasindx))
            call memfree(Point(raydspix))
            call memfree(Point(lasers))
            call memfree(Point(nrays))
            nc = nc -1
            write(msg, 951) laser(i)
            call ezcerror(msg, 0)
951   format('ezcaddr: invalid laser number ', i7)
            return
         endif

c ... check if laser is to be plotted
         if (jrp(laser(i)) .eq. 0) then
            call memfree(Point(lasindx))
            call memfree(Point(raydspix))
            call memfree(Point(lasers))
            call memfree(Point(nrays))
            nc = nc -1
            write (msg, 961) laser(i)
            call ezcerror(msg, 0)
961   format ('ezcray: ray plot flag (JRP) is off for laser number ', i7)
            return
         endif

c ... set laser index
         lasindx(i) = 0
         do j = 1, laser(i)
            lasindx(i) = lasindx(i) + jrp(j)
         enddo

         raydspix(i) = ndx(lasindx(i)) - 1      # used for dispmarks

c ... number of rays for this laser
         nrays(i) = rayu(lasindx(i))-rayl(lasindx(i))+1         
         tnrays = tnrays + nrays(i)             # the total number of rays

      enddo

      call memtemp(Point(nraypts), Quote(integer), tnrays,
     &             Quote(EZCADDR:nraypts ))
      call memtemp(Point(raylabs), Quote(integer), tnrays,
     &             Quote(EZCADDR:raylabs ))
      call memtemp(Point(dispmarks), Quote(integer), tnrays,
     &             Quote(EZCADDR:dispmarks ))

      nthray = 0        # cursor to walk through all rays
      do i = 1, nlaser
         do j = 1, nrays(i)
            kk = rayl(lasindx(i)) + j - 1
            nthray = nthray + 1
            nraypts(nthray) = mxp(kk)   # store no of pts in each ray
            if (mxp(kk) > 0) then

c ... calculate number of total ploting points
               tnraypts= tnraypts+ mxp(kk)      # the total plot points
c ... store ray labels and dispmarks
               raylabs(nthray) = kk

               ii = idmpr(kk)
               if (ii > 0 & ii < 16) then
                  dispmarks(nthray) = dispmark(ii)
               else
                  dispmarks(nthray) = 0
               endif
            endif
         enddo
      enddo

      call memtemp(Point(xs), Quote(real8), tnraypts,
     &             Quote(EZCADDR:xs ))
      call memtemp(Point(ys), Quote(real8), tnraypts,
     &             Quote(EZCADDR:ys ))

c ... allocate memory to store power reading at the points
      call memtemp(Point(pws), Quote(real8), tnraypts,
     &             Quote(EZCADDR:pws ))
      
      nthpt = 0 # cursor to walk through all data points
      do i = 1, nlaser    

c ... process all laser rays
         do j = rayl(lasindx(i)), rayu(lasindx(i))
            if (mxp(j) > 0) then

c ... store the ray info
               do k = 1, mxp(j)
                  nthpt = nthpt + 1
                  ys(nthpt)  = raypr(kpt(j)+k)
                  xs(nthpt)  = raypz(kpt(j)+k)
                  pws(nthpt) = rayppow(kpt(j)+k)        # store power values
               enddo
            endif
         enddo
      enddo

c ... store the data for ezcdispl
      call ezcsdata(Point(lasers), nlaser, 1, lasi(nc), FALSE)
      call ezcsdata(Point(nrays), nlaser, 1, nrayi(nc), FALSE)
      call ezcsdata(Point(raylabs), tnrays, 1, raylabi(nc), FALSE)
      call ezcsdata(Point(dispmarks), tnrays, 1, dispmarki(nc), FALSE)
      call ezcsdata(Point(nraypts), tnrays, 1, nraypti(nc), FALSE)
      call ezcsdata(Point(ys), tnraypts, 1, yi(nc), FALSE)
      call ezcsdata(Point(xs), tnraypts, 1, xi(nc), FALSE)
      call ezcsdata(Point(pws), tnraypts, 1, pwi(nc), FALSE)       

      pending = TRUE
      if (ezcshow) call ezcshowf

      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c EZCADDT - add text to display list

      subroutine ezcaddt(s, x, y, nsize, angle, align)
      character*(*) s
      real(Size8) x, y, angle, align

      integer nsize, n, m
      Address ssave
      Dynamic(tdata, real(Size8), 4)
      Dynamic(xsave, real(Size8))
      Dynamic(ysave, real(Size8))

Use(Ezcurve)
Use(Collections)
Use(Default_attributes)

      integer utsizeof
      external utsizeof

      logical ezcnopl
      external ezcnopl

      if (ezcnopl()) return  # Implement no-plot option (FNF 11/11/96)

      n = len(s)
      m = utsizeof(1, -n)

      call memtemp(Point(xsave), Quote(real8), 1, Quote(EZCADDT:xsave ))
      call memtemp(Point(ysave), Quote(real8), 1, Quote(EZCADDT:ysave ))
      call memtemp(ssave, Quote(character*(LSIZE)), m,
     &             Quote(EZCADDT:ssave ))
      call memtemp(Point(tdata), Quote(real8), 4,
     &             Quote(EZCADDT:tdata ))

      call smovftoa (ssave, 0, s, 0, n)

        xsave = x
        ysave = y

        tdata(1) = n
        tdata(2) = nsize
        tdata(3) = angle
        tdata(4) = align

        call ezcxpnd
        namec(nc) = Text

        call ezcsdata(Point(xsave), 1, 1, xi(nc), TRUE)
        call ezcsdata(Point(ysave), 1, 1, yi(nc), TRUE)
        call ezcsdata(Point(tdata), 4, 1, vxi(nc), FALSE)
        call ezcsdata(ssave, m, 1, zi(nc), FALSE)

        pending = TRUE

        if (ezcshow) call ezcshowf

        return
        end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c EZCADDV - add vector plot to display list

      subroutine ezcaddv(x, y, xv, yv, ireg, kmax, lmax)
      implicit none
      integer kmax, lmax
      real(Size8) x(kmax, lmax), y(kmax, lmax), xv(kmax, lmax), yv(kmax, lmax)
      integer ireg(kmax, lmax)

Use(Ezcurve)
Use(Collections)
Use(Default_attributes)
Use(Extrema)
Use(EzcurveDefaults)

      call ezcadd22(x, y, xv, yv, ireg, kmax, lmax, Vector, 1)

      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c EZCADDZ - add contour map of random data or matrix vs. vector vector
c         - or matrix matrix matrix to display list

      subroutine ezcaddz(z, nz1, nz2, x, nx1, nx2, y, ny1, ny2)
      implicit none
      real(Size8) z(1)
      integer nz1, nz2
      real(Size8) x(1)
      integer nx1, nx2
      real(Size8) y(1)
      integer ny1, ny2

Use(Ezcurve)
Use(Collections)
Use(Default_attributes)
Use(Extrema)
Use(Random_Contour_Plots)

      integer cpfl

c ... rectangular is default
c ... z, x, and y are matrices of the same shape
      cpfl = 0

c ... matrix-vector-vector
c ... z is a matrix, x and y are vectors
      if ((nz2 .gt. 1) .and. (nz1 .eq. nx1) .and.
     &    (nz2 .eq. ny1) .and. (nx2 .eq. 1) .and. (ny2 .eq. 1)) then
         cpfl = 1

c ... random
c ... use multiquadric fit to fill a grid
c ... this grid should fit the data, not the frame -- pfd, 10/3/91
      elseif ((nz2 .eq. 1) .and.
     &        (nz1*nz2 .eq. nx1*nx2) .and. (nz1*nz2 .eq. ny1*ny2)) then

c GOTCHA: add this capability
c         call ezcremrk("plotz: blowing this one off for now")
         return
      endif

      call ezcadd21(x, y, z, 0, nx1, ny1, OtherContour, 0, cpfl)

      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c EZCADD21 - add 2D domain 1D range plot
c          - Z is the array of physics quantities 

      subroutine ezcadd21(x, y, z, ireg, kmax, lmax, render, irfl, cpfl)
      implicit none
      integer kmax, lmax
      real(Size8) x(kmax, lmax), y(kmax, lmax), z(kmax, lmax)
      integer ireg(kmax, lmax), render, irfl, cpfl

Use(Ezcurve)
Use(Collections)
Use(Default_attributes)
Use(Extrema)
Use(EzcurveDefaults)

      real(Size8) zz(5)
      character*80 errmsg

      integer j, k, l, m, n, nn, nz, nhit
      integer nks, nls, nkm, nlm, km
      integer klo, khi, kinc, khilmt, llo, lhi, linc, lhilmt
      integer ic
      logical xexlarge, xexsmall, yexlarge, yexsmall, ok
      real(Size8) xsmin, xsmax, ysmin, ysmax
      real(Size8) xsamin, xsamax, ysamin, ysamax
      real(Size8) xc, yc

      Dynamic(xs, real(Size8), 1)
      Dynamic(ys, real(Size8), 1)
      Dynamic(zs, real(Size8), 1)
      Dynamic(zexts, real(Size8), 5)    # zmin, zmax, zbar, zsigma and zmap
      Dynamic(iregs, integer, 1)
      Dynamic(kllmts, integer, 8)
      Dynamic(kpregs, logical, 1)

      real(Size8) d1mach
      external d1mach
      integer utsizeof
      external utsizeof
      integer ibasis
      external ibasis
      logical ezcsel
      external ezcsel
      logical ezcnopl
      external ezcnopl

      logical arequal
      real(Size8) floor, anum, arg1, arg2

      floor(anum) = real(sign(max(realsmall, abs(anum)), anum), Size8)

c ... the following assumes arg2 > 0
      arequal(arg1, arg2) = abs(arg1-arg2)/max(abs(arg1), arg2) .lt. d1mach(4)

      if (ezcnopl()) then
         return
      endif

      xexlarge = .false.
      yexlarge = .false.
      xexsmall = .false.
      yexsmall = .false.

c ... initialize zz
      do j = 1, 5
         zz(j) = 0.0
      enddo

c ... pick up user-supplied limits
      if (nzlima .gt. 0) then
         zz(1) = zlimin(1)
         zz(2) = zlimin(2)
      endif

      klo  = 1
      khi  = kmax
      kinc = 1
      nks  = khi
      llo  = 1
      lhi  = lmax
      linc = 1
      nls  = lhi
      if (irfl .eq. 1) then
         call ezckl(kmax, lmax, ireg, klo, khi, kinc, 
     &              llo, lhi, linc, nks, nls)
      endif

      n = nks*nls
      if (n .eq. 0) then
         call ezcremrk('plot21:  specification excludes all points, ignored.')
         return
      endif

      call ezcxpnd
      namec(nc) = render

      lhilmt = lhi
      khilmt = khi
      if (lhi .lt. lmax) lhilmt = lhilmt + 1
      if (khi .lt. kmax) khilmt = khilmt + 1

      nks = khilmt - klo + 1
      nls = lhilmt - llo + 1
      nkm = nks - 1
      nlm = nls - 1
      km  = khilmt - 1
      nn  = nks*nls
      nz  = nkm*nlm

      call memtemp(Point(xs),     Quote(real8),   nn, Quote(EZCADD21:xs ))
      call memtemp(Point(ys),     Quote(real8),   nn, Quote(EZCADD21:ys ))
      call memtemp(Point(zs),     Quote(real8),   nz, Quote(EZCADD21:zs ))
      call memtemp(Point(iregs),  Quote(integer), nz, Quote(EZCADD21:iregs ))
      call memtemp(Point(kpregs), Quote(integer), nn, Quote(EZCADD21:kpregs ))
      call memtemp(Point(kllmts), Quote(integer), 8,  Quote(EZCADD21:kllmts ))
      call memtemp(Point(zexts),  Quote(real8),   5,  Quote(EZCADD21:zexts ))

      zexts(1) = zz(1)
      zexts(2) = zz(2)
      zexts(3) = zz(3)
      zexts(4) = zz(4)
      zexts(5) = zz(5)

      j      = 0
      nhit   = 0
      ysmin  = real(ceiling, Size8)
      ysmax  = real(-ceiling, Size8)
      xsmin  = real(ceiling, Size8)
      xsmax  = real(-ceiling, Size8)
      ysamin = real(ceiling, Size8)
      ysamax = real(-ceiling, Size8)
      xsamin = real(ceiling, Size8)
      xsamax = real(-ceiling, Size8)
      do l = llo, lhilmt
         do k = klo, khilmt
            j = j + 1

            if (cpfl .eq. 1) then
               xc = x(k, 1)
               yc = y(l, 1)
            else
               xc = x(k, l)
               yc = y(k, l)
            endif

            if (irfl .eq. 1) then
               ic = ireg(k, l)
            else
               ic = 1
            endif

            if ((yc .eq. -1.0e8) .and. (ic .eq. 0)) then
               yc = ysmin
            endif

            ys(j) = yc
            if (arequal(abs(ys(j)), real(ceiling, Size8))) then
               yexlarge = .true.

            else if (yc .ne. 0.0) then
               ys(j) = floor(yc)
               if (arequal(abs(ys(j)), real(realsmall, Size8))) then
                  yexsmall = .true.
               endif
            endif

            xs(j) = xc
            if (arequal(abs(xs(j)), real(ceiling, Size8))) then
               xexlarge = .true.

            else if (xc .ne. 0.0) then
               xs(j) = floor(xc)
               if (arequal(abs(xs(j)), real(realsmall, Size8))) then
                  xexsmall = .true.
               endif
            endif

            if ((l .ne. llo) .and. (k .ne. klo)) then
               m = (l - 2)*km + k - 1
               zs(m)    = z(k, l)
               iregs(m) = ic
            endif

            if (irfl .eq. 1) then
               kpregs(j) = .not.(excludea(ic))
               ok = ezcsel(k, l, kmax, lmax, ireg)
            else
               kpregs(j) = .false.
               ok        = .true.
            endif
            if (ok) then
               xsmin  = min(xsmin,  xs(j))
               xsmax  = max(xsmax,  xs(j))
               xsamin = min(xsamin, abs(xs(j)))
               xsamax = max(xsamax, abs(xs(j)))

               ysmin  = min(ysmin,  ys(j))
               ysmax  = max(ysmax,  ys(j))
               ysamin = min(ysamin, abs(ys(j)))
               ysamax = max(ysamax, abs(ys(j)))

               nhit = nhit + 1
            endif
         enddo
      enddo

      if (nhit .eq. 0) then
         call ezcremrk('plot21:  specification excludes all points, ignored.')
         call memfree(Point(xs))
         call memfree(Point(ys))
         call memfree(Point(zs))
         call memfree(Point(iregs))
         call memfree(Point(kpregs))
         call memfree(Point(kllmts))
         call memfree(Point(zexts))
         nc = nc - 1
         return
      endif

      if (ezcdebug) then
         if (xexlarge) then
            write(errmsg, '(a, 1p, e11.3)') 'WARNING!! x data exceeds plot limit ', ceiling
            call ezcremrk(errmsg)
         endif
         if (xexsmall) then
            write(errmsg, '(a, 1p, e11.3)') 'WARNING!! x data is below plot limit ', realsmall
            call ezcremrk(errmsg)
         endif
         if (yexlarge) then
            write(errmsg, '(a, 1p, e11.3)') 'WARNING!! y data exceeds plot limit ', ceiling
            call ezcremrk(errmsg)
         endif
         if (yexsmall) then
            write(errmsg, '(a, 1p, e11.3)') 'WARNING!! y data is below plot limit ', realsmall
            call ezcremrk(errmsg)
         endif
      endif

      kllmts(1) = klo
      kllmts(2) = khi
      kllmts(3) = kinc
      kllmts(4) = llo
      kllmts(5) = lhi
      kllmts(6) = linc
      kllmts(7) = kmax
      kllmts(8) = lmax

      call ezcsdata(Point(xs),     nks, nls, xi(nc),     FALSE)
      call ezcsdata(Point(ys),     nks, nls, yi(nc),     FALSE)
      call ezcsdata(Point(zs),     nkm, nlm, zi(nc),     FALSE)
      call ezcsdata(Point(iregs),  nkm, nlm, iregi(nc),  FALSE)
      call ezcsdata(Point(kpregs), nks, nls, kpregi(nc), FALSE)
      call ezcsdata(Point(kllmts), 1,   8,   kllmti(nc), FALSE)
      call ezcsdata(Point(zexts),  1,   5,   zexti(nc),  FALSE)

      call ezcchgfe(yi(nc), ysmin, ysmax, ysamin, ysamax)
      call ezcchgfe(xi(nc), xsmin, xsmax, xsamin, xsamax)

c ... store mesh plot attributes
c     call ezcsmda

      pending = TRUE

      if (ezcshow) call ezcshowf

      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c EZCADDAC21 - add 2D domain 1D range arbitrarily connected plot
c            - Z is the array of physics quantities 

      subroutine ezcaddac21(x, y, z, npts, nply, render)
      implicit none
      integer npts, nply
      real(Size8) x(npts, nply), y(npts, nply), z(nply)
      integer ireg(npts, nply), render

Use(Ezcurve)
Use(Collections)
Use(Default_attributes)
Use(Extrema)
Use(EzcurveDefaults)

      real(Size8) zz(5)
      character*80 errmsg

      integer j, k, l, n, nn, nhit
      integer ic
      logical xexlarge, xexsmall, yexlarge, yexsmall, ok
      real(Size8) xsmin, xsmax, ysmin, ysmax
      real(Size8) xsamin, xsamax, ysamin, ysamax
      real(Size8) xc, yc

      Dynamic(xs, real(Size8), 1)
      Dynamic(ys, real(Size8), 1)
      Dynamic(zs, real(Size8), 1)
      Dynamic(zexts, real(Size8), 5)    # zmin, zmax, zbar, zsigma and zmap
      Dynamic(kllmts, integer, 8)
      Dynamic(kpregs, logical, 1)

      real(Size8) d1mach
      external d1mach
      integer utsizeof
      external utsizeof
      integer ibasis
      external ibasis
      logical ezcsel
      external ezcsel
      logical ezcnopl
      external ezcnopl

      logical arequal
      real(Size8) floor, anum, arg1, arg2

      floor(anum) = real(sign(max(realsmall, abs(anum)), anum), Size8)

c ... the following assumes arg2 > 0
      arequal(arg1, arg2) = abs(arg1-arg2)/max(abs(arg1), arg2) .lt. d1mach(4)

      if (ezcnopl()) then
         return
      endif

      xexlarge = .false.
      yexlarge = .false.
      xexsmall = .false.
      yexsmall = .false.

c ... initialize zz
      do j = 1, 5
         zz(j) = 0.0
      enddo

c ... pick up user-supplied limits
      if (nzlima .gt. 0) then
         zz(1) = zlimin(1)
         zz(2) = zlimin(2)
      endif

      n = npts*nply
      if (n .eq. 0) then
         call ezcremrk('plot21ac:  specification excludes all points, ignored.')
         return
      endif

      call ezcxpnd
      namec(nc) = render

      nn = npts*nply

      call memtemp(Point(xs),     Quote(real8),   nn,   Quote(EZCADDAC21:xs ))
      call memtemp(Point(ys),     Quote(real8),   nn,   Quote(EZCADDAC21:ys ))
      call memtemp(Point(zs),     Quote(real8),   nply, Quote(EZCADDAC21:zs ))
      call memtemp(Point(kpregs), Quote(integer), nn,   Quote(EZCADDAC21:kpregs ))
      call memtemp(Point(kllmts), Quote(integer), 8,    Quote(EZCADDAC21:kllmts ))
      call memtemp(Point(zexts),  Quote(real8),   5,    Quote(EZCADDAC21:zexts ))

      zexts(1) = zz(1)
      zexts(2) = zz(2)
      zexts(3) = zz(3)
      zexts(4) = zz(4)
      zexts(5) = zz(5)

      j      = 0
      nhit   = 0
      ysmin  = real(ceiling, Size8)
      ysmax  = real(-ceiling, Size8)
      xsmin  = real(ceiling, Size8)
      xsmax  = real(-ceiling, Size8)
      ysamin = real(ceiling, Size8)
      ysamax = real(-ceiling, Size8)
      xsamin = real(ceiling, Size8)
      xsamax = real(-ceiling, Size8)
      do l = 1, nply
         do k = 1, npts
            j = j + 1

            xc = x(k, l)
            yc = y(k, l)

            ic = 1

            if ((yc .eq. -1.0e8) .and. (ic .eq. 0)) then
               yc = ysmin
            endif

            ys(j) = yc
            if (arequal(abs(ys(j)), real(ceiling, Size8))) then
               yexlarge = .true.

            else if (yc .ne. 0.0) then
               ys(j) = floor(yc)
               if (arequal(abs(ys(j)), real(realsmall, Size8))) then
                  yexsmall = .true.
               endif
            endif

            xs(j) = xc
            if (arequal(abs(xs(j)), real(ceiling, Size8))) then
               xexlarge = .true.

            else if (xc .ne. 0.0) then
               xs(j) = floor(xc)
               if (arequal(abs(xs(j)), real(realsmall, Size8))) then
                  xexsmall = .true.
               endif
            endif

            kpregs(j) = .false.
            ok        = .true.

            if (ok) then
               xsmin  = min(xsmin,  xs(j))
               xsmax  = max(xsmax,  xs(j))
               xsamin = min(xsamin, abs(xs(j)))
               xsamax = max(xsamax, abs(xs(j)))

               ysmin  = min(ysmin,  ys(j))
               ysmax  = max(ysmax,  ys(j))
               ysamin = min(ysamin, abs(ys(j)))
               ysamax = max(ysamax, abs(ys(j)))

               nhit = nhit + 1
            endif
         enddo

         zs(l) = z(l)

      enddo

      if (nhit .eq. 0) then
         call ezcremrk('plot21:  specification excludes all points, ignored.')
         call memfree(Point(xs))
         call memfree(Point(ys))
         call memfree(Point(zs))
         call memfree(Point(kpregs))
         call memfree(Point(kllmts))
         call memfree(Point(zexts))
         nc = nc - 1
         return
      endif

      if (ezcdebug) then
         if (xexlarge) then
            write(errmsg, '(a, 1p, e11.3)') 'WARNING!! x data exceeds plot limit ', ceiling
            call ezcremrk(errmsg)
         endif
         if (xexsmall) then
            write(errmsg, '(a, 1p, e11.3)') 'WARNING!! x data is below plot limit ', realsmall
            call ezcremrk(errmsg)
         endif
         if (yexlarge) then
            write(errmsg, '(a, 1p, e11.3)') 'WARNING!! y data exceeds plot limit ', ceiling
            call ezcremrk(errmsg)
         endif
         if (yexsmall) then
            write(errmsg, '(a, 1p, e11.3)') 'WARNING!! y data is below plot limit ', realsmall
            call ezcremrk(errmsg)
         endif
      endif

      kllmts(1) = 1
      kllmts(2) = npts
      kllmts(3) = 1
      kllmts(4) = 1
      kllmts(5) = nply
      kllmts(6) = 1
      kllmts(7) = npts
      kllmts(8) = nply

      call ezcsdata(Point(xs),     npts, nply, xi(nc),     FALSE)
      call ezcsdata(Point(ys),     npts, nply, yi(nc),     FALSE)
      call ezcsdata(Point(zs),     nply, 1,    zi(nc),     FALSE)
      call ezcsdata(Point(kpregs), npts, nply, kpregi(nc), FALSE)
      call ezcsdata(Point(kllmts), 1,    8,    kllmti(nc), FALSE)
      call ezcsdata(Point(zexts),  1,    5,    zexti(nc),  FALSE)

      call ezcchgfe(yi(nc), ysmin, ysmax, ysamin, ysamax)
      call ezcchgfe(xi(nc), xsmin, xsmax, xsamin, xsamax)

c ... store mesh plot attributes
c     call ezcsmda

      pending = TRUE

      if (ezcshow) call ezcshowf

      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c EZCADD22 - add 2D vector type plots to display list

      subroutine ezcadd22(x, y, xv, yv, ireg, kmax, lmax, render, irfl)
      implicit none
      integer kmax, lmax
      real(Size8) x(kmax, lmax), y(kmax, lmax), xv(kmax, lmax), yv(kmax, lmax)
      integer ireg(kmax, lmax)
      integer render, irfl

Use(Ezcurve)
Use(Collections)
Use(Default_attributes)
Use(Extrema)
Use(EzcurveDefaults)

      integer j, k, l, n, nhit
      integer klo, khi, kinc, llo, lhi, linc
      integer nks, nls, ic
      real(Size8) xsmin, xsmax, ysmin, ysmax
      real(Size8) xsamin, xsamax, ysamin, ysamax
      real(Size8) xc, yc
      logical xexlarge, xexsmall, yexlarge, yexsmall
      logical xvexlarge, xvexsmall, yvexlarge, yvexsmall
      logical ok
      character*80 errmsg

      Dynamic(xs, real(Size8), 1)
      Dynamic(ys, real(Size8), 1)
      Dynamic(xvs, real(Size8), 1)
      Dynamic(yvs, real(Size8), 1)

      real(Size8) anum, arg1, arg2
      real(Size8) floor
      logical arequal
      logical ezcsel
      external ezcsel
      logical ezcnopl
      external ezcnopl
      real(Size8) d1mach
      external d1mach

      floor(anum)=real(sign(max(realsmall, abs(anum)), anum), Size8)

c ... the following assumes arg2 > 0.0
      arequal(arg1, arg2) = abs(arg1-arg2)/max(abs(arg1), arg2) .lt. d1mach(4)

      if (ezcnopl()) then
         return
      endif

      xexlarge = .false.
      yexlarge = .false.
      xexsmall = .false.
      yexsmall = .false.

      xvexlarge = .false.
      yvexlarge = .false.
      xvexsmall = .false.
      yvexsmall = .false.

      klo  = 1
      khi  = kmax
      kinc = 1
      nks  = khi
      llo  = 1
      lhi  = lmax
      linc = 1
      nls  = lhi
      if (irfl .eq. 1) then
         call ezckl(kmax, lmax, ireg, klo, khi, kinc, 
     &              llo, lhi, linc, nks, nls)
      endif

      n = nks*nls
      if (n .eq. 0) then
         call ezcremrk('plot22: no points selected, ignored.')
         return
      endif

      call ezcxpnd
      namec(nc) = render

      marksc(nc) = vscalea

      call memtemp(Point(xs),  Quote(real8), n, Quote(EZCADD22:xs ))
      call memtemp(Point(ys),  Quote(real8), n, Quote(EZCADD22:ys ))
      call memtemp(Point(xvs), Quote(real8), n, Quote(EZCADD22:xvs ))
      call memtemp(Point(yvs), Quote(real8), n, Quote(EZCADD22:yvs ))

      j      = 0
      nhit   = 0
      ysmin  = real(ceiling, Size8)
      ysmax  = real(-ceiling, Size8)
      xsmin  = real(ceiling, Size8)
      xsmax  = real(-ceiling, Size8)
      ysamin = real(ceiling, Size8)
      ysamax = real(-ceiling, Size8)
      xsamin = real(ceiling, Size8)
      xsamax = real(-ceiling, Size8)

      do l = llo, lhi, linc
         do k = klo, khi, kinc
            j = j + 1

            xc = x(k, l)
            yc = y(k, l)
            if (irfl .eq. 1) then
               ic = ireg(k, l)
            else
               ic = 1
            endif

            if ((yc .eq. -1.0e8) .and. (ic .eq. 0)) then
               yc = ysmin
            endif

            ys(j) = yc
            if (arequal(abs(ys(j)), real(ceiling, Size8))) then
               yexlarge = .true.
            else if (yc .ne. 0.) then
               ys(j) = floor(yc)
               if (arequal(abs(ys(j)), real(realsmall, Size8))) \
                  yexsmall = .true.
            endif

            xs(j) = xc
            if (arequal(abs(xs(j)), real(ceiling, Size8))) then
               xexlarge = .true.
            else if (xc .ne. 0.) then
               xs(j) = floor(xc)
               if (arequal(abs(xs(j)), real(realsmall, Size8))) \
                  xexsmall = .true.
            endif

            if (irfl .eq. 1) then
               ok = ezcsel(k, l, kmax, lmax, ireg)
            else
               ok = .true.
            endif
            if (ok) then
               yvs(j) = yv(k, l)
               if (arequal(abs(yvs(j)), real(ceiling, Size8))) then
                  yvexlarge =.true.
               else if (yv(k, l) .ne. 0.) then
                  yvs(j) = floor(yv(k, l))
                  if (arequal(abs(yvs(j)), real(realsmall, Size8))) \
                     yvexsmall =.true.
               endif

               xvs(j) = xv(k, l)
               if (arequal(abs(xvs(j)), real(ceiling, Size8))) then
                  xvexlarge =.true.
               else if (xv(k, l) .ne. 0.) then
                  xvs(j) = floor(xv(k, l))
                  if (arequal(abs(xvs(j)), real(realsmall, Size8))) \
                     xvexsmall =.true.
               endif

               xsmin  = min(xsmin, xs(j))
               xsmax  = max(xsmax, xs(j))
               ysmin  = min(ysmin, ys(j))
               ysmax  = max(ysmax, ys(j))
               xsamin = min(xsamin, abs(xs(j)))
               xsamax = max(xsamax, abs(xs(j)))
               ysamin = min(ysamin, abs(ys(j)))
               ysamax = max(ysamax, abs(ys(j)))

               nhit = nhit + 1

            else
               yvs(j) = 0.0
               xvs(j) = 0.0
            endif
         enddo
      enddo

      if (ezcdebug) then
         if (xexlarge) then
            write(errmsg, '(a, 1p, e11.3)') 'WARNING!! x data exceeds plot limit ', ceiling
            call ezcremrk(errmsg)
         endif

         if (xexsmall) then
            write(errmsg, '(a, 1p, e11.3)') 'WARNING!! x data is below plot limit ', realsmall
            call ezcremrk(errmsg)
         endif

         if (yexlarge) then
            write(errmsg, '(a, 1p, e11.3)') 'WARNING!! y data exceeds plot limit ', ceiling
            call ezcremrk(errmsg)
         endif

         if (yexsmall) then
            write(errmsg, '(a, 1p, e11.3)') 'WARNING!! y data is below plot limit ', realsmall
            call ezcremrk(errmsg)
         endif

         if (xvexlarge) then
            write(errmsg, '(a, 1p, e11.3)') 'WARNING!! xv data exceeds plot limit ', ceiling
            call ezcremrk(errmsg)
         endif

         if (xvexsmall) then
            write(errmsg, '(a, 1p, e11.3)') 'WARNING!! xv data is below plot limit ', realsmall
            call ezcremrk(errmsg)
         endif

         if (yvexlarge) then
            write(errmsg, '(a, 1p, e11.3)') 'WARNING!! yv data exceeds plot limit ', ceiling
            call ezcremrk(errmsg)
         endif

         if (yvexsmall) then
            write(errmsg, '(a, 1p, e11.3)') 'WARNING!! yv data is below plot limit ', realsmall
            call ezcremrk(errmsg)
         endif
      endif

      if (nhit .eq. 0) then
         call ezcremrk('plot22: no points selected, ignored.')
         call memfree(Point(ys))
         call memfree(Point(xs))
         call memfree(Point(yvs))
         call memfree(Point(xvs))
         nc = nc - 1
         return
      endif

      call ezcsdata(Point(xs),  nks, nls, xi(nc),  FALSE)
      call ezcsdata(Point(ys),  nks, nls, yi(nc),  FALSE)
      call ezcsdata(Point(xvs), nks, nls, vxi(nc), FALSE)
      call ezcsdata(Point(yvs), nks, nls, vyi(nc), FALSE)

      call ezcchgfe(xi(nc), xsmin, xsmax, xsamin, xsamax)
      call ezcchgfe(yi(nc), ysmin, ysmax, ysamin, ysamax)

c ... store plot attributes
c      call ezcsmda

      pending = TRUE

      if (ezcshow) call ezcshowf

      return
      end

c--------------------------------------------------------------------------

c                        DISPLAY LIST ROUTINES

c--------------------------------------------------------------------------

c EZCSUB - undo the i'th command listed on the legend
c        - this part marks them, ezcsubx does the delete

      subroutine ezcsub(k)
      implicit none

Use(Collections)
Use(Default_attributes)

      integer i, j, k
      integer streq1f
      external streq1f

      call pltstart

      if (k < 1) return
      if (k > nc) return

      j = 0
      do i = 1, nc
         if (streq1f(legendc, (i - 1)*LSIZE, LSIZE, " ", 0, 1) == 0) then
            j = j + 1
            if (j .eq. k) then
               namec(i) = Remove
               return
            endif
         endif
      enddo

      call ezcremrk("undo: huh?")
      return

      entry ezcsubx

      i = nc
      while (i > 0)
         if (namec(i) = Remove) then
            do j = i, nc-1
               xi(j)       = xi(j+1)
               yi(j)       = yi(j+1)
               vyi(j)      = vyi(j+1)
               vxi(j)      = vxi(j+1)
               zi(j)       = zi(j+1)
               pwi(j)      = pwi(j+1)
               zexti(j)    = zexti(j+1)
               iregi(j)    = iregi(j+1)
               kpregi(j)   = kpregi(j+1)
               kllmti(j)   = kllmti(j+1)
               bndflagi(j) = bndflagi(j+1)
               labeli(j)   = labeli(j+1)
               marksc(j)   = marksc(j+1)
               namec(j)    = namec(j+1)
               thickc(j)   = thickc(j+1)
            enddo

            if (nc - i > 0) then
               call smovatoa(stylec, 8 * (i - 1), stylec, 8 * i,
     &                       (nc - i) * 8)
               call smovatoa(lstylec, 8 * (i - 1), lstylec, 8 * i,
     &                       (nc - i) * 8)
               call smovatoa(kstylec, 8 * (i - 1), kstylec, 8 * i,
     &                       (nc - i) * 8)
               call smovatoa(markc, 8 * (i - 1), markc, 8 * i,
     &                       (nc - i) * 8)
               call smovatoa(fontc, 8 * (i - 1), fontc, 8 * i,
     &                       (nc - i) * 8)
               call smovatoa(colorc, 16 * (i - 1), colorc, 16 * i,
     &                       (nc - i) * 16)
               call smovatoa(kcolorc, 16 * (i - 1), kcolorc, 16 * i,
     &                       (nc - i) * 16)
               call smovatoa(lcolorc, 16 * (i - 1), lcolorc, 16 * i,
     &                       (nc - i) * 16)
               call smovatoa(preleg, 16 * (i - 1), preleg, 16 * i,
     &                       (nc - i) * 16)
               call smovatoa(legendc, LSIZE * (i - 1), legendc, LSIZE * i,
     &                       (nc - i) * LSIZE)
            endif
            
            nc = nc - 1
         endif

         i = i - 1
      endwhile
      
      return
      end

c--------------------------------------------------------------------------

c                      DRAWING ROUTINES

c--------------------------------------------------------------------------

c EZCDISPL - draw everything on the display list

      subroutine ezcdispl
      implicit none

Use(Ezcurve)      
Use(Collections)
Use(Probe)
Use(Extrema)
Use(Default_attributes)
Use(EzcurveDefaults)
Use(Random_Contour_Plots)
Use(Cpmpxy)
Use(Contours)
Use(Device_Internal)

c ... variables for color implementations
      logical cfill, rcfill, filml

c ... variables for contour plot
      logical conerr, conplot

c ... variables for fillmesh plot
      logical fmplot
      integer indbase, numcol
      real(Size8) eps
 
c ... variables for ray plot
      logical raypw
      integer laserct, rayct, rayptct

c ... variables for polyfill or polyfun plot
      logical pfplot
      integer npoly, npts, pcolor

c ... variables for general plot usage
      integer devid, id
      integer nlines
      parameter(nlines=64)
      character*(LSIZE) logmsg
      integer iplot, i, q1, textonly, jminsz, plttyp, nlinfac
      real(Size8) pquad(4), quad(4), xspec(3), yspec(3)
      real(Size8) titlert, titlelf, titletp, titlebt, suptitle
      real(Size8) xdivider, conkey
c       real(Size8) cfux, cfuy
c       external cfux, cfuy # NCAR

      integer utgetcl, utsizeof, ezcmqd, ezcmarki, strgetcl, streq1f
      external utgetcl, utsizeof, ezcmqd, ezcmarki, strgetcl, streq1f
      integer imkstr
      external imkstr
      external ezcmap
      real(Size8) ezcmap
      integer ezcctoi
      external ezcctoi
      integer ezcrnbw
      external ezcrnbw
      integer ibasis
      external ibasis

      eps     = 1.0e-14
      conerr  = .false.
      conplot = .false.
      fmplot  = .false.
      pfplot  = .false.
      raypw   = .false.
      cfill   = .false.
      rcfill  = .false.
      filml   = .false.

      if (yucked) then
         call ezcerror("Clearing EZN display list of data that caused error.", 0)
c         call ezcclear
         call ezcsetxn
         call ezcfradv("ezcshowf")
         return
      endif

      call ezciquad(pquad(1), pquad(2), pquad(3), pquad(4), q1)

      if (.not.pending) go to 9000

      pending = FALSE
      yucked  = TRUE
      call ezciminsz(jminsz)

c      call pcgetr("HW", hw)
c      nlinfac = 1024/(hw*jminsz)
      nlinfac = 20

c ... set up the frame
c ... viewport
c ... come in a little bit for our stuff
      quad(1) = pquad(1) + 0.01_Size8
      quad(3) = pquad(3) + 0.01_Size8
      quad(2) = pquad(2) - 0.01_Size8
      quad(4) = pquad(4) - 0.01_Size8
      if (nc .eq. 0) go to 9000

      call ezcscale

      ezctctn  =  0 # initialize contour list

      ezclegfr = min(0.75_Size8, ezclegfr)
      ezclegfr = max(0.0_Size8, ezclegfr)
      ezccntfr = min(0.25_Size8, ezccntfr)
      ezccntfr = max(0.0_Size8, ezccntfr)
      textonly = YES
      do i = 1, nc
         if (namec(i) .ne. Text) then
            textonly = NO
         endif
      enddo

c ... fixed sizes
      titlert  = ezctitfr*(quad(2) - quad(1))
      titlelf  = ezctitfr*(quad(2) - quad(1))
      titletp  = ezctitfr*(quad(4) - quad(3))
      titlebt  = ezctitfr*(quad(4) - quad(3))
      suptitle = ezctitfr*0.6_Size8*(quad(4) - quad(3))
      conkey   = ezccntfr*(quad(2) - quad(1))
      xdivider = (1 - textonly)*ezclegfr*(quad(4) - quad(3))

c ... check for contour plot
      do i = 1, nc
         if (namec(i) .eq. MeshContour|namec(i) .eq. OtherContour) then
            conplot = .true.
            break
         endif
      enddo

c ... check for fillmesh plot
      do i = 1, nc
         if (namec(i) .eq. FillMesh) then
            fmplot = .true.
            break
         endif
      enddo

c ... check for polyfunc plot
      do i = 1, nc
         if (namec(i) .eq. PolyFunc) then
            pfplot = .true.
            break
         endif
      enddo

c ... check for ray power plot		# add for ray power plot YHC 4/5/95
      do i = 1, nc
         if (namec(i) .eq. Ray &
             (streq1f(colorc, (i - 1)*16, 16, "power", 0, 16) == 1 |
              streq1f(colorc, (i - 1)*16, 16, "relpow", 0, 16) == 1)) then
            raypw = .true.
            break
         endif
      enddo

      xspec(1) = xminu
      xspec(2) = xmaxu
      xspec(3) = 0._Size8
      yspec(1) = yminu
      yspec(2) = ymaxu
      yspec(3) = 0._Size8
      if (scalea .eq. "linlog") then
	 yspec(3) = 1.0_Size8
      elseif (scalea .eq. "loglin") then
         xspec(3) = 1.0_Size8
      elseif (scalea .eq. "loglog") then
         xspec(3) = 1.0_Size8
	 yspec(3) = 1.0_Size8
      endif

      call pedat(maxdata, maxnc, nc, ndata, data, dminc, dmaxc, dminac, dmaxac,
     &           dnoec, n1, n2, zi, xi, yi, zexti, iregi, kpregi,
     &           kllmti, bndflagi, lstylec, kstylec, lcolorc, kcolorc,
     &           vyi, vxi, pwi, lasi, nrayi, raylabi, dispmarki, nraypti,
     &           labeli, stylec, namec, fontc, markc, marksc, thickc, colorc,
     &           legendc, preleg, dshp, ixprev, ixpreva, xspec, yspec)

      do id = 1, iezcdev
         devid = ezcdevs(id)

c ... adorn the plot
         call peadn(devid, scalea, gridxa, gridya)

c ... main loop over entries in collection
         do iplot = 1, nc
             logmsg = " "
             call smovatof (logmsg, 3, legendc, (iplot - 1) * LSIZE,
             strgetcl (legendc, (iplot - 1) * LSIZE, LSIZE))
c            call ezcwrtlog(logmsg)
            plttyp = namec(iplot)
            call sblkset (preleg, (iplot - 1) * 16, 16)

c ... CURVES and MARKERS
            if (plttyp .le. Curve) then

               call pecrv(devid, iplot, labelsa)

c ... MESH
            elseif (plttyp .eq. Mesh) then
               Point(reg)     = data(iregi(iplot))
               Point(kpreg)   = data(kpregi(iplot))
               Point(kllmt)   = data(kllmti(iplot))
               Point(bndflag) = data(bndflagi(iplot))

               call pemsh(devid, iplot, Point(reg),
     &                    Point(kpreg), Point(kllmt), Point(bndflag),
     &                    labelsa)


c ... FILLMESH or POLYFUNC
            elseif ((plttyp .eq. FillMesh) .or.
     &              (plttyp .eq. PolyFunc) .or.
     &              (plttyp .eq. PolyFill)) then
               Point(reg)   = data(iregi(iplot))
               Point(kpreg) = data(kpregi(iplot))
               Point(kllmt) = data(kllmti(iplot))

               call pefpy(devid, iplot, plttyp, Point(reg),
     &                    Point(kpreg), Point(kllmt), Point(bndflag))

c c ... POLYFILL
c             elseif (plttyp .eq. PolyFill) then
c 
c c ... set up polygon fill style
c                call smovatof (mstylec, 0, stylec, 8*(iplot-1), 8)
c                if (mstylec == "solid") then
c                   call gsfais(1)
c                else
c                   call gsfais(0)
c                endif
c 
c c ... determine the proper color index
c                call smovatof (mcolorc, 0, colorc, 16*(iplot-1), 16)
c                pcolor = ezcctoi(mcolorc)
c                if (pcolor < 0)  pcolor = ezcctoi("fgcolor")
c                call gsfaci(pcolor)
c 
c c ... plot the polygons
c                do i = 1, npoly
c                   call gfa(npts, x((i-1)*npts+1), y((i-1)*npts+1) )
c                enddo

c ... CONTOURS
            elseif (plttyp .eq. OtherContour .or. plttyp .eq. MeshContour) then
               Point(reg)   = data(iregi(iplot))
               Point(kpreg) = data(kpregi(iplot))
               Point(kllmt) = data(kllmti(iplot))

               call pecnt(devid, iplot, Point(reg),
     &                    Point(kpreg), Point(kllmt), Point(bndflag))

c ... CELLARRAY
            elseif (plttyp .eq. CellArray) then
               Point(reg)   = data(iregi(iplot))
               Point(kpreg) = data(kpregi(iplot))
               Point(kllmt) = data(kllmti(iplot))

               call peimg(devid, iplot, Point(reg),
     &                    Point(kpreg), Point(kllmt), Point(bndflag))

c ... VECTORS
            elseif (plttyp .eq. Vector) then
               Point(reg)   = data(iregi(iplot))
               Point(kpreg) = data(kpregi(iplot))
               Point(kllmt) = data(kllmti(iplot))

               call pevct(devid, iplot, Point(reg),
     &                    Point(kpreg), Point(kllmt), Point(bndflag),
     &                    vscalea)

c ... RAYS
            elseif (plttyp .eq. Ray) then
               numcol  = ibasis("ezc.numcol")	# number of color indices
               indbase = ibasis("ezc.indbase")	# base color index

               Point(laslist)  = data(lasi(iplot))
               Point(nray)     = data(nrayi(iplot))
               Point(raylab)   = data(raylabi(iplot))
               Point(dispmark) = data(dispmarki(iplot))
               Point(nraypt)   = data(nraypti(iplot))
               Point(y)        = data(yi(iplot))
               Point(x)        = data(xi(iplot))
               Point(pw)       = data(pwi(iplot))
               laserct         = n1(lasi(iplot))
               rayct           = n1(raylabi(iplot))
               rayptct         = n1(pwi(iplot))	   # total ray points count

               call peray(devid, Point(x), Point(y), Point(reg),
     &                    Point(kpreg), Point(kllmt), Point(bndflag))

	      
c ... TEXT
            elseif (plttyp .eq. Text) then
               call petxt(devid, iplot)

c ... Fr TEXT
            elseif (plttyp .eq. Ftext) then
               call petxt(devid, iplot)

            endif

c ... reset the color fill flags for next list item
            cfill  = .false.
            rcfill = .false.
            filml  = .false.
         enddo iplot

c ... do the annotations and finish the frame
          call peann(devid, leginfoa, xdivider, nlinfac,
     &               titlelf, titlel, titlert, titler,
     &               titlebt, titleb, titletp, titlet,
     &               suptitle, ezctitle, ezcsuper)

      enddo

c ... set the transformation to the quadrant
c ... in case following text or Fortran to be added

9000  continue

c      call set(pquad(1), pquad(2), pquad(3), pquad(4), 
c               0._Size8, 1._Size8, 0._Size8, 1._Size8, 
c               1)

      yucked = FALSE

      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c EZCSHOWF - display the current picture 
c          - new quadrant: new frame if not in quadrant mode

      subroutine ezcshowf
      implicit none

      real(Size8) v1, v2, v3, v4
      integer q1

      call pltstart
      call ezciquad(v1, v2, v3, v4, q1)

      if (q1 .eq. YES) call ezcclrxn

      call ezcfradv("ezcshowf")
      call ezcdispl

      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c EZCSHOWG - handle sf command

      subroutine ezcshowg
      implicit none

Use(Default_attributes)

      pending = TRUE

      call ezcshowf

      return
      end     

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c EZCNOPL - return value of no-plot flag

      logical function ezcnopl()
      implicit none

Use(Ezcurve)

      return(ezcnoplot)
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c EZCCLEAR - clear the display list

      subroutine ezcclear
      implicit none

Use(Ezcurve)
Use(EzcurveDefaults)
Use(Collections)
Use(Extrema)
Use(Default_attributes)
Use(Probe)

      integer i

      titlet = " "
      titleb = " "
      titlel = " "
      titler = " "

      ixprev = 0

      do i = 1, 4 
         framee(i) = TRUE
      enddo

      do i = 1, ndata
         call memfree(data(i))
      enddo

      nc     = 0
      ndata  = 0
      levela = 0

c ... reset lastprobe. (Don't save ezczoom probe positions across nf's.)
      lastprobe = 0

      if (deflev == 0) deflev = 8
      nlevela = deflev

      if (ezcreset) call ezcada()

      yucked = FALSE
      pending = FALSE

      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c EZCSDATA - x array to save
c          - n,m dimensions of the data
c          - j return the index in data
c          - flag : does this data contribute to the extrema calculations?

      subroutine ezcsdata(x, n, m, j, flag)
      implicit none
      Address x
      integer n, m, j
      logical flag

Use(Ezcurve)
Use(Collections)    

      integer m1, m2, m2o, m2i, m3i
      integer err, addrwrds

      integer utsizeof, utsizstr
      external utsizeof, utsizstr
      integer scmark
      external scmark

      if (ndata+1 > maxdata) then

c ... logic change by ZCM 9/28/94--ezn acts as if some of these
c ... arrays are 0:maxdata, but only maxdata places were being
c ... allocated. This change allocates 1 more space for dminc, 
c ... dmaxc, dminac, dmaxac, and dnoec the first time around.
c ... it also uses maxdata+1 to compute the old size of the
c ... first four arrays.
c ... thanks, purify, for the umr
         if (maxdata .eq. 0) then
            m2i = 1
            m2o = 0
            m3i = 0
         else
            m2i = 0
            m2o = maxdata+1
            m3i = 1
         endif

         m1 = max(maxdata+40, ndata+1)
         m2 = utsizeof(m1+m2i, type4)

         addrwrds = utsizstr(1, "Address")

         call oschangn(Point(data), m1*addrwrds, maxdata*addrwrds,
     &                 "EZCSDATA:data ")
         call oschangn(Point(n1), m1, maxdata, "EZCSDATA:n1 ")
         call oschangn(Point(n2), m1, maxdata, "EZCSDATA:n2 ")
         call oschangn(Point(dnoec), m1+m2i, maxdata+m3i,
     &                 "EZCSDATA:dnoec ")

c ... dnoec must be initialized
c ... sometimes an uninitialized piece is being read
         call lvaluea(TRUE, Point(dnoec), maxdata + m3i,
     &                m1 + m2i - maxdata - m3i)

         call oschangn(Point(dminc), m2, m2o, "EZCSDATA:dminc ")
         call oschangn(Point(dmaxc), m2, m2o, "EZCSDATA:dmaxc ")
         call oschangn(Point(dminac), m2, m2o, "EZCSDATA:dminac ")
         call oschangn(Point(dmaxac), m2, m2o, "EZCSDATA:dmaxac ")

         maxdata = m1 + m2i - 1
      endif

      ndata = ndata + 1

      j = ndata

      data(ndata) = x
      n1(ndata)   = n
      n2(ndata)   = m

      dminc(ndata)  = ceiling
      dmaxc(ndata)  = -ceiling
      dminac(ndata) = ceiling
      dmaxac(ndata) = 0._Size8
      dnoec(ndata)  = .not.(flag)

c ... increase the reference count for this pointer
      err = scmark(data(ndata), 1)

      if (flag) call ezcsetfe(ndata)

      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c EZCXPND - expand the display list

      subroutine ezcxpnd
      implicit none

Use(Collections)
Use(Default_attributes)

      integer m1

      integer utsizeof
      external utsizeof

      if (nc+1 > maxnc) then
         m1 = max(maxnc+20,  nc+1)

         call memchange(Point(xi),        Quote(real8),   m1, maxnc)
         call memchange(Point(yi),        Quote(real8),   m1, maxnc)
         call memchange(Point(zi),        Quote(real8),   m1, maxnc)
         call memchange(Point(iregi),     Quote(integer), m1, maxnc)
         call memchange(Point(kpregi),    Quote(integer), m1, maxnc)
         call memchange(Point(kllmti),    Quote(integer), m1, maxnc)
         call memchange(Point(bndflagi),  Quote(integer), m1, maxnc)
         call memchange(Point(vxi),       Quote(real8),   m1, maxnc)
         call memchange(Point(vyi),       Quote(real8),   m1, maxnc)

         call memchange(Point(lasi),      Quote(integer), m1, maxnc)
         call memchange(Point(nrayi),     Quote(integer), m1, maxnc)
         call memchange(Point(raylabi),   Quote(integer), m1, maxnc)
         call memchange(Point(dispmarki), Quote(integer), m1, maxnc)
         call memchange(Point(nraypti),   Quote(integer), m1, maxnc)
         call memchange(Point(pwi),       Quote(integer), m1, maxnc)
         call memchange(Point(zexti),     Quote(integer), m1, maxnc)
         call memchange(Point(labeli),    Quote(integer), m1, maxnc)
         call memchange(Point(namec),     Quote(integer), m1, maxnc)

         call memchange(Point(marksc),    Quote(real8),   m1, maxnc)
         call memchange(Point(thickc),    Quote(real8),   m1, maxnc)

         call memchange(stylec,  Quote(character*(8)), m1, maxnc)
         call memchange(lstylec, Quote(character*(8)), m1, maxnc)
         call memchange(kstylec, Quote(character*(8)), m1, maxnc)
         call memchange(markc,   Quote(character*(8)), m1, maxnc)
         call memchange(fontc,   Quote(character*(8)), m1, maxnc)

         call memchange(preleg,  Quote(character*(16)), m1, maxnc)
         call memchange(colorc,  Quote(character*(16)), m1, maxnc)
         call memchange(kcolorc, Quote(character*(16)), m1, maxnc)
         call memchange(lcolorc, Quote(character*(16)), m1, maxnc)

         call memchange(legendc, Quote(character*(LSIZE)), m1, maxnc)

         maxnc = m1
      endif

      nc = nc + 1

      marksc(nc)   = marksa
      thickc(nc)   = thicka
      call smovftoa (markc, (nc - 1) * 8, marka, 0, 8)
      call smovftoa (fontc, (nc - 1) * 8, fonta, 0, 8)
      call smovftoa (colorc, (nc - 1) * 16, colora, 0, 16)
      call smovftoa (kcolorc, (nc - 1) * 16, kcolora, 0, 16)
      call smovftoa (lcolorc, (nc - 1) * 16, lcolora, 0, 16)
      call smovftoa (stylec, (nc - 1) * 8, stylea, 0, 8)
      call smovftoa (legendc, (nc - 1) * LSIZE, legenda, 0, LSIZE)
      xi(nc)       = 0
      yi(nc)       = 0
      zi(nc)       = 0
      pwi(nc)      = 0
      zexti(nc)    = 0
      iregi(nc)    = 0
      kpregi(nc)   = 0
      kllmti(nc)   = 0
      bndflagi(nc) = 0

      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c EZNFREE - free the non-specific dynamic memory

      subroutine eznfree
      implicit none

Use(Collections)
Use(Default_attributes)

# from EZCXPND 
      call osfreen(Point(xi),        "EZCFREE:xi ")
      call osfreen(Point(yi),        "EZCFREE:yi ")
      call osfreen(Point(iregi),     "EZCFREE:iregi ")
      call osfreen(Point(kpregi),    "EZCFREE:kpregi ")
      call osfreen(Point(kllmti),    "EZCFREE:kllmti ")
      call osfreen(Point(bndflagi),  "EZCFREE:bndflgi ")
      call osfreen(Point(vyi),       "EZCFREE:vyi ")
      call osfreen(Point(vxi),       "EZCFREE:vxi ")
      call osfreen(Point(lasi),      "EZCFREE:lasi ")
      call osfreen(Point(nrayi),     "EZCFREE:nrayi ")
      call osfreen(Point(raylabi),   "EZCFREE:raylabi ")
      call osfreen(Point(dispmarki), "EZCFREE:dispmarki ")
      call osfreen(Point(nraypti),   "EZCFREE:nraypti ")
      call osfreen(Point(zi),        "EZCFREE:zi ")
      call osfreen(Point(pwi),       "EZCFREE:pwi ")
      call osfreen(Point(zexti),     "EZCFREE:zexti ")
      call osfreen(Point(labeli),    "EZCFREE:labeli ")
      call osfreen(Point(namec),     "EZCFREE:namec ")

      call osfreen(Point(marksc), "EZCFREE:marksc ")
      call osfreen(Point(thickc), "EZCFREE:thickc ")

      call osfreen(stylec,  "EZCFREE:stylec ")
      call osfreen(lstylec, "EZCFREE:lstylec ")
      call osfreen(kstylec, "EZCFREE:kstylec ")
      call osfreen(markc,   "EZCFREE:markc ")
      call osfreen(fontc,   "EZCFREE:fontc ")

      call osfreen(preleg,  "EZCFREE:preleg ")
      call osfreen(colorc,  "EZCFREE:colorc ")
      call osfreen(kcolorc, "EZCFREE:kcolorc ")
      call osfreen(lcolorc, "EZCFREE:lcolorc ")
      call osfreen(legendc, "EZCFREE:legendc ")

# from EZCSDATA
      call osfreen(Point(data),  "EZCFREE:data ")
      call osfreen(Point(n1),    "EZCFREE:n1 ")
      call osfreen(Point(n2),    "EZCFREE:n2 ")
      call osfreen(Point(dnoec), "EZCFREE:dnoec ")

      call osfreen(Point(dminc),  "EZCFREE:dminc ")
      call osfreen(Point(dmaxc),  "EZCFREE:dmaxc ")
      call osfreen(Point(dminac), "EZCFREE:dminac ")
      call osfreen(Point(dmaxac), "EZCFREE:dmaxac ")

      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c EZCSETFE - calculate the extrema of the ith set of data

      subroutine ezcsetfe(idata)
      implicit none

Use(Collections)
Use(Ezcurve)

      integer idata, nx, j
      real(Size8) xsmin, xsmax, xsamin, xsamax
      Dynamic(x, real(Size8), 1)

      Point(x) = data(idata)
      nx = n1(idata)*n2(idata)

      do j = 1, nx
         dminc(idata)  = min(dminc(idata), x(j))
         dmaxc(idata)  = max(dmaxc(idata), x(j))
         dminac(idata) = min(dminac(idata), abs(x(j)))
         dmaxac(idata) = max(dmaxac(idata), abs(x(j)))
      enddo
      return

      entry ezcchgfe(idata, xsmin, xsmax, xsamin, xsamax)

      dminc(idata)  = xsmin
      dmaxc(idata)  = xsmax
      dminac(idata) = xsamin
      dmaxac(idata) = xsamax
      dnoec(idata)  = FALSE

      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c EZCSEL - 

      logical function ezcsel(k, l, kmax, lmax, ireg)
      implicit none
      integer k, l, kmax, lmax, ireg(kmax, lmax)

Use(Default_attributes)

      if (l .lt. lmax) then
         if (k .lt. kmax) then
            if (excludea(ireg(k, l)) .and. excludea(ireg(k+1, l)) .and.
     &          excludea(ireg(k, l+1)) .and. excludea(ireg(k+1, l+1))) then
               return(FALSE)
            endif
         else
            if (excludea(ireg(k, l)) .and. excludea(ireg(k, l+1))) then
               return(FALSE)
            endif
         endif
      else
         if (k .lt. kmax) then
            if (excludea(ireg(k, l)) .and. excludea(ireg(k+1, l))) then
               return(FALSE)
            endif
         else
            if (excludea(ireg(k, l))) then
               return(FALSE)
            endif
         endif
      endif

      return(TRUE)
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c EZCSMDA - save the default style attributes for mesh plots.

      subroutine ezcsmda
      implicit none

Use(Saved_attributes)
Use(Default_attributes)

      integer i

      do i = 1, 3
         kranges(i) = krangea(i)
         lranges(i) = lrangea(i)
      enddo

      do i = 1, MAXREG
         excludes(i) = excludea(i)
      enddo

      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c EZCSDA - save the default style attributes

      subroutine ezcsda
      implicit none

Use(Saved_attributes)
Use(Default_attributes)

      call ezcsmda

      fonts   = fonta
      styles  = stylea
      thicks  = thicka
      arrows  = arrowa
      marks   = marka
      markss  = marksa

      kstyles = kstylea
      lstyles = lstylea

      bnds    = bnda
      vscales = vscalea
      colors  = colora 
      kcolors = kcolora
      lcolors = lcolora
      cscales = cscalea
      centers = centera     
      nlevels = nlevela
      levels  = levela
      rsqs    = rsqa

c ... deal with things that can be optionally given
      labels  = labela
      nzlims  = nzlima

      zlimins(1) = zlimin(1)
      zlimins(2) = zlimin(2)

      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c EZCSETXN - routine to call to notify devices that you have
c          - pending frame advance

      subroutine ezcsetxn
      implicit none

Use(Ezcxnc)

      notified = YES
      return

      entry ezcclrxn
      notified = NO

      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c EZCCTOI - determine the corresponding color index for a given colorname

      integer function ezcctoi(colorname)
      implicit none
      character *(*) colorname

Use(Colors)

      integer i

      do i = 1, NCOLORS
         if (colorname .eq. color(i)) then
            return(clrid(i)) 
         endif
      enddo
        
      return(1)
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c EZCXN - return notified flag

      integer function ezcxn()
      implicit none

      integer notified
      save /ezcxnc/
      common /ezcxnc/ notified

      return(notified)
      end
      
c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c EZCKL - 

      subroutine ezckl(kmax, lmax, ireg, plkmin, plkmax, plkinc, 
                       pllmin, pllmax, pllinc, nks, nls)
      implicit none
      integer kmax, lmax, ireg(kmax, lmax)
      integer plkmin, plkmax, plkinc, pllmin, pllmax, pllinc
      integer nks, nls, k, l

Use(Default_attributes)

      logical ezcsel
      external ezcsel

      plkmin = 1
      pllmin = 1
      plkmax = kmax
      pllmax = lmax

      if (krangea(1) .ne. DEFAULT) then
         plkmin = max(1, krangea(1))
      endif

      if (lrangea(1) .ne. DEFAULT) then
         pllmin = max(1, lrangea(1))
      endif

      if (krangea(2) .ne. DEFAULT) then
         plkmax = min(kmax, krangea(2))
      endif

      if (lrangea(2) .ne. DEFAULT) then
         pllmax = min(lmax, lrangea(2))
      endif

      plkinc = krangea(3)
      pllinc = lrangea(3)

      plkinc = max(1, plkinc)
      pllinc = max(1, pllinc)

c ... tighten up around the edges
      do l = pllmin, pllmax
         do k = plkmin, plkmax
            if (ezcsel(k, l, kmax, lmax, ireg)) break(2)
         enddo
      enddo

      pllmin = l
      do l = pllmax, pllmin, -1
         do k = plkmin, plkmax
            if (ezcsel(k, l, kmax, lmax, ireg)) break(2)
         enddo
      enddo

      pllmax = l
      do k = plkmin, plkmax
         do l = pllmin, pllmax
            if (ezcsel(k, l, kmax, lmax, ireg)) break(2)
         enddo
      enddo

      plkmin = k
      do k = plkmax, plkmin, -1
         do l = pllmin, pllmax
            if (ezcsel(k, l, kmax, lmax, ireg)) break(2)
         enddo
      enddo

      plkmax = k
       
      nks = 1 + ((plkmax - plkmin)/plkinc)
      nls = 1 + ((pllmax - pllmin)/pllinc)

      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

