c
c EPFRAM.M - frame handlers
c


define([QUADMODE_COMMON], [
      real(Size8) l, r, b, t
      integer quad1
      save /ezcvc/ 
      common /ezcvc/ l, r, b, t, quad1
])

define([QUAD_COMMON], [
      real(Size8) l, r, b, t
      save /ezcqc/ 
      common /ezcqc/ l, r, b, t
])

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

      block data bdezcvc
QUADMODE_COMMON
      data l/.0_Size8/, r/1._Size8/, b/.0_Size8/, t/1._Size8/
      data quad1/NO/
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c EZCIQUAD - inquire quadrant requested

      subroutine ezciquad(v1, v2, v3, v4, q1)

QUADMODE_COMMON

      external bdezcvc
      real(Size8) v1, v2, v3, v4
      integer q1

      v1 = l
      v2 = r
      v3 = b
      v4 = t
      q1 = quad1

      return

      entry ezcsq1(q1)

      quad1 = q1

      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c EZCIDQUAD - return the default reference box for quadrants

      subroutine ezcidquad(v1, v2, v3, v4)

QUAD_COMMON

      real(Size8) v1, v2, v3, v4

      v1 = l
      v2 = r
      v3 = b
      v4 = t

      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c EZCRQUAD - restore quadrand to default quadrant
c          - set up linear ndc transformation into the viewport.
c          - called by ezcfradv

      subroutine ezcrquad

QUADMODE_COMMON

      real(Size8) w1, w2, w3, w4

      call pltstart
      call ezcidquad(w1, w2, w3, w4)

      l = w1
      r = w2
      b = w3
      t = w4
      quad1 = NO

c      call set(l, r, b, t, 0._Size8, 1._Size8, 0._Size8, 1._Size8, 1)

      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c EZCNQ - display the current picture and clear collection
c       - willing to stay in current quadrant     

      subroutine ezcnq

      call ezcshowf
      call ezcclear

      call ptextstl(0)

      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c EZCNF - display the current picture and clear collection
c       - new frame for sure
c       - have to set up so that the next nf or nq does
c       - a frame advance 

      subroutine ezcnf

Use(Device_Internal)

      integer id, devid, iq
      real(Size8) v1, v2, v3, v4

      call ezcnq

c ... if were were drawing quadrants, assume there must be something
c ... on the screen and put us back out of quadrant mode so that
c ... the next nf will see quad1==NO.
      call ezciquad(v1, v2, v3, v4, iq)

      if (iq .eq. YES) then
         call ezcsetxn
      endif

      call ezcrquad
      call ptextstl(0)

      do id = 1, iezcdev
         devid = ezcdevs(id)
         call peclr(devid)
      enddo

      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c FRAME - display the current picture and clear collection
c       - new frame for sure
c       - have to set up so that the next nf or nq does
c       - a frame advance 

      subroutine frame

Use(Device_Internal)

      integer devid

      devid = iwscn(1, iwinop)

      call peclr(devid)

      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c EZCFRADV -  frame advance

      subroutine ezcfradv(note)
      character*(*) note

Use(Devices)

      integer ezcxn
      external ezcxn

c ... Don't do frame advance before first "cgm send"
c ... or  any  "ps send". (FNF-12/02/98)
      if ((.not.ezcsend) .or. 
     &    ((iezccgma .gt. 0) .and. (iezccgmn .gt. 0)))  then
         if (ezcxn() .eq. NO) then
            call ezchook("ready", note)
            return
         endif
         call ezcclrxn
         call frame
      endif

      if (iezccgma .gt. 0) then
         iezccgmn = iezccgmn + 1
         if (iezccgmn .ge. ezccgmc) then
            call ezccgm("close", " ")
            call ezccgm("on", " ")      # cgmclrmap was set in previous cgmfile
         endif
      endif

      if (iezcpsa .gt. 0) then
         iezcpsn = iezcpsn + 1
         if (iezcpsn .ge. ezcpsc) then
            call ezcps("close", " ")
            call ezcps("on", " ")       # psclrmap was set in previous psfile
         endif
      endif

      call ezchook("frame", note)       # move after frame YHC 01/31/95
      call ezchook("ready", "ezcfradv")

      return      
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c EZCSCALE - process the frame info as specified by the user into the
c          - form in which it will be used by the renderers

      subroutine ezcscale

Use(Ezcurve)
Use(Collections)
Use(Default_attributes)
Use(Extrema)
Use(EzcurveDefaults)

      integer i
      logical j
      real(Size8) yminus, r1mach

      xminu = real(ceiling, Size8)
      xmaxu = real(-ceiling, Size8)
      yminu = real(ceiling, Size8)
      ymaxu = real(-ceiling, Size8)

      xlog = FALSE
      ylog = FALSE
      if (scalea(1:3) .eq. "log") xlog = TRUE
      if (scalea(4:6) .eq. "log") ylog = TRUE

      xfloor = ezcfloor
      yfloor = ezcfloor
      if (xfloor .eq. 0.0_Size8) xfloor = d1mach(4)
      if (yfloor .eq. 0.0_Size8) yfloor = d1mach(4)

      j = TRUE

c ...loop over all curves
      do i = 1, nc     

c ... dnoec(0) is always TRUE so ok if no data
         if (.not. dnoec(xi(i))) then

            j = FALSE
            if (framee(1)) then
               if (xlog) then
                  xminu = min(xminu, dminac(xi(i)))
               else
                  xminu = min(xminu, dminc(xi(i)))
               endif
            else
               xminu = xmin
            endif
            
            if (framee(2)) then
               if (xlog) then
                  xmaxu = max(xmaxu, dmaxac(xi(i)))
               else
                  xmaxu = max(xmaxu, dmaxc(xi(i)))
               endif
            else
               xmaxu = xmax
            endif
         endif

         if (.not. dnoec(yi(i))) then
            j = FALSE
            
            if (framee(3)) then
               if (ylog) then
                  yminu = min(yminu, dminac(yi(i)))
               else
                  yminu = min(yminu, dminc(yi(i)))
               endif
            else
               yminu = ymin
            endif
            
            if (framee(4)) then
               if (ylog) then
                  ymaxu = max(ymaxu, dmaxac(yi(i)))
               else
                  ymaxu = max(ymaxu, dmaxc(yi(i)))
               endif
            else
               ymaxu = ymax
            endif
         endif
      enddo

c ... no data
      if (j) then
         xminu = xmin
         xmaxu = xmax
         yminu = ymin
         ymaxu = ymax
      endif

      if (xlog) then
	if (xfloor*xmaxu > realsmall) then
	   xfloor = xfloor * xmaxu
        else
	   xfloor = realsmall
	endif
        xminu = max(xfloor, xminu)
      endif
      xmaxu = max(xminu, xmaxu)

      if (ylog) then
	if (yfloor*ymaxu > realsmall) then
	   yfloor = yfloor * ymaxu
	else
	   yfloor = realsmall
	endif 
        yminu = max(yfloor, yminu)
      endif
      ymaxu = max(yminu, ymaxu)

c ... widen frame if not log and if data is determining limits
      if ((.not. ylog) & framee(3) & framee(4)) then
         yminus = yminu
         
         if (((ymaxu-yminu) >= realsmall) & ((ymaxu-yminu) <= ceiling)) then
             yminu = yminu - ezcextra*(ymaxu-yminu)
             ymaxu = ymaxu + ezcextra*(ymaxu-yminus)
         endif
      endif

      if (xminu .eq. xmaxu) then
         if (.not. xlog) then
            if (xminu .eq. 0.0_Size8) then
               xminu = -0.5_Size8
               xmaxu =  0.5_Size8
            else
               if ((xminu >= realsmall) & (xmaxu <= ceiling)) then
                  xminu = xminu - abs(xminu * 0.025_Size8)
                  xmaxu = xmaxu + abs(xmaxu * 0.025_Size8)
               endif
            endif
         endif
      endif

      if (yminu .eq. ymaxu ) then
         if (.not. ylog) then
            if (yminu .eq. 0.0_Size8) then
               yminu = -0.5_Size8
               ymaxu =  0.5_Size8
            else
               if ((yminu >= realsmall) & 
		   (ymaxu <= ceiling)) then
                  yminu = yminu - abs(yminu * 0.025_Size8)
                  ymaxu = ymaxu + abs(ymaxu * 0.025_Size8)
               endif
            endif
         endif
      endif

      return
      end 

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

