c
c EPINTF.M - Basis interface routines
c

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c EZCVERS - version for the package

        subroutine ezcvers(iunit)
        integer iunit

        call baswline(iunit, "EZN Graphics Interface Version 5.9")

        return
        end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c EZCBFCN - Basis interpreter interface

        function ezcbfcn(nargs, f, sx)
        integer ezcbfcn
        integer nargs, sx(SS_WIDTH)
        character*(*) f

Use(Keywords)
Use(Extrema)
Use(Default_attributes)
Use(Collections)

        integer icurves(3), i, nargs1, j, n, ierr
        real(Size8) x
        integer ezcfkey, ezcplot, ezcplotv, ezcplotm, ezcplotr, ezcplotc, 
                ezcplotz, ezcplotf, ezcploti, ezcplotp, ezcplotpf,
                ezctext, ezcftext
        external ezcfkey, ezcplot, ezcplotv, ezcplotm, ezcplotr, ezcplotc, 
                 ezcplotz, ezcplotf, ezcploti, ezcplotp, ezcplotpf,
                 ezctext, ezcftext
        Address  paraddr
        external paraddr
        integer  partypea, parlen, si(SS_WIDTH)
        external partypea, parlen
        Dynamic(ilist, integer, 1)

c ... implement no-plot mode (FNF 11/ll/96)
        logical ezcnopl
        external ezcnopl
        if (ezcnopl()) then
           do i = 1, nargs
              call parkilla(i)
           enddo
           return
        endif

c ... ezcurve commands 
        call pltstart

        sx(SS_N)  = 0
        sx(SS_TC) = 0
        pending   = TRUE

        do i = 0, nargs
           call fcnargs(i, symbols(i), lsymbols(i))
        enddo

c ... curve plot
        if (f .eq. "ezcplot") then
            ierr = ezcfkey(plotkey, NPLOTKEY, nargs, nargs1)
            if (ierr .eq. ERR) go to 500
            call ezclegnd("plot", nargs, nargs1)
            return(ezcplot(nargs, nargs1))

c ... vector plot
        elseif (f .eq. "ezcplotv") then
            ierr = ezcfkey(veckey, NVECKEY, nargs, nargs1)
            if (ierr .eq. ERR) go to 500
            call ezclegnd("plotv", nargs, nargs1)
            return(ezcplotv(nargs, nargs1))

c ... attr
        elseif (f .eq. "ezcattr") then
            ierr = ezcfkey(attrkey, NATTRKEY, nargs, nargs1)
            call ezclegnd("attr", nargs, nargs1)
            if (ierr .eq. ERR) go to 500
            if (nargs1 .ne. 0) then
               call ezcremrk("attr: improper keyword")
               call ezcremrk(legenda)
               return(ERR)
            endif
            call ezcseta(nargs, nargs1, GLOBAL)

c ... frame
        elseif (f .eq. "ezcframe") then
           ierr = ezcfkey(attrkey, NATTRKEY, nargs, nargs1)
           if (ierr .eq. ERR) go to 500
           if (nargs1 .gt. 6) then
              call ezcremrk("frame: too many numerical arguments.")
              call ezcremrk(legenda)
              return(ERR)
           endif
           call ezclegnd("frame", nargs, nargs1)
           call ezcseta(nargs, nargs1, GLOBAL)
           do i = 1, 4
              framee(i) = TRUE
           enddo
           if (nargs1 .ge. 1) then
              call ezcargr(1, x)
              if (x .ne. float(DEFAULT)) then
                 framee(1) = FALSE
                 xmin = x
              endif
           endif
           if (nargs1 .ge. 2) then
              call ezcargr(2, x)
              if (x .ne. float(DEFAULT)) then
                 framee(2) = FALSE
                 xmax = x
              endif
           endif
           if (nargs1 .ge. 3) then
              call ezcargr(3, x)
              if (x .ne. float(DEFAULT)) then
                 framee(3) = FALSE
                 ymin = x
              endif
           endif
           if (nargs1 .ge. 4) then
              call ezcargr(4, x)
              if (x .ne. float(DEFAULT)) then
                 framee(4) = FALSE
                 ymax = x
              endif
           endif
           do i = 1, nargs1
              call parkilla(i)
           enddo
           call ezcshowg
           
c ... undo
        elseif (f .eq. "ezcsub") then
           if (nargs .eq. 0) then
              call ezcsub(nc)
           else
              do j = 1, nargs
                 if (partypea(j) .eq. typex) then
                    call ezcargx(j, icurves)
                    do i = icurves(1), icurves(2), icurves(3)
                       call ezcsub(i)
                    enddo
                 elseif (partypea(j) .eq. typeint) then
                    call fcnarga(j, si)
                    Point(ilist) = paraddr(si)
                    n  =  parlen(si)
                    do i = 1, n
                       call ezcsub(ilist(i))
                    enddo
                 else
                    call ezcremrk("undo: bad argument, ignored.")
                 endif
              enddo
           endif
           call ezcsubx
           do i = 1, nargs
              call parkilla(i)
           enddo
           call ezcshowg
           
c ... mesh plot
        elseif (f .eq. "ezcplotm") then
           ierr = ezcfkey(meshkey, NMESHKEY, nargs, nargs1)
           if (ierr .eq. ERR) go to 500
           call ezclegnd("plotm", nargs, nargs1)
           return(ezcplotm(nargs, nargs1))
           
c ... contour plot
        elseif (f .eq. "ezcplotc") then
           ierr = ezcfkey(conkey, NCONKEY, nargs, nargs1)
           if (ierr .eq. ERR) go to 500
           call ezclegnd("plotc", nargs, nargs1)
           return(ezcplotc(nargs, nargs1))

c ... fillpoly plot
        elseif (f .eq. "ezcplotf") then
           ierr = ezcfkey(filkey, NFILKEY, nargs, nargs1)
           if (ierr .eq. ERR) go to 500
           call ezclegnd("plotf", nargs, nargs1)
           return(ezcplotf(nargs, nargs1))

c ... draw a polygon
        elseif (f .eq. "ezcplotp") then
            ierr = ezcfkey(polykey, NPOLYKEY, nargs, nargs1)
            if (ierr .eq.  ERR) go to 500
            call ezclegnd("plotp", nargs, nargs1)
            return(ezcplotp(nargs, nargs1))

c ... ac fillpoly plot
        elseif (f .eq. "ezcplotpf") then
            ierr = ezcfkey(polfkey, NPOLFKEY, nargs, nargs1)
            if (ierr .eq.  ERR) go to 500
            call ezclegnd("plotpf", nargs, nargs1)
            return(ezcplotpf(nargs, nargs1))

c ... image plot
        elseif (f .eq. "ezcploti") then
           ierr = ezcfkey(cellkey, NLKEY, nargs, nargs1)
           if (ierr .eq. ERR) go to 500
           call ezclegnd("ploti", nargs, nargs1)
           return(ezcploti(nargs, nargs1))

c ... contour plot
        elseif (f .eq. "ezcplotz") then
           ierr = ezcfkey(zconkey, NZCONKEY, nargs, nargs1)
           if (ierr .eq. ERR) go to 500
           call ezclegnd("plotz", nargs, nargs1)
           return(ezcplotz(nargs, nargs1))

c ... ray plot
        elseif (f .eq. "ezcplotr") then
           ierr = ezcfkey(raykey, NRAYKEY, nargs, nargs1)
           if (ierr .eq. ERR) go to 500
           call ezclegnd("plotr", nargs, nargs1)
           return(ezcplotr(nargs, nargs1))

c ... text
        elseif (f .eq. "ezctext") then
           ierr = ezcfkey(textkey, NTEXTKEY, nargs, nargs1)
           if (ierr .eq. ERR) go to 500
           call ezclegnd("text", nargs, nargs1)
           return(ezctext(nargs, nargs1))

c ... ftext
        elseif (f .eq. "ezcftext") then
           ierr = ezcfkey(ftextkey, NFTXTKEY, nargs, nargs1) 
           if (ierr .eq. ERR) go to 500
           call ezclegnd("ftext", nargs, nargs1)
           return(ezcftext(nargs, nargs1))

        else
           call sorry(f)
        endif

        return(OK)

 500    continue
        call ezcremrk("ezc command ignored.")
        call ezcremrk(symbols(0))

        return(OK)
        end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c EZCINIT - initialize EZN

	subroutine ezcinit

Use(Keywords)
Use(Ezcurve)
Use(Collections)
Use(Contours)
Use(Colors)

        integer utstrcod, i
	real(Size8) t1, t2, t4
        real(Size8) d1mach

        external utstrcod, d1mach

        attrkey(1) = "grid"
        attrkey(2) = "scale"
        attrkey(3) = "style"
        attrkey(4) = "thick"
        attrkey(5) = "mark"
        attrkey(6) = "marksize"
        attrkey(7) = "font"
        attrkey(8) = "arrow"
        attrkey(9) = "labels"
        attrkey(10) = "legend"
        attrkey(11) = "vsc"
        attrkey(12) = "lev"
        attrkey(13) = "bnd"
        attrkey(14) = "region"
        attrkey(15) = "krange"
        attrkey(16) = "lrange"
        attrkey(17) = "kstyle"
        attrkey(18) = "lstyle"
        attrkey(19) = "color"
        attrkey(20) = "rsquared"
        attrkey(21) = "cscale"
        attrkey(22) = "kcolor"
        attrkey(23) = "lcolor"

c ... data related to colors
c ... BLACK        = 0,1
c ... WHITE        = 1,0
c ... GRAY         = 2
c ... DARK_GRAY    = 3
c ... BLUE         = 4
c ... GREEN        = 5
c ... CYAN         = 6
c ... RED          = 7
c ... MAGENTA      = 8
c ... BROWN        = 9
c ... DARK_BLUE    = 10
c ... DARK_GREEN   = 11
c ... DARK_CYAN    = 12
c ... DARK_RED     = 13
c ... YELLOW       = 14
c ... DARK_MAGENTA = 15

       color(1)  = "relpow"
       clrid(1)  = 1
       color(2)  = "power"
       clrid(2)  = 1
       color(3)  = "rfillnl"
       clrid(3)  = 1
       color(4)  = "fillnl"
       clrid(4)  = 1
       color(5)  = "rfill"
       clrid(5)  = 1
       color(6)  = "filled"
       clrid(6)  = 1
       color(7)  = "rainbow"
       clrid(7)  = 1
       color(8)  = "bgcolor"
       clrid(8)  = 0
       color(9)  = "fgcolor"
       clrid(9)  = 1
       color(10) = "red"
       clrid(10) = 13
       color(11) = "green"
       clrid(11) = 11
       color(12) = "blue"
       clrid(12) = 10
       color(13) = "cyan"
       clrid(13) = 12
       color(14) = "magenta"
       clrid(14) = 15
       color(15) = "yellow"
       clrid(15) = 14
       color(16) = "coral"
       clrid(16) = 7
       color(17) = "yellowgreen"
       clrid(17) = 5
       color(18) = "springgreen"
       clrid(18) = 5
       color(19) = "slateblue"
       clrid(19) = 10
       color(20) = "skyblue"
       clrid(20) = 4
       color(21) = "orangered"
       clrid(21) = 9
       color(22) = "gray33"
       clrid(22) = 2
       color(23) = "lavender"
       clrid(23) = 8
       color(24) = "orchid"
       clrid(24) = 6
       color(25) = "gray70"
       clrid(25) = 3

c ... define plot commands
        call mcchrdef("plot",   "ezcplot command_(eWCQ)",        FALSE)
        call mcchrdef("plotm",  "ezcplotm command_(eWCQ)",       FALSE)
        call mcchrdef("plotb",  "ezcplotm command_(eWCQ) bnd=1", FALSE)
        call mcchrdef("plotv",  "ezcplotv command_(eWCQ)",       FALSE)
        call mcchrdef("plotr",  "ezcplotr command_(eWCQ)",       FALSE)
        call mcchrdef("plotc",  "ezcplotc command_(eWCQ)",       FALSE)
        call mcchrdef("plotf",  "ezcplotf command_(eWCQ)",       FALSE)
        call mcchrdef("plotz",  "ezcplotz command_(eWCQ)",       FALSE)
        call mcchrdef("ploti",  "ezcploti command_(eWCQ)",       FALSE)
        call mcchrdef("plotp",  "ezcplotp command_(eWCQ)",       FALSE)
        call mcchrdef("plotpf", "ezcplotpf command_(eWCQ)",      FALSE)
        call mcchrdef("attr",   "ezcattr command_(eWCQ)",        FALSE)
        call mcchrdef("frame",  "ezcframe command_(eWCQ)",       FALSE)
        call mcchrdef("nf",     "call ezcnf",                    FALSE)
        call mcchrdef("sf",     "call ezcshowg",                 FALSE)
        call mcchrdef("fr",     "nf;frame",                      FALSE)
        call mcchrdef("titles", "ezctitls command_(eWCQ)",       FALSE)
        call mcchrdef("text",   "ezctext command_(eWCQ)",        FALSE)
        call mcchrdef("ftext",  "ezcftext command_(eWCQ)",       FALSE)
        call mcchrdef("undo",   "ezcsub command",                FALSE)

c ... devices
        call mcchrdef("mpeg", "ezcdodev command_SSc(SwcS) mpeg $1", TRUE)
        call mcchrdef("jpeg", "ezcdodev command_SSc(SwcS) jpeg $1", TRUE)
        call mcchrdef("cgm",  "ezcdodev command_SSc(SwcS) cgm $1",  TRUE)
        call mcchrdef("ps",   "ezcdodev command_S(ScQS) ps $1",     TRUE)
        call mcchrdef("win",  "ezcdodev command_SSc(SwcS) win $1",  TRUE)

        t1 = d1mach(1)
        t2 = d1mach(2)
        t4 = d1mach(4)

        ceiling   = real(t2/1000._Size8, Size8)
        realsmall = real(t1/t4, Size8)
        typeint   = utstrcod("integer")
        type4     = utstrcod(Quote(real(Size8)))
        type8     = utstrcod(Quote(real(Size8)))
        typelog   = utstrcod("logical")
        typex     = utstrcod("range")
        typef     = utstrcod("function")

        do i = 1, 26
           ezctcl(i) = char(64+i)
        enddo

        do i = 27, 52
           ezctcl(i) = char(70+i)
        enddo

        call pestp

        return
        end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c EZCSS - 

      subroutine ezcss(lll, time, flag)
      character*(*) lll
      real(Size8) time
      logical flag

Use(Collections)
Use(Ezcurve)

      character*(10) banner
      character*(120) logmsg	# log message
      integer utgetcl, l1
      external utgetcl

      call pltstart
      call ezcnf

c ... do the log       
c ... write frame count and filename to the log
c       call ezcfrlog

       if (ezctitle .ne. " ") then
          logmsg = "   "//ezctitle(1:utgetcl(ezctitle))

c ... write frame title to the log
c          call ezcwrtlog(logmsg)
       endif
       write(logmsg, '(3x, "ss ", 1Pe14.4)') time

c ... write time to the log
c       call ezcwrtlog(logmsg)

c ... talk to the terminal about it
      l1 = utgetcl(lll)
      if (flag) then
         write(logmsg, 300) lll(1:l1), time
         call ezcremrk(logmsg)
      endif

c ... make a header frame
      write(banner, 200) time
      ezcreset = TRUE
      ezcshow  = FALSE
      call ezcwtext(0.5_Size8, 0.25_Size8, 
     &              banner, 0.5_Size8, 1.0_Size8, 
     &              0._Size8, 0._Size8)
      call ezcwtext(0.5_Size8, 0.75_Size8, 
     &              lll(1:l1), 0.25_Size8, 1.0_Size8, 
     &              0._Size8, 0._Size8)

200   format(1Pe10.3)
300   format("Doing ", a, " at time ", 1Pe10.3)

      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c PLTEND - gracefully end

      subroutine pltend

      call ezcp(0)
      call peend
      call eznfree

      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c PLTDIE - emergency shutdown

      subroutine pltdie

      call ezcp(-1)
      call peend

      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c PLTSTART - begin gks and make sure at least one device is on

      subroutine pltstart

      call ezcp(1)
c      call ezcdvck

      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c EZCFIN - fin the graphics

      integer function ezcfin(i1, i2)
      integer i1, i2

      call pltend

       return(OK)
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c BACKCOLR - use black background for windows if 0 and
c          - white background otherwise

      subroutine backcolr(bkcolr)
      integer bkcolr

Use(Colors)
Use(Devices)

      bakcol = bkcolr
      if (bakcol .ne. 0) bakcol = 1

      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c EZCSETBW - set background color to white

      subroutine ezcsetbw

Use(Colors)
Use(Devices)

      bakcol = 1

      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c EZCSETBB - set background color to black

      subroutine ezcsetbb

Use(Colors)
Use(Devices)

      bakcol = 0

      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c LOADCT - load numbered color table

      integer function loadct(ctab)
      integer ctab

      return(0)
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c EZDMINSZ - 

      subroutine ezcminsz(isize)
      integer isize

Use(Devices)

      ezcminch = max(6, min(isize, VARNAMESIZE))
c      call agminsz(ezcminch)
      return

      entry ezciminsz(isize)
      isize = ezcminch

      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c EZCARGR - 

      subroutine ezcargr(iarg, value)
      integer iarg
      real(Size8) value

Use(Default_attributes)
Use(Collections)

      Address  paraddr
      external paraddr
      integer  parcoerc
      external parcoerc
      integer sy(SS_WIDTH)
      Dynamic(x, real(Size8))
      
      call fcnarga(iarg, sy)

      if (sy(SS_TC) .eq. 0) then
         value = float(DEFAULT)
         return
      endif

      if (parcoerc(sy, type4) .eq. ERR) then
         call ezcremrk("Ignoring bad value for keyword:")
         call ezcremrk(key)
         return
      endif

      Point(x) = paraddr(sy)
      value = x
      call parkill(sy) # ZCM 11/14/95

      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c EZCARGX - 

      subroutine ezcargx(iarg, value)
      integer iarg, value(3)

Use(Default_attributes)
Use(Collections)

      Address  paraddr
      external paraddr
      integer sy(SS_WIDTH), j
      Dynamic(x, integer, 3)
      
      call fcnarga(iarg, sy)

      if (sy(SS_TC) .eq. 0) then
         value(1)= DEFAULT
         value(2)= DEFAULT
         value(3)= 1
         return
      endif

      Point(x) = paraddr(sy)
      if (sy(SS_TC) .eq. typex) then
         do j = 1, 3
            value(j) = x(j)
         enddo
         if (value(3) .eq. 0) then
            value(2) = value(1)
            value(3) = 1
         endif
      elseif (sy(SS_TC) = typeint) then
         value(1) = x(1)
         value(2) = x(1)
         value(3) = 1
      else
         call ezcremrk("Ignoring bad value for keyword:")
         call ezcremrk(key)
         call parkill(sy) # ZCM 11/14/95
         return
      endif

      call parkill(sy) # ZCM 11/14/95

      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c EZCARGS - 

      subroutine ezcargs(iarg, value)
      integer iarg
      character*(*) value
      integer lvalue

Use(Default_attributes)
Use(Collections)

      Address  paraddr
      external paraddr
      integer  parcoerc
      external parcoerc
      integer sy(SS_WIDTH)
      Address x
      
      call fcnarga(iarg, sy)

      if (sy(SS_TC) <0) then  
         x = paraddr(sy)
         lvalue = len (value)
         call smovatof (value, 0, x, 0, min (lvalue, -sy(SS_TC)))
         if (lvalue > -sy(SS_TC)) value (-sy(SS_TC):) = " "
         call parkill(sy) # ZCM 11/14/95
         return
      else
         call ezcremrk("Ignoring bad value for keyword:")
         call ezcremrk(key)
         call parkill(sy) # ZCM 11/14/95
         return
      endif

      return
      end      

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c EZCARGI - 

      subroutine ezcargi(iarg, value)
      integer iarg
      integer value

Use(Default_attributes)
Use(Collections)

      Address  paraddr
      external paraddr
      integer  parcoerc
      external parcoerc
      integer sy(SS_WIDTH)
      Dynamic(x, integer)
      
      call fcnarga(iarg, sy)

      if (sy(SS_TC) .eq. 0) then
         value = DEFAULT
         return
      endif

      if (parcoerc(sy, typeint) .eq. ERR) then
         call ezcremrk("Ignoring bad value for keyword:")
         call ezcremrk(key)
         return
      endif

      Point(x) = paraddr(sy)
      value = x

      call parkill(sy) # ZCM 11/14/95

      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c EZCFKEY - find the boundary between the numerical and the keyword arguments
c         - check that remaining things are keyword/value pairs

        integer function ezcfkey(keys, nkeys, nargs, nargs1)

Use(Keywords)

        character*(*) keys(nkeys)
        integer nargs, nargs1, nkeys, iarg, k
        logical iskey

        nargs1 = nargs #nargs1 = number of numerical arguments

        for (iarg=1, iarg <= nargs, iarg=iarg+1)
           iskey = FALSE
           do k = 1, nkeys
               if (keys(k) .eq. symbols(iarg)) then
                  iskey = TRUE
                  break
               endif
           enddo
           if (nargs1 .eq. nargs) then
              if (iskey) then
                 nargs1 = iarg-1
                 iarg = iarg + 1
              endif
           elseif (iskey) then
              iarg = iarg + 1
           else
              call ezcremrk("ezcfkey: bad keyword or argument, near")
              call ezcremrk(symbols(iarg))
              return(ERR)
           endif
        endfor

        return(OK)
        end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c EZCPKEY - call ezcfkey with plot keywords

      integer function ezcpkey(sym, lsym, nargs, nargs1)
      integer nargs, nargs1, lsym(0:30), i
      integer ezcfkey
      external ezcfkey
      character*(*) sym(0:30)

Use(Keywords)

      do i = 1, nargs
	 symbols(i)  = sym(i)
	 lsymbols(i) = lsym(i)
      enddo

      return(ezcfkey(plotkey, NPLOTKEY, nargs, nargs1))
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c EZCREMRK - process messages to terminal from EZC

        subroutine ezcremrk(msg)
        character *(*) msg

        integer ezcgetcl
        external ezcgetcl

        call baspline(STDOUT, msg(1:ezcgetcl(msg)) )

        return
        end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c EZCLEGND - 

        subroutine ezclegnd(command, nargs, nargs1)
        character*(*) command
        integer utgetcl, nleg, nargs, nargs1, i
        external utgetcl

Use(Keywords)
Use(Default_attributes)

        legenda = command
        nleg    = utgetcl(legenda)

        do i = 1, nargs1
           call utcat(legenda, nleg, legenda, nleg, " ", 1, symbols(i), 
     &                lsymbols(i))
        enddo

        do i = nargs1+1, nargs, 2
           call utcat(legenda, nleg, legenda, nleg, " ", 1, symbols(i), 
     &                lsymbols(i))
           call utcat(legenda, nleg, legenda, nleg, "=", 1, symbols(i+1), 
     &                lsymbols(i+1))
        enddo

        return
        end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c EZCERROR - process error messages from EZC
c          - If errsvl is nonzero, terminate the code after writing msg

        subroutine ezcerror(msg, errsvl)
        character *(*) msg
        integer errsvl  #error severity level

        integer ezcgetcl
        external ezcgetcl

        call baspline(STDERR, msg(1:ezcgetcl(msg)))

        if (errsvl .ne. 0) then
c          call ezcdie
           stop
        endif

        return
        end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c MEMTEMP - allocate temporary memory

        subroutine memtemp(ipoint, type, nelts, name)
        implicit none
        Address ipoint
        character*(*) type
        integer nelts
        character*(*) name

        integer err, ni, nw, szwd

        integer scmakf, utsizstr, utgetcl
        external scmakf, utsizstr, utgetcl

        ni   = max(nelts, 1)
        nw   = utsizstr(ni, type)
        szwd = CHAR_PER_WORD

        err = scmakf(ipoint, nw, szwd, utgetcl(name), name)
        if (err .eq. 0) then
           call remark("WARNING: ALLOCATING SPACE - MEMTEMP")
        endif

        return
        end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c MEMFREE - release temporary memory

        subroutine memfree(ipoint)
        implicit none
        Address ipoint

        integer err

        integer scfree
        external scfree

        err = scfree(ipoint)
        if ((err .eq. 0) .and. (ipoint .ne. 0)) then
           call remark("WARNING: FREEING SPACE - MEMFREE")
        endif

        return
        end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c MEMCHANGE - change temporary memory

        subroutine memchange(ipoint, type, nnew, nold)
        implicit none
        Address ipoint
        character*(*) type
        integer nnew, nold

        integer err, szwd, size, sizeo

        integer scmake, screma, utsizstr
        external scmake, screma, utsizstr

        size  = utsizstr(nnew, type)
        sizeo = utsizstr(nold, type)
        szwd  = CHAR_PER_WORD

        if ((ipoint .eq. 0) .or. (ipoint .eq. -8192)) then
           err = scmake(ipoint, size, szwd)
        else
           err = screma(ipoint, size, szwd)
        endif

        if (err .eq. 0) then
           call remark("WARNING: CHANGING SPACE - MEMCHANGE")
        endif

        return
        end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

