# 
# EZN.V - EZN on PGS
# 

ezc

usertype real8 
{

%define real8 real(Size8)
%define _real8 real8

CGMLOGUNIT  = 51
PSLOGUNIT   = 52
JPEGLOGUNIT = 53
MPEGLOGUNIT = 54

NWINDOWS = 30	# maximum number of windows
NCOLORS  = 25	# number of colors setup for use

SSIZE = 8

GASAP     = 0
GALLOW    = 1
GSNEVR    = 2
GIFIXUP   = 4
GREALI    = 1
GCLIP     = 1
LSIZE     =  120
LOCAL     =  1
GLOBAL    =  2
NPLOTKEY  = 11
NVECKEY   = 10
NFILKEY   = 7
NCONKEY   = 14
NZCONKEY  = 11
NLKEY     = 4
NMESHKEY  = 16
NATTRKEY  = 23
NRAYKEY   = 5
NPOLYKEY  = 4
NPOLFKEY  = 4
NTEXTKEY  = 5
NFTXTKEY  = 3
MAXREG    = 64
NHARDCOPY = 4

NMARKERS = 5  # number of markers recognized by this GKS
NSTYLES  = 7
LDASH    = 32

Mark         = 1 # order of
Arrow        = 2 # these
Curve        = 3 # counts!
Mesh         = 4
Vector       = 5
Ray          = 6
MeshContour  = 7
Text         = 8
OtherContour = 9
FillMesh     = 10
CellArray    = 11
Ftext        = 12
PolyFill     = 13
PolyFunc     = 14
Remove       = -1 # marker for undo (ezcsub)

NPRBSAVE     = 20  # Number of ezczoom probes that will be saved.

}

*** Devices local:

%Use(Device_Control)
%Use(Device_Internal)
%Use(Problem_name)

*** Problem_name /baspn/ hidden:

   # Note, shared with parser package if Basis present
   # Same as Basis variable "probname"
fnroot character*(32)

*** Device_Control dump:

# variables to control the graphics devices

# for SCREEN

   # X11 display specification.
ezcdisp character*32  -dump
   # X11 window height in inches. (default  =  7.)
ezcwinht real8 -dump
   # X11 window width in inches. (default  =  7.)
ezcwinwd real8 -dump
   # X11 window size specification: -dx DX -dy DY -u 0|1|2
   #   where DX,DY are real, -u indicates the units
   #   specification: 0 (default) meters, 1 inches, 2 rasters.
   #   Applies to ATC GKS only.
ezcwinsz character*32 -dump
   # X11 window label specification.
ezcwinlb character*16 -dump

# for CGM

   # Number of frames to put in a single CGM file.
ezccgmc integer 
   # Name of the current CGM file.
cgmfile Filename -dump
   # CGM file suffix.
cgmfsfx integer
   # Log file name for CGM device.
iezccgmf Filename -dump

# for PS

   # Number of frames to put in a single PS file.
ezcpsc integer
   # Name of the current PS file.
psfile Filename -dump
   # PS file suffix.
psfsfx integer
   # Log file name for PS file.
iezcpsf Filename -dump

# for JPEG

   # Number of frames to put in a single JPEG file.
ezcjpegc integer
   # Name of the current JPEG file.
jpegfile Filename -dump
   # JPEG file suffix.
jpegfsfx integer
   # Log file name for JPEG file.
iezcjpegf Filename -dump

# for MPEG

   # Number of frames to put in a single MPEG file.
ezcmpegc integer
   # Name of the current MPEG file.
mpegfile Filename -dump
   # MPEG file suffix.
mpegfsfx integer
   # Log file name for MPEG file.
iezcmpegf Filename -dump


# for parameter index specifications

   # Parameter index, for use with ezcset and ezcget routines.
ezcpidx integer /0/

*** Device_Internal hidden:

   # Number of active devices.
iezcdev integer    /0/
   # Array of devices
ezcdevs(NWINDOWS) integer
   # Are plots active?
codeplot integer 
   # Is this frame the result of a "device send" command?
ezcsend logical /FALSE/

# for Xwindow workstation

   # Xwindow colormap name, default "color".
winclrmap character*16
   # Open window count.
iwinop integer
   # Workstation id, initialized to 1000.
iwsidset integer
   # Connection id, initialized to 0.
iconn integer
   # List of window names.
winame(NWINDOWS) character*16
   # List of window activations.
winstate(NWINDOWS) logical
   # Workstation id assigned to the window list.
iwsid(NWINDOWS) integer
   # Workstation connection id (each must be 64 bits).
iwscn(2,NWINDOWS) integer
   # Associated DISPLAY of the window.
windisp(NWINDOWS) character*32
   # Number of colors available on window.
winncoli(NWINDOWS) integer
   # Is this a color window?
wincola(NWINDOWS) integer

# for CGM

   # CGM status flag: -1 uninitialized, 0 off, 1 on.
iezccgma integer /-1/
   # Number of frames in current CGM file.
iezccgmn integer
   # CGM colormap name, default "color".
cgmclrmap character*16
   # CGM device id
iezccgmid integer  /-1/

# for PostScript

   # Postscript activation status.
iezcpsa integer /-1/
   # Number of frames in current PS file.
iezcpsn integer
   # PS colormap name, default to "mono".
psclrmap character*16
   # PS device id
iezcpsid integer /-1/

# for JPEG

   # JPEG activation status.
iezcjpega integer /-1/
   # Number of frames in current JPEG file.
iezcjpegn integer
   # JPEG colormap name, default to "mono".
jpegclrmap character*16
   # JPEG device id
iezcjpegid integer /-1/

# for MPEG

   # MPEG activation status.
iezcmpega integer /-1/
   # Number of frames in current MPEG file.
iezcmpegn integer
   # MPEG colormap name, default to "mono".
mpegclrmap character*16
   # MPEG device id
iezcmpegid integer /-1/


# for minimum character size

   # Minimum character size.  (Set via ezcminsx.)
ezcminch integer

*** Colors:

   # Names of colors.
color(NCOLORS) character*16
   # Index of colors.
clrid(NCOLORS) integer
   # Print debug output in color routines if non-zero.
debcolr integer
   # First color available to user (also number of named colors).
   # DO NOT ASSIGN TO THIS VARIABLE.
indbase integer
   # Number of user alterable colors.
numcol integer
   # Background color: 0 means black, else white.
   # DO NOT ASSIGN TO THIS VARIABLE.
bakcol integer
   # Maxium color index that has been set for the colormap.
indmax integer

   # Red in user defined RGB for colormap.
ezcred(249) integer /249*0/
   # Green in user defined RGB for colormap.
ezcgreen(249) integer /249*0/
   # Blue in user defined RGB for colormap.
ezcblue(249) integer /249*0/

   # Set color representation for indices indlo thru indhi from arrays
   # red, green, and blue.
#ezccoltb(indlo:integer,indhi:integer,red:real8,green:real8,blue:real8) integer function
   # Print the color table of the X11 window to the terminal.
#ctablist() integer function
   # Print the RGB components of the color whose index is indx.
#ezcgetcol(indx:integer) integer function
   # Load numbered color table.
loadct(ctab:integer) integer function
   # Request number of entries in color table.
# reqcolr(nreq:integer) subroutine
   # Request background color (0 for black, 1 for white).
backcolr(bakndx:integer) subroutine
   # Set background color to white.
ezcsetbw subroutine
   # Set background color to black.
ezcsetbb subroutine

# *** Ptext /ptextc/:
# 
#    # Number of lines per page for ptext.
# nptext integer 
#    # Number of lines on current ptext page.
# textline integer
# 
# %save /ptextc/

*** Routines:

# Routines in ezc package

   # Set quadrant: 1, 2, 3, 4, 12, 34, 13, 24, or 1234.
#ezcquad(iquad) subroutine
   # Set portion of 0-1 space to be used for the quadrants by ezcquad.
#ezcdquad(v1:real8,v2:real8,v3:real8,v4:real8) subroutine
   # Inquiry for quadrant parameters.  (All arguments are outputs;
   # do not forget the &s if used from Basis.)
ezciquad(v1:real8,v2:real8,v3:real8,v4:real8,iquad:integer) subroutine
   # Set quadrant parameters.  (Does not have to be a quadrant per se.)
#ezcsquad(v1:real8,v2:real8,v3:real8,v4:real8) subroutine
   # nf: begin new frame.
ezcnf subroutine
   # Process command:  device flag aux
   #   device  =  "cgm", "ps", "jpeg", "mpeg", or "win";
   #   flag  = "on", "off", "send" or "close".
ezcdodev(device:string;flag:string,aux:string) subroutine
   # Inquiry for file name.
#ezcifname(s1:string,s2:string) subroutine
   # Check whether fname2 has ezactly nadd more characters than fname1.
   # Return value is TRUE if this condition is satisfied, else FALSE.
   # Intended to check for truncation during filename construction.
#ezccklen(fname1:string,fname2:string,nadd:integer) logical function
   # Inquiry for the unit number of the input unitype; e.g. ps,etc.
   # (Basis users: don't forget & on first argument.)
#ezciunit(iunit:integer,unitype:string) subroutine
   # Write message (character*120) to the log file.
#ezcwrtlog(message:string) subroutine
   # Get the current value "pvalue" of integer parameter "pname".
   # (Don't forget to use &pvalue if called from Basis.)
   # If "pname" is an array name, ezcpidx is the index of the array
   # element, which should be set with ezcseti.
#ezcgeti(pname:string,pvalue:integer) subroutine
   # Get the current value "pvalue" of real parameter "pname".
   # (Don't forget to use &pvalue if called from Basis.)
   # If "pname" is an array name, ezcpidx is the index of the array
   # element, which should be set with ezcseti.
#ezcgetr(pname:string,pvalue:real8) subroutine
   # Get the current value "pvalue" of string parameter "pname".
   # WARNING: this routine will NOT work in Basis.
   # If "pname" is an array name, ezcpidx is the index of the array
   # element, which should be set with ezcseti.
#ezcgetc(pname:string,pvalue:integer) subroutine
   # Set the integer parameter "pname" to value "pvalue".
   # If "pname" is an array name, ezcpidx is the index of the array
   # element, which should be set with ezcseti.

   # Create and install a default colormap with idepth entries.
 ezcscm(idepth:integer) subroutine

#ezcseti(pname:string,pvalue:integer) subroutine
   # Set the real parameter "pname" to value "pvalue".
   # If "pname" is an array name, ezcpidx is the index of the array
   # element, which should be set with ezcseti.
#ezcsetr(pname:string,pvalue:real8) subroutine
   # Set the string parameter "pname" to value "pvalue".
   # If "pname" is an array name, ezcpidx is the index of the array
   # element, which should be set with ezcseti.
#ezcsetc(pname:string,pvalue:string) subroutine
   # Return the number of currently active windows in wson.
   # If the return value of wson is > 0, then:
   #   wsid   is the workstation ID of the most recently opened one,
   #   wsname is the associated window name (character*16), and
   #   wsdisp is the display on which the window is open (character*32).
#ezdckwin(wson:integer,wsid:integer,wsname:string,wsdisp:string) subroutine
   # Flush any outstanding events on window with workstation ID wsid.
   # A return value of stat > 0 implies trouble flushing.
#ezdflwin(wsid:integer,stat:integer) subroutine
   # Probe the current active window until ezdprob returns qflag<>0.
#ezdpbsv subroutine
   # Probe the current active window for values.
   # qflag returns nonzero if probe is outside plot frame.
#ezdprobe(px:real8,py:real8,upx:real8,upy:real8,qflag:integer) subroutine

# ------------------------------------------------------------------------------

# EZC Groups

*** Ezcurve controls dump:

# User controls for ezc package

   # Flag to set ezc debug mode: if TRUE will print WARNING messages.
 ezcdebug logical /FALSE/
   # Flag to set no-plot mode, if TRUE.  (default = FALSE)
 ezcnoplot logical /FALSE/
   # Supertitle, typically used for every frame; not cleared by ezcnf.
 ezctitle character*LSIZE /" "/
   # Title for the top.
 titlet character*LSIZE /" "/
   # Title for the bottom.
 titleb character*LSIZE /" "/
   # Title for the left side.
 titlel character*LSIZE /" "/
   # Title for the right side.
 titler character*LSIZE /" "/
   # Names of markers you can use.
 markers(NMARKERS) character*8 /"dot","plus","asterisk","circle","cross"/
   # Names of line styles.
 style(NSTYLES) character*8 
   /"solid","dashed","dotted","dotdash","ltor","rtol","none"/
   # Dash patterns corresponding to above names.
 pattern(NSTYLES) character*LDASH 
   # Determines if each plot command causes a send to all active devices.
 ezcshow                  logical  /TRUE/
   # Determines if ATTR attributes reset to the default values on frame
   # advance.
 ezcreset                     logical  /TRUE/
   # Amount of extra y room in pictures when frame not specified.
 ezcextra real8 /.025_Size8/
   # Prevent averaging of x data if 1 longer than y data?
 ezcnocx logical /FALSE/
   # Prevent averaging of y data if 1 longer than x data?
 ezcnocy logical /FALSE/
   # Control for contour label style: "alpha", "on", or "off".
 ezclabel character*8 /"alpha"/
   # Control for display of contour level keys: "on" or "off".
 ezcconkey character*8 /"on"/
   # Control for contour level keys color fill: "hollow" or "solid".
   # (default  =  hollow)
 ezcconord character*SSIZE /"incr"/
   # Control for order of contour level keys: "incr" or "decr".
   # (default = incr)
 ezccksfill character*8 /"hollow"/
   # Control for display of fillmesh color keys: "on" or "off".
 ezcfmkey character*8 /"on"/
   # Control for fillmesh level keys color fill: "hollow" or "solid".
   # (default  =  solid)
 ezcfmfill character*8 /"solid"/
   # Control for display of ray power color keys: "on" or "off".
 ezcpwkey character*8 /"on"/
   # Control for ray power level keys color fill: "hollow" or "solid".
   # (default  =  solid)
 ezcpwfill character*8 /"solid"/
   # Format to use to form contour labels -- DANGER: no error checking.
   # Be sure format is contained in (), writes one real number,
   # field < =  16 characters.
   # Beginning and ending blanks will be removed.
 ezcclf character*16 /"(1Pe16.2)"/
   # Multiplier for arrow size.
 ezcarsz real8	/1.0_Size8/
   # Multiplier for spacing between arrows.
 ezcarsp real8 /1.0_Size8/
   # Control the ray label: "on" or "off".
 ezcraylab character*8 /"off"/
   # Control the fat ray: "on" or "off".
 ezcthickray character*8 /"on"/
   # The count of laser numbers.
 ezcnlaser integer /0/
   # An array of laser numbers.
 ezclaser(ezcnlaser) _integer 
   # Style of rays when they are traveling left to right.
 ezcraylr character*8 /"ltor"/
   # Style of rays when they are traveling right to left.
 ezcrayrl character*8 /"rtol"/
   # Color of rays when they are traveling left to right.
 ezcrayclr character*16 /"fgcolor"/
   # Color of rays when they are traveling right to left.
 ezcraycrl character*16 /"fgcolor"/
   # Scale vectors to this amount of frame size by default.
 ezcvsc real8      /0.0_Size8/
   # List contour levels in the legend?
 ezcshowl logical /TRUE/
   # Should the plot box always be the same size regardless of titles and 
   # contours?
 ezcfixed logical /TRUE/
   # Fraction of the frame devoted to titles; 3/5 of this for ezctitle.
 ezctitfr real8 /0.04_Size8/
   # Fraction of the frame to devote to the legend.
 ezclegfr real8 /0.125_Size8/
   # Fraction of the frame to devote to contour level list.
 ezccntfr real8 /0.125_Size8/
   # Control placement of the supertitle ezctitle: at the top if TRUE,
   # at the bottom if FALSE
 ezcsuper logical /TRUE/
   # The minimum value for log plots is ezcfloor times the maximum data
   # value.  If 0., use d1mach(4).
 ezcfloor real8 /0._Size8/
   # Curve label shift for the subsequent curves.
 ezclbshft integer /0/
   # Control flag to override log plot style set by the program:
   # TRUE if set by program, FALSE if set by user.
 dflogstyle logical /FALSE/

*** Collections hidden:

 # collections of data

   # previously got "yucked" while plotting
 yucked logical /FALSE/
   # a "big" real number for this machine
 ceiling real
   # a "small" real number for this machine
 realsmall real
   # number of frames written so far
 nframes integer /0/
 xfloor real8
 yfloor real8
 maxdata         integer /0/
 ndata           integer /0/
   # pointers
 data(maxdata)   _Address

   # if true, this data does not contribute to extremea for x and y
 dminc(0:maxdata) _real8
 dmaxc(0:maxdata) _real8
 dminac(0:maxdata) _real8
 dmaxac(0:maxdata) _real8
 dnoec(0:maxdata) _logical

   # first dimension of data
 n1(maxdata)                  _integer  
   # second dimension of data
 n2(maxdata) _integer
   # current maximum size of arrays dimensioned by nc
 maxnc           integer /0/
   # number of elements currently in the display list
 nc              integer  /0/
   # index into data for y
 yi(maxnc)              _integer
   # index into data for x
 xi(maxnc)              _integer
   # index into data for z
 zi(maxnc)              _integer

# fillmesh specific

   # index into data for z extrema
 zexti(maxnc)		_integer

# mesh plot specific

   # index into data for ireg
 iregi(maxnc)           _integer
   # index into data for kept regions
 kpregi(maxnc)		_integer
   # index into data for k,l limits for mesh plot
 kllmti(maxnc)		_integer
   # index into data for boundary plot flag for mesh plot
 bndflagi(maxnc)	_integer
   # l line style for mesh plot
 lstylec(maxnc)		_character*(8)
   # k line style for mesh plot
 kstylec(maxnc)		_character*(8)
   # l line color for mesh plot
 lcolorc(maxnc)		_character*(16)
   # k line color for mesh plot
 kcolorc(maxnc)		_character*(16)

# vector specific

 vyi(maxnc)             _integer
 vxi(maxnc)             _integer

# ray specific

   # index into data for power
 pwi(maxnc)              _integer
   # index to laser number
 lasi(maxnc)		_integer
   # index to the number of rays in each laser
 nrayi(maxnc)		_integer
   # index to the labels for rays 
 raylabi(maxnc)		_integer
   # index to the dispmarks for rays
 dispmarki(maxnc)	_integer
   # index to the number of plot points in each ray
 nraypti(maxnc)		_integer

# curve , markers and general 

   # index to label to use for curve
 labeli(maxnc)		_integer
   # curve style
 stylec(maxnc)           _character*(8)  
   # curve type
 namec(maxnc)            _integer
   # font to use
 fontc(maxnc)            _character*(8)  
   # mark to use for curve
 markc(maxnc)            _character*(8)  
   # mark size pararmeter for curve marks
 marksc(maxnc)        _real8  
   # line thickness to use
 thickc(maxnc)        _real8
   # color to use for curve
 colorc(maxnc)     _character*16
   # legend to use for curve
 legendc(maxnc)          _character*(LSIZE)  
   # prefix to legend
 preleg(maxnc)           _character*16
   # dash-pattern holder
 dshp  character*LDASH /" "/

# miscellaneous
 ixprev integer /0/ # index of previous x
# default stack elements for plotv, plotm, plotc, plotf
 ixpreva integer /0/ # index of averaged form of previous x

 typeint integer
 type4 integer   # code for type of a real(Size8)
 type8 integer   # code for type of a real(Size8)
 typex integer
 typelog  integer
 typef integer

*** Probe:

# variables related to probe functions
# fraction coordinates and user coordinates

   # Fraction coordinates for box left.
 ezcfl real8
   # Fraction coordinates for box right.
 ezcfr real8
   # Fraction coordinates for box bottom.
 ezcfb real8
   # Fraction coordinates for box top.
 ezcft real8
   # User coordinates for box left.
 ezcul real8
   # User coordinates for box right.
 ezcur real8
   # User coordinates for box bottom.
 ezcub real8
   # User coordinates for box top.
 ezcut real8
   # Linear/logarithmic transformation flag.
 ezcll integer

# arrays to keep history of last ezcprsave probe function selections.

   # Counter for number of probe commands issued.
 lastprobe integer  /0/
   # Size of probe arrays.  Maximum lastprobe value.
 ezcprsave integer  /NPRBSAVE/   readonly
   # Array of saved values of ezcfl.
 savezcfl(NPRBSAVE) real8
   # Array of saved values of ezcfr.
 savezcfr(NPRBSAVE) real8
   # Array of saved values of ezcfb.
 savezcfb(NPRBSAVE) real8
   # Array of saved values of ezcft.
 savezcft(NPRBSAVE) real8
   # Array of saved values of ezcul.
 savezcul(NPRBSAVE) real8
   # Array of saved values of ezcur.
 savezcur(NPRBSAVE) real8
   # Array of saved values of ezcub.
 savezcub(NPRBSAVE) real8
   # Array of saved values of ezcut.
 savezcut(NPRBSAVE) real8
   # Array of saved values of ezcll.
 savezcll(NPRBSAVE) integer

*** Extrema:

 xmin real /0./ # User specified frame limit if any.
 xmax real /1./ # User specified frame limit if any.
 ymin real /0./ # User specified frame limit if any.
 ymax real /1./ # User specified frame limit if any.
 xminu real8 # Actual value used for plot limit.
 xmaxu real8 # Actual value used for plot limit.
 yminu real8 # Actual value used for plot limit.
 ymaxu real8 # Actual value used for plot limit.
 xlog logical # Is x scale logarithmic?
 ylog logical # Is y scale logarithmic?

   # TRUE if the data determines xminu, ...ymaxu.
 framee(4)          logical  /4*TRUE/

*** Saved_attributes hidden:

 markss             real8 /0./
 thicks                real8  
# zfactors              real8  
 vscales               real8  
 rsqs		       real8
 arrows                integer  
 bnds                  integer  
# zcenters              integer  
 kranges(3)              integer
 lranges(3)              integer
 labels        integer
 nlevels       integer
 levels        integer
 fonts                 character*8  /" "/
 marks                 character*8  /" "/
 styles                character*8  /" "/
 kstyles               character*8  /" "/
 lstyles               character*8  /" "/
 cscales	       character*8  /" "/
 colors                 character*16 /"fgcolor"/
 kcolors                 character*16 /"fgcolor"/
 lcolors                 character*16 /"fgcolor"/
 excludes(0:MAXREG)   logical
 centers              integer
 zlimins(2)           real8
 nzlims               integer

*** Default_attributes hidden:

 marksa             real8  
 thicka             real8     
# zfactora           real8     
 vscalea            real8     
 rsqa               real8
 labelsa       integer
   # put labels on curves                 
 leginfoa               integer
   # put legends on the curves 
 arrowa                integer  
 bnda                  integer  
# zcentera              integer  
 krangea(3)              integer
 lrangea(3)              integer
   # index for contour level list, if any
 levela                  integer /0/
   # number of contour levels requested, negative means log
 nlevela               integer 

 gridxa                character*8  /" "/
 gridya                character*8  /" "/
 scalea                character*8  /" "/
 cscalea               character*8  /" "/
 fonta                 character*8  /" "/
 marka                 character*8  /" "/
 stylea                character*8  /" "/
 kstylea               character*8  /" "/
 lstylea               character*8  /" "/
 legenda               character*(LSIZE) /" "/
 labela              integer /0/
 colora                 character*16 /"fgcolor"/
 kcolora                 character*16 /"fgcolor"/
 lcolora                 character*16 /"fgcolor"/
 excludea(0:MAXREG)  logical /TRUE,MAXREG*FALSE/

   # argument to plotc is point-centered
 centera                integer  /NO/
   # User-supplied z-limits, if any.
 zlimin(2)           real8
   # Number of z-limits (0 or 2).
 nzlima              integer /0/
   # last keyword encountered
 key Varname /" "/
   # have we received commands we haven't yet displayed?
 pending                  logical /FALSE/

*** Keywords:

# Keyword Tables

   # Keywords for the plot command.
plotkey(NPLOTKEY) character*8 
/"grid","scale","style","thick", "mark", "marksize", "font", 
"arrow", "labels", "legend","color"/

   # Keywords for the plotv command.
veckey(NVECKEY) character*8
/"grid","scale","style","thick", "region", 
"legend", "vsc","color","krange","lrange"/

   # Keywords for the plotf command.
filkey(NFILKEY) character*8 	$??? need rethinking
/"cscale", "krange", "lrange", "region", "legend", "point", "zlim"/

   # Keywords for the plotc command.
conkey(NCONKEY) character*8 
/"grid","scale","style", "thick", "lev", "font",  "mark",
"marksize", "krange", "lrange", "region", "legend","color","point"/
      
   # Keywords for the plotz command.
zconkey(NZCONKEY) character*8 
/"grid","scale","style", "thick", "lev", "font",  
"legend","color","rsquared","marksize", "mark"/

   # Keywords for the ploti command.
cellkey(NLKEY) character*8 
/"grid","scale","font", "legend"/

   # Keywords for the plotm command.
meshkey(NMESHKEY) character*8
/"grid","scale","kstyle",
      "lstyle", "thick", "krange", "lrange", "region", 
      "bnd","labels","legend","mark","marksize","color","kcolor","lcolor"/

   # Keywords for the plotr command.
raykey(NRAYKEY) character*8
/"grid","scale","thick","color","legend"/

   # Keywords for the plotp command.
polykey(NPOLYKEY) character*SSIZE
/"grid", "style", "legend", "color"/
 
   # Keywords for the plotpf command.
polfkey(NPOLFKEY) character*SSIZE
/"grid", "cscale", "legend", "zlim"/

   # Keywords for the attr command.
   # data loaded in ezcinit due to length of list
attrkey(NATTRKEY) character*8

   # Keywords for the text command.
textkey(NTEXTKEY) character*8 
/"grid","scale","font", "color","legend"/

   # Keywords for the ftext command.
ftextkey(NFTXTKEY) character*8 
/"font", "color","legend"/

   # Symbolic form of arguments to ezcbfcn.
symbols(0:30) character*72 /31*" "/

   # Length of symbols.
lsymbols(0:30) integer /31*0/

*** Routines:

# Routines in ezc package

   # Set minimum chararacter size (default 12).
# ezcminsz(minsz) subroutine	
   # Set text quality (default 1):
   # < 0 Call pwrit same as in default agpwrt;
   # 0  High-quality characters;
   # l  Medium-quality characters (default);
   # 2  Low-quality via GKS primitives.
# ezcstxqu(iquality) subroutine
   # Inquiry for text quality.
# ezcitxqu(iquality) subroutine
   # Plot text at position xpos,ypos no higher than height and no longer
   # than width (the latter two are fractions of the viewport) with angle 
   # and centering flags per plotchar routines.
 ezcwtext(xpos:real8,ypos:real8,chrs:string,height:real8,width:real8,
         angle:real8,centering:real8) subroutine
   # plot: routine for curves.
 ezcplot(various)           [0-30] builtin
   # plotc: routine for contours.
 ezcplotc(various)           [1-30] builtin
   # plotf: routine for filled mesh.
 ezcplotf(various)           [1-30] builtin
   # ploti: routine for cell array.
 ezcploti(icell;xmin,xmax,ymin,ymax)           [1-30] builtin
   # plotz: routine for random contour plots.
 ezcplotz(z, x, y)           [3-30] builtin
   # plotr: routine for laser rays.
 ezcplotr(various)           [0-30] builtin
   # plotv: routine for vectors.
 ezcplotp(various)           [2-30] builtin
   #plotp: routine for filled polygons.
 ezcplotpf(various)          [3-30] builtin
   #plotpf: routine for function-filled polygons.
 ezcplotv(various)           [0-30] builtin
   # plotm: routine for meshes.
 ezcplotm(various)           [0-30] builtin
   # Set default attributes for ezc package.
 ezcattr(various)           [0-30] builtin
   # frame: set frame limits.
 ezcframe(xmin:real,xmax:real,ymin:real,ymax:real) [0-4] builtin
   # sf: display current frame.
 ezcshowg subroutine
   # titles top, bottom, left, right
 ezctitls(;titlet:string,titleb:string,titlel:string,titler:string) subroutine
   # subtract <list of command numbers>
 ezcsub  [0-30] builtin
   # Make a frame that has tag and time as a label; put into ezcshow = false
   # mode.  Echo a description to the terminal if flag is true.
 ezcss(tag:string,time:real,flag:logical) subroutine
   # Interpolate mesh-based quantity to point-centered:
   #  zout  =  point-centered version of zin.
 ezctopt(zin:real,zout:real, ireg, kmax, lmax) subroutine
   # text "message" x y nsize angle align :
   #  Put text at x,y, size nsize, at angle angle with alignment align,
   #  where x,y are in 0-1 coordinates.
   #  Default is horizontal, center of left edge at x,y.
   #  nsize should be in the range 6-24; bigger is bigger.
 ezctext(s:string,x:real,y:real,nsize:integer,angle:real,align:integer) 
	builtin [3-30]	
   # ftext "message" x y nsize angle align :
   #  Put text at x,y, size nsize, at angle angle with alignment align,
   #  where x,y are in frame coordinates.
   #  Default is horizontal, center of left edge at x,y.
   #  nsize should be in the range 6-24; bigger is bigger.
 ezcftext(s:string,x:real,y:real,nsize:integer,angle:real,align:integer) 
	builtin [3-30]	
   # Add ray plot data to Basis database:
   #  laser is an array of laser numbers;
   #  nlaser is the count of laser numbers;
   #  z is the z-coordinates for ray plot;
   #  r is the r-coordinates for ray plot;
   #  p is the power at ray point;
   #  jrp is the ray source plotflag;
   #  kpt is the array holding indices to ray plot storage;
   #  mxp is the maximum number of plot points for this laser;
   #  ndx is the index into lrayp arrays for ray plot;
   #  id is the final disposition of ray;
   #  iflg is equivalent to rypltf(nray) and is the ray plot flag;
   #  il is equivalent to irayl(nsray) and is the lower ray index;
   #  iu is equivalent to irayu(nsray) and is the upper ray index;
   #  n is equivalent to nsray.
 ezcaddr
(laser,nlaser,z:real(Size8),r:real(Size8),p:real(Size8),jrp,kpt,mxp,ndx,id,
iflg,il,iu,n) subroutine

  # Routine for zooming application.
# ezczoom subroutine

   # Find the zone to which rpin and zpin belong.
# ezcfz(rpin:real,zpin:real,n:integer,kout,lout,rt:real,zt:real,ireg,kmax,lmax) subroutine
   # Compute bilinear interpolation coordinates for point (rp,zp) in zone
   # with coordinates (r,z) specified in counterclockwise order.
# ebilin(r:real,z:real,rp:real,zp:real,c:real) subroutine

# Linearly convert an array z(1:n) of reals to color indices
# clrndx(1:n) with each color index in the range 1:ncol.
# The color indices can then be plotted as a cell array.
 ezclr4(ncol,n:integer,z:real(Size8),clrndx:integer) subroutine

   # Logarithmically convert an array z(1:n) of reals to color
   # indices clrndx(1:n) with each color index in the range 1:ncol.
   # The color indices can then be plotted as a cell array.
# ezclr4ln(ncol,n:integer,z:real(Size8),clrndx:integer) subroutine
   # Linearly convert an array z(1:n) of reals to color indices
   # clrndx(1:n) with each color index in the range 1:ncol.
   # The color indices can then be plotted as a cell array.
   # zz(1:5) returns zmin,zmax,zbar,zsigma,zmap.
# ezclr8(ncol,n:integer,z:real(Size8),clrndx:integer,zz:real(Size8)) subroutine
   # Logarithmically convert an array z(1:n) of reals to color
   # indices clrndx(1:n) with each color index in the range 1:ncol.
   # The color indices can then be plotted as a cell array.
   # zz(1:5) returns zmin,zmax,zbar,zsigma,zmap.
# ezclr8ln(ncol,n:integer,z:real(Size8),clrndx:integer,zz:real(Size8)) subroutine
   # Normally distribute an array z(1:n) of reals to color
   # indices clrndx(1:n) with each color index in the range 1:ncol.
   # The color indices can then be plotted as a cell array.
   # zz(1:5) returns zmin,zmax,zbar,zsigma,zmap.
# ezclr8nml(ncol,n:integer,z:real(Size8),clrndx:integer,zz:real(Size8)) subroutine
   # Create and install a default colormap with idepth entries.
# ezcscm(idepth:integer) subroutine
   # Linearly convert an array z(1:n) of reals to color indices
   # ndx(1:n) with each color index in the range 1:ncol.
   # User supplies the zmin and zmax for limiting the z values:
   # zz(1) = zmin, zz(2) = zmax.
# ezcfmc(ncol,n,z:real(Size8),ndx,zz:real(Size8)) subroutine
   # Logarithmically convert an array z(1:n) of reals to color
   # indices ndx(1:n) with each color index in the range 1:ncol.
   # User supplies the zmin and zmax for limiting the z values:
   # zz(1) = zmin, zz(2) = zmax.
# ezcfmcln(ncol,n,z:real(Size8),ndx,zz:real(Size8)) subroutine
   # Normally distribute an array z(1:n) of reals to color
   # indices ndx(1:n) with each color index in the range 1:ncol.
   # User supplies the zmin and zmax for limiting the z values:
   # zz(1) = zmin, zz(2) = zmax.
# ezcfmcnml(ncol,n,z:real(Size8),ndx,zz:real(Size8)) subroutine


*** EzcurveDefaults dump:

# Defaults for attributes

   # Grid lines in x direction.
defgridx character*8 /"off"/
   # Grid lines in y direction.
defgridy character*8 /"off"/
   # Size of largest vector, relative to the frame size.
defvsc real8 /0.05_Size8/
   # Scale size for marks.
defmarks real8 /1.0_Size8/
   # Thickness of lines.
defthick real8 /1.0_Size8/
   # Font.  (Currently unused) 
deffont  character*8 /"standard"/
   # Mark -- blank for curves.
defmark character*8 /" "/
   # Line style.
defstyle character*8 /"solid"/
   # Show labels on curves?
deflabel integer /YES/
   # Show the legend?
deflegnd integer /YES/
   # Plot scale: "linlin", "linlog", "loglin", "loglog", or "equal".
defscale character*8 /"linlin"/
   # Color index scale, cscale: "lin", "log" or "normal".
defcscale character*8 /"lin"/
   # Put arrows on curves?
defarrow integer /NO/
   # Normal color.
defcolor character*16 /"fgcolor"/
   # Are contour z values point-centered?
defpoint integer /NO/
   # Style for k lines.
defksty character*8 /"solid"/
   # Style for l lines.
deflsty character*8 /"solid"/
   # If YES, only draw boundaries of regions, not interiors.
defbnd integer /NO/
   # Minimum number of contour levels to choose.
   # Negative means use logarithmic contours.
deflev integer /8/
   # Title for top.
deftop character*LSIZE /" "/
   # Title for bottom.
defbot character*LSIZE /" "/
   # Title for left.
defleft character*LSIZE /" "/
   # Title for right.
defright character*LSIZE /" "/
   # r-squared parameter for multiquadric; calculated for you if  =  0.
   # Used by random contour plots to interpolate to a grid.
defrsq real8 /0._Size8/

   # Default name for z.
ezcx     Varname /"zt"/
   # Default name for r.
ezcy     Varname /"rt"/
   # Default name for v.
ezcxv    Varname /"vt"/
   # Default name for u.
ezcyv    Varname /"ut"/
   # Default name for ireg.
ezcireg  Varname /"ireg"/

*** Random_Contour_Plots:

# control interpolation of random data to a rectangular grid
# for contour plotting

   # r-squared parameter actually used by multiquadric.
rsqmqd  real8 /0._Size8/
   # Number of x-grid points for random contour plotter.
nxcplot integer /50/
   # Number of y-grid points for random contour plotter.
nycplot integer /50/
   # Number of input points in random contour plot request.
nzcplot integer
   # x-grid points calculated by random contour plot.
xcplot(nxcplot) _real8 
   # y-grid points calculated by random contour plot.
ycplot(nycplot) _real8 
   # Matrix of function values calculated by multiquadric fit for random
   # contour plot.
zcplot(nxcplot,nycplot)  _real8
   # Calculated coefficients of multiquadric fit for random contour plots.
acplot(nzcplot) _real8 
   # If TRUE, release space for above arrays after plotting.
freemqd logical /TRUE/

*** Cpmpxy hidden:

nx1 integer
nx2 integer
ny1 integer
ny2 integer
x(1) _real8
y(1) _real8
z(1) _real8
zext(1) _real8	# zmin,zmax,zbar,zsigma for fillmesh
ci(1) _integer	# for color index corresponding physics quantity

# for mesh
reg(1) _integer
kpreg(1) _logical
kllmt(1) _integer
bndflag(1) _integer

# for ray 
pw(1) _real8
laslist(1) _integer
nray(1) _integer
raylab(1) _integer
dispmark(1) _integer
nraypt(1) _integer

*** Contours:

# information about the contour levels on this picture

# Total number of contour levels used.
ezctctn integer
# Storage size of ezctctlev.
ezctctm integer
# Complete list of contour levels used in this picture.
ezctctlev(ezctctm) _real8 limited(ezctctn)
# Complete list of contour levels color indices used in this picture.
ezctctci(ezctctm) _integer limited(ezctctn)
# Complete list of letter labels.
ezctcl(52) character 
# Constant data detected if this is not zero.
ezcctcon integer /0/
# Number of contour levels used in a contour map.
ezcctn  integer
# Contour levels used in a map.
ezcctlev(ezcctn) _real8
# Index of current set into large set.
ezcctk(ezcctn) _integer
# Color index of current set of contour lines.
ezcctci(ezcctn) _integer

# ------------------------------------------------------------------------------

# ISO Groups

*** Iso3D :

# 3-D isosurface plotting routine
isoplot(t:real8, nx:integer, ny:integer, nz:integer, c0:real8,
        view:real8) subroutine

*** Internal_Iso /ISOFCN/ hidden :

       # converts lowercase to uppercase
isol2u(starr:string) subroutine
       # load data, possibly thinned, into plot arys
isoload(t:real8, inx:integer, iny:integer, inz:integer, tnew:real8, 
            nx:integer, ny:integer, nz:integer) subroutine
       # get label posns according to viewpoint
isovpt(view:real8, ixflip:integer, iyflip:integer,
            ixswap:integer, iyswap:integer) subroutine

*** Iso_Internal_Info :

isomaxsz   integer /80/     # maximum size for titles
isoscr(1)  _real8           # scratch array for ISOSRF
isotplot(1) _real8          # scrub array: x values to be plotted

*** Iso_Internal_Real_Scalar :

isoview    real8 /1.0/      # scaling factor for isosurface plot

*** Isosurface_Plot:

isoflg     integer /7/      # draw constant lines in x, y, and z
isotitle   character*80     # major title for isosurface plots
isoxtle    character*80     # X-Axis title for isosurface plots
isoytle    character*80     # Y-Axis title for isosurface plots
isoxn      integer /1/      # (boolean) call ezcsetxn within isoplot
isolabel   integer /1/      # (boolean) label the axes with the titles
isonpx     integer /100/    # number of points to display in X-direction
isonpy     integer /100/    # number of points to display in Y-direction
isonpz     integer /100/    # number of points to display in Z-direction

# ------------------------------------------------------------------------------

# SRF Groups

*** Srf3D :

# 3-D surface plotting routine, an easy-use version
#    (assumes z_ij = fcn(i,j))
srfplot(x:real8, y:real8, z:real8, nx:integer, ny:integer,
        view:real8) subroutine

*** Internal_Srf /INSRF/ hidden:

       # converts lowercase to uppercase
srfl2u(starr:string) subroutine
       # load data, possibly thinned, into plot arys
srfload(x:real8, y:real8, z:real8, inx:integer, iny:integer, xnew:real8, 
            ynew:real8, znew:real8, nx:integer, ny:integer) subroutine
       # scale the data and return the extrema
srfscal(x:real8, y:real8, z:real8, nx:integer, ny:integer, low:real8,
            high:real8) integer function
       # get label posns according to viewpoint
srfvpt(view:real8, ixflip:integer, iyflip:integer, ixswap:integer,
            iyswap:integer) subroutine

*** Srf_Internal_Parms /EZCSRF/ :

srfscr(1)  _real8           # scratch array for SRFACE
srfmaxsz   integer /80/     # maximum size for titles

*** Srf_Real_Parms :

srfspmin   real8 /1.0e-6/   # minimum spread allowed in data values
srfxplot(1) _real8          # scrub array: x values to be plotted
srfyplot(1) _real8          # scrub array: y values to be plotted
srfzplot(1) _real8          # scrub array: z values to be plotted

*** Surface_Plot:

srfxlo     real8 /1.0/      # maximum and minimum X values for scaling
srfxhi     real8 /0.0/
srfylo     real8 /1.0/      # maximum and minimum Y values for scaling
srfyhi     real8 /0.0/
srfzlo     real8 /1.0/      # maximum and minimum Z values for scaling
srfzhi     real8 /0.0/
srftitle   character*80     # major title for surface plots
srfxtle    character*80     # X-Axis title for surface plots
srfytle    character*80     # Y-Axis title for surface plots
srfztle    character*80     # Z-Axis title for surface plots
srftopln   integer /1/      # (boolean) put legend on the topline
srfxn      integer /1/      # (boolean) call ezcsetxn within showsrf
srflabel   integer /1/      # (boolean) label the axes with the titles
srfautoscal integer /1/     # (boolean) perform automatic scaling
srfnpx     integer /100/    # number of points to display in X-direction
srfnpy     integer /100/    # number of points to display in Y-direction
srfiskrt   integer /0/      # (boolean) plot skirt? (Default: no)
srfhskrt   real8 /0.1/      # skirt height, if srfskrt = 1.

*** Ezcxnc /ezcxnc/ hidden :
notified integer /NO/
%save /ezcxnc/
