/*
 * crng.c -
 */

#include <Basis.h>

#define ERR -1
#define OK 0
#define SS_TC 2

/* externals */
extern Address Paraddr(Integer *);
extern Integer Utstrcod(char *);

/* FORTRAN prototypes */
#define Rngrngr FF_ID(rngrngr, RNGRNGR)
#define Rngrngd FF_ID(rngrngd, RNGRNGD)
#define Rngrngc FF_ID(rngrngc, RNGRNGC)

extern Integer Rngrngr(float *, Integer *);
extern Integer Rngrngd(real8 *, Integer *);
extern Integer Rngrngc(float *, Integer *);

#ifdef HAS_DOUBLE_COMPLEX
#define Rngrngdc FF_ID(rngrngdc, RNGRNGDC)
extern Integer Rngrngdc(real8 *, Integer *);
#endif

/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/

Integer Crngrngc(Integer *sx, Integer npoints)
{
    Address x;
    static char msg[] = "uni32: illegal argument type.";

    x = Paraddr(sx);
    if (sx[SS_TC - 1] == Utstrcod("real"))
        Rngrngr((float *) x, &npoints);
    else if (sx[SS_TC - 1] == Utstrcod("doubleprecision"))
        Rngrngd((real8 *) x, &npoints);
#ifdef HAS_DOUBLE_COMPLEX
    else if (sx[SS_TC - 1] == Utstrcod("complex"))
#else
    else if (sx[SS_TC - 1] == Utstrcod("complex") ||
             sx[SS_TC - 1] == Utstrcod("doublecomplex"))
#endif
        Rngrngc((float *) x, &npoints);
#ifdef HAS_DOUBLE_COMPLEX
    else if (sx[SS_TC - 1] == Utstrcod("doublecomplex"))
        Rngrngdc((real8 *) x, &npoints);
#endif
    else {
        BasError(msg, strlen(msg));
        return ERR;
    }
    return OK;
}

/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
