# Test main program
# Typical use: "mppl -DTESTRNG thisfile.m > file.f; f77 -o tst file.f;./tst"

ifdef([TESTRNG],[

define([Use],[
      integer mzseed_1,mzseed_2,mzseed_3,mzseed_4
      common /foobar/ mzseed_1,mzseed_2,mzseed_3,mzseed_4
])

      program aaa
      Use(Mzran)
      real(Size4) uni32,r
      external uni32,mzran,setmzran,getmzran
      integer i,a,b,c,d,p

      call setmzran(0,0,0,0)
      call getmzran(a,b,c,d)
      write(*,*) "Initial seeds: ",a,b,c,d

      write(*,*) "First 5 values..."
      write(*,*) uni32(),uni32(),uni32(),uni32(),uni32()

      call getmzran(a,b,c,d)
      write(*,*) "Current seeds are: ",a,b,c,d

      write(*,*) "Next 5 values..."
      write(*,*) uni32(),uni32(),uni32(),uni32(),uni32()

      write(*,*) "Resetting seeds: ",a,b,c,d
      call setmzran(a,b,c,d)
      call getmzran(a,b,c,d)
      write(*,*) "Current seeds are: ",a,b,c,d

      write(*,*) "Next 5 values should repeat the previous set..."
      write(*,*) uni32(),uni32(),uni32(),uni32(),uni32()

      call setmzran(0,0,0,0)

      write(*,*) "Next 5 values should repeat the first 5..."
      write(*,*) uni32(),uni32(),uni32(),uni32(),uni32()

      call setmzran(0,0,0,0)
      do i=1,10000
          p = mzran()
      enddo
      write(*,*) "10,001th seed should be ...."
      write(*,*) p

      call setmzran(0,0,0,0)
      write(*,*) "Checking range of uni32()"
      do i=1,1000000
         r = uni32()
	 if(r <= 0.0_Size4 | r >= 1.0_Size4) then
	     write(*,*) "Range error: ",r," at index i = ",i
	 endif
      enddo
      end
])

# Return random integers in [-2^31,2^31-1].  Based on a generator due to
# Marsaglia and Zaman, Computers in Physics, v8n1, January, 1994,
# pp. 117-121.
      integer function mzran()
Immediate(CDIR$ INTEGER=64)
      Use(Mzran)
      integer modulus
      parameter(modulus=2147483579) ! 2^31-69
ifelse(WORDSIZE,32,[
! Workstation version

      mzran = mzseed_1 - mzseed_3
      if(mzran < 0) mzran = mzran + modulus
      mzseed_1 = mzseed_2
      mzseed_2 = mzseed_3
      mzseed_3 = mzran
      mzseed_4 = 69069*mzseed_4 + 1013904243
      mzran = mzran + mzseed_4
],[
! Cray version
      integer two31,two32
      parameter(two31=2**31,two32=2**32)

      mzran = mod(mzseed_1 - mzseed_3,two32)
      if(mzran < 0) mzran = mzran + modulus
      mzseed_1 = mzseed_2
      mzseed_2 = mzseed_3
      mzseed_3 = mzran
      mzseed_4 = mod(69069*mzseed_4 + 1013904243,two32)
      mzran = mod(mzran + mzseed_4,two32)
      if(mzran > two31) mzran = mzran - two32
])
      return
      end

# Return random deviates on (0,1), or more precisely, [2^-32, 1 - 2^-24].
# The constant q is based on the IEEE 754 standard single precision format.
# It's the largest single precision number < 1.0.
      real(Size4) function uni32()
      real(Size4) p,q,x
      parameter (p = 2.0**(-32), q = 1.0 - 2.0**(-24))
      integer mzran
      external mzran
      x = 0.5 + p*mzran()
      return(max(p, min(q,x)))
      end

      subroutine setmzran(a,b,c,d)
      Use(Mzran)
      integer a,b,c,d
      if(a==0 & b==0 & c==0 & d==0)then
         mzseed_1 = 521288629
         mzseed_2 = 362436069
         mzseed_3 = 16163801
         mzseed_4 = 1131199299
      else
         mzseed_1 = a
         mzseed_2 = b
         mzseed_3 = c
         mzseed_4 = d
      endif
      end

      subroutine getmzran(a,b,c,d)
      Use(Mzran)
      integer a,b,c,d
      a = mzseed_1
      b = mzseed_2
      c = mzseed_3
      d = mzseed_4
      end
