# Basis Code Development System
# Copyright 1986 The Regents of the University of California
# All rights reserved

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c PARCNFM - make the operands conformable for the binary operation op
c         - basic cases: if one operand is a scalar and the other isn't,
c         - expand the scalar appropriately
c         - If both are scalars, do nothing
c         - If neither is a scalar, check that they match appropriately
c         - dimension of length 1 will be removed only if the two operands don't have
c         - these dimensions in the same positions.
c         - Once this is done, set values in u to reflect the size of the answer.
c         - Storage is allocated by the calling routine
c         -
c         - Revised 8/91(ZCM) add double complex type; really only pertinent for Suns
c         - screen out types
c         - Revised 3/97(ZCM) For EQU and NE between string variables, expand a
c         - scalar to match an array in shape if necessary. This is kind of a
c         - kludge(two goto's!!).

      function parcnfm(u,s,t,op)
      integer u(*),s(*),t(*),op
      integer parcnfm
      integer i,snew(SSWIDTH)
      Address ssa, ssnewa
      Ch(8) parop
      integer parl, parlen, strl, offs
      Address paraddr
      external paraddr,parlen,brdcast
      logical releaset
      
      if (s(TC) < 0 & t(TC) < 0) then
         select (op)
            case EQU,NE:
                 if (parlen(s) == 1 & parlen(t) <> 1) then
                    call parcopy(t, snew)
                    snew(TC) = s(TC)
                    call parget(snew)
                    parl = parlen(t)
                    ssnewa = paraddr(snew)
                    ssa = paraddr(s)
                    releaset = FALSE
                 else if (parlen(t) == 1 & parlen(s) <> 1) then
                    call parcopy(s, snew)
                    snew(TC) = t(TC)
                    call parget(snew)
                    parl = parlen(s)
                    ssnewa = paraddr(snew)
                    ssa = paraddr(t)
                    releaset = TRUE
                 else # both are of length 1
                    goto 800
                 endif

                 strl = - snew(TC)

# Can't do straight assignment because FORTRAN
# thinks everything is MAXSTRING long.
                 offs = 0
                 do i = 1, parl
                    call smovatoa(ssnewa, offs, ssa, 0, strl)
                    offs = offs + strl
                 enddo

                 if (releaset) then
                    call parrel(t)
                    call parcopy(snew,t)
                 else
                    call parrel(s)
                    call parcopy(snew,s)
                 endif
                 goto 800

            default:
                 call paropnam(op,parop)
                 call baserror(
                      "parcnfm: operand has character type in "//parop)
                 return(ERR)
         endselect
      endif

      select (s(TC) )
         case INTEGER,REAL,DOUBLE,COMPLEX,LOGICAL,DOUBLE_C: ;
         case RANGE:
              if (op <> ADD & op <> SUBTRACT & op <> NE & op <> EQU) then
                 call paropnam(op,parop)
                 call baserror(
                 "parcnfm: operand has range type in "//parop)
                 return(ERR)
              endif
         case FWA:
              if (op <> NE & op <> EQU) then
                 call paropnam(op,parop)
                 call baserror(
                 "parcnfm: operand has address type in "//parop)
                 return(ERR)
              endif

         default:
              call paropnam(op,parop)
              call baserror("parcnfm: operand has illegal type for "//parop)
              return(ERR)
      endselect

      select (t(TC) )
         case INTEGER,REAL,DOUBLE,COMPLEX,LOGICAL,DOUBLE_C: ;
         case RANGE:
              if (op <> ADD & op <> SUBTRACT & op <> NE & op <> EQU) then
                 call paropnam(op,parop)
                 call baserror(
                 "parcnfm: operand has character type in "//parop)
                 return(ERR)
              endif
         case FWA:
              if (op <> NE & op <> EQU) then
                 call paropnam(op,parop)
                 call baserror(
                 "parcnfm: operand has address type in "//parop)
                 return(ERR)
              endif

         default:
              call paropnam(op,parop)
              call baserror("parcnfm: operand has illegal type for "//parop)
              return(ERR)
      endselect

      if ((t(TC)==FWA|s(TC)==FWA)&(parlen(s) <> 1 | parlen(t) <> 1)) then
         call baserror(
         "parcnfm: operations on address arrays not implemented.")
         return(ERR)
      endif

      if (parlen(s) == 1 & parlen(t) <> 1) then
         call parcopy(t,snew)
         call parget(snew)
         parl = parlen(t)
         call brdcast(paraddr(s), paraddr(snew), parl, t(TC))
         call parrel(s)
         call parcopy(snew,s)
      else if (parlen(t) == 1 & parlen(s) <> 1) then
         call parcopy(s,snew)
         call parget(snew)
         parl = parlen(s)
         call brdcast(paraddr(t), paraddr(snew), parl, t(TC))
         call parrel(t)
         call parcopy(snew,t)
      endif

# now the scalars if any have been promoted

 800  if (t(N) <> s(N)) goto 900      # squeeze dims and try again

# set the dimension of u
      u(N) = t(N)

# set the lengths of the columns of u
      do i=1,t(N)
         if (t(N1-1+i) <> s(N1-1+i)) goto 900  #squeeze, retry
         u(N1-1+i) = t(N1-1+i)
         if (t(M1-1+i) <> s(M1-1+i) | t(I1-1+i) <> s(I1-1+i)) then
            u(M1-1+i) = 1
            u(I1-1+i) = 1
         else
            u(M1-1+i) = s(M1-1+i)
            u(I1-1+i) = s(I1-1+i)
         endif
         
      enddo
      return(OK)

 900  continue
      call pardim(s)
      call pardim(t)
      if (t(N) <> s(N)) then
         call paropnam(op,parop)
         call baserror(
         "parcnfm: Operands not compatible in size for "//parop)
         return(ERR)
      endif

# set the dimension of u
      u(N) = t(N)

# set the lengths of the columns of u
      do i = 1, t(N)
         if (t(N1-1+i) <> s(N1-1+i)) then
            call paropnam(op,parop)
            call baserror(
            "parcnfm: Operands not compatible in size for "//parop)
            return(ERR)
         else
            u(N1-1+i) = t(N1-1+i)
         endif
         if (t(M1-1+i) <> s(M1-1+i) | t(I1-1+i) <> s(I1-1+i)) then
            u(M1-1+i) = 1
            u(I1-1+i) = 1
         else
            u(M1-1+i) = s(M1-1+i)
            u(I1-1+i) = s(I1-1+i)
         endif
      enddo

      return(OK)
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c PARCOPY - copy stack element s to t

        subroutine parcopy(s,t)
        integer s(SSWIDTH)
        integer t(SSWIDTH)

        integer i

        do i = 1, SSWIDTH
           t(i) = s(i)
        enddo

        return
        end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c PARINT - Find the integer value corresponding to a stack entry
c        - Return OK or ERR
c        -    si        = stack element containing an integer constant

      function parint(si, parin)
      integer parint, parin, parcoerc, ivalue
      Address paraddr
      external paraddr, parcoerc, ivalue
      integer si(*)
      
      if (parcoerc(si,INTEGER) = ERR) then
         call baserror("parint: Could not coerce expression to integer")
         return(ERR)
      endif

      call pardim(si)

      if (si(N) <> 0) then
         call baserror("parint:  Integer is not scalar")
         return(ERR)
      endif

      parin = ivalue(paraddr(si))

      return(OK)
      end
      
c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c PARREAL - Return the real value corresponding to a stack entry
c         -   si        = stack element containing a real constant

      integer function parreal(si,parre)
      integer parcoerc
      Address paraddr
      real parre, rvalue
      external paraddr, parcoerc, rvalue
      integer si(*)
      
      if (parcoerc(si,REAL) == ERR)then
         call baserror("parreal: Could not coerce expression to real.")
         return(ERR)
      endif

      call pardim(si)

      if (si(N) <> 0) then
         call baserror("parreal:  Real is not scalar")
         return(ERR)
      endif

      parre = rvalue(paraddr(si))

      return(OK)
      end
      
c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c PARCPLX - to allow stream output of complex no's

      integer function parcplx( si, parcpx )
      integer parcoerc
      Address paraddr
      complex parcpx	
      external paraddr, parcoerc, cvalue
      integer si(*)
      
      if (parcoerc(si,COMPLEX) == ERR)then
         call baserror("parcplx: Could not coerce expression to complex.")
         return(ERR)
      endif

      call pardim(si)

      if (si(N) <> 0) then
         call baserror("parcplx:  Complex no. is not scalar")
         return(ERR)
      endif

      call cvalue(paraddr(si), parcpx)

      return(OK)
      end
      
c--------------------------------------------------------------------------

ifelse(HAS_DOUBLE_COMPLEX,YES,[

c--------------------------------------------------------------------------

c PARDCPLX - allow stream output of double complex no's

      integer function pardcplx( si, pardcpx )
      integer parcoerc
      Address paraddr
      double complex pardcpx
      external paraddr, parcoerc, dcvalue
      integer si(*)
      
      if (parcoerc(si,DOUBLE_C) == ERR)then
         call baserror(
         "pardcplx: Could not coerce expression to double complex.")
         return(ERR)
      endif

      call pardim(si)

      if (si(N) <> 0) then
         call baserror("pardcplx:  Double complex no. is not scalar")
         return(ERR)
      endif

      call dcvalue(paraddr(si), pardcpx)

      return(OK)
      end

c--------------------------------------------------------------------------

])

c--------------------------------------------------------------------------

c PARDBLE - Return the double precision value corresponding to a stack entry
c         -    si        = stack element containing a double precision constant

      integer function pardble(si, parre)
      integer parcoerc
      Address paraddr
      double precision parre, dvalue
      external paraddr, parcoerc, dvalue
      integer si(*)
      
      if (parcoerc(si,DOUBLE) == ERR)then
         call baserror("pardble: Could not coerce expression to double precision.")
         return(ERR)
      endif

      call pardim(si)

      if (si(N) <> 0) then
         call baserror("pardble:  Double precision expr. is not scalar")
         return(ERR)
      endif

      parre = dvalue(paraddr(si))

      return(OK)
      end
      
c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c PAROPNAM - given an op code op, return the string parop corresponding to it.

      subroutine paropnam(op,parop)
      integer op
      character*(*) parop
      
      select (op)
         case ADD: parop ="+"
         case SUBTRACT: parop ="-"
         case MULTIPLY: parop ="*"
         case DIVIDE: parop ="/"
         case POWER: parop ="**"
         case CONCATENATE: parop="//"
         case MATRIXMULTIPLY: parop="*!"
         case MATRIXDIVIDE: parop="/!"	#YHC(9/16/93)
         case DOTPRODUCT: parop="!"
         case AND: parop = "&"
         case OR: parop = "|"
         case LT: parop = "<"
         case LE: parop = "<="
         case GT: parop = ">"
         case GE: parop = ">="
         case EQU: parop = "=="
         case NE: parop = "~="
         case OREQ: parop = "|="
         case ANDEQ: parop = "&="
         case PLUSEQ: parop = "+="
         case MINUSEQ: parop = "-="
         case TIMESEQ: parop = "*="
         case DIVIDEEQ: parop = "/="
         case EXPEQ: parop = "**="
         default: call baderr("paropnam: impossible operation code")
      endselect

      return
      end
        
c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c PARPUSH - 

      subroutine parpush(name)
      character*(*) name

      integer glbpknum
      external glbpknum

      n = glbpknum(name)

      if (n = 0) call kaboom(0)

      call glbninit(n)
      call parpushp(n)

      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c PARPUSHP - push package number on top of search stack

      subroutine parpushp(number)
      integer number

      Use(Controls)

      call rtparpp(number, usrfirst)

      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c PARPUT - moves both integer and address portions of stack

      subroutine parput(i, si)

Use(Stacks)

      integer i, si(SSWIDTH)

      do j = 1, SSWIDTH
         ss(j,i) = si(j)
      enddo

      return
      end
      
c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c PARSQBR - Do explist ::= explist , matrix inside square brackets
c         -     s,t     = stack elements

      function parsqbr()
      integer sx(SSWIDTH), sss(SSWIDTH), tt(SSWIDTH)
      integer parsqbr, newtype
      integer parcoerc, parlen, utsizeof
      Address paraddr
      external parcoerc,paraddr,parlen,utsizeof
      Address svar, tvar, result

Use(Actions)
Use(Stacks)

#
# explist ::= explist , matrix
#
#
# dimension checks:
# if dim(x) == dim(y), dim(result) = that + 1
# otherwise, if dim(y) < dim(x), then dim(result)=dim(y)+1
#  this will be o.k. if x and y match in the dimensions they both have.
#  the new dim(y)+1'th length will be 1 plus the product of the dim(y)+k,
#  k = 1, ... th column lengths of y.
# Likewise, if dim(y) > dim(x), similarly.
      call parfetch(ss(1,rsp),nxp(rsp),lxp(rsp),ACTUAL,TRUE)

# explist , matrix
      if (symbolic) then
         call utcat(nxp(rsp-1),lxp(rsp-1),nxp(rsp-1),lxp(rsp-1),",",1,nxp(rsp),lxp(rsp))
      endif

      newtype = max(ss(TC,rsp-1), ss(TC,rsp))
      
      if (newtype < 0)
     &   newtype = min(ss(TC,rsp-1), ss(TC,rsp))

# coerce to same type
      if ( parcoerc(ss(1,rsp-1),newtype) == ERR) return(ERR)
      if ( parcoerc(ss(1,rsp),newtype) == ERR) return(ERR)

# if either argument has zero length, answer is the other one
      nte = parlen(ss(1,rsp))
      if (nte == 0) then
         call parrel(ss(1,rsp))
         return(OK)
      endif

      nse = parlen(ss(1,rsp-1))
      if (nse = 0) then
         call parrel(ss(1,rsp-1))
         call parcopy(ss(1,rsp),ss(1,rsp-1))
         return(OK)
      endif

      ns = ss(N,rsp-1)
      nt = ss(N,rsp)
      n = min(ns,nt)

# do more dimensions correspond, if the dimensions of length 1 are removed?
      nmatchs = 0
      do i=1,n
         if (ss(N1-1+i,rsp-1) <> ss(N1-1+i,rsp)) break
         nmatchs = i
      enddo

      call parcopy(ss(1,rsp-1),sss)
      call parcopy(ss(1,rsp),tt)
      call pardim(sss)
      call pardim(tt)

      nmatchss = 0
      do i=1,n
         if (sss(N1-1+i) <> tt(N1-1+i)) break
         nmatchss = i
      enddo

      if (nmatchss > nmatchs) then     #squeeze dims of len 1 
         call pardim(ss(1,rsp-1))
         call pardim(ss(1,rsp))
         ns = ss(N,rsp-1)
         nt = ss(N,rsp)
         n = min(ns, nt)
      endif

# answer will be in s eventually, but form it in sx
      call parcopy(ss(1,rsp-1),sx)
      
# check sizes
      nmatch = 0
      do i=1,n
         if (ss(M1-1+i,rsp-1) <> ss(M1-1+i,rsp))  sx(M1-1+i) = 1
         if (ss(I1-1+i,rsp-1) <> ss(I1-1+i,rsp))  sx(I1-1+i) = 1
         if (ss(N1-1+i,rsp-1) <> ss(N1-1+i,rsp)) break
         nmatch = i
      enddo

      if (ns > nmatch) then
         nes = ss(N1+nmatch,rsp-1)
         do i = nmatch+2,ns
            nes = nes * ss(N1-1+i,rsp-1)
         enddo
      else
         nes = 1
      endif

      if (nt > nmatch) then
         net = ss(N1+nmatch,rsp)
         do i = nmatch+2,nt
            net = net * ss(N1-1+i,rsp)
         enddo
      else
         net = 1
      endif

      sx(N) = nmatch + 1
      sx(N1+nmatch) = nes + net
      sx(M1+nmatch) = 1
      sx(I1+nmatch) = 1

#(ZCM 11/1/95) need to parget space in literal table to avoid
# clobbering literal table(strings in string table).
      if (sx(TC)<0&sx(NAML)==0)then
         call parget(sx)
      elseif (sx(TC)<0 & sx(NAML)~=0 | sx(TC) > 0)then
         call parget(sx)
      endif

# move the data
      svar = paraddr(ss(1,rsp-1))
      tvar = paraddr(ss(1,rsp))
      result = paraddr(sx)

      if (newtype <0) then
         ncs = nse *(-newtype)
         nct = nte *(-newtype)
         call smovatoa(result,0,svar,0,ncs)
         call smovatoa(result,ncs,tvar,0,nct)
      else
         nws = utsizeof(nse, newtype)
         nwt = utsizeof(nte, newtype)
         call assgn(svar, result, 0, nws)
         call assgn(tvar, result, nws, nwt)
      endif

# release storage
      call parrel(ss(1,rsp-1))
      call parrel(ss(1,rsp))
      call parcopy(sx,ss(1,rsp-1))

      return(OK)
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c PARTRANS - 

      subroutine partrans(s)
      integer s(SSWIDTH),t(SSWIDTH)
      integer parlen
      Address paraddr, src, tar
      external paraddr,parlen, transp

Use(Actions)

      if (parlen(s) = 1) return

      if (s(N) == 1) then
         s(N) = 2
         s(N2) = s(N1)
         s(M2) = s(M1)
         s(I2) = s(I1)
         s(N1) = 1
         s(M1) = 1
         s(I1) = 1
         return
      elseif (s(N) > 2) then
         call pardim(s)
      endif

      if (s(N) <> 2 ) then
         call baserror("Cannot transpose array of > 2 dimensions.")
         call kaboom(0)
      endif

      t(TC) = s(TC)
      t(N)  = 2
      t(N1) = s(N2)
      t(N2) = s(N1)
      t(M1) = s(M2)
      t(M2) = s(M1)
      t(I1) = s(I1)
      t(I2) = s(I2)
      if ( t(TC) < 0 ) then
         t(NAML) = 1
      endif

      call parget(t)

      tar = paraddr(t)
      src = paraddr(s)

      call transp(src, tar, s(N1), s(N2), t(TC))
      call parrel(s)

# compute dimension of resulting object.  Should be a noop
      call parcopy(t, s)

      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c PARXERR - 

      subroutine parxerr(msg,i)
      Ch(*) msg
      integer i

      Character*(OUTLINE) errmsg

      call baserror("...Error in computation...")
      call baserror(msg)

      call utsprint(1, 1, OUTLINE, errmsg,
     &              57, "The error occurred in the %d component of the expression.",
     &              i)

      call baserror(errmsg)

      return
      end
      
c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c PARPKNUM - 

      integer function parpknum(si)
      Ch(PNSIZE) name
      integer n1
      integer si(SSWIDTH)
      
      integer glbpknum, parname
      external glbpknum, parname

Use(Stacks)

      n1 = parname(si, name)
      ss(N,rsp) = glbpknum(name(1:n1))

      if ( si(NAML) < 0 ) call parrel(si)

      if (ss(N,rsp) == 0) then
         semerr = ERR
         return(ERR)
      endif

      call glbninit(ss(N,rsp))
      semerr = OK

      return(OK)
      end
      
c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c PARKILLA - release storage for the iarg'th entry on the runtime stack(i. e., the
c          - iarg'th parameter of the currently executing function) if necessary

      subroutine parkilla(iarg)
      integer iarg

Use(Stacks)

      call parkill(ss(1, rlinkp + iarg))

      return
      end
      
c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c PARTYPE - returns the typecode for the iarg'th entry on the runtime stack(i. e., the
c         - iarg'th parameter of the currently executing function).

      integer function partypea(iarg)
      integer iarg

Use(Stacks)

      return(ss(TC, rlinkp + iarg))
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c PARSAV - save scalar, create matrix entry

      subroutine parsav()

Use(Stacks)

      integer utsizeof
      Address paraddr
      external utsizeof,paraddr,smovftoa

      call parget(ss(1,rsp))
      call smovbtoa(paraddr(ss(1,rsp)), 0, ss(N1,rsp), 0,
     &              CHAR_PER_WORD * utsizeof(1,ss(TC,rsp)))

      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

