/*
 * bascwd.c - curent working directory routines
 *
 */

#include "rt.h"

#ifdef SUN4
#define getcwd(a,b) getwd(a)
char *getwd();
#endif
#if defined(YMP)|defined(C90)|defined(CRAY2)|defined(J90)
#define MAXPATHLEN 1024
#endif

/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/

void Kaboom();

/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/

/* Current working directory to q, allowing for automounter */

void BasCWD(char q[501])
{
    char *cp;
    char *getcwd();
    char name[MAXPATHLEN + 1];
    char errmsg[80];

    if ((cp = getcwd(name, MAXPATHLEN + 1)) == (char *) NULL) {
        sprintf(errmsg,
                "BasCWD could not get current directory! Error 1.");
        BasError(errmsg, strlen(errmsg));
        sprintf(errmsg, "%s", name);
        BasError(errmsg, strlen(errmsg));
        Kaboom(0);
    }
    if (strlen(cp) > strlen(q)) {
        sprintf(errmsg,
                "BasCWD current directory name too long for Fortran!");
        BasError(errmsg, strlen(errmsg));
        sprintf(errmsg, "%s", cp);
        BasError(errmsg, strlen(errmsg));
        Kaboom(0);
    }
    strcpy(q, cp);
}

/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/

#ifdef TEST
/* Typical compile line: "cc -o mycd -D$CPU -DTEST thisfile.c"  */
main(int a, char *b[])
{
    char c[MAXPATHLEN + 1];
    int j;

    for (j = 0; j < MAXPATHLEN + 1; j++) {
        c[j] = ' ';
    }
    c[MAXPATHLEN] = '\0';
    BasCWD(c);
    printf("%s\n", c);
    exit(0);
}

void Kaboom(int i)
{
    exit(1);
}
#endif

/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
