
c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c FUNCHK - check to make sure that a compiled call of a
c        - user function has integrity--the variable
c        - exists, is a function, has no parameters, etc.

      function funchk(name)
      external rtxdbf, baserror
      integer funchk, tc, minargs, maxargs, jvar, njvar
      integer npack
      integer ftyp
      character*(*) name
      integer ndb, rtfinder
      external rtfinder
      
      if (rtfinder(name,jvar,ndb, tc,"funchk/execuser") == OK) then
         if (tc == FUNCTION_TYPE) then
            call rtxdbf(jvar,ndb,ftyp,minargs,maxargs,npack,njvar)
            if ((minargs == 0) &(maxargs == 0) &(ftyp > 0)) then
               return(OK)
            else
               call baserror(
               "execuser: argument must be user function that has no arguments.")
            endif
         else
            call baserror(
            "execuser: attempt to call a non-function ")
         endif

      else
         call baserror(
         "execuser: name is not a user function, cannot be called.")
      endif

      call baserror(name)

      return(ERR)
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c PARCFCN - execute jump to compiled function
c         - if an argument is still an LHS, do a parfetch for it. This
c         - is so-called "lazy evaluation."
c         - nargs is number of arguments; iptf points into funparn
c         - iseg is segment number for passing to glbxpf
c
c    releasetype is a character string with one entry per argument, that tells
c    what to do with the argument after the function call. "0" means do nothing.
c    "1" means parkill the corresponding stack element. "2" means osfree the
c    variable itself, "3" means do both "1" and "2". "0" is used for default
c    numeric variables, which are permanent. "1" is used for actual arguments
c    that are numeric; they have been copied, and the address of the copy(which
c    is in the literal table) must be freed. "2" is used for character string
c    address arguments(generated by calls from the interpreter with the '&'
c   (reference) operator); space is allocated for the address of the string,
c    and must be freed, but the address of the string must be left alone, as
c    it is owned by the user. "2" is also used for the length of a string
c    argument, for which space is allocated. "3" is used when the string
c    argument does not have an '&' in front of it: that means it has been
c    copied, so the stack element which designates it must be parrel'ed;
c    and it means that space for that temporary address has been allocated, 
c    so that must be freed as well.
c   (done for STRING_ADDRESS types).

      integer function parcfcn(nargs, iptf,npkg,iseg)

Use(Stacks)
Use(Functions)	

      integer nargs, iptf, npkg 
      integer parcoerc, sorry, parlen, rtgndim
      Address paraddr, fcnmkch, pusharg, getaddr, pargeti, pargeta, strgaddr
      integer sx(SSWIDTH)  #stack element for answer
      integer argtype, j, jj, k, n, n1
      Address namptr
      integer ifwa
      integer iseg
      integer idummy
      integer flen, utgetcl, strgetcl
      external utgetcl, strgetcl
      external parcoerc, paraddr, sorry, fcnmkch, parlen, rtgndim, pusharg
      external getaddr, pargeti, pargeta, strgaddr
      character*(MAXALLARGS) releasetype
      integer lenrel # length of the above
      integer ivalueo, gfunpart
      Address n2
      Varname vname
      external smovbtoa, ivalueo, gfunpart
      
#  nargs = number of args supplied, is known to be correct
# collect arguments and make them the correct type
      cfcnargc = nargs  #remember argument count

# Now, in order to handle character arguments as a raw pointer plus a count,
# we need to count the number of character arguments and increase cfcnargc
# accordingly.
      jj = 1
      do j = 1, nargs
         k = rlinkp + j
         argtype = gfunpart(iptf + jj)
         if (ss(TC,k) == LHS) call parfetch(ss(1,k),nxp(k),lxp(k),COPY,FALSE)

         if (ss(TC,k) = NULL_TYPE) then
            if (argtype == STRING_ADDRESS)  then
# default character
               cfcnargc = cfcnargc + 1
               jj = jj + 1
            endif
         elseif (ss(TC,k) == FWA) then  #pass by address; if char, we need length
            if (ss(TCSAVE, k) < 0) then #it is a character variable
               cfcnargc = cfcnargc + 1
               jj = jj + 1
            endif
         elseif (argtype == STRING_ADDRESS)
            if (ss(TC, k) < 0) then # explicit character variable
               cfcnargc = cfcnargc + 1
               jj = jj + 1
            endif
         endif
         jj = jj + 1
      enddo

      lenrel = cfcnargc

# jj and j will be the same unless there are string arguments.
      jj = 1
      do j=1, nargs
         k = rlinkp + j
         argtype = gfunpart(iptf + jj)
         if (ss(TC,k) = NULL_TYPE) then
            releasetype(jj:jj) = "0"

            select argtype
               case INTEGER: cfcnarg(jj) = pusharg(0, defint)
               case REAL: cfcnarg(jj) = pusharg(0, defreal)
               case DOUBLE: cfcnarg(jj) = pusharg(0, defdbl)
ifelse(HAS_DOUBLE_COMPLEX,YES,[
               case COMPLEX: cfcnarg(jj) = pusharg(0, defcmp)
],[
               case COMPLEX,DOUBLE_C: cfcnarg(jj) = pusharg(0, defcmp)
])
ifelse(HAS_DOUBLE_COMPLEX,YES,[
               case DOUBLE_C: cfcnarg(jj) = pusharg(0, defdcmp)
])
               case LOGICAL: cfcnarg(jj) = pusharg(0, deflog)
               default: 
               if (argtype == STRING_ADDRESS) then
                  cfcnarg(jj)=pusharg(0,pargeta(defch))
                  releasetype(jj:jj) = "2"
                  jj = jj + 1
                  cfcnarg(jj)=pusharg(0,pargeti(1))
                  releasetype(jj:jj) = "2"
               else
                  call baserror(
                  "Defaulted argument to a compiled function must be a normal variable type.")
                  return(ERR)
               endif
            endselect
         
         elseif (ss(TC,k) = FUNCTION_TYPE) then
            if (argtype ~= FUNCTION_TYPE) then
               return(funcerr(iptf, j))
            endif
            
#  ss(N,.) = package number
#  ss(N2,.) = has to be <0 for compiled function
#  ss(PTR,.) = variable number
            namptr = rtgndim(ss(PTR,k),ss(N,k))
            ifwa   = ss(N2,k)   # = -iseg
            if (ifwa >= 0) idummy = sorry(
            "Passing non-compiled function as argument to a compiled function.")

########## Call to glbxpf below does not actually execute function #########
            fargnum = jj  #signal to parexecf that this is jj arg
            call gfunparn(namptr, vname)
            flen = utgetcl(vname)
            call glbxpf(ss(N,k), -ifwa, vname(1:flen))
            fargnum = 0
            releasetype(jj:jj) = "1"
            
# pass by address; check for char
         elseif (ss(TC,k) == FWA) then
            cfcnarg(jj) = pusharg(0, paraddr(ss(1,k)))
            if (ss(TCSAVE, k) < 0) then
               cfcnarg(jj) = pusharg(0, pargeta(paraddr(ss(1,k))))
               releasetype(jj:jj) = "2"
               jj = jj + 1
               cfcnarg(jj)=pusharg(0,pargeti(-ss(TCSAVE, k)))
               releasetype(jj:jj) = "2"
            else
               cfcnarg(jj) = pusharg(0, paraddr(ss(1,k)))
# It's a plain old FWA, so release it.
               releasetype(jj:jj) = "1"
            endif
            
         elseif (argtype == RANGE) then
            releasetype(jj:jj) = "1"
            if (ss(TC,k) == RANGE) then
               cfcnarg(jj) = pusharg(0, paraddr(ss(1,k)))
            elseif (parcoerc(ss(1,k),INTEGER) == ERR) then
               return(funcerr(iptf, j))
            else
               n = parlen(ss(1,k))
               if (n == 1) then
                  n2 = paraddr(ss(1,k))
                  n1 = ivalue(n2)
                  call parkill(ss(1,k))
                  ss(N,k) = 1
                  ss(N1,k) = 3
                  ss(M1,k) = 1
                  ss(I1,k) = 1
                  call parget(ss(1,k))
                  n2 = paraddr(ss(1,k))
                  call smovbtoa(n2, 0, n1, 0, CHAR_PER_WORD)
                  call smovbtoa \
                 (n2, CHAR_PER_WORD, n1, 0, CHAR_PER_WORD)
                  call smovbtoa \
                 (n2, 2 * CHAR_PER_WORD, 1, 0, CHAR_PER_WORD)
                  cfcnarg(jj) = pusharg(0, n2)
               elseif (n ==3) then
                  cfcnarg(jj) = pusharg(0, paraddr(ss(1,k)))
               else
                  return(funcerr(iptf, j))
               endif
            endif
            
# non-character type expected
         elseif (argtype > 0 & argtype <> STRING_ADDRESS) then 
            if (parcoerc(ss(1,k),argtype) == ERR) then
               return(funcerr(iptf, j))
            endif
            cfcnarg(jj) = pusharg(0, paraddr(ss(1,k)))
            releasetype(jj:jj) = "1"
            
# expecting characters
         else
            if (ss(TC,k) >= 0) then
               idummy = funcerr(iptf, j)
               call baserror("Character argument expected.")
               return(idummy)
            endif
            
# call fcnmkch to form character descriptor
#         cfcnarg(j) =  fcnmkch(-ss(TC,k),paraddr(ss(1,k)))
            cfcnarg(jj) = pusharg(0, pargeta(paraddr(ss(1,k))))
            releasetype(jj:jj) = "3"
            jj = jj + 1
            cfcnarg(jj)=pusharg(0,pargeti(-ss(TC, k)))
            releasetype(jj:jj) = "2"
         endif
         
         jj = jj + 1
      enddo j
      
# prepare for the answer
      cfcnres = gfunpart(iptf)
      sx(N) = 0
      sx(TC) = gfunpart(iptf)
      if (sx(TC) < 0) sx(NAML) = 1 # character variable is in literal table
      if (sx(TC) == NULL_TYPE) sx(TC) = INTEGER
      
      call parget(sx)
      
      cfcnarg(0) = paraddr(sx)
      
# execute the function call -- glbxpf calls pkgxpf which calls parexecf
      call gfunparn(iptf, vname)
      call glbxpf(npkg, iseg, vname)
      
      jj = 1
      do j = 1, nargs
         argtype = gfunpart(iptf+jj)
         k = rlinkp + j
         if (releasetype(jj:jj) == "1") then
            call parkill(ss(1,k))
         elseif (releasetype(jj:jj) == "2") then
            call osfreen(cfcnarg(jj),"cfcnarg(jj)")
         elseif (releasetype(jj:jj) == "3") then
            call osfreen(cfcnarg(jj),"cfcnarg(jj)")
            call parkill(ss(1,k))
         endif
         if (releasetype(jj:jj) <> "0" & argtype == STRING_ADDRESS) then
            jj = jj + 1
            if (releasetype(jj:jj) == "2") then
               call osfreen(cfcnarg(jj),"cfcnarg(jj)")
            endif
         endif
         jj = jj + 1
      enddo
      
      if (gfunpart(iptf) = NULL_TYPE) then
         call parrel(sx)
         sx(TC) = NULL_TYPE
      endif
      
      call parcopy(sx,ss(1,rlinkp-1))

      return(OK)
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c PAREXECF - Improve recursion and make parstr callable from
c          - anywhere. Saving of the result has been moved
c          - from the next lower level routines to this one
c          - because of changes in the way the environment is
c          - stored

        subroutine parexecf(handler, ihandler, f)
        integer ihandler
        Address fcnadr
        external fcnadr
        integer utsizeof
        external handler,f,utsizeof,smovbtoa

Use(Functions)

        integer ires
        real rres
        double precision dres
        complex cres

ifelse(HAS_DOUBLE_COMPLEX,YES,[
        double complex dcres
])
        character *(MAXSTRING) sres

#       local variables to save cfcnres and cfcnarg(0) for the results
#      (note that in the event a compiled funtion calls the parser
#       recursively, these values could be lost otherwise.)
#       Putting ares into common insures that it gets treated
#       as a 64 bit quantity by cft77.
# 2/27/93 Dubois
# Whoever put ares into common didn't read the comment above !
# Delay transfer to it until after function returns
        Address ipres2
        common / pxfcommn / ares
        integer restype

# check fargnum; if 0 this is a call; otherwise passing a function as an arg
        if (fargnum > 0) then
                cfcnarg(fargnum) = fcnadr(f)
ifelse(SYSTEM,LINUX,[
	        cfcnarg(cfcnargc+1) = 0
	        cfcnargc = cfcnargc + 1
])
                return
        endif
        restype = cfcnres

# Use smovftof rather than straight assignment to avoid a cft77
# optimization in which the upper 32 bits are ignored in dealing
# with integer pointers.
        call smovftof(ipres2, 0, cfcnarg(0), 0, BYTES_PER_ADDRESS)

        select cfcnres
           case NULL_TYPE:
                call handler(ihandler, f, ires, cfcnarg)
           case INTEGER,LOGICAL:
                call handler(ihandler, f, ires, cfcnarg)
                call smovbtoa(ipres2,0,ires,0,utsizeof(1,INTEGER)*CHAR_PER_WORD)
           case REAL:
                call handler(ihandler, f, rres, cfcnarg)
                call smovbtoa(ipres2,0,rres,0,utsizeof(1,REAL)*CHAR_PER_WORD)
           case DOUBLE:
                call handler(ihandler, f, dres, cfcnarg)
                call smovbtoa(ipres2,0,dres,0,utsizeof(1,DOUBLE)*CHAR_PER_WORD)
ifelse(HAS_DOUBLE_COMPLEX,YES,[
           case COMPLEX:
],[
           case COMPLEX, DOUBLE_C: # double complex is complex on crays
])
                call handler(ihandler, f, cres, cfcnarg)
                call smovbtoa(ipres2,0,cres,0,utsizeof(1,COMPLEX)*CHAR_PER_WORD)
ifelse(HAS_DOUBLE_COMPLEX,YES,[
           case DOUBLE_C: 
                call handler(ihandler, f, dcres, cfcnarg)
                call smovbtoa(ipres2,0,dcres,0,utsizeof(1,DOUBLE_C)*CHAR_PER_WORD)
])
           default:
                if (cfcnres >= 0) call baderr(
                                "parexecf: illegal value for cfcnres")
                call handler(ihandler, f, sres, cfcnarg)
                call smovbtoa(ipres2,0,sres,0,-restype)
        endselect

        cfcnres = restype

        return
        end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c PARUFCN - execute jump to user-defined function
c         - and do entry coding

      function parufcn(jvar,ndb, nargs, pcnext)

Use(Functions)
Use(Actions)
Use(Stacks)

      integer nargs, pcnext, parufcn
      Address  fwa, nname
      integer idummy
      integer sorry, rtgloc, strgfind, rtgrpe, strgfina,
      strgetcl, utgetcl
      external sorry, rtgloc, rtsloc, rtguinfo, strgfind,
      rtgrpe, strgfina, strgetcl, utgetcl, gfuparn2
      integer svari(SSWIDTH), svali(SSWIDTH)
      integer  i, ns, tc, len, idum
      Address anull, getic, getnb
      Varname vfname, vtname, tvfname
      Varname newgroup
      integer rtfcnfp
      external rtfcnfp, getic, setic, getnb, setnb, fstkpsh
      
#  nargs = number of args supplied
#  iptf = index into fcnparam
#  fwa = location of FCNENTER code in intcode
#  pcnext = return address for this call
      
      call rtguinfo(jvar,ndb,fwa,len,nname)
      
      call parnest(FUNCTION_TYPE)
      
      call gfuparn2(nname, 1, vfname)
      
      anull = NULL_TYPE
      call fstkpsh(rlinkp - 1, pcnext, 0, anull)
      call rtsloc(0)
      
# set pcnext for next instruction after entry
      pcnext = 2
      
### ARGUMENT COLLECTION
#  First create a group for the local stackframe
      newgroup = "Locals_"//vfname
      idum = rtgrpe(LOCALDB,newgroup)

#  Next collect arguments using fcnargb ; create svari,svara to describe
#  the formal parameter as being like the argument
      do iarg = 1, nargs  #already checked before entry to be correct

# for each argument create entry
# for NULL_TYPE arguments do nothing
# for FUNCTION arguments create the entry
# for variables, call rtbind to do the job
#  get the stack element describing the iarg'th argument
         call fcnargb(iarg, svali)
         select svali(TC)

# the function name got on the stack via parid(for if it had had
# arguments it would have gotten evaluated instead).
# parid sets various values in svali; see parid for details.
            case NULL_TYPE:
            case FUNCTION_TYPE:
                call gfuparn2(nname, iarg + 1, tvfname)
                if (rtfcnfp(tvfname,svali) = ERR) return(ERR)

# item passed by address;
            case FWA:
                 idummy = sorry(
                 "Passing argument by address to user-defined function.")

# create svari
            default:
                 call gfuparn2(nname, iarg + 1, vtname)
                 call rtbind(svari, vtname, vfname, svali)
         endselect
      enddo
      
# get new bases for code and tokens for called functions
# (this must be done at the last minute because old bases need to be used
#  for argument gathering)
      call setic(fwa)
      call setnb(nname)

      paruser = TRUE

      return(OK)
      end
      
c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c RTBIND - bind a variable an argument value

      subroutine rtbind(svari, vtname, vfname, svali)
      implicit none
      integer svari(SSWIDTH)
      Varname vtname, vfname
      integer svali(SSWIDTH)

      integer i, ns, tc

      integer rtnewvar, strgfind, utgetcl
      external rtnewvar, strgfind

      do i = 1, SSWIDTH
         svari(i) = 0
      enddo
      
      svari(TC)   = NAME
      svari(NAML) = utgetcl(vtname)
      svari(PTR)  = strgfind(vtname)
      svari(N)    = 0
      
c ... NAML > 0 signals names in string table
      ns = svali(N)
      tc = svali(TC)
      
      svari(NS) = ns
      do i = 1, ns
         svari(N1-1+i) = svali(M1-1+i)
         svari(M1-1+i) = svali(N1-1+i) + svali(M1-1+i) - 1
      enddo i
      
c ... create parameter and assign value
      if (rtnewvar(LOCALDB, tc, svari, svali) = 0) then
         call baserror("parufcn: argument error in call to "//vfname)
         call baserror("Parameter name is "//vtname)
         return
      endif

      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------
      
c PARXFCN - reduce production <rid> ::= reference <args> where the name
c         - has been looked up already and the information extracted from
c         - the database.  It is:
c         -   ftyp = 0 for builtin, positive for user defined,
c         -        = -segment number for user-compiled.
c         -   minargs, maxargs   = min and max permissible arguments
c         -   jvar = index of name in database
c         -   npack = package number to which the function belongs
c         - Additional argument pcnext is the return address in intcode; this
c         - routine may modify it.

      subroutine parxfcn(pcnext)
      character*OUTLINE errmsg

Use(Functions)
Use(Stacks)
Use(Controls)

      integer minargs,maxargs,pcnext
      integer ftyp, jvar
      integer nargs, npack, i
      integer n0
      integer sx(SSWIDTH)
      integer glbbfcn,parufcn,parcfcn,utgetcl, rtgndim, jextra, iptf
      external glbbfcn,parufcn,parcfcn,utgetcl,rtgvname, rtgndim, rtginame
      Varname fname
      integer ivalueo, gfunpart
      external ivalueo, gfunpart
      
# unpack the info
      npack   = ss(N,   rlinkp-1)
      minargs = ss(N1,  rlinkp-1)
      maxargs = ss(M1,  rlinkp-1)
      jvar    = ss(PTR, rlinkp-1)
      ftyp    = ss(N2,  rlinkp-1)

      call lrfdotr

# if called with rsp <= 0 just do error message
      if (rsp .le. 0) call parxferr(npack,ss(N2,rlinkp-1),jvar,ftyp)

      nargs = rsp - rlinkp
      
      if (jvar .gt. 0) then

# check correct number of arguments
# Don't check args for foreign variables!
# jextra counts extra integer arguments added for string arguments
# with calls for compiled functions.
         jextra = 0
         iptf = rtgndim(jvar, npack)
         if (ftyp .lt. 0) then
            do i = 1, maxargs
               if (gfunpart(iptf+i) .eq. STRING_ADDRESS) jextra = jextra + 1
            enddo
         endif

         if (nargs + jextra .lt. minargs .or. nargs + jextra .gt. maxargs) then
            call baserror("parxfcn: incorrect number of arguments.")
            write(errmsg,800) minargs-jextra,maxargs-jextra,nargs
            call baserror(errmsg)
 800        format(
            "Function takes between ",i3," and ",i3," arguments; ",i3," supplied.")
            call parxferr(npack,ss(N2,rlinkp-1),jvar,ftyp)
         endif
      endif

      if (tracefcn) then
         if (jvar .gt. 0) then
            if (npack .eq. LOCALDB .and. ss(N2,rlinkp-1) .le. 0) then
               call rtginame(jvar,npack, fname)
            elseif (npack .ne. 0) then
               call rtgvname(jvar,npack, fname)
            else # user function
               call rtgvname(jvar,USERDB, fname)
            endif
            call baserror(fname)
         elseif (jvar .eq. 0) then
            call baserror("parxfcn: called with unknown name.")
            call kaboom(0)
         elseif (jvar .lt. 0) then
            call baserror("File variable access routine.")
         endif
      endif

# depending on fwa, use different methods to invoke function
      if (ftyp .eq. 0) then

# builtin, call parbfcn ; pcnext not modified
         do i=1,SSWIDTH
            sx(i) = 0
         enddo
         sx(N)  = 0                  # default return value is nothing
         sx(TC) = NULL_TYPE

         if (jvar .gt. 0) then
            call rtgvname(jvar,npack,fname)
            i = utgetcl(fname)
            if (glbbfcn(npack, nargs, fname(1:i), sx) .eq. ERR) then
               call parxferr(npack,ss(N2,rlinkp-1),jvar,ftyp)
            endif

         elseif (jvar == 0) then
            call baserror("parxfcn: called with unknown name.")
            call kaboom(0)

         else
            sx(N) = -jvar             # this is now the original jvar value
            if (glbbfcn(npack, nargs, "file_access", sx) .eq. ERR) then
               call parxferr(npack,ss(N2,rlinkp-1),jvar,ftyp)
            endif
         endif

         call parcopy(sx, ss(1,rlinkp-1))

# must be called with full number of args; -- set missing ones to NULL_TYPE
      else
         if (nargs .lt. maxargs-jextra) then
            if (rsp+maxargs-nargs > SSLENGTH) then
               call baserror("Runtime stack overflow building stack frame...possible runaway recursion.")
               call kaboom(0)
            endif

            do i=nargs+1, maxargs
# push NULL_TYPEs on stack for omitted args
               ss(TC, rlinkp + i) = NULL_TYPE
               rsp = rsp + 1
            enddo
            nargs = maxargs-jextra
         endif

# user-defined, call parufcn; pcnext modified. Note change of calling sequence
         if (ftyp .gt. 0) then
            if (parufcn(jvar,npack,nargs,pcnext) .eq. ERR) then
               call parxferr(npack,ss(N2,rlinkp-1),jvar,ftyp)
            endif

# user-compiled, call parcfcn; pcnext not modified
# pcnext must be passed, however, to be saved on stack in event of nested calls
         else
            n0 = rtgndim(jvar,npack)
            if (parcfcn(nargs,n0,npack,-ftyp) .eq. ERR) then
               call parxferr(npack,ss(N2,rlinkp-1),jvar,ftyp)
            endif
         endif
      endif

      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c PARXFERR - Handle errors encountered in function calls.
c          - This is also called from asgn.m in preference to
c          - calling parxfcn with a bad argument; and also it
c          - prevents having to use a stack element or stack pointer
c          - as an argument to parxfcn.

        subroutine parxferr(npack, n2, jvar, ftyp)
        integer npack, n2, jvar, ftyp
        Varname fname

        external rtginame, rtgvname

        if (npack = LOCALDB & n2 <= 0) then
           call rtginame(jvar,npack, fname)
        elseif (npack ~= 0) then
           call rtgvname(jvar,npack,fname)
        else # user function
           call rtgvname(jvar,USERDB,fname)
        endif

        if (ftyp <= 0) then
            if (jvar >= 0) then
                call baserror("Error in calling "//fname)
            else
                call baserror("Error in file variable access routine.")
            endif
        else
                call baserror("Error in calling "//fname)
        endif

        call kaboom(1)
        end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

