/*
 * CFCN.H
 *
 */

#ifndef HDR_CFCN
#define HDR_CFCN

#include "rt.h"

#undef ABS

/*--------------------------------------------------------------------------*/

/*                                   MACROS                                 */

/*--------------------------------------------------------------------------*/

#define MAX_INFO_ITEMS    3

#define	C_TO_DC(_d, _c)                                                      \
    {complex _cc;                                                            \
     _cc  = _c;                                                              \
     _d.r = _cc.r;                                                           \
     _d.i = _cc.i;}

#define	DC_TO_C(_c, _d)                                                      \
    {complex _cc;                                                            \
     _cc.r = _d.r;                                                           \
     _cc.i = _d.i;                                                           \
     _c    = _cc;}

#define GET_FCODE(_f)                                                        \
   (((_f)->info == NULL) ?                                                   \
    -1 :                                                                     \
    ((_f)->info[0] == NULL) ? -1 : *(Integer *) (_f)->info[0])


#define SIGNF(_x, _y)     ((_y < 0.0) ? -fabs(_x) : fabs(_x))
#define SIGNI(_x, _y)     ((_y < 0.0) ?  -abs(_x) :  abs(_x))

#define bassubl(i,j) bassubs[SSWIDTH *(j - 1) + i - 1]

/*--------------------------------------------------------------------------*/

/*                          TYPEDEFS and STRUCTS                            */

/*--------------------------------------------------------------------------*/

typedef struct s_scomplex scomplex;
typedef struct s_dcomplex dcomplex;
typedef struct s_f_entry f_entry;

typedef Integer (*PFHand)(Integer *sxi, f_entry *thisf,
			  Integer nargs, Integer *syi);

struct s_scomplex
   {float r;
    float i;};

struct s_dcomplex
   {double r;
    double i;};

struct s_f_entry
   {char *fname;  		/* Actual name of the function  */
    Integer arg1typ;	        /* Allowable types for arg 1    */
    PFHand handler;
    Integer ni;
    void **info;};


/*--------------------------------------------------------------------------*/

/*                          VARIABLE DECLARATIONS                           */

/*--------------------------------------------------------------------------*/

extern logical
 false;

extern Integer
 copy,
 nodata,
 actual,
 myrng,
 myint,
 myreal,
 mydble,
 mycmplx,
 mydcmplx,
 two,
 nine,
 ATAN2,
 BASNXTSQ,
 INF,
 MAX,
 MIN,
 MNX,
 MXX,
 PSUM,
 RNGINC,
 RSUM,
 STRLEN,
 SUP,
 TOLOWER,
 TOUPPER,
 TRIM,
 TRIML,
 TRIMR;

/*--------------------------------------------------------------------------*/

/*                          FUNCTION DECLARATIONS                           */

/*--------------------------------------------------------------------------*/

/* Externals */

extern Address
 Paraddr(Integer *),
 Pargeti(Integer n);

extern void
 Parrel(Integer *s),
 Parget(Integer *s),
 Utcodstr(Integer icode, char *utcod),
 Parkill(Integer *s),
 Kaboom(Integer i),
 Rtxdb(Integer jvar, Integer ndb, Address *fwa, Integer *ndim,
       Integer *ilow, Integer *ihi, Integer *icol, Integer access),
 Rtstgdel(Integer jvar, Integer ndb),
 Parnams(Integer *si, char *parnam, Integer *nc),
 SBlkSet(char *target, integer offset, integer length),
 Osfreen(Address *ptr, char *name);

extern Integer
 I1mach(Integer *i),
 StrIndex(char *str1, integer offset1, integer len1,
	  char *str2, integer offset2, integer len2),
 Rtfinder(char *name, Integer *jvar, Integer *ndb,
	  Integer *tc, char *complain),
 Parname(Integer *si, char *parnam),
 Rtgetvar(char *vname, Address *fwa, Integer *tc,
	  Integer *ndim, Integer *nlow, Integer *nhi),
 Parlen(Integer *s),
 Struadd(Integer *sstru, Integer *s, Integer strcod);

extern float
 R1mach(Integer *i);

extern real8
 D1mach(Integer *i);


/* CFCN.C declarations */

extern f_entry
 *Parlookup_fcn(char *fname);

extern void
 Parclear_fcn_tab(void),
 Parinstall_fcn(char *fname, PFHand hand, Integer atyp, Integer ni, ...),
 Fcnarga(Integer iarg, Integer *s),
 Fcnargb(Integer iarg, Integer *s),
 Fcnargbp(Integer iarg, Integer *s),
 Fcnargs(Integer iarg, char *nx, Integer *lx),
 Fcnargd(Integer n, Integer iarg, Integer *sdi, char *name);

extern float
 Rvecmin(float *rarray, Integer ifirst, Integer ilast),
 Rvecmax(float *rarray, Integer ifirst, Integer ilast);

extern real8
 Dvecmin(real8 *darray, Integer ifirst, Integer ilast),
 Dvecmax(real8 *darray, Integer ifirst, Integer ilast);

extern Integer
 Par2get(char *fname, Integer *syi, Integer nargs,
	 Integer *dim, Integer *sxi, Integer *dimlens, Integer *dimstride),
 Ivecmin(Integer *iarray, Integer ifirst, Integer ilast),
 Ivecmax(Integer *iarray, Integer ifirst, Integer ilast);


/* CFCN1.C declarations */

extern Integer
 Catan2(Integer *sxi, f_entry *thisf,
	Integer nargs, Integer *syi),
 Cdcmplx(Integer *sxi, f_entry *thisf,
	 Integer nargs, Integer *syi),
 Ccmplx(Integer *sxi, f_entry *thisf,
	Integer nargs, Integer *syi),
 Cwhere(Integer *sxi, f_entry *thisf,
	Integer nargs, Integer *syi);


/* CFCN2.C declarations */

extern Integer
 Cnint(Integer *sxi, f_entry *thisf,
       Integer nargs, Integer *syi),
 Csign(Integer *sxi, f_entry *thisf,
       Integer nargs, Integer *syi),
 Cformat(Integer *sxi, f_entry *thisf,
	 Integer nargs, Integer *syi),
 Cmnxmxx(Integer *sxi, f_entry *thisf,
	 Integer nargs, Integer *syi);


/* CFCN3.C declarations */

extern Integer
 Cdiag(Integer *sxi, f_entry *thisf,
       Integer nargs, Integer *syi),
 Cpsumrsum(Integer *sxi, f_entry *thisf,
	   Integer nargs, Integer *syi),
 Cptp(Integer *sxi, f_entry *thisf,
      Integer nargs, Integer *syi),
 Crngend(Integer *sxi, f_entry *thisf,
	 Integer nargs, Integer *syi);


/* CFCN4.C declarations */

extern Integer
 Crnginc(Integer *sxi, f_entry *thisf,
	 Integer nargs, Integer *syi),
 Ctolowerupper(Integer *sxi, f_entry *thisf,
	       Integer nargs, Integer *syi),
 Cstrchpat(Integer *sxi, f_entry *thisf,
	   Integer nargs, Integer *syi),
 Csubstr(Integer *sxi, f_entry *thisf,
	 Integer nargs, Integer *syi),
 Cones(Integer *sxi, f_entry *thisf,
       Integer nargs, Integer *syi),
 Cmod(Integer *sxi, f_entry *thisf,
      Integer nargs, Integer *syi),
 Cland(Integer *sxi, f_entry *thisf,
       Integer nargs, Integer *syi),
 Ctrim(Integer *sxi, f_entry *thisf,
       Integer nargs, Integer *syi),
 Crangex(Integer *sxi, f_entry *thisf,
	 Integer nargs, Integer *syi),
 Crngbeg(Integer *sxi, f_entry *thisf,
	 Integer nargs, Integer *syi),
 Ctrueshape(Integer *sxi, f_entry *thisf,
	    Integer nargs, Integer *syi);


/* CFCN5.C declarations */

extern Integer
 Csum(Integer *sxi, f_entry *thisf,
      Integer nargs, Integer *syi),
 Cave(Integer *sxi, f_entry *thisf,
      Integer nargs, Integer *syi),
 Cinfsup(Integer *sxi, f_entry *thisf,
	 Integer nargs, Integer *syi),
 Clor(Integer *sxi, f_entry *thisf,
      Integer nargs, Integer *syi);


/* CFCN6.C declarations */

extern Integer
 Cshape(Integer *sxi, f_entry *thisf,
	Integer nargs, Integer *syi),
 Caimag(Integer *sxi, f_entry *thisf,
	Integer nargs, Integer *syi),
 Cspanl(Integer *sxi, f_entry *thisf,
	Integer nargs, Integer *syi),
 Cload(Integer *sxi, f_entry *thisf,
       Integer nargs, Integer *syi);


/* CFCN7.C declarations */

extern void
 Parstru0(Integer *sarg);

extern Integer
 Ccross(Integer *sxi, f_entry *thisf,
	Integer nargs, Integer *syi),
 Ctruerange(Integer *sxi, f_entry *thisf,
	    Integer nargs, Integer *syi),
 Czcen(Integer *sxi, f_entry *thisf,
       Integer nargs, Integer *syi),
 Cfloat(Integer *sxi, f_entry *thisf,
	Integer nargs, Integer *syi),
 Cichar(Integer *sxi, f_entry *thisf,
	Integer nargs, Integer *syi),
 Crmsdv(Integer *sxi, f_entry *thisf,
	Integer nargs, Integer *syi);


/* CFCN8.C declarations */

extern Integer
 Cvminvmax(Integer *sxi, f_entry *thisf,
	   Integer nargs, Integer *syi),
 Cbasnxtsq(Integer *sxi, f_entry *thisf,
	   Integer nargs, Integer *syi),
 Cbasloc(Integer *sxi, f_entry *thisf,
	 Integer nargs, Integer *syi),
 Cchar(Integer *sxi, f_entry *thisf,
       Integer nargs, Integer *syi),
 Ccumaddin(Integer *sxi, f_entry *thisf,
	   Integer nargs, Integer *syi),
 Cconjg(Integer *sxi, f_entry *thisf,
	Integer nargs, Integer *syi),
 Ciota(Integer *sxi, f_entry *thisf,
       Integer nargs, Integer *syi);


/* CFCN9.C declarations */

extern Integer
 Couter(Integer *sxi, f_entry *thisf,
	Integer nargs, Integer *syi),
 Cgather(Integer *sxi, f_entry *thisf,
	 Integer nargs, Integer *syi),
 Crngsetdf(Integer *sxi, f_entry *thisf,
	   Integer nargs, Integer *syi),
 Cindex(Integer *sxi, f_entry *thisf,
	 Integer nargs, Integer *syi),
 Csort(Integer *sxi, f_entry *thisf,
       Integer nargs, Integer *syi);


/* CFCN10.C declarations */

extern Integer
 Clegendre(Integer *sxi, f_entry *thisf,
	   Integer nargs, Integer *syi),
 Cbtest(Integer *sxi, f_entry *thisf,
	Integer nargs, Integer *syi),
 Cibset(Integer *sxi, f_entry *thisf,
	Integer nargs, Integer *syi),
 Cibclr(Integer *sxi, f_entry *thisf,
	Integer nargs, Integer *syi),
 Cishft(Integer *sxi, f_entry *thisf,
	Integer nargs, Integer *syi),
 Cishftc(Integer *sxi, f_entry *thisf,
	 Integer nargs, Integer *syi),
 Cibits(Integer *sxi, f_entry *thisf,
	Integer nargs, Integer *syi),
 Ciand(Integer *sxi, f_entry *thisf,
       Integer nargs, Integer *syi),
 Cior(Integer *sxi, f_entry *thisf,
      Integer nargs, Integer *syi),
 Cieor(Integer *sxi, f_entry *thisf,
       Integer nargs, Integer *syi),
 Cunot(Integer *sxi, f_entry *thisf,
       Integer nargs, Integer *syi);


/* CFCN11.C declarations */

extern Integer
 Cminmaxb(Integer *sxi, f_entry *thisf,
	  Integer nargs, Integer *syi),
 Ctype(Integer *sxi, f_entry *thisf,
       Integer nargs, Integer *syi),
 Cutype(Integer *sxi, f_entry *thisf,
	Integer nargs, Integer *syi),
 Cfromone(Integer *sxi, f_entry *thisf,
	  Integer nargs, Integer *syi),
 Cchecksum(Integer *sxi, f_entry *thisf,
	   Integer nargs, Integer *syi),
 Clength(Integer *sxi, f_entry *thisf,
	 Integer nargs, Integer *syi),
 Cstrlen(Integer *sxi, f_entry *thisf,
	 Integer nargs, Integer *syi),
 Csqueeze(Integer *sxi, f_entry *thisf,
	  Integer nargs, Integer *syi),
 Cdble(Integer *sxi, f_entry *thisf,
       Integer nargs, Integer *syi),
 Ctranspose(Integer *sxi, f_entry *thisf,
	    Integer nargs, Integer *syi),
 Cstruct(Integer *sxi, f_entry *thisf,
	 Integer nargs, Integer *syi),
 Ciint(Integer *sxi, f_entry *thisf,
       Integer nargs, Integer *syi),
 Csngl(Integer *sxi, f_entry *thisf,
       Integer nargs, Integer *syi),
 Cflist(Integer *sxi, f_entry *thisf,
	Integer nargs, Integer *syi);


/* FFCN.M declarations */

extern double
 Ranf(void);


/* HAND.C declarations */

extern Integer
 Par_zarg(Integer *sxi, f_entry *thisf,
	  Integer nargs, Integer *syi),
 Par_sarg(Integer *sxi, f_entry *thisf,
	  Integer nargs, Integer *syi),
 Par_srarg(Integer *sxi, f_entry *thisf,
	   Integer nargs, Integer *syi);


/* MATHF.C declarations */

extern double
 masqrt(double x),
 malog(double x),
 malog10(double x),
 macot(double x),
 macoth(double x),
 maacos(double x),
 maasin(double x),
 maaint(double x),
 maanint(double x),
 masign(double x, double y);

extern void
 madcranf(dcomplex *c, int n),
 madcabs(double *r, dcomplex *c, int n),
 madcaint(double *r, dcomplex *c, int n),
 madcanint(double *r, dcomplex *c, int n),
 madcexp(dcomplex *r, dcomplex *c, int n),
 madclog(dcomplex *r, dcomplex *c, int n),
 madclog10(dcomplex *r, dcomplex *c, int n),
 madcsqrt(dcomplex *r, dcomplex *c, int n),
 madcsin(dcomplex *r, dcomplex *c, int n),
 madccos(dcomplex *r, dcomplex *c, int n),
 madctan(dcomplex *r, dcomplex *c, int n),
 madccot(dcomplex *r, dcomplex *c, int n),
 madcsinh(dcomplex *r, dcomplex *c, int n),
 madccosh(dcomplex *r, dcomplex *c, int n),
 madctanh(dcomplex *r, dcomplex *c, int n),
 madccoth(dcomplex *r, dcomplex *c, int n),
 madcasin(dcomplex *r, dcomplex *c, int n),
 madcacos(dcomplex *r, dcomplex *c, int n),
 madcatan(dcomplex *r, dcomplex *c, int n);

#endif
