/*
 * CFCN8.C
 *
 */

#include "cfcn.h"

/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/

/* CVMINVMAX - handler for vmin and vmax builtins */

Integer Cvminvmax(Integer *sxi, f_entry *thisf, Integer nargs,
                  Integer *syi)
{
    Integer fcode, npoints, *ix, *iy, dim, dimstride[8], dimlens[7];
    float *rx, *ry;
    real8 *dx, *dy;
    int i, j, newindx, offset, izindx;
    char *fname;

    fname = thisf->fname;
    fcode = GET_FCODE(thisf);

    npoints = Par2get(fname, syi, nargs, &dim, sxi, dimlens, dimstride);
    if (npoints == 0 && nargs == 1) {
        sxi[N - 1] = 0;
        sxi[TC - 1] = syi[TC - 1];
        Parget(sxi);
        if (syi[TC - 1] == INTEGER) {
            ix = (Integer *) Paraddr(sxi);
            ix[0] = fcode == MAX ? I1mach(&nine) + 1 : I1mach(&nine);
        } else if (syi[TC - 1] == REAL) {
            rx = (float *) Paraddr(sxi);
            rx[0] = fcode == MAX ? -R1mach(&two) : R1mach(&two);
        } else if (syi[TC - 1] == DOUBLE) {
            dx = (real8 *) Paraddr(sxi);
            dx[0] = fcode == MAX ? -D1mach(&two) : D1mach(&two);
        }
        Parrel(syi);
        return OK;
    } else if (npoints == 0) {
        Parrel(syi);
        return OK;
    }
    if (syi[TC - 1] == INTEGER) {
        ix = (Integer *) Paraddr(sxi);
        iy = (Integer *) Paraddr(syi);
        if (nargs == 1) {
            ix[0] = iy[0];
            if (fcode == MAX) {
                for (i = 1; i < npoints; i++)
                    if (iy[i] > ix[0])
                        ix[0] = iy[i];
            } else {
                for (i = 1; i < npoints; i++)
                    if (iy[i] < ix[0])
                        ix[0] = iy[i];
            }
        } else {
            newindx = 0;
            if (fcode == MAX) {
                for (offset = 0; offset < dimstride[syi[N - 1]];
                     offset += dimstride[dim])
                    for (i = 0; i < dimstride[dim - 1]; i++) {
                        izindx = i + offset;
                        ix[newindx] = iy[izindx];
                        for (j = 1; j < dimlens[dim - 1]; j++) {
                            izindx += dimstride[dim - 1];
                            if (iy[izindx] > ix[newindx])
                                ix[newindx] = iy[izindx];
                        }
                        newindx += 1;
                    }
            } else {
                for (offset = 0; offset < dimstride[syi[N - 1]];
                     offset += dimstride[dim])
                    for (i = 0; i < dimstride[dim - 1]; i++) {
                        izindx = i + offset;
                        ix[newindx] = iy[izindx];
                        for (j = 1; j < dimlens[dim - 1]; j++) {
                            izindx += dimstride[dim - 1];
                            if (iy[izindx] < ix[newindx])
                                ix[newindx] = iy[izindx];
                        }
                        newindx += 1;
                    }
            }
        }
    } else if (syi[TC - 1] == REAL) {
        rx = (float *) Paraddr(sxi);
        ry = (float *) Paraddr(syi);
        if (nargs == 1) {
            rx[0] = ry[0];
            if (fcode == MAX) {
                for (i = 1; i < npoints; i++)
                    if (ry[i] > rx[0])
                        rx[0] = ry[i];
            } else {
                for (i = 1; i < npoints; i++)
                    if (ry[i] < rx[0])
                        rx[0] = ry[i];
            }
        } else {
            newindx = 0;
            if (fcode == MAX) {
                for (offset = 0; offset < dimstride[syi[N - 1]];
                     offset += dimstride[dim])
                    for (i = 0; i < dimstride[dim - 1]; i++) {
                        izindx = i + offset;
                        rx[newindx] = ry[izindx];
                        for (j = 1; j < dimlens[dim - 1]; j++) {
                            izindx += dimstride[dim - 1];
                            if (ry[izindx] > rx[newindx])
                                rx[newindx] = ry[izindx];
                        }
                        newindx += 1;
                    }
            } else {
                for (offset = 0; offset < dimstride[syi[N - 1]];
                     offset += dimstride[dim])
                    for (i = 0; i < dimstride[dim - 1]; i++) {
                        izindx = i + offset;
                        rx[newindx] = ry[izindx];
                        for (j = 1; j < dimlens[dim - 1]; j++) {
                            izindx += dimstride[dim - 1];
                            if (ry[izindx] < rx[newindx])
                                rx[newindx] = ry[izindx];
                        }
                        newindx += 1;
                    }
            }
        }
    } else if (syi[TC - 1] == DOUBLE) {
        dx = (real8 *) Paraddr(sxi);
        dy = (real8 *) Paraddr(syi);
        if (nargs == 1) {
            dx[0] = dy[0];
            if (fcode == MAX) {
                for (i = 1; i < npoints; i++)
                    if (dy[i] > dx[0])
                        dx[0] = dy[i];
            } else {
                for (i = 1; i < npoints; i++)
                    if (dy[i] < dx[0])
                        dx[0] = dy[i];
            }
        } else {
            newindx = 0;
            if (fcode == MAX) {
                for (offset = 0; offset < dimstride[syi[N - 1]];
                     offset += dimstride[dim])
                    for (i = 0; i < dimstride[dim - 1]; i++) {
                        izindx = i + offset;
                        dx[newindx] = dy[izindx];
                        for (j = 1; j < dimlens[dim - 1]; j++) {
                            izindx += dimstride[dim - 1];
                            if (dy[izindx] > dx[newindx])
                                dx[newindx] = dy[izindx];
                        }
                        newindx += 1;
                    }
            } else {
                for (offset = 0; offset < dimstride[syi[N - 1]];
                     offset += dimstride[dim])
                    for (i = 0; i < dimstride[dim - 1]; i++) {
                        izindx = i + offset;
                        dx[newindx] = dy[izindx];
                        for (j = 1; j < dimlens[dim - 1]; j++) {
                            izindx += dimstride[dim - 1];
                            if (dy[izindx] < dx[newindx])
                                dx[newindx] = dy[izindx];
                        }
                        newindx += 1;
                    }
            }
        }
    }
    Parrel(syi);
    return OK;
}

/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/

/* CBASNXTSQ - handler for the basnxtsq builtin */

Integer Cbasnxtsq(Integer *sxi, f_entry *thisf, Integer nargs,
                  Integer *syi)
{
    Integer nc;
    char f[FILENAMESIZE + 1];
    char *fd;

    INIT_BLANK_STRING(f, FILENAMESIZE + 1);

    nc = Parname(syi, f);
    Parkill(syi);
    memset((void *) (f + nc), (int) ' ', FILENAMESIZE - nc);
    f[FILENAMESIZE] = '\0';

    Basnxtsq(f, f, FILENAMESIZE, FILENAMESIZE);

    nc = strcspn(f, " ");
    sxi[TC - 1] = -nc;
    sxi[N - 1] = 0;

/* so it knows address is in literal table.(ZCM 4/10/95): */
    sxi[NAML - 1] = 1;
    Parget(sxi);
    fd = (char *) Paraddr(sxi);

    strncpy(fd, f, nc);

    return OK;
}

/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/

/* CBASLOC - handler for basloc builtin */

Integer Cbasloc(Integer *sxi, f_entry *thisf, Integer nargs, Integer *syi)
{
    Address *ax;
    char vname[VARNAMESIZE + 1];
    Integer j;
    Integer nc;

    Fcnargbp(1, syi);
    sxi[TC - 1] = FWA;
    sxi[N - 1] = 0;
    Parget(sxi);
    ax = (Address *) Paraddr(sxi);

    INIT_BLANK_STRING(vname, VARNAMESIZE);

    if (syi[TC - 1] < 0) {      /* string argument */
        Parnams(syi, vname, &j);        /* get name */
        *ax = Basloc(vname, j);
    } else {                    /* some other type; just get address */
        nc = Parname(syi, vname);
        *ax = Basloc(vname, nc);
    }
    return OK;
}

/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/

/* CCHAR - handler for the char builtin */

Integer Cchar(Integer *sxi, f_entry *thisf, Integer nargs, Integer *syi)
{
    Integer *ix, npoints;
    char *chx, errmsg[MAXOUT];
    int i;

    ix = (Integer *) Paraddr(syi);
    npoints = Parlen(syi);
    Parcopy(syi, sxi);
    sxi[TC - 1] = -1;
    /* forces string to be in literal table: */
    sxi[NAML - 1] = 1;
    Parget(sxi);
    chx = (char *) Paraddr(sxi);
    for (i = 0; i < npoints; i++)
        if (ix[i] < 0 || ix[i] > 255) {
            sprintf(errmsg,
                    "char: element number %d (value %ld) is not between 0 and 255.",
                    i + 1, (long) ix[i]);
            BasError(errmsg, strlen(errmsg));
            return ERR;
        } else
            chx[i] = (char) ix[i];
    Parrel(syi);
    return OK;
}

/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/

/* CCUMADDIN - handler for cumaddin builtin */

Integer Ccumaddin(Integer *sxi, f_entry *thisf, Integer nargs,
                  Integer *syi)
{
    Integer szi[SSWIDTH], *ix, *iy, *iz, leny, lenz, ilow, ihi, tc;
    int iincr, i, j, free_iz;
    float *rx, *ry, *cx, *cy;
    real8 *dx, *dy, *dcx, *dcy;
    static char
        errmsg1[] = "cumaddin: first argument must have 1d array subscript.",
        errmsg2[] = "          use += for all other types.",
        errmsg3[] = "cumaddin: source argument is wrong type.",
        errmsg4[] = "cumaddin: source and destination have different lengths.",
        errmsg5[] = "cumaddin: Subscript out of range.";

    free_iz = 0;
    if (syi[N1 - 1] != DEFAULT + 1 &&
        (syi[NS - 1] != 1 || syi[N1 - 1] != syi[M1 - 1])) {
        BasError(errmsg1, strlen(errmsg1));
        BasError(errmsg2, strlen(errmsg2));
        return ERR;
    }
    Fcnargb(2, szi);
    tc = syi[TCSAVE - 1];
    if (Parcoerc(szi, &tc) == ERR) {
        BasError(errmsg3, strlen(errmsg3));
        return ERR;
    }
    leny = Parlen(szi);
    if (syi[NS - 1] == 1 && syi[N1 - 1] != DEFAULT + 1 && leny != 1) {
        BasError(errmsg4, strlen(errmsg4));
        return ERR;
    } else if (syi[N1 - 1] != DEFAULT + 1 && syi[NS - 1] == 1 && leny == 1) {
        /* scalar subscript and scalar value */
        iz = (Integer *) Pargeti(syi[N1 - 1]);
        lenz = 1;
        ilow = iz[0];
        ihi = iz[0];
        free_iz = 1;
    } else {
        /* general case */
        iz = (Integer *) Paraddr(&(bassubl(1, syi[M1 - 1])));
        leny = Parlen(szi);
        lenz = bassubl(N1, syi[M1 - 1]);
        if (leny == 1) {
            iincr = 0;          /* scalar broadcast */
        } else {                /* better be same size: */
            if (leny != lenz) {
                BasError(errmsg4, strlen(errmsg4));
                return ERR;
            }
            iincr = 1;
        }
        ilow = bassubl(N1 + 2, syi[M1 - 1]);
        ihi = bassubl(N1 + 3, syi[M1 - 1]);
    }
    j = 0;
    switch (tc) {
    case INTEGER:
        ix = (Integer *) Paraddr(syi);
        iy = (Integer *) Paraddr(szi);
        for (i = 0; i < lenz; i++) {
            if (iz[i] > ihi || iz[i] < ilow) {
                BasError(errmsg5, strlen(errmsg5));
                return ERR;
            }
            ix[iz[i] - ilow] += iy[j];
            j += iincr;
        }
        break;
    case REAL:
        rx = (float *) Paraddr(syi);
        ry = (float *) Paraddr(szi);
        for (i = 0; i < lenz; i++) {
            if (iz[i] > ihi || iz[i] < ilow) {
                BasError(errmsg5, strlen(errmsg5));
                return ERR;
            }
            rx[iz[i] - ilow] += ry[j];
            j += iincr;
        }
        break;
    case DOUBLE:
        dx = (real8 *) Paraddr(syi);
        dy = (real8 *) Paraddr(szi);
        for (i = 0; i < lenz; i++) {
            if (iz[i] > ihi || iz[i] < ilow) {
                BasError(errmsg5, strlen(errmsg5));
                return ERR;
            }
            dx[iz[i] - ilow] += dy[j];
            j += iincr;
        }
        break;
    case COMPLEX:
#   ifndef HAS_DOUBLE_COMPLEX
    case DOUBLE_C:
#   endif
        cx = (float *) Paraddr(syi);
        cy = (float *) Paraddr(szi);
        for (i = 0; i < lenz; i++) {
            if (iz[i] > ihi || iz[i] < ilow) {
                BasError(errmsg5, strlen(errmsg5));
                return ERR;
            }
            cx[2 * (iz[i] - ilow)] += cy[2 * j];
            cx[2 * (iz[i] - ilow) + 1] += cy[2 * j + 1];
            j += iincr;
        }
        break;
#   ifdef HAS_DOUBLE_COMPLEX
    case DOUBLE_C:
        dcx = (real8 *) Paraddr(syi);
        dcy = (real8 *) Paraddr(szi);
        for (i = 0; i < lenz; i++) {
            if (iz[i] > ihi || iz[i] < ilow) {
                BasError(errmsg5, strlen(errmsg5));
                return ERR;
            }
            dcx[2 * (iz[i] - ilow)] += dcy[2 * j];
            dcx[2 * (iz[i] - ilow) + 1] += dcy[2 * j + 1];
            j += iincr;
        }
        break;
#   endif
    }
    if (syi[NS - 1] == 1 && leny == 1)
        Osfreen((Address *) &iz, "CCUMADDIN:iz");
    else {
        Parrel(&(bassubl(1, syi[M1 - 1])));
        bassubl(TC, syi[M1 - 1]) = NULL_TYPE;
        bassubl(N1 + 1, syi[M1 - 1]) = 0;
    }
    Parrel(syi);
    Parrel(szi);
    if (free_iz == 1)
        Osfreen((Address *) &iz, "CCUMADDIN:iz");
    return OK;
}

/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/

/* CCONJG - handler for the conjg builtin */

Integer Cconjg(Integer *sxi, f_entry *thisf, Integer nargs, Integer *syi)
{
    float *cx;
    real8 *dx;
    Integer npoints;
    int i;

#ifdef HAS_DOUBLE_COMPLEX
    if (syi[TC - 1] == COMPLEX) {
#else
    if (syi[TC - 1] == COMPLEX || syi[TC - 1] == DOUBLE_C) {
#endif
        npoints = Parlen(syi);
        cx = (float *) Paraddr(syi);
        for (i = 0; i < npoints; i++) {
            cx[2 * i + 1] = -cx[2 * i + 1];
        }
    }
#ifdef HAS_DOUBLE_COMPLEX
    else if (syi[TC - 1] == DOUBLE_C) {
        npoints = Parlen(syi);
        dx = (real8 *) Paraddr(syi);
        for (i = 0; i < npoints; i++) {
            dx[2 * i + 1] = -dx[2 * i + 1];
        }
    }
#endif
    Parcopy(syi, sxi);
    return OK;
}

/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/

/* CIOTA - handler for the iota builtin */

Integer Ciota(Integer *sxi, f_entry *thisf, Integer nargs, Integer *syi)
{
    Integer *ix, ilow, ihi, istr;
    int i;
    static char errmsg1[] = "iota: illegal argument type.",
        errmsg2[] = "iota: illegal argument, must be > 0.",
        errmsg3[] = "iota: bad second argument.",
        errmsg4[] = "iota: bad third argument.";

    if (syi[TC - 1] == RANGE && nargs == 1) {
        ix = (Integer *) Paraddr(syi);
        ilow = ix[0];
        ihi = ix[1];
        istr = ix[2];
        Parrel(syi);
    } else {
        if (Parcoerc(syi, &myint) == ERR) {
            BasError(errmsg1, strlen(errmsg1));
            return ERR;
        }
        ix = (Integer *) Paraddr(syi);
        ihi = ix[0];
        Parrel(syi);
        if (nargs == 1) {
            if (ihi <= 0) {
                BasError(errmsg2, strlen(errmsg2));
                return ERR;
            }
            ilow = 1;
        } else if (nargs >= 2) {
            Fcnargb(2, syi);
            if (Parcoerc(syi, &myint) == ERR) {
                BasError(errmsg3, strlen(errmsg3));
                return ERR;
            }
            ix = (Integer *) Paraddr(syi);
            ilow = ihi;
            ihi = ix[0];
            Parrel(syi);
        }
        if (nargs == 3) {
            Fcnargb(3, syi);
            if (Parcoerc(syi, &myint) == ERR) {
                BasError(errmsg4, strlen(errmsg4));
                return ERR;
            }
            ix = (Integer *) Paraddr(syi);
            istr = max(ix[0], 1);
            Parrel(syi);
        } else
            istr = 1;
    }
    sxi[N1 - 1] = abs((ihi - ilow) / istr) + 1;
    sxi[TC - 1] = INTEGER;
    sxi[N - 1] = 1;
    sxi[I1 - 1] = istr;
    Parget(sxi);
    ix = (Integer *) Paraddr(sxi);
    if (ilow <= ihi) {
        for (i = 0; i < sxi[N1 - 1]; i++)
            ix[i] = ilow + i * istr;
        sxi[M1 - 1] = ilow;
    } else {
        for (i = 0; i < sxi[N1 - 1]; i++)
            ix[i] = ilow - i * istr;
        sxi[M1 - 1] = ihi;
    }
    return OK;
}

/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
