/*
 * chdir.c
 *
 */

#include "rt.h"

/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/

int C_chdir(char *p)
{
    int i;
    struct passwd *pw;
    char *cp;
    char buf[1024], name[32];
    char errmsg[80];

    while (isspace(*p))
        ++p;
    if ('~' == *p) {
        if ('/' == *++p || '\0' == *p) {        /* This user's HOME directory */
            if ((pw = getpwuid(getuid())) == (struct passwd *) 0) {
                sprintf(errmsg, "Can't find your HOME directory!");
                BasError(errmsg, strlen(errmsg));
                return (-1);
            }
        } else {                /* Some other user's HOME directory */
            if ((cp = strchr(p, '/')) == (char *) 0) {
                p = strcpy(name, p);
            } else {
                (void) strncpy(name, p, cp - p);
                name[cp - p] = '\0';
                p = cp;
            }
            if ((pw = getpwnam(name)) == (struct passwd *) 0) {
                sprintf(errmsg, "Can't find HOME directory for %s!", p);
                BasError(errmsg, strlen(errmsg));
                return (-1);
            }
            if (!cp)
                *p = '\0';
        }
        (void) strcpy(buf, pw->pw_dir);
        (void) strcat(buf, p);
        p = buf;
    }

    i = chdir(p);
    if (-1 == i) {
        perror(p);
    }
    return (i);
}

/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/

#ifdef TEST
/* Typical compile line: "cc -o mycd -D$CPU -DTEST thisfile.c"  */
/* Test usage: "./mycd;./mycd /usr/local"       */

main(int a, char *b[])
{
    int rval;
    int C_chdir();

    if (1 == a) {
        rval = C_chdir("H_o_m_E");
    } else {
        rval = C_chdir(*++b);
    }
    (void) system("/bin/pwd");
    exit(rval);
}
#endif

/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
