/*
 * CLR.C
 *
 * All parser stack manipulations now take place here. Code moved here
 * from various places by Zane C. Motteler, 2/15/2000.
 *
 */

#include "rt.h"

typedef struct {
    Integer vocabulary;
    Integer state;
} Parse_Stack;

Parse_Stack *parse_stack;

Integer xlrstk;
Integer stkptr;

/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/

/* Return the state on top of the stack */

void Lrgsta(Integer *state)
{
    *state = parse_stack[stkptr - 1].state;
}

/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/

Integer Gstkptr(void)
{
    return stkptr;
}

/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/

Integer Gvocab(Integer i)
{
    return parse_stack[i - 1].vocabulary;
}

/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/

/* Moved here from skel.r77 2/15/2000 */

void Lrgptr(Integer *ptr)
{
    *ptr = stkptr;
}

/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/

/*
 ******* ROUTINE LRPOPN ( N ) : POP N ITEMS OFF THE STACK
 * Moved here from skel.r77 2/15/2000
 */
void Lrpopn(Integer n)
{
    stkptr -= n;
}

/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/

/*
 ******* ROUTINE LRSTKN : INITIALIZE THE STACK
 * Moved here from skel.r77 2/15/2000
 */
void Lrstkn(void)
{
    stkptr = 0;
}

/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/

void Sstkptr(Integer ptr)
{
    stkptr = ptr;
}

/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/

void Pstkinit(void)
{
    integer size;

    xlrstk = MAXSTACK;
    stkptr = 0;
    size = sizeof(Parse_Stack) / sizeof(Integer) +
        (sizeof(Parse_Stack) % sizeof(Integer) ? 1 : 0);
    Osallotn((Address *) &parse_stack, size * xlrstk,
             "PERM|PSTKINIT:parse_stack");
}

/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/

/* peek inside stack, return 0 if bad */

Integer Lrpkst(Integer i, Integer *state, Integer *vocab)
{
    Integer ilook;

    ilook = stkptr - i;
    if (ilook <= 0)
        return 0;
    else {
        *state = parse_stack[ilook - 1].state;
        *vocab = parse_stack[ilook - 1].vocabulary;
        return 1;
    }
}

/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/

/* pop the stack and return the values on top */
void Lrpop(Integer *state, Integer *vocab)
{
    *state = parse_stack[stkptr - 1].state;
    *vocab = parse_stack[stkptr - 1].vocabulary;
    stkptr -= 1;
}

/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/

/*
 *      push the state and vocabulary item on top of the stack
 *      revised 8/89 (ZCM) to expand the stack if out of space
 *      2/15/2000 (ZCM) This was originally part of lrpush.
 */
void Pstkpush(Integer state, Integer vocab)
{
    static char msg[] = "lrpush: parser stack overflow. Nesting too deep.";
    Integer size;

    if (stkptr - 1 >= xlrstk) {
        /* allocate more space */
        if (xlrstk > 10000) {
            BasError(msg, strlen(msg));
            Kaboom(0);
        }
        xlrstk += MAXSTACK;
        size = sizeof(Parse_Stack) / sizeof(Integer) +
            (sizeof(Parse_Stack) % sizeof(Integer) ? 1 : 0);
        Oschangn((Address *) &parse_stack, xlrstk * size,
                 (xlrstk - MAXSTACK) * size, "parse_stack");
    }
    parse_stack[stkptr].state = state;
    parse_stack[stkptr].vocabulary = vocab;
    stkptr += 1;
}

/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
