/*
 * CMDARGS.C - process any command line flags out of the command line
 *
 */

#include "rt.h"

/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/

/* CMDARGS - reprocess the command line to
 *         - find any command flags, process them, and
 *         - remove them so that the interpreter doesn't
 *         - choke on them
 */

void Cmdargs(int *pg, int *pn, char *out, char *in)
{
    int c, zsp;
    char *p;

    zsp = 1;
    *pg = FALSE;
    *pn = TRUE;

/* process the command line for flags
 * flags are of the form:
 *        
 *        /x
 *
 * since that is illegal syntax for the Basis interpreter
 */
    p = in;

/* skip white space */
    while (TRUE) {
        c = *p++;
        if ((c != ' ') && (c != '\t'))
            break;
    }
    p--;

/* look for flags */
    while (*p++ == '/') {
        c = *p++;
        switch (c)

        {
/* global memory leak check flag */
        case 'g':
            p++;
            *pg = TRUE;
            break;

/* no startup files flag */
        case 'n':
            p++;
            *pn = FALSE;
            break;

/* verbose flag */
        case 'v':
            p++;
            verbose = 0;
            break;

/* zero space flag */
        case 'z':
            p++;
            zsp = 0;
            break;
        }
    }
    p--;

    strncpy(out, p, strlen(p));

/* set byte ordering flag */
    netnormord = Isnetnormord();

    SC_zero_space(zsp);

    return;
}

/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
