        integer function octatob(ttokn, ltokn, result)
#*******************************************************************************
#                              OCTATOB and DECATOB                             *
#                                                                              *
# Programmed by: Zane C. Motteler                                              *
#                June 1988                                                     *
# Purpose: Convert the exactly ltokn characters in ttokn to binary as if it  *
#          were the ascii octal (resp. decimal) representation of an integer.  *
#          Return ERR if there is overflow or an incorrect character           *
# Kludge added 12/13/95 (ZCM): skip leading blanks which somehow get
#        stuck in when debugger is invoked.
#*******************************************************************************
        character * (*) ttokn
        character * 80 msg
        character * 2 ic
        integer tlen, ltokn, result, digit, i, base
        integer decatob
        integer i1mach
        external i1mach
        logical leading
        base = 8
        tlen = ltokn + 1
        goto 10
        entry decatob(ttokn, ltokn, result)
        tlen = ltokn
        base = 10
10      result = 0
        leading=TRUE
        do i = 1, ltokn
                if(leading & ttokn(i:i) == " ")next
                digit=ichar(ttokn(i:i))-ichar('0')
                if((digit>base-1)|(digit<0)) then # illegal digit
                        ic(1:1)=char((digit+ichar('0'))/10 +ichar('0'))
                        ic(2:2)=char(mod((digit+ichar('0')),10) +ichar('0'))
                        msg = "oct(dec)atob: illegal digit (ascii "//ic//") in number "//ttokn(1:tlen)//"."
                        call remark(msg)

                        return(ERR)
                else
                        leading=FALSE
                        if(result > ((i1mach(9)-digit)/base) ) then
                                msg="oct(dec)atob: too many digits in "//ttokn(1:tlen)
                                call remark(msg)
                                return(ERR)
                        endif
                        result = result * base + digit
                endif
        enddo
        return(OK)
        end

        integer function hexatob(ttokn, ltokn, result)
#*******************************************************************************
#                              HEXATOB                                         *
#                                                                              *
# Programmed by: Zane C. Motteler                                              *
#                June 1988                                                     *
# Purpose: Convert the exactly ltokn characters in ttokn to binary as if it  *
#          were the ascii hex representation of an integer.                    *
#          Return ERR if overflow or illegal characters in the input.          *
#*******************************************************************************
        character * (*) ttokn
        character * 80 msg
        integer ltokn, result, digit, i
        logical bad
        integer i1mach
        external i1mach
        result = 0
        bad = FALSE
        do i = 1, ltokn
                digit = ichar(ttokn(i:i))
                if(digit <= ichar('9')) then
                        digit = digit - ichar('0')
                        bad = digit .lt. 0
                elseif(digit <= ichar('F')) then
                        digit = digit - ichar('A') + 10
                        bad = digit .lt. 10
                elseif(digit <= ichar('f')) then
                        digit = digit - ichar('a') + 10
                        bad = digit .lt. 10
                else
                        bad = TRUE
                endif
                if(bad) then
                        msg = "hexatob: hex digit ("//ttokn(i:i)//") out of range in number "//ttokn(1:ltokn+1)//"."
                        call remark(msg)

                        return(ERR)
                endif
                if(result > ((i1mach(9)-digit)/16)) then
                        msg="hexatob: too many digits in "//ttokn(1:ltokn)
                        call remark(msg)
                        return(ERR)
                endif
                result = result * 16 + digit
        enddo
        return(OK)
        end

        integer function decator(ttokn, ltokn, result)
#******************************************************************************
#*                            DECATOR                                         *
#*                                                                            *
#* Programmed by Zane C. Motteler                                             *
#*               June, 1988                                                   *
#* Purpose: converts the ascii string in ttokn (exactly ltokn characters of *
#* it) into a real binary number. Returns ERR if there is any trouble.        *
#******************************************************************************
Use(Qzdecato)
        real rdigit, result, rdiv
        character *(*) ttokn
        character * 100 msg
        integer ltokn, digit, chclass, dtort, exp, state,
            sign, i, texp
        integer zerocnt
        real r1mach
        external r1mach
# initializations:
        result = 0.0
        rdiv = 1.0
        dtort = 0
        state = 1
        exp = 0
        texp = -1
        sign = 1
# main loop:
        zerocnt = 0
        do i = 1, ltokn
                if((ttokn(i:i)>='0')&(ttokn(i:i)<='9')) then
                        digit = ichar(ttokn(i:i))-ichar('0')
                        rdigit = float(digit)
                        chclass = 1
ifelse(HAS_DOUBLE_COMPLEX,YES,[
                elseif((ttokn(i:i)=='e') | (ttokn(i:i)=='E')) then
],[
# change for Crays (ZCM 8/91)--comes here with double complex constant
# so allow 'd' exponent for portability
                elseif((ttokn(i:i)=='e') | (ttokn(i:i)=='E') |
                       (ttokn(i:i)=='d') | (ttokn(i:i)=='D')) then
])
                        chclass = 2
                elseif((ttokn(i:i)=='+')|(ttokn(i:i)=='-')) then
                        chclass = 3
                elseif(ttokn(i:i)=='.') then
                        chclass = 4
                else
                        chclass = 0
                endif
                if(states(state,chclass)==0) then #illegal character in input
                        msg = "decator: illegal character ("//ttokn(i:i)//
     >          ") in real "//ttokn(1:ltokn)//"."
                        call remark(msg)
                        return (ERR)
                endif
                if(chclass == 1) then # a digit just came in
                        if (state<=2) then # working on mantissa
                                result = result *10.0 + rdigit
                                texp = texp + 1
                        elseif(state<=4) then   # mantissa to right of dec. pt.
                                if (digit == 0) then
                                        zerocnt = zerocnt + 1
                                else
                                        result = result*10.0**(zerocnt+1)+rdigit
                                        rdiv  = rdiv * 10.0 ** (zerocnt+1)
                                        dtort = dtort + zerocnt + 1
                                        texp = texp + zerocnt + 1
                                        zerocnt = 0
                                endif
                        else # accumulate exponent
                                exp = exp *10 + digit
                        endif
                elseif((chclass==3)&(ttokn(i:i)=='-')) then # negative exponent
                        sign = -1
                endif
                state = states(state,chclass) # change state
        enddo
# if we got here we had a legal number (syntactically)
        texp = texp -dtort + sign*exp
        if(texp>int(log10(abs(r1mach(2))))-1) then
                msg = "decator: exponent overflow in "//ttokn(1:ltokn)
                call remark(msg)
                return(ERR)
        elseif(texp<int(log10(abs(r1mach(1))))-1) then
                msg = "decator: exponent underflow in "//ttokn(1:ltokn)
                call remark(msg)
                return(ERR)
        endif
# if we got here we had a legal number (semantically)
        result = result / rdiv * 10.0 ** (sign * exp)
        return(OK)
        end

        integer function decatod(ttokn, ltokn, dresult, p10)
#**************************************************************************
#*                            DECATOD
#*
#* Programmed by Peter A. Willmann
#*               April, 1989
#* Purpose: converts the ascii string in ttokn (exactly ltokn characters
#* of it) into a double binary number. Returns ERR if there is any trouble.
#**************************************************************************
Use(Qzdecato)
        double precision drdigit, dresult
        integer divexp
        character *(*) ttokn
        character * 100 msg
        integer ltokn, digit, chclass, dtort, exp, state,
            sign, texp
        integer  zerocnt
        double precision power10, p10, mult
        external  i1mach
        integer i1mach
        integer i, ii
# initializations:
        dresult = 0.0d0
        divexp = 0
        dtort = 0
        state = 1
        exp = 0
        texp = -1
        sign = 1
# main loop:
        zerocnt = 0
        do i = 1, ltokn
                if((ttokn(i:i)>='0')&(ttokn(i:i)<='9')) then
                        digit = ichar(ttokn(i:i))-ichar('0')
                        drdigit = digit
                        chclass = 1
                elseif((ttokn(i:i)=='d') | (ttokn(i:i)=='D')) then
                        chclass = 2
                elseif((ttokn(i:i)=='e') | (ttokn(i:i)=='E')) then
                        chclass = 2
                elseif((ttokn(i:i)=='+')|(ttokn(i:i)=='-')) then
                        chclass = 3
                elseif(ttokn(i:i)=='.') then
                        chclass = 4
                else
                        chclass = 0
                endif
                if(states(state,chclass)==0) then #illegal character in input
                        msg = "decatod: illegal character ("//ttokn(i:i)//
     >          ") in double precision "//ttokn(1:ltokn)//"."
                        call remark(msg)
                        return (ERR)
                endif
                if(chclass == 1) then # a digit just came in
                        if (state<=2) then # working on mantissa
                                dresult = dresult *1.0D1 + drdigit
                                texp = texp + 1
                        elseif(state<=4) then   # mantissa to right of dec. pt.
                                if (digit == 0) then
                                        zerocnt = zerocnt + 1
                                else
                                        dresult = dresult*1.0D1**(zerocnt+1)+drdigit
                                        divexp = divexp - zerocnt - 1
                                        dtort = dtort + zerocnt + 1
                                        texp = texp + zerocnt + 1
                                        zerocnt = 0
                                endif
                        else # accumulate exponent
                                exp = exp *10 + digit
                        endif
                elseif((chclass==3)&(ttokn(i:i)=='-')) then # negative exponent
                        sign = -1
                endif
                state = states(state,chclass) # change state
        enddo
# if we got here we had a legal number (syntactically)
        texp = texp - dtort + sign * exp
        if(texp>int(i1mach (16) * log10 (2.) - 1)) then
                msg = "decatod: exponent overflow in "//ttokn(1:ltokn)
                call remark(msg)
                return(ERR)
        elseif(texp<i1mach (15) * log10 (2.) + 1) then
                msg = "decatod: exponent underflow in "//ttokn(1:ltokn)
                call remark(msg)
                return(ERR)
        endif
# if we got here we had a legal number (semantically)
# The following computation is a workaround for a bug (feature??) in the
# HP exponential routine, which overflows for 10**(legal but large power)
        power10 = 10.d0
        mult = dresult
        p10 = 1.d0
        i = divexp + sign * exp
        ii = abs (i)
        # This does the exponentiation by multiplying 10's raised to
        # powers of 2, using the binary expansion of the exponent.
        while (ii > 0)
           if (ii ~= ii / 2 * 2) then
              if (i > 0) then
                 mult = mult * power10
                 p10 = p10 * power10
              else
                 mult = mult / power10
              endif
           endif
           ii = ii / 2
           if (ii > 0) power10 = power10 * power10
        endfor
        dresult = mult
        return(OK)
        end

        integer function btodeca(ivalue, text, slot, width, fill)
#*******************************************************************************
#*                           BTODECA                                           *
#* Programmed by: Zane C. Motteler                                             *
#*                July, 1988                                                   *
#* Purpose: Convert the integer in ivalue into an i-formatted ascii string in  *
#*          string 'text', beginning in position slot+1. 'width' is the field  *
#*          width. 'fill,' if nonzero, tells how many leading zeroes you want  *
#*          on the number (maximum); it won't give you all of them if there    *
#*          isn't room. 'btodeca' will fill the field with *'s if the number   *
#*          will not fit.                                                      *
#*                                                                             *
#* Bug fixes and simplification by ZCM 8/91                                    *
#*******************************************************************************
# (FNF 7/28/97) Changed "write(STDERR,..." statements to "call baserror".
        character*(OUTLINE) errmsg

        character*(*) text
        character*(30) text1
#       Save(text1)  #attempt to dodge civic bug
#       No more civic so:
        save text1
        integer ivalue, slot, width, fill, sign, i, myfill
        integer imkstr, lena
        external imkstr
        character wid*3, fmt*8
        if(ivalue<0) then
                sign = 1
        else
                sign = 0
        endif
        if((slot+width)>len(text)) then
                write(errmsg,990) width
990             format("btodeca: requested width for i conversion (", i6,")")
                call baserror(errmsg)
                call baserror("         is too long to fit in text field.")
                do i = 1+slot, min(len(text),width + slot)
                        text(i:i)='*'
                enddo
                return(OK)
        endif
        if(ivalue~=0) then
                if((int(log10(float(abs(ivalue))))+1+sign)>width) then
                        write(errmsg,991) width, ivalue
                        call baserror(errmsg)
991                     format("btodeca: width (",i6,") is to narrow to hold integer ",
                        i14,".")
                        do i = 1+slot, min(len(text),width + slot)
                                text(i:i)='*'
                        enddo
                        return(OK)
                endif
        endif
        myfill = fill
        lena = imkstr(width, wid)
        fmt = "(1i"//wid(1:lena)//")"
        write(text1,fmt)iabs(ivalue)
        text(slot+1:slot+width) = text1(1:width)
        if(ivalue>=0 & myfill == 0)return(OK)
        for(i=slot+width, i>=slot+1, i=i-1)
           if(text(i:i)==" ")break
        endfor
        while((i>slot+1)&(myfill>0))
                text(i:i) = '0'
                i = i - 1
                myfill = myfill - 1
        endwhile
        if(ivalue<0) then
                text(i:i) = '-'
        elseif(myfill>0) then
                text(i:i)= '0'
        endif
        return(OK)
        end

        integer function rconverr(rval,lentext,slot,width,places,min,type)
#*******************************************************************************
#*                                RCONVERR                                     *
#* Programmed by: Zane C. Motteler                                             *
#*                July 1988                                                    *
#* Purpose: Do all the error-checking with respect to real conversions to      *
#*          ascii. rval is the number to be converted (we hope); lentext is    *
#*          the length of the field it is to fit into; slot+1 is its offset    *
#*          into the text field; width is the total number of characters       *
#*          requested; places is the number of digits to the right of the      *
#*          decimal; min is the minimum field length needed (3 for f, 7 for    *
#*          e conversion); and type is 'f' or 'e', respectively.               *
#* Bug fixes and simplification by ZCM 8/91                                    *
#*******************************************************************************
# (FNF 7/28/97) Changed "write(STDERR,..." statements to "call baserror".
        character*(OUTLINE) errmsg

        real rval
        character * 1 type
        integer width, places, field, slot, min, lentext, exp, sign
        field = lentext - slot
        if(width-places<min) then
                write(errmsg,989)width
                call baserror(errmsg)
989             format("rconverr: width (",i2,") is too small for e or f conversion.")
                return(ERR)
        endif
        if(field<width) then
                write(errmsg,990)field,width
                call baserror(errmsg)
990             format("rconverr: string of size ",i6,
                " is too short for width of ",i6,".")
                return(ERR)
        endif
        if(rval == 0.0)return(OK)
        if(type=='e') then
                return(OK)
        endif
# Only f-format checks remain to be done
        exp = int(log10(abs(rval)))
        if(rval<0) then
                sign=1
        else
                sign = 0
        endif
        if(exp<0 | exp == 0 & abs(rval) < 1)then
                field = sign+1+places
        else
                field = sign+2+exp+places
        endif
        if(field>width)then
                write(errmsg,993)width,rval
                call baserror(errmsg)
993             format("rconverr: given width (",i6,
                ") will not hold ",1pe15.7)
                write(errmsg,994)places
                call baserror(errmsg)
994             format("          in f conversion with ",
                i6," digits to right of decimal.")
                return(ERR)
        endif
        return(OK)
        end

        integer function dconverr(dval,lentext,slot,width,places,min,type)
#*******************************************************************************
#*                                DCONVERR                                     *
#* Programmed by: Peter A. Willmann
#*                4/5/1989
#* Purpose: Do all the error-checking with respect to double precision conversions to      *
#*          ascii. dval is the number to be converted (we hope); lentext is    *
#*          the length of the field it is to fit into; slot+1 is its offset    *
#*          into the text field; width is the total number of characters       *
#*          requested; places is the number of digits to the right of the      *
#*          decimal; min is the minimum field length needed (3 for f, 7 for    *
#*          d conversion); and type is 'f' or 'd', respectively.               *
#* Bug fixes by ZCM 8/91
#**************************************************************************
# (FNF 7/28/97) Changed "write(STDERR,..." statements to "call baserror".
        character*(OUTLINE) errmsg

        double precision dval
        character * 1 type
        integer width, places, field, slot, min, lentext, exp, sign
        field = lentext - slot
        if(width-places < min) then #bug fix (ZCM 8/91)
                write(errmsg,989) width
                call baserror(errmsg)
989             format("dconverr: width (",i2,") is too small for d or f conversion.")
                return(ERR)
        endif

        if(field < width) then
                write(errmsg,990) field,width
                call baserror(errmsg)
990             format("dconverr: string of size ",i6,
                " is too short for width of ",i6,".")
                return(ERR)
        endif
        if(dval == 0.0)return(OK)

        if(type == 'd') then
                return(OK)
        endif
# Only f-format checks remain to be done
        exp = int(log10(abs(dval)))
        if(dval<0) then
                sign=1
        else
                sign = 0
        endif
        if(exp<0 | exp == 0 & abs(dval) < 1)then
                field = sign+1+places
        else
                field = sign+2+exp+places
        endif
        if(field>width)then
                write(errmsg,993)width,dval
                call baserror(errmsg)
993             format("dconverr: given width (",i6,
                ") will not hold ",1pd15.7)
                write(errmsg,994)places
                call baserror(errmsg)
994             format("          in f conversion with ",
                i6," digits to right of decimal.")
                return(ERR)
        endif
        return(OK)
        end

        integer function rtodecf(rval, text, slot, width, places)
#*******************************************************************************
#*                            RTODECF                                          *
#* Programmed by: Zane C. Motteler                                             *
#*                July, 1988                                                   *
#* Purpose: Convert the real number rval into f-format ascii. The field width  *
#*          is 'width,' places to the right of the decimal is 'places.' The    *
#*          ascii result is to go into 'text' beginning at position slot + 1.  *
#*          Return OK  and text filled with '*' in the event of error.         *
#* Revised and simplified by ZCM 8/91
#*******************************************************************************
        real rval
        character *(*) text
        integer width, places, i, slot
        integer rconverr,imkstr, len1, len2
        external rconverr,imkstr
        character wid*3, pl*3, fmt*12
#*      Check for error
        if(rconverr(rval,len(text),slot,width,places,3,'f')==ERR) then
                do i = 1+slot,min(len(text),width+slot)
                        text(i:i) = '*'
                enddo
                return(OK)
        endif
#*      At this point we can guarantee that the conversion will go through.
        len1=imkstr(width,wid)
        len2=imkstr(places,pl)
        fmt="(1f"//wid(1:len1)//"."//pl(1:len2)//")"
        write(text(slot+1:slot+width),fmt)rval
        return(OK)
        end

        integer function dtodecf(dval, text, slot, width, places)
#*******************************************************************************
#*                            DTODECF
#* Programmed by: Peter A. Willmann
#*                4/5/1989
#* Purpose: Convert the real number dval into f-format ascii. The field width  *
#*          is 'width,' places to the right of the decimal is 'places.' The    *
#*          ascii result is to go into 'text' beginning at position slot + 1.  *
#*          Return OK  and text filled with '*' in the event of error.
#* Revised and simplified by ZCM 8/91
#*******************************************************************************
        double precision dval
        character *(*) text
        integer width, places, i, slot
        integer dconverr, imkstr, len1, len2
        external dconverr, imkstr
        character wid*3, pl*3, fmt*12
#*      Check for error
        if(dconverr(dval,len(text),slot,width,places,3,'f') == ERR) then
                do i  =  1+slot,min(len(text),width+slot)
                        text(i:i)  =  '*'
                enddo
                return(OK)
        endif
#*      At this point we can guarantee that the conversion will go through.
        len1=imkstr(width,wid)
        len2=imkstr(places,pl)
        fmt="(1f"//wid(1:len1)//"."//pl(1:len2)//")"
        write(text(slot+1:slot+width),fmt)dval
        return(OK)
        end

        integer function rtodece(rval, text, slot, width, places)
#*******************************************************************************
#*                             RTODECE                                         *
#* Programmed by: Zane C. Motteler                                             *
#*                July 1988                                                    *
#* Purpose: Convert the real number in rval into "1pe"-type format ascii,      *
#*          placing it into ascii string 'text' starting at position slot+1.   *
#*          The total string will be 'width' characters long and will have     *
#*          'places' digits to the right of the decimal point. OK will be      *
#*          returned if the field width is too narrow or if too many           *
#*          significant figures are requested. In that case the field will be  *
#*          filled with asterisks.                                             *
#* Revised and simplified by ZCM 8/91
#*******************************************************************************
        real rval
        character*(*) text
        integer width, places, i, slot
        integer rconverr, imkstr, len2, len1
        external rconverr, imkstr
        character wid*3, pl*3, fmt*12
#*      Check for error
        if(rconverr(rval,len(text),slot,width,places,7,'e')==ERR) then
                do i = 1+slot,min(len(text),width+slot)
                        text(i:i) = '*'
                enddo
                return(OK)
        endif
#*      At this point we can guarantee that the worst errors have been caught.
        len1 = imkstr(width,wid)
        len2 = imkstr(places,pl)
        fmt = "(1pe"//wid(1:len1)//"."//pl(1:len2)//")"
        write(text(slot+1:slot+width),fmt)rval
        return(OK)
        end

        integer function dtodece(dval, text, slot, width, places)
#*******************************************************************************
#*                             DTODECE
#* Programmed by: Peter A. Willmann
#*                4/5/1989
#* Purpose: Convert the double precision number in dval into "1pd"-type format 
#8          ascii,
#*          placing it into ascii string 'text' starting at position slot+1.   *
#*          The total string will be 'width' characters long and will have
#*          'places' digits to the right of the decimal point. OK will be
#*          returned if the field width is too narrow or if too many
#*          significant figures are requested. In that case the field
#*          will be filled with asterisks.
#* Revised and simplified by ZCM 8/91
#*******************************************************************************
        double precision dval
        character*(*) text
        integer width, places, i, slot
        integer dconverr,imkstr,len1,len2
        external dconverr,imkstr
        character wid*3,pl*3,fmt*12
#*      Check for error
        if(dconverr(dval,len(text),slot,width,places,7,'d') == ERR) then
                do i = 1+slot, min(len(text), width+slot)
                        text(i:i) = '*'
                enddo
                return(OK)
        endif
#*   At this point we can guarantee that the worst errors have been caught.
        len1 = imkstr(width,wid)
        len2 = imkstr(places,pl)
        fmt = "(1pd"//wid(1:len1)//"."//pl(1:len2)//")"
        write(text(slot+1:slot+width),fmt)dval
        return(OK)
        end
