#######################################################################################
##
##  FILE NAME
##    debugger.m
##
##  AUTHOR
##    James A Crotinger
##    Added to Basis permanently by Zane C. Motteler
##    Copyright 1995, The Regents of the University of California,
##    and Lawrence Livermore National Laboratory
##  ENHANCEMENT
##    Zane C. Motteler 8/14/95
##    Print debugger stuff to the log file, if one has been opened.
##
##  CREATED
##    October 12, 1994
##
##  ADDED TO BASIS
##    February 23, 1995
##
##  NAMES
##    debugger
##      -- debug mode - prompts for strings and passes them
##         on to parsestr.
##
#######################################################################################

subroutine debugger

  implicit none
Use(Basplc)

  character*500 line
  character*8 prompt
  character*80 logline

  external basget, kaboom, parsestr
  integer basget

  integer nc

  prompt = "DEBUG>"

  call baspline(STDOUT, ' ')
  call baspline(STDOUT,'Type "cont" to continue, "abort" to return to Basis,')
  call baspline(STDOUT,'or a single line to be evaluated by Basis.')

  while (TRUE)

    line = ' '
    nc = basget(prompt(1:7),line)

    logline = "> "//line(1:nc)//" # <DEBUG"

    if ( iecho > 0 ) call baspline(iecho,logline)

    if (line(1:4) == "cont") break
    if (line(1:5) == "abort") call kaboom (0)

    call parsestr(line(1:nc))

  endwhile

end
