# Basis Code Development System
# Copyright 1986 The Regents of the University of California
# All rights reserved

c--------------------------------------------------------------------------

c                       FORGET FUNCTIONS

c--------------------------------------------------------------------------

c LRFORGET - Erase a specified user-defined function or variable

        subroutine lrforget()

Use(Stacks)

        integer type, nv,ndb
        integer parfinds
        external parfinds
        Address strloc
        external strloc
        integer nc
        Varname name

        nc = 0 # Have to look it up
        if (parfinds(ss(1,rsp), nv, ndb, type, nc, strloc(name), \
           len (name))== ERR) then

c ... release the space even if it's unknown (ZCM 11/10/95)
           call parrel(ss(1,rsp))
           return
        endif

        if (type == GROUP) then
           call remark("Sorry, cannot forget a group name.")
           call remark(
           "Enter 'forget' to forget all user-defined variables and functions.")
        else
           call rtforget(nv, ndb)
        endif

c ... Release the space (ZCM 10/2/95)
        call parrel(ss(1,rsp))

        return
        end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

# LRXACT - This subroutine actually carries out runtime parser actions.
# sets pcnext to next instruction, normally pc+1 unless function call
# Revised by Zane C. Motteler
#                       June 1988
# Change action UNNEST to pop the dostack (do loop controls for definite
#       do loops, if any)
# -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -
# Revisions by Zane C. Motteler
# 1 --->                July 1989
# Changes due to tokens no longer being kept in separate array, and ss(PTR,.)
#       being an actual pointer to the string for a NAME or known LHS
#                       August 1989
# 2 ---> Changes to support revised grammar for controlled DO's
# 3 ---> Further changes throughout lrsrc to support the postponement of 
#        'parfetch' until values are actually needed.
#			May, 1990
# 4 ---> naml = parname instead of call parname
#                       Bug fix 8/1990
# 5 ---> clear nameflg after a 'save <namelist>' line (action 362)
#                       Bug fix December 1990
# 6 ---> Add action 131, for reduction of ` <rterm> `. The stack element is
#        parfetched and then converted to a NAME (if possible). It must have 
#        been a string, and a scalar.
#                       Altered 7/91
# Domestic references removed to rtd.
# Revised by Zane C. Motteler
#                      August 1993
# Add "LINE" (opcode 150). It's a NOP in every respect except it is used to
# convey source line numbers to Basis for debugging purposes.
#                      September 9, 1993
# when the function name and arguments have been processed, call mcunnest
# to restore the previous state of macro nesting.
#                      March 27, 1995
# for names and strings, ss(PTR,.) gives entry into string table
#                      August 8, 1997
# implement computed names for functions. This means expanding action
# 131 to process the computed name by sending it to lxvcons with action
# 100.
#       Revised August 1999 by Zane C. Motteler.
#               Unlinked the runtime stack from the parsing stack.
#               This effected many simplifications.
#               1) No longer need to compute a "safe stack pointer"
#                  so that parsing operations would destroy the parse stack
#               2) Many operations always take place on the top one or
#                  two stack elements, so it is no longer necessary
#                  to send the stack pointer or stack elements as parameters
#               3) It is now necessary to pop the stack after operations
#                  which combine the top two stack elements and push the
#                  result back (binary operations, for example)
#               4) The runtime stack contains only information about
#                  data, and does not have "wasted" stack elements
#                  corresponding to operators, separators, etc.,
#                  so it is seldom necessary simply to move a stack element.

        subroutine lrxact(pc, pcnext)

Use(Actions)
Use(Controls)
Use(Functions)
Use(Inout)
Use(Stacks)
        integer action, pc, pcnext, trsp, i
        Ch(1) char91, char93
        Ch(16) caction, itostr
        external itostr
        integer parpknum
        integer strglen
        external parpknum, sorry, strglen, strgget, cllit
	Varname xxxx

        integer pardodi,pardobin,pardoneg,parsqbr,parlen
        external pardodi,pardobin,pardoneg,parsqbr,parlen
        integer parasgn,paropasn,pargetsd, lrdochk, parapp
        external parasgn,paropasn,pargetsd, lrdochk, parapp
        integer pardomm,pardomd,pardonot
        external pardomm,pardomd,pardonot
        integer pardodig,pardodp, getius
        external pardodig,pardodp, getius
        integer parcolon
        external parcolon,parfetch, parsubs,parid, paramb, ivalueo
        integer iousasgn,ioezout,iooutpt1,ioinput,pardocat, ivalueo
        external iousasgn,ioezout,iooutpt1,ioinput, pardocat
        integer pardoli, rtnewvar, gfuncdep, igetic
        external pardoli, rtnewvar, utcat, gfuncdep, igetic
        integer utsizstr, iooutus, parint, parname
        external utsizstr, iooutus, parint, parname
        Address paraddr
        external paraddr

	integer naml, ierr, ityp

#       rsp can't go up more than about 3 on one instruction.
        if (rsp + 3 > SSLENGTH)then    #<arglist>::=<argitem>  (first argument)
           call baserror("lrxact: Runtime stack overflow...possible runaway recursion.")
           call kaboom (0)
        endif

        action = igetic (pc)
        pcnext = pc + 1    #default unless overridden

#  this label is handy for watching for things
99      continue
        go to (100,200,300,400,500,600,700,800,900,1000,1100,1200,1300,1400,
               1500,1600,1700,1800,1900,2000) min(action,20)
	call remark("UUURRRP!")
	call kaboom(0)

#  1 <lhs>::=<id>
#  2 <lhs>::=<lhs> <args>
#  3 <lhs> = <lexp>
#  4 display group
#  5 display expression
#  6 call <lhs>
#  7 <misc>::=<id> command <comlist>
#  8 <factor>:=<lhs>
#  9 & <lhs>
# 10 the equals in an a assignment statement

100	continue # <lhs> ::= <id>
	call parid(rsp)
        return

200	continue # <lhs> ::= <lhs> <args>
        if (ss (TC, rlinkp - 1) == FUNCTION_TYPE & partrace) then
           if (paruser) then
               call dbgtrace (getius(), pc, rsp, rsp, rlinkp, rlinkp)
           elseif (ss (1, rlinkp) == 0) then
               call dbgtrace (getius(), pc, rsp, rlinkp - 1, 0, 0)
           else 
               call dbgtrace (getius(), pc, rsp, rlinkp - 1, ss(1, rlinkp), 
                  ss(1, ss (1, rlinkp)))
           endif
           tracedone = TRUE
        endif
	call parsubs(pcnext)
        # remove stack frame
        if (~ paruser) then
           rsp = rlinkp - 1
           rlinkp = ss(1, rlinkp)
        else
           paruser = FALSE
        endif
	return

300     continue
	semerr = parasgn(ss(1,rsp-1),ss(1,rsp)) #assignment stmt
        rsp = rsp - 2                           # pop both off the stack
        return

400	continue	
	idummy = pardodig()                     #display group
        rsp = rsp - 1                           # pop stack
	return

500     continue    #display expression
	if(ss(TC,rsp) = FUNCTION_TYPE ) go to 550
        idummy = pardodi()
        rsp = rsp - 1                           # pop stack
	return

550     continue    #SPECIAL SECTION
# THIS SECTION IS USED FROM SEVERAL PLACES
# it assumes that at rsp there is a FUNCTION which now needs to be 
# executed (subscripted) with no arguments, followed by the execution of the
# previous instruction again.
# Why? If f represents a user function, we need to evaluate it, which
# will cause a lot of activity followed by the execution of the
# instruction in pcnext
# As of Basis 8.0, this can't really happen any more except when a function
# that takes more than 0 args is referenced with out any.
# For now, leave this as is so as to make old stored intermediate code work ok
                ss(1,rsp+1) = rlinkp    # no arguments
                ss(TC,rsp+1) = 0
                rlinkp = rsp + 1
                rsp = rlinkp
                if (ss (TC, rlinkp - 1) == FUNCTION_TYPE & partrace) then
                   call dbgtrace (getius(), pc, rsp, rsp, rlinkp, ss (1, rlinkp))
                   tracedone = TRUE
                endif
                pcnext = pc
                call parsubs(pcnext)
                rlinkp = ss (1, rlinkp)
                rsp = rsp - 1
		return

600	continue   #call <factor>
	if(ss(TC,rsp) == LHS) then   #trying to call a variable
	   call remark("You tried to call a  non-function.")
	   naml = parname(ss(1,rsp),xxxx)
	   call remark(" -- name is '"//xxxx(1:naml) // "'")
           call kaboom(0)
	elseif(ss(TC,rsp) == FUNCTION_TYPE) then #a no argument call
	   go to 550
	else   #it already got called.
	   call parkill(ss(1,rsp))
           rsp = rsp - 1  # pop the stack
	endif
        return

700     continue  #reduce <id> command <comlist>

# command name is always one below the link pointer
        ityp = ss(TC, rlinkp - 1)
	if (ityp == NAME) then
	   call parid(rlinkp-1)

           ityp = ss(TC, rlinkp - 1)
           if (ityp == FUNCTION_TYPE) then
                if (partrace) then
                   if (paruser) then
                      call dbgtrace (getius(), pc, rsp, rsp, rlinkp, ss (1, rlinkp))
                   elseif (ss (1, rlinkp) == 0) then
                      call dbgtrace (getius(), pc, rsp, rlinkp - 2, 0, 0)
                   else
                      call dbgtrace (getius(), pc, rsp, rlinkp - 2,
                         ss (1, rlinkp), ss (1, ss (1, rlinkp)))
                   endif
                   tracedone = TRUE
                endif
                pcnext = pc + 1
                call parsubs(pcnext)
# pop stack
                if (~ paruser) then
                   rsp    = rlinkp - 2
                   rlinkp = ss (1, rlinkp)
                else
                   paruser = FALSE
                endif
		return
           else
		call remark("You tried to execute an unknown command.")
		naml = parname(ss(1,rlinkp-1),xxxx)
	        call remark(" -- name is '"//xxxx(1:naml) // "'")
                call kaboom(0)
	   endif
	else
	   call parkill(ss(1,rlinkp - 1))
           rsp = rlinkp - 2   # Pops command name off stack
           rlinkp = ss (1, rlinkp)
	endif
	return

800     continue   # <factor> := <lhs>
        call parfetch(ss(1,rsp),nxp(rsp),lxp(rsp),ACTUAL,FALSE)
        return

900     continue    # <argitem> := & <lhs>
        call paramb()
	if(symbolic)then
		call utcat(nxp(rsp),lxp(rsp),"&",1,nxp(rsp),lxp(rsp)," ",0)
	endif
	return

1000    continue    # the equals in an assignment statement
        assignsp = rsp + 1
	inassign = TRUE
	if(debug=NO) symbolic=FALSE
	return

# named actions that need to be coordinated with the BNF file
1100    continue   #FACLIT factor ::= literal number
	call parsav()
	return

1200    continue   #SET1 dospec ::= lhs = first , last incr
        call lrsetdo()
        # pop the stack
        rsp = rsp - 3
        return

1300    continue   #NEST
	call parnest(igetic(pc+1))  #keep track of nesting at runtime
        pcnext = pcnext + 1
        return

1400    continue   #UNNEST
#       pop the stack of DO controls as appropriate
#       if we are exiting any DO_DEF loops, release the control variable
        call parunnst (pc)
        pcnext = pcnext + 1
        return

1500    continue    #LOOPSTRT first:=exp
        call remark("lrxact: Action 15 (LOOPSTRT) no longer exists.")
        semerr = ERR
        return

1600    continue   #FCNENTER
        call remark("lrxact: bad jump to FCNENTER code")
        semerr = ERR
        return

1700    continue  #RET function return, but watch out for "return f"
        if(ss(TC,rsp) = FUNCTION_TYPE) then
# call with no arguments, reexecute this instruction afterwards
# see remarks under 550
		go to 550
        else
                if (ss(TC, rlinkp) == COMMAND) then
                   trsp = rlinkp - 2
                else
                   trsp = rlinkp - 1
                endif
                if (partrace) then
                   if (ss (1, rlinkp) == 0) then
                      call dbgtrace (getius(), pc, rsp, trsp, 0, 0)
                   else
                      call dbgtrace (getius(), pc, rsp, trsp, ss (1, rlinkp),
                         ss (1, ss (1, rlinkp)))
                   endif
                   tracedone = TRUE
                endif
                semerr = lrxret(pcnext)
                if (ss(TC, rlinkp) == COMMAND) then
                   # Throw away return value
                   call parkill (ss(1, rlinkp - 1))
                   ss(TC, rlinkp) = 0
                endif
                # pop the argument stack
                rsp = trsp
                rlinkp = ss (1, rlinkp)
        endif
        return

1800    continue   #NULLRET
        rsp = rsp + 1             #push a null return value on stack
	ss(TC,rsp) = NULL_TYPE    #optval :: =  null
        return

1900    continue
        call parfetch(ss(1,rsp),nxp(rsp),lxp(rsp),COPY,FALSE)
        return

2000	continue
   select(action/100)
   case 1:
        select(action)
        case 101: semerr = parsqbr()            #explist ::= explist,lexp
                  rsp = rsp - 1                 #(in matrix::=[ explist ])
        case 102: semerr = pardobin(OR)         #lexp ::= lexp | lterm
                  rsp = rsp - 1
        case 103: semerr = pardobin(AND)        #lterm ::= lterm & lprim
                  rsp = rsp - 1
        case 104: semerr = pardonot()            #lprim ::= ~ lfactor
        case 105: semerr = pardobin(LT)          #lfact ::= exp < exp
                  rsp = rsp - 1
        case 106: semerr = pardobin(LE)          #lfact ::= exp <= exp
                  rsp = rsp - 1
        case 107: semerr = pardobin(GT)          #lfact ::= exp > exp
                  rsp = rsp - 1
        case 108: semerr = pardobin(GE)          #lfact ::= exp >= exp
                  rsp = rsp - 1
        case 109: semerr = pardobin(EQU)         #lfact ::= exp == exp
                  rsp = rsp - 1
        case 110: semerr = pardobin(NE)          #lfact ::= exp ~= exp
                  rsp = rsp - 1
        case 115: semerr = pardobin(ADD)         #exp ::= exp + term
                  rsp = rsp - 1
        case 116: semerr = pardobin(SUBTRACT)    #exp ::= exp - term
                  rsp = rsp - 1
        case 117:                                #exp ::= +term
                if( symbolic ) then
                        call utcat(
                        nxp(rsp),lxp(rsp),"+",1,nxp(rsp),lxp(rsp),BLANK,0)
                endif
        case 118: semerr = pardoneg()            #exp ::= -term
        case 119: semerr = pardobin(MULTIPLY)    #term ::= term * primry
                  rsp = rsp - 1
        case 120: semerr = pardomm()             #term ::= term *! primry
                  rsp = rsp - 1
        case 121: semerr = pardobin(DIVIDE)      #term ::= term / primry
                  rsp = rsp - 1
        case 122: semerr = pardodp()             #term ::= term ! primry
                  rsp = rsp - 1
        case 123: call parkill (ss (1,rsp))      #optlevel ::= level
                  rsp = rsp - 1
        case 124: semerr = pardocat()            #term ::= term // primry
                  rsp = rsp - 1
        case 125: semerr = pardomd()             #term ::= trem /! primry
                  rsp = rsp - 1
		# added by YHC 9/17/93
        case 126: semerr = pardobin(POWER)       #primry ::= factor ** primry
                  rsp = rsp - 1
        case 129:                                #atom ::= [ <explist> ]
                  if(  symbolic) then
                        char91 = char(91)
                        char93 = char(93)
                        call utcat(nxp(rsp),lxp(rsp),char91,1,
                        nxp(rsp),lxp(rsp),char93,1)
                  endif
        case 130:                                #atom ::= ( <lexp> )
                  if(  symbolic) then
                        call utcat(
                        nxp(rsp),lxp(rsp),"(",1,nxp(rsp),lxp(rsp),")",1)
                  endif
	case 131:				#<dname> ::= ` <rterm> `
#		The difference between this and 130 is that ss(1,rsp) must be	
#		evaluated (parfetched) before it is copied back.
#		Also, it must be a string and better not have subscripts.
#		Then it must be transformed into a NAME.
		call parfetch(ss(1,rsp),nxp(rsp),lxp(rsp),COPY,FALSE)
                if (ss (TC, rsp) < 0 & ss (NAML, rsp) == 0) then
                   call pargetc (ss (1, rsp), paraddr (ss (1, rsp)))
                endif
		if(ss(TC,rsp)>=0)then
			call remark(
			"lrxact: in ` <rterm> `, <rterm> must be a string.")
			semerr = ERR
			return
		elseif(parlen(ss(1,rsp))>1)then
			call remark(
			"lrxact: in ` <rterm> `, <rterm> must be a scalar.")
			semerr = ERR
			return
		endif

		ss(NAML, rsp) = ss(TC, rsp)  # negative means ss(PTR,.)
                                 # points into literal table (ZCM 5/8/95)
		ss(TC, rsp) = NAME
                ss(N1, rsp) = 0  # says that name has to be looked up
#               note that ss(PTR, rsp) already contains pointer
#               into literal table
                if(  symbolic) then
                        call utcat(
                        nxp(rsp),lxp(rsp),"`",1,nxp(rsp),lxp(rsp),"`",1)
                endif
        case 132:                               #<arglist>::=<argitem>  (first argument)
                 # Move first argument/subscript up one
                 call parcopy (ss (1, rsp), ss (1, rsp + 1))
                 if (symbolic) then
                    #Move symbols as well.
                    nxp (rsp + 1) = nxp (rsp)
                    lxp (rsp + 1) = lxp (rsp)
                 endif
                 # set rlinkp to element in between
                 ss (1, rsp) = rlinkp
                 ss (TC, rsp) = 0
                 # establish stack frame
                 rlinkp = rsp
                 rsp = rsp + 1
        case 133:                               #<comlist>::=<comitem> (first arg)
                 #Same as 132, except that the TC of the link element
                 #Will tell us that this is a command, and keep from
                 #leaving a value on the stack.
                 call parcopy (ss (1, rsp), ss (1, rsp + 1))
                 if (symbolic) then
                    #Move symbols as well.
                    nxp (rsp + 1) = nxp (rsp)
                    lxp (rsp + 1) = lxp (rsp)
                 endif
                 # set rlinkp to element in between
                 ss (1, rsp) = rlinkp
                 ss (TC, rsp) = COMMAND
                 # establish stack frame
                 rlinkp = rsp
                 rsp = rsp + 1
        case 134:semerr=parcolon(2)             #<exp>::=<rexp>:<rexp>
                 rsp = rsp - 1
        case 135:ss(TC,rsp+1) = NULL_TYPE       #<dexp>::= NULL
                 lxp(rsp+1) = 0
                 rsp = rsp + 1
        case 136:if (ss(TC,rsp) == FUNCTION_TYPE)then #<factor>::=<lhs>
                 # case of a function with no arguments; evaluate now
                 # if legal; if not let it go for now.
                     if(ss(N1,rsp)== 0) then #minargs=0
                        rsp = rsp + 1
                        ss (1, rsp) = rlinkp
                        ss(TC, rsp) = 0
                        rlinkp = rsp
                        if (partrace) then
                           if (paruser) then
                              call dbgtrace (getius(), pc, rsp, rsp, rlinkp,
                                 ss (1, rlinkp))
                           elseif (ss (1, rlinkp) == 0) then
                              call dbgtrace (getius(), pc, rsp, rlinkp - 1,
                                 0, 0)
                           else
                              call dbgtrace (getius(), pc, rsp, rlinkp - 1,
                                 ss (1, rlinkp), ss (1, ss (1, rlinkp)))
                           endif
                           tracedone = TRUE
                        endif
                        call parsubf (pcnext, 0)
                        if (~ paruser) then
                           rsp = rlinkp - 1
                           rlinkp = ss (1, rlinkp)
                        else
                           paruser = FALSE
                        endif
                     endif
                 endif
        case 138:semerr=parcolon(3)             #<exp>::=<rexp>:<rexp>:<rexp>
                 rsp = rsp - 2
        case 143:                               #id ::= name . name|reference|groupname
                ierr = parpknum(ss(1,rsp-1))
                if( symbolic) then
                     if ( ss(NAML,rsp) >= 0 ) then # string lives in string table
                        call strgget(ss(PTR,rsp),nxp(rsp)) # get string from table
                        lxp(rsp) = strglen(ss(PTR,rsp))
                     else # name lives in literal table
                        lxp(rsp) = - ss(NAML,rsp)
                     endif
                     call utcat(nxp(rsp-1),lxp(rsp-1),
                          nxp(rsp-1),lxp(rsp-1),".",1,nxp(rsp),lxp(rsp))
                endif

                call parput(rsp-1,ss(1,rsp))  #put result on stack at rsp-1
                rsp = rsp - 1
        case LINE:
                call lrdoline (pc, pcnext)
        default:
                caction = itostr (action)
                call utskipbl (caction, i)
                call remark("Impossible action number in lrxact: "//caction(i:16))
                semerr = ERR
        endselect
   case 2:
        # ZCM 12/13/95 add calls to mc121 to turn off protection
        #              of names from macro expansion
        select(action)
        case 230: call listlist(iooutus())
                  call mc121      # ZCM 12/13/95
        case 234: semerr = pardoli()            #list id
                  call mc121      # ZCM 12/13/95
                  rsp = rsp - 1
        case 235: semerr = pardoli()            #list group
                  call mc121      # ZCM 12/13/95
                  rsp = rsp - 1
        default:
                caction = itostr (action)
                call utskipbl (caction, i)
                call remark("Impossible action number in lrxact: "//caction(i:16))
                semerr = ERR
        endselect
   case 3:
        select(action)
        case 369: semerr=ioezout(STDIN)         # input from terminal
        case 370: call ioconout                 #output a line
        case 371: call parfetch(ss(1,rsp),nxp(rsp),lxp(rsp),ACTUAL,FALSE)
                  semerr=iousasgn()             #assign io unit
                  rsp = rsp - 1
        case 372: semerr=ioezout(6)             #...to tty
        case 374: call parfetch(ss(1,rsp),nxp(rsp),lxp(rsp),ACTUAL,FALSE)
                  semerr = iooutpt1()           # output
                  rsp = rsp - 1
        case 375: call uncndout                 # output
        case 376: semerr = ioinput()            # input
                  rsp = rsp - 1
        case 377: semerr = ioinput()            # input
                  rsp = rsp - 1
        case 378: call ionxtlin(0)              # skip line
        case 379: call ionxtlin(1)              # skip line
        case 380: oldunit = iounit              # end of input
                  inassign = FALSE
                  assignsp = 0
                  symbolic = TRUE
        default:
                caction = itostr (action)
                call utskipbl (caction, i)
                call remark("Impossible action number in lrxact: "//caction(i:16))
                semerr = ERR
        endselect
   case 4:
        select(action)
        case 400: ss(TC,rsp+1) = INTEGER           #type ::= integer
                  rsp = rsp + 1
        case 401: ss(TC,rsp+1) = REAL              #type ::= real
                  rsp = rsp + 1
        case 402: ss(TC,rsp+1) = LOGICAL           #type ::= logical
                  rsp = rsp + 1
        case 403: ss(TC,rsp+1) = COMPLEX           #type ::= complex
                  rsp = rsp + 1
        case 404: ss(TC,rsp+1) = CHAMELEON         #type ::= chameleon
                  rsp = rsp + 1
        case 405:                               #type ::= character * <lexp>
                 semerr=parint(ss(1,rsp),i)
                 if(semerr = OK) then
                        if(i <= 0 | i > MAXSTRING) then
                                call remark(
                                "Bad length in character declaration")
                                semerr = ERR
                        endif
                        call parrel(ss(1,rsp))
                        ss(TC,rsp) = - i
                 endif
        case 406: ss(TC,rsp+1) = -1                #type ::= character
                  rsp = rsp + 1
        case 407: ss(TC,rsp+1) = INDIRECT
                  rsp = rsp + 1
        case 408: ss(TC,rsp+1) = RANGE
                  rsp = rsp + 1
        case 409: ss(TC,rsp+1) = DOUBLE
                  rsp = rsp + 1

        case 410:                               #<varlist>::=<dvar><vals>
                jvar=rtnewvar(ss(N,rsp-3),ss(TC,rsp-2),ss(1,rsp-1), ss(1,rsp))
                if(jvar==0) semerr=ERR
                rsp = rsp - 2 # Pop the top two entries
        case 411:                               #<varlist>::=<varlist>,<dvar><vals>
                jvar=rtnewvar(ss(N,rsp-3),ss(TC,rsp-2),ss(1,rsp-1), ss(1,rsp))
                if(jvar==0) semerr=ERR
                rsp = rsp - 2 # Pop the top two entries
        case 412: ss(NS,rsp) = 0                #dvar ::= name
        case 413: semerr = pargetsd()           #dvar ::= reference <args>
                  # Now can get rid of the stack frame
                  rsp = rlinkp - 1
                  rlinkp = ss (1, rlinkp)
        case 414: call parfetch(ss(1,rsp),nxp(rsp),lxp(rsp),COPY,FALSE)
                                                #vals ::=  = lexp
        case 415: ss(TC,rsp+1) = NULL_TYPE      #<vals> ::= (null)
                  rsp = rsp + 1
ifelse(HAS_DOUBLE_COMPLEX,YES,[
        case 416: ss(TC,rsp+1) = DOUBLE_C        #type ::= double complex
],[
        case 416: ss(TC,rsp+1) = COMPLEX         #type ::= double complex
])
                  rsp = rsp + 1
        case 417: rsp = rsp - 2                 #<misc> ::= <scope> <type> <varlist>
                  # Declaration is done, so pop scope & type off stack.
        case 418: ss(TC,rsp+1) = FWA
		  rsp = rsp + 1
        case 420: ierr = parpknum(ss(1,rsp))     # <scope> ::= name
        case 421: if (gfuncdep () = 0) then      # <scope> ::= (null)
	             ss(N,rsp+1) = USERDB
		  else
		     ss(N,rsp+1) = LOCALDB
		  endif
                  rsp = rsp + 1
        case 422: ss(TC,rsp+1) = ifelse(WORDSIZE,64,REAL,DOUBLE) #real8
                  rsp = rsp + 1
        case 423: ss(TC,rsp+1) =  #complex8
 ifelse(WORDSIZE,64,COMPLEX,ifelse(HAS_DOUBLE_COMPLEX,YES,DOUBLE_C,COMPLEX))
                  rsp = rsp + 1
        default:
                caction = itostr (action)
                call utskipbl (caction, i)
                call remark("Impossible action number in lrxact: "//caction(i:16))
                semerr = ERR
        endselect
   case 6:
        select(action)
        case 600: call parfetch(ss(1,rsp),nxp(rsp),lxp(rsp),ACTUAL,FALSE)
                                                #incr ::= , exp
                  semerr = lrdochk()
        case 603: call rtzapall                 #forget
        case 604: call lrforget()               #forget <dname>
                  rsp = rsp - 1
        case 605: call lrread()                 # read <filename>
                  rsp = rsp - 1
        case 606: call parfetch(ss(1,rsp),nxp(rsp),lxp(rsp),COPY,FALSE)
                  semerr = lrdochk()
                                                #first ::= exp
        case 607: call parfetch(ss(1,rsp),nxp(rsp),lxp(rsp),ACTUAL,FALSE)
                  semerr = lrdochk()
                                                #last ::= exp
	case 608:                               # name := value (append)
	          semerr = parapp()
                  rsp = rsp - 2
        default:
                caction = itostr (action)
                call utskipbl (caction, i)
                call remark("Impossible action number in lrxact: "//caction(i:16))
                semerr = ERR
        endselect
   case 7: 
        # operator assignment
        # performs operation on ss(.,rsp-1) and ss(.,resp) and stores the
        # result in ss(.,rsp-1), after which it pops the top two stack emements.
        select(action)
                           # <lhs> <op=> <lexp> :
                           # |= :
        case 701:
                semerr = paropasn (OREQ)
                rsp = rsp - 2
                           # &= :
        case 702:
                semerr = paropasn (ANDEQ)
                rsp = rsp - 2
                           # += :
        case 703:
                semerr = paropasn (PLUSEQ)
                rsp = rsp - 2
                           # -= :
        case 704:
                semerr = paropasn (MINUSEQ)
                rsp = rsp - 2
                           # *= :
        case 705:
                semerr = paropasn (TIMESEQ)
                rsp = rsp - 2
                           # /= :
        case 706:
                semerr = paropasn (DIVIDEEQ)
                rsp = rsp - 2
                           # **= :
        case 707:
                semerr = paropasn (EXPEQ)
                rsp = rsp - 2
        default:
                caction = itostr (action)
                call utskipbl (caction, i)
                call remark("Impossible action number in lrxact: "//caction(i:16))
                semerr = ERR
        endselect
   default:
        caction = itostr (action)
        call utskipbl (caction, i)
        call remark("Impossible action number in lrxact: "//caction(i:16))
        semerr = ERR
   endselect
        return
999     continue #error trap
        semerr = ERR
        return
        end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c LRDOCHK - Make sure that <first>, <last>, and <incr> are scalars and
c         - are coercible to integers. This is done as action 606 and
c         - part of action 600.

        integer function lrdochk()

Use(Stacks)

        integer parcoerc, parlen
        external parcoerc, parlen

        if (parcoerc(ss(1,rsp), INTEGER) == ERR) then
           call remark(
           "lrdochk: do loop control expression "//nxp(rsp)(1:lxp(rsp))//  \
           " is not coercible to integer.")
           return(ERR)
        endif

        if ((parlen(ss(1,rsp)) > 1)) then
           call remark(
           "lrdochk: do loop control expression "//nxp(rsp)(1:lxp(rsp))//  \
           " is an array.")
           return(ERR)
        endif

        return(OK)
        end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c LRXREAD - Actually execute a read instruction
c         - read commands from a file
c         - save the rest of the line for afterwards...this is done by ospush

      integer function lrxread(filename)
      character*(*) filename

Use(Actions)
Use(Functions)
Use(Lrhcoms)

      Filename namef, getoutp
      character*(MAXLINE) pblin
      integer i, recur, lxptr
      integer lxpop,lpblin
      external lxpop, lxgptr
      logical osfind
      integer  ospush, ivalueo
      external  ospush, osfind, getius, setius, getoutp, setoutp, ivalueo
      integer getius

      if (~osfind(filename,namef,"i")) then
         call remark("Cannot find file to read:")
         call remark(filename)
         call kaboom(0)
      endif

# special check -- if trying to read the edit file , close it first
        if (namef == getoutp ()) then
           call basclose(getius())
           call setius (STDOUT)
           call setoutp ("tty")
        endif

# open the new file, saving the rest of this line
# the lookahead has already processed at least one character
# beyond the  cr or ; that ends the read command
# these have been pushed back
        lpblin = 0

# get the characters that were pushed back
        recur = 0
        lxptr = 0
        call getpbch(recur, lxptr)

        while (lxpop(i, recur, lxptr) == OK)
           call smovftof(pblin, lpblin, char(i), 0, 1)
           lpblin = lpblin + 1
        endwhile

# get the rest of the current line, if any
        if (linpos <= linlen) then #get rest of current line
           call smovftof(pblin, lpblin, lintex, linpos-1, linlen+1-linpos)
           lpblin = lpblin + linlen + 1 - linpos
        endif

        if (ospush(namef,pblin,lpblin) == ERR) return(ERR)

# force the parser to get the first line of the next file
        linpos = linlen + 1             #make the rest of the line disappear

        return(OK)
        end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c LRSIZE - find the size of an object

      integer function lrsize(s)
      integer s(SSWIDTH), size, i
      integer ilow(7), ihi(7), icol(7), ndim
      Address fwa
      external rtxdb

      call rtxdb(s(PTR), s(N),fwa, ndim, ilow, ihi ,icol,0)

      size = 1
      do i = 1, s(NS) # get rid of any default subscripts
         if (s(M1+i-1) == DEFAULT) s(M1+i-1) = ihi (i)
         if (s(N1+i-1) == DEFAULT) s(N1+i-1) = ilow (i)
      enddo

      do i = 1, s(NS)
         size = size * (1 + abs(s(M1+i-1)-s(N1+i-1))/s(I1+i-1))
      enddo

      return(size)
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c SORRY - apologize and die

      subroutine sorry(feature)
      character*(*) feature

      call remark("The following feature is unavailable at this time:")
      call remark(feature)
      call kaboom(1)

      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c LRREAD - execute read command

        subroutine lrread()

Use(Actions)
Use(Functions)
Use(Problem_name)
Use(Stacks)

        character*200 f   #needs to hold 2 file names and a colon
        integer parname, lrxread
        external parname, lrxread
        integer islash

        idum = parname(ss(1,rsp),f)

        call parkill(ss(1,rsp))

        if (lrxread(f) .eq. ERR) call kaboom(0)

        if (probname .eq. "problem") then
           do islash = len(f), 1, -1
              if (f(islash:islash) .eq. "/") break
           enddo
           probname = f(islash+1:)
        endif

        return
        end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------
