# Basis Code Development System
# Copyright 1986 The Regents of the University of California

        subroutine fcnargb(iarg, s)
#       Revised: Zane C. Motteler
#                January 1990
#       Purpose: put call to parfetch to aid in lazy evaluation
#       Revised: Zane C. Motteler
#                August 1999
#       Purpose: stack and stack pointer are no longer necessary.
#                position of stack frame is known. arguments
#                run from rlinkp+1 to rsp.
Use(Stacks)
        integer iarg, s(*), i
#### get iarg'th argument off stack into s
        i = rlinkp + iarg
	if(ss(TC, i) == LHS)then
#          do lazy evaluation of argument (LHS means not yet evaluated)
	   call parfetch(ss(1,i),nxp(i), lxp(i), COPY,FALSE)
        endif
        call parcopy(ss(1, i), s)
        return
        end

        subroutine fcnargbp(iarg, s)
#       Programmer: Zane C. Motteler
#                   January 1990
#       Purpose:    This is used by routines which don't need the data such
#                   as 'shape', 'length', and the like
#       Revised: Zane C. Motteler
#                August 1999
#       Purpose: stack and stack pointer are no longer necessary.
#                position of stack frame is known. arguments
#                run from rlinkp+1 to rsp.
Use(Stacks)
        integer iarg, s(*), i
#### get iarg'th argument off stack into s
        i = rlinkp + iarg
	if(ss(TC, i) == LHS)then
#          do lazy evaluation of argument (LHS means not yet evaluated)
	   call parfetch(ss(1,i), nxp(i), lxp(i), NODATA,FALSE)
        endif
        call parcopy(ss(1, i), s)
        return
        end

        subroutine fcnarga(iarg, s)
#       Programmer: Dubois
#                   March 1991
#       Purpose:    This is used by routines which don't need the 
#                   a copy of the data.
#       Revised: Zane C. Motteler
#                August 1999
#       Purpose: stack and stack pointer are no longer necessary.
#                position of stack frame is known. arguments
#                run from rlinkp+1 to rsp.
Use(Stacks)
        integer iarg, s(1), i
#### get iarg'th argument off stack into s
        i = rlinkp + iarg
	if(ss(TC, i) == LHS)then
#          do lazy evaluation of argument (LHS means not yet evaluated)
	   call parfetch(ss(1,i), nxp(i), lxp(i), ACTUAL,FALSE)
        endif
        call parcopy(ss(1, i), s)
        return
        end

	subroutine fcnargs(iarg,nx,lx)
### Purpose: return symbolic representation of a stack element
#   (ZCM 8/13/1999) does this for the airgh'th value in the stack frame.
        integer iarg, lx, jarg
        character*(*) nx
Use(Stacks)
        jarg = iarg
        if (iarg == 0) jarg = -1 # function name is below link pointer
        lx = lxp(rlinkp + jarg)
        if(lx==0) then
           nx = " "
           return
        endif
        nx = nxp(rlinkp + jarg)
        return
        end


        function parbfcn( nargs, fname, sxi)
# avoid xmp problems !
clll.   optimize level g
#
#       ----- written by Andrew Zachary 4/3/85
#               fixed bugs in inner, outer  6/25/85 dubois
#               changed to handle structured argument list 6/10/85
#             rewrite for call from parxfcn dubois 1/8/87
#             changed to accomodate package builtins 12/10/87
#               rewrite to add double - Peter Willmann 3/30/89
#
#       reduces the production
#
#       <rid>::= reference <args>
#
#       for the builtin functions
#
#       Revised: Zane C. Motteler
#                January 1990
#       Purpose: Change fcnargb call to fcnargbp when NODATA is needed
#                COPY most of the time, because a copy of the data is needed.
#                NODATA for the rest, because only information about the data
#                       (length, type, ...) is needed
#       This supports lazy evaluation of function arguments (they are only
#       evaluated as -- and when -- needed).
#
#	Revised: Peter A. Willmann
#		 July 1990
#	Purpose: Broke into four routines.
#       Revised: Zane C. Motteler
#                August 1999
#       Purpose: stack and stack pointer are no longer necessary.
#                position of stack frame is known. arguments
#                run from rlinkp+1 to rsp.
Use(Controls)
Use(Functions)
        integer parbfcn, nargs
        integer parbfcn2, parbfcn4, parbfcn6
        external parbfcn2, parbfcn4, parbfcn6
        integer parbfcn1, parbfcn3, parbfcn5, parbfcn7# , parbfcn8
        external parbfcn1, parbfcn3, parbfcn5, parbfcn7# , parbfcn8
	external parkill
        Varname fname
        Dynamic(     x   ,    real   , 1 )
        Dynamic(    xc   ,  complex  , 1 )
        Dynamic(    xd   , double precision, 1 )
        Address Point(cx)
        Dynamic(     y   ,    real   , 1 )
        Dynamic(    yc   ,  complex  , 1 )
        Dynamic(    yd   , double precision, 1 )
        Dynamic(    ix   ,  integer  , 1 )
        Dynamic(    iy   ,  integer  , 1 )
        Dynamic( ndimen  ,  integer  , 1 )
ifelse(HAS_DOUBLE_COMPLEX,YES,[
        Dynamic(   xdc   , double complex , 1)
        Dynamic(   ydc   , double complex , 1)
])
#
        integer sxi(SSWIDTH), syi(SSWIDTH), szi(SSWIDTH)
        integer npoints, itemp, iskip, npointsy
        integer nmin, npointsx, parl
        integer  ndim
        logical fndflg
        integer parlen, parcoerc
        Address paraddr
        external paraddr, parlen, parcoerc
        integer utgetcl, parint, parreal, pardble
        external utcodstr, utgetcl, parint, parreal, pardble
        external  ivecmin, vecmin, ivecmax
        integer ivecmin, ivecmax
        real vecmin, ratio, rstart, rend
        double precision   dstart, dend, dratio, dxmin
        real xmin
ifelse(WORDSIZE,32,[
        double precision ranf
],[
        real ranf
])
ifelse(SYSTEM,XMP|YMP|C90|CRAY2|J90,[
#   Must not declare ranf external to get Cray's optimized version.
],[
        external ranf
])
        integer i, j
        Varname ferr     # name of function
        character*(TYPESIZE) typestr
clll.   option nodyneqv
#  begin search through function list
####################   A L G E B R A I C   ####################
########   A B S   ########
        if( fname == "abs" )  then
                call fcnargb( 1, sxi )
                npoints   = parlen( sxi )
                if( sxi(TC) == INTEGER )  then
                        Point( ix )  =  paraddr( sxi )
                        do i = 1, npoints
                                ix(i)   = abs( ix(i) )
                        enddo
                elseif( sxi(TC) == REAL )  then
                        Point( x ) = paraddr( sxi )
                        do i = 1, npoints
                                x(i)   = abs( x(i) )
                        enddo
                elseif( sxi(TC) == DOUBLE )  then
                        Point( xd ) = paraddr( sxi )
                        do i = 1, npoints
                                xd(i)   = abs( xd(i) )
                        enddo
ifelse(HAS_DOUBLE_COMPLEX,YES,[
                elseif( sxi(TC) == COMPLEX )  then
],[
                elseif( sxi(TC) == COMPLEX | sxi(TC) == DOUBLE_C )  then
])
                        call parcopy(sxi,syi)
                        Point( yc )   = paraddr( syi )
                        sxi(TC) = REAL
                        call parget(sxi)
                        Point(x) = paraddr(sxi)
                        do i = 1, npoints
                                x(i) = abs( yc(i) )
                        enddo
                        call parrel(syi)
ifelse(HAS_DOUBLE_COMPLEX,YES,[
                elseif( sxi(TC) == DOUBLE_C )  then
                        call parcopy(sxi,syi)
                        Point( ydc )   = paraddr( syi )
                        sxi(TC) = DOUBLE
                        call parget(sxi)
                        Point(xd) = paraddr(sxi)
                        do i = 1, npoints
                                xd(i) = cdabs( ydc(i) )
                        enddo
                        call parrel(syi)
])
                else
                        call remark( "abs: illegal argument type." )
                        return(ERR)
                endif
########   L E N G T H ######
        elseif( fname == "length") then
#               data is not actually needed for this function
                call fcnargbp(1, syi)
		if(syi(TC) = FUNCTION_TYPE) then
		   call remark("length: illegal argument type.")
		   return(ERR)
		endif
                npoints = parlen(syi)
		call parkill(syi)
                sxi(N) = 0
                sxi(TC) = INTEGER
                call parget(sxi)
                Point(ix) = paraddr(sxi)
                ix(1) = npoints
########   FROMONE  #######
	elseif( fname == "fromone") then
		call fcnargb(1,sxi)
		if(sxi(TC) = FUNCTION_TYPE) then
		   call remark("fromone: illegal argument type.")
		   return(ERR)
		endif
		ndim = sxi(N)
		do i = 1, ndim
			sxi(M1-1+i) = 1
			sxi(I1-1+i) = 1
		enddo
########   T Y P E  ######
        elseif( fname == "type") then
                call fcnargbp(1, sxi)
                if(sxi(TC) < 0) then
# utcodstr returns "character*3" for string of length 3.
                        typestr = "character"   # easier to test for
                        i = 9
                else
                        call utcodstr(sxi(TC), typestr)
                        i = utgetcl(typestr)
                endif
		call parkill(sxi)
                sxi(N) = 0
                sxi(TC) = -i
                sxi(NAML) = 1 # so it knows address is in literal table.(ZCM 4/10/95)
                call parget(sxi)
                Point(cx) = paraddr(sxi)
                call smovftoa(Point(cx), 0, typestr, 0, i)
########   A I N T   ########
        elseif( fname == "aint" )  then
                call fcnargb( 1, sxi )
                npoints       = parlen( sxi )
                if( sxi(TC) == INTEGER )  idummy = parcoerc( sxi,REAL )
                if( sxi(TC) == REAL )  then
                        Point( x ) = paraddr( sxi )
                        do i = 1, npoints
                              x(i) = aint( x(i) )
                        enddo
                elseif( sxi(TC) == DOUBLE )  then
                        Point( xd ) = paraddr( sxi )
                        do i = npoints, 1, -1
                              xd(i) = aint( xd(i) )
                        enddo
                else
                        call remark( "aint: illegal argument type" )
                        return(ERR)
                endif
########   A N I N T   ########
        elseif( fname == "anint" ) then
                call fcnargb( 1, sxi )
                npoints  = parlen( sxi )
                if( sxi(TC) == INTEGER )  idummy = parcoerc( sxi, REAL )
                if( sxi(TC) == REAL )  then
                        Point( x ) = paraddr( sxi )
                        do i = 1, npoints
                              x(i) = anint( x(i) )
                        enddo
                elseif( sxi(TC) == DOUBLE )  then
                        Point( xd ) = paraddr( sxi )
                        do i = npoints, 1, -1
                              xd(i) = anint( xd(i) )
                        enddo
                else
                        call remark( "anint: illegal argument type" )
                        return(ERR)
                endif
########   N I N T   ########
        elseif( fname == "nint" )  then
                call fcnargb( 1, syi )
                if( parcoerc( syi,REAL ) == ERR )  then
                        call remark( "nint: illegal argument type." )
                        return(ERR)
                endif
                call parcopy( syi, sxi )
                sxi(TC)        = INTEGER
                call parget( sxi )
                Point( ix )   = paraddr( sxi )
                Point( x )    = paraddr( syi )
                npoints       = parlen( syi )
                do i = 1, npoints
                        ix(i)       = nint( x(i) )
                enddo
                call parrel( syi )
########   M O D   ########
        elseif( fname == "mod" )  then
                call fcnargb( 1, sxi )
                call fcnargb( 2, syi )
                npointsy = parlen( syi )
                npointsx = parlen( sxi )
#  error check
                if( sxi(TC) < INTEGER | sxi(TC) > DOUBLE |
                    syi(TC) < INTEGER | syi(TC) > DOUBLE ) then
                        call remark( "mod: illegal argument types." )
                        return(ERR)
                endif
#  if the arguments have different types, force them to agree.
                if( syi(TC) <> sxi(TC) )  then
                        if(parcoerc(sxi, max(sxi(TC),syi(TC))) == ERR) return(ERR)
                        if(parcoerc(syi, max(sxi(TC),syi(TC))) == ERR) return(ERR)
                endif
#  if second argument is a scaler, do usual mod call.  If
#  it's a vector or array, it must be the same length as the first
#  argument in order to do a point by point mod call
                if( npointsy <> 1 & npointsy <> npointsx )  then
                        call remark( "mod: cannot match lengths." )
                        return(ERR)
                endif
                if( sxi(TC) == REAL )  then
                        Point( y ) = paraddr( syi )
                        Point( x ) = paraddr( sxi )
                        if( npointsy == 1 ) then
                                do i = 1, npointsx
                                        x(i)  = mod( x(i), y(1) )
                                enddo
                        else
                                do i = 1, npointsx
                                        x(i)  = mod( x(i), y(i) )
                                enddo
                        endif
                elseif( sxi(TC) == DOUBLE )  then
                        Point( yd ) = paraddr( syi )
                        Point( xd ) = paraddr( sxi )
                        if( npointsy == 1 ) then
                                do i = npointsx, 1, -1
                                        xd(i)  = mod( xd(i), yd(1) )
                                enddo
                        else
                                do i = npointsx, 1, -1
                                        xd(i)  = mod( xd(i), yd(i) )
                                enddo
                        endif
                else
                        Point( iy ) = paraddr( syi )
                        Point( ix ) = paraddr( sxi )
                        if( npointsy == 1 )  then
                                do i = 1, npointsx
                                        ix(i)  = mod( ix(i), iy(1) )
                                enddo
                        else
                                do i = 1, npointsx
                                        ix(i)  = mod( ix(i), iy(i) )
                                enddo
                        endif
                endif
        call parrel( syi )
########   S I G N   ########
        elseif( fname == "sign" )  then
                call fcnargb( 1, syi )
                call fcnargb( 2, sxi )
                npointsx  = parlen( sxi )
                npointsy  = parlen( syi )
#
#  error check
                if( sxi(TC) < INTEGER | sxi(TC) > DOUBLE |
                    syi(TC) < INTEGER | syi(TC) > DOUBLE ) then
                        call remark( "sign: illegal argument types." )
                        return(ERR)
                endif
#  if the arguments have different types, force them to agree.
                if( syi(TC) <> sxi(TC) )  then
                        if( parcoerc( sxi, max(sxi(TC),syi(TC)) ) == ERR) return(ERR)
                        if( parcoerc( syi, max(sxi(TC),syi(TC)) ) == ERR) return(ERR)
                endif
#  if both arguments are scalers, or if the first argument is a
#  scaler, do usual  sign  call.  If they are arrays, they must both
#  be the same length.
                if( npointsy <> 1 & npointsx <> npointsy )  then
                        call remark( "sign: cannot match lengths." )
                        return(ERR)
                endif
                if( sxi(TC) == INTEGER )  then
                        Point( ix ) = paraddr( sxi )
                        Point( iy ) = paraddr( syi )
                        if( npointsy == 1 )  then
                                do i = 1, npointsx
                                        ix(i)  = sign( iy(1), ix(i) )
                                enddo
                        else
                                do i = 1, npointsx
                                        ix(i)  = sign( iy(i), ix(i) )
                                enddo
                        endif
                elseif( sxi(TC) == REAL )  then
                        Point( x )  = paraddr( sxi )
                        Point( y )  = paraddr( syi )
                        if( npointsy == 1 )  then
                                do i = 1, npointsx
                                        x(i)    = sign( y(1), x(i) )
                                enddo
                        else
                                do i = 1, npointsx
                                        x(i)  = sign( y(i), x(i) )
                                enddo
                        endif
                elseif( sxi(TC) == DOUBLE )  then
                        Point( xd )  = paraddr( sxi )
                        Point( yd )  = paraddr( syi )
                        if( npointsy == 1 )  then
                                do i = npointsx, 1, -1
                                        xd(i)  = sign( yd(1), xd(i) )
                                enddo
                        else
                                do i = npointsx, 1, -1
                                        xd(i)  = sign( yd(i), xd(i) )
                                enddo
                        endif
                endif
                call parrel( syi )
########   R A N F   ########
        elseif( fname == "ranf" )  then
#  create random array of same size and type as the argument
                if(nargs == 0) then
                        sxi(N) = 0
                        sxi(TC) = ifelse(WORDSIZE,64,REAL,DOUBLE)
                        call parget(sxi)
                        npoints = 1
                else
                        call fcnargb( 1, sxi )
                        npoints       = parlen( sxi )
                endif
		if( sxi(TC) == RANGE) then
			Point(ix) = paraddr(sxi)
			ilow = ix(1)
			ihi = ix(2)
			istr = ix(3)
			npoints = (ihi-ilow)/istr + 1
			call parrel(sxi)
			sxi(TC) = ifelse(WORDSIZE,64,REAL,DOUBLE)
			sxi(N) = 1
			sxi(N1) = npoints
			sxi(M1) = ilow
			sxi(I1) = istr
			call parget(sxi)
                endif
                if( sxi(TC) == INTEGER )  idummy = parcoerc( sxi, ifelse(WORDSIZE,64,REAL,DOUBLE) )
                if( sxi(TC) == REAL )  then
                        Point( x ) = paraddr( sxi )
                        do i = 1, npoints
                                x(i)     = ranf()
                        enddo
                elseif( sxi(TC) == DOUBLE )  then
                        Point( xd ) = paraddr( sxi )
                        do i = 1, npoints #Removed backward loop (FNF 9/24/96)
                                xd(i)     = ranf()
                        enddo
ifelse(HAS_DOUBLE_COMPLEX,YES,[
                elseif( sxi(TC) == COMPLEX )  then
],[
                elseif( sxi(TC) == COMPLEX | sxi(TC) == DOUBLE_C)  then
])
                        Point( xc ) = paraddr( sxi )
                        do i = 1, npoints
                                xmin      = 2. * Pi * ranf()
                                xc(i)     = cmplx( cos(xmin), sin(xmin) )
                        enddo
ifelse(HAS_DOUBLE_COMPLEX,YES,[
                elseif( sxi(TC) == DOUBLE_C )  then
                        Point( xdc ) = paraddr( sxi )
                        do i = 1, npoints
                                dxmin      = 2. * Pi * ranf()
                                xdc(i)     = dcmplx( cos(dxmin), sin(dxmin) )
                        enddo
])
                else
                        call remark( "ranf: illegal argument type" )
                        return(ERR)
                endif
		return(OK)
########   O N E S   ########
        elseif( fname == "ones" )   then
#  get information on number of arguments.  Store in array ndimen
                syi(TC)  = INTEGER
                syi(N1)  = nargs
                syi(M1)  = 1
                syi(N )  = 1
                call parget( syi )
                Point( ndimen )  = paraddr( syi )
                do i = 1, nargs
                        call fcnargb( i, sxi )
                        if( parcoerc( sxi, INTEGER ) == ERR )  then
                                call remark( "ones: illegal argument type" )
                                return(ERR)
                        endif
                        if( parlen( sxi ) <> 1 )  then
                                call remark( "ones: argument not scalar" )
                                return(ERR)
                        endif
                        Point( ix ) = paraddr( sxi )
                        if( ix(1) < 1 )  then
                                call remark("ones: argument negative or 0" )
                                return(ERR)
                        endif
                        ndimen(i)     = ix(1)
                        call parrel( sxi )
                enddo
#  get space for array
                sxi(TC)  = INTEGER
                sxi(N )  = nargs
                do i   = 1, nargs
                        sxi(N1+i-1)  = ndimen(i)
                        sxi(M1+i-1)  = 1
                enddo
                call parget( sxi )
                Point( ix )   = paraddr( sxi )
#  if one dimensional, put 1's in each location
                if( nargs == 1 )  then
                        do i = 1, ndimen(1)
                                ix(i) = 1
                        enddo
#  in multi-dimensional case, put 1's on diagonal elements.  This is
#  equivalent to a multi-dimensional Kronecker delta.
                else
                        parl = parlen(sxi)
                        do i = 1, parl                     #zero array
                                ix(i) = 0
                        enddo
#determine skip size
                        nmin    = ivecmin( ndimen, 1, nargs )
                        iskip   = 1
                        do i = 1, nargs-1
                                itemp = 1
                                do j = 1, i
                                        itemp   = itemp * ndimen(j)
                                enddo
                                iskip     = iskip + itemp
                        enddo
                        do i = 1, nmin*iskip, iskip
                                ix(i) = 1
                        enddo
                endif
                call parrel( syi )
########   I O T A   ########
        elseif( fname == "iota" )  then
                call fcnargb( 1, syi )
         if( syi(TC) == RANGE & nargs == 1) then
            Point(ix) = paraddr(syi)
            ilow = ix(1)
            ihi = ix(2)
            istr = ix(3)
	    call parrel(syi)
         else
                if( parcoerc( syi, INTEGER ) == ERR )  then
                        call remark( "iota: illegal argument type." )
                        return(ERR)
                endif

                Point( ix ) = paraddr( syi )
                ihi = ix(1)
                call parrel(syi)
                if(nargs == 1) then
                        if(ihi <= 0 ) then
                                call remark(
                                "iota: illegal argument, must be > 0")
                                return(ERR)
                        endif
                        ilow = 1
            elseif(nargs >= 2) then
                        call fcnargb(2, syi)
                        if(parcoerc(syi, INTEGER) == ERR) then
                                call remark("iota: bad second argument")
                                return(ERR)
                        endif
                        Point( ix) = paraddr(syi)
                        ilow = ihi
                        ihi = ix(1)
                        call parrel(syi)
                endif
            if(nargs == 3) then
               call fcnargb(3, syi)
               if(parcoerc(syi, INTEGER) == ERR) then
                  call remark("iota: bad third argument")
                  return(ERR)
               endif
               Point( ix) = paraddr(syi)
               istr = max(ix(1),1)
               call parrel(syi)
            else
               istr = 1
            endif
         endif
         sxi(N1) = abs((ihi-ilow)/istr) + 1
                sxi(TC) = INTEGER
                sxi(N ) = 1
	 sxi(I1) = istr
                call parget( sxi )
                Point( ix ) = paraddr( sxi )
                if(ilow <= ihi) then
                        do i = 1, sxi(N1)
               ix(i)  = ilow + (i - 1)*istr
                        enddo
                        sxi(M1) = ilow
                else
                        do i = 1, sxi(N1)
               ix(i) = ilow - ( i - 1)*istr
                        enddo
                        sxi(M1) = ihi
                endif
	 return(OK)
########   S P A N L  ########  
        elseif(fname == "spanl") then
# get the starting value
                call fcnargb( 1, syi )                
                if( parlen( syi ) <> 1 )  then
                    call remark( "spanl: illegal argument length" )
                    return(ERR)
                endif
                if(syi(TC) == INTEGER) then
                    if(parcoerc(syi, REAL) == ERR)  then
                       call remark( "spanl: illegal argument type." )
                       return(ERR)
                    endif
                endif
# get the stopping value
                call fcnargb( 2, szi)
                if( parlen( szi ) <> 1 )  then
                    call remark( "spanl: illegal argument length" )
                    return(ERR)
                endif
                if(szi(TC) == INTEGER) then
                    if(parcoerc(szi, REAL) == ERR)  then
                       call remark( "spanl: illegal argument type." )
                       return(ERR)
                    endif
                endif
# Check type
                if (syi(TC) == REAL   & szi(TC) == REAL) then
                    if( parreal(syi,rstart) == ERR)return(ERR)
                    if( parreal(szi,rend) == ERR)return(ERR)
                    sxi(TC) = REAL
                elseif (syi(TC) == DOUBLE & szi(TC) == DOUBLE) then
                    if( pardble(syi,dstart) == ERR) return(ERR)
                    if( pardble(szi,dend) == ERR) return(ERR)
                    sxi(TC) = DOUBLE
                elseif (syi(TC) == REAL   & szi(TC) == DOUBLE) then
                    if( parreal(syi,rstart) == ERR)return(ERR)
                    if (parcoerc(szi,REAL) == ERR) then
                       call remark( "spanl: illegal argument type." )
                       return(ERR)
                    endif
                    if( parreal(szi,rend) == ERR)return(ERR)
                    sxi(TC) = REAL
                elseif(syi(TC) == DOUBLE & szi(TC) == REAL) then
                    if (parcoerc(syi,REAL) == ERR) then
                       call remark( "spanl: illegal argument type." )
                       return(ERR)
                    endif
                    if( parreal(syi,rstart) == ERR)return(ERR)    
                    if( parreal(szi,rend) == ERR)return(ERR)
                    sxi(TC) = REAL
                else
                   call remark("spanl: illegal argument type.")
                   return(ERR)
                endif

                call parrel(syi)
                call parrel(szi)
#get the length
                call fcnargb( 3, syi)
                if( parcoerc( syi, INTEGER ) == ERR )  then
                    call remark( "spanl: illegal argument type." )
                    return(ERR)
                endif
                if( parlen( syi ) <> 1 )  then
                    call remark( "spanl: illegal argument length" )
                    return(ERR)
                endif
                if( parint(syi,npoints) == ERR) return(ERR)
                if (npoints < 2) then
                   call remark ("spanl: scale must have at least 2 points.")
                   return(ERR)
                endif
                call parrel(syi)

# get space for array
                sxi(N)=1
                sxi(M1) = 1
                sxi(N1) = npoints
                call parget(sxi)
#
                if (sxi(TC) == REAL) then
                   if(rstart == 0.) then
		      rstart = rend*1.e-7
                   endif
#                  Corrected to trap if both arguments negative (FNF 12/96/96)
		   if (rstart <= 0 | rend <= 0) then
		      call remark("spanl: illegal input.")
                      return(ERR)
                   endif
                   ratio = log(rend)-log(rstart)
                   Point(x) = paraddr(sxi)
                   x(1)=rstart
                   do i=2,npoints-1
                      x(i)=rstart*exp(ratio*(i-1.)/(npoints-1.))
                   enddo
                   x(npoints) = rend
                else        # double
                   if (dstart==0) then
		      dstart = dend*1.d-7
                   endif
#                  Corrected to trap if both arguments negative (FNF 12/96/96)
		   if (dstart <= 0 | dend <= 0) then
		      call remark("spanl: illegal input.")
                      return(ERR)
                   endif
                   dratio = log(dend)-log(dstart)
                   Point(xd) = paraddr(sxi)
                   xd(1)=dstart
                   do i=2,npoints-1
                      xd(i)=dstart*exp(dratio*(i-1.)/(npoints-1.))
                   enddo
                   xd(npoints)=dend
                endif

        else #not one of these builtin functions
		if(parbfcn1(nargs,fname,sxi,fndflg) == ERR) return(ERR)
                if (fndflg) goto 900
		if(parbfcn2(nargs,fname,sxi,fndflg) == ERR) return(ERR)
                if (fndflg) goto 900
		if(parbfcn3(nargs,fname,sxi,fndflg) == ERR) return(ERR)
                if (fndflg) goto 900
		if(parbfcn4(nargs,fname,sxi,fndflg) == ERR) return(ERR)
                if (fndflg) goto 900
		if(parbfcn5(nargs,fname,sxi,fndflg) == ERR) return(ERR)
                if (fndflg) goto 900
		if(parbfcn6(nargs,fname,sxi,fndflg) == ERR) return(ERR)
                if (fndflg) goto 900
		if(parbfcn7(nargs,fname,sxi,fndflg) == ERR) return(ERR)
                if (fndflg) goto 900
#		if(parbfcn8(nargs,fname,sxi,fndflg) == ERR) return(ERR)
#               if (fndflg) goto 900
                ferr = fname
                call remark("parbfcn called with bad name.")
		call remark(ferr)
                call remark("End this run NOW; something has been damaged.")
                return(ERR)
        endif

####################   F I N I S H   ####################

900     continue
        do i=1,7
           sxi(I1+i-1) = 1
        enddo
        return(OK)
        end
