        function parbfcn1( nargs, fname, sxi, fndflg)
# avoid xmp problems !
clll.   optimize level g
#
#       ----- written by Andrew Zachary 4/3/85
#               fixed bugs in inner, outer  6/25/85 dubois
#               changed to handle structured argument list 6/10/85
#             rewrite for call from parxfcn dubois 1/8/87
#             changed to accomodate package builtins 12/10/87
#               rewrite to add double - Peter Willmann 3/30/89
#
#       reduces the production
#
#       <rid>::= reference <args>
#
#       for the builtin functions
#
#       Revised: Zane C. Motteler
#                January 1990
#       Purpose: Change fcnargb call to fcnargbp when NODATA is needed
#                COPY most of the time, because a copy of the data is needed.
#                NODATA for the rest, because only information about the data
#                       (length, type, ...) is needed
#       This supports lazy evaluation of function arguments (they are only
#       evaluated as -- and when -- needed).
#
#	Revised: Peter A. Willmann
#		 July 1990
#	Purpose: Broke into four routines.
#
#       Revised: Fred N. Fritsch
#                May 1996
#       Purpose: Repaired unsafe transfers for one-argument min/max.
#
#       Revised: Zane C. Motteler
#                August 1999
#       Purpose: stack and stack pointer are no longer necessary.
#                position of stack frame is known. arguments
#                run from rlinkp+1 to rsp.
##########################################################################
Use(Controls)
Use(Functions)
        integer parbfcn1, nargs
        Varname fname
        Dynamic(     x   ,    real   , 1 )
        Dynamic(    xc   ,  complex  , 1 )
        Dynamic(    xd   , double precision, 1 )
        Dynamic(    ix   ,  integer  , 1 )
        Dynamic(    xl   ,  logical  , 1 )
        Dynamic(    yl   ,  logical  , 1 )
ifelse(HAS_DOUBLE_COMPLEX,YES,[
        Dynamic(   xdc   , double complex , 1 )
])
#
        integer sxi(SSWIDTH), syi(SSWIDTH)
        integer npoints, itemp
        integer nmin, nmax
        logical fndflg
        integer parlen, parcoerc
        Address paraddr
        external paraddr, parlen, parcoerc
        integer fcndomax, fcndomin
        external fcndomax, fcndomin
        external utcodstr
        external dvecmin, ivecmin, vecmin, dvecmax, ivecmax, vecmax
        integer ivecmin, ivecmax
        real vecmin, vecmax
        double precision dxmin, dxmax, dxmin1, dxmax1
        double precision dvecmin, dvecmax
        real xmin, xmax
        integer i
        logical lm
        external r1mach, d1mach, i1mach
        real r1mach
        integer i1mach
        double precision d1mach
clll.   option nodyneqv

	fndflg = TRUE
#  begin search through function list
########   M I N   ########
        if    (fname =="min" & nargs > 1) then   # treat as inf if one argument
                if(fcndomin(nargs, sxi) = ERR) return(ERR)
########   M A X   ##########
        elseif(fname =="max" & nargs > 1) then   # treat as sup if one argument
                if(fcndomax(nargs, sxi) = ERR) return(ERR)
########   I N F   ########
        elseif(fname =="inf" | (fname =="min" & nargs == 1))  then
                itemp = INTEGER
                nmin  = 0
                xmin  = 0
                dxmin = 0
                icount = 0
                idcount = 0
                ircount = 0
                do i = 1, nargs
                        call fcnargb( i, syi )
                        if(syi(TC) < INTEGER | syi(TC) > DOUBLE) then
                                    call remark("inf: illegal argument type." )
                                    return(ERR)
                        endif

                        itemp = max(itemp, syi(TC))
                        npoints = parlen( syi )
                        if (npoints == 0 & nargs == 1) then
                           sxi (TC) = syi (TC)
                           sxi (N) = 0
                           call parget (sxi)
                           if (syi (TC) == REAL) then
                              Point (x) = paraddr (sxi)
                              x (1) = r1mach (2)
                           elseif (syi (TC) == DOUBLE) then
                              Point (xd) = paraddr (sxi)
                              xd (1) = d1mach (2)
                           else
                              Point (ix) = paraddr (sxi)
                              ix (1) = i1mach (9)
                           endif
                           call parrel (syi)
                           return (OK)
                        endif
                        if( syi(TC) == REAL )  then
                                ircount = ircount + 1
                                Point( x ) = paraddr( syi )
                                if( ircount == 1 )  then
                                        xmin = vecmin( x, 1, npoints )
                                else
                                        xmin = min(xmin, vecmin(x, 1, npoints))
                                endif
                        elseif( syi(TC) == DOUBLE )  then
                                idcount = idcount + 1
                                Point( xd ) = paraddr( syi )
                                dxmin1 = dvecmin( xd, 1, npoints )
                                if( idcount == 1 )  then
                                        dxmin = dxmin1
                                else
                                        dxmin = min(dxmin, dxmin1)
                                endif
                        else
                                icount = icount + 1
                                Point( ix ) = paraddr( syi )
                                if( icount == 1 )  then
                                        nmin = ivecmin( ix, 1, npoints )
                                else
                                        nmin = min( nmin,
                                        ivecmin( ix, 1, npoints ) )
                                endif
                        endif
                        call parrel( syi )
                enddo i
                sxi(TC) = itemp
                sxi(N1) = 1
                sxi(M1) = 1
                sxi(N ) = 0
                call parget( sxi )
                if( itemp == REAL )  then
                        Point( x  )  = paraddr( sxi )
                        x(1) = xmin
                        if(icount > 0) x(1) = min(x(1), float(nmin))
                elseif( itemp == DOUBLE )  then
                        Point( xd  )  = paraddr( sxi )
                        xd(1) = dxmin
                        if(icount > 0) then
                                dxmin1 = dble(nmin)
                                xd(1) = min(xd(1),dxmin1)
                        endif
                        if(ircount > 0) then
                                dxmin1 = dble(xmin)
                                xd(1) = min(xd(1),dxmin1)
                        endif
                else
                        Point( ix )  = paraddr( sxi )
                        ix(1)           = nmin
                endif
########   S U P   ########
        elseif(fname =="sup" | (fname =="max" & nargs == 1))  then
                itemp = INTEGER
                nmax  = 0
                xmax  = 0
                dxmax = 0
                icount = 0
                idcount = 0
                ircount = 0
                do i = 1, nargs
                        call fcnargb( i, syi )
                        if(syi(TC) < INTEGER | syi(TC) > DOUBLE) then
                                    call remark("sup: illegal argument type." )
                                    return(ERR)
                        endif
                        itemp = max(itemp, syi(TC))
                        npoints = parlen( syi )
                        if (npoints == 0 & nargs == 1) then
                           sxi (TC) = syi (TC)
                           sxi (N) = 0
                           call parget (sxi)
                           if (syi (TC) == REAL) then
                              Point (x) = paraddr (sxi)
                              x (1) = - r1mach (2)
                           elseif (syi (TC) == DOUBLE) then
                              Point (xd) = paraddr (sxi)
                              xd (1) = - d1mach (2)
                           else
                              Point (ix) = paraddr (sxi)
                              ix (1) = i1mach (9) + 1
                           endif
                           call parrel (syi)
                           return (OK)
                        endif
                        if( syi(TC) == REAL )  then
                                ircount = ircount + 1
                                Point( x ) = paraddr( syi )
                                if( ircount == 1 )  then
                                        xmax = vecmax( x, 1, npoints )

                                else
                                        xmax = max(xmax, vecmax(x, 1, npoints))
                                endif
                        elseif( syi(TC) == DOUBLE )  then
                                idcount = idcount + 1
                                Point( xd ) = paraddr( syi )
                                dxmax1 = dvecmax( xd, 1, npoints )
                                if( idcount == 1 )  then
                                        dxmax = dxmax1
                                else
                                        dxmax = max(dxmax, dxmax1)
                                endif
                        else
                                icount = icount + 1
                                Point( ix ) = paraddr( syi )
                                if( icount == 1 )  then
                                        nmax = ivecmax( ix, 1, npoints )
                                else
                                        nmax = max( nmax,
                                                    ivecmax( ix, 1, npoints ) )
                                endif
                        endif
                        call parrel( syi )
                enddo i
                sxi(TC) = itemp
                sxi(N1) = 1
                sxi(M1) = 1
                sxi(N ) = 0
                call parget( sxi )
                if( itemp == REAL )  then
                        Point( x  )  = paraddr( sxi )
                        x(1) = xmax
                        if(icount > 0) x(1) = max(x(1), float(nmax))
                elseif( itemp == DOUBLE )  then
                        Point( xd  )  = paraddr( sxi )
                        xd(1) = dxmax
                        if(icount > 0) then
                                dxmax1 = dble(nmax)
                                xd(1) = max(xd(1), dxmax1)
                        endif
                        if(ircount > 0) then
                                dxmax1 = dble(xmax)
                                xd(1) = max(xd(1), dxmax1)
                        endif
                else
                        Point( ix )  = paraddr( sxi )
                        ix(1)   = nmax
                endif
########   S Q R T   ########
        elseif( fname == "sqrt" )  then
 #  determine type of variable
                call fcnargb( 1, sxi )
                if( sxi(TC) == INTEGER )  idummy = parcoerc( sxi, REAL )
                npoints  = parlen( sxi )
                if( sxi(TC) == REAL )  then
                        Point( x ) = paraddr( sxi )
                        xmin  = vecmin( x, 1, npoints )
                        if( xmin < 0 )  then
                                call remark("sqrt: negative argument")
                                return(ERR)
                        endif
                        do i = 1, npoints
                                x(i)  = sqrt( abs(x(i)) )
                        enddo
                elseif( sxi(TC) == DOUBLE )  then
                        Point( xd ) = paraddr( sxi )
                        dxmin  = dvecmin( xd, 1, npoints )
                        if( dxmin < 0 )  then
                                call remark("sqrt: negative argument")
                                return(ERR)
                        endif
                        do i = npoints, 1, -1
                                xd(i)  = sqrt( abs(xd(i)) )
                        enddo
ifelse(HAS_DOUBLE_COMPLEX,YES,[
                elseif( sxi(TC) == COMPLEX )  then
],[
                elseif( sxi(TC) == COMPLEX | sxi(TC) == DOUBLE_C )  then
])
                        Point( xc ) = paraddr( sxi )
                        do i = 1, npoints
                                xc(i) = sqrt( xc(i) )
                        enddo
ifelse(HAS_DOUBLE_COMPLEX,YES,[
                elseif ( sxi(TC) == DOUBLE_C ) then
                        Point( xdc ) = paraddr( sxi )
                        do i = 1, npoints
                                xdc(i) = sqrt( xdc(i) )
                        enddo
])
                else
                        call remark( "sqrt: illegal argument type." )
                        return(ERR)
                endif
########   L A N D   ########
        elseif( fname == "land" )  then
                do i = 1, nargs
                        call fcnargb( i, syi )
                        if( syi(TC) <> LOGICAL )  then
                            call remark( "land: illegal argument type." )
                            return(ERR)
                        else
                            lm = TRUE
                            npoints = parlen( syi )
                            Point( yl ) = paraddr( syi )
                            do 998 ipoints = 1, npoints
                                if( .not.yl(ipoints)  ) then
                                    lm = FALSE
                                    go to 998
                                endif
998   continue
                        endif
                        call parrel( syi )
                enddo i
                sxi(TC) = LOGICAL
                sxi(N1) = 1
                sxi(M1) = 1
                sxi(N ) = 0
                call parget( sxi )
                Point( xl  )  = paraddr( sxi )
                xl(1)   = lm
########   L O R   ########
        elseif( fname == "lor" )  then
                do i = 1, nargs
                        call fcnargb( i, syi )
                        if( syi(TC) <> LOGICAL )  then
                            call remark( "lor: illegal argument type." )
                            return(ERR)
                        else
                            lm = FALSE
                            npoints = parlen( syi )
                            Point( yl ) = paraddr( syi )
                            do 999 ipoints = 1, npoints
                                if( yl(ipoints)  ) then
                                    lm = TRUE
                                    go to 999
                                endif
999   continue
                        endif
                        call parrel( syi )
                enddo i
                sxi(TC) = LOGICAL
                sxi(N1) = 1
                sxi(M1) = 1
                sxi(N ) = 0
                call parget( sxi )
                Point( xl  )  = paraddr( sxi )
                xl(1)   = lm
###################   E X P O N E N T I A L S   ####################
########   E X P   ########
        elseif ( fname == "exp" )  then
#  determine type of variable
                call fcnargb( 1, sxi )
                if( sxi(TC) == INTEGER )  idummy = parcoerc( sxi, REAL )
                npoints  = parlen( sxi )
                if( sxi(TC) == REAL )  then
                        Point( x ) = paraddr( sxi )
                        do i = 1, npoints
                                x(i)  = exp( x(i) )
                        enddo
                elseif( sxi(TC) == DOUBLE )  then
                        Point( xd ) = paraddr( sxi )
                        do i = npoints, 1, -1
                                xd(i)  = exp( xd(i) )
                        enddo
ifelse(HAS_DOUBLE_COMPLEX,YES,[
                elseif( sxi(TC) == COMPLEX )  then
],[
                elseif( sxi(TC) == COMPLEX | sxi(TC) == DOUBLE_C )  then
])
                        Point( xc ) = paraddr( sxi )
                        do i = 1, npoints
                                xc(i) = exp( xc(i) )
                        enddo
ifelse(HAS_DOUBLE_COMPLEX,YES,[
                elseif( sxi(TC) == DOUBLE_C ) then
                        Point( xdc ) = paraddr( sxi )
                        do i = 1, npoints
                                xdc(i) = exp( xdc(i) )
                        enddo
])
                else
                        call remark( "exp: illegal argument type." )
                        return(ERR)
                endif
########   L O G   ########
        elseif ( fname == "log" | fname == "alog")  then
#  determine type of variable
                call fcnargb( 1, sxi )
                if( sxi(TC) == INTEGER )  idummy = parcoerc( sxi, REAL )
                if( sxi(TC) > DOUBLE_C | sxi(TC) < 0)
                        call sorry("log of a bad argument type")
                npoints  = parlen( sxi )
                if( sxi(TC) == REAL )  then
                        Point( x ) = paraddr( sxi )
                        do i = 1, npoints
                                if( x(i) <= 0. ) then
                                        x(i) = logof0
                                else
                                        x(i) = log(x(i))
                                endif
                        enddo
                elseif( sxi(TC) == DOUBLE )  then
                        Point( xd ) = paraddr( sxi )
                        do i = npoints, 1, -1
                                if( xd(i) <= 0. ) then
                                        xd(i) = logof0
                                else
                                        xd(i) = log(xd(i))
                                endif
                        enddo
ifelse(HAS_DOUBLE_COMPLEX,YES,[
                elseif( sxi(TC) == COMPLEX )  then
],[
                elseif( sxi(TC) == COMPLEX | sxi(TC) == DOUBLE_C )  then
])
                        Point( xc ) = paraddr( sxi )
                        do i = 1, npoints
                                if( xc(i) == (0.,0.)) then
                                        xc(i) = logof0
                                else
                                        xc(i) = log( xc(i) )
                                endif
                        enddo
ifelse(HAS_DOUBLE_COMPLEX,YES,[
                elseif( sxi(TC) == DOUBLE_C )  then
                        Point( xdc ) = paraddr( sxi )
                        do i = 1, npoints
                                if( xdc(i) == (0.,0.)) then
                                        xdc(i) = logof0
                                else
                                        xdc(i) = log( xdc(i) )
                                endif
                        enddo
])
                else
                        call remark( "log: illegal argument type." )
                        return(ERR)
                endif
########   L O G 1 0   ########
        elseif ( fname == "log10" | fname == "alog10")   then
                call fcnargb( 1, sxi )
                if( sxi(TC) > DOUBLE | sxi(TC) < 0)
                        call sorry("log10 of a bad argument type")
                if( sxi(TC) == INTEGER )  idummy = parcoerc( sxi, REAL )
                npoints       = parlen( sxi )
                if( sxi(TC) == REAL )  then
                    Point( x )    = paraddr( sxi )
                    do i = 1, npoints
                                if( x(i) <= 0. ) then
                                        x(i) = logof0
                                else
                                        x(i) = log10(x(i))
                                endif
                    enddo
                elseif( sxi(TC) == DOUBLE )  then
                    Point( xd )  = paraddr( sxi )
                        do i = npoints, 1, -1
                                if( xd(i) <= 0. ) then
                                        xd(i) = logof0
                                else
                                        xd(i) = log10(xd(i))
                                endif
                    enddo
                endif
        else #not a builtin function
                fndflg = FALSE
                return(OK)
        endif

####################   F I N I S H   ####################

900     continue
        return(OK)
        end
