        function parbfcn2( nargs, fname, sxi, fndflg)
# avoid xmp problems !
clll.   optimize level g
#
#       ----- written by Andrew Zachary 4/3/85
#               fixed bugs in inner, outer  6/25/85 dubois
#               changed to handle structured argument list 6/10/85
#             rewrite for call from parxfcn dubois 1/8/87
#             changed to accomodate package builtins 12/10/87
#               rewrite to add double - Peter Willmann 3/30/89
#
#       reduces the production
#
#       <rid>::= reference <args>
#
#       for the builtin functions
#
#       Revised: Zane C. Motteler
#                January 1990
#       Purpose: Change fcnargb call to fcnargbp when NODATA is needed
#                COPY most of the time, because a copy of the data is needed.
#                NODATA for the rest, because only information about the data
#                       (length, type, ...) is needed
#       This supports lazy evaluation of function arguments (they are only
#       evaluated as -- and when -- needed).
#       Revised: Zane C. Motteler
#                January 1994
#       Purpose: cmplx will produce double complex on machines that support
#                it, if either argument is DOUBLE.
#       Revised: Fred N. Fritsch
#                June 1996
#       Purpose: Correct some subtle problems with above double complex fix.
#
#       Revised: Zane C. Motteler
#                August 1999
#       Purpose: stack and stack pointer are no longer necessary.
#                position of stack frame is known. arguments
#                run from rlinkp+1 to rsp.
Use(Controls)
Use(Functions)
        integer parbfcn2, nargs
        logical fndflg
        Varname fname
        Dynamic(     x   ,    real   , 1 )
        Dynamic(    xc   ,  complex  , 1 )
        Dynamic(    xd   , double precision, 1 )
        Dynamic(    xi   , integer )
        Dynamic(     y   ,    real   , 1 )
        Dynamic(    yd   , double precision, 1 )
        Address Point (cx)
        character cx
ifelse(HAS_DOUBLE_COMPLEX,YES,[
        Dynamic(    xdc  , double complex , 1 )
])
#
        integer sxi(SSWIDTH), syi(SSWIDTH), szi(SSWIDTH)
        integer npoints, npointsy
        integer npointsx, npointsz
        integer typ1, typ2
        character*6 rout
        integer parlen, parcoerc
        Address paraddr
        external paraddr, parlen, parcoerc
        external parcopy, parrel, parget
        real  rvalue
        double precision   dvalue
        real  cot
        double precision dcot
	external cot,dcot
        real del
        double precision ddel
        integer i
clll.   option nodyneqv

        fndflg = TRUE

#  begin search through function list
####################   T Y P E  C O N V E R S I O N   ####################
########   I N T   ########
        if( fname == "int" )  then
                call fcnargb( 1, sxi )
                if( parcoerc( sxi, INTEGER ) == ERR )  then
                        call remark( "int: illegal argument type" )
                        return(ERR)
                endif
########   C H A R  #######
        elseif( fname == "char") then
                call fcnargb( 1, syi )
                if (syi(TC) ~= INTEGER) then
                      call remark ("char: argument must be integer type.")
                      return (ERR)
                endif
                Point (xi) = paraddr (syi)
                if (xi < 0 | xi > 255) then
                      call remark ("char: argument must be between 0 and 255.")
                      return (ERR)
                endif
                sxi(TC) = -1
                sxi (N) = 0
                sxi(NAML) = 1 # forces string to be in literal table
                sxi(NS) = 0 
                call parget(sxi)
                Point(cx) = paraddr(sxi)
                call smovftoa (Point(cx), 0, char (xi), 0, 1)
                call parrel (syi)
########   I C H A R   ####
        elseif( fname == "ichar") then
                call fcnargb( 1, syi )
                if (syi(TC) ~= -1) then
                      call remark ("ichar: argument must be character*1 type.")
                      return (ERR)
                endif
                Point (cx) = paraddr (syi)
                call smovatof (cx, 0, Point (cx), 0, 1)
                sxi(TC) = INTEGER
                sxi (N) = 0
                call parget (sxi)
                Point (xi) = paraddr (sxi)
                xi = ichar (cx)
                call parrel (syi)
########   F L O A T   ########
        elseif( fname == "float")  then
                call fcnargb( 1, syi )
ifelse(HAS_DOUBLE_COMPLEX,YES,[
                if( syi(TC) == COMPLEX )  then
],[
                if( syi(TC) == COMPLEX | syi(TC) == DOUBLE_C )  then
])
                	call parcopy( syi, sxi )
                	sxi(TC)  = REAL
                	call parget( sxi )
                	Point( xc ) = paraddr( syi )
                	Point( x  ) = paraddr( sxi )
                	npoints     = parlen( syi )
                	do i = 1, npoints
                        	x(i)      = real( xc(i) )
                	enddo
                	call parrel( syi )
ifelse(HAS_DOUBLE_COMPLEX,YES,[
                elseif( syi(TC) == DOUBLE_C ) then
                    call parcopy( syi, sxi )
                    sxi(TC)  = DOUBLE
                    call parget( sxi )
                    Point( xdc ) = paraddr( syi )
                    Point( xd  ) = paraddr( sxi )
                    npoints     = parlen( syi )
                    do i = 1, npoints
                            xd(i)      = dble( xdc(i) )
                    enddo
                    call parrel( syi )
])
                else
                    call parcopy(syi,sxi)
                    if( parcoerc( sxi, REAL ) == ERR )  then
                        call remark( "float: illegal argument type" )
                        return(ERR)
                    endif
                endif
########   S N G L   ########
        elseif( fname == "sngl")  then
                call fcnargb( 1, sxi )
                if( parcoerc( sxi, REAL ) == ERR )  then
                        call remark( "sngl: illegal argument type" )
                        return(ERR)
                endif
########   D B L E   ########
        elseif( fname == "dble")  then
                call fcnargb( 1, sxi )
                if( parcoerc( sxi, DOUBLE ) == ERR )  then
                        call remark( "dble: illegal argument type" )
                        return(ERR)
                endif
########   C M P L X   ########
ifelse(HAS_DOUBLE_COMPLEX,YES,[
        elseif( fname == "cmplx" )  then
],[
        elseif( fname == "cmplx" | fname == "dcmplx" ) then
])
                if( nargs == 1 )  then
                        call fcnargb( 1, sxi )
ifelse(HAS_DOUBLE_COMPLEX,YES,[
                        # force double complex if argument is double
                        # and platform supports double complex
                        if( sxi(TC) == DOUBLE ) then
                          if(parcoerc(sxi, DOUBLE_C) == ERR) return(ERR)
                        else
                          if(parcoerc(sxi, COMPLEX) == ERR) return(ERR)
                        endif
],[
                        if(parcoerc(sxi, COMPLEX) == ERR) return(ERR)
])
                elseif( nargs == 2 )  then
                        call fcnargb( 1, syi )
                        call fcnargb( 2, szi )
                        npointsy      = parlen( syi )
                        npointsz      = parlen( szi )
                        npointsx      = max( npointsy, npointsz )
                        if( npointsy <> npointsz )  then
                                if( npointsy <> 1 & npointsz <> 1 )  then
                                        call remark(
                                "cmplx: incorrect length of arguments" )
                                        return(ERR)
                                endif
                        endif
ifelse(HAS_DOUBLE_COMPLEX,YES,[
                        if( syi(TC) == COMPLEX | szi(TC) == COMPLEX |
                            syi(TC) == DOUBLE_C | szi(TC) == DOUBLE_C )  then
],[
                        if( syi(TC) == COMPLEX | szi(TC) == COMPLEX )  then
])
                                call remark(
                                 "cmplx: cannot convert a complex argument." )
                                return(ERR)
                        endif
ifelse(HAS_DOUBLE_COMPLEX,YES,[
                        # force double complex if either argument is double
                        # and platform supports double complex
                        if( syi(TC) == DOUBLE | szi(TC) == DOUBLE ) then
                           typ1 = DOUBLE
                           typ2 = DOUBLE_C
                           rout = "dcmplx"
                        else
                           typ1 = REAL
                           typ2 = COMPLEX
                           rout = " cmplx"
                        endif
],[
                        # Code to be compatible with double complex patch
                        typ1 = REAL
                        typ2 = COMPLEX
                        rout = " cmplx"
])
                        if( parcoerc( syi, typ1 ) == ERR )  then
                                call remark(
                                 rout//": first argument illegal type" )
                                return(ERR)
                        endif
                        if( parcoerc( szi, typ1 ) == ERR )  then
                                call remark(
                                 rout//": second argument illegal type" )
                                return(ERR)
                        endif
                        if( npointsy <= npointsz )  then
                                call parcopy( szi, sxi )
                        else
                                call parcopy( syi, sxi )
                        endif
                        sxi(TC)            = typ2
                        call parget( sxi )
ifelse(HAS_DOUBLE_COMPLEX,YES,[
                      if (typ2 == COMPLEX) then
])
                        Point( xc )       = paraddr( sxi )
                        Point( y )        = paraddr( szi )
                        Point( x )        = paraddr( syi )
                        if( npointsy == 1 )  then
                                do i = 1, npointsx
                                        xc(i) = cmplx( x(1), y(i) )
                                enddo
                        elseif( npointsz == 1 & npointsy <> 1 )  then
                                do i = 1, npointsx
                                        xc(i) = cmplx( x(i), y(1) )
                                enddo
                        else
                                do i = 1, npointsx
                                        xc(i) = cmplx( x(i), y(i) )
                                enddo
                        endif
ifelse(HAS_DOUBLE_COMPLEX,YES,[
                      else
                        #ASSERT: typ2==DOUBLE_C
                        Point( xdc )       = paraddr( sxi )
                        Point( yd )        = paraddr( szi )
                        Point( xd )        = paraddr( syi )
                        if( npointsy == 1 )  then
                                do i = 1, npointsx
                                        xdc(i) = dcmplx( xd(1), yd(i) )
                                enddo
                        elseif( npointsz == 1 & npointsy <> 1 )  then
                                do i = 1, npointsx
                                        xdc(i) = dcmplx( xd(i), yd(1) )
                                enddo
                        else
                                do i = 1, npointsx
                                        xdc(i) = dcmplx( xd(i), yd(i) )
                                enddo
                        endif
                      endif
])
                        call parrel( szi )
                        call parrel( syi )
                endif
ifelse(HAS_DOUBLE_COMPLEX,YES,[
########  D C M P L X  ######## (implemented on Workstations only; ZCM 8/91)
        elseif( fname == "dcmplx" ) then
                if( nargs == 1 )  then
                        call fcnargb( 1, sxi )
                        if(parcoerc(sxi, DOUBLE_C) == ERR) return(ERR)
                elseif( nargs == 2 )  then
                        call fcnargb( 1, syi )
                        call fcnargb( 2, szi )
                        npointsy      = parlen( syi )
                        npointsz      = parlen( szi )
                        npointsx      = max( npointsy, npointsz )
                        if( npointsy <> npointsz )  then
                                if( npointsy <> 1 & npointsz <> 1 )  then
                                        call remark(
                                "dcmplx: incorrect length of arguments" )
                                        return(ERR)
                                endif
                        endif
                        if( syi(TC) == DOUBLE_C | szi(TC) == DOUBLE_C )  then
                           call remark(
                           "dcmplx: cannot convert a double complex argument." )
                           return(ERR)
                        elseif( syi(TC) == COMPLEX | szi(TC) == COMPLEX )  then
                           call remark(
                           "dcmplx: cannot convert a complex argument." )
                           return(ERR)
                        endif
                        if( parcoerc( syi, DOUBLE ) == ERR )  then
                                call remark(
                                 "dcmplx: first argument illegal type" )
                                return(ERR)
                        endif
                        if( parcoerc( szi, DOUBLE ) == ERR )  then
                                call remark(
                                 "dcmplx: second argument illegal type" )
                                return(ERR)
                        endif
                        if( npointsy <= npointsz )  then
                                call parcopy( szi, sxi )
                        else
                                call parcopy( syi, sxi )
                        endif
                        sxi(TC)            = DOUBLE_C
                        call parget( sxi )
                        Point( xdc )       = paraddr( sxi )
                        Point( yd )        = paraddr( szi )
                        Point( xd )        = paraddr( syi )
                        if( npointsy == 1 )  then
                                do i = 1, npointsx
                                        xdc(i) = dcmplx( xd(1), yd(i) )
                                enddo
                        elseif( npointsz == 1 & npointsy <> 1 )  then
                                do i = 1, npointsx
                                        xdc(i) = dcmplx( xd(i), yd(1) )
                                enddo
                        else
                                do i = 1, npointsx
                                        xdc(i) = dcmplx( xd(i), yd(i) )
                                enddo
                        endif
                        call parrel( szi )
                        call parrel( syi )
                endif
])
########   A I M A G   ########
        elseif( fname == "aimag" )  then
                call fcnargb( 1, syi )
ifelse(HAS_DOUBLE_COMPLEX,YES,[
                if( syi(TC) == COMPLEX )  then
],[
                if( syi(TC) == COMPLEX | syi(TC) == DOUBLE_C )  then
])
                	call parcopy( syi, sxi )
                	sxi(TC)  = REAL
                	call parget( sxi )
                	Point( xc ) = paraddr( syi )
                	Point( x  ) = paraddr( sxi )
                	npoints     = parlen( syi )
                	do i = 1, npoints
                        	x(i)      = aimag( xc(i) )
                	enddo
                	call parrel( syi )
ifelse(HAS_DOUBLE_COMPLEX,YES,[
                elseif( syi(TC) == DOUBLE_C ) then
                    call parcopy( syi, sxi )
                    sxi(TC)  = DOUBLE
                    call parget( sxi )
                    Point( xdc ) = paraddr( syi )
                    Point( xd  ) = paraddr( sxi )
                    npoints     = parlen( syi )
                    do i = 1, npoints
                            xd(i)      = dimag( xdc(i) )
                    enddo
                    call parrel( syi )
])
                else
                        call remark( "aimag: illegal argument type." )
                        return(ERR)
                endif
########   C O N J G   ########
        elseif( fname == "conjg" )  then
                call fcnargb( 1, sxi )
ifelse(HAS_DOUBLE_COMPLEX,YES,[
                if( sxi(TC) == COMPLEX )  then
],[
                if( sxi(TC) == COMPLEX | sxi(TC) == DOUBLE_C )  then
])
                    npoints       = parlen( sxi )
                    Point( xc )   = paraddr( sxi )
                    do i = 1, npoints
                            xc(i)       = conjg( xc(i) )
                    enddo
ifelse(HAS_DOUBLE_COMPLEX,YES,[
                elseif( sxi(TC) == DOUBLE_C ) then
                    npoints       = parlen( sxi )
                    Point( xdc )   = paraddr( sxi )
                    do i = 1, npoints
                            xdc(i)       = dconjg( xdc(i) )
                    enddo
])
                else
                        call remark( "conjg: illegal argument type." )
                        return(ERR)
                endif
####################   T R I G O N O M E T R Y   ####################
########   S I N   ########
        elseif( fname == "sin" )   then
                call fcnargb( 1, sxi )
                if( sxi(TC) == INTEGER )  idummy = parcoerc( sxi, REAL )
                npoints  = parlen( sxi )
                if( sxi(TC) == REAL    )  then
                        Point( x ) = paraddr( sxi )
                        do i = 1, npoints
                                x(i)  = sin( x(i) )
                        enddo
                elseif( sxi(TC) == DOUBLE )  then
                        Point( xd ) = paraddr( sxi )
                        do i = npoints, 1, -1
                                xd(i)  = sin( xd(i) )
                        enddo
ifelse(HAS_DOUBLE_COMPLEX,YES,[
                elseif( sxi(TC) == COMPLEX )  then
],[
                elseif( sxi(TC) == COMPLEX | sxi(TC) == DOUBLE_C )  then
])
                        Point( xc ) = paraddr( sxi )
                        do i = 1, npoints
                                xc(i) = sin( xc(i) )
                        enddo
ifelse(HAS_DOUBLE_COMPLEX,YES,[
                elseif( sxi(TC) == DOUBLE_C ) then
                        Point( xdc ) = paraddr( sxi )
                        do i = 1, npoints
                                xdc(i) = cdsin( xdc(i) )
                        enddo
])
                else
                        call remark( "sin: illegal argument type." )
                        return(ERR)
                endif
########   C O S   ########
        elseif ( fname == "cos" )  then
                call fcnargb( 1, sxi )
                if( sxi(TC) == INTEGER )  idummy = parcoerc( sxi, REAL )
                npoints  = parlen( sxi )
                if( sxi(TC) == REAL    )  then
                        Point( x ) = paraddr( sxi )
                        do i = 1, npoints
                                x(i)  = cos( x(i) )
                        enddo
                elseif( sxi(TC) == DOUBLE )  then
                        Point( xd ) = paraddr( sxi )
                        do i = 1, npoints
                                xd(i)  = cos( xd(i) )
                        enddo
ifelse(HAS_DOUBLE_COMPLEX,YES,[
                elseif( sxi(TC) == COMPLEX )  then
],[
                elseif( sxi(TC) == COMPLEX | sxi(TC) == DOUBLE_C )  then
])
                        Point( xc ) = paraddr( sxi )
                        do i = 1, npoints
                                xc(i) = cos( xc(i) )
                        enddo
ifelse(HAS_DOUBLE_COMPLEX,YES,[
                elseif( sxi(TC) == DOUBLE_C ) then
                        Point( xdc ) = paraddr( sxi )
                        do i = 1, npoints
                                xdc(i) = cdcos( xdc(i) )
                        enddo
])
                else
                        call remark( "cos: illegal argument type." )
                        return(ERR)
                endif
########   T A N   ########
        elseif ( fname == "tan" )  then
                call fcnargb( 1, sxi )
                if( sxi(TC) == INTEGER )  idummy = parcoerc( sxi, REAL )
                npoints  = parlen( sxi )
                if( sxi(TC) == REAL )  then
                        Point( x ) = paraddr( sxi )
                        do i = 1, npoints
                           x(i)  = tan( x(i) )
                        enddo
                elseif( sxi(TC) == DOUBLE )  then
                        Point( xd ) = paraddr( sxi )
                        do i = 1, npoints
                           xd(i)  = tan( xd(i) )
                        enddo
ifelse(HAS_DOUBLE_COMPLEX,YES,[
                elseif( sxi(TC) == COMPLEX )  then
],[
                elseif( sxi(TC) == COMPLEX | sxi(TC) == DOUBLE_C )  then
])
                        Point( xc ) = paraddr( sxi )
                        do i = 1, npoints
                                xc(i) = (exp((0.,2.0)*xc(i))+1.0)
                                if(abs(xc(i)) == 0.) then
                                        call remark("tan: error.")
                                        return(ERR)
                                else
                                        xc(i) = (0.,-1.0) + (0.,2.0)/xc(i)
                                endif
                        enddo
ifelse(HAS_DOUBLE_COMPLEX,YES,[
                elseif(sxi (TC) == DOUBLE_C ) then
                        Point( xdc ) = paraddr( sxi )
                        do i = 1, npoints
                                xdc(i) = (cdexp((0.,2.0d0)*xdc(i))+1.0d0)
                                if(cdabs(xdc(i)) == 0.) then
                                        call remark("tan: error.")
                                        return(ERR)
                                else
                                        xdc(i) = (0.,-1.0d0) + (0.,2.0d0)/xdc(i)
                                endif
                        enddo
])
                else
                        call remark( "tan: illegal argument type." )
                        return(ERR)
                endif
########   C O T   ########
        elseif ( fname == "cot" )  then
                call fcnargb( 1, sxi )
                if( sxi(TC) == INTEGER )  idummy = parcoerc( sxi, REAL )
                npoints  = parlen( sxi )
                if( sxi(TC) == REAL )  then
                        Point( x ) = paraddr( sxi )
                        do i = 1, npoints
                            x(i)  = cot( x(i) )
                        enddo
                elseif( sxi(TC) == DOUBLE )  then
                        Point( xd ) = paraddr( sxi )
                        do i = 1, npoints
                            xd(i)  = dcot( xd(i) )
                        enddo
ifelse(HAS_DOUBLE_COMPLEX,YES,[
                elseif( sxi(TC) == COMPLEX )  then
],[
                elseif( sxi(TC) == COMPLEX | sxi(TC) == DOUBLE_C )  then
])
                        Point( xc ) = paraddr( sxi )
                        do i = 1, npoints
                                xc(i) = (exp((0.,2.)*xc(i))-1.0)
                                if(abs(xc(i)) = 0.) then
                                        call remark("cot: error.")
                                        return(ERR)
                                else
                                        xc(i) = (0.,1.0) + (0.,2.)/xc(i)
                                endif
                        enddo
ifelse(HAS_DOUBLE_COMPLEX,YES,[
                elseif( sxi(TC) == DOUBLE_C )  then
                        Point( xdc ) = paraddr( sxi )
                        do i = 1, npoints
                                xdc(i) = (cdexp((0.,2.d0)*xdc(i))-1.0d0)
                                if(cdabs(xdc(i)) = 0.) then
                                        call remark("cot: error.")
                                        return(ERR)
                                else
                                        xdc(i) = (0.,1.0d0) + (0.,2.d0)/xdc(i)
                                endif
                        enddo
])
                else
                        call remark( "cot: illegal argument type." )
                        return(ERR)
                endif
########   A S I N   ########
        else if ( fname == "asin" )  then
                call fcnargb( 1, sxi )
                if( sxi(TC) > DOUBLE | sxi(TC) < 0) then
                        call remark( "asin: illegal argument type." )
                        return(ERR)
                endif
                if( sxi(TC) == INTEGER )  idummy = parcoerc( sxi, REAL )
                npoints       = parlen( sxi )
                if( sxi(TC) == REAL )  then
                    Point( x )    = paraddr( sxi )
                    do i = 1, npoints          #clip argument at +1 or -1.
                        if(abs(x(i)) > 1.000001) then
                                call remark("asin: abs(argument) > 1.000001")
                                return(ERR)
                        endif
                        x(i)        = sign( 1., x(i) )*min( 1., abs(x(i)) )
                        x(i)        = asin( x(i) )
                    enddo
                elseif( sxi(TC) == DOUBLE )  then
                    Point( xd )    = paraddr( sxi )
                    do i = 1, npoints          #clip argument at +1 or -1.
                        if(abs(xd(i)) > 1.000001) then
                                call remark("asin: abs(argument) > 1.000001")
                                return(ERR)
                        endif
                        xd(i)  = sign( 1.d0,xd(i))*min( 1.d0, abs(xd(i)))
                        xd(i)  = asin( xd(i) )
                    enddo
                endif
########   A C O S   ########
        else if ( fname == "acos" )  then
                call fcnargb( 1, sxi )
                if( sxi(TC) > DOUBLE | sxi(TC) < 0) then
                        call remark( "acos: illegal argument type." )
                        return(ERR)
                endif
                if( sxi(TC) == INTEGER )  idummy = parcoerc( sxi, REAL )
                npoints       = parlen( sxi )
                if( sxi(TC) == REAL )  then
                    Point( x )    = paraddr( sxi )
                    do i = 1, npoints          #clip argument at +1 or -1.
                        if(abs(x(i)) > 1.000001) then
                                call remark("acos: abs(argument) > 1.000001")
                                return(ERR)
                        endif
                        x(i)        = sign( 1., x(i) )*min( 1., abs(x(i)) )
                        x(i)        = acos( x(i) )
                    enddo
                elseif( sxi(TC) == DOUBLE )  then
                    Point( xd )    = paraddr( sxi )
                    do i = 1, npoints          #clip argument at +1 or -1.
                        if(abs(xd(i)) > 1.000001) then
                                call remark("acos: abs(argument) > 1.000001")
                                return(ERR)
                        endif
                        xd(i)  = sign( 1.d0,xd(i))*min( 1.d0, abs(xd(i)))
                        xd(i)        = acos( xd(i) )
                    enddo
                endif
########   A T A N   ########
        elseif ( fname == "atan" )  then
                call fcnargb( 1, sxi )
                npoints       = parlen( sxi )
                if(sxi(TC) == INTEGER ) idummy = parcoerc( sxi,  REAL)
                if(sxi(TC) == REAL )  then
                        Point( x )    = paraddr( sxi )
                        do i = 1, npoints
                                x(i)        = atan( x(i) )
                        enddo
                elseif( sxi(TC) == DOUBLE )  then
                        Point( xd ) = paraddr( sxi )
                        do i = 1, npoints
                                xd(i)  = atan( xd(i) )
                        enddo
                else
                        call remark( "atan: illegal argument type." )
                        return(ERR)
                endif
########   A T A N 2   ########
        elseif ( fname == "atan2" )  then
                call fcnargb( 1, syi )
                call fcnargb( 2, sxi )
                npointsy = parlen( syi )
                npointsx = parlen( sxi )
                if(npointsx <> npointsy & npointsx <> 1 & npointsy <> 1)  then
                        call remark( "atan2: wrong length of arguments." )
                        return(ERR)
                endif
                if( sxi(TC) > DOUBLE | sxi(TC) < 0 | syi(TC) > DOUBLE | syi(TC) < 0) then
                        call remark( "atan2: bad argument type")
                        return(ERR)
                endif
                if( sxi(TC) == INTEGER )  idummy = parcoerc( sxi, REAL )
                if( syi(TC) == INTEGER )  idummy = parcoerc( syi, REAL )
		if( sxi(TC) > syi(TC) ) idummy = parcoerc ( syi , sxi(TC) )
		if( sxi(TC) < syi(TC) ) idummy = parcoerc ( sxi , syi(TC) )
	  	if(npointsx == 1) then
                  if( syi(TC) == REAL )  then
                    Point( x )  = paraddr( sxi )
		    rvalue = x(1)
                  elseif( syi(TC) == DOUBLE )  then
                    Point( xd )  = paraddr( sxi )
		    dvalue = xd(1)
		  endif
	  	  sxi(N1) = npointsy
		  sxi(N) = 1
                  call parrel(sxi) # ZCM 11/13/95 discovered by basltest
                  call parget(sxi)
		endif

                if( syi(TC) == REAL )  then
                  Point( x )  = paraddr( sxi )
                  Point( y )  = paraddr( syi )
		  if(npointsx == 1) then
                    do i = npointsy, 1, -1
#avoid division by 0.
                        del = 0.
                        if(rvalue < 0.) del = sign(Pi, y(i))
                        if(rvalue == 0.) then
                           if (y (i) ~= 0) then
                               x(i) = sign(Pi/2., y(i))
                           else
                               call baserror ("atan2 (0., 0.) is not defined.")
                               return (ERR)
                           endif
                        else
                            x(i) = atan( y(i)/ rvalue ) + del
                        endif
                    enddo
		  else
                    do i = npointsx, 1, -1
		        k = i
		        if( npointsy == 1) k = 1
#avoid division by 0.
                        del = 0.
                        if(x(i) < 0.) del = sign(Pi, y(k))
                        if(x(i) == 0.) then
                           if (y (k) ~= 0) then
                               x(i) = sign(Pi/2., y(k))
                           else
                               call baserror ("atan2 (0., 0.) is not defined.")
                               return (ERR)
                           endif
                        else
                            x(i) = atan( y(k)/ x(i) ) + del
                        endif
                    enddo
		  endif
                elseif( syi(TC) == DOUBLE )  then
                    Point( xd )    = paraddr( sxi )
                    Point( yd )    = paraddr( syi )
		  if(npointsx == 1) then
                    do i = npointsy, 1, -1
#avoid division by 0.
                        ddel = 0.
                        if(dvalue < 0.) ddel = sign(PiD, yd(i))
                        if(dvalue == 0.) then
                           if (yd (i) ~= 0) then
                               xd(i) = sign(Pi/2.d00, yd(i))
                           else
                               call baserror ("atan2 (0., 0.) is not defined.")
                               return (ERR)
                           endif
                        else
                            xd(i) = atan( yd(i)/ dvalue ) + ddel
                        endif
                    enddo
		  else
                    do i = npointsx, 1, -1
		        k = i
		        if( npointsy == 1) k = 1
#avoid division by 0.
                        ddel = 0.
                        if(xd(i) < 0.) ddel = sign(PiD, yd(k))
                        if(xd(i) == 0.) then
                           if (yd (k) ~= 0) then
                               xd(i) = sign(Pi/2.d00, yd(k))
                           else
                               call baserror ("atan2 (0., 0.) is not defined.")
                               return (ERR)
                           endif
                        else
                            xd(i) = atan( yd(k)/ xd(i) ) + ddel
                        endif
                    enddo
		  endif
                endif
                call parrel( syi )
###################   H Y P E R B O L I C  F U N C T I O N S   ###########
########   S I N H   ########
        elseif ( fname == "sinh" )  then
                call fcnargb( 1, sxi )
                if( sxi(TC) == INTEGER) idummy = parcoerc(sxi, REAL)
                npoints       = parlen( sxi )
                if( sxi(TC) == REAL) then
                        Point( x )    = paraddr( sxi )
                        do i = 1, npoints
                                x(i) = sinh( x(i) )
                        enddo
                elseif( sxi(TC) == DOUBLE )  then
                        Point( xd ) = paraddr( sxi )
                        do i = npoints, 1, -1
                                xd(i)  = sinh( xd(i) )
                        enddo
ifelse(HAS_DOUBLE_COMPLEX,YES,[
                elseif( sxi(TC) == COMPLEX )  then
],[
                elseif( sxi(TC) == COMPLEX | sxi(TC) == DOUBLE_C )  then
])
                        Point( xc )    = paraddr( sxi )
                        do i = 1, npoints
                                xc(i)  = .5*(exp(xc(i))-exp(-xc(i)))
                        enddo
ifelse(HAS_DOUBLE_COMPLEX,YES,[
                elseif( sxi(TC) == DOUBLE_C) then
                        Point( xdc )    = paraddr( sxi )
                        do i = 1, npoints
                                xdc(i)  = .5d0*(cdexp(xdc(i))-cdexp(-xdc(i)))
                        enddo
])
                else
                        call remark( "sinh: illegal argument type." )
                        return(ERR)
                endif
########   C O S H   ########
        elseif ( fname == "cosh" )  then
                call fcnargb( 1, sxi )
                if( sxi(TC) == INTEGER) idummy = parcoerc(sxi, REAL)
                npoints       = parlen( sxi )
                if( sxi(TC) == REAL) then
                        Point( x )    = paraddr( sxi )
                        do i = 1, npoints
                                x(i) = cosh( x(i) )
                        enddo
                elseif( sxi(TC) == DOUBLE )  then
                        Point( xd ) = paraddr( sxi )
                        do i = npoints, 1, -1
                                xd(i)  = cosh( xd(i) )
                        enddo
ifelse(HAS_DOUBLE_COMPLEX,YES,[
                elseif( sxi(TC) == COMPLEX )  then
],[
                elseif( sxi(TC) == COMPLEX | sxi(TC) == DOUBLE_C )  then
])
                        Point( xc )    = paraddr( sxi )
                        do i = 1, npoints
                                xc(i)  = .5*(exp(xc(i))+exp(-xc(i)))
                        enddo
ifelse(HAS_DOUBLE_COMPLEX,YES,[
                elseif( sxi(TC) == DOUBLE_C) then
                        Point( xdc )    = paraddr( sxi )
                        do i = 1, npoints
                                xdc(i)  = .5d0*(cdexp(xdc(i))+cdexp(-xdc(i)))
                        enddo
])
                else
                        call remark( "cosh: illegal argument type." )
                        return(ERR)
                endif
########   T A N H   ########
        elseif ( fname == "tanh" )  then
                call fcnargb( 1, sxi )
                if(sxi(TC) == INTEGER) idummy = parcoerc(sxi, REAL)
                npoints       = parlen( sxi )
                if( sxi(TC) == REAL) then
                        Point( x )    = paraddr( sxi )
                        do i = 1, npoints
                                x(i) = tanh( x(i) )
                        enddo
                elseif( sxi(TC) == DOUBLE )  then
                        Point( xd ) = paraddr( sxi )
                        do i = npoints, 1, -1
                                xd(i)  = tanh( xd(i) )
                        enddo
ifelse(HAS_DOUBLE_COMPLEX,YES,[
                elseif( sxi(TC) == COMPLEX )  then
],[
                elseif( sxi(TC) == COMPLEX | sxi(TC) == DOUBLE_C )  then
])
                        Point( xc )    = paraddr( sxi )
                        do i = 1, npoints
                          xc(i)=(exp(xc(i))-exp(-xc(i)))/(exp(xc(i))+exp(-xc(i)))
                        enddo
ifelse(HAS_DOUBLE_COMPLEX,YES,[
                elseif( sxi(TC) == DOUBLE_C) then
                        Point( xdc )    = paraddr( sxi )
                        do i = 1, npoints
                          xdc(i)=(cdexp(xdc(i))-cdexp(-xdc(i)))/\
                                 (cdexp(xdc(i))+cdexp(-xdc(i)))
                        enddo
])
                else
                        call remark( "tanh: illegal argument type." )
                        return(ERR)
                endif
        else #not a builtin function
                fndflg = FALSE
                return(OK)
        endif
####################   F I N I S H   ####################
900     continue
        return(OK)
        end
