        function parbfcn3( nargs, fname, sxi, fndflg)
# avoid xmp problems !
clll.   optimize level g
#
#       ----- written by Andrew Zachary 4/3/85
#               fixed bugs in inner, outer  6/25/85 dubois
#               changed to handle structured argument list 6/10/85
#             rewrite for call from parxfcn dubois 1/8/87
#             changed to accomodate package builtins 12/10/87
#               rewrite to add double - Peter Willmann 3/30/89
#
#       reduces the production
#
#       <rid>::= reference <args>
#
#       for the builtin functions
#
#       Revised: Zane C. Motteler
#                January 1990
#       Purpose: Change fcnargb call to fcnargbp when NODATA is needed
#                COPY most of the time, because a copy of the data is needed.
#                NODATA for the rest, because only information about the data
#                       (length, type, ...) is needed
#       This supports lazy evaluation of function arguments (they are only
#       evaluated as -- and when -- needed).
#       Revised: Yu-Hsing Chiu
#                December 1995
#       Purpose: extend the functionalities of "shape" to expand a base matrix
#                 to a higher dimensional matrix.  The higher dimesions can be
#		 interlaid with the dimensions of the base matrix.
#
#       Revised: Zane C. Motteler
#                August 1999
#       Purpose: stack and stack pointer are no longer necessary.
#                position of stack frame is known. arguments
#                run from rlinkp+1 to rsp.
Use(Controls)
Use(Functions)
        integer parbfcn3, nargs
        logical fndflg, zerof
        integer sui(SSWIDTH), svi(SSWIDTH)
	external parkill
        Varname fname
        character*(32) str,fstr
        character*(OUTLINE) msg
        Dynamic(     x   ,    real   , 1 )
        Dynamic(    xc   ,  complex  , 1 )
        Dynamic(    xd   , double precision, 1 )
        Dynamic(     y   ,    real   , 1 )
        Dynamic(    yc   ,  complex  , 1 )
        Dynamic(    yd   , double precision, 1 )
        Dynamic(    ix   ,  integer  , 1 )
        Dynamic(    iy   ,  integer  , 1 )
        Dynamic(    iz   ,  integer  , 1 )
        Dynamic(    xl   ,  logical  , 1 )
        Dynamic(    yl   ,  logical  , 1 )
        Address Point(cx), Point(cy), Point(xs), Point(ys)
ifelse(HAS_DOUBLE_COMPLEX,YES,[
        Dynamic(    xdc   , double complex, 1 )
        Dynamic(    ydc   , double complex, 1 )
])
#
        integer sxi(SSWIDTH), syi(SSWIDTH), szi(SSWIDTH)
        integer parlen, parcoerc, utgetcl
        Address paraddr
        external paraddr, parlen, parcoerc, utgetcl, strgetcl
        integer parint, strgetcl
        external parint, uttolc, uttouc
        double precision  dval
        real rval
        integer i, j
        integer sslen, start, sublen, nc
        integer ival, fw, nd, ts
#additional declaration for minus dimensions expansion
        external parmdexpn, parreal, pardble, strindex
        integer parmdexpn, parreal, pardble, strindex
        external parget, parrel
	integer tc,icur
	integer mdc,mdp(7),mdv(7)
        logical bdfin
        integer newlen, minlen

clll.   option nodyneqv

        fndflg = TRUE

#  begin search through function list
########   S H A P E   ######################
        if(fname == "shape") then
#if only one argument, return shape, else set it.
                if(nargs == 1) then  #return info about size
#
# for "y=shape(z)" call
#
#                       data is not actually needed for this function
                        call fcnargbp( 1, syi)
		        if(syi(TC) = FUNCTION_TYPE| syi(TC)==NULL_TYPE) then
		           call remark("shape: illegal argument type.")
			   return(ERR)
		        endif
                        sxi(N) = 1 ; sxi(N1) = max(syi(N),1) ; sxi(M1) = 1
                        sxi(TC) = INTEGER
                        call parget(sxi)
                        Point(ix) = paraddr(sxi)
                        ix(1)=1
                        do i = 1, syi(N)
                           ix(i) = syi(N1-1+i)
                        enddo
		        call parkill(syi)
                else   #more than one argument, reshape
                        call fcnargb( 1, sxi)
                        if (sxi(TC) == NULL_TYPE) then
                           call remark("shape: null is an illegal 1st argument")
                           return(ERR)
                        endif
                        n = parlen(sxi)
			if (n == 0) then
				call remark("shape: zero length 1st argument.")
				return(ERR)
			endif
                        m = 1
                        if(nargs == 2) then
#
# for "y=shape(x,shape(z))" call
#
# this including the case of 2nd argument is a linear vector
# the expansion to minus dimension may be applied for this situation
                                bdfin = (n .eq. 1)
                                sxi(N) = 0
				mdc = 0
                                icur = 0
                                call fcnargb( 2, syi)
                                if(syi(TC)  <> INTEGER | syi(N) > 1)  then
                                        call remark(
                                "shape: second argument not an integer vector")
                                return(ERR)
                                endif
                                Point(iy) = paraddr(syi)
                                leny = parlen( syi)
                                do i = 1, leny
                                  if (bdfin) then
				     iy(i) = -iabs(iy(i))
                                  endif
                                  if (iy(i) < 0) then
                                     mdc = mdc + 1
				     mdp(mdc) = i
                                     mdv(mdc) = -iy(i)
                                  else
                                     sxi(N) = sxi(N) + 1
                                     sxi(N1+icur) = iy(i)
                                     sxi(M1+icur) = 1
                                     icur = icur + 1
                                     m = m*iy(i)
                                     if (m == n) bdfin = .true.
                                  endif
                                enddo
                                call parrel(syi)
                       else
#
# for "y=shape(x,i,j,k,...)" call
#
				bdfin = (n .eq. 1) #base dims done
                                sxi(N) = 0		#initialize dim count
                                mdc = 0		#minus dimension count
                                icur = 0
                                do i = 2, nargs
                                  call fcnargb( i,syi)
                                  if(syi(TC) <> INTEGER | parlen(syi) <> 1) then
                                        call remark(
                                  "shape: argument not an integer scalar")
                                        write(msg,9000) i
                                        call remark(msg)
9000    format("Argument number ",i5)
                                        return(ERR)
                                  endif
                                  Point(iy) = paraddr(syi)
                                  if (bdfin) then #for backwards compatible
                                     iy(1) = -iabs(iy(1))
				  endif
				  if (iy(1) < 0) then	# minus dimesion spec
                                     mdc = mdc + 1
				     mdp(mdc) = i-1	# minus dim position
				     mdv(mdc) = -iy(1)	# minus dim true value
				  else
				     sxi(N) = sxi(N) + 1	#add pos dim
                                     sxi(N1+icur) = iy(1)
                                     sxi(M1+icur) = 1
                                     icur = icur + 1
                                     m = m*iy(1)
                                     if (m == n) bdfin = .true.
                                  endif
                                  call parrel(syi)
                                enddo
                        endif
			# the size of m and n should be equal
			# for positive dimension list
                        if(m <> n) then
                                call remark(
                                "shape: size doesn't match arguments.")
                                return(ERR)
                        else
# build base matrix with assigned positive dimensions
#
# for "y=shape(x,i,j,k,...)" call
#
			# the call fcnargb is to identify the type of x
			# note the iarg = 1
		 	# in y=shape(x,i,j,k,...) call
                               call fcnargb( 1, syi)
                               call parget(sxi)
                               if(syi(TC) == INTEGER) then
                                  Point(ix) = paraddr(sxi)
                                  Point(iy) = paraddr(syi)
                                  do j=1, n
                                        ix(j) = iy(j)
                                  enddo
                               elseif(syi(TC) == REAL) then
                                  Point(x) = paraddr(sxi)
                                  Point(y) = paraddr(syi)
                                  do j=1, n
                                        x(j) = y(j)
                                  enddo
                               elseif(syi(TC) == DOUBLE) then
                                  Point(xd) = paraddr(sxi)
                                  Point(yd) = paraddr(syi)
                                  do j = n, 1, -1
                                        xd(j) = yd(j)
                                  enddo
ifelse(HAS_DOUBLE_COMPLEX,YES,[
                               elseif(syi(TC) == COMPLEX) then
],[
                               elseif(syi(TC) == COMPLEX |
                                      syi(TC) == DOUBLE_C ) then
])
                                  Point(xc) = paraddr(sxi)
                                  Point(yc) = paraddr(syi)
                                  do j = 1, n
                                        xc(j) = yc(j)
                                  enddo
ifelse(HAS_DOUBLE_COMPLEX,YES,[
                               elseif(syi(TC) == DOUBLE_C) then
                                  Point(xdc) = paraddr(sxi)
                                  Point(ydc) = paraddr(syi)
                                  do j = 1, n
                                        xdc(j) = ydc(j)
                                  enddo
])
                               elseif(syi(TC) == LOGICAL) then
                                  Point(xl) = paraddr(sxi)
                                  Point(yl) = paraddr(syi)
                                  do j = 1, n
                                        xl(j) = yl(j)
                                  enddo
                               elseif(syi(TC) < 0) then	
                                  Point(ix) = paraddr(sxi)
                                  Point(iy) = paraddr(syi)
                                  jindex = 0
                                  kindex = 0
                                  do j = 1, n
                                  call zmovechr(ix, jindex, iy, kindex, -syi(TC))
                                     jindex = jindex-syi(TC)
                                     kindex = kindex-syi(TC)
                                  enddo
                               else
                                  call remark(
                                  "shape:  shape: invalid type for arg1")
                                  return(ERR)
                               endif
##################################################
# expand for minus dimensions
			       if (mdc > 0) then
				  tc = syi(TC)
                                  if (parmdexpn(tc,mdc,mdp,mdv,sxi)==ERR) then
				     call remark("minus dim expansion error")
                                     return(ERR)
	                          endif
                               endif

                               call parrel(syi)
                            endif
                        endif
#########   S U B S T R #########

        elseif (fname = 'substr') then

### -- Get the first argument.  Verify that it is a scalar of type character.

           call fcnargb(1, syi)

           if (syi(TC) >= 0) then
              call remark ("substr:  illegal argument type")
              return(ERR)
           endif

           if (parlen(syi) <> 1) then
              call remark("substr:  scalar expected")
              return(ERR)
           endif

           Point(iy) = paraddr(syi)
           len = abs(syi(TC))

###    -- Get the 1-origin index of the starting character.

           call fcnargb(2, szi)
           if (parcoerc(szi, INTEGER) = ERR) then
              call remark ("substr: bad type for index")
              return (ERR)
           endif
           Point(iz) = paraddr(szi)
           start = iz(1)
           call parrel(szi)

###    -- Get the length of the substring.

           call fcnargb(3, sxi)
           if (parcoerc(sxi, INTEGER) = ERR) then
              call remark ("substr: bad type for length")
              return (ERR)
           endif
           Point(ix) = paraddr(sxi)
           sslen = ix(1)
           call parrel(sxi)
           if (sslen <= 0) then
              call remark ("substr: length must be > 0")
              return (ERR)
           endif

           if (start > len | start <= 0) then
              call remark ("substr: bad starting index")
              return (ERR)
           endif
           sublen = min(sslen, len-start+1)
           sxi(N) = 0
           sxi(TC) = -sublen
           sxi(NAML) = 1 # so it knows address is in literal table.(ZCM 4/10/95)
           call parget (sxi)
           Point(cx) = paraddr(sxi)
           call smovatoa(Point(cx), 0, Point(iy), start-1, sublen)
           call parrel (syi)

#########   S T R L E N #########

        elseif (fname = 'strlen') then

###  -- Get the argument.  Verify that it is a scalar of type character.

#          data is not actually needed for this function
           call fcnargbp(1, syi)

           if (syi(TC) >= 0) then
              call remark ("strlen:  illegal argument type")
              return(ERR)
           endif

           if (parlen(syi) <> 1) then
              call remark("strlen:  scalar expected")
              return(ERR)
           endif

           sxi(N) = 0
           sxi(TC) = INTEGER
           call parget(sxi)
           Point(ix) = paraddr(sxi)
           ix(1) = abs(syi(TC))
           call parkill(syi)
#########   T R I M    #########
        elseif (fname = 'trim') then

###    -- Get the argument.  Verify that it is a scalar of type character.

           call fcnargb(1, syi)

           if (syi(TC) >= 0) then
              call remark ("trim:  illegal argument type")
              return(ERR)
           endif

           if (parlen(syi) <> 1) then
              call remark("trim:  scalar expected")
              return(ERR)
           endif

           Point(ys) = paraddr(syi)
           len = abs(syi(TC))
	   start = 1
	   call strskipbl(Point(ys),len,start)
	   ihit = strgetcl(Point(ys), start, len - start)

           sxi(N) = 0
           sxi(TC) = -ihit
           sxi(NAML) = 1 # needs to be nonzero for name in literal table
           call parget (sxi)
           Point(cx) = paraddr(sxi)
           call smovatoa (Point (cx), 0, Point (ys), start, ihit)
           call parrel (syi)

#########   T R I M L    #########
        elseif (fname = 'triml') then

###    -- Get the argument.  Verify that it is a scalar of type character.

           call fcnargb(1, syi)

           if (syi(TC) >= 0) then
              call remark ("triml:  illegal argument type")
              return(ERR)
           endif

           if (parlen(syi) <> 1) then
              call remark("triml:  scalar expected")
              return(ERR)
           endif

           Point(ys) = paraddr(syi)
           len = abs(syi(TC))
	   start = 1
	   call strskipbl(Point(ys),len,start)
           newlen = len-start
           sxi(N) = 0
           sxi(TC) = -newlen
           sxi(NAML) = 1 # so it knows address is in literal table.(ZCM 4/10/95)
           call parget (sxi)
           Point(cx) = paraddr(sxi)
           call smovatoa (Point(cx), 0, Point(ys), start, newlen)
           call parrel (syi)

#########   T R I M R   #########

        elseif (fname = 'trimr') then

###    -- Get the argument.  Verify that it is a scalar of type character.

           call fcnargb(1, syi)

           if (syi(TC) >= 0) then
              call remark ("trimr:  illegal argument type")
              return(ERR)
           endif

           if (parlen(syi) <> 1) then
              call remark("trimr:  scalar expected")
              return(ERR)
           endif

           Point(ys) = paraddr(syi)
           len = abs(syi(TC))
           ihit = strgetcl(Point(ys), 0, len)
           
           sxi(N) = 0
           sxi(TC) = -ihit
           sxi(NAML) = 1 # so it knows address is in literal table.(ZCM 4/10/95)
           call parget (sxi)
           Point(cx) = paraddr(sxi)
           call smovatoa (Point(cx), 0, Point(ys), 0, ihit)
           call parrel (syi)

##################   F O R M A T   ##################
        elseif(fname='format') then
# get first two arguments, number and field width
                call fcnargb(1, syi)
                call fcnargb(2, szi)
# revision by ZCM 9/15/95: if 4th argument is 2, coerce the number to
# real and print it out with e format.
                if ( nargs >= 3 ) then
                        # get and check third argument
                        call fcnargb(3, sui)
                        if (parint(sui, nd) <> OK ) then
                                call remark(
                'FORMAT: number of decimal places must be of type integer')
                                return(ERR)
                        elseif( nd < 0) then
                                call remark(
                'FORMAT: number of decimal places must be positive.')
                                return(ERR)
                        endif
                endif
                if ( nargs >= 4) then
                        # get and check fourth argument
                        call fcnargb(4, svi)
                        if (parint(svi, ts) <> OK) then
                                call remark(
                                'FORMAT: type specification must be integer')
                                return(ERR)
                        endif
                        if ( ts == 2 ) then
                           # convert to double number
                           if( pardble(syi, dval) == ERR)return(ERR)
                        endif
                endif
# check that field width is legal
                if (parint(szi, fw) <> OK) then
                        call remark('FORMAT: field width not integer')
                        return(ERR)
                endif
                zerof = FALSE
                if (abs(fw) > 32) then
                        call remark('FORMAT: field width too large')
                        return(ERR)
                elseif (fw = 0) then    # will skip leading blanks
                        len = 32
                elseif (fw < 0) then   # zero-fill to n digits
                        fw = abs(fw)
                        len = fw
                        zerof = TRUE
                else
                        len = fw
                endif
# call subroutines to do conversion
                if(syi(TC) == INTEGER) then
                        if (nargs <> 2) then
                                call remark(
'FORMAT:conversion of integer to string requires exactly two arguments')
                                return(ERR)
                        elseif (parint(syi, ival) <> OK)
                                call remark(
'FORMAT:conversion of integer to string requires integer second argument')
                                return(ERR)
                        endif
                        write(fstr, 24000) len
                        write(str,fstr) ival
24000 format('(i',i2,')')
                elseif(syi(TC) == REAL) then
                        if (nargs <> 4) then
                                call remark(
        'FORMAT:conversion of real to string requires four arguments')
                                return(ERR)
                        endif
                        # convert to real number
                        if( parreal(syi, rval) == ERR)return(ERR)
                        if (ts = 0) then
				write(fstr,24100) len,nd
				write(str,fstr) rval
24100 format('(1Pe',i2,'.',i2,')')
                        elseif (ts=1) then
				write(fstr,24200) len,nd
				write(str,fstr) rval
24200 format('(f',i2,'.',i2,')')
                        else
                                call remark(
                                'FORMAT:type specification must be 0 or 1')
                                return(ERR)
                        endif
# release storage for args 3 and 4
                        call parrel(sui)
                        call parrel(svi)
                elseif(syi(TC) == DOUBLE) then
                        if (nargs <> 4) then
                                call remark(
        'FORMAT:conversion of double to string requires four arguments')
                                return(ERR)
                        endif
# convert to double precision number
                        if( pardble(syi, dval) == ERR) return(ERR)
                        if (ts = 0) then
				write(fstr,24300) len,nd
				write(str,fstr) dval
24300 format('(1Pd',i2,'.',i2,')')
                        elseif (ts=1) then
				write(fstr,24200) len,nd
				write(str,fstr) dval
                        elseif (ts=2) then
                                write(fstr,24100) len,nd
                                write(str,fstr) dval
                        else
                                call remark(
                                'FORMAT:type specification must be 0 , 1, or 2')
                                return(ERR)
                        endif
# release storage for args 3 and 4
                        call parrel(sui)
                        call parrel(svi)
                else
                        call remark('FORMAT: illegal argument type')
                        return(ERR)
                endif
# release storage for args 1 and 2
                call parrel(syi)
                call parrel(szi)
# create resultant stack element
                if (fw <> 0) then
                   start = 1
                   newlen = len
                   if(zerof) then  #zero-fill it
		     do i=start, newlen-1
                       if(str(i:i) = '-') then
                          str(i:i) = '0'
                          str(start:start)='-'
                          break
                       endif
                       if(str(i:i) <> ' ') break
                       str(i:i)='0'
                     enddo
                   endif
                else            # no leading blanks (blank passed as integer)
			do start=1, len-1
                           if(str(start:start) <> ' ') break
                        enddo
                        newlen = len - start + 1
                endif
                sxi(TC) = -newlen
                sxi(N) = 0
                sxi(NAML) = 1 # forces string to be in literal table
                sxi(NS) = 0   # of course it has no subscripts (ZCM 8/3/95)
                call parget(sxi)
                Point(cx) = paraddr(sxi)
                minlen = min (newlen, len - start + 1)
                call smovftoa (Point (cx), 0, str(start:len), 0, minlen)
                if (minlen < newlen) call sblkset (Point (cx), minlen, newlen - minlen)

#########   I N D E X   ########
        elseif( fname == "index" )  then
                call fcnargb(1, syi)
                call fcnargb(2, szi)

                if(syi(TC) >= 0 | szi(TC) >= 0) then
                        call remark("index: character expected")
                        return(ERR)
                endif

                if(parlen(syi) <> 1 | parlen(szi) <> 1) then
                        call remark("index: scalars expected")
                        return(ERR)
                endif

                Point(ys) = paraddr(syi)
                len = -syi(TC)
                Point(xs) = paraddr(szi)
                sublen = -szi(TC)

                sxi(N) = 0
                sxi(TC) = INTEGER
                call parget(sxi)
                Point(ix) = paraddr(sxi)

		ix(1) = strindex(Point (ys), 0, len, Point (xs), 0, sublen)

                call parrel(syi)
                call parrel(szi)

#########   T O L O W E R #########
        elseif (fname == 'tolower') then

###    -- Get the argument.  Verify that it is a scalar of type character.

           call fcnargb(1, syi)

           if (syi(TC) >= 0) then
              call remark ("tolower:  illegal argument type")
              return(ERR)
           endif

           if (parlen(syi) <> 1) then
              call remark("tolower:  scalar expected")
              return(ERR)
           endif
           nc = -syi(TC)
           Point(cy) = paraddr(syi)
           sxi(N) = 0
           sxi(TC) = -nc
           sxi(NAML) = 1 # so it knows address is in literal table.(ZCM 4/10/95)
           call parget (sxi)
           Point(cx) = paraddr(sxi)
           call strtolc (Point(cy), Point(cx), nc)
           call parrel (syi)

#########   T O U P P E R #########
        elseif (fname == 'toupper') then

###    -- Get the argument.  Verify that it is a scalar of type character.

           call fcnargb(1, syi)

           if (syi(TC) >= 0) then
              call remark ("toupper:  illegal argument type")
              return(ERR)
           endif

           if (parlen(syi) <> 1) then
              call remark("toupper:  scalar expected")
              return(ERR)
           endif
           nc = -syi(TC)
           Point(cy) = paraddr(syi)
           sxi(N) = 0
           sxi(TC) = -nc
           sxi(NAML) = 1 # so it knows address is in literal table.(ZCM 4/10/95)
           call parget (sxi)
           Point(cx) = paraddr(sxi)
           call strtouc (Point(cy), Point(cx), nc)
           call parrel (syi)


        else #not a builtin function
                fndflg = FALSE
                return(OK)
        endif
####################   F I N I S H   ####################
900     continue
        return(OK)
        end
