        function parbfcn4( nargs, fname, sxi, fndflg)
# avoid xmp problems !
clll.   optimize level g
#
#       ----- written by Andrew Zachary 4/3/85
#               fixed bugs in inner, outer  6/25/85 dubois
#               changed to handle structured argument list 6/10/85
#             rewrite for call from parxfcn dubois 1/8/87
#             changed to accomodate package builtins 12/10/87
#               rewrite to add double - Peter Willmann 3/30/89
#
#       reduces the production
#
#       <rid>::= reference <args>
#
#       for the builtin functions
#
#       Revised: Zane C. Motteler
#                January 1990
#       Purpose: Change fcnargb call to fcnargbp when NODATA is needed
#                COPY most of the time, because a copy of the data is needed.
#                NODATA for the rest, because only information about the data
#                       (length, type, ...) is needed
#
#       Revised: Zane C. Motteler
#                August 1999
#       Purpose: stack and stack pointer are no longer necessary.
#                position of stack frame is known. arguments
#                run from rlinkp+1 to rsp.
Use(Controls)
Use(Functions)
Use(Type_codes)
        integer parbfcn4, nargs
        logical fndflg
	external parkill
        Varname fname
        Dynamic(    xc   ,  complex  , 1 )
        Dynamic(     y   ,    real   , 1 )
        Dynamic(    yc   ,  complex  , 1 )
        Dynamic(    yd   , double precision, 1 )
        Dynamic(    ix   ,  integer  , 1 )
        Dynamic(    iy   ,  integer  , 1 )
        Dynamic(    iz   ,  integer  , 1 )
        Dynamic(     x    ,  real     ,1)
        Dynamic(    xd    , double precision, 1)
ifelse(HAS_DOUBLE_COMPLEX,YES,[
        Dynamic(    xdc   , double complex , 1)
        Dynamic(    ydc   , double complex , 1)
])
        integer sxi(SSWIDTH), syi(SSWIDTH), szi(SSWIDTH)
        integer npointsy
        integer npointsx, npointsz
        integer parlen, parcoerc, struadd
        Address paraddr
        external paraddr, parlen, parcoerc, struadd
        integer i
        character*(OUTLINE) errmsg
clll.   option nodyneqv
#  begin search through function list

        fndflg = TRUE

#########   D I A G  #########
        if(fname == "diag") then
# create a matrix whose k'th diagonal is the first argument, where
# k is the second argument...k = 0 default
# result has type of first argument
                call fcnargb( 1, syi)
                call pardim(syi)
                if(syi(TC)<>INTEGER & syi(TC)<>REAL&syi(TC)<>DOUBLE_C&
                   syi(TC)<>DOUBLE & syi(TC)<>COMPLEX) then
                        call remark("diag: first argument has bad type.")
                        return(ERR)
                endif
                ndiag = 0
                if(nargs == 2) then
                        call fcnargb( 2, szi)
                        if( parcoerc(szi,INTEGER) == ERR) then
                                call remark("diag: bad type for second arg.")
                                return(ERR)
                        endif
                        Point(ix) = paraddr(szi)
                        ndiag = ix(1)
                        call parrel(szi)
                endif
                ny = parlen(syi)
                n = ny + abs(ndiag)
                sxi(N) = 2
                sxi(N1) = n ; sxi(M1) = 1 ; sxi(I1)=1
                sxi(N2) = n ; sxi(M2) = 1 ; sxi(I2)=1
                sxi(TC) = syi(TC)
                call parget(sxi)
                if(ndiag >= 0) then
                        k = 1 + ndiag*n
                else
                        k = 1 + abs(ndiag)
                endif
                nskip  = n + 1  #plus one since it's diagonal                 
                if(sxi(TC)==INTEGER) then
                    Point(iy) = paraddr(syi)
                    Point(ix) = paraddr(sxi)
                    do i=1,n*n
                       ix(i) = 0
                    enddo
                    do i= 1, ny
                         ix(k+(i-1)*nskip) = iy(i)
                    enddo
                elseif(sxi(TC)==REAL) then
                    Point(y) = paraddr(syi)
                    Point(x) = paraddr(sxi)
                    do i=1,n*n
                       x(i) = 0.0
                    enddo
                    do i= 1, ny
                         x(k+(i-1)*nskip) = y(i)
                    enddo
                elseif(sxi(TC)==DOUBLE) then
                    Point(yd) = paraddr(syi)
                    Point(xd) = paraddr(sxi)
                    do i=1,n*n
                       xd(i) = 0.0d0
                    enddo
                    do i= 1, ny
                         xd(k+(i-1)*nskip) = yd(i)
                    enddo
ifelse(HAS_DOUBLE_COMPLEX,YES,[
                elseif(sxi(TC) == COMPLEX) then
],[
                elseif(sxi(TC) == COMPLEX | sxi(TC) == DOUBLE_C) then
])
                    Point(yc) = paraddr(syi)
                    Point(xc) = paraddr(sxi)
                    do i=1,n*n
                       xc(i) = (0.0,0.0)
                    enddo
                    do i= 1, ny
                         xc(k+(i-1)*nskip) = yc(i)
                    enddo
ifelse(HAS_DOUBLE_COMPLEX,YES,[
                elseif(sxi(TC) == DOUBLE_C) then
                    Point(ydc) = paraddr(syi)
                    Point(xdc) = paraddr(sxi)
                    do i=1,n*n
                       xdc(i) = (0.0,0.0)
                    enddo
                    do i= 1, ny
                         xdc(k+(i-1)*nskip) = ydc(i)
                    enddo
])
                endif
                call parrel(syi)
#########   R A N G E X   #########
        elseif(fname == "rangex") then
#               data is not actually needed for this function
                call fcnargbp( 1, syi)
		if(syi(TC) = FUNCTION_TYPE| syi(TC)==NULL_TYPE) then
		   call remark("rangex: illegal argument type.")
		   return(ERR)
		endif

                npointsy = parlen(syi)
                if(npointsy == 1) then
                        syi(N) = 1 ; syi(N1) = 1 ; syi(M1) = 1
                elseif (npointsy==0) then
                        syi(N) = 1 ; syi(N1) = 1 ; syi(M1) = 1
                        syi(M1) = 1; syi(N1) = 0
                endif
                sxi(N) = 2
                sxi(TC) = INTEGER
                sxi(N1) = syi(N) ; sxi(N2) = 2
                sxi(M1) = 1     ; sxi(M2) = 1
                call parget(sxi)
                Point(ix) = paraddr(sxi)
                do i = 1, syi(N)
                        ix(i) = syi(M1-1+i)   #low index
                        ix(i+sxi(N1)) = syi(N1-1+i) + syi(M1-1+i) - 1  #high
                enddo
		call parkill(syi)
#########   R N G S E T D F   #########
        elseif(fname == "rngsetdf") then
                call fcnargb( 1, sxi)
                npointsx = parlen(sxi)
                call fcnargb( 2, syi)
                npointsy = parlen(syi)

                errmsg = " "
                if (parcoerc(syi, RANGE) == ERR)
     1                     errmsg = "argument2 not of type RANGE"
                if (sxi(TC) == NULL_TYPE) then
                         call parcopy (syi, sxi)
                         return(OK)
                endif
                if(npointsx <> npointsy & npointsy <> 1)
     1                     errmsg = "argument1 and argument2 size mismatch"
                if(sxi(TC) <> RANGE & sxi(TC) <> INTEGER & sxi(TC) <> REAL & sxi(TC) <>
     1               DOUBLE&sxi(TC) <> COMPLEX&sxi(TC) <> DOUBLE_C)
     2                errmsg = "Bad data type for argument 1"

                if (errmsg <> " ") then
                        call remark("rngsetdf: " //errmsg)
                        call parrel(syi)
                        return(ERR)
                endif

## -- IF type RANGE replace defaults,
## -- but if type INTEGER, REAL, DOUBLE, or COMPLEX, return data unchanged

                if (sxi(TC) == RANGE) then
                        Point(ix) = paraddr(sxi)
                        Point(iy) = paraddr(syi)
                        do i=1, 3*npointsx
                                if (ix(i) == DEFAULT) then
                                        if (npointsy = 1) then
                                                ix(i) = iy(mod(i-1,3)+1)
                                        else
                                                ix(i) = iy(i)
                                        endif
                                endif
                        enddo
                endif
                call parrel(syi)
#########   R N G B E G   #########
        elseif(fname == "rngbeg") then
                call fcnargb( 1, syi)
                npointsy = parlen(syi)
                call fcnargb( 2, szi)
                npointsz = parlen(szi)

                errmsg = " "
                if (parcoerc(szi, INTEGER) == ERR)
     1                   errmsg="second argument not of type INTEGER"
                if (syi(TC) == NULL_TYPE) then
                         call parcopy (szi, sxi)
                         return(OK)
                endif
                if(npointsy <> npointsz & npointsz <> 1)
     1                   errmsg = "argument1 and argument2 size mismatch"
                if(parcoerc(syi, RANGE) == ERR)
     1                   errmsg = "first argument not of type RANGE"

                if (errmsg <> " ") then
                        call remark("rngbeg: " //errmsg)
                        call parrel(syi)
                        call parrel(szi)
                        return(ERR)
                endif

                call parcopy(syi, sxi)
                sxi(TC) = INTEGER
                call parget(sxi)
                Point(ix) = paraddr(sxi)
                Point(iy) = paraddr(syi)
                Point(iz) = paraddr(szi)
                do i=1, npointsy
                        ix(i) = iy(3*(i-1) + 1)
                        if (ix(i) == DEFAULT) then
                                if (npointsz = 1) then
                                        ix(i) = iz(1)
                                else
                                        ix(i) = iz(i)
                                endif
                        endif
                enddo

                call parrel(syi)
                call parrel(szi)
#########   R N G E N D   #########
        elseif(fname == "rngend") then
                call fcnargb( 1, syi)
                npointsy = parlen(syi)
                call fcnargb( 2, szi)
                npointsz = parlen(szi)

                errmsg = " "
                if (parcoerc(szi, INTEGER) == ERR)
     1                   errmsg="second argument not of type INTEGER"
                if (syi(TC) == NULL_TYPE) then
                         call parcopy (szi, sxi)
                         return(OK)
                endif
                if(npointsy <> npointsz & npointsz <> 1)
     1                   errmsg = "argument1 and argument2 size mismatch"
                if(parcoerc(syi, RANGE) == ERR)
     1                   errmsg = "first argument not of type RANGE"

                if (errmsg <> " ") then
                        call remark("rngend: " //errmsg)
                        call parrel(syi)
                        call parrel(szi)
                        return(ERR)
                endif

                call parcopy(syi, sxi)
                sxi(TC) = INTEGER
                call parget(sxi)
                Point(ix) = paraddr(sxi)
                Point(iy) = paraddr(syi)
                Point(iz) = paraddr(szi)
                do i=1, npointsy
                        ix(i) = iy(3*(i-1) + 2)
                        if (ix(i) == DEFAULT) then
                                if (npointsz = 1) then
                                        ix(i) = iz(1)
                                else
                                        ix(i) = iz(i)
                                endif
                        endif
                enddo

                call parrel(syi)
                call parrel(szi)
#########   R N G I N C   #########
        elseif(fname == "rnginc") then
                call fcnargb( 1, syi)
                npointsy = parlen(syi)
                if (nargs == 2) then
                        call fcnargb( 2, szi)
                        call parrel(szi)
                endif

                errmsg = " "
                if (syi(TC) == NULL_TYPE) then
                         sxi(TC) = INTEGER
                         sxi(N) = 0
                         call parget(sxi)
                         Point(ix) = paraddr(sxi)
                         ix(1) = 1
                         return(OK)
                endif
                if(parcoerc(syi, RANGE) == ERR)
     1                   errmsg = "first argument not of type RANGE"

                if (errmsg <> " ") then
                        call remark("rnginc: " //errmsg)
                        call parrel(syi)
                        return(ERR)
                endif

                call parcopy(syi, sxi)
                sxi(TC) = INTEGER
                call parget(sxi)
                Point(ix) = paraddr(sxi)
                Point(iy) = paraddr(syi)
                do i=1, npointsy
                        ix(i) = iy(3*(i-1) + 3)
                enddo

                call parrel(syi)
        elseif(fname = 'struct') then
                call parstru0(sxi)
                do i= 1, nargs
                        call fcnargb( i, syi)
                        idummy = struadd(sxi, syi, 0)
                        call parrel(syi)
                enddo

        else #not a builtin function
                fndflg = FALSE
                return(OK)
        endif
####################   F I N I S H   ####################
900     continue
        return(OK)
        end
