        function parbfcn5( nargs, fname, sxi, fndflg)
# avoid xmp problems !
clll.   optimize level g
#
#       ----- written by Andrew Zachary 4/3/85
#               fixed bugs in inner, outer  6/25/85 dubois
#               changed to handle structured argument list 6/10/85
#             rewrite for call from parxfcn dubois 1/8/87
#             changed to accomodate package builtins 12/10/87
#               rewrite to add double - Peter Willmann 3/30/89
#
#       reduces the production
#
#       <rid>::= reference <args>
#
#       for the builtin functions
#
#       Revised: Zane C. Motteler
#                January 1990
#       Purpose: Change fcnargb call to fcnargbp when NODATA is needed
#                COPY most of the time, because a copy of the data is needed.
#                NODATA for the rest, because only information about the data
#                       (length, type, ...) is needed
#       This supports lazy evaluation of function arguments (they are only
#       evaluated as -- and when -- needed).
#
#       Revised: Zane C. Motteler
#                August 1999
#       Purpose: stack and stack pointer are no longer necessary.
#                position of stack frame is known. arguments
#                run from rlinkp+1 to rsp.
Use(Controls)
Use(Functions)
Use(Stacks)
        integer parbfcn5, nargs
        logical fndflg
	integer parname, strindex1
	external parname, strindex1
	external parkill
	character*(MAXSTRING) aryname, dimstr
        Varname fname
        Dynamic(     x   ,    real   , 1 )
        Dynamic(    xc   ,  complex  , 1 )
        Dynamic(    xd   , double precision, 1 )
        Dynamic(     y   ,    real   , 1 )
        Dynamic(    yc   ,  complex  , 1 )
        Dynamic(    yd   , double precision, 1 )
        Dynamic(     z   ,    real   , 1 )
        Dynamic(    zc   ,  complex  , 1 )
        Dynamic(    zd   , double precision, 1 )
        Dynamic(    ix   ,  integer  , 1 )
        Dynamic(    iy   ,  integer  , 1 )
        Dynamic(    iz   ,  integer  , 1 )
        Dynamic(    izz  ,  integer  , 1 )
# for where
ifelse(HAS_DOUBLE_COMPLEX,YES,[
        Dynamic(   xdc   , double complex , 1)
        Dynamic(   ydc   , double complex , 1)
        Dynamic(   zdc   , double complex , 1)
        Dynamic(   zzdc   , double complex , 1)
])
        Dynamic(    yl   ,  logical  , 1 )
        Dynamic(     zz  ,    real   , 1 )
        Dynamic(    zzc  ,  complex  , 1 )
        Dynamic(    zzd  , double precision, 1 )
        Address Point(ys)
#
        integer sxi(SSWIDTH), syi(SSWIDTH), szi(SSWIDTH), szzi(SSWIDTH)
        integer sx (SSWIDTH)
        integer nlow(7), nhi(7)
        integer npointsy
        integer namebeg, nameend, nameend2, jvar, tc, ndim, ierr
        Address fwa
        integer lenz, leny, startss, endss
        integer parlen, parcoerc
        Address paraddr, pargeti
        external paraddr, parlen, parcoerc
        integer parint, utgetcl
        external parint, utgetcl, pargeti
	integer rtfinder, rtgetvar
        external rtfinder, rtgetvar, mcsdlimn
        Varname mcudlim
        integer i, iskip, j
	integer db
        integer ilow, ihi
clll.   option nodyneqv
#  begin search through function list

        fndflg = TRUE

###################   V E C T O R S   ####################
########   O U T E R   ########
        if( fname == "outer" )  then
#  copy argument list and count total dimension.
                call fcnargb( 1, syi )
                call fcnargb( 2, szi )
                call pardim(syi)
                call pardim(szi)
ifelse(HAS_DOUBLE_COMPLEX,YES,[
                if( syi(TC) < INTEGER | syi(TC) > DOUBLE_C |
                    szi(TC) < INTEGER | szi(TC) > DOUBLE_C )then
],[
                if( syi(TC) < INTEGER | syi(TC) > COMPLEX |
                    szi(TC) < INTEGER | szi(TC) > COMPLEX )then
])
                        call remark( "outer: illegal argument type" )
                        return(ERR)
                endif
                if( parlen(syi) == 1 )  then
                        syi(N) = 1 ; syi(N1) = 1 ; syi(M1) = 1
                endif
                if( parlen(szi) == 1 )  then
                        szi(N) = 1 ; szi(N1) = 1 ; szi(M1) = 1
                endif
#######################################################################
###############  DETERMINE CHARACTERISTICS OF NEW MATRIX ##############
#######################################################################
                sxi(N)       = syi(N) + szi(N)
                if( sxi(N) > 7 )  then
                        call remark("outer: array will exceed dimension limit")
                        return(ERR)
                endif
#  new array must be same type as the highest argument.
                sxi(TC)      = max(syi(TC), szi(TC))
                if(parcoerc(syi, sxi(TC)) == ERR) return(ERR)
                if(parcoerc(szi, sxi(TC)) == ERR) return(ERR)
#  go through dimensions of syi, make dimensions of sxi the same
                do i  = N1, N1 + syi(N) - 1
                        sxi(i) = syi(i)
                enddo
                do i  = M1, M1 + syi(N) - 1
                        sxi(i) = syi(i)
                enddo
#  ..... repeat for szi
                do i = N1, N1 + szi(N) - 1
                        iskip      = i + syi(N)
                        sxi(iskip) = szi(i)
                enddo
                do i  = M1, M1 + szi(N) - 1
                        iskip      = i + syi(N)
                        sxi(iskip) = szi(i)
                enddo
#  get space for the array, and do outer product(s)
                call parget( sxi )
                if( sxi(TC) == INTEGER )  then
                        Point( ix )  = paraddr( sxi )
                        npoints      = parlen( sxi )
                        Point( iy )  = paraddr( syi )
                        npointsy     = parlen( syi )
                        do i  = 1, npoints-npointsy+1,npointsy
                                do j  = 0, npointsy-1
                                        ix(i+j) = iy(j+1)
                                enddo
                        enddo
                        Point( iy ) = paraddr( szi )
                        npointsy    = parlen( szi )
                        nskip       = npoints / npointsy
                        do i  = 1, npointsy
                                do j  = (i-1)*nskip+1, i*nskip
                                        ix(j)   = ix(j) * iy(i)
                                enddo
                        enddo
                elseif( sxi(TC) == REAL )  then
                        Point( x )    = paraddr( sxi )
                        npoints       = parlen( sxi )
                        Point( y )    = paraddr( syi )
                        npointsy      = parlen( syi )
                        do i = 1, npoints-npointsy+1, npointsy
                                do j  = 0, npointsy-1
                                        x(i+j) = y(j+1)
                                enddo
                        enddo
                        Point( y )  = paraddr( szi )
                        npointsy    = parlen( szi )
                        nskip       = npoints / npointsy
                        do i  = 1, npointsy
                                do j  = (i-1)*nskip+1, i*nskip
                                        x(j)   = x(j) * y(i)
                                enddo
                        enddo
                elseif( sxi(TC) == DOUBLE )  then
                        Point( xd )    = paraddr( sxi )
                        npoints       = parlen( sxi )
                        Point( yd )    = paraddr( syi )
                        npointsy      = parlen( syi )
                        do i = 1, npoints-npointsy+1, npointsy
                                do j  = 0, npointsy-1
                                        xd(i+j) = yd(j+1)
                                enddo
                        enddo
                        Point( yd )  = paraddr( szi )
                        npointsy    = parlen( szi )
                        nskip       = npoints / npointsy
                        do i  = 1, npointsy
                                do j  = (i-1)*nskip+1, i*nskip
                                        xd(j) = xd(j) * yd(i)
                                enddo
                        enddo
ifelse(HAS_DOUBLE_COMPLEX,YES,[
                elseif( sxi(TC) == COMPLEX )  then
],[
                elseif( sxi(TC) == COMPLEX | sxi(TC) == DOUBLE_C )  then
])
                        Point( xc )   = paraddr( sxi )
                        npoints       = parlen( sxi )
                        npointsy     = parlen( syi )
                        Point( yc )  = paraddr( syi )
                        do i  = 1, npoints-npointsy+1,npointsy
                                do j  = 0, npointsy-1
                                        xc(i+j) = yc(j+1)
                                enddo
                        enddo
                        npointsy     = parlen( szi )
                        Point( yc )  = paraddr( szi )
                        nskip        = npoints / npointsy
                        do i  = 1, npointsy
                                do j  = (i-1)*nskip+1, i*nskip
                                        xc(j)  = xc(j) * yc(i)
                                enddo
                        enddo
ifelse(HAS_DOUBLE_COMPLEX,YES,[
            elseif( sxi(TC) == DOUBLE_C )  then
                        Point( xdc )   = paraddr( sxi )
                        npoints       = parlen( sxi )
                        npointsy     = parlen( syi )
                        Point( ydc )  = paraddr( syi )
                        do i  = 1, npoints-npointsy+1,npointsy
                                do j  = 0, npointsy-1
                                        xdc(i+j) = ydc(j+1)
                                enddo
                        enddo
                        npointsy     = parlen( szi )
                        Point( ydc )  = paraddr( szi )
                        nskip        = npoints / npointsy
                        do i  = 1, npointsy
                                do j  = (i-1)*nskip+1, i*nskip
                                        xdc(j)  = xdc(j) * ydc(i)
                                enddo
                        enddo
])
                else
                        call remark( "outer: type of result unknown." )
                        return(ERR)
                endif
                call parrel(syi)
                call parrel(szi)
#########   C R O S S   ########
        elseif( fname == "cross" )  then
#  copy argument list and count total dimension.
                call fcnargb( 1, syi )
                call fcnargb( 2, szi )
                if( syi(TC) < INTEGER | syi(TC) > DOUBLE |
                  szi(TC) < INTEGER | szi(TC) > DOUBLE) then
                        call remark( "cross: illegal argument type" )
                        return(ERR)
                endif
                if( parlen(syi) <> 3 | parlen(szi) <> 3)  then
                        call remark( "cross: vectors not of length = 3" )
                        return(ERR)
                endif
                do i = 1, 18
                  sxi(i)     = syi(i)
                enddo
#  new vector must be type real or double
                sxi(TC) = max(2, sxi(TC), syi(TC))
                if(parcoerc(syi, sxi(TC)) == ERR) return(ERR)
                if(parcoerc(szi, sxi(TC)) == ERR) return(ERR)
#  get space for the array, and do cross product(s)
                call parget( sxi )
                if( sxi(TC) == REAL )  then
                     Point( x )     = paraddr( sxi )
                     Point( y )     = paraddr( syi )
                     Point( z )     = paraddr( szi )
                     x(1) = y(2)*z(3) - y(3)*z(2)
                     x(2) = y(3)*z(1) - y(1)*z(3)
                     x(3) = y(1)*z(2) - y(2)*z(1)
                elseif( sxi(TC) == DOUBLE )  then
                     Point( xd )     = paraddr( sxi )
                     Point( yd )     = paraddr( syi )
                     Point( zd )     = paraddr( szi )
                     xd(1) = yd(2)*zd(3) - yd(3)*zd(2)
                     xd(2) = yd(3)*zd(1) - yd(1)*zd(3)
                     xd(3) = yd(1)*zd(2) - yd(2)*zd(1)
                endif
                call parrel(syi)
                call parrel(szi)
#########   L O A D   ###############################
        elseif(fname == "load") then
                call fcnargb( 1, syi )
                call fcnargb( 2, szi )
                if(parlen(syi) <> 1 | syi(TC) <> FWA) then
                        call remark(
                                "load: first argument not a scalar of type address.")
                        return(ERR)
                endif
                if(parlen(szi) <> 1 | szi(TC) <> INTEGER)then
                        call remark(
                        "load: second argument not an integer scalar")
                        return(ERR)
                endif
                Point(ix)= paraddr(szi)
                sxi(TC) = REAL
                sxi(N) = 1
                sxi(N1) = ix(1)
                sxi(M1) = 1
                call parget(sxi)
                Point(iy) = paraddr(syi)
                Point(y) = iy(1)
                Point(x) = paraddr(sxi)
                call zmovewrd(x, y, sxi(N1))
                call parrel(syi)
                call parrel(szi)

#########   S Q U E E Z E  ###################
        elseif(fname == "squeeze") then
               call fcnargb( 1, sxi)
               call pardim(sxi)

#################### U T Y P E #################################

        elseif (fname = "utype") then
            # collect the user-defined delimiters
            if(nargs > 10)then
                call remark("utype: no more than 10 user delimiters allowed.")
                call kaboom(0)
            endif
            do i= 1, nargs
                call fcnargb( i, sxi)
		junk = parname(sxi,mcudlim)
		call mcsdlim (mcudlim(1:junk), i)
		if (i <> nargs) call parkill(sxi)
            enddo
            call mcsdlimn ( nargs )

################## C U M A D D I N ###############################
        elseif (fname == "cumaddin") then
            call fcnargb(1, sx)
            if (sx (TC) ~= FWA) then
               call baserror (
                  "cumaddin: first argument must be preceded by &.")
               return (ERR)
            endif
            if (sx (N1) ~= DEFAULT + 1 & (sx (NS) ~= 1 | sx (N1) ~= sx (M1))) then
               call baserror (
                  "cumaddin: first argument must have 1d array subscript.")
               call baserror (
                  "          use += for all other types.")
               return (ERR)
            endif
            call fcnargb(2, syi)
            tc = sx (TCSAVE)
            if (parcoerc (syi, tc) == ERR) then
               call baserror (
                  "cumaddin: source argument is wrong type.")
               return (ERR)
            endif
            leny = parlen (syi)
            if (sx (NS) == 1 & sx (N1) ~= DEFAULT + 1 & leny ~= 1) then
               call baserror (
               "cumaddin: source and destination have different lengths.")
               return (ERR)
            elseif (sx (N1) ~= DEFAULT + 1 & sx (NS) == 1 & leny == 1) then 
               # scalar subscript and scalar value
               Point (iz) = pargeti (sx (N1))
               lenz = 1
               ilow = iz (1)
               ihi = iz (1)
            else 
               # general case
               Point (iz) = paraddr (bassubs (1, sx (M1))) # subscript array
               leny = parlen (syi)
               lenz = bassubs (N1, sx (M1))
               if (leny == 1) then
                  iincr = 0 # scalar broadcast
               else         # better be the same size
                  if (leny ~= lenz) then
                     call baserror (
                     "cumaddin: source and destination have different lengths.")
                     return (ERR)
                  endif
                  iincr = 1
               endif
               ilow = bassubs (N1 + 2, sx (M1))
               ihi = bassubs (N1 + 3, sx (M1))
            endif
            j = 1
            select tc
            case INTEGER:
               Point (ix) = paraddr (sx)
               Point (iy) = paraddr (syi)
               do i = 1, lenz
                  if (iz (i) > ihi | iz (i) < ilow) then
                     call baserror ("cumaddin: Subscript out of range.")
                     return (ERR)
                  endif
                  ix (iz (i) - ilow + 1) = ix (iz (i) - ilow + 1) + iy (j)
                  j = j + iincr
               enddo
            case REAL:
               Point (x) = paraddr (sx)
               Point (y) = paraddr (syi)
               do i = 1, lenz
                  if (iz (i) > ihi | iz (i) < ilow) then
                     call baserror ("cumaddin: Subscript out of range.")
                     return (ERR)
                  endif
                  x (iz (i) - ilow + 1) = x (iz (i) - ilow + 1) + y (j)
                  j = j + iincr
               enddo
            case DOUBLE:
               Point (xd) = paraddr (sx)
               Point (yd) = paraddr (syi)
               do i = 1, lenz
                  if (iz (i) > ihi | iz (i) < ilow) then
                     call baserror ("cumaddin: Subscript out of range.")
                     return (ERR)
                  endif
                  xd (iz (i) - ilow + 1) = xd (iz (i) - ilow + 1) + yd (j)
                  j = j + iincr
               enddo
            case COMPLEX:
ifelse(HAS_DOUBLE_COMPLEX,YES,[
],[
            case DOUBLE_C:
])
               Point (xc) = paraddr (sx)
               Point (yc) = paraddr (syi)
               do i = 1, lenz
                  if (iz (i) > ihi | iz (i) < ilow) then
                     call baserror ("cumaddin: Subscript out of range.")
                     return (ERR)
                  endif
                  xc (iz (i) - ilow + 1) = xc (iz (i) - ilow + 1) + yc (j)
                  j = j + iincr
               enddo
ifelse(HAS_DOUBLE_COMPLEX,YES,[
            case DOUBLE_C:
               Point (xdc) = paraddr (sx)
               Point (ydc) = paraddr (syi)
               do i = 1, lenz
                  if (iz (i) > ihi | iz (i) < ilow) then
                     call baserror ("cumaddin: Subscript out of range.")
                     return (ERR)
                  endif
                  xdc (iz (i) - ilow + 1) = xdc (iz (i) - ilow + 1) + ydc (j)
                  j = j + iincr
               enddo
])
            default:
               call baserror (
                  "cumaddin: does not support this type.")
               return (ERR)
            endselect
            if (sx (NS) == 1 & leny == 1) then
               call Osfree (Point (iz))
            else
               call parrel (bassubs (1, sx (M1)))
               bassubs (TC, sx (M1)) = NULL_TYPE
               bassubs (N1 + 1, sx (M1)) = 0
            endif
            call parrel (sx)
            call parrel (syi)
            # Doesn't return anything:
            sxi (TC) = NULL_TYPE


#################### G A T H E R #################################

        elseif (fname = "gather") then

#### get the source array
           call fcnargb(1, syi)
           call pardim(syi)
           if( syi(N) ==0) then
              syi(N) = 1
              syi(N1) = 1
              syi(M1) = 1
              syi(I1) = 1
           endif
           if (syi(N) <> 1) then
              call remark ("gather: source array must be a 1-D array")
              return(ERR)
           endif
ifelse(HAS_DOUBLE_COMPLEX,YES,[
           if ( syi(TC) < INTEGER | syi(TC) > DOUBLE_C) then
],[
           if ( syi(TC) < INTEGER | syi(TC) > COMPLEX) then
])
              call remark ("gather: illegal argument type for source array")
              return(ERR)
           else
              sxi(N) = 1
              sxi(TC) = syi(TC)
              startss = syi(M1)
              endss = startss + syi(N1) - 1
           endif

#### get the index array
           call fcnargb(2, szi)
           call pardim(szi)
           if( szi(N) ==0) then
              szi(N) = 1
              szi(N1) = 1
              szi(M1) = 1
              szi(I1) = 1
           endif
           if (szi(N) <> 1) then
              call remark ("gather: index array must be a 1-D array")
              return(ERR)
           endif
           if (parcoerc( szi, INTEGER ) == ERR )  then
               call remark( "gather: illegal argument type for index array")
               return(ERR)
           else
               Point(iz) = paraddr(szi)
               lenz = parlen(szi)
               sxi(N1) = szi(N1)
               sxi(M1) = szi(M1)
           endif

#### set up space for the answer
           call parget(sxi)

           if (syi(TC) == REAL) then
              Point(x) = paraddr(sxi)
              Point(y) = paraddr(syi)
              do i = 1, lenz
                 if (iz(i) >= startss & iz(i) <= endss) then
                    x(i) = y(iz(i)-startss+1)
                 else
                    call remark ("gather: index outside range of source array")
                    return (ERR)
                 endif
              enddo
           elseif (syi(TC) == DOUBLE) then
              Point(xd) = paraddr(sxi)
              Point(yd) = paraddr(syi)
              do i = 1, lenz
                 if (iz(i) >= startss & iz(i) <= endss) then
                    xd(i) = yd(iz(i)-startss+1)
                 else
                    call remark ("gather: index outside range of source array")
                    return (ERR)
                 endif
              enddo
           elseif (syi(TC) == INTEGER) then
              Point(ix) = paraddr(sxi)
              Point(iy) = paraddr(syi)
              do i = 1, lenz
                 if (iz(i) >= startss & iz(i) <= endss) then
                    ix(i) = iy(iz(i)-startss+1)
                 else
                    call remark ("gather: index outside range of source array")
                    return (ERR)
                 endif
              enddo
ifelse(HAS_DOUBLE_COMPLEX,YES,[
           elseif(syi(TC) == COMPLEX) then
],[
           elseif(syi(TC) == COMPLEX | syi(TC) == DOUBLE_C) then
])
              Point(xc) = paraddr(sxi)
              Point(yc) = paraddr(syi)
              do i = 1, lenz
                 if (iz(i) >= startss & iz(i) <= endss) then
                    xc(i) = yc(iz(i)-startss+1)
                 else
                    call remark ("gather: index outside range of source array")
                    return (ERR)
                 endif
              enddo
ifelse(HAS_DOUBLE_COMPLEX,YES,[
            elseif( syi(TC) == DOUBLE_C )  then
              Point(xdc) = paraddr(sxi)
              Point(ydc) = paraddr(syi)
              do i = 1, lenz
                 if (iz(i) >= startss & iz(i) <= endss) then
                    xdc(i) = ydc(iz(i)-startss+1)
                 else
                    call remark ("gather: index outside range of source array")
                    return (ERR)
                 endif
              enddo
])
           endif
           call parrel(syi)
           call parrel(szi)

###   W H E R E   ###

        elseif (fname = "where") then

#### get the arguments
           call fcnargb(1, syi)
           if (syi(TC) <> LOGICAL) then
              call remark("where: arg 1 not type LOGICAL")
              return(ERR)
           endif
           Point(yl) = paraddr(syi)

           call fcnargb(2, szi)
           npntsy = parlen(syi)
           npntsz = parlen(szi)
           if (npntsz <> 1 & npntsz <> npntsy) then
              call remark("where: lengths of arg1 and arg2 don't match")
              return(ERR)
           endif

           if (nargs == 2) then
              sxi(N) = 1
              sxi(TC) = szi(TC)
              sxi(M1) = 1
              sxi(N1) = 0
              do i=1,npntsy
                 if (yl(i)) sxi(N1) = sxi(N1) + 1
              enddo

          elseif (nargs == 3) then
              call fcnargb(3, szzi)
              npntszz = parlen(szzi)
              if (npntszz <> 1 & npntszz <> npntsy) then
                 call remark("where: lengths of arg1 and arg3 don't match")
                 return(ERR)
              endif
              if (szzi(TC) < szi(TC)) then
                 if (parcoerc(szzi, szi(TC)) = ERR) then
                    call remark("where: arg2 not coerceable to arg1 type")
                    return(ERR)
                 endif
              else
                 if (parcoerc(szi, szzi(TC)) = ERR) then
                    call remark("where: arg1 not coerceable to arg2 type")
                    return(ERR)
                 endif
              endif

              call parcopy(syi, sxi)
              sxi(TC) = szi(TC)
           endif

#### set up space for the answer

           call parget(sxi)

           if (szi(TC) == INTEGER) then
              Point(ix) = paraddr(sxi)
              Point(iz) = paraddr(szi)
              if (nargs == 2) then
                 j = 1
                 do i = 1, npntsy
                    if (yl(i)) then
                       k = min(i, npntsz)
                       ix(j) = iz(k)
                       j = j + 1
                    endif
                 enddo
              else
                 Point(izz) = paraddr(szzi)
                 do i= 1, npntsy
                    if (yl(i)) then
                       k = min(i, npntsz)
                       ix(i) = iz(k)
                    else
                       k = min(i, npntszz)
                       ix(i) = izz(k)
                    endif
                 enddo
              endif
           elseif(szi(TC) == REAL) then
              Point(x) = paraddr(sxi)
              Point(z) = paraddr(szi)
              if (nargs == 2) then
                 j = 1
                 do i = 1, npntsy
                    if (yl(i)) then
                       k = min(i, npntsz)
                       x(j) = z(k)
                       j = j + 1
                    endif
                 enddo
              else
                 Point(zz) = paraddr(szzi)
                 do i= 1, npntsy
                    if (yl(i)) then
                       k = min(i, npntsz)
                       x(i) = z(k)
                    else
                       k = min(i, npntszz)
                       x(i) = zz(k)
                    endif
                 enddo
              endif

           elseif(szi(TC) == DOUBLE) then
              Point(xd) = paraddr(sxi)
              Point(zd) = paraddr(szi)
              if (nargs == 2) then
                 j = 1
                 do i = 1, npntsy
                    if (yl(i)) then
                       k = min(i, npntsz)
                       xd(j) = zd(k)
                       j = j + 1
                    endif
                 enddo
              else
                 Point(zzd) = paraddr(szzi)
                 do i= 1, npntsy
                    if (yl(i)) then
                       k = min(i, npntsz)
                       xd(i) = zd(k)
                    else
                       k = min(i, npntszz)
                       xd(i) = zzd(k)
                    endif
                 enddo
              endif

ifelse(HAS_DOUBLE_COMPLEX,YES,[
           elseif(szi(TC) == COMPLEX) then
],[
           elseif(szi(TC) == COMPLEX|szi(TC) == DOUBLE_C) then
])
              Point(xc) = paraddr(sxi)
              Point(zc) = paraddr(szi)
              if (nargs == 2) then
                 j = 1
                 do i = 1, npntsy
                    if (yl(i)) then
                       k = min(i, npntsz)
                       xc(j) = zc(k)
                       j = j + 1
                    endif
                 enddo
              else
                 Point(zzc) = paraddr(szzi)
                 do i= 1, npntsy
                    if (yl(i)) then
                       k = min(i, npntsz)
                       xc(i) = zc(k)
                    else
                       k = min(i, npntszz)
                       xc(i) = zzc(k)
                    endif
                 enddo
              endif

ifelse(HAS_DOUBLE_COMPLEX,YES,[
            elseif( szi(TC) == DOUBLE_C )  then
              Point(xdc) = paraddr(sxi)
              Point(zdc) = paraddr(szi)
              if (nargs == 2) then
                 j = 1
                 do i = 1, npntsy
                    if (yl(i)) then
                       k = min(i, npntsz)
                       xdc(j) = zdc(k)
                       j = j + 1
                    endif
                 enddo
              else
                 Point(zzdc) = paraddr(szzi)
                 do i= 1, npntsy
                    if (yl(i)) then
                       k = min(i, npntsz)
                       xdc(i) = zdc(k)
                    else
                       k = min(i, npntszz)
                       xdc(i) = zzdc(k)
                    endif
                 enddo
              endif
])
           else
              call remark("where: arg2, arg3 are wrong type")
              return(ERR)
           endif
        call parrel(syi)   # release space for arguments
        call parrel(szi)
        if (nargs >= 3) call parrel(szzi)
####################   T R A N S P O S E   ##############################
        elseif( fname = "transpose") then
	       call fcnargb(1,sxi)
	       call partrans(sxi)
############# T R U E S H A P E #####################
	elseif( fname = "trueshape") then
		call fcnargb(1,syi)
		if(syi(TC) >= 0) then
		   call remark("trueshape: character argument expected")
		   return(ERR)
		endif

		len = -syi(TC)
		if (len > MAXSTRING) then
		   call remark("trueshape: name is too long")
		   return(ERR)
		endif
		Point(ys) = paraddr(syi)

		nameend=strindex1(Point(ys), 0, len, "(", 1)
		if(nameend == 0) nameend = len
		aryname = " "
		call smovatof(aryname, 0,Point(ys), 0,nameend)
		namebeg = 1
		call utskipbl(aryname, namebeg)
		nameend2 = utgetcl(aryname)
		aryname = aryname(namebeg:nameend2)

		if (nameend < len) then
		   dimstr = " "
		   call smovatof(dimstr,0,Point(ys),nameend,len-nameend)
		   if (rtfinder(aryname, jvar, db, tc, "parbfcn") = ERR) then
		      call remark("trueshape:  unknown name "//aryname)
		      return (ERR)
		   endif
		   call pullapt2(db,dimstr,jvar,nlow,nhi,ndim, ierr)
		else
		   if (rtgetvar(aryname, fwa, tc, ndim, nlow, nhi) = ERR) then
		      call remark("trueshape:  unknown array "//aryname)
		      return (ERR)
		   endif
		endif
		sxi(N) = 1
		sxi(M1) = 1
		sxi(N1) = max(ndim, 1)
		sxi(TC) = INTEGER
		call parget(sxi)
		Point(ix) = paraddr(sxi)
		ix(1) = 1          # for scalar case (ndim = 0) 
		do i=1,ndim
		   ix(i) = nhi(i) - nlow(i) + 1
		enddo
		call parrel(syi)
############# T R U E R A N G E #####################
	elseif( fname = "truerange") then
		call fcnargb(1,syi)
		if(syi(TC) >= 0) then
		   call remark("truerange: character argument expected")
		   return(ERR)
		endif

		len = -syi(TC)
		if (len > MAXSTRING) then
		   call remark("truerange: name is too long")
		   return(ERR)
		endif
		Point(ys) = paraddr(syi)

		nameend=strindex1(Point(ys), 0, len, "(", 1)
		if(nameend == 0) nameend = len
		aryname = " "
		call smovatof(aryname,0,Point(ys),0,nameend)
		namebeg = 1
		call utskipbl(aryname, namebeg)
		nameend2 = utgetcl(aryname)
		aryname = aryname(namebeg:nameend2)

		if (nameend < len) then
		   dimstr = " "
		   call smovatof(dimstr,0,Point(ys),nameend,len-nameend)
		   if (rtfinder(aryname, jvar, db, tc, "parbfcn") = ERR) then
                      call remark ("truerange:  unknown name "//aryname)
                      return (ERR)
		   endif
		   call pullapt2(db,dimstr,jvar,nlow,nhi,ndim, ierr)
		else
		   if (rtgetvar(aryname, fwa, tc, ndim, nlow, nhi) = ERR) then
                      call remark ("truerange:  unknown array "//aryname)
                      return (ERR)
		   endif
		endif
		sxi(N) = 2
		sxi(M1) = 1
		sxi(M2) = 1
		sxi(N1) = max(ndim, 1)
		sxi(N2) = 2
		sxi(TC) = INTEGER
		call parget(sxi)
		Point(ix) = paraddr(sxi)
		ix(1) = 1          # for scalar case (ndim = 0)
		ix(2) = 1
		do i=1,ndim
		   ix(i) = nlow(i)
		   ix(i+sxi(N1)) = nhi(i)
		enddo
		call parrel(syi)

        else #not a builtin function
                fndflg = FALSE
                return(OK)
        endif
####################   F I N I S H   ####################
900     continue
        return(OK)
        end
