        function parbfcn6( nargs, fname, sxi, fndflg)
# avoid xmp problems !
clll.   optimize level g
#
#       ----- written by Andrew Zachary 4/3/85
#               fixed bugs in inner, outer  6/25/85 dubois
#               changed to handle structured argument list 6/10/85
#             rewrite for call from parxfcn dubois 1/8/87
#             changed to accomodate package builtins 12/10/87
#               rewrite to add double - Peter Willmann 3/30/89
#
#       reduces the production
#
#       <rid>::= reference <args>
#
#       for the builtin functions
#
#       Revised: Zane C. Motteler
#                January 1990
#       Purpose: Change fcnargb call to fcnargbp when NODATA is needed
#                COPY most of the time, because a copy of the data is needed.
#                NODATA for the rest, because only information about the data
#                       (length, type, ...) is needed
#       This supports lazy evaluation of function arguments (they are only
#       evaluated as -- and when -- needed).
#
#       Revised: Zane C. Motteler
#                August 1999
#       Purpose: stack and stack pointer are no longer necessary.
#                position of stack frame is known. arguments
#                run from rlinkp+1 to rsp.
Use(Controls)
Use(Functions)
        integer parbfcn6, nargs
        logical fndflg
        Varname fname
        Dynamic(     x   ,    real   , 1 )
        Dynamic(    xc   ,  complex  , 1 )
        Dynamic(    xd   , double precision, 1 )
        Dynamic(     y   ,    real   , 1 )
        Dynamic(    yc   ,  complex  , 1 )
        Dynamic(    yd   , double precision, 1 )
        Dynamic(    ix   ,  integer  , 1 )
        Dynamic(    iy   ,  integer  , 1 )
ifelse(HAS_DOUBLE_COMPLEX,YES,[
        Dynamic(    xdc  , double complex, 1 )
        Dynamic(    ydc  , double complex, 1 )
])
#
        integer sxi(SSWIDTH), syi(SSWIDTH), szi(SSWIDTH)
        integer parlen, parcoerc
        Address paraddr
        external paraddr, parlen, parcoerc
        integer parint
        external parint
        double precision dvalue
        real rminval, rvalue, rmaxval
        integer i, j, npoints
        integer dim, dimlen, dimsize, offset
        integer dimlens(7)
        integer dimstride(7+1)
        complex csum
        double precision dmaxval, dminval, dsum
        Varname ferr     # name of function
        integer par2get
        external par2get
        external i1mach, r1mach, d1mach
        integer i1mach
        real r1mach
        double precision d1mach

        fndflg = TRUE
#  begin search through function list
########################   P T P   #################################

        if (fname = "ptp") then
           call fcnargb(1, syi)
           npoints = par2get(fname,syi,nargs,dim,sxi,dimlens,dimstride)
           if( npoints == 0) then
              call remark ("ptp: max - min of 0 items is meaningless.")
              return (ERR)
           endif

           if (syi(TC) = INTEGER) then
              Point(ix) = paraddr(sxi)
              Point(iy) = paraddr(syi)
              if (nargs == 1) then
                 minval = iy(1)
                 maxval = iy(1)
                 do i = 2, npoints
                    if (iy(i) < minval) then
                       minval = iy(i)
                    elseif (iy(i) > maxval) then
                       maxval = iy(i)
                    endif
                 enddo
                 ix(1) = maxval - minval
              else
                 newindx = 1
                 do offset = 0, dimstride(syi(N)+1) -1, dimstride(dim+1)
                    do i = 1, dimstride(dim)
                       izindx = i + offset
                       minval = iy(izindx)
                       maxval = iy(izindx)
                       do j = 2, dimlens(dim)
                          izindx = izindx + dimstride(dim)
                          if (iy(izindx) < minval) then
                             minval = iy(izindx)
                          elseif (iy(izindx) > maxval) then
                             maxval = iy(izindx)
                          endif
                       enddo
                       ix(newindx) = maxval - minval
                       newindx = newindx + 1
                    enddo
                 enddo
              endif

           elseif(syi(TC) == REAL) then
              Point(x) = paraddr(sxi)
              Point(y) = paraddr(syi)
              if (nargs == 1) then
                 rminval = y(1)
                 rmaxval = y(1)
                 do i = 2, npoints
                    if (y(i) < rminval) then
                       rminval = y(i)
                    elseif (y(i) > rmaxval) then
                       rmaxval = y(i)
                    endif
                 enddo
                 x(1) = rmaxval - rminval
              else
                 newindx = 1
                 do offset = 0, dimstride(syi(N)+1) -1, dimstride(dim+1)
                    do i = 1, dimstride(dim)
                       izindx = i + offset
                       rminval = y(izindx)
                       rmaxval = y(izindx)
                       do j = 2, dimlens(dim)
                          izindx = izindx + dimstride(dim)
                          if (y(izindx) < rminval) then
                             rminval = y(izindx)
                          elseif (y(izindx) > rmaxval) then
                             rmaxval = y(izindx)
                          endif
                       enddo
                       x(newindx) = rmaxval - rminval
                       newindx = newindx + 1
                    enddo
                 enddo
              endif
           elseif(syi(TC) == DOUBLE) then
              Point(xd) = paraddr(sxi)
              Point(yd) = paraddr(syi)
              if (nargs == 1) then
                 dminval = yd(1)
                 dmaxval = yd(1)
                 do i = 2, npoints
                    if (yd(i) < dminval) then
                       dminval = yd(i)
                    elseif (yd(i) > dmaxval) then
                       dmaxval = yd(i)
                    endif
                 enddo
                 xd(1) = dmaxval - dminval
              else
                 newindx = 1
                 do offset = 0, dimstride(syi(N)+1) -1, dimstride(dim+1)
                    do i = 1, dimstride(dim)
                       izindx = i + offset
                       dminval = yd(izindx)
                       dmaxval = yd(izindx)
                       do j = 2, dimlens(dim)
                          izindx = izindx + dimstride(dim)
                          if (yd(izindx) < dminval) then
                             dminval = yd(izindx)
                          elseif (yd(izindx) > dmaxval) then
                             dmaxval = yd(izindx)
                          endif
                       enddo
                       xd(newindx) = dmaxval - dminval
                       newindx = newindx + 1
                    enddo
                 enddo
              endif
           else
              call remark("ptp: arg1 is wrong type")
              return(ERR)
           endif
           call parrel(syi)   # release space for argument

########################  V M A X  #################################
        elseif (fname = "vmax") then
           call fcnargb(1, syi)
           npoints = par2get(fname,syi,nargs,dim,sxi,dimlens,dimstride)
           if( npoints == 0 & nargs == 1) then
              sxi (N) = 0
              sxi (TC) = syi (TC)
              call parget (sxi)
              if (syi (TC) == INTEGER) then
                 Point(ix) = paraddr(sxi)
                 ix (1) = i1mach (9) + 1
              elseif (syi (TC) == REAL) then
                 Point(x) = paraddr(sxi)
                 x (1) = - r1mach (2)
              elseif (syi (TC) == DOUBLE) then
                 Point(xd) = paraddr(sxi)
                 xd (1) = - d1mach (2)
              else
                 call remark("vmax: arg1 is wrong type")
                 call parrel(syi)
                 return(ERR)
              endif
              call parrel (syi)
              return (OK)
           elseif (npoints == 0) then
              return (OK)
           endif
           if (syi(TC) == INTEGER) then
              Point(ix) = paraddr(sxi)
              Point(iy) = paraddr(syi)
              if (nargs == 1) then
                 ix(1)=iy(1)
                 do i = 2, npoints
                    if(iy(i)>ix(1))ix(1)=iy(i)
                 enddo
              else
                 newindx = 1
                 do offset = 0, dimstride(syi(N)+1) -1, dimstride(dim+1)
                    do i = 1, dimstride(dim)
                       izindx = i + offset
                       ix(newindx) = iy(izindx)
                       do j = 2, dimlens(dim)
                          izindx = izindx + dimstride(dim)
                          if(iy(izindx)>ix(newindx))ix(newindx) = iy(izindx)
                       enddo
                       newindx = newindx + 1
                    enddo
                 enddo
              endif

           elseif(syi(TC) == REAL) then
              Point(x) = paraddr(sxi)
              Point(y) = paraddr(syi)
              if (nargs == 1) then
                 x(1) = y(1)
                 do i = 2, npoints
                    if(y(i)>x(1))x(1)=y(i)
                 enddo
              else
                 newindx = 1
                 do offset = 0, dimstride(syi(N)+1) -1, dimstride(dim+1)
                    do i = 1, dimstride(dim)
                       izindx = i + offset
                       x(newindx) = y(izindx)
                       do j = 2, dimlens(dim)
                          izindx = izindx + dimstride(dim)
                          if(y(izindx)>x(newindx)) x(newindx) = y(izindx)
                       enddo
                       newindx = newindx + 1
                    enddo
                 enddo
              endif

           elseif(syi(TC) == DOUBLE) then
              Point(xd) = paraddr(sxi)
              Point(yd) = paraddr(syi)
              if (nargs == 1) then
                 xd(1) = yd(1)
                 do i = 2, npoints
                    if(yd(i)>xd(1))xd(1)=yd(i)
                 enddo
              else
                 newindx = 1
                 do offset = 0, dimstride(syi(N)+1) -1, dimstride(dim+1)
                    do i = 1, dimstride(dim)
                       izindx = i + offset
                       xd(newindx) = yd(izindx)
                       do j = 2, dimlens(dim)
                          izindx = izindx + dimstride(dim)
                          if(yd(izindx)>xd(newindx))xd(newindx) = yd(izindx)
                       enddo
                       newindx = newindx + 1
                    enddo
                 enddo
              endif
           else
              call remark("vmax: arg1 is wrong type")
              call parrel(syi)
              return(ERR)
           endif
           call parrel(syi)   # release space for argument


########################  V M I N  #################################
        elseif (fname = "vmin") then
           call fcnargb(1, syi)
           npoints = par2get(fname,syi,nargs,dim,sxi,dimlens,dimstride)
           if( npoints == 0 & nargs == 1) then
              sxi (N) = 0
              sxi (TC) = syi (TC)
              call parget (sxi)
              if (syi (TC) == INTEGER) then
                 Point(ix) = paraddr(sxi)
                 ix (1) = i1mach (9)
              elseif (syi (TC) == REAL) then
                 Point(x) = paraddr(sxi)
                 x (1) = r1mach (2)
              elseif (syi (TC) == DOUBLE) then
                 Point(xd) = paraddr(sxi)
                 xd (1) = d1mach (2)
              else
                 call remark("vmin: arg1 is wrong type")
                 call parrel(syi)
                 return(ERR)
              endif
              call parrel (syi)
              return (OK)
           elseif (npoints == 0) then
              return (OK)
           endif
           if (syi(TC) == INTEGER) then
              Point(ix) = paraddr(sxi)
              Point(iy) = paraddr(syi)
              if (nargs == 1) then
                 ix(1)=iy(1)
                 do i = 2, npoints
                    if(iy(i)<ix(1))ix(1)=iy(i)
                 enddo
              else
                 newindx = 1
                 do offset = 0, dimstride(syi(N)+1) -1, dimstride(dim+1)
                    do i = 1, dimstride(dim)
                       izindx = i + offset
                       ix(newindx) = iy(izindx)
                       do j = 2, dimlens(dim)
                          izindx = izindx + dimstride(dim)
                          if(iy(izindx)<ix(newindx))ix(newindx) = iy(izindx)
                       enddo
                       newindx = newindx + 1
                    enddo
                 enddo
              endif

           elseif(syi(TC) == REAL) then
              Point(x) = paraddr(sxi)
              Point(y) = paraddr(syi)
              if (nargs == 1) then
                 x(1) = y(1)
                 do i = 2, npoints
                    if(y(i)<x(1))x(1)=y(i)
                 enddo
              else
                 newindx = 1
                 do offset = 0, dimstride(syi(N)+1) -1, dimstride(dim+1)
                    do i = 1, dimstride(dim)
                       izindx = i + offset
                       x(newindx) = y(izindx)
                       do j = 2, dimlens(dim)
                          izindx = izindx + dimstride(dim)
                          if(y(izindx)<x(newindx)) x(newindx) = y(izindx)
                       enddo
                       newindx = newindx + 1
                    enddo
                 enddo
              endif

           elseif(syi(TC) == DOUBLE) then
              Point(xd) = paraddr(sxi)
              Point(yd) = paraddr(syi)
              if (nargs == 1) then
                 xd(1) = yd(1)
                 do i = 2, npoints
                    if(yd(i)<xd(1))xd(1)=yd(i)
                 enddo
              else
                 newindx = 1
                 do offset = 0, dimstride(syi(N)+1) -1, dimstride(dim+1)
                    do i = 1, dimstride(dim)
                       izindx = i + offset
                       xd(newindx) = yd(izindx)
                       do j = 2, dimlens(dim)
                          izindx = izindx + dimstride(dim)
                          if(yd(izindx)<xd(newindx))xd(newindx) = yd(izindx)
                       enddo
                       newindx = newindx + 1
                    enddo
                 enddo
              endif
           else
              call remark("vmin: arg1 is wrong type")
              call parrel(syi)
              return(ERR)
           endif
           call parrel(syi)   # release space for argument


########################   S U M   #################################

        elseif (fname = "sum") then
           call fcnargb(1, syi)
           npoints = par2get(fname,syi,nargs,dim,sxi,dimlens,dimstride)
           if( npoints == 0) then
              # return a value of zero.
              sxi (N) = 0
              sxi (TC) = syi (TC)
              call parget (sxi)
              if (syi(TC) == INTEGER) then
                 Point(ix) = paraddr(sxi)
                 ix (1) = 0
              elseif (syi(TC) == REAL) then
                 Point(x) = paraddr(sxi)
                 x (1) = 0.e0
              elseif(syi(TC) == DOUBLE) then
                 Point(xd) = paraddr(sxi)
                 xd (1) = 0.d0
ifelse(HAS_DOUBLE_COMPLEX,YES,[
              elseif(syi(TC) == COMPLEX) then
],[
              elseif(syi(TC) == COMPLEX | syi(TC) == DOUBLE_C) then
])
                 Point(xc) = paraddr(sxi)
                 xc (1) = (0.e0, 0.e0)
ifelse(HAS_DOUBLE_COMPLEX,YES,[
              elseif(syi(TC) == DOUBLE_C) then
                 Point(xdc) = paraddr(sxi)
                 xdc (1) = (0.d0, 0.d0)
])
              endif
              call parrel (syi)
              return (OK)
           endif
           if (syi(TC) == INTEGER) then
              Point(ix) = paraddr(sxi)
              Point(iy) = paraddr(syi)
              if (nargs == 1) then
                 ix(1)=0
                 do i = 1, npoints
                    ix(1) = ix(1) + iy(i)
                 enddo
              else
                 newindx = 1
                 do offset = 0, dimstride(syi(N)+1) -1, dimstride(dim+1)
                    do i = 1, dimstride(dim)
                       izindx = i + offset
                       ix(newindx) = iy(izindx)
                       do j = 2, dimlens(dim)
                          izindx = izindx + dimstride(dim)
                          ix(newindx) = ix(newindx) + iy(izindx)
                       enddo
                       newindx = newindx + 1
                    enddo
                 enddo
              endif

           elseif(syi(TC) == REAL) then
              Point(x) = paraddr(sxi)
              Point(y) = paraddr(syi)
              if (npoints == 0 | nargs == 1) then
                 x(1) = 0
                 do i = 1, npoints
                    x(1) = x(1) + y(i)
                 enddo
              else
                 newindx = 1
                 do offset = 0, dimstride(syi(N)+1) -1, dimstride(dim+1)
                    do i = 1, dimstride(dim)
                       izindx = i + offset
                       x(newindx) = y(izindx)
                       do j = 2, dimlens(dim)
                          izindx = izindx + dimstride(dim)
                          x(newindx) = x(newindx) + y(izindx)
                       enddo
                       newindx = newindx + 1
                    enddo
                 enddo
              endif

           elseif(syi(TC) == DOUBLE) then
              Point(xd) = paraddr(sxi)
              Point(yd) = paraddr(syi)
              if (npoints == 0 | nargs == 1) then
                 xd(1) = 0
                 do i = 1, npoints
                    xd(1) = xd(1) + yd(i)
                 enddo
              else
                 newindx = 1
                 do offset = 0, dimstride(syi(N)+1) -1, dimstride(dim+1)
                    do i = 1, dimstride(dim)
                       izindx = i + offset
                       xd(newindx) = yd(izindx)
                       do j = 2, dimlens(dim)
                          izindx = izindx + dimstride(dim)
                          xd(newindx) = xd(newindx) + yd(izindx)
                       enddo
                       newindx = newindx + 1
                    enddo
                 enddo
              endif

ifelse(HAS_DOUBLE_COMPLEX,YES,[
           elseif(syi(TC) == COMPLEX) then
],[
           elseif(syi(TC) == COMPLEX | syi(TC) == DOUBLE_C) then
])
              Point(xc) = paraddr(sxi)
              Point(yc) = paraddr(syi)
              if (npoints == 0 | nargs == 1) then
                 xc(1) = 0
                 do i = 1, npoints
                    xc(1) = xc(1) + yc(i)
                 enddo
              else
                 newindx = 1
                 do offset = 0, dimstride(syi(N)+1) -1, dimstride(dim+1)
                    do i = 1, dimstride(dim)
                       izindx = i + offset
                       xc(newindx) = yc(izindx)
                       do j = 2, dimlens(dim)
                          izindx = izindx + dimstride(dim)
                          xc(newindx) = xc(newindx) + yc(izindx)
                       enddo
                       newindx = newindx + 1
                    enddo
                 enddo
              endif

ifelse(HAS_DOUBLE_COMPLEX,YES,[
           elseif(syi(TC) == DOUBLE_C) then
              Point(xdc) = paraddr(sxi)
              Point(ydc) = paraddr(syi)
              if (npoints == 0 | nargs == 1) then
                 xdc(1) = 0
                 do i = 1, npoints
                    xdc(1) = xdc(1) + ydc(i)
                 enddo
              else
                 newindx = 1
                 do offset = 0, dimstride(syi(N)+1) -1, dimstride(dim+1)
                    do i = 1, dimstride(dim)
                       izindx = i + offset
                       xdc(newindx) = ydc(izindx)
                       do j = 2, dimlens(dim)
                          izindx = izindx + dimstride(dim)
                          xdc(newindx) = xdc(newindx) + ydc(izindx)
                       enddo
                       newindx = newindx + 1
                    enddo
                 enddo
              endif
])

           else
              call remark("sum: arg1 is wrong type")
              call parrel(syi)
              return(ERR)
           endif
           call parrel(syi)   # release space for argument
########################   A V E   #################################
        elseif (fname = "ave") then
           call fcnargb(1, syi)
           npoints = par2get(fname,syi,nargs,dim,sxi,dimlens,dimstride)
           if( npoints == 0) then
              call remark ("ave: can't take the average of 0 items.")
              return (ERR)
           endif
           if (syi(TC) == INTEGER | syi(TC) == REAL) then
              if (syi(TC) == INTEGER) then
                 if (parcoerc(syi, REAL) = ERR) then
                    call remark ("ave: illegal argument type")
                    return(ERR)
                 endif
                 sxi(TC) = REAL
              endif
              Point(x) = paraddr(sxi)
              Point(y) = paraddr(syi)
              if (nargs == 1) then
                 rsum = 0
                 do i = 1, npoints
                    rsum = rsum + y(i)
                 enddo
                 x(1) = rsum / npoints
              else
                 newindx = 1
                 do offset = 0, dimstride(syi(N)+1) -1, dimstride(dim+1)
                    do i = 1, dimstride(dim)
                       izindx = i + offset
                       rsum = y(izindx)
                       do j = 2, dimlens(dim)
                          izindx = izindx + dimstride(dim)
                          rsum = rsum + y(izindx)
                       enddo
                       x(newindx) = rsum / dimlens(dim)
                       newindx = newindx + 1
                    enddo
                 enddo
              endif

           elseif(syi(TC) == DOUBLE) then
              Point(xd) = paraddr(sxi)
              Point(yd) = paraddr(syi)
              if (nargs == 1) then
                 dsum = 0
                 do i = 1, npoints
                    dsum = dsum + yd(i)
                 enddo
                 xd(1) = dsum / npoints
              else
                 newindx = 1
                 do offset = 0, dimstride(syi(N)+1) -1, dimstride(dim+1)
                    do i = 1, dimstride(dim)
                       izindx = i + offset
                       dsum = yd(izindx)
                       do j = 2, dimlens(dim)
                          izindx = izindx + dimstride(dim)
                          dsum = dsum + yd(izindx)
                       enddo
                       xd(newindx) = dsum / dimlens(dim)
                       newindx = newindx + 1
                    enddo
                 enddo
              endif
ifelse(HAS_DOUBLE_COMPLEX,YES,[
           elseif(syi(TC) == COMPLEX) then
],[
           elseif(syi(TC) == COMPLEX|syi(TC) == DOUBLE_C) then
])
              Point(xc) = paraddr(sxi)
              Point(yc) = paraddr(syi)
              if (nargs == 1) then
                 csum = 0
                 do i = 1, npoints
                    csum = csum + yc(i)
                 enddo
                 xc(1) = csum / npoints
              else
                 newindx = 1
                 do offset = 0, dimstride(syi(N)+1) -1, dimstride(dim+1)
                    do i = 1, dimstride(dim)
                       izindx = i + offset
                       csum = yc(izindx)
                       do j = 2, dimlens(dim)
                          izindx = izindx + dimstride(dim)
                          csum = csum + yc(izindx)
                       enddo
                       xc(newindx) = csum / dimlens(dim)
                       newindx = newindx + 1
                    enddo
                 enddo
              endif

ifelse(HAS_DOUBLE_COMPLEX,YES,[
           elseif(syi(TC) == DOUBLE_C) then
              Point(xdc) = paraddr(sxi)
              Point(ydc) = paraddr(syi)
              if (nargs == 1) then
                 csum = 0
                 do i = 1, npoints
                    csum = csum + ydc(i)
                 enddo
                 xdc(1) = csum / npoints
              else
                 newindx = 1
                 do offset = 0, dimstride(syi(N)+1) -1, dimstride(dim+1)
                    do i = 1, dimstride(dim)
                       izindx = i + offset
                       csum = ydc(izindx)
                       do j = 2, dimlens(dim)
                          izindx = izindx + dimstride(dim)
                          csum = csum + ydc(izindx)
                       enddo
                       xdc(newindx) = csum / dimlens(dim)
                       newindx = newindx + 1
                    enddo
                 enddo
              endif
])
           else

              call remark("ave: arg1 is wrong type")
              call parrel(syi)
              return(ERR)
           endif
           call parrel(syi)   # release space for argument

###################### M N X  /  M X X #################################

        elseif (fname = "mnx" | fname = "mxx") then

# set up array for functions which stride can stride along a dimension.
#     i.e.  funcname (arrayname [, dimension])

#### get the argument
           call fcnargb(1, syi)
	   if(syi(N)==0) then
	      syi(N) = 1
	      syi(N1) = 1
	      syi(M1) = 1
	   endif
           sxi(TC) = INTEGER
           if (nargs == 1) then
              npoints = parlen(syi)
              sxi(N) = 0
	      if(syi(N)==1) then
		 ilbase = syi(M1)-1
	      else
		 ilbase = 0
	      endif
              dim = 0
              dimlens (1) = 0
              dimstride (1) = 0
           elseif (nargs == 2) then
              call fcnargb(2, szi)
              if (parint(szi, dim) = ERR) return(ERR)
              call parrel(szi)    # release space for argument
              if (dim > syi(N) | dim < 1) then
                 ferr = fname
                 call remark(ferr // ": arg2 is out of range")
                 return(ERR)
              endif
              sxi(N) = syi(N) - 1
	      if(sxi(N)<=1) then
		 ilbase = syi(M1-1+dim)-1
	      else
		 ilbase = 0
	      endif
              dimstride(1) = 1
              do i = 1, syi(N)
                 dimlens(i) = syi(N1+i-1)
                 dimstride(i+1) = dimstride(i) * dimlens(i)

                 if (i < dim) then
                    sxi(N1+i-1) = syi(N1+i-1)
                    sxi(M1+i-1) = syi(M1+i-1)
                 elseif (i > dim) then
                    sxi(N1+i-2) = syi(N1+i-1)
                    sxi(M1+i-2) = syi(M1+i-1)
                 endif
              enddo
           endif

#### set up space for the answer
           call parget(sxi)
           Point(ix) = paraddr(sxi)

           if (syi(TC) >= INTEGER & syi(TC) <= DOUBLE) then
              if (syi(TC) == INTEGER) idummy = parcoerc(syi, REAL)
              if (syi(TC) == REAL) then
                 Point(y) = paraddr(syi)
                 if (nargs == 1) then
                    ix(1) = 1 + ilbase
                    rvalue = y(1)
                    if (fname = "mnx") then
                       do i=2, npoints
                             if (y(i) < rvalue) then
                                ix(1) = i + ilbase 
                                rvalue = y(i)
                             endif
                       enddo
                    else
                       do i=2, npoints
                             if (y(i) > rvalue) then
                                ix(1) = i + ilbase
                                rvalue = y(i)
                             endif
                       enddo
                    endif

                 else
                    newindx = 1
                    do offset = 0, dimstride(syi(N)+1) -1, dimstride(dim+1)
                       do i = 1, dimstride(dim)
                             izindx = i + offset
                             ix(newindx) = 1 + ilbase
                             rvalue = y(izindx)
                             if (fname = "mnx") then
                                do j = 2, dimlens(dim)
                                   izindx = izindx + dimstride(dim)
                                   if (y(izindx) < rvalue) then
                                      ix(newindx) = j + ilbase
                                      rvalue = y(izindx)
                                   endif
                                enddo
                             else
                                do j = 2, dimlens(dim)
                                   izindx = izindx + dimstride(dim)
                                   if (y(izindx) > rvalue) then
                                      ix(newindx) = j + ilbase
                                      rvalue = y(izindx)
                                   endif
                                enddo
                             endif
                             newindx = newindx + 1
                       enddo
                    enddo
                 endif
              elseif (syi(TC) == DOUBLE) then
                 Point(yd) = paraddr(syi)
                 if (nargs == 1) then
                    ix(1) = 1 + ilbase
                    dvalue = yd(1)
                    if (fname = "mnx") then
                       do i=2, npoints
                             if (yd(i) < dvalue) then
                                ix(1) = i + ilbase
                                dvalue = yd(i)
                             endif
                       enddo
                    else
                       do i=2, npoints
                             if (yd(i) > dvalue) then
                                ix(1) = i + ilbase
                                dvalue = yd(i)
                             endif
                       enddo
                    endif

                 else
                    newindx = 1
                    do offset = 0, dimstride(syi(N)+1) -1, dimstride(dim+1)
                       do i = 1, dimstride(dim)
                             izindx = i + offset
                             ix(newindx) = 1 + ilbase
                             dvalue = yd(izindx)
                             if (fname = "mnx") then
                                do j = 2, dimlens(dim)
                                   izindx = izindx + dimstride(dim)
                                   if (yd(izindx) < dvalue) then
                                      ix(newindx) = j + ilbase
                                      dvalue = yd(izindx)
                                   endif
                                enddo
                             else
                                do j = 2, dimlens(dim)
                                   izindx = izindx + dimstride(dim)
                                   if (yd(izindx) > dvalue) then
                                      ix(newindx) = j + ilbase
                                      dvalue = yd(izindx)
                                   endif
                                enddo
                             endif
                             newindx = newindx + 1
                       enddo
                    enddo
                 endif
              endif

           else
              ferr = fname
              call remark(ferr // ": arg1 is wrong type")
              call parrel(syi)
              return(ERR)
           endif
           call parrel(syi)       # release space for arguments
###   R S U M   ###
###   This is a reversal of PSUM   ###
###   first = sum_over_all, second = sum_over_all - last, and so on   ###

        elseif (fname = "rsum") then

#### get the argument
           call fcnargb(1, syi)
           npoints = parlen(syi)
           call parcopy(syi,sxi)
           if (nargs == 2) then
              call fcnargb(2, szi)
              if (parint(szi, dim) = ERR) return(ERR)
              if (dim > syi(N) | dim < 1) then
                 call remark("rsum: arg2 is out of range")
                 return(ERR)
              endif
              istride = 1
              do i = 0, dim-2
                 istride = istride * syi(N1+i)
              enddo
              dimlen = syi(N1+dim-1)
              dimsize = istride * dimlen
           endif

#### set up space for the answer
           call parget(sxi)

           if (syi(TC) = INTEGER) then
              Point(ix) = paraddr(sxi)
              Point(iy) = paraddr(syi)
              if (nargs == 1) then
                 ix(npoints)=iy(npoints)
                 do i =  npoints-1, 1, -1
                    ix(i) = iy(i) + ix(i+1)
                 enddo
              else
                 do offset = npoints-1, 0, -dimsize
                    i=1
                    icount = 0
                    while (icount < istride)
                       izindx = i + offset
                       ix(izindx) = iy(izindx)
                       do j= 2,dimlen
                          izindx = izindx - istride
                          ix(izindx) = iy(izindx) + ix(izindx+istride)
                       enddo
                       i=i-1
                       icount = icount + 1
                    endwhile
                 enddo
              endif

           elseif(syi(TC) == REAL) then
              Point(x) = paraddr(sxi)
              Point(y) = paraddr(syi)
              if (nargs == 1) then
                 x(npoints) = y(npoints)
                 do i = npoints-1, 1, -1
                    x(i) = y(i) + x(i+1)
                 enddo
              else
                 do offset = npoints-1, 0, -dimsize
                    i=1
                    icount = 0
                    while (icount < istride)
                       izindx = i + offset
                       x(izindx) = y(izindx)
                       do j= 2,dimlen
                          izindx = izindx - istride
                          x(izindx) = y(izindx) + x(izindx+istride)
                       enddo
                       i = i-1
                       icount = icount + 1
                    endwhile
                 enddo
              endif

           elseif(syi(TC) == DOUBLE) then
              Point(xd) = paraddr(sxi)
              Point(yd) = paraddr(syi)
              if (nargs == 1) then
                 xd(npoints) = yd(npoints)
                 do i = npoints-1, 1, -1
                    xd(i) = yd(i) + xd(i+1)
                 enddo
              else
                 do offset = npoints-1, 0, -dimsize
                    i=1
                    icount = 0
                    while (icount < istride)
                       izindx = i + offset
                       xd(izindx) = yd(izindx)
                       do j= 2,dimlen
                          izindx = izindx - istride
                          xd(izindx) = yd(izindx) + xd(izindx+istride)
                       enddo
                       i = i-1
                       icount = icount + 1
                    endwhile
                 enddo
              endif

ifelse(HAS_DOUBLE_COMPLEX,YES,[
           elseif(syi(TC) == COMPLEX) then
],[
           elseif(syi(TC) == COMPLEX|syi(TC)==DOUBLE_C) then
])
              Point(xc) = paraddr(sxi)
              Point(yc) = paraddr(syi)
              if (nargs == 1) then
                 xc(npoints) = yc(npoints)
                 do i = npoints-1, 1, -1
                    xc(i) = yc(i) + xc(i+1)
                 enddo
              else
                 do offset = npoints-1, 0, -dimsize
                    i = 1
                    icount = 0
                    while (icount < istride)
                       izindx = i + offset
                       xc(izindx) = yc(izindx)
                       do j= 2,dimlen
                          izindx = izindx + istride
                          xc(izindx) = yc(izindx) + xc(izindx+istride)
                       enddo
                       i = i-1
                       icount = icount + 1
                    endwhile
                 enddo
              endif

           else
              call remark("rsum: arg1 is wrong type")
              call parrel(syi)
              return(ERR)
           endif

        call parrel(syi)   # release space for arguments
        if (nargs == 2) call parrel(szi)

        else #not a builtin function
                fndflg = FALSE
                return(OK)
        endif
####################   F I N I S H   ####################
900     continue
        return(OK)
        end
