        function parbfcn7( nargs, fname, sxi, fndflg)
# avoid xmp problems !
clll.   optimize level g
#
#       ----- written by Andrew Zachary 4/3/85
#               fixed bugs in inner, outer  6/25/85 dubois
#               changed to handle structured argument list 6/10/85
#             rewrite for call from parxfcn dubois 1/8/87
#             changed to accomodate package builtins 12/10/87
#               rewrite to add double - Peter Willmann 3/30/89
#
#       reduces the production
#
#       <rid>::= reference <args>
#
#       for the builtin functions
#
#       Revised: Zane C. Motteler
#                January 1990
#       Purpose: Change fcnargb call to fcnargbp when NODATA is needed
#                COPY most of the time, because a copy of the data is needed.
#                NODATA for the rest, because only information about the data
#                       (length, type, ...) is needed
#       This supports lazy evaluation of function arguments (they are only
#       evaluated as -- and when -- needed).
#
#       Revised: Zane C. Motteler
#                August 1999
#       Purpose: stack and stack pointer are no longer necessary.
#                position of stack frame is known. arguments
#                run from rlinkp+1 to rsp.
Use(Controls)
Use(Functions)
        integer parbfcn7, nargs
        logical fndflg
        Varname fname, vname
        Dynamic(     x   ,    real   , 1 )
        Dynamic(    xc   ,  complex  , 1 )
        Dynamic(    xd   , double precision, 1 )
        Dynamic(     y   ,    real   , 1 )
        Dynamic(    yc   ,  complex  , 1 )
        Dynamic(    yd   , double precision, 1 )
        Dynamic(    ix   ,  integer  , 1 )
        Dynamic(    iy   ,  integer  , 1 )
        Dynamic(    ax   , Address )
#
        integer sxi(SSWIDTH), syi(SSWIDTH), szi(SSWIDTH)
        integer parlen, parcoerc
        Address paraddr
        external paraddr, parlen, parcoerc
        integer parint, parname, utgetcl
        external parint, parname, utgetcl, parnams, basloc
        Address basloc
        double precision drmsdv, drmssq, ddiff, dvalue
        real rvalue, rmsdv, rmssq, rdiff
        integer i, j, npoints, itot
        integer dim, dimlen, dimsize, offset, nc
        integer dimlens(7)
        integer dimstride(7+1)
        Filename f
        Address fd
clll.   option nodyneqv

        fndflg = TRUE

#  begin search through function list
####################   P S U M   #####################
        if (fname = "psum") then

#### get the argument
           call fcnargb(1, syi)
           npoints = parlen(syi)
           call parcopy(syi,sxi)
           if (nargs == 2) then
              call fcnargb(2, szi)
              if (parint(szi, dim) = ERR) return(ERR)
              if (dim > syi(N) | dim < 1) then
                 call remark("psum: arg2 is out of range")
                 return(ERR)
              endif
              istride = 1
              do i = 0, dim-2
                 istride = istride * syi(N1+i)
              enddo
              dimlen = syi(N1+dim-1)
              dimsize = istride * dimlen

           endif

#### set up space for the answer
           call parget(sxi)


           if (syi(TC) == INTEGER) then
              Point(ix) = paraddr(sxi)
              Point(iy) = paraddr(syi)
              if (nargs == 1) then
                 ix(1) = iy(1)
                 do i = 2, npoints
                    ix(i) = iy(i) + ix(i-1)
                 enddo
              else
                 do offset = 0, npoints-1, dimsize
                    do i = 1, istride
                       izindx = i + offset
                       ix(izindx) = iy(izindx)
                       do j= 2, dimlen
                          izindx = izindx + istride
                          ix(izindx) = iy(izindx) + ix(izindx-istride)
                       enddo
                    enddo
                 enddo
              endif

           elseif(syi(TC) == REAL) then
              Point(x) = paraddr(sxi)
              Point(y) = paraddr(syi)
              if (nargs == 1) then
                 x(1) = y(1)
                 do i = 2, npoints
                    x(i) = y(i) + x(i-1)
                 enddo
              else
                 do offset = 0, npoints-1, dimsize
                    do i = 1, istride
                       izindx = i + offset
                       x(izindx) = y(izindx)
                       do j= 2, dimlen
                          izindx = izindx + istride
                          x(izindx) = y(izindx) + x(izindx-istride)
                       enddo
                    enddo
                 enddo
              endif

           elseif(syi(TC) == DOUBLE) then
              Point(xd) = paraddr(sxi)
              Point(yd) = paraddr(syi)
              if (nargs == 1) then
                 xd(1) = yd(1)
                 do i = 2, npoints
                    xd(i) = yd(i) + xd(i-1)
                 enddo
              else

###              -- increment the index of the dimensions following dim

                 do offset = 0, npoints-1, dimsize

###              -- increment the index of the dimensions preceding dim

                    do i = 1, istride
                       izindx = i + offset
                       xd(izindx) = yd(izindx)
                       do j= 2, dimlen
                          izindx = izindx + istride
                          xd(izindx) = yd(izindx) + xd(izindx-istride)
                       enddo
                    enddo
                 enddo
              endif

ifelse(HAS_DOUBLE_COMPLEX,YES,[
           elseif(syi(TC) == COMPLEX) then
],[
           elseif(syi(TC) == COMPLEX|syi(TC)==DOUBLE_C) then
])
              Point(xc) = paraddr(sxi)
              Point(yc) = paraddr(syi)
              if (nargs == 1) then
                 xc(1) = yc(1)
                 do i = 2, npoints
                    xc(i) = yc(i) + xc(i-1)
                 enddo
              else

###              -- increment the index of the dimensions following dim

                 do offset = 0, npoints-1, dimsize

###              -- increment the index of the dimensions preceding dim

                    do i = 1, istride
                       izindx = i + offset
                       xc(izindx) = yc(izindx)
                       do j= 2, dimlen
                          izindx = izindx + istride
                          xc(izindx) = yc(izindx) + xc(izindx-istride)
                       enddo
                    enddo
                 enddo
              endif

           else
              call remark("psum: arg1 is wrong type")
              call parrel(syi)
              return(ERR)
           endif
           call parrel(syi)   # release space for arguments
           if (nargs == 2) call parrel(szi)

###   R S U M   ###
###   This is a reversal of PSUM   ###
###   first = sum_over_all, second = sum_over_all - last, and so on   ###

        elseif (fname = "rsum") then

#### get the argument
           call fcnargb(1, syi)
           npoints = parlen(syi)
           call parcopy(syi,sxi)
           if (nargs == 2) then
              call fcnargb(2, szi)
              if (parint(szi, dim) = ERR) return(ERR)
              if (dim > syi(N) | dim < 1) then
                 call remark("rsum: arg2 is out of range")
                 return(ERR)
              endif
              istride = 1
              do i = 0, dim-2
                 istride = istride * syi(N1+i)
              enddo
              dimlen = syi(N1+dim-1)
              dimsize = istride * dimlen
           endif

#### set up space for the answer
           call parget(sxi)

           if (syi(TC) = INTEGER) then
              Point(ix) = paraddr(sxi)
              Point(iy) = paraddr(syi)
              if (nargs == 1) then
                 ix(npoints)=iy(npoints)
                 itot = ix(npoints)
                 do i =  npoints-1, 1, -1
                    itot = itot + iy(i)
                    ix(i) = itot
                 enddo
              else

###              -- increment the index of the dimensions following dim

                 do offset = npoints-1, 0, -dimsize

###              -- increment the index of the dimensions preceding dim
                    i=1
                    icount = 0
                    while (icount < istride)
                       izindx = i + offset
                       ix(izindx) = iy(izindx)
                       do j= 2,dimlen
                          izindx = izindx - istride
                          ix(izindx) = iy(izindx) + ix(izindx+istride)
                       enddo
                       i=i-1
                       icount = icount + 1
                    endwhile
                 enddo
              endif

           elseif(syi(TC) == REAL) then
              Point(x) = paraddr(sxi)
              Point(y) = paraddr(syi)
              if (nargs == 1) then
                 x(npoints) = y(npoints)
                 do i = npoints-1, 1, -1
                    x(i) = y(i) + x(i+1)
                 enddo
              else

###              -- increment the index of the dimensions following dim

                 do offset = npoints-1, 0, -dimsize

###              -- increment the index of the dimensions preceding dim
                    i=1
                    icount = 0
                    while (icount < istride)
                       izindx = i + offset
                       x(izindx) = y(izindx)
                       do j= 2,dimlen
                          izindx = izindx - istride
                          x(izindx) = y(izindx) + x(izindx+istride)
                       enddo
                       i = i-1
                       icount = icount + 1
                    endwhile
                 enddo
              endif

           elseif(syi(TC) == DOUBLE) then
              Point(xd) = paraddr(sxi)
              Point(yd) = paraddr(syi)
              if (nargs == 1) then
                 xd(npoints) = yd(npoints)
                 do i = npoints-1, 1, -1
                    xd(i) = yd(i) + xd(i+1)
                 enddo
              else

###              -- increment the index of the dimensions following dim

                 do offset = npoints-1, 0, -dimsize

###              -- increment the index of the dimensions preceding dim
                    i=1
                    icount = 0
                    while (icount < istride)
                       izindx = i + offset
                       xd(izindx) = yd(izindx)
                       do j= 2,dimlen
                          izindx = izindx - istride
                          xd(izindx) = yd(izindx) + xd(izindx+istride)
                       enddo
                       i = i-1
                       icount = icount + 1
                    endwhile
                 enddo
              endif

ifelse(HAS_DOUBLE_COMPLEX,YES,[
           elseif(syi(TC) == COMPLEX) then
],[
           elseif(syi(TC) == COMPLEX|syi(TC)==DOUBLE_C) then
])
              Point(xc) = paraddr(sxi)
              Point(yc) = paraddr(syi)
              if (nargs == 1) then
                 xc(npoints) = yc(npoints)
                 do i = npoints-1, 1, -1
                    xc(i) = yc(i) + xc(i+1)
                 enddo
              else

###              -- increment the index of the dimensions following dim

                 do offset = npoints-1, 0, -dimsize

###              -- increment the index of the dimensions preceding dim

                    i = 1
                    icount = 0
                    while (icount < istride)
                       izindx = i + offset
                       xc(izindx) = yc(izindx)
                       do j= 2,dimlen
                          izindx = izindx + istride
                          xc(izindx) = yc(izindx) + xc(izindx+istride)
                       enddo
                       i = i-1
                       icount = icount + 1
                    endwhile
                 enddo
              endif

           else
              call remark("rsum: arg1 is wrong type")
              call parrel(syi)
              return(ERR)
           endif

        call parrel(syi)   # release space for arguments
        if (nargs == 2) call parrel(szi)

####################   R M S D V   #################################

        elseif (fname = "rmsdv") then
# set up array for functions which stride can stride along a dimension.
#     i.e.  funcname (arrayname [, dimension])

#### get the argument
           call fcnargb(1, syi)
           if (nargs == 1) then
              npoints = parlen(syi)
              sxi(N) = 0
              sxi(TC) = syi(TC)

           elseif (nargs == 2) then
              call fcnargb(2, szi)
              if (parint(szi, dim) = ERR) return(ERR)
              call parrel(szi)    # release space for argument
              if (dim > syi(N) | dim < 1) then
                 call remark("rmsdv: arg2 is out of range")
                 return(ERR)
              endif
              sxi(N) = syi(N) - 1
              sxi(TC) = syi(TC)

              dimstride(1) = 1
              do i = 1, syi(N)
                 dimlens(i) = syi(N1+i-1)
                 dimstride(i+1) = dimstride(i) * dimlens(i)

                 if (i < dim) then
                    sxi(N1+i-1) = syi(N1+i-1)
                    sxi(M1+i-1) = syi(M1+i-1)
                 elseif (i > dim) then
                    sxi(N1+i-2) = syi(N1+i-1)
                    sxi(M1+i-2) = syi(M1+i-1)
                 endif
              enddo
           endif

#### set up space for the answer
           call parget(sxi)

           if (syi(TC) == INTEGER | syi(TC) == REAL) then
              if (syi(TC) == INTEGER) then
                 if (parcoerc(syi, REAL) = ERR) then
                    call remark ("rmsdv: illegal argument type")
                    return(ERR)
                 endif
                 sxi(TC) = REAL
              endif
              Point(x) = paraddr(sxi)
              Point(y) = paraddr(syi)
              if (nargs == 1) then
                 rmsdv = 0.
                 rmssq=0.
                 do i = 1, npoints
                    rdiff = y(i) - y(1)
                    rmsdv = rmsdv + rdiff
                    rmssq = rmssq +rdiff**2
                 enddo
                 x(1) = sqrt(max(0.,rmssq/npoints-(rmsdv/npoints)**2))
              else
                 newindx = 1

###              -- increment the index of the dimensions following dim.

                 do offset = 0, dimstride(syi(N)+1) -1, dimstride(dim+1)

###              -- increment the index of the dimensions preceding dim.

                    do i = 1, dimstride(dim)
                       izindx = i + offset
                       rmsdv = 0.
                       rmssq = 0.
                       rvalue = y(izindx)
                       do j = 2, dimlens(dim)
                          izindx = izindx + dimstride(dim)
                          rdiff = y(izindx) - rvalue
                          rmsdv = rmsdv + rdiff
                          rmssq = rmssq + rdiff**2
                       enddo
                       x(newindx) = sqrt(max(0.,rmssq/dimlens(dim)-
                                         (rmsdv/dimlens(dim))**2))
                       newindx = newindx + 1
                    enddo
                 enddo
              endif

           elseif(syi(TC) == DOUBLE) then
              Point(xd) = paraddr(sxi)
              Point(yd) = paraddr(syi)
              if (nargs == 1) then
                 drmsdv = 0
                 drmssq = 0
                 do i = 1, npoints
                    ddiff = yd(i) - yd(1)
                    drmsdv = drmsdv + ddiff
                    drmssq = drmssq +ddiff**2
                 enddo
                 xd(1) = sqrt(max(0.d0,drmssq/npoints-(drmsdv/npoints)**2))
              else
                 newindx = 1

###              -- increment the index of the dimensions following dim.

                 do offset = 0, dimstride(syi(N)+1) -1, dimstride(dim+1)

###              -- increment the index of the dimensions preceding dim.

                    do i = 1, dimstride(dim)
                       izindx = i + offset
                       drmsdv = 0
                       drmssq = 0
                       dvalue=yd(izindx)
                       do j = 2, dimlens(dim)
                          izindx = izindx + dimstride(dim)
                          ddiff = yd(izindx) - dvalue
                          drmsdv = drmsdv + ddiff
                          drmssq = drmssq + ddiff**2
                       enddo
                       xd(newindx) = sqrt(max(0.d0,drmssq/dimlens(dim)-
                                         (drmsdv/dimlens(dim))**2))
                       newindx = newindx + 1
                    enddo
                 enddo
              endif
           else
              call remark("rmsdv: arg1 is wrong type")
              call parrel(syi)
              return(ERR)
           endif
           call parrel(syi)   # release space for argument

####################   Z C E N   #################################
        elseif( fname = "zcen") then

###        -- Get the arguments.  The first argument is the array to
###        -- apply the zone centering to.

           call fcnargb(1, syi)

###        -- Make a copy of the data descriptor for the input array.
###        -- Get space for the resulting array.

           call parcopy (syi, sxi)
           call parget (sxi)
           call pardim(syi)   # must do after parcopy, so output sxi has same
                              # original shape as input syi.

           if (syi(TC) >= INTEGER & syi(TC) <=DOUBLE) then

###           -- Coerce an integer array to type REAL.

              if (syi(TC) == INTEGER) then
                 if (parcoerc(syi, REAL) = ERR) then
                    call remark ("zcen:  illegal argument type")
                    return(ERR)
                 endif
                 sxi(TC) = REAL
              endif

              if(syi(TC) == REAL) then
                Point(x) = paraddr(sxi)
                Point(y) = paraddr(syi)

###            -- Zone center 1-dimensional array.

                if (syi(N) = 1) then
                   npoints = parlen(syi)
                   if (npoints <= 0) then
                      call remark ("zcen:  no data available")
                      return (ERR)
                   endif
                   x(1) = y(1)
                   do i = 2, npoints
                      x(i) = (y(i) + y(i-1)) / 2.
                   enddo

###            -- Zone center 2-dimensional array.

                elseif (syi(N) = 2) then
                   nrows = syi(N1)
                   ncols = syi(N2)
                   call zcen2d (y, nrows, ncols, x)

                else
                   call remark ("zcen:  only takes 1 and 2-D arrays")
                   return (ERR)
                endif
              elseif(syi(TC) == DOUBLE) then
                Point(xd) = paraddr(sxi)
                Point(yd) = paraddr(syi)

###            -- Zone center 1-dimensional array.

                if (syi(N) = 1) then
                   npoints = parlen(syi)
                   if (npoints <= 0) then
                      call remark ("zcen:  no data available")
                      return (ERR)
                   endif
                   xd(1) = yd(1)
                   do i = 2, npoints
                      xd(i) = (yd(i) + yd(i-1)) / 2.
                   enddo

###            -- Zone center 2-dimensional array.

                elseif (syi(N) = 2) then
                   nrows = syi(N1)
                   ncols = syi(N2)
                   call dzcen2d (yd, nrows, ncols, xd)

                else
                   call remark ("zcen:  only takes 1 and 2-D arrays")
                   return (ERR)
                endif

              endif

           else
              call remark ("zcen:  invalid type for array")
              return (ERR)
           endif
           call parrel(syi)
##################### BASNXTSQ **************************************
        elseif(fname =="basnxtsq")  then
            call fcnarga(1,szi)
            nc = parname(szi,f)
            call parkill(szi)
            call basnxtsq(f,f)
            nc = utgetcl(f)
            sxi(SS_TC) = -nc
            sxi(SS_N) = 0
            sxi(NAML) = 1 # so it knows address is in literal table.(ZCM 4/10/95)
            call parget(sxi)
            fd = paraddr(sxi)
            call smovftoa (fd, 0, f, 0, nc)
##################### B A S L O C ####################
        elseif(fname =="basloc") then
            # Return the location of the object specified
            call fcnargbp (1, szi)
            sxi (TC) = FWA
            sxi (N) = 0
            call parget(sxi)
            Point (ax) = paraddr (sxi)
            if (szi (TC) < 0) then # string argument
                 call parnams (szi, vname, j) # Get name
                 ax = basloc (vname (1:j))
            else # some other type; just get address
                 nc = parname (szi, vname)
                 ax = basloc (vname (1:nc))
            endif
        else #not a builtin function
                fndflg = FALSE
                return(OK)
        endif
####################   F I N I S H   ####################
900     continue
        return(OK)
        end

	subroutine fcnbres(sxi)
# for use by package builtin routines
        Use(Stacks)
        integer sxi(*)
# put answer on stack
        call parcopy(sxi,ss(1,rlinkp-1))
        return
        end

        subroutine zcen2d (ycen, nrows, ncols, xcen)
#*s
#     NAME OF ROUTINE...zcen2d
#
#     AUTHOR OF ROUTINE...Janet Takemoto  03/03/88
#
#     PURPOSE...
#
#        Zone center the array specified.
#
#     GLOSSARY OF IMPORTANT VARIABLES...
#
#        ycen     =:  array to apply centering to
#        nrows    =:  number of rows in the array
#        ncols    =:  number of columns in the array
#        xcen      := resultant array
#
#     COMMENTS...
#
#        This routine allows the arrays to be accessed with
#        two subscripts.  Currently, the zone centering
#        value = 2.  If additional values are needed, an
#        extra argument may be added to the builtin function.
#/c

        real ycen(nrows, ncols), xcen(nrows, ncols)
        integer i, j

        do i=1, nrows
           xcen(i,1) = ycen(i,1)
        enddo
        do j=1, ncols
           xcen(1,j) = ycen(1,j)
        enddo
        do i=2, nrows
           do j = 2, ncols
              xcen(i,j)=(ycen(i,j)+ycen(i,j-1)+ycen(i-1,j-1)+ycen(i-1,j))/4.
           enddo
        enddo

        return
        end
        subroutine dzcen2d (ycen, nrows, ncols, xcen)
#*s
#     NAME OF ROUTINE...dzcen2d
#
#     AUTHOR OF ROUTINE...Peter a. Willmann  04/08/89
#
#     PURPOSE...
#
#        Zone center the double precision array specified.
#
#     GLOSSARY OF IMPORTANT VARIABLES...
#
#        ycen     =:  array to apply centering to
#        nrows    =:  number of rows in the array
#        ncols    =:  number of columns in the array
#        xcen      := resultant array
#
#     COMMENTS...
#
#        This routine allows the arrays to be accessed with
#        two subscripts.  Currently, the zone centering
#        value = 2.  If additional values are needed, an
#        extra argument may be added to the builtin function.
#/c

        double precision ycen(nrows, ncols), xcen(nrows, ncols)
        integer i, j

        do i=1, nrows
           xcen(i,1) = ycen(i,1)
        enddo
        do j=1, ncols
           xcen(1,j) = ycen(1,j)
        enddo
        do i=2, nrows
           do j = 2, ncols
              xcen(i,j)=(ycen(i,j)+ycen(i,j-1)+ycen(i-1,j-1)+ycen(i-1,j))/4.
           enddo
        enddo

        return
        end

      integer function ivecmax(iarray,ifirst,ilast)
c this function (partially) implements the Mathlib routine maxaf (LCSD-422)
c based on Mike McNeill 3/86 version of aminmx
c  input: iarray= integer array
c         ifirst= the first element in the array
c         ilast= the last element in the array
c  function output: the maximum number in the array
      dimension iarray(*)
      ivecmax = iarray(ifirst)
      do 10 i = ifirst, ilast
         if (iarray(i) > ivecmax) ivecmax = iarray(i)
10    continue
      return
      end



      integer function ivecmin(iarray,ifirst,ilast)
c this subroutine (partially) implements the Mathlib routine minaf (LCSD-422)
c based on Mike McNeill 3/86 version of aminmx
c  input: iarray= integer array
c         ifirst= the first element in the array
c         ilast= the last element in the array
c  function output: the minimum number in the array
      dimension iarray(*)
      ivecmin = iarray(ifirst)
      do 10 i = ifirst, ilast
         if (iarray(i) < ivecmin) ivecmin = iarray(i)
10    continue
      return
      end

      real function vecmax(array,ifirst,ilast)
c this function (partially) implements the Mathlib routine amaxaf (LCSD-422)
c based on Mike McNeill 3/86 version of aminmx
c  input: array= real array
c         ifirst= the first element in the array
c         ilast= the last element in the array
c  function output: the maximum number in the array
      dimension array(*)
      vecmax = array(ifirst)
      do 10 i = ifirst, ilast
         if (array(i) > vecmax) vecmax = array(i)
10    continue
      return
      end

      double precision function dvecmax(array,ifirst,ilast)
c this function (partially) implements the Mathlib routine amaxaf (LCSD-422)
c based on Mike McNeill 3/86 version of aminmx
c  input: array= double precision array
c         ifirst= the first element in the array
c         ilast= the last element in the array
c  function output: the maximum number in the array
      double precision array(*)
      dvecmax = array(ifirst)
      do 10 i = ifirst, ilast
         if (array(i) > dvecmax) dvecmax = array(i)
10    continue
      return
      end

      real function vecmin(array,ifirst,ilast)
c this function (partially) implements the Mathlib routine aminaf (LCSD-422)
c based on Mike McNeill 3/86 version of aminmx
c  input: array= real array
c         ifirst= the first element in the array
c         ilast= the last element in the array
c  function output: the minimum number in the array
      dimension array(*)
      vecmin = array(ifirst)
      do 10 i = ifirst, ilast
         if (array(i) < vecmin) vecmin = array(i)
10    continue
      return
      end

      double precision function dvecmin(array,ifirst,ilast)
c this function (partially) implements the Mathlib routine aminaf (LCSD-422)
c based on Mike McNeill 3/86 version of aminmx
c  input: array= double precision array
c         ifirst= the first element in the array
c         ilast= the last element in the array
c  function output: the minimum number in the array
      double precision array(*)
      dvecmin = array(ifirst)
      do 10 i = ifirst, ilast
         if (array(i) < dvecmin) dvecmin = array(i)
10    continue
      return
      end

      subroutine fcnargd(n,iarg,sdi,name)
#return iarg'th argument, defaulting to name; result to sdi
#       Revised: Zane C. Motteler
#                August 1999
#       Purpose: stack and stack pointer are no longer necessary.
#                position of stack frame is known. arguments
#                run from rlinkp+1 to rsp.
      character*(*) name
      integer  n, iarg, sdi(SSWIDTH), i, ilow(7),
         ihi(7), icol(7), ndim, tc, nwords, jvar, ndb
      Address fwa
      logical  gottemp
      integer rtfinder, parlen, utsizeof
        Address paraddr
      external rtfinder, paraddr, parlen, utsizeof
      Dynamic(idata,integer,1)
      Dynamic(jdata,integer,1)
      character*64 tempname

      if(iarg <= n) then
         call fcnarga(iarg,sdi)
         if(sdi(TC) <> 0) return
      endif
      if(rtfinder(name,jvar,ndb,tc,"fcnargd")==OK) then
            gottemp=FALSE
            if( tc == FUNCTION_TYPE) then
              tempname="par.$fcnargd="//name
	      call parsestr(tempname)
              gottemp = TRUE
              if(rtfinder("par.$fcnargd",jvar,ndb,tc,"fcnargd")==ERR) then
                 call remark("Internal error in fcnargd, please report this.")
                 call kaboom(0)
              endif
            endif
            call rtxdb(jvar,ndb,fwa,ndim,ilow,ihi,icol,2)
            sdi(N)=ndim
            sdi(TC)=tc
            do i=1, ndim
               sdi(N1-1+i) = icol(i)
               sdi(M1-1+i) = ilow(i)
               sdi(I1-1+i) = 1
            enddo
            call parget(sdi)
            Point(idata) = fwa
            Point(jdata) = paraddr(sdi)
            nwords = utsizeof(parlen(sdi),tc)
            call zmovewrd(jdata,idata,nwords)
            if(gottemp) then
              call rtstgdel(jvar, ndb)
            endif
      else
            call kaboom(0)
      endif
      return
      end

      integer function par2get(fname,syi,nargs,dim,sxi,dimlens,dimstride)
# encapsulate a frequently repeated motif
#       Revised: Zane C. Motteler
#                August 1999
#       Purpose: stack and stack pointer are no longer necessary.
#                position of stack frame is known. arguments
#                run from rlinkp+1 to rsp.
      Varname fname
      integer sxi(SS_WIDTH), syi(SS_WIDTH), nargs, npoints, dim, dimlens(7),
        dimstride(8), szi(SS_WIDTH)
      integer parlen, parint, i

      npoints = parlen(syi)
      if( npoints == 0) then
          # This case is detected as a special case by the caller
          return (0)
      endif
      if (nargs == 1) then
           sxi(N) = 0
           sxi(TC) = syi(TC)
           dim = 0
           dimlens (1) = 0
           dimstride (1) = 0
      elseif (nargs == 2) then
           call fcnargb(2, szi)
           if (parint(szi, dim) = ERR) return(ERR)
           call parrel(szi)    # release space for argument
           if (dim > syi(N) | dim < 1) then
              call remark(fname)
              call remark("has second argument out of range")
              call kaboom(0)
           endif
           sxi(N) = syi(N) - 1
           sxi(TC) = syi(TC)
           dimstride(1) = 1
           do i = 1, syi(N)
              dimlens(i) = syi(N1+i-1)
              dimstride(i+1) = dimstride(i) * dimlens(i)

              if (i < dim) then
                 sxi(N1+i-1) = syi(N1+i-1)
                 sxi(M1+i-1) = syi(M1+i-1)
              elseif (i > dim) then
                 sxi(N1+i-2) = syi(N1+i-1)
                 sxi(M1+i-2) = syi(M1+i-1)
              endif
           enddo
       endif
##   set up space for the answer
       call parget(sxi)
       return(npoints)
       end
