# (ZCM 5/3/1999) This routine implements the bit functions for Basis.
       function parbfcn8( nargs, fname, sxi, fndflg)
#       Revised: Zane C. Motteler
#                August 1999
#       Purpose: stack and stack pointer are no longer necessary.
#                position of stack frame is known. arguments
#                run from rlinkp+1 to rsp.
       integer utgetcl, parlen, parint, nargs
       integer sxi (SSWIDTH), syi (SSWIDTH), szi (SSWIDTH)
       Varname fname
       logical fngflg, arg2scalar
       external utgetcl, parlen, parint
       integer iarg2, iarg3, i, npoints
       Address paraddr
       external paraddr
       Dynamic (lx, logical, 1)
       Dynamic (ix, integer, 1)
       Dynamic (iy, integer, 1)
# avoid xmp problems !
clll.   optimize level g

      if (nargs < 1 | nargs > 3 | (nargs == 3 & fname <> "ishftc") | \
          (nargs == 1 & fname <> "not")) then
            call baserror ("Wrong number of arguments for bit function " // fname)
            call kaboom (0)
      endif
#  All these functions have at least one argument; get it.
      call fcnargb (1, sxi)
      if (sxi (TC) <> INTEGER) then
         call baserror ("Bit function "//fname(1:utgetcl(fname))// \
            " only applies to integers.")
         call kaboom (0)
      endif
      npoints = parlen (sxi)
      if (nargs >= 2) then
         call fcnargb(2, syi)
         if (syi (TC) <> INTEGER) then
            call baserror ("Second argument of "//fname(1:utgetcl(fname))// \
               " must be integer.")
            call kaboom (0)
         endif
      endif
      if (parlen (syi) ==1) then
         arg2scalar = TRUE
         if (parint (syi, iarg2) == ERR) return (ERR)
         call parrel (syi)
      else if (fname == "iand" | fname == "ior" | fname == "ieor" ) then
         if (npoints != parlen (syi)) then
            call baserror ("Second argument of "//fname(1:utgetcl(fname))// \
               " must have same size as first.")
            call kaboom (0)
         endif
         arg2scalar = FALSE
      else
         call baserror ("Second argument of "//fname(1:utgetcl(fname))// \
            " must be scalar.")
         call kaboom (0)
      endif

      if (nargs == 3) then
         call fcnargb(3, szi)
         if (szi (TC) <> INTEGER) then
            call baserror ("Third argument of "//fname(1:utgetcl(fname))// \
               " must be integer.")
            call kaboom (0)
         elseif (parlen (szi) <> 1) then
            call baserror ("Third argument of "//fname(1:utgetcl(fname))// \
               " must be scalar.")
            call kaboom (0)
         endif
         if (parint (szi, iarg3) == ERR) return (ERR)
         call parrel (szi)
      endif
#  begin search through function list
####################   B T E S T ####################################
      if (fname == "btest") then
         # we want to return an array the same size and shape, but of
         # type logical, so copy the original stack element, then
         # change its type, then get new space.
         call parcopy (sxi, syi)
         sxi (TC) = LOGICAL
         call parget (sxi)
         Point (lx) = paraddr (sxi)
         Point (ix) = paraddr (syi)
         do i = 1, npoints
            lx (i) = btest (ix (i), iarg2)
         enddo
         # Finally, release space for data.
         call parrel (syi)
####################### I A N D #####################################
      else if (fname == "iand") then
         Point (ix) = paraddr (sxi)
         if (arg2scalar) then
            do i = 1, npoints
               ix (i) = iand (ix (i), iarg2)
            enddo
         else
            Point (iy) = paraddr (syi)
            do i = 1, npoints
               ix (i) = iand (ix (i), iy(i))
            enddo
            call parrel (syi)
         endif
####################   I B C L R   ##################################
      else if (fname == "ibclr") then
         Point (ix) = paraddr (sxi)
         do i = 1, npoints
            ix (i) = ibclr (ix (i), iarg2)
         enddo
####################   I B S E T   ##################################
      else if (fname == "ibset") then
         Point (ix) = paraddr (sxi)
         do i = 1, npoints
            ix (i) = ibset (ix (i), iarg2)
         enddo
####################### I E O R #####################################
      else if (fname == "ieor") then
         Point (ix) = paraddr (sxi)
         if (arg2scalar) then
            do i = 1, npoints
               ix (i) = ieor (ix (i), iarg2)
            enddo
         else
            Point (iy) = paraddr (syi)
            do i = 1, npoints
               ix (i) = ieor (ix (i), iy(i))
            enddo
            call parrel (syi)
         endif
######################## I O R ######################################
      else if (fname == "ior") then
         Point (ix) = paraddr (sxi)
         if (arg2scalar) then
            do i = 1, npoints
               ix (i) = ior (ix (i), iarg2)
            enddo
         else
            Point (iy) = paraddr (syi)
            do i = 1, npoints
               ix (i) = ior (ix (i), iy(i))
            enddo
            call parrel (syi)
         endif
####################   I S H F T   ##################################
      else if (fname == "ishft") then
         Point (ix) = paraddr (sxi)
            do i = 1, npoints
               ix (i) = ishft (ix (i), iarg2)
            enddo
####################  I S H T F C  ##################################
      else if (fname == "ishftc") then
         Point (ix) = paraddr (sxi)
         if (nargs == 2) then
            do i = 1, npoints
               ix (i) = ishftc (ix (i), iarg2)
            enddo
         elseif (nargs == 3) then
            do i = 1, npoints
               ix (i) = ishftc (ix (i), iarg2, iarg3)
            enddo
         endif
######################## N O T ######################################
      else if (fname == "not") then
         Point (ix) = paraddr (sxi)
         do i = 1, npoints
            ix (i) = not (ix (i))
         enddo
      else 
         fndflg = FALSE
      end if
      return (OK)
      end
