
c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c PRRATAN2 - implements the real arctan of 2 variables

      integer function prratan2(rx, ry, rvalue, npointsx, npointsy,
     &                          npoints)
      real rx(*), ry(*), rvalue, del, rpi
      integer npointsx, npointsy, npoints, i, k
      
      rpi = Pi

      if (npointsx == 1) then
         do i = npointsy, 1, -1
            #avoid division by 0.
            del = 0.
            if (rvalue < 0.) del = sign(rpi, ry(i))
            if (rvalue == 0.) then
               if (ry(i) ~= 0) then
                  rx(i) = sign(rpi/2., ry(i))
               else
                  call baserror("atan2(0., 0.) is not defined.")
                  return(ERR)
               endif
            else
               rx(i) = atan(ry(i)/ rvalue) + del
            endif
         enddo
      else
         do i = npointsx, 1, -1
            k = i
            if (npointsy == 1) k = 1
            #avoid division by 0.
            del = 0.
            if (rx(i) < 0.) del = sign(rpi, ry(k))
            if (rx(i) == 0.) then
               if (ry(k) ~= 0) then
                  rx(i) = sign(rpi/2., ry(k))
               else
                  call baserror("atan2(0., 0.) is not defined.")
                  return(ERR)
               endif
            else
               rx(i) = atan(ry(k)/ rx(i)) + del
            endif
         enddo
      endif

      return(OK)
      end
 
c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c PRDATAN2 - implements the double arctan of 2 variables(ZCM 3/10/2000)

      integer function prdatan2(dx, dy, dvalue, npointsx, npointsy, npoints)
      double precision dx(*), dy(*), dvalue, ddel
      integer npointsx, npoints, i
      
      if (npointsx == 1) then
         do i = npointsy, 1, -1
            #avoid division by 0.
            ddel = 0.d0
            if (dvalue < 0.d0) ddel = sign(PiD, dy(i))
            if (dvalue == 0.d0) then
               if (dy(i) ~= 0) then
                  dx(i) = sign(PiD/2.d0, dy(i))
               else
                  call baserror("atan2(0.d0, 0.d0) is not defined.")
                  return(ERR)
               endif
            else
               dx(i) = atan(dy(i)/ dvalue ) + ddel
            endif
         enddo
      else
         do i = npointsx, 1, -1
            k = i
            if (npointsy == 1) k = 1
               #avoid division by 0.d0
               ddel = 0.d0
               if (dx(i) < 0.d0) ddel = sign(PiD, dy(k))
               if (dx(i) == 0.d0) then
                  if (dy(k) ~= 0) then
                     dx(i) = sign(PiD/2.d0, dy(k))
                  else
                     call baserror("atan2(0.d0, 0.d0) is not defined.")
                     return(ERR)
                  endif
               else
                  dx(i) = atan(dy(k)/ dx(i) ) + ddel
               endif
            enddo
      endif

      return(OK)
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

