#ifndef FUNC_H
#define FUNC_H

#include "par_.h"
#include "Basis.h"

/* externals */
extern void Basltest (Integer line);
extern void Rtsloc (Integer n);
extern void Rtpoploc (void);
extern Integer Rtgloc (void);
extern void Lremit (Integer code);
extern Integer Rtgrpe (Integer ndb, char * group);
extern integer Lrexec(void);
extern Integer Parname (Integer * si, char * parnam);
extern void Parrel (Integer * s);
extern Integer Fstkgeti (Integer comp, Integer depth);
extern void Parnest (Integer * icode);
extern void Cllit (Integer i);
extern Address Getaddr (Integer i);
extern Integer * Gmacatra (Integer i);

typedef struct {
    Integer spfn;               /* position of function name on runtime stack */
    Integer retadd;     /* where function value will be returned      */
    Integer Nextcode;
    Integer locdepth;
    Integer linenumber;
    Integer ftextptr;
    Integer ftextlno;
    Integer ftextbeg;
    Integer ftextend;
    Address retbgn;    /* base of function code                    */
    Address namebgn;   /* Addresses into NameType array */
    Address typebgn;
} Function_Stack;

typedef struct {
 char names [VARNAMESIZE];      /* names for functions and their arguments */
 Integer types;                 /* types for functions and their arguments */
} NameType;

extern Function_Stack * funcstk;    /* stack        */
extern NameType * funpar;           /* array of names & types */

extern int funcdep;                /* stack pointer */
extern int cfuncdep;
extern int fund;
extern int fdepth;
extern Integer funmax;
extern char * functext;
extern Integer textsize;
extern Integer textpos;
extern logical linsuprs;
extern Integer xuser;
extern Integer * intcode;
extern Integer * ic;
extern Integer * forstck;
extern Integer * lbstack;
extern Integer * argfwa;
extern Integer * arglen;
extern Integer * looptyp;
extern Integer * loopctl;
extern Integer * fnfwa;
extern Integer * lpnext;
extern Integer * tb;
extern Integer nextcode,
               mxcode,
               codebgn,
               mdl,
               forstptr,
               lbstptr,
               mxdep,
               nestlevl,
               lpdepth,
               lxskip,
               tickflag,
               tclose,
               tickpos;
extern Integer macatr;
extern Integer oldpc,
               nsp;
extern char * nb;
extern logical set1flg,
               lxsave,
               firstf;
extern Integer * values,
               * nextptr,
               * nextptd;
extern real8 * dvalues;
extern Integer valavail,
               valavaid,
               maxvals,
               maxvald;

#define spfn(i) funcstk [i].spfn
#define retadd(i) funcstk [i].retadd
#define Nextcode(i) funcstk [i].Nextcode
#define locdepth(i) funcstk [i].locdepth
#define linenumber(i) funcstk [i].linenumber
#define retbgn(i) funcstk [i].retbgn
#define namebgn(i) funcstk [i].namebgn
#define typebgn(i) funcstk [i].typebgn
#define ftextptr(i) funcstk [i].ftextptr
#define ftextlno(i) funcstk [i].ftextlno
#define ftextbeg(i) funcstk [i].ftextbeg
#define ftextend(i) funcstk [i].ftextend

#define funparn(i) funpar[i].names
#define funpart(i) funpar[i].types

#if ! defined (NOTSET)
#  if defined (SGI)
#       define NOTSET 0
#  else
#       define NOTSET -8192
#  endif
#endif

#endif
