
!*--------------------------------------------------------------------------
!*--------------------------------------------------------------------------

# Wrapper function to be called by C when it wants glbfind
# (No std way to get string from C to FORTRAN, so use string index)
# Written by Zane C. Motteler, 9/30/1999

      integer function fglbfind (ndb, nvar, tc)
      integer ndb, nvar, tc
      Varname name
      integer glbfind
      external glbfind

      call strgget (nvar, name)
      return (glbfind (ndb, name, tc))
      end

!*--------------------------------------------------------------------------
!*--------------------------------------------------------------------------

#*s
#     NAME OF ROUTINE...glbecho
#
#     AUTHOR OF ROUTINE...Paul Dubois 12/2/84; new arg added 6/14/85
#                                               third arg 11/24/85
#     PURPOSE...
#
#        Give user code a chance to echo input
#
#     GLOSSARY OF IMPORTANT VARIABLES...
#
#        line     = array containing input line
#        ioc      = i/o connector from which line was read
#        clen    = number of chars in line
#
# (FNF 8/20/97)  Changed "write(iecho,..." to "call baspline(iecho,...".
# (FNF 9/10/97)  Corrected so echo=logonly(=2) works.  (Lynda LoDestro)
#/c

      subroutine glbecho(ioc,line,clen)
Use(Basplc)
        integer ioc,clen,clen1, getius
        external getius
	character*(*) line
        character*500 line1

Use(Controls)

        clen1 = clen
        if(clen1 = 0) then
	   clen1=1
	   line(1:1)=" "
        endif
        if(ioc <> STDIN) then   # We are reading from a file.
          if (echo==1) then                   #Echo to terminal;
                                              # baspline will echo to logfile.
             call baspline(getius(),line(1:clen1))

          else if (iecho>0 & echo==2) then    #Echo to logfile only.
             call baspline(iecho,line(1:clen1))
          endif

        else   # Echo line input from terminal with '> ' prepended.
          if(iecho> 0) then
             line1='> '//line(1:clen1)
             clen1=clen1+2   # Assume this doesn't exceed length of line1.
             call baspline(iecho,line1(1:clen1))
          endif
        endif
        call basisech(line(1:clen1),clen1)
        return
        end
  
!*--------------------------------------------------------------------------
!*--------------------------------------------------------------------------

      subroutine mcfilset(macfil)
      character*(*) macfil
      integer i
Use(Code_Info)
      if(macfil == " ") return
      if(nmacfils >= MAXPAK) then
         call baderr("Too many startup files specified.")
      endif
      do i=1, nmacfils
         if(macfil=macfile(i)) then
            call remark(
            "Caution: given startup file listed twice, cannot comply.")
            call remark("Will read the following file only once:")
            call remark(macfil)
         endif
      enddo
      nmacfils = nmacfils + 1
      macfile(nmacfils) = macfil
      return
      end

!*--------------------------------------------------------------------------
!*--------------------------------------------------------------------------

# now obsolete

      subroutine basdfset(nlib)
      integer nlib
      return
      end

!*--------------------------------------------------------------------------
!*--------------------------------------------------------------------------

      subroutine varset(codnam, prmpt, lprmpt, verbos, ech)
Use(Code_Info)
Use(Controls)
Use(Problem_name)
      character*(*) codnam, prmpt, verbos, ech
      integer lprmpt

      if(codnam <> " ") codename = codnam
      if(prmpt <> " ") cprompt = prmpt
      if(lprmpt > 0) lcprompt = lprmpt
      if(verbos <> "yes") verbose = NO
      if(ech <> "yes") echo = NO
      return
      end

!*--------------------------------------------------------------------------
!*--------------------------------------------------------------------------

       integer function izverbos(dummy)
Use(Controls)
      real dummy
 
      izverbos = verbose
      return
      end
 
!*--------------------------------------------------------------------------
!*--------------------------------------------------------------------------

# write version info to terminal

    subroutine version
    integer iooutus
    external iooutus
    call glbhead(iooutus(),2)
    return
    end

!*--------------------------------------------------------------------------
!*--------------------------------------------------------------------------

#*s
#     NAME OF ROUTINE...glbhead
#
#     AUTHOR OF ROUTINE...Paul F. Dubois Sept. 27, 1984
#       revised 12/88 PFD
#
#     PURPOSE...
#
#         write information about this code to ioc fd.
#
#     GLOSSARY OF IMPORTANT VARIABLES...
#
#        fd = unit specifier on which to write
#
#/c

      subroutine glbhead (fd,iflag)
Use(Controls)
Use(Code_Info)
Use(Constants)
        integer fd
        character*(*) cdate,ctime,rtime,rdate,rmach
        character*72 cline0, cline1, cline2
        character*(64) name,vers,versmsg
        integer utgetcl, rtnumpak
        external utgetcl, rtnumpak

#
        call nameme(name,vers,'.')
        versmsg = ")"
        if(vers == 'x') call parversion(vers)
        if(vers <> BLANK) versmsg=", Version "//vers(1:utgetcl(vers))//")"
        cline0=codename//" ("//name(1:utgetcl(name)) \
               //versmsg(1:utgetcl(versmsg))
        cline1 = BLANK
        call glbtmdat(codetime,codedate)
	if (codedate <> BLANK) then
	   write(cline1,100) codedate, codetime
	endif
        write(cline2,102) cruntime,crundate,crunmach(1:utgetcl(crunmach))

        call baswline(fd, cline0)
        if(cline1<>BLANK) call baswline(fd,cline1)
        call baswline(fd, cline2)

        if (iflag <> NO) then # write version info
          do i = 1, rtnumpak ()
            if (iflag==2|verbose == YES | fd == stdplot) call glbvers(i,fd)
          enddo
        endif

100     format('Created on ',a,' at ',a)
102     format('Run at ',a,' on ',a,' on the ',a,' machine')

        return

        entry glbheadi(cdate,ctime,rtime,rdate,rmach)
# return the value of codedate, codetime,cruntime,crundate,crunmach
# provided for authors who want to get at this info; not used by Basis
        cdate=codedate
        ctime=codetime
        rtime=cruntime
        rdate=crundate
        rmach=crunmach
        return
        end

!*--------------------------------------------------------------------------
!*--------------------------------------------------------------------------

# ZCM (7/23/1999) Isolating references to Code_Info to glb.m

        character*80 function gtimdat()
        Use(Code_Info)
        return ("#date="//crundate//" time="//cruntime//" mach="//crunmach)
        end

!*--------------------------------------------------------------------------
!*--------------------------------------------------------------------------

# ZCM (7/23/1999) Return the number of macfiles.

        integer function getnmacf()
        Use(Code_Info)                                            
        return (nmacfils)
        end

!*--------------------------------------------------------------------------
!*--------------------------------------------------------------------------

# ZCM (7/23/1999) Return the name of macfile number nfil.

        Filename function getmacf (nfil)
        integer nfil
        Use(Code_Info)                                            
        return (macfile (nfil))
        end

!*--------------------------------------------------------------------------
!*--------------------------------------------------------------------------

#set document file name for package
# Moved here from raux.m (ZCM 7.1999)

        subroutine rtsetdoc(ndb,f)
        character*(*) f
        integer ndb
Use(Code_Info)
        docfile(ndb) = f
        return
        end

!*--------------------------------------------------------------------------
!*--------------------------------------------------------------------------

#get document file name for package
# Moved here from raux.m (ZCM 7.1999)

        Filename function rtgetdoc(ndb)
        integer ndb
Use(Code_Info)
        return(docfile(ndb))
        end

!*--------------------------------------------------------------------------
!*--------------------------------------------------------------------------

# Return the program name and version by splitting the name
# found in "coderpn" into a name and version component,
# using the single character separator found in "spliton".
# (ZCM 7/1999) moved here from ut.m to help isolate Code_Info

      subroutine nameme(name,vers,spliton)
      character *(*) name,vers
      character spliton
Use(Code_Info)
      integer i

      i = index(coderpn,spliton)
      if(i == 0) then
         name = coderpn
         vers = " "
      else
         name = coderpn(1:i-1)
         vers = coderpn(i+1:len(coderpn))
      endif
      return
      end

!*--------------------------------------------------------------------------
!*--------------------------------------------------------------------------

# (ZCM 7/23/1999) removed from basmain to help isolate Code_Info

        subroutine initcrpn (argv0, codedir)
Use(Code_Info)
        character *(*) argv0
        Filename codedir
        coderpn = " "
# Set the value of "coderpn" for later reference.
        call nameme0(argv0,coderpn,codedir)
        return
        end

!*--------------------------------------------------------------------------
!*--------------------------------------------------------------------------

# OSINFO              
# Programmed by: Zane C. Motteler, July 1988
# Purpose: obtain time, date, and other information.
# (ZCM 7/1999) moved here from vosunx.m to help isolate Code_Info
#
# Codedate, codetime are not set by basis. The user-replaceable function
# glbtmdat may set them, whereupon basis will obligingly print them out.
# At some point in the past, code{date,time} were probably set by the
# old loadinfo() function provided by FORTLIB. I'm preserving them now
# at the request of L. LoDestro. (LEB, October, 2000)

        subroutine osinfo
Use(Code_Info)
        cruntime=BLANK
        crundate=BLANK
        crunmach=BLANK
        codedate=BLANK
        codetime=BLANK
        call timedate(cruntime,crundate,crunmach,SMALLSTR)
        return
        end

!*--------------------------------------------------------------------------
!*--------------------------------------------------------------------------

#pop search stack, always leave par on the bottom
#altered by ZCM 7/91 (moving database references to rtd)
#altered by ZCM 7/99 (moving Code_Info references to glb)

        subroutine parpop
Use(Code_Info)
        integer rtnumpak
        external rtnumpak
                call rtparpop ( rtnumpak ())
        return
        end

!*--------------------------------------------------------------------------
!*--------------------------------------------------------------------------

!**
!* REFFUNC ::: do nothing function to capture and
!*             force a reference to a function or variable
!*
!* by calling reffunc with a variable or function a reference is forced
!* which must be honored by the linker
!* some linkers don't honor a simple external declaration
!*

      subroutine reffunc(x)
      implicit none
      integer x

      return
      end

!*--------------------------------------------------------------------------
!*--------------------------------------------------------------------------

