        subroutine parinit      #----------------------------------parinit
#
#       Revised by Zane C. Motteler
#               August, 1986
#       To make initial allocations for all dynamic storage and stacks.
#       To also define predefined macros such as FCOMMAND.
#       Revised by Zane C. Motteler
#               June, 1988
#       Add initializations for do stack (for controlled DO index, last,
#               and increment values), and for literal values table (hash table
#               to hold integer, real, and complex literals).
#       Revised by Zane C. Motteler
#               July, 1989
#       Changes due to elimination of token arrays and changed funcstk
#       Revised by Zane C. Motteler
#               August, 1989
#       vocstk and states are initialized here as they are now dynamic
#       Revised by Janet Takemoto
#               October, 1989
#       To include version number for binary SAVE files to prevent 'readb'
#       from reading an outdated version.
#       Revised by Zane C. Motteler
#               March, 1990
#	Allocate space for double precision constants based on their sizes
#
#   Altered by ZCM 7/91 to encapsulate database references in rtd
#   Altered by ZCM 8/93 to allocate space for function text
#   Altered by ZCM 1/94 to initialize type code for real(Size8)
#   Altered by ZCM 3/95 due to splitting funcstk into funcstki (integers),
#                       funcstkp (pointers)
#   Altered by ZCM 9/95 allocate space for output line. This disn't used
#                       to be dynamic, but users have asked for the
#                       ability to change its size.
#   Altered by ZCM 1/2000 Remove funcstk initialization to C.
Use(Actions)
Use(Functions)
Use(Lrhcoms)
Use(Stacks)
Use(Controls)
Use(Problem_name)
Use(Type_codes)
Use(Inout)
Use(Multiprocessing)
Use(Infiles)
#
        integer i
	integer rtattrlu
	external rtattrlu, rtsnv0,setrdo
        integer glbpknum
        external glbpknum
        integer rtgrpe,rtvare
        real r1mach
        external rtgrpe,rtvare,r1mach
        integer utsizstr,utsizeof, utstrcod
        external utsizstr,utsizeof, mcpar, mcctyp, utstrcod
        integer id
        real rd
        complex cd
        double precision dd (2)
        logical ld
        character * 4 chd
        Address atmp

# initialize first file
        fds(1)    = STDIN
        fnames(1) = "TERMINAL"
        istk      = 1
        pblinl(1) = 0

        call bfcninit () # Initialize builtin function tables
        call osmulti  #set up multiprocessing variables
        call oscache (TRUE)
############################
#       debuglr =1             #master switch
#       debtok =1
#       debred =1
#       debtrn =1
#       debstk =1
#       debact =1
#       doacts =1
############################
        call initkill # Initialize killme array (ZCM 2/22/99)
#
        call setrdo(rtattrlu("readonly",1,FALSE,junk))
        infinity = 10.0 ** int(log10(abs(r1mach(2))))
        logof0 = int(log10(abs(r1mach(1))))
# define the character classifications
		call mcctyp
# start the search stack
        npar = glbpknum("par")
        call parpushp(npar)
# make the dollar variables
        call chaminit (npar)
        call rtsnv0(npar)
#
#       Set up initial allocations of all dynamic stacks
        call fstkinit ()
        call codeinit ()
        call litallot () # special routine to allot space for literals
        do i = 1, SSLENGTH
                lxp(i) = 0
        enddo
        do i = 1, SSLENGTH
                nxp(i) = BLANK
        enddo
        do i = 1, SUBSLENGTH
           bassubs (TC, i) = NULL_TYPE
           bassubs (N1 + 1, i) = 0
        enddo
        call pstkinit ()   # ZCM 2/2000 initialize parser stack
        call lxstkcr       # ZCM 8/94 unstak creation moved
        call mcpar         # ZCM 7/91 macro initialization moved
# allocate space for default variables
        id = DEFAULT
        rd = DEFAULT.
        cd = (DEFAULT.,DEFAULT.)
        dd (1) = DEFAULT.d0
        dd (2) = DEFAULT.d0
        ld = FALSE
        chd = " "
        call osallotn (defaddr, utsizeof(1, FWA),     "PERM|PARINIT:defaddr ")
        call osallotn (defint,  utsizeof(1,INTEGER),  "PERM|PARINIT:defint ")
        call osallotn (defdbl,  utsizeof(1,DOUBLE),   "PERM|PARINIT:defdbl ")
        call osallotn (defcmp,  utsizeof(1,COMPLEX),  "PERM|PARINIT:defcmp ")
        call osallotn (defdcmp, utsizeof(1,DOUBLE_C), "PERM|PARINIT:defdcmp ")
        call osallotn (defreal, utsizeof(1,REAL),     "PERM|PARINIT:defreal ")
        call osallotn (deflog,  utsizeof(1,LOGICAL),  "PERM|PARINIT:deflog ")
        call osallotn (defch,   1,                    "PERM|PARINIT:defch ")
# now initialize these values
        atmp = NOTSET
        call smovbtoa (
         defaddr, 0, atmp, 0, CHAR_PER_WORD * utsizeof (1,FWA))
        call smovbtoa (
         defint, 0, id, 0, CHAR_PER_WORD * utsizeof (1,INTEGER))
        call smovbtoa (
         defdbl, 0, dd, 0, CHAR_PER_WORD * utsizeof (1,DOUBLE))
        call smovbtoa (
         defcmp, 0, cd, 0, CHAR_PER_WORD * utsizeof (1,COMPLEX))
        call smovbtoa (
         defdcmp, 0, dd, 0, CHAR_PER_WORD * utsizeof (1,DOUBLE_C))
        call smovbtoa (
         defreal, 0, rd, 0, CHAR_PER_WORD * utsizeof (1,REAL))
        call smovbtoa (
         deflog, 0, ld, 0, CHAR_PER_WORD * utsizeof (1,LOGICAL))
        call smovbtoa (defch, 0, chd, 0, 4)
# allocate space for stream output line
        call osallotn(outline, utsizstr(MAXOUT,Quote(Ch(1))),
     &                Quote(PERM|PARINIT:outline ))

# create a dummy database
        call rtdbcr(0,0,0)
# create a database for the local stackframes
        call rtdbcr(LOCALDB,0,0)
# create database and group for the user's run-time variables and functions
        call rtdbcr(USERDB,0,0)
        jvar =  rtgrpe(USERDB,"User")
        call rtcomeg(jvar, USERDB, "User-defined variables and functions")

        call mcchrdef("pi", Quote(Pi), FALSE)  ## macro has no args
        call mcchrdef("wordsize",Quote(WORDSIZE),FALSE)
        call mcchrdef("system",'"'//Quote(SYSTEM)//'"',FALSE)
        call mcchrdef("fcommand", "command_s", FALSE)  ## macro has no args
        call mcchrdef("FCOMMAND", "command_s", FALSE)  ## macro has no args
        call mcchrdef("remark","<<",FALSE)
        call mcchrdef("timer","partime command_s",FALSE)
        call mcchrdef("package","parpush command_s",FALSE)
        call mcchrdef("resume","osresume command_es $1 $2", TRUE)
        call mcchrdef("dec","decimal command",FALSE)
	call mcchrdef("default",
	  'if(~exists(".$1")) chameleon $1 ', TRUE)
        call mcchrdef("logonly","2",FALSE)
        call mcchrdef("WORDSIZE",Quote(WORDSIZE),FALSE)
        call mcchrdef("output","outputto command_(Swc)",TRUE)
        call mcchrdef("cd","f_chdir command_s",FALSE)
        call mcchrdef("setenv","{setenv} command_ss",FALSE)
        call mcchrdef("getenv","fgetenv",FALSE)
        call mcchrdef("chdir","f_chdir",FALSE)
        call mcchrdef("pwd",
           '$ = basisexe("pwd");if($ ~= 0) << "pwd: internal error."',FALSE)
        call mcchrdef("flush", "basflush", FALSE)
        probname="problem"
# set up action on assignment to usrfirst
	call setact("par.usrfirst","call parsetuf(usrfirst)")
# initialize type code for real(Size8)
        typr8 = utstrcod ( Quote(real(Size8)) )
# initialize stack pointers
        rsp = 0
        rlinkp = 0
        partrace = FALSE
        paruser = FALSE
        tracedone = FALSE
        return
        end

        subroutine paroops(itypein)

#lexical, syntactic, or semantic error has occurred
#
#                         PAROOPS
#
# Paroops reinitializes everything and returns.
# subtle bug fix 7/13/88 dubois
# itype might be pointed to by something whose storage gets released
# when kaboom called from user code via parxpf
# copy it, rename argument itypein
# Altered by ZCM 7/91: remove Domestic references, call new routine rtclean
    integer itypein    #severity flag no longer used
Use(Actions)
Use(Controls)
Use(Functions)
Use(Stacks)
Use(Inout)
    integer i, itype
    integer nottwice
    save nottwice
    data nottwice/0/
	external mcoops, cllittab
####
    if( nottwice <> 0) then
        call basexit(1)
    else
        call cparoops ()
        nottwice = 1
        itype = itypein
        call oserrpop
        call lrserr(0)
# initialize action quantities
        execflag = FALSE
        funcflag = FALSE
        nextlab = 1
        brkflg = FALSE
        nextflg = FALSE
        call mcoops # ZCM 7/91 -- handle macro stuff
        semerr = OK
        noisy = NO
        inassign = FALSE
        assignsp = 0
        symbolic = TRUE
        fargnum = 0
# initialize stream input units
        inunit(1)=5
        inpstr(1)=' '
        inptr(1)=0
        do i = 2, MAXINP
           inunit(i)=0
        enddo
# remove any stack frames
# they might have already gotten removed in errprt, but maybe not due to 
# execflag being false in a syntax error in a recursive parses or debug=no 
        call rtclean
#clean up any allocated arrays that are lying around
        do i = 1, SUBSLENGTH
           call parrel (bassubs (1, i))
           bassubs (TC, i) = NULL_TYPE
           bassubs (N1 + 1, i) = 0
        enddo
        # free all literal storage
        call cllittab
        # get rid of any subscript arrays
	call basiserr  #user hook
#
        if(itypein <= 0) then
            call remark("Returned to user input level.")
        else
            call remark("Remainder of input line ignored.")
        endif
    endif
# clean up Fcc pointer
    call fccclear
#
    nottwice = 0
# initialize stack pointers
        rsp = 0
        rlinkp = 0
        paruser = FALSE
        tracedone = FALSE
    return
    end

    subroutine lrstop
    call kaboom(0)
    end

      subroutine freeout ()
      Use(Inout)
      call osfreen (outline,"FREEOUT:outline")
      return
      end
