# Basis Code Development System
# Copyright 1986 The Regents of the University of California

# This code removed from mac.m 8/31/94 as it seems to have
# nothing to do with macros, everything to do with stream i/o.
#               (Zane C. Motteler)

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

# FFOPEN - Open a file for traceback

        subroutine ffopen (jout)

        Use (Controls)

        integer jout
        integer nnn
        integer utgetcl
        external utgetcl

        nnn = utgetcl (bastrace)
        call freeus (jout)

        open (unit = jout, file = bastrace (1:nnn), err = 1000)

        go to 2000
1000    continue
        call remark("Unable to create traceback file, will use terminal.")
        jout = STDERR
        bastrace = "terminal"
2000    continue

        nnn = utgetcl (bastrace)
        call remark("Writing traceback info to file "//bastrace(1:nnn))

        call glbhead(jout,YES)

        return
        end

c--------------------------------------------------------------------------

c                         STREAM I/O

c--------------------------------------------------------------------------

# IOUSASGN - finds unit number for stream i/o in table; if not there, adds it.

      function iousasgn()

Use(Inout)
Use(Stacks)

      integer iousasgn,us,parint
      external parint

c ... make an assignment to iounit
      if (ss(TC,rsp) .ne. INTEGER) then
         call remark('iousasgn: unit specifier must be integer')
         call kaboom(0)
      endif

      if (parint(ss(1,rsp),us) .eq. ERR) return(ERR)

      call parrel(ss(1,rsp))
      iounit = us

      do i = 1,MAXINP
         if (iounit.eq.inunit(i)) then
            curin=i
            return(OK)
         endif
      enddo

      j=0
      do i = 2,MAXINP
         if (inunit(i).eq.0) then # available
            inunit(i)=iounit
            inpstr(i)=' '
            inptr(i)=0
            curin=i
            break
         endif
         j=j+1
      enddo

      if (j >= MAXINP1) then
         call remark('Too many files open for stream input.')
         call kaboom(0)
      endif

      return(OK)
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

# IOEZOUT - assign us to the iounit -- usually for 'tty' or 'plot'

        function ioezout(us)

Use(Inout)

        integer ioezout,us

        iounit = us
        if (iounit.eq.STDIN)curin=1

        return(OK)
        end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c GENCONV - Convert an ascii character to a number from 1 to 10 (its generic
c         - character type) so that it can be used to index into the columns
c         - of the ioitem (token recognizer) state transition table. For an
c         - explanation of the generic character types, see comments in ioitem.

        integer function genconv(ch)

Use(Inout)

        character ch * 1

        if ((ch.eq.'+')|(ch.eq.'-')) then
           return(1)
        elseif ((ch>='0')&(ch<='9')) then
           return(2)
        elseif (ch.eq.'.') then
           return(3)
        elseif (ch.eq.'e'|ch.eq.'d') then
           return(4)
        elseif (ch.eq.'E'|ch.eq.'D') then
           return(5)
        elseif ((ch.eq.'$')|(ch.eq.'%')|((ch>='a')&(ch<='z'))) then
           return(6)
        elseif ((ch>='A')&(ch<='Z')) then
           return(7)
        elseif (ch.eq.'_') then
           return(8)
        elseif (index(delims,ch)~=0) then
           return(9)
        elseif (ch.eq."'") then
           return(11)
        elseif (ch.eq.'"') then
           return(12)
        else
           return(10)
        endif

        end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c IOINPUT - This routine replaces the old ioinput1 and ioinput2 routines.
c         - It checks (via iodoinpt) to make sure an input line is available. It
c         - then fetches the next token from the input line via ioitem (tokens 
c         - consist of integer numbers, real numbers, names, group names or
c         - anything else; see ioitem for details). It will return with NULL_TYPE
c         - type if the rest of the input line consists of delimiters. It then 
c         - creates a stack entry and performs an assignment if possible. If
c         - s is a character string, it will receive the token as a character  
c         - string provided it is not integer or real; if s is of numeric type
c         - and t is integer or real, then type coercion and numeric assign-
c         - ment will occur. If no assignment occurs, the token is ignored
c         - and another token is fetched. No error indication is given.

        integer function ioinput()

Use(Inout)
Use(Controls)
Use(Stacks)

        integer decatob, decatod, decator, parsave, parasgn
        Address paraddr
        double precision p10
        external remark, iodoinpt, ioitem, decatob, decator, parsave,
                paraddr, parasgn, parget, decatod
        Address pval
        integer ival
        real rval
        double precision dval
        character*MAXLINE token
        integer ti(SSWIDTH), error, toklen, sign, j, size
        integer lrsize, inarray, rtgndim
		logical rtischam, ischamel, isknown
		external lrsize, rtischam, inarray, rtgndim

      if ( ss(TCSAVE,rsp) < 0 & noisy .eq. NO ) then
         call remark(
         "ioinput: you can't input a string unless noisy is yes.")
         call remark(
         "         input strings containing ' ' or ',' must be quoted.")
         return(ERR)
      endif

      if (ss(NS,rsp) > 0) size = lrsize(ss(1,rsp))

      ischamel = rtischam(ss(PTR,rsp),ss(N,rsp))
      isknown = (ss(N,rsp).ne.UNKNOWN)
      if (isknown) then
         if (~ischamel ) then
            if ((ss(NS,rsp) .eq. 0 & rtgndim(ss(PTR,rsp),ss(N,rsp)) > 0) | 
     &           (ss(NS,rsp) > 0 & size > 0) ) then
               error = inarray(size)
               return(error)
            endif
         endif
      endif

      error = OK
      ti(N) = 0
      ti(TC) = NULL_TYPE
      while (error.eq.OK)
         call iodoinpt
         if (eof.eq.YES) return(error) # routine is a nop if read fails
         call ioitem(ti,token,toklen)
         if ((ti(TC)>=INTEGER) & (ti(TC)<=DOUBLE)) then
            call parget(ti)  #       get storage for number
            if ( token(1:1) .eq. '-' ) then
               sign = -1
               j = 2
               toklen = toklen - 1
            elseif (token(1:1) .eq. '+') then
               sign = 1
               j = 2
               toklen = toklen - 1
            else
               sign = 1
               j = 1
            endif

# If the target ss(.,rsp) is double, force ti to be double
# (ZCM 8/17/93) 
            if ( ss(TC,rsp) .eq. DOUBLE | ss(TC,rsp) .eq. LHS ) ti(TC) = DOUBLE
            pval = paraddr (ti)

            select (ti(TC))
            case INTEGER:
                 ival = 0
                 error=decatob(token(j:),toklen,ival)
                 call iset (pval, ival * sign)
            case REAL:
                 rval = 0.
                 error=decator(token(j:),toklen,rval)
                 call rset (pval, rval * sign)
            case DOUBLE:
                 dval = 0.d0
                 error=decatod(token(j:),toklen,dval, p10)
                 if (sign < 0) dval = - dval
                 call dset (pval, dval)
            endselect

c ... now ti has a value, need to store it in S.
            if (error.eq.OK) then
               error = parasgn(ss(1,rsp), ti)
               break
            endif

         elseif ((noisy.eq.YES)&(ti(TC)~=NULL_TYPE)) then # allow character assignments
            ti(TC) = - toklen
            ti(PTR) = parsave(token, toklen)
            ti(NAML) = 1 #since value is in literal table
            error = parasgn(ss(1,rsp), ti)
            break 
         endif
         call ruthere
      endwhile

      if (error .eq. ERR & iounit ~= STDIN) then
         close(unit=iounit)
         inunit(curin)=0
         curin=1
         call remark('stream input file closed due to error in input.')
      endif

      return(error)
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c INARRAY - Performs the function of ioinput, only for arrays.
c         - It does this in a series of steps commented below.

      integer function inarray(size)
      integer size
      Use(Inout)
      Use(Controls)
      Use(Stacks)
      integer t(SSWIDTH), u(SSWIDTH), i, j, ltoken,
              soffset, nchar, tchar, sign, ival, arlen, error
      Address paraddr
      integer utsizeof, partemp, decatob, decator, decatod, parasgn
      external utsizeof, partemp, decatob, decator, decatod, parasgn,
          paraddr
      integer utgetcl
      external utgetcl
      real rval
      double precision dval, p10
      Address pval
      Ch(MAXLINE) token
      Ch(80) blanks
      Ch(20) ctype
      Varname ar
      blanks = " "
      error = OK

#     (1) t is going to be the source. First, zero it out.
      do i = 1, SSWIDTH
         t(i) = 0
      enddo

#     (2) next, find out how big ss(1,rsp) is and set t accordingly.
#         t subscripts start with 1 and have stride of 1, of course.
      if (ss(NS,rsp) .eq. 0) then
#        (a) if ss(1,rsp) has no subscripts, then dimension t like ss(.,rsp)
#            (except run t subscripts from 1 to whatever)
         t(N) = 0
         size = 1
         i = 1
#        You can't rely on ss(.,rsp) subscripts, so rtgsubs will get them
         call rtgsubs()
         do
            if (i > 7 | ((ss(N1+i-1,rsp) .eq. 0) & (ss(M1+i-1,rsp) .eq. 0)))break
            t(N1+i-1) = abs(ss(M1+i-1,rsp) - ss(N1+i-1,rsp)) + 1
            t(M1+i-1) = 1
            t(I1+i-1) = 1
            size = size * t(N1+i-1)
            t(N) = t(N) + 1
            ss(N1+i-1,rsp) = 0
            ss(M1+i-1,rsp) = 0
            i = i + 1
         enddo
      else
#        (b) if ss(.,rsp) has subscripts, make t conform to ss(.,rsp)
#            (except as above run t subscripts from 1 to whatever
#            and give it a stride of 1)
         t(N) = ss(NS,rsp)
         do i = 1, ss(NS,rsp)
            t(M1+i-1) = 1
            t(N1+i-1) = 1 + (ss(M1+i-1,rsp) - ss(N1+i-1,rsp))/ss(I1+i-1,rsp)
            t(I1+i-1) = 1
         enddo
      endif

#     (3) Figure out how much space there is, reserve it, get a pointer to it
      t(TC) = ss(TCSAVE,rsp) # ss(TCSAVE,rsp) is the type code for a <lhs>
      call parget (t)
      if (ss (TCSAVE,rsp) < 0 | ss (TCSAVE,rsp) .eq. INTEGER |
          ss (TCSAVE,rsp) .eq. REAL | ss (TCSAVE,rsp) .eq. DOUBLE) then
         pval = paraddr (t)
      else
         call utcodstr (ss (TCSAVE,rsp), ctype)
         call remark ("Unable to input array of " // ctype
     &      (1:utgetcl (ctype)) // "type.")
         return (ERR)
      endif

#     (4) This loop, if it succeeds, brings in size items
      i = 1
      do 
#        (a) ensure that input is available
         call iodoinpt
         if (eof .eq. YES) then
             call utgetnm(ss(PTR,rsp), ss(N,rsp), ar, arlen)
             call remark("inarray: eof in stream input to array variable '"//\
                  ar(1:arlen)//"'.")
             break
         endif
#        (b) get next item
         call ioitem(u, token, ltoken)
         if (u(TC) .eq. NULL_TYPE) then
#            (note that we don't want to increment i if we have a null token;
#            that's why this do loop is not a standard one).
             next
         endif
         if (ss(TCSAVE,rsp) < 0 & u(TC) >= INTEGER & u(TC) <= DOUBLE) then
#        (c) can't assign numerical value to string
             call utgetnm(ss(PTR,rsp), ss(N,rsp), ar, arlen)
             call remark("inarray: can't read numerical value into string"//\
                  "array variable '"//ar(1:arlen)//"'.")
             error = ERR
             break
         elseif (ss(TCSAVE,rsp) < 0 & noisy .eq. YES) then
#        (d) string case: move string characters, blank fill if necessary
#            character assignments are not allowed unless noisy is YES
             nchar = min(-ss(TCSAVE,rsp), ltoken)
             call smovftoa(pval, soffset, token, 0, nchar)
             soffset = soffset + nchar
             tchar = -ss(TC,rsp) - nchar
             if (tchar > 0) then
                call smovftoa(pval, soffset, blanks, 0, tchar)
                soffset = soffset + tchar
             endif
         elseif (ss(TCSAVE,rsp) > 0 & u(TC) >= INTEGER & u(TC) <= DOUBLE) then
#        (e) numerical case
             if ( token(1:1) .eq. '-' ) then
                 sign = -1
                 j = 2
                 ltoken = ltoken - 1
             elseif (token(1:1) .eq. '+') then
                 sign = 1
                 j = 2
                 ltoken = ltoken - 1
             else
                 sign = 1
                 j = 1
             endif
             # If the target t is double, force u to be double
             # (ZCM 8/17/93) 
             if ( t(TC) .eq. DOUBLE ) u(TC) = DOUBLE
             if (u(TC) .eq. INTEGER) then
                 error=decatob(token(j:),ltoken,ival)
                 if (error .ne. 0)break
                 ival = ival * sign
                 if (ss (TCSAVE,rsp) .eq. INTEGER) then
                    call iseto (pval, i, ival)
                 else if (ss (TCSAVE,rsp) .eq. REAL) then
                    call rseto (pval, i, real (ival))
                 else
                    call iseto (pval, i, dble (ival))
                 endif
             elseif (u(TC) .eq. REAL) then
                 error=decator(token(j:),ltoken,rval)
                 if (error .ne. 0)break
                 rval = rval * sign
                 if (ss (TCSAVE,rsp) .eq. INTEGER) then                 
                    call iseto (pval, i, int (rval))
                 else if (ss (TCSAVE,rsp) .eq. REAL) then
                    call rseto (pval, i, rval)
                 else
                    call dseto (pval, i, dble (rval))
                 endif
             else
                 error=decatod(token(j:),ltoken,dval, p10)
                 if (error .ne. 0)break
                 if (sign < 0) dval = - dval
                 if (ss (TCSAVE,rsp) .eq. INTEGER) then                 
                    call iseto (pval, i, int (dval))
                 else if (ss (TCSAVE,rsp) .eq. REAL) then
                    call rseto (pval, i, real (dval))
                 else
                    call dseto (pval, i, dval)
                 endif
             endif
         else
             i = i - 1
         endif
         i = i + 1
         if (i > size)break
         call ruthere
      enddo

#     (5) If i > size, then all items have been successfully read and coerced.
#         now we can assign t to ss(.,rsp).
      if (i > size) then
          error = parasgn(ss(1,rsp), t)
          assign = YES
      endif

      return(error)
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c IODOINPT - Make sure that there is an input line available for the '>>'
c          - operator. Prompt for it if it's STDIN, otherwise just go to
c          - file and read it. kaboom if attempt to read past end of file.
c          - This routine replaces an older routine by the same name

      subroutine iodoinpt

Use(Inout)
Use(Controls)

      eof = NO
      if ((inptr(curin)>MAXLINE)|(inptr(curin).eq.0)) then
         if (iounit~=STDIN) then
            inpstr(curin) = ' '
            read(iounit,990,end=999,err=998)inpstr(curin)
 990        format(a)
            inptr(curin) = 1
         else # standard input
            j=min(len(sprompt),max(1,lsprompt))
            call osprompt(sprompt(1:j))
            inpstr(curin) = ' '
            read(iounit,990)inpstr(curin)
            inptr(curin) = 1
         endif
      endif
      return
      
 998  continue
      call iooops(iounit)
      return
      
 999  continue
      eof = YES

      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c IOITEM - This is a special-purpose "token finder" to replace FORTLIB routine
c        - 'getnumb.' This routine is a table-driven finite state machine
c        - simulator which breaks a character string into the tokens name,
c        - group name, integer number, real number, or 'other.' Tokens are
c        - normally taken to be separated by delimiters ' ' or ','; however,
c        - the routine is smart enough to break something like '29ABC' into
c        - '29' and 'ABC.' Each time ioitem is called, one token is found,
c        - unless the remainder of the input line consists only of delimiters,
c        - in which case a token with type code NULL_TYPE is returned. The caller
c        - is responsible for replentishing the input line and for deciding
c        - what to do with the tokens (e. g. ascii to numeric conversion, and
c        - the like.) In the case of a normal return, 'token' contains the
c        - text of the token, 'toklen' its length, and 't(TC)' its type code.
c        - The global 'inptr' will point to the next available character in
c        - 'inpstr,' or MAXLINE+1 if the input line was exhausted.
c
#           EXPLANATION OF THE FINITE STATE MACHINE
# The state table is indexed into by (state, gench) and tells where you are in
# processing the current token. The encoding of character types and states is
# explained below.
# A) Generic character types
#   1: '+' or '-' (sign)                7: 'A'..'Z' (except 'E')
#   2: '0'..'9' (digit)                 8: '_' (underscore)
#   3: '.' (decimal point)              9: delimiters (currently ' ' and ',')
#   4: 'e' or 'd'                      10: all other characters
#   5: 'E' or 'D'                      11: "'" (single quote)
#   6: '$', '%', 'a'..'z' (except 'e') 12: '"' (double quote)
#
# B) Non-final states (incomplete token has been parsed)
#  1 - Start state; no characters, or only delimiters, scanned so far.
#  2 - Scanning a name (have seen '$', '%', or 'a'..'z' at the start of a
#      token.)
#  3 - Scanning a group name (have seen 'A'..'Z' at the start of a token.)
#  4 - Scanning a string which started with a character which can not legally
#      begin an identifier or number.
#  5 - Just scanned a decimal point, possibly preceded by a sign, but no
#      digits have been seen yet.
#  6 - Have seen a sign at the start of a token.
#  7 - Have seen one or more digits, possibly preceded by a sign.
#  8 - Have seen a decimal point and at least one digit.
#  9 - Have seen a decimal point, at least one digit, and 'd', 'e', 'D', or 'E'.
# 10 - Have seen a decimal point, at least one digit, 'd', 'e', 'D', or 'E', and
#      a sign.
# 11 - Scanning digits in the exponent.
# 12 - Have seen 'd', 'e', 'D', or 'E' in a number without a decimal point.
# 13 - Have seen 'd', 'e', 'D', or 'E' followed by a sign in a number without a
#      decimal point.
# 14 - Have seen "'" starting a string.
# 15 - Have seen '"' starting a string.
# 16 - Scanning a single-quoted string.
# 17 - Scanning a double-quoted string.
#
# C) Final states (complete token has been parsed). In some cases 'inptr' needs
# to be adjusted backwards one or two characters. For instance, 326e+ABC will
# be parsed as '326,' 'e,' '+,' and 'ABC,' but the '326' is only recognized
# when we are examining the 'A', two characters ahead of the token 'e.'
# 18 - Arbitrary string (none of the following).
# 19 - Group name.
# 20 - name.
# 21, 22, 23 - real number. 22 = back up 1; 23 = back up 2.
# 24, 25, 26 - integer number. 25 = back up 1; 26 = back up 2.
# 27 - quoted string (either single or double)


        subroutine ioitem(t, token, toklen)

Use(Inout)
Use(Controls)
#     Changed dummy dimension from 1 to *. (FNF 12/17/96)
        integer t(*), toklen
        character * MAXLINE token
        integer genconv
        external genconv
        integer startptr, states(17,12), state, final, start, newstate, gench,
		delim
        character * 1 ch
        save final, start, states, delim
        data final, start, delim /18, 1, 9/

c ... state transition table
        data states/6,19,20,3*18,24,21,10,23,21,13,26,16,17,16,17,
        7,2,8,18,8,7,7,8,5*11,16,17,16,17,
        5,20,19,18,18,5,8,21,22,23,21,25,26,16,17,16,17,
        2,2,3,3*18,12,9,22,23,21,25,26,16,17,16,17,
        3,2,3,3*18,12,9,22,23,21,25,26,16,17,16,17,
        2,2,3,3*18,24,21,22,23,21,25,26,16,17,16,17,
        3,2,3,3*18,24,21,22,23,21,25,26,16,17,16,17,
        4,2,3,3*4,24,21,22,23,21,25,26,16,17,16,17,
        1,20,19,3*18,24,21,22,23,21,25,26,16,17,16,17,
        4,20,19,3*4,24,21,22,23,21,25,26,16,17,16,17,
        14,20,19,3*18,24,21,22,23,21,25,26,18,17,27,17,
        15,20,19,3*18,24,21,22,23,21,25,26,16,18,16,27/

c ... initialize (thanks, purify!! ZCM 9/28/94)
      toklen = 0
      state = 1 # start the machine
      startptr = 1
      nd = 0
      while ((state < final) & (inptr(curin) <= MAXLINE))
         ch = inpstr(curin)(inptr(curin):inptr(curin))
         if (ch .eq. 'd' | ch .eq. 'D') nd = 1
         gench = genconv(ch)
         newstate = states(state,gench)
         if (newstate<final) then # save character into token
            if (newstate ~= start) then # as long as it's not a delimiter
               token(startptr:startptr) = ch
               startptr = startptr + 1
            endif
            inptr(curin) = inptr(curin) + 1
            if (inptr(curin)>MAXLINE) then # string exhausted
               ch = ' ' # so fool mother nature into seeing a delimiter
            else
               ch = inpstr(curin)(inptr(curin):inptr(curin))
            endif
         endif
         state = newstate # now make state change permanent
      endwhile

      toklen = startptr - 1 #moved here by ZCM 1/3/95

#       treat nl as a delimiter
      if (inptr(curin) > MAXLINE & toklen > 0) then
         state = states(state, delim)

#		string terminated by eol treated as other kind of string
         if ( state .eq. 16 | state .eq. 17 ) state = 18
      endif

      select(state)
        case 18: t(TC) = - toklen # has to be character string
        case 19: t(TC) = GROUP
        case 20: t(TC) = NAME
        case 21-22:
                t(TC) = REAL
		if (nd .eq. 1) t(TC) = DOUBLE
                inptr(curin) = inptr(curin) - (state - 21)
                toklen = toklen - (state - 21)
        case 24-26:
                t(TC) = INTEGER
                inptr(curin) = inptr(curin) - (state - 24)
                toklen = toklen - (state - 24)
        case 27: # string -- strip quotes
		token = token(2:toklen)
		toklen = toklen - 1
		t(TC) = -toklen
                inptr(curin) = inptr(curin) + 1
        default: if (toklen .eq. 0) then
			t(TC) = NULL_TYPE
		 else
#			if not in a final state, treat token as a string
			t(TC) = - toklen
		 endif
      endselect

      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c IONXTLIN - To do FORTRAN standard input

        subroutine ionxtlin(cond)

Use(Inout)
Use(Controls)
        integer cond
        integer oldunit
        integer skpdel
        external skpdel

# cond tells if we have the first element of an input command (0) or not (1)
        Ch*(MAXLINE) str

        if (cond = 0) oldunit = iounit
# if not at the beginning of a line, reset inptr
# (this will force a read when the next input item is wanted)
        inptr(curin) = skpdel()
        if ((inptr(curin) >= 1)&(inptr(curin) <= MAXLINE)) then
                inptr(curin)=MAXLINE+1 # (means current line is finished)
                return
        endif
        if (iounit .eq. STDIN) then
                j = min(len(sprompt),max(1,lsprompt))
                call osprompt(sprompt(1:j))
        endif
        read(iounit,990,end=999,err=1000)str
990     format(a)
        return

999     eof = YES
        return

1000    continue
	call iooops(iounit)

        return
        end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

        subroutine iooops(iunit)
	integer iunit
	Filename f

Use(Controls)
Use(Inout)

	inquire(unit=iunit,name=f)
        call remark("Stream i/o encountered error reading file.")
        call remark(f)

        call basclose(iunit)
	eof = YES
	curin = 1

	return
	end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c SKPDEL - This routine returns the index of the next non-delimiter in the
c        - current line, or MAXLINE+1 if there are only delimiters left. The
c        - intention is to make 'return' work correctly. 'return' should go
c        - to the beginning of the very next line if there are nonblank items
c        - remaining on the current line, but should skip the next line if
c        - the current line is empty from here on. In other words, the user
c        - should not have to know whether a line has trailing blanks or not.

      integer function skpdel()

Use(Inout)

      integer cursor
      logical change

      cursor=inptr(curin)
      if ((cursor.eq.0)|(cursor>MAXLINE))return(cursor)
      change=FALSE
      do
         change=index(delims,inpstr(curin)(cursor:cursor)) .ne. 0
         if (change)      cursor=cursor+1
      until((cursor>MAXLINE)|(~change))
         
      return(cursor)
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c IOCONOUT - output the current line if auto-carraige return is yes

      subroutine ioconout

Use(Controls)

      if (autocr .eq. YES) call uncndout

      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c UNCNDOUT - output the current line

      subroutine uncndout

Use(Inout)
Use(Controls)

      character*MAXSTRING loutline
      
      if (outptr = 1) then
         loutline(1:1) = ' '
         call baswline(iounit,loutline(1:outptr))
         
      else
         call smovatof (loutline, 0, outline, 0, outptr-1)
         call baswline(iounit,loutline(1:outptr-1))
         outptr = 1
      endif
      
      return
      end
      
c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c IOOUTSTR - put a character string into outline

      subroutine iooutstr(str, lin)
      character*(*)str
      integer lin
      
Use(Inout)

      integer l
      
      l = lin
      if (outptr+l-1 > linesize) then
         call uncndout
         outptr = 1
      endif
      
      if (l > linesize) l = linesize
      
#       outline(outptr:outptr+l-1) = str(1:l)
      call smovftoa(outline, outptr-1, str, 0, l)
      outptr = outptr + l
      
      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c IOOUTV - send a variable to the output stream
c        - print a maximum of EPL elements per line
c        -
c        -   PVAR  ptr to one dimensional variable to be written
c        -   N     number of things to print

      subroutine iooutv(type, pvar, n)
      implicit none
      integer type
      Address pvar
      integer n

Use(Controls)

      integer epl
      integer lc, nc, ni, kk
      integer id(20)
      character*MAXSTRING msg
      character ftyp
      double precision var(128)

      integer utgetcl
      external utgetcl

      call utfmtdesc(id, ftyp, -1, 1, 1, 1, 1, n, 1, type, pvar)

      epl = id(5)

c ... print strings without quotes
      id(9) = 0
      id(13) = 0 # Set inter-element gap to 0 for stream output.
      if (n > 1) id(13) = 1 # ... unless we're printing an array.
      id(14) = 1 # Set stream i/o flag.

c ... now print values one at a time
      lc = 1
      while (lc .le. n)
         kk = min0(lc+epl-1, n)
         ni = kk - lc + 1

c ... get the next element
         call mvalue(pvar, lc, type, var, 1)

c ... make the part of the line with the value
         msg      = " "
         msg(1:1) = char(0)
         call prstr(msg, ftyp, 9, id, 1, var)

c ... get length of the string differently for characters
         if (id(2) .lt. 0) then
            nc = -id(2)
         else
            nc = utgetcl(msg)
         endif

c ... push the element
         call iooutstr(msg, nc)

         lc = lc + 1
      endwhile

      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c IOOUTPT1 - put the next item to be output into outline
c          - if this will make the line too long, output the line first

        integer function iooutpt1()
        implicit none

Use(Inout)
Use(Controls)
Use(Stacks)

        Address pval
        integer n, ityp

        integer parlen
        external parlen

        Address paraddr
        external paraddr

c ... convert value in ss(.,rsp) into a string and put it in outline
        ityp = ss(TC, rsp)
        n    = parlen(ss(1, rsp))
        pval = paraddr(ss(1, rsp))

        call iooutv(ityp, pval, n)

        call parrel(ss(1, rsp))

        return(OK)
        end

c--------------------------------------------------------------------------

c                            PARSER AIDS

c--------------------------------------------------------------------------

c RTDEVAL1 - This fuction returns the value of a valid infix integer
c          - expression. If it cannot be evaluated, it returns 0
c          - and ierr = ERR

        subroutine rtdeval1(str,lo,hi,ndb,deflo,defhi,defflg,ierr,total)

        character*(*) str        # input string
        integer i,j,             # delimits current token in str
                  lo,hi,         # delimits part of string to evaluate
                  tok,           # type of current token
                  term(2),       # value of integer or range token
                  total(2),      # value of expression
                  deflo,defhi,   # default lo and hi subscripts of range
                  ierr
        integer ndb, jj
        integer   index,         # index to act1,act2
                  state,nstate,  # current state,next state
                  stray,stop,    # stack of states,stack top
                  numray,numtop, # stack of tokens, stack top
                  t(2)           # temporary variable
        integer action    # current action
        character       nxtin    # next input
        logical defflg           #TRUE if default subscripts allowed, else FALSE

        integer rtdetokn    # functions
        external rtdetokn   # functions

        integer act1(26,8), act2(26,8), move(26,4)
        dimension stray(MACMAX), numray(2*MACMAX)

# act1,act2 indexed by current state and input
# columns 1-8 correspond to: ( ) * + int - eof /

      save act1,act2, move
      data (act1(1,i),i=1,8)/1,1,1,1,1,1,1,1/
      data (act1(2,i),i=1,8)/3,1,1,1,3,3,1,1/
      data (act1(3,i),i=1,8)/3,1,1,1,3,3,1,1/
      data (act1(4,i),i=1,8)/3,1,1,1,3,1,1,1/
      data (act1(5,i),i=1,8)/1,2,2,2,1,2,2,2/
      data (act1(6,i),i=1,8)/1,1,1,3,1,3,1,1/
      data (act1(7,i),i=1,8)/1,1,1,1,1,1,4,1/
      data (act1(8,i),i=1,8)/1,2,2,2,1,2,2,2/
      data (act1(9,i),i=1,8)/1,2,3,2,1,2,2,3/
      data (act1(10,i),i=1,8)/1,3,1,1,1,1,1,1/
      data (act1(11,i),i=1,8)/1,1,1,3,1,3,1,1/
      data (act1(12,i),i=1,8)/1,2,3,2,1,2,2,3/
      data (act1(13,i),i=1,8)/3,1,1,1,3,1,1,1/
      data (act1(14,i),i=1,8)/3,1,1,1,3,1,1,1/
      data (act1(15,i),i=1,8)/1,1,1,1,1,1,4,1/
      data (act1(16,i),i=1,8)/3,1,1,1,3,1,1,1/
      data (act1(17,i),i=1,8)/3,1,1,1,3,1,1,1/
      data (act1(18,i),i=1,8)/1,2,2,2,1,2,2,2/
      data (act1(19,i),i=1,8)/3,1,1,1,3,1,1,1/
      data (act1(20,i),i=1,8)/3,1,1,1,3,1,1,1/
      data (act1(21,i),i=1,8)/1,2,3,2,1,2,2,3/
      data (act1(22,i),i=1,8)/1,2,3,2,1,2,2,3/
      data (act1(23,i),i=1,8)/1,2,2,2,1,2,2,2/
      data (act1(24,i),i=1,8)/1,2,2,2,1,2,2,2/
      data (act1(25,i),i=1,8)/1,2,3,2,1,2,2,3/
      data (act1(26,i),i=1,8)/1,2,3,2,1,2,2,3/
      data (act2(1,i), i=1,8) /8*1/
      data (act2(2,i), i=1,8) /3,3*1,5,4,2*1/
      data (act2(3,i), i=1,8) /3,1,1,1,5,4,1,1/
      data (act2(4,i), i=1,8) /3,3*1,5,3*1/
      data (act2(5,i), i=1,8) /1,3*14,1,3*14/
      data (act2(6,i), i=1,8) /3*1,13,1,14,2*1/
      data (act2(7,i), i=1,8) /8*1/
      data (act2(8,i), i=1,8) /1,3*11,1,3*11/
      data (act2(9,i), i=1,8) /1,2,16,8,1,8,2,17/
      data (act2(10,i), i=1,8) /1,18,6*1/
      data (act2(11,i), i=1,8) /3*1,19,1,20,2*1/
      data (act2(12,i), i=1,8) /1,3,16,8,1,8,3,17/
      data (act2(13,i), i=1,8) /3,3*1,5,3*1/
      data (act2(14,i), i=1,8) /3,3*1,5,3*1/
      data (act2(15,i), i=1,8) /8*1/
      data (act2(16,i), i=1,8) /3,3*1,5,3*1/
      data (act2(17,i), i=1,8) /3,3*1,5,3*1/
      data (act2(18,i), i=1,8) /1,3*15,1,3*15/
      data (act2(19,i), i=1,8) /3,3*1,5,3*1/
      data (act2(20,i), i=1,8) /3,3*1,5,3*1/
      data (act2(21,i), i=1,8) /1,4,16,9,1,9,4,17/
      data (act2(22,i), i=1,8) /1,6,16,10,1,10,6,17/
      data (act2(23,i), i=1,8) /1,3*12,1,3*12/
      data (act2(24,i), i=1,8) /1,3*13,1,3*13/
      data (act2(25,i), i=1,8) /1,5,16,9,1,9,5,17/
      data (act2(26,i), i=1,8) /1,7,16,10,1,10,7,17/
#     
# move indexed by stray(stop) and current non-terminal
# from grammar
# columns 1-4 correspond to: E  E'  T  F
#     
      data (move(1,i), i=1,4) /4*1/
      data (move(2,i), i=1,4) /7,6,9,8/
      data (move(3,i), i=1,4) /10,6,9,8/
      data (move(4,i),i=1,4) /1,11,12,8/
      data (move(5,i), i=1,4) /4*1/
      data (move(6,i), i=1,4) /4*1/
      data (move(7,i), i=1,4) /4*1/
      data (move(8,i), i=1,4) /4*1/
      data (move(9,i), i=1,4) /4*1/
      data (move(10,i), i=1,4) /4*1/
      data (move(11,i), i=1,4) /4*1/
      data (move(12,i), i=1,4) /4*1/
      data (move(13,i), i=1,4) /2*1,21,8 /
      data (move(14,i), i=1,4) /2*1,22,8/
      data (move(15,i), i=1,4) /4*1/
      data (move(16,i), i=1,4) /3*1,23/
      data (move(17,i), i=1,4) /3*1,24/
      data (move(18,i), i=1,4) /4*1/
      data (move(19,i), i=1,4) /2*1,25,8/
      data (move(20,i), i=1,4) /2*1,26,8/
      data (move(21,i), i=1,4) /4*1/
      data (move(22,i), i=1,4) /4*1/
      data (move(23,i), i=1,4) /4*1/
      data (move(24,i), i=1,4) /4*1/
      data (move(25,i), i=1,4) /4*1/
      data (move(26,i), i=1,4) /4*1/
#     
#     
#     
#   ***********initialize**************
#     
      ierr = OK
      i = lo
      tok = rtdetokn(str,i,j,ierr,hi)
      jj = j
      if (ierr .eq. ERR) return

      if (tok .eq. TOKEOF) then
         if (~defflg) then
            call remark(
     1           "Error:  cannot have defaulted ranges as subscripts")
            ierr = ERR
            return
         endif
         total(1) = deflo
         total(2) = defhi
         return
      endif
      
      total(1) = 0
      total(2) = 0
      action = 1
      stop = 0
      numtop = 0
      state = 2
      call rtdvpush(state,1,stray,stop,ierr)
      if (ierr .eq. ERR) return
      
      for (i=lo, action <4, i = j)
          j = jj
          term(1) = 0
          term(2) = 0
          call pargetin(ndb,tok,i,j,str,term,nxtin,index,
          deflo, defhi, defflg, ierr)
          if (ierr .eq. ERR) return

          action = 1
          while(action < 3)
             state=stray(stop)
             action=act1(state,index)
             nstate=act2(state,index)
             go to (501,502,503,504) action
 501         continue # "error"
             ierr = ERR   #        error
             return
             
 503         continue #shift
             if (nxtin = '#') then # shift
                call rtdvpush (term,2,numray,numtop,ierr)
             else
                t(1) = ichar(nxtin)
                t(2) = ichar(nxtin)
                call rtdvpush(t,2,numray,numtop,ierr)
             endif
             if (ierr .eq. ERR) return
             call rtdvpush (nstate, 1,stray, stop, ierr)
             next
             
 502         continue  #reduce
             call rtvoper(ierr, nstate, stray, stop, numray, numtop)
             if (ierr .eq. ERR) return

             go to (605, 601 ,601, 601, 601, 601, 601,
     &              602 ,602, 602, 603, 603, 603, 604, 604) nstate

 601         continue #case 2,3,4,5,6,7:
             state=move(stray(stop),1)
             go to 606

 602         continue #case 8,9,10:
             state=move(stray(stop),2)
             go to 606

 603         continue #case 11,12,13:
             state=move(stray(stop),3)
             go to 606

 604         continue #case 14,15:
             state=move(stray(stop),4)
             go to 606

 605         continue #1, impossible
             call baderr('rtdeval1:bad input state')

 606         continue
             call rtdvpush (state,1,stray, stop, ierr)
             if (ierr .eq. ERR) break 2
             next
             
 504         continue    #       "accept"
             call rtdvpop( total, 2,numray, numtop, ierr) # accept
          endwhile

          j = j + 1
          tok = rtdetokn(str,j,jj,ierr,hi)
          if (ierr .eq. ERR) break
      endfor

      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c RTDETOKN - this function determines whether the current token
c          - invalid, eof, an operator, an integer, or a variable
c          -   str      input string
c          -   i,j      position of token in string
c          -   c1       integer value of current character

        function rtdetokn(str, i, j, ierr,lstr)
        integer rtdetokn
        character*(*) str
        integer i,j,lstr, c1

        ierr = OK
        if (i>lstr) return(TOKEOF)
        call utskipbl(str,i)

        if (i>lstr) return(TOKEOF)       # it's the end of the string
        c1 = ichar(str(i:i))

#    (, ), *, +, -, /
        if (c1=40|c1=41|c1=42|c1=43|c1=45|c1=47) then
           j=i
           return(TOKOPER)          # it's an operator
        
        elseif (c1 >= 48 & c1 <= 57) then           # integer
           for (j = i + 1, j <= lstr, j = j + 1)
               c1 = ichar(str(j:j))
               if (c1 < 48 | c1 > 57) break
           endfor
           j = j -1
           return (TOKNUM)         # it's an integer

        elseif (c1>=97 & c1<=122) then
           for(j=i+1,j<=lstr,j=j+1)
              c1=ichar(str(j:j))
              if (.not.((c1>=48 & c1<=57) | (c1>=97 & c1<=122) |
     &            (c1.eq.95))) break
           endfor
           j=j-1
           return(TOKALPHA)

        else
           ierr = ERR
           return (TOKEOF)          # it's a bad character
        endif
        
        end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c PARGETIN - 

      subroutine pargetin(ndb,tok,i,j,str,term,nxtin,index,deflo,defhi,
     &                    defflg,ierr)
      integer tok,         # type of token
              i,j,         # delimiters
              term(2),     # value of integer token
              index,       # index to arrays
              deflo, defhi # default low and high subscripts in range
      character*(*) str   # input string
      character*(1) nxtin # next input
      integer ndb, ierr, itrm
      integer strtoi, parfind, ivalueo
      external strtoi, parfind, ivalueo
      integer ndim, ilow(7), ihi(7), icol(7), npack
      Varname vname
      Address piv
      integer tc, jvar
      logical defflg

      select(tok)
      case TOKEOF:
           index=7
           nxtin = '$'
      case TOKOPER:
           index=ichar(str(i:i))-39
           nxtin=str(i:i)
      case TOKNUM,TOKALPHA:
           index=5
           nxtin = '#'
           if (tok .eq. TOKNUM) then
              term(1) = strtoi(str(i:j))
              term(2) = term(1)
           else
              call utskipbl(str,i)
              vname = str(i:j)
              npack = ndb

# 7/27 ZCM add argument to parfind
              if (parfind(npack,vname,jvar,ndb,tc,-1).eq.ERR) then
# not in ndb, try elsewhere
                 npack = 0
# 7/27 ZCM add argument to parfind
                 if ( parfind(npack,vname,jvar,ndb,tc,-1) = ERR) then
                    call remark("pargetin:unknown name in string")
                    call remark(vname)
                    ierr = ERR
                    return
                 endif
              endif

              if (tc .ne. INTEGER & tc .ne. RANGE) then
                 call remark("pargetin:variable not integer or range")
                 call remark(vname)
                 ierr = ERR
                 return

              else
                 call rtxdb(jvar,ndb,piv,ndim,ilow,ihi,icol,LIMITED)
                 if (piv .eq. NOTSET) then
                    call remark("pargetin:variable not allocated")
                    call remark(vname)
                    ierr = ERR
                    return
                 elseif (tc .eq. RANGE)
                    term(1) = ivalueo (piv, 1)
                    term(2) = ivalueo (piv, 2)
                    if (ivalueo (piv, 3) .ne. 1) then
                       call remark(
                       "pargetin: illegal for limiting string to have a range increment")
                       ierr = ERR
                       return
                    endif
                    if (term(1).eq.DEFAULT) term(1) = deflo
                    if (term(2).eq.DEFAULT) term(2) = defhi
                 else
                    itrm = ivalueo(piv, 1)
                    term(1) = itrm
                    term(2) = itrm
                 endif
              endif
           endif
           default: call baderr('pargetin:impossible token')
        endselect

        return
        end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c RTVOPER - this subroutine performs a reduction
c         - p corresponds to the production being used

      subroutine rtvoper(ierr, p, stray, stop, numray, numtop)
      integer stray, numray, stop, numtop
      dimension stray(MACMAX), numray(2*MACMAX)
      integer first(2), second(2), temp(2), p, optr(2), value(2)
      
      if (p<2 | p>15) then
         ierr = ERR
      
      elseif (p=2 | p=8 | p=11 | p=14) then
         call rtdvpop(temp, 1,stray, stop, ierr)
      
      elseif (p=15) then
         do k=1,3
            call rtdvpop(temp, 1,stray, stop, ierr)
         enddo k
         call rtdvpop(temp, 2,numray, numtop, ierr)
         call rtdvpop(value, 2,numray, numtop,ierr)
         call rtdvpop(temp, 2,numray, numtop, ierr)
         call rtdvpush (value,2,numray,numtop,ierr)
      
      else
         do k=1,2
            call rtdvpop(temp, 1,stray, stop, ierr)
         enddo k
         call rtdvpop(second, 2,numray, numtop, ierr)
         call rtdvpop(optr, 2,numray, numtop, ierr)
         if (p=3) then
            value(1) = -second(1)
            value(2) = -second(2)
         else
            call rtdvpop(temp, 1,stray, stop, ierr)
            call rtdvpop(first, 2,numray, numtop, ierr)
            if (first(1) .ne. first(2) | second(1) .ne. second(2)) then
               if (optr(1) .eq. 42 | optr(1) .eq. 47) then
                  call remark("illegal * or / operator on range")
                  ierr = ERR
               endif
            endif
            if (p .ne. 5 & p .ne. 7) then
               select (optr(1))
               case 42: value(1) = first(1) * second(1)
                        value(2) = value(1)
               case 43: value(1) = first(1) + second(1)
                        value(2) = first(2) + second(2)
               case 45: value(1) = first(1) - second(1)
                        value(2) = first(2) - second(2)
               case 47: if (second(1) .ne.0) then
                           value(1) = first(1)/second(1)
                           value(2) = value(1)
                        else
                           call remark('rtvoper--divide by zero')
                           call kaboom(1)
                        endif
               endselect
            else
               call rtdvpop(temp, 2,numray, numtop, ierr)
               call rtdvpop (temp, 1,stray, stop, ierr)
               select (optr(1))
               case 45: value(1) = -first(1) - second(1)
                        value(2) = -first(2) - second(2)
               case 43: value(1) = -first(1) + second(1)
                        value(2) = -first(2) + second(2)
               endselect
            endif
         endif
      
         call rtdvpush (value, 2,numray,numtop, ierr)
      endif
      
      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c RTDVPOP - this function pops an integer off an integer stack

      subroutine rtdvpop(item, nitems, stack, top, ierr)
      integer item, nitems, stack, top, i
      dimension stack(nitems*MACMAX), item(nitems)

      if (nitems < 1) then
         call remark("rtdvpop internal error:  bad item count")
         ierr = ERR
         return
      endif
      
      do i=1,nitems
         item(i) = 0
      enddo

      if (top>nitems-1) then
         do i=1,nitems
            item(i) = stack(top)
            top = top - 1
         enddo
      else
         ierr = ERR
      endif

      return
      end
      
c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c RTDVPUSH - this subroutine pushes an integer onto an integer stack

      subroutine rtdvpush(item, nitems, stack, top, ierr)
      integer item, nitems, stack, top
      dimension stack(nitems*MACMAX), item(nitems)
      
      if (nitems < 1) then
         call remark("rtdvpush internal error:  bad item count")
         ierr = ERR
         return
      endif
      
      if (top+nitems-1 < nitems*MACMAX ) then
         do i=nitems,1, -1
            top = top + 1
            stack(top) = item(i)
         enddo

      else
         ierr = ERR
      endif
      
      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

