
#*****************************************************************************
#                   LRGSTA, LRPKST, LRPOP, LRPUSH                            *
# Moved here from skel.r77                                                   *
# Instigator: Zane C. Motteler                                               *
# Date      : August 1989                                                    *
# Purpose   : vocstk and states have been made dynamic because of occasional *
#             overflow caused by deep recursion. Thus the routines that      *
#             manipulate these stacks have been moved out of skel.r77.       *
# Moved: The first three of these routines, and part of the fourth, have     *
#        been moved to clr.c (ZCM 2/15/2000)                                 *
#*****************************************************************************

        subroutine lrpush ( state , voc ) #--------------------------lrpush
#       push the state and vocabulary item on top of the stack
#       revised 8/89 (ZCM) to expand the stack if out of space
#       revised 7/95 (ZCM) to try to keep the last 80 or so characters
#                          actually parsed, after macro expansion, etc.
Use(Lrhcoms)
        ################
Use(Controls)
Use(Yyyyzzzz)
        integer hwmny
        character*3 spec
	integer jjj
        ################
        integer state, voc
        call pstkpush (state, voc)
        ################
        if ( debug == YES ) then
           # ignore repeats (same token is never doubled)
           if (ttoken(1:ltoken)==lsttok(1:ltoken)) return
           if ( ltoken == 1 ) then # Look for special characters
              if ( ichar(ttoken(1:1)) < pblnk ) then
                 lsttok = ttoken(1:ltoken)
		 jjj = 92 # Workaround IRIX64 compiler bug
                 spec(1:1) = char ( jjj )
                 spec(2:2) = char ( ichar(ttoken(1:1)) / 8 + ichar("0") )
                 spec(3:3) = char ( mod ( ichar(ttoken(1:1)) , 8 ) + ichar("0") )
                 do i = 1,3
                    lst = lst + 1
                    if ( lst == 80 ) lst = 1 
                    last80( lst ) = spec(i:i)
                    if ( frst == lst ) then
                       frst = frst + 1
                       if ( frst == 80 ) frst = 1
                    elseif ( frst == 0 ) then
                       frst = 1
                    endif
                 enddo
                 return
              endif
           endif
           lsttok = ttoken(1:ltoken)
           hwmny = min(ltoken, 80)
           if ( frst ~= 0 ) then
              # put blanks between tokens
              lst = lst + 1
              if ( lst == 80 ) lst = 1
              last80( lst ) = " "
              if ( frst == lst ) then
                 frst = frst + 1
                 if ( frst == 80 ) frst = 1
              endif
           endif
           do i = 1, hwmny
              lst = lst + 1
              if ( lst == 80 ) lst = 1
              last80( lst ) = ttoken(i:i)
              if ( frst == lst ) then
                 frst = frst + 1
                 if ( frst == 80 ) frst = 1
              elseif ( frst == 0 ) then
                 frst = 1
              endif
           enddo
        endif
        ################
        return
        end

#*****************************************************************************
# END of special section on LRGSTA, LRPKST, LRPOP, LRPUSH                    *
#*****************************************************************************

        function lrerr(ernum,parstr,nstr,strptr,recur)   #---------------------lrerr
        integer lrerr,ernum, strptr, recur, nstr
        Address parstr
Use(Lrhcoms)
Use(Controls)
Use(Yyyyzzzz)
        character*80 tmp

#watch out that this value of ESETSIZE is big enough for the grammar
# Revised 8/89 (ZCM) -- new parameters parstr, strptr, recur
#                    -- send vocstk to lrwsyn since it's now dynamic
define ESETSIZE 1000

        integer vset(ESETSIZE)
        if(ernum == 7) then
                call lxwlin(ltoken + 1,parstr,nstr,strptr,recur)
                call lerrno(ernum)
                ################
                if ( debug == YES & frst ~= 0 ) then # print out context
                   tmp = " "
                   i = frst
                   j = 1
                   while ( i ~= lst )
                      tmp(j:j) = last80(i)
                      i = i + 1
                      j = j + 1
                      if ( i == 80 ) i = 1
                   endwhile
                   tmp(j:j) = last80(lst)
# (FNF 7/31/97) Changed "write(STDERR,..." statement to "call baserror".
                   call baserror(
                   "***The most recent 80 characters (or less) of context are:")
                   call baserror("-->"//tmp)
                   call baserror(" ")
                endif
                ################
                if(debug = YES) then
                   call lrwsyn(vocstk)
                   call lztext(STDERR,"Expected one of the following (?): $")
                   call lzsend(STDERR)
                   call lztext(STDERR,"  $")
                   vset(1) = 0
                   call lreset(vset)
                   call lrwset(STDERR,vset)
                   call lzsend(STDERR)
                endif
                if(recur.ne.0)return(ERR) #on recursive call parser
                                          #handles error
        else
                call lerrno(ernum)
        endif
        call ruthere
        call kaboom(0)
        end



integer function lrpact(action, psp, retflg, recur)
#########################lrpact####################################
# This routine is called by the parser to execute parser actions  #
###################################################################
#
# Written by Zane C. Motteler
#            July, 1986
# This routine converts input statements into intermediate code;
# when a statement is complete, it controls the execution of the
# intermediate code. In essence, the intermediate code contains a
# record of what would have happened to the stack if the code had
# been executed interactively.
#
# Revised by Zane C. Motteler
#            June, 1988
# Event service has been removed from the language, and as a result
# parser actions 804, 806, 807, and 821 have been eliminated. Case 817
# has been revised. Some of the functions of these routine 807 have been
# taken over by lrv115, lrv116, and lrv121 (actions on ENDDO, ENDFOR, and
# ENDWHILE).
#
# Revised by Susan Hockett
#            March, 1989
# Added argument retflg, so that the parser can be logically and physically
# segmented from the action execution.  The call to LREXEC is now done by
# PAREXE instead of this routine.
# Revised by Zane C. Motteler
#            September, 1993
#
# Revised by Zane C. Motteler
#            August 1999
# The argument psp is now the value of the parser stack pointer.
# Actions 808 and 813 now use the value on top of the runtime stack,
# since this is where lryact does its work.
#
	integer action, psp, id, recur # psp is the parser stack pointer
	logical retflg
        integer bnlevel
        external bnlevel, setbknx
        external lrlpend, smovbtoa
        integer lrp823,lxvcons
        external lrp823,lxvcons
        integer ckstacks
        external ckstacks
        Address paraddr
        external paraddr, deccfdep
Use(Actions)
Use(Controls)
Use(Functions)
Use(Stacks)
Use(Lrh4)
Use(Lrh5)
#
        retflg = FALSE
        if (ckstacks()==ERR) return(ERR)   #increase size of stacks if necessary
        if (action == 123) then
                call lrp123
        endif
        if (action <= MAXPSV) then      #simply store the action
		semerr = OK
                call lremit(action)
                if (semerr == ERR) return (ERR)
                if (funcflag & action == 131) then
                   return (lxback (FALSE))
                endif
                return(semerr)
        elseif (action == EXECUTE) then
		retflg = TRUE
## call lrexec
        else    #actions which require manipulating auxiliary structures etc.
                select(action)
                case 800:       #ifstmt ::= if ifexp lalt {logical if}
                        call lrp800
                case 801:       #ifstmt ::= if ifexp thenlist optelse endif
                        call lrp801
                case 802:       #dostmt ::= do eos ... docontrol
                        call lrlpend()
                case 803:       #ifexp ::= ( lexp )
                        call lrp803
		case 804:       #semicolon encountered in paramlist
			umnargs = min(umnargs,ufcnargc-1)
                case 805:       #whilestmt ::= while ... endwhile
                        call lrlpend()
                case 808:                       #level ::= ( int )
                        # level is on top of stack
                        id = ss(N1,rsp)
                        call setbknx(bnlevel(id),id)
                        rsp = rsp - 1
                case 809:                       #optlevel ::=
                        # level defaults to 1
                        id=1
                        call setbknx(bnlevel(id),id)
                case 810:               #docontrol ::= until ( lexp )
                        call lrp810
                case 813:               #level ::= int
                        # level is on top of stack
                        id = ss(N1,rsp)
                        call setbknx(bnlevel(id),id)
                        rsp = rsp - 1
                case 814:               #dorange ::= first , last incr
                        call lrp814
                case 816:               #incr ::=
                        call lrp816
                case 817:               #dostmt ::= do name = ... enddo
                        call lrlpend()
                case 818:               #forinit ::= assignlist | <empty>
                        call lrpfor3 ()
                case 819:               #forout ::= lexp
                        call lrpfor ()
                case 820:               #lstmt ::= cstmt
                        call lrpfor2 ()
                case 822:          #forstmt ::= for (...) stlist ... endfor
                        call lrlpend()
                case 823:               #funcspec ::= function name ... endf
                        semerr = lrp823()
                case 824: # <funcdes>::= name | reference(namelist)
                        call lrp824 # ZCM 9/9/93
                case 825: # <nonnullstmt> ::= <funcspec>
                        call deccfdep ()
                default:
                        semerr=ERR
                        call remark("lrpact: action not in range 800-825.")
                endselect
# check for errors
                return(semerr)
        endif
        return(semerr)

992     format(" Break or next: level = ",i5,".")
995     format(" Push following address for for loop control:",i5,".")

        end #lrpact

        integer function lrvact(action, psp, recur)
        integer action, psp, recur
###############################lrvact######################################
# This routine is called by the parser to execute vocabulary actions.     #
###########################################################################
#
#       written by Zane C. Motteler
#               July, 1986
#       (Description revised July, 1989)
#       This routine carries out certain terminal actions, and calls
#       lxvcons, which stores others in the code stack for later
#       execution. a terminal action is stored in a variable number of 
#       words as
#       1. - action (see lryact for actions)
#       2. token code, or more frequently, pointer into scalar table for
#          a numeric value
#       3. index into string table for token text (from which text and
#          its length can be recovered)
#       This information is needed by the runtime interpreter to build
#       correct stack entries.
#                                                                         #
# Revised by Zane C. Motteler                                             #
#            June 1988                                                    #
#                                                                         #
# Changed cases 115 and 116, and added case 121. Event and serve have been#
# eliminated from the language, and new routines for loop ends became     #
# necessary.                                                              #
# Changed case 111 to just check context. This used to call a routine to  #
# backpatch labels for jumps over event service, which is no longer done. #
# Revised by Zane C. Motteler                                             #
#            September 1993                                               #
# Place last line of function text in buffer (action 123)                 #
# (9/17/93--only done if not recursing)                                   #
#                                                                         #
# (FNF 7/28/97) Changed "write(STDERR,..." statement to "call baserror".
      character*(OUTLINE) errmsg

Use(Actions)
Use(Controls)
Use(Functions)
Use(Lrhcoms)
Use(Stacks)
        external lrelse, lrloops, lrv107, lxvcons, mc119, mc120, ivalueo
        integer  lrv107, lxvcons, ivalueo, ckuntil
        external ckuntil
#
        if (action <= STRACT) then      #name or constant
           return(lxvcons(ntoken, ttoken, ltoken, action))
        endif   #name or constant section
###
##  reserved words
###
        select (action)
        case 107:               #function keyword
                semerr = lrv107(recur)
                if(semerr==ERR) return(ERR)
        case 108:                       #do
                call lrloops(DO_IND)
        case 109:                       #for
                call lrloops(FOR_LOOP)
        case 110:                       #while
                call lrloops(WHILE_LOOP)
        case 111:                       #until
                semerr = ckuntil ()
        case 112:                       #if
                call lrv112
        case 113:                       #else
                call lrp113
        case 114:                       #else if needs new label
                call lrp114
        case 115:                       #enddo
                call lrv115
        case 116:                       #endfor
                call lrv116
        case 117:                       #break
                brkflg = TRUE
        case 118:                       #next
                nextflg = TRUE
        case 119:                       #force string collection
                call mc119
        case 120:               #list
                call mc120
        case 121:               #endwhile
                call lrv121
        case 122:
                call mcscomtk(ttoken)
                call mclrv122(ttoken,ltoken,max(COMINC,ltoken))
	case 123:		#endf
		#no action here any longer
        default:
                write(errmsg,996)action
                call baserror(errmsg)
                semerr = ERR
        endselect
        return(semerr)
994     format(" Create dummy else label at ptr = ",i4,".")
995     format(" Jump ahead label for elseif ",i4," , ptr = ",i4,".")
996     format("lrvact: impossible lexical action (",i4,").")
        end     #lrvact

