/*
 * MACH.C
 *
 */

#include "rt.h"

/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/

double D1mach(integer *i)
{
    char msg[80];

    switch (*i) {
    case 1:
        return DBL_MIN;
    case 2:
        return DBL_MAX;
    case 3:
        return DBL_EPSILON / FLT_RADIX;
    case 4:
        return DBL_EPSILON;
    case 5:
        return log10(FLT_RADIX);
    }
    sprintf(msg, "invalid argument: d1mach(%ld)", (long) *i);
    BasError(msg, strlen(msg));
    Kaboom(0);
    return 0;
}

/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/

integer I1mach(integer *i)
{
    char msg[80];

    switch (*i) {
    case 1:
        return 5;               /* standard input */
    case 2:
        return 6;               /* standard output */
    case 3:
        return 7;               /* standard punch */
    case 4:
        return 0;               /* standard error */
    case 5:
        return WORD_BIT;        /* bits per integer */
    case 6:
        return 1;               /* Fortran 77 value */
    case 7:
        return 2;               /* base for integers */
    case 8:
        return WORD_BIT - 1;    /* digits of integer base */
    case 9:
        if (sizeof(integer) == sizeof(long))
            return ((integer) LONG_MAX);
        else if (sizeof(integer) == sizeof(int))
            return ((integer) INT_MAX);
        else {
            sprintf(msg, " i1mach: Can't figure out length of integer!");
            BasError(msg, strlen(msg));
            Kaboom(0);
            return ((integer) 0);
        }
    case 10:
        return FLT_RADIX;
    case 11:
        return FLT_MANT_DIG;
    case 12:
        return FLT_MIN_EXP;
    case 13:
        return FLT_MAX_EXP;
    case 14:
        return DBL_MANT_DIG;
    case 15:
        return DBL_MIN_EXP;
    case 16:
        return DBL_MAX_EXP;
    }
    sprintf(msg, "invalid argument: i1mach(%ld)", (long) *i);
    BasError(msg, strlen(msg));
    Kaboom(0);
    return 0;
}

/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/

float R1mach(integer *i)
{
    char msg[80];

    switch (*i) {
    case 1:
        return FLT_MIN;
    case 2:
        return FLT_MAX;
    case 3:
        return FLT_EPSILON / FLT_RADIX;
    case 4:
        return FLT_EPSILON;
    case 5:
        return log10(FLT_RADIX);
    }
    sprintf(msg, "invalid argument: r1mach(%ld)", (long) *i);
    BasError(msg, strlen(msg));
    Kaboom(0);
    return 0;
}

/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
