/*
 * multi.c -
 *  The functions in this file can be overridden by the user with a 
 *  machine-specific set. The assumption is that only the processor with
 *  id zero should receive normal output.
 */

#include <multi.h>

/*  ------------------------------------------------------
    The following static global variables retain the state
    of multiprocessing for Basis.
    ------------------------------------------------------ */
static integer Number_of_processors = 1;
static integer Processor_number = 0;


/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/

/* Get the total number of processors
  (Always returns one in the default case.)
*/
integer Basprocessor_count()
{
    return Number_of_processors;
}

/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/

/* Get the number of this processor
  (Always returns zero in the default case.)
*/
integer Basprocessor_id()
{
    return Processor_number;
}

/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/

/* Set the number of processors to nprocs */
void Basprocessor_setnum(nprocs)
integer nprocs;
{
    Number_of_processors = (integer) nprocs;
}

/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/

 /* Set the number of this processor to id */
void Basprocessor_setid(integer id)
{
    Processor_number = (integer) id;
}

/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
