# Basis Code Development System
# Copyright 1986 The Regents of the University of California

# Added by ZCM 12/19/95 to supply a system solver which always
# works with Size8 reals
       subroutine sgesv8 ( n , nrhs , a , lda , ipiv , b , ldb , info )
       integer info , lda , ldb , n , nrhs , ipiv ( * )
       real(Size8) a ( lda , * ) , b ( ldb , * )
ifelse(WORDSIZE,32,[
       call dgesv ( n , nrhs , a , lda , ipiv , b , ldb , info )
],[
       call sgesv ( n , nrhs , a , lda , ipiv , b , ldb , info )
])
       return
       end

        function pardobin (op)
#*s
#     NAME OF ROUTINE...pardobin
#
#     AUTHOR OF ROUTINE...Paul F. Dubois
#       Revised by Zane C. Motteler to handle logical and
#                                   relational operators
#                  7/86
#       Revised by Paul Dubois to do character compares for EQU and NE.
#
#     PURPOSE...
#
#        Do binary operations on matrices
#
#     GLOSSARY OF IMPORTANT VARIABLES...
#
#        op        = operation code:
#                       ADD
#                       SUBTRACT
#                       MULTIPLY
#                       DIVIDE
#                       POWER, etc.
#
#     REVISED...
#       Zane C. Motteler, August 1989
#       --put in calls to parfetch to get values of variables
#     REVISED...
#       Zane C. Motteler, August 1999
#       op is the only parameter needed, as pardobin will always operate
#       on the top two elements of the runtime stack.
#/c
        Ch(COMMENTSIZE) nxpm1
        Ch(TYPESIZE) utcod
        integer u(SSWIDTH)
        integer lxpm1, op, pardobin, type, type1
        integer parxbin, parcoerc, parcnfm, utgetcl
        external parxbin,parcoerc,parcnfm,parget,parrel,parcopy,paropnam,
                utgetcl, utcat
Use(Actions)
Use(Stacks)
        call parfetch(ss(1,rsp-1),nxp(rsp-1),lxp(rsp-1),ACTUAL,TRUE)
        call parfetch(ss(1,rsp),nxp(rsp),lxp(rsp),ACTUAL,TRUE)
        do i=1,SSWIDTH
           u(i) = 0
        enddo
#
#  u := s op t
#symbolic form
        call paropnam(op, nxpm1)
        lxpm1 = utgetcl(nxpm1)
        if( symbolic) then
                call utcat(nxp(rsp-1),lxp(rsp-1),nxp(rsp-1),lxp(rsp-1), \
                  nxpm1,lxpm1,nxp(rsp),lxp(rsp))
        endif
#
        type = max(ss(TC,rsp-1), ss(TC,rsp))
        type1 = min(ss(TC,rsp-1), ss(TC,rsp))
        if (type == FWA & type1 ~= FWA & type1 ~= INTEGER) then
                call utcodstr (type1, utcod)
                call remark(
                "pardobin: Address type incompatible with " // \
                   utcod(1:utgetcl(utcod)) // ".")
                return (ERR)
        endif
# note that if both operands of character type then type is negative
        if(type<0) then
                type = min(ss(TC,rsp-1), ss(TC,rsp))
                select op
                case EQU,NE,LT,LE,GT,GE:
                    u(TC) = LOGICAL
                default:
                    call remark("pardobin: character argument to "//nxpm1(1:lxpm1)//".")
                    return(ERR)
                endselect
        elseif (op < OR ) then           #op is arithmetic
           u(TC) = type             #so result must be.
        else
           u(TC) = LOGICAL          #otherwise logical or relational
           if ((op == ANDEQ | op == OREQ) & (type ~= LOGICAL)) then
                call remark(
                "pardobin: Logical type expected for operator "//nxpm1(1:lxpm1)//".")
                return (ERR)
           elseif(type==RANGE & (op<>ADD & op<>SUBTRACT & op<>NE & op<>EQU))then
                call remark(
                "pardobin: Range is wrong type for operator "//nxpm1(1:lxpm1)//".")
                return (ERR)
           elseif ((op = NE | op = EQU) & type > DOUBLE_C & type <> RANGE \
                & type <> FWA) then
                call remark(
                "pardobin: Numerical, address, or range type expected for operator " \
                    //nxpm1(1:lxpm1)//".")
                return (ERR)
           elseif ((op >= LT & op <= GE) & (type > DOUBLE)) then
                call remark(
                "pardobin: Numerical type expected for operator "//nxpm1(1:lxpm1)//".")
                return (ERR)
           endif
        endif
# coerce to same type
        if( parcoerc(ss(1,rsp-1), type) == ERR) return(ERR)
        if( parcoerc(ss(1,rsp), type) == ERR) return(ERR)
# make sizes conform for the operation
        if( parcnfm(u, ss(1,rsp-1), ss(1,rsp), op) == ERR) return(ERR)
# get storage for the result
        call parget(u)
# do it
        if(parxbin(u, op) == ERR) return(ERR)
#release storage
        call parrel(ss(1,rsp-1))
        call parrel(ss(1,rsp))
#put the answer on the stack
        call parcopy(u, ss(1,rsp-1))
        return(OK)
        end

        function parxbin (u, op)
#*s
#     NAME OF ROUTINE...parxbin
#
#     AUTHOR OF ROUTINE...Paul Dubois 12/27/84
#               Revised...Zane Motteler 7/86
#                         to do logical and relational ops
#
#     PURPOSE...
#
#        execute binary matrix operations
#        This routine assumes types match, sizes are correct
#        u:= ss(1,rsp-1) op ss(1,rsp)   (storage for u already exists)
#
#     GLOSSARY OF IMPORTANT VARIABLES...
#
#       u              = stack element for result
#       ss(1,rsp-1),
#       ss(1,rsp)      = stack elements representing operands
#       op             = integer code ADD,SUBTRACT,MULTIPLY,DIVIDE,POWER,
#                               MATRIXMULTIPLY, MATRIXDIVIDE,
# 				OR, AND, GT, GE, LT,
#                               LE, EQU, NE, OREQ, ANDEQ, PLUSEQ,
#                               MINUSEQ, TIMESEQ, DIVIDEEQ, EXPEQ
#       type     = the coerced type of ss(1,rsp-1) and ss(1,rsp)
#
#     REVISED...
#       Zane C. Motteler 8/91
#       Add double complex type for SUNOS only
#	Yu-Hsing Chiu 9/93
#	Add MATRIXDIVIDE operation for /!
#       Zane C. Motteler 8/1999
#       parxbin operates on the top two elements of the runtime
#       stack, so those elements are not needed as parameters.
#       Zane C. Motteler 1/2000
#       Removal of Dynamics. All all variables whose addresses
#       are given are actually accesses in C routines. See access.c.
#/c
clll.   option nodyneqv
Use(Controls)
Use(Stacks)
        integer parxbin
        integer u(SSWIDTH),op,type
        integer binopi, binopr, binopd, binopc, binopl, binoprg
        external binopi, binopr, binopd, binopc, binopl, binoprg
ifelse(HAS_DOUBLE_COMPLEX,YES,[
        integer binopdc
        external binopdc
])
        integer parlen,parxchop, i1mach
        Address paraddr
        external paraddr,parlen,parxerr,baderr,parxchop,i1mach
        integer n
# handle character ops in another routine
        if(ss(TC,rsp-1) < 0) return(parxchop(u,op))
        type = ss(TC,rsp-1)
        n = parlen(ss(1,rsp-1))     # lengths of ss(.,rsp-1),ss(1,rsp) match; u may be different
        select (u(TC))                  #1
        case INTEGER:
                return (binopi (paraddr(u), paraddr(ss(1,rsp-1)), \
                   paraddr(ss(1,rsp)), n, op, u(N1), u(N2), ss(N2,rsp-1)))
        case REAL:
                return (binopr (paraddr(u), paraddr(ss(1,rsp-1)), \
                   paraddr(ss(1,rsp)), n, op, u(N1), u(N2), ss(N2,rsp-1)))
        case DOUBLE:
                return (binopd (paraddr(u), paraddr(ss(1,rsp-1)), \
                   paraddr(ss(1,rsp)), n, op, u(N1), u(N2), ss(N2,rsp-1)))
ifelse(HAS_DOUBLE_COMPLEX,YES,[
        case COMPLEX:
],[
        case COMPLEX, DOUBLE_C:
])
                return (binopc (paraddr(u), paraddr(ss(1,rsp-1)), \
                   paraddr(ss(1,rsp)), n, op, u(N1), u(N2), ss(N2,rsp-1)))
ifelse(HAS_DOUBLE_COMPLEX,YES,[
#       Do the double complex
        case DOUBLE_C:
                return (binopdc (paraddr(u), paraddr(ss(1,rsp-1)), \
                   paraddr(ss(1,rsp)), n, op, u(N1), u(N2), ss(N2,rsp-1)))
])
        case RANGE:
                return (binoprg (paraddr(u), paraddr(ss(1,rsp-1)), \
                   paraddr(ss(1,rsp)), n, op))
        case LOGICAL:
                return (binopl (paraddr(u), paraddr(ss(1,rsp-1)), \
                   paraddr(ss(1,rsp)), n, op, type))
        default:
                call remark("parxbin: illegal type of operands")
                return(ERR)
        endselect                               #1
        return(OK)
        end


        function pardonot ()
#*s
#     NAME OF ROUTINE...pardonot
#
#     AUTHOR OF ROUTINE...Zane C. Motteler
#
#     PURPOSE...
#
#        Do logical not of matrix on stack
#
#     GLOSSARY OF IMPORTANT VARIABLES...
#
#        s,sm1       = stack elements
#
#     REVISED...
#       Zane C. Motteler, August 1989
#       --put in calls to parfetch to get values of variables
#       Zane C. Motteler, August 1999
#       --No arguments are needed as this routine operates always
#       on the runtime stacktop pointed at by rsp.
#       Zane C. Motteler, January 2000
#       --Remove Dynamics and let C do the dereferencing.
#
#/c
        integer pardonot, parlen
        external paraddr, parlen, parcopy, utcat
        Address paraddr
        integer n
        integer unopnot
        external unopnot
Use(Actions)
Use(Stacks)
        call parfetch(ss(1,rsp),nxp(rsp),lxp(rsp),COPY,TRUE)
        if( symbolic) then
                call utcat(nxp(rsp), lxp(rsp), "~", 1, nxp(rsp), lxp(rsp), BLANK, 0)
        endif
        n = parlen(ss(1,rsp))
        if(ss(TC,rsp) == LOGICAL) then
                return (unopnot (paraddr(ss(1,rsp)), n))
        else
                call remark(
                "pardonot: illegal type of operand for NOT.")
                return(ERR)
        endif
        
        end #pardonot

        function pardoneg ()
#*s
#     NAME OF ROUTINE...pardoneg
#
#     AUTHOR OF ROUTINE...Paul F. Dubois
#
#     PURPOSE...
#
#        Do negation of matrix on stack
#
#     GLOSSARY OF IMPORTANT VARIABLES...
#
#        s,sm1       = stack elements
#
#     REVISED...
#       Zane C. Motteler, August 1989
#       --put in calls to parfetch to get values of variables
#       Zane C. Motteler, August 1991
#       --add double complex type for SUNOS
#       Zane C. Motteler, August 1999
#       --No arguments are needed as this routine operates always
#       on the runtime stacktop pointed at by rsp.
#       Zane C. Motteler, January 2000
#       --Remove Dynamics and let C do the dereferencing.
#
#/c
        integer pardoneg,parlen
        external paraddr,parlen
        Address paraddr
        integer n
        integer unopneg
        external unopneg
#
#  u :=  - s
#
Use(Actions)
Use(Stacks)
        call parfetch(ss(1,rsp),nxp(rsp),lxp(rsp),COPY,TRUE)
        if( symbolic) then
                call utcat(nxp(rsp), lxp(rsp), "-", 1, nxp(rsp), lxp(rsp), BLANK, 0)
        endif
        n = parlen(ss(1,rsp))
# do it in place
        return (unopneg (paraddr(ss(1,rsp)), n, ss(TC,rsp)))

        end

        integer function parxchop(u,op)
# execute binary character ops EQU,NE
# Revised 3/97 (ZCM) Implement comparison between two character
# arrays. Formerly this only worked between scalars.
#     Changed dummy dimension from 1 to *. (FNF 12/17/96)
#       Zane C. Motteler, January 2000
#       --Remove Dynamics and let C do the dereferencing.
Use(Stacks)
        integer u(*),op
        integer binoplch
        external binoplch
        Address paraddr
        external paraddr
        integer parlen
        external parlen
#
# can handle EQU, NE
        return (binoplch (paraddr(u), paraddr(ss(1,rsp-1)), paraddr(ss(1,rsp)),\
           parlen (u), - ss (TC,rsp-1), - ss (TC,rsp), op))
        end

        function fcndomax(nargs,sxi)
        integer fcndomax,i,j,incy,nargs,sxi(SSWIDTH)
        integer syi(SSWIDTH)
# calculate point-by-point maximum
# (ZCM 8/11/99) Revised to eliminate ss and sp arguments.
# Runtime and compile-time stacks are now separate.
#       Zane C. Motteler, January 2000
#       --Remove Dynamics and let C do the dereferencing.
        integer parcoerc,parlen
        Address paraddr
        external parrel, parcoerc, parlen, paraddr
        integer nx,ny,tc,iarg, idum
        integer maxop
        external maxop
#
        call fcnargb(1,sxi)
        nx = parlen(sxi)
        if(sxi(TC) < INTEGER | sxi(TC) > DOUBLE) then
                if(parcoerc(sxi,REAL) = ERR) then
                        call remark("max: first argument of bad type.")
                        return(ERR)
                endif
        endif
        do iarg=2, nargs
# get the next argument into syi
                call fcnargb(iarg,syi)
# coerce types
                tc = min(max(sxi(TC), syi(TC)), DOUBLE)
                if(parcoerc(sxi,tc) = ERR) call baderr("max: impossible")
                if(parcoerc(syi,tc) = ERR) then
                        call remark("max: bad argument type")
                        return(ERR)
                endif
# scalars get promoted in the loops themselves
# get the length of y
                ny = parlen(syi)
# must match length of x unless one or both scalar
                if(ny > 1 & nx > 1 & nx <> ny) then
                        call remark("max: lengths of arguments don't match")
                        return(ERR)
                endif
                if( ny > nx) then
# x must be scalar, y vector
# switch them
                        do i=1,SSWIDTH
                                j = syi(i)
                                syi(i) = sxi(i)
                                sxi(i) = j
                        enddo
                        nx = ny ; ny = 1
                endif
# now either ny=ny or nx > 1 and ny = 1
                if(ny = 1) then
                        incy = 0
                else
                        incy = 1
                endif
                idum = maxop (paraddr(sxi), paraddr(syi), nx, incy, tc)
                call parrel(syi)
        enddo
        return(OK)
        end
#-------------------------------------------------------------------fcndomin
        function fcndomin(nargs,sxi)
        integer fcndomin,i,j,incy,nargs,sxi(SSWIDTH)
        integer syi(SSWIDTH)
# calculate point-by-point minimum
# (ZCM 8/11/99) Revised to eliminate ss and sp arguments.
# Runtime and compile-time stacks are now separate.
#       Zane C. Motteler, January 2000
#       --Remove Dynamics and let C do the dereferencing.
        integer parcoerc,parlen
        Address paraddr
        external parrel, parcoerc, parlen, paraddr
        integer minop
        external minop
        integer nx,ny,tc,iarg
#
        call fcnargb(1, sxi)
        nx = parlen(sxi)
        if(sxi(TC) < INTEGER | sxi(TC) > DOUBLE_C) then
                if(parcoerc(sxi,REAL) = ERR) then
                        call remark("min: first argument of bad type.")
                        return(ERR)
                endif
        endif
        do iarg=2, nargs
# get the next argument into syi
                call fcnargb(iarg, syi)
# coerce types
                tc = min(max(sxi(TC), syi(TC)), DOUBLE_C)
                if(parcoerc(sxi,tc) = ERR) call baderr("min: impossible")
                if(parcoerc(syi,tc) = ERR) then
                        call remark("min: bad argument type")
                        return(ERR)
                endif
# scalars get promoted in the loops themselves
# get the length of y
                ny = parlen(syi)
# must match length of x unless one or both scalar
                if(ny > 1 & nx > 1 & nx <> ny) then
                        call remark("min: lengths of arguments don't match")
                        return(ERR)
                endif
                if( ny > nx) then
# x must be scalar, y vector
# switch them
                        do i=1,SSWIDTH
                                j = syi(i)
                                syi(i) = sxi(i)
                                sxi(i) = j
                        enddo
                        nx = ny ; ny = 1
                endif
# now either ny=ny or nx > 1 and ny = 1
                if(ny = 1) then
                        incy = 0
                else
                        incy = 1
                endif
                idum = minop (paraddr(sxi), paraddr(syi), nx, incy, tc)
                call parrel(syi)
        enddo loop on argument list
        return(OK)
        end

        function pardomm ()
#*s
#     NAME OF ROUTINE...pardomm
#
#     AUTHOR OF ROUTINE...Paul F. Dubois
#
#     PURPOSE...
#
#        Do matrix multiply
#
#     GLOSSARY OF IMPORTANT VARIABLES...
#
#        s,t      = stack elements
#
#     REVISED...
#       Zane C. Motteler, August 1989
#       --put in calls to parfetch to get values of variables
#       Zane C. Motteler, August 1999
#       --No longer needs arguments, as it always operates on
#       the top two stack elements.
#/c
        integer u(SSWIDTH)
        integer pardomm, ierr
        integer pardobin,parcoerc, utgetcl, parxbin
        external pardobin,parcoerc, utgetcl, parxbin
Use(Actions)
Use(Stacks)
#
#  u := ss(1,rsp-1) *! ss(1,rsp)
#
# if either ss(1,rsp-1) or ss(1,rsp) is a scalar, just use regular multiplication
        call parfetch(ss(1,rsp-1),nxp(rsp-1),lxp(rsp-1),ACTUAL,TRUE)
        call parfetch(ss(1,rsp),nxp(rsp),lxp(rsp),ACTUAL,TRUE)
        call pardim(ss(1,rsp-1))
        call pardim(ss(1,rsp))
        if(ss(N,rsp-1) == 0 | ss(N,rsp) == 0 ) then
           return(pardobin(MULTIPLY))
        endif
#
        if( symbolic) then
                call utcat(nxp(rsp-1),lxp(rsp-1),nxp(rsp-1),lxp(rsp-1), \
                   "*!",2,nxp(rsp),lxp(rsp))
        endif
# screen out types
        select (ss(TC,rsp-1) )
        case INTEGER,REAL,DOUBLE,COMPLEX,DOUBLE_C: ;
        default:
                call remark("pardomm: operand has illegal type for ")
                call remark("matrix multiply.")
                return(ERR)
        endselect
        select (ss(TC,rsp) )
        case INTEGER,REAL,DOUBLE,COMPLEX,DOUBLE_C: ;
        default:
                call remark("pardomm: operand has illegal type for ")
                call remark("matrix multiply.")
                return(ERR)
        endselect
        u(TC) = max(ss(TC,rsp-1), ss(TC,rsp))
# coerce to same type
        if( parcoerc(ss(1,rsp-1),u(TC)) == ERR) return(ERR)
        if( parcoerc(ss(1,rsp),u(TC)) == ERR) return(ERR)
# make sizes conform for the operation
        if(ss(N,rsp-1) == 1) then
                ss(N,rsp-1) = 2
                ss(N2,rsp-1) = 1
                ss(M2,rsp-1) = 1
		ss(I2,rsp-1) = 1
        endif
        if(ss(N,rsp) == 1) then
                ss(N,rsp) = 2
                ss(N2,rsp) = 1
                ss(M2,rsp) = 1
		ss(I2,rsp) = 1
        endif
        if(ss(N,rsp-1) <> 2 | ss(N,rsp) <> 2) then
                call remark("pardomm: matrix multiply with wrong dimensions.")
                return(ERR)
        endif
        if(ss(N2,rsp-1) <> ss(N1,rsp)) then
                call remark("pardomm: matrix multiply with size mismatch.")
                return(ERR)
        endif
# get storage for the result
        u(N) = 2
        u(N1) = ss(N1,rsp-1)
	u(M1) = ss(M1,rsp-1)
	u(I1) = ss(I1,rsp-1)
        u(N2) = ss(N2,rsp)
	u(M2) = ss(M2,rsp)
	u(I2) = ss(I2,rsp)
        call parget(u)
# do it
        ierr = parxbin(u, MATRIXMULTIPLY)
#release storage
        call parrel(ss(1,rsp-1))
        call parrel(ss(1,rsp))
#put the answer on the stack
# get rid of any phony dimensions
        call pardim(u)
        call parcopy(u, ss(1,rsp-1))
        return(ierr)
        end

        function pardomd ()
#*s
#     NAME OF ROUTINE...pardomd
#
#     AUTHOR OF ROUTINE...Yu-Hsing Chiu 
#
#     PURPOSE...
#
#        Do matrix division
#
#     GLOSSARY OF IMPORTANT VARIABLES...
#
#        ss(.,rsp),ss(.,rsp-1)      = stack elements
#
#     REVISED...
#                          ...   Zane C. Motteler
#                                August 1999
#       --No longer needs arguments, as it always operates on
#       the top two stack elements.
#/c
        integer u(SSWIDTH)
        integer pardomd, ierr
        integer pardobin,parcoerc, utgetcl, parxbin
        external pardobin,parcoerc, utgetcl, parxbin
Use(Actions)
Use(Stacks)
#
#  u := ss(.,rsp-1) /! ss(.,rsp)
#  definition of /!: 	ss(.,rsp) *! u = ss(.,rsp-1)
#
# if t is a scalar, just use regular multiplication
        call parfetch(ss(1,rsp-1),nxp(rsp-1),lxp(rsp-1),COPY,TRUE)
        call parfetch(ss(1,rsp),nxp(rsp),lxp(rsp),COPY,TRUE)
        call pardim(ss(1,rsp-1))
        call pardim(ss(1,rsp))
        if( ss(N,rsp) == 0 ) then
           return(pardobin(DIVIDE))
	else
	   if( ss(N,rsp-1) == 0 ) then
	   call remark("impossible argument type for MATRIXDIVIDE")
           call remark("the 2nd arg is a matrix but the 1st arg is a scalar")
	   return(ERR) 
	   endif
        endif
#
        if( symbolic) then
                call paropnam(MATRIXDIVIDE,nxpm1)
                lxpm1 = utgetcl(nxpm1)
                call utcat(nxp(rsp-1),lxp(rsp-1),nxp(rsp-1),lxp(rsp-1),\
                   "/!",2,nxp(rsp),lxp(rsp))
        endif
# screen out types
        select (ss(TC,rsp-1) )
        case INTEGER,REAL,DOUBLE: ;
        default:
                call remark("pardomd: operand has illegal type for ")
                call remark("matrix divide.")
		call remark("legal type: INTEGER, REAL, or DOUBLE")
                return(ERR)
        endselect
        select (ss(TC,rsp) )
        case INTEGER,REAL,DOUBLE: ;
        default:
                call remark("pardomd: operand has illegal type for ")
                call remark("matrix divide.")
                call remark("legal type: INTEGER, REAL, or DOUBLE")
                return(ERR)
        endselect
        u(TC) = max(ss(TC,rsp-1), ss(TC,rsp), REAL)	#at least be REAL
# coerce to same type
        if( parcoerc(ss(1,rsp-1),u(TC)) == ERR) return(ERR)
        if( parcoerc(ss(1,rsp),u(TC)) == ERR) return(ERR)
        if(ss(N,rsp-1) == 1) then
                ss(N,rsp-1) = 2
                ss(N2,rsp-1) = 1
                ss(M2,rsp-1) = 1
                ss(I2,rsp-1) = 1
        endif
        if(ss(N,rsp) == 1) then
                ss(N,rsp) = 2
                ss(N2,rsp) = 1
                ss(M2,rsp) = 1
                ss(I2,rsp) = 1
        endif
        if(ss(N,rsp-1) <> 2 | ss(N,rsp) <> 2) then
                call remark("pardomd: matrix divide with wrong dimensions.")
                return(ERR)
        endif
	if(ss(N1,rsp) <> ss(N2,rsp)) then
		call remark("the 2nd matrix has to be a square matrix.")
	        return(ERR)
	endif
        if(ss(N1,rsp-1) <> ss(N1,rsp)) then #check number of rows same as dimension of t
                call remark("pardomd: matrix divide with size mismatch.")
                return(ERR)
        endif
# get storage for the result
# the shape of u should be identical to s (YHC)
	call parcopy(ss(1,rsp-1),u) 
        call parget(u)
# do it
        ierr = parxbin(u, MATRIXDIVIDE)
#release storage
        call parrel(ss(1,rsp-1))
        call parrel(ss(1,rsp))
#put the answer on the stack
# get rid of any phony dimensions
        call pardim(u)
        call parcopy(u, ss(1,rsp-1))
        return(ierr)
        end

        function pardodp ()
#*s
#     NAME OF ROUTINE...pardodp
#
#     AUTHOR OF ROUTINE...Paul F. Dubois
#
#     PURPOSE...
#
#        Do dot product
#
#     GLOSSARY OF IMPORTANT VARIABLES...
#
#        s,t      = stack elements
#
#     REVISED...
#       Zane C. Motteler, August 1989
#       --put in calls to parfetch to get values of variables
#       Zane C. Motteler, August 1999
#       --No longer needs arguments, as it always operates on
#       the top two stack elements.
#/c
        integer u(SSWIDTH)
        integer pardodp
        integer parcoerc,parlen, utgetcl, parxbin, ierr
        external parcoerc,parlen, utgetcl, parxbin
Use(Actions)
Use(Stacks)
        call parfetch(ss(1,rsp-1), nxp(rsp-1),lxp(rsp-1),ACTUAL,TRUE)
        call parfetch(ss(1,rsp), nxp(rsp),lxp(rsp),ACTUAL,TRUE)
#
#  u := ss(1,rsp-1) ! ss(1,rsp)  (inner product)
#
        if( symbolic) then
                call utcat(nxp(rsp-1),lxp(rsp-1),nxp(rsp-1),lxp(rsp-1),\
                  "!",1,nxp(rsp),lxp(rsp))
        endif
        if(parlen(ss(1,rsp-1)) ~= parlen(ss(1,rsp))) then
                call remark("inner product with non-matching lengths.")
                return(ERR)
        endif
#
# screen out types
        select (ss(TC,rsp-1) )
        case INTEGER,REAL,DOUBLE,COMPLEX,DOUBLE_C: ;
        default:
                call remark("pardodp: operand has illegal type for ")
                call remark("dot product.")
                return(ERR)
        endselect
        select (ss(TC,rsp) )
        case INTEGER,REAL,DOUBLE,COMPLEX,DOUBLE_C: ;
        default:
                call remark("pardomm: operand has illegal type for ")
                call remark("dot product.")
                return(ERR)
        endselect
        u(TC) = max(ss(TC,rsp-1), ss(TC,rsp))
# coerce to same type
        if( parcoerc(ss(1,rsp-1),u(TC)) == ERR) return(ERR)
        if( parcoerc(ss(1,rsp),u(TC)) == ERR) return(ERR)
# get storage for the result
        u(N) = 0
        call parget(u)
# do it
        ierr = parxbin(u, DOTPRODUCT)
#release storage
        call parrel(ss(1,rsp-1))
        call parrel(ss(1,rsp))
#put the answer on the stack
        call parcopy(u, ss(1,rsp-1))
        return(ierr)
        end

#--------------------------------------------------------------------parcolon
        function parcolon(nexp)
# reduce the production <exp>:=<rexp> : <rexp>            or
#                       <exp>:=<rexp> : <rexp> : <rexp>
# <rexp> is either an expression or it is of type NULL_TYPE
# nexp is the number of components (2 or 3).
# sp points to the first <rexp> term (i.e. the start index)
# Revised 8/89 (ZCM) add parfetches to get values
# Revised 10/89 (PFD) to add creation of real vectors
# (FNF 7/31/97) Changed "call remark" statements to "call baserror".
# Moved here from ref.m 8/6/97 (ZCM)
# (ZCM 8/12/2999) No longer needs sp as argument; parcolon always operates
# on the top two (or three) elements of the stack.
#       Zane C. Motteler, January 2000
#       --Remove Dynamics and let C do the dereferencing.

        integer parcolon, nexp
Use(Controls)
Use(Actions)
Use(Stacks)
        character*2 msg
        integer parint, parreal, parcoerc
        Address paraddr
        external parint, parreal, paraddr, parcoerc
        external rangei, ranger, ranged
        integer ilow, ihi, iinc, i, itot, itype
	real rlow, rhi, rdelta
	double precision dlow,dhi,ddelta, dvalue
        external dvalue

        call parfetch(ss(1,rsp),nxp(rsp),lxp(rsp),ACTUAL,FALSE)
        call parfetch(ss(1,rsp-1),nxp(rsp-1),lxp(rsp-1),ACTUAL,FALSE)
        if (nexp = 3) call parfetch(ss(1,rsp-2),nxp(rsp-2),lxp(rsp-2),ACTUAL,FALSE)

        if(symbolic) then
                call utcat(nxp(rsp-1),lxp(rsp-1),nxp(rsp-1),lxp(rsp-1),
                           ":",1,nxp(rsp),lxp(rsp))
                if (nexp = 3) call utcat(nxp(rsp-2),lxp(rsp-2),nxp(rsp-2),lxp(rsp-2),
                           ":",1,nxp(rsp-1),lxp(rsp-1))
        endif
	itype = 0
	do i=1,nexp
           if(ss(TC,rsp-(nexp-i)) < 0 | ss(TC,rsp-(nexp-i)) > DOUBLE) then
                if(i==1) then
                   msg = "a."
                elseif(i==2) then
                   msg = "b."
                elseif(i==3) then
                   msg = "c."
                endif
                call baserror("a:b or a:b:c with improper type on the "//msg)
                call kaboom(0)
           endif
	   itype=max(itype,ss(TC,rsp-(nexp-i)))
	enddo
	if (itype > INTEGER) go to 500
# check for NULL_TYPE and then get value
        if( ss(TC,rsp-nexp+1) == NULL_TYPE) then
                ilow = DEFAULT
        else
                if(parint(ss(1,rsp-nexp+1),ilow) = ERR) return(ERR)
                call parrel(ss(1,rsp-nexp+1))
        endif

        if( ss(TC,rsp-nexp+2) == NULL_TYPE) then
                ihi = DEFAULT
        else
                if(parint(ss(1,rsp-nexp+2),ihi) = ERR) return(ERR)
                call parrel(ss(1,rsp-nexp+2))
        endif

        if ( nexp = 3) then
                if( ss(TC,rsp) == NULL_TYPE) then
                        iinc = 1
                else
                        if(parint(ss(1,rsp),iinc) = ERR) return(ERR)
                        call parrel(ss(1,rsp))
                        if (iinc = 0) then
                                call baserror(
     1                         "ERROR: illegal to have increment of 0 in range")
                                return(ERR)
                        endif
                endif
        else
                iinc = 1
        endif

        ss(TC,rsp-nexp+1) = RANGE
        ss(N,rsp-nexp+1) = 0
        call parget(ss(1,rsp-nexp+1))
        call rangei (paraddr(ss(1,rsp-nexp+1)), ilow, ihi, iinc)

        return(OK)
500     continue   #handle case with real/double values
        if(itype=DOUBLE) go to 550
	if( parcoerc(ss(1,rsp-nexp+1),REAL) == ERR) go to 600
        if(parreal(ss(1,rsp-nexp+1),rlow) = ERR) go to 600
        call parrel(ss(1,rsp-nexp+1))

	if( parcoerc(ss(1,rsp-nexp+2),REAL) == ERR) go to 600
        if(parreal(ss(1,rsp-nexp+2),rhi) = ERR) go to 600
        call parrel(ss(1,rsp-nexp+2))

        if ( nexp = 3) then
                if( ss(TC,rsp) == NULL_TYPE) then
			if(ncolon <=0) go to 600
			itot = max(ncolon,2)
			rdelta = (rhi-rlow)/(itot-1)
                elseif(ss(TC,rsp) == INTEGER) then
                        if(parint(ss(1,rsp),itot) = ERR) go to 600
			if(itot <=0) go to 600
                        call parrel(ss(1,rsp))
			itot = max(itot,2)
			rdelta = (rhi-rlow)/(itot-1)
		else
			if(parreal(ss(1,rsp),rdelta) == ERR) go to 600
			if(rdelta <=0.) go to 600
			if(rlow > rhi) rdelta=-rdelta
			itot = .99999*abs((rhi-rlow)/rdelta) + 1.
			itot = itot+1
			itot = max(itot,2)
                endif
        else
		if(ncolon <=0) go to 600
		itot = max(ncolon,2)
		rdelta = (rhi-rlow)/(itot-1)
        endif
	ss(TC,rsp-nexp+1) = REAL
	ss(N,rsp-nexp+1) = 1
	ss(M1,rsp-nexp+1) = 1
	ss(N1,rsp-nexp+1) = itot
	ss(I1,rsp-nexp+1) = 1
	call parget(ss(1,rsp-nexp+1))
        call ranger (paraddr(ss(1,rsp-nexp+1)), itot, rlow, rhi, rdelta)
	return(OK)
550     continue ### double precision
	if( parcoerc(ss(1,rsp-nexp+1),DOUBLE) == ERR) go to 600
	dlow = dvalue(paraddr(ss(1,rsp-nexp+1)))
        call parrel(ss(1,rsp-nexp+1))

	if( parcoerc(ss(1,rsp-nexp+2),DOUBLE) == ERR) go to 600
	dhi = dvalue(paraddr(ss(1,rsp-nexp+2)))
        call parrel(ss(1,rsp-nexp+2))

        if ( nexp = 3) then
                if( ss(TC,rsp) == NULL_TYPE) then
			if(ncolon <=0) go to 600
			itot = max(ncolon,2)
			ddelta = (dhi-dlow)/(itot-1)
                elseif(ss(TC,rsp) == INTEGER) then
                        if(parint(ss(1,rsp),itot) = ERR) go to 600
			if(itot <=0) go to 600
                        call parrel(ss(1,rsp))
			itot = max(itot,2)
			ddelta = (dhi-dlow)/(itot-1)
		else
			if(parcoerc(ss(1,rsp),DOUBLE) == ERR) go to 600
			ddelta = dvalue(paraddr(ss(1,rsp)))
			if(ddelta <=0.) go to 600
			if(dlow > dhi) ddelta=-ddelta
			itot = .99999*abs((dhi-dlow)/ddelta) + 1.
			itot = itot+1
			itot = max(itot,2)
                endif
        else
		if(ncolon <=0) go to 600
		itot = max(ncolon,2)
		ddelta = (dhi-dlow)/(itot-1)
        endif
	ss(TC,rsp-nexp+1) = DOUBLE
	ss(N,rsp-nexp+1) = 1
	ss(M1,rsp-nexp+1) = 1
	ss(N1,rsp-nexp+1) = itot
	ss(I1,rsp-nexp+1) = 1
	call parget(ss(1,rsp-nexp+1))
        call ranged (paraddr(ss(1,rsp-nexp+1)), itot, dlow, dhi, ddelta)
	return(OK)
600     call baserror("Error in colon operation with real or double value(s).")
	return(ERR)
        end


#-------------------------------------------------------------------pardocat
        function pardocat()
#*s
#       NAME OF ROUTINE    ...   pardocat
#
#       AUTHOR OF ROUTINE  ...   Zane C. Motteler
#                                June, 1987
#
#       PURPOSE:To concatenate arbitrary objects as follows:
#               Numeric objects--produce a linear array with all the items of
#                       two objects (coerced, if necessary) in order.
#               String objects--only scalars are allowed, and they are con-
#                       catenated the way strings normally are.
#
#       GLOSSARY OF IMPORTANT VARIABLES  ...
#
#               ss(.,rsp-1), ss(.,rsp) = stack elements to concatenate
#
#       REVISION           ...   Zane C. Motteler
#                                August, 1989
#       PURPOSE : 'parfetch' the data prior to concatenating
#                          ...   Zane C. Motteler
#                                August 1999
#       --No longer needs arguments, as it always operates on
#       the top two stack elements.
#
#       Zane C. Motteler, January 2000
#       --Remove Dynamics and let C do the dereferencing.
        integer u(SSWIDTH)
        integer pardocat, type, ns, nt
        integer utgetcl, utsizeof, parcoerc, parlen
        Address paraddr
        external utgetcl, utsizeof, utcat, baserror, parcoerc, parlen, parget,
                parrel, parcopy, paraddr, bincat
Use(Actions)
Use(Stacks)
        call parfetch(ss(1,rsp-1),nxp(rsp-1),lxp(rsp-1),ACTUAL,TRUE) # don't spoil names already
        call parfetch(ss(1,rsp),nxp(rsp),lxp(rsp),ACTUAL,TRUE) # constructed
        if (symbolic) then
                call utcat(nxp(rsp-1), lxp(rsp-1), nxp(rsp-1), lxp(rsp-1), "//", 2,
                        nxp(rsp), lxp(rsp))
        endif
        type = max(ss(TC,rsp-1), ss(TC,rsp))
#if both operands are character type, then type is negative
        if (type < 0) then
        # we have character types
                call pardim(ss(1,rsp-1))
                call pardim(ss(1,rsp))
                if((ss(N,rsp-1) ~= 0) | (ss(N,rsp) ~= 0)) then
                        call baserror(
                        "pardocat: can only concatenate scalar strings.")
                        return(ERR)
                endif
                u(TC) = ss(TC,rsp-1) + ss(TC,rsp)
                u(N) = 0
                u(NAML) = 1 # ZCM 5/95 force result into literal table
                call parget(u)
                call bincat (paraddr (u), paraddr (ss(1,rsp-1)),
                  paraddr (ss(1,rsp)), -ss(TC,rsp-1), -ss(TC,rsp))
        else if ((ss(TC,rsp-1)*ss(TC,rsp))<=0)then
                call baserror(
                "pardocat: Wrong type of arguments for //.")
                return(ERR)
        else #coerce to same type
                if(parcoerc(ss(1,rsp-1),type) == ERR) return(ERR)
                if(parcoerc(ss(1,rsp),type) == ERR) return(ERR)
                u(TC) = type
                u(N) = 1
                u(N1) = parlen(ss(1,rsp-1)) + parlen(ss(1,rsp))
                u(M1) = 1
                u(I1) = 1
                call parget(u)
                ns = utsizeof(parlen(ss(1,rsp-1)), type) * CHAR_PER_WORD
                nt = utsizeof(parlen(ss(1,rsp)), type) * CHAR_PER_WORD
                call bincat (paraddr(u), paraddr(ss(1,rsp-1)), \
                  paraddr(ss(1,rsp)), ns, nt)
        endif
        call parrel(ss(1,rsp-1))
        call parrel(ss(1,rsp))
        call parcopy(u, ss(1,rsp-1))
        return(OK)

        end #----------------------------------------------------of pardocat

      integer function cpow (c, a, b, n)
      # (ZCM 1/6/1999) c, a and b are complex arrays n long.
      # compute the array whose elements are a(i) ** b(i)
      # and put the result into c(i).
      # This routine is called from C due to the difficulty
      # of doing the same thing in C.
      complex a (*), b (*), c (*)
      integer i0, i, n
      do i = 1, n
         if (a (i) == 0. & b (i) == 0.) then
            call parxerr ("Complex power error", i)
            return (ERR)
         endif
         i0 = b (i)
         if(cmplx(i0) == b (i)) then
            c (i) = a (i) ** i0
         else
            c (i) = a (i) ** b (i)
         endif
      enddo
      return (OK)
      end

ifelse(HAS_DOUBLE_COMPLEX,YES,[

      integer function dcpow (c, a, b, n)
      # (ZCM 1/6/1999) c, a and b are double complex arrays n long.
      # compute the array whose elements are a(i) ** b(i)
      # and put the result into c(i).
      # This routine is called from C due to the difficulty
      # of doing the same thing in C.
      double complex a (*), b (*), c (*)
      integer i0, i, n
      do i = 1, n
         if (a (i) == 0. & b (i) == 0.) then
            call parxerr ("Complex power error", i)
            return (ERR)
         endif
         i0 = b (i)
         if(cmplx(i0) == b (i)) then
            c (i) = a (i) ** i0
         else
            c (i) = a (i) ** b (i)
         endif
      enddo
	return (OK)
      end

])
