#Copyright, 1994, Regents of the University of California
#This file has the mechanisms to hunt down files using a path

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c PATHINIT - initialize the searth path
c          - search path includes home, work, and directory
c          - out of which code was executed
c          - and $(BASIS_ROOT)/include

      subroutine pathinit(codedir)
      character*(*) codedir
      character*500 fgetenv
      external fgetenv, pathlast, utgetcl
      character*500 bpath
      integer istart, pathlast, bpathlen, utgetcl

Use(Path)

      call pathadd("$BASIS_ROOT/include")
      call pathadd("$HOME")
      call pathadd("$WRK")
      call pathadd(codedir)
      call pathadd(".")

      bpath = fgetenv("BASIS_PATH")
      if (bpath == " ") return

      bpathlen = utgetcl (bpath)
      do
         istart = pathlast (bpath(1:bpathlen))
         call pathadd(bpath(istart:bpathlen))
         if (istart <= 2) break
         bpathlen = istart - 2
      enddo

      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c PATHLAST - Find the index of the char following the last colon in str

      integer function pathlast (str)
      character * (*) str
      integer index1, index2

      index1 = 1
      do
         index2 = index(str(index1:), ":")
         if (index2 == 0) break
         index1 = index1 + index2
      enddo

      return (index1)
      end
      
c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c PATHADD - fills path from pathtop down
c         - calculate effective path top in bounds

      subroutine pathadd(f)
      character*(*) f
      logical osfind
      integer islot, j, utsizeof, pathtope
      external osfind, utsizeof

Use(Path)

      if (f .eq. " ") return

      pathtope = min(pathsize+1, pathtop, MAXPATH)
      pathtope = max(1, pathtope)

      do islot = 1, pathtope-1
        if (path(islot) .eq. f) return
      enddo

      do islot = pathtope, pathsize
	if (path(islot) .eq. " ") break
        if (path(islot) .eq. f  ) break
      enddo

      if (islot > pathsize) then
         pathsize = min(islot,MAXPATH)
         islot    = pathsize
      endif

      do j = islot-1, pathtope, -1
	path(j+1) = path(j)
      enddo

      path(pathtope) = f

      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

      subroutine pathrm(f)
      character*(*) f

Use(Path)

      integer islot, j

      do islot = 1, pathsize
         if (path(islot) .eq. f) then
            do j = islot+1, pathsize
               path(j-1) = path(j)
            enddo
            pathsize = pathsize-1
         endif
      enddo

      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c BASFILEX - given a name f, returns cf with $ and leading ~ expanded

        subroutine basfilex(f,cf)
        character*(*) f, cf

        character*(MAXSTRING) tf, rf

        call basdol(f,tf)
        call bastilde(tf,rf)

        cf = rf

        return
        end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c BASTILDE - replace leading ~ component

        subroutine bastilde(f,cf)
        character*(*) f,cf

        character*(MAXSTRING) tf
        integer ntf, n, j0, utgetcl
        external utgetcl

        if (f(1:1) .eq.  "~") then  # leading tilde
           n = utgetcl(f)
           do j0 = 2, n
              if (f(j0:j0) .eq. "/") break
           enddo

           tf = " "   
           call bastilde1(f(1:j0-1),tf)
           ntf = utgetcl(tf)
	   cf  = tf(1:ntf) // f(j0:n)

        else
           cf = f
        endif

        return
        end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

        subroutine pathref(tf, truepath)     
Use(Path)
        character*(*) tf, truepath
        character*(MAXSTRING) cf, f, df, msg
        integer n, ncf, i0, k, ndf
        integer utgetcl
        external utgetcl

        if (pathbug > 0) then
           msg = "Trying: "//tf
           call remark(msg)
        endif

        if (tf .eq. " ") go to 100

# expand any environment variables and tildes
        call basfilex(tf,f) 
        if (pathbug > 1) then
	   msg = "pathref after $, ~ replacement: "//f
           call remark(msg)
        endif

        if (f .eq. " ") go to 100

# Resolve front, leave i0 pointing to first char in f to consider
        cf  = " "   
        ncf = 0
        n   = utgetcl(f)
        i0  = 1

# Keep k = the number of / in cf so far (not counting the current one, if any)
# (because the first thing we do below is stick it on and count it)
        k = 0
        if (f(i0:i0) <> "/") then  #relative path
           call baswd(cf)
           ncf = utgetcl(cf)
           do j = 1, ncf
             if (cf(j:j)="/") k = k + 1
           enddo
        else
           i0=i0+1
        endif

        if (pathbug > 2 & ncf > 0) then
           msg="pathref after lead expansion: " // cf(1:ncf) // "/" // f(i0:n)
           call remark(msg)

        elseif (pathbug > 2) then
           msg="pathref after lead expansion: " // "/" // f(i0:n)
        endif

# Handle . and .. knowing they are not the leading component.
        for (, i0 <= n, i0 = j0+1; k = k+1)
           call utcat(cf,ncf,cf,ncf,"/",1," ",0)
           k = k + 1
           do j0 = i0+1, n
              if(f(j0:j0) .eq. "/") break
           enddo

      	   df = f(i0:j0-1)
	   if (df .eq. ".") then
                ncf = ncf - 1
                k = k - 1
                next

	   elseif (df .eq. "..") then
                do ncf=ncf-1,2,-1
                   if(cf(ncf:ncf) .eq. '/') break
                enddo
                k = k - 2
                ncf = ncf - 1
                next

           else
              ndf = utgetcl(df)
              call utcat(cf,ncf,cf,ncf,df,ndf," ",0)
           endif
	endfor

        if (ncf <= 0) go to 100

 90     continue
        if (ncf <= len(truepath) ) then
           truepath = cf(1:ncf)
        else
           call remark("pathref: warning, pathname got too long.")
           call remark(cf(1:ncf))
           go to 100
        endif

        if (pathbug > 1) then
           msg="pathref out: "//cf
           call remark(msg)
        endif

        return

 100    continue
# expansion was not proving helpful
        if (pathbug > 1) then
           call remark("pathref: pathology, will return blank name")
        endif

        cf  = " "
        ncf = 1
        go to 90

        end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

      subroutine basdol(tf,f)
      character*(*) tf,f

Use(Path)

      character*(MAXSTRING) g, df, temp
      integer c,cn
      character cnext  
      integer utgetcl, n, j, ic, k, ndf, nt
      external utgetcl

      g = tf
      n = utgetcl(g)
      k = 0
      f = " "
      ic = 1
      while (ic < n)
         c = ichar(g(ic:ic))
         if (c = 92) then   #backslash
               k = k+1
               f(k:k) = g(ic:ic)
               ic = ic + 2

         elseif ( c .eq. 36) then #dollar
            do j=ic+1, n
               cnext = g(j:j)
               cn = ichar(cnext)
               if(.not.( (cn >= 48 & cn <= 57) | cn .eq. 95 | 
                   (cn >= 65 & cn <= 90) |
                   (cn >= 97 & cn <= 122)) ) break
            enddo

            if ( j > ic + 1) then
               df = " "
               if (pathbug .eq. YES) then
                  call remark("Looking up:")
                  call remark(g(ic:j-1))
               endif
               call getenv(g(ic+1:j-1),df)
               if (pathbug .eq. YES) then
                  call remark("Result:")
                  call remark(df)
               endif
               if (df .eq. " ") then
                  ndf = 0
               elseif ( df .eq. g(ic+1:j-1)) then
                  call remark(
                  "Error: infinite recursion in environment variable")
                  call remark(df)
                  call kaboom(0)
               else
                  ndf = utgetcl(df)
               endif
               if (j <= n) then 
                  temp = g(j:n)
                  nt = n + 1 - j
               else
                  temp = " "
                  nt = 0
               endif
               n=ic
               call utcat(g,n,f,k,df,ndf,temp,nt)
               if(pathbug .eq. YES) then
                  call remark("Replacement done, now have:")
                  call remark(g(1:n))
               endif
               ic = k+1
            else
               k = k + 1
               f(k:k)=g(ic:ic)
               ic = ic + 1
            endif
         else
            k = k + 1
            f(k:k)=g(ic:ic)
            ic = ic + 1
         endif
      endwhile

      if ( ic .eq. n) then
         k = k + 1
         f(k:k)=g(n:n)
      endif

      if (pathbug > 2) then
         call remark("After dollar expansion:")
         call remark(f(1:k))
      endif

      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c OSFIND - find the file name, placing a name by which it can be
c        - opened into pathname
c        - the argument 'spec' was not being used. I have added it to
c        - the arguments for bastest, so that if a user calls osfind
c        - with a spec of "d",
c        - then bastest will call a routine which will return the
c        - path to a directory
c        - as well as to a regular file.

        logical function osfind(name,pathname,spec)
        character*(*) name, pathname, spec

Use(Path)

        character*(MAXSTRING) xname
	logical here, bastest
        integer i, utgetcl, ns
	external bastest, utgetcl

        if (name .eq. " ") return(FALSE)

        if (name(1:1) .eq. "." | name(1:1) .eq. "~" | \
            name(1:1) .eq. "/" | name(1:1) .eq. "$") then
           call pathref(name,pathname)
           here = bastest(pathname,spec)

           if (here) return(here)

c ... if the file name was absolute or relative to the current dir, stop now
           if (name(1:1)="/") return(FALSE) 
           if (name(1:1)="~") return(FALSE)

           ns = index(name,"/")

           if (ns = 0) ns=utgetcl(name)+1
           if (name(1:ns-1) .eq. ".") return(FALSE)
           if (name(1:ns-1) .eq. "..") return(FALSE)
        endif

c ... search each member of the path
	do i = 1, pathsize
           if (path(i) .eq. ' ') next
           xname = path(i)(1:utgetcl(path(i)))//'/'//name
           call pathref(xname,pathname)
           here = bastest(pathname,spec)
           if (here) break
	enddo

        return(here)
        end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c MORE - print out the contents of file f
c      -   name = name of file

      subroutine more(name)
      character*(*) name

      external osfind, utgetcl
      logical osfind
      integer utgetcl
      character*(MAXSTRING) fname
      character*256 temp
      integer itemp
 
      if (~osfind(name,fname,"r")) then 
         temp = 'Cannot find file "' // name // '"'
         itemp = utgetcl(temp)
         call remark(temp(1:itemp))
         call kaboom(0)
      endif	
 
      call utfpage(fname)

      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c BASTEST - test for file/directory existence
c         - ask for a path to s directory by using spec .eq. "d".

        logical function bastest(f,spec)
        character*(*) f, spec

Use(Path)

        logical result
        character*(MAXSTRING) msg
        integer basisrd, basisrdd
        external basisrd, basisrdd

c ... go to c since fortran inquire messes up links, directories on some systems
        integer iexist

        if (f .eq. " ") then
           iexist = 0
        elseif (spec (1:1) .eq. "d") then
           iexist = basisrdd(f)
        else
           iexist = basisrd(f)
        endif

        result = (iexist .eq. 1)

        if (pathbug > 2) then
           if (result) then
             msg="Found: "//f
           else
             msg="Not Found: "//f
           endif
           call remark(msg)
        endif

        return(result)
        end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c BASWD - get the current directory

        subroutine baswd(f)
        character*(*) f
        character*(MAXSTRING) g
        common /baswdc/ g
        integer utgetcl, n, i, ic, m, is, istart
        external utgetcl

Use(Path)

c ... go to C routine to get current directory
        g = " "
        call bascwd(g)

c ... now strip off any automount prefix
        istart = 1
        m      = utgetcl(g)
        if (basmntp <> " " & basmntn > 0) then
           n = utgetcl(basmntp)
           if (n < m) then
              if (g(1:n)=basmntp) then
                 if (pathbug > 2) then
                    call remark("bascwd attempting to strip automount prefix")
                 endif

                 if (g(n+1:n+1)="/") then
                    is = n + 1
                    do ic = 2, basmntn
                       do i=is+1, m
                          if (g(i:i) .eq. "/") break
                       enddo

                       if (i>m) then
                          call remark(
                       "bascwd: disabling automounter correction.")
                          call remark("Bad value of basmntp, basmntn suspected.")
                          call remark("Resetting basmntn to 0")
                          basmntn = 0
                          is = 1
                          break
                       else
                          is = i
                       endif
                    enddo
                    istart = is
                 endif
              endif
           endif
        endif

        f = g(istart:m)

        return
        end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c PATHGET - functional interface to pathref

        function pathget(f)
        character*(500) pathget
        character*(*) f

        character*(500) g
        call pathref(f,g)

        return(g)
        end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

