c
c QUIT.M - gather all the quit/exit/done type routines together
c

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c BASEXIT - do global memory leak check and call BASFIN

      subroutine basexit(istatus)

Use(Controls)

      call parclrft

      call glmmchk

      call basfin(istatus, coredump)

      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c BASISEND - user-replaceable routines

      subroutine basisend(iflag)
      integer iflag

      call basexit(iflag)

      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c GLBDONE - sort of in the middle of exiting a BASIS session

      subroutine glbdone

Use(Controls)
Use(IO)

      real cpu,io,sys,mem
      Filename fname

      call baspecho(0)

      call rtfin(0)

      if (verbose == YES) then
         call ostime(cpu,io,sys,mem)
         call glbwrtim(STDOUT,cpu,io,sys,mem)
      endif

      do i = 1, iotabtn
         call smovatof(fname, 0, iotabt, (i-1)*len(fname), len(fname))
         open(1,file=fname,err=100)
         close(1,status='delete')
 100     continue
      enddo

      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c ALLDONE - stop the code
c         - icode is termination status

      subroutine alldone(icode)
      integer icode

Use(Controls)

      character*(OUTLINE) msg

c ... no recovery from this point on.
      call errortrp("off")

      if (icode == ERR) then
         call utsprint(1, 1, OUTLINE, msg,
     &                 41, "alldone: *** FATAL ERROR HAS OCCURRED ***")

         call remark(" ")
         call remark(" ")
         call remark(msg)
      endif

      if (verbose == YES) call osoutfls

      call glbdone
      call basisend(icode)

      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c QUIT - nicest way out of basis from command level

      subroutine quit(iflag)
      integer iflag

      integer jflag
      if (iflag == DEFAULT) then
         jflag = 0
      else
         jflag = iflag
      endif

      call alldone(jflag)
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------
