#Basis Code Development System
# Copyright 1986 The Regents of the University of California
#-------------------------------------------------------------------------------
# FILE raux.m: Consists of those database routines which do not
# explicitly access the database. They either indirectly access
# it via access functions, or they are used by the database routines
# to do dog work.
#       Extracted from the old rtd.m. (ZCM 8/20/97)
#----------------------------------------------------------------------

#----------------------------------------------------------------------
# ZCM 01/03/2000: The following two functions return the address
# associated with a name (if there is one) or the name associated with an
# address (if there is one), otherwise kaboom.
#----------------------------------------------------------------------
       Address function basloc (name)
       Varname name
       integer npack,  jvar, ndb, tc
       integer parfind, utgetcl
       Address rtgaddr
       external parfind, rtgaddr, utgetcl
       npack = 0
       if (parfind (npack, name, jvar, ndb, tc, -1) == ERR) then
          call remark ("basloc: unknown variable "//name(1:utgetcl(name))//".")
          call kaboom (0)
       endif
       return (rtgaddr (jvar, ndb))
       end

       Varname function basname (loca)
       Address loca
       Varname myname
       call cbasname (loca, myname)
       return (myname)
       end

#-------------------------------------------------------------------------------
         function exists(name)
         Use(Hash)
 # return TRUE/FALSE depending on whether or not a name exists
         character *(*) name
         logical exists
         external cexists, ismac
         integer cexists, ismac

 # (ZCM 4/4/2000) Is this a macro? If so, it "exists".
         if (ismac (name) ~= 0) then
                return (TRUE)
         endif
# Does it exist in the database as a variable?
         if (cexists (name) ~= 0) then
          return (TRUE)
         else
          return (FALSE)
         endif
         end

         function setlast (name, irec)
         integer setlast, irec, csetlast
         external csetlast
         Varname name
         return (csetlast (name, irec))
         end

         subroutine protect
         call cprotect
         return
         end

         integer function setlimit (name, limits)
         character * (*) name, limits
         integer csetlimit
         external csetlimit
         return (csetlimit (name, limits))
         end

         integer function setact (name, actstr)
         character * (*) name, actstr
         integer csetact
         external csetact
         return (csetact (name, actstr))
         end

         subroutine comment (name, comm)
         character * (*) name, comm
         external ccomment
         call ccomment (name, comm)
         return
         end

#----------------------------------------------------------------------
      function rtadddim(name)
#adds a dimension of length one to the variable
#This wraps the C function, but can't be put entirely in C
#because it is called from FORTRAN.
      integer rtadddim
      character*(*) name
      integer crtaddim
      external crtaddim
      return (crtaddim (name))
      end

################################################################################
#                   NONDATABASE ROUTINES                                       #
################################################################################
# These routines isolate rtd's access to groups other than Domestic, Database, #
# Servopts, and Comments. Thus if database manipulations are redone in C or    #
# C++, they can be put into a new file and only these routines left in rtd.m.  #
#                        Zane C. Motteler--July, 1991                          #
################################################################################
        integer function rthide()
#
Use(Controls)
        return(bashide)
        end
 
        integer function rtpad()
#
Use(Controls)
        return(padding)
        end
 
        integer function rtbell()
#
Use(Controls)
    return(bell)
    end
 
        integer function rtverb()
#
Use(Controls)
    return(verbose)
    end
 
    integer function rtdebug ()
#
Use(Controls)
    return(debug)
    end
 
        integer function rtauto()
#
Use(Controls)
        return(autodyn)
        end
 
        integer function rtautop()
#
Use(Controls)
    return(autodynp)
    end
 
        Varname function rtautoa()
#
Use(Controls)
    return(autodyna)
    end
 
        Varname function rtfunpn(i)
        integer i
        Varname vname
        call gfunparn (i, vname)
        return(vname)
        end
 
        subroutine rtufnam(fname)
        Address fname
Use(Functions)
        fname = ufcnname
        return
        end
 
        integer function rtfunpt(i)
        integer i, gfunpart
        external gfunpart
        return(gfunpart (i))
        end
 
#-------------------------------------------------------------------------------
        subroutine rtaedit(ndb,jvar,name,tc,fwa,ndim,ilow,ihi,icol,attr,iout,
                           moreargs,istage)
# moved here to isolate non-database routines (ZCM, 7/91)
        integer ndb,jvar, tc,ndim,ilow(7),ihi(7),icol(7),iout,moreargs,istage
        Address fwa
        character*(*) name, attr
        integer incrs(7)
        integer i, command
        command = 0
10      continue
        if(istage==1) then
           if(command == 0) then
                do i=1,7
                        incrs(i) = 1
                enddo
                call prtvar(name,jvar,ndb,tc,incrs,iout)
           elseif(command ==1) then
                if (ndb=0) then     # macro
                   write(iout,100) name
100                format(a)
                elseif (tc==FUNCTION_TYPE) then
                   call edtlstf(name,jvar,ndb,iout)
                else
                   call edtlstv(name,jvar,ndb,tc,iout)
                endif
           endif
        endif
        return
        entry rtalist(ndb,jvar,name,tc,fwa,ndim,ilow,ihi,icol,attr,iout,
                           moreargs,istage)
        command = 1
        go to 10
        end
#------------------------------------------------------------------------
        subroutine sorti (sortary, sortidx, len)
clll.   implicit none
        integer len
        integer sortary(len), sortidx(len)
        integer i, j, tmp
        logical swapflg
           swapflg = TRUE
           do i=1,len
              sortidx(i) = i
           enddo
           do i = len, 1, -1
              if (~swapflg) break

              swapflg = FALSE
              do j=2,i
                 if (sortary(j-1) > sortary(j)) then
                    tmp = sortary(j-1)
                    sortary(j-1) = sortary(j)
                    sortary(j) = tmp

                    tmp = sortidx(j-1)
                    sortidx(j-1) = sortidx(j)
                    sortidx(j) = tmp
                    swapflg = TRUE
                 endif
              enddo
           enddo

        return
        end

#----------------------------------------------------------setshape
      function setshape(name,limits)
c*s
c     NAME OF ROUTINE...SETSHAPE
c
c     PURPOSE: To reset shape of array, permanently
c
c     (10/5/1999 ZCM) This is now a FORTRAN shell for a routine that
c     lives in C. where all database access now takes place.

      integer setshape, csetshap
      character*(*) name,limits

      return (csetshap (name, limits))
      end

#----------------------------------------------------------setmnarg
      function setmnarg(name,imin)
c*s
c     NAME OF ROUTINE...SETMNARG
c
c     PURPOSE: To reset minimum number of permitted arguments
c
c     (10/5/1999 ZCM) This is now a FORTRAN shell for a routine that
c     lives in C. where all database access now takes place.

      integer setmnarg, csetmnar
      character*(*) name
      integer imin

      return (csetmnar (name, imin))
      end

	logical function rtxcom(jvar, ndb, icom, comment)
### extract the icom'th comment for variable jvar
### from the comment file
#	Revised by Zane C. Motteler
#	Date       August 20, 1990
#	Revised by Zane C. Motteler
#       Date       September 1, 1993
#       user function a special case--no comment attached
#       Revised by Zane C. Motteler
#       Date       December 13, 1993
#       the above is false. You can attach comments bu calling 'comment'.
#       Revised by Zane C. Motteler
#       Date       October 24, 1996
#       change to allow names of arbitrary length (used to be a8)
#       Date       September, 1999
#       remove references to Domestic and replace them with access
#       functions to database routines now written in C.
	integer jvar, ndb, icom, icount, k, islot, strgfind
	character*(*) comment
	Varname v
	character*OUTLINE c
	logical found
        logical osfind
	integer basopen, utgetcl, lcom
	external osfind, basopen, rtsetdoc, strgfind, utgetcl
        integer rtgnname, rtgdcomm, rtgdcomn, rtxcomd
        external rtgnname, rtgdcomm, rtgdcomn, rtxcomd
	Filename f, rtgetdoc
	external rtgetdoc
        integer n
	if( jvar > 0) then
		k = rtgdcomm(jvar, ndb)
		if(k==0) then
		   if(rtgetdoc(ndb)<>" ") then
		      if(osfind(rtgetdoc(ndb),f,"r")) then
			call rtsetdoc(ndb, f)
		      else
			return(FALSE)
		      endif
                      iunit = basopen(rtgetdoc(ndb),"r")
		      found=FALSE
		      do
                         do
			    read(iunit,100,end=200,err=200) c
100   format(a)
                            if (c(1:1) ~= " ") break
                         enddo
                         n = index (c, " ")
                         if (n == 0) then
                            v = c
                            c = " "
                         else
                            v = c(1:n-1)
                            c = c(n+1:)
                         endif
			 islot = strgfind(v) # put v in table, or find it
			 # now name compares are integer compares
			 if(found) then
			 	if(rtgnname(jvar,ndb)==islot) then
		    		call rtcomev(jvar,ndb,c)
				else
					break
				endif
			 else
				if(rtgnname(jvar,ndb)==islot) then
					found=TRUE
				endif
			 endif
		      enddo
200                   continue
		      call basclose(iunit)
		      k = rtgdcomm(jvar,ndb)
		      if(k==0) then
				call rtcomev(jvar,ndb,"(no comment available)")
				k = rtgdcomm(jvar,ndb)
		      endif
		    endif
		endif
		icount = 0
		while( k  <> 0)
			icount = icount + 1
			if(icount = icom) then
                                lcom = min (COMMENTSIZE, len (comment))
                                comment = " "
                                if (rtxcomd (jvar, ndb, icom, comment)==ERR)return(FALSE)
				return(TRUE)
			endif
			k = rtgdcomn(k)
		endwhile
		return(FALSE)
	else
### foreign !
		call glbxcom(ndb, -jvar, icom, comment)
	endif
	if(comment <> " ")then
		return(TRUE)
	endif
        return(FALSE)
	end

#----------------------------------------------------------------------
        subroutine rtprtsf ( jout , debug )
#   Prints information about local Groups if debug is on and we're
#   sending output elsewhere than STDOUT.
    integer jout , debug
        Varname group
        integer ierr, edit, utgetcl, rtgngrp
        external edit, rtgngrp, rtggname, utgetcl
        if ( debug == YES ) then
                do i = rtgngrp (LOCALDB), 1, -1
                        call rtggname (i, LOCALDB, group)
                        if(jout <> STDOUT) ierr = edit(jout, group(1:utgetcl(group)))
                        call rtpoploc
                enddo
        endif
        return
        end

