# Basis Code Development System
# Copyright 1986 The Regents of the University of California
# rmem.m: Contains all of the memory allocation, initialization,
# and deallocation routines from the old rtd.m. (ZCM 8/20/97)
#-------------------------------------------------------------------------------
      function allot(name, inew)
c*s
c     NAME OF ROUTINE...ALLOT
c
c     PURPOSE: To allot memory.
c
c     AUTHOR...Peter Willmann  5/30/86
c			Paul Dubois 8/11/86 added treatment of inew=0
c               Paul Dubois 8/23/89 added padding
c
# makes final dimension of name = inew, reevaluates dimsto
# if inew = 0, uses final dimension from database
      integer allot, tc, allotj, rtfinder, rtnofrgn
      external allotj, rtfinder, rtnofrgn
      character*(*) name
      integer jvar, ndb, inew
c
      if( rtfinder( name, jvar, ndb, tc, "allot") = ERR) return(ERR)
# this service not available to foreigners
      if(tc == GROUP) then
	 call remark("allot: use gallot for groups")
	 call remark(name)
	 return(ERR)
      endif
      if( rtnofrgn("allot", jvar, ndb) = ERR) then
	 call remark(name)
	 return(ERR)
      endif
      return( allotj(jvar,ndb,inew))
      end

################################################################################

      integer function allotj(jvar,ndb,inew)
# Modified by ZCM 7/91 to extract Controls
## REVISION (ZCM) 08/19/97
##    remove references to Domestic and replace with access functions
      integer jvar, ndb, inew
      integer ihi(7),ilow(7),ndim
      integer pad
      character*(DIMSTRSIZE) dimsto
      Varname name
      integer rtpad, rtgndimst
      external rtpad, rtgvname, rtgndimst
#
      call fpullapt(ndb,rtgndimst(jvar,ndb),0,ilow,ihi,ndim,ierr)
      if(ierr = ERR) then
	    call rtgvname(jvar, ndb, name)
	    call remark("allot: trouble analyzing dimensions")
	    call remark(name)
            call strgget(rtgndimst(jvar,ndb),dimsto)
	    call remark(dimsto)
	    return(ERR)
      endif
      do j = 1, ndim
	      ihi(j) = ihi(j) - ilow(j) + 1
      enddo
# set new length if supplied
      pad = rtpad()
      if(inew > 0) then
	ihi(ndim) = inew
      elseif( inew < 0)
	pad = pad-inew
      endif
      call rtstgget(jvar, ndb, ndim, ihi, ilow, pad)
      return(OK)
      end
##############################################################################
      integer function rallotj(jvar,ndb,inew)
c
c     PURPOSE: To allot memory the same as last time.
c          If no last time, call allotj.
c
# note inew ignored if has been previously allocated.
## REVISION (ZCM) 08/19/97
##    remove references to Domestic and replace with access functions
      integer jvar, ndb, inew
      integer nitms, nwords
      Address ip, pip, avalue
      integer allotj, utsizeof, rtgdrely, rtgtc
      external allotj, utsizeof, rtgdrely, rtgdaddr, rtgtc, avalue
      Address rtgdaddr
#
      nitms = rtgdrely(jvar, ndb)
      if(nitms >= 0) then
	 pip = rtgdaddr(jvar, ndb)
         nwords = max(1,utsizeof(nitms, rtgtc(jvar, ndb)))
         ip = avalue (pip)
	 if(ip == NOTSET) then
	    call osallot1(pip,nwords,"RALLOTJ:ip ")
            call rtsdelms (jvar, ndb, nitms)
            call rtincref(jvar, ndb)
	 endif
         call rtstgini(jvar,ndb,nwords)
      else
         if( allotj(jvar,ndb,inew)==ERR) call kaboom(0)
      endif
      return(OK)
      end
#-------------------------------------------------------------------------------
      function change(name, inew)
c*s
c     NAME OF ROUTINE...CHANGE
c
c     PURPOSE: To change the amount of memory.
c
c     AUTHOR...Paul Dubois  Complete rewrite 10/26/29
c
# changes memory for a variable ; otherwise similar to allot
      integer change
      character*(*) name
      integer rtfinder, rtnofrgn, allotj, changej
      external rtfinder, rtnofrgn, allotj, changej
      integer jvar, ndb, tc
c
      if(rtfinder(name, jvar, ndb, tc, "change") == ERR) return(ERR)
      if(tc == GROUP) then
	 call remark("change: use gchange for groups")
	 call remark(name)
	 return(ERR)
      endif
# this service not available to foreigners
      if( rtnofrgn("change", jvar, ndb) = ERR) then
	 call remark(name)
	 return(ERR)
      endif
# 
      if(changej(jvar,ndb,inew)==ERR) then
	 call remark(name)
	 return(ERR)
      endif
      return(OK)
      end
#-------------------------------------------------------------------------------
      function changej(jvar,ndb, inew)
c*s
c     NAME OF ROUTINE...CHANGEJ
c
c     PURPOSE: To change the amount of memory.
c
c     AUTHOR...Paul Dubois  Broken off of change 9/24/90
c
# changes memory for a variable ; otherwise similar to allot
# if inew<=0, uses last dimension from database
# can cope with multiply dimensioned data, moving things correctly
# In a particular dimension, moves/stores the minimum of the old/new sizes.
# Fills any new space in a dimension; truncates if new size is smaller.
# If there are more new dimensions than old, stores at the start of 
# the new space
# If there are more old dimensions than new, uses only first part of old.
# Modified 7/91 by ZCM to extract reference to Controls
## REVISION (ZCM) 08/19/97
##    remove references to Domestic and replace with access functions
      integer changej
      Ch(DIMSTRSIZE) dimsto
      integer inew, jvar, ilow(7),ihi(7), icol(7),ndim, tc, ierr, ia (7)
      Address fwa, ib(7)
      Address dest, ofwa
      integer nold,olow(7),ohi(7),ocol(7),sold(SSWIDTH)
      integer tlow(7),thi(7),ti(7)
      integer rtfinder, rtnofrgn, allotj
      external rtfinder, rtnofrgn, rtxdb, allotj
      integer utgetcl, parstore, parmove
      Address paraddr
      external utgetcl, parstore, parmove, paraddr
      integer ndb, pad, idim
      logical rtisdyn
      integer rtpad, rtgdelms, rtgtc, rtgndimst
      external rtpad, rtisdyn, rtgdelms, rtgtc, rtgndimst
      data ia /7*0/, ib /7*0/
      call rtxdb(jvar,ndb,ofwa,nold,olow,ohi,ocol,INFO)
      if(ofwa == NOTSET ) then
	  return( allotj(jvar,ndb,inew))
      endif
      if(~rtisdyn(jvar,ndb)) then
	 call remark("change: variable not dynamic!")
	 return(ERR)
      endif
      if(rtgdelms(jvar, ndb) == -1) then
	 call remark("change: space allocated before but not by allot,")
	 call remark("change: so unable to determine length of data.")
	 return(ERR)
      endif
      tc = rtgtc(jvar, ndb)
      idim = rtgndimst(jvar, ndb)
      call fpullapt(ndb, idim, 0, ilow, ihi, ndim, ierr)
      if(ierr == ERR) then
	 return(ERR)
      endif
      do i=1, ndim
	 icol(i) = ihi(i) -ilow(i) + 1
      enddo
      if(ierr = ERR) then
	    call remark("change: trouble analyzing dimensions")
            call strgget(idim,dimsto)
	    call remark(dimsto)
	    return(ERR)
      endif
      pad = rtpad()
      if(inew > 0) then
	icol(ndim) = inew
      elseif( inew < 0)
	pad = pad-inew
      endif

#check for nothing to do
      if(ndim == nold) then
	 do i=1, ndim
	    if(icol(i) <> ocol(i)) go to 100
	    if(ilow(i) <> olow(i)) go to 100
	 enddo
	 return(OK)
      endif
100   continue
# Get current contents to temporary store
      sold(N)=nold
      sold(TC) = tc
      do i=1, min(nold,ndim)
	 sold(M1-1+i) = olow(i)
	 sold(N1-1+i) = min(ocol(i),icol(i))
	 sold(I1-1+i) = 1
	 tlow(i) = olow(i)
	 thi(i) = olow(i)+min(ocol(i),icol(i))-1
	 ti(i) = 1
      enddo
      do i= min(nold,ndim) + 1, max (nold, ndim)
	 sold(M1-1+i) = olow(i)
	 sold(N1-1+i) = olow(i)
	 sold(I1-1+i) = 1
	 tlow(i) = olow(i)
	 thi(i) = olow(i)
	 ti(i) = 1
      enddo
      if(tc < 0) sold(NAML) = 1 # ZCM 5/9/95 force string into literal table
      call parget(sold)
      dest = paraddr(sold)
      if( parmove(dest,ofwa,tc,nold,olow,ohi,ocol,
	         tlow,thi,ti,ib,ia)==ERR) return(ERR)
# Get new storage for new size, then locate it
      call rtstgget(jvar, ndb, ndim, icol, ilow, pad)
      call rtxdb(jvar,ndb,fwa,ndim,ilow,ihi,icol,FULL)
      do i=1, min(nold,ndim)
	 tlow(i) = ilow(i)
	 thi(i) = ilow(i) + sold(N1-1+i) -1
      enddo
      do i= min(nold,ndim)+1, ndim
	 tlow(i) = ilow(i)
	 thi(i) = ilow(i) 
      enddo
# Do the store
      if(parstore(fwa,tc,ndim,ilow,ihi,icol,tlow,thi,ti,sold,ib,ia)==ERR) then
	 return(ERR)
      endif
      call parrel(sold)
      return(OK)
      end
#-------------------------------------------------------------------------------
      function basfree(name)
c*s
c     PURPOSE: To basfree memory.
c
c     AUTHOR...Peter Willmann  5/30/86
c
      integer basfree
      character*(*) name
      external rtfinder, rtnofrgn
      integer rtfinder, rtnofrgn
      integer tc, jvar
      integer ndb
c
      if(rtfinder(name, jvar, ndb, tc, "basfree") == ERR) return(ERR)
# this service not available to foreigners
      if(tc == GROUP) then
	 call remark("basfree: use gfree for groups:")
         call remark(name)
	 return(ERR)
      endif
      if( rtnofrgn("basfree", jvar, ndb) = ERR) then
	 call remark(name)
	 return(ERR)
      endif
# 
      call rtstgdel(jvar, ndb)
      return(OK)
      end
#-------------------------------------------------------------------------------
      function gallot(name, n)
c*s
c     NAME OF ROUTINE...GALLOT
c
c     PURPOSE: To allot all dynamic variables in a group.
c
c     NAME OF AUTHOR...Peter Willmann  4/27/86
c     Revision (SMH) 11/89    -- Removed concept of . and .. for LOCAL & USER
c 
## REVISION (ZCM) 08/19/97
##    remove references to Domestic and replace with access functions
      character*(*) name
      integer gallot, n, ierr, type
      integer igrp, jvar, jgrp, ndb, lenvname
      integer rtfinder, allot, utgetcl
      external rtfinder, allot, utgetcl, glbpknam, rtgvname
      character*(PNSIZE+1) pname
##      character*40 vname, tmpname
      Varname vname
      character*(PNSIZE+1+VARNAMESIZE) tmpname
      integer npname
      integer rtgnvar1
      logical rtisdyn
      external rtgnvar1, rtisdyn
      integer igvm1, igvm2
c   Get group number.
      if( rtfinder(name, jgrp, ndb, type, "gallot") .eq. ERR) return(ERR)
# name must be the name of a group
	if(type <> GROUP) then
		call remark("gallot: Not a group name.")
		call remark(name)
		return(ERR)
	endif
c 
      ierr = OK
c   Get package name
      call glbpknam(ndb, pname)
      npname = utgetcl(pname) + 1
      pname(npname:) = "."
c   Cycle on variables in the group.
      igrp = iabs(jgrp)
      igvm1 = rtgnvar1 (igrp, ndb)
      igvm2 = rtgnvar1 (igrp + 1, ndb) -1
      call rtmemchk (ndb, igvm1, igvm2, 0)
      do jvar=igvm1, igvm2
c   If the variable is dynamic, allot it.
c   Note that functions have ddynflg false
	if(rtisdyn(jvar, ndb)) then
          call rtgvname (jvar, ndb, vname)
 	  tmpname = pname(1:npname)//vname(1:utgetcl(vname)) # avoid character overruns
          lenvname = utgetcl(tmpname)
          if(lenvname <= VARNAMESIZE) then
            vname = tmpname(1:utgetcl(tmpname))
          else
            vname(1:VARNAMESIZE) = tmpname(1:VARNAMESIZE)
            call remark("rtgvname variable name truncated to: "//vname)
          endif
 	  ierr = allot(vname,n)
	endif
      enddo
c 
      return(ierr)
      end
#-------------------------------------------------------------------------------
      function gchange(name, n)
c*s
c     NAME OF ROUTINE...GCHANGE
c
c     PURPOSE: To change all dynamic variables in a group.
c
c     NAME OF AUTHOR...Peter Willmann  4/27/86
c     Revision (SMH) 11/89    -- Removed concept of . and .. for LOCAL & USER
c 
## REVISION (ZCM) 08/19/97
##    remove references to Domestic and replace with access functions
      character*(*) name
      integer igrp, jvar, jgrp, ndb
      integer gchange, n, ierr, type
      integer rtfinder, change, utgetcl
      external rtfinder, change, utgetcl, glbpknam, rtgvname
      character*(PNSIZE+1) pname
      character*(40) vname, tmpname
      integer npname
      integer rtgnvar1
      logical rtisdyn
      external rtgnvar1, rtisdyn
      integer igvm1, igvm2
c   Get group number.
      if( rtfinder(name, jgrp, ndb, type, "gchange") .eq. ERR) return(ERR)
	if(type <> GROUP) then
		call remark("gchange: Not a group name.")
		call remark(name)
		return(ERR)
	endif
c 
      ierr = OK
c   Get package name
      call glbpknam(ndb, pname)
      npname = utgetcl(pname) + 1
      pname(npname:) = "."
c   Cycle on variables in the group.
      igrp = iabs(jgrp)
      igvm1 = rtgnvar1 (igrp, ndb)
      igvm2 = rtgnvar1 (igrp + 1, ndb) - 1
      do jvar=igvm1, igvm2
c   If the variable is dynamic, change it.
	if(rtisdyn(jvar, ndb)) then
          call rtgvname (jvar, ndb, vname)
 	  tmpname = pname(1:npname)//vname(1:utgetcl(vname)) # avoid characteer overruns
          vname = tmpname(1:utgetcl(tmpname))
 	  ierr = change(vname,n)
	endif
      enddo
c 
      return(ierr)
      end
#-------------------------------------------------------------------------------
      function gfree(name)
c*s
c     NAME OF ROUTINE...GFREE
c
c     PURPOSE: To basfree all dynamic variables in a group.
c
c     NAME OF AUTHOR...Peter Willmann  4/27/86
c     Revision (SMH) 11/89    -- Removed concept of . and .. for LOCAL & USER
c 
## REVISION (ZCM) 08/19/97
##    remove references to Domestic and replace with access functions
      integer gfree
      character*(*) name
      integer igrp, jvar, jgrp, ndb, type
      integer rtfinder, basfree, utgetcl
      external rtfinder, basfree, utgetcl, glbpknam, rtgvname
      character*(PNSIZE+1) pname
      character*(40) vname
      logical rtisdyn
      integer npname, ierr
      integer rtgnvar1
      external rtgnvar1, rtisdyn, rtgpkgno
      integer rtgpkgno
      integer igvm1, igvm2
c   Get group number.
      if( rtfinder(name, jgrp, ndb, type, "gfree") .eq. ERR) return(ERR)
	if(type <> GROUP) then
		call remark("gchange: Not a group name:")
                call remark(name)
		return(ERR)
	endif
c 
      ierr = OK
c   Get package name
      call glbpknam(rtgpkgno(ndb), pname)
      npname = utgetcl(pname) + 1
      pname(npname:) = "."
c   Cycle on variables in the group.
      igrp = abs(jgrp)
      igvm1 = rtgnvar1 (igrp, ndb)
      igvm2 = rtgnvar1 (igrp + 1, ndb) -1
      do jvar=igvm1, igvm2
	if(rtisdyn(jvar, ndb)) then
c   If the variable is dynamic, free it.
          call rtgvname (jvar, ndb, vname)
	  vname = pname(1:npname)//vname
	  ierr = basfree(vname)
	endif
      enddo
c 
      return(ierr)
      end
#-----------------------------------------------------------------------
      subroutine fpullapt(ndb, istr, jvard, ilow, ihi, ndim, ierr)
      integer ndb, istr, jvard, ilow(7), ihi(7), ndim, ierr
      character*DIMSTRSIZE limstr
# call pullapt with appropriate string
      ierr = OK
      if( istr == 0) then
	 ndim = 0
	 return
      endif
      call strgget(istr,limstr)
      call pullapt(ndb, limstr, jvard, ilow, ihi, ndim, ierr)
      return
      end

#-------------------------------------------------------------------------------
      subroutine pullapt (dbnum, dimstro, jvar, ilow, ihi, ndim, ierr)
c*s
c     NAME OF ROUTINE...pullapt
c
c     AUTHOR OF ROUTINE...Peter A. Willmann  6/10/86
c			revised 6/18/86 PFD
c                       revised 12/01/88 SMH  (allow defaults and ranges)
c
c     PURPOSE...
c
c	 This routine takes a character string of the form
c	 "scalar" or
c	 "( ispec[,ispec,...])"
c	where ispec is an integer or the name of an integer scalar in
c	the database db, or two such separated by a colon.
c   returns ndim = 0 if string is "scalar"
c   otherwise returns the number of dimensions in ndim and their lower
c   and upper bounds, evaluated to the current value of any variables,
c  in ilow and ihi respectively.
c
c     GLOSSARY OF IMPORTANT VARIABLES...
c
c	 dimstro    = original dimensioning string from a database
c	 ndim	   = number of dimensions, 0 for scalar
c        jvar      = number of database entry describing defaults for
c                    subscripts.  0 values means defaults not allowed
c	 ilow	   = array of lower limits on dimensions
c	 ihi	  = array of upper limits on dimensions
c	 ierr	  = returns OK or ERR
c/c
## REVISION (ZCM) 08/19/97
##    remove references to Domestic and replace with access functions
      character*(*) dimstro
c
      integer dbnum, ndb,ndim,ilow(1),ihi(1), jvar
      integer subscript(6),i
      integer ierr, ldimstro, idx, idt, icolon, dlo, dhi, inxlo, inxhi
c rtdeval1 is a "miniparser" for parsing expressions
c source used to follow this routine but moved to macsrc to make rtdsrc smaller
      integer utgetcl
      external rtdeval1, utgetcl
      logical defflg
      integer rtglow, rtghigh, rtgndim
      external rtglow, rtghigh, rtgndim

        ndb = dbnum
	ierr = OK
c
c	 if string is "scalar", set ndim = 0 and return
      if(dimstro .eq. "scalar") then
	 ndim = 0
	 return
      endif
c
c	 first determine length of the character string, dimstro, and setup to
c	 loop over characters collecting character sets to be converted
c	 from ascii to binary integer
c
	ldimstro = utgetcl(dimstro)
	if (ldimstro < 2) then
	   ierr = ERR
	   return
	endif
c the first charactar in dimstro is (.
	ndim = 0
	defflg = FALSE
	inxlo = 0
	inxhi = 0                       # used if no default values
	if (jvar > 0) then
  	   defflg = TRUE
	   if (dimstro(2:ldimstro-1) == " ") then
	      ndim = rtgndim(jvar, ndb)
	      do i=1,ndim
	         ilow(i) = rtglow (jvar, ndb, i)
		 ihi(i) = rtghigh (jvar, ndb, i)
	      enddo
	      return
	   endif
	endif
# in this loop, idx is start of token, idt the last char of token
	for(idx=2 , idx <= ldimstro, idx = idt + 2)   #the +2 skips the comma
		ndim = ndim + 1
                call utskipbl(dimstro,idx)
                if(idx >= ldimstro) break
		idt = idx - 1 + index(dimstro(idx:ldimstro),",")
		if(idt = idx - 1 ) then
			idt = ldimstro-1
		else
			idt = idt - 1
		endif
		icolon = idt+1
		subscript(5) = 1     # default increment
		subscript(6) = 1     # default increment
		i = 0
		if (defflg) then
 	  	   inxlo = rtglow (jvar, ndb, ndim)
		   inxhi = rtghigh (jvar, ndb, ndim)
		endif
		do
			i = i + 1
			if (i > 3) then
			       ierr = ERR
		   	       call remark("pullapt: too many fields in range")
			       return
			endif

			if (idx<=idt) icolon = idx-1+index(dimstro(idx:idt),":")
			if (icolon == idx -1) icolon = idt+1

##  -- Set up defaults for the correct field of a range.

			if (i == 1) then
				dlo = inxlo
				dhi = inxhi     ## not range, i.e. no ":"
				if (icolon <=idt) dhi = inxlo  # 1st range field
			elseif (i == 2) then
			        dlo = inxhi                    # 2nd range field
				dhi = inxhi
			elseif (i == 3) then
				dlo = 1                        # 3rd range field
				dhi = 1
			endif
			call rtdeval1(dimstro,idx,icolon-1,ndb,dlo,
		                 dhi,defflg,ierr,subscript(2*(i-1)+1))
			if (ierr = ERR) return

			idx = icolon + 1
		until (icolon > idt)


		if (i = 1) then  ### subscript, not range fields
			ilow(ndim) = 1
			if (defflg) ilow(ndim) = inxlo
			ihi(ndim) = subscript(2)
			if(subscript(1)<>subscript(2)) ilow(ndim) = subscript(1)
		elseif (subscript(1)<>subscript(2) |
			           subscript(3)<>subscript(4)) then
			ierr = ERR
 	    call remark("pullapt: range variable can't be component of a range")
	 		return
		elseif (subscript(5)<>1 | subscript(6)<>1) then
			ierr=ERR
		        call remark("pullapt: increment field not allowed")
			return
                else
 			ilow(ndim) = subscript(1)
			ihi(ndim) = subscript(3)
		endif



	endfor
      return
      end
#-------------------------------------------------------------------------------
      subroutine pullapt2 (dbnum, dimstro, jvar, ilow, ihi, ndim, ierr)
c*s
c     NAME OF ROUTINE...pullapt2
c     different from  pullapt in that a non-ranged subscript does not
c     imply it is ranged from 1 (or starting-subscript)to the given subscript
c
c     AUTHOR OF ROUTINE...Peter A. Willmann  6/10/86
c			revised 6/18/86 PFD
c                       revised 12/01/88 SMH  (allow defaults and ranges)
c                       revised 07/24/89 SMH (new routine)
c
c     PURPOSE...
c
c	 This routine takes a character string of the form
c	 "scalar" or
c	 "( ispec[,ispec,...])"
c	where ispec is an integer or the name of an integer scalar in
c	the database db, or two such separated by a colon.
c   returns ndim = 0 if string is "scalar"
c   otherwise returns the number of dimensions in ndim and their lower
c   and upper bounds, evaluated to the current value of any variables,
c  in ilow and ihi respectively.
c
c     GLOSSARY OF IMPORTANT VARIABLES...
c
c	 dimstro    = original dimensioning string from a database
c	 ndim	   = number of dimensions, 0 for scalar
c        jvar      = number of database entry describing defaults for
c                    subscripts.  0 values means defaults not allowed
c	 ilow	   = array of lower limits on dimensions
c	 ihi	  = array of upper limits on dimensions
c	 ierr	  = returns OK or ERR
c/c
## REVISION (ZCM) 08/19/97
##    remove references to Domestic and replace with access functions
      character*(*) dimstro
c
      integer dbnum, ndb,ndim,ilow(1),ihi(1), jvar
      integer subscript(6),i
      integer ierr, ldimstro, idx, idt, icolon, dlo, dhi, inxlo, inxhi
c rtdeval1 is a "miniparser" for parsing expressions
c source used to follow this routine but moved to macsrc to make rtdsrc smaller
      integer utgetcl
      external rtdeval1, utgetcl
      logical defflg
      integer rtglow, rtghigh, rtgndim
      external rtglow, rtghigh, rtgndim
        ndb = dbnum
	ierr = OK
c
c	 if string is "scalar", set ndim = 0 and return
      if(dimstro .eq. "scalar") then
	 ndim = 0
	 return
      endif
c
c	 first determine length of the character string, dimstro, and setup to
c	 loop over characters collecting character sets to be converted
c	 from ascii to binary integer
c
	ldimstro = utgetcl(dimstro)
	if (ldimstro < 2) then
	   ierr = ERR
	   return
	endif
c the first charactar in dimstro is (.
	ndim = 0
	defflg = FALSE
	inxlo = 0
	inxhi = 0                       # used if no default values
	if (jvar > 0) then
 	   defflg = TRUE
	   # if "()" or "(   )" use entire array
	   if (ldimstro == 2 & dimstro(2:2) == ")") then
	      ndim = rtgndim(jvar,ndb)
	      do i=1,ndim
	         ilow(i) = rtglow(jvar, ndb, i)
		 ihi(i) = rtghigh(jvar, ndb, i)
	      enddo
	      return
	   endif
	   if (dimstro(2:ldimstro-1)=" " & dimstro(ldimstro:ldimstro)=")") then
	      ndim = rtgndim(jvar,ndb)
	      do i=1,ndim
	         ilow(i) = rtglow(jvar, ndb, i)
		 ihi(i) = rtghigh(jvar, ndb, i)
	      enddo
	      return
	   endif
	endif
# in this loop, idx is start of token, idt the last char of token
	for(idx=2 , idx <= ldimstro, idx = idt + 2)   #the +2 skips the comma
		ndim = ndim + 1
		idt = idx - 1 + index(dimstro(idx:ldimstro),",")
		if(idt = idx - 1 ) then
			idt = ldimstro-1
		else
			idt = idt - 1
		endif
		icolon = idt+1
		subscript(5) = 1     # default increment
		subscript(6) = 1     # default increment
		i = 0
		if (defflg) then
 	  	   inxlo = rtglow(jvar, ndb, ndim)
		   inxhi = rtghigh(jvar, ndb, ndim)
		endif
		do
			i = i + 1
			if (i > 3) then
			       ierr = ERR
		   	       call remark("pullapt: too many fields in range")
			       return
			endif

			if (idx<=idt) icolon = idx-1+index(dimstro(idx:idt),":")
			if (icolon == idx -1) icolon = idt+1

##  -- Set up defaults for the correct field of a range.

			if (i == 1) then
				dlo = inxlo
				dhi = inxhi     ## not range, i.e. no ":"
				if (icolon <=idt) dhi = inxlo  # 1st range field
			elseif (i == 2) then
			        dlo = inxhi                    # 2nd range field
				dhi = inxhi
			elseif (i == 3) then
				dlo = 1                        # 3rd range field
				dhi = 1
			endif
			call rtdeval1(dimstro,idx,icolon-1,ndb,dlo,
		                 dhi,defflg,ierr,subscript(2*(i-1)+1))
			if (ierr = ERR) return

			idx = icolon + 1
		until (icolon > idt)


		if (i = 1) then  ### subscript, not range fields
			ilow(ndim) = subscript(1)
			ihi(ndim) = subscript(2)
		elseif (subscript(1)<>subscript(2) |
			           subscript(3)<>subscript(4)) then
			ierr = ERR
 	    call remark("pullapt: range variable can't be component of a range")
	 		return
		elseif (subscript(5)<>1 | subscript(6)<>1) then
			ierr=ERR
		        call remark("pullapt: increment field not allowed")
			return
                else
 			ilow(ndim) = subscript(1)
			ihi(ndim) = subscript(3)
		endif



	endfor
      return
      end
