/*
 * setenv.c
 *
 */

#include "rt.h"

/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/

int C_setenv(char *p1, char *p2)
{
    char *p;

#ifdef PCK_SCORE
    p = FMAKE_N(char, strlen(p1) + strlen(p2) + 2, "C_SETENV:p");
#else
    p = malloc(strlen(p1) + strlen(p2) + 2);
#endif

    if ((char *) 0 == p) {
        return (-1);
    }
    sprintf(p, "%s=%s", p1, p2);
    if (putenv(p)) {
        char errmsg[80];

        sprintf(errmsg, "Setenv failed: %s", p);
        BasError(errmsg, strlen(errmsg));
        return (-1);
    }
    return (0);
}

/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/

#ifdef TEST
/* Typical compile line: "cc -o setenv -D$CPU -DTEST thisfile.c"        */
/* Test usage: "./setenv foo bar"       */
main(int a, char *b[])
{
    int rval;
    int C_setenv();

    if (a < 3) {
        fprintf(stderr, "Usage: %s foo bar\n", *b);
        exit(1);
    } else {
        rval = C_setenv(b[1], b[2]);
    }
    printf("%s = %s\n\n", b[1], getenv(b[1]));
    (void) system("printenv");
    exit(rval);
}
#endif

/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
