# Basis Code Development System
# Copyright 1986 The Regents of the University of California
#-------------------------------------------------------------------------------
# Extracted from rtd.m 8/19/97 (ZCM) and purged of Domestic and Database
# references in favor of access functions.
# Contains all of the attribute server routines.
# 10/06/1999 All references to group Attributes have been removed;
# This group is now processed entirely by C code in attr.c. (ZCM)
#-------------------------------------------------------------------------------


#-------------------------------------------------------------------------------
	function rtattr(name,attr)
# Revision (SMH)  10/89  --
# does name have attribute attr?
# ZCM 10/06/1999 This is now just a wrapper for a C routine
# (Can't move entirely to C because called from command line)
 	character*(*) name, attr
	external crtattr
        integer crtattr
        logical rtattr

        if (crtattr (name, attr) ~= 0) then
         return (TRUE)
        else
         return (FALSE)
        endif
	end
#-------------------------------------------------------------------------------

#-------------------------------------------------------------------------------
        subroutine rtcattr (name, attr)
## Updated 10/30/89     Susan Hockett
#          Allow setting an attribute on a macro
# (ZCM 10/06/1999) Acts as a wrapper for C routine; can't put all into C
# since can be called from command line.
        character*(*) name, attr
        external crtcattr
        call crtcattr (name, attr)
        return
        end

#-------------------------------------------------------------------------------
      logical function rtattexp(jvar, ndb, warnflg)
      integer jvar, ndb
      logical warnflg

      integer pcount, idxcod, tok, gattcode
      external gattcode
      logical value, notflg, notstk(NOTDEPTH)
      integer rtnxatte
      logical rtdattr

      value = TRUE
      pcount = 0         # parenthesis count
      notflg = FALSE     # TRUE if ~ found.  Reset after applying to operand
                         #   or after encountering "(" at which point notflg
                         #   is saved on a stack
      idxcod = 1
      do
         tok = gattcode(idxcod)

## .. Process current token

         if (tok = LPARNATT) then
	    pcount = pcount +1
	    if (pcount > NOTDEPTH) then
	       call remark("rtattexp INTERNAL ERROR: STACK overflow.")
               return(value)
	    endif
	    notstk(pcount) = notflg     ## save whether or not a ~ preceded (
	    notflg = FALSE              ##    and then reset

         elseif (tok = RPARNATT) then
	    if (pcount < 1) then
	       call remark("rtattexp INTERNAL ERROR: STACK underflow")
	       return(value)
	    endif
	    if (notstk(pcount)) value = .not.value
	    pcount = pcount -1


	 elseif (tok = NOTATT)
	    notflg = .not.notflg

##.. F & expr = F, thus don't need to evaluate this expression.  Get next expr
##..   else T & expr = expr, so value will be reset upon evaluation of this expr

	 elseif (tok = ANDATT) then
	    if (.not.value ) then
	       idxcod = rtnxatte(value, idxcod, pcount)
	    endif

##.. T | expr = T, thus don't need to evaluate this expression.  Get next expr.
##..   else F | expr = expr, so value will be reset upon evaluation of this expr

         elseif (tok = ORATT) then
	    if (value ) then
	       idxcod = rtnxatte(value, idxcod, pcount)
	    endif

##.. If more than one consecutive index (>0) then there are several possible
##.. partial matches for the given attribute.  Seach until a TRUE match or
##.. until exhausted.  Then reposition IDXCOD to the last consecutive index.

         elseif (tok > 0)   # tok is attribute index
            value = FALSE
            do
              if (~value) value = rtdattr(jvar,ndb,gattcode(idxcod))
              idxcod = idxcod + 1
            until (gattcode(idxcod) <= 0)
            idxcod = idxcod - 1

	    if (notflg) value = .not.value
	    notflg = FALSE
	 endif
         idxcod = idxcod + 1
      until (tok = EOFATT)   ## EOF
      return (value)
      end

#-------------------------------------------------------------------------------

      integer function rtnxatte(value, idxcod, pcount)
      integer pcount, gattcode
      external gattcode
      logical value
      integer oldpcnt
## called in one of 2 cases.
#           T | expr
#           F & expr

      idx = idxcod
      if (value  & pcount = 0) then
         do
           idx = idx + 1
           if (gattcode(idx) = EOFATT) return(idx -1)
         enddo
      endif

      oldpcnt = pcount
      do
         idx = idx + 1
         if (gattcode(idx) = LPARNATT) then
	    pcount = pcount + 1
	 elseif (gattcode(idx) = RPARNATT) then
	    if (pcount < oldpcnt) then
	       call remark("rtnxtatte: extra ')' in attribute expression")
               do                  ## set idx to last non-EOF instruction
                  idx = idx +1
                  if (gattcode(idx) = EOFATT) return(idx-1)
               enddo
	    endif
	    if (pcount = oldpcnt) return(idx-1) 
	    pcount = pcount -1     ##end of expression. found closing )
         elseif (.not.value & gattcode(idx) = ORATT) then
                                          ## found end of "&" expression
  	                                  ##   & is higher precedence than |
	    if (pcount = oldpcnt) return(idx-1)
	 endif
      until(gattcode(idx) = EOFATT)

      if (pcount > 0) then
         call remark(
     x	      "rtnxatte ERROR: parenthesis mismatch in attribute string")
      endif

      return(idx-1)
      end

#-------------------------------------------------------------------------------

      integer function rtatttok(str, lo, hi, tok)
      character*(*) str, tok
      integer lo, hi
      character chr1, chri

      if (hi < lo) then
         tok = " "     ## EOF
	 return(hi+1)
      endif
      call utskipbl(str,lo)
      if (lo > hi) then
         tok = " "     ## EOF
	 return(hi+1)
      endif

      chr1 = str(lo:lo)
      if (chr1="(" | chr1=")" | chr1="~" | chr1="&" | chr1="|") then
         tok = chr1
	 return(lo+1)
      endif

      do i=lo+1,hi
         chri = str(i:i)
         if(chri=" " | chri="(" | chri=")" | chri="~" | chri="&" | chri="|")then
	    tok = str(lo:i-1)
	    return(i)
	 endif
      enddo
      tok = str(lo:hi)
      return(hi+1)
      end
#-------------------------------------------------------------------------------
      integer function rtprsatt(str)
      Use(Servopts)
      character*(*) str
      integer newlo, hi, nexttok, nattr, idxattr, pcount
      logical xactmtch
      Varname tok
      external iattcdln
      integer rtatttok, rtattrlu, utgetcl
#

      call iattcdln
      if (str = " ") then
         call rtinscod(EOFATT)
         return (OK)
      endif

      newlo = 1
      hi = utgetcl(str)
      pcount = 0         # parenthesis count
      nexttok = OPERND   # need operand, NOT operation, to start expression
                         #   is saved on a stack
      do
         newlo = rtatttok(str, newlo, hi, tok)

## .. Check if token found is the same type as that expected.

         if (tok=")" | tok="&" | tok="|" | tok=" ") then   ##tok is an operation
	    if (nexttok = OPERND) then
	       if (tok = " ") tok = "EOF"
	       call remark("rtprsatt ERROR: found '"//tok(1:3)//
     x	              "' when expecting an operand in the attribute expression")
               return(ERR)
	    endif
	 else                                              ##tok is an operand
            if (nexttok = OPERATN) then
	       call remark("rtprsatt ERROR: expecting an " //
     x	             "operation, but found operand '"//tok//"'")
               return(ERR)
	    endif
	 endif

## .. Process current token

         nexttok = OPERND       ## next token needs to be an operand (or "(")
	                        ## unless the current token is operand or (
         if (tok = "(") then
            call rtinscod(LPARNATT)
            pcount = pcount + 1
            if (pcount > NOTDEPTH) then
               call remark("rtprsatt ERROR:  Parenthesis nesting level is" //
     x                     " too deep")
               return(ERR)
            endif
         elseif (tok = ")") then
            if (pcount < 1) then
               call remark("rtrpsatt ERROR: Mismatched ()'s in attribute exp")
               return(ERR)
            endif
            call rtinscod(RPARNATT)
            nexttok = OPERATN
            pcount = pcount -1

	 elseif (tok = "~")
            call rtinscod(NOTATT)

	 elseif (tok = "&") then
            call rtinscod(ANDATT)

         elseif (tok = "|") then
            call rtinscod(ORATT)

         elseif (tok <> " ")      # case EOF is a no-op. tok is attribute name
            nexttok = OPERATN
            idxattr = 1                          ## allow for partial matches
            nattr = rtattrlu(tok, idxattr, TRUE, xactmtch)
            if (nattr = 0) then
               call remark("ERROR: attribute expression contained unknown " //
     1                      "attribute "//tok)
               return(ERR)
            endif

            if (xactmtch) then
               call rtinscod(nattr)
            else
               do             ## find all possible matches for att:
                  call rtinscod(nattr)
                  idxattr = nattr+1
                  nattr=rtattrlu(tok, idxattr, TRUE, xactmtch)
               until (nattr = 0)
            endif
	 endif

      until (tok = " ")   ## EOF
      call rtinscod(EOFATT)
      return (OK)
      end

########################################################################
#    errflg = rtsrvstr(srvstr)
#
#    purpose:
#       to parse the SERVSTR passed to RTSERV and return the appropriate
#       information
#
#    arguments:
#       srvstr   =:  the string to parse
#
#    common variables:
#       srvmac    := TRUE if macros are to be serviced, else FALSE
#       srvfunc   := TRUE if functions are to be serviced, else FALSE
#       srvvar    := TRUE if variables are to be servied, else FALSE
#       srvtype   := value of keyword SERVE.  values "data", "info", 
#                    "index", or "no"
#       tmpndb    := database number of database in which to store
#                    temporary variables.  If 0, temporaries are not stored.
#       tmpdbnam  := database name of database in which to store temporary
#                    variables.  If " ", temporaries are not stored.
#       srvdbnum  := database number of database to service.  If 0, then
#                    service all databases (and macros if asked for).
#       srvaccss  := integer value describing how to access data.  values
#                    LIMITED, FULL, INFO, INFO_LIMITED.
#       srvlen0   := logical TRUE if to serve on length 0 variables, else FALSE
#
#    Comments:
#       The string to parse should be of the form
#            type_designator keyword_list
#
#       where type_designator is upto 3 characters long and can contain the
#       characters "m","v", and/or "f".  The key_word list is a list of 0
#       or more blank delimited items of the form
#             keyword:value
#
#       This routine also does consistency checks to make sure all needed
#       information was in the SERVESTR and that no information is conflicting.
#
#       Maximum size of keyword names and values is 24 characters.
########################################################################
      integer function rtsrvstr(srvstr)
      Use(Servopts)
      character*(*) srvstr
      integer idx, srvlen, idxnew, i, idxcolon, idxnext
      integer utgetcl, glbpknum
      character*(KEYSZ) keyname, keyvalue
#


      if (srvstr = " ") goto 900 

      srvtype = "data"               ## set default values for keywords
      srvaccss = FULL
      tmpdbnam = " "
      tmpndb = 0
      srvdbnum = 0
      srvmac = FALSE
      srvfunc = FALSE
      srvvar = FALSE
      srvlen0 = TRUE

      srvlen = utgetcl(srvstr)
      idx = 1
      call utskipbl(srvstr,idx)
      idxnew = index(srvstr(idx:srvlen)," ")
      if (idxnew = 0) idxnew = srvlen - idx + 2  #at end of string
      if (idxnew > 4) goto 910

## .. Read type_designator to determine what should be serviced.

      do i=idx,idx+idxnew-2
         if (srvstr(i:i) = "m") then
	    srvmac = TRUE
	 elseif (srvstr(i:i) = "f") then
	    srvfunc = TRUE
	 elseif (srvstr(i:i) = "v") then
	    srvvar = TRUE
	 else
	    goto 910
	 endif
      enddo
      idx = idx + idxnew

## .. Loop over  keyword:value   pairs

      while (idx <= srvlen)
         call utskipbl(srvstr,idx)
         idxcolon = index(srvstr(idx:srvlen),":")  # idxcolon = keyword len + 1
         if (idxcolon < 2 | idxcolon-1 > KEYSZ) goto 920

	 idxnew = idx + idxcolon
	 call utskipbl(srvstr,idxnew)
	 idxnext = index(srvstr(idxnew:srvlen)," ")  # idxnext = value len + 1
	 if (idxnext = 0) idxnext = srvlen-idxnew+2    #at end of string
	 if (idxnext < 2 | idxnext-1 > KEYSZ) goto 930

         keyname = srvstr(idx:idx+idxcolon-2)
	 keyvalue = srvstr(idxnew:idxnew+idxnext-2)
         if (keyname = "serve") then
            if (srvtype <> "data" & srvtype <> "info" & srvtype <> "index"
     x                            & srvtype <> "no") goto 940
	    srvtype = keyvalue
	 elseif (keyname = "pkg") then
	    tmpndb = glbpknum(keyvalue)   # get database number of package name
            if (tmpndb==0) goto 980
            tmpdbnam = keyvalue
	 elseif (keyname = "dims") then
	    if (keyvalue = "limited") then
	       srvaccss = LIMITED
	    elseif (keyvalue = "unlimited") then
	       srvaccss = FULL
	    else
	       goto 940
	    endif
	 elseif (keyname = "db") then
	    srvdbnum = glbpknum(keyvalue)   # get database number of package name
            if (srvdbnum == 0) goto 980
         elseif (keyname = "skip") then
            if (keyvalue <> "len0") goto 940
            srvlen0 = FALSE
	 else
	    goto 950
	 endif
	 idx = idxnew+idxnext
      endwhile

      if (srvtype = "info") then
         if (srvaccss = LIMITED) then
	    srvaccss = INFO_LIMITED
	 else
	    srvaccss = INFO
	 endif
      endif
      if ((srvmac | srvfunc) & srvtype="data" & tmpndb = 0) goto 960
      if (srvmac & srvdbnum<>0) goto 970
      if (.not. srvlen0 & srvtype <> "data") goto 990
      return(OK)

900   call remark("rtsrvstr ERROR: illegal for blank SERVSTR in RTSERV call")
      return(ERR)

910   call remark(
     x      "rtsrvstr ERROR: bad type_designator in SERVSTR for RTSERV call")
      call remark(
     x      "                maximumum length of 3.  Valid characters m,f,v")
      call remark(srvstr)
      return(ERR)

920   call remark(
     x "rtsrvstr ERROR: bad SERVSTR keyword.  Not followed by : or > 24 length")
      call remark(srvstr)
      return(ERR)

930   call remark(
     x    "rtsrvstr ERROR: SERVSTR keyword value is longer than 24 characters")
      call remark(srvstr)
      return(ERR)

940   call remark("rtsrvstr ERROR: unknown value '"//keyvalue//"'")
      call remark("         for SERVSTR keyword '"//keyname//" in RTSERV call")
      return(ERR)

950   call remark("rtsrvstr ERROR: unknown SERVSTR keyword '"//keyname//
     x            "' in RTSERV call")
      return(ERR)

960   call remark("rtsrvstr ERROR: temporary variables needed, but SERVSTR "//
     x            "keyword PKG was not set")
      call remark(srvstr)
      return(ERR)

970   call remark("rtsrvstr ERROR: illegal for macros to be serviced when " //
     x            "SERVSTR keyword DB is set")
      call remark(srvstr)
      return(ERR)

980   call remark("rtsrvstr ERROR: unknown package name '"//keyvalue//"'")
      call remark("         for SERVSTR keyword '"//keyname//" in RTSERV call")
      return(ERR)

990   call remark("rtsrvstr ERROR: if PASS:LEN0 then keyword SERVE must be " //
     x            "of type DATA")
      return(ERR)
      end


########################################################################
#    errflg = rtactstr(actstr)
#
#    purpose:
#       to parse the ACTSTR passed to RTSERV and set the appropriate
#       information
#
#    arguments:
#       actstr   =:  the string to parse
#
#    common variables:
#       srv4get   := value of keyword FORGET.  Values are "name, "temp, or "all"
#                    If keyword FORGET is not present, then set to " ".
#       srvtag    := first part of value for keyword TAG.  Can be "name",
#                    "temp", or "all".  If keyword TAG is not present,
#                    then set to " ".  Note keyword TAG has a two part value
#                    (parts are separated by :).  The first part is described
#                    above.  The second part is a list of tags.
#       srvtgstr  := second part of value for keyword TAG.  The string of
#                    attribute add and subtract requests.  Set to " "
#                    if not present
#
#    Comments:
#       The string to parse should be a list of 0 or more blank delimited
#       items of the form
#             keyword:value
#
#       value can consist of 1 or 2 parts.  Keyword TAG requires a two part
#       value, keyword FORGET must have only a 1 part value.  Value has one
#       of the following two forms.
#             value1
#             value1:value2
#
#
#       Note value must contain no blanks -- even between parts.
#
#       Maximum size of keyword names and values is 8 characters.
########################################################################
      integer function rtactstr(actstr)
      Use(Servopts)
      character*(*) actstr
      integer idx, actlen, idxnew, idxcolon, idxnext, idxcol2, idxend
      integer tagstrt, taglen
      integer utgetcl
      character*(KEYSZ) keyname, keyvalue
#

      srv4get = " "      ## set default values for keywords
      srvtag = " "
      srvtgstr = " "
      if (actstr = " ") return(OK)


      actlen = utgetcl(actstr)

## .. Loop over  keyword:value  or keyword:value1:value2    terms

      idx = 1
      while (idx < actlen)
         call utskipbl(actstr,idx)
         idxcolon = index(actstr(idx:actlen),":") # idxcolon = keyword len + 1
         if (idxcolon < 2 | idxcolon-1 > KEYSZ) goto 920

	 idxnew = idx + idxcolon
	 call utskipbl(actstr,idxnew)

## .. idxnext = length of (value or value1:value2) + 1
## .. idxcol2 = length of  value1: (if no : present, then set to 0)
## .. idxend = length of (value or value1) + 1.

	 idxnext = index(actstr(idxnew:actlen)," ")
	 idxcol2 = index(actstr(idxnew:actlen),":")
	 if (idxnext = 0) idxnext = actlen-idxnew+2   #at end of string
	 idxend = idxnext
	 if (idxcol2<>0 & idxcol2 < idxnext)  idxend = idxcol2
	 if (idxend < 2 | idxend-1 > KEYSZ) goto 930

         keyname = actstr(idx:idx+idxcolon-2)
	 keyvalue = actstr(idxnew:idxnew+idxend-2)
	 if (keyvalue<>"name" & keyvalue<>"temp" & keyvalue<>"all") goto 940
         if (keyname = "forget") then
	    srv4get = keyvalue
	    if (idxend <> idxnext) goto 960
	 elseif (keyname = "tag") then
	    srvtag = keyvalue
	    if (idxend <> idxcol2) goto 970
	    tagstrt =idxnew+idxcol2
	    taglen =idxnext-idxcol2-1
            if (taglen > MAXTAGSZ) goto 980
            srvtgstr = actstr(tagstrt:tagstrt+taglen-1)
	 else
	    goto 950
	 endif
	 idx = idxnew+idxnext
      endwhile
      return(OK)

920   call remark(
     x "rtactstr ERROR: bad ACTSTR keyword.  Not followed by : or > 24 length")
      call remark(actstr)
      return(ERR)

930   call remark(
     x    "rtactstr ERROR: ACTSTR keyword value is longer than 8 characters")
      call remark(actstr)
      return(ERR)

940   call remark("rtactstr ERROR: unknown value '"//keyvalue//"'")
      call remark("         for ACTSTR keyword '"//keyname//" in RTSERV call")
      return(ERR)

950   call remark("rtactstr ERROR: unknown SERVSTR keyword '"//keyname//
     x            "' in RTSERV call")
      return(ERR)

960   call remark("rtactstr ERROR: value for ACTSTR keyword '"//keyname//
     x            "' contained an illegal ':'")
      return(ERR)

970   call remark("rtactstr ERROR: value for ACTSTR keyword '"//keyname//"'")
      call remark("   ' is expecting a two part value (parts delimited by ':')")
      return(ERR)

980   call remark("rtactstr ERROR: ACTSTR tag is longer than 120 characters")
      call remark(actstr)
      return(ERR)
      end
#-------------------------------------------------------------------------------
        subroutine rtcntsiz(npack,jvar,name,typecode,fwa,ndim,ilow,ihi,icol,
                           attr,param,moreargs,istage)
## Created 02/01/90   (SMHT)
##   purpose: returns count of variables (and macros and functions if in data
##            form) and combined length (words) of these variables.  An error
##            is returned if a macro or function, not converted to data, is
##            present or if the dimension information is not present.
##
##   argument param(1):  (output) number of variables
##            param(2):  (output) combined word length of data
##            param(3):  (output) error flag.  0 if no error, else 1.
#

        Use(Servopts)
        integer npack,jvar,typecode,ndim,ilow(7),ihi(7),icol(7),param(3)
        Address fwa
        integer moreargs(1), istage
        character*(*) name, attr
        integer nitems, i, varlen
        integer utsizeof

        select istage
        case 0:
            param(1)=0           #initial count
            param(2)=0           #initial length
            param(3)=0           #no error
            if (srvtype=="index") param(3)=1    ## ERROR: must have dim info
        case 1:
            if (param(3)==1) return
            if (typecode==FUNCTION_TYPE | npack==0) then   #function or macro
               param(3)=1
               return
            endif
            param(1)=param(1)+1
            nitems=1
            do for i=1,ndim
               nitems = nitems*(icol(i)-ilow(i)+1)
            enddo
            varlen = utsizeof(nitems, typecode)
            param(2) = param(2) + varlen

        endselect
        return
        end
#-------------------------------------------------------------------------------
       subroutine rtservmc (attr, actor, param)
#      Revised: Zane C. Motteler
#      Date:    August 31, 1994
#      Purpose: Use the Dubois hash/string tables
## Created 01/23/90 by SMHT
## rtservmc: macro service for attributes
# attr: an attribute expression
# actor: a subroutine
# param: a parameter to be passed to actor
# rtservmc cycles over the macros which have the given attribute set.
# changed to remove Macros references (ZCM, 7/91)
# changed to use dvarnam.c routines for macro names (ZCM, 8/91)
Use(Hash)
       Use(Servopts)
       character*(*) attr
       external actor, mcunstal, nstrgs
       integer param, nstrgs
       integer i,ns
       logical tmpflg, warnflg, skip
       logical rtattexp

       tmpflg = FALSE
       warnflg = TRUE
       ns = nstrgs ( )
       do i = 1 , ns
          if ( ihashfind ( mactable , i-1 ) > 0 ) then # it is a macro
             skip = FALSE
             if (rtattexp(i-1,MACRODB,warnflg)) then
                if (srvtype<>"no") call rtmactor(actor,i-1,0,attr,param,1,
                                                 tmpflg,newndb,newjvar,skip)
   
                if (skip) next
                if (srvtag=="name" | srvtag=="all") then
                   call mcvattre(i-1,srvtgstr)
                elseif (tmpflg & (srvtag=="temp" | srvtag=="all")) then
                   call rtvattre(newjvar,newndb,srvtgstr)
                endif

                if (srv4get=="name" | srv4get=="all") then
                   call mcunstal ( i-1 ) # delete macro
                elseif (tmpflg & (srv4get=="temp" | srv4get=="all")) then
                   call rtforget(newjvar,newndb)
                endif
             endif
          endif
          warnflg = FALSE
       enddo
       return
       end
#-------------------------------------------------------------------------------
       subroutine rtmactor(actor,jvar,ndb,attr,param,istage,tmpflg,newndb,
                           newjvar, skip)
#      Revised: Zane C. Motteler
#      Date:    August 31, 1994
#      Purpose: Adopting Dubois string/hash tables for macros
       Use(Servopts)
### Created (SMHT) 01/23/90    Parallel to RTACTOR, except process macros
# changed to remove Macros references (ZCM, 7/91)
# changed to use dvarnam.c routines for macro names (ZCM 8/91)

        external actor
        integer jvar, ndb, param, istage, newjvar
        character*(*) attr
        integer newndb
        logical tmpflg, skip
        integer moreargs(1)
        integer ndim, ilow(7), ihi(7), icol(7), tc
        Address fwa
        character*40 macname
        logical varflg
        integer utgetcl, strglen, rtgetany
        external utgetcl,strglen, rtgetany

        macname = " "
        call strgget ( jvar , macname )
        if (strglen(jvar) > 40) then
           call remark("mcserv:  macro name truncated to 40 characters '"//
     x                  macname//"'")
        endif

        newndb = ndb
        newjvar = jvar
        fwa=NOTSET
        moreargs(1) = MACINITL
        ndim=0
        tc=0
        tmpflg = FALSE
        skip = FALSE
        if (srvtype=="data") then
           if (rtgetany(macname, tmpdbnam, srvaccss, newndb, newjvar, fwa,
                        tc, ndim, ilow, ihi, icol, varflg) == ERR) return
           tmpflg = .not.varflg
           if (.not. srvlen0) then
              do i=1,ndim
                 if (ihi(i) -ilow(i) +1 == 0) skip = TRUE
              enddo
           endif
        endif
        if (skip) return
        call actor(newndb,newjvar,macname,tc,fwa,ndim,ilow,ihi,icol,attr,param,
                           moreargs,istage)
        return
        end
#-------------------------------------------------------------------------------
	subroutine rtserv(attr,actor,param,servstr,actstr)
        Use(Servopts)
## REVISION (SMH)   01/23/90
##    added arguments SERVSTR and ACTSTR; removed arguments KACTOR and NOFUNC.
##    will now process macros and function, even calculating data if needed.
## REVISION (ZCM) 08/19/97
##    remove references to Domestic and replace with access functions
#
### rtserv: service for attributes
# attr: an attribute expression
# actor: a subroutine
# param: a parameter to be passed to actor
# servstr: defines conditions of how to call actor
# actstr:  defines what actions to do after calling server
# rtserv cycles over the set of databases in initialized packages
	character*(*) attr,servstr,actstr
	external actor
	integer param
	integer i, npack, ndb, tmppri(MAXPAK+1), sortidx(MAXPAK+1)
	integer rtnumpak, glbstat, rtsrvstr, rtactstr, rtprsatt
	external rtnumpak, glbstat, rtsrvstr, rtactstr, rtprsatt
        integer rtgpri
        external rtgpri

	if (rtsrvstr(servstr) == ERR) return   # set vars in common Servopts
        if (rtactstr(actstr) == ERR) return    # set vars in common Servopts
	npack = rtnumpak()
        if (rtprsatt(attr) = ERR) return     # parse attr
	call rtserv1(attr,actor,0,param,0)
	if (srvdbnum <> 0) then
	   call rtserv1(attr,actor,srvdbnum,param,1)
	elseif(srvvar | srvfunc)
	   if (tmpndb <> 0) call rtserv1(attr,actor,tmpndb,param,1)
           do i=1,npack
              tmppri(i) = rtgpri (i)
           enddo
           tmppri(npack+1) = rtgpri (USERDB)
           call sorti(tmppri, sortidx, npack+1)
   	   do i = npack+1, 1, -1
                ndb = sortidx(i)    ## ndb's in priority order
                if (ndb = npack+1) ndb= USERDB
		if(glbstat(ndb) == 0 | ndb==tmpndb) next
		call rtserv1(attr,actor,ndb,param,1)
	   enddo
	endif
	if (srvmac) call rtservmc(attr,actor,param)
	call rtserv1(attr,actor,0,param,2)
        return
	end

#-------------------------------------------------------------------------------
	subroutine rtserv1(attr,actor,ndb,param,istage)
        Use(Servopts)
## REVISION (SMH)   01/23/90
##    modified to accept SERVSTR and ACTSTR options;
#     removed arguments KACTOR and NOFUNC.
## REVISION (ZCM) 08/19/97
##    remove references to Domestic and replace with access functions
	external actor
        character*(*) attr
	integer ndb, param, istage
	logical warnflg   ## TRUE if ok to print warning message
        logical tmpflg, skip
        integer newndb, newjvar
# istage = 0 initialize, 1 do a db, 2 finish
# if srvfunc = FALSE, don't do functions; if srvvar=FALSE, don't do variables
	logical rtattexp, rtisdead
        integer rtgtc, rtgnvar, nvar
        external rtgtc, rtgnvar, rtisdead
	save warnflg

	select (istage)
	case 0:
	   if (srvtype<>"no") call rtactor(actor,0,ndb,attr,param,istage,tmpflg,
                                           newndb, newjvar, skip)
	   warnflg = TRUE
	case 1:
# convert the attribute to a number
           if (ndb == 0) then
              call remark ("rtserv1: istage == 1, ndb == 0???")
              call kaboom (1)
           endif
           tmpflg = FALSE
           nvar = rtgnvar (ndb)
	   do i = 1, nvar
	      if(rtisdead (i, ndb)) next
              if(rtgtc(i, ndb) == FUNCTION_TYPE) then
	         if (~srvfunc) next
	      else
	         if (~srvvar) next
	      endif
              skip = FALSE
	      if(rtattexp(i,ndb,warnflg)) then
	         if (srvtype<>"no") call rtactor(actor,i,ndb,attr,param,istage,
	 	                                 tmpflg, newndb,newjvar, skip)
                 if (skip) next
		 if (srvtag=="name" | srvtag=="all") then
		    call rtvattre(i,ndb,srvtgstr)
		 elseif (tmpflg & (srvtag=="temp" | srvtag=="all")) then
		    call rtvattre(newjvar,newndb,srvtgstr)
		 endif

		 if (srv4get=="name" | srv4get=="all") then
		    call rtforget(i,ndb)
		 elseif (tmpflg & (srv4get=="temp" | srv4get=="all")) then
		    call rtforget(newjvar,newndb)
		 endif
	      endif
	      warnflg = FALSE
	   enddo
	case 2:
	   if (srvtype<>"no") call rtactor(actor,0,ndb,attr,param,istage,
                                           tmpflg,newndb, newjvar, skip)
	default:
		call remark("rtserv1, illegal stage value.")
		call kaboom(1)
	endselect
	return
	end
#-------------------------------------------------------------------------------
	subroutine rtactor(actor,jvar,ndb,attr,param,istage,tmpflg,newndb,
                           newjvar, skip)
Use(Servopts)
## REVISION (SMH)  01/23/90
##    modified to call with new calling sequence due to attribute handler
##    improvements.  Removed argument KACTOR
#
#  REVISION (SMHT) 03/04/91
##    added argument skip to allow skipping over 0-length variables
## REVISION (ZCM) 08/19/97
##    remove references to Domestic and replace with access functions

	external actor, rtgvname, rtgtc
	integer jvar, ndb, param, istage, newndb, newjvar, rtgtc
	character*(*) attr
        logical skip
        character*(PNSIZE) pkg
        logical tmpflg
        integer moreargs(1)
	integer ndim, ilow(7), ihi(7), icol(7), tc, lpkg, i
        Address fwa
        logical varflg
	Varname vname
	integer utgetcl, rtgetany
	external utgetcl, rtgetany

        skip = FALSE
	if(istage==0 | istage==2) then
	   call glbpknam(ndb,vname)
           moreargs(1) = VARINITL  # value doesn't matter in these cases.
	   call actor(0,0,vname,0,0,0,0,0,0,attr,param,moreargs,istage)
	   return
        endif

	if(ndb == 0) return

        newndb = ndb
        newjvar = jvar
        fwa=NOTSET
        moreargs(1) = VARINITL                            # variable
        ndim=0
        tc=0
        if (rtgtc(jvar,ndb)==FUNCTION_TYPE) then                  # function
           moreargs(1)=FNCINITL

   	   if (srvtype=="data") then
              call glbpknam(ndb, pkg)
              lpkg = utgetcl(pkg)
              call rtgvname (jvar, ndb, vname)
 	      if (rtgetany(pkg(1:lpkg)//"."//vname,
                           tmpdbnam, srvaccss,
                           newndb, newjvar, fwa,
                           tc, ndim, ilow, ihi, icol, varflg)==ERR) return
	      tmpflg = .not.varflg
              if (.not. srvlen0) then
                 do i=1,ndim
                    if (ihi(i) -ilow(i) +1 == 0) skip = TRUE
                 enddo
              endif
           elseif (srvtype=="info")
              tc=FUNCTION_TYPE
           endif
        else
	   if (srvtype<>"index") then
              call rtxdb(jvar, ndb, fwa, ndim, ilow,ihi,icol,srvaccss)
              if (.not. srvlen0) then
                 do i=1,ndim
                    if (ihi(i) -ilow(i) +1 == 0) skip = TRUE
                 enddo
              endif
           endif
	   tmpflg = FALSE
	endif

        if (skip) return
        call rtgvname(newjvar, newndb, vname)
 	call actor(newndb,newjvar,vname,rtgtc(newjvar,newndb),fwa,
	                   ndim,ilow,ihi,icol,attr,param,moreargs,istage)
	return
	end

#-------------------------------------------------------------------------------
	subroutine attredit(jout,attr)
# edit every variable with a given attribute to unit jout
	integer jout
	character*(*) attr
	external rtaedit
	call rtserv(attr,rtaedit,jout,"v"," ")
	return
	end
#-------------------------------------------------------------------------------
	subroutine attrlist(jout,attr)
# list every entity with a given attribute to unit jout
	integer jout
	character*(*) attr
	external rtalist
	call rtserv(attr,rtalist,jout,"vfm serve:info"," ")
	return
	end
#-------------------------------------------------------------------------------
	subroutine rtxnattr(i,nattr)
	integer i, nattr
	nattr = i
	return
	end

#-------------------------------------------------------------------------------
        subroutine rtcount(npack,jvar,name,typecode,fwa,ndim,ilow,ihi,icol,
                           attr,param,moreargs,istage)
## Created 02/01/90   (SMHT)
##   purpose: returns count of variables, macros, functions.
##   argument param(1):  (output) number of variables, macros, functions
        integer npack,jvar,typecode,ndim,ilow(7),ihi(7),icol(7),param(1)
        Address fwa
        integer moreargs(1), istage
        character*(*) name, attr
 
        select istage
        case 0:
            param(1)=0
        case 1:
            param(1)=param(1)+1
        endselect
        return
        end

