
c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

        subroutine parid(psp)
# reduce the production <lhs>:=<id>
#  psp points to the identifier (psp = parameter stack pointer)
# look it up by calling parfinds...
#     ...if unknown set jvar = 0
#     ...else
#         ...for functions, load up function element in ss(,psp)
#         ...for variables, create an element of type LHS
# after this action, the thing on the stack is either FUNCTION or LHS, 
# or else ss(TC,psp) >= UNKNOWN
# Revision 9/9/94 (ZCM) always put the name in nxp because
#                       sometimes that is used for diagnostics
# Revision 7/28/95 (ZCM) changes reflect the fact that parfinds
#                        will look up the name only if it hasn't
#                        already been done, and that a parrel
#                        must be done on ss(.,rsp), since it now always
#                        contains a reference to literal, which
#                        must be cleared of the reference to the name.
# Revision 8/11/1999 (ZCM) uses only the argument psp, and no longer
#                        uses a dynamic stack element to save typing.
Use(Stacks)
Use(Actions)
Use(Controls)
        integer psp
        integer parfinds, parname
        external parfinds, parname
        integer ndb,jvar,tc
        integer ierr, leng
        Varname tmpname
        integer strgfind
        Address strloc
        external strloc
        external strgfind
#
        if(symbolic) then
                lxp(psp) = parname(ss(1,psp), nxp(psp))
                leng = lxp(psp)
        else
                nxp(psp) = " "
                lxp(psp) = 0
                leng = len (nxp (psp))
        endif
# look up variable
# 7/28/95 ZCM Add extra arguments to parfinds.
#             Do a parrel on ss(1,psp), since it now contains a literal table reference.
# 8/23/95 ZCM Don't parrel if it can't be found, need to put it in string table first
        ierr = parfinds(ss(1,psp),jvar,ndb,tc,lxp(psp),strloc(nxp(psp)),leng)
        if ( ierr == OK ) call parrel(ss(1,psp))
        if( ierr = ERR) then
# mark it as "UNKNOWN" -- otherwise it really hasn't been touched
# you test for this later by checking ss(N,psp) == UNKNOWN
            if(ss(N,psp) == 0) then
                if ( lxp(psp) == 0 ) then
                   tmpname = nxp(psp)
                else
                   ierr = parname(ss(1,psp),tmpname)
                endif
                call parrel ( ss(1,psp) )
                ss(PTR,psp) = strgfind(tmpname)
		ss(N,psp) = UNKNOWN
		ss(TC,psp) = LHS
		return
	    else
# a specific package was named, but the variable isn't in it
		call unknownv(ss(1,psp))
		call kaboom(1)
	    endif
	endif
        ss(N,psp) = ndb
        ss(PTR,psp) = jvar
	if( tc <> FUNCTION_TYPE) then
	    ss(NS,psp) = 0
            ss(TC,psp) = LHS
            ss(TCSAVE,psp) = tc
	else
# For functions create function stack element
# Function stack elements are as follows: (ZCM 3/27/95)
#  ss(TC,.) = FUNCTION_TYPE
#  ss(PTR,.) = jvar (variable number in package)
#            (5/22/95) rtxdb may return with ss(N,.) and ss(PTR,.) changed,
#            since this may be the formal parameter name of an actual
#            parameter which is a compiled function.
#  ss(N,.) = package number
#  ss(N1,.), ss(M1) = min, max number of args
#  ss(N2,.) =0: builtin fn; <0: -iseg for compiled; >0: user
	    ss(TC,psp) = FUNCTION_TYPE
	    call rtxdbf(jvar,ndb,ss(N2,psp),ss(N1,psp),ss(M1,psp),ss(N,psp),ss(PTR,psp))
        endif
        return
        end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

	subroutine parautov(ti,s)
        integer ti(SSWIDTH),s(SSWIDTH)
Use(Controls)
Use(Functions)
        integer jvar
        integer rtinname, gfuncdep
        external rtinname, gfuncdep
# (FNF 7/31/97) Changed "call remark" statements to "call baserror".
#
        if(ti(TC) == FUNCTION_TYPE) then
           call baserror("Cannot assign to a function name.")
           if(debug == YES)then
               call kaboom(1)
           else
               call kaboom(0)
           endif
	endif
        if(ti(TC) <> LHS) return
	if(ti(N) <> UNKNOWN) return
        if(autovar==NO|ti(NS)>0) then
# an unknown variable encountered, and either:
#  a. autovar is NO
#  b. subscripts were supplied on the target ti
           call unknownv(ti)
           call kaboom(1)
        endif
# turn t back into a name for now
        ti(N) = 0
        ti(TC) = NAME
        if (ti(NAML)<0)ti(NAML)=-ti(NAML) # ZCM 11/13/95
# create a database entry for this variable;
# the space for it is reserved later by parendow.
	ti(NS) = s(N)
        do i = 1, s(N)
	    ti(N1-1+i) = 1
	    ti(M1-1+i) = s(N1-1+i)
	    ti(I1-1+i) = 1
        enddo
	if(gfuncdep()==0)then
                jvar = rtinname(USERDB,s(TC),ti)
                if( jvar == 0) go to 900
                call parendow(jvar,USERDB,s)
                ti(N) = USERDB
	else
                jvar = rtinname(LOCALDB,s(TC),ti)
                if( jvar == 0) go to 900
                call parendow(jvar,LOCALDB,s)
                ti(N) = LOCALDB
	endif
	ti(TC) = LHS
	ti(TCSAVE) = s(TC)
	ti(PTR) = jvar
        ti(NS) = 0
	return
900     call baserror("Unexpected failure in autovar variable creation.")
        call kaboom(0)
        end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

# PARSUBS
#
# Rewritten by : Zane C. Motteler
# Date         : August, 1989
#
# Parameter:
#       pcnext   :  next instruction pointer
#
# Purpose:
#       Reduce the production <lhs>:=<lhs> <args>.
#       Since this production is left recursive, the reduction can occur
#       several times. The idea is that repetitive reductions leave the
#       stack object a LHS unless it happens to be a function call. The
#       object is not actually (par)fetched until its value is needed.
#       The argument at rlinkp-1 can be of type:
#       1. FUNCTION -- call parsubf (q.v.)
#       2. LHS -- call parsubl (q.v.)
#       3. any actual data type -- call parsubd (q. v.)
#
#       rsp points to the top of the stack of arguments; rsp-rlinkp = number of arguments
#       number of arguments >=1 but arguments may be NULL_TYPE
#       one NULL_TYPE argument means NO arguments (e. g. f())
#
#       pcnext is currently set to the current pc + 1; this is correct
#       return address for a function, but parxfcn may modify it for
#       a call to a user-defined function
# Revised: October 1989
#       improved error printouts when debug is on
# Revised: August 1999
#       Use global runtime stack pointer and link pointer. Cut number
#       of arguments back to just pcnext.

        subroutine parsubs(pcnext)

Use(Stacks)
        integer pcnext
#
        external parsubd, parsubf, parsubl
        integer ns
#
        ns = rsp - rlinkp
        if( ss(TC, rlinkp - 1) == FUNCTION_TYPE) then
           call parsubf(pcnext, ns)
        elseif( ss(TC, rlinkp - 1) == LHS) then
           call parsubl(ns)
        else
# it's a real data object so subscript it as in old times
           call parsubd(ns)
        endif
        return
        end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

# PARSUBC
#
# Programmed by : Zane C. Motteler
# Date          : August 1989
# Purpose       : Handle the collection of subscripts forced by the first
#                 reduction of <lhs> ::= <lhs> <args> when it is a real <lhs>,
#                 and by subsequent reductions of a data object generated by
#                 a function call
# Parameters    : ns -- number of subscripts
# Revised: October 1989 (ZCM)
#       improved error printouts when debug is on
# Revised: January 1990 (ZCM)
#       to support lazy evaluation, parfetch must be called for subscripts
#       which have type LHS.
# (FNF 7/29/97) Changed "write(STDERR,..." statements to "call baserror".
# (ZCM 8/10/1999) Eliminated all arguments but ns; use global runtime stack
# (ZCM 8/26/1999) Added the capability for any subscript to be a 1d array
# and link pointers to access the stack; use the new stack frame structure.

      subroutine parsubc(ns)
      character*(OUTLINE) errmsg
Use(Stacks)
Use(Controls)
      integer ns, i, j, ival, k, isub, ityp
      Address pirange
      integer parcoerc, parint, ivalueo
      Address paraddr
      external parcoerc, parint, parrel, kaboom, paraddr, ivalueo

# collect the subscripts
      if (ns == 1 & ss(TC, rlinkp + 1) == NULL_TYPE) then
         if (ss(NS, rlinkp - 1) > 0) then
# Treat subsequent "all defaults" as NOPs:
            return
         endif
         ns = 0
         ss(NS, rlinkp - 1) = 0
         return
      endif

      do i = 1, ns
         j = rlinkp + i
         call parfetch(ss(1,j), nxp(j), lxp(j), COPY,FALSE)
 10      continue

         ityp = ss(TC,j)
         select(ityp)

         case INTEGER:
             # (ZCM 8/13/97) get the true dimensions of an integer
             # (This prevents a spurious DEFAULT + 1)
             call pardim (ss (1, j))
             if (ss (N, j) ~= 1) then
                if( parint(ss(1,j), ival) == ERR) then
                    if (lxp (rlinkp - 1) > 40) lxp (rlinkp - 1) = 40
		    write(errmsg, 998)i, nxp (rlinkp - 1)(1:lxp (rlinkp - 1))
                    call baserror(errmsg)
                    if(debug == YES)then
                        call kaboom(1)
                    else
                        call kaboom(0)
                    endif
	        endif
                ss(N1-1+i, rlinkp - 1) = ival
                ss(M1-1+i, rlinkp - 1) = ival
                ss(I1-1+i, rlinkp - 1) = 1
                call parrel(ss(1,j))
             else
                # a singly subscripted array is allowed to have a
                # singly subscripted array as its subscript.
                # find an empty entry in bassubs.
                isub = 0
                do k = 1, SUBSLENGTH
                   if (bassubs (TC, k) == NULL_TYPE) then
                      # found! save subscript stack element
                      call parcopy (ss (1, j), bassubs (1, k))
                      isub = k
                      bassubs (N1 + 1, isub) = 1 # can be parrel'ed
                      # put signal in operand stack element
                      ss (N1 + i - 1, rlinkp-1) = DEFAULT + 1
                      ss (M1 + i - 1, rlinkp-1) = isub
                      ss (I1 + i - 1, rlinkp-1) = 1 # dummy
                      break
                   endif
                enddo
                if (isub == 0) then
                   errmsg = nxp(rlinkp-1)(1:lxp(rlinkp-1)) // \
                      ": subscript stack overflow."
                   call baserror (errmsg)
                   if (debug == YES) then
                       call kaboom(1)
                   else
                       call kaboom(0)
                   endif
                endif
             endif

          case RANGE:
             pirange = paraddr(ss(1,j))
             ss(N1-1+i,rlinkp-1) = ivalueo (pirange, 1)
             ss(M1-1+i,rlinkp-1) = ivalueo (pirange, 2)
             ss(I1-1+i,rlinkp-1) = ivalueo (pirange, 3)
             call parrel(ss(1,j))

          case NULL_TYPE:
             ss(N1-1+i,rlinkp-1) = DEFAULT
             ss(M1-1+i,rlinkp-1) = DEFAULT
             ss(I1-1+i,rlinkp-1)=1

          default:
             if (ss(N,rlinkp-1) .eq. UNKNOWN) then
                 if (lxp(rlinkp-1) > 54) lxp(rlinkp-1) = 54
                 write(errmsg, 999)nxp(rlinkp-1)(1:lxp(rlinkp-1))
                 call baserror(errmsg)
                 call baserror("The variable in question is currently UNKNOWN.")
	     else
                 if (parcoerc(ss(1,j),INTEGER) = ERR) then
                        if (lxp(rlinkp-1) > 54) lxp(rlinkp-1) = 54
                        write(errmsg, 999)nxp(rlinkp-1)(1:lxp(rlinkp-1))
                        call baserror(errmsg)
   	                write(errmsg,
                       '("Subscript ",i3," not integer.")') i
                        call baserror(errmsg)
                 else
                    go to 10
                 endif
             endif
             call kaboom(0)
          endselect

          if (ss(I1-1+i,rlinkp-1) == 0) then
              if (lxp(rlinkp-1) > 54) lxp(rlinkp-1) = 54
              write(errmsg, 999)nxp(rlinkp-1)(1:lxp(rlinkp-1))
              call baserror(errmsg)
   	      write(errmsg,
                    '("stride on subscript ",i3," is zero.")') i
              call baserror(errmsg)
              call kaboom(0)
          endif
       enddo i

       if (ss(TC, rlinkp-1) == LHS) then
          ss(NS, rlinkp-1) = ns
       endif

       return
998    format("parsubc: error is in subscript ",i1," of '",a,"'.")
999    format("parsubc: trouble with '",a,"'.")
       end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

# PARSUBD
#
# Programmed by : Zane C. Motteler
#                 (Actually, this is an adaptation of large parts of the
#                 old parsubs, and hasn't been changed by much.)
# Date          : August 1989
# Purpose       : Handle the reduction <lhs> ::= <lhs> <args> when <lhs> is
#                 actual data. This will only happen if a function call is
#                 subscripted, because that's the only case where this reduc-
#                 tion can change the type code of <lhs> to something other
#                 than <lhs>.
# Parameters    :
#                  ns -- the number of subscripts specified by <args>
# Revised: October 1989
#       improved error printouts when debug is on
# Bug Fix: March 1991 (zcm)
#       correct calculation of ihi
# (FNF 7/29/97) Changed "write(STDERR,..." statements to "call baserror".
# (FNF 7/31/97) Changed "call remark" statements to "call baserror".
# (ZCM 8/10/1999) Eliminated all arguments but ns; use global runtime stack
# and link pointers to access the stack; use the new stack frame structure.
# (ZCM 8/27/1999) Added infrastructure for arbitrary array subscripts

       subroutine parsubd(ns)
Use(Stacks)
Use(Controls)
Use(Actions)
       integer ns
       integer structg
       Address paraddr
       external structg,paraddr,parsubc,kaboom,parget,parcopy,utcat
       integer parmove, imkstr
       Address parfwa
       external parmove, parfwa, imkstr
       integer tc, ilow(7), ihi(7), icol(7), si(7), isub, imax, imin
       Address fwa, dest
       integer n0,i,ierr,lcomma, ival
       integer t(SSWIDTH)
       character*OUTLINE errmsg
       character*(16) titem
       integer ntitem
       Address pstr
       Address subarr (7)    # Put addresses of subscript arrays here
       integer lsubarr (7)   # Lengths of the subscript arrays

#### if there are no subscripts, or all are defaulted, (and BTW we know
#### this isn't a function call) then subscripting does nothing
       if( ns = 0 | ns == 1 & ss (TC, rlinkp + 1) == NULL_TYPE) return
       fwa = paraddr(ss(1, rlinkp-1))
       n0 = ss(N, rlinkp - 1)
       do i = 1, n0
          ilow(i) = ss(M1-1+i, rlinkp - 1)
          ihi(i) = ss(M1-1+i, rlinkp - 1) - 1 + ss(N1-1+i, rlinkp - 1)
          icol(i) = ss(N1-1+i, rlinkp - 1)
          si(i) = ss(I1-1+i, rlinkp - 1)
       enddo
       tc = ss(TC, rlinkp - 1)

#      parsubc parfetches all the subscripts and applies them to ss(.,rlinkp-1)
       call parsubc(ns)
       if(ns == 0)return

# Get addresses of subscript arrays for parmove, if any
       do i = 1, 7
          if (i <= ns & ss (N1 - 1 + i, rlinkp -1) == DEFAULT + 1) then
             subarr (i) = paraddr (bassubs (1, ss (M1 - 1 + i, rlinkp - 1)))
             lsubarr (i) = bassubs (N1, ss (M1 - 1 + i, rlinkp - 1))
          else
             subarr (i) = 0
             lsubarr (i) = 0
          endif
       enddo

#  SUBSCRIPTING **********************************
#
# Assumptions:
#   1>=ns>=7
#   ss(., rlinkp-1) contains entries in its NS, N1...I7 components giving the
#   ns subscripts desired, some of which may be DEFAULT
#   Arrays ilow, ihi, icol, si and scalar n0 contain a description of the
#   object to be subscripted, and fwa points to it.
#
        if(tc == STRUCTURE) go to 20100
# 1. Check for bad input
# too many subscripts
        if( ns > n0) then
	    if( ns = 1 & n0 = 0) then  #allow for (1) on scalars
		n0 = 1
		ilow(1) = 1
		ihi(1) = 1
		icol(1) = 1                        
		si(1) = 1
	    else
                if (lxp(rlinkp-1) > 42) lxp(rlinkp-1) = 42
                write(errmsg,20995)nxp(rlinkp-1)(1:lxp(rlinkp-1))
                call baserror(errmsg)
		write(errmsg,90) n0,ns
                call baserror(errmsg)
90              format("Expression with ",i1," dimension(s) has ", i1, " subscripts.")
        if(debug == YES)then
            call kaboom(1)
        else
            call kaboom(0)
        endif
	    endif
	endif
# Fill in defaulted subscripts
# the unsupplied ones are treated as taking the lower bound
# check lower subscript <= upper; take into account negative strides i.e. 4:2:-1
	do i=1, ns
            if (lsubarr (i) ~= 0) then # this is an array subscript
		t (N1 - 1 + i) = lsubarr (i)
                t (M1 - 1 + i) = 1
                t (I1 - 1 + i) = 1
                # make sure array subscripts are in range.
                call iaminmax (subarr (i), lsubarr (i), imin, imax)
                if (imin < ilow (i) | imin > ihi (i)) then
                    errmsg = "Min. array subscript out of range."
                    ival = imin
                    ierr = i
                    go to 20999
                endif
                if (imax < ilow (i) | imax > ihi (i)) then
                    errmsg = "Max. array subscript out of range."
                    ival = imax
                    ierr = i
                    go to 20999
                endif
            else                       # regular subscript
		if(ss(N1-1+i,rlinkp-1) == DEFAULT) ss(N1-1+i,rlinkp-1) = ilow(i)
		if(ss(M1-1+i,rlinkp-1) == DEFAULT) ss(M1-1+i,rlinkp-1) = ihi(i)
		if(ss(I1-1+i,rlinkp-1) == DEFAULT) ss(I1-1+i,rlinkp-1) = 1
		t(N1-1+i) = (ss(M1-1+i,rlinkp-1) - \
                   ss(N1-1+i,rlinkp-1))/ss(I1-1+i,rlinkp-1) + 1
		t(M1-1+i) = ss(N1-1+i,rlinkp-1)
		t(I1-1+i) = ss(I1-1+i, rlinkp - 1)*si(i)
                ss(M1-1+i, rlinkp - 1) = ss(N1-1+i, rlinkp - 1) + \
                   (t(N1-1+i) - 1) * ss(I1-1+i, rlinkp - 1)
	        if(t(N1-1+i) < 0) then
                   errmsg = "Improper subscripts."
                   ival = t(N1-1+i)
                   ierr = i
                   go to 20999
		endif
                if(ss(I1-1+i, rlinkp - 1) > 0) then
                   if(ss(M1-1+i, rlinkp - 1) > ihi(i)) then
		       errmsg = "Subscript too large."
                       ival = ss(M1-1+i, rlinkp - 1)
                       ierr = i
                       go to 20999
		   endif
                   if( ss(N1-1+i, rlinkp - 1) < ilow(i)) then
		       errmsg = "Subscript too small."
                       ival = ss(N1-1+i, rlinkp - 1)
                       ierr = i
                       go to 20999
                   endif
		else
                   if(ss(M1-1+i, rlinkp - 1) < ilow(i)) then
		       errmsg = "Subscript too small."
                       ival = ss(M1-1+i, rlinkp - 1)
                       ierr = i
                       go to 20999
		   endif
                   if( ss(N1-1+i, rlinkp - 1) > ihi(i)) then
		       errmsg = "Subscript too large."
                       ival = ss(N1-1+i, rlinkp - 1)
                       ierr = i
                       go to 20999
                   endif
		endif
            endif
	enddo i
        if( symbolic) then
		call utcat(nxp(rlinkp-1),lxp(rlinkp-1),nxp(rlinkp-1),
                     lxp(rlinkp-1), "(", 1, BLANK, 0)
		lcomma = 0
		do i=1, ns
                       call utcat(nxp(rlinkp-1),lxp(rlinkp-1),nxp(rlinkp-1),
                            lxp(rlinkp-1), ",", lcomma, " ", 0)
                       call utcat(nxp(rlinkp-1),lxp(rlinkp-1),nxp(rlinkp-1),
                            lxp(rlinkp-1), nxp(rlinkp+i),lxp(rlinkp+i)," ",0)
		       lcomma = 1
		enddo
		call utcat(nxp(rlinkp-1),lxp(rlinkp-1),
		nxp(rlinkp-1),lxp(rlinkp-1),")",1," ",0)
        endif
# now get the data
	t(N) = ns            # dimension of result is <= ns
	t(TC) = tc
        if ( tc < 0 ) t(NAML) = 1 #force chars to lit table (ZCM 5/9/95)
	call parget(t)       # get space for data
	dest = paraddr(t)    # get address of this space
        #copy data to t's addr
	if(parmove(dest,fwa,tc,ns,ilow,ihi,icol, ss(N1, rlinkp - 1),ss(M1, rlinkp - 1),
	       ss(I1, rlinkp - 1), subarr, lsubarr) == ERR) call kaboom(0)
#       Get rid of any subscript arrays no longer needed
        do i = 1, ns
           if (ss (N1 - 1 + i, rlinkp -1) == DEFAULT + 1) then
              isub = ss (M1 - 1 + i, rlinkp - 1)
              bassubs (N1 + 1, isub) = bassubs (N1 + 1, isub) - 1
              if (bassubs (N1 + 1, isub) == 0) then
                 # reference count reached 0, so release
                 call parrel (bassubs (1, isub))
                 bassubs (TC, isub) = NULL_TYPE
              endif
           endif
        enddo
#       now can safely release name
	call parkill(ss(1, rlinkp - 1))
#       and replace it with value
	call parcopy(t,ss(1, rlinkp - 1))
        return
20100   continue
# structure references
	if( ns > 1|ss(N1,rlinkp-1)<>ss(M1,rlinkp-1)|ss(N1,rlinkp-1)<0 |ss(I1,rlinkp-1)<>1) then
	    errmsg="Improper subscripting of a structure."
        ival = 99
	    ierr = 0
	    go to 20999
	endif
        if( symbolic) then
	    call utcat(nxp(rlinkp-1),lxp(rlinkp-1),nxp(rlinkp-1), lxp(rlinkp-1), "(", 1, BLANK, 0)
	    ntitem = imkstr(ss(N1,rlinkp-1),titem)
	    call utcat(nxp(rlinkp-1),lxp(rlinkp-1),nxp(rlinkp-1),lxp(rlinkp-1),titem,ntitem,")",1)
        endif
        dest = parfwa(fwa, tc, ns, ilow, ihi, icol, ilow)
# structg needs to be passed the structure to extract a piece
# extract the piece into ss
	pstr = dest
	if (structg(pstr,ss(N1,rlinkp-1),ss(1, rlinkp -1), FALSE) == ERR) call kaboom(0)
        return
20999   continue
#error handler
        call baserror(errmsg)
        if(debug==NO) call kaboom(0)
        if (lxp(rlinkp-1) > 42) lxp(rlinkp-1) = 42
        write(errmsg,20995)nxp(rlinkp-1)(1:lxp(rlinkp-1))
        call baserror(errmsg)
        write(errmsg,20996) n0
        call baserror(errmsg)
        if(ierr > 0) then
           write(errmsg,20997) ierr,ival
           call baserror(errmsg)
           if(n0>0) then
              call baserror("Its lower and upper subscripts, "// \
                            "and total range in each dimension follow:")
              do i=1, n0
                 write(errmsg,20998) ilow(i), ihi(i), icol(i)
                 call baserror(errmsg)
              enddo
           endif
        endif
        call kaboom(1)
20995   format("parsubd: trouble with object named '",a,"'.")
20996   format("The object in question has dimension ",i2,".")
20997   format("Error is in subscript ",i2," (value given",i7,").")
20998   format(3i7)

       end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

# PARSUBF
#
# Programmed by : Zane C. Motteler
# Date          : August 1989
# Purpose       : Handle the reduction <lhs> ::= <lhs> <args> when it is a
#                 function call. The function is called and returns with a
#                 data object at location rlinkp-1 of the stack.
# Parameters    :
#                 pcnext--current pc plus 1, but could be set to something
#                         else by a call to a user-defined function
#                 ns--the number of subscripts in <args>
#
#       Revised by ZCM 8/89 -- in recursion cleanup, remove superfluous
#                              arguments to parxfcn
#
# Revised: October 1989
#       improved error printouts when debug is on
# (ZCM 8/10/1999) Eliminated all arguments but ns; use global runtime stack
# and link pointers to access the stack; use the new stack frame structure.

       subroutine parsubf(pcnext, ns)
Use(Actions)
Use(Stacks)
      integer pcnext, ns
      integer lcomma, i, j

      external utcat, parxfcn

      if(symbolic) then
         if (ns >= 1) then
            call utcat(nxp(rlinkp-1),lxp(rlinkp-1),
                       nxp(rlinkp-1), lxp(rlinkp-1), "(", 1, BLANK, 0)
            lcomma = 0
            do i=1, ns
               j = rlinkp + i
               call utcat(nxp(rlinkp-1),lxp(rlinkp-1),
                          nxp(rlinkp-1),lxp(rlinkp-1),",",lcomma,nxp(j),lxp(j))
               lcomma = 1
             enddo
             call utcat(nxp(rlinkp-1),lxp(rlinkp-1),
             nxp(rlinkp-1),lxp(rlinkp-1),")",1," ",0)
          endif
       endif
#      if( ss(NS,sp) == 1 & ss(TC,sp+1) == NULL_TYPE) ss(NS,sp) = 0
       # pop stack if there's one parameter but it's NULL_TYPE.
       if(rsp-rlinkp == 1 & ss(TC,rsp)==NULL_TYPE)rsp = rsp - 1
       call parxfcn(pcnext)
       return
       end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

# PARFETCH
#
# Parameters:
#       si:  stack element
#       addrflg  : if TRUE then set stack element TARG's pointer to the true
#                   data (and not a copy), else TARG contains a copy.
#        vname, nvname -- symbolic equivalent
#        Assumes these already have the base if symbolic is true
#
# Purpose:
#       turn a LHS into a stack object 
#       if not of type LHS return
#
#        Call kaboom if any problem
# Revised by : Zane C. Motteler
# Date       : August 1989
# Purpose    : To prevent 'parfetch' from actually copying data to a new
#              dynamic area, if the data is consecutive in memory, and only
#              its values are needed.
#              It is consecutive in memory if the first k subscripts are
#              for the full range, the k + 1st is any subrange, and the
#              subscripts from k + 2 to ns are singles. 
#              This is controlled by 'status', as follows:
#              NODATA: don't need a data address at all, just gather
#                      subscript and type info.
#              ACTUAL: get a pointer to the actual data if it is consecutive.
#                      copy it to dynamic storage if not.
#              COPY  : copy the data to dynamic storage in any event.
# Revised: October 1989
#       improved error printouts when debug is on
# Bug Fix: January/February 1990 (ZCM)
#       Was computing offsets into ACTUAL character arrays wrong; revised
#       by using making COPY (parcho alone doesn't work on Crays)
# Enhancement: August 1990 (ZCM)
#	Once a variable has been parfetched, s(NAMESLOT) is no longer used.
#		I am placing a pointer to the variable's name in this field.
#		This will aid in diagnosing assignment errors.
# New parameter: September 1991 (ZCM)
#       The new parameter nocat (if TRUE) suppresses the calls to utcat.
#       This is necessary because sometimes these calls destroy perfectly
#       good information about fireign names.
# Added capability of using an array of subscripts on a 1-d array
#       8/1/97 (ZCM)
# Revised to allow for arbitrary 1d arrays of subscripts.
#       9/1/1999 (ZCM)
#
# Altered : 7/91 (ZCM) encapsulating database manipulations in rtd
# (FNF 7/29/97) Changed "write(STDERR,..." statements to "call baserror".
# (FNF 7/31/97) Changed "call remark" statements to "call baserror".

        subroutine parfetch(si, vname, nvname, status, nocat)
        integer si(SSWIDTH)
        character*(*) vname
        integer nvname, status
        logical nocat

Use(Controls)
Use(Actions)
Use(Stacks)

        logical consec, subrange, noconsec
        integer totalne, structg
        integer jvar,ndb
        integer tc, ilow(7), ihi(7), icol(7), ia (7)
        integer n0, ns, i, ival, ierr
        integer t(7), sx(SSWIDTH)
        integer ntitem, nb
        integer lsubarr (7), imin (7), imax (7)
        integer ibs # points to bassubs
        Address ib(7)
        Address dest, fwa
        Address pstr, psrc, ptar
        Address subarr (7)
        character*OUTLINE errmsg
        character*(16) titem

        integer getlock
        external getlock
        integer parmove, imkstr, utsizeof, parlen, parcho, rtkey
        integer getkill
        Address paraddr
        Address parfwa
        external parmove, parfwa, imkstr, paraddr, utsizeof, parcopy,
                 parget, pargetc, parrel, parlen, parcho, rtkey, getkill
        external structg, smovatoa

        data ia /7*0/, ib /7*0/

        if (si(TC) <> LHS)then
# return if this is the kind of type that really doesn't have storage
             if(getkill (si) == 0) return
# return if this is a string--s(PTR) already tells how to find it
             if(si(TC) < 0) return
             if(getlock(si) == LOCKED)then
                if(status == ACTUAL)then
#                  it's already been parfetched and we won't change it
                   return
                elseif(status == COPY)
#                  it's locked so we need a disposable copy
                   call parcopy(si, sx)
                   call parget(sx)
                   psrc = paraddr(si)
                   ptar = paraddr(sx)

                   nb = CHAR_PER_WORD*utsizeof(parlen(si), si(TC))
                   call smovatoa(ptar, 0, psrc, 0, nb)

                   call parrel(si)
                   call parcopy(sx, si)
                   return
                else
                   return
                endif
             else
#               it's not locked so it's already a copy.
                return
             endif
        endif
        if(si(N) == UNKNOWN) then   #unresolved name
             call unknownv(si)
             call kaboom(1)
        endif
        ns = si(NS)
#  get attributes
        ndb = si(N)
        tc = si(TCSAVE)
        jvar = si(PTR)
	si(NAMESLOT)=rtkey(jvar, ndb) #caution, TCSAVE == NAMESLOT
        call rtxdb(jvar,ndb,fwa,n0,ilow,ihi,icol,LIMITED)
# rtxdb always finds the variable's name (if it's non-foreign).
# unset dynamic array
        if(status ~= NODATA & fwa == NOTSET) then
	       call utgetnm(jvar, ndb, vname, nvname)
               if (nvname > 49) nvname = 49
               errmsg = 
               "Variable "//vname(1:nvname)// \ 
               " is dynamic with unset pointer."
               ierr = 0
               ival = 99
               go to 20999
        endif
	if( ns == 0) then  #fetch entire array
#		storage is consecutive, so if status is ACTUAL, don't copy it.
# but...watch out for case when there is a limiting string
            consec = TRUE
            si(TC) = tc
            si(N) = n0
	    do i=1, n0
		    si(N1-1+i) = ihi(i) - ilow(i) + 1
		    si(M1-1+i) = ilow(i)
		    si(I1-1+i) = 1
		    if(si(N1-1+i)<>icol(i)) consec=FALSE
	    enddo
            if(status == ACTUAL & consec) then
               call pargetc(si,fwa)
            elseif(status <> NODATA)then
               call parget(si)
               dest = paraddr(si)
	       if(parmove(dest,fwa,tc,n0,ilow,ihi,icol,ilow,ihi,si(I1), ib, ia) == ERR)
                   call kaboom(0)  
	    else # no data so make sure the pointer cell is 0
	       si(PTR) = 0
            endif
	    return
	endif
#  SUBSCRIPTING **********************************
#
# Assumptions:
#   1>=ns>=7
#   si contains entries in its si(NS), si(N1)...si(I7) components giving the
#   ns subscripts desired, some of which may be DEFAULT
#   Arrays ilow, ihi, icol, and scalar n0 contain a description of the
#   object to be subscripted, and fwa points to it.
#
# 8/5/97 ZCM : Added a sort of reference count to bassubs to keep
#              it from being parrel'ed prematurely (2 or more stack elts
#              are using it)
        if(tc == STRUCTURE) go to 20100

# 1. Check for bad input
# too many subscripts
        if( ns > n0) then
	    if( ns = 1 & n0 = 0) then  #allow for (1) on scalars
		n0 = 1
		ilow(1) = 1
		ihi(1) = 1
		icol(1) = 1                        
	    else
	        call utgetnm(jvar, ndb, vname, nvname)
                if (nvname > 40) nvname = 40
                write(errmsg,20995)vname(1:nvname)
                call baserror(errmsg)
		write(errmsg,90) n0,ns
                call baserror(errmsg)
90              format("Expression with ",i1," dimension(s) has ", i1, " subscripts.")
        if(debug == YES)then
            call kaboom(1)
        else
            call kaboom(0)
        endif
	    endif
	endif
# Fill in defaulted subscripts
        si (TC) = tc
           # put true subscripts in si for later parrel
# the unsupplied ones are treated as taking the lower bound
#check lower subscript <= upper; take into account negative strides i.e. 4:2:-1
	do i=ns+1, n0
		if(icol(i) == 0) then
		   if(debug==YES)call utgetnm(jvar, ndb, vname, nvname)
		   errmsg = "Trying to subscript zero-length array"
		   ierr = i
		   ival = ilow(i)
		   go to 20999
		endif
	enddo
# Get addresses of subscript arrays for parmove, if any
        do i = 1, 7
           if (i <= ns & si (N1 - 1 + i) == DEFAULT + 1) then
              subarr (i) = paraddr (bassubs (1, si (M1 - 1 + i)))
              lsubarr (i) = bassubs (N1, si (M1 - 1 + i))
           else
              subarr (i) = 0
              lsubarr (i) = 0
           endif
        enddo

	totalne = 1
	subrange = FALSE
	noconsec = FALSE
                	
	do i=1, ns
           if (si (N1 - 1 + i) == DEFAULT + 1) then
#             # This subscript is an arbitrery 1d array
              noconsec = TRUE
              totalne = totalne * lsubarr (i)
#             # t array gets lengths in each dimension
              t (i) = lsubarr (i)
#             # move subscript into bassubs to I1 element for later parrel
              si (I1 - 1 + i) = si (M1 - 1 + i)
#             # set M1 element to DEFAULT +1, signal for 1d subscript array
              si (M1 - 1 + i) = DEFAULT + 1
#             # set N1 element to size in each dimension for parget
              si (N1- 1 + i) = lsubarr (i)
              # make sure array subscripts are in range.
              call iaminmax (subarr (i), lsubarr (i), imin (i), imax (i))
              if (imin (i) < ilow (i) | imin (i) > ihi (i)) then
                  if (debug == YES) call utgetnm (jvar, ndb, vname, nvname)
                  errmsg = "Min. array subscript out of range."
                  ival = imin (i)
                  ierr = i
                  go to 20999
              endif
              if (imax (i) < ilow (i) | imax (i) > ihi (i)) then
                  if (debug == YES) call utgetnm (jvar, ndb, vname, nvname)
                  errmsg = "Max. array subscript out of range."
                  ival = imax (i)
                  ierr = i
                  go to 20999
              endif
           else
		if(si(N1-1+i) == DEFAULT) si(N1-1+i) = ilow(i)
		if(si(M1-1+i) == DEFAULT) si(M1-1+i) = ihi(i)
		if(si(I1-1+i) == DEFAULT) si(I1-1+i) = 1
		ne = (si(M1-1+i) - si(N1-1+i))/si(I1-1+i) + 1  #new number of elts
	        if(ne < 0) then
		   if(debug==YES)call utgetnm(jvar, ndb, vname, nvname)
                   errmsg = "Improper subscripts."
                   ierr = i
                   ival = ne
                   go to 20999
		endif
                si(M1-1+i) = si(N1-1+i)   #"low" subscript
                t(i) = si(M1-1+i)+(ne-1)*si(I1-1+i)  #"hi" subscript
                si(N1-1+i) = ne   #column length
                if(si(I1-1+i) ~= 1)noconsec = TRUE
                if(si(I1-1+i) > 0) then
                   if(t(i) > ihi(i)) then
		       if(debug==YES)call utgetnm(jvar, ndb, vname, nvname)
		       errmsg = "Subscript too large."
                       ierr = i
                       ival = t(i)
                       go to 20999
		   endif
                   if( si(M1-1+i) < ilow(i)) then
		       if(debug==YES)call utgetnm(jvar, ndb, vname, nvname)
		       errmsg = "Subscript too small."
                       ival = si(M1-1+i)
                       ierr = i
                       go to 20999
                   endif
                   if(~subrange)then
                       subrange = ((t(i).ne.ihi(i)).or.(si(M1-1+i).ne.ilow(i)))
                   else
                       totalne = totalne * ne
                   endif
		else
                   if(t(i) < ilow(i)) then
		       if(debug==YES)call utgetnm(jvar, ndb, vname, nvname)
		       errmsg = "Subscript too small."
                       ival = t(i)
                       ierr = i
                       go to 20999
		   endif
                   if( si(M1-1+i) > ihi(i)) then
		       if(debug==YES)call utgetnm(jvar, ndb, vname, nvname)
		       errmsg = "Subscript too large."
                       ival = si(M1-1+i)
                       ierr = i
                       go to 20999
                   endif
                   if(~subrange)then
                       subrange = ((t(i).ne.ilow(i)).or.(si(M1-1+i).ne.ihi(i)))
                   else
                       totalne = totalne * ne
                   endif
		endif
           endif
	enddo i
	consec = ((.not.subrange).or.(totalne.eq.1)).and.(.not.noconsec)
        if( symbolic & ~nocat ) then
		call utgetnm(jvar, ndb, vname, nvname)
		call utcat(vname,nvname,vname, nvname, "(", 1, BLANK, 0)
		lcomma = 0
		do i=1, ns
                    call utcat(vname,nvname,vname,nvname,
                        ",",lcomma," ",0)
                    if (lsubarr (i) ~= 0) then
#                      1d array subscripts are written as min..max
                       ntitem = imkstr(imin(i),titem)
                       call utcat(vname,nvname,vname,nvname, \
                          titem,ntitem, " ", 0)
                       ntitem = imkstr(imax(i),titem)
                       call utcat(vname,nvname,vname,nvname, \
                          "..",2,titem,ntitem)
                    else
		       ntitem = imkstr(si(M1-1+i),titem)
                       call utcat(vname,nvname,vname,nvname,
                          titem,ntitem," ",0)
                       if(si(N1-1+i)<>1) then
			   ntitem=imkstr(t(i), titem)
			   call utcat(vname,nvname,vname,nvname,
				":",1,titem,ntitem)
			   if(si(I1-1+i) <> 1) then
				ntitem = imkstr(si(I1-1+i),titem)
				call utcat(vname,nvname,vname,nvname,
				    ":",1,titem,ntitem)
			   endif
		       endif
                    endif
                    lcomma = 1
		enddo
		call utcat(vname,nvname,
		vname,nvname,")",1," ",0)
        endif
# now get the data
	si(N) = ns            # dimension of result is <= ns
	si(TC) = tc
	if(consec & status == ACTUAL & tc >= 0)then
	    call pargetc(si,parfwa(fwa,tc,ns,ilow,ihi,icol,si(M1)))
	elseif(status~=NODATA)then
		call parget(si)       # get space for data
		dest = paraddr(si)    # get address of this space
		if(parmove(dest,fwa,tc,ns,ilow,ihi,icol, si(M1),t,
                   si(I1), subarr, lsubarr) == ERR) call kaboom(0)  #copy data to t's addr
                do i = 1, ns
                   if (lsubarr (i) ~= 0) then
                      ibs = si (I1 - 1 + i)
                      bassubs (N1 + 1, ibs) = bassubs (N1 + 1, ibs) - 1
                      if (bassubs (N1 + 1, ibs) == 0) then
                         # reference count reached 0, so release
                         call parrel (bassubs (1, ibs))
                         bassubs (TC, ibs) = NULL_TYPE
                      endif
                   endif
                enddo 
	else # NODATA -- signal for parkill
		si(PTR) = 0
	endif
        return
20100   continue
# structure references
	if( ns > 1|si(N1)<>si(M1)|si(N1)<0 |si(I1)<>1) then
	    if(debug==YES)call utgetnm(jvar, ndb, vname, nvname)
	    errmsg="Improper subscripting of a structure."
        ival = 99
	    ierr = 0
	    go to 20999
	endif
        if( symbolic & ~nocat ) then
	    call utgetnm(jvar, ndb, vname, nvname)
	    call utcat(vname,nvname,vname, nvname, "(", 1, BLANK, 0)
	    ntitem = imkstr(si(N1),titem)
	    call utcat(vname,nvname,vname,nvname,titem,ntitem,")",1)
        endif
        dest = parfwa(fwa, tc, ns, ilow, ihi, icol, ilow)
# structg needs to be passed the structure to extract a piece
# extract the piece into si
	pstr = dest
	if (structg(pstr,si(N1),si,FALSE) == ERR) call kaboom(0)
        return
20999   continue
#error handler
        call baserror(errmsg)
        if(debug==NO) call kaboom(0)
        if (nvname > 40) nvname = 40
        write(errmsg,20995)vname(1:nvname)
        call baserror(errmsg)
        write(errmsg,20996) n0
        call baserror(errmsg)
        if(ierr > 0) then
           write(errmsg,20997) ierr, ival
           call baserror(errmsg)
           if(n0>0) then
              call baserror("Its lower and upper subscripts, "// \
                            "and total range in each dimension follow:")
              do i=1, n0
                 write(errmsg,20998) ilow(i), ihi(i), icol(i)
                 call baserror(errmsg)
              enddo
           endif
        endif
        call kaboom(1)
20995   format("parfetch: trouble with object named '",a,"'.")
20996   format("The object in question has dimension ",i2,".")
20997   format("Error is in subscript ",i2," (value ",i7,").")
20998   format(3i7)
        end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c PARDIM - changes entries of a stack element to reflect its true dimensions

        subroutine pardim(t)
        integer t(*)

        integer n0, tn

        n0 = 0
        tn = t(N)
        do i = 1, tn
           if (t(N1-1+i) <> 1) then
              n0 = n0 + 1

# note that n0 <= i
              t(N1-1+n0) = t(N1-1+i)
              t(M1-1+n0) = t(M1-1+i)
              t(I1-1+n0) = t(I1-1+i)
           endif
        enddo

        t(N) = n0

        return
        end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

# PARGETSD
#
#  <dvar>::= reference <args>
# collect the dimensions of a variable being declared,
# (FNF 7/29/97) Changed "write(STDERR,..." statements to "call baserror".
# (FNF 7/31/97) Changed "call remark" statements to "call baserror".
# (ZCM 8/11/1999) No longer needs stack pointer as argument.
#                 irange is no longer dynamic

        function pargetsd()
        integer pargetsd

        character*OUTLINE errmsg
Use(Stacks)
Use(Actions)
        integer nargs, i, j, ival
        Varname parnam
        integer irange (3)
        integer parcoerc, parname, parint, idum, utsizeof
        Address paraddr
        external parcoerc, paraddr, parname, parint, utsizeof
#
        nargs = rsp - rlinkp
        ss(NS,rlinkp-1) = nargs
        do i = 1, nargs
                j = rlinkp + i
10              continue
		if(ss(TC,j)==LHS)call parfetch(ss(1,j),nxp(j),lxp(j),ACTUAL,FALSE)
                select(ss(TC,j))
                case INTEGER:
                        idum = parint(ss(1,j),ival)
                        ss(N1-1+i,rlinkp-1) = 1; ss(M1-1+i,rlinkp-1) = ival
                        call parrel(ss(1,j))
                case RANGE:
                        call smovatob (irange, 0, paraddr(ss(1,j)),
                           0, CHAR_PER_WORD*utsizeof(3,INTEGER))
                        if (irange(3) <> 1) then
                                call baserror(
     1                 "ERROR: increment field on assignment target is illegal")
                                goto 1000
                        endif

                        ss(N1-1+i,rlinkp-1) = irange(1); ss(M1-1+i,rlinkp-1) = irange(2)
                        if(irange(1) > irange(2)+1) then
                                call baserror(
                                "Left value in colon > right value+1")
                                go to 1000
                        endif
                        if(ss(N1-1+i,rlinkp-1) = DEFAULT) then
                                call baserror("Missing dimension.")
                                go to 1000
                        endif
                        if(ss(M1-1+i,rlinkp-1) = DEFAULT) then
                                call baserror("Missing dimension.")
                                go to 1000
                        endif
                        call parrel(ss(1,j))
                case NULL_TYPE:
                        call baserror("Missing dimension.")
                        go to 1000
                default:
                        if(parcoerc(ss(1,j),INTEGER) = ERR) then
                                call baserror(
                                "Subscript can't be made integer.")
                                go to 1000
                        else
                                go to 10
                        endif
                endselect
        enddo i
        return(OK)
### errors in subscripts
1000    continue
        call baserror("pargetsd: improper dimension statement.")
        idum = parname(ss(1,rlinkp-1),parnam)
        if (idum > 47) idum = 47
        write(errmsg, 100) i, parnam(1:idum)
        call baserror(errmsg)
        return(ERR)
100     format("Problem is with subscript ",i2," of ",a)
        end

	
c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

# PARSTRU0

        subroutine parstru0(sarg)
        integer sarg(*)
        Address iparg
        Address paraddr
        external paraddr
# creates an empty structure, sarg
#  1. set properties, get space for sarg
        sarg(N)=1
        sarg(TC)=STRUCTURE
        sarg(N1)=3
        sarg(M1)=1
        call parget(sarg)
#  2. initialize sarg as empty structure
        iparg=paraddr(sarg)
        call iseto (iparg, 1, STRUCTURE) #type code for structure
        call iseto (iparg, 2, 3)         #length of structure
        call iseto (iparg, 3, 0)         #number of elements
        return
        end


c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

# STRCODTX
#  returns the text corresponding to a specific structure piece code

        subroutine strcodtx(code,text)
        integer code
        character *(*) text

        select(code)
        case STRUCTURE: text= 'structure'
        default: text= ' '
        endselect
        return
        end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

# PARAMB
#
# Parameters:
#       None. See below.
#
# Purpose:
#       turn a LHS into a FWA
#       if not of type LHS error
#
#        Call kaboom if any problem
########################################################################
# (FNF 7/29/97) Changed "write(STDERR,..." statements to "call baserror".
# (FNF 7/31/97) Changed "call remark" statements to "call baserror".
# (ZCM 8.11.1999) No longer needs arguments, as it always acts on
# the stacktop.

        subroutine paramb()
Use(Stacks)
Use(Actions)
Use(Functions)
Use(Controls)

        integer structg
        Address parfwa
        integer partempc
        external structg, parfwa, partempc
        integer jvar,ndb,isub
        integer tc, n0, ilow(7), ihi(7), icol(7), ns
        Address pstr
        character*OUTLINE errmsg
        character*(16) titem
        integer ntitem, len, i
        Address dest, fwa

########
        if(ss(TC,rsp)==FUNCTION_TYPE)return
        if(ss(TC,rsp) <> LHS) then
            if (lxp(rsp) > 79) lxp(rsp) = 79
            write(errmsg,20995)nxp(rsp)(1:lxp(rsp))
            call baserror(errmsg)
	    call baserror("Improper application of address operator.")
        if(debug == YES)then
            call kaboom(1)
        else
            call kaboom(0)
        endif
	endif
	if(ss(N,rsp) == UNKNOWN) then   #unresolved name
		call unknownv(ss(1,rsp))
                call kaboom(1)
	endif
        ns = ss(NS,rsp)
#  get attributes
	ndb = ss(N,rsp)
        tc = ss(TCSAVE,rsp)
        jvar = ss(PTR,rsp)
        call rtxdb(jvar,ndb,fwa,n0,ilow,ihi,icol,FULL)
# unset dynamic array
        if(fwa == NOTSET) then
            if (lxp(rsp) > 39) lxp(rsp) = 39
	    errmsg = "Variable "//nxp(rsp)(1:lxp(rsp))//" is dynamic with unset pointer."
            ival = -1
            ierr = 0
            go to 20999
        endif
	if( ns == 0 | ns == 1 & ss (N1,rsp) == DEFAULT + 1) then
        #fetch entire array (no subscript, or an array of them)
            ss(TC,rsp) = FWA
            ss(PTR,rsp) = partempc(fwa)
            if (ns == 0) then
               # Get actual length of the array
               len = 1
               do i = 1, n0
                  len = len * icol (i)
               enddo
               ss(N1, rsp) = len
            elseif (ns == 1) then
               isub = ss (M1,rsp)
               ## The following are necessary for builtin cumaddin:
               bassubs (N1 + 2, isub) = ilow (1)
               bassubs (N1 + 3, isub) = ihi (1)
            endif
	    return
	endif
#  SUBSCRIPTING FOR FWA **********************************
#
# Assumptions:
#   1>=ns>=7
#   ss(.,rsp) contains entries in its NS, N1...I7 components giving the
#   ns subscripts desired, some of which may be DEFAULT
#   Arrays ilow, ihi, icol, ss(.,rsp) and scalar n0 contain a description of the
#   object to be subscripted, and fwa points to it.
#
        if(tc == STRUCTURE) go to 20100
# 1. Check for bad input
# too many subscripts
        if( ns > n0) then
	    if( ns = 1 & n0 = 0) then  #allow for (1) on scalars
		n0 = 1
		ilow(1) = 1
		ihi(1) = 1
		icol(1) = 1                        
	    else
                if (lxp(rsp) > 39) lxp(rsp) = 39
                write(errmsg,20995)nxp(rsp)(1:lxp(rsp))
                call baserror(errmsg)
		write(errmsg,90) n0,ns
                call baserror(errmsg)
90              format("Expression with ",i1," dimension(s) has ", i1, " subscripts.")
		call kaboom(1)
	    endif
	endif
# Fill in defaulted subscripts
# the unsupplied ones are treated as taking the lower bound
#check lower subscript <= upper; take into account negative strides i.e. 4:2:-1
	do i=ns+1, n0
		if(icol(i) == 0) then
		   errmsg = "Trying to subscript zero-length array"
		   ierr = i
		   ival = ilow(i)
		   go to 20999
		endif
	enddo
	do i=1, ns
		if(ss(N1-1+i,rsp) == DEFAULT) ss(N1-1+i,rsp) = ilow(i)
		if(ss(M1-1+i,rsp) == DEFAULT) ss(M1-1+i,rsp) = ihi(i)
		if(ss(I1-1+i,rsp) == DEFAULT) ss(I1-1+i,rsp) = 1
		if(ss(M1-1+i,rsp) <> ss(N1-1+i,rsp) ) then
                   if (lxp(rsp) > 39) lxp(rsp) = 39
                   if (ns > 0 & ss(N1-1+i,rsp) == DEFAULT + 1) then
                      call baserror(
           "If a subscript is an array, it must be the only subscript.")
                   else
                      call baserror(
                        "Range not allowed in address calculation.")
                   endif
                   write(errmsg,20995)nxp(rsp)(1:lxp(rsp))
                   call baserror(errmsg)
                   call kaboom (0)
		endif
                if(ss(I1-1+i,rsp) == 1) then
                   if(ss(N1-1+i,rsp) > ihi(i)) then
		       errmsg = "Subscript too large."
                       ival = ss(N1-1+i,rsp)
                       ierr = i
                       go to 20999
		   endif
                   if( ss(N1-1+i,rsp) < ilow(i)) then
		       errmsg = "Subscript too small."
                       ival = ss(N1-1+i,rsp)
                       ierr = i
                       go to 20999
                   endif
		else
                   call baserror("Stride not allowed in address calculation.")
                   if (lxp(rsp) > 39) lxp(rsp) = 39
                   write(errmsg,20995)nxp(rsp)(1:lxp(rsp))
                   call baserror(errmsg)
                   call kaboom (0)
		endif
	enddo i
        if( symbolic) then
		call utcat(nxp(rsp),lxp(rsp),nxp(rsp), lxp(rsp), "(", 1, BLANK, 0)
		lcomma = 0
		do i=1, ns
		       ntitem = imkstr(ss(N1-1+i,rsp),titem)
		       call utcat(nxp(rsp),lxp(rsp),nxp(rsp),lxp(rsp),
			    ",",lcomma,titem,ntitem)
		       lcomma = 1
		enddo
		call utcat(nxp(rsp),lxp(rsp),nxp(rsp),lxp(rsp),")",1, BLANK, 0)
        endif
        dest = parfwa(fwa, tc, ns, ilow, ihi, icol, ss(N1,rsp))
        ss(PTR,rsp) = partempc(dest)
        #call pargetc(si,dest)
        ss(TC,rsp) = FWA
	return
20100   continue
# structure references
	if( ns > 1|ss(N1,rsp)<>ss(M1,rsp)|ss(N1,rsp)<0 |ss(I1,rsp)<>1) then
	    errmsg="Improper subscripting of a structure."
        ival = 99
	    ierr = 0
	    go to 20999
	endif
        if( symbolic) then
		call utcat(nxp(rsp),lxp(rsp),nxp(rsp), lxp(rsp), "(", 1, BLANK, 0)
		ntitem = imkstr(ss(N1,rsp),titem)
	        call utcat(nxp(rsp),lxp(rsp),nxp(rsp),lxp(rsp),titem,ntitem,")",1)
        endif
        dest = parfwa(fwa, tc, ns, ilow, ihi, icol, ilow)
# structg needs to be passed the structure to extract a piece
# extract the piece into ss(.,rsp)
	pstr = dest
	if (structg(pstr,ss(N1,rsp),ss(1,rsp),TRUE) == ERR) call kaboom(0)
        return
20999   continue
#error handler
        call baserror(errmsg)
        if(debug==NO) call kaboom (0)
        if (lxp(rsp) > 39) lxp(rsp) = 39
        write(errmsg,20995)nxp(rsp)(1:lxp(rsp))
        call baserror(errmsg)
        write(errmsg,20996) n0
        call baserror(errmsg)
        if(ierr > 0) then
           write(errmsg,20997) ierr, ival
           call baserror(errmsg)
           if(n0>0) then 
              call baserror("Its lower and upper subscripts, and total range in each dimension follow:")
              do i=1, n0
                 write(errmsg,20998) ilow(i), ihi(i), icol(i)
                 call baserror(errmsg)
              enddo
           endif
        endif
        call kaboom(1)

20995	format("paramb: trouble with object named '",a,"'.")
20996   format("The object in question has dimension ",i2,".")
20997   format("Error is in subscript ",i2," (value ",i7,").")
20998   format(3i7)

	end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

