/*
 * tilde.c
 *
 */

#include "rt.h"

/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/

/* Resolve "~" or "~somebody"
 *  result to q
 */
void BasTilde1(char *p, char *q)
{
    struct passwd *pw;
    char *cp;
    char buf[1024], name[501];
    char errmsg[80];

    while (isspace(*p))
        ++p;
    if ('~' == *p) {
        if ('/' == *++p || '\0' == *p) {        /* This user's HOME directory */
            if ((pw = getpwuid(getuid())) == (struct passwd *) 0) {
                sprintf(errmsg, "Can't find your HOME directory!");
                BasError(errmsg, strlen(errmsg));
                return;
            }
        } else {                /* Some other user's HOME directory */
            if ((cp = strchr(p, '/')) == (char *) 0) {
                p = strcpy(name, p);
            } else {
                (void) strncpy(name, p, cp - p);
                name[cp - p] = '\0';
                p = cp;
            }
            if ((pw = getpwnam(name)) == (struct passwd *) 0) {
                sprintf(errmsg, "Can't find HOME directory for %s!", p);
                BasError(errmsg, strlen(errmsg));
                return;
            }
            if (!cp)
                *p = '\0';
        }
        (void) strcpy(buf, pw->pw_dir);
        (void) strcat(buf, p);
        p = buf;
    }
    if (strlen(p) > strlen(q)) {
        sprintf(errmsg, "HOME directory name too long for Basis");
        BasError(errmsg, strlen(errmsg));
        return;
    }
    strcpy(q, p);
}

/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/

#ifdef TEST
/* Typical compile line: "cc -o mycd -D$CPU -DTEST thisfile.c"  */
/* Test usage: "./mycd;./mycd /usr/local"       */
main(int a, char *b[])
{
    void BasTilde1();
    char c[501];

    if (1 == a) {
        BasTilde1("H_o_m_E", c);
    } else {
        BasTilde1(*++b, c);
    }
    printf("%s\n", c);
    exit(0);
}
#endif

/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
