/*
 * timedate.c
 */

#include "rt.h"

/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/

void Timedate(char *runtime, char *rundate, char *runmach, integer len)
{
    time_t current_time;
    struct tm *thetime;
    struct utsname sysname;
    char fmt[MAXLINE];
    char *question = "(" "?" "?" "?" ")";       /* (Avoid ANSI trigraphs.) */

    (void) time(&current_time);
    thetime = localtime(&current_time);

    sprintf(fmt, "%%H:%%M:%%S");
    if (len != strftime(runtime, len + 1, fmt, thetime)) {
        (void) strncpy(runtime, question, len);
        runtime[len] = '\0';
    }

    sprintf(fmt, "%%m/%%d/%%y");
    if (len != strftime(rundate, len + 1, fmt, thetime)) {
        (void) strncpy(rundate, question, len);
        rundate[len] = '\0';
    }

    if (uname(&sysname) != -1) {
        (void) strncpy(runmach, sysname.machine, len);
    } else {
        (void) strncpy(runmach, question, len);
    }
    runmach[len] = '\0';
}

/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
