# Basis Code Development System
# Copyright 1986 The Regents of the University of California

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

        subroutine badstr(caller,str,bad)
#reports bad string input
#str is the bad string, caller is the name of the calling routine
#bad is an index into str which is the bad character
#if bad is zero, it is set to the last character
        Ch(*) caller,str
        Ch(OUTLINE) blanks
        Ch(OUTLINE-1) lstr
        integer bad
#
#
        blanks=BLANK
        lstr=caller
        call remark("Bad string detected in "//lstr(1:8))
        lstr=str
        call remark(lstr)
        l = min0(len(str),OUTLINE,bad)
        if( l <= 0 ) then
                call remark(blanks)
        else if( l == 1 )
                call remark("^")
        else
                call remark(blanks(1:l-1)//"^")
        endif
        call kaboom (0)
        return  #never returns, kaboom returns to prompt
        end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

        function charstor(n)
        integer charstor
#calculates the number of words needed to store n characters
        integer n
        if(mod(n,CHAR_PER_WORD) <> 0) then
                return((n/CHAR_PER_WORD)+1)
        else
                return(n/CHAR_PER_WORD)
        endif
        end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

        function ctoi(c)
        character c
        integer ctoi
        return(ichar(c)-ichar('0'))
        end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

      subroutine utftxout(unit,jvar,ndb)
      integer unit, jvar, ndb
####################################################################
#      Written by Zane C. Motteler
#      30 August 1993
#      Purpose--to print out the text of a function
#                8 September 1993 added unit number & msg
####################################################################
      Use(Lrh1)
      Address text
      integer i, j, ln, size, j1
      character*(MAXLINE)msg
      external baswline,utgetcl,rtgftext, streqchf
      integer utgetcl, streqchf
      Address rtgftext
      text = rtgftext(jvar,ndb,size)
      if ( size == 0 | text == NOTSET ) then
         call remark ( "...Sorry, function seems to have no text.")
         call remark ( "   (Perhaps it was read in from a binary save file.)")
         return
      endif
      ln = 1
      i = 1
      j = 1
      while ( j <= size )
              while (streqchf (text, j-1, char(peol), 1) <> 1)
                      j = j + 1
		      if ( j > size ) break
              endwhile
              msg = " "
              if ( i < j)then
                      j1 = min(73,j-i)
                      call smovatof (msg,6,text,i-1,j1)
                      write(msg(1:6),1409)ln
                      call baswline(unit,msg)
                      while(i+j1 < j)
			i = i+j1
                        j1 = min(79,j-i)
                        msg = " "
                        call smovatof (msg,0,text,i-1,j1)
                        call baswline(unit,msg)
                      endwhile
              endif
              ln = ln + 1
              i=j+1
              j=i
      endwhile
      return
1409    format(i4,": ")
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

      subroutine utskipbl(str,i)
      character*(*) str
      integer i,j

      j = len(str)
      while (i < j)
	 if (str(i:i) .ne. " ") return
	 i = i + 1
      endwhile

      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

        function strtoi(numstr)
#returns value of str as an integer
#carefully checks for legal string
        integer strtoi
        Ch(*) numstr
        character*8 str
        Ch    x
        integer i,ans,sign,ctoi
        external ctoi
#
#
        str = numstr
        sign = 1
# skip leading blanks
        i = 1
        call utskipbl(str,i)
        if ( i > len(str) )
                return(0) #return zero for blank string
# check for leading sign
        if (str(i:i)=="-" | str(i:i) == "+")  then
                if(str(i:i) == "-") sign = -1
                i=i+1
        endif
        ans = 0
        for( , i<=len(str) , i=i+1)
                x = str(i:i)
                if( x == BLANK )
                        break
# check that everything before next blank is in range 0-9
                if ( x >= "0" & x <= "9")  then
                        ans = ans*10 + ctoi(x)
                else
                        call remark("Error in converting string to integer")
                        call badstr("strtoi",str,i)
                endif
        endfor
        return(ans*sign)
        end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

        function utchlen(typestr)
#calculates n where typestr contains the string
#character, character*n or character*(n) where n is an integer.
#note that n cannot be an integer expression.
        integer utchlen, i
        integer strtoi,j,jlast,jfirst
        external strtoi
        Ch(*)   typestr
	Ch(TYPESIZE) badtype
#
        if(Index(typestr,"character") >0 ) then
                i=Index(typestr,"*")
                if( i == 0) then
                        j = 1 #no asterisk, length is 1
                else
#distinguish between character*n and character*(n)
#note that we do not allow an expression for n
                        jfirst=Index(typestr,"(")
                        if(jfirst  == 0 ) then
                                j=strtoi(typestr(i+1:len(typestr)))
                        else
                        #make jfirst,jlast delimit the number
                                jlast =Index(typestr,")") - 1
                                jfirst = jfirst + 1
                                if(jlast<jfirst) then
                                        call badstr("utchlen",typestr,0)
                                else if (typestr(jfirst:jlast) == "*") then
                                   call remark ("character*(*) is illegal. " // \
                                   " Replaced by character *(1).")
                                   j = 1
                                else
                                        j=strtoi(typestr(jfirst:jlast))
                                endif
                        endif
                endif
# now j is the number of characters per element
                return(j)
        endif
# should not reach here...bad input
	badtype = typestr
        call remark("Error in utchlen: type input was " // badtype)
        call kaboom (0)
        end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

        function utsizeof(nelement,typecode)
#calculates number of words occupied by nelement elements of the type
#contained in typecode.  The latter is an integer code containing
#INTEGER,REAL,COMPLEX,DOUBLE,LOGICAL or a negative number to denote a
#character var of length n.
        integer utsizeof, i
        integer charstor,nelement,j
        external charstor
        integer typecode
#
        select (typecode)
        case INTEGER,REAL,LOGICAL,STRUCTURE: return(nelement)
        case COMPLEX,DOUBLE: return(2*nelement)
ifelse(HAS_DOUBLE_COMPLEX,YES,[
        case DOUBLE_C: return(4*nelement)
],[
        case DOUBLE_C: return(2*nelement)
])
        case RANGE: return(3*nelement)
        case NULL_TYPE: return(0)
        case FWA: return(nelement*BYTES_PER_ADDRESS/CHAR_PER_WORD)
        case FUNCTION_TYPE: call remark("utsizeof called with type FUNCTION")
                  call kaboom (0)
        default:  # a character variable
                if(typecode < 0) then
#get the number of characters per element
                        j = -typecode
                        i=nelement*j                    #number of characters
                        return(charstor(i))
                else
# should not reach here...bad input
                        call remark("Error in utsizeof: bad type input.")
                        call kaboom (0)
                endif
        endselect
        return
        end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

        function utsizstr(nelement,typestr)
#calculates number of words occupied by nelement elements of the type
#contained in typestr.  The latter may contain a character string with
#the word integer, real, logical, complex, double (or double precision),
#character, character*n or character*(n) where n is an integer.
#note that n cannot be an integer expression.
        integer utsizstr,utchlen, i
        integer charstor,nelement,strtoi,j
        external charstor,strtoi,utchlen
        Ch(*)   typestr
	Ch(TYPESIZE) badtype
#
        if(typestr = "real" | typestr = "integer" | typestr = "logical")
                return(nelement)
        if(typestr = "complex" )
                return(2*nelement)
        if(typestr = "range" )
                return(3*nelement)
        if(typestr = "Address")
                return(nelement*BYTES_PER_ADDRESS/CHAR_PER_WORD)
        if(typestr = "integer*8")
                return(nelement*8/CHAR_PER_WORD)
        if(index(typestr,"double")  > 0 )then
            if(index(typestr,"complex") > 0)then
                return(4*nelement) #double complex
            else
                return(2*nelement)
            endif
        endif
        if(typestr = "null")
                return(0)
        if(index(typestr,"character") >0 ) then
#get the number of characters per element
                j = utchlen(typestr)
# now j is the number of characters per element
                i=nelement*j                    #number of characters
                return(charstor(i))
        endif
# should not reach here...bad input
	badtype = typestr
        call remark("Error in utsizstr: type input was " // badtype)
        call kaboom (0)
        end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

        subroutine uttolc(str,newstr)
#*s
#     NAME OF ROUTINE...uttolc
#
#     AUTHOR OF ROUTINE...Janet Takemoto Sept. 16, 1988
#
#     PURPOSE...
#
#        convert a string to lower case.
#
#     GLOSSARY OF IMPORTANT VARIABLES...
#
#        str      = string to convert to lower case
#        newstr   = resultant string
#
#/c
        Ch(*) str, newstr
        integer i, length

        newstr=str
# get the length of the string
        length = len(str)
# convert uppercase characters to lowercase.
        do i=1,length
           if (str(i:i) >= "A"  &  str(i:i) <=  "Z") then
              newstr(i:i)=char(ichar(str(i:i))+32)
           endif
        enddo
        return
        end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

        subroutine uttouc(str,newstr)
#*s
#     NAME OF ROUTINE...uttouc
#
#     AUTHOR OF ROUTINE...Janet Takemoto Nov. 8, 1988
#
#     PURPOSE...
#
#        convert a string to upper case.
#
#     GLOSSARY OF IMPORTANT VARIABLES...
#
#        str      = string to convert to upper case
#        newstr   = resultant string
#
#/c
        Ch(*) str, newstr
        integer i, length

        newstr=str
# get the length of the string
        length = len(str)
# convert lowercase characters to uppercase.
        do i=1,length
           if (str(i:i) >= "a"  &  str(i:i) <=  "z") then
              newstr(i:i)=char(ichar(str(i:i))-32)
           endif
        enddo
        return
        end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

        subroutine utcat(w,lw,x,lx,y,ly,z,lz)
        Ch(*) w,x,y,z
        integer lw,lx,ly,lz
# concatenate x y and z into w, using the lengths lx,ly,lz
# return lw as the new length
# o.k. if any of w,x,y,z are equivalent and lx,ly,lz may be 0.
        Ch(500) r
        integer lr, lr1, lr2, lwtot
#
        lwtot = len(w)
        lr = min(500,lwtot,lx+ly+lz)
        lr1 = min(lr,lx)
        if(lr1 > 0) then
           r(1:lr1) = x(1:lr1)
        endif
        lr2 = min(lr,lr1+ly)
        if((lr2 - lr1) > 0) then
           r(lr1+1:lr2) = y(1:(lr2-lr1))
        endif
        lw = min(lr,lr2+lz)
        if((lw-lr2) > 0) then
           r(lr2+1:lw) = z(1:(lw-lr2))
        endif
        if(lw > 0) then
           w = r(1:lw)
        else
           w = " "
        endif
        return
        end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

        real function switch(i)
Use(Controls)
        return(switches(i))
        end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

        subroutine swset(i,x)
        integer i
        real x
Use(Controls)
        switches(i)=x
        return
        end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c UTGETCL - return index of last non-blank in w or 1

        integer function utgetcl(w)
        character*(*) w

        integer nc

        nc = len(w)
	while (nc .gt. 1)
	   if (w(nc:nc) .ne. " ") break
           nc = nc - 1
        endwhile

        return(nc)
        end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

        subroutine baderr(message)
#stop code after issuing message
        Ch(*) message
#
Use(Controls)
        call remark(message)
        call oserrpop
        call alldone(1)
        end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

        subroutine remark(message)
#issue message to logfile
        Ch(*) message

        integer iooutus, utgetcl
        external iooutus, utgetcl
        integer mlen
        mlen = utgetcl(message)
        idone = 0
	while(idone<mlen)
	       ido = min(mlen, idone+OUTLINE)
               call baspline(iooutus(), message(idone+1:ido))
	       idone = ido
        endwhile
        return
        end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

      integer function lrxparse(retflg)
# Revised 8/89 (ZCM) add parameters to lrpars call
      integer lrpars, n, ptr, lxptr
      logical retflg
      external lrpars
      ptr = 0
      lxptr = 0
      return (lrpars(0,"$",0,ptr,lxptr,n,retflg))
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

    subroutine osprompt (prompt)
#*s
#     NAME OF ROUTINE...osprompt
#
#     AUTHOR OF ROUTINE...Paul Dubois, 10/24/84
#
#     PURPOSE...
#
#     set the prompt to 'prompt'
#
#     GLOSSARY OF IMPORTANT VARIABLES...
#
#    prompt   = new prompt string
#
#/c
    Ch(*) prompt

    Use(Prompt)
    gprompt = prompt
    lgprompt=min(len(gprompt),len(prompt))

    return
    end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

      subroutine paws
#
#                                  PAWS
#
# get a line from the terminal then return
#
# No change for SUN...Zane C. Motteler 6/20/88
# (FNF 8/15/97)  Rewrote to use basget for i/o.
      character*8 msg
      msg = ' '
      call basget(
         "Enter return to continue; anything else returns to prompt: ",
         msg)
      if(msg <> ' ' & msg (1:1) <> char (0)) call kaboom(-1)
      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

        subroutine parnewpr
#do the prompt
Use(Actions)
Use(Controls)
Use(Stacks)

        integer nmac , mcnum, nestpr
        external mcnum, nestpr
# if nesting level is zero, calculate prompt depending on package stack
# otherwise, send a number of >>>'s equal to the nesting level
        nmac = mcnum()
        if (nestpr () == 1) return;
# calculate and issue new prompt
# look for customized prompt
        if( lcprompt > 0 & lcprompt < 17) then
                call osprompt(cprompt(1:lcprompt))
                return
        else
# if no customized
                call osprompt("basis> ")
                return
        endif
        end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

      integer function ibasis ( name )
#*******************************************************************************
#     Programmed by: Zane C. Motteler                                          *
#     Date         : October 1989                                              *
#     Purpose      : Given the name of an integer variable, return its value   *
#*******************************************************************************
      Ch (*) name
      Varname lname
      integer jvar, ndb, type, ndim, ilow(7), ihi(7), icol(7)
      integer rtfinder, utgetcl, ivalue
      external rtfinder, utgetcl, ivalue
      Address pival

      lname = name
      if(rtfinder(lname, jvar, ndb, type, "ibasis") == ERR)then
          call kaboom(0)
      endif

      if(type ~= INTEGER)then
         call remark(
         "ibasis: variable "//lname(1:utgetcl(lname))//" is not INTEGER.")
         call kaboom(0)
      endif

      call rtxdb(jvar, ndb, pival, ndim, ilow, ihi, icol, INFO)
      if(ndim ~= 0)then
         call remark(
         "ibasis: variable "//lname(1:utgetcl(lname))//" is not SCALAR.")
         call kaboom(0)
      endif

      if(pival == NOTSET)return(0)
      return(ivalue(pival))
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

      real function rbasis ( name )
#*******************************************************************************
#     Programmed by: Zane C. Motteler                                          *
#     Date         : October 1989                                              *
#     Purpose      : Given the name of a real variable, return its value       *
#*******************************************************************************
      Ch(*) name
      Varname lname
      integer jvar, ndb, type, ndim, ilow(7), ihi(7), icol(7)
      integer rtfinder, utgetcl
      external rtfinder, utgetcl
      Address prval
      real rvalue
      external rvalue

      lname = name
      if(rtfinder(lname, jvar, ndb, type, "rbasis") == ERR)then
          call kaboom(0)
      endif

      if(type ~= REAL)then
         call remark(
         "rbasis: variable "//lname(1:utgetcl(lname))//" is not REAL.")
         call kaboom(0)
      endif

      call rtxdb(jvar, ndb, prval, ndim, ilow, ihi, icol, INFO)
      if(ndim ~= 0)then
         call remark(
         "rbasis: variable "//lname(1:utgetcl(lname))//" is not SCALAR.")
         call kaboom(0)
      endif

      if(prval == NOTSET)return(0)
      return(rvalue(prval))
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

      real(Size8) function r8basis ( name )
#*******************************************************************************
#     Programmed by: Zane C. Motteler                                          *
#     Date         : October 1989                                              *
#     Purpose      : Given the name of a real variable, return its value       *
#*******************************************************************************
      Ch(*) name
      Varname lname
      integer jvar, ndb, type, ndim, ilow(7), ihi(7), icol(7)
      Address pdval
      integer rtfinder, utgetcl
      external rtfinder, utgetcl
      real(Size8) dvalue
      external dvalue

      lname = name
      if(rtfinder(lname, jvar, ndb, type, "r8basis") == ERR)then
          call kaboom(0)
      endif

      if(type ~= ifelse(WORDSIZE,32,DOUBLE,REAL))then
         call remark(
         "r8basis: variable "//lname(1:utgetcl(lname))//" is not REAL8.")
         call kaboom(0)
      endif

      call rtxdb(jvar, ndb, pdval, ndim, ilow, ihi, icol, INFO)
      if(ndim ~= 0)then
         call remark(
         "r8basis: variable "//lname(1:utgetcl(lname))//" is not SCALAR.")
         call kaboom(0)
      endif

      if(pdval == NOTSET)return(0)
      return(dvalue(pdval))
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

      complex function cbasis ( name )
#*******************************************************************************
#     Programmed by: Zane C. Motteler                                          *
#     Date         : October 1989                                              *
#     Purpose      : Given the name of a complex variable, return its value    *
#*******************************************************************************
      
      Ch(*) name
      Varname lname
      integer jvar, ndb, type, ndim, ilow(7), ihi(7), icol(7)
      Address pcval
      integer rtfinder, utgetcl
      external rtfinder, utgetcl
      complex cval
      external cvalue

      lname = name
      if(rtfinder(lname, jvar, ndb, type, "cbasis") == ERR)then
          call kaboom(0)
      endif

      if(type ~= COMPLEX)then
         call remark(
         "cbasis: variable "//lname(1:utgetcl(lname))//" is not COMPLEX.")
         call kaboom(0)
      endif

      call rtxdb(jvar, ndb, pcval, ndim, ilow, ihi, icol, INFO)
      if(ndim ~= 0)then
         call remark(
         "cbasis: variable "//lname(1:utgetcl(lname))//" is not SCALAR.")
         call kaboom(0)
      endif

      if(pcval == NOTSET)return(0)
      call cvalue (pcval, cval)
      return(cval)
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

      complex(Size8) function c8basis ( name )
#*******************************************************************************
#     Programmed by: Zane C. Motteler                                          *
#     Date         : October 1989                                              *
#     Purpose      : Given the name of a complex variable, return its value    *
#*******************************************************************************
      Ch(*) name
      Varname lname
      integer jvar, ndb, type, ndim, ilow(7), ihi(7), icol(7)
      Address pdcval
      integer rtfinder, utgetcl
      external rtfinder, utgetcl
      complex(Size8)dcval
      external dcvalue

      lname = name
      if(rtfinder(lname, jvar, ndb, type, "c8basis") == ERR)then
          call kaboom(0)
      endif

      if(type ~= ifelse(WORDSIZE,32,DOUBLE_C,COMPLEX) ) then
         call remark(
         "c8basis: variable "//lname(1:utgetcl(lname))//" is not COMPLEX8.")
         call kaboom(0)
      endif

      call rtxdb(jvar, ndb, pdcval, ndim, ilow, ihi, icol, INFO)
      if(ndim ~= 0)then
         call remark(
         "c8basis: variable "//lname(1:utgetcl(lname))//" is not SCALAR.")
         call kaboom(0)
      endif

      if(pdcval == NOTSET)return(0)
      call dcvalue (pdcval, dcval)
      return(dcval)
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

ifelse(HAS_DOUBLE_COMPLEX,YES,[
      double complex function dcbasis ( name )
#*******************************************************************************
#     Programmed by: Zane C. Motteler                                          *
#     Date         : August 1991                                               *
#     Purpose      : Given the name of a double complex variable, return its   *
#                    value  (SUNOS only)                                       *
#*******************************************************************************
      Ch(*) name
      Varname lname
      integer jvar, ndb, type, ndim, ilow(7), ihi(7), icol(7)
      Address pdcval
      integer rtfinder, utgetcl
      external rtfinder, utgetcl
      double complex dcval
      external dcvalue

      lname = name
      if(rtfinder(lname, jvar, ndb, type, "dcbasis") == ERR)then
          call kaboom(0)
      endif

      if(type ~= DOUBLE_C)then
         call remark(
         "dcbasis: variable "//lname(1:utgetcl(lname))//" is not DOUBLE COMPLEX.")
         call kaboom(0)
      endif

      call rtxdb(jvar, ndb, pdcval, ndim, ilow, ihi, icol, INFO)
      if(ndim ~= 0)then
         call remark(
         "dcbasis: variable "//lname(1:utgetcl(lname))//" is not SCALAR.")
         call kaboom(0)
      endif

      if(pdcval == NOTSET)return(0)
      call dcvalue (pdcval, dcval)
      return(dcval)
      end
],[
#     no double complex except on SUNOS
      complex function dcbasis ( name )
      complex cbasis
      external cbasis
      Ch(*) name
      return ( cbasis ( name ) )
      end
])

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

      double precision function dbasis ( name )
#*******************************************************************************
#     Programmed by: Zane C. Motteler                                          *
#     Date         : October 1989                                              *
#     Purpose      : Given the name of a double variable, return its value     *
#*******************************************************************************
      Ch(*) name
      Varname lname
      integer jvar, ndb, type, ndim, ilow(7), ihi(7), icol(7)
      Address pdval
      integer rtfinder, utgetcl
      external rtfinder, utgetcl
      double precision dvalue
      external dvalue

      lname = name
      if(rtfinder(lname, jvar, ndb, type, "dbasis") == ERR)then
          call kaboom(0)
      endif

      if(type ~= DOUBLE)then
         call remark(
         "dbasis: variable "//lname(1:utgetcl(lname))//" is not DOUBLE.")
         call kaboom(0)
      endif

      call rtxdb(jvar, ndb, pdval, ndim, ilow, ihi, icol, INFO)
      if(ndim ~= 0)then
         call remark(
         "dbasis: variable "//lname(1:utgetcl(lname))//" is not SCALAR.")
         call kaboom(0)
      endif

      if (pdval == NOTSET) return (0)
      return(dvalue(pdval))
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

      character*MAXSTRING function sbasis ( name )
#*******************************************************************************
#     Programmed by: Zane C. Motteler                                          *
#     Date         : October 1989                                              *
#     Purpose      : Given the name of a string variable, return its value     *
#*******************************************************************************
      Ch(*) name
      Varname lname
      integer jvar, ndb, type, ndim, ilow(7), ihi(7), icol(7)
      Address fwa
      integer rtfinder, utgetcl
      external rtfinder, utgetcl
      character*MAXSTRING sval

      lname = name
      if(rtfinder(lname, jvar, ndb, type, "sbasis") == ERR)then
          call kaboom(0)
      endif

      if(type >= 0)then
         call remark(
         "sbasis: variable "//lname(1:utgetcl(lname))//" is not a STRING.")
         call kaboom(0)
      endif

      call rtxdb(jvar, ndb, fwa, ndim, ilow, ihi, icol, INFO)
      if(ndim ~= 0)then
         call remark(
         "sbasis: variable "//lname(1:utgetcl(lname))//" is not SCALAR.")
         call kaboom(0)
      endif

      if(fwa == NOTSET)return(' ')
      call smovatof(sval, 0, fwa, 0, -type)
      return(sval(1:(-type)))
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

      logical function lbasis ( name )
#*******************************************************************************
#     Programmed by: Zane C. Motteler                                          *
#     Date         : October 1989                                              *
#     Purpose      : Given the name of a logical variable, return its value    *
#*******************************************************************************
      Ch(*) name
      Varname lname
      integer jvar, ndb, type, ndim, ilow(7), ihi(7), icol(7)
      Address plval
      integer rtfinder, utgetcl
      external rtfinder, utgetcl
      logical lvalue
      external lvalue

      lname = name
      if(rtfinder(lname, jvar, ndb, type, "lbasis") == ERR)then
          call kaboom(0)
      endif

      if(type ~= LOGICAL)then
         call remark(
         "lbasis: variable "//lname(1:utgetcl(lname))//" is not LOGICAL.")
         call kaboom(0)
      endif

      call rtxdb(jvar, ndb, plval, ndim, ilow, ihi, icol, INFO)
      if(ndim ~= 0)then
         call remark(
         "lbasis: variable "//lname(1:utgetcl(lname))//" is not SCALAR.")
         call kaboom(0)
      endif

      if(plval == NOTSET)return(FALSE)
      return(lvalue(plval))
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

      subroutine sibasis ( name , value )
#*******************************************************************************
#     Programmed by: Zane C. Motteler                                          *
#     Date         : October 1989                                              *
#     Purpose      : Given the name of an integer variable, set its value      *
#*******************************************************************************
      Ch(*) name
      Varname lname
      integer value
      integer jvar, ndb, type, ndim, ilow(7), ihi(7), icol(7)
      Address pival
      integer rtfinder, utgetcl
      external rtfinder, utgetcl
      external iset

      lname = name
      if(rtfinder(lname, jvar, ndb, type, "sibasis") == ERR)then
          call kaboom(0)
      endif

      if(type ~= INTEGER)then
         call remark(
         "sibasis: variable "//lname(1:utgetcl(lname))//" is not INTEGER.")
         call kaboom(0)
      endif

      call rtxdb(jvar, ndb, pival, ndim, ilow, ihi, icol, INFO)
      if(ndim ~= 0)then
         call remark(
         "sibasis: variable "//lname(1:utgetcl(lname))//" is not SCALAR.")
         call kaboom(0)
      endif
      if (pival == NOTSET) then
         call remark(
	 "sibasis: variable "//lname(1:utgetcl(lname))//" is unset dynamic.")
         call kaboom (0)
      endif

      call iset (pival, value)
      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

      subroutine srbasis ( name , value )
#*******************************************************************************
#     Programmed by: Zane C. Motteler                                          *
#     Date         : October 1989                                              *
#     Purpose      : Given the name of a real variable, set its value          *
#*******************************************************************************
      Ch(*) name
      Varname lname
      real value
      integer jvar, ndb, type, ndim, ilow(7), ihi(7), icol(7)
      Address prval
      integer rtfinder, utgetcl
      external rtfinder, utgetcl
      external rset

      lname = name
      if(rtfinder(lname, jvar, ndb, type, "srbasis") == ERR)then
          call kaboom(0)
      endif

      if(type ~= REAL)then
         call remark(
         "srbasis: variable "//lname(1:utgetcl(lname))//" is not REAL.")
         call kaboom(0)
      endif

      call rtxdb(jvar, ndb, prval, ndim, ilow, ihi, icol, INFO)
      if(ndim ~= 0)then
         call remark(
         "srbasis: variable "//lname(1:utgetcl(lname))//" is not SCALAR.")
         call kaboom(0)
      endif
      if (prval == NOTSET) then
         call remark(
	 "srbasis: variable "//lname(1:utgetcl(lname))//" is unset dynamic.")
         call kaboom (0)
      endif

      call rset (prval, value)
      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

      subroutine scbasis ( name , value )
#*******************************************************************************
#     Programmed by: Zane C. Motteler                                          *
#     Date         : October 1989                                              *
#     Purpose      : Given the name of a complex variable, set its value       *
#*******************************************************************************
      Ch(*) name
      Varname lname
      complex value
      integer jvar, ndb, type, ndim, ilow(7), ihi(7), icol(7)
      Address pcval
      integer rtfinder, utgetcl
      external rtfinder, utgetcl
      external cset

      lname = name
      if(rtfinder(lname, jvar, ndb, type, "scbasis") == ERR)then
          call kaboom(0)
      endif

      if(type ~= COMPLEX) then
         call remark(
         "scbasis: variable "//lname(1:utgetcl(lname))//" is not COMPLEX.")
         call kaboom(0)
      endif

      call rtxdb(jvar, ndb, pcval, ndim, ilow, ihi, icol, INFO)
      if(ndim ~= 0)then
         call remark(
         "scbasis: variable "//lname(1:utgetcl(lname))//" is not SCALAR.")
         call kaboom(0)
      endif
      if (pcval == NOTSET) then
         call remark(
	 "scbasis: variable "//lname(1:utgetcl(lname))//" is unset dynamic.")
         call kaboom (0)
      endif

      call cset (pcval, value)
      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

      subroutine sr8basis ( name , value )
#*******************************************************************************
#     Programmed by: Dubois
#     Date         : Feb 1993
#     Purpose      : Given the name of a real variable, set its value          *
#*******************************************************************************
      Ch(*) name
      Varname lname
      real(Size8) value
      integer jvar, ndb, type, ndim, ilow(7), ihi(7), icol(7)
      Address pdval
      integer rtfinder, utgetcl
      external rtfinder, utgetcl
      external dset

      lname = name
      if(rtfinder(lname, jvar, ndb, type, "sr8basis") == ERR)then
          call kaboom(0)
      endif

      if(type ~= ifelse(WORDSIZE,32,DOUBLE,REAL))then
         call remark(
         "sr8basis: variable "//lname(1:utgetcl(lname))//" is not REAL8.")
         call kaboom(0)
      endif

      call rtxdb(jvar, ndb, pdval, ndim, ilow, ihi, icol, INFO)
      if(ndim ~= 0)then
         call remark(
         "sr8basis: variable "//lname(1:utgetcl(lname))//" is not SCALAR.")
         call kaboom(0)
      endif
      if (pdval == NOTSET) then
         call remark(
	 "sr8basis: variable "//lname(1:utgetcl(lname))//" is unset dynamic.")
         call kaboom (0)
      endif

      call dset (pdval, value)
      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

      subroutine sc8basis ( name , value )
#*******************************************************************************
#     Programmed by: Zane C. Motteler                                          *
#     Date         : October 1989                                              *
#     Purpose      : Given the name of a complex variable, set its value       *
#*******************************************************************************
      Ch(*) name
      Varname lname
      complex(Size8) value
      integer jvar, ndb, type, ndim, ilow(7), ihi(7), icol(7)
      Address pdcval
      integer rtfinder, utgetcl
      external rtfinder, utgetcl
      external c8set

      lname = name
      if(rtfinder(lname, jvar, ndb, type, "sc8basis") == ERR)then
          call kaboom(0)
      endif

      if(type ~= ifelse(WORDSIZE,32,DOUBLE_C,COMPLEX)) then
         call remark(
         "sc8basis: variable "//lname(1:utgetcl(lname))//" is not COMPLEX8.")
         call kaboom(0)
      endif

      call rtxdb(jvar, ndb, pdcval, ndim, ilow, ihi, icol, INFO)
      if(ndim ~= 0)then
         call remark(
         "sc8basis: variable "//lname(1:utgetcl(lname))//" is not SCALAR.")
         call kaboom(0)
      endif
      if (pdcval == NOTSET) then
         call remark(
	 "sc8basis: variable "//lname(1:utgetcl(lname))//" is unset dynamic.")
         call kaboom (0)
      endif

      call c8set (pdcval, value)
      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

ifelse(HAS_DOUBLE_COMPLEX,YES,[
      subroutine sdcbasis ( name , value )
#*******************************************************************************
#     Programmed by: Zane C. Motteler                                          *
#     Date         : August 1991                                               *
#     Purpose      : Given the name of a double complex variable, set its value*
#*******************************************************************************
      Ch(*) name
      Varname lname
      double complex value
      integer jvar, ndb, type, ndim, ilow(7), ihi(7), icol(7)
      Address pdcval
      integer rtfinder, utgetcl
      external rtfinder, utgetcl
      external dcset

      lname = name
      if(rtfinder(lname, jvar, ndb, type, "sdcbasis") == ERR)then
          call kaboom(0)
      endif

      if(type ~= DOUBLE_C)then
         call remark(
         "sdcbasis: variable "//lname(1:utgetcl(lname))//" is not DOUBLE COMPLEX.")
         call kaboom(0)
      endif

      call rtxdb(jvar, ndb, pdcval, ndim, ilow, ihi, icol, INFO)
      if(ndim ~= 0)then
         call remark(
         "sdcbasis: variable "//lname(1:utgetcl(lname))//" is not SCALAR.")
         call kaboom(0)
      endif
      if (pdcval == NOTSET) then
         call remark(
	 "sdcbasis: variable "//lname(1:utgetcl(lname))//" is unset dynamic.")
         call kaboom (0)
      endif

      call dcset (pdcval, value)
      return
      end
],[
#     No double complex except SUNOS
      subroutine sdcbasis ( name , value )
      Ch(*) name
      complex value
      call scbasis ( name , value )
      return
      end
])

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

      subroutine sdbasis ( name , value )
#*******************************************************************************
#     Programmed by: Zane C. Motteler                                          *
#     Date         : October 1989                                              *
#     Purpose      : Given the name of a double variable, set its value        *
#*******************************************************************************
      Ch(*) name
      Varname lname
      double precision value
      integer jvar, ndb, type, ndim, ilow(7), ihi(7), icol(7)
      Address pdval
      integer rtfinder, utgetcl
      external rtfinder, utgetcl
      external dset

      lname = name
      if(rtfinder(lname, jvar, ndb, type, "sdbasis") == ERR)then
          call kaboom(0)
      endif

      if(type ~= DOUBLE)then
         call remark(
         "sdbasis: variable "//lname(1:utgetcl(lname))//" is not DOUBLE.")
         call kaboom(0)
      endif

      call rtxdb(jvar, ndb, pdval, ndim, ilow, ihi, icol, INFO)
      if(ndim ~= 0)then
         call remark(
         "sdbasis: variable "//lname(1:utgetcl(lname))//" is not SCALAR.")
         call kaboom(0)
      endif
      if (pdval == NOTSET) then
         call remark(
	 "sdbasis: variable "//lname(1:utgetcl(lname))//" is unset dynamic.")
         call kaboom (0)
      endif

      call dset (pdval, value)
      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

      subroutine ssbasis ( name , value )
#*******************************************************************************
#     Programmed by: Zane C. Motteler                                          *
#     Date         : October 1989                                              *
#     Purpose      : Given the name of a string variable, set its value        *
#*******************************************************************************
      Ch(*) name
      Ch(*) value
      Varname lname
      Ch(MAXSTRING) blanks
      integer jvar, ndb, type, ndim, ilow(7), ihi(7), icol(7), len
      Address fwa
      integer rtfinder, utgetcl
      external rtfinder, utgetcl

      lname = name
      if(rtfinder(lname, jvar, ndb, type, "ssbasis") == ERR)then
          call kaboom(0)
      endif

      if(type >= 0)then
         call remark(
         "ssbasis: variable "//lname(1:utgetcl(lname))//" is not CHARACTER.")
         call kaboom(0)
      endif

      call rtxdb(jvar, ndb, fwa, ndim, ilow, ihi, icol, INFO)
      if(ndim ~= 0)then
         call remark(
         "ssbasis: variable "//lname(1:utgetcl(lname))//" is not SCALAR.")
         call kaboom(0)
      endif
      if (fwa == NOTSET) then
         call remark(
	 "ssbasis: variable "//lname(1:utgetcl(lname))//" is unset dynamic.")
         call kaboom (0)
      endif

      type = - type
      len = utgetcl(value)
      if(type > len)then
         blanks = " "
         call smovftoa(fwa, 0, value, 0, len)
         call smovftoa(fwa, len, blanks, 0, type - len)
      else
         call smovftoa(fwa, 0, value, 0, type)
      endif
      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

      subroutine slbasis ( name , value )
#*******************************************************************************
#     Programmed by: Zane C. Motteler                                          *
#     Date         : October 1989                                              *
#     Purpose      : Given the name of a logical variable, set its value       *
#*******************************************************************************
      Ch(*) name
      Varname lname
      logical value
      integer jvar, ndb, type, ndim, ilow(7), ihi(7), icol(7)
      Address plval
      integer rtfinder, utgetcl
      external rtfinder, utgetcl
      external lset

      lname = name
      if(rtfinder(lname, jvar, ndb, type, "slbasis") == ERR)then
          call kaboom(0)
      endif

      if(type ~= LOGICAL)then
         call remark(
         "slbasis: variable "//lname(1:utgetcl(lname))//" is not LOGICAL.")
         call kaboom(0)
      endif

      call rtxdb(jvar, ndb, plval, ndim, ilow, ihi, icol, INFO)
      if(ndim ~= 0)then
         call remark(
         "slbasis: variable "//lname(1:utgetcl(lname))//" is not SCALAR.")
         call kaboom(0)
      endif
      if (plval == NOTSET) then
         call remark(
	 "slbasis: variable "//lname(1:utgetcl(lname))//" is unset dynamic.")
         call kaboom (0)
      endif

      call lset (plval, value)
      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

        subroutine news
# print the file news
        call more("news")
        return
        end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

        subroutine help
# print the file help
        call more("help")
        return
        end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

	subroutine partime(arg)	
#
#                                PARTIME
#
#turn timer on or off
	character*(*) arg
	real fcpu,fsys,fmem,fio,cpu,sys,mem,io
	common /partim/cpu,io,sys,mem	
#
 	if(arg == "on") then
		call ostime(cpu, io, sys, mem)
 	else if(arg == "off") then
		call ostime(fcpu,fio,fsys,fmem)
		call glbwrtim(iooutus(),fcpu-cpu,fio-io,fsys-sys,fmem-mem)
	else
		call remark("partime: argument must be on or off")
		call kaboom(0)
	endif
	return
	end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

ifelse(COMPILER,CIVIC,[
      integer function ishft(x,y)
# In case we have an old version of Lpp...
Undefine([shiftl])
Undefine([shiftr])
      integer x,y,shiftl,shiftr
      if(y > 0) then
         return(shiftl(x,y))
      elseif(y < 0) then
         return(shiftr(x,-y))
      else
         return(x)
      endif
      end
])
      integer function ranges(r)
      integer r(3)
      if(r(1)==DEFAULT|r(2)==DEFAULT|r(3)==DEFAULT) then
        return(ERR)
      endif
      return(1 + (r(2)-r(1))/r(3))
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

      subroutine basmaxout ( n )
      Use(Inout)
      external utsizstr
      integer n , utsizstr
      # Added 9/19/95 by ZCM to allow users to change the length
      # of an output line that can be sent by stream output
      if ( n > 500 ) then
         call remark("basmaxout: line length can not be set > 500.")
         call kaboom ( 0 )
      elseif ( n <= 0 ) then
         call remark("basmaxout: line length can not be set <= 0.")
         call kaboom ( 0 )
      endif
      call oschangn(outline , utsizstr(n, Quote(Ch(1))),linesize,
       "outline")
      linesize = n
      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

        subroutine utgetnm(jvar, ndb, vname, nvname)
#       Programmed by: Zane C. Motteler
#       Date         : June 1990
#       Purpose      : get the variable's name in the event of an error
#   Altered      : July 1991 (go to rtd for database stuff)
#   Moved here from ref.m and renamed utgetnm (ZCM 8/6/97)
        logical rtisdead
        external rtgvname, rtisdead
        integer jvar, ndb, nvname, utgetcl
        external utgetcl
        Ch(*) vname
        if ((jvar > 0) & ~rtisdead(jvar, ndb)) then
                call rtgvname(jvar,ndb,vname)
                nvname = utgetcl(vname)
        else
                vname = "?"
                nvname = 1
        endif
        end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c UTEXTRR - extract the interior portion of real array S
c         - to fill the real array D

      subroutine utextrr(d, s, kmax, lmax)
      implicit none
      real d(1), s(1)
      integer kmax, lmax

      integer j, k, l, m, km

      km = kmax - 1
      do k = 2, kmax
         do l = 2, lmax
            j = (l - 1)*kmax + k
            m = (l - 2)*km + k - 1
            d(m) = s(j)
         enddo
      enddo

      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c UTEXTRI - extract the interior portion of integer array S
c         - to fill the real array D

      subroutine utextri(d, s, kmax, lmax)
      implicit none
      real d(1)
      integer s(1)
      integer kmax, lmax

      integer j, k, l, m, km

      km = kmax - 1
      do k = 2, kmax
         do l = 2, lmax
            j = (l - 1)*kmax + k
            m = (l - 2)*km + k - 1
            d(m) = s(j)
         enddo
      enddo

      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c UTARRCPY - copy N elements of S into D

      subroutine utarrcpy(d, s, n)
      implicit none
      real d(1), s(1)
      integer n

      integer i

      do i = 1, n
         d(i) = s(i)
      enddo

      return
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

