/*
 *                                                                
 *  FILE
 *    utfpage.c - routine to use more to display a text file.
 *
 *  AUTHOR
 *    James Crotinger
 *    Copyright 1992, The Regents of the University of California, 
 *    and Lawrence Livermore National Laboratory.
 *                                                                
 *  CREATED
 *    Aug 26, 1992; 2:26pm
 *    Changed by Dubois to use cfortran.h
 *    
 *  NAMES                                                         
 *
 *    void Utfpage(char *filename);
 *
 *  DESCRIPTION
 *
 *    Display the file "filename" to stdout using a pager [more].
 *    "filename" must be the full path to the file.
 *
 *    To test, compile with -DTEST.
 *    Written such that it should be compilable with K&R C, ANSI C,
 *    or C++. Designed to be called from Fortran as call utfpage(filename)
 *
 */

#include "rt.h"

#define PAGER "${PAGER:-more}  "        /* environment variable, or default */

#ifdef __cplusplus
extern "C" {
#endif

#ifdef __STDC__
void Utfpage(char *filename)
#else
void Utfpage(filename)
char *filename;
#endif
{
    char cmd[256];

    strcpy(cmd, PAGER);
    strcat(cmd, filename);
    system(cmd);
}

#ifdef __cplusplus
}
#endif

/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/

#ifdef TEST

main()
{
    char *file = "par.v";
    int len = 5;

    Utfpage("par.v");
}

#endif

/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
