#*****************************************************************************
#* UNIX version of vossrc                                                    *
#*                                                                           *
#* Revised from original versions by: Zane C. Motteler                       *
#*                                     June 1988                             *
#*****************************************************************************
#
# Basis Code Development System
# Copyright 1986 The Regents of the University of California
#
#

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c FCNMKCH - To place a proper string descriptor in the calling sequence for a
c         - string-valued actual parameter

ifelse(WORDSIZE,32,[

	Address function fcnmkch(ilen,addr)
	integer ilen
        Address addr

Use(Functions)

	cfcnarg(cfcnargc+1) = ilen
	cfcnargc = cfcnargc + 1

	return(addr)
	end
])

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

ifelse(SYSTEM,YMP|C90|J90,[

        function fcnmkch(ilen,iaddr)
	integer fcnmkch

	fcnmkch = iaddr + ishft(ilen,35)

c--- 35 = 32(length of address field) + 3(2**3 bits in a character).

	return
	end

####    include ymode.i
])

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

ifelse(SYSTEM,XMP,[

        function fcnmkch(ilen,iaddr)
	integer fcnmkch

	fcnmkch = ior(iaddr,ishft(ilen,33))

c--- 33 = 24(length 0f address field) + 6(length of offset field)
c--- + 3(2**3 bits in a character).

	return
	end

####    include mach.i

])

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c PUSHARG - Most Fortran compilers push an extra argument on the stack for
c         - each character variable in the list of actual arguments.
c         - The Absoft Linux compiler pushes an extra argument for *every*
c         - actual argument, regardless of its type.

	Address function pusharg(ilen, iaddr)
	integer ilen
        Address iaddr

ifelse(SYSTEM,LINUX,[
ifelse(COMPILER,F77,[

Use(Functions)

        cfcnarg(cfcnargc+1) = ilen
        cfcnargc = cfcnargc + 1
])
])
	return(iaddr)
	end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c TRUNCADR - stub on Sun, truncate parameter to legal address length

	Address function truncadr(addr)
	Address addr

	return(addr)   
	end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c RDLINE -

      subroutine rdline(unit,msg,n)
      character*(*) msg
      character*(OUTLINE) errmsg
      integer n,unit

      integer utgetcl
      external utgetcl

      read(unit, 100, end=300, err=400) msg

 100  format(a)
      n = utgetcl(msg)
      return

 300  continue
      msg = ' '
      n = -1
      return

 400  call utsprint(1, 1, OUTLINE, errmsg,
     &              28, "Error trying to read unit %d", unit)
      call remark(errmsg)

      if (unit<>STDIN) then
         close(unit)
         call kaboom(0)
# The following will force-load bzero on the systems where NCAR requires it
ifelse(SYSTEM,SOL,[
      call bzero(msg,4)
])
      else
         call baderr("Error reading STDIN, I'm doomed.")
      endif

      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c XERABT - abort program execution and print error message.
c        - xerabt aborts the execution of the program.
c        - the error message causing the abort is given in the calling
c        - sequence, in case one needs it for printing on a dayfile,
c        - for example.
c        -   messg and nmessg are as in xerror, except that nmessg may
c        -   be zero, in which case no message is being supplied.

      subroutine xerabt(messg,nmessg)
      dimension messg(nmessg)

      call kaboom(0)

      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

# replacing second on the C90 breaks flowtrace !?

ifelse(SYSTEM,UNICOS,[],[
       real function second(r)
       real r, c,s,m
       call ostime(r,c,s,m)
       return(r)
       end
])

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

      subroutine basmain(argv0,cmdline)
      character*(*) cmdline
      character*(*) argv0
      Filename codedir

Use(Controls)
Use(Infiles)
Use(Hash)

      integer gmmlk, nrdif

      external ospush, utgetcl, initcrpn
      integer ospush, utgetcl

# process the command line
      call cmdargs(gmmlk, nrdif, cmdline, cmdline)

# initialize global memory leak detection
      call glmminit(gmmlk)

      call strginit(3000)  #initialize string table
      mactable = ihashnew(500)   # table for macro lookup
      vartable = ihashnew(1500)  # table for variable lookup
      call osinfo
      codedir = " "

# Set the value of "coderpn" for later reference.
      call initcrpn (argv0, codedir)
      call pathinit(codedir)

# get startup-files into list
      if (nrdif .eq. 1) then
         call mcfilset(".basis")
         call mcfilset("$BASIS")
         call mcfilset(".automounter")
      endif

# install the packages -- call routine written by config
      call setpkgs

# Do not buffer standard output.
# This is done, so that run/proxy and nqs work correctly.
      call bufstdo

# now it is o.k. to write to STDOUT
      if (verbose == YES) then
	  call glbhead(STDOUT,NO) #print the header greeting
      endif

# wake up the parser
      call glbpinit("par")

# begin main procedures
      call parexe(cmdline)

# parexe never returns !
      stop
      end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c PAREXE - This routine executes the parser

	subroutine parexe(cmdline)

Use(Actions)
Use(Functions)
Use(Infiles)

	integer glbpknum, lrxparse, i, utgetcl
	external glbpknum, lrxparse, utgetcl
        character*(*) cmdline
        character*(PNSIZE)firstpn
        external getfirstp, getnfirst
        integer getnfirst

# if firstpkg is specified, make it the current package
# firstpkg gets set by config program
        call errortrp("on")

	do ifp = getnfirst(), 1, -1
            call getfirstp(ifp,firstpn)
	    if(firstpn <> "   ") then
		i = glbpknum(firstpn)
		if( i == 0 ) call baderr(
		     "Specified firstpkg not loaded by config")
		call glbpinit(firstpn)
		call parpushp(i)
	    endif
	enddo

# parctl is a C routine which calls setjmp, thereby setting up stack unwind
# for kaboom, then calls parexe1, which does the rest of the old parexe
# stuff. kaboom has also been moved to C.
        call basismac		# routine to get and push macro files

        pblin(1) = cmdline
        pblinl(1) = utgetcl(cmdline)

        call errortrp("on")
	call ruthere0
	call parctl

	return
	end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

c PAREXE1 - This routine carries out all of the other functions of the old parexe,
c         - except the error recovery, which is handled by parctl, a new C routine.

	subroutine parexe1

	Use(Actions)
	Use(Functions)

	external lxinit, lrinit, lrxparse, kaboom, alldone
        integer parsflg
	logical retflg

	call lxinit  # parser lex initialization
	call lrinit  # parser lr initialization

        retflg = FALSE
	do  
	   parsflg = lrxparse(retflg)
	   if (parsflg == ERR) then
	      execflag = TRUE
	      call kaboom ( 1 )
	   endif
	   if (retflg) call lrexec()
       until (parsflg == DONE)

       call alldone(OK)

       stop
       end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

        subroutine glbwrtim(unit,cpu,io,sys,mem)
        integer unit
        character*(OUTLINE) msg
        real cpu,io,sys,mem

        call baswline(unit," ")
        call baswline(unit,"   CPU (sec)   SYS (sec)")

	call utsprint(1, 1, OUTLINE, msg,
     &                13, "%12.3e %12.3e", cpu, sys)

        call baswline(unit, msg)

        return
        end

c--------------------------------------------------------------------------
c--------------------------------------------------------------------------

