#
# macio
#
# TODO: move expand in to getattr, thus expand the _list attributes when
# requested.

########################################
#
#
class Template:
    '''This class is used to help generate source from a Template.
    Each attribute is entered into a dictionary.  If the attribute
    is a list, it is joined into a block of lines before being printed.
    The dictionary is then used as the source of values for the template.
    '''

    def __init__(self):
        self._dict = {}

    def __setattr__(self, name, value):
#        if name in ('_dict',):
        if name == '_dict':
            self.__dict__[name] = value
        else:
            self._dict[name] = value

    def __getattr__(self, name):
        _dict = self.__dict__['_dict']
        if _dict.has_key(name):
            return _dict[name]
        if self.__dict__.has_key(name):
            return self.__dict__[name]
        raise AttributeError, name
        
    def clear(self):
        self._dict = {}

#    def listify(self, key, value=None):
#        '''join a list into a newline delimited string'''
#        if value:
#            self._dict[key + '_list'] = string.join(value, '\n')
#        else:
#            value = self._dict.get(key)
#            if type(value) == type([]):
#                self._dict[key + '_list'] = string.join(value, '\n')
#                del self._dict[key]

    def write(self, fp, template):
        for (key, value) in self._dict.items():
            if type(value) == type([]):
                if value:
                    self._dict[key + '_list'] = '\n'.join(value) + '\n'
                else:
                    self._dict[key + '_list'] = ''
                del self._dict[key]
        fp.write(template % self._dict)

    def expand(self, template):
        for (key, value) in self._dict.items():
            if type(value) == type([]):
                if value:
                    self._dict[key + '_list'] = '\n'.join(value) + '\n'
                else:
                    self._dict[key + '_list'] = ''
                del self._dict[key]
        return template % self._dict

