/* FILE: ctr.h */

#if !defined(__ctr__)
#define __ctr__

#include <basconf.h>

#if defined(__cplusplus)
#if !defined(__Basis__)
#include "Basis.h"
#endif
#if !defined(__Vector__)
#include "Vector.h"
#endif
#if !defined(__Array3__)
#include "Array3.h"
#endif
#if !defined(__Array4__)
#include "Array4.h"
#endif
#if !defined(__Character__)
#include "Character.h"
#endif
#if !defined(__CCLComplex__)
#include "CCLComplex.h"
#endif
#endif

#if !defined(__cplusplus)
#include "SysConfig.h"
#endif

/* Definitions / Parameters */

#define Pi 3.14159265358979323
#define Ntemps 2
#define Nparts 10
#define Ndata 6
#define Nscalings 6
#define Nconfig 12
#define GLFNKY 20

/* Group Transport_Control */
#define ctr_genTrStorage FF_ID(gentrstorage, GENTRSTORAGE)          /* c-subroutine */
#define ctr_newTrPlasma FF_ID(newtrplasma, NEWTRPLASMA)          /* c-subroutine */
#define ctr_checkTrEqns FF_ID(checktreqns, CHECKTREQNS)          /* c-subroutine */
#define ctr_configureTrEqn FF_ID(configuretreqn, CONFIGURETREQN)          /* c-subroutine */
#define ctr_setTrInitConds FF_ID(settrinitconds, SETTRINITCONDS)          /* c-subroutine */
#define ctr_computeTrProfiles FF_ID(computetrprofiles, COMPUTETRPROFILES)          /* c-subroutine */
#define ctr_setBCs FF_ID(setbcs, SETBCS)          /* c-subroutine */
#define ctr_computeTrCoefs FF_ID(computetrcoefs, COMPUTETRCOEFS)          /* c-subroutine */
#define ctr_computeTrParms FF_ID(computetrparms, COMPUTETRPARMS)          /* c-subroutine */
#define ctr_advanceTrEqns FF_ID(advancetreqns, ADVANCETREQNS)          /* c-subroutine */
#define ctr_setTrModel FF_ID(settrmodel, SETTRMODEL)          /* c-subroutine */
#define ctr_makeTrProfile FF_ID(maketrprofile, MAKETRPROFILE)          /* c-subroutine */
#define ctr_testTr FF_ID(testtr, TESTTR)          /* c-subroutine */
#define ctr_ip_chi FF_ID(ip_chi, IP_CHI)          /* subroutine */
#define ctr_evalSimple FF_ID(evalsimple, EVALSIMPLE)          /* c-subroutine */
#define ctr_evalNeo FF_ID(evalneo, EVALNEO)          /* c-subroutine */
#define ctr_evalCH FF_ID(evalch, EVALCH)          /* c-subroutine */
#define ctr_evalRLW FF_ID(evalrlw, EVALRLW)          /* c-subroutine */
#define ctr_evalGLF FF_ID(evalglf, EVALGLF)          /* c-subroutine */
#define ctr_evalHS FF_ID(evalhs, EVALHS)          /* c-subroutine */
#define ctr_evalNclass FF_ID(evalnclass, EVALNCLASS)          /* c-subroutine */
#define ctr_evalKDBH FF_ID(evalkdbh, EVALKDBH)          /* c-subroutine */
#define ctr_evalUserTransport FF_ID(evalusertransport, EVALUSERTRANSPORT)          /* c-subroutine */
#define ctr_glfinit1_0 FF_ID(glfinit1_0, GLFINIT1_0)          /* subroutine */
#define ctr_glftest1_0 FF_ID(glftest1_0, GLFTEST1_0)          /* subroutine */
#define ctr_glf2d1_0 FF_ID(glf2d1_0, GLF2D1_0)          /* subroutine */
#define ctr_glf2d FF_ID(glf2d, GLF2D)          /* subroutine */
#define ctr_callglf2d_wrap FF_ID(callglf2d_wrap, CALLGLF2D_WRAP)          /* subroutine */
#define ctr_getOmegaExB FF_ID(getomegaexb, GETOMEGAEXB)          /* c-subroutine */

/* Group Transport_Hooks */
#define CTR10_Transport_Hooks FCB_ID(ctr10, CTR10)

/* Group Transport_Flags */
#define CTR20_Transport_Flags FCB_ID(ctr20, CTR20)
#define CTR21_Transport_Flags FCB_ID(ctr21, CTR21)

/* Group Transport_Dimensions */
#define CTR30_Transport_Dimensions FCB_ID(ctr30, CTR30)

/* Group Flux_Transport */
#define CTR43_Flux_Transport FCB_ID(ctr43, CTR43)
#define CTR46_Flux_Transport FCB_ID(ctr46, CTR46)
#define CTR40_Flux_Transport FCB_ID(ctr40, CTR40)
#define CTR41_Flux_Transport FCB_ID(ctr41, CTR41)

/* Group Entropy_Transport */
#define CTR53_Entropy_Transport FCB_ID(ctr53, CTR53)
#define CTR56_Entropy_Transport FCB_ID(ctr56, CTR56)

/* Group Auxiliary_Power */
#define CTR63_Auxiliary_Power FCB_ID(ctr63, CTR63)
#define CTR66_Auxiliary_Power FCB_ID(ctr66, CTR66)

/* Group Drag_Power */
#define CTR73_Drag_Power FCB_ID(ctr73, CTR73)
#define CTR76_Drag_Power FCB_ID(ctr76, CTR76)

/* Group Fusion_Power */
#define CTR83_Fusion_Power FCB_ID(ctr83, CTR83)
#define CTR86_Fusion_Power FCB_ID(ctr86, CTR86)

/* Group Ohmic_Power */
#define CTR93_Ohmic_Power FCB_ID(ctr93, CTR93)
#define CTR96_Ohmic_Power FCB_ID(ctr96, CTR96)

/* Group RF_Power */
#define CTR103_RF_Power FCB_ID(ctr103, CTR103)
#define CTR106_RF_Power FCB_ID(ctr106, CTR106)

/* Group Runaway_Electrons */
#define CTR116_Runaway_Electrons FCB_ID(ctr116, CTR116)
#define CTR111_Runaway_Electrons FCB_ID(ctr111, CTR111)

/* Group Radiation_Power */
#define CTR123_Radiation_Power FCB_ID(ctr123, CTR123)
#define CTR126_Radiation_Power FCB_ID(ctr126, CTR126)

/* Group Density_Transport */
#define CTR133_Density_Transport FCB_ID(ctr133, CTR133)
#define CTR136_Density_Transport FCB_ID(ctr136, CTR136)

/* Group Turbulent_Transport */
#define CTR146_Turbulent_Transport FCB_ID(ctr146, CTR146)

/* Group Simple_Transport_Input */
#define CTR156_Simple_Transport_Input FCB_ID(ctr156, CTR156)

/* Group Simple_Transport_Output */
#define CTR166_Simple_Transport_Output FCB_ID(ctr166, CTR166)

/* Group Neo_Transport */
#define CTR176_Neo_Transport FCB_ID(ctr176, CTR176)

/* Group CH_Transport */
#define CTR186_CH_Transport FCB_ID(ctr186, CTR186)

/* Group RLW_Transport_Input */
#define CTR193_RLW_Transport_Input FCB_ID(ctr193, CTR193)

/* Group RLW_Transport_Output */
#define CTR206_RLW_Transport_Output FCB_ID(ctr206, CTR206)

/* Group HS_Transport_Output */
#define CTR216_HS_Transport_Output FCB_ID(ctr216, CTR216)

/* Group Nclass_Transport */
#define CTR226_Nclass_Transport FCB_ID(ctr226, CTR226)

/* Group KDBH_Transport_Input */
#define CTR233_KDBH_Transport_Input FCB_ID(ctr233, CTR233)
#define CTR236_KDBH_Transport_Input FCB_ID(ctr236, CTR236)

/* Group KDBH_Transport_Output */
#define CTR246_KDBH_Transport_Output FCB_ID(ctr246, CTR246)

/* Group GLF_Transport_Input1_0 */
#define CTR250_GLF_Transport_Input1_0 FCB_ID(ctr250, CTR250)
#define CTR253_GLF_Transport_Input1_0 FCB_ID(ctr253, CTR253)

/* Group GLF_Transport_Output1_0 */
#define CTR263_GLF_Transport_Output1_0 FCB_ID(ctr263, CTR263)

/* Group GLF_Transport_Output */
#define CTR276_GLF_Transport_Output FCB_ID(ctr276, CTR276)

/* Group Callglf2d_com */
#define GLF_CT_Callglf2d_com FCB_ID(glf_ct, GLF_CT)

/* Group GLF_Transport_Input */
#define CTR290_GLF_Transport_Input FCB_ID(ctr290, CTR290)
#define CTR293_GLF_Transport_Input FCB_ID(ctr293, CTR293)
#define CTR296_GLF_Transport_Input FCB_ID(ctr296, CTR296)

/* Group GLF_Transport_Output2 */
#define CTR303_GLF_Transport_Output2 FCB_ID(ctr303, CTR303)
#define CTR306_GLF_Transport_Output2 FCB_ID(ctr306, CTR306)

/* Group GLF_Transport_wrapper_temps */
#define CTR313_GLF_Transport_wrapper_temps FCB_ID(ctr313, CTR313)
#define CTR316_GLF_Transport_wrapper_temps FCB_ID(ctr316, CTR316)
#define CTR310_GLF_Transport_wrapper_temps FCB_ID(ctr310, CTR310)

/* Group GLF_Transport_diagnostics */
#define CTR326_GLF_Transport_diagnostics FCB_ID(ctr326, CTR326)
#define CTR323_GLF_Transport_diagnostics FCB_ID(ctr323, CTR323)
#define CTR320_GLF_Transport_diagnostics FCB_ID(ctr320, CTR320)

/* Group ToroidalRotation */
#define CTR333_ToroidalRotation FCB_ID(ctr333, CTR333)
#define CTR336_ToroidalRotation FCB_ID(ctr336, CTR336)

/* Group ErShearFields */
#define CTR340_ErShearFields FCB_ID(ctr340, CTR340)

/* Group ErShearMod */
#define CTR350_ErShearMod FCB_ID(ctr350, CTR350)

/* Group AngularMomentum_Transport */
#define CTR363_AngularMomentum_Transport FCB_ID(ctr363, CTR363)
#define CTR366_AngularMomentum_Transport FCB_ID(ctr366, CTR366)
#define CTR360_AngularMomentum_Transport FCB_ID(ctr360, CTR360)

/* Group Pellets */
#define CTR373_Pellets FCB_ID(ctr373, CTR373)
#define CTR376_Pellets FCB_ID(ctr376, CTR376)

/* Group Confinement */
#define CTR383_Confinement FCB_ID(ctr383, CTR383)

/* Group Galerkin */
#define CTR396_Galerkin FCB_ID(ctr396, CTR396)

/* Group Sawtooth_Data */
#define CTR403_Sawtooth_Data FCB_ID(ctr403, CTR403)
#define CTR400_Sawtooth_Data FCB_ID(ctr400, CTR400)

/* Group TransStep */
#define CTR413_TransStep FCB_ID(ctr413, CTR413)

#if defined(__cplusplus)

// ctr package class definition

class ctr {
public:

// Group Transport_Control

  static void genTrStorage ( void );
  static void newTrPlasma ( void );
  static void checkTrEqns ( void );
  static void configureTrEqn ( Integer &, Integer & );
  static void setTrInitConds ( void );
  static void computeTrProfiles ( void );
  static void setBCs ( void );
  static void computeTrCoefs ( void );
  static void computeTrParms ( void );
  static void advanceTrEqns ( void );
  static void setTrModel ( Integer &, Integer & );
  static void makeTrProfile ( Real &, Real &, Real &, Real &, Real &, Real & );
  static void testTr ( Real &, Real & );
  static void ip_chi ( Real &, Real &, Real &, Real &, Real &, Real &, Real &, Real &, Real &, Real &, Real &, Real &, Real &, Real &, Real &, Real &, Real &, Real &, Real &, Real &, Real &, Real &, Real &, Real &, Real &, Real & );
  static void evalSimple ( void );
  static void evalNeo ( void );
  static void evalCH ( void );
  static void evalRLW ( void );
  static void evalGLF ( void );
  static void evalHS ( void );
  static void evalNclass ( void );
  static void evalKDBH ( void );
  static void evalUserTransport ( void );
  static void glfinit1_0 ( void );
  static void glftest1_0 ( void );
  static void glf2d1_0 ( void );
  static void glf2d ( void );
  static void callglf2d_wrap ( void );
  static void getOmegaExB ( Integer & );

// Group Transport_Hooks

  static Integer  &userSource_hooks_n;
  static Integer  &diagnostic_hooks_n;
  static Integer  &iterdiag_hooks_n;
  static Integer  &history_hooks_n;
  static Integer  &profiles_prehooks_n;
  static Integer  &profiles_posthooks_n;
  static Integer  &transCoefs_prehooks_n;
  static Integer  &transCoefs_posthooks_n;
  static Integer  &parameters_prehooks_n;
  static Integer  &parameters_posthooks_n;
  static Integer  &equations_prehooks_n;
  static Integer  &equations_posthooks_n;

// Group Transport_Flags

  static Integer  &iSimple;
  static Integer  &iNeo;
  static Integer  &iRLW;
  static Integer  &iKDBH;
  static Integer  &iGLF;
  static Integer  &iUser;
  static Integer  &currentModel;
  static Logical  &neoWarn;
  static Integer  &suppress_Simple;
  static Integer  &suppress_Neo;
  static Integer  &suppress_PS;
  static Logical  &useMassLumping;
  static Logical  &useBSplineInterp;
  static Logical  &nonConvDirichletBC;
  static Logical  &goodEndDerivative;
  static Logical  &fluxEnforceBC;
  static Integer  &hr_BCFlag;
  static Integer  &elementType;
  static Vector<Integer> eqnsConfig;
  static Integer  &iNoEqn;
  static Integer  &iZeroD;
  static Integer  &iBSplineFE;
  static Integer  &iLinearFE;
  static Integer  &iSpecifyIotaIC;
  static Integer  &iSpecifyQIC;
  static Integer  &iSpecifyEntropyIC;
  static Integer  &iSpecifyTempIC;
  static Integer  &useUGradP;
  static Integer  &magnShld;
  static Integer  &iNeoAlc;
  static Integer  &iDIIID;
  static Integer  &iITER_P;
  static Integer  &iITER_O;
  static Integer  &iRebutLallia;
  static Integer  &iITER_PMin;
  static Integer  &useSawtoothModel;
  static Integer  &iNoSawtooth;
  static Integer  &iUserSawtooth;
  static Integer  &iChiSawtooth;
  static Integer  &iSmoothSawtooth;
  static Integer  &boundaryFluxHack;
  static Logical  &fixed_dens;
  static Logical  &fixed_y;
  static Logical  &fixed_mu;
  static Logical  &fixed_lz;

// Group Transport_Dimensions

  static Integer  &nrho;
  static Integer  &nigpts;
  static Integer  &nfps;
  static Integer  &nparts;
  static Integer  &ntemps;
  static Integer  &nhterms;
  static Integer  &iElecIon;
  static Integer  &iIonElec;

// Group Flux_Transport

  static Double  &thetaFlux;
  static Double  &torfDot;
  static Double  &psiAxis;
  static Double  &psiAxisDot;
  static Double  &psiEdge;
  static Double  &ipPrEdge;
  static Double  &jtTor_edge;
  static Double  &jparTor_edge;
  static Vector<Double> yBC_;
  static Vector<Double> yBC_old;
  static Vector<Double> c23Dot;
  static Vector<Double> ipTor;
  static Vector<Double> ipPrTor;
  static Vector<Double> strTor;
  static Integer  &lstrTor;
  static Vector<Double> unstrTor;
  static Vector<Double> strPrTor;
  static Vector<Double> rhostr;
  static Vector<Double> iotaTor;
  static Vector<Double> iotaPrTor;
  static Vector<Double> yTor;
  static Vector<Double> yPrTor;
  static Vector<Double> yPrPrTor;
  static Vector<Double> yTorDot;
  static Vector<Double> hrTor;
  static Vector<Double> hrPrTor;
  static Vector<Double> hrPrPrTor;
  static Vector<Double> qExp;
  static Vector<Double> pExp;
  static Vector<Double> jniTor;
  static Vector<Double> jICTor;
  static Vector<Double> jLHTor;
  static Vector<Double> jECTor;
  static Vector<Double> juserTor;
  static Vector<Double> factTor;
  static Array3<Double> yHProfs;
  static Array3<Double> yHProfs_old;
  static Logical  &withHyperR;

// Group Entropy_Transport

  static Double  &thetaMu;
  static Double  &convMult;
  static Vector<Double> tempVolAvg;
  static Vector<Double> tempNVolAvg;
  static Vector<Double> heatSrcTot;
  static Vector<Double> pUGradPTot;
  static Matrix<Double> tempBC;
  static Matrix<Double> tempBC_old;
  static Matrix<Double> muBC_;
  static Matrix<Double> muBC_old;
  static Matrix<Double> pUGradP;
  static Matrix<Double> muTor;
  static Matrix<Double> muPrTor;
  static Matrix<Double> muPrPrTor;
  static Matrix<Double> muTorDot;
  static Array3<Double> muToTemp;
  static Vector<Double> vpr23;
  static Matrix<Double> gammaPS;
  static Matrix<Double> chi;
  static Matrix<Double> fluxH;
  static Matrix<Double> pinchH;
  static Matrix<Double> heatSrc;
  static Array3<Double> heatFluxCoefs;
  static Matrix<Double> heatFlux;
  static Matrix<Double> entropyTor;
  static Array3<Double> muHProfs;
  static Array3<Double> muHProfs_old;

// Group Auxiliary_Power

  static Vector<Double> pAuxTot;
  static Matrix<Double> pAuxCoefs;
  static Matrix<Double> pAux;

// Group Drag_Power

  static Double  &pDragTot;
  static Vector<Double> pDrag;
  static Vector<Double> dragCoef;

// Group Fusion_Power

  static Double  &pFusDDElecTot;
  static Double  &pFusDDIonTot;
  static Double  &pNeutDDTot;
  static Double  &pFusDDTot;
  static Double  &fPromptLoss;
  static Double  &pFusDTElecTot;
  static Double  &pFusDTIonTot;
  static Double  &pNeutDTTot;
  static Double  &pFusDTTot;
  static Vector<Double> sigmavDDn;
  static Vector<Double> sigmavDDp;
  static Vector<Double> rxnRateDDn;
  static Vector<Double> rxnRateDDp;
  static Vector<Double> pFusDDElec;
  static Vector<Double> pFusDDIon;
  static Vector<Double> pNeutDD;
  static Vector<Double> fastPressDD;
  static Vector<Double> sigmavDT;
  static Vector<Double> rxnRateDT;
  static Vector<Double> pFusDTElec;
  static Vector<Double> pFusDTIon;
  static Vector<Double> pNeutDT;
  static Vector<Double> fastPressDT;
  static Vector<Double> rxnRateBtDDn;
  static Vector<Double> rxnRateBtDT;
  static Vector<Double> pNeutBtDD;
  static Vector<Double> pNeutBtDT;
  static Double  &pNeutBtDDTot;
  static Double  &pNeutBtDTTot;
  static Double  &rxnRateDDnTot;
  static Double  &rxnRateDTTot;
  static Double  &rxnRateBtDDnTot;
  static Double  &rxnRateBtDTTot;

// Group Ohmic_Power

  static Double  &pOhmicTot;
  static Vector<Double> pOhmic;

// Group RF_Power

  static Double  &pRFTot;
  static Vector<Double> pRF;

// Group Runaway_Electrons

  static Vector<Double> tau_run;
  static Vector<Double> source_run;
  static Vector<Double> ecrit;
  static Logical  &run_away;

// Group Radiation_Power

  static Double  &rWall;
  static Double  &pBLRRadTot;
  static Double  &pSyncTot;
  static Vector<Double> pBLRRad;
  static Vector<Double> pSync;

// Group Density_Transport

  static Double  &thetaN;
  static Vector<Double> particleSrcTot;
  static Vector<Double> mass;
  static Vector<Double> densVolAvg;
  static Double  &ionMassAvg;
  static Vector<Double> etaDivertor;
  static Vector<Double> alphaRecycle;
  static Vector<Double> recycleCoef;
  static Vector<Double> gasPuffSrc;
  static Vector<Double> gasPuffCoef;
  static Double  &recycleWidth;
  static Double  &densBorass;
  static Double  &densGreenwald;
  static Matrix<Double> densBC;
  static Matrix<Double> nBC_;
  static Matrix<Double> nTor;
  static Matrix<Double> nPrTor;
  static Matrix<Double> nPrPrTor;
  static Matrix<Double> nTorDot;
  static Vector<Double> massDensPrTor;
  static Vector<Double> mn_over_charge;
  static Vector<Double> mnPr_over_charge;
  static Matrix<Double> nToDens;
  static Matrix<Double> recycleSrc;
  static Matrix<Double> implicitRecycleSrc;
  static Matrix<Double> diff;
  static Matrix<Double> pinch;
  static Matrix<Double> fluxN;
  static Matrix<Double> particleSrc;
  static Array3<Double> particleFluxCoefs;
  static Matrix<Double> particleFlux;
  static Vector<Double> sumPartFlux;
  static Array3<Double> nHProfs;

// Group Turbulent_Transport

  static Vector<Double> shat;
  static Vector<Double> taui;

// Group Simple_Transport_Input

  static Matrix<Double> chiData;
  static Matrix<Double> diffData;
  static Vector<Double> diff_LzData;

// Group Simple_Transport_Output

  static Matrix<Double> chiSimple;
  static Matrix<Double> diffSimple;
  static Vector<Double> diff_LzSimple;

// Group Neo_Transport

  static Matrix<Double> diffNeo;
  static Matrix<Double> pinchNNeo;
  static Matrix<Double> fluxNNeo;
  static Matrix<Double> chiNeo;
  static Matrix<Double> pinchHNeo;
  static Matrix<Double> fluxHNeo;
  static Vector<Double> diff_LzNeo;

// Group CH_Transport

  static Matrix<Double> chiCH;
  static Vector<Double> diffCH;
  static Vector<Double> vWarePinch;

// Group RLW_Transport_Input

  static Double  &rebutHElec;
  static Double  &rebutHIon;
  static Vector<Double> rebutDiffCoef;
  static Double  &rebutDiff_LzCoef;
  static Double  &chifact1;
  static Double  &critTeCoef;
  static Double  &chiIECoef;
  static Double  &chiIECoef2;
  static Double  &diffOverChi;
  static Double  &pinchCoef;

// Group RLW_Transport_Output

  static Matrix<Double> chiRLW;
  static Vector<Double> diffRLW;
  static Vector<Double> pinchRLW;
  static Vector<Double> diff_LzRLW;
  static Vector<Double> gradTe_crit;
  static Vector<Double> chiAnomalous;

// Group HS_Transport_Output

  static Matrix<Double> chiHS;
  static Matrix<Double> diffHS;
  static Matrix<Double> pinchNHS;
  static Matrix<Double> pinchHHS;
  static Matrix<Double> fluxNHS;
  static Matrix<Double> fluxHHS;

// Group Nclass_Transport

  static Matrix<Double> diffNclass;
  static Matrix<Double> pinchNNclass;
  static Matrix<Double> fluxNNclass;
  static Matrix<Double> chiNclass;
  static Matrix<Double> pinchHNclass;
  static Matrix<Double> fluxHNclass;

// Group KDBH_Transport_Input

  static Double  &shatmin;
  static Vector<Double> rmajLTi;
  static Vector<Double> rmajLNi;
  static Vector<Double> rmajLNe;
  static Vector<Double> z_effKDBH;
  static Vector<Double> eps_tmp;
  static Vector<Double> gnuKDBH;
  static Vector<Double> ionGyroRad;
  static Vector<Double> ionVth;
  static Vector<Double> geomfac;

// Group KDBH_Transport_Output

  static Matrix<Double> chiKDBH;
  static Vector<Double> diffKDBH;
  static Vector<Double> diff_LzKDBH;
  static Vector<Double> rmajLTcrit;
  static Vector<Double> rmajLTcritz;
  static Vector<Double> gamKDBH;

// Group GLF_Transport_Input1_0

  static Integer  &eigen_solver_gf1_0;
  static Integer  &nroot_gf1_0;
  static Vector<Integer> iflagin_gf1_0;
  static Vector<Double> xparam_gf1_0;
  static Double  &xky0_gf1_0;
  static Double  &rms_theta_gf1_0;
  static Double  &rlti_gf1_0;
  static Double  &rlte_gf1_0;
  static Double  &rlne_gf1_0;
  static Double  &rlni_gf1_0;
  static Double  &dil_gf1_0;
  static Double  &xdil_m1_0;
  static Double  &taui_gf1_0;
  static Double  &rmin_gf1_0;
  static Double  &rmaj_gf1_0;
  static Double  &q_gf1_0;
  static Double  &xnu_gf1_0;
  static Double  &cxnu1_0;
  static Double  &xshift1_0;
  static Double  &betae_gf1_0;
  static Double  &cbetae1_0;
  static Double  &shat_gf1_0;
  static Double  &alpha_gf1_0;
  static Double  &elong_gf1_0;
  static Double  &xwell_gf1_0;
  static Double  &park_gf1_0;
  static Double  &ghat_gf1_0;
  static Double  &gchat_gf1_0;
  static Double  &adamp_gf1_0;
  static Double  &alpha_star_gf1_0;
  static Double  &gamma_star_gf1_0;
  static Double  &alpha_e_gf1_0;
  static Double  &gamma_e_gf1_0;
  static Double  &alpha_mode_gf1_0;
  static Double  &gamma_mode_gf1_0;
  static Double  &alpha_p_gf1_0;
  static Double  &gamma_p_gf1_0;
  static Double  &xkdamp_gf1_0;
  static Integer  &ikymax_gf1_0;
  static Double  &xkymin_gf1_0;
  static Double  &xkymax_gf1_0;
  static Integer  &lprint_gf1_0;
  static Double  &amassgas_gf1_0;
  static Double  &cmodel1_0;
  static Integer  &vGLF;

// Group GLF_Transport_Output1_0

  static Vector<Double> yparam_gf1_0;
  static Double  &xkyf_gf1_0;
  static Vector<Double> gamma_gf1_0;
  static Vector<Double> freq_gf1_0;
  static Vector<Double> phi_norm_gf1_0;
  static Double  &diff_gf1_0;
  static Double  &chii_gf1_0;
  static Double  &chie_gf1_0;
  static Double  &exch_gf1_0;
  static Double  &eta_par_gf1_0;
  static Double  &eta_per_gf1_0;
  static Double  &eta_phi_gf1_0;
  static Double  &chie_e_gf1_0;
  static Matrix<Double> yparam_k_gf1_0;
  static Vector<Double> xkyf_k_gf1_0;
  static Matrix<Double> gamma_k_gf1_0;
  static Matrix<Double> freq_k_gf1_0;
  static Matrix<Double> phi_norm_k_gf1_0;
  static Vector<Double> diff_k_gf1_0;
  static Vector<Double> chii_k_gf1_0;
  static Vector<Double> chie_k_gf1_0;
  static Vector<Double> exch_k_gf1_0;
  static Vector<Double> eta_par_k_gf1_0;
  static Vector<Double> eta_per_k_gf1_0;
  static Vector<Double> eta_phi_k_gf1_0;
  static Vector<Double> chie_e_k_gf1_0;

// Group GLF_Transport_Output

  static Vector<Double> ionSound;
  static Vector<Double> rhoStar;
  static Vector<Double> xky_m;
  static Vector<Double> anrate_m;
  static Vector<Double> anfreq_m;
  static Matrix<Double> chiGLF;
  static Vector<Double> diffGLF;
  static Vector<Double> diff_LzGLF;

// Group Callglf2d_com

  static Array3<Double> zevec_k_gf;
  static Matrix<Double> zomega_k_gf;
  static Matrix<Double> yparam_k_gf;
  static Matrix<Double> gamma_k_gf;
  static Matrix<Double> freq_k_gf;
  static Matrix<Double> phi_norm_k_gf;
  static Vector<Double> xparam_gf;
  static Vector<Double> xkyf_k_gf;
  static Vector<Double> diff_k_gf;
  static Vector<Double> diff_im_k_gf;
  static Vector<Double> chii_k_gf;
  static Vector<Double> chie_k_gf;
  static Vector<Double> exch_k_gf;
  static Vector<Double> eta_par_k_gf;
  static Vector<Double> eta_per_k_gf;
  static Vector<Double> eta_phi_k_gf;
  static Vector<Double> chie_e_k_gf;
  static Vector<Double> yparam_gf;
  static Vector<Double> gamma_gf;
  static Vector<Double> freq_gf;
  static Vector<Double> phi_norm_gf;
  static Vector<Double> xky_gf;
  static Double  &xky0_gf;
  static Double  &rms_theta_gf;
  static Double  &rlti_gf;
  static Double  &rlte_gf;
  static Double  &rlne_gf;
  static Double  &rlni_gf;
  static Double  &rlnimp_gf;
  static Double  &dil_gf;
  static Double  &apwt_gf;
  static Double  &aiwt_gf;
  static Double  &taui_gf;
  static Double  &rmin_gf;
  static Double  &rmaj_gf;
  static Double  &q_gf;
  static Double  &xnu_gf;
  static Double  &betae_gf;
  static Double  &shat_gf;
  static Double  &alpha_gf;
  static Double  &elong_gf;
  static Double  &xwell_gf;
  static Double  &park_gf;
  static Double  &ghat_gf;
  static Double  &gchat_gf;
  static Double  &adamp_gf;
  static Double  &alpha_star_gf;
  static Double  &gamma_star_gf;
  static Double  &alpha_e_gf;
  static Double  &gamma_e_gf;
  static Double  &alpha_mode_gf;
  static Double  &gamma_mode_gf;
  static Double  &alpha_p_gf;
  static Double  &gamma_p_gf;
  static Double  &xkdamp_gf;
  static Double  &xkyf_gf;
  static Double  &diff_gf;
  static Double  &diff_im_gf;
  static Double  &chii_gf;
  static Double  &chie_gf;
  static Double  &exch_gf;
  static Double  &eta_par_gf;
  static Double  &eta_per_gf;
  static Double  &eta_phi_gf;
  static Double  &chie_e_gf;
  static Double  &cnorm_gf;
  static Double  &xkymin_gf;
  static Double  &xkymax_gf;
  static Double  &amassgas_gf;
  static Double  &amassimp_gf;
  static Double  &zimp_gf;
  static Vector<Integer> iflagin_gf;
  static Vector<Integer> ngrow_k_gf;
  static Integer  &nroot_gf;
  static Integer  &lprint_gf;
  static Integer  &ikymax_gf;
  static Integer  &i_err;
  static Integer  &i_proc;
  static Integer  &n_proc;
  static Integer  &jeigen;
  static Integer  &igfac;
  static Integer  &first_order_gf;
  static Integer  &ipert_gf;

// Group GLF_Transport_Input

  static Integer  &bt_flag;
  static Double  &alpha_d;
  static Double  &alpha_e;
  static Double  &x_alpha;
  static Vector<Double> alpha_exp;
  static Integer  &leigen;
  static Integer  &nroot;
  static Integer  &irotstab;
  static Integer  &i_grad;
  static Integer  &idengrad;
  static Integer  &i_delay;

// Group GLF_Transport_Output2

  static Double  &diffnem;
  static Double  &chietem;
  static Double  &chiitim;
  static Double  &etaphim;
  static Double  &etaparm;
  static Double  &etaperm;
  static Double  &exchm;
  static Vector<Double> chie_m;
  static Vector<Double> chii_m;
  static Vector<Double> etaphi_m;
  static Vector<Double> etapar_m;
  static Vector<Double> etaper_m;
  static Vector<Double> exch_m;
  static Vector<Double> egamma_m;
  static Vector<Double> egamma_d;
  static Vector<Double> gamma_p;
  static Vector<Double> anrate;
  static Vector<Double> anrate2;
  static Vector<Double> anfreq;
  static Vector<Double> anfreq2;
  static Vector<Double> xkymax;
  static Vector<Double> xkymax2;
  static Matrix<Double> chiGLFN;
  static Vector<Double> diffGLFN;
  static Vector<Double> diff_LzGLFN;

// Group GLF_Transport_wrapper_temps

  static Double  &hydDens;
  static Double  &impDens;
  static Double  &arhosquared;
  static Double  &bt;
  static Double  &csdacoef;
  static Double  &csda;
  static Double  &rho_over_r;
  static Vector<Double> te_glf;
  static Vector<Double> ti_glf;
  static Vector<Double> ne_glf;
  static Vector<Double> ni_glf;
  static Integer  &jmm;

// Group GLF_Transport_diagnostics

  static Vector<Double> neGLF;
  static Vector<Double> niGLF;
  static Vector<Double> nbeamGLF;
  static Double  &zpte_in;
  static Double  &zpti_in;
  static Double  &zpne_in;
  static Double  &zpni_in;
  static Vector<Double> angrotp_exp;
  static Vector<Double> egamma_exp;
  static Vector<Double> gamma_p_exp;
  static Vector<Double> vphilin;
  static Vector<Double> vpar_m;
  static Vector<Double> vper_m;
  static Double  &bt_axis;
  static Vector<Double> bteff_exp;
  static Vector<Double> rho_glf;
  static Double  &arho;
  static Vector<Double> gradrho_glf;
  static Vector<Double> gradrhosq_glf;
  static Double  &rmajor_exp;
  static Double  &zimpav;
  static Double  &amassimpav;
  static Vector<Double> shat_glf;
  static Double  &amassgas_glf;
  static Integer  &jshoot;
  static Integer  &jmaxm;
  static Vector<Integer> itport_pt;

// Group ToroidalRotation

  static Double  &omstarax;
  static Vector<Double> omegaTor;
  static Vector<Double> omegaPrTor;
  static Vector<Double> omegaExB;
  static Vector<Double> er_outer;
  static Vector<Double> erbp;
  static Vector<Double> e_r;
  static Vector<Double> e_r1;
  static Vector<Double> e_r2;

// Group ErShearFields

  static Integer  &iEr;
  static Integer  &iErBp;
  static Integer  &iPhiEPr;
  static Integer  &iOmegTor;

// Group ErShearMod

  static Integer  &iEShearMod;
  static Integer  &iWaltz;
  static Integer  &iHB;
  static Integer  &iStaeb;

// Group AngularMomentum_Transport

  static Double  &lzSrcTot;
  static Vector<Double> omegaBC;
  static Vector<Double> lzBC_;
  static Double  &diff_Lz_add;
  static Double  &chiForLzMult;
  static Double  &diff_LzCoef;
  static Vector<Double> lzTor;
  static Vector<Double> lzPrTor;
  static Vector<Double> lzPrPrTor;
  static Matrix<Double> lzToOmega;
  static Vector<Double> diff_Lz;
  static Integer  &useChiForDLz;
  static Vector<Double> vpinch_Lz;
  static Vector<Double> extraLzFlux;
  static Vector<Double> lzSrc;
  static Vector<Double> nbLzSrc;
  static Matrix<Double> lzFluxCoefs;
  static Vector<Double> lzFlux;
  static Matrix<Double> lzHProfs;

// Group Pellets

  static Double  &rPellet;
  static Double  &vPellet;
  static Double  &cPel;
  static Double  &pelDFrac;
  static Double  &pelTFrac;
  static Double  &pelHFrac;
  static Double  &pelSrcTot;
  static Vector<Double> nFuelTot;
  static Matrix<Double> nFuelCoefs;
  static Matrix<Double> nFuel;
  static Vector<Double> hydPelSrc;
  static Vector<Double> deutPelSrc;
  static Vector<Double> tritPelSrc;

// Group Confinement

  static Double  &ionStoredEnergy;
  static Double  &elecStoredEnergy;
  static Double  &storedEnergy;
  static Double  &tau_E;
  static Vector<Double> tauScale;
  static Vector<Double> hFacScale;

// Group Galerkin

  static Vector<Double> yFP;
  static Vector<Double> hrFP;
  static Vector<Double> lzFP;
  static Matrix<Double> muFP;
  static Matrix<Double> nFP;
  static Array3<Double> yCap;
  static Array3<Double> yStiff;
  static Matrix<Double> yLoad;
  static Array3<Double> muCap;
  static Array3<Double> muStiff;
  static Matrix<Double> muLoad;
  static Array3<Double> muDrag;
  static Array3<Double> nCap;
  static Array3<Double> nStiff;
  static Matrix<Double> nLoad;
  static Matrix<Double> lzCap;
  static Matrix<Double> lzStiff;
  static Vector<Double> lzLoad;

// Group Sawtooth_Data

  static Double  &qSawtooth;
  static Double  &sawtoothRadius;
  static Double  &chiEnhanceFac;
  static Double  &chiEnhanceDelta;
  static Double  &diffEnhanceFac;
  static Double  &diffEnhanceDelta;
  static Double  &sigTorEnhanceFrac;
  static Integer  &iSawtoothRadius;

// Group TransStep

  static Double  &time;
  static Double  &dt;
  static Double  &time_last;

#if defined(UseCTLPackage)
  static Integer gen(Vector<Integer> &optlist, Integer &nopt);
  static Integer exe(Vector<Integer> &optlist, Integer &nopt);
  static Integer fin(Vector<Integer> &optlist, Integer &nopt);
#endif

  static void sync();
};

#endif /* __cplusplus */

/* Run-controller package stuff: */

#if defined(UseCTLPackage)
#define ctr_ctrgen FF_ID(ctrgen, CTRGEN)
#define ctr_ctrexe FF_ID(ctrexe, CTREXE)
#define ctr_ctrfin FF_ID(ctrfin, CTRFIN)
#endif


#endif  /* __ctr__ */

