/* FILE: ctrBase.cc */

#if !defined(__ctr__)
#include "ctr.h"
#endif

#if defined(UseCTLPackage)
  extern "C" Integer ctr_ctrgen(Integer &, Integer &);
  extern "C" Integer ctr_ctrexe(Integer &, Integer &);
  extern "C" Integer ctr_ctrfin(Integer &, Integer &);
#endif



// Group Transport_Control


// genTrStorage is a c++ subroutine
extern "C" {
  void ctr_genTrStorage()
    {
      ctr::genTrStorage();
    }
};

// newTrPlasma is a c++ subroutine
extern "C" {
  void ctr_newTrPlasma()
    {
      ctr::newTrPlasma();
    }
};

// checkTrEqns is a c++ subroutine
extern "C" {
  void ctr_checkTrEqns()
    {
      ctr::checkTrEqns();
    }
};

// configureTrEqn is a c++ subroutine
extern "C" {
  void ctr_configureTrEqn( Integer &iEqn, Integer &iFlags )
    {
      ctr::configureTrEqn( iEqn, iFlags );
    }
};

// setTrInitConds is a c++ subroutine
extern "C" {
  void ctr_setTrInitConds()
    {
      ctr::setTrInitConds();
    }
};

// computeTrProfiles is a c++ subroutine
extern "C" {
  void ctr_computeTrProfiles()
    {
      ctr::computeTrProfiles();
    }
};

// setBCs is a c++ subroutine
extern "C" {
  void ctr_setBCs()
    {
      ctr::setBCs();
    }
};

// computeTrCoefs is a c++ subroutine
extern "C" {
  void ctr_computeTrCoefs()
    {
      ctr::computeTrCoefs();
    }
};

// computeTrParms is a c++ subroutine
extern "C" {
  void ctr_computeTrParms()
    {
      ctr::computeTrParms();
    }
};

// advanceTrEqns is a c++ subroutine
extern "C" {
  void ctr_advanceTrEqns()
    {
      ctr::advanceTrEqns();
    }
};

// setTrModel is a c++ subroutine
extern "C" {
  void ctr_setTrModel( Integer &iModel, Integer &iDefault )
    {
      ctr::setTrModel( iModel, iDefault );
    }
};

// makeTrProfile is a c++ subroutine
extern "C" {
  void ctr_makeTrProfile( Real &u, Real &u0, Real &a, Real &b, Real &r, Real &n )
    {
      ctr::makeTrProfile( u, u0, a, b, r, n );
    }
};

// testTr is a c++ subroutine
extern "C" {
  void ctr_testTr( Real &in, Real &out )
    {
      ctr::testTr( in, out );
    }
};

// ip_chi is a fortran subroutine
extern "C" void ctr_ip_chi( Real &, Real &, Real &, Real &, Real &, Real &, Real &, Real &, Real &, Real &, Real &, Real &, Real &, Real &, Real &, Real &, Real &, Real &, Real &, Real &, Real &, Real &, Real &, Real &, Real &, Real & );
void ctr::ip_chi( Real &rlt, Real &rln, Real &rlne, Real &q, Real &kappa, Real &shat, Real &zth, Real &nbeam, Real &tau, Real &eps, Real &gnu, Real &beta, Real &g_perp, Real &rmajor, Real &rho_i, Real &v_ti, Real &rho_e, Real &v_te, Real &etg, Real &rlte, Real &rltcrit, Real &rltcritz, Real &chi_0, Real &gfac, Real &chi_i, Real &chi_e )
  {
      ::ctr_ip_chi( rlt, rln, rlne, q, kappa, shat, zth, nbeam, tau, eps, gnu, beta, g_perp, rmajor, rho_i, v_ti, rho_e, v_te, etg, rlte, rltcrit, rltcritz, chi_0, gfac, chi_i, chi_e );
  }

// evalSimple is a c++ subroutine
extern "C" {
  void ctr_evalSimple()
    {
      ctr::evalSimple();
    }
};

// evalNeo is a c++ subroutine
extern "C" {
  void ctr_evalNeo()
    {
      ctr::evalNeo();
    }
};

// evalCH is a c++ subroutine
extern "C" {
  void ctr_evalCH()
    {
      ctr::evalCH();
    }
};

// evalRLW is a c++ subroutine
extern "C" {
  void ctr_evalRLW()
    {
      ctr::evalRLW();
    }
};

// evalGLF is a c++ subroutine
extern "C" {
  void ctr_evalGLF()
    {
      ctr::evalGLF();
    }
};

// evalHS is a c++ subroutine
extern "C" {
  void ctr_evalHS()
    {
      ctr::evalHS();
    }
};

// evalNclass is a c++ subroutine
extern "C" {
  void ctr_evalNclass()
    {
      ctr::evalNclass();
    }
};

// evalKDBH is a c++ subroutine
extern "C" {
  void ctr_evalKDBH()
    {
      ctr::evalKDBH();
    }
};

// evalUserTransport is a c++ subroutine
extern "C" {
  void ctr_evalUserTransport()
    {
      ctr::evalUserTransport();
    }
};

// glfinit1_0 is a fortran subroutine
extern "C" void ctr_glfinit1_0( void );
void ctr::glfinit1_0()
  {
      ::ctr_glfinit1_0();
  }

// glftest1_0 is a fortran subroutine
extern "C" void ctr_glftest1_0( void );
void ctr::glftest1_0()
  {
      ::ctr_glftest1_0();
  }

// glf2d1_0 is a fortran subroutine
extern "C" void ctr_glf2d1_0( void );
void ctr::glf2d1_0()
  {
      ::ctr_glf2d1_0();
  }

// glf2d is a fortran subroutine
extern "C" void ctr_glf2d( void );
void ctr::glf2d()
  {
      ::ctr_glf2d();
  }

// callglf2d_wrap is a fortran subroutine
extern "C" void ctr_callglf2d_wrap( void );
void ctr::callglf2d_wrap()
  {
      ::ctr_callglf2d_wrap();
  }

// getOmegaExB is a c++ subroutine
extern "C" {
  void ctr_getOmegaExB( Integer &ifield )
    {
      ctr::getOmegaExB( ifield );
    }
};



// Group Transport_Hooks


extern "C" struct {
  Integer userSource_hooks_n;
  Integer diagnostic_hooks_n;
  Integer iterdiag_hooks_n;
  Integer history_hooks_n;
  Integer profiles_prehooks_n;
  Integer profiles_posthooks_n;
  Integer transCoefs_prehooks_n;
  Integer transCoefs_posthooks_n;
  Integer parameters_prehooks_n;
  Integer parameters_posthooks_n;
  Integer equations_prehooks_n;
  Integer equations_posthooks_n;
} CTR10_Transport_Hooks;

Integer  &ctr::userSource_hooks_n = CTR10_Transport_Hooks.userSource_hooks_n;
Integer  &ctr::diagnostic_hooks_n = CTR10_Transport_Hooks.diagnostic_hooks_n;
Integer  &ctr::iterdiag_hooks_n = CTR10_Transport_Hooks.iterdiag_hooks_n;
Integer  &ctr::history_hooks_n = CTR10_Transport_Hooks.history_hooks_n;
Integer  &ctr::profiles_prehooks_n = CTR10_Transport_Hooks.profiles_prehooks_n;
Integer  &ctr::profiles_posthooks_n = CTR10_Transport_Hooks.profiles_posthooks_n;
Integer  &ctr::transCoefs_prehooks_n = CTR10_Transport_Hooks.transCoefs_prehooks_n;
Integer  &ctr::transCoefs_posthooks_n = CTR10_Transport_Hooks.transCoefs_posthooks_n;
Integer  &ctr::parameters_prehooks_n = CTR10_Transport_Hooks.parameters_prehooks_n;
Integer  &ctr::parameters_posthooks_n = CTR10_Transport_Hooks.parameters_posthooks_n;
Integer  &ctr::equations_prehooks_n = CTR10_Transport_Hooks.equations_prehooks_n;
Integer  &ctr::equations_posthooks_n = CTR10_Transport_Hooks.equations_posthooks_n;


// Group Transport_Flags


extern "C" struct {
  Integer iSimple;
  Integer iNeo;
  Integer iRLW;
  Integer iKDBH;
  Integer iGLF;
  Integer iUser;
  Integer currentModel;
  Integer suppress_Simple;
  Integer suppress_Neo;
  Integer suppress_PS;
  Integer hr_BCFlag;
  Integer elementType;
  Integer eqnsConfig[Nconfig];
  Integer iNoEqn;
  Integer iZeroD;
  Integer iBSplineFE;
  Integer iLinearFE;
  Integer iSpecifyIotaIC;
  Integer iSpecifyQIC;
  Integer iSpecifyEntropyIC;
  Integer iSpecifyTempIC;
  Integer useUGradP;
  Integer magnShld;
  Integer iNeoAlc;
  Integer iDIIID;
  Integer iITER_P;
  Integer iITER_O;
  Integer iRebutLallia;
  Integer iITER_PMin;
  Integer useSawtoothModel;
  Integer iNoSawtooth;
  Integer iUserSawtooth;
  Integer iChiSawtooth;
  Integer iSmoothSawtooth;
  Integer boundaryFluxHack;
} CTR20_Transport_Flags;

extern "C" struct {
  Logical neoWarn;
  Logical useMassLumping;
  Logical useBSplineInterp;
  Logical nonConvDirichletBC;
  Logical goodEndDerivative;
  Logical fluxEnforceBC;
  Logical fixed_dens;
  Logical fixed_y;
  Logical fixed_mu;
  Logical fixed_lz;
} CTR21_Transport_Flags;

Integer  &ctr::iSimple = CTR20_Transport_Flags.iSimple;
Integer  &ctr::iNeo = CTR20_Transport_Flags.iNeo;
Integer  &ctr::iRLW = CTR20_Transport_Flags.iRLW;
Integer  &ctr::iKDBH = CTR20_Transport_Flags.iKDBH;
Integer  &ctr::iGLF = CTR20_Transport_Flags.iGLF;
Integer  &ctr::iUser = CTR20_Transport_Flags.iUser;
Integer  &ctr::currentModel = CTR20_Transport_Flags.currentModel;
Logical  &ctr::neoWarn = CTR21_Transport_Flags.neoWarn;
Integer  &ctr::suppress_Simple = CTR20_Transport_Flags.suppress_Simple;
Integer  &ctr::suppress_Neo = CTR20_Transport_Flags.suppress_Neo;
Integer  &ctr::suppress_PS = CTR20_Transport_Flags.suppress_PS;
Logical  &ctr::useMassLumping = CTR21_Transport_Flags.useMassLumping;
Logical  &ctr::useBSplineInterp = CTR21_Transport_Flags.useBSplineInterp;
Logical  &ctr::nonConvDirichletBC = CTR21_Transport_Flags.nonConvDirichletBC;
Logical  &ctr::goodEndDerivative = CTR21_Transport_Flags.goodEndDerivative;
Logical  &ctr::fluxEnforceBC = CTR21_Transport_Flags.fluxEnforceBC;
Integer  &ctr::hr_BCFlag = CTR20_Transport_Flags.hr_BCFlag;
Integer  &ctr::elementType = CTR20_Transport_Flags.elementType;
Vector<Integer> ctr::eqnsConfig(1,Nconfig, CTR20_Transport_Flags.eqnsConfig);
Integer  &ctr::iNoEqn = CTR20_Transport_Flags.iNoEqn;
Integer  &ctr::iZeroD = CTR20_Transport_Flags.iZeroD;
Integer  &ctr::iBSplineFE = CTR20_Transport_Flags.iBSplineFE;
Integer  &ctr::iLinearFE = CTR20_Transport_Flags.iLinearFE;
Integer  &ctr::iSpecifyIotaIC = CTR20_Transport_Flags.iSpecifyIotaIC;
Integer  &ctr::iSpecifyQIC = CTR20_Transport_Flags.iSpecifyQIC;
Integer  &ctr::iSpecifyEntropyIC = CTR20_Transport_Flags.iSpecifyEntropyIC;
Integer  &ctr::iSpecifyTempIC = CTR20_Transport_Flags.iSpecifyTempIC;
Integer  &ctr::useUGradP = CTR20_Transport_Flags.useUGradP;
Integer  &ctr::magnShld = CTR20_Transport_Flags.magnShld;
Integer  &ctr::iNeoAlc = CTR20_Transport_Flags.iNeoAlc;
Integer  &ctr::iDIIID = CTR20_Transport_Flags.iDIIID;
Integer  &ctr::iITER_P = CTR20_Transport_Flags.iITER_P;
Integer  &ctr::iITER_O = CTR20_Transport_Flags.iITER_O;
Integer  &ctr::iRebutLallia = CTR20_Transport_Flags.iRebutLallia;
Integer  &ctr::iITER_PMin = CTR20_Transport_Flags.iITER_PMin;
Integer  &ctr::useSawtoothModel = CTR20_Transport_Flags.useSawtoothModel;
Integer  &ctr::iNoSawtooth = CTR20_Transport_Flags.iNoSawtooth;
Integer  &ctr::iUserSawtooth = CTR20_Transport_Flags.iUserSawtooth;
Integer  &ctr::iChiSawtooth = CTR20_Transport_Flags.iChiSawtooth;
Integer  &ctr::iSmoothSawtooth = CTR20_Transport_Flags.iSmoothSawtooth;
Integer  &ctr::boundaryFluxHack = CTR20_Transport_Flags.boundaryFluxHack;
Logical  &ctr::fixed_dens = CTR21_Transport_Flags.fixed_dens;
Logical  &ctr::fixed_y = CTR21_Transport_Flags.fixed_y;
Logical  &ctr::fixed_mu = CTR21_Transport_Flags.fixed_mu;
Logical  &ctr::fixed_lz = CTR21_Transport_Flags.fixed_lz;


// Group Transport_Dimensions


extern "C" struct {
  Integer nrho;
  Integer nigpts;
  Integer nfps;
  Integer nparts;
  Integer ntemps;
  Integer nhterms;
  Integer iElecIon;
  Integer iIonElec;
} CTR30_Transport_Dimensions;

Integer  &ctr::nrho = CTR30_Transport_Dimensions.nrho;
Integer  &ctr::nigpts = CTR30_Transport_Dimensions.nigpts;
Integer  &ctr::nfps = CTR30_Transport_Dimensions.nfps;
Integer  &ctr::nparts = CTR30_Transport_Dimensions.nparts;
Integer  &ctr::ntemps = CTR30_Transport_Dimensions.ntemps;
Integer  &ctr::nhterms = CTR30_Transport_Dimensions.nhterms;
Integer  &ctr::iElecIon = CTR30_Transport_Dimensions.iElecIon;
Integer  &ctr::iIonElec = CTR30_Transport_Dimensions.iIonElec;


// Group Flux_Transport


extern "C" struct {
  Integer lstrTor;
} CTR40_Flux_Transport;

extern "C" struct {
  Logical withHyperR;
} CTR41_Flux_Transport;

extern "C" struct {
  Double thetaFlux;
  Double torfDot;
  Double psiAxis;
  Double psiAxisDot;
  Double psiEdge;
  Double ipPrEdge;
  Double jtTor_edge;
  Double jparTor_edge;
  Double yBC_[3];
  Double yBC_old[3];
} CTR43_Flux_Transport;

extern "C" struct {
  Double *c23Dot;
  Double *ipTor;
  Double *ipPrTor;
  Double *strTor;
  Double *unstrTor;
  Double *strPrTor;
  Double *rhostr;
  Double *iotaTor;
  Double *iotaPrTor;
  Double *yTor;
  Double *yPrTor;
  Double *yPrPrTor;
  Double *yTorDot;
  Double *hrTor;
  Double *hrPrTor;
  Double *hrPrPrTor;
  Double *qExp;
  Double *pExp;
  Double *jniTor;
  Double *jICTor;
  Double *jLHTor;
  Double *jECTor;
  Double *juserTor;
  Double *factTor;
  Double *yHProfs;
  Double *yHProfs_old;
} CTR46_Flux_Transport;

Double  &ctr::thetaFlux = CTR43_Flux_Transport.thetaFlux;
Double  &ctr::torfDot = CTR43_Flux_Transport.torfDot;
Double  &ctr::psiAxis = CTR43_Flux_Transport.psiAxis;
Double  &ctr::psiAxisDot = CTR43_Flux_Transport.psiAxisDot;
Double  &ctr::psiEdge = CTR43_Flux_Transport.psiEdge;
Double  &ctr::ipPrEdge = CTR43_Flux_Transport.ipPrEdge;
Double  &ctr::jtTor_edge = CTR43_Flux_Transport.jtTor_edge;
Double  &ctr::jparTor_edge = CTR43_Flux_Transport.jparTor_edge;
Vector<Double> ctr::yBC_(1,3, CTR43_Flux_Transport.yBC_);
Vector<Double> ctr::yBC_old(1,3, CTR43_Flux_Transport.yBC_old);
Vector<Double> ctr::c23Dot(false);
Vector<Double> ctr::ipTor(false);
Vector<Double> ctr::ipPrTor(false);
Vector<Double> ctr::strTor(false);
Integer  &ctr::lstrTor = CTR40_Flux_Transport.lstrTor;
Vector<Double> ctr::unstrTor(false);
Vector<Double> ctr::strPrTor(false);
Vector<Double> ctr::rhostr(false);
Vector<Double> ctr::iotaTor(false);
Vector<Double> ctr::iotaPrTor(false);
Vector<Double> ctr::yTor(false);
Vector<Double> ctr::yPrTor(false);
Vector<Double> ctr::yPrPrTor(false);
Vector<Double> ctr::yTorDot(false);
Vector<Double> ctr::hrTor(false);
Vector<Double> ctr::hrPrTor(false);
Vector<Double> ctr::hrPrPrTor(false);
Vector<Double> ctr::qExp(false);
Vector<Double> ctr::pExp(false);
Vector<Double> ctr::jniTor(false);
Vector<Double> ctr::jICTor(false);
Vector<Double> ctr::jLHTor(false);
Vector<Double> ctr::jECTor(false);
Vector<Double> ctr::juserTor(false);
Vector<Double> ctr::factTor(false);
Array3<Double> ctr::yHProfs(false);
Array3<Double> ctr::yHProfs_old(false);
Logical  &ctr::withHyperR = CTR41_Flux_Transport.withHyperR;


// Group Entropy_Transport


extern "C" struct {
  Double thetaMu;
  Double convMult;
  Double tempVolAvg[Ntemps];
  Double tempNVolAvg[Ntemps];
  Double heatSrcTot[Ntemps];
  Double pUGradPTot[Ntemps];
  Double tempBC[3*Ntemps];
  Double tempBC_old[3*Ntemps];
  Double muBC_[3*2*Ntemps];
  Double muBC_old[3*2*Ntemps];
} CTR53_Entropy_Transport;

extern "C" struct {
  Double *pUGradP;
  Double *muTor;
  Double *muPrTor;
  Double *muPrPrTor;
  Double *muTorDot;
  Double *muToTemp;
  Double *vpr23;
  Double *gammaPS;
  Double *chi;
  Double *fluxH;
  Double *pinchH;
  Double *heatSrc;
  Double *heatFluxCoefs;
  Double *heatFlux;
  Double *entropyTor;
  Double *muHProfs;
  Double *muHProfs_old;
} CTR56_Entropy_Transport;

Double  &ctr::thetaMu = CTR53_Entropy_Transport.thetaMu;
Double  &ctr::convMult = CTR53_Entropy_Transport.convMult;
Vector<Double> ctr::tempVolAvg(1,Ntemps, CTR53_Entropy_Transport.tempVolAvg);
Vector<Double> ctr::tempNVolAvg(1,Ntemps, CTR53_Entropy_Transport.tempNVolAvg);
Vector<Double> ctr::heatSrcTot(1,Ntemps, CTR53_Entropy_Transport.heatSrcTot);
Vector<Double> ctr::pUGradPTot(1,Ntemps, CTR53_Entropy_Transport.pUGradPTot);
Matrix<Double> ctr::tempBC(1,3,1,Ntemps, CTR53_Entropy_Transport.tempBC);
Matrix<Double> ctr::tempBC_old(1,3,1,Ntemps, CTR53_Entropy_Transport.tempBC_old);
Matrix<Double> ctr::muBC_(1,3,1,2*Ntemps, CTR53_Entropy_Transport.muBC_);
Matrix<Double> ctr::muBC_old(1,3,1,2*Ntemps, CTR53_Entropy_Transport.muBC_old);
Matrix<Double> ctr::pUGradP(false);
Matrix<Double> ctr::muTor(false);
Matrix<Double> ctr::muPrTor(false);
Matrix<Double> ctr::muPrPrTor(false);
Matrix<Double> ctr::muTorDot(false);
Array3<Double> ctr::muToTemp(false);
Vector<Double> ctr::vpr23(false);
Matrix<Double> ctr::gammaPS(false);
Matrix<Double> ctr::chi(false);
Matrix<Double> ctr::fluxH(false);
Matrix<Double> ctr::pinchH(false);
Matrix<Double> ctr::heatSrc(false);
Array3<Double> ctr::heatFluxCoefs(false);
Matrix<Double> ctr::heatFlux(false);
Matrix<Double> ctr::entropyTor(false);
Array3<Double> ctr::muHProfs(false);
Array3<Double> ctr::muHProfs_old(false);


// Group Auxiliary_Power


extern "C" struct {
  Double pAuxTot[Ntemps];
  Double pAuxCoefs[3*Ntemps];
} CTR63_Auxiliary_Power;

extern "C" struct {
  Double *pAux;
} CTR66_Auxiliary_Power;

Vector<Double> ctr::pAuxTot(1,Ntemps, CTR63_Auxiliary_Power.pAuxTot);
Matrix<Double> ctr::pAuxCoefs(1,3,1,Ntemps, CTR63_Auxiliary_Power.pAuxCoefs);
Matrix<Double> ctr::pAux(false);


// Group Drag_Power


extern "C" struct {
  Double pDragTot;
} CTR73_Drag_Power;

extern "C" struct {
  Double *pDrag;
  Double *dragCoef;
} CTR76_Drag_Power;

Double  &ctr::pDragTot = CTR73_Drag_Power.pDragTot;
Vector<Double> ctr::pDrag(false);
Vector<Double> ctr::dragCoef(false);


// Group Fusion_Power


extern "C" struct {
  Double pFusDDElecTot;
  Double pFusDDIonTot;
  Double pNeutDDTot;
  Double pFusDDTot;
  Double fPromptLoss;
  Double pFusDTElecTot;
  Double pFusDTIonTot;
  Double pNeutDTTot;
  Double pFusDTTot;
  Double pNeutBtDDTot;
  Double pNeutBtDTTot;
  Double rxnRateDDnTot;
  Double rxnRateDTTot;
  Double rxnRateBtDDnTot;
  Double rxnRateBtDTTot;
} CTR83_Fusion_Power;

extern "C" struct {
  Double *sigmavDDn;
  Double *sigmavDDp;
  Double *rxnRateDDn;
  Double *rxnRateDDp;
  Double *pFusDDElec;
  Double *pFusDDIon;
  Double *pNeutDD;
  Double *fastPressDD;
  Double *sigmavDT;
  Double *rxnRateDT;
  Double *pFusDTElec;
  Double *pFusDTIon;
  Double *pNeutDT;
  Double *fastPressDT;
  Double *rxnRateBtDDn;
  Double *rxnRateBtDT;
  Double *pNeutBtDD;
  Double *pNeutBtDT;
} CTR86_Fusion_Power;

Double  &ctr::pFusDDElecTot = CTR83_Fusion_Power.pFusDDElecTot;
Double  &ctr::pFusDDIonTot = CTR83_Fusion_Power.pFusDDIonTot;
Double  &ctr::pNeutDDTot = CTR83_Fusion_Power.pNeutDDTot;
Double  &ctr::pFusDDTot = CTR83_Fusion_Power.pFusDDTot;
Double  &ctr::fPromptLoss = CTR83_Fusion_Power.fPromptLoss;
Double  &ctr::pFusDTElecTot = CTR83_Fusion_Power.pFusDTElecTot;
Double  &ctr::pFusDTIonTot = CTR83_Fusion_Power.pFusDTIonTot;
Double  &ctr::pNeutDTTot = CTR83_Fusion_Power.pNeutDTTot;
Double  &ctr::pFusDTTot = CTR83_Fusion_Power.pFusDTTot;
Vector<Double> ctr::sigmavDDn(false);
Vector<Double> ctr::sigmavDDp(false);
Vector<Double> ctr::rxnRateDDn(false);
Vector<Double> ctr::rxnRateDDp(false);
Vector<Double> ctr::pFusDDElec(false);
Vector<Double> ctr::pFusDDIon(false);
Vector<Double> ctr::pNeutDD(false);
Vector<Double> ctr::fastPressDD(false);
Vector<Double> ctr::sigmavDT(false);
Vector<Double> ctr::rxnRateDT(false);
Vector<Double> ctr::pFusDTElec(false);
Vector<Double> ctr::pFusDTIon(false);
Vector<Double> ctr::pNeutDT(false);
Vector<Double> ctr::fastPressDT(false);
Vector<Double> ctr::rxnRateBtDDn(false);
Vector<Double> ctr::rxnRateBtDT(false);
Vector<Double> ctr::pNeutBtDD(false);
Vector<Double> ctr::pNeutBtDT(false);
Double  &ctr::pNeutBtDDTot = CTR83_Fusion_Power.pNeutBtDDTot;
Double  &ctr::pNeutBtDTTot = CTR83_Fusion_Power.pNeutBtDTTot;
Double  &ctr::rxnRateDDnTot = CTR83_Fusion_Power.rxnRateDDnTot;
Double  &ctr::rxnRateDTTot = CTR83_Fusion_Power.rxnRateDTTot;
Double  &ctr::rxnRateBtDDnTot = CTR83_Fusion_Power.rxnRateBtDDnTot;
Double  &ctr::rxnRateBtDTTot = CTR83_Fusion_Power.rxnRateBtDTTot;


// Group Ohmic_Power


extern "C" struct {
  Double pOhmicTot;
} CTR93_Ohmic_Power;

extern "C" struct {
  Double *pOhmic;
} CTR96_Ohmic_Power;

Double  &ctr::pOhmicTot = CTR93_Ohmic_Power.pOhmicTot;
Vector<Double> ctr::pOhmic(false);


// Group RF_Power


extern "C" struct {
  Double pRFTot;
} CTR103_RF_Power;

extern "C" struct {
  Double *pRF;
} CTR106_RF_Power;

Double  &ctr::pRFTot = CTR103_RF_Power.pRFTot;
Vector<Double> ctr::pRF(false);


// Group Runaway_Electrons


extern "C" struct {
  Logical run_away;
} CTR111_Runaway_Electrons;

extern "C" struct {
  Double *tau_run;
  Double *source_run;
  Double *ecrit;
} CTR116_Runaway_Electrons;

Vector<Double> ctr::tau_run(false);
Vector<Double> ctr::source_run(false);
Vector<Double> ctr::ecrit(false);
Logical  &ctr::run_away = CTR111_Runaway_Electrons.run_away;


// Group Radiation_Power


extern "C" struct {
  Double rWall;
  Double pBLRRadTot;
  Double pSyncTot;
} CTR123_Radiation_Power;

extern "C" struct {
  Double *pBLRRad;
  Double *pSync;
} CTR126_Radiation_Power;

Double  &ctr::rWall = CTR123_Radiation_Power.rWall;
Double  &ctr::pBLRRadTot = CTR123_Radiation_Power.pBLRRadTot;
Double  &ctr::pSyncTot = CTR123_Radiation_Power.pSyncTot;
Vector<Double> ctr::pBLRRad(false);
Vector<Double> ctr::pSync(false);


// Group Density_Transport


extern "C" struct {
  Double thetaN;
  Double particleSrcTot[Nparts];
  Double mass[Nparts];
  Double densVolAvg[Nparts];
  Double ionMassAvg;
  Double etaDivertor[Nparts];
  Double alphaRecycle[Nparts];
  Double recycleCoef[Nparts];
  Double gasPuffSrc[Nparts];
  Double gasPuffCoef[Nparts];
  Double recycleWidth;
  Double densBorass;
  Double densGreenwald;
  Double densBC[3*Nparts];
  Double nBC_[3*Nparts];
} CTR133_Density_Transport;

extern "C" struct {
  Double *nTor;
  Double *nPrTor;
  Double *nPrPrTor;
  Double *nTorDot;
  Double *massDensPrTor;
  Double *mn_over_charge;
  Double *mnPr_over_charge;
  Double *nToDens;
  Double *recycleSrc;
  Double *implicitRecycleSrc;
  Double *diff;
  Double *pinch;
  Double *fluxN;
  Double *particleSrc;
  Double *particleFluxCoefs;
  Double *particleFlux;
  Double *sumPartFlux;
  Double *nHProfs;
} CTR136_Density_Transport;

Double  &ctr::thetaN = CTR133_Density_Transport.thetaN;
Vector<Double> ctr::particleSrcTot(1,Nparts, CTR133_Density_Transport.particleSrcTot);
Vector<Double> ctr::mass(1,Nparts, CTR133_Density_Transport.mass);
Vector<Double> ctr::densVolAvg(1,Nparts, CTR133_Density_Transport.densVolAvg);
Double  &ctr::ionMassAvg = CTR133_Density_Transport.ionMassAvg;
Vector<Double> ctr::etaDivertor(1,Nparts, CTR133_Density_Transport.etaDivertor);
Vector<Double> ctr::alphaRecycle(1,Nparts, CTR133_Density_Transport.alphaRecycle);
Vector<Double> ctr::recycleCoef(1,Nparts, CTR133_Density_Transport.recycleCoef);
Vector<Double> ctr::gasPuffSrc(1,Nparts, CTR133_Density_Transport.gasPuffSrc);
Vector<Double> ctr::gasPuffCoef(1,Nparts, CTR133_Density_Transport.gasPuffCoef);
Double  &ctr::recycleWidth = CTR133_Density_Transport.recycleWidth;
Double  &ctr::densBorass = CTR133_Density_Transport.densBorass;
Double  &ctr::densGreenwald = CTR133_Density_Transport.densGreenwald;
Matrix<Double> ctr::densBC(1,3,1,Nparts, CTR133_Density_Transport.densBC);
Matrix<Double> ctr::nBC_(1,3,1,Nparts, CTR133_Density_Transport.nBC_);
Matrix<Double> ctr::nTor(false);
Matrix<Double> ctr::nPrTor(false);
Matrix<Double> ctr::nPrPrTor(false);
Matrix<Double> ctr::nTorDot(false);
Vector<Double> ctr::massDensPrTor(false);
Vector<Double> ctr::mn_over_charge(false);
Vector<Double> ctr::mnPr_over_charge(false);
Matrix<Double> ctr::nToDens(false);
Matrix<Double> ctr::recycleSrc(false);
Matrix<Double> ctr::implicitRecycleSrc(false);
Matrix<Double> ctr::diff(false);
Matrix<Double> ctr::pinch(false);
Matrix<Double> ctr::fluxN(false);
Matrix<Double> ctr::particleSrc(false);
Array3<Double> ctr::particleFluxCoefs(false);
Matrix<Double> ctr::particleFlux(false);
Vector<Double> ctr::sumPartFlux(false);
Array3<Double> ctr::nHProfs(false);


// Group Turbulent_Transport


extern "C" struct {
  Double *shat;
  Double *taui;
} CTR146_Turbulent_Transport;

Vector<Double> ctr::shat(false);
Vector<Double> ctr::taui(false);


// Group Simple_Transport_Input


extern "C" struct {
  Double *chiData;
  Double *diffData;
  Double *diff_LzData;
} CTR156_Simple_Transport_Input;

Matrix<Double> ctr::chiData(false);
Matrix<Double> ctr::diffData(false);
Vector<Double> ctr::diff_LzData(false);


// Group Simple_Transport_Output


extern "C" struct {
  Double *chiSimple;
  Double *diffSimple;
  Double *diff_LzSimple;
} CTR166_Simple_Transport_Output;

Matrix<Double> ctr::chiSimple(false);
Matrix<Double> ctr::diffSimple(false);
Vector<Double> ctr::diff_LzSimple(false);


// Group Neo_Transport


extern "C" struct {
  Double *diffNeo;
  Double *pinchNNeo;
  Double *fluxNNeo;
  Double *chiNeo;
  Double *pinchHNeo;
  Double *fluxHNeo;
  Double *diff_LzNeo;
} CTR176_Neo_Transport;

Matrix<Double> ctr::diffNeo(false);
Matrix<Double> ctr::pinchNNeo(false);
Matrix<Double> ctr::fluxNNeo(false);
Matrix<Double> ctr::chiNeo(false);
Matrix<Double> ctr::pinchHNeo(false);
Matrix<Double> ctr::fluxHNeo(false);
Vector<Double> ctr::diff_LzNeo(false);


// Group CH_Transport


extern "C" struct {
  Double *chiCH;
  Double *diffCH;
  Double *vWarePinch;
} CTR186_CH_Transport;

Matrix<Double> ctr::chiCH(false);
Vector<Double> ctr::diffCH(false);
Vector<Double> ctr::vWarePinch(false);


// Group RLW_Transport_Input


extern "C" struct {
  Double rebutHElec;
  Double rebutHIon;
  Double rebutDiffCoef[Nparts];
  Double rebutDiff_LzCoef;
  Double chifact1;
  Double critTeCoef;
  Double chiIECoef;
  Double chiIECoef2;
  Double diffOverChi;
  Double pinchCoef;
} CTR193_RLW_Transport_Input;

Double  &ctr::rebutHElec = CTR193_RLW_Transport_Input.rebutHElec;
Double  &ctr::rebutHIon = CTR193_RLW_Transport_Input.rebutHIon;
Vector<Double> ctr::rebutDiffCoef(1,Nparts, CTR193_RLW_Transport_Input.rebutDiffCoef);
Double  &ctr::rebutDiff_LzCoef = CTR193_RLW_Transport_Input.rebutDiff_LzCoef;
Double  &ctr::chifact1 = CTR193_RLW_Transport_Input.chifact1;
Double  &ctr::critTeCoef = CTR193_RLW_Transport_Input.critTeCoef;
Double  &ctr::chiIECoef = CTR193_RLW_Transport_Input.chiIECoef;
Double  &ctr::chiIECoef2 = CTR193_RLW_Transport_Input.chiIECoef2;
Double  &ctr::diffOverChi = CTR193_RLW_Transport_Input.diffOverChi;
Double  &ctr::pinchCoef = CTR193_RLW_Transport_Input.pinchCoef;


// Group RLW_Transport_Output


extern "C" struct {
  Double *chiRLW;
  Double *diffRLW;
  Double *pinchRLW;
  Double *diff_LzRLW;
  Double *gradTe_crit;
  Double *chiAnomalous;
} CTR206_RLW_Transport_Output;

Matrix<Double> ctr::chiRLW(false);
Vector<Double> ctr::diffRLW(false);
Vector<Double> ctr::pinchRLW(false);
Vector<Double> ctr::diff_LzRLW(false);
Vector<Double> ctr::gradTe_crit(false);
Vector<Double> ctr::chiAnomalous(false);


// Group HS_Transport_Output


extern "C" struct {
  Double *chiHS;
  Double *diffHS;
  Double *pinchNHS;
  Double *pinchHHS;
  Double *fluxNHS;
  Double *fluxHHS;
} CTR216_HS_Transport_Output;

Matrix<Double> ctr::chiHS(false);
Matrix<Double> ctr::diffHS(false);
Matrix<Double> ctr::pinchNHS(false);
Matrix<Double> ctr::pinchHHS(false);
Matrix<Double> ctr::fluxNHS(false);
Matrix<Double> ctr::fluxHHS(false);


// Group Nclass_Transport


extern "C" struct {
  Double *diffNclass;
  Double *pinchNNclass;
  Double *fluxNNclass;
  Double *chiNclass;
  Double *pinchHNclass;
  Double *fluxHNclass;
} CTR226_Nclass_Transport;

Matrix<Double> ctr::diffNclass(false);
Matrix<Double> ctr::pinchNNclass(false);
Matrix<Double> ctr::fluxNNclass(false);
Matrix<Double> ctr::chiNclass(false);
Matrix<Double> ctr::pinchHNclass(false);
Matrix<Double> ctr::fluxHNclass(false);


// Group KDBH_Transport_Input


extern "C" struct {
  Double shatmin;
} CTR233_KDBH_Transport_Input;

extern "C" struct {
  Double *rmajLTi;
  Double *rmajLNi;
  Double *rmajLNe;
  Double *z_effKDBH;
  Double *eps_tmp;
  Double *gnuKDBH;
  Double *ionGyroRad;
  Double *ionVth;
  Double *geomfac;
} CTR236_KDBH_Transport_Input;

Double  &ctr::shatmin = CTR233_KDBH_Transport_Input.shatmin;
Vector<Double> ctr::rmajLTi(false);
Vector<Double> ctr::rmajLNi(false);
Vector<Double> ctr::rmajLNe(false);
Vector<Double> ctr::z_effKDBH(false);
Vector<Double> ctr::eps_tmp(false);
Vector<Double> ctr::gnuKDBH(false);
Vector<Double> ctr::ionGyroRad(false);
Vector<Double> ctr::ionVth(false);
Vector<Double> ctr::geomfac(false);


// Group KDBH_Transport_Output


extern "C" struct {
  Double *chiKDBH;
  Double *diffKDBH;
  Double *diff_LzKDBH;
  Double *rmajLTcrit;
  Double *rmajLTcritz;
  Double *gamKDBH;
} CTR246_KDBH_Transport_Output;

Matrix<Double> ctr::chiKDBH(false);
Vector<Double> ctr::diffKDBH(false);
Vector<Double> ctr::diff_LzKDBH(false);
Vector<Double> ctr::rmajLTcrit(false);
Vector<Double> ctr::rmajLTcritz(false);
Vector<Double> ctr::gamKDBH(false);


// Group GLF_Transport_Input1_0


extern "C" struct {
  Integer eigen_solver_gf1_0;
  Integer nroot_gf1_0;
  Integer iflagin_gf1_0[20];
  Integer ikymax_gf1_0;
  Integer lprint_gf1_0;
  Integer vGLF;
} CTR250_GLF_Transport_Input1_0;

extern "C" struct {
  Double xparam_gf1_0[20];
  Double xky0_gf1_0;
  Double rms_theta_gf1_0;
  Double rlti_gf1_0;
  Double rlte_gf1_0;
  Double rlne_gf1_0;
  Double rlni_gf1_0;
  Double dil_gf1_0;
  Double xdil_m1_0;
  Double taui_gf1_0;
  Double rmin_gf1_0;
  Double rmaj_gf1_0;
  Double q_gf1_0;
  Double xnu_gf1_0;
  Double cxnu1_0;
  Double xshift1_0;
  Double betae_gf1_0;
  Double cbetae1_0;
  Double shat_gf1_0;
  Double alpha_gf1_0;
  Double elong_gf1_0;
  Double xwell_gf1_0;
  Double park_gf1_0;
  Double ghat_gf1_0;
  Double gchat_gf1_0;
  Double adamp_gf1_0;
  Double alpha_star_gf1_0;
  Double gamma_star_gf1_0;
  Double alpha_e_gf1_0;
  Double gamma_e_gf1_0;
  Double alpha_mode_gf1_0;
  Double gamma_mode_gf1_0;
  Double alpha_p_gf1_0;
  Double gamma_p_gf1_0;
  Double xkdamp_gf1_0;
  Double xkymin_gf1_0;
  Double xkymax_gf1_0;
  Double amassgas_gf1_0;
  Double cmodel1_0;
} CTR253_GLF_Transport_Input1_0;

Integer  &ctr::eigen_solver_gf1_0 = CTR250_GLF_Transport_Input1_0.eigen_solver_gf1_0;
Integer  &ctr::nroot_gf1_0 = CTR250_GLF_Transport_Input1_0.nroot_gf1_0;
Vector<Integer> ctr::iflagin_gf1_0(1,20, CTR250_GLF_Transport_Input1_0.iflagin_gf1_0);
Vector<Double> ctr::xparam_gf1_0(1,20, CTR253_GLF_Transport_Input1_0.xparam_gf1_0);
Double  &ctr::xky0_gf1_0 = CTR253_GLF_Transport_Input1_0.xky0_gf1_0;
Double  &ctr::rms_theta_gf1_0 = CTR253_GLF_Transport_Input1_0.rms_theta_gf1_0;
Double  &ctr::rlti_gf1_0 = CTR253_GLF_Transport_Input1_0.rlti_gf1_0;
Double  &ctr::rlte_gf1_0 = CTR253_GLF_Transport_Input1_0.rlte_gf1_0;
Double  &ctr::rlne_gf1_0 = CTR253_GLF_Transport_Input1_0.rlne_gf1_0;
Double  &ctr::rlni_gf1_0 = CTR253_GLF_Transport_Input1_0.rlni_gf1_0;
Double  &ctr::dil_gf1_0 = CTR253_GLF_Transport_Input1_0.dil_gf1_0;
Double  &ctr::xdil_m1_0 = CTR253_GLF_Transport_Input1_0.xdil_m1_0;
Double  &ctr::taui_gf1_0 = CTR253_GLF_Transport_Input1_0.taui_gf1_0;
Double  &ctr::rmin_gf1_0 = CTR253_GLF_Transport_Input1_0.rmin_gf1_0;
Double  &ctr::rmaj_gf1_0 = CTR253_GLF_Transport_Input1_0.rmaj_gf1_0;
Double  &ctr::q_gf1_0 = CTR253_GLF_Transport_Input1_0.q_gf1_0;
Double  &ctr::xnu_gf1_0 = CTR253_GLF_Transport_Input1_0.xnu_gf1_0;
Double  &ctr::cxnu1_0 = CTR253_GLF_Transport_Input1_0.cxnu1_0;
Double  &ctr::xshift1_0 = CTR253_GLF_Transport_Input1_0.xshift1_0;
Double  &ctr::betae_gf1_0 = CTR253_GLF_Transport_Input1_0.betae_gf1_0;
Double  &ctr::cbetae1_0 = CTR253_GLF_Transport_Input1_0.cbetae1_0;
Double  &ctr::shat_gf1_0 = CTR253_GLF_Transport_Input1_0.shat_gf1_0;
Double  &ctr::alpha_gf1_0 = CTR253_GLF_Transport_Input1_0.alpha_gf1_0;
Double  &ctr::elong_gf1_0 = CTR253_GLF_Transport_Input1_0.elong_gf1_0;
Double  &ctr::xwell_gf1_0 = CTR253_GLF_Transport_Input1_0.xwell_gf1_0;
Double  &ctr::park_gf1_0 = CTR253_GLF_Transport_Input1_0.park_gf1_0;
Double  &ctr::ghat_gf1_0 = CTR253_GLF_Transport_Input1_0.ghat_gf1_0;
Double  &ctr::gchat_gf1_0 = CTR253_GLF_Transport_Input1_0.gchat_gf1_0;
Double  &ctr::adamp_gf1_0 = CTR253_GLF_Transport_Input1_0.adamp_gf1_0;
Double  &ctr::alpha_star_gf1_0 = CTR253_GLF_Transport_Input1_0.alpha_star_gf1_0;
Double  &ctr::gamma_star_gf1_0 = CTR253_GLF_Transport_Input1_0.gamma_star_gf1_0;
Double  &ctr::alpha_e_gf1_0 = CTR253_GLF_Transport_Input1_0.alpha_e_gf1_0;
Double  &ctr::gamma_e_gf1_0 = CTR253_GLF_Transport_Input1_0.gamma_e_gf1_0;
Double  &ctr::alpha_mode_gf1_0 = CTR253_GLF_Transport_Input1_0.alpha_mode_gf1_0;
Double  &ctr::gamma_mode_gf1_0 = CTR253_GLF_Transport_Input1_0.gamma_mode_gf1_0;
Double  &ctr::alpha_p_gf1_0 = CTR253_GLF_Transport_Input1_0.alpha_p_gf1_0;
Double  &ctr::gamma_p_gf1_0 = CTR253_GLF_Transport_Input1_0.gamma_p_gf1_0;
Double  &ctr::xkdamp_gf1_0 = CTR253_GLF_Transport_Input1_0.xkdamp_gf1_0;
Integer  &ctr::ikymax_gf1_0 = CTR250_GLF_Transport_Input1_0.ikymax_gf1_0;
Double  &ctr::xkymin_gf1_0 = CTR253_GLF_Transport_Input1_0.xkymin_gf1_0;
Double  &ctr::xkymax_gf1_0 = CTR253_GLF_Transport_Input1_0.xkymax_gf1_0;
Integer  &ctr::lprint_gf1_0 = CTR250_GLF_Transport_Input1_0.lprint_gf1_0;
Double  &ctr::amassgas_gf1_0 = CTR253_GLF_Transport_Input1_0.amassgas_gf1_0;
Double  &ctr::cmodel1_0 = CTR253_GLF_Transport_Input1_0.cmodel1_0;
Integer  &ctr::vGLF = CTR250_GLF_Transport_Input1_0.vGLF;


// Group GLF_Transport_Output1_0


extern "C" struct {
  Double yparam_gf1_0[20];
  Double xkyf_gf1_0;
  Double gamma_gf1_0[4];
  Double freq_gf1_0[4];
  Double phi_norm_gf1_0[4];
  Double diff_gf1_0;
  Double chii_gf1_0;
  Double chie_gf1_0;
  Double exch_gf1_0;
  Double eta_par_gf1_0;
  Double eta_per_gf1_0;
  Double eta_phi_gf1_0;
  Double chie_e_gf1_0;
  Double yparam_k_gf1_0[20*20];
  Double xkyf_k_gf1_0[20];
  Double gamma_k_gf1_0[4*20];
  Double freq_k_gf1_0[4*20];
  Double phi_norm_k_gf1_0[4*20];
  Double diff_k_gf1_0[20];
  Double chii_k_gf1_0[20];
  Double chie_k_gf1_0[20];
  Double exch_k_gf1_0[20];
  Double eta_par_k_gf1_0[20];
  Double eta_per_k_gf1_0[20];
  Double eta_phi_k_gf1_0[20];
  Double chie_e_k_gf1_0[20];
} CTR263_GLF_Transport_Output1_0;

Vector<Double> ctr::yparam_gf1_0(1,20, CTR263_GLF_Transport_Output1_0.yparam_gf1_0);
Double  &ctr::xkyf_gf1_0 = CTR263_GLF_Transport_Output1_0.xkyf_gf1_0;
Vector<Double> ctr::gamma_gf1_0(1,4, CTR263_GLF_Transport_Output1_0.gamma_gf1_0);
Vector<Double> ctr::freq_gf1_0(1,4, CTR263_GLF_Transport_Output1_0.freq_gf1_0);
Vector<Double> ctr::phi_norm_gf1_0(1,4, CTR263_GLF_Transport_Output1_0.phi_norm_gf1_0);
Double  &ctr::diff_gf1_0 = CTR263_GLF_Transport_Output1_0.diff_gf1_0;
Double  &ctr::chii_gf1_0 = CTR263_GLF_Transport_Output1_0.chii_gf1_0;
Double  &ctr::chie_gf1_0 = CTR263_GLF_Transport_Output1_0.chie_gf1_0;
Double  &ctr::exch_gf1_0 = CTR263_GLF_Transport_Output1_0.exch_gf1_0;
Double  &ctr::eta_par_gf1_0 = CTR263_GLF_Transport_Output1_0.eta_par_gf1_0;
Double  &ctr::eta_per_gf1_0 = CTR263_GLF_Transport_Output1_0.eta_per_gf1_0;
Double  &ctr::eta_phi_gf1_0 = CTR263_GLF_Transport_Output1_0.eta_phi_gf1_0;
Double  &ctr::chie_e_gf1_0 = CTR263_GLF_Transport_Output1_0.chie_e_gf1_0;
Matrix<Double> ctr::yparam_k_gf1_0(1,20,1,20, CTR263_GLF_Transport_Output1_0.yparam_k_gf1_0);
Vector<Double> ctr::xkyf_k_gf1_0(1,20, CTR263_GLF_Transport_Output1_0.xkyf_k_gf1_0);
Matrix<Double> ctr::gamma_k_gf1_0(1,4,1,20, CTR263_GLF_Transport_Output1_0.gamma_k_gf1_0);
Matrix<Double> ctr::freq_k_gf1_0(1,4,1,20, CTR263_GLF_Transport_Output1_0.freq_k_gf1_0);
Matrix<Double> ctr::phi_norm_k_gf1_0(1,4,1,20, CTR263_GLF_Transport_Output1_0.phi_norm_k_gf1_0);
Vector<Double> ctr::diff_k_gf1_0(1,20, CTR263_GLF_Transport_Output1_0.diff_k_gf1_0);
Vector<Double> ctr::chii_k_gf1_0(1,20, CTR263_GLF_Transport_Output1_0.chii_k_gf1_0);
Vector<Double> ctr::chie_k_gf1_0(1,20, CTR263_GLF_Transport_Output1_0.chie_k_gf1_0);
Vector<Double> ctr::exch_k_gf1_0(1,20, CTR263_GLF_Transport_Output1_0.exch_k_gf1_0);
Vector<Double> ctr::eta_par_k_gf1_0(1,20, CTR263_GLF_Transport_Output1_0.eta_par_k_gf1_0);
Vector<Double> ctr::eta_per_k_gf1_0(1,20, CTR263_GLF_Transport_Output1_0.eta_per_k_gf1_0);
Vector<Double> ctr::eta_phi_k_gf1_0(1,20, CTR263_GLF_Transport_Output1_0.eta_phi_k_gf1_0);
Vector<Double> ctr::chie_e_k_gf1_0(1,20, CTR263_GLF_Transport_Output1_0.chie_e_k_gf1_0);


// Group GLF_Transport_Output


extern "C" struct {
  Double *ionSound;
  Double *rhoStar;
  Double *xky_m;
  Double *anrate_m;
  Double *anfreq_m;
  Double *chiGLF;
  Double *diffGLF;
  Double *diff_LzGLF;
} CTR276_GLF_Transport_Output;

Vector<Double> ctr::ionSound(false);
Vector<Double> ctr::rhoStar(false);
Vector<Double> ctr::xky_m(false);
Vector<Double> ctr::anrate_m(false);
Vector<Double> ctr::anfreq_m(false);
Matrix<Double> ctr::chiGLF(false);
Vector<Double> ctr::diffGLF(false);
Vector<Double> ctr::diff_LzGLF(false);


// Group Callglf2d_com


extern "C" struct {
  Double zevec_k_gf[2*GLFNKY*12*12];
  Double zomega_k_gf[2*GLFNKY*12];
  Double yparam_k_gf[GLFNKY*GLFNKY];
  Double gamma_k_gf[(4-(1)+1)*GLFNKY];
  Double freq_k_gf[(4-(1)+1)*GLFNKY];
  Double phi_norm_k_gf[(4-(1)+1)*GLFNKY];
  Double xparam_gf[30];
  Double xkyf_k_gf[GLFNKY];
  Double diff_k_gf[GLFNKY];
  Double diff_im_k_gf[GLFNKY];
  Double chii_k_gf[GLFNKY];
  Double chie_k_gf[GLFNKY];
  Double exch_k_gf[GLFNKY];
  Double eta_par_k_gf[GLFNKY];
  Double eta_per_k_gf[GLFNKY];
  Double eta_phi_k_gf[GLFNKY];
  Double chie_e_k_gf[GLFNKY];
  Double yparam_gf[GLFNKY];
  Double gamma_gf[(4-(1)+1)];
  Double freq_gf[(4-(1)+1)];
  Double phi_norm_gf[(4-(1)+1)];
  Double xky_gf[(4-(1)+1)];
  Double xky0_gf;
  Double rms_theta_gf;
  Double rlti_gf;
  Double rlte_gf;
  Double rlne_gf;
  Double rlni_gf;
  Double rlnimp_gf;
  Double dil_gf;
  Double apwt_gf;
  Double aiwt_gf;
  Double taui_gf;
  Double rmin_gf;
  Double rmaj_gf;
  Double q_gf;
  Double xnu_gf;
  Double betae_gf;
  Double shat_gf;
  Double alpha_gf;
  Double elong_gf;
  Double xwell_gf;
  Double park_gf;
  Double ghat_gf;
  Double gchat_gf;
  Double adamp_gf;
  Double alpha_star_gf;
  Double gamma_star_gf;
  Double alpha_e_gf;
  Double gamma_e_gf;
  Double alpha_mode_gf;
  Double gamma_mode_gf;
  Double alpha_p_gf;
  Double gamma_p_gf;
  Double xkdamp_gf;
  Double xkyf_gf;
  Double diff_gf;
  Double diff_im_gf;
  Double chii_gf;
  Double chie_gf;
  Double exch_gf;
  Double eta_par_gf;
  Double eta_per_gf;
  Double eta_phi_gf;
  Double chie_e_gf;
  Double cnorm_gf;
  Double xkymin_gf;
  Double xkymax_gf;
  Double amassgas_gf;
  Double amassimp_gf;
  Double zimp_gf;
  Integer iflagin_gf[30];
  Integer ngrow_k_gf[(GLFNKY-(0)+1)];
  Integer nroot_gf;
  Integer lprint_gf;
  Integer ikymax_gf;
  Integer i_err;
  Integer i_proc;
  Integer n_proc;
  Integer jeigen;
  Integer igfac;
  Integer first_order_gf;
  Integer ipert_gf;
} GLF_CT_Callglf2d_com;

Array3<Double> ctr::zevec_k_gf(1,2*GLFNKY,1,12,1,12, GLF_CT_Callglf2d_com.zevec_k_gf);
Matrix<Double> ctr::zomega_k_gf(1,2*GLFNKY,1,12, GLF_CT_Callglf2d_com.zomega_k_gf);
Matrix<Double> ctr::yparam_k_gf(1,GLFNKY,1,GLFNKY, GLF_CT_Callglf2d_com.yparam_k_gf);
Matrix<Double> ctr::gamma_k_gf(1,4,1,GLFNKY, GLF_CT_Callglf2d_com.gamma_k_gf);
Matrix<Double> ctr::freq_k_gf(1,4,1,GLFNKY, GLF_CT_Callglf2d_com.freq_k_gf);
Matrix<Double> ctr::phi_norm_k_gf(1,4,1,GLFNKY, GLF_CT_Callglf2d_com.phi_norm_k_gf);
Vector<Double> ctr::xparam_gf(1,30, GLF_CT_Callglf2d_com.xparam_gf);
Vector<Double> ctr::xkyf_k_gf(1,GLFNKY, GLF_CT_Callglf2d_com.xkyf_k_gf);
Vector<Double> ctr::diff_k_gf(1,GLFNKY, GLF_CT_Callglf2d_com.diff_k_gf);
Vector<Double> ctr::diff_im_k_gf(1,GLFNKY, GLF_CT_Callglf2d_com.diff_im_k_gf);
Vector<Double> ctr::chii_k_gf(1,GLFNKY, GLF_CT_Callglf2d_com.chii_k_gf);
Vector<Double> ctr::chie_k_gf(1,GLFNKY, GLF_CT_Callglf2d_com.chie_k_gf);
Vector<Double> ctr::exch_k_gf(1,GLFNKY, GLF_CT_Callglf2d_com.exch_k_gf);
Vector<Double> ctr::eta_par_k_gf(1,GLFNKY, GLF_CT_Callglf2d_com.eta_par_k_gf);
Vector<Double> ctr::eta_per_k_gf(1,GLFNKY, GLF_CT_Callglf2d_com.eta_per_k_gf);
Vector<Double> ctr::eta_phi_k_gf(1,GLFNKY, GLF_CT_Callglf2d_com.eta_phi_k_gf);
Vector<Double> ctr::chie_e_k_gf(1,GLFNKY, GLF_CT_Callglf2d_com.chie_e_k_gf);
Vector<Double> ctr::yparam_gf(1,GLFNKY, GLF_CT_Callglf2d_com.yparam_gf);
Vector<Double> ctr::gamma_gf(1,4, GLF_CT_Callglf2d_com.gamma_gf);
Vector<Double> ctr::freq_gf(1,4, GLF_CT_Callglf2d_com.freq_gf);
Vector<Double> ctr::phi_norm_gf(1,4, GLF_CT_Callglf2d_com.phi_norm_gf);
Vector<Double> ctr::xky_gf(1,4, GLF_CT_Callglf2d_com.xky_gf);
Double  &ctr::xky0_gf = GLF_CT_Callglf2d_com.xky0_gf;
Double  &ctr::rms_theta_gf = GLF_CT_Callglf2d_com.rms_theta_gf;
Double  &ctr::rlti_gf = GLF_CT_Callglf2d_com.rlti_gf;
Double  &ctr::rlte_gf = GLF_CT_Callglf2d_com.rlte_gf;
Double  &ctr::rlne_gf = GLF_CT_Callglf2d_com.rlne_gf;
Double  &ctr::rlni_gf = GLF_CT_Callglf2d_com.rlni_gf;
Double  &ctr::rlnimp_gf = GLF_CT_Callglf2d_com.rlnimp_gf;
Double  &ctr::dil_gf = GLF_CT_Callglf2d_com.dil_gf;
Double  &ctr::apwt_gf = GLF_CT_Callglf2d_com.apwt_gf;
Double  &ctr::aiwt_gf = GLF_CT_Callglf2d_com.aiwt_gf;
Double  &ctr::taui_gf = GLF_CT_Callglf2d_com.taui_gf;
Double  &ctr::rmin_gf = GLF_CT_Callglf2d_com.rmin_gf;
Double  &ctr::rmaj_gf = GLF_CT_Callglf2d_com.rmaj_gf;
Double  &ctr::q_gf = GLF_CT_Callglf2d_com.q_gf;
Double  &ctr::xnu_gf = GLF_CT_Callglf2d_com.xnu_gf;
Double  &ctr::betae_gf = GLF_CT_Callglf2d_com.betae_gf;
Double  &ctr::shat_gf = GLF_CT_Callglf2d_com.shat_gf;
Double  &ctr::alpha_gf = GLF_CT_Callglf2d_com.alpha_gf;
Double  &ctr::elong_gf = GLF_CT_Callglf2d_com.elong_gf;
Double  &ctr::xwell_gf = GLF_CT_Callglf2d_com.xwell_gf;
Double  &ctr::park_gf = GLF_CT_Callglf2d_com.park_gf;
Double  &ctr::ghat_gf = GLF_CT_Callglf2d_com.ghat_gf;
Double  &ctr::gchat_gf = GLF_CT_Callglf2d_com.gchat_gf;
Double  &ctr::adamp_gf = GLF_CT_Callglf2d_com.adamp_gf;
Double  &ctr::alpha_star_gf = GLF_CT_Callglf2d_com.alpha_star_gf;
Double  &ctr::gamma_star_gf = GLF_CT_Callglf2d_com.gamma_star_gf;
Double  &ctr::alpha_e_gf = GLF_CT_Callglf2d_com.alpha_e_gf;
Double  &ctr::gamma_e_gf = GLF_CT_Callglf2d_com.gamma_e_gf;
Double  &ctr::alpha_mode_gf = GLF_CT_Callglf2d_com.alpha_mode_gf;
Double  &ctr::gamma_mode_gf = GLF_CT_Callglf2d_com.gamma_mode_gf;
Double  &ctr::alpha_p_gf = GLF_CT_Callglf2d_com.alpha_p_gf;
Double  &ctr::gamma_p_gf = GLF_CT_Callglf2d_com.gamma_p_gf;
Double  &ctr::xkdamp_gf = GLF_CT_Callglf2d_com.xkdamp_gf;
Double  &ctr::xkyf_gf = GLF_CT_Callglf2d_com.xkyf_gf;
Double  &ctr::diff_gf = GLF_CT_Callglf2d_com.diff_gf;
Double  &ctr::diff_im_gf = GLF_CT_Callglf2d_com.diff_im_gf;
Double  &ctr::chii_gf = GLF_CT_Callglf2d_com.chii_gf;
Double  &ctr::chie_gf = GLF_CT_Callglf2d_com.chie_gf;
Double  &ctr::exch_gf = GLF_CT_Callglf2d_com.exch_gf;
Double  &ctr::eta_par_gf = GLF_CT_Callglf2d_com.eta_par_gf;
Double  &ctr::eta_per_gf = GLF_CT_Callglf2d_com.eta_per_gf;
Double  &ctr::eta_phi_gf = GLF_CT_Callglf2d_com.eta_phi_gf;
Double  &ctr::chie_e_gf = GLF_CT_Callglf2d_com.chie_e_gf;
Double  &ctr::cnorm_gf = GLF_CT_Callglf2d_com.cnorm_gf;
Double  &ctr::xkymin_gf = GLF_CT_Callglf2d_com.xkymin_gf;
Double  &ctr::xkymax_gf = GLF_CT_Callglf2d_com.xkymax_gf;
Double  &ctr::amassgas_gf = GLF_CT_Callglf2d_com.amassgas_gf;
Double  &ctr::amassimp_gf = GLF_CT_Callglf2d_com.amassimp_gf;
Double  &ctr::zimp_gf = GLF_CT_Callglf2d_com.zimp_gf;
Vector<Integer> ctr::iflagin_gf(1,30, GLF_CT_Callglf2d_com.iflagin_gf);
Vector<Integer> ctr::ngrow_k_gf(0,GLFNKY, GLF_CT_Callglf2d_com.ngrow_k_gf);
Integer  &ctr::nroot_gf = GLF_CT_Callglf2d_com.nroot_gf;
Integer  &ctr::lprint_gf = GLF_CT_Callglf2d_com.lprint_gf;
Integer  &ctr::ikymax_gf = GLF_CT_Callglf2d_com.ikymax_gf;
Integer  &ctr::i_err = GLF_CT_Callglf2d_com.i_err;
Integer  &ctr::i_proc = GLF_CT_Callglf2d_com.i_proc;
Integer  &ctr::n_proc = GLF_CT_Callglf2d_com.n_proc;
Integer  &ctr::jeigen = GLF_CT_Callglf2d_com.jeigen;
Integer  &ctr::igfac = GLF_CT_Callglf2d_com.igfac;
Integer  &ctr::first_order_gf = GLF_CT_Callglf2d_com.first_order_gf;
Integer  &ctr::ipert_gf = GLF_CT_Callglf2d_com.ipert_gf;


// Group GLF_Transport_Input


extern "C" struct {
  Integer bt_flag;
  Integer leigen;
  Integer nroot;
  Integer irotstab;
  Integer i_grad;
  Integer idengrad;
  Integer i_delay;
} CTR290_GLF_Transport_Input;

extern "C" struct {
  Double alpha_d;
  Double alpha_e;
  Double x_alpha;
} CTR293_GLF_Transport_Input;

extern "C" struct {
  Double *alpha_exp;
} CTR296_GLF_Transport_Input;

Integer  &ctr::bt_flag = CTR290_GLF_Transport_Input.bt_flag;
Double  &ctr::alpha_d = CTR293_GLF_Transport_Input.alpha_d;
Double  &ctr::alpha_e = CTR293_GLF_Transport_Input.alpha_e;
Double  &ctr::x_alpha = CTR293_GLF_Transport_Input.x_alpha;
Vector<Double> ctr::alpha_exp(false);
Integer  &ctr::leigen = CTR290_GLF_Transport_Input.leigen;
Integer  &ctr::nroot = CTR290_GLF_Transport_Input.nroot;
Integer  &ctr::irotstab = CTR290_GLF_Transport_Input.irotstab;
Integer  &ctr::i_grad = CTR290_GLF_Transport_Input.i_grad;
Integer  &ctr::idengrad = CTR290_GLF_Transport_Input.idengrad;
Integer  &ctr::i_delay = CTR290_GLF_Transport_Input.i_delay;


// Group GLF_Transport_Output2


extern "C" struct {
  Double diffnem;
  Double chietem;
  Double chiitim;
  Double etaphim;
  Double etaparm;
  Double etaperm;
  Double exchm;
} CTR303_GLF_Transport_Output2;

extern "C" struct {
  Double *chie_m;
  Double *chii_m;
  Double *etaphi_m;
  Double *etapar_m;
  Double *etaper_m;
  Double *exch_m;
  Double *egamma_m;
  Double *egamma_d;
  Double *gamma_p;
  Double *anrate;
  Double *anrate2;
  Double *anfreq;
  Double *anfreq2;
  Double *xkymax;
  Double *xkymax2;
  Double *chiGLFN;
  Double *diffGLFN;
  Double *diff_LzGLFN;
} CTR306_GLF_Transport_Output2;

Double  &ctr::diffnem = CTR303_GLF_Transport_Output2.diffnem;
Double  &ctr::chietem = CTR303_GLF_Transport_Output2.chietem;
Double  &ctr::chiitim = CTR303_GLF_Transport_Output2.chiitim;
Double  &ctr::etaphim = CTR303_GLF_Transport_Output2.etaphim;
Double  &ctr::etaparm = CTR303_GLF_Transport_Output2.etaparm;
Double  &ctr::etaperm = CTR303_GLF_Transport_Output2.etaperm;
Double  &ctr::exchm = CTR303_GLF_Transport_Output2.exchm;
Vector<Double> ctr::chie_m(false);
Vector<Double> ctr::chii_m(false);
Vector<Double> ctr::etaphi_m(false);
Vector<Double> ctr::etapar_m(false);
Vector<Double> ctr::etaper_m(false);
Vector<Double> ctr::exch_m(false);
Vector<Double> ctr::egamma_m(false);
Vector<Double> ctr::egamma_d(false);
Vector<Double> ctr::gamma_p(false);
Vector<Double> ctr::anrate(false);
Vector<Double> ctr::anrate2(false);
Vector<Double> ctr::anfreq(false);
Vector<Double> ctr::anfreq2(false);
Vector<Double> ctr::xkymax(false);
Vector<Double> ctr::xkymax2(false);
Matrix<Double> ctr::chiGLFN(false);
Vector<Double> ctr::diffGLFN(false);
Vector<Double> ctr::diff_LzGLFN(false);


// Group GLF_Transport_wrapper_temps


extern "C" struct {
  Integer jmm;
} CTR310_GLF_Transport_wrapper_temps;

extern "C" struct {
  Double hydDens;
  Double impDens;
  Double arhosquared;
  Double bt;
  Double csdacoef;
  Double csda;
  Double rho_over_r;
} CTR313_GLF_Transport_wrapper_temps;

extern "C" struct {
  Double *te_glf;
  Double *ti_glf;
  Double *ne_glf;
  Double *ni_glf;
} CTR316_GLF_Transport_wrapper_temps;

Double  &ctr::hydDens = CTR313_GLF_Transport_wrapper_temps.hydDens;
Double  &ctr::impDens = CTR313_GLF_Transport_wrapper_temps.impDens;
Double  &ctr::arhosquared = CTR313_GLF_Transport_wrapper_temps.arhosquared;
Double  &ctr::bt = CTR313_GLF_Transport_wrapper_temps.bt;
Double  &ctr::csdacoef = CTR313_GLF_Transport_wrapper_temps.csdacoef;
Double  &ctr::csda = CTR313_GLF_Transport_wrapper_temps.csda;
Double  &ctr::rho_over_r = CTR313_GLF_Transport_wrapper_temps.rho_over_r;
Vector<Double> ctr::te_glf(false);
Vector<Double> ctr::ti_glf(false);
Vector<Double> ctr::ne_glf(false);
Vector<Double> ctr::ni_glf(false);
Integer  &ctr::jmm = CTR310_GLF_Transport_wrapper_temps.jmm;


// Group GLF_Transport_diagnostics


extern "C" struct {
  Integer jshoot;
  Integer jmaxm;
  Integer itport_pt[5];
} CTR320_GLF_Transport_diagnostics;

extern "C" struct {
  Double zpte_in;
  Double zpti_in;
  Double zpne_in;
  Double zpni_in;
  Double bt_axis;
  Double arho;
  Double rmajor_exp;
  Double zimpav;
  Double amassimpav;
  Double amassgas_glf;
} CTR323_GLF_Transport_diagnostics;

extern "C" struct {
  Double *neGLF;
  Double *niGLF;
  Double *nbeamGLF;
  Double *angrotp_exp;
  Double *egamma_exp;
  Double *gamma_p_exp;
  Double *vphilin;
  Double *vpar_m;
  Double *vper_m;
  Double *bteff_exp;
  Double *rho_glf;
  Double *gradrho_glf;
  Double *gradrhosq_glf;
  Double *shat_glf;
} CTR326_GLF_Transport_diagnostics;

Vector<Double> ctr::neGLF(false);
Vector<Double> ctr::niGLF(false);
Vector<Double> ctr::nbeamGLF(false);
Double  &ctr::zpte_in = CTR323_GLF_Transport_diagnostics.zpte_in;
Double  &ctr::zpti_in = CTR323_GLF_Transport_diagnostics.zpti_in;
Double  &ctr::zpne_in = CTR323_GLF_Transport_diagnostics.zpne_in;
Double  &ctr::zpni_in = CTR323_GLF_Transport_diagnostics.zpni_in;
Vector<Double> ctr::angrotp_exp(false);
Vector<Double> ctr::egamma_exp(false);
Vector<Double> ctr::gamma_p_exp(false);
Vector<Double> ctr::vphilin(false);
Vector<Double> ctr::vpar_m(false);
Vector<Double> ctr::vper_m(false);
Double  &ctr::bt_axis = CTR323_GLF_Transport_diagnostics.bt_axis;
Vector<Double> ctr::bteff_exp(false);
Vector<Double> ctr::rho_glf(false);
Double  &ctr::arho = CTR323_GLF_Transport_diagnostics.arho;
Vector<Double> ctr::gradrho_glf(false);
Vector<Double> ctr::gradrhosq_glf(false);
Double  &ctr::rmajor_exp = CTR323_GLF_Transport_diagnostics.rmajor_exp;
Double  &ctr::zimpav = CTR323_GLF_Transport_diagnostics.zimpav;
Double  &ctr::amassimpav = CTR323_GLF_Transport_diagnostics.amassimpav;
Vector<Double> ctr::shat_glf(false);
Double  &ctr::amassgas_glf = CTR323_GLF_Transport_diagnostics.amassgas_glf;
Integer  &ctr::jshoot = CTR320_GLF_Transport_diagnostics.jshoot;
Integer  &ctr::jmaxm = CTR320_GLF_Transport_diagnostics.jmaxm;
Vector<Integer> ctr::itport_pt(1,5, CTR320_GLF_Transport_diagnostics.itport_pt);


// Group ToroidalRotation


extern "C" struct {
  Double omstarax;
} CTR333_ToroidalRotation;

extern "C" struct {
  Double *omegaTor;
  Double *omegaPrTor;
  Double *omegaExB;
  Double *er_outer;
  Double *erbp;
  Double *e_r;
  Double *e_r1;
  Double *e_r2;
} CTR336_ToroidalRotation;

Double  &ctr::omstarax = CTR333_ToroidalRotation.omstarax;
Vector<Double> ctr::omegaTor(false);
Vector<Double> ctr::omegaPrTor(false);
Vector<Double> ctr::omegaExB(false);
Vector<Double> ctr::er_outer(false);
Vector<Double> ctr::erbp(false);
Vector<Double> ctr::e_r(false);
Vector<Double> ctr::e_r1(false);
Vector<Double> ctr::e_r2(false);


// Group ErShearFields


extern "C" struct {
  Integer iEr;
  Integer iErBp;
  Integer iPhiEPr;
  Integer iOmegTor;
} CTR340_ErShearFields;

Integer  &ctr::iEr = CTR340_ErShearFields.iEr;
Integer  &ctr::iErBp = CTR340_ErShearFields.iErBp;
Integer  &ctr::iPhiEPr = CTR340_ErShearFields.iPhiEPr;
Integer  &ctr::iOmegTor = CTR340_ErShearFields.iOmegTor;


// Group ErShearMod


extern "C" struct {
  Integer iEShearMod;
  Integer iWaltz;
  Integer iHB;
  Integer iStaeb;
} CTR350_ErShearMod;

Integer  &ctr::iEShearMod = CTR350_ErShearMod.iEShearMod;
Integer  &ctr::iWaltz = CTR350_ErShearMod.iWaltz;
Integer  &ctr::iHB = CTR350_ErShearMod.iHB;
Integer  &ctr::iStaeb = CTR350_ErShearMod.iStaeb;


// Group AngularMomentum_Transport


extern "C" struct {
  Integer useChiForDLz;
} CTR360_AngularMomentum_Transport;

extern "C" struct {
  Double lzSrcTot;
  Double omegaBC[3];
  Double lzBC_[3];
  Double diff_Lz_add;
  Double chiForLzMult;
  Double diff_LzCoef;
} CTR363_AngularMomentum_Transport;

extern "C" struct {
  Double *lzTor;
  Double *lzPrTor;
  Double *lzPrPrTor;
  Double *lzToOmega;
  Double *diff_Lz;
  Double *vpinch_Lz;
  Double *extraLzFlux;
  Double *lzSrc;
  Double *nbLzSrc;
  Double *lzFluxCoefs;
  Double *lzFlux;
  Double *lzHProfs;
} CTR366_AngularMomentum_Transport;

Double  &ctr::lzSrcTot = CTR363_AngularMomentum_Transport.lzSrcTot;
Vector<Double> ctr::omegaBC(1,3, CTR363_AngularMomentum_Transport.omegaBC);
Vector<Double> ctr::lzBC_(1,3, CTR363_AngularMomentum_Transport.lzBC_);
Double  &ctr::diff_Lz_add = CTR363_AngularMomentum_Transport.diff_Lz_add;
Double  &ctr::chiForLzMult = CTR363_AngularMomentum_Transport.chiForLzMult;
Double  &ctr::diff_LzCoef = CTR363_AngularMomentum_Transport.diff_LzCoef;
Vector<Double> ctr::lzTor(false);
Vector<Double> ctr::lzPrTor(false);
Vector<Double> ctr::lzPrPrTor(false);
Matrix<Double> ctr::lzToOmega(false);
Vector<Double> ctr::diff_Lz(false);
Integer  &ctr::useChiForDLz = CTR360_AngularMomentum_Transport.useChiForDLz;
Vector<Double> ctr::vpinch_Lz(false);
Vector<Double> ctr::extraLzFlux(false);
Vector<Double> ctr::lzSrc(false);
Vector<Double> ctr::nbLzSrc(false);
Matrix<Double> ctr::lzFluxCoefs(false);
Vector<Double> ctr::lzFlux(false);
Matrix<Double> ctr::lzHProfs(false);


// Group Pellets


extern "C" struct {
  Double rPellet;
  Double vPellet;
  Double cPel;
  Double pelDFrac;
  Double pelTFrac;
  Double pelHFrac;
  Double pelSrcTot;
  Double nFuelTot[Nparts];
  Double nFuelCoefs[6*Nparts];
} CTR373_Pellets;

extern "C" struct {
  Double *nFuel;
  Double *hydPelSrc;
  Double *deutPelSrc;
  Double *tritPelSrc;
} CTR376_Pellets;

Double  &ctr::rPellet = CTR373_Pellets.rPellet;
Double  &ctr::vPellet = CTR373_Pellets.vPellet;
Double  &ctr::cPel = CTR373_Pellets.cPel;
Double  &ctr::pelDFrac = CTR373_Pellets.pelDFrac;
Double  &ctr::pelTFrac = CTR373_Pellets.pelTFrac;
Double  &ctr::pelHFrac = CTR373_Pellets.pelHFrac;
Double  &ctr::pelSrcTot = CTR373_Pellets.pelSrcTot;
Vector<Double> ctr::nFuelTot(1,Nparts, CTR373_Pellets.nFuelTot);
Matrix<Double> ctr::nFuelCoefs(1,6,1,Nparts, CTR373_Pellets.nFuelCoefs);
Matrix<Double> ctr::nFuel(false);
Vector<Double> ctr::hydPelSrc(false);
Vector<Double> ctr::deutPelSrc(false);
Vector<Double> ctr::tritPelSrc(false);


// Group Confinement


extern "C" struct {
  Double ionStoredEnergy;
  Double elecStoredEnergy;
  Double storedEnergy;
  Double tau_E;
  Double tauScale[Nscalings];
  Double hFacScale[Nscalings];
} CTR383_Confinement;

Double  &ctr::ionStoredEnergy = CTR383_Confinement.ionStoredEnergy;
Double  &ctr::elecStoredEnergy = CTR383_Confinement.elecStoredEnergy;
Double  &ctr::storedEnergy = CTR383_Confinement.storedEnergy;
Double  &ctr::tau_E = CTR383_Confinement.tau_E;
Vector<Double> ctr::tauScale(1,Nscalings, CTR383_Confinement.tauScale);
Vector<Double> ctr::hFacScale(1,Nscalings, CTR383_Confinement.hFacScale);


// Group Galerkin


extern "C" struct {
  Double *yFP;
  Double *hrFP;
  Double *lzFP;
  Double *muFP;
  Double *nFP;
  Double *yCap;
  Double *yStiff;
  Double *yLoad;
  Double *muCap;
  Double *muStiff;
  Double *muLoad;
  Double *muDrag;
  Double *nCap;
  Double *nStiff;
  Double *nLoad;
  Double *lzCap;
  Double *lzStiff;
  Double *lzLoad;
} CTR396_Galerkin;

Vector<Double> ctr::yFP(false);
Vector<Double> ctr::hrFP(false);
Vector<Double> ctr::lzFP(false);
Matrix<Double> ctr::muFP(false);
Matrix<Double> ctr::nFP(false);
Array3<Double> ctr::yCap(false);
Array3<Double> ctr::yStiff(false);
Matrix<Double> ctr::yLoad(false);
Array3<Double> ctr::muCap(false);
Array3<Double> ctr::muStiff(false);
Matrix<Double> ctr::muLoad(false);
Array3<Double> ctr::muDrag(false);
Array3<Double> ctr::nCap(false);
Array3<Double> ctr::nStiff(false);
Matrix<Double> ctr::nLoad(false);
Matrix<Double> ctr::lzCap(false);
Matrix<Double> ctr::lzStiff(false);
Vector<Double> ctr::lzLoad(false);


// Group Sawtooth_Data


extern "C" struct {
  Integer iSawtoothRadius;
} CTR400_Sawtooth_Data;

extern "C" struct {
  Double qSawtooth;
  Double sawtoothRadius;
  Double chiEnhanceFac;
  Double chiEnhanceDelta;
  Double diffEnhanceFac;
  Double diffEnhanceDelta;
  Double sigTorEnhanceFrac;
} CTR403_Sawtooth_Data;

Double  &ctr::qSawtooth = CTR403_Sawtooth_Data.qSawtooth;
Double  &ctr::sawtoothRadius = CTR403_Sawtooth_Data.sawtoothRadius;
Double  &ctr::chiEnhanceFac = CTR403_Sawtooth_Data.chiEnhanceFac;
Double  &ctr::chiEnhanceDelta = CTR403_Sawtooth_Data.chiEnhanceDelta;
Double  &ctr::diffEnhanceFac = CTR403_Sawtooth_Data.diffEnhanceFac;
Double  &ctr::diffEnhanceDelta = CTR403_Sawtooth_Data.diffEnhanceDelta;
Double  &ctr::sigTorEnhanceFrac = CTR403_Sawtooth_Data.sigTorEnhanceFrac;
Integer  &ctr::iSawtoothRadius = CTR400_Sawtooth_Data.iSawtoothRadius;


// Group TransStep


extern "C" struct {
  Double time;
  Double dt;
  Double time_last;
} CTR413_TransStep;

Double  &ctr::time = CTR413_TransStep.time;
Double  &ctr::dt = CTR413_TransStep.dt;
Double  &ctr::time_last = CTR413_TransStep.time_last;

// Sync function initializations

void ctr::sync()
{
  c23Dot.init(1,nrho, CTR46_Flux_Transport.c23Dot);
  ipTor.init(1,nrho, CTR46_Flux_Transport.ipTor);
  ipPrTor.init(1,nrho, CTR46_Flux_Transport.ipPrTor);
  strTor.init(1,nrho, CTR46_Flux_Transport.strTor);
  unstrTor.init(1,nrho, CTR46_Flux_Transport.unstrTor);
  strPrTor.init(1,nrho, CTR46_Flux_Transport.strPrTor);
  rhostr.init(1,nrho, CTR46_Flux_Transport.rhostr);
  iotaTor.init(1,nrho, CTR46_Flux_Transport.iotaTor);
  iotaPrTor.init(1,nrho, CTR46_Flux_Transport.iotaPrTor);
  yTor.init(1,nrho, CTR46_Flux_Transport.yTor);
  yPrTor.init(1,nrho, CTR46_Flux_Transport.yPrTor);
  yPrPrTor.init(1,nrho, CTR46_Flux_Transport.yPrPrTor);
  yTorDot.init(1,nrho, CTR46_Flux_Transport.yTorDot);
  hrTor.init(1,nrho, CTR46_Flux_Transport.hrTor);
  hrPrTor.init(1,nrho, CTR46_Flux_Transport.hrPrTor);
  hrPrPrTor.init(1,nrho, CTR46_Flux_Transport.hrPrPrTor);
  qExp.init(1,nrho, CTR46_Flux_Transport.qExp);
  pExp.init(1,nrho, CTR46_Flux_Transport.pExp);
  jniTor.init(1,nrho, CTR46_Flux_Transport.jniTor);
  jICTor.init(1,nrho, CTR46_Flux_Transport.jICTor);
  jLHTor.init(1,nrho, CTR46_Flux_Transport.jLHTor);
  jECTor.init(1,nrho, CTR46_Flux_Transport.jECTor);
  juserTor.init(1,nrho, CTR46_Flux_Transport.juserTor);
  factTor.init(1,nrho, CTR46_Flux_Transport.factTor);
  yHProfs.init(1,nrho,1,nhterms,1,4, CTR46_Flux_Transport.yHProfs);
  yHProfs_old.init(1,nrho,1,nhterms,1,4, CTR46_Flux_Transport.yHProfs_old);
  pUGradP.init(1,nrho,1,Ntemps, CTR56_Entropy_Transport.pUGradP);
  muTor.init(1,nrho,1,Ntemps, CTR56_Entropy_Transport.muTor);
  muPrTor.init(1,nrho,1,Ntemps, CTR56_Entropy_Transport.muPrTor);
  muPrPrTor.init(1,nrho,1,Ntemps, CTR56_Entropy_Transport.muPrPrTor);
  muTorDot.init(1,nrho,1,2, CTR56_Entropy_Transport.muTorDot);
  muToTemp.init(1,nrho,1,2,1,Ntemps, CTR56_Entropy_Transport.muToTemp);
  vpr23.init(1,nrho, CTR56_Entropy_Transport.vpr23);
  gammaPS.init(1,nrho,1,2, CTR56_Entropy_Transport.gammaPS);
  chi.init(1,nrho,1,2*Ntemps, CTR56_Entropy_Transport.chi);
  fluxH.init(1,nrho,1,Ntemps, CTR56_Entropy_Transport.fluxH);
  pinchH.init(1,nrho,1,Ntemps, CTR56_Entropy_Transport.pinchH);
  heatSrc.init(1,nrho,1,Ntemps, CTR56_Entropy_Transport.heatSrc);
  heatFluxCoefs.init(1,nrho,1,3,1,2*Ntemps, CTR56_Entropy_Transport.heatFluxCoefs);
  heatFlux.init(1,nrho,1,Ntemps, CTR56_Entropy_Transport.heatFlux);
  entropyTor.init(1,nrho,1,Ntemps, CTR56_Entropy_Transport.entropyTor);
  muHProfs.init(1,nrho,1,nhterms,1,2*Ntemps, CTR56_Entropy_Transport.muHProfs);
  muHProfs_old.init(1,nrho,1,nhterms,1,2*Ntemps, CTR56_Entropy_Transport.muHProfs_old);
  pAux.init(1,nrho,1,Ntemps, CTR66_Auxiliary_Power.pAux);
  pDrag.init(1,nrho, CTR76_Drag_Power.pDrag);
  dragCoef.init(1,nrho, CTR76_Drag_Power.dragCoef);
  sigmavDDn.init(1,nrho, CTR86_Fusion_Power.sigmavDDn);
  sigmavDDp.init(1,nrho, CTR86_Fusion_Power.sigmavDDp);
  rxnRateDDn.init(1,nrho, CTR86_Fusion_Power.rxnRateDDn);
  rxnRateDDp.init(1,nrho, CTR86_Fusion_Power.rxnRateDDp);
  pFusDDElec.init(1,nrho, CTR86_Fusion_Power.pFusDDElec);
  pFusDDIon.init(1,nrho, CTR86_Fusion_Power.pFusDDIon);
  pNeutDD.init(1,nrho, CTR86_Fusion_Power.pNeutDD);
  fastPressDD.init(1,nrho, CTR86_Fusion_Power.fastPressDD);
  sigmavDT.init(1,nrho, CTR86_Fusion_Power.sigmavDT);
  rxnRateDT.init(1,nrho, CTR86_Fusion_Power.rxnRateDT);
  pFusDTElec.init(1,nrho, CTR86_Fusion_Power.pFusDTElec);
  pFusDTIon.init(1,nrho, CTR86_Fusion_Power.pFusDTIon);
  pNeutDT.init(1,nrho, CTR86_Fusion_Power.pNeutDT);
  fastPressDT.init(1,nrho, CTR86_Fusion_Power.fastPressDT);
  rxnRateBtDDn.init(1,nrho, CTR86_Fusion_Power.rxnRateBtDDn);
  rxnRateBtDT.init(1,nrho, CTR86_Fusion_Power.rxnRateBtDT);
  pNeutBtDD.init(1,nrho, CTR86_Fusion_Power.pNeutBtDD);
  pNeutBtDT.init(1,nrho, CTR86_Fusion_Power.pNeutBtDT);
  pOhmic.init(1,nrho, CTR96_Ohmic_Power.pOhmic);
  pRF.init(1,nrho, CTR106_RF_Power.pRF);
  tau_run.init(1,nrho, CTR116_Runaway_Electrons.tau_run);
  source_run.init(1,nrho, CTR116_Runaway_Electrons.source_run);
  ecrit.init(1,nrho, CTR116_Runaway_Electrons.ecrit);
  pBLRRad.init(1,nrho, CTR126_Radiation_Power.pBLRRad);
  pSync.init(1,nrho, CTR126_Radiation_Power.pSync);
  nTor.init(1,nrho,1,Nparts, CTR136_Density_Transport.nTor);
  nPrTor.init(1,nrho,1,Nparts, CTR136_Density_Transport.nPrTor);
  nPrPrTor.init(1,nrho,1,Nparts, CTR136_Density_Transport.nPrPrTor);
  nTorDot.init(1,nrho,1,Nparts, CTR136_Density_Transport.nTorDot);
  massDensPrTor.init(1,nrho, CTR136_Density_Transport.massDensPrTor);
  mn_over_charge.init(1,nrho, CTR136_Density_Transport.mn_over_charge);
  mnPr_over_charge.init(1,nrho, CTR136_Density_Transport.mnPr_over_charge);
  nToDens.init(1,nrho,1,2, CTR136_Density_Transport.nToDens);
  recycleSrc.init(1,nrho,1,Nparts, CTR136_Density_Transport.recycleSrc);
  implicitRecycleSrc.init(1,nrho,1,Nparts, CTR136_Density_Transport.implicitRecycleSrc);
  diff.init(1,nrho,1,Nparts, CTR136_Density_Transport.diff);
  pinch.init(1,nrho,1,Nparts, CTR136_Density_Transport.pinch);
  fluxN.init(1,nrho,1,Nparts, CTR136_Density_Transport.fluxN);
  particleSrc.init(1,nrho,1,Nparts, CTR136_Density_Transport.particleSrc);
  particleFluxCoefs.init(1,nrho,1,3,1,Nparts, CTR136_Density_Transport.particleFluxCoefs);
  particleFlux.init(1,nrho,1,Nparts, CTR136_Density_Transport.particleFlux);
  sumPartFlux.init(1,nrho, CTR136_Density_Transport.sumPartFlux);
  nHProfs.init(1,nrho,1,nhterms,1,Nparts, CTR136_Density_Transport.nHProfs);
  shat.init(1,nrho, CTR146_Turbulent_Transport.shat);
  taui.init(1,nrho, CTR146_Turbulent_Transport.taui);
  chiData.init(1,Ndata,1,Ntemps, CTR156_Simple_Transport_Input.chiData);
  diffData.init(1,Ndata,1,Nparts, CTR156_Simple_Transport_Input.diffData);
  diff_LzData.init(1,Ndata, CTR156_Simple_Transport_Input.diff_LzData);
  chiSimple.init(1,nrho,1,Ntemps, CTR166_Simple_Transport_Output.chiSimple);
  diffSimple.init(1,nrho,1,Nparts, CTR166_Simple_Transport_Output.diffSimple);
  diff_LzSimple.init(1,nrho, CTR166_Simple_Transport_Output.diff_LzSimple);
  diffNeo.init(1,nrho,1,Nparts, CTR176_Neo_Transport.diffNeo);
  pinchNNeo.init(1,nrho,1,Nparts, CTR176_Neo_Transport.pinchNNeo);
  fluxNNeo.init(1,nrho,1,Nparts, CTR176_Neo_Transport.fluxNNeo);
  chiNeo.init(1,nrho,1,2*Ntemps, CTR176_Neo_Transport.chiNeo);
  pinchHNeo.init(1,nrho,1,Ntemps, CTR176_Neo_Transport.pinchHNeo);
  fluxHNeo.init(1,nrho,1,Ntemps, CTR176_Neo_Transport.fluxHNeo);
  diff_LzNeo.init(1,nrho, CTR176_Neo_Transport.diff_LzNeo);
  chiCH.init(1,nrho,1,Ntemps, CTR186_CH_Transport.chiCH);
  diffCH.init(1,nrho, CTR186_CH_Transport.diffCH);
  vWarePinch.init(1,nrho, CTR186_CH_Transport.vWarePinch);
  chiRLW.init(1,nrho,1,Ntemps, CTR206_RLW_Transport_Output.chiRLW);
  diffRLW.init(1,nrho, CTR206_RLW_Transport_Output.diffRLW);
  pinchRLW.init(1,nrho, CTR206_RLW_Transport_Output.pinchRLW);
  diff_LzRLW.init(1,nrho, CTR206_RLW_Transport_Output.diff_LzRLW);
  gradTe_crit.init(1,nrho, CTR206_RLW_Transport_Output.gradTe_crit);
  chiAnomalous.init(1,nrho, CTR206_RLW_Transport_Output.chiAnomalous);
  chiHS.init(1,nrho,1,2*Ntemps, CTR216_HS_Transport_Output.chiHS);
  diffHS.init(1,nrho,1,Nparts, CTR216_HS_Transport_Output.diffHS);
  pinchNHS.init(1,nrho,1,Nparts, CTR216_HS_Transport_Output.pinchNHS);
  pinchHHS.init(1,nrho,1,Ntemps, CTR216_HS_Transport_Output.pinchHHS);
  fluxNHS.init(1,nrho,1,Nparts, CTR216_HS_Transport_Output.fluxNHS);
  fluxHHS.init(1,nrho,1,Ntemps, CTR216_HS_Transport_Output.fluxHHS);
  diffNclass.init(1,nrho,1,Nparts, CTR226_Nclass_Transport.diffNclass);
  pinchNNclass.init(1,nrho,1,Nparts, CTR226_Nclass_Transport.pinchNNclass);
  fluxNNclass.init(1,nrho,1,Nparts, CTR226_Nclass_Transport.fluxNNclass);
  chiNclass.init(1,nrho,1,2*Ntemps, CTR226_Nclass_Transport.chiNclass);
  pinchHNclass.init(1,nrho,1,Ntemps, CTR226_Nclass_Transport.pinchHNclass);
  fluxHNclass.init(1,nrho,1,Ntemps, CTR226_Nclass_Transport.fluxHNclass);
  rmajLTi.init(1,nrho, CTR236_KDBH_Transport_Input.rmajLTi);
  rmajLNi.init(1,nrho, CTR236_KDBH_Transport_Input.rmajLNi);
  rmajLNe.init(1,nrho, CTR236_KDBH_Transport_Input.rmajLNe);
  z_effKDBH.init(1,nrho, CTR236_KDBH_Transport_Input.z_effKDBH);
  eps_tmp.init(1,nrho, CTR236_KDBH_Transport_Input.eps_tmp);
  gnuKDBH.init(1,nrho, CTR236_KDBH_Transport_Input.gnuKDBH);
  ionGyroRad.init(1,nrho, CTR236_KDBH_Transport_Input.ionGyroRad);
  ionVth.init(1,nrho, CTR236_KDBH_Transport_Input.ionVth);
  geomfac.init(1,nrho, CTR236_KDBH_Transport_Input.geomfac);
  chiKDBH.init(1,nrho,1,Ntemps, CTR246_KDBH_Transport_Output.chiKDBH);
  diffKDBH.init(1,nrho, CTR246_KDBH_Transport_Output.diffKDBH);
  diff_LzKDBH.init(1,nrho, CTR246_KDBH_Transport_Output.diff_LzKDBH);
  rmajLTcrit.init(1,nrho, CTR246_KDBH_Transport_Output.rmajLTcrit);
  rmajLTcritz.init(1,nrho, CTR246_KDBH_Transport_Output.rmajLTcritz);
  gamKDBH.init(1,nrho, CTR246_KDBH_Transport_Output.gamKDBH);
  ionSound.init(1,nrho, CTR276_GLF_Transport_Output.ionSound);
  rhoStar.init(1,nrho, CTR276_GLF_Transport_Output.rhoStar);
  xky_m.init(1,nrho, CTR276_GLF_Transport_Output.xky_m);
  anrate_m.init(1,nrho, CTR276_GLF_Transport_Output.anrate_m);
  anfreq_m.init(1,nrho, CTR276_GLF_Transport_Output.anfreq_m);
  chiGLF.init(1,nrho,1,Ntemps, CTR276_GLF_Transport_Output.chiGLF);
  diffGLF.init(1,nrho, CTR276_GLF_Transport_Output.diffGLF);
  diff_LzGLF.init(1,nrho, CTR276_GLF_Transport_Output.diff_LzGLF);
  alpha_exp.init(1,nrho, CTR296_GLF_Transport_Input.alpha_exp);
  chie_m.init(1,nrho, CTR306_GLF_Transport_Output2.chie_m);
  chii_m.init(1,nrho, CTR306_GLF_Transport_Output2.chii_m);
  etaphi_m.init(1,nrho, CTR306_GLF_Transport_Output2.etaphi_m);
  etapar_m.init(1,nrho, CTR306_GLF_Transport_Output2.etapar_m);
  etaper_m.init(1,nrho, CTR306_GLF_Transport_Output2.etaper_m);
  exch_m.init(1,nrho, CTR306_GLF_Transport_Output2.exch_m);
  egamma_m.init(1,nrho, CTR306_GLF_Transport_Output2.egamma_m);
  egamma_d.init(1,nrho, CTR306_GLF_Transport_Output2.egamma_d);
  gamma_p.init(1,nrho, CTR306_GLF_Transport_Output2.gamma_p);
  anrate.init(1,nrho, CTR306_GLF_Transport_Output2.anrate);
  anrate2.init(1,nrho, CTR306_GLF_Transport_Output2.anrate2);
  anfreq.init(1,nrho, CTR306_GLF_Transport_Output2.anfreq);
  anfreq2.init(1,nrho, CTR306_GLF_Transport_Output2.anfreq2);
  xkymax.init(1,nrho, CTR306_GLF_Transport_Output2.xkymax);
  xkymax2.init(1,nrho, CTR306_GLF_Transport_Output2.xkymax2);
  chiGLFN.init(1,nrho,1,Ntemps, CTR306_GLF_Transport_Output2.chiGLFN);
  diffGLFN.init(1,nrho, CTR306_GLF_Transport_Output2.diffGLFN);
  diff_LzGLFN.init(1,nrho, CTR306_GLF_Transport_Output2.diff_LzGLFN);
  te_glf.init(1,nrho, CTR316_GLF_Transport_wrapper_temps.te_glf);
  ti_glf.init(1,nrho, CTR316_GLF_Transport_wrapper_temps.ti_glf);
  ne_glf.init(1,nrho, CTR316_GLF_Transport_wrapper_temps.ne_glf);
  ni_glf.init(1,nrho, CTR316_GLF_Transport_wrapper_temps.ni_glf);
  neGLF.init(1,nrho, CTR326_GLF_Transport_diagnostics.neGLF);
  niGLF.init(1,nrho, CTR326_GLF_Transport_diagnostics.niGLF);
  nbeamGLF.init(1,nrho, CTR326_GLF_Transport_diagnostics.nbeamGLF);
  angrotp_exp.init(1,nrho, CTR326_GLF_Transport_diagnostics.angrotp_exp);
  egamma_exp.init(1,nrho, CTR326_GLF_Transport_diagnostics.egamma_exp);
  gamma_p_exp.init(1,nrho, CTR326_GLF_Transport_diagnostics.gamma_p_exp);
  vphilin.init(1,nrho, CTR326_GLF_Transport_diagnostics.vphilin);
  vpar_m.init(1,nrho, CTR326_GLF_Transport_diagnostics.vpar_m);
  vper_m.init(1,nrho, CTR326_GLF_Transport_diagnostics.vper_m);
  bteff_exp.init(1,nrho, CTR326_GLF_Transport_diagnostics.bteff_exp);
  rho_glf.init(1,nrho, CTR326_GLF_Transport_diagnostics.rho_glf);
  gradrho_glf.init(1,nrho, CTR326_GLF_Transport_diagnostics.gradrho_glf);
  gradrhosq_glf.init(1,nrho, CTR326_GLF_Transport_diagnostics.gradrhosq_glf);
  shat_glf.init(1,nrho, CTR326_GLF_Transport_diagnostics.shat_glf);
  omegaTor.init(1,nrho, CTR336_ToroidalRotation.omegaTor);
  omegaPrTor.init(1,nrho, CTR336_ToroidalRotation.omegaPrTor);
  omegaExB.init(1,nrho, CTR336_ToroidalRotation.omegaExB);
  er_outer.init(1,nrho, CTR336_ToroidalRotation.er_outer);
  erbp.init(1,nrho, CTR336_ToroidalRotation.erbp);
  e_r.init(1,nrho, CTR336_ToroidalRotation.e_r);
  e_r1.init(1,nrho, CTR336_ToroidalRotation.e_r1);
  e_r2.init(1,nrho, CTR336_ToroidalRotation.e_r2);
  lzTor.init(1,nrho, CTR366_AngularMomentum_Transport.lzTor);
  lzPrTor.init(1,nrho, CTR366_AngularMomentum_Transport.lzPrTor);
  lzPrPrTor.init(1,nrho, CTR366_AngularMomentum_Transport.lzPrPrTor);
  lzToOmega.init(1,nrho,1,2, CTR366_AngularMomentum_Transport.lzToOmega);
  diff_Lz.init(1,nrho, CTR366_AngularMomentum_Transport.diff_Lz);
  vpinch_Lz.init(1,nrho, CTR366_AngularMomentum_Transport.vpinch_Lz);
  extraLzFlux.init(1,nrho, CTR366_AngularMomentum_Transport.extraLzFlux);
  lzSrc.init(1,nrho, CTR366_AngularMomentum_Transport.lzSrc);
  nbLzSrc.init(1,nrho, CTR366_AngularMomentum_Transport.nbLzSrc);
  lzFluxCoefs.init(1,nrho,1,3, CTR366_AngularMomentum_Transport.lzFluxCoefs);
  lzFlux.init(1,nrho, CTR366_AngularMomentum_Transport.lzFlux);
  lzHProfs.init(1,nrho,1,nhterms, CTR366_AngularMomentum_Transport.lzHProfs);
  nFuel.init(1,nrho,1,Nparts, CTR376_Pellets.nFuel);
  hydPelSrc.init(1,nrho, CTR376_Pellets.hydPelSrc);
  deutPelSrc.init(1,nrho, CTR376_Pellets.deutPelSrc);
  tritPelSrc.init(1,nrho, CTR376_Pellets.tritPelSrc);
  yFP.init(1,nfps, CTR396_Galerkin.yFP);
  hrFP.init(1,nfps, CTR396_Galerkin.hrFP);
  lzFP.init(1,nfps, CTR396_Galerkin.lzFP);
  muFP.init(1,nfps,1,Ntemps, CTR396_Galerkin.muFP);
  nFP.init(1,nfps,1,Nparts, CTR396_Galerkin.nFP);
  yCap.init(1,nfps,1,nfps,1,4, CTR396_Galerkin.yCap);
  yStiff.init(1,nfps,1,nfps,1,4, CTR396_Galerkin.yStiff);
  yLoad.init(1,nfps,1,4, CTR396_Galerkin.yLoad);
  muCap.init(1,nfps,1,nfps,1,2*Ntemps, CTR396_Galerkin.muCap);
  muStiff.init(1,nfps,1,nfps,1,2*Ntemps, CTR396_Galerkin.muStiff);
  muLoad.init(1,nfps,1,2*Ntemps, CTR396_Galerkin.muLoad);
  muDrag.init(1,nfps,1,nfps,1,2*Ntemps, CTR396_Galerkin.muDrag);
  nCap.init(1,nfps,1,nfps,1,Nparts, CTR396_Galerkin.nCap);
  nStiff.init(1,nfps,1,nfps,1,Nparts, CTR396_Galerkin.nStiff);
  nLoad.init(1,nfps,1,Nparts, CTR396_Galerkin.nLoad);
  lzCap.init(1,nfps,1,nfps, CTR396_Galerkin.lzCap);
  lzStiff.init(1,nfps,1,nfps, CTR396_Galerkin.lzStiff);
  lzLoad.init(1,nfps, CTR396_Galerkin.lzLoad);
}

// Run-controller package stuff:

#if defined(UseCTLPackage)

extern "C" {
  Integer ctr_ctrgen(Integer &optlist, Integer &nopt)
    {
      Vector<Integer> optlist1(32, &optlist);
      return ctr::gen(optlist1, nopt);
    }
  Integer ctr_ctrexe(Integer &optlist, Integer &nopt)
    {
      Vector<Integer> optlist1(32, &optlist);
      return ctr::exe(optlist1, nopt);
    }
  Integer ctr_ctrfin(Integer &optlist, Integer &nopt)
    {
      Vector<Integer> optlist1(32, &optlist);
      return ctr::fin(optlist1, nopt);
    }
};

#endif  /* ifdef(UseCTLPackage) */
