/* FILE: xxx.h */

#if !defined(__xxx__)
#define __xxx__

#include <basconf.h>

#if defined(__cplusplus)
#if !defined(__Basis__)
#include "Basis.h"
#endif
#if !defined(__Vector__)
#include "Vector.h"
#endif
#if !defined(__Array3__)
#include "Array3.h"
#endif
#if !defined(__Array4__)
#include "Array4.h"
#endif
#if !defined(__Character__)
#include "Character.h"
#endif
#if !defined(__CCLComplex__)
#include "CCLComplex.h"
#endif
#endif

#if !defined(__cplusplus)
#include "SysConfig.h"
#endif

/* Definitions / Parameters */

#define Pi 3.14159265358979323

/* Group Controlaccess */
#define xxx_sub2b FF_ID(sub2b, SUB2B)          /* subroutine */
#define xxx_sub3 FF_ID(sub3, SUB3)          /* subroutine */
#define xxx_sub4 FF_ID(sub4, SUB4)          /* subroutine */
#define xxx_sub7 FF_ID(sub7, SUB7)          /* subroutine */

/* Group Gname_i */
#define xxx_sub_a FF_ID(sub_a, SUB_A)          /* subroutine */
#define xxx_func_a FF_ID(func_a, FUNC_A)          /* function */
#define xxx_ifunc_a FF_ID(ifunc_a, IFUNC_A)          /* function */
#define xxx_sub_b FF_ID(sub_b, SUB_B)          /* subroutine */
#define xxx_func_b FF_ID(func_b, FUNC_B)          /* function */
#define xxx_csub_b FF_ID(csub_b, CSUB_B)          /* c-subroutine */
#define xxx_cfunc_b FF_ID(cfunc_b, CFUNC_B)          /* c-function */

/* Group Gname_r */
#define xxx_sub_c FF_ID(sub_c, SUB_C)          /* subroutine */
#define xxx_func_c FF_ID(func_c, FUNC_C)          /* function */
#define xxx_csub_c FF_ID(csub_c, CSUB_C)          /* c-subroutine */
#define xxx_cfunc_c FF_ID(cfunc_c, CFUNC_C)          /* c-function */

#if defined(__cplusplus)

// xxx package class definition

class xxx {
public:

// Group Controlaccess

  static void sub2b ( void );
  static void sub3 ( Character &, Character & );
  static void sub4 ( Character &, Character & );
  static void sub7 ( Integer &, Real & );

// Group Gname_i

  static void sub_a ( void );
  static Double func_a ( void );
  static Integer ifunc_a ( void );
  static void sub_b ( Integer &, Integer &, Integer & );
  static Double func_b ( Integer &, Integer &, Integer & );
  static void csub_b ( Integer &, Integer &, Integer & );
  static Double cfunc_b ( Integer &, Integer &, Integer & );

// Group Gname_r

  static void sub_c ( Real &, Real &, Real & );
  static Double func_c ( Real &, Real &, Real & );
  static void csub_c ( Real &, Real &, Real & );
  static Double cfunc_c ( Real &, Real &, Real & );

#if defined(UseCTLPackage)
  static Integer gen(Vector<Integer> &optlist, Integer &nopt);
  static Integer exe(Vector<Integer> &optlist, Integer &nopt);
  static Integer fin(Vector<Integer> &optlist, Integer &nopt);
#endif

  static void sync();
};

#endif /* __cplusplus */

/* Run-controller package stuff: */

#if defined(UseCTLPackage)
#define xxx_xxxgen FF_ID(xxxgen, XXXGEN)
#define xxx_xxxexe FF_ID(xxxexe, XXXEXE)
#define xxx_xxxfin FF_ID(xxxfin, XXXFIN)
#endif


#endif  /* __xxx__ */

