echo = no
#  Les "command" dans le langue "Basis" pour le package "spx"
define nar nar_set command_(See)
define courbe plot_curve command
define curve plot_curve command
define ajoutez plot_add command
define addcurve plot_add command
define surface plot_contour command
define titres titres_set command_S
define titles titres_set command_S
define bornes bornes_set command
define bounds bornes_set command
define newframe nar calcul_socket 1 ; nar
define linlin nar axe_log_x 0 ; nar axe_log_y 0
define linlog nar axe_log_x 0 ; nar axe_log_y 1
define loglog nar axe_log_x 1 ; nar axe_log_y 1
define default_x nar axe_x_min 0 ; nar axe_x_max 0
define default_y nar axe_y_min 0 ; nar axe_y_max 0
if(~exists("eznshow")) then
	define frame bounds
	define plot curve
	define plotz surface
endif
function plot_curve(y ;x)
        call naropen
        integer sy=shape(y)
        if(~exists("local.x")) then
           integer yr=rangex(y)
           real x=iota(yr(1,1),yr(1,2))
        endif
        integer sx=shape(x)
        if(length(sy)==1 & length(sx)==1) then
		integer n= length(x)
		if( length(y) <> n) then
			remark "Narcisse curve: lengths of x and y do not match!"
			call kaboom(0)
		endif
		call spx2moc(x, y, n, spxfile)
	elseif(length(sy)==2 & length(sx)==2) then
		integer ny=sx(2)
		integer nx=shape(sx(1),ny)
		call spx2muc(x,y,nx,ny,spxfile)
	elseif(length(sy)==2 & length(sx) == 1) then
		real xx=shape(x,shape(y))
                integer ny=sy(2)
		integer nx=shape(sy(1),ny)
		call spx2muc(xx,y,nx,ny,spxfile)
	else
		remark "Narcisse curve: incompatible curve sizes."
	endif
endf

function plot_contour(z;x,y,c)
        naropen
	integer s=shape(z)
        if( ~exists("local.x")) then
		call spx3prc(s(1),s(2),z,s(1),spxfile)
		return
	endif
	if( ~exists("local.y")) then
		<< "Narcisse surface: x given but y not given!"
		call kaboom(0)
	endif
	integer sx=shape(x), sy=shape(y)
        if(exists("local.c")) then
		integer sc=shape(c)
                if( length(sc) <> 2) surface_error(z,x,y,c)
                if( sc(1) <> s(1) | sc(2) <> s(2)) surface_error

		if(length(sx) == 1 & length(sy) == 1) then
			if(sx(1) <> sy(1)) then 
				surface_error(z,x,y,c)
			endif
			if(sx(1) <> s(1) | sy(1) <> s(2)) surface_error(z,x,y,c)
			spx4rec(s(1), s(2), x, y, z, s(1), c, s(1), spxfile)
		elseif(length(sx) = 2 & length(sy) == 2) then
			if(sx(1) <> s(1) | sy(1) <> s(1) | sx(2) <> s(2) |
			   sy(2) <> s(2) ) surface_error(x, y, z, c)
			spx4tec(s(1), s(2), x, s(1), y, s(1), z, s(1), 
				c, s(1), spxfile)
		else
			surface_error(x, y, z, c)
		endif
        else
		if(length(sx) == 1 & length(sy) == 1) then
			if(sx(1) <> s(1) | sy(1) <> s(2)) surface_error(x, y, z)
			spx3rec(s(1), s(2), x, y, z, s(1), spxfile)
		elseif(length(sx) = 2 & length(sy) == 2) then
			if(sx(1) <> s(1) | sy(1) <> s(1) | sx(2) <> s(2) |
			   sy(2) <> s(2) ) surface_error(x, y, z)
			spx3tec(s(1), s(2), x, s(1), y, s(1), z, s(1), spxfile)
		else
			surface_error(x, y, z)
		endif
        endif
endf

function surface_error(z,x,y;c)
	<< "Narcisse surface: shapes of arguments inconsistent."
   Locals_surface_error
	call kaboom(0)
endf

# Attributes

function nar_set(;key, valeur, index)
# nar name value 
# nar name value index
# nar (a envoyer )
# changes by ZCM 11/29/95 to support vector values for valeur and index
   integer i, j
   chameleon t, motcle
   integer l, m
   real x
        call naropen
# If called with no arguments, send buffer to Narcisse
   if ( ~exists("local.key") ) then
      call spxsv(spxfile, &spxarg, nspxarg)
      nspxarg = 0
      return
   endif
   if ( ~exists("local.valeur") ) then
      << "nar: No value given for keyword " << motcle
      call kaboom(0)
   endif;
   j = spxkey(key)
   l = length(valeur)
   motcle = spxmots(j)
   if( ~exists("local.index") ) then
      # If valuer is a vector of values call nar_set for each separate value
      if ( l > 1 ) then
         do i = 1 , l
            nar_set( key,  valeur(i))
         enddo
         return
      endif
      t = type(valeur)
      if( t=="real" | t=="double precision") then
	x = valeur
        call spxsar(&spxarg, j, motcle, x)
      elseif( t=="integer") then
        call spxsai(&spxarg, j, motcle, valeur)
      elseif( t=="character") then
        call spxsac(&spxarg, j, motcle, valeur)
      else
        << "Bad type for nar value: " << t
        call kaboom(0)
      endif
   else
      if(type(index) <> "integer") then
         << "Index in nar command must be integer."
         call kaboom(0)
      endif
      m = length(index)
      if ( m > 1 | l > 1 ) then
         if ( m > 1 & l > 1 & m ~= l ) then
            << "Vectors in nar command do not match."
            call kaboom ( 0 )
         endif
         # we call nar_set recursively for vector arguments
         if ( m == 1 ) then
            do i = 1 , l
               nar_set(key,valeur(i),index)
            enddo
         elseif ( l == 1 ) then
            do i = 1 , l
               nar_set(key,valeur,index(i))
            enddo
         else
            do i = 1 , l
               nar_set(key,valeur(i),index(i))
            enddo
         endif
         return
      endif
      t = type(valeur)
      if( t=="real" | t=="double precision") then
	x = valeur
        call spxsatr(&spxarg, j, motcle, x, index)
      elseif( t=="integer") then
        call spxsati(&spxarg, j, motcle, valeur, index)
      elseif( t=="character") then
        call spxsatc(&spxarg, j, motcle, valeur, index)
      else
        << "Bad type for nar value: " << t
        call kaboom(0)
      endif
   endif
   if(narmode) then
      call spxsv(spxfile, &spxarg, nspxarg)
      nspxarg = 0
   endif
endf

function titres_set(;top,bottom,left,right)
	default(top)=" "
	default(bottom)=" "
	default(left)=" "
	default(right)=" "
        logical ptds = narmode
        call naropen
        narmode = false
        nar titre_valeur_haut top
        nar titre_valeur_bas bottom
        nar titre_valeur_gauche left
        nar titre_valeur_droit right
        nar
        narmode = ptds
endf

function bornes_set(;xmin,xmax,ymin,ymax,zmin,zmax)
	default(xmin)=0.
	default(xmax)=0.
	default(ymin)=0.
	default(ymax)=0.
        logical explicit = exists("local.zmin")
	default(zmin)=0.
	default(zmax)=0.
        logical ptds = narmode
        call naropen
        narmode = false
	nar axe_x_min xmin
	nar axe_x_max xmax
	nar axe_y_min ymin
	nar axe_y_max ymax
	nar axe_z_min zmin
	nar axe_z_max zmax
        if(explicit) then
		nar axe_yd_min zmin
		nar axe_yd_max zmax
        endif
        nar
	narmode = ptds
# Would be better to ask the server for the real values.
	spx.xmin_used = xmin 
	spx.xmax_used = xmax
	spx.ymin_used = ymin
	spx.ymax_used = ymax
	spx.zmin_used = zmin
	spx.zmax_used = zmax
        if(explicit) then
		spx.ydmin_used = zmin
		spx.ydmax_used = zmax
	endif
endf

function plot_add(y;x)
        logical ptds = narmode
        call naropen
        narmode = true
	nar option_2d_concatene 1
        if( exists("local.x") ) then
           plot y x
        else
           plot y
        endif
        nar option_2d_concatene 0
	narmode = ptds
endf
