spx
# Interface to Narcisse
{
   NNARCISSE = 10000   # Size of array for setting attributes.
   NARTABLE = 200       # Size of table of keyword pairs
   MOTSIZE = 32         # Longest keyword
}

**** Bounds:
# Variables which remember values from the last bounds (bournes)
# command.
# In a future version we should ask the server for data limits
# when data limits are used.
# These can be used in subsequent bornes commands.
xmin_used real /0./
   # Last xmin given in bounds (bornes) command.
xmax_used real /0./
   # Last xmax given in a bounds (bornes) command.
ymin_used real /0./
   # Last ymin given in a bounds (bornes) command.
ymax_used real /0./
   # Last ymax given in a bounds (bornes) command.
zmin_used real /0./
   # Last zmin given in a bounds (bornes) command.
zmax_used real /0./
   # Last zmin given in a bounds (bornes) command.
ydmin_used real /0./
   # Last ydmin given in a bounds (bornes) command.
ydmax_used real /0./
   # Last ydmax given in a bounds (bornes) command.

**** Connections:
# Management of the dialogue with the Narcisse server.

narmode logical /TRUE/
   # Should the nar command send immediately or wait for a nar
   # command with no arguments? Default: send immediately.

naropen subroutine
   # Shell around spxopen

narclose subroutine
   # Shell around spxclose

spxstatus logical /FALSE/
   # Is spx open?

spxfile integer /0/
   # Holds the connection id returned by spxopen

spxname Filename /" "/
   # Name of the file to open

spxopen(name:string) integer function
   # Ouverature d'une connexion vers Narcisse.

spcopen(name:string) integer function
   # Not sure of what this does, open for data retrieval?

spxclose(numero) subroutine
   # Ferme le connexion vers Narcisse.

spxsync(numero) subroutine
   # Syncronize with Narcisse.

spxqry(name:string) integer function
   # Test d'existence de Narcisse

***** Configuration:
# Arrays and routines supporting the nar command.
# This data structure is used to support sending multiple requests
# to the server simulatenously. See the "nar" command.

narkey integer /0/
   # number of entries in nartable

nartable(NARTABLE, 2) character*MOTSIZE limited(narkey, 2)
   # English, French equivalent pairs

nspxarg integer /0/
   # Number of entries in spxarg so far.

mspxarg integer /0/
   # Maximum number of entries allowed in spxarg.

spxarg(NNARCISSE) integer 
   # Workspace used by configuration routines.

spxmots(0:mspxarg-1) _character*MOTSIZE limited(0:nspxarg-1)
   # Keywords in spxarg

spxkey(motcle:string) integer function
   # Return a slot number in spxmots for motcle.

$ Interface to Narcisse
spxia(spxarg:integer, taille:integer) integer function
   # spxarg(taille) is initialized.

spxpa(spxarg:integer, taille:integer) subroutine
  # Probably not needed from Basis (?)

spxsai(spxarg:integer, numero:integer, motcle:string, valint:integer) subroutine
   #Ecriver un couple motcle, valeur
   #spxarg est le tableau initialise avec spxia
   # Use the nar command instead of using this directly


spxsar(spxarg:integer, numero:integer, motcle:string, valreel:real) subroutine
   # Use the nar command instead of using this directly

spxsac(spxarg:integer, numero:integer, motcle:string, valcar:string) subroutine
   # Use the nar command instead of using this directly

spxsati(spxarg:integer, numero:integer, motcle:string, valint:integer, indice:integer) 
	subroutine
   # Use the nar command instead of using this directly

spxsatr(spxarg:integer, numero:integer, motcle:string, valreel:real, indice:integer) 
	subroutine
   # Use the nar command instead of using this directly

spxsatc(spxarg:integer, numero:integer, motcle:string, valcar:string, indice:integer) 
	subroutine
   # Use the nar command instead of using this directly

spxsv(spxfile:integer, spxarg:integer, taille:integer) subroutine
   # Used by the nar command to send requests to the server.

****** Donnees2D:
# Routines for plotting curves.

spx2moc(x:real, y:real, nx:integer, spxfile:integer) subroutine
   # Plot a curve

spx2muc(x:real, y:real, nx:integer, ny:integer, spxfile:integer) subroutine
   # Plot multiple curves (see also, "ajoutez" command).

***** Donnees3D:
# Plotting surfaces
# Use the plotz command.

spx3prc(nx:integer, ny:integer, z:real, dimz:integer, spxfile:integer) subroutine
   # z(i,j)
   # Used by plotz z

spx3rec(nx:integer, ny:integer, x:real, y:real, z:real,
	dimz:integer, spxfile:integer) subroutine
   # z(x(i),y(j))
   # Used by plotz z x y

spx3tec(nx:integer, ny:integer, x:real, dimx:integer,
	y:real, dimy:integer, z:real, dimz:integer, spxfile:integer) subroutine
   # z(x(i,j), y(i,j))
   # Used by plotz z x y


spx4rec(nx:integer, ny:integer, x:real, 
	y:real, z:real, dimz:integer, 
        c:real, dimc:integer, spxfile:integer) subroutine
   # z(x(i), y(j)), colored by c(i,j)
   # Used by plotz z x y c

spx4tec(nx:integer, ny:integer, x:real, dimx:integer,
	y:real, dimy:integer, z:real, dimz:integer, 
        c:real, dimc:integer, spxfile:integer) subroutine
   # z(x(i), y(j)), colored by c(i,j)
   # Used by plotz z x y c

spx4nsc(npoints:integer, x:real, y:real, z:real, c:real, nmailles:integer,
   dimmailles:integer, mailles:integer, spxfile:integer) subroutine
   # This routine is a mystery to Paul Dubois.

spx4parec(nx:integer, ny:integer, nz:integer, x:real, y:real, z:real, c:real,
   dimc1:integer, dimc2:integer, spxfile:integer) subroutine
   # This routine is a mystery to Paul Dubois.

****** Retrieval: 
# Routines for retrieving data, I think.

spxgc(x:real, y:real, spxfile:integer) subroutine

spx2gc(x:real, y:real, spxfile:integer) subroutine

spx3gc(x:real, y:real, z:real, spxfile:integer) subroutine

spxgda(dimbloc:integer, dimdon:integer, dimc:integer, dimmai:integer, dimvol:integer,
	x:real, y:real, z:real, c:real, nbloc:integer, nx:integer, ny:integer,
	nz:integer, type:integer, typec:integer, typem:integer, nmailles:integer,
	dimmailles:integer, nvolumes:integer, dimvolumes:integer, volumes:integer,
	spxfile:integer) integer function

