/*
 * svd.c
 */

#include "svd.h"

/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/

Integer Svdbfcn(Integer nargs, char *fname, Integer *sx)
{
    real8 *x;
    Integer t8, n, m, sy[SS_WIDTH];
    static Integer zero = 0;
    static char
        msg1[] = "argument to svd is wrong type.",
        msg2[] = "Impossible error in svd.",
        msg3[] = "svd: argument not a matrix.";

    sx[SS_N - 1] = 0;
    sx[SS_TC - 1] = 0;
    if (!strncmp(fname, "svd", 3)) {
        Fcnargb(1, sy);
        Pardim(sy);
        if (sy[SS_TC - 1] < INTEGER || sy[SS_TC - 1] > DOUBLE) {
            BasError(msg1, strlen(msg1));
            return ERR;
        }

        t8 = sizeof(float) == 8 ? REAL : DOUBLE;
        if (Parcoerc(sy, &t8) == ERR) {
            BasError(msg2, strlen(msg2));
            Kaboom(0);
        }

/* save to see if this problem like last one */
        m = svdm;
        n = svdn;
        if (Parlen(sy) == 1) {
            svdm = 1;
            svdn = 1;
        } else if (sy[SS_N - 1] != 2) {
            BasError(msg3, strlen(msg3));
            Kaboom(0);
        } else {
            svdm = sy[SS_N1 - 1];
            svdn = sy[SS_N1];
        }

        svdnm = min(svdm, svdn);

/* set workspace size, but use suggestion of previous call if appropriate */
        if (svdm != m || svdn != n)
            svdlw = max(5 * svdm, 5 * svdn);
        else
            svdlw = max(5 * svdm, max(5 * svdn, svdlw));

        Gallot("svd.SVD", &zero, 7);

        x = (real8 *) Paraddr(sy);

#ifdef UNICOS
        Sgesvd("A", "A", &svdm, &svdn, x, &svdm, svds, svdu, &svdm, svdvt,
               &svdn, svdwork, &svdlw, &svdinfo, 1, 1);
#else
        Dgesvd("A", "A", &svdm, &svdn, x, &svdm, svds, svdu, &svdm, svdvt,
               &svdn, svdwork, &svdlw, &svdinfo, 1, 1);
#endif

        svdlw = (Integer) svdwork[0];
        Basfree("svd.svdwork", 11);
        Parkill(sy);
    }

    return OK;
}

/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
