/*
 * svd.h -
 */

#ifndef SVD_H
#define SVD_H
#include "Fcc.h"
#include "svd_.h"
#include <string.h>

/* macros */
#define SS_N 1
#define SS_TC 2
#define ERR -1
#define OK 0
#define SS_N1 6
#define SS_WIDTH 26
#define INTEGER 1
#define REAL 2
#define DOUBLE 3
#undef max
#define max(a,b) ( (a) >  (b) ?  (a) :  (b))
#undef min
#define min(a,b) ( (a) <  (b) ?  (a) :  (b))

/* Forwards */
extern Address Paraddr (Integer *);
extern Integer Parlen (Integer *);
extern Integer Utstrcod (char *);
extern void Fcnargb (Integer, Integer *);
extern void Kaboom(Integer);
extern void Parkill (Integer * s);

/* FORTRAN prototypes */
#if defined(CRAY2) || defined(XMP) || defined(YMP) || defined(C90) || defined(J90)
#   undef WORKSTATION
#   define BasError BasErrCray
#else
#   define WORKSTATION
#   define BasError FF_ID(baserror, BASERROR)
#endif

#define Parcoerc FF_ID(parcoerc, PARCOERC)
#define Gallot   FF_ID(gallot, GALLOT)
#define Basfree  FF_ID(basfree, BASFREE)
#define Sgesvd   FF_ID(sgesvd, SGESVD)
#define Dgesvd   FF_ID(dgesvd, DGESVD)
#define Pardim   FF_ID(pardim, PARDIM)

extern void BasError(const char *, const Integer);
extern Integer Parcoerc(Integer *, Integer *);
extern Integer Gallot(char *, Integer *, Integer);
extern Integer Basfree(char *, Integer);
extern void Sgesvd(char *, char *, Integer *, Integer *, real8 *,
   Integer *, real8 *, real8 *, Integer *, real8 *, Integer *, real8 *,
   Integer *, Integer *, Integer, Integer);
extern void Dgesvd(char *, char *, Integer *, Integer *, real8 *,
   Integer *, real8 *, real8 *, Integer *, real8 *, Integer *, real8 *,
   Integer *, Integer *, Integer, Integer);
extern void Pardim(Integer *);

#endif
