C------------------------------------------------------------------------
C
C  FORTRAN77/LRLTRAN Skeleton Source File
C  ******** Altered to allow recursive parser calls.********
C  ******** This version also has improved error    ********
C  ******** printouts. Finally, LRPARS, LRPACT,     ********
C  ******** LRVACT, and other routines have been    ********
C  ******** changed to INTEGER FUNCTIONs which      ********
C  ******** return OK, DONE, or ERR.                ********
C  ********                  Zane C. Motteler           ********
C  ********               July and August, 1987         ********
C  ******** Revised to improve recursion process.   ********
C  ******** Virtually all environment preservation  ********
C  ******** has been moved out, and rhslen, lhsvoc  ********
C  ******** have been returned to being LRPARS      ********
C  ******** local variables.                        ********
C  ********             Zane C. Motteler            ********
C  ********                August 1989              ********
C
C
C------------------------------------------------------------------------
 
C
 
 
 
C****** ----------------------------------------------------------------
C******                Standard FORTRAN-77 Skeleton
C****** WARNING This file was created from the file SKEL.LSK, changes to
C******         this file may be lost unless SKEL.LSK is changed also.
C******         See the file SKEL.LSK for more information.
C****** ----------------------------------------------------------------
 
 
C------------------------------------------------------------------------
C
C   (c) Copyright 1984 by the Regents of the University of California.
C   All rights reserved.  This work was produced under the sponsorship of
C   the U.S.Department of Energy.  The Government retains certain rights
C   therein.
C
C                      DISCLAIMER
C       This document was  prepared as an account
C       of work  sponsored  by  an  agency of the
C       United States  Government.   Neither  the
C       United States    Government    nor    the
C       University of California nor any of their
C       employees, makes any warranty, express or
C       implied, or assumes  any  legal liability
C       or responsibility   for   the   accuracy,
C       completeness or   usefulness    of    any
C       information, apparatus,     product    or
C       process disclosed, or represents that its
C       use would  not  infringe  privately owned
C       rights.  Reference herein to any specific
C       commercial products,  process, or service
C       by trade name,  trademark,  manufacturer,
C       or otherwise,    does   not   necessarily
C       constitute or  imply   its   endorsement,
C       recommendation, or favoring by the United
C       States Government  or the  University  of
C       California.  The  views  and  opinions of
C       authors expressed    herein     do    not
C       necessarily state or reflect those of the
C       United States  Government   thereof,  and
C       shall not  be  used  for  advertising  or
C       product endorsement purposes.
C
C       Work performed under  the auspices of the
C       U.S. Department of   Energy  by  Lawrence
C       Livermore National    Laboratory    under
C       contract number W-7405-Eng-48.
C
C------------------------------------------------------------------------
 
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
C
 
      SUBROUTINE LERRNO ( ERNUM )
C****** ROUTINE LERRNO ( ERNUM ) : PRINT ERROR MESSAGE
C****** Global constants data loaded in main.
      INTEGER PBLNK, PSTDIN, PSTDOUT, PSTDERR, PMXERR, PENDF
      INTEGER PEOL, PTAB, PDOL, PETX, OK, ERR, DONE
      COMMON/G4CONST/PBLNK, PSTDIN, PSTDOUT, PSTDERR, PMXERR, PENDF
      COMMON/G4CONST/PEOL, PTAB, PDOL, PETX, OK, ERR, DONE
C****** COMMON: G4ERR (ERROR COUNT)
      INTEGER ECOUNT, PCOUNT
      COMMON/G4ERR/ECOUNT, PCOUNT
C******  print out error message
      INTEGER ERNUM
C******  keep count of errors
      ECOUNT = ECOUNT + 1
C******  print specific messages
      GO TO ( 1 , 2 , 3 , 4 , 5 , 6 , 7 , 8 , 9 , 10 , 11 ), ERNUM
    1 CONTINUE
        CALL LZTEXT(PSTDOUT,'Program error, see author.$')
        CALL LZSEND(PSTDOUT)
        CALL LZTEXT(PSTDOUT,'lrvlup: Cannot find item in vocabulary.$')
        CALL LZSEND(PSTDOUT)
        GO TO 300
    2 CONTINUE
        CALL LZTEXT(PSTDOUT,'Program error, see author.$')
        CALL LZSEND(PSTDOUT)
        CALL LZTEXT(PSTDOUT,'lxpush: Unput stack overflow.$')
        CALL LZSEND(PSTDOUT)
        GO TO 300
    3 CONTINUE
        CALL LZTEXT(PSTDOUT,'Usage error: token too long$')
        CALL LZTEXT(PSTDOUT,' or too much lookahead.$')
        CALL LZSEND(PSTDOUT)
        CALL LZTEXT(PSTDOUT,'Token will be truncated.')
        CALL LZSEND(PSTDOUT)
        GO TO 200
    4 CONTINUE
        CALL LZTEXT(PSTDOUT,'Illegal character in input.$')
        CALL LZSEND(PSTDOUT)
        GO TO 200
    5 CONTINUE
        CALL LZTEXT(PSTDOUT,'Unknown text in input.$')
        CALL LZSEND(PSTDOUT)
        GO TO 200
    6 CONTINUE
        CALL LZTEXT(PSTDOUT,'Program error, see author.$')
        CALL LZSEND(PSTDOUT)
        CALL LZTEXT(PSTDOUT,'lxgtok: Trouble in lookahead state.$')
        CALL LZSEND(PSTDOUT)
        GO TO 300
    7 CONTINUE
        CALL LZTEXT(PSTDOUT,'Syntax error.$')
        CALL LZSEND(PSTDOUT)
        GO TO 200
    8 CONTINUE
        CALL LZTEXT(PSTDOUT,'Program error, see author.$')
        CALL LZSEND(PSTDOUT)
        CALL LZTEXT(PSTDOUT,'Parse stack overflow.$')
        CALL LZSEND(PSTDOUT)
        GO TO 300
    9 CONTINUE
        CALL LZTEXT(PSTDOUT,'Program had a semantic error.$')
        CALL LZSEND(PSTDOUT)
        GO TO 300
   10 CONTINUE
        CALL LZTEXT(PSTDOUT,'Too many recursive calls to LRPARS.$')
        CALL LZSEND(PSTDOUT)
        GO TO 300
   11 CONTINUE
        CALL LZTEXT(PSTDOUT,'Program error, see author.$')
        CALL LZSEND(PSTDOUT)
        CALL LZTEXT(PSTDOUT,
     >  'LRPARS: recursive stack pointer out of bounds.$')
        CALL LZSEND(PSTDOUT)
        GO TO 300
  200 CONTINUE
      IF ( ECOUNT .GE. PMXERR ) THEN
        CALL LZTEXT(PSTDOUT,'****** TOO MANY ERRORS. ******$')
        CALL LZSEND(PSTDOUT)
        GO TO 300
      ENDIF
      RETURN
  300 CONTINUE
      CALL LRSTOP
      RETURN
      END
 
      INTEGER FUNCTION LRDRED ( REDNUM , LHSVOC, RHSLEN, RETFLG, RECRSV)
C****** ROUTINE LRDRED ( REDNUM, LHSVOC, RHSLEN, RETFLG, RECRSV) : DO REDUCTION
C****** COMMON: G4LR (LR TABLES)
      INTEGER MLRST, MLRST1, MLRFIN, MLRINT, MLRVCL
      INTEGER MLRV1, MLRVTX, MLRVCT, MLRRED, MLRRE1
      INTEGER MLRTR, MLRTR1, MLRLOK, MLRPRD, MLRRHS
      INTEGER MLREND
      PARAMETER ( MLRST = 345 )
      PARAMETER ( MLRST1 = 346 )
      PARAMETER ( MLRFIN = 5 )
      PARAMETER ( MLRINT = 1 )
      PARAMETER ( MLRVCL = 166 )
      PARAMETER ( MLRV1 = 167 )
      PARAMETER ( MLRVTX = 1041 )
      PARAMETER ( MLRVCT = 87 )
      PARAMETER ( MLRRED = 366 )
      PARAMETER ( MLRRE1 = 367 )
      PARAMETER ( MLRTR  = 2912 )
      PARAMETER ( MLRTR1  = 2913 )
      PARAMETER ( MLRLOK = 92 )
      PARAMETER ( MLRPRD = 214 )
      PARAMETER ( MLRRHS = 10 )
      PARAMETER ( MLREND = 30 )
      CHARACTER VOCLR*1
      INTEGER BVOCLR, ENTLR, REDLR
      INTEGER FRDLR,TRANLR,NLOKLR,PRODLR
      INTEGER LSETLR, RHSLR, LHSLR, ACTLR
      INTEGER VACTLR
      DIMENSION VOCLR ( 1041 )
      DIMENSION BVOCLR ( 167 )
      DIMENSION ENTLR ( 345 )
      DIMENSION REDLR ( 346 )
      DIMENSION FRDLR ( 346 )
      DIMENSION TRANLR ( 2912 )
      DIMENSION NLOKLR ( 366 )
      DIMENSION PRODLR ( 366 )
      DIMENSION LSETLR ( 92 , 87 )
      DIMENSION RHSLR ( 214 )
      DIMENSION LHSLR ( 214 )
      DIMENSION ACTLR ( 214 )
      DIMENSION VACTLR ( 87 )
      COMMON /G4LR1/ VOCLR
      COMMON /G4LR2/ BVOCLR, ENTLR, REDLR
      COMMON /G4LR2/ FRDLR,TRANLR,NLOKLR,PRODLR
      COMMON /G4LR2/ LSETLR, RHSLR, LHSLR, ACTLR
      COMMON /G4LR2/ VACTLR
C****** COMMON: G4DBG (DEBUG FLAGS)
        INTEGER DBGFIL , DEBUG , DEBTOK , DEBRED , DEBTRN , DEBSTK
        INTEGER DEBACT , DOACTS
        COMMON /G4DBG/ DBGFIL , DEBUG  , DEBTOK , DEBRED , DEBTRN
        COMMON /G4DBG/ DEBSTK , DEBACT , DOACTS
C****** COMMON: G4ERR (ERROR COUNT)
      INTEGER ECOUNT, PCOUNT
      COMMON/G4ERR/ECOUNT, PCOUNT
C****** Global constants data loaded in main.
      INTEGER PBLNK, PSTDIN, PSTDOUT, PSTDERR, PMXERR, PENDF
      INTEGER PEOL, PTAB, PDOL, PETX, OK, ERR, DONE
      COMMON/G4CONST/PBLNK, PSTDIN, PSTDOUT, PSTDERR, PMXERR, PENDF
      COMMON/G4CONST/PEOL, PTAB, PDOL, PETX, OK, ERR, DONE
      INTEGER REDNUM, RECRSV
      LOGICAL RETFLG
      INTEGER ACTION , NSTATE , LHSVOC , RHSLEN , CSTATE , PTR
      EXTERNAL LRFTRN
      INTEGER LRFTRN
      LHSVOC = LHSLR(REDNUM)
      RHSLEN = RHSLR(REDNUM)
        IF(DEBUG+DEBRED.EQ.2)CALL LRWRED(DBGFIL,LHSVOC,RHSLEN)
      ACTION = ACTLR(REDNUM)
        IF(DEBUG.EQ.1.AND.DOACTS.EQ.0)ACTION=0
      IF ( ACTION .NE. 0 ) THEN
          IF(DEBUG+DEBACT.EQ.2)CALL LRWPAC(DBGFIL,ACTION)
        CALL LRGPTR ( PTR )
        LRDRED = LRPACT ( ACTION , PTR , RETFLG, RECRSV)
      ELSE
        LRDRED = OK
        RETFLG = .FALSE.
      ENDIF
      CALL LRPOPN ( RHSLEN )
      CALL LRGSTA ( CSTATE )
      NSTATE = LRFTRN ( CSTATE , LHSVOC )
      CALL LRPUSH ( NSTATE , LHSVOC )
      RETURN
      END
 
      INTEGER FUNCTION LRDTRN ( STATE , TOKEN , RECRSV )
C****** ROUTINE LRDTRN ( STATE , TOKEN ) : DO TRANSITION
C****** COMMON: G4DBG (DEBUG FLAGS)
        INTEGER DBGFIL , DEBUG , DEBTOK , DEBRED , DEBTRN , DEBSTK
        INTEGER DEBACT , DOACTS
        COMMON /G4DBG/ DBGFIL , DEBUG  , DEBTOK , DEBRED , DEBTRN
        COMMON /G4DBG/ DEBSTK , DEBACT , DOACTS
C****** COMMON: G4LR (LR TABLES)
      INTEGER MLRST, MLRST1, MLRFIN, MLRINT, MLRVCL
      INTEGER MLRV1, MLRVTX, MLRVCT, MLRRED, MLRRE1
      INTEGER MLRTR, MLRTR1, MLRLOK, MLRPRD, MLRRHS
      INTEGER MLREND
      PARAMETER ( MLRST = 345 )
      PARAMETER ( MLRST1 = 346 )
      PARAMETER ( MLRFIN = 5 )
      PARAMETER ( MLRINT = 1 )
      PARAMETER ( MLRVCL = 166 )
      PARAMETER ( MLRV1 = 167 )
      PARAMETER ( MLRVTX = 1041 )
      PARAMETER ( MLRVCT = 87 )
      PARAMETER ( MLRRED = 366 )
      PARAMETER ( MLRRE1 = 367 )
      PARAMETER ( MLRTR  = 2912 )
      PARAMETER ( MLRTR1  = 2913 )
      PARAMETER ( MLRLOK = 92 )
      PARAMETER ( MLRPRD = 214 )
      PARAMETER ( MLRRHS = 10 )
      PARAMETER ( MLREND = 30 )
      CHARACTER VOCLR*1
      INTEGER BVOCLR, ENTLR, REDLR
      INTEGER FRDLR,TRANLR,NLOKLR,PRODLR
      INTEGER LSETLR, RHSLR, LHSLR, ACTLR
      INTEGER VACTLR
      DIMENSION VOCLR ( 1041 )
      DIMENSION BVOCLR ( 167 )
      DIMENSION ENTLR ( 345 )
      DIMENSION REDLR ( 346 )
      DIMENSION FRDLR ( 346 )
      DIMENSION TRANLR ( 2912 )
      DIMENSION NLOKLR ( 366 )
      DIMENSION PRODLR ( 366 )
      DIMENSION LSETLR ( 92 , 87 )
      DIMENSION RHSLR ( 214 )
      DIMENSION LHSLR ( 214 )
      DIMENSION ACTLR ( 214 )
      DIMENSION VACTLR ( 87 )
      COMMON /G4LR1/ VOCLR
      COMMON /G4LR2/ BVOCLR, ENTLR, REDLR
      COMMON /G4LR2/ FRDLR,TRANLR,NLOKLR,PRODLR
      COMMON /G4LR2/ LSETLR, RHSLR, LHSLR, ACTLR
      COMMON /G4LR2/ VACTLR
C****** COMMON: G4LRTK (CURRENT AND LAST TOKEN NUMBER, TEXT, LENGTH)
      INTEGER NTOKEN , LTOKEN , LASTNTOK , LASTLTOK
        CHARACTER TTOKEN*(500)
        CHARACTER LASTTTOK*(500)
      COMMON/G4LRTK1/ NTOKEN , LTOKEN , LASTNTOK , LASTLTOK
      COMMON/G4LRTK2/ TTOKEN , LASTTTOK
C****** Global constants data loaded in main.
      INTEGER PBLNK, PSTDIN, PSTDOUT, PSTDERR, PMXERR, PENDF
      INTEGER PEOL, PTAB, PDOL, PETX, OK, ERR, DONE
      COMMON/G4CONST/PBLNK, PSTDIN, PSTDOUT, PSTDERR, PMXERR, PENDF
      COMMON/G4CONST/PEOL, PTAB, PDOL, PETX, OK, ERR, DONE
      INTEGER STATE , TOKEN , RECRSV
      INTEGER ACTION , PTR
        IF(DEBUG+DEBTRN.EQ.2)CALL LRWTRN(DBGFIL,TOKEN)
      CALL LRPUSH ( STATE , TOKEN )
      LASTNTOK = NTOKEN
        LASTTTOK = TTOKEN(1:LTOKEN)
      LASTLTOK = LTOKEN
      ACTION = VACTLR(TOKEN)
      IF(DEBUG.EQ.1.AND.DOACTS.EQ.0)ACTION=0
      IF(STATE.EQ.MLRFIN)THEN
        LRDTRN = DONE
      ELSE
        LRDTRN = OK
      ENDIF
      IF ( ACTION .NE. 0 ) THEN
          IF(DEBUG+DEBACT.EQ.2)CALL LRWVAC(DBGFIL,ACTION)
        CALL LRGPTR ( PTR )
        IF ( LRVACT ( ACTION , PTR , RECRSV ) .EQ. ERR ) THEN
          LRDTRN = ERR
        ENDIF
      ENDIF
      RETURN
      END
 
 
      SUBROUTINE LRERRN
C****** Initialize the count of parentheses and of reductions, which are
C****** used in the event of a syntax error.
C****** COMMON: G4ERR (ERROR COUNT)
      INTEGER ECOUNT, PCOUNT
      COMMON/G4ERR/ECOUNT, PCOUNT
      PCOUNT = 0
      RETURN
      END
 
      SUBROUTINE LRESET ( VSET )
C****** ROUTINE LRESET ( VSET ) : CALCULATE EXPECTED SET OF TERMINALS
C****** COMMON: G4LR (LR TABLES)
      INTEGER MLRST, MLRST1, MLRFIN, MLRINT, MLRVCL
      INTEGER MLRV1, MLRVTX, MLRVCT, MLRRED, MLRRE1
      INTEGER MLRTR, MLRTR1, MLRLOK, MLRPRD, MLRRHS
      INTEGER MLREND
      PARAMETER ( MLRST = 345 )
      PARAMETER ( MLRST1 = 346 )
      PARAMETER ( MLRFIN = 5 )
      PARAMETER ( MLRINT = 1 )
      PARAMETER ( MLRVCL = 166 )
      PARAMETER ( MLRV1 = 167 )
      PARAMETER ( MLRVTX = 1041 )
      PARAMETER ( MLRVCT = 87 )
      PARAMETER ( MLRRED = 366 )
      PARAMETER ( MLRRE1 = 367 )
      PARAMETER ( MLRTR  = 2912 )
      PARAMETER ( MLRTR1  = 2913 )
      PARAMETER ( MLRLOK = 92 )
      PARAMETER ( MLRPRD = 214 )
      PARAMETER ( MLRRHS = 10 )
      PARAMETER ( MLREND = 30 )
      CHARACTER VOCLR*1
      INTEGER BVOCLR, ENTLR, REDLR
      INTEGER FRDLR,TRANLR,NLOKLR,PRODLR
      INTEGER LSETLR, RHSLR, LHSLR, ACTLR
      INTEGER VACTLR
      DIMENSION VOCLR ( 1041 )
      DIMENSION BVOCLR ( 167 )
      DIMENSION ENTLR ( 345 )
      DIMENSION REDLR ( 346 )
      DIMENSION FRDLR ( 346 )
      DIMENSION TRANLR ( 2912 )
      DIMENSION NLOKLR ( 366 )
      DIMENSION PRODLR ( 366 )
      DIMENSION LSETLR ( 92 , 87 )
      DIMENSION RHSLR ( 214 )
      DIMENSION LHSLR ( 214 )
      DIMENSION ACTLR ( 214 )
      DIMENSION VACTLR ( 87 )
      COMMON /G4LR1/ VOCLR
      COMMON /G4LR2/ BVOCLR, ENTLR, REDLR
      COMMON /G4LR2/ FRDLR,TRANLR,NLOKLR,PRODLR
      COMMON /G4LR2/ LSETLR, RHSLR, LHSLR, ACTLR
      COMMON /G4LR2/ VACTLR
        INTEGER VSET
        DIMENSION VSET ( MLRVCT )
      INTEGER I , J , IBIT , START , STOP , STATE
      DO 100 I = 1 , MLRVCT
        VSET ( I ) = 0
  100 CONTINUE
      CALL LRGSTA ( STATE )
      START = REDLR(STATE)
      STOP  = REDLR(STATE+1) -1
      DO 200 I = START , STOP
        DO 300 J = 1 , MLRVCT
          IBIT = 0
        IBIT = VSET ( J )
          IF ( IBIT .EQ. 0 ) THEN
        VSET ( J ) = LSETLR(NLOKLR(I),J)
          ENDIF
  300   CONTINUE
  200 CONTINUE
      START = FRDLR(STATE)
      STOP  = FRDLR(STATE+1) - 1
      DO 400 I = START , STOP
        J = ENTLR(TRANLR(I))
        IF ( J .LE. MLRVCT ) THEN
        VSET ( J ) = 1
        ENDIF
  400 CONTINUE
      RETURN
      END
 
      INTEGER FUNCTION LRFRED ( STATE , TOKEN )
C****** ROUTINE LRFRED ( STATE , TOKEN ) : FIND REDUCTION, RETURN -1 IF NONE
C****** COMMON: G4LR (LR TABLES)
      INTEGER MLRST, MLRST1, MLRFIN, MLRINT, MLRVCL
      INTEGER MLRV1, MLRVTX, MLRVCT, MLRRED, MLRRE1
      INTEGER MLRTR, MLRTR1, MLRLOK, MLRPRD, MLRRHS
      INTEGER MLREND
      PARAMETER ( MLRST = 345 )
      PARAMETER ( MLRST1 = 346 )
      PARAMETER ( MLRFIN = 5 )
      PARAMETER ( MLRINT = 1 )
      PARAMETER ( MLRVCL = 166 )
      PARAMETER ( MLRV1 = 167 )
      PARAMETER ( MLRVTX = 1041 )
      PARAMETER ( MLRVCT = 87 )
      PARAMETER ( MLRRED = 366 )
      PARAMETER ( MLRRE1 = 367 )
      PARAMETER ( MLRTR  = 2912 )
      PARAMETER ( MLRTR1  = 2913 )
      PARAMETER ( MLRLOK = 92 )
      PARAMETER ( MLRPRD = 214 )
      PARAMETER ( MLRRHS = 10 )
      PARAMETER ( MLREND = 30 )
      CHARACTER VOCLR*1
      INTEGER BVOCLR, ENTLR, REDLR
      INTEGER FRDLR,TRANLR,NLOKLR,PRODLR
      INTEGER LSETLR, RHSLR, LHSLR, ACTLR
      INTEGER VACTLR
      DIMENSION VOCLR ( 1041 )
      DIMENSION BVOCLR ( 167 )
      DIMENSION ENTLR ( 345 )
      DIMENSION REDLR ( 346 )
      DIMENSION FRDLR ( 346 )
      DIMENSION TRANLR ( 2912 )
      DIMENSION NLOKLR ( 366 )
      DIMENSION PRODLR ( 366 )
      DIMENSION LSETLR ( 92 , 87 )
      DIMENSION RHSLR ( 214 )
      DIMENSION LHSLR ( 214 )
      DIMENSION ACTLR ( 214 )
      DIMENSION VACTLR ( 87 )
      COMMON /G4LR1/ VOCLR
      COMMON /G4LR2/ BVOCLR, ENTLR, REDLR
      COMMON /G4LR2/ FRDLR,TRANLR,NLOKLR,PRODLR
      COMMON /G4LR2/ LSETLR, RHSLR, LHSLR, ACTLR
      COMMON /G4LR2/ VACTLR
      INTEGER STATE , TOKEN
      INTEGER START , STOP , I
      START = REDLR(STATE)
      STOP  = REDLR(STATE+1) -1
      L = -1
      I = START
  100 CONTINUE
        IF ( I .GT. STOP ) GO TO 200
        IF ( LSETLR(NLOKLR(I),TOKEN) .EQ. 1 ) THEN
          L = PRODLR(I)
          I = STOP + 1
        ELSE
          I = I + 1
        ENDIF
      GO TO 100
  200 CONTINUE
      LRFRED = L
      RETURN
      END
 
      INTEGER FUNCTION LRFTRN ( STATE , TOKEN )
C****** ROUTINE LRFTRN ( STATE , TOKEN ) : FIND TRANSITION, RETURN -1 IF NONE
C****** COMMON: G4LR (LR TABLES)
      INTEGER MLRST, MLRST1, MLRFIN, MLRINT, MLRVCL
      INTEGER MLRV1, MLRVTX, MLRVCT, MLRRED, MLRRE1
      INTEGER MLRTR, MLRTR1, MLRLOK, MLRPRD, MLRRHS
      INTEGER MLREND
      PARAMETER ( MLRST = 345 )
      PARAMETER ( MLRST1 = 346 )
      PARAMETER ( MLRFIN = 5 )
      PARAMETER ( MLRINT = 1 )
      PARAMETER ( MLRVCL = 166 )
      PARAMETER ( MLRV1 = 167 )
      PARAMETER ( MLRVTX = 1041 )
      PARAMETER ( MLRVCT = 87 )
      PARAMETER ( MLRRED = 366 )
      PARAMETER ( MLRRE1 = 367 )
      PARAMETER ( MLRTR  = 2912 )
      PARAMETER ( MLRTR1  = 2913 )
      PARAMETER ( MLRLOK = 92 )
      PARAMETER ( MLRPRD = 214 )
      PARAMETER ( MLRRHS = 10 )
      PARAMETER ( MLREND = 30 )
      CHARACTER VOCLR*1
      INTEGER BVOCLR, ENTLR, REDLR
      INTEGER FRDLR,TRANLR,NLOKLR,PRODLR
      INTEGER LSETLR, RHSLR, LHSLR, ACTLR
      INTEGER VACTLR
      DIMENSION VOCLR ( 1041 )
      DIMENSION BVOCLR ( 167 )
      DIMENSION ENTLR ( 345 )
      DIMENSION REDLR ( 346 )
      DIMENSION FRDLR ( 346 )
      DIMENSION TRANLR ( 2912 )
      DIMENSION NLOKLR ( 366 )
      DIMENSION PRODLR ( 366 )
      DIMENSION LSETLR ( 92 , 87 )
      DIMENSION RHSLR ( 214 )
      DIMENSION LHSLR ( 214 )
      DIMENSION ACTLR ( 214 )
      DIMENSION VACTLR ( 87 )
      COMMON /G4LR1/ VOCLR
      COMMON /G4LR2/ BVOCLR, ENTLR, REDLR
      COMMON /G4LR2/ FRDLR,TRANLR,NLOKLR,PRODLR
      COMMON /G4LR2/ LSETLR, RHSLR, LHSLR, ACTLR
      COMMON /G4LR2/ VACTLR
      INTEGER STATE , TOKEN
      INTEGER START , STOP , TRANS , I
      START = FRDLR(STATE)
      STOP  = FRDLR(STATE+1) - 1
      LRFTRN = -1
      I = START
  100 CONTINUE
        IF ( I .GT. STOP ) GO TO 200
        TRANS = TRANLR(I)
        IF ( TOKEN .EQ. ENTLR(TRANS) ) THEN
          LRFTRN = TRANS
          I = STOP + 1
        ELSE
          I = I + 1
        ENDIF
      GO TO 100
  200 CONTINUE
      RETURN
      END
 
      SUBROUTINE LRGDBG ( FIL, DEB, TOK, RED, TRN, STK, ACT, DOACT )
C****** ROUTINE LRGDBG ( FIL , DEB , TOK , RED , TRN , STK , ACT , DOACT )
C****** COMMON: G4DBG (DEBUG FLAGS)
        INTEGER DBGFIL , DEBUG , DEBTOK , DEBRED , DEBTRN , DEBSTK
        INTEGER DEBACT , DOACTS
        COMMON /G4DBG/ DBGFIL , DEBUG  , DEBTOK , DEBRED , DEBTRN
        COMMON /G4DBG/ DEBSTK , DEBACT , DOACTS
      INTEGER FIL, DEB, TOK, RED, TRN, STK, ACT, DOACT
        FIL = DBGFIL
        DEB = DEBUG
        TOK = DEBTOK
        RED = DEBRED
        TRN = DEBTRN
        STK = DEBSTK
        ACT = DEBACT
        DOACT = DOACTS
      RETURN
      END
 
      SUBROUTINE LRGERR ( ERRS )
C****** ROUTINE LRGERR ( ERRS ) : RETURN COUNT OF ERRORS
C****** COMMON: G4ERR (ERROR COUNT)
      INTEGER ECOUNT, PCOUNT
      COMMON/G4ERR/ECOUNT, PCOUNT
      INTEGER ERRS
      ERRS = ECOUNT
      RETURN
      END
 
C     SUBROUTINE LRGPTR ( PTR )
C****** ROUTINE LRGPTR ( PTR ) : RETURN STACK POINTER
C****** COMMON: G4LRST (LR STATE/VOCABULARY STACKS)
C****** Moved to clr.c where dynamic work takes place
 
C     SUBROUTINE LRGSTA ( STATE )
C****** moved to lrsrc so that states could be made dynamic
C****** ZCM 8/89
 
      SUBROUTINE LRINIT
C****** ROUTINE LRINIT : INITIALIZE THE PARSER
C****** COMMON: G4LR (LR TABLES)
      INTEGER MLRST, MLRST1, MLRFIN, MLRINT, MLRVCL
      INTEGER MLRV1, MLRVTX, MLRVCT, MLRRED, MLRRE1
      INTEGER MLRTR, MLRTR1, MLRLOK, MLRPRD, MLRRHS
      INTEGER MLREND
      PARAMETER ( MLRST = 345 )
      PARAMETER ( MLRST1 = 346 )
      PARAMETER ( MLRFIN = 5 )
      PARAMETER ( MLRINT = 1 )
      PARAMETER ( MLRVCL = 166 )
      PARAMETER ( MLRV1 = 167 )
      PARAMETER ( MLRVTX = 1041 )
      PARAMETER ( MLRVCT = 87 )
      PARAMETER ( MLRRED = 366 )
      PARAMETER ( MLRRE1 = 367 )
      PARAMETER ( MLRTR  = 2912 )
      PARAMETER ( MLRTR1  = 2913 )
      PARAMETER ( MLRLOK = 92 )
      PARAMETER ( MLRPRD = 214 )
      PARAMETER ( MLRRHS = 10 )
      PARAMETER ( MLREND = 30 )
      CHARACTER VOCLR*1
      INTEGER BVOCLR, ENTLR, REDLR
      INTEGER FRDLR,TRANLR,NLOKLR,PRODLR
      INTEGER LSETLR, RHSLR, LHSLR, ACTLR
      INTEGER VACTLR
      DIMENSION VOCLR ( 1041 )
      DIMENSION BVOCLR ( 167 )
      DIMENSION ENTLR ( 345 )
      DIMENSION REDLR ( 346 )
      DIMENSION FRDLR ( 346 )
      DIMENSION TRANLR ( 2912 )
      DIMENSION NLOKLR ( 366 )
      DIMENSION PRODLR ( 366 )
      DIMENSION LSETLR ( 92 , 87 )
      DIMENSION RHSLR ( 214 )
      DIMENSION LHSLR ( 214 )
      DIMENSION ACTLR ( 214 )
      DIMENSION VACTLR ( 87 )
      COMMON /G4LR1/ VOCLR
      COMMON /G4LR2/ BVOCLR, ENTLR, REDLR
      COMMON /G4LR2/ FRDLR,TRANLR,NLOKLR,PRODLR
      COMMON /G4LR2/ LSETLR, RHSLR, LHSLR, ACTLR
      COMMON /G4LR2/ VACTLR
C****** COMMON: G4LRTK (CURRENT AND LAST TOKEN NUMBER, TEXT, LENGTH)
      INTEGER NTOKEN , LTOKEN , LASTNTOK , LASTLTOK
        CHARACTER TTOKEN*(500)
        CHARACTER LASTTTOK*(500)
      COMMON/G4LRTK1/ NTOKEN , LTOKEN , LASTNTOK , LASTLTOK
      COMMON/G4LRTK2/ TTOKEN , LASTTTOK
C****** COMMON: G4DBG (DEBUG FLAGS)
        INTEGER DBGFIL , DEBUG , DEBTOK , DEBRED , DEBTRN , DEBSTK
        INTEGER DEBACT , DOACTS
        COMMON /G4DBG/ DBGFIL , DEBUG  , DEBTOK , DEBRED , DEBTRN
        COMMON /G4DBG/ DEBSTK , DEBACT , DOACTS
      EXTERNAL LRLOAD
        IF(DEBUG+DEBSTK.EQ.2)THEN
          CALL LZTEXT(DBGFIL,'Stack completely reset.$')
          CALL LZSEND(DBGFIL)
        ENDIF
        TTOKEN = 'END'
        LTOKEN = 3
        NTOKEN = MLREND
        CALL LRSTKN
        CALL LRPUSH ( MLRINT , NTOKEN )
        CALL LRERRN
      RETURN
      END
 

      BLOCK DATA LRLO00
      CHARACTER VOCLR*1
      INTEGER BVOCLR, ENTLR, REDLR
      INTEGER FRDLR,TRANLR,NLOKLR,PRODLR
      INTEGER LSETLR, RHSLR, LHSLR, ACTLR
      INTEGER VACTLR
      DIMENSION VOCLR ( 1041 )
      DIMENSION BVOCLR ( 167 )
      DIMENSION ENTLR ( 345 )
      DIMENSION REDLR ( 346 )
      DIMENSION FRDLR ( 346 )
      DIMENSION TRANLR ( 2912 )
      DIMENSION NLOKLR ( 366 )
      DIMENSION PRODLR ( 366 )
      DIMENSION LSETLR ( 92 , 87 )
      DIMENSION RHSLR ( 214 )
      DIMENSION LHSLR ( 214 )
      DIMENSION ACTLR ( 214 )
      DIMENSION VACTLR ( 87 )
      COMMON /G4LR1/ VOCLR
      COMMON /G4LR2/ BVOCLR, ENTLR, REDLR
      COMMON /G4LR2/ FRDLR,TRANLR,NLOKLR,PRODLR
      COMMON /G4LR2/ LSETLR, RHSLR, LHSLR, ACTLR
      COMMON /G4LR2/ VACTLR
      DATA BVOCLR ( 1 ) / 1 /
      DATA VOCLR ( 1 ) /'!'/
      DATA BVOCLR ( 2 ) / 2 /
      DATA VOCLR ( 2 ) /'&'/
      DATA BVOCLR ( 3 ) / 3 /
      DATA VOCLR ( 3 ) /'&'/,VOCLR ( 4 ) /'='/
      DATA BVOCLR ( 4 ) / 5 /
      DATA VOCLR ( 5 ) /'('/
      DATA BVOCLR ( 5 ) / 6 /
      DATA VOCLR ( 6 ) /')'/
      DATA BVOCLR ( 6 ) / 7 /
      DATA VOCLR ( 7 ) /'*'/
      DATA BVOCLR ( 7 ) / 8 /
      DATA VOCLR ( 8 ) /'*'/,VOCLR ( 9 ) /'*'/
      DATA BVOCLR ( 8 ) / 10 /
      DATA VOCLR ( 10 ) /'*'/,VOCLR ( 11 ) /'*'/,VOCLR ( 12 ) /'='/
      DATA BVOCLR ( 9 ) / 13 /
      DATA VOCLR ( 13 ) /'*'/,VOCLR ( 14 ) /'='/
      DATA BVOCLR ( 10 ) / 15 /
      DATA VOCLR ( 15 ) /'+'/
      DATA BVOCLR ( 11 ) / 16 /
      DATA VOCLR ( 16 ) /'+'/,VOCLR ( 17 ) /'='/
      DATA BVOCLR ( 12 ) / 18 /
      DATA VOCLR ( 18 ) /','/
      DATA BVOCLR ( 13 ) / 19 /
      DATA VOCLR ( 19 ) /'-'/
      DATA BVOCLR ( 14 ) / 20 /
      DATA VOCLR ( 20 ) /'-'/,VOCLR ( 21 ) /'='/
      DATA BVOCLR ( 15 ) / 22 /
      DATA VOCLR ( 22 ) /'.'/
      DATA BVOCLR ( 16 ) / 23 /
      DATA VOCLR ( 23 ) /'/'/
      DATA BVOCLR ( 17 ) / 24 /
      DATA VOCLR ( 24 ) /'/'/,VOCLR ( 25 ) /'='/
      DATA BVOCLR ( 18 ) / 26 /
      DATA VOCLR ( 26 ) /':'/
      DATA BVOCLR ( 19 ) / 27 /
      DATA VOCLR ( 27 ) /':'/,VOCLR ( 28 ) /'='/
      DATA BVOCLR ( 20 ) / 29 /
      DATA VOCLR ( 29 ) /'<'/
      DATA BVOCLR ( 21 ) / 30 /
      DATA VOCLR ( 30 ) /'<'/,VOCLR ( 31 ) /'<'/
      DATA BVOCLR ( 22 ) / 32 /
      DATA VOCLR ( 32 ) /'<'/,VOCLR ( 33 ) /'='/
      DATA BVOCLR ( 23 ) / 34 /
      DATA VOCLR ( 34 ) /'<'/,VOCLR ( 35 ) /'>'/
      DATA BVOCLR ( 24 ) / 36 /
      DATA VOCLR ( 36 ) /'='/
      DATA BVOCLR ( 25 ) / 37 /
      DATA VOCLR ( 37 ) /'='/,VOCLR ( 38 ) /'='/
      DATA BVOCLR ( 26 ) / 39 /
      DATA VOCLR ( 39 ) /'>'/
      DATA BVOCLR ( 27 ) / 40 /
      DATA VOCLR ( 40 ) /'>'/,VOCLR ( 41 ) /'='/
      DATA BVOCLR ( 28 ) / 42 /
      DATA VOCLR ( 42 ) /'>'/,VOCLR ( 43 ) /'>'/
      DATA BVOCLR ( 29 ) / 44 /
      DATA VOCLR ( 44 ) /'@'/
      DATA BVOCLR ( 30 ) / 45 /
      DATA VOCLR ( 45 ) /'E'/,VOCLR ( 46 ) /'N'/,VOCLR ( 47 ) /'D'/
      DATA BVOCLR ( 31 ) / 48 /
      DATA VOCLR ( 48 ) /'G'/,VOCLR ( 49 ) /'r'/,VOCLR ( 50 ) /'o'/,
     X VOCLR ( 51 ) /'u'/,VOCLR ( 52 ) /'p'/,VOCLR ( 53 ) /'n'/,
     X VOCLR ( 54 ) /'a'/,VOCLR ( 55 ) /'m'/,VOCLR ( 56 ) /'e'/
      DATA BVOCLR ( 32 ) / 57 /
      DATA VOCLR ( 57 ) /'['/
      DATA BVOCLR ( 33 ) / 58 /
      DATA VOCLR ( 58 ) /']'/
      DATA BVOCLR ( 34 ) / 59 /
      DATA VOCLR ( 59 ) /'^'/
      DATA BVOCLR ( 35 ) / 60 /
      DATA VOCLR ( 60 ) /'`'/
      DATA BVOCLR ( 36 ) / 61 /
      DATA VOCLR ( 61 ) /'a'/,VOCLR ( 62 ) /'d'/,VOCLR ( 63 ) /'d'/,
     X VOCLR ( 64 ) /'r'/,VOCLR ( 65 ) /'e'/,VOCLR ( 66 ) /'s'/,
     X VOCLR ( 67 ) /'s'/
      DATA BVOCLR ( 37 ) / 68 /
      DATA VOCLR ( 68 ) /'b'/,VOCLR ( 69 ) /'r'/,VOCLR ( 70 ) /'e'/,
     X VOCLR ( 71 ) /'a'/,VOCLR ( 72 ) /'k'/
      DATA BVOCLR ( 38 ) / 73 /
      DATA VOCLR ( 73 ) /'c'/,VOCLR ( 74 ) /'a'/,VOCLR ( 75 ) /'l'/,
     X VOCLR ( 76 ) /'l'/
      DATA BVOCLR ( 39 ) / 77 /
      DATA VOCLR ( 77 ) /'c'/,VOCLR ( 78 ) /'h'/,VOCLR ( 79 ) /'a'/,
     X VOCLR ( 80 ) /'m'/,VOCLR ( 81 ) /'e'/,VOCLR ( 82 ) /'l'/,
     X VOCLR ( 83 ) /'e'/,VOCLR ( 84 ) /'o'/,VOCLR ( 85 ) /'n'/
      DATA BVOCLR ( 40 ) / 86 /
      DATA VOCLR ( 86 ) /'c'/,VOCLR ( 87 ) /'h'/,VOCLR ( 88 ) /'a'/,
     X VOCLR ( 89 ) /'r'/,VOCLR ( 90 ) /'a'/,VOCLR ( 91 ) /'c'/,
     X VOCLR ( 92 ) /'t'/,VOCLR ( 93 ) /'e'/,VOCLR ( 94 ) /'r'/
      DATA BVOCLR ( 41 ) / 95 /
      DATA VOCLR ( 95 ) /'c'/,VOCLR ( 96 ) /'o'/,VOCLR ( 97 ) /'m'/,
     X VOCLR ( 98 ) /'m'/,VOCLR ( 99 ) /'a'/,VOCLR ( 100 ) /'n'/,
     X VOCLR ( 101 ) /'d'/
      DATA BVOCLR ( 42 ) / 102 /
      DATA VOCLR ( 102 ) /'c'/,VOCLR ( 103 ) /'o'/,VOCLR ( 104 ) /'m'/,
     X VOCLR ( 105 ) /'p'/,VOCLR ( 106 ) /'l'/,VOCLR ( 107 ) /'e'/,
     X VOCLR ( 108 ) /'x'/
      DATA BVOCLR ( 43 ) / 109 /
      DATA VOCLR ( 109 ) /'c'/,VOCLR ( 110 ) /'o'/,VOCLR ( 111 ) /'m'/,
     X VOCLR ( 112 ) /'p'/,VOCLR ( 113 ) /'l'/,VOCLR ( 114 ) /'e'/,
     X VOCLR ( 115 ) /'x'/,VOCLR ( 116 ) /'-'/,VOCLR ( 117 ) /'c'/,
     X VOCLR ( 118 ) /'o'/,VOCLR ( 119 ) /'n'/,VOCLR ( 120 ) /'s'/,
     X VOCLR ( 121 ) /'t'/,VOCLR ( 122 ) /'a'/,VOCLR ( 123 ) /'n'/,
     X VOCLR ( 124 ) /'t'/
      DATA BVOCLR ( 44 ) / 125 /
      DATA VOCLR ( 125 ) /'c'/,VOCLR ( 126 ) /'o'/,VOCLR ( 127 ) /'m'/,
     X VOCLR ( 128 ) /'p'/,VOCLR ( 129 ) /'l'/,VOCLR ( 130 ) /'e'/,
     X VOCLR ( 131 ) /'x'/,VOCLR ( 132 ) /'8'/
      DATA BVOCLR ( 45 ) / 133 /
      DATA VOCLR ( 133 ) /'c'/,VOCLR ( 134 ) /'r'/
      DATA BVOCLR ( 46 ) / 135 /
      DATA VOCLR ( 135 ) /'d'/,VOCLR ( 136 ) /'o'/
      DATA BVOCLR ( 47 ) / 137 /
      DATA VOCLR ( 137 ) /'d'/,VOCLR ( 138 ) /'o'/,VOCLR ( 139 ) /'u'/,
     X VOCLR ( 140 ) /'b'/,VOCLR ( 141 ) /'l'/,VOCLR ( 142 ) /'e'/
      DATA BVOCLR ( 48 ) / 143 /
      DATA VOCLR ( 143 ) /'d'/,VOCLR ( 144 ) /'o'/,VOCLR ( 145 ) /'u'/,
     X VOCLR ( 146 ) /'b'/,VOCLR ( 147 ) /'l'/,VOCLR ( 148 ) /'e'/,
     X VOCLR ( 149 ) /'-'/,VOCLR ( 150 ) /'c'/,VOCLR ( 151 ) /'o'/,
     X VOCLR ( 152 ) /'m'/,VOCLR ( 153 ) /'p'/,VOCLR ( 154 ) /'l'/,
     X VOCLR ( 155 ) /'e'/,VOCLR ( 156 ) /'x'/,VOCLR ( 157 ) /'-'/,
     X VOCLR ( 158 ) /'c'/,VOCLR ( 159 ) /'o'/,VOCLR ( 160 ) /'n'/,
     X VOCLR ( 161 ) /'s'/,VOCLR ( 162 ) /'t'/,VOCLR ( 163 ) /'a'/,
     X VOCLR ( 164 ) /'n'/,VOCLR ( 165 ) /'t'/
      DATA BVOCLR ( 49 ) / 166 /
      DATA VOCLR ( 166 ) /'d'/,VOCLR ( 167 ) /'o'/,VOCLR ( 168 ) /'u'/,
     X VOCLR ( 169 ) /'b'/,VOCLR ( 170 ) /'l'/,VOCLR ( 171 ) /'e'/,
     X VOCLR ( 172 ) /'-'/,VOCLR ( 173 ) /'c'/,VOCLR ( 174 ) /'o'/,
     X VOCLR ( 175 ) /'n'/,VOCLR ( 176 ) /'s'/,VOCLR ( 177 ) /'t'/,
     X VOCLR ( 178 ) /'a'/,VOCLR ( 179 ) /'n'/,VOCLR ( 180 ) /'t'/
      DATA BVOCLR ( 50 ) / 181 /
      DATA VOCLR ( 181 ) /'e'/,VOCLR ( 182 ) /'l'/,VOCLR ( 183 ) /'s'/,
     X VOCLR ( 184 ) /'e'/
      DATA BVOCLR ( 51 ) / 185 /
      DATA VOCLR ( 185 ) /'e'/,VOCLR ( 186 ) /'l'/,VOCLR ( 187 ) /'s'/,
     X VOCLR ( 188 ) /'e'/,VOCLR ( 189 ) /'i'/,VOCLR ( 190 ) /'f'/
      DATA BVOCLR ( 52 ) / 191 /
      DATA VOCLR ( 191 ) /'e'/,VOCLR ( 192 ) /'n'/,VOCLR ( 193 ) /'d'/,
     X VOCLR ( 194 ) /'d'/,VOCLR ( 195 ) /'o'/
      DATA BVOCLR ( 53 ) / 196 /
      DATA VOCLR ( 196 ) /'e'/,VOCLR ( 197 ) /'n'/,VOCLR ( 198 ) /'d'/,
     X VOCLR ( 199 ) /'f'/
      DATA BVOCLR ( 54 ) / 200 /
      DATA VOCLR ( 200 ) /'e'/,VOCLR ( 201 ) /'n'/,VOCLR ( 202 ) /'d'/,
     X VOCLR ( 203 ) /'f'/,VOCLR ( 204 ) /'o'/,VOCLR ( 205 ) /'r'/
      DATA BVOCLR ( 55 ) / 206 /
      DATA VOCLR ( 206 ) /'e'/,VOCLR ( 207 ) /'n'/,VOCLR ( 208 ) /'d'/,
     X VOCLR ( 209 ) /'i'/,VOCLR ( 210 ) /'f'/
      DATA BVOCLR ( 56 ) / 211 /
      DATA VOCLR ( 211 ) /'e'/,VOCLR ( 212 ) /'n'/,VOCLR ( 213 ) /'d'/,
     X VOCLR ( 214 ) /'w'/,VOCLR ( 215 ) /'h'/,VOCLR ( 216 ) /'i'/,
     X VOCLR ( 217 ) /'l'/,VOCLR ( 218 ) /'e'/
      DATA BVOCLR ( 57 ) / 219 /
      DATA VOCLR ( 219 ) /'f'/,VOCLR ( 220 ) /'c'/,VOCLR ( 221 ) /'o'/,
     X VOCLR ( 222 ) /'m'/,VOCLR ( 223 ) /'s'/,VOCLR ( 224 ) /'t'/,
     X VOCLR ( 225 ) /'r'/
      DATA BVOCLR ( 58 ) / 226 /
      DATA VOCLR ( 226 ) /'f'/,VOCLR ( 227 ) /'o'/,VOCLR ( 228 ) /'r'/
      DATA BVOCLR ( 59 ) / 229 /
      DATA VOCLR ( 229 ) /'f'/,VOCLR ( 230 ) /'o'/,VOCLR ( 231 ) /'r'/,
     X VOCLR ( 232 ) /'g'/,VOCLR ( 233 ) /'e'/,VOCLR ( 234 ) /'t'/
      DATA BVOCLR ( 60 ) / 235 /
      DATA VOCLR ( 235 ) /'f'/,VOCLR ( 236 ) /'u'/,VOCLR ( 237 ) /'n'/,
     X VOCLR ( 238 ) /'c'/,VOCLR ( 239 ) /'t'/,VOCLR ( 240 ) /'i'/,
     X VOCLR ( 241 ) /'o'/,VOCLR ( 242 ) /'n'/
      DATA BVOCLR ( 61 ) / 243 /
      DATA VOCLR ( 243 ) /'h'/,VOCLR ( 244 ) /'e'/,VOCLR ( 245 ) /'x'/,
     X VOCLR ( 246 ) /'-'/,VOCLR ( 247 ) /'c'/,VOCLR ( 248 ) /'o'/,
     X VOCLR ( 249 ) /'n'/,VOCLR ( 250 ) /'s'/,VOCLR ( 251 ) /'t'/,
     X VOCLR ( 252 ) /'a'/,VOCLR ( 253 ) /'n'/,VOCLR ( 254 ) /'t'/
      DATA BVOCLR ( 62 ) / 255 /
      DATA VOCLR ( 255 ) /'i'/,VOCLR ( 256 ) /'f'/
      DATA BVOCLR ( 63 ) / 257 /
      DATA VOCLR ( 257 ) /'i'/,VOCLR ( 258 ) /'n'/,VOCLR ( 259 ) /'d'/,
     X VOCLR ( 260 ) /'i'/,VOCLR ( 261 ) /'r'/,VOCLR ( 262 ) /'e'/,
     X VOCLR ( 263 ) /'c'/,VOCLR ( 264 ) /'t'/
      DATA BVOCLR ( 64 ) / 265 /
      DATA VOCLR ( 265 ) /'i'/,VOCLR ( 266 ) /'n'/,VOCLR ( 267 ) /'t'/,
     X VOCLR ( 268 ) /'e'/,VOCLR ( 269 ) /'g'/,VOCLR ( 270 ) /'e'/,
     X VOCLR ( 271 ) /'r'/
      DATA BVOCLR ( 65 ) / 272 /
      DATA VOCLR ( 272 ) /'i'/,VOCLR ( 273 ) /'n'/,VOCLR ( 274 ) /'t'/,
     X VOCLR ( 275 ) /'e'/,VOCLR ( 276 ) /'g'/,VOCLR ( 277 ) /'e'/,
     X VOCLR ( 278 ) /'r'/,VOCLR ( 279 ) /'-'/,VOCLR ( 280 ) /'c'/,
     X VOCLR ( 281 ) /'o'/,VOCLR ( 282 ) /'n'/,VOCLR ( 283 ) /'s'/,
     X VOCLR ( 284 ) /'t'/,VOCLR ( 285 ) /'a'/,VOCLR ( 286 ) /'n'/,
     X VOCLR ( 287 ) /'t'/
      DATA BVOCLR ( 66 ) / 288 /
      DATA VOCLR ( 288 ) /'l'/,VOCLR ( 289 ) /'i'/,VOCLR ( 290 ) /'s'/,
     X VOCLR ( 291 ) /'t'/
      DATA BVOCLR ( 67 ) / 292 /
      DATA VOCLR ( 292 ) /'l'/,VOCLR ( 293 ) /'o'/,VOCLR ( 294 ) /'g'/,
     X VOCLR ( 295 ) /'i'/,VOCLR ( 296 ) /'c'/,VOCLR ( 297 ) /'a'/,
     X VOCLR ( 298 ) /'l'/
      DATA BVOCLR ( 68 ) / 299 /
      DATA VOCLR ( 299 ) /'n'/,VOCLR ( 300 ) /'a'/,VOCLR ( 301 ) /'m'/,
     X VOCLR ( 302 ) /'e'/
      DATA BVOCLR ( 69 ) / 303 /
      DATA VOCLR ( 303 ) /'n'/,VOCLR ( 304 ) /'e'/,VOCLR ( 305 ) /'x'/,
     X VOCLR ( 306 ) /'t'/
      DATA BVOCLR ( 70 ) / 307 /
      DATA VOCLR ( 307 ) /'o'/,VOCLR ( 308 ) /'c'/,VOCLR ( 309 ) /'t'/,
     X VOCLR ( 310 ) /'a'/,VOCLR ( 311 ) /'l'/,VOCLR ( 312 ) /'-'/,
     X VOCLR ( 313 ) /'c'/,VOCLR ( 314 ) /'o'/,VOCLR ( 315 ) /'n'/,
     X VOCLR ( 316 ) /'s'/,VOCLR ( 317 ) /'t'/,VOCLR ( 318 ) /'a'/,
     X VOCLR ( 319 ) /'n'/,VOCLR ( 320 ) /'t'/
      DATA BVOCLR ( 71 ) / 321 /
      DATA VOCLR ( 321 ) /'r'/,VOCLR ( 322 ) /'a'/,VOCLR ( 323 ) /'n'/,
     X VOCLR ( 324 ) /'g'/,VOCLR ( 325 ) /'e'/
      DATA BVOCLR ( 72 ) / 326 /
      DATA VOCLR ( 326 ) /'r'/,VOCLR ( 327 ) /'e'/,VOCLR ( 328 ) /'a'/,
     X VOCLR ( 329 ) /'d'/
      DATA BVOCLR ( 73 ) / 330 /
      DATA VOCLR ( 330 ) /'r'/,VOCLR ( 331 ) /'e'/,VOCLR ( 332 ) /'a'/,
     X VOCLR ( 333 ) /'l'/
      DATA BVOCLR ( 74 ) / 334 /
      DATA VOCLR ( 334 ) /'r'/,VOCLR ( 335 ) /'e'/,VOCLR ( 336 ) /'a'/,
     X VOCLR ( 337 ) /'l'/,VOCLR ( 338 ) /'-'/,VOCLR ( 339 ) /'c'/,
     X VOCLR ( 340 ) /'o'/,VOCLR ( 341 ) /'n'/,VOCLR ( 342 ) /'s'/,
     X VOCLR ( 343 ) /'t'/,VOCLR ( 344 ) /'a'/,VOCLR ( 345 ) /'n'/,
     X VOCLR ( 346 ) /'t'/
      DATA BVOCLR ( 75 ) / 347 /
      DATA VOCLR ( 347 ) /'r'/,VOCLR ( 348 ) /'e'/,VOCLR ( 349 ) /'a'/,
     X VOCLR ( 350 ) /'l'/,VOCLR ( 351 ) /'8'/
      DATA BVOCLR ( 76 ) / 352 /
      DATA VOCLR ( 352 ) /'r'/,VOCLR ( 353 ) /'e'/,VOCLR ( 354 ) /'t'/,
     X VOCLR ( 355 ) /'u'/,VOCLR ( 356 ) /'r'/,VOCLR ( 357 ) /'n'/
      DATA BVOCLR ( 77 ) / 358 /
      DATA VOCLR ( 358 ) /'s'/,VOCLR ( 359 ) /'t'/,VOCLR ( 360 ) /'r'/,
     X VOCLR ( 361 ) /'i'/,VOCLR ( 362 ) /'n'/,VOCLR ( 363 ) /'g'/
      DATA BVOCLR ( 78 ) / 364 /
      DATA VOCLR ( 364 ) /'t'/,VOCLR ( 365 ) /'h'/,VOCLR ( 366 ) /'e'/,
     X VOCLR ( 367 ) /'n'/
      DATA BVOCLR ( 79 ) / 368 /
      DATA VOCLR ( 368 ) /'u'/,VOCLR ( 369 ) /'n'/,VOCLR ( 370 ) /'t'/,
     X VOCLR ( 371 ) /'i'/,VOCLR ( 372 ) /'l'/
      DATA BVOCLR ( 80 ) / 373 /
      DATA VOCLR ( 373 ) /'w'/,VOCLR ( 374 ) /'h'/,VOCLR ( 375 ) /'i'/,
     X VOCLR ( 376 ) /'l'/,VOCLR ( 377 ) /'e'/
      DATA BVOCLR ( 81 ) / 378 /
      DATA VOCLR ( 378 ) /'w'/,VOCLR ( 379 ) /'h'/,VOCLR ( 380 ) /'i'/,
     X VOCLR ( 381 ) /'t'/,VOCLR ( 382 ) /'e'/,VOCLR ( 383 ) /'s'/,
     X VOCLR ( 384 ) /'p'/,VOCLR ( 385 ) /'a'/,VOCLR ( 386 ) /'c'/,
     X VOCLR ( 387 ) /'e'/
      DATA BVOCLR ( 82 ) / 388 /
      DATA VOCLR ( 388 ) /'{'/
      DATA BVOCLR ( 83 ) / 389 /
      DATA VOCLR ( 389 ) /'|'/
      DATA BVOCLR ( 84 ) / 390 /
      DATA VOCLR ( 390 ) /'|'/,VOCLR ( 391 ) /'='/
      DATA BVOCLR ( 85 ) / 392 /
      DATA VOCLR ( 392 ) /'}'/
      DATA BVOCLR ( 86 ) / 393 /
      DATA VOCLR ( 393 ) /'~'/
      DATA BVOCLR ( 87 ) / 394 /
      DATA VOCLR ( 394 ) /'~'/,VOCLR ( 395 ) /'='/
      DATA BVOCLR ( 88 ) / 396 /
      DATA VOCLR ( 396 ) /'<'/,VOCLR ( 397 ) /'$'/,VOCLR ( 398 ) /'>'/
      DATA BVOCLR ( 89 ) / 399 /
      DATA VOCLR ( 399 ) /'<'/,VOCLR ( 400 ) /'a'/,VOCLR ( 401 ) /'l'/,
     X VOCLR ( 402 ) /'t'/,VOCLR ( 403 ) /'2'/,VOCLR ( 404 ) /'>'/
      DATA BVOCLR ( 90 ) / 405 /
      DATA VOCLR ( 405 ) /'<'/,VOCLR ( 406 ) /'a'/,VOCLR ( 407 ) /'p'/,
     X VOCLR ( 408 ) /'p'/,VOCLR ( 409 ) /'e'/,VOCLR ( 410 ) /'n'/,
     X VOCLR ( 411 ) /'d'/,VOCLR ( 412 ) /'='/,VOCLR ( 413 ) /'>'/
      DATA BVOCLR ( 91 ) / 414 /
      DATA VOCLR ( 414 ) /'<'/,VOCLR ( 415 ) /'a'/,VOCLR ( 416 ) /'p'/,
     X VOCLR ( 417 ) /'p'/,VOCLR ( 418 ) /'e'/,VOCLR ( 419 ) /'n'/,
     X VOCLR ( 420 ) /'d'/,VOCLR ( 421 ) /'>'/
      DATA BVOCLR ( 92 ) / 422 /
      DATA VOCLR ( 422 ) /'<'/,VOCLR ( 423 ) /'a'/,VOCLR ( 424 ) /'r'/,
     X VOCLR ( 425 ) /'g'/,VOCLR ( 426 ) /'i'/,VOCLR ( 427 ) /'t'/,
     X VOCLR ( 428 ) /'e'/,VOCLR ( 429 ) /'m'/,VOCLR ( 430 ) /'>'/
      DATA BVOCLR ( 93 ) / 431 /
      DATA VOCLR ( 431 ) /'<'/,VOCLR ( 432 ) /'a'/,VOCLR ( 433 ) /'r'/,
     X VOCLR ( 434 ) /'g'/,VOCLR ( 435 ) /'l'/,VOCLR ( 436 ) /'i'/,
     X VOCLR ( 437 ) /'s'/,VOCLR ( 438 ) /'t'/,VOCLR ( 439 ) /'>'/
      DATA BVOCLR ( 94 ) / 440 /
      DATA VOCLR ( 440 ) /'<'/,VOCLR ( 441 ) /'a'/,VOCLR ( 442 ) /'r'/,
     X VOCLR ( 443 ) /'g'/,VOCLR ( 444 ) /'s'/,VOCLR ( 445 ) /'>'/
      DATA BVOCLR ( 95 ) / 446 /
      DATA VOCLR ( 446 ) /'<'/,VOCLR ( 447 ) /'a'/,VOCLR ( 448 ) /'s'/,
     X VOCLR ( 449 ) /'s'/,VOCLR ( 450 ) /'i'/,VOCLR ( 451 ) /'g'/,
     X VOCLR ( 452 ) /'n'/,VOCLR ( 453 ) /'='/,VOCLR ( 454 ) /'>'/
      DATA BVOCLR ( 96 ) / 455 /
      DATA VOCLR ( 455 ) /'<'/,VOCLR ( 456 ) /'a'/,VOCLR ( 457 ) /'s'/,
     X VOCLR ( 458 ) /'s'/,VOCLR ( 459 ) /'i'/,VOCLR ( 460 ) /'g'/,
     X VOCLR ( 461 ) /'n'/,VOCLR ( 462 ) /'>'/
      DATA BVOCLR ( 97 ) / 463 /
      DATA VOCLR ( 463 ) /'<'/,VOCLR ( 464 ) /'a'/,VOCLR ( 465 ) /'s'/,
     X VOCLR ( 466 ) /'s'/,VOCLR ( 467 ) /'i'/,VOCLR ( 468 ) /'g'/,
     X VOCLR ( 469 ) /'n'/,VOCLR ( 470 ) /'l'/,VOCLR ( 471 ) /'i'/,
     X VOCLR ( 472 ) /'s'/,VOCLR ( 473 ) /'t'/,VOCLR ( 474 ) /'>'/
      DATA BVOCLR ( 98 ) / 475 /
      DATA VOCLR ( 475 ) /'<'/,VOCLR ( 476 ) /'c'/,VOCLR ( 477 ) /'o'/,
     X VOCLR ( 478 ) /'m'/,VOCLR ( 479 ) /'i'/,VOCLR ( 480 ) /'t'/,
     X VOCLR ( 481 ) /'e'/,VOCLR ( 482 ) /'m'/,VOCLR ( 483 ) /'>'/
      DATA BVOCLR ( 99 ) / 484 /
      DATA VOCLR ( 484 ) /'<'/,VOCLR ( 485 ) /'c'/,VOCLR ( 486 ) /'o'/,
     X VOCLR ( 487 ) /'m'/,VOCLR ( 488 ) /'l'/,VOCLR ( 489 ) /'i'/,
     X VOCLR ( 490 ) /'s'/,VOCLR ( 491 ) /'t'/,VOCLR ( 492 ) /'>'/
      DATA BVOCLR ( 100 ) / 493 /
      DATA VOCLR ( 493 ) /'<'/,VOCLR ( 494 ) /'c'/,VOCLR ( 495 ) /'o'/,
     X VOCLR ( 496 ) /'n'/,VOCLR ( 497 ) /'s'/,VOCLR ( 498 ) /'t'/,
     X VOCLR ( 499 ) /'a'/,VOCLR ( 500 ) /'n'/,VOCLR ( 501 ) /'t'/,
     X VOCLR ( 502 ) /'>'/
      DATA BVOCLR ( 101 ) / 503 /
      DATA VOCLR ( 503 ) /'<'/,VOCLR ( 504 ) /'c'/,VOCLR ( 505 ) /'s'/,
     X VOCLR ( 506 ) /'t'/,VOCLR ( 507 ) /'m'/,VOCLR ( 508 ) /'t'/,
     X VOCLR ( 509 ) /'>'/
      DATA BVOCLR ( 102 ) / 510 /
      DATA VOCLR ( 510 ) /'<'/,VOCLR ( 511 ) /'d'/,VOCLR ( 512 ) /'e'/,
     X VOCLR ( 513 ) /'x'/,VOCLR ( 514 ) /'p'/,VOCLR ( 515 ) /'>'/
      DATA BVOCLR ( 103 ) / 516 /
      DATA VOCLR ( 516 ) /'<'/,VOCLR ( 517 ) /'d'/,VOCLR ( 518 ) /'i'/,
     X VOCLR ( 519 ) /'s'/,VOCLR ( 520 ) /'p'/,VOCLR ( 521 ) /'l'/,
     X VOCLR ( 522 ) /'a'/,VOCLR ( 523 ) /'y'/,VOCLR ( 524 ) /'>'/
      DATA BVOCLR ( 104 ) / 525 /
      DATA VOCLR ( 525 ) /'<'/,VOCLR ( 526 ) /'d'/,VOCLR ( 527 ) /'i'/,
     X VOCLR ( 528 ) /'t'/,VOCLR ( 529 ) /'e'/,VOCLR ( 530 ) /'m'/,
     X VOCLR ( 531 ) /'>'/
      DATA BVOCLR ( 105 ) / 532 /
      DATA VOCLR ( 532 ) /'<'/,VOCLR ( 533 ) /'d'/,VOCLR ( 534 ) /'n'/,
     X VOCLR ( 535 ) /'a'/,VOCLR ( 536 ) /'m'/,VOCLR ( 537 ) /'e'/,
     X VOCLR ( 538 ) /'>'/
      DATA BVOCLR ( 106 ) / 539 /
      DATA VOCLR ( 539 ) /'<'/,VOCLR ( 540 ) /'d'/,VOCLR ( 541 ) /'o'/,
     X VOCLR ( 542 ) /'c'/,VOCLR ( 543 ) /'o'/,VOCLR ( 544 ) /'n'/,
     X VOCLR ( 545 ) /'t'/,VOCLR ( 546 ) /'r'/,VOCLR ( 547 ) /'o'/,
     X VOCLR ( 548 ) /'l'/,VOCLR ( 549 ) /'>'/
      DATA BVOCLR ( 107 ) / 550 /
      DATA VOCLR ( 550 ) /'<'/,VOCLR ( 551 ) /'d'/,VOCLR ( 552 ) /'o'/,
     X VOCLR ( 553 ) /'s'/,VOCLR ( 554 ) /'p'/,VOCLR ( 555 ) /'e'/,
     X VOCLR ( 556 ) /'c'/,VOCLR ( 557 ) /'>'/
      DATA BVOCLR ( 108 ) / 558 /
      DATA VOCLR ( 558 ) /'<'/,VOCLR ( 559 ) /'d'/,VOCLR ( 560 ) /'o'/,
     X VOCLR ( 561 ) /'s'/,VOCLR ( 562 ) /'t'/,VOCLR ( 563 ) /'m'/,
     X VOCLR ( 564 ) /'t'/,VOCLR ( 565 ) /'>'/
      DATA BVOCLR ( 109 ) / 566 /
      DATA VOCLR ( 566 ) /'<'/,VOCLR ( 567 ) /'d'/,VOCLR ( 568 ) /'v'/,
     X VOCLR ( 569 ) /'a'/,VOCLR ( 570 ) /'r'/,VOCLR ( 571 ) /'>'/
      DATA BVOCLR ( 110 ) / 572 /
      DATA VOCLR ( 572 ) /'<'/,VOCLR ( 573 ) /'e'/,VOCLR ( 574 ) /'o'/,
     X VOCLR ( 575 ) /'s'/,VOCLR ( 576 ) /'>'/
      DATA BVOCLR ( 111 ) / 577 /
      DATA VOCLR ( 577 ) /'<'/,VOCLR ( 578 ) /'e'/,VOCLR ( 579 ) /'x'/,
     X VOCLR ( 580 ) /'p'/,VOCLR ( 581 ) /'>'/
      DATA BVOCLR ( 112 ) / 582 /
      DATA VOCLR ( 582 ) /'<'/,VOCLR ( 583 ) /'e'/,VOCLR ( 584 ) /'x'/,
     X VOCLR ( 585 ) /'p'/,VOCLR ( 586 ) /'l'/,VOCLR ( 587 ) /'i'/,
     X VOCLR ( 588 ) /'s'/,VOCLR ( 589 ) /'t'/,VOCLR ( 590 ) /'>'/
      DATA BVOCLR ( 113 ) / 591 /
      DATA VOCLR ( 591 ) /'<'/,VOCLR ( 592 ) /'f'/,VOCLR ( 593 ) /'a'/,
     X VOCLR ( 594 ) /'c'/,VOCLR ( 595 ) /'t'/,VOCLR ( 596 ) /'o'/,
     X VOCLR ( 597 ) /'r'/,VOCLR ( 598 ) /'>'/
      DATA BVOCLR ( 114 ) / 599 /
      DATA VOCLR ( 599 ) /'<'/,VOCLR ( 600 ) /'f'/,VOCLR ( 601 ) /'i'/,
     X VOCLR ( 602 ) /'l'/,VOCLR ( 603 ) /'e'/,VOCLR ( 604 ) /'n'/,
     X VOCLR ( 605 ) /'a'/,VOCLR ( 606 ) /'m'/,VOCLR ( 607 ) /'e'/,
     X VOCLR ( 608 ) /'>'/
      DATA BVOCLR ( 115 ) / 609 /
      DATA VOCLR ( 609 ) /'<'/,VOCLR ( 610 ) /'f'/,VOCLR ( 611 ) /'i'/,
     X VOCLR ( 612 ) /'r'/,VOCLR ( 613 ) /'s'/,VOCLR ( 614 ) /'t'/,
     X VOCLR ( 615 ) /'>'/
      DATA BVOCLR ( 116 ) / 616 /
      DATA VOCLR ( 616 ) /'<'/,VOCLR ( 617 ) /'f'/,VOCLR ( 618 ) /'o'/,
     X VOCLR ( 619 ) /'r'/,VOCLR ( 620 ) /'g'/,VOCLR ( 621 ) /'e'/,
     X VOCLR ( 622 ) /'t'/,VOCLR ( 623 ) /'l'/,VOCLR ( 624 ) /'i'/,
     X VOCLR ( 625 ) /'s'/,VOCLR ( 626 ) /'t'/,VOCLR ( 627 ) /'>'/
      DATA BVOCLR ( 117 ) / 628 /
      DATA VOCLR ( 628 ) /'<'/,VOCLR ( 629 ) /'f'/,VOCLR ( 630 ) /'o'/,
     X VOCLR ( 631 ) /'r'/,VOCLR ( 632 ) /'i'/,VOCLR ( 633 ) /'n'/,
     X VOCLR ( 634 ) /'i'/,VOCLR ( 635 ) /'t'/,VOCLR ( 636 ) /'>'/
      DATA BVOCLR ( 118 ) / 637 /
      DATA VOCLR ( 637 ) /'<'/,VOCLR ( 638 ) /'f'/,VOCLR ( 639 ) /'o'/,
     X VOCLR ( 640 ) /'r'/,VOCLR ( 641 ) /'o'/,VOCLR ( 642 ) /'u'/,
     X VOCLR ( 643 ) /'t'/,VOCLR ( 644 ) /'>'/
      DATA BVOCLR ( 119 ) / 645 /
      DATA VOCLR ( 645 ) /'<'/,VOCLR ( 646 ) /'f'/,VOCLR ( 647 ) /'o'/,
     X VOCLR ( 648 ) /'r'/,VOCLR ( 649 ) /'s'/,VOCLR ( 650 ) /'t'/,
     X VOCLR ( 651 ) /'m'/,VOCLR ( 652 ) /'t'/,VOCLR ( 653 ) /'>'/
      DATA BVOCLR ( 120 ) / 654 /
      DATA VOCLR ( 654 ) /'<'/,VOCLR ( 655 ) /'f'/,VOCLR ( 656 ) /'u'/,
     X VOCLR ( 657 ) /'n'/,VOCLR ( 658 ) /'c'/,VOCLR ( 659 ) /'d'/,
     X VOCLR ( 660 ) /'e'/,VOCLR ( 661 ) /'s'/,VOCLR ( 662 ) /'>'/
      DATA BVOCLR ( 121 ) / 663 /
      DATA VOCLR ( 663 ) /'<'/,VOCLR ( 664 ) /'f'/,VOCLR ( 665 ) /'u'/,
     X VOCLR ( 666 ) /'n'/,VOCLR ( 667 ) /'c'/,VOCLR ( 668 ) /'s'/,
     X VOCLR ( 669 ) /'p'/,VOCLR ( 670 ) /'e'/,VOCLR ( 671 ) /'c'/,
     X VOCLR ( 672 ) /'>'/
      DATA BVOCLR ( 122 ) / 673 /
      DATA VOCLR ( 673 ) /'<'/,VOCLR ( 674 ) /'g'/,VOCLR ( 675 ) /'r'/,
     X VOCLR ( 676 ) /'o'/,VOCLR ( 677 ) /'u'/,VOCLR ( 678 ) /'p'/,
     X VOCLR ( 679 ) /'>'/
      DATA BVOCLR ( 123 ) / 680 /
      DATA VOCLR ( 680 ) /'<'/,VOCLR ( 681 ) /'i'/,VOCLR ( 682 ) /'d'/,
     X VOCLR ( 683 ) /'>'/
      DATA BVOCLR ( 124 ) / 684 /
      DATA VOCLR ( 684 ) /'<'/,VOCLR ( 685 ) /'i'/,VOCLR ( 686 ) /'f'/,
     X VOCLR ( 687 ) /'e'/,VOCLR ( 688 ) /'x'/,VOCLR ( 689 ) /'p'/,
     X VOCLR ( 690 ) /'>'/
      DATA BVOCLR ( 125 ) / 691 /
      DATA VOCLR ( 691 ) /'<'/,VOCLR ( 692 ) /'i'/,VOCLR ( 693 ) /'f'/,
     X VOCLR ( 694 ) /'s'/,VOCLR ( 695 ) /'t'/,VOCLR ( 696 ) /'m'/,
     X VOCLR ( 697 ) /'t'/,VOCLR ( 698 ) /'>'/
      DATA BVOCLR ( 126 ) / 699 /
      DATA VOCLR ( 699 ) /'<'/,VOCLR ( 700 ) /'i'/,VOCLR ( 701 ) /'n'/,
     X VOCLR ( 702 ) /'c'/,VOCLR ( 703 ) /'r'/,VOCLR ( 704 ) /'>'/
      DATA BVOCLR ( 127 ) / 705 /
      DATA VOCLR ( 705 ) /'<'/,VOCLR ( 706 ) /'i'/,VOCLR ( 707 ) /'n'/,
     X VOCLR ( 708 ) /'d'/,VOCLR ( 709 ) /'e'/,VOCLR ( 710 ) /'v'/,
     X VOCLR ( 711 ) /'i'/,VOCLR ( 712 ) /'c'/,VOCLR ( 713 ) /'e'/,
     X VOCLR ( 714 ) /'>'/
      DATA BVOCLR ( 128 ) / 715 /
      DATA VOCLR ( 715 ) /'<'/,VOCLR ( 716 ) /'i'/,VOCLR ( 717 ) /'n'/,
     X VOCLR ( 718 ) /'l'/,VOCLR ( 719 ) /'i'/,VOCLR ( 720 ) /'s'/,
     X VOCLR ( 721 ) /'t'/,VOCLR ( 722 ) /'>'/
      DATA BVOCLR ( 129 ) / 723 /
      DATA VOCLR ( 723 ) /'<'/,VOCLR ( 724 ) /'l'/,VOCLR ( 725 ) /'a'/,
     X VOCLR ( 726 ) /'l'/,VOCLR ( 727 ) /'t'/,VOCLR ( 728 ) /'>'/
      DATA BVOCLR ( 130 ) / 729 /
      DATA VOCLR ( 729 ) /'<'/,VOCLR ( 730 ) /'l'/,VOCLR ( 731 ) /'a'/,
     X VOCLR ( 732 ) /'s'/,VOCLR ( 733 ) /'t'/,VOCLR ( 734 ) /'>'/
      DATA BVOCLR ( 131 ) / 735 /
      DATA VOCLR ( 735 ) /'<'/,VOCLR ( 736 ) /'l'/,VOCLR ( 737 ) /'e'/,
     X VOCLR ( 738 ) /'v'/,VOCLR ( 739 ) /'e'/,VOCLR ( 740 ) /'l'/,
     X VOCLR ( 741 ) /'>'/
      DATA BVOCLR ( 132 ) / 742 /
      DATA VOCLR ( 742 ) /'<'/,VOCLR ( 743 ) /'l'/,VOCLR ( 744 ) /'e'/,
     X VOCLR ( 745 ) /'x'/,VOCLR ( 746 ) /'p'/,VOCLR ( 747 ) /'>'/
      DATA BVOCLR ( 133 ) / 748 /
      DATA VOCLR ( 748 ) /'<'/,VOCLR ( 749 ) /'l'/,VOCLR ( 750 ) /'f'/,
     X VOCLR ( 751 ) /'a'/,VOCLR ( 752 ) /'c'/,VOCLR ( 753 ) /'t'/,
     X VOCLR ( 754 ) /'o'/,VOCLR ( 755 ) /'r'/,VOCLR ( 756 ) /'>'/
      DATA BVOCLR ( 134 ) / 757 /
      DATA VOCLR ( 757 ) /'<'/,VOCLR ( 758 ) /'l'/,VOCLR ( 759 ) /'h'/,
     X VOCLR ( 760 ) /'s'/,VOCLR ( 761 ) /'>'/
      DATA BVOCLR ( 135 ) / 762 /
      DATA VOCLR ( 762 ) /'<'/,VOCLR ( 763 ) /'l'/,VOCLR ( 764 ) /'i'/,
     X VOCLR ( 765 ) /'s'/,VOCLR ( 766 ) /'t'/,VOCLR ( 767 ) /'>'/
      DATA BVOCLR ( 136 ) / 768 /
      DATA VOCLR ( 768 ) /'<'/,VOCLR ( 769 ) /'l'/,VOCLR ( 770 ) /'i'/,
     X VOCLR ( 771 ) /'s'/,VOCLR ( 772 ) /'t'/,VOCLR ( 773 ) /'e'/,
     X VOCLR ( 774 ) /'l'/,VOCLR ( 775 ) /'t'/,VOCLR ( 776 ) /'>'/
      DATA BVOCLR ( 137 ) / 777 /
      DATA VOCLR ( 777 ) /'<'/,VOCLR ( 778 ) /'l'/,VOCLR ( 779 ) /'i'/,
     X VOCLR ( 780 ) /'s'/,VOCLR ( 781 ) /'t'/,VOCLR ( 782 ) /'s'/,
     X VOCLR ( 783 ) /'p'/,VOCLR ( 784 ) /'e'/,VOCLR ( 785 ) /'c'/,
     X VOCLR ( 786 ) /'>'/
      DATA BVOCLR ( 138 ) / 787 /
      DATA VOCLR ( 787 ) /'<'/,VOCLR ( 788 ) /'l'/,VOCLR ( 789 ) /'p'/,
     X VOCLR ( 790 ) /'r'/,VOCLR ( 791 ) /'i'/,VOCLR ( 792 ) /'m'/,
     X VOCLR ( 793 ) /'a'/,VOCLR ( 794 ) /'r'/,VOCLR ( 795 ) /'y'/,
     X VOCLR ( 796 ) /'>'/
      DATA BVOCLR ( 139 ) / 797 /
      DATA VOCLR ( 797 ) /'<'/,VOCLR ( 798 ) /'l'/,VOCLR ( 799 ) /'s'/,
     X VOCLR ( 800 ) /'t'/,VOCLR ( 801 ) /'m'/,VOCLR ( 802 ) /'t'/,
     X VOCLR ( 803 ) /'>'/
      DATA BVOCLR ( 140 ) / 804 /
      DATA VOCLR ( 804 ) /'<'/,VOCLR ( 805 ) /'l'/,VOCLR ( 806 ) /'t'/,
     X VOCLR ( 807 ) /'e'/,VOCLR ( 808 ) /'r'/,VOCLR ( 809 ) /'m'/,
     X VOCLR ( 810 ) /'>'/
      DATA BVOCLR ( 141 ) / 811 /
      DATA VOCLR ( 811 ) /'<'/,VOCLR ( 812 ) /'m'/,VOCLR ( 813 ) /'i'/,
     X VOCLR ( 814 ) /'s'/,VOCLR ( 815 ) /'c'/,VOCLR ( 816 ) /'>'/
      DATA BVOCLR ( 142 ) / 817 /
      DATA VOCLR ( 817 ) /'<'/,VOCLR ( 818 ) /'n'/,VOCLR ( 819 ) /'o'/,
     X VOCLR ( 820 ) /'n'/,VOCLR ( 821 ) /'n'/,VOCLR ( 822 ) /'u'/,
     X VOCLR ( 823 ) /'l'/,VOCLR ( 824 ) /'l'/,VOCLR ( 825 ) /'s'/,
     X VOCLR ( 826 ) /'t'/,VOCLR ( 827 ) /'l'/,VOCLR ( 828 ) /'i'/,
     X VOCLR ( 829 ) /'s'/,VOCLR ( 830 ) /'t'/,VOCLR ( 831 ) /'>'/
      DATA BVOCLR ( 143 ) / 832 /
      DATA VOCLR ( 832 ) /'<'/,VOCLR ( 833 ) /'n'/,VOCLR ( 834 ) /'o'/,
     X VOCLR ( 835 ) /'n'/,VOCLR ( 836 ) /'n'/,VOCLR ( 837 ) /'u'/,
     X VOCLR ( 838 ) /'l'/,VOCLR ( 839 ) /'l'/,VOCLR ( 840 ) /'s'/,
     X VOCLR ( 841 ) /'t'/,VOCLR ( 842 ) /'m'/,VOCLR ( 843 ) /'t'/,
     X VOCLR ( 844 ) /'>'/
      DATA BVOCLR ( 144 ) / 845 /
      DATA VOCLR ( 845 ) /'<'/,VOCLR ( 846 ) /'o'/,VOCLR ( 847 ) /'p'/,
     X VOCLR ( 848 ) /'a'/,VOCLR ( 849 ) /'s'/,VOCLR ( 850 ) /'s'/,
     X VOCLR ( 851 ) /'i'/,VOCLR ( 852 ) /'g'/,VOCLR ( 853 ) /'n'/,
     X VOCLR ( 854 ) /'>'/
      END

      BLOCK DATA LRLO01
      CHARACTER VOCLR*1
      INTEGER BVOCLR, ENTLR, REDLR
      INTEGER FRDLR,TRANLR,NLOKLR,PRODLR
      INTEGER LSETLR, RHSLR, LHSLR, ACTLR
      INTEGER VACTLR
      DIMENSION VOCLR ( 1041 )
      DIMENSION BVOCLR ( 167 )
      DIMENSION ENTLR ( 345 )
      DIMENSION REDLR ( 346 )
      DIMENSION FRDLR ( 346 )
      DIMENSION TRANLR ( 2912 )
      DIMENSION NLOKLR ( 366 )
      DIMENSION PRODLR ( 366 )
      DIMENSION LSETLR ( 92 , 87 )
      DIMENSION RHSLR ( 214 )
      DIMENSION LHSLR ( 214 )
      DIMENSION ACTLR ( 214 )
      DIMENSION VACTLR ( 87 )
      COMMON /G4LR1/ VOCLR
      COMMON /G4LR2/ BVOCLR, ENTLR, REDLR
      COMMON /G4LR2/ FRDLR,TRANLR,NLOKLR,PRODLR
      COMMON /G4LR2/ LSETLR, RHSLR, LHSLR, ACTLR
      COMMON /G4LR2/ VACTLR
      DATA BVOCLR ( 145 ) / 855 /
      DATA VOCLR ( 855 ) /'<'/,VOCLR ( 856 ) /'o'/,VOCLR ( 857 ) /'p'/,
     X VOCLR ( 858 ) /'t'/,VOCLR ( 859 ) /'e'/,VOCLR ( 860 ) /'l'/,
     X VOCLR ( 861 ) /'s'/,VOCLR ( 862 ) /'e'/,VOCLR ( 863 ) /'>'/
      DATA BVOCLR ( 146 ) / 864 /
      DATA VOCLR ( 864 ) /'<'/,VOCLR ( 865 ) /'o'/,VOCLR ( 866 ) /'p'/,
     X VOCLR ( 867 ) /'t'/,VOCLR ( 868 ) /'l'/,VOCLR ( 869 ) /'e'/,
     X VOCLR ( 870 ) /'v'/,VOCLR ( 871 ) /'e'/,VOCLR ( 872 ) /'l'/,
     X VOCLR ( 873 ) /'>'/
      DATA BVOCLR ( 147 ) / 874 /
      DATA VOCLR ( 874 ) /'<'/,VOCLR ( 875 ) /'o'/,VOCLR ( 876 ) /'p'/,
     X VOCLR ( 877 ) /'t'/,VOCLR ( 878 ) /'v'/,VOCLR ( 879 ) /'a'/,
     X VOCLR ( 880 ) /'l'/,VOCLR ( 881 ) /'>'/
      DATA BVOCLR ( 148 ) / 882 /
      DATA VOCLR ( 882 ) /'<'/,VOCLR ( 883 ) /'o'/,VOCLR ( 884 ) /'u'/,
     X VOCLR ( 885 ) /'t'/,VOCLR ( 886 ) /'d'/,VOCLR ( 887 ) /'e'/,
     X VOCLR ( 888 ) /'v'/,VOCLR ( 889 ) /'i'/,VOCLR ( 890 ) /'c'/,
     X VOCLR ( 891 ) /'e'/,VOCLR ( 892 ) /'>'/
      DATA BVOCLR ( 149 ) / 893 /
      DATA VOCLR ( 893 ) /'<'/,VOCLR ( 894 ) /'o'/,VOCLR ( 895 ) /'u'/,
     X VOCLR ( 896 ) /'t'/,VOCLR ( 897 ) /'l'/,VOCLR ( 898 ) /'i'/,
     X VOCLR ( 899 ) /'s'/,VOCLR ( 900 ) /'t'/,VOCLR ( 901 ) /'>'/
      DATA BVOCLR ( 150 ) / 902 /
      DATA VOCLR ( 902 ) /'<'/,VOCLR ( 903 ) /'p'/,VOCLR ( 904 ) /'a'/,
     X VOCLR ( 905 ) /'r'/,VOCLR ( 906 ) /'a'/,VOCLR ( 907 ) /'m'/,
     X VOCLR ( 908 ) /'l'/,VOCLR ( 909 ) /'i'/,VOCLR ( 910 ) /'s'/,
     X VOCLR ( 911 ) /'t'/,VOCLR ( 912 ) /'>'/
      DATA BVOCLR ( 151 ) / 913 /
      DATA VOCLR ( 913 ) /'<'/,VOCLR ( 914 ) /'p'/,VOCLR ( 915 ) /'a'/,
     X VOCLR ( 916 ) /'r'/,VOCLR ( 917 ) /'s'/,VOCLR ( 918 ) /'e'/,
     X VOCLR ( 919 ) /'>'/
      DATA BVOCLR ( 152 ) / 920 /
      DATA VOCLR ( 920 ) /'<'/,VOCLR ( 921 ) /'p'/,VOCLR ( 922 ) /'r'/,
     X VOCLR ( 923 ) /'i'/,VOCLR ( 924 ) /'m'/,VOCLR ( 925 ) /'r'/,
     X VOCLR ( 926 ) /'y'/,VOCLR ( 927 ) /'>'/
      DATA BVOCLR ( 153 ) / 928 /
      DATA VOCLR ( 928 ) /'<'/,VOCLR ( 929 ) /'r'/,VOCLR ( 930 ) /'e'/,
     X VOCLR ( 931 ) /'x'/,VOCLR ( 932 ) /'p'/,VOCLR ( 933 ) /'>'/
      DATA BVOCLR ( 154 ) / 934 /
      DATA VOCLR ( 934 ) /'<'/,VOCLR ( 935 ) /'r'/,VOCLR ( 936 ) /'t'/,
     X VOCLR ( 937 ) /'e'/,VOCLR ( 938 ) /'r'/,VOCLR ( 939 ) /'m'/,
     X VOCLR ( 940 ) /'>'/
      DATA BVOCLR ( 155 ) / 941 /
      DATA VOCLR ( 941 ) /'<'/,VOCLR ( 942 ) /'s'/,VOCLR ( 943 ) /'c'/,
     X VOCLR ( 944 ) /'o'/,VOCLR ( 945 ) /'p'/,VOCLR ( 946 ) /'e'/,
     X VOCLR ( 947 ) /'>'/
      DATA BVOCLR ( 156 ) / 948 /
      DATA VOCLR ( 948 ) /'<'/,VOCLR ( 949 ) /'s'/,VOCLR ( 950 ) /'i'/,
     X VOCLR ( 951 ) /'m'/,VOCLR ( 952 ) /'p'/,VOCLR ( 953 ) /'l'/,
     X VOCLR ( 954 ) /'e'/,VOCLR ( 955 ) /'s'/,VOCLR ( 956 ) /'t'/,
     X VOCLR ( 957 ) /'m'/,VOCLR ( 958 ) /'t'/,VOCLR ( 959 ) /'>'/
      DATA BVOCLR ( 157 ) / 960 /
      DATA VOCLR ( 960 ) /'<'/,VOCLR ( 961 ) /'s'/,VOCLR ( 962 ) /'t'/,
     X VOCLR ( 963 ) /'l'/,VOCLR ( 964 ) /'i'/,VOCLR ( 965 ) /'s'/,
     X VOCLR ( 966 ) /'t'/,VOCLR ( 967 ) /'>'/
      DATA BVOCLR ( 158 ) / 968 /
      DATA VOCLR ( 968 ) /'<'/,VOCLR ( 969 ) /'s'/,VOCLR ( 970 ) /'t'/,
     X VOCLR ( 971 ) /'m'/,VOCLR ( 972 ) /'t'/,VOCLR ( 973 ) /'>'/
      DATA BVOCLR ( 159 ) / 974 /
      DATA VOCLR ( 974 ) /'<'/,VOCLR ( 975 ) /'s'/,VOCLR ( 976 ) /'t'/,
     X VOCLR ( 977 ) /'r'/,VOCLR ( 978 ) /'u'/,VOCLR ( 979 ) /'c'/,
     X VOCLR ( 980 ) /'s'/,VOCLR ( 981 ) /'t'/,VOCLR ( 982 ) /'m'/,
     X VOCLR ( 983 ) /'t'/,VOCLR ( 984 ) /'>'/
      DATA BVOCLR ( 160 ) / 985 /
      DATA VOCLR ( 985 ) /'<'/,VOCLR ( 986 ) /'t'/,VOCLR ( 987 ) /'e'/,
     X VOCLR ( 988 ) /'r'/,VOCLR ( 989 ) /'m'/,VOCLR ( 990 ) /'>'/
      DATA BVOCLR ( 161 ) / 991 /
      DATA VOCLR ( 991 ) /'<'/,VOCLR ( 992 ) /'t'/,VOCLR ( 993 ) /'h'/,
     X VOCLR ( 994 ) /'e'/,VOCLR ( 995 ) /'n'/,VOCLR ( 996 ) /'l'/,
     X VOCLR ( 997 ) /'i'/,VOCLR ( 998 ) /'s'/,VOCLR ( 999 ) /'t'/,
     X VOCLR ( 1000 ) /'>'/
      DATA BVOCLR ( 162 ) / 1001 /
      DATA VOCLR ( 1001 ) /'<'/,VOCLR ( 1002 ) /'t'/,
     X VOCLR ( 1003 ) /'y'/,VOCLR ( 1004 ) /'p'/,VOCLR ( 1005 ) /'e'/,
     X VOCLR ( 1006 ) /'>'/
      DATA BVOCLR ( 163 ) / 1007 /
      DATA VOCLR ( 1007 ) /'<'/,VOCLR ( 1008 ) /'v'/,
     X VOCLR ( 1009 ) /'a'/,VOCLR ( 1010 ) /'l'/,VOCLR ( 1011 ) /'s'/,
     X VOCLR ( 1012 ) /'>'/
      DATA BVOCLR ( 164 ) / 1013 /
      DATA VOCLR ( 1013 ) /'<'/,VOCLR ( 1014 ) /'v'/,
     X VOCLR ( 1015 ) /'a'/,VOCLR ( 1016 ) /'r'/,VOCLR ( 1017 ) /'l'/,
     X VOCLR ( 1018 ) /'i'/,VOCLR ( 1019 ) /'s'/,VOCLR ( 1020 ) /'t'/,
     X VOCLR ( 1021 ) /'>'/
      DATA BVOCLR ( 165 ) / 1022 /
      DATA VOCLR ( 1022 ) /'<'/,VOCLR ( 1023 ) /'w'/,
     X VOCLR ( 1024 ) /'h'/,VOCLR ( 1025 ) /'i'/,VOCLR ( 1026 ) /'l'/,
     X VOCLR ( 1027 ) /'e'/,VOCLR ( 1028 ) /'s'/,VOCLR ( 1029 ) /'t'/,
     X VOCLR ( 1030 ) /'m'/,VOCLR ( 1031 ) /'t'/,VOCLR ( 1032 ) /'>'/
      DATA BVOCLR ( 166 ) / 1033 /
      DATA VOCLR ( 1033 ) /'<'/,VOCLR ( 1034 ) /'w'/,
     X VOCLR ( 1035 ) /'h'/,VOCLR ( 1036 ) /'i'/,VOCLR ( 1037 ) /'l'/,
     X VOCLR ( 1038 ) /'e'/,VOCLR ( 1039 ) /'x'/,VOCLR ( 1040 ) /'p'/,
     X VOCLR ( 1041 ) /'>'/
      DATA BVOCLR ( 167 ) / 1042 /
      DATA ( ENTLR ( I ) , I = 1 , 100 ) /
     X 3, 30, 151, 157, 30, 4, 10, 13, 31, 32, 34, 35, 37,
     X 38, 43, 46, 48, 49, 58, 59, 60, 61, 62, 65, 66, 68,
     X 69, 70, 72, 74, 76, 77, 80, 81, 82, 91, 96, 100,
     X 103, 104, 105, 108, 111, 113, 119, 121, 122, 123, 125,
     X 127, 134, 135, 141, 143, 144, 148, 152, 153, 154, 155,
     X 156, 158, 159, 160, 165, 86, 105, 111, 123, 132, 133,
     X 134, 138, 140, 160, 160, 112, 132, 154, 4, 61, 65,
     X 70, 131, 146, 113, 45, 107, 110, 134, 4, 116, 123,
     X 105, 120, 4, 124, 105, 122, 123/
      DATA ( ENTLR ( I ) , I = 101 , 200 ) /
     X 136, 137, 146, 2, 57, 92, 102, 114, 132, 132, 147, 4,
     X 166, 85, 12, 15, 7, 41, 28, 128, 3, 4, 8, 9, 11,
     X 14, 17, 19, 24, 84, 90, 94, 95, 21, 149, 18, 10, 13,
     X 36, 39, 40, 42, 44, 47, 63, 64, 67, 71, 73, 75, 162,
     X 110, 1, 6, 16, 133, 15, 20, 22, 23, 24, 25, 26, 27,
     X 87, 5, 83, 2, 12, 33, 35, 61, 65, 70, 110, 157, 24,
     X 96, 97, 117, 134, 12, 4, 110, 132, 78, 110, 129, 143,
     X 161, 12, 136, 134, 132, 157, 104, 105, 111, 31, 105/
      DATA ( ENTLR ( I ) , I = 201 , 300 ) /
     X 152, 98, 99, 114, 76, 134, 28, 132, 92, 93, 132, 132,
     X 132, 132, 132, 132, 132, 132, 76, 132, 21, 153, 154,
     X 160, 160, 6, 42, 105, 109, 164, 152, 1, 152, 1, 16,
     X 152, 111, 111, 111, 111, 111, 111, 111, 111, 140, 138,
     X 132, 5, 5, 5, 157, 52, 79, 106, 111, 115, 110, 12,
     X 123, 45, 68, 150, 157, 5, 157, 78, 143, 50, 51, 145,
     X 136, 5, 56, 15, 12, 29, 81, 76, 134, 5, 12, 76, 132,
     X 18, 154, 94, 24, 163, 12, 152, 152, 152, 52, 4, 12,
     X 96, 118, 132, 68, 5/
      DATA ( ENTLR ( I ) , I = 301 , 345 ) /
     X 12, 45, 53, 157, 157, 124, 55, 98, 98, 98, 92, 153,
     X 132, 109, 132, 111, 130, 12, 68, 68, 78, 89, 110,
     X 142, 143, 163, 5, 12, 126, 101, 139, 158, 157, 145,
     X 78, 142, 110, 111, 110, 5, 157, 157, 158, 157, 54/
      DATA ( REDLR ( I ) , I = 1 , 100 ) /
     X 1, 1, 2, 2, 8, 9, 10, 10, 10, 11, 12, 13, 13, 14,
     X 14, 15, 15, 16, 17, 17, 18, 18, 19, 19, 20, 21, 22,
     X 23, 24, 26, 27, 29, 30, 30, 31, 31, 32, 33, 34, 35,
     X 36, 38, 39, 42, 43, 44, 45, 46, 47, 48, 48, 49, 50,
     X 51, 52, 53, 53, 54, 54, 56, 56, 57, 57, 58, 59, 60,
     X 61, 62, 63, 64, 64, 65, 66, 67, 68, 69, 70, 70, 71,
     X 71, 71, 72, 73, 74, 75, 76, 77, 78, 78, 79, 79, 80,
     X 81, 82, 83, 83, 84, 88, 89, 90/
      DATA ( REDLR ( I ) , I = 101 , 200 ) /
     X 91, 92, 93, 94, 94, 95, 96, 97, 98, 99, 100, 101,
     X 102, 103, 104, 105, 105, 105, 107, 107, 108, 109, 111,
     X 112, 113, 114, 115, 116, 117, 118, 119, 120, 121, 122,
     X 123, 124, 125, 125, 125, 126, 127, 128, 129, 130, 131,
     X 132, 133, 134, 135, 136, 137, 137, 138, 138, 138, 138,
     X 139, 139, 140, 141, 142, 143, 144, 145, 146, 147, 148,
     X 149, 150, 151, 152, 153, 153, 153, 153, 154, 159, 160,
     X 161, 162, 162, 162, 162, 162, 163, 163, 164, 168, 169,
     X 170, 171, 171, 172, 173, 173, 178, 179, 180, 181, 182/
      DATA ( REDLR ( I ) , I = 201 , 300 ) /
     X 183, 184, 185, 186, 187, 188, 189, 189, 190, 191, 191,
     X 192, 193, 194, 195, 196, 197, 198, 199, 200, 201, 202,
     X 203, 204, 205, 206, 206, 207, 208, 209, 210, 211, 211,
     X 212, 212, 212, 213, 214, 215, 216, 217, 218, 219, 220,
     X 221, 222, 223, 224, 225, 226, 227, 232, 233, 233, 234,
     X 235, 235, 235, 236, 237, 237, 238, 238, 243, 244, 250,
     X 251, 252, 253, 253, 253, 254, 255, 256, 256, 258, 260,
     X 262, 263, 264, 265, 267, 268, 269, 270, 271, 272, 273,
     X 274, 274, 275, 276, 277, 278, 279, 280, 281, 281, 282,
     X 283/
      DATA ( REDLR ( I ) , I = 301 , 346 ) /
     X 284, 284, 284, 285, 291, 297, 301, 302, 303, 304, 305,
     X 306, 307, 308, 309, 309, 310, 311, 316, 317, 318, 319,
     X 320, 324, 325, 325, 326, 327, 328, 329, 330, 330, 331,
     X 337, 338, 339, 340, 341, 342, 347, 348, 354, 360, 361,
     X 366, 367/
      END

      BLOCK DATA LRLO02
      CHARACTER VOCLR*1
      INTEGER BVOCLR, ENTLR, REDLR
      INTEGER FRDLR,TRANLR,NLOKLR,PRODLR
      INTEGER LSETLR, RHSLR, LHSLR, ACTLR
      INTEGER VACTLR
      DIMENSION VOCLR ( 1041 )
      DIMENSION BVOCLR ( 167 )
      DIMENSION ENTLR ( 345 )
      DIMENSION REDLR ( 346 )
      DIMENSION FRDLR ( 346 )
      DIMENSION TRANLR ( 2912 )
      DIMENSION NLOKLR ( 366 )
      DIMENSION PRODLR ( 366 )
      DIMENSION LSETLR ( 92 , 87 )
      DIMENSION RHSLR ( 214 )
      DIMENSION LHSLR ( 214 )
      DIMENSION ACTLR ( 214 )
      DIMENSION VACTLR ( 87 )
      COMMON /G4LR1/ VOCLR
      COMMON /G4LR2/ BVOCLR, ENTLR, REDLR
      COMMON /G4LR2/ FRDLR,TRANLR,NLOKLR,PRODLR
      COMMON /G4LR2/ LSETLR, RHSLR, LHSLR, ACTLR
      COMMON /G4LR2/ VACTLR
      DATA ( FRDLR ( I ) , I = 1 , 100 ) /
     X 1, 2, 4, 5, 65, 65, 94, 113, 132, 132, 162, 162,
     X 184, 190, 207, 207, 217, 217, 217, 218, 223, 227, 227,
     X 229, 229, 237, 237, 243, 243, 277, 277, 307, 307, 309,
     X 309, 310, 310, 310, 310, 311, 311, 312, 312, 312, 313,
     X 313, 313, 313, 314, 314, 316, 329, 329, 329, 329, 329,
     X 331, 331, 332, 334, 347, 347, 349, 349, 352, 352, 377,
     X 378, 386, 386, 388, 388, 390, 390, 391, 394, 397, 399,
     X 400, 403, 406, 406, 406, 406, 406, 406, 406, 406, 408,
     X 409, 412, 422, 423, 423, 424, 426, 455, 516, 517, 517/
      DATA ( FRDLR ( I ) , I = 101 , 200 ) /
     X 517, 517, 525, 525, 532, 532, 532, 532, 532, 533, 534,
     X 534, 563, 564, 564, 591, 595, 613, 649, 657, 658, 687,
     X 720, 749, 778, 807, 836, 865, 865, 865, 894, 923, 923,
     X 952, 982, 983, 1006, 1025, 1044, 1044, 1044, 1045,
     X 1045, 1045, 1046, 1046, 1046, 1046, 1046, 1046, 1046,
     X 1051, 1051, 1069, 1088, 1108, 1108, 1111, 1135, 1159,
     X 1183, 1207, 1231, 1255, 1279, 1303, 1303, 1331, 1358,
     X 1387, 1387, 1387, 1388, 1389, 1390, 1391, 1454, 1479,
     X 1479, 1481, 1482, 1486, 1490, 1493, 1494, 1496, 1497,
     X 1554, 1554, 1554, 1557, 1564, 1564, 1566, 1568, 1629,
     X 1629, 1630, 1630, 1630/
      DATA ( FRDLR ( I ) , I = 201 , 300 ) /
     X 1630, 1630, 1630, 1633, 1633, 1633, 1635, 1643, 1644,
     X 1644, 1646, 1647, 1648, 1649, 1650, 1651, 1652, 1653,
     X 1654, 1654, 1655, 1685, 1686, 1688, 1691, 1694, 1716,
     X 1716, 1718, 1720, 1721, 1721, 1739, 1739, 1757, 1775,
     X 1775, 1775, 1775, 1775, 1775, 1775, 1775, 1775, 1775,
     X 1776, 1776, 1777, 1777, 1777, 1777, 1838, 1838, 1839,
     X 1839, 1839, 1840, 1848, 1878, 1878, 1879, 1879, 1882,
     X 1943, 1943, 2003, 2004, 2004, 2005, 2007, 2008, 2008,
     X 2008, 2008, 2012, 2047, 2082, 2117, 2117, 2119, 2119,
     X 2151, 2151, 2152, 2175, 2177, 2177, 2206, 2206, 2210,
     X 2210, 2210, 2210, 2210, 2239, 2264, 2264, 2265, 2266,
     X 2266/
      DATA ( FRDLR ( I ) , I = 301 , 346 ) /
     X 2266, 2267, 2268, 2268, 2328, 2388, 2449, 2449, 2449,
     X 2449, 2449, 2449, 2449, 2450, 2452, 2454, 2454, 2456,
     X 2518, 2518, 2518, 2519, 2522, 2580, 2580, 2582, 2582,
     X 2582, 2606, 2606, 2608, 2609, 2609, 2669, 2669, 2670,
     X 2670, 2671, 2671, 2731, 2732, 2792, 2852, 2852, 2913,
     X 2913/
      END

      BLOCK DATA LRLO03
      CHARACTER VOCLR*1
      INTEGER BVOCLR, ENTLR, REDLR
      INTEGER FRDLR,TRANLR,NLOKLR,PRODLR
      INTEGER LSETLR, RHSLR, LHSLR, ACTLR
      INTEGER VACTLR
      DIMENSION VOCLR ( 1041 )
      DIMENSION BVOCLR ( 167 )
      DIMENSION ENTLR ( 345 )
      DIMENSION REDLR ( 346 )
      DIMENSION FRDLR ( 346 )
      DIMENSION TRANLR ( 2912 )
      DIMENSION NLOKLR ( 366 )
      DIMENSION PRODLR ( 366 )
      DIMENSION LSETLR ( 92 , 87 )
      DIMENSION RHSLR ( 214 )
      DIMENSION LHSLR ( 214 )
      DIMENSION ACTLR ( 214 )
      DIMENSION VACTLR ( 87 )
      COMMON /G4LR1/ VOCLR
      COMMON /G4LR2/ BVOCLR, ENTLR, REDLR
      COMMON /G4LR2/ FRDLR,TRANLR,NLOKLR,PRODLR
      COMMON /G4LR2/ LSETLR, RHSLR, LHSLR, ACTLR
      COMMON /G4LR2/ VACTLR
      DATA ( TRANLR ( I ) , I = 1 , 100 ) /
     X 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15,
     X 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28,
     X 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40, 41,
     X 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, 52, 53, 54,
     X 55, 56, 57, 58, 59, 60, 61, 62, 63, 64, 65, 6, 7,
     X 8, 10, 12, 15, 17, 18, 22, 24, 26, 28, 30, 32, 66,
     X 38, 67, 68, 44, 69, 70, 71, 72, 73, 74, 57, 58, 59,
     X 64, 6, 10, 12, 15, 17, 18, 22/
      DATA ( TRANLR ( I ) , I = 101 , 200 ) /
     X 24, 26, 28, 30, 32, 38, 67, 44, 69, 72, 57, 75, 6,
     X 10, 12, 15, 17, 18, 22, 24, 26, 28, 30, 32, 38, 67,
     X 44, 69, 72, 57, 76, 6, 7, 8, 10, 12, 15, 17, 18,
     X 22, 24, 26, 28, 30, 32, 66, 38, 67, 68, 77, 44, 69,
     X 78, 71, 72, 73, 74, 57, 58, 59, 64, 6, 7, 8, 10,
     X 12, 15, 17, 18, 22, 24, 26, 28, 30, 32, 38, 67, 44,
     X 69, 72, 57, 79, 64, 80, 81, 82, 83, 84, 85, 6, 10,
     X 12, 15, 17, 18, 22, 24, 26, 28, 30/
      DATA ( TRANLR ( I ) , I = 201 , 300 ) /
     X 32, 38, 67, 86, 69, 72, 6, 10, 12, 87, 26, 67, 88,
     X 89, 69, 90, 91, 12, 26, 67, 92, 93, 12, 26, 94, 95,
     X 96, 97, 9, 12, 26, 98, 99, 100, 101, 102, 80, 81,
     X 82, 83, 84, 103, 104, 6, 7, 8, 10, 12, 15, 17, 18,
     X 105, 22, 24, 26, 28, 30, 32, 66, 106, 38, 107, 67,
     X 68, 44, 108, 69, 109, 71, 72, 73, 74, 57, 58, 59,
     X 64, 6, 7, 8, 10, 12, 15, 17, 18, 22, 24, 26, 28,
     X 30, 32, 66, 38, 67, 68, 44, 69, 110, 71, 72, 73/
      DATA ( TRANLR ( I ) , I = 301 , 400 ) /
     X 74, 111, 57, 58, 59, 64, 112, 113, 114, 115, 116,
     X 117, 118, 119, 120, 121, 122, 123, 124, 125, 126, 127,
     X 128, 129, 130, 131, 132, 133, 134, 135, 136, 137, 138,
     X 139, 140, 141, 142, 143, 144, 145, 146, 147, 148, 149,
     X 150, 151, 87, 152, 153, 154, 155, 6, 7, 8, 10, 12,
     X 15, 17, 18, 22, 24, 26, 28, 30, 32, 38, 67, 68, 44,
     X 69, 156, 72, 57, 58, 59, 64, 157, 158, 159, 160, 161,
     X 162, 163, 164, 165, 166, 167, 122, 132, 168, 153, 154,
     X 155, 153, 154, 155, 169, 170, 167, 137/
      DATA ( TRANLR ( I ) , I = 401 , 500 ) /
     X 138, 171, 172, 173, 174, 87, 175, 176, 122, 177, 132,
     X 6, 10, 12, 26, 178, 179, 67, 180, 69, 181, 182, 183,
     X 87, 184, 6, 7, 8, 10, 12, 15, 17, 18, 22, 24, 26,
     X 28, 30, 32, 66, 38, 67, 68, 44, 69, 185, 71, 72, 73,
     X 74, 57, 58, 59, 64, 6, 7, 8, 9, 10, 12, 13, 14, 15,
     X 87, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27,
     X 28, 29, 30, 31, 32, 186, 33, 36, 37, 38, 39, 40, 41,
     X 42, 187, 43, 44, 45, 46, 47, 48, 49, 50, 188/
      DATA ( TRANLR ( I ) , I = 501 , 600 ) /
     X 51, 52, 53, 189, 55, 56, 57, 58, 59, 60, 61, 63, 64,
     X 190, 65, 116, 191, 9, 12, 26, 98, 99, 100, 192, 6,
     X 10, 12, 26, 67, 69, 193, 167, 167, 6, 7, 8, 10, 12,
     X 15, 17, 18, 22, 24, 26, 28, 30, 32, 66, 38, 67, 68,
     X 44, 69, 194, 71, 72, 73, 74, 57, 58, 59, 64, 195, 6,
     X 7, 8, 9, 10, 12, 15, 17, 18, 22, 24, 26, 28, 30,
     X 32, 38, 196, 197, 198, 44, 47, 69, 72, 57, 58, 59,
     X 64, 199, 12, 26, 200, 6, 10, 12, 15, 17, 18/
      DATA ( TRANLR ( I ) , I = 601 , 700 ) /
     X 22, 24, 26, 28, 30, 32, 38, 67, 44, 69, 72, 201,
     X 104, 6, 7, 8, 10, 12, 15, 17, 18, 105, 22, 24, 26,
     X 28, 30, 32, 66, 106, 202, 203, 38, 107, 67, 68, 44,
     X 204, 69, 109, 71, 72, 73, 74, 57, 58, 59, 64, 6, 10,
     X 12, 26, 205, 67, 69, 206, 207, 6, 7, 8, 10, 12, 15,
     X 17, 18, 22, 24, 26, 28, 30, 32, 66, 38, 67, 68, 44,
     X 69, 208, 71, 72, 73, 74, 57, 58, 59, 64, 104, 6, 7,
     X 8, 10, 12, 15, 17, 18, 22, 24, 26, 28, 30/
      DATA ( TRANLR ( I ) , I = 701 , 800 ) /
     X 32, 66, 209, 210, 38, 107, 67, 68, 44, 69, 109, 71,
     X 72, 73, 74, 57, 58, 59, 64, 6, 7, 8, 10, 12, 15,
     X 17, 18, 22, 24, 26, 28, 30, 32, 66, 38, 67, 68, 44,
     X 69, 211, 71, 72, 73, 74, 57, 58, 59, 64, 6, 7, 8,
     X 10, 12, 15, 17, 18, 22, 24, 26, 28, 30, 32, 66, 38,
     X 67, 68, 44, 69, 212, 71, 72, 73, 74, 57, 58, 59, 64,
     X 6, 7, 8, 10, 12, 15, 17, 18, 22, 24, 26, 28, 30,
     X 32, 66, 38, 67, 68, 44, 69, 213, 71, 72/
      DATA ( TRANLR ( I ) , I = 801 , 900 ) /
     X 73, 74, 57, 58, 59, 64, 6, 7, 8, 10, 12, 15, 17,
     X 18, 22, 24, 26, 28, 30, 32, 66, 38, 67, 68, 44, 69,
     X 214, 71, 72, 73, 74, 57, 58, 59, 64, 6, 7, 8, 10,
     X 12, 15, 17, 18, 22, 24, 26, 28, 30, 32, 66, 38, 67,
     X 68, 44, 69, 215, 71, 72, 73, 74, 57, 58, 59, 64, 6,
     X 7, 8, 10, 12, 15, 17, 18, 22, 24, 26, 28, 30, 32,
     X 66, 38, 67, 68, 44, 69, 216, 71, 72, 73, 74, 57, 58,
     X 59, 64, 6, 7, 8, 10, 12, 15, 17/
      DATA ( TRANLR ( I ) , I = 901 , 1000 ) /
     X 18, 22, 24, 26, 28, 30, 32, 66, 38, 67, 68, 44, 69,
     X 217, 71, 72, 73, 74, 57, 58, 59, 64, 6, 7, 8, 10,
     X 12, 15, 17, 18, 22, 24, 26, 28, 30, 32, 66, 38, 67,
     X 68, 44, 69, 218, 71, 72, 73, 74, 57, 58, 59, 64, 6,
     X 7, 8, 10, 12, 15, 17, 18, 22, 24, 26, 28, 30, 219,
     X 32, 66, 38, 67, 68, 44, 69, 220, 71, 72, 73, 74, 57,
     X 58, 59, 64, 221, 6, 7, 8, 10, 12, 15, 17, 18, 22,
     X 24, 26, 28, 30, 32, 38, 67, 44, 69/
      END

      BLOCK DATA LRLO04
      CHARACTER VOCLR*1
      INTEGER BVOCLR, ENTLR, REDLR
      INTEGER FRDLR,TRANLR,NLOKLR,PRODLR
      INTEGER LSETLR, RHSLR, LHSLR, ACTLR
      INTEGER VACTLR
      DIMENSION VOCLR ( 1041 )
      DIMENSION BVOCLR ( 167 )
      DIMENSION ENTLR ( 345 )
      DIMENSION REDLR ( 346 )
      DIMENSION FRDLR ( 346 )
      DIMENSION TRANLR ( 2912 )
      DIMENSION NLOKLR ( 366 )
      DIMENSION PRODLR ( 366 )
      DIMENSION LSETLR ( 92 , 87 )
      DIMENSION RHSLR ( 214 )
      DIMENSION LHSLR ( 214 )
      DIMENSION ACTLR ( 214 )
      DIMENSION VACTLR ( 87 )
      COMMON /G4LR1/ VOCLR
      COMMON /G4LR2/ BVOCLR, ENTLR, REDLR
      COMMON /G4LR2/ FRDLR,TRANLR,NLOKLR,PRODLR
      COMMON /G4LR2/ LSETLR, RHSLR, LHSLR, ACTLR
      COMMON /G4LR2/ VACTLR
      DATA ( TRANLR ( I ) , I = 1001 , 1100 ) /
     X 72, 57, 222, 223, 64, 6, 10, 12, 15, 17, 18, 22, 24,
     X 26, 28, 30, 32, 38, 67, 44, 69, 72, 57, 224, 6, 10,
     X 12, 15, 17, 18, 22, 24, 26, 28, 30, 32, 38, 67, 44,
     X 69, 72, 57, 225, 226, 227, 12, 26, 228, 229, 230, 6,
     X 10, 12, 15, 17, 18, 22, 24, 26, 28, 30, 32, 38, 67,
     X 44, 69, 72, 231, 232, 6, 10, 12, 15, 17, 18, 22, 24,
     X 26, 28, 30, 32, 38, 67, 44, 69, 72, 233, 234, 6,
     X 235, 10, 12, 15, 17, 18, 22, 24, 26, 28, 30/
      DATA ( TRANLR ( I ) , I = 1101 , 1200 ) /
     X 32, 38, 67, 44, 69, 72, 236, 12, 26, 200, 6, 7, 8,
     X 10, 12, 15, 17, 18, 22, 24, 26, 28, 30, 32, 38, 67,
     X 237, 44, 69, 72, 57, 58, 59, 64, 6, 7, 8, 10, 12,
     X 15, 17, 18, 22, 24, 26, 28, 30, 32, 38, 67, 238, 44,
     X 69, 72, 57, 58, 59, 64, 6, 7, 8, 10, 12, 15, 17,
     X 18, 22, 24, 26, 28, 30, 32, 38, 67, 239, 44, 69, 72,
     X 57, 58, 59, 64, 6, 7, 8, 10, 12, 15, 17, 18, 22,
     X 24, 26, 28, 30, 32, 38, 67, 240, 44/
      DATA ( TRANLR ( I ) , I = 1201 , 1300 ) /
     X 69, 72, 57, 58, 59, 64, 6, 7, 8, 10, 12, 15, 17,
     X 18, 22, 24, 26, 28, 30, 32, 38, 67, 241, 44, 69, 72,
     X 57, 58, 59, 64, 6, 7, 8, 10, 12, 15, 17, 18, 22,
     X 24, 26, 28, 30, 32, 38, 67, 242, 44, 69, 72, 57, 58,
     X 59, 64, 6, 7, 8, 10, 12, 15, 17, 18, 22, 24, 26,
     X 28, 30, 32, 38, 67, 243, 44, 69, 72, 57, 58, 59, 64,
     X 6, 7, 8, 10, 12, 15, 17, 18, 22, 24, 26, 28, 30,
     X 32, 38, 67, 244, 44, 69, 72, 57, 58/
      DATA ( TRANLR ( I ) , I = 1301 , 1400 ) /
     X 59, 64, 6, 7, 8, 10, 12, 15, 17, 18, 22, 24, 26,
     X 28, 30, 32, 66, 38, 67, 68, 44, 69, 71, 72, 73, 245,
     X 57, 58, 59, 64, 6, 7, 8, 10, 12, 15, 17, 18, 22,
     X 24, 26, 28, 30, 32, 66, 38, 67, 68, 44, 69, 71, 72,
     X 246, 57, 58, 59, 64, 6, 7, 8, 10, 12, 15, 17, 18,
     X 22, 24, 26, 28, 30, 32, 66, 38, 67, 68, 44, 69, 247,
     X 71, 72, 73, 74, 57, 58, 59, 64, 248, 249, 250, 251,
     X 6, 7, 8, 9, 10, 11, 12, 13, 14, 15/
      DATA ( TRANLR ( I ) , I = 1401 , 1500 ) /
     X 16, 17, 18, 252, 19, 20, 21, 22, 23, 24, 25, 26, 27,
     X 28, 29, 30, 31, 32, 253, 33, 34, 35, 36, 37, 38, 39,
     X 40, 41, 254, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51,
     X 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63, 64,
     X 65, 6, 7, 8, 10, 12, 15, 17, 18, 22, 24, 26, 28,
     X 30, 32, 38, 67, 255, 44, 256, 69, 72, 57, 58, 59,
     X 64, 87, 257, 258, 122, 129, 132, 133, 12, 26, 67,
     X 259, 260, 261, 262, 263, 264, 167, 265, 6, 7, 8, 9/
      DATA ( TRANLR ( I ) , I = 1501 , 1600 ) /
     X 10, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23,
     X 24, 25, 26, 27, 28, 29, 30, 31, 32, 266, 33, 36, 37,
     X 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50,
     X 51, 52, 53, 267, 55, 56, 57, 58, 59, 60, 61, 63, 64,
     X 65, 268, 269, 270, 9, 12, 26, 98, 99, 100, 271, 122,
     X 132, 272, 167, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15,
     X 16, 17, 18, 273, 19, 20, 21, 22, 23, 24, 25, 26, 27,
     X 28, 29, 30, 31, 32, 33, 34, 35, 36, 37/
      DATA ( TRANLR ( I ) , I = 1601 , 1700 ) /
     X 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50,
     X 51, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63,
     X 64, 65, 274, 275, 276, 277, 122, 132, 6, 10, 12, 26,
     X 278, 67, 69, 279, 167, 280, 281, 167, 167, 167, 167,
     X 167, 167, 167, 167, 167, 6, 7, 8, 10, 12, 15, 17,
     X 18, 22, 24, 26, 28, 30, 282, 32, 66, 38, 67, 68, 44,
     X 69, 283, 71, 72, 73, 74, 57, 58, 59, 64, 284, 137,
     X 138, 153, 154, 155, 153, 154, 155, 6, 7, 8, 10, 12,
     X 15, 17/
      DATA ( TRANLR ( I ) , I = 1701 , 1800 ) /
     X 18, 22, 24, 26, 28, 30, 32, 38, 67, 44, 69, 72, 57,
     X 285, 64, 122, 286, 287, 288, 289, 6, 10, 12, 15, 17,
     X 18, 22, 24, 26, 28, 30, 32, 38, 67, 44, 69, 72, 290,
     X 6, 10, 12, 15, 17, 18, 22, 24, 26, 28, 30, 32, 38,
     X 67, 44, 69, 72, 291, 6, 10, 12, 15, 17, 18, 22, 24,
     X 26, 28, 30, 32, 38, 67, 44, 69, 72, 292, 168, 167,
     X 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18,
     X 293, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28/
      DATA ( TRANLR ( I ) , I = 1801 , 1900 ) /
     X 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40, 41,
     X 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, 52, 53, 54,
     X 55, 56, 57, 58, 59, 60, 61, 62, 63, 64, 65, 294,
     X 295, 6, 10, 12, 26, 296, 67, 69, 181, 6, 7, 8, 10,
     X 12, 15, 17, 18, 22, 24, 26, 28, 30, 32, 66, 38, 67,
     X 68, 44, 297, 69, 298, 71, 72, 73, 74, 57, 58, 59,
     X 64, 299, 300, 301, 302, 6, 7, 8, 9, 10, 11, 12, 13,
     X 14, 15, 16, 17, 18, 303, 19, 20, 21, 22, 23/
      DATA ( TRANLR ( I ) , I = 1901 , 2000 ) /
     X 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36,
     X 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49,
     X 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 62,
     X 63, 64, 65, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16,
     X 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29,
     X 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42,
     X 43, 44, 45, 46, 47, 48, 49, 50, 51, 52, 53, 54, 55,
     X 56, 57, 58, 59, 60, 61, 62, 63/
      END

      BLOCK DATA LRLO05
      CHARACTER VOCLR*1
      INTEGER BVOCLR, ENTLR, REDLR
      INTEGER FRDLR,TRANLR,NLOKLR,PRODLR
      INTEGER LSETLR, RHSLR, LHSLR, ACTLR
      INTEGER VACTLR
      DIMENSION VOCLR ( 1041 )
      DIMENSION BVOCLR ( 167 )
      DIMENSION ENTLR ( 345 )
      DIMENSION REDLR ( 346 )
      DIMENSION FRDLR ( 346 )
      DIMENSION TRANLR ( 2912 )
      DIMENSION NLOKLR ( 366 )
      DIMENSION PRODLR ( 366 )
      DIMENSION LSETLR ( 92 , 87 )
      DIMENSION RHSLR ( 214 )
      DIMENSION LHSLR ( 214 )
      DIMENSION ACTLR ( 214 )
      DIMENSION VACTLR ( 87 )
      COMMON /G4LR1/ VOCLR
      COMMON /G4LR2/ BVOCLR, ENTLR, REDLR
      COMMON /G4LR2/ FRDLR,TRANLR,NLOKLR,PRODLR
      COMMON /G4LR2/ LSETLR, RHSLR, LHSLR, ACTLR
      COMMON /G4LR2/ VACTLR
      DATA ( TRANLR ( I ) , I = 2001 , 2100 ) /
     X 64, 65, 304, 305, 96, 306, 307, 199, 12, 26, 200,
     X 104, 6, 7, 8, 10, 12, 15, 17, 18, 105, 22, 24, 26,
     X 28, 30, 32, 66, 106, 308, 38, 107, 67, 68, 44, 204,
     X 69, 109, 71, 72, 73, 74, 57, 58, 59, 64, 104, 6, 7,
     X 8, 10, 12, 15, 17, 18, 105, 22, 24, 26, 28, 30, 32,
     X 66, 106, 309, 38, 107, 67, 68, 44, 204, 69, 109, 71,
     X 72, 73, 74, 57, 58, 59, 64, 104, 6, 7, 8, 10, 12,
     X 15, 17, 18, 105, 22, 24, 26, 28, 30, 32, 66, 106,
     X 310/
      DATA ( TRANLR ( I ) , I = 2101 , 2200 ) /
     X 38, 107, 67, 68, 44, 204, 69, 109, 71, 72, 73, 74,
     X 57, 58, 59, 64, 122, 132, 104, 6, 7, 8, 10, 12, 15,
     X 17, 18, 22, 24, 26, 28, 30, 32, 66, 311, 38, 107,
     X 67, 68, 44, 69, 109, 71, 72, 73, 74, 57, 58, 59, 64,
     X 167, 6, 7, 8, 10, 12, 15, 17, 18, 22, 24, 26, 28,
     X 30, 32, 38, 67, 44, 69, 72, 57, 312, 223, 64, 137,
     X 138, 6, 7, 8, 10, 12, 15, 17, 18, 22, 24, 26, 28,
     X 30, 32, 66, 38, 67, 68, 44, 69, 313, 71, 72, 73/
      DATA ( TRANLR ( I ) , I = 2201 , 2300 ) /
     X 74, 57, 58, 59, 64, 12, 26, 228, 314, 6, 7, 8, 10,
     X 12, 15, 17, 18, 22, 24, 26, 28, 30, 32, 66, 38, 67,
     X 68, 44, 69, 315, 71, 72, 73, 74, 57, 58, 59, 64, 6,
     X 7, 8, 10, 12, 15, 17, 18, 22, 24, 26, 28, 30, 32,
     X 38, 67, 316, 44, 69, 317, 72, 57, 58, 59, 64, 318,
     X 167, 319, 320, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15,
     X 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28,
     X 29, 30, 31, 32, 33, 34, 35, 36, 37, 38/
      DATA ( TRANLR ( I ) , I = 2301 , 2400 ) /
     X 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51,
     X 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63, 64,
     X 65, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18,
     X 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31,
     X 32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44,
     X 45, 46, 47, 48, 49, 50, 51, 52, 53, 54, 55, 56, 57,
     X 58, 59, 60, 61, 62, 63, 64, 65, 6, 7, 8, 9, 10, 12,
     X 13, 14, 15, 87, 16, 17, 18/
      DATA ( TRANLR ( I ) , I = 2401 , 2500 ) /
     X 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31,
     X 32, 321, 33, 322, 36, 37, 38, 39, 40, 41, 42, 323,
     X 43, 44, 45, 46, 47, 48, 49, 50, 51, 52, 53, 324,
     X 325, 55, 56, 57, 58, 59, 60, 61, 63, 64, 65, 167,
     X 287, 326, 327, 167, 328, 329, 6, 7, 8, 9, 10, 11,
     X 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24,
     X 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37,
     X 38, 330, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49/
      DATA ( TRANLR ( I ) , I = 2501 , 2600 ) /
     X 50, 51, 52, 331, 53, 54, 55, 56, 57, 58, 59, 60, 61,
     X 332, 63, 64, 65, 333, 268, 269, 334, 6, 7, 8, 9, 10,
     X 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24,
     X 25, 26, 27, 28, 29, 30, 31, 32, 335, 33, 36, 37, 38,
     X 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51,
     X 52, 53, 336, 325, 55, 56, 57, 58, 59, 60, 61, 63,
     X 64, 65, 87, 337, 6, 7, 8, 10, 12, 15, 17, 18, 22,
     X 24, 26, 28, 30, 32, 38, 67, 338, 44, 69/
      DATA ( TRANLR ( I ) , I = 2601 , 2700 ) /
     X 72, 57, 58, 59, 64, 87, 339, 340, 6, 7, 8, 9, 10,
     X 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23,
     X 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36,
     X 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49,
     X 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 62,
     X 63, 64, 65, 341, 342, 6, 7, 8, 9, 10, 11, 12, 13,
     X 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26,
     X 27, 28, 29, 30, 31, 32, 33, 34, 35/
      DATA ( TRANLR ( I ) , I = 2701 , 2800 ) /
     X 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48,
     X 49, 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61,
     X 343, 63, 64, 65, 344, 6, 7, 8, 9, 10, 11, 12, 13,
     X 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26,
     X 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39,
     X 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, 52,
     X 53, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63, 64, 65,
     X 6, 7, 8, 9, 10, 11, 12, 13, 14/
      DATA ( TRANLR ( I ) , I = 2801 , 2900 ) /
     X 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27,
     X 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40,
     X 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, 52, 53,
     X 54, 55, 56, 57, 58, 59, 60, 61, 62, 63, 64, 65, 6,
     X 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 345,
     X 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31,
     X 32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44,
     X 45, 46, 47, 48, 49, 50, 51, 52, 53/
      DATA ( TRANLR ( I ) , I = 2901 , 2912 ) /
     X 54, 55, 56, 57, 58, 59, 60, 61, 62, 63, 64, 65/
      END

      BLOCK DATA LRLO06
      CHARACTER VOCLR*1
      INTEGER BVOCLR, ENTLR, REDLR
      INTEGER FRDLR,TRANLR,NLOKLR,PRODLR
      INTEGER LSETLR, RHSLR, LHSLR, ACTLR
      INTEGER VACTLR
      DIMENSION VOCLR ( 1041 )
      DIMENSION BVOCLR ( 167 )
      DIMENSION ENTLR ( 345 )
      DIMENSION REDLR ( 346 )
      DIMENSION FRDLR ( 346 )
      DIMENSION TRANLR ( 2912 )
      DIMENSION NLOKLR ( 366 )
      DIMENSION PRODLR ( 366 )
      DIMENSION LSETLR ( 92 , 87 )
      DIMENSION RHSLR ( 214 )
      DIMENSION LHSLR ( 214 )
      DIMENSION ACTLR ( 214 )
      DIMENSION VACTLR ( 87 )
      COMMON /G4LR1/ VOCLR
      COMMON /G4LR2/ BVOCLR, ENTLR, REDLR
      COMMON /G4LR2/ FRDLR,TRANLR,NLOKLR,PRODLR
      COMMON /G4LR2/ LSETLR, RHSLR, LHSLR, ACTLR
      COMMON /G4LR2/ VACTLR
      DATA ( NLOKLR ( I ) , I = 1 , 100 ) /
     X 55, 84, 89, 86, 90, 82, 87, 87, 82, 63, 82, 64, 64,
     X 9, 9, 9, 64, 9, 9, 64, 15, 64, 9, 82, 64, 9, 82,
     X 64, 9, 64, 64, 64, 9, 64, 67, 89, 4, 64, 67, 86,
     X 84, 7, 64, 64, 67, 5, 64, 3, 64, 64, 64, 64, 7, 31,
     X 82, 64, 64, 27, 64, 82, 8, 29, 8, 29, 9, 29, 66,
     X 27, 27, 80, 64, 64, 64, 64, 64, 64, 36, 49, 77, 64,
     X 67, 90, 82, 82, 86, 84, 89, 63, 63, 63, 63, 64, 64,
     X 68, 68, 68, 64, 68, 64, 64/
      DATA ( NLOKLR ( I ) , I = 101 , 200 ) /
     X 82, 52, 64, 82, 82, 68, 64, 82, 82, 69, 82, 82, 82,
     X 82, 82, 51, 51, 82, 82, 10, 82, 82, 64, 26, 88, 88,
     X 88, 88, 88, 88, 88, 88, 88, 88, 88, 88, 37, 29, 82,
     X 82, 82, 82, 82, 82, 82, 82, 10, 82, 82, 82, 10, 15,
     X 47, 82, 90, 89, 84, 86, 82, 81, 77, 46, 45, 82, 86,
     X 84, 89, 64, 64, 92, 63, 68, 82, 90, 89, 84, 86, 67,
     X 1, 67, 63, 6, 7, 68, 64, 68, 60, 60, 64, 69, 64,
     X 64, 64, 64, 64, 64, 64, 67, 59, 59/
      DATA ( NLOKLR ( I ) , I = 201 , 300 ) /
     X 82, 31, 26, 27, 27, 88, 56, 67, 64, 7, 7, 7, 29,
     X 29, 29, 29, 29, 29, 29, 29, 66, 29, 80, 64, 64, 64,
     X 82, 90, 89, 84, 86, 64, 64, 77, 82, 67, 67, 82, 90,
     X 89, 84, 86, 53, 84, 89, 86, 90, 82, 91, 45, 64, 42,
     X 63, 52, 64, 82, 68, 82, 68, 82, 68, 60, 60, 10, 82,
     X 69, 59, 59, 31, 88, 56, 82, 67, 7, 7, 7, 64, 82,
     X 82, 81, 77, 67, 90, 64, 84, 89, 86, 90, 82, 91, 84,
     X 89, 86, 90, 82, 92, 82, 86, 84, 89/
      DATA ( NLOKLR ( I ) , I = 301 , 366 ) /
     X 64, 68, 68, 68, 69, 31, 67, 67, 81, 90, 82, 64, 89,
     X 84, 86, 67, 67, 45, 92, 82, 86, 84, 89, 91, 67, 64,
     X 82, 90, 65, 64, 84, 89, 86, 90, 82, 91, 92, 45, 91,
     X 45, 90, 82, 64, 89, 84, 86, 38, 84, 89, 86, 90, 82,
     X 91, 84, 89, 86, 90, 82, 91, 64, 82, 90, 89, 84, 86,
     X 64/
      DATA ( PRODLR ( I ) , I = 1 , 100 ) /
     X 4, 82, 78, 79, 24, 168, 2, 1, 168, 213, 168, 23,
     X 105, 192, 193, 191, 68, 195, 194, 102, 120, 105, 196,
     X 168, 209, 190, 168, 132, 189, 22, 9, 7, 184, 11, 114,
     X 77, 211, 13, 124, 80, 81, 182, 14, 19, 125, 185, 16,
     X 183, 10, 12, 20, 8, 180, 164, 167, 17, 18, 173, 15,
     X 168, 211, 155, 185, 153, 183, 152, 150, 171, 172, 147,
     X 107, 106, 108, 104, 72, 69, 6, 4, 43, 67, 116, 26,
     X 168, 168, 79, 82, 78, 211, 130, 129, 126, 103, 73,
     X 205, 206, 207, 66, 210, 131, 76/
      DATA ( PRODLR ( I ) , I = 101 , 200 ) /
     X 168, 4, 21, 168, 168, 209, 74, 168, 168, 209, 168,
     X 168, 168, 168, 168, 101, 99, 168, 168, 187, 168, 168,
     X 75, 168, 144, 139, 141, 136, 145, 138, 146, 133, 135,
     X 142, 134, 143, 3, 154, 168, 168, 168, 168, 168, 168,
     X 168, 168, 186, 168, 168, 168, 188, 121, 4, 168, 24,
     X 78, 82, 79, 168, 45, 42, 4, 4, 168, 79, 82, 78, 52,
     X 56, 61, 128, 208, 168, 24, 78, 82, 79, 115, 211, 124,
     X 214, 212, 181, 200, 70, 204, 88, 87, 93, 198, 98, 96,
     X 94, 95, 97, 92, 100, 91, 84, 83/
      DATA ( PRODLR ( I ) , I = 201 , 300 ) /
     X 168, 165, 167, 169, 170, 137, 118, 123, 71, 177, 174,
     X 176, 156, 157, 162, 160, 161, 158, 159, 163, 149, 151,
     X 148, 110, 109, 111, 168, 24, 78, 82, 79, 39, 33, 35,
     X 168, 117, 28, 168, 24, 78, 82, 79, 54, 82, 78, 79,
     X 24, 168, 58, 4, 55, 4, 127, 51, 50, 168, 209, 168,
     X 209, 168, 209, 90, 89, 197, 168, 209, 86, 85, 168,
     X 140, 119, 168, 112, 175, 179, 178, 32, 168, 168, 46,
     X 44, 29, 27, 25, 82, 78, 79, 24, 168, 57, 82, 78, 79,
     X 24, 168, 59, 168, 79, 82, 78/
      DATA ( PRODLR ( I ) , I = 301 , 366 ) /
     X 53, 201, 202, 203, 199, 166, 122, 123, 36, 38, 168,
     X 24, 78, 82, 79, 31, 30, 4, 61, 168, 79, 82, 78, 62,
     X 113, 40, 168, 34, 47, 48, 82, 78, 79, 24, 168, 65,
     X 60, 4, 63, 4, 37, 168, 24, 78, 82, 79, 4, 82, 78,
     X 79, 24, 168, 64, 82, 78, 79, 24, 168, 5, 49, 168,
     X 24, 78, 82, 79, 41/
      DATA ( LSETLR ( 1 , I ) , I = 1 , 87 ) /
     X  1,0,0,1,1,1,1,0,0,1,0,1,1,0,0,1,0,1,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0/
      DATA ( LSETLR ( 2 , I ) , I = 1 , 87 ) /
     X  1,0,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,0,1,0,0,1,0,0,0,
     X  1,0,0,1,0,0,0,1,0,0,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,0,1,0,0,0/
      DATA ( LSETLR ( 3 , I ) , I = 1 , 87 ) /
     X  1,0,0,0,1,1,1,0,0,1,0,1,1,0,0,1,0,1,0,0,1,0,0,0,0,0,0,
     X  1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0/
      END

      BLOCK DATA LRLO07
      CHARACTER VOCLR*1
      INTEGER BVOCLR, ENTLR, REDLR
      INTEGER FRDLR,TRANLR,NLOKLR,PRODLR
      INTEGER LSETLR, RHSLR, LHSLR, ACTLR
      INTEGER VACTLR
      DIMENSION VOCLR ( 1041 )
      DIMENSION BVOCLR ( 167 )
      DIMENSION ENTLR ( 345 )
      DIMENSION REDLR ( 346 )
      DIMENSION FRDLR ( 346 )
      DIMENSION TRANLR ( 2912 )
      DIMENSION NLOKLR ( 366 )
      DIMENSION PRODLR ( 366 )
      DIMENSION LSETLR ( 92 , 87 )
      DIMENSION RHSLR ( 214 )
      DIMENSION LHSLR ( 214 )
      DIMENSION ACTLR ( 214 )
      DIMENSION VACTLR ( 87 )
      COMMON /G4LR1/ VOCLR
      COMMON /G4LR2/ BVOCLR, ENTLR, REDLR
      COMMON /G4LR2/ FRDLR,TRANLR,NLOKLR,PRODLR
      COMMON /G4LR2/ LSETLR, RHSLR, LHSLR, ACTLR
      COMMON /G4LR2/ VACTLR
      DATA ( LSETLR ( 4 , I ) , I = 1 , 87 ) /
     X  1,0,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,0,1,0,0,1,0,0,0,
     X  1,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,0,1,0,0,0/
      DATA ( LSETLR ( 5 , I ) , I = 1 , 87 ) /
     X  1,0,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,0,1,0,0,1,0,0,0,
     X  1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,0,1,0,0,0/
      DATA ( LSETLR ( 6 , I ) , I = 1 , 87 ) /
     X  1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,
     X  1,1,0,1,0,1,0,1,0,0,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,1,
     X  0,1,1,0,0,1/
      DATA ( LSETLR ( 7 , I ) , I = 1 , 87 ) /
     X  1,1,0,0,1,1,0,0,0,1,0,1,1,0,0,1,0,1,0,1,1,1,1,1,1,1,1,
     X  1,1,0,0,0,1,0,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,1,
     X  0,1,0,0,0,1/
      DATA ( LSETLR ( 8 , I ) , I = 1 , 87 ) /
     X  1,1,0,1,1,1,1,0,0,1,0,1,1,0,0,1,0,1,0,1,1,1,1,1,1,1,1,
     X  1,1,0,0,0,1,0,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,1,
     X  0,1,0,0,0,1/
      DATA ( LSETLR ( 9 , I ) , I = 1 , 87 ) /
     X  1,1,0,0,1,1,1,0,0,1,0,1,1,0,0,1,0,1,0,1,1,1,1,1,1,1,1,
     X  1,1,0,0,0,1,0,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,1,
     X  0,1,0,0,0,1/
      DATA ( LSETLR ( 10 , I ) , I = 1 , 87 ) /
     X  1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,
     X  1,1,0,0,0,1,0,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,1,
     X  0,1,1,0,0,1/
      DATA ( LSETLR ( 11 , I ) , I = 1 , 87 ) /
     X  1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,
     X  1,0,0,1,0,1,0,1,0,0,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,1,1,0,0,1/
      DATA ( LSETLR ( 12 , I ) , I = 1 , 87 ) /
     X  1,1,0,0,1,1,0,0,0,1,0,1,1,0,0,1,0,1,0,1,1,1,1,1,1,1,1,
     X  1,1,0,0,0,1,0,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,
     X  0,1,0,0,0,1/
      DATA ( LSETLR ( 13 , I ) , I = 1 , 87 ) /
     X  1,1,0,1,1,1,1,0,0,1,0,1,1,0,0,1,0,1,0,1,1,1,1,1,1,1,1,
     X  1,1,0,0,0,1,0,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,
     X  0,1,0,0,0,1/
      DATA ( LSETLR ( 14 , I ) , I = 1 , 87 ) /
     X  1,1,0,0,1,1,1,0,0,1,0,1,1,0,0,1,0,1,0,1,1,1,1,1,1,1,1,
     X  1,1,0,0,0,1,0,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,
     X  0,1,0,0,0,1/
      DATA ( LSETLR ( 15 , I ) , I = 1 , 87 ) /
     X  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
     X  1,1,0,1,0,1,0,1,1,0,0,1,1,1,1,0,1,1,0,1,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,1,1,0,0,1,1,0,0,1,0,1,0,1,0,0,0,0,0,1,
     X  0,1,1,0,0,1/
      END

      BLOCK DATA LRLO08
      CHARACTER VOCLR*1
      INTEGER BVOCLR, ENTLR, REDLR
      INTEGER FRDLR,TRANLR,NLOKLR,PRODLR
      INTEGER LSETLR, RHSLR, LHSLR, ACTLR
      INTEGER VACTLR
      DIMENSION VOCLR ( 1041 )
      DIMENSION BVOCLR ( 167 )
      DIMENSION ENTLR ( 345 )
      DIMENSION REDLR ( 346 )
      DIMENSION FRDLR ( 346 )
      DIMENSION TRANLR ( 2912 )
      DIMENSION NLOKLR ( 366 )
      DIMENSION PRODLR ( 366 )
      DIMENSION LSETLR ( 92 , 87 )
      DIMENSION RHSLR ( 214 )
      DIMENSION LHSLR ( 214 )
      DIMENSION ACTLR ( 214 )
      DIMENSION VACTLR ( 87 )
      COMMON /G4LR1/ VOCLR
      COMMON /G4LR2/ BVOCLR, ENTLR, REDLR
      COMMON /G4LR2/ FRDLR,TRANLR,NLOKLR,PRODLR
      COMMON /G4LR2/ LSETLR, RHSLR, LHSLR, ACTLR
      COMMON /G4LR2/ VACTLR
      DATA ( LSETLR ( 16 , I ) , I = 1 , 87 ) /
     X  1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,
     X  1,1,0,0,0,1,0,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,
     X  0,1,1,0,0,1/
      DATA ( LSETLR ( 17 , I ) , I = 1 , 87 ) /
     X  1,0,0,1,0,1,1,0,0,1,0,1,1,0,0,1,0,1,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0/
      DATA ( LSETLR ( 18 , I ) , I = 1 , 87 ) /
     X  1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
     X  1,0,0,1,0,1,0,1,1,0,0,1,1,1,1,0,1,1,0,1,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,1,1,0,0,1,1,0,0,1,0,1,0,1,0,0,0,0,0,0,
     X  0,1,1,0,0,1/
      DATA ( LSETLR ( 19 , I ) , I = 1 , 87 ) /
     X  1,1,0,0,1,1,0,0,0,1,0,1,1,0,0,1,0,1,0,1,1,1,1,1,1,1,1,
     X  1,0,0,0,0,1,0,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,1,0,0,0,1/
      DATA ( LSETLR ( 20 , I ) , I = 1 , 87 ) /
     X  1,1,0,1,1,1,1,0,0,1,0,1,1,0,0,1,0,1,0,1,1,1,1,1,1,1,1,
     X  1,0,0,0,0,1,0,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,1,0,0,0,1/
      DATA ( LSETLR ( 21 , I ) , I = 1 , 87 ) /
     X  1,1,0,0,1,1,1,0,0,1,0,1,1,0,0,1,0,1,0,1,1,1,1,1,1,1,1,
     X  1,0,0,0,0,1,0,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,1,0,0,0,1/
      DATA ( LSETLR ( 22 , I ) , I = 1 , 87 ) /
     X  1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,
     X  1,0,0,0,0,1,0,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,1,1,0,0,1/
      DATA ( LSETLR ( 23 , I ) , I = 1 , 87 ) /
     X  1,0,1,1,0,1,1,1,1,1,1,1,1,1,0,1,1,1,1,0,1,0,0,1,0,0,0,
     X  1,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,0,1,0,0,0/
      DATA ( LSETLR ( 24 , I ) , I = 1 , 87 ) /
     X  1,0,1,1,0,1,1,1,1,1,1,1,1,1,0,1,1,1,1,0,1,0,0,1,0,0,0,
     X  1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,0,1,0,0,0/
      DATA ( LSETLR ( 25 , I ) , I = 1 , 87 ) /
     X  1,0,0,0,0,1,1,0,0,1,0,1,1,0,0,1,0,1,0,0,1,0,0,0,0,0,0,
     X  1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0/
      DATA ( LSETLR ( 26 , I ) , I = 1 , 87 ) /
     X  0,1,0,0,1,0,0,0,0,0,0,1,0,0,0,0,0,1,0,1,1,1,1,1,1,1,1,
     X  1,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,
     X  0,1,0,0,0,1/
      DATA ( LSETLR ( 27 , I ) , I = 1 , 87 ) /
     X  0,1,0,0,1,0,0,0,0,1,0,1,1,0,0,0,0,1,0,1,1,1,1,1,1,1,1,
     X  1,1,0,0,0,1,0,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,1,
     X  0,1,0,0,0,1/
      END

      BLOCK DATA LRLO09
      CHARACTER VOCLR*1
      INTEGER BVOCLR, ENTLR, REDLR
      INTEGER FRDLR,TRANLR,NLOKLR,PRODLR
      INTEGER LSETLR, RHSLR, LHSLR, ACTLR
      INTEGER VACTLR
      DIMENSION VOCLR ( 1041 )
      DIMENSION BVOCLR ( 167 )
      DIMENSION ENTLR ( 345 )
      DIMENSION REDLR ( 346 )
      DIMENSION FRDLR ( 346 )
      DIMENSION TRANLR ( 2912 )
      DIMENSION NLOKLR ( 366 )
      DIMENSION PRODLR ( 366 )
      DIMENSION LSETLR ( 92 , 87 )
      DIMENSION RHSLR ( 214 )
      DIMENSION LHSLR ( 214 )
      DIMENSION ACTLR ( 214 )
      DIMENSION VACTLR ( 87 )
      COMMON /G4LR1/ VOCLR
      COMMON /G4LR2/ BVOCLR, ENTLR, REDLR
      COMMON /G4LR2/ FRDLR,TRANLR,NLOKLR,PRODLR
      COMMON /G4LR2/ LSETLR, RHSLR, LHSLR, ACTLR
      COMMON /G4LR2/ VACTLR
      DATA ( LSETLR ( 28 , I ) , I = 1 , 87 ) /
     X  0,1,0,0,1,0,0,0,0,0,0,1,0,0,0,0,0,1,0,1,1,1,1,1,1,1,1,
     X  1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,1,0,0,0,1/
      DATA ( LSETLR ( 29 , I ) , I = 1 , 87 ) /
     X  0,1,0,0,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,
     X  0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,
     X  0,1,0,0,0,0/
      DATA ( LSETLR ( 30 , I ) , I = 1 , 87 ) /
     X  0,1,0,0,1,0,0,0,0,1,0,1,1,0,0,0,0,1,0,1,1,1,1,1,1,1,1,
     X  1,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,
     X  0,1,0,0,0,1/
      DATA ( LSETLR ( 31 , I ) , I = 1 , 87 ) /
     X  0,1,0,0,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,
     X  1,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,
     X  0,1,0,0,0,1/
      DATA ( LSETLR ( 32 , I ) , I = 1 , 87 ) /
     X  0,1,0,0,1,0,0,0,0,1,0,1,1,0,0,0,0,1,0,1,1,1,1,1,1,1,1,
     X  1,1,0,0,0,1,0,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,
     X  0,1,0,0,0,1/
      DATA ( LSETLR ( 33 , I ) , I = 1 , 87 ) /
     X  0,1,0,0,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,1,0,0,0,0/
      DATA ( LSETLR ( 34 , I ) , I = 1 , 87 ) /
     X  0,1,0,0,1,0,0,0,0,1,0,1,1,0,0,0,0,1,0,1,1,1,1,1,1,1,1,
     X  1,0,0,0,0,1,0,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,1,0,0,0,1/
      DATA ( LSETLR ( 35 , I ) , I = 1 , 87 ) /
     X  0,1,0,0,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,
     X  1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,1,0,0,0,1/
      DATA ( LSETLR ( 36 , I ) , I = 1 , 87 ) /
     X  0,0,0,1,1,0,0,0,0,1,0,0,1,0,0,0,0,1,0,0,1,0,0,0,0,0,0,
     X  1,0,1,1,1,0,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,
     X  1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
     X  1,0,0,0,0,0/
      DATA ( LSETLR ( 37 , I ) , I = 1 , 87 ) /
     X  0,0,0,1,0,0,0,0,0,1,0,0,1,0,0,0,0,1,0,0,1,0,0,0,0,0,0,
     X  1,0,1,1,1,0,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,
     X  1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,
     X  1,0,0,0,0,0/
      DATA ( LSETLR ( 38 , I ) , I = 1 , 87 ) /
     X  0,0,0,1,0,0,0,0,0,1,0,0,1,0,0,0,0,1,0,0,1,0,0,0,0,0,0,
     X  1,0,0,1,1,0,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,0,0,0,0,1,
     X  0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,
     X  1,0,0,0,0,0/
      DATA ( LSETLR ( 39 , I ) , I = 1 , 87 ) /
     X  0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0/
      END

      BLOCK DATA LRLO10
      CHARACTER VOCLR*1
      INTEGER BVOCLR, ENTLR, REDLR
      INTEGER FRDLR,TRANLR,NLOKLR,PRODLR
      INTEGER LSETLR, RHSLR, LHSLR, ACTLR
      INTEGER VACTLR
      DIMENSION VOCLR ( 1041 )
      DIMENSION BVOCLR ( 167 )
      DIMENSION ENTLR ( 345 )
      DIMENSION REDLR ( 346 )
      DIMENSION FRDLR ( 346 )
      DIMENSION TRANLR ( 2912 )
      DIMENSION NLOKLR ( 366 )
      DIMENSION PRODLR ( 366 )
      DIMENSION LSETLR ( 92 , 87 )
      DIMENSION RHSLR ( 214 )
      DIMENSION LHSLR ( 214 )
      DIMENSION ACTLR ( 214 )
      DIMENSION VACTLR ( 87 )
      COMMON /G4LR1/ VOCLR
      COMMON /G4LR2/ BVOCLR, ENTLR, REDLR
      COMMON /G4LR2/ FRDLR,TRANLR,NLOKLR,PRODLR
      COMMON /G4LR2/ LSETLR, RHSLR, LHSLR, ACTLR
      COMMON /G4LR2/ VACTLR
      DATA ( LSETLR ( 40 , I ) , I = 1 , 87 ) /
     X  0,0,0,1,1,0,0,0,0,1,0,0,1,0,0,0,0,1,0,0,1,0,0,0,0,0,0,
     X  1,0,1,1,1,0,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,0,
     X  1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
     X  1,0,0,0,0,0/
      DATA ( LSETLR ( 41 , I ) , I = 1 , 87 ) /
     X  0,0,0,1,0,0,0,0,0,1,0,0,1,0,0,0,0,1,0,0,1,0,0,0,0,0,0,
     X  1,0,1,1,1,0,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,0,
     X  1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
     X  1,0,0,0,0,0/
      DATA ( LSETLR ( 42 , I ) , I = 1 , 87 ) /
     X  0,0,0,1,0,0,0,0,0,1,0,0,1,0,0,0,0,1,0,0,1,0,0,0,0,0,0,
     X  1,0,0,1,1,0,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,0,0,0,0,0,
     X  1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,
     X  1,0,0,0,0,0/
      DATA ( LSETLR ( 43 , I ) , I = 1 , 87 ) /
     X  0,0,0,1,0,0,0,0,0,1,0,0,1,0,0,0,0,1,0,0,1,0,0,0,0,0,0,
     X  1,0,1,1,1,0,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,0,
     X  1,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,
     X  1,0,0,0,0,0/
      DATA ( LSETLR ( 44 , I ) , I = 1 , 87 ) /
     X  0,0,0,1,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,
     X  0,0,0,0,0,0/
      DATA ( LSETLR ( 45 , I ) , I = 1 , 87 ) /
     X  0,0,0,1,0,0,0,0,0,1,0,0,1,0,0,0,0,1,0,0,1,0,0,0,0,0,0,
     X  1,0,0,1,1,0,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,1,1,0,0,0,
     X  1,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,
     X  1,0,0,0,0,0/
      DATA ( LSETLR ( 46 , I ) , I = 1 , 87 ) /
     X  0,0,0,1,0,0,0,0,0,1,0,0,1,0,0,0,0,1,0,0,1,0,0,0,0,0,0,
     X  1,0,0,1,1,0,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,0,0,0,1,0,
     X  0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,
     X  1,0,0,0,0,0/
      DATA ( LSETLR ( 47 , I ) , I = 1 , 87 ) /
     X  0,0,0,1,0,0,0,0,0,1,0,0,1,0,0,0,0,1,0,0,1,0,0,0,0,0,0,
     X  1,0,0,1,1,0,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,0,0,1,0,0,
     X  0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,
     X  1,0,0,0,0,0/
      DATA ( LSETLR ( 48 , I ) , I = 1 , 87 ) /
     X  0,0,0,1,0,0,0,0,0,1,0,0,1,0,0,0,0,1,0,0,1,0,0,0,0,0,0,
     X  1,0,1,1,1,0,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,0,0,1,1,0,
     X  0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
     X  1,0,0,0,0,0/
      DATA ( LSETLR ( 49 , I ) , I = 1 , 87 ) /
     X  0,0,0,1,0,0,0,0,0,1,0,0,1,0,0,0,0,1,0,0,1,0,0,0,0,0,0,
     X  1,0,0,1,1,0,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,0,0,1,0,0,
     X  0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,
     X  1,0,0,0,0,0/
      DATA ( LSETLR ( 50 , I ) , I = 1 , 87 ) /
     X  0,0,0,1,0,0,0,0,0,1,0,0,1,0,0,0,0,1,0,0,1,0,0,0,0,0,0,
     X  1,0,1,1,1,0,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,0,0,1,0,0,
     X  0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,
     X  1,0,0,0,0,0/
      DATA ( LSETLR ( 51 , I ) , I = 1 , 87 ) /
     X  0,0,0,1,0,0,0,0,0,1,0,0,1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,1,0,0,1,0,0,0,0,0,0,0,1,0,0,0,0,1,1,0,0,0,0,0,
     X  0,0,0,0,0,0,1,0,0,0,1,0,0,1,0,1,0,0,0,1,0,0,1,0,0,0,0,
     X  0,0,0,0,1,0/
      END

      BLOCK DATA LRLO11
      CHARACTER VOCLR*1
      INTEGER BVOCLR, ENTLR, REDLR
      INTEGER FRDLR,TRANLR,NLOKLR,PRODLR
      INTEGER LSETLR, RHSLR, LHSLR, ACTLR
      INTEGER VACTLR
      DIMENSION VOCLR ( 1041 )
      DIMENSION BVOCLR ( 167 )
      DIMENSION ENTLR ( 345 )
      DIMENSION REDLR ( 346 )
      DIMENSION FRDLR ( 346 )
      DIMENSION TRANLR ( 2912 )
      DIMENSION NLOKLR ( 366 )
      DIMENSION PRODLR ( 366 )
      DIMENSION LSETLR ( 92 , 87 )
      DIMENSION RHSLR ( 214 )
      DIMENSION LHSLR ( 214 )
      DIMENSION ACTLR ( 214 )
      DIMENSION VACTLR ( 87 )
      COMMON /G4LR1/ VOCLR
      COMMON /G4LR2/ BVOCLR, ENTLR, REDLR
      COMMON /G4LR2/ FRDLR,TRANLR,NLOKLR,PRODLR
      COMMON /G4LR2/ LSETLR, RHSLR, LHSLR, ACTLR
      COMMON /G4LR2/ VACTLR
      DATA ( LSETLR ( 52 , I ) , I = 1 , 87 ) /
     X  0,0,0,1,0,0,0,0,0,1,0,0,1,0,0,0,0,1,0,0,1,0,0,0,0,0,0,
     X  1,0,0,1,1,0,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,0,0,0,0,0,
     X  0,1,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,
     X  1,0,0,0,0,0/
      DATA ( LSETLR ( 53 , I ) , I = 1 , 87 ) /
     X  0,0,0,1,0,0,0,0,0,1,0,0,1,0,0,0,0,1,0,0,1,0,0,0,0,0,0,
     X  1,0,0,1,1,0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,0,0,0,0,0,
     X  0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,0,
     X  0,0,0,0,0,0/
      DATA ( LSETLR ( 54 , I ) , I = 1 , 87 ) /
     X  0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0/
      DATA ( LSETLR ( 55 , I ) , I = 1 , 87 ) /
     X  0,0,0,1,0,0,0,0,0,1,0,0,1,0,0,0,0,1,0,0,1,0,0,0,0,0,0,
     X  1,0,1,1,1,0,1,1,1,1,1,1,1,0,1,1,1,1,1,1,1,1,0,0,0,0,0,
     X  0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,
     X  1,0,0,0,0,0/
      DATA ( LSETLR ( 56 , I ) , I = 1 , 87 ) /
     X  0,0,0,0,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0/
      DATA ( LSETLR ( 57 , I ) , I = 1 , 87 ) /
     X  0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,1,0,0,0,0/
      DATA ( LSETLR ( 58 , I ) , I = 1 , 87 ) /
     X  0,0,0,0,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,1,0,0,0,0/
      DATA ( LSETLR ( 59 , I ) , I = 1 , 87 ) /
     X  0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0/
      DATA ( LSETLR ( 60 , I ) , I = 1 , 87 ) /
     X  0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0/
      DATA ( LSETLR ( 61 , I ) , I = 1 , 87 ) /
     X  0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,1,0,0,0,0/
      DATA ( LSETLR ( 62 , I ) , I = 1 , 87 ) /
     X  0,0,0,0,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,
     X  0,1,0,0,0,0/
      DATA ( LSETLR ( 63 , I ) , I = 1 , 87 ) /
     X  0,0,0,0,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0/
      END

      BLOCK DATA LRLO12
      CHARACTER VOCLR*1
      INTEGER BVOCLR, ENTLR, REDLR
      INTEGER FRDLR,TRANLR,NLOKLR,PRODLR
      INTEGER LSETLR, RHSLR, LHSLR, ACTLR
      INTEGER VACTLR
      DIMENSION VOCLR ( 1041 )
      DIMENSION BVOCLR ( 167 )
      DIMENSION ENTLR ( 345 )
      DIMENSION REDLR ( 346 )
      DIMENSION FRDLR ( 346 )
      DIMENSION TRANLR ( 2912 )
      DIMENSION NLOKLR ( 366 )
      DIMENSION PRODLR ( 366 )
      DIMENSION LSETLR ( 92 , 87 )
      DIMENSION RHSLR ( 214 )
      DIMENSION LHSLR ( 214 )
      DIMENSION ACTLR ( 214 )
      DIMENSION VACTLR ( 87 )
      COMMON /G4LR1/ VOCLR
      COMMON /G4LR2/ BVOCLR, ENTLR, REDLR
      COMMON /G4LR2/ FRDLR,TRANLR,NLOKLR,PRODLR
      COMMON /G4LR2/ LSETLR, RHSLR, LHSLR, ACTLR
      COMMON /G4LR2/ VACTLR
      DATA ( LSETLR ( 64 , I ) , I = 1 , 87 ) /
     X  0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0/
      DATA ( LSETLR ( 65 , I ) , I = 1 , 87 ) /
     X  0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0/
      DATA ( LSETLR ( 66 , I ) , I = 1 , 87 ) /
     X  0,0,0,0,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,
     X  0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,
     X  0,1,0,0,0,0/
      DATA ( LSETLR ( 67 , I ) , I = 1 , 87 ) /
     X  0,0,0,0,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0/
      DATA ( LSETLR ( 68 , I ) , I = 1 , 87 ) /
     X  0,0,0,0,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,
     X  0,0,0,0,0,0/
      DATA ( LSETLR ( 69 , I ) , I = 1 , 87 ) /
     X  0,0,0,0,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0/
      DATA ( LSETLR ( 70 , I ) , I = 1 , 87 ) /
     X  0,0,0,0,1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,1,0,0,0,0/
      DATA ( LSETLR ( 71 , I ) , I = 1 , 87 ) /
     X  0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,1,0,0,0,0/
      DATA ( LSETLR ( 72 , I ) , I = 1 , 87 ) /
     X  0,0,0,0,0,0,0,0,0,1,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0/
      DATA ( LSETLR ( 73 , I ) , I = 1 , 87 ) /
     X  0,0,0,0,0,0,0,0,0,1,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0/
      DATA ( LSETLR ( 74 , I ) , I = 1 , 87 ) /
     X  0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,1,0,0,0,0/
      DATA ( LSETLR ( 75 , I ) , I = 1 , 87 ) /
     X  0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0/
      END

      BLOCK DATA LRLO13
      CHARACTER VOCLR*1
      INTEGER BVOCLR, ENTLR, REDLR
      INTEGER FRDLR,TRANLR,NLOKLR,PRODLR
      INTEGER LSETLR, RHSLR, LHSLR, ACTLR
      INTEGER VACTLR
      DIMENSION VOCLR ( 1041 )
      DIMENSION BVOCLR ( 167 )
      DIMENSION ENTLR ( 345 )
      DIMENSION REDLR ( 346 )
      DIMENSION FRDLR ( 346 )
      DIMENSION TRANLR ( 2912 )
      DIMENSION NLOKLR ( 366 )
      DIMENSION PRODLR ( 366 )
      DIMENSION LSETLR ( 92 , 87 )
      DIMENSION RHSLR ( 214 )
      DIMENSION LHSLR ( 214 )
      DIMENSION ACTLR ( 214 )
      DIMENSION VACTLR ( 87 )
      COMMON /G4LR1/ VOCLR
      COMMON /G4LR2/ BVOCLR, ENTLR, REDLR
      COMMON /G4LR2/ FRDLR,TRANLR,NLOKLR,PRODLR
      COMMON /G4LR2/ LSETLR, RHSLR, LHSLR, ACTLR
      COMMON /G4LR2/ VACTLR
      DATA ( LSETLR ( 76 , I ) , I = 1 , 87 ) /
     X  0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,
     X  0,0,0,0,0,0/
      DATA ( LSETLR ( 77 , I ) , I = 1 , 87 ) /
     X  0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0/
      DATA ( LSETLR ( 78 , I ) , I = 1 , 87 ) /
     X  0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0/
      DATA ( LSETLR ( 79 , I ) , I = 1 , 87 ) /
     X  0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,1,0,0,0,0/
      DATA ( LSETLR ( 80 , I ) , I = 1 , 87 ) /
     X  0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0/
      DATA ( LSETLR ( 81 , I ) , I = 1 , 87 ) /
     X  0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0/
      DATA ( LSETLR ( 82 , I ) , I = 1 , 87 ) /
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0/
      DATA ( LSETLR ( 83 , I ) , I = 1 , 87 ) /
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0/
      DATA ( LSETLR ( 84 , I ) , I = 1 , 87 ) /
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0/
      DATA ( LSETLR ( 85 , I ) , I = 1 , 87 ) /
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0/
      DATA ( LSETLR ( 86 , I ) , I = 1 , 87 ) /
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0/
      DATA ( LSETLR ( 87 , I ) , I = 1 , 87 ) /
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0/
      END

      BLOCK DATA LRLO14
      CHARACTER VOCLR*1
      INTEGER BVOCLR, ENTLR, REDLR
      INTEGER FRDLR,TRANLR,NLOKLR,PRODLR
      INTEGER LSETLR, RHSLR, LHSLR, ACTLR
      INTEGER VACTLR
      DIMENSION VOCLR ( 1041 )
      DIMENSION BVOCLR ( 167 )
      DIMENSION ENTLR ( 345 )
      DIMENSION REDLR ( 346 )
      DIMENSION FRDLR ( 346 )
      DIMENSION TRANLR ( 2912 )
      DIMENSION NLOKLR ( 366 )
      DIMENSION PRODLR ( 366 )
      DIMENSION LSETLR ( 92 , 87 )
      DIMENSION RHSLR ( 214 )
      DIMENSION LHSLR ( 214 )
      DIMENSION ACTLR ( 214 )
      DIMENSION VACTLR ( 87 )
      COMMON /G4LR1/ VOCLR
      COMMON /G4LR2/ BVOCLR, ENTLR, REDLR
      COMMON /G4LR2/ FRDLR,TRANLR,NLOKLR,PRODLR
      COMMON /G4LR2/ LSETLR, RHSLR, LHSLR, ACTLR
      COMMON /G4LR2/ VACTLR
      DATA ( LSETLR ( 88 , I ) , I = 1 , 87 ) /
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0/
      DATA ( LSETLR ( 89 , I ) , I = 1 , 87 ) /
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,1,0,0,1,1,0,1,0,1,0,0,1,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,1,1,0,0,1,0,0,0,1,0,1,0,1,0,0,0,0,0,0,
     X  0,0,0,0,0,0/
      DATA ( LSETLR ( 90 , I ) , I = 1 , 87 ) /
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0/
      DATA ( LSETLR ( 91 , I ) , I = 1 , 87 ) /
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,
     X  1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0/
      DATA ( LSETLR ( 92 , I ) , I = 1 , 87 ) /
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
     X  0,0,0,0,0,0/
      DATA ( RHSLR ( I ) , I = 1 , 100 ) /
     X 3, 1, 3, 0, 3, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
     X 1, 1, 1, 1, 2, 1, 1, 0, 5, 1, 4, 1, 2, 3, 3, 5,
     X 4, 6, 1, 1, 2, 0, 1, 4, 10, 1, 0, 1, 1, 3, 1, 1,
     X 3, 4, 3, 3, 5, 3, 2, 1, 3, 2, 2, 4, 0, 1, 2, 3,
     X 2, 2, 2, 1, 2, 3, 3, 2, 2, 2, 2, 2, 1, 0, 0, 1,
     X 1, 0, 2, 2, 3, 3, 2, 2, 3, 3, 3, 3, 3, 3, 3, 3,
     X 3, 3, 1, 3/
      DATA ( RHSLR ( I ) , I = 101 , 200 ) /
     X 1, 1, 2, 1, 0, 1, 1, 1, 3, 3, 3, 2, 4, 1, 3, 1,
     X 3, 1, 2, 1, 3, 2, 0, 1, 1, 1, 3, 2, 1, 1, 1, 0,
     X 1, 1, 1, 1, 2, 1, 1, 3, 1, 1, 1, 1, 1, 1, 1, 3,
     X 3, 1, 3, 1, 1, 2, 1, 3, 3, 3, 3, 3, 3, 3, 3, 1,
     X 3, 5, 1, 0, 3, 3, 2, 2, 1, 3, 4, 3, 3, 4, 4, 1,
     X 3, 1, 1, 1, 1, 3, 2, 3, 1, 1, 1, 1, 1, 1, 1, 1,
     X 3, 1, 3, 1/
      DATA ( RHSLR ( I ) , I = 201 , 214 ) /
     X 3, 3, 3, 1, 1, 1, 1, 2, 0, 1, 1, 3, 1, 3/
      DATA ( LHSLR ( I ) , I = 1 , 100 ) /
     X 88, 151, 157, 157, 142, 110, 156, 156, 156, 156, 156,
     X 156, 159, 159, 159, 159, 143, 143, 143, 158, 158, 158,
     X 158, 158, 121, 120, 120, 150, 150, 150, 150, 108, 108,
     X 107, 115, 130, 126, 126, 106, 106, 119, 117, 117, 118,
     X 97, 97, 139, 101, 101, 165, 166, 125, 125, 124, 129,
     X 129, 161, 161, 145, 145, 145, 89, 89, 89, 89, 141,
     X 141, 141, 141, 141, 141, 141, 141, 141, 141, 141, 155,
     X 155, 127, 127, 148, 148, 149, 149, 149, 149, 128, 128,
     X 128, 128, 96, 144, 144, 144, 144, 144, 144, 144, 95,
     X 91/
      DATA ( LHSLR ( I ) , I = 101 , 200 ) /
     X 90, 135, 135, 146, 146, 131, 131, 131, 131, 131, 131,
     X 164, 164, 103, 103, 116, 116, 109, 109, 105, 105, 163,
     X 163, 104, 104, 137, 137, 137, 136, 136, 147, 147, 162,
     X 162, 162, 162, 162, 162, 162, 162, 162, 162, 162, 162,
     X 162, 162, 112, 112, 132, 132, 140, 140, 138, 138, 133,
     X 133, 133, 133, 133, 133, 133, 133, 133, 111, 111, 111,
     X 153, 153, 154, 154, 154, 154, 154, 160, 160, 160, 160,
     X 160, 160, 160, 152, 152, 113, 113, 134, 134, 134, 134,
     X 100, 100, 100, 100, 100, 100, 100, 100, 94, 93, 93,
     X 99/
      DATA ( LHSLR ( I ) , I = 201 , 214 ) /
     X 99, 99, 99, 98, 114, 114, 92, 92, 102, 102, 123, 123,
     X 122, 122/
      DATA ( ACTLR ( I ) , I = 1 , 100 ) /
     X 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     X 1000, 1000, 825, 0, 0, 0, 0, 0, 823, 824, 824, 0,
     X 804, 804, 0, 817, 802, 814, 606, 607, 600, 816, 0,
     X 810, 822, 818, 818, 819, 0, 0, 820, 0, 0, 805, 803,
     X 800, 801, 803, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     X 605, 0, 603, 6, 7, 417, 0, 0, 380, 370, 17, 420,
     X 421, 369, 371, 371, 372, 374, 375, 374, 375, 376, 378,
     X 377, 379, 3, 701, 702, 703, 704, 705, 706, 707, 10,
     X 608/
      DATA ( ACTLR ( I ) , I = 101 , 200 ) /
     X 10, 230, 0, 123, 809, 813, 813, 813, 808, 808, 808,
     X 410, 411, 0, 0, 604, 604, 412, 413, 0, 131, 414, 415,
     X 5, 4, 0, 0, 0, 234, 235, 19, 18, 400, 401, 402, 403,
     X 416, 409, 404, 405, 406, 408, 422, 418, 423, 407, 8,
     X 101, 102, 0, 103, 0, 0, 104, 0, 105, 106, 107, 108,
     X 109, 109, 110, 110, 0, 134, 138, 0, 135, 115, 116,
     X 117, 118, 0, 119, 120, 121, 122, 124, 125, 0, 126, 0,
     X 136, 0, 1, 130, 2, 129, 0, 11, 11, 11, 11, 11, 11,
     X 11, 0, 132, 0, 133/
      DATA ( ACTLR ( I ) , I = 201 , 214 ) /
     X 0, 0, 0, 0, 0, 0, 0, 9, 135, 0, 0, 143, 0, 143/
      END

      BLOCK DATA LRLO15
      CHARACTER VOCLR*1
      INTEGER BVOCLR, ENTLR, REDLR
      INTEGER FRDLR,TRANLR,NLOKLR,PRODLR
      INTEGER LSETLR, RHSLR, LHSLR, ACTLR
      INTEGER VACTLR
      DIMENSION VOCLR ( 1041 )
      DIMENSION BVOCLR ( 167 )
      DIMENSION ENTLR ( 345 )
      DIMENSION REDLR ( 346 )
      DIMENSION FRDLR ( 346 )
      DIMENSION TRANLR ( 2912 )
      DIMENSION NLOKLR ( 366 )
      DIMENSION PRODLR ( 366 )
      DIMENSION LSETLR ( 92 , 87 )
      DIMENSION RHSLR ( 214 )
      DIMENSION LHSLR ( 214 )
      DIMENSION ACTLR ( 214 )
      DIMENSION VACTLR ( 87 )
      COMMON /G4LR1/ VOCLR
      COMMON /G4LR2/ BVOCLR, ENTLR, REDLR
      COMMON /G4LR2/ FRDLR,TRANLR,NLOKLR,PRODLR
      COMMON /G4LR2/ LSETLR, RHSLR, LHSLR, ACTLR
      COMMON /G4LR2/ VACTLR
      DATA ( VACTLR ( I ) , I = 1 , 87 ) /
     X 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     X 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 105, 0,
     X 0, 0, 0, 0, 117, 0, 0, 0, 122, 0, 103, 0, 0, 108,
     X 0, 103, 104, 113, 114, 115, 123, 116, 0, 121, 106,
     X 109, 0, 107, 101, 112, 0, 0, 101, 120, 0, 100, 118,
     X 101, 0, 119, 0, 102, 0, 0, 106, 0, 111, 110, 0, 0,
     X 0, 0, 0, 0, 0/
      END

      SUBROUTINE LRLOAD
      EXTERNAL LRLO00, LRLO01, LRLO02, LRLO03, LRLO04, LRLO05, LRLO06,
     X LRLO07, LRLO08, LRLO09, LRLO10, LRLO11, LRLO12, LRLO13, LRLO14,
     X LRLO15
      RETURN
      END

 
      SUBROUTINE LRLTOK ( TOKEN , TOKTXT , LENTOK )
C****** ROUTINE LRLTOK ( TOKEN , TOKTXT , LENTOK ) : PEEK AT THE TOP TOKEN
C****** COMMON: G4LRTK (CURRENT AND LAST TOKEN NUMBER, TEXT, LENGTH)
      INTEGER NTOKEN , LTOKEN , LASTNTOK , LASTLTOK
        CHARACTER TTOKEN*(500)
        CHARACTER LASTTTOK*(500)
      COMMON/G4LRTK1/ NTOKEN , LTOKEN , LASTNTOK , LASTLTOK
      COMMON/G4LRTK2/ TTOKEN , LASTTTOK
      INTEGER TOKEN , LENTOK
        CHARACTER TOKTXT*(500)
      TOKEN     = LASTNTOK
      LENTOK    = LASTLTOK
        TOKTXT = LASTTTOK(1:LASTLTOK)
      RETURN
      END
 
      INTEGER FUNCTION LRPARS ( RECRSV , PARSTR,NSTR,STRPTR , LXPTR ,
     >      NSTATE , RETFLG)
C****** ROUTINE LRPARS : PARSE INPUT (MAIN ROUTINE)
C****** COMMON: G4DBG (DEBUG FLAGS)
        INTEGER DBGFIL , DEBUG , DEBTOK , DEBRED , DEBTRN , DEBSTK
        INTEGER DEBACT , DOACTS
        COMMON /G4DBG/ DBGFIL , DEBUG  , DEBTOK , DEBRED , DEBTRN
        COMMON /G4DBG/ DEBSTK , DEBACT , DOACTS
C****** COMMON: G4LR (LR TABLES)
      INTEGER MLRST, MLRST1, MLRFIN, MLRINT, MLRVCL
      INTEGER MLRV1, MLRVTX, MLRVCT, MLRRED, MLRRE1
      INTEGER MLRTR, MLRTR1, MLRLOK, MLRPRD, MLRRHS
      INTEGER MLREND
      PARAMETER ( MLRST = 345 )
      PARAMETER ( MLRST1 = 346 )
      PARAMETER ( MLRFIN = 5 )
      PARAMETER ( MLRINT = 1 )
      PARAMETER ( MLRVCL = 166 )
      PARAMETER ( MLRV1 = 167 )
      PARAMETER ( MLRVTX = 1041 )
      PARAMETER ( MLRVCT = 87 )
      PARAMETER ( MLRRED = 366 )
      PARAMETER ( MLRRE1 = 367 )
      PARAMETER ( MLRTR  = 2912 )
      PARAMETER ( MLRTR1  = 2913 )
      PARAMETER ( MLRLOK = 92 )
      PARAMETER ( MLRPRD = 214 )
      PARAMETER ( MLRRHS = 10 )
      PARAMETER ( MLREND = 30 )
      CHARACTER VOCLR*1
      INTEGER BVOCLR, ENTLR, REDLR
      INTEGER FRDLR,TRANLR,NLOKLR,PRODLR
      INTEGER LSETLR, RHSLR, LHSLR, ACTLR
      INTEGER VACTLR
      DIMENSION VOCLR ( 1041 )
      DIMENSION BVOCLR ( 167 )
      DIMENSION ENTLR ( 345 )
      DIMENSION REDLR ( 346 )
      DIMENSION FRDLR ( 346 )
      DIMENSION TRANLR ( 2912 )
      DIMENSION NLOKLR ( 366 )
      DIMENSION PRODLR ( 366 )
      DIMENSION LSETLR ( 92 , 87 )
      DIMENSION RHSLR ( 214 )
      DIMENSION LHSLR ( 214 )
      DIMENSION ACTLR ( 214 )
      DIMENSION VACTLR ( 87 )
      COMMON /G4LR1/ VOCLR
      COMMON /G4LR2/ BVOCLR, ENTLR, REDLR
      COMMON /G4LR2/ FRDLR,TRANLR,NLOKLR,PRODLR
      COMMON /G4LR2/ LSETLR, RHSLR, LHSLR, ACTLR
      COMMON /G4LR2/ VACTLR
C****** COMMON: G4LRTK (CURRENT AND LAST TOKEN NUMBER, TEXT, LENGTH)
      INTEGER NTOKEN , LTOKEN , LASTNTOK , LASTLTOK
        CHARACTER TTOKEN*(500)
        CHARACTER LASTTTOK*(500)
      COMMON/G4LRTK1/ NTOKEN , LTOKEN , LASTNTOK , LASTLTOK
      COMMON/G4LRTK2/ TTOKEN , LASTTTOK
C****** COMMON: G4ERR (ERROR COUNT)
      INTEGER ECOUNT, PCOUNT
      COMMON/G4ERR/ECOUNT, PCOUNT
C****** Global constants data loaded in main.
      INTEGER PBLNK, PSTDIN, PSTDOUT, PSTDERR, PMXERR, PENDF
      INTEGER PEOL, PTAB, PDOL, PETX, OK, ERR, DONE
      COMMON/G4CONST/PBLNK, PSTDIN, PSTDOUT, PSTDERR, PMXERR, PENDF
      COMMON/G4CONST/PEOL, PTAB, PDOL, PETX, OK, ERR, DONE
C****** COMMON: G4LRST (LR STATE/VOCABULARY STACKS)
      INTEGER PARSIN , REDNUM , CSTATE , NSTATE, I, LHSVOC, RHSLEN,
     >            STRPTR
      EXTERNAL LRFRED , LRFTRN , LRERR , LXMAC
      INTEGER LRFRED , LRFTRN , LRERR , LXMAC
      LOGICAL RETFLG
      INTEGER RECRSV, LXPTR
      INTEGER PARSTR(*)
      IF(RECRSV .EQ. 1)THEN
        STRPTR=1
      ENDIF
      PARSIN = OK
      I = OK
  100 CONTINUE
      IF ( PARSIN .NE. OK ) GO TO 200
        CALL LRGSTA ( CSTATE )
        REDNUM = LRFRED ( CSTATE , NTOKEN )
        IF ( REDNUM .GT. 0 ) THEN
          PARSIN = LRDRED ( REDNUM , LHSVOC, RHSLEN, RETFLG, RECRSV)
          IF (RETFLG) GOTO 200
        ELSE
          NSTATE = LRFTRN ( CSTATE , NTOKEN )
          IF ( NSTATE .GT. 0  ) THEN
            PARSIN = LRDTRN ( NSTATE , NTOKEN , RECRSV )
            IF ( PARSIN .EQ. OK ) THEN
  101         CONTINUE
              I = LXGTOK (NTOKEN,TTOKEN,LTOKEN,PARSTR,NSTR,STRPTR,
     >                RECRSV,LXPTR)
              J = LXMAC ( NTOKEN,TTOKEN,LTOKEN,PARSTR,NSTR,STRPTR,
     >                RECRSV, LXPTR)
              IF((I.EQ.ERR).OR.(J.EQ.ERR)) GO TO 101
              IF((I.EQ.DONE).OR.(J.EQ.DONE))THEN
150             CALL LRGSTA ( CSTATE )
C               (Any further reductions?)
                REDNUM = LRFRED ( CSTATE , NTOKEN )
                IF ( REDNUM .GT. 0 ) THEN
                  PARSIN = LRDRED(REDNUM, LHSVOC, RHSLEN, RETFLG,
     >                             RECRSV)
                  IF (RETFLG) GOTO 200
                  GO TO 150
                ENDIF
                IF (TTOKEN .EQ. 'ETX') THEN
                   LRPARS = DONE
                   RETURN
                ELSE
                   PARSIN = LRERR ( 7 , PARSTR , NSTR, STRPTR , RECRSV )
                ENDIF

              ENDIF
            ENDIF
          ELSE
            PARSIN = LRERR ( 7 , PARSTR , NSTR, STRPTR , RECRSV )
          ENDIF
        ENDIF
          IF(DEBUG+DEBSTK.EQ.2)CALL LRWSTK(DBGFIL)
      GO TO 100
  200 CONTINUE
      LRPARS = PARSIN
      RETURN
      END
 
C     INTEGER FUNCTION LRPKST ( I , STATE , VOC )
C****** moved to lrsrc so that states & vocstk could be dynamic
C****** ZCM 8/89
 
C     SUBROUTINE LRPOP ( STATE , VOC )
C****** moved to lrsrc so that states & vocstk could be dynamic
C******  ZCM 8/89
 
C     SUBROUTINE LRPOPN ( N )
C****** ROUTINE LRPOPN ( N ) : POP N ITEMS OFF THE STACK
C****** COMMON: G4LRST (LR STATE/VOCABULARY STACKS)
C****** moved to lrsrc so that states & vocstk could be dynamic
 
      SUBROUTINE LRPTOK ( TOKEN , TOKTXT , LENTOK )
C****** ROUTINE LRPTOK ( TOKEN , TOKTXT , LENTOK ) : PEEK AT THE CURRENT TOKEN
C****** COMMON: G4LRTK (CURRENT AND LAST TOKEN NUMBER, TEXT, LENGTH)
      INTEGER NTOKEN , LTOKEN , LASTNTOK , LASTLTOK
        CHARACTER TTOKEN*(500)
        CHARACTER LASTTTOK*(500)
      COMMON/G4LRTK1/ NTOKEN , LTOKEN , LASTNTOK , LASTLTOK
      COMMON/G4LRTK2/ TTOKEN , LASTTTOK
      INTEGER TOKEN , LENTOK
        CHARACTER TOKTXT*(500)
      TOKEN     = NTOKEN
      LENTOK    = LTOKEN
        TOKTXT = TTOKEN(1:LTOKEN)
      RETURN
      END
 
C     SUBROUTINE LRPUSH ( STATE , VOC )
C****** moved to lrsrc so that states and vocstk could be dynamic
C****** ZCM 8/89
 
      SUBROUTINE LRSDBG ( FIL, DEB, TOK, RED, TRN, STK, ACT, DOACT )
C****** ROUTINE LRSDBG ( FIL , DEB , TOK , RED , TRN , STK , ACT , DOACT )
C****** COMMON: G4DBG (DEBUG FLAGS)
        INTEGER DBGFIL , DEBUG , DEBTOK , DEBRED , DEBTRN , DEBSTK
        INTEGER DEBACT , DOACTS
        COMMON /G4DBG/ DBGFIL , DEBUG  , DEBTOK , DEBRED , DEBTRN
        COMMON /G4DBG/ DEBSTK , DEBACT , DOACTS
      INTEGER FIL, DEB, TOK, RED, TRN, STK, ACT, DOACT
        DBGFIL = FIL
        DEBUG  = DEB
        DEBTOK = TOK
        DEBRED = RED
        DEBTRN = TRN
        DEBSTK = STK
        DEBACT = ACT
        DOACTS = DOACT
      RETURN
      END
 
 
      SUBROUTINE LRSERR ( ERRS )
C****** ROUTINE LRSERR ( ERRS ) : SET THE ERROR COUNT
C****** COMMON: G4ERR (ERROR COUNT)
      INTEGER ECOUNT, PCOUNT
      COMMON/G4ERR/ECOUNT, PCOUNT
      INTEGER ERRS
      ECOUNT = ERRS
      RETURN
      END
 
C     SUBROUTINE LRSTKN
C****** ROUTINE LRSTKN : INITIALIZE THE STACK
C****** COMMON: G4LRST (LR STATE/VOCABULARY STACKS)
C****** moved to lrsrc so that states and vocstk could be dynamic
 
      SUBROUTINE LRSTOK ( TOKEN , TOKTXT , LENTOK )
C****** ROUTINE LRSTOK ( TOKEN , TOKTXT , LENTOK ) : SET THE CURRENT TOKEN
C****** COMMON: G4LRTK (CURRENT AND LAST TOKEN NUMBER, TEXT, LENGTH)
      INTEGER NTOKEN , LTOKEN , LASTNTOK , LASTLTOK
        CHARACTER TTOKEN*(500)
        CHARACTER LASTTTOK*(500)
      COMMON/G4LRTK1/ NTOKEN , LTOKEN , LASTNTOK , LASTLTOK
      COMMON/G4LRTK2/ TTOKEN , LASTTTOK
      INTEGER TOKEN , LENTOK
        CHARACTER TOKTXT*(500)
      NTOKEN     = TOKEN
      LTOKEN     = LENTOK
        TTOKEN = TOKTXT(1:LTOKEN)
      RETURN
      END
 
      SUBROUTINE LRVLUP ( TOKEN , TOKTXT , LENTOK )
C****** ROUTINE LRVLUP ( TOKEN , TOKTXT , LENTOK ) : LOOK UP NAME IN VOCABULARY
C****** COMMON: G4LR (LR TABLES)
      INTEGER MLRST, MLRST1, MLRFIN, MLRINT, MLRVCL
      INTEGER MLRV1, MLRVTX, MLRVCT, MLRRED, MLRRE1
      INTEGER MLRTR, MLRTR1, MLRLOK, MLRPRD, MLRRHS
      INTEGER MLREND
      PARAMETER ( MLRST = 345 )
      PARAMETER ( MLRST1 = 346 )
      PARAMETER ( MLRFIN = 5 )
      PARAMETER ( MLRINT = 1 )
      PARAMETER ( MLRVCL = 166 )
      PARAMETER ( MLRV1 = 167 )
      PARAMETER ( MLRVTX = 1041 )
      PARAMETER ( MLRVCT = 87 )
      PARAMETER ( MLRRED = 366 )
      PARAMETER ( MLRRE1 = 367 )
      PARAMETER ( MLRTR  = 2912 )
      PARAMETER ( MLRTR1  = 2913 )
      PARAMETER ( MLRLOK = 92 )
      PARAMETER ( MLRPRD = 214 )
      PARAMETER ( MLRRHS = 10 )
      PARAMETER ( MLREND = 30 )
      CHARACTER VOCLR*1
      INTEGER BVOCLR, ENTLR, REDLR
      INTEGER FRDLR,TRANLR,NLOKLR,PRODLR
      INTEGER LSETLR, RHSLR, LHSLR, ACTLR
      INTEGER VACTLR
      DIMENSION VOCLR ( 1041 )
      DIMENSION BVOCLR ( 167 )
      DIMENSION ENTLR ( 345 )
      DIMENSION REDLR ( 346 )
      DIMENSION FRDLR ( 346 )
      DIMENSION TRANLR ( 2912 )
      DIMENSION NLOKLR ( 366 )
      DIMENSION PRODLR ( 366 )
      DIMENSION LSETLR ( 92 , 87 )
      DIMENSION RHSLR ( 214 )
      DIMENSION LHSLR ( 214 )
      DIMENSION ACTLR ( 214 )
      DIMENSION VACTLR ( 87 )
      COMMON /G4LR1/ VOCLR
      COMMON /G4LR2/ BVOCLR, ENTLR, REDLR
      COMMON /G4LR2/ FRDLR,TRANLR,NLOKLR,PRODLR
      COMMON /G4LR2/ LSETLR, RHSLR, LHSLR, ACTLR
      COMMON /G4LR2/ VACTLR
      INTEGER TOKEN , LENTOK
        CHARACTER TOKTXT*(500)
      INTEGER ITOKEN , EQUAL , I1 , I2 , CH , CHVOC
      EQUAL = 0
      ITOKEN = 1
  100 CONTINUE
        IF ( EQUAL .EQ. 1 .OR. ITOKEN .GT. MLRVCL ) GO TO 200
        I1 = BVOCLR(ITOKEN)
        IF ( ( BVOCLR(ITOKEN+1) - I1 ) .EQ. LENTOK ) THEN
          I2 = 1
          EQUAL = 1
  300     CONTINUE
          IF ( EQUAL .EQ. 0 .OR. I2 .GT. LENTOK ) GO TO 400
            EQUAL = 0
            CH = 0
        CH = ICHAR ( TOKTXT(I2:I2) )
        CHVOC = ICHAR ( VOCLR(I1)(1:1) )
            IF ( CHVOC .EQ. CH ) EQUAL = 1
            I1 = I1 + 1
            I2 = I2 + 1
          GO TO 300
  400     CONTINUE
        ENDIF
        IF ( EQUAL .EQ. 0 ) ITOKEN = ITOKEN + 1
      GO TO 100
  200 CONTINUE
      IF ( EQUAL .EQ. 1 ) THEN
        TOKEN = ITOKEN
      ELSE
        CALL LERRNO ( 1 )
      ENDIF
      RETURN
      END
 
      SUBROUTINE LRWCON()
C****** Write out current stack context to help diagnose syntax errors
C****** ZCM 8/89 make vocstk a parameter since it is now dynamic
      INTEGER COUNT, I, J
C****** COMMON: G4LRST (LR STATE/VOCABULARY STACKS)
C****** COMMON: G4LR (LR TABLES)
      INTEGER MLRST, MLRST1, MLRFIN, MLRINT, MLRVCL
      INTEGER MLRV1, MLRVTX, MLRVCT, MLRRED, MLRRE1
      INTEGER MLRTR, MLRTR1, MLRLOK, MLRPRD, MLRRHS
      INTEGER MLREND
      PARAMETER ( MLRST = 345 )
      PARAMETER ( MLRST1 = 346 )
      PARAMETER ( MLRFIN = 5 )
      PARAMETER ( MLRINT = 1 )
      PARAMETER ( MLRVCL = 166 )
      PARAMETER ( MLRV1 = 167 )
      PARAMETER ( MLRVTX = 1041 )
      PARAMETER ( MLRVCT = 87 )
      PARAMETER ( MLRRED = 366 )
      PARAMETER ( MLRRE1 = 367 )
      PARAMETER ( MLRTR  = 2912 )
      PARAMETER ( MLRTR1  = 2913 )
      PARAMETER ( MLRLOK = 92 )
      PARAMETER ( MLRPRD = 214 )
      PARAMETER ( MLRRHS = 10 )
      PARAMETER ( MLREND = 30 )
      CHARACTER VOCLR*1
      INTEGER BVOCLR, ENTLR, REDLR
      INTEGER FRDLR,TRANLR,NLOKLR,PRODLR
      INTEGER LSETLR, RHSLR, LHSLR, ACTLR
      INTEGER VACTLR
      DIMENSION VOCLR ( 1041 )
      DIMENSION BVOCLR ( 167 )
      DIMENSION ENTLR ( 345 )
      DIMENSION REDLR ( 346 )
      DIMENSION FRDLR ( 346 )
      DIMENSION TRANLR ( 2912 )
      DIMENSION NLOKLR ( 366 )
      DIMENSION PRODLR ( 366 )
      DIMENSION LSETLR ( 92 , 87 )
      DIMENSION RHSLR ( 214 )
      DIMENSION LHSLR ( 214 )
      DIMENSION ACTLR ( 214 )
      DIMENSION VACTLR ( 87 )
      COMMON /G4LR1/ VOCLR
      COMMON /G4LR2/ BVOCLR, ENTLR, REDLR
      COMMON /G4LR2/ FRDLR,TRANLR,NLOKLR,PRODLR
      COMMON /G4LR2/ LSETLR, RHSLR, LHSLR, ACTLR
      COMMON /G4LR2/ VACTLR
C****** Global constants data loaded in main.
      INTEGER PBLNK, PSTDIN, PSTDOUT, PSTDERR, PMXERR, PENDF
      INTEGER PEOL, PTAB, PDOL, PETX, OK, ERR, DONE
      COMMON/G4CONST/PBLNK, PSTDIN, PSTDOUT, PSTDERR, PMXERR, PENDF
      COMMON/G4CONST/PEOL, PTAB, PDOL, PETX, OK, ERR, DONE
      INTEGER STKMKR
      INTEGER GSTKPTR, GVOCAB, STKPTR
      EXTERNAL GSTKPTR, GVOCAB
      COUNT = 0
      STKPTR = GSTKPTR ()
      DO 5 STKMKR = STKPTR,1,-1
         IF(GVOCAB(STKMKR).EQ.MLREND) GO TO 6
5     CONTINUE
6     STKMKR = STKMKR + 1
      DO 10 I = STKMKR+1, STKPTR
        J=GVOCAB(I)
        IF((COUNT+BVOCLR(J+1)-BVOCLR(J)) .GT. 72)THEN
           CALL LZSEND(PSTDOUT)
           COUNT = 0
        ENDIF
        CALL LRWVOC(PSTDOUT, J)
        CALL LZTEXT(PSTDOUT,' $')
        COUNT=COUNT+BVOCLR(J+1)-BVOCLR(J)+1
10    CONTINUE
      RETURN
      END
 
      SUBROUTINE LRWESE ( PFILE )
C****** ROUTINE LRWESE ( PFILE ) : WRITE OUT EXPECTED SET TO FILE
      INTEGER PFILE
      INTEGER MLRST, MLRST1, MLRFIN, MLRINT, MLRVCL
      INTEGER MLRV1, MLRVTX, MLRVCT, MLRRED, MLRRE1
      INTEGER MLRTR, MLRTR1, MLRLOK, MLRPRD, MLRRHS
      INTEGER MLREND
      PARAMETER ( MLRST = 345 )
      PARAMETER ( MLRST1 = 346 )
      PARAMETER ( MLRFIN = 5 )
      PARAMETER ( MLRINT = 1 )
      PARAMETER ( MLRVCL = 166 )
      PARAMETER ( MLRV1 = 167 )
      PARAMETER ( MLRVTX = 1041 )
      PARAMETER ( MLRVCT = 87 )
      PARAMETER ( MLRRED = 366 )
      PARAMETER ( MLRRE1 = 367 )
      PARAMETER ( MLRTR  = 2912 )
      PARAMETER ( MLRTR1  = 2913 )
      PARAMETER ( MLRLOK = 92 )
      PARAMETER ( MLRPRD = 214 )
      PARAMETER ( MLRRHS = 10 )
      PARAMETER ( MLREND = 30 )
        INTEGER VSET
        DIMENSION VSET ( MLRVCT )
        VSET ( 1 ) = 0
      CALL LRESET ( VSET )
      CALL LRWSET ( PFILE , VSET )
      RETURN
      END
 
      SUBROUTINE LRWPAC ( PFILE , ACTION )
C****** ROUTINE LRWPAC ( PFILE , ACTION ) : WRITE PRODUCTION ACTION TO FILE
      INTEGER PFILE , ACTION
      CALL LZTEXT(PFILE,'Production action $')
      CALL LZNUM(PFILE,ACTION)
      CALL LZSEND(PFILE)
      RETURN
      END
 
      SUBROUTINE LRWRED ( PFILE , LHSVOC , RHSLEN )
C****** ROUTINE LRWRED ( PFILE , LHSVOC , RHSLEN ) : WRITE REDUCTION TO FILE
      INTEGER PFILE , LHSVOC , RHSLEN
      INTEGER I , STATE , VOC , OK
      EXTERNAL LRPKST
      INTEGER LRPKST
      CALL LZTEXT(PFILE,'Reduction : $')
      CALL LRWVOC ( PFILE , LHSVOC )
      CALL LZTEXT(PFILE,' ::= $')
      DO 100 I = 0 , RHSLEN-1
        OK = LRPKST ( RHSLEN - 1 - I , STATE , VOC )
        IF ( OK .EQ. 1 .AND. STATE .GT. 0 ) CALL LRWVOC ( PFILE , VOC )
        CALL LZTEXT(PFILE,' $')
  100 CONTINUE
      CALL LZSEND(PFILE)
      RETURN
      END
 
      SUBROUTINE LRWSET ( PFILE , VSET )
C****** ROUTINE LRWSET ( PFILE , VSET ) : WRITE EXPECTED SET TO FILE
      INTEGER PFILE
      INTEGER COUNT
C****** COMMON: G4LR (LR TABLES)
      INTEGER MLRST, MLRST1, MLRFIN, MLRINT, MLRVCL
      INTEGER MLRV1, MLRVTX, MLRVCT, MLRRED, MLRRE1
      INTEGER MLRTR, MLRTR1, MLRLOK, MLRPRD, MLRRHS
      INTEGER MLREND
      PARAMETER ( MLRST = 345 )
      PARAMETER ( MLRST1 = 346 )
      PARAMETER ( MLRFIN = 5 )
      PARAMETER ( MLRINT = 1 )
      PARAMETER ( MLRVCL = 166 )
      PARAMETER ( MLRV1 = 167 )
      PARAMETER ( MLRVTX = 1041 )
      PARAMETER ( MLRVCT = 87 )
      PARAMETER ( MLRRED = 366 )
      PARAMETER ( MLRRE1 = 367 )
      PARAMETER ( MLRTR  = 2912 )
      PARAMETER ( MLRTR1  = 2913 )
      PARAMETER ( MLRLOK = 92 )
      PARAMETER ( MLRPRD = 214 )
      PARAMETER ( MLRRHS = 10 )
      PARAMETER ( MLREND = 30 )
      CHARACTER VOCLR*1
      INTEGER BVOCLR, ENTLR, REDLR
      INTEGER FRDLR,TRANLR,NLOKLR,PRODLR
      INTEGER LSETLR, RHSLR, LHSLR, ACTLR
      INTEGER VACTLR
      DIMENSION VOCLR ( 1041 )
      DIMENSION BVOCLR ( 167 )
      DIMENSION ENTLR ( 345 )
      DIMENSION REDLR ( 346 )
      DIMENSION FRDLR ( 346 )
      DIMENSION TRANLR ( 2912 )
      DIMENSION NLOKLR ( 366 )
      DIMENSION PRODLR ( 366 )
      DIMENSION LSETLR ( 92 , 87 )
      DIMENSION RHSLR ( 214 )
      DIMENSION LHSLR ( 214 )
      DIMENSION ACTLR ( 214 )
      DIMENSION VACTLR ( 87 )
      COMMON /G4LR1/ VOCLR
      COMMON /G4LR2/ BVOCLR, ENTLR, REDLR
      COMMON /G4LR2/ FRDLR,TRANLR,NLOKLR,PRODLR
      COMMON /G4LR2/ LSETLR, RHSLR, LHSLR, ACTLR
      COMMON /G4LR2/ VACTLR
        INTEGER VSET
        DIMENSION VSET ( MLRVCT )
      INTEGER I , IBIT
      COUNT = 6
      DO 100 I = 1 , MLRVCT
        IBIT = 0
        IBIT = VSET ( I )
        IF ( IBIT .EQ. 1 ) THEN
          IF ( BVOCLR(I+1)-BVOCLR(I)+COUNT+1 .GT. 72 ) THEN
            CALL LZSEND ( PFILE )
            COUNT = 0
          ENDIF
          COUNT = COUNT + BVOCLR(I+1) - BVOCLR(I) + 1
          CALL LRWVOC ( PFILE , I )
          CALL LZTEXT(PFILE,' $')
          IF ( COUNT .GE. 72 ) COUNT = 0
        ENDIF
  100 CONTINUE
      RETURN
      END
 
      SUBROUTINE LRWSTK ( PFILE )
C****** ROUTINE LRWSTK ( PFILE ) : WRITE STACK TO FILE
      INTEGER PFILE
      INTEGER STATE , VOC , I , OK , PTR
      EXTERNAL LRPKST
      INTEGER LRPKST
      CALL LRGPTR ( PTR )
      CALL LZSEND(PFILE)
      CALL LZTEXT(PFILE,'Stack:$')
      CALL LZSEND(PFILE)
      CALL LZTEXT(PFILE,'              State  Vocabulary$')
      CALL LZSEND(PFILE)
      CALL LZTEXT(PFILE,'              -----  ----------$')
      CALL LZSEND(PFILE)
      CALL LZTEXT(PFILE,'   Top ->     $')
      I = 0
      OK = LRPKST ( I , STATE , VOC )
  100 CONTINUE
        IF ( OK .EQ. 0 ) GO TO 200
        IF ( I .NE. 0 ) THEN
          CALL LZTEXT(PFILE,'              $')
        ENDIF
        CALL LZNUM(PFILE,STATE)
        CALL LZTEXT(PFILE,'    $')
        IF ( ( I + 1 ) .NE. PTR ) CALL LRWVOC ( PFILE , VOC )
        CALL LZSEND(PFILE)
        I = I + 1
        OK = LRPKST ( I , STATE , VOC )
      GO TO 100
  200 CONTINUE
      CALL LZTEXT(PFILE,'              -----  ----------$')
      CALL LZSEND(PFILE)
      CALL LZSEND(PFILE)
      RETURN
      END
 
      SUBROUTINE LRWSYN ( )
C****** ROUTINE LRWSYN: Attempt a more self-explanatory syntax error printout
C****** ZCM 8/89 add states as parameter since it's dynamic
C****** COMMON: G4ERR (ERROR COUNT)
      INTEGER ECOUNT, PCOUNT
      COMMON/G4ERR/ECOUNT, PCOUNT
C****** COMMON: G4LR (LR TABLES)
      INTEGER MLRST, MLRST1, MLRFIN, MLRINT, MLRVCL
      INTEGER MLRV1, MLRVTX, MLRVCT, MLRRED, MLRRE1
      INTEGER MLRTR, MLRTR1, MLRLOK, MLRPRD, MLRRHS
      INTEGER MLREND
      PARAMETER ( MLRST = 345 )
      PARAMETER ( MLRST1 = 346 )
      PARAMETER ( MLRFIN = 5 )
      PARAMETER ( MLRINT = 1 )
      PARAMETER ( MLRVCL = 166 )
      PARAMETER ( MLRV1 = 167 )
      PARAMETER ( MLRVTX = 1041 )
      PARAMETER ( MLRVCT = 87 )
      PARAMETER ( MLRRED = 366 )
      PARAMETER ( MLRRE1 = 367 )
      PARAMETER ( MLRTR  = 2912 )
      PARAMETER ( MLRTR1  = 2913 )
      PARAMETER ( MLRLOK = 92 )
      PARAMETER ( MLRPRD = 214 )
      PARAMETER ( MLRRHS = 10 )
      PARAMETER ( MLREND = 30 )
      CHARACTER VOCLR*1
      INTEGER BVOCLR, ENTLR, REDLR
      INTEGER FRDLR,TRANLR,NLOKLR,PRODLR
      INTEGER LSETLR, RHSLR, LHSLR, ACTLR
      INTEGER VACTLR
      DIMENSION VOCLR ( 1041 )
      DIMENSION BVOCLR ( 167 )
      DIMENSION ENTLR ( 345 )
      DIMENSION REDLR ( 346 )
      DIMENSION FRDLR ( 346 )
      DIMENSION TRANLR ( 2912 )
      DIMENSION NLOKLR ( 366 )
      DIMENSION PRODLR ( 366 )
      DIMENSION LSETLR ( 92 , 87 )
      DIMENSION RHSLR ( 214 )
      DIMENSION LHSLR ( 214 )
      DIMENSION ACTLR ( 214 )
      DIMENSION VACTLR ( 87 )
      COMMON /G4LR1/ VOCLR
      COMMON /G4LR2/ BVOCLR, ENTLR, REDLR
      COMMON /G4LR2/ FRDLR,TRANLR,NLOKLR,PRODLR
      COMMON /G4LR2/ LSETLR, RHSLR, LHSLR, ACTLR
      COMMON /G4LR2/ VACTLR
C****** COMMON: G4LRTK (CURRENT AND LAST TOKEN NUMBER, TEXT, LENGTH)
      INTEGER NTOKEN , LTOKEN , LASTNTOK , LASTLTOK
        CHARACTER TTOKEN*(500)
        CHARACTER LASTTTOK*(500)
      COMMON/G4LRTK1/ NTOKEN , LTOKEN , LASTNTOK , LASTLTOK
      COMMON/G4LRTK2/ TTOKEN , LASTTTOK
C****** Global constants data loaded in main.
      INTEGER PBLNK, PSTDIN, PSTDOUT, PSTDERR, PMXERR, PENDF
      INTEGER PEOL, PTAB, PDOL, PETX, OK, ERR, DONE
      COMMON/G4CONST/PBLNK, PSTDIN, PSTDOUT, PSTDERR, PMXERR, PENDF
      COMMON/G4CONST/PEOL, PTAB, PDOL, PETX, OK, ERR, DONE
      CALL LZTEXT(PSTDOUT,'Attempting to parse after following context:
     >$')
      CALL LZSEND(PSTDOUT)
      CALL LRWCON()
      CALL LZSEND(PSTDOUT)
      CALL LZTEXT(PSTDOUT,'which may not be followed by "$')
      CALL LRWVOC(PSTDOUT,NTOKEN)
      CALL LZTEXT(PSTDOUT,'" in this context.$')
      CALL LZSEND(PSTDOUT)
      IF(PCOUNT .NE. 0)THEN
        CALL LZTEXT(PSTDOUT,
     >  'Count of parentheses unbalanced: left = right $')
        IF(PCOUNT .GT. 0)THEN
           CALL LZTEXT(PSTDOUT,'+$')
        ELSE
           CALL LZTEXT(PSTDOUT,'-$')
        ENDIF
        CALL LZNUM(PSTDOUT,ABS(PCOUNT))
        CALL LZTEXT(PSTDOUT,'.$')
        CALL LZSEND(PSTDOUT)
        PCOUNT = 0
      ENDIF
      RETURN
      END
 
 
      SUBROUTINE LRWTRN ( PFILE , TOKEN )
C****** ROUTINE LRWTRN ( PFILE , TOKEN ) : WRITE TRANSITION TO FILE
      INTEGER PFILE , TOKEN
      CALL LZTEXT(PFILE,'Transition, $')
      CALL LRWVOC ( PFILE , TOKEN )
      CALL LZTEXT(PFILE,' has been put on the stack.$')
      CALL LZSEND(PFILE)
      RETURN
      END
 
      SUBROUTINE LRWVAC ( PFILE , ACTION )
C****** ROUTINE LRWVAC ( PFILE , ACTION ) : WRITE VOCABULARY ACTION TO FILE
      INTEGER PFILE , ACTION
      CALL LZTEXT(PFILE,'Vocabulary action $')
      CALL LZNUM(PFILE,ACTION)
      CALL LZSEND(PFILE)
      RETURN
      END
 
      SUBROUTINE LRWVOC ( PFILE , VOC )
C****** ROUTINE LRWVOC ( PFILE , VOC ) : WRITE VOCABULARY ITEM TO FILE
C****** COMMON: G4LR (LR TABLES)
      INTEGER MLRST, MLRST1, MLRFIN, MLRINT, MLRVCL
      INTEGER MLRV1, MLRVTX, MLRVCT, MLRRED, MLRRE1
      INTEGER MLRTR, MLRTR1, MLRLOK, MLRPRD, MLRRHS
      INTEGER MLREND
      PARAMETER ( MLRST = 345 )
      PARAMETER ( MLRST1 = 346 )
      PARAMETER ( MLRFIN = 5 )
      PARAMETER ( MLRINT = 1 )
      PARAMETER ( MLRVCL = 166 )
      PARAMETER ( MLRV1 = 167 )
      PARAMETER ( MLRVTX = 1041 )
      PARAMETER ( MLRVCT = 87 )
      PARAMETER ( MLRRED = 366 )
      PARAMETER ( MLRRE1 = 367 )
      PARAMETER ( MLRTR  = 2912 )
      PARAMETER ( MLRTR1  = 2913 )
      PARAMETER ( MLRLOK = 92 )
      PARAMETER ( MLRPRD = 214 )
      PARAMETER ( MLRRHS = 10 )
      PARAMETER ( MLREND = 30 )
      CHARACTER VOCLR*1
      INTEGER BVOCLR, ENTLR, REDLR
      INTEGER FRDLR,TRANLR,NLOKLR,PRODLR
      INTEGER LSETLR, RHSLR, LHSLR, ACTLR
      INTEGER VACTLR
      DIMENSION VOCLR ( 1041 )
      DIMENSION BVOCLR ( 167 )
      DIMENSION ENTLR ( 345 )
      DIMENSION REDLR ( 346 )
      DIMENSION FRDLR ( 346 )
      DIMENSION TRANLR ( 2912 )
      DIMENSION NLOKLR ( 366 )
      DIMENSION PRODLR ( 366 )
      DIMENSION LSETLR ( 92 , 87 )
      DIMENSION RHSLR ( 214 )
      DIMENSION LHSLR ( 214 )
      DIMENSION ACTLR ( 214 )
      DIMENSION VACTLR ( 87 )
      COMMON /G4LR1/ VOCLR
      COMMON /G4LR2/ BVOCLR, ENTLR, REDLR
      COMMON /G4LR2/ FRDLR,TRANLR,NLOKLR,PRODLR
      COMMON /G4LR2/ LSETLR, RHSLR, LHSLR, ACTLR
      COMMON /G4LR2/ VACTLR
      INTEGER PFILE , VOC
      INTEGER I , I1 , I2 , CHVOC
      I1 = BVOCLR(VOC)
      I2 = BVOCLR(VOC+1) - 1
      DO 100 I = I1 , I2
        CHVOC = ICHAR ( VOCLR(I)(1:1) )
        CALL LZCHAR(PFILE,CHVOC)
  100 CONTINUE
      RETURN
      END
 
      INTEGER FUNCTION LXGTOK ( TOKEN , TOKTXT , LENTOK , PARSTR , NSTR,
     >                          STRPTR , RECRSV , LXPTR)
C****** ROUTINE LXGTOK (TOKEN,TOKTXT,LENTOK,PARSTR,NSTR,STRPTR,RECRSV,LXPTR) :
C******                       GET NEXT TOKEN
C****** Global constants data loaded in main.
      INTEGER PBLNK, PSTDIN, PSTDOUT, PSTDERR, PMXERR, PENDF
      INTEGER PEOL, PTAB, PDOL, PETX, OK, ERR, DONE
      COMMON/G4CONST/PBLNK, PSTDIN, PSTDOUT, PSTDERR, PMXERR, PENDF
      COMMON/G4CONST/PEOL, PTAB, PDOL, PETX, OK, ERR, DONE
      INTEGER MLRST, MLRST1, MLRFIN, MLRINT, MLRVCL
      INTEGER MLRV1, MLRVTX, MLRVCT, MLRRED, MLRRE1
      INTEGER MLRTR, MLRTR1, MLRLOK, MLRPRD, MLRRHS
      INTEGER MLREND
      PARAMETER ( MLRST = 345 )
      PARAMETER ( MLRST1 = 346 )
      PARAMETER ( MLRFIN = 5 )
      PARAMETER ( MLRINT = 1 )
      PARAMETER ( MLRVCL = 166 )
      PARAMETER ( MLRV1 = 167 )
      PARAMETER ( MLRVTX = 1041 )
      PARAMETER ( MLRVCT = 87 )
      PARAMETER ( MLRRED = 366 )
      PARAMETER ( MLRRE1 = 367 )
      PARAMETER ( MLRTR  = 2912 )
      PARAMETER ( MLRTR1  = 2913 )
      PARAMETER ( MLRLOK = 92 )
      PARAMETER ( MLRPRD = 214 )
      PARAMETER ( MLRRHS = 10 )
      PARAMETER ( MLREND = 30 )
C****** COMMON: G4DBG (DEBUG FLAGS)
        INTEGER DBGFIL , DEBUG , DEBTOK , DEBRED , DEBTRN , DEBSTK
        INTEGER DEBACT , DOACTS
        COMMON /G4DBG/ DBGFIL , DEBUG  , DEBTOK , DEBRED , DEBTRN
        COMMON /G4DBG/ DEBSTK , DEBACT , DOACTS
C****** COMMON: G4LX (LEXICAL TABLES)
      INTEGER MLEXST, MLEXNX
      PARAMETER ( MLEXST = 481 )
      PARAMETER ( MLEXNX = 2442 )
      INTEGER FLEX,BLEX,DLEX,NLEX,CLEX,LLEX
      DIMENSION FLEX ( 481 )
      DIMENSION BLEX ( 481 )
      DIMENSION DLEX ( 481 )
      DIMENSION NLEX ( 2442 )
      DIMENSION CLEX ( 2442 )
      DIMENSION LLEX ( 481 )
      COMMON/G4LX/FLEX,BLEX,DLEX,NLEX,CLEX,LLEX
C****** COMMON: G4ERR (ERROR COUNT)
      INTEGER ECOUNT, PCOUNT
      COMMON/G4ERR/ECOUNT, PCOUNT
      INTEGER TOKEN , LENTOK, STRPTR, RECRSV, LXPTR
        CHARACTER TOKTXT*(500)
        INTEGER PARSTR(*)
      INTEGER FLAG, NSTATE, GSTATE, STATE, CH, STKLEX, IRETURN, I, L
      DIMENSION STKLEX ( 500)
      EXTERNAL LXNEXT , LXERR
      INTEGER LXNEXT , LXERR
 
      L = OK
   99 CONTINUE
      STATE = 1
      LENTOK = 0
      IF( LXGCHR(CH,PARSTR,NSTR,STRPTR,RECRSV,LXPTR) .EQ. DONE )
     >    THEN
        L = DONE
        TOKEN = -1
        TOKTXT = 'ETX'
        LENTOK = 3
        GO TO 2
      ELSE
        CALL LXPREP ( CH , PARSTR , NSTR, STRPTR, RECRSV , LXPTR)
      ENDIF
      NSTATE = LXNEXT ( STATE , CH )
 
  200 CONTINUE
      IF ( NSTATE .EQ. 0 ) GO TO 300
        IF ( LENTOK .EQ. 500+1 ) THEN
          FLAG = LXERR ( 3 , PARSTR , NSTR, STRPTR , RECRSV )
          IF ( FLAG .EQ. ERR ) GO TO 99
          IF ( FLAG .EQ. DONE ) GO TO 2
        ENDIF
        IF ( LENTOK .LT. 500) THEN
          LENTOK = LENTOK + 1
        TOKTXT(LENTOK:LENTOK) = CHAR ( CH )
          STKLEX  ( LENTOK ) = STATE
        ENDIF
        STATE = NSTATE
        I = LXGCHR ( CH , PARSTR , NSTR, STRPTR, RECRSV , LXPTR)
        NSTATE = LXNEXT ( STATE , CH )
        GO TO 200
 
  300 CONTINUE
      IF(L.NE.DONE)CALL LXPUSH ( CH )
 
      IF ( LENTOK .EQ. 0 ) THEN
        IF ( CH .EQ. PETX ) THEN
           TOKEN = -1
           TOKTXT = 'ETX'
           LENTOK = 3
           L = DONE
           GO TO 2
        ENDIF
        IF ( CH .NE. PENDF ) THEN
          FLAG = LXERR ( 4, PARSTR , NSTR, STRPTR , RECRSV  )
          IF ( FLAG .EQ. DONE ) GO TO 2
          GO TO 99
        ELSE
          TOKTXT = 'END'
          LENTOK = 3
          TOKEN = MLREND
          GO TO 2
        ENDIF
      ENDIF
 
      IF ( FLEX(STATE) .EQ. 0 ) THEN
  400 CONTINUE
        IF ( LENTOK .LE. 0 .OR. FLEX(STATE) .NE. 0 ) GO TO 500
        CH = ICHAR ( TOKTXT(LENTOK:LENTOK) )
          CALL LXPUSH ( CH )
          STATE  = STKLEX ( LENTOK )
          LENTOK = LENTOK - 1
        GO TO 400
  500   CONTINUE
        IF ( LENTOK .EQ. 0 ) THEN
          FLAG = LXERR ( 5 , PARSTR , NSTR, STRPTR , RECRSV )
          IF ( FLAG .EQ. DONE ) GO TO 2
          GO TO 99
        ENDIF
      ENDIF
 
      TOKEN = FLEX ( STATE )
 
  700 CONTINUE
      IF ( LLEX ( STATE ) .NE. STATE ) THEN
        GSTATE = LLEX ( STATE )
        IRETURN = 0
  800   CONTINUE
          IRETURN = IRETURN + 1
          IF ( ( IRETURN .LT. LENTOK ) .AND.
     X         ( GSTATE .NE. STKLEX(LENTOK+1-IRETURN) ) .AND.
     X         ( FLEX(STKLEX(LENTOK+1-IRETURN)) .EQ. 0 ) ) GO TO 800
        IF ( IRETURN .EQ. LENTOK ) CALL LERRNO(6)
        DO 900 I = 1 , IRETURN
        CH = ICHAR ( TOKTXT(LENTOK-(I-1):LENTOK-(I-1)) )
          CALL LXPUSH ( CH )
  900   CONTINUE
        LENTOK = LENTOK - IRETURN
        IF ( ( STKLEX(LENTOK+1) .LT. STATE ) .AND.
     X       ( FLEX(STKLEX(LENTOK+1)) .NE. 0 ) ) THEN
          STATE = STKLEX(LENTOK+1)
          TOKEN = FLEX(STATE)
          GO TO 700
        ENDIF
      ENDIF
 
    2 CONTINUE
        IF(DEBUG+DEBTOK.EQ.2)CALL LXWTOK(DBGFIL,TOKEN,TOKTXT,LENTOK)
 
        IF(LENTOK .EQ. 1)THEN
           IF(TOKTXT(1:1) .EQ. '(')THEN
              PCOUNT = PCOUNT + 1
           ELSEIF(TOKTXT(1:1) .EQ. ')')THEN
              PCOUNT = PCOUNT - 1
           ENDIF
        ENDIF
      LXGTOK = L
      RETURN
      END
 
      SUBROUTINE LXINIT
C****** ROUTINE LXINIT : INITIALIZE THE LEXICAL ANALYZER
C****** Global constants data loaded in main.
      INTEGER PBLNK, PSTDIN, PSTDOUT, PSTDERR, PMXERR, PENDF
      INTEGER PEOL, PTAB, PDOL, PETX, OK, ERR, DONE
      COMMON/G4CONST/PBLNK, PSTDIN, PSTDOUT, PSTDERR, PMXERR, PENDF
      COMMON/G4CONST/PEOL, PTAB, PDOL, PETX, OK, ERR, DONE
      EXTERNAL LXLOAD
        CALL LXLINN
        CALL LXSTKN
        CALL LXPUSH ( PBLNK )
      RETURN
      END
 
      INTEGER FUNCTION LXLEN ( T )
C****** ROUTINE LXLEN : COMPUTE LENGTH OF STRING T LESS TRAILING BLANKS
      CHARACTER * (*) T
      INTEGER L
      L = LEN(T)
100   CONTINUE
        IF((T(L:L).NE.' ').OR.(L.EQ.1))GO TO 200
        L=L-1
        GO TO 100
200   CONTINUE
      LXLEN = L
      RETURN
      END
 
      SUBROUTINE LXLINN
C****** ROUTINE LXLINN : INITIALIZE INPUT LINE BUFFER
C****** COMMON: G4LXTX (CURRENT INPUT LINE)
      INTEGER NCHARS , LINENO , LINPOS , LINLEN
        CHARACTER LINTEX*(500)
      COMMON/G4LXTX1/ NCHARS , LINENO , LINPOS , LINLEN
      COMMON/G4LXTX2/ LINTEX
      LINLEN = 0
      LINPOS = 1
      NCHARS = 0
      LINENO = 0
      RETURN
      END
 

      BLOCK DATA LXLO00
      INTEGER FLEX,BLEX,DLEX,NLEX,CLEX,LLEX
      DIMENSION FLEX ( 481 )
      DIMENSION BLEX ( 481 )
      DIMENSION DLEX ( 481 )
      DIMENSION NLEX ( 2442 )
      DIMENSION CLEX ( 2442 )
      DIMENSION LLEX ( 481 )
      COMMON/G4LX/FLEX,BLEX,DLEX,NLEX,CLEX,LLEX
      DATA ( FLEX(I) , I = 1, 100 )/
     X 0, 3, 4, 5, 6, 7, 8, 9, 10, 11, 13, 14, 15, 16, 17, 18, 19, 21,
     X 24, 28, 30, 30, 30, 30, 32, 33, 40, 40, 71, 71, 82, 84, 85, 87,
     X 36, 36, 37, 37, 38, 38, 39, 39, 41, 41, 41, 41, 41, 41, 41, 42,
     X 42, 44, 44, 47, 47, 46, 46, 50, 50, 51, 51, 52, 52, 53, 53, 54,
     X 54, 55, 55, 56, 56, 58, 58, 59, 59, 60, 60, 62, 62, 63, 63, 64,
     X 64, 66, 66, 67, 67, 69, 69, 72, 72, 73, 73, 75, 75, 76, 76, 78,
     X 78, 79/
      DATA ( FLEX(I) , I = 101, 200 )/
     X 79, 80, 80, 1, 2, 2, 20, 20, 22, 23, 25, 26, 26, 27, 29, 83,
     X 83, 86, 86, 35, 12, 34, 68, 68, 68, 68, 68, 68, 68, 68, 68, 68,
     X 68, 68, 68, 68, 68, 68, 68, 68, 68, 68, 68, 68, 68, 68, 68, 68,
     X 68, 68, 68, 68, 68, 68, 68, 68, 68, 68, 68, 68, 68, 68, 68, 68,
     X 68, 68, 68, 68, 68, 68, 68, 68, 68, 68, 68, 68, 68, 68, 68, 68,
     X 68, 68, 68, 68, 68, 68, 68, 68, 68, 68, 68, 68, 68, 68, 68, 68,
     X 68, 68, 68, 68/
      DATA ( FLEX(I) , I = 201, 300 )/
     X 68, 68, 68, 68, 68, 68, 68, 68, 68, 68, 68, 68, 68, 68, 68, 68,
     X 68, 68, 68, 68, 68, 68, 68, 68, 68, 68, 68, 68, 68, 31, 31, 31,
     X 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31,
     X 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31,
     X 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31,
     X 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31,
     X 31, 31, 31, 31/
      DATA ( FLEX(I) , I = 301, 400 )/
     X 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31,
     X 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31, 31,
     X 31, 31, 31, 65, 65, 61, 70, 74, 74, 74, 74, 74, 74, 74, 74, 74,
     X 74, 74, 74, 49, 49, 49, 49, 49, 49, 49, 49, 43, 43, 48, 45, 77,
     X 57, 81, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     X 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0/
      DATA ( FLEX(I) , I = 401, 481 )/
     X 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     X 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     X 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     X 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0/
      DATA ( BLEX(I) , I = 1, 100 )/
     X 350, 0, 0, 0, 821, 640, 0, 0, 642, 0, 679, 0, 2250, 687, 0,
     X 787, 0, 0, 549, 0, 547, 434, 0, 179, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     X 0, 0, 0, 0, 0, 0, 0, 0, 0, 512, 1, 589, 0, 257, 0, 0, 5, 3, 0,
     X 0, 0, 0, 521, 158, 532, 168, 0, 0, 0, 0, 524, 160, 0, 0, 0, 0,
     X 0, 0, 531, 167, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     X 0, 0, 4, 2, 0, 0, 0, 0, 0, 0, 0/
      DATA ( BLEX(I) , I = 101, 200 )/
     X 0, 0, 0, 0, 637, 0, 631, 0, 0, 0, 0, 561, 0, 0, 0, 788, 0, 789,
     X 0, 0, 0, 0, 0, 168, 153, 192, 150, 182, 148, 156, 152, 155, 190,
     X 149, 142, 145, 147, 144, 179, 135, 177, 132, 172, 123, 169, 122,
     X 125, 134, 118, 129, 111, 152, 132, 127, 110, 120, 0, 110, 126,
     X 140, 112, 137, 109, 119, 115, 116, 108, 111, 95, 105, 92, 136,
     X 106, 88, 93, 96, 92, 98, 90, 130, 93, 96, 84, 82, 78, 86, 83,
     X 85, 69, 67, 76, 79, 108, 62, 67, 73, 58, 105, 63, 59/
      DATA ( BLEX(I) , I = 201, 300 )/
     X 67, 66, 63, 49, 56, 44, 53, 56, 55, 58, 44, 38, 67, 48, 47, 26,
     X 37, 33, 44, 28, 33, 61, 18, 27, 17, 10, 11, 14, 83, 531, 515,
     X 529, 510, 514, 506, 0, 518, 508, 511, 514, 506, 499, 504, 507,
     X 495, 485, 498, 421, 463, 409, 459, 458, 399, 401, 412, 389, 397,
     X 377, 385, 413, 390, 373, 381, 360, 348, 311, 448, 380, 376, 320,
     X 311, 312, 305, 306, 290, 300, 284, 390, 301, 282, 288, 291, 287,
     X 292, 282, 286, 288, 287, 275, 274, 270, 278, 275, 277, 261, 261,
     X 271, 274, 270, 255/
      DATA ( BLEX(I) , I = 301, 400 )/
     X 260, 266, 251, 256, 263, 251, 259, 258, 255, 241, 248, 236,
     X 246, 249, 247, 239, 224, 218, 231, 215, 227, 206, 217, 209, 219,
     X 200, 204, 199, 216, 208, 16, 8, 13, 201, 517, 1116, 1090, 0,
     X 789, 1968, 1994, 580, 582, 1056, 1481, 1517, 1030, 1152, 566,
     X 1708, 1686, 1018, 1740, 1955, 992, 1750, 563, 1934, 1913, 0, 0,
     X 0, 0, 4, 0, 934, 1190, 709, 1317, 1, 0, 0, 800, 773, 783, 880,
     X 884, 835, 798, 795, 770, 799, 875, 907, 805, 769, 0, 979, 964,
     X 2131, 2068, 2027, 817, 648, 826, 639, 581, 643, 17, 622/
      DATA ( BLEX(I) , I = 401, 481 )/
     X 632, 829, 649, 841, 0, 826, 638, 849, 567, 0, 1, 0, 0, 832, 0,
     X 2105, 2004, 2095, 2121, 2083, 2053, 19, 0, 615, 601, 650, 0, 0,
     X 842, 0, 2282, 2314, 606, 2154, 2180, 807, 576, 1, 805, 1892,
     X 1871, 947, 1652, 1630, 817, 2195, 2210, 610, 1718, 614, 1100,
     X 2225, 2240, 1850, 1829, 626, 932, 1619, 1597, 634, 906, 617,
     X 1662, 621, 1002, 1808, 1563, 1573, 882, 872, 846, 1787, 1541,
     X 1766, 1507, 604, 1404, 778, 0, 1427, 0/
      END

      BLOCK DATA LXLO01
      INTEGER FLEX,BLEX,DLEX,NLEX,CLEX,LLEX
      DIMENSION FLEX ( 481 )
      DIMENSION BLEX ( 481 )
      DIMENSION DLEX ( 481 )
      DIMENSION NLEX ( 2442 )
      DIMENSION CLEX ( 2442 )
      DIMENSION LLEX ( 481 )
      COMMON/G4LX/FLEX,BLEX,DLEX,NLEX,CLEX,LLEX
      DATA ( DLEX(I) , I = 1, 100 )/
     X 23, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     X 22, 0, 0, 23, 0, 0, 22, 23, 22, 23, 0, 0, 0, 0, 22, 23, 22, 23,
     X 22, 23, 22, 23, 22, 23, 22, 22, 23, 23, 0, 22, 23, 22, 23, 22,
     X 23, 22, 23, 22, 23, 22, 23, 22, 23, 22, 23, 22, 23, 22, 23, 22,
     X 23, 22, 23, 22, 23, 22, 23, 22, 23, 22, 23, 22, 23, 22, 23, 22,
     X 23, 22, 23, 22, 23, 22, 23, 22, 23, 22, 23, 22, 23, 22/
      DATA ( DLEX(I) , I = 101, 200 )/
     X 23, 22, 23, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     X 0, 0, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23,
     X 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23,
     X 23, 23, 23, 23, 0, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23,
     X 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23,
     X 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23/
      DATA ( DLEX(I) , I = 201, 300 )/
     X 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23,
     X 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 22, 22, 22,
     X 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22,
     X 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22,
     X 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22,
     X 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22,
     X 22, 22, 22, 22/
      DATA ( DLEX(I) , I = 301, 400 )/
     X 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22,
     X 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22,
     X 22, 22, 22, 339, 339, 0, 0, 0, 0, 340, 341, 339, 0, 345, 339,
     X 345, 345, 345, 345, 339, 0, 353, 339, 353, 353, 353, 353, 0, 0,
     X 0, 0, 0, 0, 0, 0, 0, 0, 367, 0, 368, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     X 0, 0, 0, 0, 0, 339, 339, 339, 0, 0, 0, 0, 0, 0, 19, 0, 0, 0, 0/
      DATA ( DLEX(I) , I = 401, 481 )/
     X 0, 0, 0, 0, 394, 0, 19, 0, 0, 398, 0, 400, 401, 0, 403, 0, 0,
     X 0, 0, 0, 0, 391, 392, 0, 0, 0, 424, 425, 0, 426, 0, 0, 418, 0,
     X 0, 419, 420, 421, 0, 353, 353, 339, 345, 345, 339, 0, 0, 434,
     X 353, 435, 345, 0, 0, 353, 353, 452, 339, 345, 345, 453, 339,
     X 446, 353, 447, 345, 353, 345, 353, 345, 339, 339, 353, 345, 353,
     X 345, 0, 0, 0, 477, 0, 480/
      END

      BLOCK DATA LXLO02
      INTEGER FLEX,BLEX,DLEX,NLEX,CLEX,LLEX
      DIMENSION FLEX ( 481 )
      DIMENSION BLEX ( 481 )
      DIMENSION DLEX ( 481 )
      DIMENSION NLEX ( 2442 )
      DIMENSION CLEX ( 2442 )
      DIMENSION LLEX ( 481 )
      COMMON/G4LX/FLEX,BLEX,DLEX,NLEX,CLEX,LLEX
      DATA ( NLEX(I) , I = 1, 100 )/
     X 0, 0, 0, 0, 0, 0, 0, 0, 0, 122, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     X 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 122, 0, 370, 364, 123, 123,
     X 370, 157, 0, 0, 0, 0, 0, 0, 0, 109, 123, 123, 123, 123, 123,
     X 123, 123, 123, 123, 123, 95, 53, 94, 52, 0, 109, 0, 123, 123,
     X 123, 123, 123, 123, 123, 123, 123, 123, 123, 123, 123, 123, 123,
     X 123, 123, 123, 123, 123, 123, 123, 123, 123, 123, 123, 41, 80,
     X 28, 76, 123, 229, 123, 123, 123/
      DATA ( NLEX(I) , I = 101, 200 )/
     X 123, 123, 123, 123, 123, 123, 123, 123, 123, 123, 123, 123,
     X 123, 123, 123, 123, 123, 123, 123, 123, 123, 123, 123, 476, 42,
     X 28, 81, 77, 71, 228, 227, 47, 47, 47, 47, 47, 47, 47, 47, 47,
     X 47, 87, 83, 226, 225, 224, 51, 44, 47, 223, 47, 222, 47, 36, 97,
     X 221, 220, 219, 218, 48, 75, 217, 227, 67, 47, 61, 47, 55, 216,
     X 215, 47, 214, 213, 212, 103, 101, 211, 30, 210, 209, 47, 208,
     X 47, 222, 47, 207, 206, 205, 69, 63, 202, 48, 201, 200, 199, 198,
     X 47, 38, 47, 197/
      DATA ( NLEX(I) , I = 201, 300 )/
     X 196, 195, 47, 99, 213, 194, 91, 193, 89, 30, 192, 85, 191, 190,
     X 93, 189, 59, 184, 182, 180, 40, 183, 180, 179, 178, 177, 176,
     X 198, 175, 173, 172, 171, 170, 169, 167, 166, 73, 23, 165, 193,
     X 23, 163, 160, 161, 160, 159, 181, 158, 174, 156, 168, 180, 155,
     X 154, 180, 152, 151, 149, 79, 146, 143, 57, 172, 150, 139, 147,
     X 148, 138, 137, 24, 188, 204, 23, 203, 162, 164, 160, 70, 333,
     X 185, 86, 65, 82, 27, 186, 334, 332, 152, 331, 140, 144, 153,
     X 145, 330, 50, 43, 141, 478, 187, 329/
      DATA ( NLEX(I) , I = 301, 400 )/
     X 328, 35, 96, 142, 327, 47, 47, 47, 47, 47, 47, 47, 47, 47, 47,
     X 27, 326, 334, 325, 324, 74, 323, 47, 66, 47, 60, 47, 54, 322,
     X 321, 320, 329, 319, 48, 318, 102, 100, 317, 47, 29, 47, 316,
     X 315, 314, 47, 313, 312, 311, 68, 62, 308, 307, 306, 305, 47,
     X 304, 47, 37, 47, 366, 363, 303, 320, 302, 301, 48, 98, 300, 88,
     X 90, 47, 29, 47, 298, 84, 297, 47, 92, 296, 295, 58, 363, 366,
     X 104, 367, 305, 290, 39, 105, 368, 3, 4, 5, 9, 121, 11, 13, 14,
     X 336, 336/
      DATA ( NLEX(I) , I = 401, 500 )/
     X 336, 336, 336, 336, 336, 336, 337, 337, 16, 363, 107, 19, 112,
     X 285, 115, 230, 231, 232, 233, 234, 235, 236, 236, 237, 236, 236,
     X 238, 236, 239, 236, 236, 236, 240, 236, 241, 242, 236, 243, 236,
     X 236, 236, 25, 284, 26, 122, 0, 120, 124, 125, 126, 127, 128,
     X 129, 288, 283, 130, 289, 282, 131, 281, 132, 299, 287, 278, 133,
     X 277, 134, 135, 276, 136, 236, 236, 275, 31, 116, 33, 118, 369,
     X 279, 272, 273, 72, 236, 236, 236, 236, 236, 236, 236, 236, 236,
     X 236, 271, 299, 287, 278, 274, 280, 269, 236/
      DATA ( NLEX(I) , I = 501, 600 )/
     X 236, 236, 236, 236, 236, 236, 236, 236, 236, 236, 236, 236,
     X 236, 236, 236, 236, 236, 236, 236, 236, 236, 236, 236, 236, 236,
     X 286, 22, 21, 268, 236, 287, 236, 236, 236, 236, 236, 236, 236,
     X 236, 236, 236, 236, 236, 236, 236, 236, 236, 236, 236, 236, 236,
     X 236, 236, 236, 236, 236, 236, 476, 22, 22, 268, 266, 287, 267,
     X 265, 45, 45, 45, 45, 45, 45, 45, 45, 45, 45, 264, 263, 262, 261,
     X 259, 258, 256, 45, 260, 45, 253, 45, 257, 78, 56, 250, 254, 251,
     X 46, 246, 268, 255, 245, 45, 244/
      DATA ( NLEX(I) , I = 601, 700 )/
     X 45, 247, 294, 310, 45, 309, 270, 335, 248, 441, 111, 259, 444,
     X 114, 45, 291, 45, 64, 45, 0, 292, 0, 114, 20, 252, 46, 419, 114,
     X 419, 478, 45, 452, 45, 249, 293, 453, 45, 45, 45, 45, 45, 45,
     X 45, 45, 45, 45, 45, 104, 420, 421, 420, 421, 419, 0, 45, 0, 45,
     X 0, 45, 0, 0, 106, 0, 452, 0, 46, 0, 453, 108, 0, 45, 0, 45, 477,
     X 446, 447, 45, 0, 110, 0, 420, 421, 420, 421, 111, 111, 45, 477,
     X 45, 113, 45, 18, 109, 110, 115, 117, 119, 46, 2, 0/
      DATA ( NLEX(I) , I = 701, 800 )/
     X 0, 7, 45, 10, 45, 477, 446, 447, 45, 372, 372, 372, 372, 372,
     X 372, 372, 372, 372, 372, 477, 372, 372, 372, 372, 372, 372, 372,
     X 372, 372, 372, 372, 372, 372, 372, 372, 372, 372, 372, 372, 372,
     X 12, 372, 372, 372, 372, 372, 372, 372, 15, 372, 372, 372, 372,
     X 372, 372, 372, 372, 372, 372, 372, 372, 372, 372, 372, 372, 372,
     X 372, 372, 372, 372, 372, 372, 372, 372, 372, 372, 372, 372, 372,
     X 372, 372, 372, 372, 372, 372, 372, 372, 372, 372, 372, 372, 372,
     X 372, 372, 372, 372, 372, 372, 372, 372/
      DATA ( NLEX(I) , I = 801, 900 )/
     X 372, 372, 372, 372, 372, 372, 372, 372, 372, 372, 372, 372,
     X 372, 372, 372, 372, 372, 372, 372, 372, 372, 372, 372, 372, 372,
     X 372, 372, 372, 372, 372, 372, 372, 372, 372, 372, 372, 372, 387,
     X 387, 387, 387, 387, 387, 387, 387, 387, 387, 480, 17, 32, 34,
     X 120, 395, 419, 387, 387, 387, 387, 387, 387, 460, 480, 460, 6,
     X 396, 461, 461, 461, 461, 461, 461, 461, 461, 461, 461, 446, 447,
     X 338, 393, 480, 403, 406, 8, 415, 394, 424, 387, 387, 387, 387,
     X 387, 387, 444, 480, 471, 471, 471, 471, 471, 471/
      DATA ( NLEX(I) , I = 901, 1000 )/
     X 471, 471, 471, 471, 401, 404, 413, 446, 447, 338, 425, 405,
     X 407, 426, 402, 445, 414, 408, 441, 361, 470, 470, 470, 470, 470,
     X 470, 470, 470, 470, 470, 475, 475, 475, 475, 475, 475, 475, 475,
     X 475, 475, 442, 427, 428, 366, 363, 362, 429, 445, 430, 397, 439,
     X 361, 432, 399, 471, 471, 471, 471, 471, 471, 471, 471, 471, 471,
     X 398, 363, 366, 0, 400, 0, 0, 0, 442, 0, 0, 0, 409, 362, 431,
     X 361, 470, 470, 470, 470, 470, 470, 470, 470, 470, 470, 456, 410,
     X 456, 363, 0, 457, 457, 457, 457, 457/
      END

      BLOCK DATA LXLO03
      INTEGER FLEX,BLEX,DLEX,NLEX,CLEX,LLEX
      DIMENSION FLEX ( 481 )
      DIMENSION BLEX ( 481 )
      DIMENSION DLEX ( 481 )
      DIMENSION NLEX ( 2442 )
      DIMENSION CLEX ( 2442 )
      DIMENSION LLEX ( 481 )
      COMMON/G4LX/FLEX,BLEX,DLEX,NLEX,CLEX,LLEX
      DATA ( NLEX(I) , I = 1001, 1100 )/
     X 457, 457, 457, 457, 457, 362, 0, 417, 411, 417, 0, 361, 344,
     X 344, 344, 344, 344, 344, 344, 344, 344, 344, 416, 412, 416, 0,
     X 0, 352, 352, 352, 352, 352, 352, 352, 352, 352, 352, 362, 441,
     X 0, 355, 355, 355, 355, 355, 355, 355, 355, 355, 355, 473, 473,
     X 473, 473, 473, 473, 473, 473, 473, 473, 442, 0, 0, 0, 431, 362,
     X 355, 355, 355, 355, 355, 355, 355, 355, 355, 355, 444, 0, 347,
     X 347, 347, 347, 347, 347, 347, 347, 347, 347, 0, 0, 0, 362, 442,
     X 0, 0, 0, 0, 362, 0, 445/
      DATA ( NLEX(I) , I = 1101, 1200 )/
     X 0, 0, 432, 361, 347, 347, 347, 347, 347, 347, 347, 347, 347,
     X 347, 0, 0, 0, 0, 0, 0, 0, 0, 0, 362, 0, 0, 0, 0, 0, 361, 0, 445,
     X 0, 0, 0, 361, 341, 0, 337, 337, 337, 337, 337, 337, 337, 337,
     X 337, 337, 467, 467, 467, 467, 467, 467, 467, 467, 467, 467, 388,
     X 389, 0, 361, 341, 360, 336, 336, 336, 336, 336, 336, 336, 336,
     X 337, 337, 0, 0, 0, 0, 0, 0, 0, 0, 339, 0, 388, 389, 0, 0, 0,
     X 360, 388, 389, 0, 0, 0, 360, 0, 0, 0, 370/
      DATA ( NLEX(I) , I = 1201, 1300 )/
     X 351, 351, 351, 351, 351, 351, 351, 351, 351, 351, 0, 0, 0, 0,
     X 339, 0, 388, 389, 0, 0, 0, 360, 370, 370, 371, 370, 370, 370,
     X 370, 370, 370, 370, 370, 370, 370, 370, 370, 370, 370, 370, 370,
     X 370, 370, 370, 370, 370, 370, 370, 370, 370, 370, 370, 370, 370,
     X 370, 370, 370, 370, 370, 370, 370, 370, 370, 370, 370, 370, 370,
     X 370, 370, 370, 370, 370, 370, 370, 370, 370, 370, 370, 370, 370,
     X 370, 370, 370, 370, 370, 370, 370, 370, 370, 370, 370, 370, 370,
     X 370, 370, 370, 370, 370, 370, 370/
      DATA ( NLEX(I) , I = 1301, 1400 )/
     X 370, 370, 370, 370, 370, 370, 370, 370, 370, 370, 370, 370,
     X 370, 370, 370, 370, 370, 369, 369, 369, 369, 369, 369, 369, 369,
     X 369, 369, 369, 369, 369, 369, 369, 369, 369, 369, 369, 369, 369,
     X 369, 369, 369, 369, 369, 369, 369, 369, 369, 369, 369, 369, 369,
     X 369, 369, 369, 369, 369, 369, 369, 369, 369, 369, 369, 369, 369,
     X 369, 369, 369, 369, 369, 369, 369, 369, 369, 369, 369, 369, 369,
     X 369, 369, 369, 369, 369, 369, 369, 369, 369, 369, 369, 369, 369,
     X 369, 369, 369, 369, 369, 369, 369, 369, 369, 369/
      DATA ( NLEX(I) , I = 1401, 1500 )/
     X 369, 369, 369, 369, 369, 369, 369, 369, 369, 369, 369, 369,
     X 369, 369, 369, 369, 369, 369, 369, 369, 369, 369, 369, 369, 369,
     X 369, 369, 369, 369, 369, 369, 369, 369, 369, 369, 369, 369, 369,
     X 369, 369, 369, 369, 369, 369, 365, 49, 0, 0, 0, 0, 0, 0, 479,
     X 479, 479, 479, 479, 479, 479, 479, 479, 479, 0, 0, 0, 0, 0, 0,
     X 49, 479, 0, 479, 0, 477, 0, 481, 481, 481, 481, 481, 481, 481,
     X 481, 481, 481, 479, 0, 477, 0, 0, 0, 479, 481, 0, 481, 0, 480,
     X 0, 0, 0/
      DATA ( NLEX(I) , I = 1501, 1600 )/
     X 0, 479, 0, 479, 0, 477, 0, 0, 481, 0, 480, 0, 0, 0, 481, 0, 0,
     X 479, 0, 477, 0, 0, 0, 479, 481, 0, 481, 432, 480, 349, 349, 349,
     X 349, 349, 349, 349, 349, 349, 349, 0, 481, 0, 480, 0, 0, 0, 481,
     X 0, 0, 0, 0, 0, 0, 444, 361, 475, 475, 475, 475, 475, 475, 475,
     X 475, 475, 475, 350, 350, 350, 350, 350, 350, 350, 350, 350, 350,
     X 0, 453, 0, 0, 0, 0, 0, 0, 0, 0, 0, 361, 444, 0, 473, 473, 473,
     X 473, 473, 473, 473, 473, 473, 473, 0/
      DATA ( NLEX(I) , I = 1601, 1700 )/
     X 0, 0, 0, 0, 0, 0, 0, 0, 453, 444, 453, 467, 467, 467, 467, 467,
     X 467, 467, 467, 467, 467, 474, 474, 474, 474, 474, 474, 474, 474,
     X 474, 474, 0, 453, 0, 0, 0, 0, 0, 0, 0, 0, 0, 453, 444, 0, 459,
     X 459, 459, 459, 459, 459, 459, 459, 459, 459, 0, 0, 0, 0, 0, 0,
     X 0, 0, 0, 453, 444, 447, 458, 458, 458, 458, 458, 458, 458, 458,
     X 458, 458, 0, 459, 459, 459, 459, 459, 459, 459, 459, 459, 459,
     X 447, 0, 0, 0, 0, 0, 0, 0, 0, 0, 447, 435/
      DATA ( NLEX(I) , I = 1701, 1800 )/
     X 458, 458, 458, 458, 458, 458, 458, 458, 458, 458, 472, 472,
     X 472, 472, 472, 472, 472, 472, 472, 472, 447, 435, 0, 0, 0, 0, 0,
     X 0, 0, 0, 0, 435, 444, 0, 351, 351, 351, 351, 351, 351, 351, 351,
     X 351, 351, 0, 0, 0, 0, 0, 0, 0, 0, 0, 435, 444, 453, 350, 350,
     X 350, 350, 350, 350, 350, 350, 350, 350, 466, 466, 466, 466, 466,
     X 466, 466, 466, 466, 466, 0, 453, 0, 0, 0, 0, 0, 0, 0, 0, 431,
     X 453, 357, 357, 357, 357, 357, 357, 357, 357, 357, 357, 359, 359/
      DATA ( NLEX(I) , I = 1801, 1900 )/
     X 359, 359, 359, 359, 359, 359, 359, 359, 0, 453, 0, 0, 441, 362,
     X 474, 474, 474, 474, 474, 474, 474, 474, 474, 474, 0, 0, 0, 0, 0,
     X 0, 0, 0, 0, 441, 452, 472, 472, 472, 472, 472, 472, 472, 472,
     X 472, 472, 362, 0, 0, 0, 0, 0, 0, 0, 0, 441, 452, 466, 466, 466,
     X 466, 466, 466, 466, 466, 466, 466, 452, 0, 0, 0, 0, 0, 0, 0, 0,
     X 441, 452, 455, 455, 455, 455, 455, 455, 455, 455, 455, 455, 452,
     X 0, 0, 0, 0, 0, 0, 0, 0, 441, 446, 454, 454/
      DATA ( NLEX(I) , I = 1901, 2000 )/
     X 454, 454, 454, 454, 454, 454, 454, 454, 452, 0, 0, 0, 0, 0, 0,
     X 0, 0, 0, 446, 455, 455, 455, 455, 455, 455, 455, 455, 455, 455,
     X 446, 0, 0, 0, 0, 0, 0, 0, 0, 0, 434, 454, 454, 454, 454, 454,
     X 454, 454, 454, 454, 454, 446, 0, 0, 0, 0, 0, 0, 0, 0, 441, 434,
     X 359, 359, 359, 359, 359, 359, 359, 359, 359, 359, 434, 0, 0, 0,
     X 0, 0, 0, 0, 0, 441, 452, 358, 358, 358, 358, 358, 358, 358, 358,
     X 358, 358, 434, 0, 0, 0, 0, 0, 0, 0/
      END

      BLOCK DATA LXLO04
      INTEGER FLEX,BLEX,DLEX,NLEX,CLEX,LLEX
      DIMENSION FLEX ( 481 )
      DIMENSION BLEX ( 481 )
      DIMENSION DLEX ( 481 )
      DIMENSION NLEX ( 2442 )
      DIMENSION CLEX ( 2442 )
      DIMENSION LLEX ( 481 )
      COMMON/G4LX/FLEX,BLEX,DLEX,NLEX,CLEX,LLEX
      DATA ( NLEX(I) , I = 2001, 2100 )/
     X 0, 0, 452, 358, 358, 358, 358, 358, 358, 358, 358, 358, 358,
     X 452, 390, 0, 342, 342, 342, 342, 342, 342, 342, 342, 342, 342,
     X 0, 0, 0, 0, 0, 0, 0, 0, 452, 0, 391, 392, 0, 0, 390, 360, 343,
     X 343, 343, 343, 343, 343, 343, 343, 343, 343, 346, 346, 346, 346,
     X 346, 346, 346, 346, 346, 346, 391, 392, 0, 0, 0, 360, 391, 392,
     X 423, 0, 423, 360, 0, 345, 345, 345, 345, 345, 345, 345, 345,
     X 345, 345, 0, 0, 0, 0, 0, 0, 0, 0, 0, 391, 392, 438, 0, 438, 360/
      DATA ( NLEX(I) , I = 2101, 2200 )/
     X 0, 348, 348, 348, 348, 348, 348, 348, 348, 348, 348, 422, 0,
     X 422, 0, 0, 353, 353, 353, 353, 353, 353, 353, 353, 353, 353,
     X 437, 0, 437, 0, 0, 356, 356, 356, 356, 356, 356, 356, 356, 356,
     X 356, 390, 0, 433, 433, 433, 433, 433, 433, 433, 433, 433, 433,
     X 354, 354, 354, 354, 354, 354, 354, 354, 354, 354, 434, 435, 0,
     X 0, 390, 360, 436, 436, 436, 436, 436, 436, 436, 436, 436, 436,
     X 418, 418, 418, 418, 418, 418, 418, 418, 418, 418, 434, 435, 0,
     X 0, 0, 360, 434, 435, 448, 0, 448/
      DATA ( NLEX(I) , I = 2201, 2300 )/
     X 360, 0, 449, 449, 449, 449, 449, 449, 449, 449, 449, 449, 0, 0,
     X 0, 0, 0, 0, 0, 0, 0, 434, 435, 450, 0, 450, 360, 0, 451, 451,
     X 451, 451, 451, 451, 451, 451, 451, 451, 462, 0, 462, 0, 0, 463,
     X 463, 463, 463, 463, 463, 463, 463, 463, 463, 464, 0, 464, 0, 0,
     X 465, 465, 465, 465, 465, 465, 465, 465, 465, 465, 456, 0, 456,
     X 0, 0, 468, 468, 468, 468, 468, 468, 468, 468, 468, 468, 460, 0,
     X 460, 0, 0, 469, 469, 469, 469, 469, 469, 469, 469, 469, 469,
     X 340, 340/
      DATA ( NLEX(I) , I = 2301, 2400 )/
     X 340, 340, 340, 340, 340, 340, 340, 340, 0, 0, 0, 0, 0, 0, 0,
     X 373, 0, 0, 374, 375, 0, 376, 0, 0, 0, 0, 377, 0, 378, 379, 440,
     X 440, 440, 440, 440, 440, 440, 440, 440, 440, 0, 0, 0, 0, 0, 0,
     X 0, 380, 0, 0, 381, 382, 0, 383, 0, 0, 0, 0, 384, 0, 385, 386,
     X 443, 443, 443, 443, 443, 443, 443, 443, 443, 443, 0, 0, 0, 0, 0,
     X 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     X 0, 0/
      DATA ( NLEX(I) , I = 2401, 2442 )/
     X 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     X 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0/
      END

      BLOCK DATA LXLO05
      INTEGER FLEX,BLEX,DLEX,NLEX,CLEX,LLEX
      DIMENSION FLEX ( 481 )
      DIMENSION BLEX ( 481 )
      DIMENSION DLEX ( 481 )
      DIMENSION NLEX ( 2442 )
      DIMENSION CLEX ( 2442 )
      DIMENSION LLEX ( 481 )
      COMMON/G4LX/FLEX,BLEX,DLEX,NLEX,CLEX,LLEX
      DATA ( CLEX(I) , I = 1, 100 )/
     X 0, 0, 0, 0, 0, 0, 0, 0, 0, 122, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     X 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 122, 0, 371, 370, 23, 23,
     X 364, 372, 0, 0, 0, 423, 438, 423, 438, 411, 23, 23, 23, 23, 23,
     X 23, 23, 23, 23, 23, 93, 51, 92, 50, 422, 399, 422, 23, 23, 23,
     X 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23,
     X 23, 23, 23, 23, 23, 23, 23, 333, 332, 227, 331, 23, 44, 23, 23,
     X 23/
      DATA ( CLEX(I) , I = 101, 200 )/
     X 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23, 23,
     X 23, 23, 23, 23, 23, 23, 23, 229, 228, 227, 226, 225, 224, 223,
     X 222, 229, 229, 229, 229, 229, 229, 229, 229, 229, 229, 221, 220,
     X 219, 218, 217, 216, 215, 229, 214, 229, 213, 229, 212, 211, 210,
     X 209, 208, 207, 229, 206, 205, 222, 204, 229, 203, 229, 202, 201,
     X 200, 229, 199, 198, 197, 196, 195, 194, 193, 192, 191, 229, 190,
     X 229, 213, 229, 189, 188, 187, 186, 185, 184, 229, 183, 182, 181,
     X 180, 229, 179, 229, 178/
      DATA ( CLEX(I) , I = 201, 300 )/
     X 177, 176, 229, 175, 198, 174, 173, 172, 171, 193, 170, 169,
     X 168, 167, 173, 166, 165, 164, 163, 162, 161, 163, 160, 159, 158,
     X 156, 155, 180, 154, 153, 152, 151, 150, 149, 148, 147, 146, 145,
     X 144, 172, 143, 142, 141, 140, 139, 138, 162, 137, 153, 136, 148,
     X 162, 135, 134, 160, 133, 132, 131, 130, 129, 128, 127, 152, 131,
     X 126, 129, 130, 125, 124, 145, 73, 65, 143, 59, 141, 57, 139,
     X 330, 328, 24, 327, 24, 326, 334, 24, 329, 325, 133, 324, 126,
     X 128, 133, 128, 323, 322, 321, 126, 47, 24, 320/
      DATA ( CLEX(I) , I = 301, 400 )/
     X 319, 318, 317, 126, 316, 47, 47, 47, 47, 47, 47, 47, 47, 47,
     X 47, 334, 315, 329, 314, 313, 312, 311, 47, 310, 47, 309, 47,
     X 308, 307, 306, 305, 320, 304, 47, 303, 302, 301, 300, 47, 299,
     X 47, 298, 297, 296, 47, 295, 294, 293, 292, 291, 290, 289, 288,
     X 287, 47, 286, 47, 285, 47, 1, 1, 284, 305, 283, 282, 47, 281,
     X 280, 277, 279, 47, 299, 47, 276, 275, 274, 47, 279, 273, 272,
     X 271, 1, 1, 1, 1, 287, 270, 266, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
     X 1/
      DATA ( CLEX(I) , I = 401, 500 )/
     X 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 265, 1, 1, 1, 1, 1, 1,
     X 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
     X 1, 264, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 269, 263, 1, 269, 262, 1,
     X 261, 1, 278, 268, 259, 1, 258, 1, 1, 257, 1, 22, 22, 256, 1, 1,
     X 1, 1, 1, 260, 254, 255, 253, 22, 22, 22, 22, 22, 22, 22, 22, 22,
     X 22, 250, 278, 268, 259, 255, 260, 248, 22/
      DATA ( CLEX(I) , I = 501, 600 )/
     X 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22,
     X 22, 22, 22, 22, 22, 22, 22, 22, 22, 267, 252, 251, 249, 22, 267,
     X 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 22,
     X 22, 22, 22, 22, 22, 22, 22, 22, 22, 22, 335, 252, 251, 249, 246,
     X 267, 247, 245, 335, 335, 335, 335, 335, 335, 335, 335, 335, 335,
     X 244, 243, 242, 241, 240, 239, 238, 335, 240, 335, 235, 335, 238,
     X 237, 233, 234, 235, 234, 335, 232, 247, 237, 231, 335, 230/
      DATA ( CLEX(I) , I = 601, 700 )/
     X 335, 232, 72, 64, 335, 58, 56, 43, 232, 357, 19, 240, 349, 409,
     X 335, 21, 335, 21, 335, 437, 21, 437, 112, 112, 234, 335, 342,
     X 397, 343, 45, 335, 357, 335, 232, 21, 349, 335, 45, 45, 45, 45,
     X 45, 45, 45, 45, 45, 45, 425, 342, 342, 343, 343, 433, 448, 45,
     X 448, 45, 450, 45, 450, 462, 424, 462, 357, 464, 45, 464, 349,
     X 400, 456, 45, 456, 45, 476, 433, 433, 45, 460, 401, 460, 342,
     X 342, 343, 343, 407, 396, 45, 476, 45, 398, 45, 107, 107, 107,
     X 394, 403, 426, 45, 105, 407/
      DATA ( CLEX(I) , I = 701, 800 )/
     X 396, 6, 45, 9, 45, 476, 433, 433, 45, 368, 368, 368, 368, 368,
     X 368, 368, 368, 368, 368, 476, 368, 368, 368, 368, 368, 368, 368,
     X 368, 368, 368, 368, 368, 368, 368, 368, 368, 368, 368, 368, 368,
     X 11, 368, 368, 368, 368, 368, 368, 368, 14, 368, 368, 368, 368,
     X 368, 368, 368, 368, 368, 368, 368, 368, 368, 368, 368, 368, 368,
     X 368, 368, 368, 368, 368, 368, 368, 368, 368, 368, 368, 368, 368,
     X 368, 368, 368, 368, 368, 368, 368, 368, 368, 368, 368, 368, 368,
     X 368, 368, 368, 368, 368, 368, 368, 368/
      DATA ( CLEX(I) , I = 801, 900 )/
     X 368, 368, 368, 368, 368, 368, 368, 368, 368, 368, 368, 368,
     X 368, 368, 368, 368, 368, 368, 368, 368, 368, 368, 368, 368, 368,
     X 368, 368, 368, 368, 368, 368, 368, 368, 368, 368, 368, 368, 339,
     X 339, 339, 339, 339, 339, 339, 339, 339, 339, 478, 16, 116, 118,
     X 439, 374, 436, 339, 339, 339, 339, 339, 339, 445, 478, 445, 5,
     X 375, 445, 445, 445, 445, 445, 445, 445, 445, 445, 445, 436, 436,
     X 339, 373, 478, 379, 381, 5, 386, 373, 393, 339, 339, 339, 339,
     X 339, 339, 471, 478, 471, 471, 471, 471, 471, 471/
      DATA ( CLEX(I) , I = 901, 1000 )/
     X 471, 471, 471, 471, 378, 380, 385, 436, 436, 339, 395, 380,
     X 382, 402, 378, 471, 385, 382, 470, 471, 470, 470, 470, 470, 470,
     X 470, 470, 470, 470, 470, 469, 469, 469, 469, 469, 469, 469, 469,
     X 469, 469, 470, 404, 406, 366, 366, 470, 408, 471, 414, 376, 429,
     X 471, 461, 377, 461, 461, 461, 461, 461, 461, 461, 461, 461, 461,
     X 376, 366, 366, 0, 377, 0, 0, 0, 470, 0, 0, 0, 383, 470, 457,
     X 461, 457, 457, 457, 457, 457, 457, 457, 457, 457, 457, 442, 383,
     X 442, 366, 0, 442, 442, 442, 442, 442/
      END

      BLOCK DATA LXLO06
      INTEGER FLEX,BLEX,DLEX,NLEX,CLEX,LLEX
      DIMENSION FLEX ( 481 )
      DIMENSION BLEX ( 481 )
      DIMENSION DLEX ( 481 )
      DIMENSION NLEX ( 2442 )
      DIMENSION CLEX ( 2442 )
      DIMENSION LLEX ( 481 )
      COMMON/G4LX/FLEX,BLEX,DLEX,NLEX,CLEX,LLEX
      DATA ( CLEX(I) , I = 1001, 1100 )/
     X 442, 442, 442, 442, 442, 457, 0, 389, 384, 389, 0, 461, 389,
     X 389, 389, 389, 389, 389, 389, 389, 389, 389, 388, 384, 388, 0,
     X 0, 388, 388, 388, 388, 388, 388, 388, 388, 388, 388, 457, 355,
     X 0, 355, 355, 355, 355, 355, 355, 355, 355, 355, 355, 465, 465,
     X 465, 465, 465, 465, 465, 465, 465, 465, 355, 0, 0, 0, 352, 355,
     X 352, 352, 352, 352, 352, 352, 352, 352, 352, 352, 347, 0, 347,
     X 347, 347, 347, 347, 347, 347, 347, 347, 347, 0, 0, 0, 352, 355,
     X 0, 0, 0, 0, 355, 0, 347/
      DATA ( CLEX(I) , I = 1101, 1200 )/
     X 0, 0, 344, 347, 344, 344, 344, 344, 344, 344, 344, 344, 344,
     X 344, 0, 0, 0, 0, 0, 0, 0, 0, 0, 352, 0, 0, 0, 0, 0, 344, 0, 347,
     X 0, 0, 0, 347, 337, 0, 337, 337, 337, 337, 337, 337, 337, 337,
     X 337, 337, 451, 451, 451, 451, 451, 451, 451, 451, 451, 451, 337,
     X 337, 0, 344, 336, 337, 336, 336, 336, 336, 336, 336, 336, 336,
     X 336, 336, 0, 0, 0, 0, 0, 0, 0, 0, 336, 0, 336, 336, 0, 0, 0,
     X 336, 337, 337, 0, 0, 0, 337, 0, 0, 0, 367/
      DATA ( CLEX(I) , I = 1201, 1300 )/
     X 348, 348, 348, 348, 348, 348, 348, 348, 348, 348, 0, 0, 0, 0,
     X 336, 0, 336, 336, 0, 0, 0, 336, 367, 367, 367, 367, 367, 367,
     X 367, 367, 367, 367, 367, 367, 367, 367, 367, 367, 367, 367, 367,
     X 367, 367, 367, 367, 367, 367, 367, 367, 367, 367, 367, 367, 367,
     X 367, 367, 367, 367, 367, 367, 367, 367, 367, 367, 367, 367, 367,
     X 367, 367, 367, 367, 367, 367, 367, 367, 367, 367, 367, 367, 367,
     X 367, 367, 367, 367, 367, 367, 367, 367, 367, 367, 367, 367, 367,
     X 367, 367, 367, 367, 367, 367, 367/
      DATA ( CLEX(I) , I = 1301, 1400 )/
     X 367, 367, 367, 367, 367, 367, 367, 367, 367, 367, 367, 367,
     X 367, 367, 367, 367, 367, 369, 369, 369, 369, 369, 369, 369, 369,
     X 369, 369, 369, 369, 369, 369, 369, 369, 369, 369, 369, 369, 369,
     X 369, 369, 369, 369, 369, 369, 369, 369, 369, 369, 369, 369, 369,
     X 369, 369, 369, 369, 369, 369, 369, 369, 369, 369, 369, 369, 369,
     X 369, 369, 369, 369, 369, 369, 369, 369, 369, 369, 369, 369, 369,
     X 369, 369, 369, 369, 369, 369, 369, 369, 369, 369, 369, 369, 369,
     X 369, 369, 369, 369, 369, 369, 369, 369, 369, 369/
      DATA ( CLEX(I) , I = 1401, 1500 )/
     X 369, 369, 369, 369, 369, 369, 369, 369, 369, 369, 369, 369,
     X 369, 369, 369, 369, 369, 369, 369, 369, 369, 369, 369, 369, 369,
     X 369, 369, 369, 369, 369, 369, 369, 369, 369, 369, 369, 369, 369,
     X 369, 369, 369, 369, 369, 369, 369, 477, 0, 0, 0, 0, 0, 0, 477,
     X 477, 477, 477, 477, 477, 477, 477, 477, 477, 0, 0, 0, 0, 0, 0,
     X 480, 477, 0, 477, 0, 477, 0, 480, 480, 480, 480, 480, 480, 480,
     X 480, 480, 480, 477, 0, 477, 0, 0, 0, 477, 480, 0, 480, 0, 480,
     X 0, 0, 0/
      DATA ( CLEX(I) , I = 1501, 1600 )/
     X 0, 477, 0, 477, 0, 477, 0, 0, 480, 0, 480, 0, 0, 0, 480, 0, 0,
     X 477, 0, 477, 0, 0, 0, 477, 480, 0, 480, 345, 480, 345, 345, 345,
     X 345, 345, 345, 345, 345, 345, 345, 0, 480, 0, 480, 0, 0, 0, 480,
     X 0, 0, 0, 0, 0, 0, 475, 345, 475, 475, 475, 475, 475, 475, 475,
     X 475, 475, 475, 346, 346, 346, 346, 346, 346, 346, 346, 346, 346,
     X 0, 475, 0, 0, 0, 0, 0, 0, 0, 0, 0, 345, 473, 0, 473, 473, 473,
     X 473, 473, 473, 473, 473, 473, 473, 0/
      DATA ( CLEX(I) , I = 1601, 1700 )/
     X 0, 0, 0, 0, 0, 0, 0, 0, 475, 467, 473, 467, 467, 467, 467, 467,
     X 467, 467, 467, 467, 467, 468, 468, 468, 468, 468, 468, 468, 468,
     X 468, 468, 0, 467, 0, 0, 0, 0, 0, 0, 0, 0, 0, 473, 459, 0, 459,
     X 459, 459, 459, 459, 459, 459, 459, 459, 459, 0, 0, 0, 0, 0, 0,
     X 0, 0, 0, 467, 458, 459, 458, 458, 458, 458, 458, 458, 458, 458,
     X 458, 458, 0, 444, 444, 444, 444, 444, 444, 444, 444, 444, 444,
     X 458, 0, 0, 0, 0, 0, 0, 0, 0, 0, 459, 444/
      DATA ( CLEX(I) , I = 1701, 1800 )/
     X 443, 443, 443, 443, 443, 443, 443, 443, 443, 443, 463, 463,
     X 463, 463, 463, 463, 463, 463, 463, 463, 458, 443, 0, 0, 0, 0, 0,
     X 0, 0, 0, 0, 444, 351, 0, 351, 351, 351, 351, 351, 351, 351, 351,
     X 351, 351, 0, 0, 0, 0, 0, 0, 0, 0, 0, 443, 350, 351, 350, 350,
     X 350, 350, 350, 350, 350, 350, 350, 350, 449, 449, 449, 449, 449,
     X 449, 449, 449, 449, 449, 0, 350, 0, 0, 0, 0, 0, 0, 0, 0, 353,
     X 351, 353, 353, 353, 353, 353, 353, 353, 353, 353, 353, 356, 356/
      DATA ( CLEX(I) , I = 1801, 1900 )/
     X 356, 356, 356, 356, 356, 356, 356, 356, 0, 350, 0, 0, 474, 353,
     X 474, 474, 474, 474, 474, 474, 474, 474, 474, 474, 0, 0, 0, 0, 0,
     X 0, 0, 0, 0, 472, 474, 472, 472, 472, 472, 472, 472, 472, 472,
     X 472, 472, 353, 0, 0, 0, 0, 0, 0, 0, 0, 466, 472, 466, 466, 466,
     X 466, 466, 466, 466, 466, 466, 466, 474, 0, 0, 0, 0, 0, 0, 0, 0,
     X 455, 466, 455, 455, 455, 455, 455, 455, 455, 455, 455, 455, 472,
     X 0, 0, 0, 0, 0, 0, 0, 0, 454, 455, 454, 454/
      DATA ( CLEX(I) , I = 1901, 2000 )/
     X 454, 454, 454, 454, 454, 454, 454, 454, 466, 0, 0, 0, 0, 0, 0,
     X 0, 0, 0, 454, 441, 441, 441, 441, 441, 441, 441, 441, 441, 441,
     X 455, 0, 0, 0, 0, 0, 0, 0, 0, 0, 441, 440, 440, 440, 440, 440,
     X 440, 440, 440, 440, 440, 454, 0, 0, 0, 0, 0, 0, 0, 0, 359, 440,
     X 359, 359, 359, 359, 359, 359, 359, 359, 359, 359, 441, 0, 0, 0,
     X 0, 0, 0, 0, 0, 358, 359, 358, 358, 358, 358, 358, 358, 358, 358,
     X 358, 358, 440, 0, 0, 0, 0, 0, 0, 0/
      END

      BLOCK DATA LXLO07
      INTEGER FLEX,BLEX,DLEX,NLEX,CLEX,LLEX
      DIMENSION FLEX ( 481 )
      DIMENSION BLEX ( 481 )
      DIMENSION DLEX ( 481 )
      DIMENSION NLEX ( 2442 )
      DIMENSION CLEX ( 2442 )
      DIMENSION LLEX ( 481 )
      COMMON/G4LX/FLEX,BLEX,DLEX,NLEX,CLEX,LLEX
      DATA ( CLEX(I) , I = 2001, 2100 )/
     X 0, 0, 358, 354, 354, 354, 354, 354, 354, 354, 354, 354, 354,
     X 359, 340, 0, 340, 340, 340, 340, 340, 340, 340, 340, 340, 340,
     X 0, 0, 0, 0, 0, 0, 0, 0, 358, 0, 340, 340, 0, 0, 341, 340, 341,
     X 341, 341, 341, 341, 341, 341, 341, 341, 341, 417, 417, 417, 417,
     X 417, 417, 417, 417, 417, 417, 341, 341, 0, 0, 0, 341, 340, 340,
     X 392, 0, 392, 340, 0, 392, 392, 392, 392, 392, 392, 392, 392,
     X 392, 392, 0, 0, 0, 0, 0, 0, 0, 0, 0, 341, 341, 421, 0, 421, 341/
      DATA ( CLEX(I) , I = 2101, 2200 )/
     X 0, 421, 421, 421, 421, 421, 421, 421, 421, 421, 421, 391, 0,
     X 391, 0, 0, 391, 391, 391, 391, 391, 391, 391, 391, 391, 391,
     X 420, 0, 420, 0, 0, 420, 420, 420, 420, 420, 420, 420, 420, 420,
     X 420, 418, 0, 418, 418, 418, 418, 418, 418, 418, 418, 418, 418,
     X 416, 416, 416, 416, 416, 416, 416, 416, 416, 416, 418, 418, 0,
     X 0, 419, 418, 419, 419, 419, 419, 419, 419, 419, 419, 419, 419,
     X 390, 390, 390, 390, 390, 390, 390, 390, 390, 390, 419, 419, 0,
     X 0, 0, 419, 418, 418, 434, 0, 434/
      DATA ( CLEX(I) , I = 2201, 2300 )/
     X 418, 0, 434, 434, 434, 434, 434, 434, 434, 434, 434, 434, 0, 0,
     X 0, 0, 0, 0, 0, 0, 0, 419, 419, 435, 0, 435, 419, 0, 435, 435,
     X 435, 435, 435, 435, 435, 435, 435, 435, 446, 0, 446, 0, 0, 446,
     X 446, 446, 446, 446, 446, 446, 446, 446, 446, 447, 0, 447, 0, 0,
     X 447, 447, 447, 447, 447, 447, 447, 447, 447, 447, 452, 0, 452,
     X 0, 0, 452, 452, 452, 452, 452, 452, 452, 452, 452, 452, 453, 0,
     X 453, 0, 0, 453, 453, 453, 453, 453, 453, 453, 453, 453, 453, 13,
     X 13/
      DATA ( CLEX(I) , I = 2301, 2400 )/
     X 13, 13, 13, 13, 13, 13, 13, 13, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0,
     X 13, 13, 0, 13, 0, 0, 0, 0, 13, 0, 13, 13, 431, 431, 431, 431,
     X 431, 431, 431, 431, 431, 431, 0, 0, 0, 0, 0, 0, 0, 13, 0, 0, 13,
     X 13, 0, 13, 0, 0, 0, 0, 13, 0, 13, 13, 432, 432, 432, 432, 432,
     X 432, 432, 432, 432, 432, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     X 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0/
      DATA ( CLEX(I) , I = 2401, 2442 )/
     X 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
     X 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0/
      DATA ( LLEX(I) , I = 1, 100 )/
     X 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18,
     X 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34,
     X 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50,
     X 51, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63, 64, 65, 66,
     X 67, 68, 69, 70, 71, 72, 73, 74, 75, 76, 77, 78, 79, 80, 81, 82,
     X 83, 84, 85, 86, 87, 88, 89, 90, 91, 92, 93, 94, 95, 96, 97, 98,
     X 99, 100/
      DATA ( LLEX(I) , I = 101, 200 )/
     X 101, 102, 103, 104, 105, 106, 107, 108, 109, 110, 111, 112,
     X 113, 114, 115, 116, 117, 118, 119, 120, 121, 122, 123, 124, 125,
     X 126, 127, 128, 129, 130, 131, 132, 133, 134, 135, 136, 137, 138,
     X 139, 140, 141, 142, 143, 144, 145, 146, 147, 148, 149, 150, 151,
     X 152, 153, 154, 155, 156, 157, 158, 159, 160, 161, 162, 163, 164,
     X 165, 166, 167, 168, 169, 170, 171, 172, 173, 174, 175, 176, 177,
     X 178, 179, 180, 181, 182, 183, 184, 185, 186, 187, 188, 189, 190,
     X 191, 192, 193, 194, 195, 196, 197, 198, 199, 200/
      DATA ( LLEX(I) , I = 201, 300 )/
     X 201, 202, 203, 204, 205, 206, 207, 208, 209, 210, 211, 212,
     X 213, 214, 215, 216, 217, 218, 219, 220, 221, 222, 223, 224, 225,
     X 226, 227, 228, 229, 230, 231, 232, 233, 234, 235, 236, 237, 238,
     X 239, 240, 241, 242, 243, 244, 245, 246, 247, 248, 249, 250, 251,
     X 252, 253, 254, 255, 256, 257, 258, 259, 260, 261, 262, 263, 264,
     X 265, 266, 267, 268, 269, 270, 271, 272, 273, 274, 275, 276, 277,
     X 278, 279, 280, 281, 282, 283, 284, 285, 286, 287, 288, 289, 290,
     X 291, 292, 293, 294, 295, 296, 297, 298, 299, 300/
      DATA ( LLEX(I) , I = 301, 400 )/
     X 301, 302, 303, 304, 305, 306, 307, 308, 309, 310, 311, 312,
     X 313, 314, 315, 316, 317, 318, 319, 320, 321, 322, 323, 324, 325,
     X 326, 327, 328, 329, 330, 331, 332, 333, 334, 335, 336, 337, 338,
     X 339, 340, 341, 342, 343, 344, 345, 346, 347, 348, 349, 350, 351,
     X 352, 353, 354, 355, 356, 357, 358, 359, 360, 361, 362, 363, 364,
     X 365, 366, 367, 368, 369, 370, 371, 372, 373, 374, 375, 376, 377,
     X 378, 379, 380, 381, 382, 383, 384, 385, 386, 387, 388, 389, 390,
     X 391, 392, 393, 394, 395, 396, 397, 398, 399, 400/
      DATA ( LLEX(I) , I = 401, 481 )/
     X 401, 402, 403, 404, 405, 406, 407, 408, 409, 410, 411, 412,
     X 413, 414, 415, 416, 417, 418, 419, 420, 421, 422, 423, 424, 425,
     X 426, 427, 428, 429, 430, 431, 432, 433, 434, 435, 436, 437, 438,
     X 439, 440, 441, 442, 443, 444, 445, 446, 447, 448, 449, 450, 451,
     X 452, 453, 454, 455, 456, 457, 458, 459, 460, 461, 462, 463, 464,
     X 465, 466, 467, 468, 469, 470, 471, 472, 473, 474, 475, 476, 477,
     X 478, 479, 480, 481/
      END

      BLOCK DATA LXLO08
      INTEGER FLEX,BLEX,DLEX,NLEX,CLEX,LLEX
      DIMENSION FLEX ( 481 )
      DIMENSION BLEX ( 481 )
      DIMENSION DLEX ( 481 )
      DIMENSION NLEX ( 2442 )
      DIMENSION CLEX ( 2442 )
      DIMENSION LLEX ( 481 )
      COMMON/G4LX/FLEX,BLEX,DLEX,NLEX,CLEX,LLEX
      END

      SUBROUTINE LXLOAD
      EXTERNAL LXLO00, LXLO01, LXLO02, LXLO03, LXLO04, LXLO05, LXLO06,
     X LXLO07, LXLO08
      RETURN
      END

 
      INTEGER FUNCTION LXNEXT ( STATE , A )
C****** ROUTINE LXNEXT ( STATE , A ) : GET NEXT STATE, RETURN 0 IF NONE
C****** COMMON: G4LX (LEXICAL TABLES)
      INTEGER MLEXST, MLEXNX
      PARAMETER ( MLEXST = 481 )
      PARAMETER ( MLEXNX = 2442 )
      INTEGER FLEX,BLEX,DLEX,NLEX,CLEX,LLEX
      DIMENSION FLEX ( 481 )
      DIMENSION BLEX ( 481 )
      DIMENSION DLEX ( 481 )
      DIMENSION NLEX ( 2442 )
      DIMENSION CLEX ( 2442 )
      DIMENSION LLEX ( 481 )
      COMMON/G4LX/FLEX,BLEX,DLEX,NLEX,CLEX,LLEX
      INTEGER STATE , A
      INTEGER I , DEF
      I = BLEX(STATE) + A + 1
      IF ( CLEX(I) .EQ. STATE ) THEN
        LXNEXT = NLEX(I)
      ELSE
        DEF = DLEX(STATE)
        IF ( DEF .NE. 0 ) THEN
          I = BLEX(DEF) + A + 1
          IF ( CLEX(I) .EQ. DEF ) THEN
            LXNEXT = NLEX(I)
          ELSE
            LXNEXT = 0
          ENDIF
        ELSE
          LXNEXT = 0
        ENDIF
      ENDIF
      RETURN
      END
 
      SUBROUTINE LXWLIN ( ITH , PARSTR , NSTR, STRPTR , RECRSV )
C****** ROUTINE LXWLIN ( ITH ) : WRITE INPUT LINE TO TERMINAL, POINT TO ERROR
C****** Global constants data loaded in main.
      INTEGER PBLNK, PSTDIN, PSTDOUT, PSTDERR, PMXERR, PENDF
      INTEGER PEOL, PTAB, PDOL, PETX, OK, ERR, DONE
      COMMON/G4CONST/PBLNK, PSTDIN, PSTDOUT, PSTDERR, PMXERR, PENDF
      COMMON/G4CONST/PEOL, PTAB, PDOL, PETX, OK, ERR, DONE
C****** COMMON: G4LXTX (CURRENT INPUT LINE)
      INTEGER NCHARS , LINENO , LINPOS , LINLEN
        CHARACTER LINTEX*(500)
      COMMON/G4LXTX1/ NCHARS , LINENO , LINPOS , LINLEN
      COMMON/G4LXTX2/ LINTEX
      INTEGER ITH
      INTEGER PARSTR(*)
      CHARACTER LSTR*(500)
      INTEGER I, POSIT, STRPTR , RECRSV , IB, IL
      IF ( RECRSV .EQ. 0 ) THEN
        POSIT = LINPOS - ITH
        IB = MAX(1, POSIT - 72)
        IL = POSIT - IB
        IM = MIN(LINLEN-2,IB+78) -IB + 1
        CALL LZSTR ( PSTDOUT , LINTEX(IB:LINLEN-2) , IM )
        CALL LZSEND ( PSTDOUT )
        DO 100 I = 1, IL
           CALL LZCHAR ( PSTDOUT , PBLNK )
  100   CONTINUE
        CALL LZTEXT ( PSTDOUT ,'^ $' )
      ELSE
        POSIT=STRPTR-ITH
        IB = MAX(1, POSIT - 72)
        IL = POSIT - IB
        IM = MIN(NSTR,IB+78) -IB + 1
        CALL SMOVATOF (LSTR, 0, PARSTR, IB - 1, IM)
        CALL LZSTR ( PSTDOUT , LSTR , IM )
        CALL LZSEND ( PSTDOUT )
        DO 200 I = 1 , IL
           CALL LZCHAR ( PSTDOUT , PBLNK )
  200   CONTINUE
        CALL LZTEXT ( PSTDOUT ,'^ $' )
      ENDIF
      RETURN
      END
 
      SUBROUTINE LXWTOK ( PFILE , TOKEN , TOKTXT , LENTOK )
C****** ROUTINE LXWTOK ( PFILE , TOKEN , TOKTXT , LENTOK ) : WRITE TOKEN TO FILE
      INTEGER PFILE , TOKEN , LENTOK
        CHARACTER TOKTXT*(500)
      CALL LZTEXT(PFILE,'Token $')
      CALL LZNUM(PFILE,TOKEN)
      CALL LZTEXT(PFILE,' scanned ($')
      CALL LRWVOC ( PFILE , TOKEN )
      CALL LZTEXT(PFILE,') = ''$')
      CALL LZSTR(PFILE,TOKTXT,LENTOK)
      CALL LZTEXT(PFILE,'''. $')
      CALL LZSEND(PFILE)
      RETURN
      END
 
      SUBROUTINE LZCHAR ( IUS , CH )
C****** ROUTINE LZCHAR ( IUS , CH ) : SEND CHARACTER TO IUS BUFFER
C****** COMMON: G4PACK (LINE BUFFER)
      INTEGER PLEN
        CHARACTER PLINE*(80)
      COMMON/G4PACK1/PLEN
      COMMON/G4PACK2/PLINE
      INTEGER IUS , CH
      PLEN = PLEN + 1
        PLINE(PLEN:PLEN) = CHAR ( CH )
      IF ( PLEN .GE. 72 ) CALL LZSEND ( IUS )
      RETURN
      END
 
      SUBROUTINE LZNUM ( IUS , I )
C****** ROUTINE LZNUM ( IUS , I ) : SEND NUMBER TO IUS BUFFER
C****** COMMON: G4PACK (LINE BUFFER)
      INTEGER PLEN
        CHARACTER PLINE*(80)
      COMMON/G4PACK1/PLEN
      COMMON/G4PACK2/PLINE
      INTEGER IUS , I
         INUM   = I
         ISTART = PLEN + 1
         IEND   = PLEN + 5
         DO 888 ILOOP = ISTART , IEND
           PLINE(ILOOP:ILOOP) = ' '
  888    CONTINUE
         PLINE(IEND:IEND) = '0'
         IF ( INUM .LT. 0 ) THEN
           PLINE(ISTART:ISTART) =  '-'
           ISTART = ISTART + 1
           INUM   = - INUM
         ENDIF
         DO 999 ILOOP = IEND , ISTART , -1
           IF ( INUM .EQ. 0 ) GO TO 999
           IDIGIT = INUM - (INUM/10)*10
           PLINE(ILOOP:ILOOP) = CHAR ( ICHAR('0') + IDIGIT )
           INUM = INUM/10
  999    CONTINUE
      PLEN = PLEN + 5
      IF ( PLEN .GE. 72 ) CALL LZSEND ( IUS )
      RETURN
      END
 
      SUBROUTINE LZSEND ( IUS )
C****** ROUTINE LZSEND ( IUS ) : SEND IUS BUFFER TO IUS
C****** COMMON: G4PACK (LINE BUFFER)
      INTEGER PLEN
        CHARACTER PLINE*(80)
      COMMON/G4PACK1/PLEN
      COMMON/G4PACK2/PLINE
      INTEGER IUS
        CALL BASWLINE ( IUS , PLINE (1:PLEN) )
        PLINE = ' '
      PLEN = 0
      RETURN
      END
 
      SUBROUTINE LZSTR ( IUS , STRING , LEN )
C****** ROUTINE LZSTR ( IUS , STRING , LEN ) : SEND STRING TO IUS BUFFER
C****** COMMON: G4PACK (LINE BUFFER)
      INTEGER PLEN
        CHARACTER PLINE*(80)
      COMMON/G4PACK1/PLEN
      COMMON/G4PACK2/PLINE
      INTEGER IUS , LEN
        CHARACTER STRING(LEN)
      INTEGER I , CH
      DO 100 I = 1 , LEN
        PLEN = PLEN + 1
        CH = 0
        CH = ICHAR ( STRING(I) )
        PLINE(PLEN:PLEN) = CHAR ( CH )
        IF ( PLEN .GE. 72 ) CALL LZSEND ( IUS )
  100 CONTINUE
      RETURN
      END
 
      SUBROUTINE LZTEXT ( IUS , TEXT )
C****** ROUTINE LZTEXT ( IUS , TEXT ) : SEND TEXT TO IUS BUFFER
C****** Global constants data loaded in main.
      external bdplen
      INTEGER PBLNK, PSTDIN, PSTDOUT, PSTDERR, PMXERR, PENDF
      INTEGER PEOL, PTAB, PDOL, PETX, OK, ERR, DONE
      COMMON/G4CONST/PBLNK, PSTDIN, PSTDOUT, PSTDERR, PMXERR, PENDF
      COMMON/G4CONST/PEOL, PTAB, PDOL, PETX, OK, ERR, DONE
C****** COMMON: G4PACK (LINE BUFFER)
      INTEGER PLEN
        CHARACTER PLINE*(80)
      COMMON/G4PACK1/PLEN
      COMMON/G4PACK2/PLINE
      INTEGER IUS
        CHARACTER TEXT*(1)
      INTEGER I , CH
      I = 0
  100 CONTINUE
      CH = 0
        CH = ICHAR ( TEXT(I+1:I+1) )
      IF ( CH .EQ. PDOL ) GO TO 200
      PLEN = PLEN + 1
        PLINE(PLEN:PLEN) = CHAR ( CH )
      I = I + 1
      IF ( PLEN .GE. 72 ) CALL LZSEND ( IUS )
      GO TO 100
  200 CONTINUE
      RETURN
      END

      block data bdplen
      common/g4pack1/plen
      data plen /0/
      end
